
#include "stdafx.h"

std::filesystem::path ReplaceExtension(const std::filesystem::path &path, const wchar_t * const ext) {
  std::filesystem::path result = path;
  result.replace_extension(ext);
  return result;
}

bool ProcMsg(const std::filesystem::path &path, const std::vector<unsigned char> data) {
  const std::filesystem::path out = ReplaceExtension(path, L".txt");
  return Touhou::Msg::TH143Msg2Txt(data, out.string().c_str());
}

bool ProcTxt(const std::filesystem::path &path, const std::vector<unsigned char> data) {
  const std::filesystem::path out = ReplaceExtension(path, L".msg");
  return Touhou::Msg::Txt2Msg(data, out.string().c_str());
}

bool Proc(const std::filesystem::path &path) {
  if (!boost::filesystem::is_regular_file(path)) {
    std::wcout << boost::wformat(L"%1%݂͑ȂAt@Cł͂܂B") % path << std::endl;
    return false;
  }
  const unsigned long long int fileSize = boost::filesystem::file_size(path);
  if (fileSize == 0) {
    std::wcout << L"TCY0̃t@C͏ł܂B" << std::endl;
    return false;
  }
  boost::filesystem::ifstream ifs(path, std::ios::binary);
  if (!ifs.good()) {
    std::wcout << boost::wformat(L"%1%̃I[vɎs܂At@CbNĂvZXIĂB") % path << std::endl;
    return false;
  }
  std::vector<unsigned char> data(static_cast<unsigned int>(fileSize));
  ifs.read(reinterpret_cast<char *>(&data.front()), data.size());
  if (!ifs.good()) {
    std::wcout << L"t@C̓ǂݍ݂Ɏs܂B" << std::endl;
    return false;
  }
  const std::filesystem::path ext = path.extension();
  if (ext == L".msg") {
    return ProcMsg(path, data);
  } else if (ext == L".txt") {
    return ProcTxt(path, data);
  }
  return false;
}

int main(const unsigned int argc, const char * const * const argv) {
  std::locale::global(std::locale("japanese"));
  if (argc < 2) {
    std::wcout << L"usage: msg_converter.exe file [,file]";
    return 1;
  }
  for (unsigned int i = 1; i < argc; i++) {
    const std::filesystem::path path(argv[i]);
    if (!Proc(path)) {
      std::wcout << boost::wformat(L"%1%̕ϊɎs܂B\n𒆒f܂B\n") % path;
      std::wcin.ignore();
      return 1;
    }
  }
  std::wcout << L"ׂĂ̏ɐ܂B\nEnterŏI";
  std::wcin.ignore();
  return 0;
}
