#include "stdafx.h"

namespace TouhouSE {

namespace TH145 {

const TH145Pak::FilenameArray FILE_NAME_LIST = {
  L"data/actor/buffScript.nut",
  L"data/actor/common/bmsln/item_back.bmb",
  L"data/actor/common/common.pat",
  L"data/actor/common/occultC_Ring0000.png",
  L"data/actor/common/occultC_wave0000.png",
  L"data/actor/common/occultE_0000.png",
  L"data/actor/common/occultE_0001.png",
  L"data/actor/common/occultF_back0000.png",
  L"data/actor/common/occultF_back0001.png",
  L"data/actor/common/occultF_back0002.png",
  L"data/actor/common/occult_A0000.png",
  L"data/actor/common/occult_A0001.png",
  L"data/actor/common/occult_A0002.png",
  L"data/actor/common/occult_A0003.png",
  L"data/actor/common/occult_A0004.png",
  L"data/actor/common/occult_B_Wall0000.png",
  L"data/actor/common/occult_D0000.png",
  L"data/actor/common/occult_D0001.png",
  L"data/actor/common/occult_D0002.png",
  L"data/actor/common/occult_G0000.png",
  L"data/actor/common/occult_object000.png",
  L"data/actor/common/occult_object001.png",
  L"data/actor/common/occult_trail0000.png",
  L"data/actor/common/texture/ball.png",
  L"data/actor/common/texture/chargeline.dds",
  L"data/actor/common/texture/chargelinea.png",
  L"data/actor/common/texture/chargeparticle0000.dds",
  L"data/actor/common/texture/common_spark.png",
  L"data/actor/common/texture/common_trail0000.png",
  L"data/actor/common/texture/flashEffectA.png",
  L"data/actor/common/texture/lightBar.png",
  L"data/actor/common/texture/mask_ball.png",
  L"data/actor/common/texture/occultAura0000.png",
  L"data/actor/cpuCommon.nut",
  L"data/actor/effect/ballCount0001.png",
  L"data/actor/effect/ballCount0002.png",
  L"data/actor/effect/ballCount0003.png",
  L"data/actor/effect/ballCount0004.png",
  L"data/actor/effect/ballCount0005.png",
  L"data/actor/effect/ballCount_Back.png",
  L"data/actor/effect/baria.bmp",
  L"data/actor/effect/bariaBreakB000.png",
  L"data/actor/effect/bariaBreakB001.png",
  L"data/actor/effect/bariaBreakB002.png",
  L"data/actor/effect/bariaBreakB003.png",
  L"data/actor/effect/bariaBreakB004.png",
  L"data/actor/effect/bariaBreakB005.png",
  L"data/actor/effect/bariaBreakB006.png",
  L"data/actor/effect/bariaBreakB007.png",
  L"data/actor/effect/bariaBreakB008.png",
  L"data/actor/effect/bariaBreakB009.png",
  L"data/actor/effect/bariaBreakB010.png",
  L"data/actor/effect/bariaBreakB011.png",
  L"data/actor/effect/bariaBreakB012.png",
  L"data/actor/effect/bariaBreakB013.png",
  L"data/actor/effect/bmsln/dashDome.bmb",
  L"data/actor/effect/bmsln/effect_baria.bmb",
  L"data/actor/effect/bmsln/effect_cancelMove.bmb",
  L"data/actor/effect/bmsln/effect_charge.bmb",
  L"data/actor/effect/bmsln/effect_chargeR.bmb",
  L"data/actor/effect/bmsln/effect_dash.bmb",
  L"data/actor/effect/bmsln/effect_guard.bmb",
  L"data/actor/effect/bmsln/effect_guardCrash.bmb",
  L"data/actor/effect/bmsln/effect_guardRed.bmb",
  L"data/actor/effect/bmsln/effect_spellBreak.bmb",
  L"data/actor/effect/bmsln/effect_wallCrash.bmb",
  L"data/actor/effect/bmsln/finishExp.bmb",
  L"data/actor/effect/bmsln/pichun.bmb",
  L"data/actor/effect/bmsln/spellBack.bmb",
  L"data/actor/effect/bmsln/spellCallBack.bmb",
  L"data/actor/effect/bmsln/spellUse.bmb",
  L"data/actor/effect/bmsln/spellUse2.bmb",
  L"data/actor/effect/callcard0000.png",
  L"data/actor/effect/callcard0001.png",
  L"data/actor/effect/callcard0002.png",
  L"data/actor/effect/callcard0003.png",
  L"data/actor/effect/callcard0004.png",
  L"data/actor/effect/callcard0005.png",
  L"data/actor/effect/callcard0006.png",
  L"data/actor/effect/callcard0007.png",
  L"data/actor/effect/callcard0008.png",
  L"data/actor/effect/callcard0009.png",
  L"data/actor/effect/crimax000.bmp",
  L"data/actor/effect/crimaxRing.bmp",
  L"data/actor/effect/effect.pat",
  L"data/actor/effect/model/dashDome.m3r",
  L"data/actor/effect/model/dashDome.png",
  L"data/actor/effect/model/loopTexA.png",
  L"data/actor/effect/model/spellBack.m3r",
  L"data/actor/effect/occult_object000.png",
  L"data/actor/effect/occult_trail0000.png",
  L"data/actor/effect/ringAc000.bmp",
  L"data/actor/effect/spellBack.bmp",
  L"data/actor/effect/spellCallback0000.png",
  L"data/actor/effect/spellCallback0001.png",
  L"data/actor/effect/spotName0000.png",
  L"data/actor/effect/spotName0001.png",
  L"data/actor/effect/spotName0002.png",
  L"data/actor/effect/spotName0003.png",
  L"data/actor/effect/spotName0004.png",
  L"data/actor/effect/spotName0005.png",
  L"data/actor/effect/spotName0006.png",
  L"data/actor/effect/stan_star000.bmp",
  L"data/actor/effect/texture/ball.png",
  L"data/actor/effect/texture/ballInfo.png",
  L"data/actor/effect/texture/bgm_01reimu.png",
  L"data/actor/effect/texture/bgm_02marisa.png",
  L"data/actor/effect/texture/bgm_03ichirin.png",
  L"data/actor/effect/texture/bgm_04hijiri.png",
  L"data/actor/effect/texture/bgm_05futo.png",
  L"data/actor/effect/texture/bgm_06miko.png",
  L"data/actor/effect/texture/bgm_07nitori.png",
  L"data/actor/effect/texture/bgm_08koishi.png",
  L"data/actor/effect/texture/bgm_09mamizou.png",
  L"data/actor/effect/texture/bgm_10mamizou2.png",
  L"data/actor/effect/texture/bgm_11kokoro.png",
  L"data/actor/effect/texture/chargeA.png",
  L"data/actor/effect/texture/chargeB.png",
  L"data/actor/effect/texture/chargeO.png",
  L"data/actor/effect/texture/continue.png",
  L"data/actor/effect/texture/continue1.png",
  L"data/actor/effect/texture/crashGlass.png",
  L"data/actor/effect/texture/debuff.png",
  L"data/actor/effect/texture/end_base.png",
  L"data/actor/effect/texture/flashEffectA.png",
  L"data/actor/effect/texture/guardA0000.png",
  L"data/actor/effect/texture/guardB0000.png",
  L"data/actor/effect/texture/guardFlash.png",
  L"data/actor/effect/texture/guardringA.bmp",
  L"data/actor/effect/texture/hitA0000.png",
  L"data/actor/effect/texture/lightBar.png",
  L"data/actor/effect/texture/lightLineRngA.png",
  L"data/actor/effect/texture/lightning_mono0000.dds",
  L"data/actor/effect/texture/loopTexA.png",
  L"data/actor/effect/texture/maA.png",
  L"data/actor/effect/texture/marisaStarFlare.bmp",
  L"data/actor/effect/texture/mask_ball.png",
  L"data/actor/effect/texture/minus.png",
  L"data/actor/effect/texture/moji_doubleKo.png",
  L"data/actor/effect/texture/moji_dowbleKO_jp.png",
  L"data/actor/effect/texture/moji_draw.png",
  L"data/actor/effect/texture/moji_draw_jp.png",
  L"data/actor/effect/texture/moji_fight.png",
  L"data/actor/effect/texture/moji_fight_jp.png",
  L"data/actor/effect/texture/moji_ko.png",
  L"data/actor/effect/texture/moji_ko_jp.png",
  L"data/actor/effect/texture/moji_ready.png",
  L"data/actor/effect/texture/moji_ready_jp.png",
  L"data/actor/effect/texture/moji_timeup.png",
  L"data/actor/effect/texture/moji_timeUp_jp.png",
  L"data/actor/effect/texture/moji_winner_1p.png",
  L"data/actor/effect/texture/moji_winner_2p.png",
  L"data/actor/effect/texture/moji_winner_jp.png",
  L"data/actor/effect/texture/namelist_left.png",
  L"data/actor/effect/texture/namelist_right.png",
  L"data/actor/effect/texture/ninki_num_minus.png",
  L"data/actor/effect/texture/ninki_num_plus.png",
  L"data/actor/effect/texture/occultAuraA0000.png",
  L"data/actor/effect/texture/plus.png",
  L"data/actor/effect/texture/practiceIcon.png",
  L"data/actor/effect/texture/round_base.png",
  L"data/actor/effect/texture/sevenGuardA0000.png",
  L"data/actor/effect/texture/sideLine.png",
  L"data/actor/effect/texture/smoke.png",
  L"data/actor/effect/texture/speedLine0000.png",
  L"data/actor/effect/texture/speedLineA.png",
  L"data/actor/effect/texture/spellBack.m3r",
  L"data/actor/effect/texture/spellChargeA0000.png",
  L"data/actor/effect/texture/story_moji_title.png",
  L"data/actor/effect/texture/wallCrash.png",
  L"data/actor/effect/texture/winName1P.png",
  L"data/actor/effect/texture/winName2P.png",
  L"data/actor/effect/texture/win_name0000.png",
  L"data/actor/effect/tips0000.png",
  L"data/actor/effect/tips0001.png",
  L"data/actor/effect/tips0002.png",
  L"data/actor/effect/tips0003.png",
  L"data/actor/effect/whiteBack.bmp",
  L"data/actor/effect.nut",
  L"data/actor/futo/atkDashLow0000.bmp",
  L"data/actor/futo/atkDashLow0001.bmp",
  L"data/actor/futo/atkDashLow0002.bmp",
  L"data/actor/futo/atkDashLow0003.bmp",
  L"data/actor/futo/atkDashLow0004.bmp",
  L"data/actor/futo/atkDashLow0005.bmp",
  L"data/actor/futo/atkDashLow0006.bmp",
  L"data/actor/futo/atkHigh0000.bmp",
  L"data/actor/futo/atkHigh0001.bmp",
  L"data/actor/futo/atkHigh0002.bmp",
  L"data/actor/futo/atkHigh0003.bmp",
  L"data/actor/futo/atkHigh0004.bmp",
  L"data/actor/futo/atkHigh0005.bmp",
  L"data/actor/futo/atkHigh0006.bmp",
  L"data/actor/futo/atkHigh0007.bmp",
  L"data/actor/futo/atkHigh0008.bmp",
  L"data/actor/futo/atkHighFront0000.bmp",
  L"data/actor/futo/atkHighFront0001.bmp",
  L"data/actor/futo/atkHighFront0002.bmp",
  L"data/actor/futo/atkHighFront0003.bmp",
  L"data/actor/futo/atkHighFront0004.bmp",
  L"data/actor/futo/atkHighFront0005.bmp",
  L"data/actor/futo/atkHighFront0006.bmp",
  L"data/actor/futo/atkHighFront0007.bmp",
  L"data/actor/futo/atkHighFront0008.bmp",
  L"data/actor/futo/atkHighFront0009.bmp",
  L"data/actor/futo/atkHighUnder0000.bmp",
  L"data/actor/futo/atkHighUnder0001.bmp",
  L"data/actor/futo/atkHighUnder0002.bmp",
  L"data/actor/futo/atkHighUnder0003.bmp",
  L"data/actor/futo/atkHighUnder0004.bmp",
  L"data/actor/futo/atkHighUnder0005.bmp",
  L"data/actor/futo/atkHighUnder0006.bmp",
  L"data/actor/futo/atkHighUnder0007.bmp",
  L"data/actor/futo/atkHighUnder0008.bmp",
  L"data/actor/futo/atkHighUpper0000.bmp",
  L"data/actor/futo/atkHighUpper0001.bmp",
  L"data/actor/futo/atkHighUpper0002.bmp",
  L"data/actor/futo/atkHighUpper0003.bmp",
  L"data/actor/futo/atkHighUpper0004.bmp",
  L"data/actor/futo/atkHighUpper0005.bmp",
  L"data/actor/futo/atkHighUpper0006.bmp",
  L"data/actor/futo/atkHighUpper0007.bmp",
  L"data/actor/futo/atkHighUpper0008.bmp",
  L"data/actor/futo/atkHighUpper0009.bmp",
  L"data/actor/futo/atkHighUpper0010.bmp",
  L"data/actor/futo/atkHighUpper0011.bmp",
  L"data/actor/futo/atkLow0000.bmp",
  L"data/actor/futo/atkLow0001.bmp",
  L"data/actor/futo/atkLow0002.bmp",
  L"data/actor/futo/atkLow0003.bmp",
  L"data/actor/futo/atkLow0004.bmp",
  L"data/actor/futo/atkLow0005.bmp",
  L"data/actor/futo/atkLow0006.bmp",
  L"data/actor/futo/atkMid0000.bmp",
  L"data/actor/futo/atkMid0001.bmp",
  L"data/actor/futo/atkMid0002.bmp",
  L"data/actor/futo/atkMid0003.bmp",
  L"data/actor/futo/atkMid0004.bmp",
  L"data/actor/futo/atkMid0005.bmp",
  L"data/actor/futo/atkMid0006.bmp",
  L"data/actor/futo/atkMid0007.bmp",
  L"data/actor/futo/battleBeginB0000.bmp",
  L"data/actor/futo/battleBeginB0001.bmp",
  L"data/actor/futo/battleBeginB0002.bmp",
  L"data/actor/futo/battleBeginB0003.bmp",
  L"data/actor/futo/battleBeginB0004.bmp",
  L"data/actor/futo/battleBeginB0005.bmp",
  L"data/actor/futo/battleBeginB0006.bmp",
  L"data/actor/futo/battleBeginB0007.bmp",
  L"data/actor/futo/BattleBeginC0000.bmp",
  L"data/actor/futo/BattleBeginC0001.bmp",
  L"data/actor/futo/BattleBeginC0003.bmp",
  L"data/actor/futo/BattleBeginC0004.bmp",
  L"data/actor/futo/BattleBeginC_Loop0000.bmp",
  L"data/actor/futo/BattleBeginC_Loop0001.bmp",
  L"data/actor/futo/BattleBeginC_Loop0002.bmp",
  L"data/actor/futo/BattleBeginC_Loop0003.bmp",
  L"data/actor/futo/BattleBeginC_Loop0004.bmp",
  L"data/actor/futo/beginBattleA0000.bmp",
  L"data/actor/futo/beginBattleA0001.bmp",
  L"data/actor/futo/beginBattleA0002.bmp",
  L"data/actor/futo/beginBattleA0003.bmp",
  L"data/actor/futo/beginBattleA0004.bmp",
  L"data/actor/futo/beginBattleA0005.bmp",
  L"data/actor/futo/beginBattleA0006.bmp",
  L"data/actor/futo/beginBattleA0007.bmp",
  L"data/actor/futo/bmsln/futo_climaxFire.bmb",
  L"data/actor/futo/bmsln/futo_firePilar.bmb",
  L"data/actor/futo/bmsln/futo_levelUp.bmb",
  L"data/actor/futo/bmsln/futo_rollFire.bmb",
  L"data/actor/futo/bmsln/futo_tornade.bmb",
  L"data/actor/futo/climax0000.bmp",
  L"data/actor/futo/climax0001.bmp",
  L"data/actor/futo/climax0002.bmp",
  L"data/actor/futo/climax0003.bmp",
  L"data/actor/futo/climax0004.bmp",
  L"data/actor/futo/climax0005.bmp",
  L"data/actor/futo/climax0006.bmp",
  L"data/actor/futo/climaxLoop0000.bmp",
  L"data/actor/futo/climaxLoop0001.bmp",
  L"data/actor/futo/climaxLoop0002.bmp",
  L"data/actor/futo/climaxLoop0003.bmp",
  L"data/actor/futo/climaxLoop0004.bmp",
  L"data/actor/futo/climaxLoop0005.bmp",
  L"data/actor/futo/climax_well0000.bmp",
  L"data/actor/futo/crash0000.bmp",
  L"data/actor/futo/crash0001.bmp",
  L"data/actor/futo/crash0002.bmp",
  L"data/actor/futo/crash0003.bmp",
  L"data/actor/futo/crash0004.bmp",
  L"data/actor/futo/cut0000.png",
  L"data/actor/futo/cut0001.png",
  L"data/actor/futo/damageBody0000.bmp",
  L"data/actor/futo/damageBody0001.bmp",
  L"data/actor/futo/damageBody0002.bmp",
  L"data/actor/futo/damageBody0003.bmp",
  L"data/actor/futo/damageBody0004.bmp",
  L"data/actor/futo/damageHead0000.bmp",
  L"data/actor/futo/damageHead0001.bmp",
  L"data/actor/futo/damageHead0002.bmp",
  L"data/actor/futo/damageHead0003.bmp",
  L"data/actor/futo/damageHead0004.bmp",
  L"data/actor/futo/damageSpin0000.bmp",
  L"data/actor/futo/damageSpin0001.bmp",
  L"data/actor/futo/damageSpin0002.bmp",
  L"data/actor/futo/damageSpin0003.bmp",
  L"data/actor/futo/damageUpper0000.bmp",
  L"data/actor/futo/damageUpper0001.bmp",
  L"data/actor/futo/damageUpper0002.bmp",
  L"data/actor/futo/damageUpper0003.bmp",
  L"data/actor/futo/damageUpper0004.bmp",
  L"data/actor/futo/damageUpper0005.bmp",
  L"data/actor/futo/damageUpper0006.bmp",
  L"data/actor/futo/damageUpper0007.bmp",
  L"data/actor/futo/damageUpper0008.bmp",
  L"data/actor/futo/damageUpper0009.bmp",
  L"data/actor/futo/damageUpper0010.bmp",
  L"data/actor/futo/damageUpper0011.bmp",
  L"data/actor/futo/damageUpper0012.bmp",
  L"data/actor/futo/damageUpper0013.bmp",
  L"data/actor/futo/damageUpper0014.bmp",
  L"data/actor/futo/damageWall0000.bmp",
  L"data/actor/futo/damageWall0001.bmp",
  L"data/actor/futo/damageWall0002.bmp",
  L"data/actor/futo/damageWall0003.bmp",
  L"data/actor/futo/damageWall0004.bmp",
  L"data/actor/futo/damageWall0005.bmp",
  L"data/actor/futo/damageWall0006.bmp",
  L"data/actor/futo/dashBack0000.bmp",
  L"data/actor/futo/dashBack0001.bmp",
  L"data/actor/futo/dashBack0002.bmp",
  L"data/actor/futo/dashBack0003.bmp",
  L"data/actor/futo/dashBack0004.bmp",
  L"data/actor/futo/dashBack0005.bmp",
  L"data/actor/futo/dashBack0006.bmp",
  L"data/actor/futo/dashBackLoop0000.bmp",
  L"data/actor/futo/dashBackLoop0001.bmp",
  L"data/actor/futo/dashBackLoop0002.bmp",
  L"data/actor/futo/dashBackLoop0003.bmp",
  L"data/actor/futo/dashBackLoop0004.bmp",
  L"data/actor/futo/dashFront0000.bmp",
  L"data/actor/futo/dashFront0001.bmp",
  L"data/actor/futo/dashFront0002.bmp",
  L"data/actor/futo/dashFront0003.bmp",
  L"data/actor/futo/dashFront0004.bmp",
  L"data/actor/futo/dashFront0005.bmp",
  L"data/actor/futo/dashFront0006.bmp",
  L"data/actor/futo/dashFrontLoop0000.bmp",
  L"data/actor/futo/dashFrontLoop0001.bmp",
  L"data/actor/futo/dashFrontLoop0002.bmp",
  L"data/actor/futo/dashFrontLoop0003.bmp",
  L"data/actor/futo/dashFrontLoop0004.bmp",
  L"data/actor/futo/face_spellcallb.png",
  L"data/actor/futo/futo.pat",
  L"data/actor/futo/futo_ed.pat",
  L"data/actor/futo/guard0000.bmp",
  L"data/actor/futo/guard0001.bmp",
  L"data/actor/futo/guard0002.bmp",
  L"data/actor/futo/guard0003.bmp",
  L"data/actor/futo/item0000.bmp",
  L"data/actor/futo/item0001.bmp",
  L"data/actor/futo/item0002.bmp",
  L"data/actor/futo/item0003.bmp",
  L"data/actor/futo/item0004.bmp",
  L"data/actor/futo/item0005.bmp",
  L"data/actor/futo/item0006.bmp",
  L"data/actor/futo/lose0000.bmp",
  L"data/actor/futo/lose0001.bmp",
  L"data/actor/futo/lose0002.bmp",
  L"data/actor/futo/lose0003.bmp",
  L"data/actor/futo/missGuard0000.bmp",
  L"data/actor/futo/missGuard0001.bmp",
  L"data/actor/futo/missGuard0002.bmp",
  L"data/actor/futo/missGuard0003.bmp",
  L"data/actor/futo/occulta0000.bmp",
  L"data/actor/futo/occulta0001.bmp",
  L"data/actor/futo/occulta0002.bmp",
  L"data/actor/futo/occulta0003.bmp",
  L"data/actor/futo/occulta0004.bmp",
  L"data/actor/futo/occultb0000.bmp",
  L"data/actor/futo/occultb0001.bmp",
  L"data/actor/futo/occultb0002.bmp",
  L"data/actor/futo/occultb0003.bmp",
  L"data/actor/futo/occultb0004.bmp",
  L"data/actor/futo/occultb0005.bmp",
  L"data/actor/futo/occultb0006.bmp",
  L"data/actor/futo/occultc0000.bmp",
  L"data/actor/futo/occultc0001.bmp",
  L"data/actor/futo/occultc0002.bmp",
  L"data/actor/futo/occultc0003.bmp",
  L"data/actor/futo/occultc0004.bmp",
  L"data/actor/futo/occultc0005.bmp",
  L"data/actor/futo/occult_dish0000.bmp",
  L"data/actor/futo/occult_okiku0000.bmp",
  L"data/actor/futo/occult_okiku0001.bmp",
  L"data/actor/futo/occult_okiku0002.bmp",
  L"data/actor/futo/occult_okiku0003.bmp",
  L"data/actor/futo/occult_okiku0004.bmp",
  L"data/actor/futo/palette000.bmp",
  L"data/actor/futo/palette001.bmp",
  L"data/actor/futo/palette002.bmp",
  L"data/actor/futo/palette003.bmp",
  L"data/actor/futo/palette004.bmp",
  L"data/actor/futo/palette005.bmp",
  L"data/actor/futo/palette006.bmp",
  L"data/actor/futo/palette007.bmp",
  L"data/actor/futo/ShotHigh0000.bmp",
  L"data/actor/futo/ShotHigh0001.bmp",
  L"data/actor/futo/ShotHigh0002.bmp",
  L"data/actor/futo/ShotHigh0003.bmp",
  L"data/actor/futo/ShotHigh0004.bmp",
  L"data/actor/futo/ShotHigh0005.bmp",
  L"data/actor/futo/ShotHigh0006.bmp",
  L"data/actor/futo/ShotHigh0007.bmp",
  L"data/actor/futo/ShotHigh0008.bmp",
  L"data/actor/futo/ShotHigh0009.bmp",
  L"data/actor/futo/ShotHigh0010.bmp",
  L"data/actor/futo/shotLow0000.bmp",
  L"data/actor/futo/shotLow0001.bmp",
  L"data/actor/futo/shotLow0002.bmp",
  L"data/actor/futo/shotLow0003.bmp",
  L"data/actor/futo/shotLow0004.bmp",
  L"data/actor/futo/shotLow0005.bmp",
  L"data/actor/futo/shotLow0006.bmp",
  L"data/actor/futo/shotLow0007.bmp",
  L"data/actor/futo/shotLow0008.bmp",
  L"data/actor/futo/shotLow0009.bmp",
  L"data/actor/futo/shotLow0010.bmp",
  L"data/actor/futo/shotLow0011.bmp",
  L"data/actor/futo/shotLow0012.bmp",
  L"data/actor/futo/skillA0000.bmp",
  L"data/actor/futo/skillA0001.bmp",
  L"data/actor/futo/skillA0002.bmp",
  L"data/actor/futo/skillA0003.bmp",
  L"data/actor/futo/skillA0004.bmp",
  L"data/actor/futo/skillA0005.bmp",
  L"data/actor/futo/skillB0000.bmp",
  L"data/actor/futo/skillB0001.bmp",
  L"data/actor/futo/skillB0002.bmp",
  L"data/actor/futo/skillB0003.bmp",
  L"data/actor/futo/skillB0004.bmp",
  L"data/actor/futo/skillB0005.bmp",
  L"data/actor/futo/skillB0006.bmp",
  L"data/actor/futo/skillB0007.bmp",
  L"data/actor/futo/skillC0000.bmp",
  L"data/actor/futo/skillC0001.bmp",
  L"data/actor/futo/skillC0002.bmp",
  L"data/actor/futo/skillC0003.bmp",
  L"data/actor/futo/skillC0004.bmp",
  L"data/actor/futo/skillC0005.bmp",
  L"data/actor/futo/skillC0006.bmp",
  L"data/actor/futo/skillC0007.bmp",
  L"data/actor/futo/skillD0000.bmp",
  L"data/actor/futo/skillD0001.bmp",
  L"data/actor/futo/skillD0002.bmp",
  L"data/actor/futo/skillD0003.bmp",
  L"data/actor/futo/skillD0004.bmp",
  L"data/actor/futo/skillD0005.bmp",
  L"data/actor/futo/skillD0006.bmp",
  L"data/actor/futo/skillD0007.bmp",
  L"data/actor/futo/skillD0008.bmp",
  L"data/actor/futo/skillD0009.bmp",
  L"data/actor/futo/skillG0000.bmp",
  L"data/actor/futo/skillG0001.bmp",
  L"data/actor/futo/skillG0002.bmp",
  L"data/actor/futo/skillG0003.bmp",
  L"data/actor/futo/skillG0004.bmp",
  L"data/actor/futo/skillG0005.bmp",
  L"data/actor/futo/skillG0006.bmp",
  L"data/actor/futo/skillG0007.bmp",
  L"data/actor/futo/skillG0008.bmp",
  L"data/actor/futo/skillG_Loop0000.bmp",
  L"data/actor/futo/skillG_Loop0001.bmp",
  L"data/actor/futo/skillG_Loop0002.bmp",
  L"data/actor/futo/skillG_Loop0003.bmp",
  L"data/actor/futo/skillG_Loop0004.bmp",
  L"data/actor/futo/slide0000.bmp",
  L"data/actor/futo/slide0001.bmp",
  L"data/actor/futo/slide0002.bmp",
  L"data/actor/futo/slide0003.bmp",
  L"data/actor/futo/slide0004.bmp",
  L"data/actor/futo/slide0005.bmp",
  L"data/actor/futo/slide0006.bmp",
  L"data/actor/futo/slide0007.bmp",
  L"data/actor/futo/slideUnderLoop0000.bmp",
  L"data/actor/futo/slideUnderLoop0001.bmp",
  L"data/actor/futo/slideUnderLoop0002.bmp",
  L"data/actor/futo/slideUnderLoop0003.bmp",
  L"data/actor/futo/slideUnderLoop0004.bmp",
  L"data/actor/futo/slideUpperLoop0000.bmp",
  L"data/actor/futo/slideUpperLoop0001.bmp",
  L"data/actor/futo/slideUpperLoop0002.bmp",
  L"data/actor/futo/slideUpperLoop0003.bmp",
  L"data/actor/futo/slideUpperLoop0004.bmp",
  L"data/actor/futo/spellA0000.bmp",
  L"data/actor/futo/spellA0001.bmp",
  L"data/actor/futo/spellA0002.bmp",
  L"data/actor/futo/spellA0003.bmp",
  L"data/actor/futo/spellA0004.bmp",
  L"data/actor/futo/spellA0005.bmp",
  L"data/actor/futo/spellA0006.bmp",
  L"data/actor/futo/spellA0007.bmp",
  L"data/actor/futo/spellA0008.bmp",
  L"data/actor/futo/spellA0009.bmp",
  L"data/actor/futo/spellA0010.bmp",
  L"data/actor/futo/spellB0000.bmp",
  L"data/actor/futo/spellB0001.bmp",
  L"data/actor/futo/spellB0002.bmp",
  L"data/actor/futo/spellB0003.bmp",
  L"data/actor/futo/spellB0004.bmp",
  L"data/actor/futo/spellB0005.bmp",
  L"data/actor/futo/spellB0006.bmp",
  L"data/actor/futo/spellB0007.bmp",
  L"data/actor/futo/spellBLoop0000.bmp",
  L"data/actor/futo/spellBLoop0001.bmp",
  L"data/actor/futo/spellBLoop0002.bmp",
  L"data/actor/futo/spellBLoop0003.bmp",
  L"data/actor/futo/spellBLoop0004.bmp",
  L"data/actor/futo/sskillA_Loop0000.bmp",
  L"data/actor/futo/sskillA_Loop0001.bmp",
  L"data/actor/futo/sskillA_Loop0002.bmp",
  L"data/actor/futo/sskillA_Loop0003.bmp",
  L"data/actor/futo/stand0000.bmp",
  L"data/actor/futo/stand0001.bmp",
  L"data/actor/futo/stand0002.bmp",
  L"data/actor/futo/stand0003.bmp",
  L"data/actor/futo/stand0004.bmp",
  L"data/actor/futo/stand0005.bmp",
  L"data/actor/futo/stand0006.bmp",
  L"data/actor/futo/stand0007.bmp",
  L"data/actor/futo/stand0008.bmp",
  L"data/actor/futo/stand0009.bmp",
  L"data/actor/futo/stand0010.bmp",
  L"data/actor/futo/stand0011.bmp",
  L"data/actor/futo/standB0000.bmp",
  L"data/actor/futo/standB0001.bmp",
  L"data/actor/futo/standB0002.bmp",
  L"data/actor/futo/standB0003.bmp",
  L"data/actor/futo/standB0004.bmp",
  L"data/actor/futo/stun0000.bmp",
  L"data/actor/futo/stun0001.bmp",
  L"data/actor/futo/stun0002.bmp",
  L"data/actor/futo/stun0003.bmp",
  L"data/actor/futo/stun0004.bmp",
  L"data/actor/futo/stun0005.bmp",
  L"data/actor/futo/stunEnd0000.bmp",
  L"data/actor/futo/stunEnd0001.bmp",
  L"data/actor/futo/stunEnd0002.bmp",
  L"data/actor/futo/texture/arrowA0000.dds",
  L"data/actor/futo/texture/auraA0000.dds",
  L"data/actor/futo/texture/auraA0000.png",
  L"data/actor/futo/texture/ball.bmp",
  L"data/actor/futo/texture/climaxBack.png",
  L"data/actor/futo/texture/climax_hit0000.png",
  L"data/actor/futo/texture/climax_smash.dds",
  L"data/actor/futo/texture/climax_smash0001.dds",
  L"data/actor/futo/texture/climax_smash0002.dds",
  L"data/actor/futo/texture/climax_srueez0000.dds",
  L"data/actor/futo/texture/climax_srueez0001.dds",
  L"data/actor/futo/texture/dangerA.png",
  L"data/actor/futo/texture/dangerB.png",
  L"data/actor/futo/texture/dangerC.png",
  L"data/actor/futo/texture/dishA0000.png",
  L"data/actor/futo/texture/dishShardA0000.dds",
  L"data/actor/futo/texture/fire.dds",
  L"data/actor/futo/texture/fireBase.png",
  L"data/actor/futo/texture/fireMask.png",
  L"data/actor/futo/texture/fireParticle.png",
  L"data/actor/futo/texture/fire_atkUpper.dds",
  L"data/actor/futo/texture/fune.png",
  L"data/actor/futo/texture/fune_B.png",
  L"data/actor/futo/texture/fune_C.png",
  L"data/actor/futo/texture/futo_animalDamage000.png",
  L"data/actor/futo/texture/futo_animalDamage001.png",
  L"data/actor/futo/texture/futo_animalDamage002.png",
  L"data/actor/futo/texture/futo_animalDamage003.png",
  L"data/actor/futo/texture/futo_animal_00000.png",
  L"data/actor/futo/texture/futo_animal_00001.png",
  L"data/actor/futo/texture/futo_animal_00002.png",
  L"data/actor/futo/texture/futo_animal_00003.png",
  L"data/actor/futo/texture/futo_animal_00004.png",
  L"data/actor/futo/texture/futo_animal_00005.png",
  L"data/actor/futo/texture/futo_animal_00006.png",
  L"data/actor/futo/texture/futo_animal_00007.png",
  L"data/actor/futo/texture/futo_animal_00008.png",
  L"data/actor/futo/texture/futo_animal_00009.png",
  L"data/actor/futo/texture/futo_animal_00010.png",
  L"data/actor/futo/texture/futo_animal_00011.png",
  L"data/actor/futo/texture/futo_fire.dds",
  L"data/actor/futo/texture/futo_fireBase.png",
  L"data/actor/futo/texture/futo_fireMask.png",
  L"data/actor/futo/texture/futo_sparkLine.dds",
  L"data/actor/futo/texture/iron0000.dds",
  L"data/actor/futo/texture/kona_A.bmp",
  L"data/actor/futo/texture/lightning_mapA.png",
  L"data/actor/futo/texture/luckFontA.png",
  L"data/actor/futo/texture/luckFontB.png",
  L"data/actor/futo/texture/mask_ball.png",
  L"data/actor/futo/texture/musou_trail.png",
  L"data/actor/futo/texture/nameCall.png",
  L"data/actor/futo/texture/occult_smoke0000.dds",
  L"data/actor/futo/texture/ringA.bmp",
  L"data/actor/futo/texture/rollFire.png",
  L"data/actor/futo/texture/sara_01.png",
  L"data/actor/futo/texture/sara_02.png",
  L"data/actor/futo/texture/sara_03.png",
  L"data/actor/futo/texture/sara_04.png",
  L"data/actor/futo/texture/sara_05.png",
  L"data/actor/futo/texture/skillG_000.png",
  L"data/actor/futo/texture/skillG_001.png",
  L"data/actor/futo/texture/skillG_002.png",
  L"data/actor/futo/texture/skillG_003.png",
  L"data/actor/futo/texture/skillG_004.png",
  L"data/actor/futo/texture/skillG_005.png",
  L"data/actor/futo/texture/skillG_006.png",
  L"data/actor/futo/texture/skillG_007.png",
  L"data/actor/futo/texture/skillG_008.png",
  L"data/actor/futo/texture/skillG_009.png",
  L"data/actor/futo/texture/skillG_010.png",
  L"data/actor/futo/texture/skillG_011.png",
  L"data/actor/futo/texture/skillG_012.png",
  L"data/actor/futo/texture/skillG_013.png",
  L"data/actor/futo/texture/skillG_014.png",
  L"data/actor/futo/texture/smoke.dds",
  L"data/actor/futo/texture/sparkLine.dds",
  L"data/actor/futo/texture/spellC.dds",
  L"data/actor/futo/texture/spellC_Aura.png",
  L"data/actor/futo/texture/spellC_chouchin.png",
  L"data/actor/futo/texture/spellC_haka.png",
  L"data/actor/futo/texture/spellC_saisenbako.png",
  L"data/actor/futo/texture/spellC_sakabin.png",
  L"data/actor/futo/texture/spellC_sakadaru.png",
  L"data/actor/futo/texture/spellC_tansu.png",
  L"data/actor/futo/texture/spellC_uekibachi.png",
  L"data/actor/futo/texture/spellC_ufoB.png",
  L"data/actor/futo/texture/squeezeA0000.png",
  L"data/actor/futo/texture/stone.png",
  L"data/actor/futo/texture/stoneB.png",
  L"data/actor/futo/texture/tatumakiHighFront.dds",
  L"data/actor/futo/texture/tornade.png",
  L"data/actor/futo/texture/tornade000.png",
  L"data/actor/futo/texture/tornade001.png",
  L"data/actor/futo/texture/tornade002.png",
  L"data/actor/futo/texture/tornade003.png",
  L"data/actor/futo/texture/tornade004.png",
  L"data/actor/futo/texture/tornade005.png",
  L"data/actor/futo/texture/tornade006.png",
  L"data/actor/futo/texture/vortexA0000.dds",
  L"data/actor/futo/texture/watarFall0000.dds",
  L"data/actor/futo/texture/watarFall0000.png",
  L"data/actor/futo/turn0000.bmp",
  L"data/actor/futo/turn0001.bmp",
  L"data/actor/futo/turn0002.bmp",
  L"data/actor/futo/walkBack0000.bmp",
  L"data/actor/futo/walkBack0001.bmp",
  L"data/actor/futo/walkBack0002.bmp",
  L"data/actor/futo/walkBack0003.bmp",
  L"data/actor/futo/walkBack0004.bmp",
  L"data/actor/futo/walkBack0005.bmp",
  L"data/actor/futo/walkBack0006.bmp",
  L"data/actor/futo/walkBackLoop0000.bmp",
  L"data/actor/futo/walkBackLoop0001.bmp",
  L"data/actor/futo/walkBackLoop0002.bmp",
  L"data/actor/futo/walkBackLoop0003.bmp",
  L"data/actor/futo/walkBackLoop0004.bmp",
  L"data/actor/futo/walkFront0000.bmp",
  L"data/actor/futo/walkFront0001.bmp",
  L"data/actor/futo/walkFront0002.bmp",
  L"data/actor/futo/walkFront0003.bmp",
  L"data/actor/futo/walkFront0004.bmp",
  L"data/actor/futo/walkFront0005.bmp",
  L"data/actor/futo/walkFrontLoop0000.bmp",
  L"data/actor/futo/walkFrontLoop0001.bmp",
  L"data/actor/futo/walkFrontLoop0002.bmp",
  L"data/actor/futo/walkFrontLoop0003.bmp",
  L"data/actor/futo/walkFrontLoop0004.bmp",
  L"data/actor/futo/winA0000.bmp",
  L"data/actor/futo/winA0001.bmp",
  L"data/actor/futo/winA0002.bmp",
  L"data/actor/futo/winA0003.bmp",
  L"data/actor/futo/winA0004.bmp",
  L"data/actor/futo/winA0005.bmp",
  L"data/actor/futo/winA0006.bmp",
  L"data/actor/futo.nut",
  L"data/actor/futoInit.nut",
  L"data/actor/futo_base.nut",
  L"data/actor/futo_boss.nut",
  L"data/actor/futo_cpu.nut",
  L"data/actor/futo_cpuBoss.nut",
  L"data/actor/futo_shot.nut",
  L"data/actor/hanako/hanako.pat",
  L"data/actor/hanako/palette000.bmp",
  L"data/actor/hanako/stand0000.bmp",
  L"data/actor/hanako/stand0001.bmp",
  L"data/actor/hanako/stand0002.bmp",
  L"data/actor/hanako/stand0003.bmp",
  L"data/actor/hanako/stand0004.bmp",
  L"data/actor/hanako/stand0005.bmp",
  L"data/actor/hanako/stand0006.bmp",
  L"data/actor/hanako/stand0007.bmp",
  L"data/actor/hanako/stand0008.bmp",
  L"data/actor/hanako/stand0009.bmp",
  L"data/actor/hanako/stand0010.bmp",
  L"data/actor/hanako/stand0011.bmp",
  L"data/actor/hanako/stand0012.bmp",
  L"data/actor/hanako/stand0013.bmp",
  L"data/actor/hanako/stand0014.bmp",
  L"data/actor/hanako/stand0015.bmp",
  L"data/actor/hanako/stand0016.bmp",
  L"data/actor/hanako/stand0017.bmp",
  L"data/actor/hanako/stand0018.bmp",
  L"data/actor/hanako/stand0019.bmp",
  L"data/actor/hanako/texture/ball.bmp",
  L"data/actor/hanako/texture/bulletGateFlash.bmp",
  L"data/actor/hanako/texture/bulletGateRing.bmp",
  L"data/actor/hanako/texture/chargeO.png",
  L"data/actor/hanako/texture/lightning_mapA.png",
  L"data/actor/hanako/texture/marisaBall2.bmp",
  L"data/actor/hanako/texture/marisaStarFlare.bmp",
  L"data/actor/hanako/texture/mask_ball.png",
  L"data/actor/hanako.nut",
  L"data/actor/hanakoInit.nut",
  L"data/actor/hanako_base.nut",
  L"data/actor/hanako_cpu.nut",
  L"data/actor/hanako_shot.nut",
  L"data/actor/hijiri/atkDashHigh0000.bmp",
  L"data/actor/hijiri/atkDashHigh0001.bmp",
  L"data/actor/hijiri/atkDashHigh0002.bmp",
  L"data/actor/hijiri/atkDashHigh0003.bmp",
  L"data/actor/hijiri/atkDashHigh0004.bmp",
  L"data/actor/hijiri/atkDashHigh0005.bmp",
  L"data/actor/hijiri/atkDashHigh0006.bmp",
  L"data/actor/hijiri/atkDashHigh0007.bmp",
  L"data/actor/hijiri/atkDashLow0000.bmp",
  L"data/actor/hijiri/atkDashLow0001.bmp",
  L"data/actor/hijiri/atkDashLow0002.bmp",
  L"data/actor/hijiri/atkDashLow0003.bmp",
  L"data/actor/hijiri/atkDashLow0004.bmp",
  L"data/actor/hijiri/atkDashLow0005.bmp",
  L"data/actor/hijiri/atkDashLow0006.bmp",
  L"data/actor/hijiri/atkDashLow0007.bmp",
  L"data/actor/hijiri/atkDashLow0008.bmp",
  L"data/actor/hijiri/atkHigh0000.bmp",
  L"data/actor/hijiri/atkHigh0001.bmp",
  L"data/actor/hijiri/atkHigh0002.bmp",
  L"data/actor/hijiri/atkHigh0003.bmp",
  L"data/actor/hijiri/atkHigh0004.bmp",
  L"data/actor/hijiri/atkHigh0005.bmp",
  L"data/actor/hijiri/atkHigh0006.bmp",
  L"data/actor/hijiri/atkHigh0007.bmp",
  L"data/actor/hijiri/atkHigh0008.bmp",
  L"data/actor/hijiri/atkHigh0009.bmp",
  L"data/actor/hijiri/atkHighUpper0000.bmp",
  L"data/actor/hijiri/atkHighUpper0001.bmp",
  L"data/actor/hijiri/atkHighUpper0002.bmp",
  L"data/actor/hijiri/atkHighUpper0003.bmp",
  L"data/actor/hijiri/atkHighUpper0004.bmp",
  L"data/actor/hijiri/atkHighUpper0005.bmp",
  L"data/actor/hijiri/atkHighUpper0006.bmp",
  L"data/actor/hijiri/atkHighUpper0007.bmp",
  L"data/actor/hijiri/atkLow0000.bmp",
  L"data/actor/hijiri/atkLow0001.bmp",
  L"data/actor/hijiri/atkLow0002.bmp",
  L"data/actor/hijiri/atkLow0003.bmp",
  L"data/actor/hijiri/atkLow0004.bmp",
  L"data/actor/hijiri/atkLow0005.bmp",
  L"data/actor/hijiri/atkLow0006.bmp",
  L"data/actor/hijiri/atkLowB0000.bmp",
  L"data/actor/hijiri/atkLowB0001.bmp",
  L"data/actor/hijiri/atkLowB0002.bmp",
  L"data/actor/hijiri/atkLowB0003.bmp",
  L"data/actor/hijiri/atkLowB0004.bmp",
  L"data/actor/hijiri/atkLowB0005.bmp",
  L"data/actor/hijiri/atkMid0000.bmp",
  L"data/actor/hijiri/atkMid0001.bmp",
  L"data/actor/hijiri/atkMid0002.bmp",
  L"data/actor/hijiri/atkMid0003.bmp",
  L"data/actor/hijiri/atkMid0004.bmp",
  L"data/actor/hijiri/atkMid0005.bmp",
  L"data/actor/hijiri/atkMid0006.bmp",
  L"data/actor/hijiri/atkMid0007.bmp",
  L"data/actor/hijiri/atkMid0008.bmp",
  L"data/actor/hijiri/atkMid0009.bmp",
  L"data/actor/hijiri/atlHighUnder0000.bmp",
  L"data/actor/hijiri/atlHighUnder0001.bmp",
  L"data/actor/hijiri/atlHighUnder0002.bmp",
  L"data/actor/hijiri/atlHighUnder0003.bmp",
  L"data/actor/hijiri/atlHighUnder0004.bmp",
  L"data/actor/hijiri/atlHighUnder0005.bmp",
  L"data/actor/hijiri/atlHighUnder0006.bmp",
  L"data/actor/hijiri/atlHighUnder0007.bmp",
  L"data/actor/hijiri/atlHighUnder0008.bmp",
  L"data/actor/hijiri/atlHighUnder0009.bmp",
  L"data/actor/hijiri/atlHighUnder0010.bmp",
  L"data/actor/hijiri/atlHighUnder0011.bmp",
  L"data/actor/hijiri/atlHighUnder0012.bmp",
  L"data/actor/hijiri/atlHighUnder0013.bmp",
  L"data/actor/hijiri/atlHighUnder0014.bmp",
  L"data/actor/hijiri/atlHighUnder0015.bmp",
  L"data/actor/hijiri/atlHighUnder0016.bmp",
  L"data/actor/hijiri/atlHighUnder0017.bmp",
  L"data/actor/hijiri/atlHighUnder0018.bmp",
  L"data/actor/hijiri/atlHighUnder0019.bmp",
  L"data/actor/hijiri/battleBeginA0000.bmp",
  L"data/actor/hijiri/battleBeginA0001.bmp",
  L"data/actor/hijiri/battleBeginA0002.bmp",
  L"data/actor/hijiri/battleBeginA0003.bmp",
  L"data/actor/hijiri/battleBeginA0004.bmp",
  L"data/actor/hijiri/battleBeginA0005.bmp",
  L"data/actor/hijiri/battleBeginA0006.bmp",
  L"data/actor/hijiri/bellA000.bmp",
  L"data/actor/hijiri/bmsln/hijiri_climaxAuraA.bmb",
  L"data/actor/hijiri/bmsln/hijiri_climaxHitA.bmb",
  L"data/actor/hijiri/bmsln/hijiri_lightningA.bmb",
  L"data/actor/hijiri/bmsln/hijiri_skillB.bmb",
  L"data/actor/hijiri/bmsln/hijiri_skillG.bmb",
  L"data/actor/hijiri/bmsln/hijiri_spellC_Impact.bmb",
  L"data/actor/hijiri/bmsln/hijiri_spellC_Pilar.bmb",
  L"data/actor/hijiri/chant0000.bmp",
  L"data/actor/hijiri/chant0001.bmp",
  L"data/actor/hijiri/chant0002.bmp",
  L"data/actor/hijiri/chant0003.bmp",
  L"data/actor/hijiri/chant0004.bmp",
  L"data/actor/hijiri/chant0005.bmp",
  L"data/actor/hijiri/chant0006.bmp",
  L"data/actor/hijiri/chant0007.bmp",
  L"data/actor/hijiri/chant0008.bmp",
  L"data/actor/hijiri/chant0009.bmp",
  L"data/actor/hijiri/chant0010.bmp",
  L"data/actor/hijiri/chant0011.bmp",
  L"data/actor/hijiri/climax0000.bmp",
  L"data/actor/hijiri/climax0001.bmp",
  L"data/actor/hijiri/climax0002.bmp",
  L"data/actor/hijiri/climax0003.bmp",
  L"data/actor/hijiri/climax0004.bmp",
  L"data/actor/hijiri/climax0005.bmp",
  L"data/actor/hijiri/climax0006.bmp",
  L"data/actor/hijiri/climax0007.bmp",
  L"data/actor/hijiri/climax0008.bmp",
  L"data/actor/hijiri/climax0009.bmp",
  L"data/actor/hijiri/climax0010.bmp",
  L"data/actor/hijiri/climax0011.bmp",
  L"data/actor/hijiri/climaxcut0000.png",
  L"data/actor/hijiri/damageBody0000.bmp",
  L"data/actor/hijiri/damageBody0001.bmp",
  L"data/actor/hijiri/damageBody0002.bmp",
  L"data/actor/hijiri/damageBody0003.bmp",
  L"data/actor/hijiri/damageBody0004.bmp",
  L"data/actor/hijiri/damageDown0000.bmp",
  L"data/actor/hijiri/damageDown0001.bmp",
  L"data/actor/hijiri/damageDown0002.bmp",
  L"data/actor/hijiri/damageDown0003.bmp",
  L"data/actor/hijiri/damageDown0004.bmp",
  L"data/actor/hijiri/damageDown0005.bmp",
  L"data/actor/hijiri/damageDown0006.bmp",
  L"data/actor/hijiri/damageDown0007.bmp",
  L"data/actor/hijiri/damageDown0008.bmp",
  L"data/actor/hijiri/damageDown0009.bmp",
  L"data/actor/hijiri/damageDown0010.bmp",
  L"data/actor/hijiri/damageDown0011.bmp",
  L"data/actor/hijiri/damageDown0012.bmp",
  L"data/actor/hijiri/damageDown0013.bmp",
  L"data/actor/hijiri/damageDown0014.bmp",
  L"data/actor/hijiri/damageDownLoop0000.bmp",
  L"data/actor/hijiri/damageDownLoop0001.bmp",
  L"data/actor/hijiri/damageDownLoop0002.bmp",
  L"data/actor/hijiri/damageDownLoop0003.bmp",
  L"data/actor/hijiri/damageDownLoop0004.bmp",
  L"data/actor/hijiri/damageHead0000.bmp",
  L"data/actor/hijiri/damageHead0001.bmp",
  L"data/actor/hijiri/damageHead0002.bmp",
  L"data/actor/hijiri/damageHead0003.bmp",
  L"data/actor/hijiri/damageHead0004.bmp",
  L"data/actor/hijiri/damageSpin0000.bmp",
  L"data/actor/hijiri/damageSpin0001.bmp",
  L"data/actor/hijiri/damageSpin0002.bmp",
  L"data/actor/hijiri/damageSpin0003.bmp",
  L"data/actor/hijiri/damageWall0000.bmp",
  L"data/actor/hijiri/damageWall0001.bmp",
  L"data/actor/hijiri/damageWall0002.bmp",
  L"data/actor/hijiri/damageWall0003.bmp",
  L"data/actor/hijiri/damageWall0004.bmp",
  L"data/actor/hijiri/damageWall0005.bmp",
  L"data/actor/hijiri/damageWall0006.bmp",
  L"data/actor/hijiri/dashBack0000.bmp",
  L"data/actor/hijiri/dashBack0001.bmp",
  L"data/actor/hijiri/dashBackB0000.bmp",
  L"data/actor/hijiri/dashBackB0001.bmp",
  L"data/actor/hijiri/dashBackB0002.bmp",
  L"data/actor/hijiri/dashBackB0003.bmp",
  L"data/actor/hijiri/dashBackB0004.bmp",
  L"data/actor/hijiri/dashBackB0005.bmp",
  L"data/actor/hijiri/dashBackB0006.bmp",
  L"data/actor/hijiri/dashBackB0007.bmp",
  L"data/actor/hijiri/dashFront0000.bmp",
  L"data/actor/hijiri/dashFront0001.bmp",
  L"data/actor/hijiri/dashFront0002.bmp",
  L"data/actor/hijiri/dashFront0003.bmp",
  L"data/actor/hijiri/dashFront0004.bmp",
  L"data/actor/hijiri/dashFrontB0000.bmp",
  L"data/actor/hijiri/dashFrontB0001.bmp",
  L"data/actor/hijiri/dashFrontB0002.bmp",
  L"data/actor/hijiri/dashFrontB0003.bmp",
  L"data/actor/hijiri/dashFrontB0004.bmp",
  L"data/actor/hijiri/dashFrontB0005.bmp",
  L"data/actor/hijiri/dashFrontB0006.bmp",
  L"data/actor/hijiri/dashFrontB0007.bmp",
  L"data/actor/hijiri/dokkoA0000.bmp",
  L"data/actor/hijiri/face_spellcallb.png",
  L"data/actor/hijiri/guard0000.bmp",
  L"data/actor/hijiri/guard0001.bmp",
  L"data/actor/hijiri/guard0002.bmp",
  L"data/actor/hijiri/guard0003.bmp",
  L"data/actor/hijiri/guardCrash0000.bmp",
  L"data/actor/hijiri/guardCrash0001.bmp",
  L"data/actor/hijiri/guardCrash0002.bmp",
  L"data/actor/hijiri/guardCrash0003.bmp",
  L"data/actor/hijiri/guardCrash0004.bmp",
  L"data/actor/hijiri/guardCrash0005.bmp",
  L"data/actor/hijiri/guardMiss0000.bmp",
  L"data/actor/hijiri/guardMiss0001.bmp",
  L"data/actor/hijiri/guardMiss0002.bmp",
  L"data/actor/hijiri/guardMiss0003.bmp",
  L"data/actor/hijiri/hijiri.pat",
  L"data/actor/hijiri/hijiri_ed.pat",
  L"data/actor/hijiri/item0000.bmp",
  L"data/actor/hijiri/item0001.bmp",
  L"data/actor/hijiri/item0002.bmp",
  L"data/actor/hijiri/item0003.bmp",
  L"data/actor/hijiri/item0004.bmp",
  L"data/actor/hijiri/item0005.bmp",
  L"data/actor/hijiri/item0006.bmp",
  L"data/actor/hijiri/item0007.bmp",
  L"data/actor/hijiri/item0008.bmp",
  L"data/actor/hijiri/lose0000.bmp",
  L"data/actor/hijiri/lose0001.bmp",
  L"data/actor/hijiri/lose0002.bmp",
  L"data/actor/hijiri/lose0003.bmp",
  L"data/actor/hijiri/lose0004.bmp",
  L"data/actor/hijiri/lose0005.bmp",
  L"data/actor/hijiri/lose0006.bmp",
  L"data/actor/hijiri/lose0007.bmp",
  L"data/actor/hijiri/lose0008.bmp",
  L"data/actor/hijiri/lose0009.bmp",
  L"data/actor/hijiri/model/hijiri_skillG_dome.png",
  L"data/actor/hijiri/occult0000.bmp",
  L"data/actor/hijiri/occult0001.bmp",
  L"data/actor/hijiri/occult0002.bmp",
  L"data/actor/hijiri/occult0003.bmp",
  L"data/actor/hijiri/occult0004.bmp",
  L"data/actor/hijiri/occult0005.bmp",
  L"data/actor/hijiri/occult0006.bmp",
  L"data/actor/hijiri/occult0007.bmp",
  L"data/actor/hijiri/occult0008.bmp",
  L"data/actor/hijiri/occult0009.bmp",
  L"data/actor/hijiri/occult0010.bmp",
  L"data/actor/hijiri/occult0011.bmp",
  L"data/actor/hijiri/occult0012.bmp",
  L"data/actor/hijiri/occult0013.bmp",
  L"data/actor/hijiri/occult0014.bmp",
  L"data/actor/hijiri/palette000.bmp",
  L"data/actor/hijiri/palette001.bmp",
  L"data/actor/hijiri/palette002.bmp",
  L"data/actor/hijiri/palette003.bmp",
  L"data/actor/hijiri/palette004.bmp",
  L"data/actor/hijiri/palette005.bmp",
  L"data/actor/hijiri/palette006.bmp",
  L"data/actor/hijiri/palette007.bmp",
  L"data/actor/hijiri/shotHigh0000.bmp",
  L"data/actor/hijiri/shotHigh0001.bmp",
  L"data/actor/hijiri/shotHigh0002.bmp",
  L"data/actor/hijiri/shotHigh0003.bmp",
  L"data/actor/hijiri/shotHigh0004.bmp",
  L"data/actor/hijiri/shotHigh0005.bmp",
  L"data/actor/hijiri/shotHigh0006.bmp",
  L"data/actor/hijiri/shotHigh0007.bmp",
  L"data/actor/hijiri/shotHigh0008.bmp",
  L"data/actor/hijiri/shotHigh0009.bmp",
  L"data/actor/hijiri/shotHigh0010.bmp",
  L"data/actor/hijiri/shotHighFront0000.bmp",
  L"data/actor/hijiri/shotHighFront0001.bmp",
  L"data/actor/hijiri/shotHighFront0002.bmp",
  L"data/actor/hijiri/shotHighFront0003.bmp",
  L"data/actor/hijiri/shotHighFront0004.bmp",
  L"data/actor/hijiri/shotHighFront0005.bmp",
  L"data/actor/hijiri/shotHighFront0006.bmp",
  L"data/actor/hijiri/shotHighFront0007.bmp",
  L"data/actor/hijiri/shotHighFront0008.bmp",
  L"data/actor/hijiri/shotHighFront0009.bmp",
  L"data/actor/hijiri/shotLow0000.bmp",
  L"data/actor/hijiri/shotLow0001.bmp",
  L"data/actor/hijiri/shotLow0002.bmp",
  L"data/actor/hijiri/shotLow0003.bmp",
  L"data/actor/hijiri/shotLow0004.bmp",
  L"data/actor/hijiri/shotLow0005.bmp",
  L"data/actor/hijiri/shotLow0006.bmp",
  L"data/actor/hijiri/shotLow0007.bmp",
  L"data/actor/hijiri/shotLow0008.bmp",
  L"data/actor/hijiri/shotLow0009.bmp",
  L"data/actor/hijiri/skillA0000.bmp",
  L"data/actor/hijiri/skillA0001.bmp",
  L"data/actor/hijiri/skillA0002.bmp",
  L"data/actor/hijiri/skillA0003.bmp",
  L"data/actor/hijiri/skillA0004.bmp",
  L"data/actor/hijiri/skillA0005.bmp",
  L"data/actor/hijiri/skillA0006.bmp",
  L"data/actor/hijiri/skillA0007.bmp",
  L"data/actor/hijiri/skillA0008.bmp",
  L"data/actor/hijiri/skillA0009.bmp",
  L"data/actor/hijiri/skillAb0000.bmp",
  L"data/actor/hijiri/skillAb0001.bmp",
  L"data/actor/hijiri/skillAb0002.bmp",
  L"data/actor/hijiri/skillAb0003.bmp",
  L"data/actor/hijiri/skillAb0004.bmp",
  L"data/actor/hijiri/skillAb0005.bmp",
  L"data/actor/hijiri/skillAb0006.bmp",
  L"data/actor/hijiri/skillAb0007.bmp",
  L"data/actor/hijiri/skillB0000.bmp",
  L"data/actor/hijiri/skillB0001.bmp",
  L"data/actor/hijiri/skillB0002.bmp",
  L"data/actor/hijiri/skillB0003.bmp",
  L"data/actor/hijiri/skillB0004.bmp",
  L"data/actor/hijiri/skillB0005.bmp",
  L"data/actor/hijiri/skillB0006.bmp",
  L"data/actor/hijiri/skillB0007.bmp",
  L"data/actor/hijiri/skillB0008.bmp",
  L"data/actor/hijiri/skillC0000.bmp",
  L"data/actor/hijiri/skillC0001.bmp",
  L"data/actor/hijiri/skillC0002.bmp",
  L"data/actor/hijiri/skillC0003.bmp",
  L"data/actor/hijiri/skillC0004.bmp",
  L"data/actor/hijiri/skillC0005.bmp",
  L"data/actor/hijiri/skillC0006.bmp",
  L"data/actor/hijiri/skillC0007.bmp",
  L"data/actor/hijiri/skillC0008.bmp",
  L"data/actor/hijiri/skillCb0000.bmp",
  L"data/actor/hijiri/skillCb0001.bmp",
  L"data/actor/hijiri/skillCb0002.bmp",
  L"data/actor/hijiri/skillCb0003.bmp",
  L"data/actor/hijiri/skillCb0004.bmp",
  L"data/actor/hijiri/skillCb0005.bmp",
  L"data/actor/hijiri/skillCb0006.bmp",
  L"data/actor/hijiri/skillCb0007.bmp",
  L"data/actor/hijiri/skillCb0008.bmp",
  L"data/actor/hijiri/skillD0000.bmp",
  L"data/actor/hijiri/skillD0001.bmp",
  L"data/actor/hijiri/skillD0002.bmp",
  L"data/actor/hijiri/skillD0003.bmp",
  L"data/actor/hijiri/skillD0004.bmp",
  L"data/actor/hijiri/skillD0005.bmp",
  L"data/actor/hijiri/skillD0006.bmp",
  L"data/actor/hijiri/skillD0007.bmp",
  L"data/actor/hijiri/skillE0000.bmp",
  L"data/actor/hijiri/skillE0001.bmp",
  L"data/actor/hijiri/skillE0002.bmp",
  L"data/actor/hijiri/skillE0003.bmp",
  L"data/actor/hijiri/skillE0004.bmp",
  L"data/actor/hijiri/skillE0005.bmp",
  L"data/actor/hijiri/skillE0006.bmp",
  L"data/actor/hijiri/skillE0007.bmp",
  L"data/actor/hijiri/skillE0008.bmp",
  L"data/actor/hijiri/skillE0009.bmp",
  L"data/actor/hijiri/skillF0000.bmp",
  L"data/actor/hijiri/skillF0001.bmp",
  L"data/actor/hijiri/skillF0002.bmp",
  L"data/actor/hijiri/skillF0003.bmp",
  L"data/actor/hijiri/skillF0004.bmp",
  L"data/actor/hijiri/skillF0005.bmp",
  L"data/actor/hijiri/skillF0006.bmp",
  L"data/actor/hijiri/skillFb0000.bmp",
  L"data/actor/hijiri/skillFb0001.bmp",
  L"data/actor/hijiri/skillFb0002.bmp",
  L"data/actor/hijiri/skillFb0003.bmp",
  L"data/actor/hijiri/skillFb0004.bmp",
  L"data/actor/hijiri/skillFb0005.bmp",
  L"data/actor/hijiri/skillFb0006.bmp",
  L"data/actor/hijiri/skillG0000.bmp",
  L"data/actor/hijiri/skillG0001.bmp",
  L"data/actor/hijiri/skillG0002.bmp",
  L"data/actor/hijiri/skillG0003.bmp",
  L"data/actor/hijiri/skillG0004.bmp",
  L"data/actor/hijiri/skillG0005.bmp",
  L"data/actor/hijiri/skillG0006.bmp",
  L"data/actor/hijiri/skillG0007.bmp",
  L"data/actor/hijiri/skillG0008.bmp",
  L"data/actor/hijiri/skillG0009.bmp",
  L"data/actor/hijiri/skillG0010.bmp",
  L"data/actor/hijiri/skillG0011.bmp",
  L"data/actor/hijiri/skillG0012.bmp",
  L"data/actor/hijiri/skillG0013.bmp",
  L"data/actor/hijiri/skillG0014.bmp",
  L"data/actor/hijiri/slide0000.bmp",
  L"data/actor/hijiri/slide0001.bmp",
  L"data/actor/hijiri/slide0002.bmp",
  L"data/actor/hijiri/slide0003.bmp",
  L"data/actor/hijiri/slide0004.bmp",
  L"data/actor/hijiri/slide0005.bmp",
  L"data/actor/hijiri/slide0006.bmp",
  L"data/actor/hijiri/slide0007.bmp",
  L"data/actor/hijiri/slide0008.bmp",
  L"data/actor/hijiri/slide0009.bmp",
  L"data/actor/hijiri/slideUnderLoop0000.bmp",
  L"data/actor/hijiri/slideUnderLoop0001.bmp",
  L"data/actor/hijiri/slideUnderLoop0002.bmp",
  L"data/actor/hijiri/slideUnderLoop0003.bmp",
  L"data/actor/hijiri/slideUnderLoop0004.bmp",
  L"data/actor/hijiri/slideUpperLoop0000.bmp",
  L"data/actor/hijiri/slideUpperLoop0001.bmp",
  L"data/actor/hijiri/slideUpperLoop0002.bmp",
  L"data/actor/hijiri/slideUpperLoop0003.bmp",
  L"data/actor/hijiri/slideUpperLoop0004.bmp",
  L"data/actor/hijiri/spellB0000.bmp",
  L"data/actor/hijiri/spellB0001.bmp",
  L"data/actor/hijiri/spellB0002.bmp",
  L"data/actor/hijiri/spellB0003.bmp",
  L"data/actor/hijiri/spellB0004.bmp",
  L"data/actor/hijiri/spellB0005.bmp",
  L"data/actor/hijiri/spellB0006.bmp",
  L"data/actor/hijiri/spellB0007.bmp",
  L"data/actor/hijiri/spellB0008.bmp",
  L"data/actor/hijiri/spellB0009.bmp",
  L"data/actor/hijiri/spellB0010.bmp",
  L"data/actor/hijiri/spellB0011.bmp",
  L"data/actor/hijiri/spellB0012.bmp",
  L"data/actor/hijiri/spellB0013.bmp",
  L"data/actor/hijiri/spellB0014.bmp",
  L"data/actor/hijiri/spellC0000.bmp",
  L"data/actor/hijiri/spellC0001.bmp",
  L"data/actor/hijiri/spellC0002.bmp",
  L"data/actor/hijiri/spellC0003.bmp",
  L"data/actor/hijiri/spellC0004.bmp",
  L"data/actor/hijiri/spellC0005.bmp",
  L"data/actor/hijiri/spellC0006.bmp",
  L"data/actor/hijiri/spellC0007.bmp",
  L"data/actor/hijiri/spellC0008.bmp",
  L"data/actor/hijiri/spellC0009.bmp",
  L"data/actor/hijiri/spellC0010.bmp",
  L"data/actor/hijiri/spellC0011.bmp",
  L"data/actor/hijiri/spellC0012.bmp",
  L"data/actor/hijiri/spellC0013.bmp",
  L"data/actor/hijiri/spellC0014.bmp",
  L"data/actor/hijiri/spellC0015.bmp",
  L"data/actor/hijiri/spellC0016.bmp",
  L"data/actor/hijiri/spellC0017.bmp",
  L"data/actor/hijiri/spellC0018.bmp",
  L"data/actor/hijiri/stand0000.bmp",
  L"data/actor/hijiri/stand0001.bmp",
  L"data/actor/hijiri/stand0002.bmp",
  L"data/actor/hijiri/stand0003.bmp",
  L"data/actor/hijiri/stand0004.bmp",
  L"data/actor/hijiri/stand0005.bmp",
  L"data/actor/hijiri/stand0006.bmp",
  L"data/actor/hijiri/stand0007.bmp",
  L"data/actor/hijiri/stand0008.bmp",
  L"data/actor/hijiri/stand0009.bmp",
  L"data/actor/hijiri/stand0010.bmp",
  L"data/actor/hijiri/stand0011.bmp",
  L"data/actor/hijiri/stand0012.bmp",
  L"data/actor/hijiri/stand0013.bmp",
  L"data/actor/hijiri/stun0000.bmp",
  L"data/actor/hijiri/stun0001.bmp",
  L"data/actor/hijiri/stun0002.bmp",
  L"data/actor/hijiri/stun0003.bmp",
  L"data/actor/hijiri/stun0004.bmp",
  L"data/actor/hijiri/stun0005.bmp",
  L"data/actor/hijiri/stun0006.bmp",
  L"data/actor/hijiri/stun0007.bmp",
  L"data/actor/hijiri/stun0008.bmp",
  L"data/actor/hijiri/test_occult0001.bmp",
  L"data/actor/hijiri/texture/assultTrailA0000.png",
  L"data/actor/hijiri/texture/atkEffectA0000.png",
  L"data/actor/hijiri/texture/atkEffectA0001.png",
  L"data/actor/hijiri/texture/atkEffectA0002.png",
  L"data/actor/hijiri/texture/atkEffectA0003.png",
  L"data/actor/hijiri/texture/atkEffectA0004.png",
  L"data/actor/hijiri/texture/atkEffectA0005.png",
  L"data/actor/hijiri/texture/atkEffectA0006.png",
  L"data/actor/hijiri/texture/atkEffectA0007.png",
  L"data/actor/hijiri/texture/atkEffectA0008.png",
  L"data/actor/hijiri/texture/atkEffectA0009.png",
  L"data/actor/hijiri/texture/atkEffectA0010.png",
  L"data/actor/hijiri/texture/atkEffectA0011.png",
  L"data/actor/hijiri/texture/atkEffectA0012.png",
  L"data/actor/hijiri/texture/atkEffectA0013.png",
  L"data/actor/hijiri/texture/atkEffectA0014.png",
  L"data/actor/hijiri/texture/ball.bmp",
  L"data/actor/hijiri/texture/bladeA0000.png",
  L"data/actor/hijiri/texture/bladeB0000.png",
  L"data/actor/hijiri/texture/bladeC0000.png",
  L"data/actor/hijiri/texture/bladeD0000.png",
  L"data/actor/hijiri/texture/bladeE0000.png",
  L"data/actor/hijiri/texture/chouzyuuA.png",
  L"data/actor/hijiri/texture/climaxAuraA.png",
  L"data/actor/hijiri/texture/climaxBack.png",
  L"data/actor/hijiri/texture/climaxLaserA0000.png",
  L"data/actor/hijiri/texture/climaxLaserCore.dds",
  L"data/actor/hijiri/texture/climax_lineObject.png",
  L"data/actor/hijiri/texture/flare.bmp",
  L"data/actor/hijiri/texture/hijirimoji.png",
  L"data/actor/hijiri/texture/hijiri_animalDamage000.png",
  L"data/actor/hijiri/texture/hijiri_animalDamage001.png",
  L"data/actor/hijiri/texture/hijiri_animalDamage002.png",
  L"data/actor/hijiri/texture/hijiri_animalDamage003.png",
  L"data/actor/hijiri/texture/hijiri_animal_00000.png",
  L"data/actor/hijiri/texture/hijiri_animal_00001.png",
  L"data/actor/hijiri/texture/hijiri_animal_00002.png",
  L"data/actor/hijiri/texture/hijiri_animal_00003.png",
  L"data/actor/hijiri/texture/hijiri_animal_00004.png",
  L"data/actor/hijiri/texture/hijiri_animal_00005.png",
  L"data/actor/hijiri/texture/hijiri_animal_00006.png",
  L"data/actor/hijiri/texture/hijiri_animal_00007.png",
  L"data/actor/hijiri/texture/hijiri_animal_00008.png",
  L"data/actor/hijiri/texture/hijiri_animal_00009.png",
  L"data/actor/hijiri/texture/hijiri_animal_00010.png",
  L"data/actor/hijiri/texture/hijiri_animal_00011.png",
  L"data/actor/hijiri/texture/hijiri_climaxeffect.png",
  L"data/actor/hijiri/texture/hijiri_skillG.dds",
  L"data/actor/hijiri/texture/hijiri_skillG_Flash.dds",
  L"data/actor/hijiri/texture/hijiri_spellC_Pilar.dds",
  L"data/actor/hijiri/texture/kona_A.bmp",
  L"data/actor/hijiri/texture/lightningA.dds",
  L"data/actor/hijiri/texture/lightning_mapA.png",
  L"data/actor/hijiri/texture/lotus.png",
  L"data/actor/hijiri/texture/marisaBall2.bmp",
  L"data/actor/hijiri/texture/marisaStarFlare.bmp",
  L"data/actor/hijiri/texture/mask_ball.png",
  L"data/actor/hijiri/texture/ofudaHit.bmp",
  L"data/actor/hijiri/texture/reimu_fallKick.png",
  L"data/actor/hijiri/texture/reimu_wallA_mask.png",
  L"data/actor/hijiri/texture/scrollB0000.bmp",
  L"data/actor/hijiri/texture/scrollB0001.bmp",
  L"data/actor/hijiri/texture/scrollB0002.bmp",
  L"data/actor/hijiri/texture/scrollBm0000.bmp",
  L"data/actor/hijiri/texture/scrollBm0001.bmp",
  L"data/actor/hijiri/texture/scrollBm0002.bmp",
  L"data/actor/hijiri/texture/skillB.png",
  L"data/actor/hijiri/texture/skillG_Aura.dds",
  L"data/actor/hijiri/texture/slide0000.png",
  L"data/actor/hijiri/texture/smoke.png",
  L"data/actor/hijiri/texture/spark_object0000.dds",
  L"data/actor/hijiri/texture/spellCharge.png",
  L"data/actor/hijiri/texture/spellC_chopA.png",
  L"data/actor/hijiri/texture/spellC_chopA2.png",
  L"data/actor/hijiri/texture/spellC_Pilar.dds",
  L"data/actor/hijiri/texture/stoneA0000.png",
  L"data/actor/hijiri/texture/tornadeBase0000.png",
  L"data/actor/hijiri/texture/tornadebase0001.png",
  L"data/actor/hijiri/texture/tornadeBase0002.png",
  L"data/actor/hijiri/texture/trail.png",
  L"data/actor/hijiri/texture/0000.bmp",
  L"data/actor/hijiri/texture/0001.bmp",
  L"data/actor/hijiri/texture/0002.bmp",
  L"data/actor/hijiri/texture/0003.bmp",
  L"data/actor/hijiri/texture/0004.bmp",
  L"data/actor/hijiri/texture/0005.bmp",
  L"data/actor/hijiri/texture/mN0000.bmp",
  L"data/actor/hijiri/texture/mN0001.bmp",
  L"data/actor/hijiri/texture/mN0002.bmp",
  L"data/actor/hijiri/texture/mN0003.bmp",
  L"data/actor/hijiri/texture/mN0004.bmp",
  L"data/actor/hijiri/texture/mN0005.bmp",
  L"data/actor/hijiri/turn0000.bmp",
  L"data/actor/hijiri/turn0001.bmp",
  L"data/actor/hijiri/turn0002.bmp",
  L"data/actor/hijiri/walkBack0000.bmp",
  L"data/actor/hijiri/walkBack0001.bmp",
  L"data/actor/hijiri/walkBack0002.bmp",
  L"data/actor/hijiri/walkBack0003.bmp",
  L"data/actor/hijiri/walkBack0004.bmp",
  L"data/actor/hijiri/walkBack0005.bmp",
  L"data/actor/hijiri/walkBackLoop0000.bmp",
  L"data/actor/hijiri/walkBackLoop0001.bmp",
  L"data/actor/hijiri/walkBackLoop0002.bmp",
  L"data/actor/hijiri/walkBackLoop0003.bmp",
  L"data/actor/hijiri/walkBackLoop0004.bmp",
  L"data/actor/hijiri/walkFront0000.bmp",
  L"data/actor/hijiri/walkFront0001.bmp",
  L"data/actor/hijiri/walkFront0002.bmp",
  L"data/actor/hijiri/walkFront0003.bmp",
  L"data/actor/hijiri/walkFront0004.bmp",
  L"data/actor/hijiri/walkFront0005.bmp",
  L"data/actor/hijiri/walkFront0006.bmp",
  L"data/actor/hijiri/walkFrontLoop0000.bmp",
  L"data/actor/hijiri/walkFrontLoop0001.bmp",
  L"data/actor/hijiri/walkFrontLoop0002.bmp",
  L"data/actor/hijiri/walkFrontLoop0003.bmp",
  L"data/actor/hijiri/walkFrontLoop0004.bmp",
  L"data/actor/hijiri/winB0000.bmp",
  L"data/actor/hijiri/winB0001.bmp",
  L"data/actor/hijiri/winB0002.bmp",
  L"data/actor/hijiri/winB0003.bmp",
  L"data/actor/hijiri/winB0004.bmp",
  L"data/actor/hijiri/winB0005.bmp",
  L"data/actor/hijiri/winC0000.bmp",
  L"data/actor/hijiri/winC0001.bmp",
  L"data/actor/hijiri/winC0002.bmp",
  L"data/actor/hijiri/winC0003.bmp",
  L"data/actor/hijiri/winC0004.bmp",
  L"data/actor/hijiri/winC0005.bmp",
  L"data/actor/hijiri/winC0006.bmp",
  L"data/actor/hijiri/winC0007.bmp",
  L"data/actor/hijiri/winC0008.bmp",
  L"data/actor/hijiri/winC0009.bmp",
  L"data/actor/hijiri/winD0000.bmp",
  L"data/actor/hijiri/winD0001.bmp",
  L"data/actor/hijiri/winD0002.bmp",
  L"data/actor/hijiri/winD0003.bmp",
  L"data/actor/hijiri/winD0004.bmp",
  L"data/actor/hijiri/winD0005.bmp",
  L"data/actor/hijiri/winD0006.bmp",
  L"data/actor/hijiri/winD0007.bmp",
  L"data/actor/hijiri/winD0008.bmp",
  L"data/actor/hijiri/winD0009.bmp",
  L"data/actor/hijiri.nut",
  L"data/actor/hijiriInit.nut",
  L"data/actor/hijiri_base.nut",
  L"data/actor/hijiri_boss.nut",
  L"data/actor/hijiri_cpu.nut",
  L"data/actor/hijiri_cpuBoss.nut",
  L"data/actor/hijiri_r.nut",
  L"data/actor/hijiri_shot.nut",
  L"data/actor/ichirin/armA.png",
  L"data/actor/ichirin/armB.png",
  L"data/actor/ichirin/armB_b.png",
  L"data/actor/ichirin/atkLowA0000.bmp",
  L"data/actor/ichirin/atkLowA0001.bmp",
  L"data/actor/ichirin/atkLowA0002.bmp",
  L"data/actor/ichirin/atkLowA0003.bmp",
  L"data/actor/ichirin/atkLowA0004.bmp",
  L"data/actor/ichirin/atkLowB0000.bmp",
  L"data/actor/ichirin/atkLowB0001.bmp",
  L"data/actor/ichirin/atkLowB0002.bmp",
  L"data/actor/ichirin/atkLowB0003.bmp",
  L"data/actor/ichirin/atkLowB0004.bmp",
  L"data/actor/ichirin/atkLowB0005.bmp",
  L"data/actor/ichirin/atk_HighDash0000.bmp",
  L"data/actor/ichirin/atk_HighDash0001.bmp",
  L"data/actor/ichirin/atk_HighDash0002.bmp",
  L"data/actor/ichirin/atk_HighDash0003.bmp",
  L"data/actor/ichirin/atk_HighDash0004.bmp",
  L"data/actor/ichirin/atk_HighDash0005.bmp",
  L"data/actor/ichirin/atk_HighDash0006.bmp",
  L"data/actor/ichirin/atk_HighDash0007.bmp",
  L"data/actor/ichirin/atk_HighFront0000.bmp",
  L"data/actor/ichirin/atk_HighFront0001.bmp",
  L"data/actor/ichirin/atk_HighFront0002.bmp",
  L"data/actor/ichirin/atk_HighFront0003.bmp",
  L"data/actor/ichirin/atk_HighFront0004.bmp",
  L"data/actor/ichirin/atk_HighFront0005.bmp",
  L"data/actor/ichirin/atk_HighFront0006.bmp",
  L"data/actor/ichirin/atk_HighFront0007.bmp",
  L"data/actor/ichirin/atk_HighFront0008.bmp",
  L"data/actor/ichirin/atk_HighFront0009.bmp",
  L"data/actor/ichirin/atk_HighFront0010.bmp",
  L"data/actor/ichirin/atk_HighFront0011.bmp",
  L"data/actor/ichirin/atk_HighUnder0000.bmp",
  L"data/actor/ichirin/atk_HighUnder0001.bmp",
  L"data/actor/ichirin/atk_HighUnder0002.bmp",
  L"data/actor/ichirin/atk_HighUnder0003.bmp",
  L"data/actor/ichirin/atk_HighUnder0004.bmp",
  L"data/actor/ichirin/atk_HighUnder0005.bmp",
  L"data/actor/ichirin/atk_HighUnder0006.bmp",
  L"data/actor/ichirin/atk_HighUnder0007.bmp",
  L"data/actor/ichirin/atk_HighUnder0008.bmp",
  L"data/actor/ichirin/atk_HighUnder0009.bmp",
  L"data/actor/ichirin/atk_HighUnder0010.bmp",
  L"data/actor/ichirin/atk_HighUpper0000.bmp",
  L"data/actor/ichirin/atk_HighUpper0001.bmp",
  L"data/actor/ichirin/atk_HighUpper0002.bmp",
  L"data/actor/ichirin/atk_HighUpper0003.bmp",
  L"data/actor/ichirin/atk_HighUpper0004.bmp",
  L"data/actor/ichirin/atk_HighUpper0005.bmp",
  L"data/actor/ichirin/atk_HighUpper0006.bmp",
  L"data/actor/ichirin/atk_HighUpper0007.bmp",
  L"data/actor/ichirin/atk_HighUpper0008.bmp",
  L"data/actor/ichirin/atk_HighUpper0009.bmp",
  L"data/actor/ichirin/atk_HighUpper0010.bmp",
  L"data/actor/ichirin/atk_HighUpperB0000.bmp",
  L"data/actor/ichirin/atk_HighUpperB0001.bmp",
  L"data/actor/ichirin/atk_HighUpperB0002.bmp",
  L"data/actor/ichirin/atk_HighUpperB0003.bmp",
  L"data/actor/ichirin/atk_HighUpperB0004.bmp",
  L"data/actor/ichirin/atk_HighUpperB0005.bmp",
  L"data/actor/ichirin/atk_HighUpperB0006.bmp",
  L"data/actor/ichirin/atk_HighUpperB0007.bmp",
  L"data/actor/ichirin/atk_HighUpperB0008.bmp",
  L"data/actor/ichirin/atk_HighUpperB0009.bmp",
  L"data/actor/ichirin/atk_HighUpperB0010.bmp",
  L"data/actor/ichirin/atk_HighUpperB0011.bmp",
  L"data/actor/ichirin/atk_HighUpperB0012.bmp",
  L"data/actor/ichirin/atk_HighUpperB0013.bmp",
  L"data/actor/ichirin/atk_MidA0000.bmp",
  L"data/actor/ichirin/atk_MidA0001.bmp",
  L"data/actor/ichirin/atk_MidA0002.bmp",
  L"data/actor/ichirin/atk_MidA0003.bmp",
  L"data/actor/ichirin/atk_MidA0004.bmp",
  L"data/actor/ichirin/atk_MidA0005.bmp",
  L"data/actor/ichirin/atk_MidA0006.bmp",
  L"data/actor/ichirin/atk_MidA0007.bmp",
  L"data/actor/ichirin/battleBeginB0000.bmp",
  L"data/actor/ichirin/battleBeginB0001.bmp",
  L"data/actor/ichirin/battleBeginB0002.bmp",
  L"data/actor/ichirin/battleBeginB0003.bmp",
  L"data/actor/ichirin/battleBeginB0004.bmp",
  L"data/actor/ichirin/battleBeginB0005.bmp",
  L"data/actor/ichirin/battleBeginB0006.bmp",
  L"data/actor/ichirin/battleBeginB0007.bmp",
  L"data/actor/ichirin/battleBeginB0008.bmp",
  L"data/actor/ichirin/battleBeginBLoop0000.bmp",
  L"data/actor/ichirin/battleBeginBLoop0001.bmp",
  L"data/actor/ichirin/battleBeginBLoop0002.bmp",
  L"data/actor/ichirin/battleBeginBLoop0003.bmp",
  L"data/actor/ichirin/battleBeginBLoop0004.bmp",
  L"data/actor/ichirin/begin0000.bmp",
  L"data/actor/ichirin/begin0001.bmp",
  L"data/actor/ichirin/begin0002.bmp",
  L"data/actor/ichirin/beginLoop0000.bmp",
  L"data/actor/ichirin/beginLoop0001.bmp",
  L"data/actor/ichirin/beginLoop0002.bmp",
  L"data/actor/ichirin/beginLoop0003.bmp",
  L"data/actor/ichirin/beginLoop0004.bmp",
  L"data/actor/ichirin/bmsln/ichirin_fistHitA.bmb",
  L"data/actor/ichirin/bmsln/ichirin_sparkHand.bmb",
  L"data/actor/ichirin/bmsln/ichirin_sparkHandB.bmb",
  L"data/actor/ichirin/climax0000.bmp",
  L"data/actor/ichirin/climax0001.bmp",
  L"data/actor/ichirin/climax0002.bmp",
  L"data/actor/ichirin/climax0003.bmp",
  L"data/actor/ichirin/climaxLoop0000.bmp",
  L"data/actor/ichirin/climaxLoop0001.bmp",
  L"data/actor/ichirin/climaxLoop0002.bmp",
  L"data/actor/ichirin/climaxLoop0003.bmp",
  L"data/actor/ichirin/climaxLoop0004.bmp",
  L"data/actor/ichirin/climaxLoopB0000.bmp",
  L"data/actor/ichirin/climaxLoopB0001.bmp",
  L"data/actor/ichirin/climaxLoopB0002.bmp",
  L"data/actor/ichirin/climaxLoopB0003.bmp",
  L"data/actor/ichirin/climaxLoopB0004.bmp",
  L"data/actor/ichirin/cut0000.png",
  L"data/actor/ichirin/cut0001.png",
  L"data/actor/ichirin/damageBody0000.bmp",
  L"data/actor/ichirin/damageBody0001.bmp",
  L"data/actor/ichirin/damageBody0002.bmp",
  L"data/actor/ichirin/damageBody0003.bmp",
  L"data/actor/ichirin/damageBody0004.bmp",
  L"data/actor/ichirin/damageDownLoop0000.bmp",
  L"data/actor/ichirin/damageDownLoop0001.bmp",
  L"data/actor/ichirin/damageDownLoop0002.bmp",
  L"data/actor/ichirin/damageDownLoop0003.bmp",
  L"data/actor/ichirin/damageDownLoop0004.bmp",
  L"data/actor/ichirin/damageHead0000.bmp",
  L"data/actor/ichirin/damageHead0001.bmp",
  L"data/actor/ichirin/damageHead0002.bmp",
  L"data/actor/ichirin/damageHead0003.bmp",
  L"data/actor/ichirin/damageHead0004.bmp",
  L"data/actor/ichirin/damageSpin0000.bmp",
  L"data/actor/ichirin/damageSpin0001.bmp",
  L"data/actor/ichirin/damageSpin0002.bmp",
  L"data/actor/ichirin/damageSpin0003.bmp",
  L"data/actor/ichirin/damageUnderLoopA0000.bmp",
  L"data/actor/ichirin/damageUnderLoopA0001.bmp",
  L"data/actor/ichirin/damageUpper0000.bmp",
  L"data/actor/ichirin/damageUpper0001.bmp",
  L"data/actor/ichirin/damageUpper0002.bmp",
  L"data/actor/ichirin/damageUpper0003.bmp",
  L"data/actor/ichirin/damageUpper0004.bmp",
  L"data/actor/ichirin/damageUpper0005.bmp",
  L"data/actor/ichirin/damageUpper0006.bmp",
  L"data/actor/ichirin/damageUpper0007.bmp",
  L"data/actor/ichirin/damageUpper0008.bmp",
  L"data/actor/ichirin/damageUpperLoopA0000.bmp",
  L"data/actor/ichirin/damageUpperLoopA0001.bmp",
  L"data/actor/ichirin/damageWall0000.bmp",
  L"data/actor/ichirin/damageWall0001.bmp",
  L"data/actor/ichirin/damageWall0002.bmp",
  L"data/actor/ichirin/damageWall0003.bmp",
  L"data/actor/ichirin/damageWall0004.bmp",
  L"data/actor/ichirin/damageWall0005.bmp",
  L"data/actor/ichirin/damageWall0006.bmp",
  L"data/actor/ichirin/dashBack0000.bmp",
  L"data/actor/ichirin/dashBack0001.bmp",
  L"data/actor/ichirin/dashBack0002.bmp",
  L"data/actor/ichirin/dashBack0003.bmp",
  L"data/actor/ichirin/dashBack0004.bmp",
  L"data/actor/ichirin/dashBack0005.bmp",
  L"data/actor/ichirin/dashBack0006.bmp",
  L"data/actor/ichirin/dashBack0007.bmp",
  L"data/actor/ichirin/dashBackLoop0000.bmp",
  L"data/actor/ichirin/dashBackLoop0001.bmp",
  L"data/actor/ichirin/dashBackLoop0002.bmp",
  L"data/actor/ichirin/dashBackLoop0003.bmp",
  L"data/actor/ichirin/dashBackLoop0004.bmp",
  L"data/actor/ichirin/dashFront0000.bmp",
  L"data/actor/ichirin/dashFront0001.bmp",
  L"data/actor/ichirin/dashFront0002.bmp",
  L"data/actor/ichirin/dashFront0003.bmp",
  L"data/actor/ichirin/dashFront0004.bmp",
  L"data/actor/ichirin/dashFront0005.bmp",
  L"data/actor/ichirin/dashFront0006.bmp",
  L"data/actor/ichirin/dashFront0007.bmp",
  L"data/actor/ichirin/dashFront0008.bmp",
  L"data/actor/ichirin/dashFrontLoop0000.bmp",
  L"data/actor/ichirin/dashFrontLoop0001.bmp",
  L"data/actor/ichirin/dashFrontLoop0002.bmp",
  L"data/actor/ichirin/dashFrontLoop0003.bmp",
  L"data/actor/ichirin/dashFrontLoop0004.bmp",
  L"data/actor/ichirin/down0000.bmp",
  L"data/actor/ichirin/down0001.bmp",
  L"data/actor/ichirin/down0002.bmp",
  L"data/actor/ichirin/down0003.bmp",
  L"data/actor/ichirin/down0004.bmp",
  L"data/actor/ichirin/draw0000.bmp",
  L"data/actor/ichirin/draw0001.bmp",
  L"data/actor/ichirin/draw0002.bmp",
  L"data/actor/ichirin/draw0003.bmp",
  L"data/actor/ichirin/draw0004.bmp",
  L"data/actor/ichirin/dummy.bmp",
  L"data/actor/ichirin/face_spellcallb.png",
  L"data/actor/ichirin/guard0000.bmp",
  L"data/actor/ichirin/guard0001.bmp",
  L"data/actor/ichirin/guard0002.bmp",
  L"data/actor/ichirin/guard0003.bmp",
  L"data/actor/ichirin/guardCrash0000.bmp",
  L"data/actor/ichirin/guardCrash0001.bmp",
  L"data/actor/ichirin/guardCrash0002.bmp",
  L"data/actor/ichirin/guardCrash0003.bmp",
  L"data/actor/ichirin/guardCrash0004.bmp",
  L"data/actor/ichirin/hand1A.png",
  L"data/actor/ichirin/hand1B.png",
  L"data/actor/ichirin/hand2A.png",
  L"data/actor/ichirin/hand2B.png",
  L"data/actor/ichirin/hand3A.png",
  L"data/actor/ichirin/hand3B.png",
  L"data/actor/ichirin/head1.png",
  L"data/actor/ichirin/head2.png",
  L"data/actor/ichirin/ichirin.pat",
  L"data/actor/ichirin/ichirin_ed.pat",
  L"data/actor/ichirin/item0000.bmp",
  L"data/actor/ichirin/item0001.bmp",
  L"data/actor/ichirin/item0002.bmp",
  L"data/actor/ichirin/item0003.bmp",
  L"data/actor/ichirin/item0004.bmp",
  L"data/actor/ichirin/item0005.bmp",
  L"data/actor/ichirin/item0006.bmp",
  L"data/actor/ichirin/item0007.bmp",
  L"data/actor/ichirin/item0008.bmp",
  L"data/actor/ichirin/item0009.bmp",
  L"data/actor/ichirin/itemLoop0000.bmp",
  L"data/actor/ichirin/itemLoop0001.bmp",
  L"data/actor/ichirin/itemLoop0002.bmp",
  L"data/actor/ichirin/itemLoop0003.bmp",
  L"data/actor/ichirin/lose0000.bmp",
  L"data/actor/ichirin/lose0001.bmp",
  L"data/actor/ichirin/lose0002.bmp",
  L"data/actor/ichirin/lose0003.bmp",
  L"data/actor/ichirin/lose0004.bmp",
  L"data/actor/ichirin/lose0005.bmp",
  L"data/actor/ichirin/occult0000.bmp",
  L"data/actor/ichirin/occult0001.bmp",
  L"data/actor/ichirin/occult0002.bmp",
  L"data/actor/ichirin/occult0003.bmp",
  L"data/actor/ichirin/occult0004.bmp",
  L"data/actor/ichirin/occult0005.bmp",
  L"data/actor/ichirin/occult0006.bmp",
  L"data/actor/ichirin/occult0007.bmp",
  L"data/actor/ichirin/occultobject0000.bmp",
  L"data/actor/ichirin/occultobject0001.bmp",
  L"data/actor/ichirin/occultobject0002.bmp",
  L"data/actor/ichirin/occultobject0003.bmp",
  L"data/actor/ichirin/occultobject0004.bmp",
  L"data/actor/ichirin/occultobject0005.bmp",
  L"data/actor/ichirin/palette000.bmp",
  L"data/actor/ichirin/palette001.bmp",
  L"data/actor/ichirin/palette002.bmp",
  L"data/actor/ichirin/palette003.bmp",
  L"data/actor/ichirin/palette004.bmp",
  L"data/actor/ichirin/palette005.bmp",
  L"data/actor/ichirin/palette006.bmp",
  L"data/actor/ichirin/palette007.bmp",
  L"data/actor/ichirin/shotA0000.bmp",
  L"data/actor/ichirin/shotA0001.bmp",
  L"data/actor/ichirin/shotA0002.bmp",
  L"data/actor/ichirin/shotA0003.bmp",
  L"data/actor/ichirin/shotA0004.bmp",
  L"data/actor/ichirin/shotA0005.bmp",
  L"data/actor/ichirin/shotA0006.bmp",
  L"data/actor/ichirin/shotA0007.bmp",
  L"data/actor/ichirin/shotA0008.bmp",
  L"data/actor/ichirin/shotA0009.bmp",
  L"data/actor/ichirin/shotA0010.bmp",
  L"data/actor/ichirin/shotA0011.bmp",
  L"data/actor/ichirin/shotA_Front0000.bmp",
  L"data/actor/ichirin/shotA_Front0001.bmp",
  L"data/actor/ichirin/shotA_Front0002.bmp",
  L"data/actor/ichirin/shotA_Front0003.bmp",
  L"data/actor/ichirin/shotA_Front0004.bmp",
  L"data/actor/ichirin/shotA_Front0005.bmp",
  L"data/actor/ichirin/shotA_Front0006.bmp",
  L"data/actor/ichirin/shotA_Front0007.bmp",
  L"data/actor/ichirin/shotA_Front0008.bmp",
  L"data/actor/ichirin/shotA_Loop0000.bmp",
  L"data/actor/ichirin/shotA_Loop0001.bmp",
  L"data/actor/ichirin/shotA_Loop0002.bmp",
  L"data/actor/ichirin/shotA_LoopB0000.bmp",
  L"data/actor/ichirin/shotA_LoopB0001.bmp",
  L"data/actor/ichirin/shotA_LoopB0002.bmp",
  L"data/actor/ichirin/shotB0000.bmp",
  L"data/actor/ichirin/shotB0001.bmp",
  L"data/actor/ichirin/shotB0002.bmp",
  L"data/actor/ichirin/shotB0003.bmp",
  L"data/actor/ichirin/shotB0004.bmp",
  L"data/actor/ichirin/shotB0005.bmp",
  L"data/actor/ichirin/shotB0006.bmp",
  L"data/actor/ichirin/shotB0007.bmp",
  L"data/actor/ichirin/shotB0008.bmp",
  L"data/actor/ichirin/shotB0009.bmp",
  L"data/actor/ichirin/shotB0010.bmp",
  L"data/actor/ichirin/shot_High0000.bmp",
  L"data/actor/ichirin/shot_High0001.bmp",
  L"data/actor/ichirin/shot_High0002.bmp",
  L"data/actor/ichirin/shot_High0003.bmp",
  L"data/actor/ichirin/shot_High0004.bmp",
  L"data/actor/ichirin/shot_High0005.bmp",
  L"data/actor/ichirin/shot_High0006.bmp",
  L"data/actor/ichirin/shot_High0007.bmp",
  L"data/actor/ichirin/shot_High0008.bmp",
  L"data/actor/ichirin/shot_High0009.bmp",
  L"data/actor/ichirin/skillA0000.bmp",
  L"data/actor/ichirin/skillA0001.bmp",
  L"data/actor/ichirin/skillA0002.bmp",
  L"data/actor/ichirin/skillA0003.bmp",
  L"data/actor/ichirin/skillA0004.bmp",
  L"data/actor/ichirin/skillA0005.bmp",
  L"data/actor/ichirin/skillA0006.bmp",
  L"data/actor/ichirin/skillA0007.bmp",
  L"data/actor/ichirin/skillA0008.bmp",
  L"data/actor/ichirin/skillA0009.bmp",
  L"data/actor/ichirin/skillA0010.bmp",
  L"data/actor/ichirin/skillB0000.bmp",
  L"data/actor/ichirin/skillB0001.bmp",
  L"data/actor/ichirin/skillB0002.bmp",
  L"data/actor/ichirin/skillB0003.bmp",
  L"data/actor/ichirin/skillB0004.bmp",
  L"data/actor/ichirin/skillB0005.bmp",
  L"data/actor/ichirin/skillB0006.bmp",
  L"data/actor/ichirin/skillB0007.bmp",
  L"data/actor/ichirin/skillB0008.bmp",
  L"data/actor/ichirin/skillB0009.bmp",
  L"data/actor/ichirin/skillB0010.bmp",
  L"data/actor/ichirin/skillB0011.bmp",
  L"data/actor/ichirin/slideLoop0000.bmp",
  L"data/actor/ichirin/slideLoop0001.bmp",
  L"data/actor/ichirin/slideLoop0002.bmp",
  L"data/actor/ichirin/slideLoop0003.bmp",
  L"data/actor/ichirin/slideLoop0004.bmp",
  L"data/actor/ichirin/slideLoop_Upper0000.bmp",
  L"data/actor/ichirin/slideLoop_Upper0001.bmp",
  L"data/actor/ichirin/slideLoop_Upper0002.bmp",
  L"data/actor/ichirin/slideLoop_Upper0003.bmp",
  L"data/actor/ichirin/slideLoop_Upper0004.bmp",
  L"data/actor/ichirin/slideUp0000.bmp",
  L"data/actor/ichirin/slideUp0001.bmp",
  L"data/actor/ichirin/slideUp0002.bmp",
  L"data/actor/ichirin/slideUp0003.bmp",
  L"data/actor/ichirin/slideUp0004.bmp",
  L"data/actor/ichirin/slideUp0005.bmp",
  L"data/actor/ichirin/slideUp0006.bmp",
  L"data/actor/ichirin/slideUp0007.bmp",
  L"data/actor/ichirin/slideUp0008.bmp",
  L"data/actor/ichirin/spellA0000.bmp",
  L"data/actor/ichirin/spellA0001.bmp",
  L"data/actor/ichirin/spellA0002.bmp",
  L"data/actor/ichirin/spellA0003.bmp",
  L"data/actor/ichirin/spellA0004.bmp",
  L"data/actor/ichirin/spellA0005.bmp",
  L"data/actor/ichirin/spellA0006.bmp",
  L"data/actor/ichirin/spellA0007.bmp",
  L"data/actor/ichirin/spellA0008.bmp",
  L"data/actor/ichirin/spellA0009.bmp",
  L"data/actor/ichirin/spellA0010.bmp",
  L"data/actor/ichirin/spellA0011.bmp",
  L"data/actor/ichirin/spellA0012.bmp",
  L"data/actor/ichirin/spellA0013.bmp",
  L"data/actor/ichirin/spellA0014.bmp",
  L"data/actor/ichirin/spellA0015.bmp",
  L"data/actor/ichirin/spellA0016.bmp",
  L"data/actor/ichirin/spellA0017.bmp",
  L"data/actor/ichirin/spellA0018.bmp",
  L"data/actor/ichirin/spellA0019.bmp",
  L"data/actor/ichirin/spellA0020.bmp",
  L"data/actor/ichirin/spellB0000.bmp",
  L"data/actor/ichirin/spellB0001.bmp",
  L"data/actor/ichirin/spellB0002.bmp",
  L"data/actor/ichirin/spellB0003.bmp",
  L"data/actor/ichirin/spellB0004.bmp",
  L"data/actor/ichirin/spellB0005.bmp",
  L"data/actor/ichirin/spellB0006.bmp",
  L"data/actor/ichirin/spellB0007.bmp",
  L"data/actor/ichirin/spellB0008.bmp",
  L"data/actor/ichirin/spellB0009.bmp",
  L"data/actor/ichirin/spellB0010.bmp",
  L"data/actor/ichirin/spellB0011.bmp",
  L"data/actor/ichirin/spellB0012.bmp",
  L"data/actor/ichirin/spellB0013.bmp",
  L"data/actor/ichirin/spellB0014.bmp",
  L"data/actor/ichirin/spellB0015.bmp",
  L"data/actor/ichirin/spellB0016.bmp",
  L"data/actor/ichirin/spellB0017.bmp",
  L"data/actor/ichirin/spellC0000.bmp",
  L"data/actor/ichirin/spellC0001.bmp",
  L"data/actor/ichirin/spellC0002.bmp",
  L"data/actor/ichirin/spellC0003.bmp",
  L"data/actor/ichirin/spellC0004.bmp",
  L"data/actor/ichirin/spellC0005.bmp",
  L"data/actor/ichirin/spellC0006.bmp",
  L"data/actor/ichirin/spellC0007.bmp",
  L"data/actor/ichirin/spellC0008.bmp",
  L"data/actor/ichirin/spellC0009.bmp",
  L"data/actor/ichirin/spellC0010.bmp",
  L"data/actor/ichirin/spellC0011.bmp",
  L"data/actor/ichirin/spellC0012.bmp",
  L"data/actor/ichirin/stand0000.bmp",
  L"data/actor/ichirin/stand0001.bmp",
  L"data/actor/ichirin/stand0002.bmp",
  L"data/actor/ichirin/stand0003.bmp",
  L"data/actor/ichirin/stand0004.bmp",
  L"data/actor/ichirin/stand0005.bmp",
  L"data/actor/ichirin/stand0006.bmp",
  L"data/actor/ichirin/stand0007.bmp",
  L"data/actor/ichirin/stand0008.bmp",
  L"data/actor/ichirin/stand0009.bmp",
  L"data/actor/ichirin/stand0010.bmp",
  L"data/actor/ichirin/stand0011.bmp",
  L"data/actor/ichirin/stand0012.bmp",
  L"data/actor/ichirin/stand0013.bmp",
  L"data/actor/ichirin/stand0014.bmp",
  L"data/actor/ichirin/stun0000.bmp",
  L"data/actor/ichirin/stun0001.bmp",
  L"data/actor/ichirin/stun0002.bmp",
  L"data/actor/ichirin/stun0003.bmp",
  L"data/actor/ichirin/stun0004.bmp",
  L"data/actor/ichirin/stunLoop0000.bmp",
  L"data/actor/ichirin/stunLoop0001.bmp",
  L"data/actor/ichirin/stunLoop0002.bmp",
  L"data/actor/ichirin/stunLoop0003.bmp",
  L"data/actor/ichirin/stunLoop0004.bmp",
  L"data/actor/ichirin/testr_climaxcutaura.png",
  L"data/actor/ichirin/test_bulletA000.bmp",
  L"data/actor/ichirin/test_effect.bmp",
  L"data/actor/ichirin/test_occult0000.bmp",
  L"data/actor/ichirin/test_occult0001.bmp",
  L"data/actor/ichirin/test_occult0002.bmp",
  L"data/actor/ichirin/test_occult0003.bmp",
  L"data/actor/ichirin/test_occult0004.bmp",
  L"data/actor/ichirin/test_skillTarnado001.png",
  L"data/actor/ichirin/test_skillTarnado002.png",
  L"data/actor/ichirin/texture/ball.png",
  L"data/actor/ichirin/texture/climax_aura0001.dds",
  L"data/actor/ichirin/texture/hitParticle.png",
  L"data/actor/ichirin/texture/hitSpark.png",
  L"data/actor/ichirin/texture/ichilin_climaxaura0000.png",
  L"data/actor/ichirin/texture/ichilin_climaxaura0001.png",
  L"data/actor/ichirin/texture/ichilin_climaxmask0000.png",
  L"data/actor/ichirin/texture/ichirin_animalDamage000.png",
  L"data/actor/ichirin/texture/ichirin_animalDamage001.png",
  L"data/actor/ichirin/texture/ichirin_animalDamage002.png",
  L"data/actor/ichirin/texture/ichirin_animalDamage003.png",
  L"data/actor/ichirin/texture/ichirin_animal_00000.png",
  L"data/actor/ichirin/texture/ichirin_animal_00001.png",
  L"data/actor/ichirin/texture/ichirin_animal_00002.png",
  L"data/actor/ichirin/texture/ichirin_animal_00003.png",
  L"data/actor/ichirin/texture/ichirin_animal_00004.png",
  L"data/actor/ichirin/texture/ichirin_animal_00005.png",
  L"data/actor/ichirin/texture/ichirin_animal_00006.png",
  L"data/actor/ichirin/texture/ichirin_animal_00007.png",
  L"data/actor/ichirin/texture/ichirin_animal_00008.png",
  L"data/actor/ichirin/texture/ichirin_animal_00009.png",
  L"data/actor/ichirin/texture/ichirin_animal_00010.png",
  L"data/actor/ichirin/texture/ichirin_animal_00011.png",
  L"data/actor/ichirin/texture/ichirin_back0000.png",
  L"data/actor/ichirin/texture/ichirin_climaxsmile0000.png",
  L"data/actor/ichirin/texture/ichirin_vortex0000.png",
  L"data/actor/ichirin/texture/kumo.png",
  L"data/actor/ichirin/texture/occultfire0000.dds",
  L"data/actor/ichirin/texture/shot_laserA0000.png",
  L"data/actor/ichirin/texture/tatumakiA0000.png",
  L"data/actor/ichirin/texture/tatumakiA0001.png",
  L"data/actor/ichirin/texture/tatumakiA0002.png",
  L"data/actor/ichirin/texture/tatumakiA0003.png",
  L"data/actor/ichirin/texture/tatumakiA0004.png",
  L"data/actor/ichirin/texture/tatumakiA0005.png",
  L"data/actor/ichirin/texture/tatumakiA0006.png",
  L"data/actor/ichirin/texture/tatumakiA0007.png",
  L"data/actor/ichirin/texture/test_bulletBa000.bmp",
  L"data/actor/ichirin/texture/test_bulletBb000.bmp",
  L"data/actor/ichirin/texture/unzanBeam.png",
  L"data/actor/ichirin/texture/unzanEffectC0000.png",
  L"data/actor/ichirin/texture/unzanEffectC0001.png",
  L"data/actor/ichirin/texture/unzanSmokeA0000.png",
  L"data/actor/ichirin/texture/unzanThunderA0000.png",
  L"data/actor/ichirin/turn0000.bmp",
  L"data/actor/ichirin/turn0001.bmp",
  L"data/actor/ichirin/turn0002.bmp",
  L"data/actor/ichirin/turn0003.bmp",
  L"data/actor/ichirin/unzanClowd.png",
  L"data/actor/ichirin/unzanHeadSpin0000.png",
  L"data/actor/ichirin/unzanHeadSpin0001.png",
  L"data/actor/ichirin/unzan_EffectA0000.bmp",
  L"data/actor/ichirin/unzan_EffectA0001.bmp",
  L"data/actor/ichirin/unzan_EffectA0002.bmp",
  L"data/actor/ichirin/unzan_EffectB0000.bmp",
  L"data/actor/ichirin/unzan_EffectB0001.bmp",
  L"data/actor/ichirin/unzan_EffectB0002.bmp",
  L"data/actor/ichirin/unzan_EffectC0000.bmp",
  L"data/actor/ichirin/unzan_EffectC0001.bmp",
  L"data/actor/ichirin/unzan_EffectC0002.bmp",
  L"data/actor/ichirin/unzan_EffectD0000.bmp",
  L"data/actor/ichirin/unzan_EffectD0001.bmp",
  L"data/actor/ichirin/unzan_EffectD0002.bmp",
  L"data/actor/ichirin/unzan_EffectE0000.bmp",
  L"data/actor/ichirin/unzan_EffectE0001.bmp",
  L"data/actor/ichirin/unzan_EffectE0002.bmp",
  L"data/actor/ichirin/unzan_EffectF0000.bmp",
  L"data/actor/ichirin/unzan_EffectF0001.bmp",
  L"data/actor/ichirin/unzan_EffectF0002.bmp",
  L"data/actor/ichirin/unzan_handA.png",
  L"data/actor/ichirin/unzan_handA_a.png",
  L"data/actor/ichirin/unzan_handA_b.png",
  L"data/actor/ichirin/unzan_handA_c.png",
  L"data/actor/ichirin/unzan_handB.png",
  L"data/actor/ichirin/unzan_handB_a.png",
  L"data/actor/ichirin/unzan_handC.png",
  L"data/actor/ichirin/unzan_handC_a.png",
  L"data/actor/ichirin/unzan_handC_b.png",
  L"data/actor/ichirin/unzan_handC_c.png",
  L"data/actor/ichirin/unzan_handC_d.png",
  L"data/actor/ichirin/unzan_handD.png",
  L"data/actor/ichirin/unzan_handD_a.png",
  L"data/actor/ichirin/unzan_handD_b.png",
  L"data/actor/ichirin/unzan_handD_c.png",
  L"data/actor/ichirin/unzan_handE.png",
  L"data/actor/ichirin/unzan_handE_a.png",
  L"data/actor/ichirin/unzan_handE_b.png",
  L"data/actor/ichirin/unzan_handE_c.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0000.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0006.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0014.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0015.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0016.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0019.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0022.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0024.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0025.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0026.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0029.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0031.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0032.png",
  L"data/actor/ichirin/unzan_HeadDowbleUpper0033.png",
  L"data/actor/ichirin/unzan_HeadFront0000.png",
  L"data/actor/ichirin/unzan_HeadFront0006.png",
  L"data/actor/ichirin/unzan_HeadFront0010.png",
  L"data/actor/ichirin/unzan_HeadFront0014.png",
  L"data/actor/ichirin/unzan_HeadFront0015.png",
  L"data/actor/ichirin/unzan_HeadFront0016.png",
  L"data/actor/ichirin/unzan_HeadFront0019.png",
  L"data/actor/ichirin/unzan_HeadFront0023.png",
  L"data/actor/ichirin/unzan_HeadFront0026.png",
  L"data/actor/ichirin/unzan_HeadFront0027.png",
  L"data/actor/ichirin/unzan_HeadFront0028.png",
  L"data/actor/ichirin/unzan_HeadFront0029.png",
  L"data/actor/ichirin/unzan_HeadFront0031.png",
  L"data/actor/ichirin/unzan_HeadFront0035.png",
  L"data/actor/ichirin/unzan_HeadHook0000.png",
  L"data/actor/ichirin/unzan_HeadHook0006.png",
  L"data/actor/ichirin/unzan_HeadHook0015.png",
  L"data/actor/ichirin/unzan_HeadHook0016.png",
  L"data/actor/ichirin/unzan_HeadHook0017.png",
  L"data/actor/ichirin/unzan_HeadHook0018.png",
  L"data/actor/ichirin/unzan_HeadHook0019.png",
  L"data/actor/ichirin/unzan_HeadHook0027.png",
  L"data/actor/ichirin/unzan_HeadHook0029.png",
  L"data/actor/ichirin/unzan_HeadHook0030.png",
  L"data/actor/ichirin/unzan_HeadStraight0000.png",
  L"data/actor/ichirin/unzan_HeadStraight0002.png",
  L"data/actor/ichirin/unzan_HeadStraight0005.png",
  L"data/actor/ichirin/unzan_HeadStraight0006.png",
  L"data/actor/ichirin/unzan_HeadStraight0007.png",
  L"data/actor/ichirin/unzan_HeadStraight0011.png",
  L"data/actor/ichirin/unzan_HeadStraight0012.png",
  L"data/actor/ichirin/unzan_HeadStraight0013.png",
  L"data/actor/ichirin/unzan_HeadStraight0014.png",
  L"data/actor/ichirin/unzan_HeadStraight0016.png",
  L"data/actor/ichirin/unzan_HeadStraight0019.png",
  L"data/actor/ichirin/unzan_HeadStraight0021.png",
  L"data/actor/ichirin/unzan_HeadUnder0000.png",
  L"data/actor/ichirin/unzan_HeadUnder0006.png",
  L"data/actor/ichirin/unzan_HeadUnder0009.png",
  L"data/actor/ichirin/unzan_HeadUnder0011.png",
  L"data/actor/ichirin/unzan_HeadUnder0014.png",
  L"data/actor/ichirin/unzan_HeadUnder0015.png",
  L"data/actor/ichirin/unzan_HeadUnder0018.png",
  L"data/actor/ichirin/unzan_HeadUnder0021.png",
  L"data/actor/ichirin/unzan_HeadUnder0024.png",
  L"data/actor/ichirin/unzan_HeadUnder0027.png",
  L"data/actor/ichirin/unzan_HeadUnder0028.png",
  L"data/actor/ichirin/unzan_HeadUnder0031.png",
  L"data/actor/ichirin/unzan_HeadUnder0032.png",
  L"data/actor/ichirin/unzan_HeadUpper0000.png",
  L"data/actor/ichirin/unzan_HeadUpper0006.png",
  L"data/actor/ichirin/unzan_HeadUpper0009.png",
  L"data/actor/ichirin/unzan_HeadUpper0012.png",
  L"data/actor/ichirin/unzan_HeadUpper0014.png",
  L"data/actor/ichirin/unzan_HeadUpper0015.png",
  L"data/actor/ichirin/unzan_HeadUpper0024.png",
  L"data/actor/ichirin/unzan_HeadUpper0025.png",
  L"data/actor/ichirin/unzan_HeadUpper0026.png",
  L"data/actor/ichirin/unzan_HeadUpper0027.png",
  L"data/actor/ichirin/unzan_HeadUpper0028.png",
  L"data/actor/ichirin/unzan_HeadUpper0029.png",
  L"data/actor/ichirin/unzan_HeadUpper0031.png",
  L"data/actor/ichirin/unzan_HeadUpper0033.png",
  L"data/actor/ichirin/walkBack0000.bmp",
  L"data/actor/ichirin/walkBack0001.bmp",
  L"data/actor/ichirin/walkBack0002.bmp",
  L"data/actor/ichirin/walkBack0003.bmp",
  L"data/actor/ichirin/walkBack0004.bmp",
  L"data/actor/ichirin/walkBack0005.bmp",
  L"data/actor/ichirin/walkBack0006.bmp",
  L"data/actor/ichirin/walkBack0007.bmp",
  L"data/actor/ichirin/walkBackloop0000.bmp",
  L"data/actor/ichirin/walkBackloop0001.bmp",
  L"data/actor/ichirin/walkBackloop0002.bmp",
  L"data/actor/ichirin/walkBackloop0003.bmp",
  L"data/actor/ichirin/walkBackloop0004.bmp",
  L"data/actor/ichirin/walkFront0000.bmp",
  L"data/actor/ichirin/walkFront0001.bmp",
  L"data/actor/ichirin/walkFront0002.bmp",
  L"data/actor/ichirin/walkFront0003.bmp",
  L"data/actor/ichirin/walkFront0004.bmp",
  L"data/actor/ichirin/walkFront0005.bmp",
  L"data/actor/ichirin/walkFront0006.bmp",
  L"data/actor/ichirin/walkFront0007.bmp",
  L"data/actor/ichirin/walkFrontLoop0000.bmp",
  L"data/actor/ichirin/walkFrontLoop0001.bmp",
  L"data/actor/ichirin/walkFrontLoop0002.bmp",
  L"data/actor/ichirin/walkFrontLoop0003.bmp",
  L"data/actor/ichirin/walkFrontLoop0004.bmp",
  L"data/actor/ichirin/winA0000.bmp",
  L"data/actor/ichirin/winA0001.bmp",
  L"data/actor/ichirin/winA0002.bmp",
  L"data/actor/ichirin/winA0003.bmp",
  L"data/actor/ichirin/winA0004.bmp",
  L"data/actor/ichirin/winA0005.bmp",
  L"data/actor/ichirin/winA0006.bmp",
  L"data/actor/ichirin/winA0007.bmp",
  L"data/actor/ichirin/winA0008.bmp",
  L"data/actor/ichirin/winA0009.bmp",
  L"data/actor/ichirin/winA0010.bmp",
  L"data/actor/ichirin/winA0011.bmp",
  L"data/actor/ichirin/winA0012.bmp",
  L"data/actor/ichirin/winA0013.bmp",
  L"data/actor/ichirin/winB0000.bmp",
  L"data/actor/ichirin/winB0001.bmp",
  L"data/actor/ichirin/winB0002.bmp",
  L"data/actor/ichirin/winB0003.bmp",
  L"data/actor/ichirin/winB0004.bmp",
  L"data/actor/ichirin/winB0005.bmp",
  L"data/actor/ichirin/winB0006.bmp",
  L"data/actor/ichirin/winC0000.bmp",
  L"data/actor/ichirin/winC0001.bmp",
  L"data/actor/ichirin/winC0002.bmp",
  L"data/actor/ichirin/winC0003.bmp",
  L"data/actor/ichirin/winC0004.bmp",
  L"data/actor/ichirin/winC0005.bmp",
  L"data/actor/ichirin/winC0006.bmp",
  L"data/actor/ichirin/winC_Loop0000.bmp",
  L"data/actor/ichirin/winC_Loop0001.bmp",
  L"data/actor/ichirin/winC_Loop0002.bmp",
  L"data/actor/ichirin/winC_Loop0003.bmp",
  L"data/actor/ichirin/winD0000.bmp",
  L"data/actor/ichirin/winD0001.bmp",
  L"data/actor/ichirin/winD0002.bmp",
  L"data/actor/ichirin/winD0003.bmp",
  L"data/actor/ichirin/winD0004.bmp",
  L"data/actor/ichirin/winD_Loop0000.bmp",
  L"data/actor/ichirin/winD_Loop0001.bmp",
  L"data/actor/ichirin/winD_Loop0002.bmp",
  L"data/actor/ichirin/winD_Loop0003.bmp",
  L"data/actor/ichirin/win_ObjectA000.bmp",
  L"data/actor/ichirin/win_ObjectB000.bmp",
  L"data/actor/ichirin.nut",
  L"data/actor/ichirinInit.nut",
  L"data/actor/ichirin_base.nut",
  L"data/actor/ichirin_boss.nut",
  L"data/actor/ichirin_cpu.nut",
  L"data/actor/ichirin_cpuBoss.nut",
  L"data/actor/ichirin_shot.nut",
  L"data/actor/item.nut",
  L"data/actor/kasen/atkFront0000.bmp",
  L"data/actor/kasen/atkFront0001.bmp",
  L"data/actor/kasen/atkFront0002.bmp",
  L"data/actor/kasen/atkFront0003.bmp",
  L"data/actor/kasen/atkFront0004.bmp",
  L"data/actor/kasen/atkFront0005.bmp",
  L"data/actor/kasen/atkFront0006.bmp",
  L"data/actor/kasen/atkFront0007.bmp",
  L"data/actor/kasen/atkHighFront0000.bmp",
  L"data/actor/kasen/atkHighFront0001.bmp",
  L"data/actor/kasen/atkHighFront0002.bmp",
  L"data/actor/kasen/atkHighFront0003.bmp",
  L"data/actor/kasen/atkHighFront0004.bmp",
  L"data/actor/kasen/atkHighFront0005.bmp",
  L"data/actor/kasen/atkHighFront0006.bmp",
  L"data/actor/kasen/atkHighFront0007.bmp",
  L"data/actor/kasen/atkHighFront0008.bmp",
  L"data/actor/kasen/atkLow0000.bmp",
  L"data/actor/kasen/atkLow0001.bmp",
  L"data/actor/kasen/atkLow0002.bmp",
  L"data/actor/kasen/atkLow0003.bmp",
  L"data/actor/kasen/atkLow0004.bmp",
  L"data/actor/kasen/atkLow0005.bmp",
  L"data/actor/kasen/atkUpper0000.bmp",
  L"data/actor/kasen/atkUpper0001.bmp",
  L"data/actor/kasen/atkUpper0002.bmp",
  L"data/actor/kasen/atkUpper0003.bmp",
  L"data/actor/kasen/atkUpper0004.bmp",
  L"data/actor/kasen/atkUpper0005.bmp",
  L"data/actor/kasen/atkUpper0006.bmp",
  L"data/actor/kasen/atkUpper0007.bmp",
  L"data/actor/kasen/atkUpper0008.bmp",
  L"data/actor/kasen/atkUpper0009.bmp",
  L"data/actor/kasen/atkUpper0010.bmp",
  L"data/actor/kasen/atkUpperArm0000.bmp",
  L"data/actor/kasen/atkUpperArm0001.bmp",
  L"data/actor/kasen/atkUpperArm0002.bmp",
  L"data/actor/kasen/atkUpperArm0003.bmp",
  L"data/actor/kasen/atk_dashLow0000.bmp",
  L"data/actor/kasen/atk_dashLow0001.bmp",
  L"data/actor/kasen/atk_dashLow0002.bmp",
  L"data/actor/kasen/atk_dashLow0003.bmp",
  L"data/actor/kasen/atk_dashLow0004.bmp",
  L"data/actor/kasen/atk_dashLow0005.bmp",
  L"data/actor/kasen/atk_dashLow0006.bmp",
  L"data/actor/kasen/atk_dashLow0007.bmp",
  L"data/actor/kasen/atk_Mid0000.bmp",
  L"data/actor/kasen/atk_Mid0001.bmp",
  L"data/actor/kasen/atk_Mid0002.bmp",
  L"data/actor/kasen/atk_Mid0003.bmp",
  L"data/actor/kasen/atk_Mid0004.bmp",
  L"data/actor/kasen/atk_Mid0005.bmp",
  L"data/actor/kasen/atk_Mid0006.bmp",
  L"data/actor/kasen/atk_Mid0007.bmp",
  L"data/actor/kasen/atk_Mid0008.bmp",
  L"data/actor/kasen/atk_mid_air0000.bmp",
  L"data/actor/kasen/atk_mid_air0001.bmp",
  L"data/actor/kasen/atk_mid_air0002.bmp",
  L"data/actor/kasen/atk_mid_air0003.bmp",
  L"data/actor/kasen/atk_mid_air0004.bmp",
  L"data/actor/kasen/atk_mid_air0005.bmp",
  L"data/actor/kasen/atk_mid_air0006.bmp",
  L"data/actor/kasen/atk_Under0000.bmp",
  L"data/actor/kasen/atk_Under0001.bmp",
  L"data/actor/kasen/atk_Under0002.bmp",
  L"data/actor/kasen/atk_Under0003.bmp",
  L"data/actor/kasen/atk_Under0004.bmp",
  L"data/actor/kasen/atk_Under0005.bmp",
  L"data/actor/kasen/atk_Under0006.bmp",
  L"data/actor/kasen/atk_Under0007.bmp",
  L"data/actor/kasen/atk_Under0008.bmp",
  L"data/actor/kasen/beginBattleB0000.bmp",
  L"data/actor/kasen/bmsln/reimu_buster.bmb",
  L"data/actor/kasen/bmsln/reimu_busterHit.bmb",
  L"data/actor/kasen/bmsln/reimu_fallKickA.bmb",
  L"data/actor/kasen/bmsln/reimu_HighShotBaria.bmb",
  L"data/actor/kasen/bmsln/reimu_keisei.bmb",
  L"data/actor/kasen/bmsln/reimu_kibakuzinA.bmb",
  L"data/actor/kasen/bmsln/reimu_musouB.bmb",
  L"data/actor/kasen/bmsln/reimu_musouG.bmb",
  L"data/actor/kasen/bmsln/reimu_musouHitB.bmb",
  L"data/actor/kasen/bmsln/reimu_musouHitG.bmb",
  L"data/actor/kasen/bmsln/reimu_musouHitR.bmb",
  L"data/actor/kasen/bmsln/reimu_musouR.bmb",
  L"data/actor/kasen/bmsln/reimu_shot.bmb",
  L"data/actor/kasen/bmsln/reimu_shotA.bmb",
  L"data/actor/kasen/bmsln/reimu_shotA_gateRing.bmb",
  L"data/actor/kasen/bmsln/reimu_shotA_hit.bmb",
  L"data/actor/kasen/bmsln/reimu_skillG_kick.bmb",
  L"data/actor/kasen/bmsln/reimu_TenseiA000.bmb",
  L"data/actor/kasen/bmsln/reimu_tenseiFinish.bmb",
  L"data/actor/kasen/bmsln/reimu_tenseiRock.bmb",
  L"data/actor/kasen/bmsln/reimu_tenseiRockShot.bmb",
  L"data/actor/kasen/bmsln/shot_A_000.bmb",
  L"data/actor/kasen/bmsln/shot_A_000.bmsln",
  L"data/actor/kasen/climax0000.bmp",
  L"data/actor/kasen/climax0001.bmp",
  L"data/actor/kasen/climax0002.bmp",
  L"data/actor/kasen/climax0003.bmp",
  L"data/actor/kasen/climax0004.bmp",
  L"data/actor/kasen/climax0005.bmp",
  L"data/actor/kasen/climax0006.bmp",
  L"data/actor/kasen/climax0007.bmp",
  L"data/actor/kasen/climax0008.bmp",
  L"data/actor/kasen/climax0009.bmp",
  L"data/actor/kasen/climax0010.bmp",
  L"data/actor/kasen/climax0011.bmp",
  L"data/actor/kasen/climaxArm0000.bmp",
  L"data/actor/kasen/climax_CutFace.png",
  L"data/actor/kasen/climax_HitLoop0000.bmp",
  L"data/actor/kasen/climax_Typoon0000.bmp",
  L"data/actor/kasen/climax_Typoon0001.bmp",
  L"data/actor/kasen/climax_Typoon0002.bmp",
  L"data/actor/kasen/climax_Typoon0003.bmp",
  L"data/actor/kasen/climax_Typoon0004.bmp",
  L"data/actor/kasen/damageSpin0000.bmp",
  L"data/actor/kasen/damageSpin0001.bmp",
  L"data/actor/kasen/damageSpin0002.bmp",
  L"data/actor/kasen/damageSpin0003.bmp",
  L"data/actor/kasen/damageUpper0000.bmp",
  L"data/actor/kasen/damageUpper0001.bmp",
  L"data/actor/kasen/damageUpper0002.bmp",
  L"data/actor/kasen/damageUpper0003.bmp",
  L"data/actor/kasen/damageUpper0004.bmp",
  L"data/actor/kasen/damageUpper0005.bmp",
  L"data/actor/kasen/damageUpper0006.bmp",
  L"data/actor/kasen/damageUpper0007.bmp",
  L"data/actor/kasen/damageUpper0008.bmp",
  L"data/actor/kasen/damageUpper0009.bmp",
  L"data/actor/kasen/damageUpper0010.bmp",
  L"data/actor/kasen/damageUpper0011.bmp",
  L"data/actor/kasen/damageUpper0012.bmp",
  L"data/actor/kasen/damageUpper0013.bmp",
  L"data/actor/kasen/damageUpper0014.bmp",
  L"data/actor/kasen/damage_body0000.bmp",
  L"data/actor/kasen/damage_body0001.bmp",
  L"data/actor/kasen/damage_body0002.bmp",
  L"data/actor/kasen/damage_body0003.bmp",
  L"data/actor/kasen/damage_body0004.bmp",
  L"data/actor/kasen/damage_head0000.bmp",
  L"data/actor/kasen/damage_head0001.bmp",
  L"data/actor/kasen/damage_head0002.bmp",
  L"data/actor/kasen/damage_head0003.bmp",
  L"data/actor/kasen/damage_head0004.bmp",
  L"data/actor/kasen/damage_wall0000.bmp",
  L"data/actor/kasen/damage_wall0001.bmp",
  L"data/actor/kasen/damage_wall0002.bmp",
  L"data/actor/kasen/damage_wall0003.bmp",
  L"data/actor/kasen/damage_wall0004.bmp",
  L"data/actor/kasen/dashBack0000.bmp",
  L"data/actor/kasen/dashBack0001.bmp",
  L"data/actor/kasen/dashBack0003.bmp",
  L"data/actor/kasen/dashBack0004.bmp",
  L"data/actor/kasen/dashBack0005.bmp",
  L"data/actor/kasen/dashBackLoop0000.bmp",
  L"data/actor/kasen/dashBackLoop0001.bmp",
  L"data/actor/kasen/dashBackLoop0002.bmp",
  L"data/actor/kasen/dashBackLoop0003.bmp",
  L"data/actor/kasen/dashBackLoop0004.bmp",
  L"data/actor/kasen/dashFront0000.bmp",
  L"data/actor/kasen/dashFront0001.bmp",
  L"data/actor/kasen/dashFront0003.bmp",
  L"data/actor/kasen/dashFront0004.bmp",
  L"data/actor/kasen/dashFront0005.bmp",
  L"data/actor/kasen/dashFrontLoop0000.bmp",
  L"data/actor/kasen/dashFrontLoop0001.bmp",
  L"data/actor/kasen/dashFrontLoop0002.bmp",
  L"data/actor/kasen/dashFrontLoop0003.bmp",
  L"data/actor/kasen/dashFrontLoop0004.bmp",
  L"data/actor/kasen/dragonB0000.bmp",
  L"data/actor/kasen/dragonB0001.bmp",
  L"data/actor/kasen/dragonB0002.bmp",
  L"data/actor/kasen/dragonB0003.bmp",
  L"data/actor/kasen/dragonB0004.bmp",
  L"data/actor/kasen/dragonB0005.bmp",
  L"data/actor/kasen/dragonB0006.bmp",
  L"data/actor/kasen/dragonB0007.bmp",
  L"data/actor/kasen/eagle_lose0000.bmp",
  L"data/actor/kasen/face_spellCall.png",
  L"data/actor/kasen/guard0000.bmp",
  L"data/actor/kasen/guard0001.bmp",
  L"data/actor/kasen/guard0002.bmp",
  L"data/actor/kasen/guard0003.bmp",
  L"data/actor/kasen/guardCrash0000.bmp",
  L"data/actor/kasen/guardCrash0001.bmp",
  L"data/actor/kasen/guardCrash0002.bmp",
  L"data/actor/kasen/guardCrash0003.bmp",
  L"data/actor/kasen/guardCrash0004.bmp",
  L"data/actor/kasen/guardCrash0005.bmp",
  L"data/actor/kasen/guard_miss0000.bmp",
  L"data/actor/kasen/guard_miss0001.bmp",
  L"data/actor/kasen/guard_miss0002.bmp",
  L"data/actor/kasen/guard_miss0003.bmp",
  L"data/actor/kasen/kanda0000.bmp",
  L"data/actor/kasen/kanda0001.bmp",
  L"data/actor/kasen/kanda0002.bmp",
  L"data/actor/kasen/kanda0003.bmp",
  L"data/actor/kasen/kanda0004.bmp",
  L"data/actor/kasen/kanda0005.bmp",
  L"data/actor/kasen/kanda0006.bmp",
  L"data/actor/kasen/kasen.pat",
  L"data/actor/kasen/kasen_ed.pat",
  L"data/actor/kasen/lose0000.bmp",
  L"data/actor/kasen/lose0001.bmp",
  L"data/actor/kasen/lose0002.bmp",
  L"data/actor/kasen/lose0003.bmp",
  L"data/actor/kasen/moveSlideLoop0000.bmp",
  L"data/actor/kasen/moveSlideLoop0001.bmp",
  L"data/actor/kasen/moveSlideLoop0002.bmp",
  L"data/actor/kasen/moveSlideLoop0003.bmp",
  L"data/actor/kasen/moveSlideLoop0004.bmp",
  L"data/actor/kasen/move_slide0000.bmp",
  L"data/actor/kasen/move_slide0002.bmp",
  L"data/actor/kasen/move_slide0003.bmp",
  L"data/actor/kasen/move_slide0004.bmp",
  L"data/actor/kasen/move_slide0005.bmp",
  L"data/actor/kasen/move_slide0006.bmp",
  L"data/actor/kasen/occult0000.bmp",
  L"data/actor/kasen/occult0001.bmp",
  L"data/actor/kasen/occult0002.bmp",
  L"data/actor/kasen/occult0003.bmp",
  L"data/actor/kasen/occult0004.bmp",
  L"data/actor/kasen/occult0005.bmp",
  L"data/actor/kasen/occult0006.bmp",
  L"data/actor/kasen/occult0007.bmp",
  L"data/actor/kasen/occult0008.bmp",
  L"data/actor/kasen/occult0009.bmp",
  L"data/actor/kasen/occult0010.bmp",
  L"data/actor/kasen/occult0011.bmp",
  L"data/actor/kasen/occultArm0000.bmp",
  L"data/actor/kasen/occultArm0001.bmp",
  L"data/actor/kasen/occult_armB0000.bmp",
  L"data/actor/kasen/occult_armB0001.bmp",
  L"data/actor/kasen/occult_armB0002.bmp",
  L"data/actor/kasen/occult_throw0000.bmp",
  L"data/actor/kasen/occult_throw0001.bmp",
  L"data/actor/kasen/occult_throw0002.bmp",
  L"data/actor/kasen/occult_throw0003.bmp",
  L"data/actor/kasen/occult_throw0004.bmp",
  L"data/actor/kasen/occult_throw0005.bmp",
  L"data/actor/kasen/occult_throw0006.bmp",
  L"data/actor/kasen/occult_throw0007.bmp",
  L"data/actor/kasen/occult_throw0008.bmp",
  L"data/actor/kasen/occult_throw0009.bmp",
  L"data/actor/kasen/occult_throw0010.bmp",
  L"data/actor/kasen/occult_throw0011.bmp",
  L"data/actor/kasen/occult_throw0012.bmp",
  L"data/actor/kasen/palette000.bmp",
  L"data/actor/kasen/palette001.bmp",
  L"data/actor/kasen/palette002.bmp",
  L"data/actor/kasen/palette003.bmp",
  L"data/actor/kasen/palette004.bmp",
  L"data/actor/kasen/palette005.bmp",
  L"data/actor/kasen/palette006.bmp",
  L"data/actor/kasen/palette007.bmp",
  L"data/actor/kasen/shotCharge0000.bmp",
  L"data/actor/kasen/shotCharge0001.bmp",
  L"data/actor/kasen/shotCharge0002.bmp",
  L"data/actor/kasen/shotCharge0003.bmp",
  L"data/actor/kasen/shotCharge0004.bmp",
  L"data/actor/kasen/shotCharge0005.bmp",
  L"data/actor/kasen/shotCharge0006.bmp",
  L"data/actor/kasen/shotFront0000.bmp",
  L"data/actor/kasen/shotFront0001.bmp",
  L"data/actor/kasen/shotFront0002.bmp",
  L"data/actor/kasen/shotFront0003.bmp",
  L"data/actor/kasen/shotFront0004.bmp",
  L"data/actor/kasen/shotFront0005.bmp",
  L"data/actor/kasen/shotFront0006.bmp",
  L"data/actor/kasen/shot_normal0000.bmp",
  L"data/actor/kasen/shot_normal0001.bmp",
  L"data/actor/kasen/shot_normal0002.bmp",
  L"data/actor/kasen/shot_normal0003.bmp",
  L"data/actor/kasen/shot_normal0004.bmp",
  L"data/actor/kasen/shot_normal0005.bmp",
  L"data/actor/kasen/shot_normal0006.bmp",
  L"data/actor/kasen/skillA0000.bmp",
  L"data/actor/kasen/skillA0001.bmp",
  L"data/actor/kasen/skillA0002.bmp",
  L"data/actor/kasen/skillA0003.bmp",
  L"data/actor/kasen/skillA0004.bmp",
  L"data/actor/kasen/skillA0005.bmp",
  L"data/actor/kasen/skillA0006.bmp",
  L"data/actor/kasen/skillA0007.bmp",
  L"data/actor/kasen/skillB0000.bmp",
  L"data/actor/kasen/skillB0001.bmp",
  L"data/actor/kasen/skillB0002.bmp",
  L"data/actor/kasen/skillB0003.bmp",
  L"data/actor/kasen/skillB0004.bmp",
  L"data/actor/kasen/skillB0005.bmp",
  L"data/actor/kasen/skillB0006.bmp",
  L"data/actor/kasen/skillB0007.bmp",
  L"data/actor/kasen/skillB0008.bmp",
  L"data/actor/kasen/skillB0009.bmp",
  L"data/actor/kasen/skillC0000.bmp",
  L"data/actor/kasen/skillC0001.bmp",
  L"data/actor/kasen/skillC0002.bmp",
  L"data/actor/kasen/skillC0003.bmp",
  L"data/actor/kasen/skillCb0000.bmp",
  L"data/actor/kasen/skillCb0001.bmp",
  L"data/actor/kasen/skillCb0002.bmp",
  L"data/actor/kasen/skillCc0000.bmp",
  L"data/actor/kasen/skillCc0001.bmp",
  L"data/actor/kasen/skillCc0002.bmp",
  L"data/actor/kasen/skillCc0003.bmp",
  L"data/actor/kasen/skillCc0004.bmp",
  L"data/actor/kasen/skillCc0005.bmp",
  L"data/actor/kasen/skillCd0000.bmp",
  L"data/actor/kasen/skillCd0001.bmp",
  L"data/actor/kasen/skillCd0002.bmp",
  L"data/actor/kasen/skillCd0003.bmp",
  L"data/actor/kasen/skillCd0004.bmp",
  L"data/actor/kasen/skillCd0005.bmp",
  L"data/actor/kasen/skillCd0006.bmp",
  L"data/actor/kasen/skillD0000.bmp",
  L"data/actor/kasen/skillD0001.bmp",
  L"data/actor/kasen/skillD0002.bmp",
  L"data/actor/kasen/skillD0003.bmp",
  L"data/actor/kasen/skillD0004.bmp",
  L"data/actor/kasen/skillD0005.bmp",
  L"data/actor/kasen/skillD0006.bmp",
  L"data/actor/kasen/skillD0007.bmp",
  L"data/actor/kasen/slideLoopB0000.bmp",
  L"data/actor/kasen/slideLoopB0001.bmp",
  L"data/actor/kasen/slideLoopB0002.bmp",
  L"data/actor/kasen/slideLoopB0003.bmp",
  L"data/actor/kasen/slideLoopB0004.bmp",
  L"data/actor/kasen/spellA0000.bmp",
  L"data/actor/kasen/spellA0001.bmp",
  L"data/actor/kasen/spellA0002.bmp",
  L"data/actor/kasen/spellA0003.bmp",
  L"data/actor/kasen/spellA0004.bmp",
  L"data/actor/kasen/spellA0005.bmp",
  L"data/actor/kasen/spellA0006.bmp",
  L"data/actor/kasen/spellA_bantageCapture0000.bmp",
  L"data/actor/kasen/spellA_throw0000.bmp",
  L"data/actor/kasen/spellA_throw0001.bmp",
  L"data/actor/kasen/spellA_throw0002.bmp",
  L"data/actor/kasen/spellA_throw0003.bmp",
  L"data/actor/kasen/spellA_throw0004.bmp",
  L"data/actor/kasen/spellA_throw0005.bmp",
  L"data/actor/kasen/spellA_throw0006.bmp",
  L"data/actor/kasen/spellA_throw0007.bmp",
  L"data/actor/kasen/spellA_throw0008.bmp",
  L"data/actor/kasen/spellA_throw0009.bmp",
  L"data/actor/kasen/spellA_throw0010.bmp",
  L"data/actor/kasen/spellA_throw0011.bmp",
  L"data/actor/kasen/spellA_throw0012.bmp",
  L"data/actor/kasen/spellA_throw0013.bmp",
  L"data/actor/kasen/spellA_throw0014.bmp",
  L"data/actor/kasen/spellA_throw0015.bmp",
  L"data/actor/kasen/spellA_throw0016.bmp",
  L"data/actor/kasen/spellA_throw0017.bmp",
  L"data/actor/kasen/spellA_throw0018.bmp",
  L"data/actor/kasen/spellA_throw0019.bmp",
  L"data/actor/kasen/spellA_throw0020.bmp",
  L"data/actor/kasen/spellB0000.bmp",
  L"data/actor/kasen/spellB0001.bmp",
  L"data/actor/kasen/spellB0002.bmp",
  L"data/actor/kasen/spellB0003.bmp",
  L"data/actor/kasen/spellB0004.bmp",
  L"data/actor/kasen/spellB0005.bmp",
  L"data/actor/kasen/spellB0006.bmp",
  L"data/actor/kasen/spellB0007.bmp",
  L"data/actor/kasen/spellB0008.bmp",
  L"data/actor/kasen/spellB0009.bmp",
  L"data/actor/kasen/spellB0010.bmp",
  L"data/actor/kasen/spellB0011.bmp",
  L"data/actor/kasen/spellB_batage0000.bmp",
  L"data/actor/kasen/spellB_batage0001.bmp",
  L"data/actor/kasen/spellC0000.bmp",
  L"data/actor/kasen/spellC0001.bmp",
  L"data/actor/kasen/spellC0002.bmp",
  L"data/actor/kasen/spellC0003.bmp",
  L"data/actor/kasen/spellC0004.bmp",
  L"data/actor/kasen/spellC0005.bmp",
  L"data/actor/kasen/spellC0006.bmp",
  L"data/actor/kasen/spellC0007.bmp",
  L"data/actor/kasen/spellC0008.bmp",
  L"data/actor/kasen/spellCall0000.bmp",
  L"data/actor/kasen/spellCall0001.bmp",
  L"data/actor/kasen/spellCall0002.bmp",
  L"data/actor/kasen/spellCall0003.bmp",
  L"data/actor/kasen/spellCall0004.bmp",
  L"data/actor/kasen/spellCall0005.bmp",
  L"data/actor/kasen/spellCall0006.bmp",
  L"data/actor/kasen/stand.bmp",
  L"data/actor/kasen/stand0000.bmp",
  L"data/actor/kasen/stand0001.bmp",
  L"data/actor/kasen/stand0002.bmp",
  L"data/actor/kasen/stand0003.bmp",
  L"data/actor/kasen/stand0004.bmp",
  L"data/actor/kasen/stand0005.bmp",
  L"data/actor/kasen/stand0006.bmp",
  L"data/actor/kasen/stand0007.bmp",
  L"data/actor/kasen/stand0008.bmp",
  L"data/actor/kasen/stand0009.bmp",
  L"data/actor/kasen/stand0010.bmp",
  L"data/actor/kasen/stand0011.bmp",
  L"data/actor/kasen/stand0012.bmp",
  L"data/actor/kasen/stand0013.bmp",
  L"data/actor/kasen/stand0014.bmp",
  L"data/actor/kasen/stun0000.bmp",
  L"data/actor/kasen/stun0001.bmp",
  L"data/actor/kasen/stun0002.bmp",
  L"data/actor/kasen/stun0003.bmp",
  L"data/actor/kasen/stun0004.bmp",
  L"data/actor/kasen/stun0005.bmp",
  L"data/actor/kasen/test_armShotUnder0000.bmp",
  L"data/actor/kasen/test_armShotUnder0001.bmp",
  L"data/actor/kasen/test_armShotUnder0002.bmp",
  L"data/actor/kasen/test_armShotUnder0003.bmp",
  L"data/actor/kasen/test_armShotUnder0004.bmp",
  L"data/actor/kasen/test_armShotUpper0000.bmp",
  L"data/actor/kasen/test_armShotUpper0001.bmp",
  L"data/actor/kasen/test_armShotUpper0002.bmp",
  L"data/actor/kasen/test_armShotUpper0003.bmp",
  L"data/actor/kasen/test_armShotUpper0004.bmp",
  L"data/actor/kasen/test_azarashi0000.bmp",
  L"data/actor/kasen/test_azarashi0001.bmp",
  L"data/actor/kasen/test_azarashi0002.bmp",
  L"data/actor/kasen/test_azarashi0003.bmp",
  L"data/actor/kasen/test_azarashi0004.bmp",
  L"data/actor/kasen/test_effect.bmp",
  L"data/actor/kasen/texture/ball.bmp",
  L"data/actor/kasen/texture/ballB.png",
  L"data/actor/kasen/texture/ballList0000.dds",
  L"data/actor/kasen/texture/climax_aura0000.png",
  L"data/actor/kasen/texture/climax_aura0001.png",
  L"data/actor/kasen/texture/common_spark.png",
  L"data/actor/kasen/texture/kasen_animal00000.png",
  L"data/actor/kasen/texture/kasen_animal00006.png",
  L"data/actor/kasen/texture/kasen_animal00012.png",
  L"data/actor/kasen/texture/kasen_animal00018.png",
  L"data/actor/kasen/texture/kasen_animal00024.png",
  L"data/actor/kasen/texture/kasen_animalDamage00000.png",
  L"data/actor/kasen/texture/kasen_animalDamage00006.png",
  L"data/actor/kasen/texture/kasen_animalDamage00012.png",
  L"data/actor/kasen/texture/kasen_animalDamage00018.png",
  L"data/actor/kasen/texture/kasen_animalDamage00024.png",
  L"data/actor/kasen/texture/kasen_auraWave0000.png",
  L"data/actor/kasen/texture/kasen_ballShot0000.png",
  L"data/actor/kasen/texture/kasen_climaxArmAura0000.png",
  L"data/actor/kasen/texture/kasen_climaxArmAura0001.png",
  L"data/actor/kasen/texture/kasen_climaxBack0000.png",
  L"data/actor/kasen/texture/kasen_colorBall0000.png",
  L"data/actor/kasen/texture/kasen_eableEffect0000.png",
  L"data/actor/kasen/texture/kasen_eagleFeather0000.png",
  L"data/actor/kasen/texture/kasen_shorNormal0000.png",
  L"data/actor/kasen/texture/kasen_shotVortex0000.png",
  L"data/actor/kasen/texture/kasen_skillBspark0000.png",
  L"data/actor/kasen/texture/kasen_skillBspark0001.png",
  L"data/actor/kasen/texture/kasen_skillB_smash0000.png",
  L"data/actor/kasen/texture/kasen_skillB_smash0001.png",
  L"data/actor/kasen/texture/kasen_skillB_smash0002.png",
  L"data/actor/kasen/texture/kasen_tigerClow0000.png",
  L"data/actor/kasen/texture/kasen_tigerGate0000.png",
  L"data/actor/kasen/texture/kasen_tigerGate0001.png",
  L"data/actor/kasen/texture/kasen_tigerGate0002.png",
  L"data/actor/kasen/texture/kasen_tigerGate0003.png",
  L"data/actor/kasen/texture/kasen_tigerHole0000.png",
  L"data/actor/kasen/texture/kasen_tornadeBase0000.png",
  L"data/actor/kasen/texture/kasen_tornadeBase0001.png",
  L"data/actor/kasen/texture/kasen_tornadeBase0002.png",
  L"data/actor/kasen/texture/kasen_trail.png",
  L"data/actor/kasen/texture/marisaBall2.bmp",
  L"data/actor/kasen/texture/marisaStarFlare.bmp",
  L"data/actor/kasen/texture/mask_ball.png",
  L"data/actor/kasen/texture/mask_Box.bmp",
  L"data/actor/kasen/texture/miko_ballB.png",
  L"data/actor/kasen/texture/occult_aura0000.dds",
  L"data/actor/kasen/texture/occult_ball0000.png",
  L"data/actor/kasen/texture/occult_slash0000.dds",
  L"data/actor/kasen/texture/reimu_boxA.png",
  L"data/actor/kasen/texture/reimu_fallKick.png",
  L"data/actor/kasen/texture/reimu_loopAuraA.png",
  L"data/actor/kasen/texture/reimu_musouBase.png",
  L"data/actor/kasen/texture/reimu_skillG_FlashA.png",
  L"data/actor/kasen/texture/reimu_wallA_Halfmask.png",
  L"data/actor/kasen/texture/reimu_wallA_mask.png",
  L"data/actor/kasen/texture/reimu_wallFlashA.png",
  L"data/actor/kasen/texture/shotStingA0000.png",
  L"data/actor/kasen/texture/skillC_charge0000.dds",
  L"data/actor/kasen/texture/skillE_fire0000.dds",
  L"data/actor/kasen/texture/skillE_fire0001.dds",
  L"data/actor/kasen/texture/skillE_texture0000.dds",
  L"data/actor/kasen/texture/spellA_swing0000.dds",
  L"data/actor/kasen/texture/spellB_shock0000.png",
  L"data/actor/kasen/texture/spellB_shock0001.png",
  L"data/actor/kasen/texture/spellC.dds",
  L"data/actor/kasen/texture/spellC_splash0000.dds",
  L"data/actor/kasen/texture/spellC_swing0000.dds",
  L"data/actor/kasen/tiger0000.bmp",
  L"data/actor/kasen/tiger0001.bmp",
  L"data/actor/kasen/tigerA0000.bmp",
  L"data/actor/kasen/tigerA0001.bmp",
  L"data/actor/kasen/tigerA0002.bmp",
  L"data/actor/kasen/tigerA0003.bmp",
  L"data/actor/kasen/tigerA0004.bmp",
  L"data/actor/kasen/turn0000.bmp",
  L"data/actor/kasen/turn0001.bmp",
  L"data/actor/kasen/turn0002.bmp",
  L"data/actor/kasen/walk0000.bmp",
  L"data/actor/kasen/walk0001.bmp",
  L"data/actor/kasen/walk0002.bmp",
  L"data/actor/kasen/walk0003.bmp",
  L"data/actor/kasen/walk0004.bmp",
  L"data/actor/kasen/walk0005.bmp",
  L"data/actor/kasen/walk0006.bmp",
  L"data/actor/kasen/walk0007.bmp",
  L"data/actor/kasen/walk0008.bmp",
  L"data/actor/kasen/walk0009.bmp",
  L"data/actor/kasen/walkBack0000.bmp",
  L"data/actor/kasen/walkBack0001.bmp",
  L"data/actor/kasen/walkBack0003.bmp",
  L"data/actor/kasen/walkBack0004.bmp",
  L"data/actor/kasen/walkBack0005.bmp",
  L"data/actor/kasen/walkBackloop0000.bmp",
  L"data/actor/kasen/walkBackloop0001.bmp",
  L"data/actor/kasen/walkBackloop0002.bmp",
  L"data/actor/kasen/walkBackloop0003.bmp",
  L"data/actor/kasen/walkBackloop0004.bmp",
  L"data/actor/kasen/walkloop0000.bmp",
  L"data/actor/kasen/walkloop0001.bmp",
  L"data/actor/kasen/walkloop0002.bmp",
  L"data/actor/kasen/walkloop0003.bmp",
  L"data/actor/kasen/walkloop0004.bmp",
  L"data/actor/kasen/warpMask.bmp",
  L"data/actor/kasen/winA0000.bmp",
  L"data/actor/kasen/winA0001.bmp",
  L"data/actor/kasen/winA0002.bmp",
  L"data/actor/kasen/winA0003.bmp",
  L"data/actor/kasen/winA0004.bmp",
  L"data/actor/kasen/winA0005.bmp",
  L"data/actor/kasen/winB0000.bmp",
  L"data/actor/kasen/winB0001.bmp",
  L"data/actor/kasen/winB0002.bmp",
  L"data/actor/kasen/winB0003.bmp",
  L"data/actor/kasen/winB0004.bmp",
  L"data/actor/kasen/winB0005.bmp",
  L"data/actor/kasen/winB0006.bmp",
  L"data/actor/kasen/winB0007.bmp",
  L"data/actor/kasen/winB0008.bmp",
  L"data/actor/kasen/winB0009.bmp",
  L"data/actor/kasen/winB0010.bmp",
  L"data/actor/kasen/winB0011.bmp",
  L"data/actor/kasen/winB0012.bmp",
  L"data/actor/kasen.nut",
  L"data/actor/kasenInit.nut",
  L"data/actor/kasen_base.nut",
  L"data/actor/kasen_boss.nut",
  L"data/actor/kasen_cpu.nut",
  L"data/actor/kasen_cpuBoss.nut",
  L"data/actor/kasen_eagle.nut",
  L"data/actor/kasen_shot.nut",
  L"data/actor/koishi/atkHighFrontOB0000.bmp",
  L"data/actor/koishi/atkHighFrontOB0001.bmp",
  L"data/actor/koishi/atkHighFrontOB0002.bmp",
  L"data/actor/koishi/atkHighFrontOB0003.bmp",
  L"data/actor/koishi/atkHighFrontOB0004.bmp",
  L"data/actor/koishi/atkHighFrontOB0005.bmp",
  L"data/actor/koishi/atkHighFrontOB0006.bmp",
  L"data/actor/koishi/atkHighFrontOB0007.bmp",
  L"data/actor/koishi/atkHighFrontOB0008.bmp",
  L"data/actor/koishi/battleBeginB0000.bmp",
  L"data/actor/koishi/battleBeginB0001.bmp",
  L"data/actor/koishi/battleBeginB0002.bmp",
  L"data/actor/koishi/battleBeginB0003.bmp",
  L"data/actor/koishi/battleBeginB0004.bmp",
  L"data/actor/koishi/battleBeginB0005.bmp",
  L"data/actor/koishi/battleBeginB0006.bmp",
  L"data/actor/koishi/battleBeginB0007.bmp",
  L"data/actor/koishi/battleBeginB0008.bmp",
  L"data/actor/koishi/battleBeginB0009.bmp",
  L"data/actor/koishi/battleBeginB0010.bmp",
  L"data/actor/koishi/bmsln/climaxRose.bmb",
  L"data/actor/koishi/bmsln/koishi_skillA_Fire.bmb",
  L"data/actor/koishi/bmsln/koishi_subtare.bmb",
  L"data/actor/koishi/climaxbase0000.bmp",
  L"data/actor/koishi/climaxbase0001.bmp",
  L"data/actor/koishi/climaxbase0002.bmp",
  L"data/actor/koishi/climaxbase0003.bmp",
  L"data/actor/koishi/crash0000.bmp",
  L"data/actor/koishi/crash0001.bmp",
  L"data/actor/koishi/crash0002.bmp",
  L"data/actor/koishi/crash0003.bmp",
  L"data/actor/koishi/crash0004.bmp",
  L"data/actor/koishi/crash0005.bmp",
  L"data/actor/koishi/dash_back0000.bmp",
  L"data/actor/koishi/dash_back0001.bmp",
  L"data/actor/koishi/dash_back0002.bmp",
  L"data/actor/koishi/dash_back0003.bmp",
  L"data/actor/koishi/dash_back0004.bmp",
  L"data/actor/koishi/dash_back0005.bmp",
  L"data/actor/koishi/dash_back0006.bmp",
  L"data/actor/koishi/dash_back0007.bmp",
  L"data/actor/koishi/dash_back0008.bmp",
  L"data/actor/koishi/dash_back0009.bmp",
  L"data/actor/koishi/dash_back0010.bmp",
  L"data/actor/koishi/dash_back0011.bmp",
  L"data/actor/koishi/dash_back0012.bmp",
  L"data/actor/koishi/dash_back0013.bmp",
  L"data/actor/koishi/dash_back0014.bmp",
  L"data/actor/koishi/face_spellCallB.png",
  L"data/actor/koishi/koishi.pat",
  L"data/actor/koishi/koishi_ed.pat",
  L"data/actor/koishi/occult0000.bmp",
  L"data/actor/koishi/occult0001.bmp",
  L"data/actor/koishi/occult0002.bmp",
  L"data/actor/koishi/occult0003.bmp",
  L"data/actor/koishi/occult0004.bmp",
  L"data/actor/koishi/occult0005.bmp",
  L"data/actor/koishi/occult0006.bmp",
  L"data/actor/koishi/occult0007.bmp",
  L"data/actor/koishi/palette000.bmp",
  L"data/actor/koishi/palette001.bmp",
  L"data/actor/koishi/palette002.bmp",
  L"data/actor/koishi/palette003.bmp",
  L"data/actor/koishi/palette004.bmp",
  L"data/actor/koishi/palette005.bmp",
  L"data/actor/koishi/palette006.bmp",
  L"data/actor/koishi/palette007.bmp",
  L"data/actor/koishi/skillD0000.bmp",
  L"data/actor/koishi/skillD0001.bmp",
  L"data/actor/koishi/skillD0002.bmp",
  L"data/actor/koishi/skillD0003.bmp",
  L"data/actor/koishi/skillD0004.bmp",
  L"data/actor/koishi/skillD0005.bmp",
  L"data/actor/koishi/skillD0006.bmp",
  L"data/actor/koishi/skillD0007.bmp",
  L"data/actor/koishi/skillD0008.bmp",
  L"data/actor/koishi/skillG0000.bmp",
  L"data/actor/koishi/skillG0001.bmp",
  L"data/actor/koishi/skillG0002.bmp",
  L"data/actor/koishi/skillG0003.bmp",
  L"data/actor/koishi/skillG0004.bmp",
  L"data/actor/koishi/skillG0005.bmp",
  L"data/actor/koishi/skillG0006.bmp",
  L"data/actor/koishi/skillG0007.bmp",
  L"data/actor/koishi/skillG0008.bmp",
  L"data/actor/koishi/skillG0009.bmp",
  L"data/actor/koishi/skillOB0000.bmp",
  L"data/actor/koishi/skillOB0001.bmp",
  L"data/actor/koishi/skillOB0002.bmp",
  L"data/actor/koishi/skillOB0003.bmp",
  L"data/actor/koishi/skillOB0004.bmp",
  L"data/actor/koishi/skillOB0005.bmp",
  L"data/actor/koishi/spellB0000.bmp",
  L"data/actor/koishi/spellB0001.bmp",
  L"data/actor/koishi/spellB0002.bmp",
  L"data/actor/koishi/spellB0003.bmp",
  L"data/actor/koishi/spellB0004.bmp",
  L"data/actor/koishi/spellB0005.bmp",
  L"data/actor/koishi/spellB0006.bmp",
  L"data/actor/koishi/spellB0007.bmp",
  L"data/actor/koishi/spellB0008.bmp",
  L"data/actor/koishi/spellB0009.bmp",
  L"data/actor/koishi/spellB0010.bmp",
  L"data/actor/koishi/spellC0000.bmp",
  L"data/actor/koishi/spellC0001.bmp",
  L"data/actor/koishi/spellC0002.bmp",
  L"data/actor/koishi/spellC0003.bmp",
  L"data/actor/koishi/spellC0004.bmp",
  L"data/actor/koishi/spellC0005.bmp",
  L"data/actor/koishi/spellC0006.bmp",
  L"data/actor/koishi/spellC0007.bmp",
  L"data/actor/koishi/spellC0008.bmp",
  L"data/actor/koishi/spellC0009.bmp",
  L"data/actor/koishi/spellC0010.bmp",
  L"data/actor/koishi/spellC0011.bmp",
  L"data/actor/koishi/spellC0012.bmp",
  L"data/actor/koishi/stand0000.bmp",
  L"data/actor/koishi/stand0001.bmp",
  L"data/actor/koishi/stand0002.bmp",
  L"data/actor/koishi/stand0003.bmp",
  L"data/actor/koishi/stand0004.bmp",
  L"data/actor/koishi/stand0005.bmp",
  L"data/actor/koishi/stand0006.bmp",
  L"data/actor/koishi/stand0007.bmp",
  L"data/actor/koishi/stand0008.bmp",
  L"data/actor/koishi/stand0009.bmp",
  L"data/actor/koishi/stand0010.bmp",
  L"data/actor/koishi/stand0011.bmp",
  L"data/actor/koishi/testr_climaxfont000.png",
  L"data/actor/koishi/testr_climaxfont001.png",
  L"data/actor/koishi/testr_climaxfont002.png",
  L"data/actor/koishi/testr_climaxfont003.png",
  L"data/actor/koishi/testr_climaxfont004.png",
  L"data/actor/koishi/testr_climaxfont005.png",
  L"data/actor/koishi/testr_climaxfont006.png",
  L"data/actor/koishi/testr_climaxfont007.png",
  L"data/actor/koishi/testr_climaxfont008.png",
  L"data/actor/koishi/test_atkDash0000.bmp",
  L"data/actor/koishi/test_atkDash0001.bmp",
  L"data/actor/koishi/test_atkDash0002.bmp",
  L"data/actor/koishi/test_atkDash0003.bmp",
  L"data/actor/koishi/test_atkDash0004.bmp",
  L"data/actor/koishi/test_atkDash0005.bmp",
  L"data/actor/koishi/test_atkDash0006.bmp",
  L"data/actor/koishi/test_atkDash0007.bmp",
  L"data/actor/koishi/test_atkDashLow0000.bmp",
  L"data/actor/koishi/test_atkDashLow0001.bmp",
  L"data/actor/koishi/test_atkDashLow0002.bmp",
  L"data/actor/koishi/test_atkDashLow0003.bmp",
  L"data/actor/koishi/test_atkDashLow0004.bmp",
  L"data/actor/koishi/test_atkDashLow0005.bmp",
  L"data/actor/koishi/test_atkDashLow0006.bmp",
  L"data/actor/koishi/test_atkDashLow0007.bmp",
  L"data/actor/koishi/test_atkDashLow0008.bmp",
  L"data/actor/koishi/test_atkHigh0001.bmp",
  L"data/actor/koishi/test_atkHigh0002.bmp",
  L"data/actor/koishi/test_atkHigh0003.bmp",
  L"data/actor/koishi/test_atkHigh0004.bmp",
  L"data/actor/koishi/test_atkHigh0005.bmp",
  L"data/actor/koishi/test_atkHigh0006.bmp",
  L"data/actor/koishi/test_atkHigh0007.bmp",
  L"data/actor/koishi/test_atkHigh0010.bmp",
  L"data/actor/koishi/test_atkHigh0011.bmp",
  L"data/actor/koishi/test_atkHighFront0000.bmp",
  L"data/actor/koishi/test_atkHighFront0001.bmp",
  L"data/actor/koishi/test_atkHighFront0002.bmp",
  L"data/actor/koishi/test_atkHighFront0003.bmp",
  L"data/actor/koishi/test_atkHighFront0004.bmp",
  L"data/actor/koishi/test_atkHighFront0005.bmp",
  L"data/actor/koishi/test_atkHighFront0006.bmp",
  L"data/actor/koishi/test_atkHighFront0007.bmp",
  L"data/actor/koishi/test_atkHighFront0008.bmp",
  L"data/actor/koishi/test_atkHighUnder0000.bmp",
  L"data/actor/koishi/test_atkHighUnder0001.bmp",
  L"data/actor/koishi/test_atkHighUnder0002.bmp",
  L"data/actor/koishi/test_atkHighUnder0003.bmp",
  L"data/actor/koishi/test_atkHighUnder0004.bmp",
  L"data/actor/koishi/test_atkHighUnder0005.bmp",
  L"data/actor/koishi/test_atkHighUnder0006.bmp",
  L"data/actor/koishi/test_atkHighUnder0007.bmp",
  L"data/actor/koishi/test_atkHighUnder0008.bmp",
  L"data/actor/koishi/test_atkHighUnder0009.bmp",
  L"data/actor/koishi/test_atkHighUnder0010.bmp",
  L"data/actor/koishi/test_atkHighUpper0003.bmp",
  L"data/actor/koishi/test_atkHighUpper0004.bmp",
  L"data/actor/koishi/test_atkHighUpper0005.bmp",
  L"data/actor/koishi/test_atkHighUpper0006.bmp",
  L"data/actor/koishi/test_atkHighUpper0007.bmp",
  L"data/actor/koishi/test_atkHighUpper0008.bmp",
  L"data/actor/koishi/test_atkHighUpper0009.bmp",
  L"data/actor/koishi/test_atkHighUpper0015.bmp",
  L"data/actor/koishi/test_atkLow0000.bmp",
  L"data/actor/koishi/test_atkLow0001.bmp",
  L"data/actor/koishi/test_atkLow0002.bmp",
  L"data/actor/koishi/test_atkLow0003.bmp",
  L"data/actor/koishi/test_atkLow0004.bmp",
  L"data/actor/koishi/test_atkLow0005.bmp",
  L"data/actor/koishi/test_atkLow0006.bmp",
  L"data/actor/koishi/test_atkMid0000.bmp",
  L"data/actor/koishi/test_atkMid0001.bmp",
  L"data/actor/koishi/test_atkMid0002.bmp",
  L"data/actor/koishi/test_atkMid0003.bmp",
  L"data/actor/koishi/test_atkMid0004.bmp",
  L"data/actor/koishi/test_atkMid0005.bmp",
  L"data/actor/koishi/test_atkMid0006.bmp",
  L"data/actor/koishi/test_atkMid0007.bmp",
  L"data/actor/koishi/test_atkMidB0000.bmp",
  L"data/actor/koishi/test_atkMidB0001.bmp",
  L"data/actor/koishi/test_atkMidB0002.bmp",
  L"data/actor/koishi/test_atkMidB0003.bmp",
  L"data/actor/koishi/test_battleBeginA0000.bmp",
  L"data/actor/koishi/test_battleBeginA0001.bmp",
  L"data/actor/koishi/test_battleBeginA0002.bmp",
  L"data/actor/koishi/test_battleBeginA0003.bmp",
  L"data/actor/koishi/test_battleBeginA0004.bmp",
  L"data/actor/koishi/test_climax0000.bmp",
  L"data/actor/koishi/test_climax0001.bmp",
  L"data/actor/koishi/test_climax0002.bmp",
  L"data/actor/koishi/test_climax0003.bmp",
  L"data/actor/koishi/test_climax0004.bmp",
  L"data/actor/koishi/test_climax0005.bmp",
  L"data/actor/koishi/test_climax0006.bmp",
  L"data/actor/koishi/test_climax0007.bmp",
  L"data/actor/koishi/test_climax0008.bmp",
  L"data/actor/koishi/test_climax0009.bmp",
  L"data/actor/koishi/test_climax0010.bmp",
  L"data/actor/koishi/test_climax0011.bmp",
  L"data/actor/koishi/test_climax0012.bmp",
  L"data/actor/koishi/test_crash0000.bmp",
  L"data/actor/koishi/test_crash0001.bmp",
  L"data/actor/koishi/test_damageBody0000.bmp",
  L"data/actor/koishi/test_damageBody0001.bmp",
  L"data/actor/koishi/test_damageBody0002.bmp",
  L"data/actor/koishi/test_damageBody0003.bmp",
  L"data/actor/koishi/test_damageBody0004.bmp",
  L"data/actor/koishi/test_damageHead0000.bmp",
  L"data/actor/koishi/test_damageHead0001.bmp",
  L"data/actor/koishi/test_damageHead0002.bmp",
  L"data/actor/koishi/test_damageHead0003.bmp",
  L"data/actor/koishi/test_damageHead0004.bmp",
  L"data/actor/koishi/test_damageSpin0000.bmp",
  L"data/actor/koishi/test_damageSpin0001.bmp",
  L"data/actor/koishi/test_damageSpin0002.bmp",
  L"data/actor/koishi/test_damageSpin0003.bmp",
  L"data/actor/koishi/test_damageUpper0000.bmp",
  L"data/actor/koishi/test_damageWall0000.bmp",
  L"data/actor/koishi/test_damageWall0001.bmp",
  L"data/actor/koishi/test_damageWall0002.bmp",
  L"data/actor/koishi/test_damageWall0003.bmp",
  L"data/actor/koishi/test_damageWall0004.bmp",
  L"data/actor/koishi/test_dashFront0000.bmp",
  L"data/actor/koishi/test_dashFront0001.bmp",
  L"data/actor/koishi/test_dashFront0002.bmp",
  L"data/actor/koishi/test_dashFront0003.bmp",
  L"data/actor/koishi/test_dashFront0004.bmp",
  L"data/actor/koishi/test_dashFront0005.bmp",
  L"data/actor/koishi/test_dashFront0006.bmp",
  L"data/actor/koishi/test_dashFront0007.bmp",
  L"data/actor/koishi/test_down0000.bmp",
  L"data/actor/koishi/test_down0001.bmp",
  L"data/actor/koishi/test_down0002.bmp",
  L"data/actor/koishi/test_down0003.bmp",
  L"data/actor/koishi/test_down0004.bmp",
  L"data/actor/koishi/test_down0005.bmp",
  L"data/actor/koishi/test_down0006.bmp",
  L"data/actor/koishi/test_down0007.bmp",
  L"data/actor/koishi/test_down0008.bmp",
  L"data/actor/koishi/test_down0009.bmp",
  L"data/actor/koishi/test_down0010.bmp",
  L"data/actor/koishi/test_down0011.bmp",
  L"data/actor/koishi/test_down0012.bmp",
  L"data/actor/koishi/test_down0013.bmp",
  L"data/actor/koishi/test_down0014.bmp",
  L"data/actor/koishi/test_down0015.bmp",
  L"data/actor/koishi/test_down0016.bmp",
  L"data/actor/koishi/test_down0017.bmp",
  L"data/actor/koishi/test_effect.bmp",
  L"data/actor/koishi/test_guard0000.bmp",
  L"data/actor/koishi/test_guard0001.bmp",
  L"data/actor/koishi/test_guard0002.bmp",
  L"data/actor/koishi/test_guardMiss0000.bmp",
  L"data/actor/koishi/test_guardMiss0001.bmp",
  L"data/actor/koishi/test_guardMiss0002.bmp",
  L"data/actor/koishi/test_guardMiss0003.bmp",
  L"data/actor/koishi/test_item0000.bmp",
  L"data/actor/koishi/test_item0001.bmp",
  L"data/actor/koishi/test_item0002.bmp",
  L"data/actor/koishi/test_item0003.bmp",
  L"data/actor/koishi/test_item0004.bmp",
  L"data/actor/koishi/test_item0005.bmp",
  L"data/actor/koishi/test_item0006.bmp",
  L"data/actor/koishi/test_item0007.bmp",
  L"data/actor/koishi/test_lose0000.bmp",
  L"data/actor/koishi/test_lose0001.bmp",
  L"data/actor/koishi/test_lose0002.bmp",
  L"data/actor/koishi/test_lose0003.bmp",
  L"data/actor/koishi/test_lose0004.bmp",
  L"data/actor/koishi/test_setMotion0000.bmp",
  L"data/actor/koishi/test_setMotion0001.bmp",
  L"data/actor/koishi/test_setMotion0002.bmp",
  L"data/actor/koishi/test_setMotion0003.bmp",
  L"data/actor/koishi/test_setMotion0004.bmp",
  L"data/actor/koishi/test_setMotion0005.bmp",
  L"data/actor/koishi/test_shotHigh0000.bmp",
  L"data/actor/koishi/test_shotHigh0001.bmp",
  L"data/actor/koishi/test_shotHigh0002.bmp",
  L"data/actor/koishi/test_shotHigh0003.bmp",
  L"data/actor/koishi/test_shotHigh0004.bmp",
  L"data/actor/koishi/test_shotHigh0005.bmp",
  L"data/actor/koishi/test_shotHigh0006.bmp",
  L"data/actor/koishi/test_shotHigh0007.bmp",
  L"data/actor/koishi/test_shotLow0000.bmp",
  L"data/actor/koishi/test_shotLow0001.bmp",
  L"data/actor/koishi/test_shotLow0002.bmp",
  L"data/actor/koishi/test_shotLow0003.bmp",
  L"data/actor/koishi/test_shotLow0004.bmp",
  L"data/actor/koishi/test_shotLow0005.bmp",
  L"data/actor/koishi/test_shotLow0006.bmp",
  L"data/actor/koishi/test_skillA0000.bmp",
  L"data/actor/koishi/test_skillA0001.bmp",
  L"data/actor/koishi/test_skillA0002.bmp",
  L"data/actor/koishi/test_skillA0003.bmp",
  L"data/actor/koishi/test_skillA0004.bmp",
  L"data/actor/koishi/test_skillA0005.bmp",
  L"data/actor/koishi/test_skillA0006.bmp",
  L"data/actor/koishi/test_skillA0007.bmp",
  L"data/actor/koishi/test_skillA0008.bmp",
  L"data/actor/koishi/test_skillA0009.bmp",
  L"data/actor/koishi/test_skillA0010.bmp",
  L"data/actor/koishi/test_skillA0011.bmp",
  L"data/actor/koishi/test_skillA0012.bmp",
  L"data/actor/koishi/test_skillD0000.bmp",
  L"data/actor/koishi/test_skillD0001.bmp",
  L"data/actor/koishi/test_skillD0002.bmp",
  L"data/actor/koishi/test_skillD0003.bmp",
  L"data/actor/koishi/test_skillD0004.bmp",
  L"data/actor/koishi/test_skillD0005.bmp",
  L"data/actor/koishi/test_skillD0006.bmp",
  L"data/actor/koishi/test_skillD0007.bmp",
  L"data/actor/koishi/test_slide0000.bmp",
  L"data/actor/koishi/test_slide0001.bmp",
  L"data/actor/koishi/test_slide0002.bmp",
  L"data/actor/koishi/test_slide0003.bmp",
  L"data/actor/koishi/test_slide0004.bmp",
  L"data/actor/koishi/test_slide0005.bmp",
  L"data/actor/koishi/test_slide0006.bmp",
  L"data/actor/koishi/test_slide0007.bmp",
  L"data/actor/koishi/test_slide0008.bmp",
  L"data/actor/koishi/test_slide0009.bmp",
  L"data/actor/koishi/test_slide0010.bmp",
  L"data/actor/koishi/test_slide0011.bmp",
  L"data/actor/koishi/test_slide0012.bmp",
  L"data/actor/koishi/test_slide0013.bmp",
  L"data/actor/koishi/test_slide0014.bmp",
  L"data/actor/koishi/test_slide0015.bmp",
  L"data/actor/koishi/test_slide0016.bmp",
  L"data/actor/koishi/test_slide0017.bmp",
  L"data/actor/koishi/test_spellA0000.bmp",
  L"data/actor/koishi/test_spellA0001.bmp",
  L"data/actor/koishi/test_spellA0002.bmp",
  L"data/actor/koishi/test_spellA0003.bmp",
  L"data/actor/koishi/test_spellA0004.bmp",
  L"data/actor/koishi/test_spellA0005.bmp",
  L"data/actor/koishi/test_spellA0006.bmp",
  L"data/actor/koishi/test_spellA0007.bmp",
  L"data/actor/koishi/test_spellA0008.bmp",
  L"data/actor/koishi/test_spellA0009.bmp",
  L"data/actor/koishi/test_spellA0010.bmp",
  L"data/actor/koishi/test_stun0000.bmp",
  L"data/actor/koishi/test_stun0001.bmp",
  L"data/actor/koishi/test_stun0002.bmp",
  L"data/actor/koishi/test_stun0003.bmp",
  L"data/actor/koishi/test_stun0004.bmp",
  L"data/actor/koishi/test_stun0005.bmp",
  L"data/actor/koishi/test_turn0000.bmp",
  L"data/actor/koishi/test_turn0001.bmp",
  L"data/actor/koishi/test_turn0002.bmp",
  L"data/actor/koishi/test_winA0000.bmp",
  L"data/actor/koishi/test_winA0001.bmp",
  L"data/actor/koishi/test_winA0002.bmp",
  L"data/actor/koishi/test_winA0003.bmp",
  L"data/actor/koishi/test_winA0004.bmp",
  L"data/actor/koishi/test_winA0005.bmp",
  L"data/actor/koishi/test_winA0006.bmp",
  L"data/actor/koishi/test_winA0007.bmp",
  L"data/actor/koishi/texture/auraA0000.png",
  L"data/actor/koishi/texture/ball.bmp",
  L"data/actor/koishi/texture/ball.png",
  L"data/actor/koishi/texture/box_seet.bmp",
  L"data/actor/koishi/texture/cut0000.png",
  L"data/actor/koishi/texture/egoA0000.png",
  L"data/actor/koishi/texture/fire.png",
  L"data/actor/koishi/texture/heartA.png",
  L"data/actor/koishi/texture/koishi_animalDamage000.png",
  L"data/actor/koishi/texture/koishi_animalDamage001.png",
  L"data/actor/koishi/texture/koishi_animalDamage002.png",
  L"data/actor/koishi/texture/koishi_animalDamage003.png",
  L"data/actor/koishi/texture/koishi_animal_00000.png",
  L"data/actor/koishi/texture/koishi_animal_00001.png",
  L"data/actor/koishi/texture/koishi_animal_00002.png",
  L"data/actor/koishi/texture/koishi_animal_00003.png",
  L"data/actor/koishi/texture/koishi_animal_00004.png",
  L"data/actor/koishi/texture/koishi_animal_00005.png",
  L"data/actor/koishi/texture/koishi_animal_00006.png",
  L"data/actor/koishi/texture/koishi_animal_00007.png",
  L"data/actor/koishi/texture/koishi_animal_00008.png",
  L"data/actor/koishi/texture/koishi_animal_00009.png",
  L"data/actor/koishi/texture/koishi_animal_00010.png",
  L"data/actor/koishi/texture/koishi_animal_00011.png",
  L"data/actor/koishi/texture/koishi_fire.png",
  L"data/actor/koishi/texture/koishi_lastwordeffect.png",
  L"data/actor/koishi/texture/koishi_sparkLine.png",
  L"data/actor/koishi/texture/kona_A.bmp",
  L"data/actor/koishi/texture/kusyami.png",
  L"data/actor/koishi/texture/lightA0000.png",
  L"data/actor/koishi/texture/lightning_mapA.png",
  L"data/actor/koishi/texture/marisa_sparkLine.png",
  L"data/actor/koishi/texture/mask_ball.png",
  L"data/actor/koishi/texture/occult_phone0000.dds",
  L"data/actor/koishi/texture/ofudaHit.bmp",
  L"data/actor/koishi/texture/pulseA.png",
  L"data/actor/koishi/texture/reimu_wallA_mask.png",
  L"data/actor/koishi/texture/roseA.png",
  L"data/actor/koishi/texture/roseB.png",
  L"data/actor/koishi/texture/roseC.png",
  L"data/actor/koishi/texture/roseD.png",
  L"data/actor/koishi/texture/skillA_circleA.png",
  L"data/actor/koishi/texture/skillC_Laser.dds",
  L"data/actor/koishi/texture/skillG_B000.png",
  L"data/actor/koishi/texture/skillG_B001.png",
  L"data/actor/koishi/texture/skillG_B002.png",
  L"data/actor/koishi/texture/skillG_B003.png",
  L"data/actor/koishi/texture/skillG_B004.png",
  L"data/actor/koishi/texture/skillG_B005.png",
  L"data/actor/koishi/texture/skillG_B006.png",
  L"data/actor/koishi/texture/skillG_R000.png",
  L"data/actor/koishi/texture/skillG_R001.png",
  L"data/actor/koishi/texture/skillG_R002.png",
  L"data/actor/koishi/texture/skillG_R003.png",
  L"data/actor/koishi/texture/skillG_R004.png",
  L"data/actor/koishi/texture/skillG_R005.png",
  L"data/actor/koishi/texture/skillG_R006.png",
  L"data/actor/koishi/texture/sonic_wave0000.png",
  L"data/actor/koishi/texture/spellC_Shadow.dds",
  L"data/actor/koishi/texture/thornA.png",
  L"data/actor/koishi/texture/trailA.png",
  L"data/actor/koishi/texture/vortexloop0000.png",
  L"data/actor/koishi/walkBack0000.bmp",
  L"data/actor/koishi/walkBack0001.bmp",
  L"data/actor/koishi/walkBack0002.bmp",
  L"data/actor/koishi/walkBack0003.bmp",
  L"data/actor/koishi/walkBack0004.bmp",
  L"data/actor/koishi/walkBack0005.bmp",
  L"data/actor/koishi/walkBack0006.bmp",
  L"data/actor/koishi/walkBack0007.bmp",
  L"data/actor/koishi/walkBack0008.bmp",
  L"data/actor/koishi/walkBack0009.bmp",
  L"data/actor/koishi/walkBack0010.bmp",
  L"data/actor/koishi/walkBack0011.bmp",
  L"data/actor/koishi/walkBack0012.bmp",
  L"data/actor/koishi/walkFront0000.bmp",
  L"data/actor/koishi/walkFront0001.bmp",
  L"data/actor/koishi/walkFront0002.bmp",
  L"data/actor/koishi/walkFront0003.bmp",
  L"data/actor/koishi/walkFront0004.bmp",
  L"data/actor/koishi/walkFront0005.bmp",
  L"data/actor/koishi/walkFront0006.bmp",
  L"data/actor/koishi/walkFront0007.bmp",
  L"data/actor/koishi/walkFront0008.bmp",
  L"data/actor/koishi/walkFront0009.bmp",
  L"data/actor/koishi/walkFront0010.bmp",
  L"data/actor/koishi/walkFront0011.bmp",
  L"data/actor/koishi/walkFront0012.bmp",
  L"data/actor/koishi/winB0000.bmp",
  L"data/actor/koishi/winB0001.bmp",
  L"data/actor/koishi/winB0002.bmp",
  L"data/actor/koishi/winB0003.bmp",
  L"data/actor/koishi/winB0004.bmp",
  L"data/actor/koishi/winB0005.bmp",
  L"data/actor/koishi/winB0006.bmp",
  L"data/actor/koishi/winB0007.bmp",
  L"data/actor/koishi/winB_Hat0000.bmp",
  L"data/actor/koishi/winB_Hat0001.bmp",
  L"data/actor/koishi/winB_Hat0002.bmp",
  L"data/actor/koishi/winB_Hat0003.bmp",
  L"data/actor/koishi.nut",
  L"data/actor/koishiInit.nut",
  L"data/actor/koishi_base.nut",
  L"data/actor/koishi_boss.nut",
  L"data/actor/koishi_cpu.nut",
  L"data/actor/koishi_cpuBoss.nut",
  L"data/actor/koishi_shot.nut",
  L"data/actor/kokoro/atkDashHigh0000.bmp",
  L"data/actor/kokoro/atkDashHigh0001.bmp",
  L"data/actor/kokoro/atkDashHigh0002.bmp",
  L"data/actor/kokoro/atkDashHigh0003.bmp",
  L"data/actor/kokoro/atkDashHigh0004.bmp",
  L"data/actor/kokoro/atkDashHigh0005.bmp",
  L"data/actor/kokoro/atkDashHigh0006.bmp",
  L"data/actor/kokoro/atkDashHigh0007.bmp",
  L"data/actor/kokoro/atkHigh0000.bmp",
  L"data/actor/kokoro/atkHigh0001.bmp",
  L"data/actor/kokoro/atkHigh0002.bmp",
  L"data/actor/kokoro/atkHigh0003.bmp",
  L"data/actor/kokoro/atkHigh0004.bmp",
  L"data/actor/kokoro/atkHigh0005.bmp",
  L"data/actor/kokoro/atkHigh0006.bmp",
  L"data/actor/kokoro/atkHigh0007.bmp",
  L"data/actor/kokoro/atkHigh0008.bmp",
  L"data/actor/kokoro/atkHigh0009.bmp",
  L"data/actor/kokoro/atkHigh0010.bmp",
  L"data/actor/kokoro/atkHigh0011.bmp",
  L"data/actor/kokoro/atkHigh0012.bmp",
  L"data/actor/kokoro/atkHighFront0000.bmp",
  L"data/actor/kokoro/atkHighFront0001.bmp",
  L"data/actor/kokoro/atkHighFront0002.bmp",
  L"data/actor/kokoro/atkHighFront0003.bmp",
  L"data/actor/kokoro/atkHighFront0004.bmp",
  L"data/actor/kokoro/atkHighFront0005.bmp",
  L"data/actor/kokoro/atkHighFront0006.bmp",
  L"data/actor/kokoro/atkHighFront0007.bmp",
  L"data/actor/kokoro/atkHighFront0008.bmp",
  L"data/actor/kokoro/atkHighFront0009.bmp",
  L"data/actor/kokoro/atkHighUnder0000.bmp",
  L"data/actor/kokoro/atkHighUnder0001.bmp",
  L"data/actor/kokoro/atkHighUnder0002.bmp",
  L"data/actor/kokoro/atkHighUnder0003.bmp",
  L"data/actor/kokoro/atkHighUnder0004.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0000.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0001.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0002.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0003.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0004.bmp",
  L"data/actor/kokoro/atkHighUnderLoop0005.bmp",
  L"data/actor/kokoro/atkHighUpper0000.bmp",
  L"data/actor/kokoro/atkHighUpper0001.bmp",
  L"data/actor/kokoro/atkHighUpper0002.bmp",
  L"data/actor/kokoro/atkHighUpper0003.bmp",
  L"data/actor/kokoro/atkHighUpper0004.bmp",
  L"data/actor/kokoro/atkHighUpper0005.bmp",
  L"data/actor/kokoro/atkHighUpper0006.bmp",
  L"data/actor/kokoro/atkHighUpper0007.bmp",
  L"data/actor/kokoro/atkHighUpper0008.bmp",
  L"data/actor/kokoro/atkHighUpper0009.bmp",
  L"data/actor/kokoro/atkHighUpper0010.bmp",
  L"data/actor/kokoro/atkHighUpper0011.bmp",
  L"data/actor/kokoro/atkHighUpper0012.bmp",
  L"data/actor/kokoro/atkLow0000.bmp",
  L"data/actor/kokoro/atkLow0001.bmp",
  L"data/actor/kokoro/atkLow0002.bmp",
  L"data/actor/kokoro/atkLow0003.bmp",
  L"data/actor/kokoro/atkLow0004.bmp",
  L"data/actor/kokoro/atkLow0005.bmp",
  L"data/actor/kokoro/atkLow0006.bmp",
  L"data/actor/kokoro/atkLow0007.bmp",
  L"data/actor/kokoro/atkLow0008.bmp",
  L"data/actor/kokoro/atkMid0000.bmp",
  L"data/actor/kokoro/atkMid0001.bmp",
  L"data/actor/kokoro/atkMid0002.bmp",
  L"data/actor/kokoro/atkMid0003.bmp",
  L"data/actor/kokoro/atkMid0004.bmp",
  L"data/actor/kokoro/atkMid0005.bmp",
  L"data/actor/kokoro/atkMid0006.bmp",
  L"data/actor/kokoro/atkMid0007.bmp",
  L"data/actor/kokoro/atkMidMask0000.bmp",
  L"data/actor/kokoro/battleBeginA0000.bmp",
  L"data/actor/kokoro/battleBeginA0001.bmp",
  L"data/actor/kokoro/battleBeginA0002.bmp",
  L"data/actor/kokoro/battleBeginA0003.bmp",
  L"data/actor/kokoro/battleBeginA0004.bmp",
  L"data/actor/kokoro/battleBeginA0005.bmp",
  L"data/actor/kokoro/battleBeginA0006.bmp",
  L"data/actor/kokoro/battleBeginA0007.bmp",
  L"data/actor/kokoro/battleBeginA0008.bmp",
  L"data/actor/kokoro/beginBattleA0000.bmp",
  L"data/actor/kokoro/beginBattleA0001.bmp",
  L"data/actor/kokoro/beginBattleA0002.bmp",
  L"data/actor/kokoro/beginBattleA0003.bmp",
  L"data/actor/kokoro/beginBattleA0004.bmp",
  L"data/actor/kokoro/beginBattleA0005.bmp",
  L"data/actor/kokoro/beginBattleA0006.bmp",
  L"data/actor/kokoro/beginBattleA0007.bmp",
  L"data/actor/kokoro/beginBattleA0008.bmp",
  L"data/actor/kokoro/beginBattleA0009.bmp",
  L"data/actor/kokoro/beginBattleA0010.bmp",
  L"data/actor/kokoro/beginBattleA2_Loop0000.bmp",
  L"data/actor/kokoro/beginBattleA2_Loop0001.bmp",
  L"data/actor/kokoro/beginBattleA2_Loop0002.bmp",
  L"data/actor/kokoro/beginBattleA2_Loop0003.bmp",
  L"data/actor/kokoro/beginBattleA2_Loop0004.bmp",
  L"data/actor/kokoro/beginBattleA_Loop0000.bmp",
  L"data/actor/kokoro/beginBattleA_Loop0001.bmp",
  L"data/actor/kokoro/beginBattleA_Loop0002.bmp",
  L"data/actor/kokoro/beginBattleA_Loop0003.bmp",
  L"data/actor/kokoro/beginBattleA_Loop0004.bmp",
  L"data/actor/kokoro/bmsln/beginAura.bmb",
  L"data/actor/kokoro/bmsln/emotionFieldB.bmb",
  L"data/actor/kokoro/bmsln/emotionFieldG.bmb",
  L"data/actor/kokoro/bmsln/emotionFieldR.bmb",
  L"data/actor/kokoro/bmsln/emotionFieldY.bmb",
  L"data/actor/kokoro/bmsln/hairShotA.bmb",
  L"data/actor/kokoro/bmsln/kokoro_6B_B.bmb",
  L"data/actor/kokoro/bmsln/kokoro_6B_G.bmb",
  L"data/actor/kokoro/bmsln/kokoro_6B_R.bmb",
  L"data/actor/kokoro/bmsln/kokoro_blaze.bmb",
  L"data/actor/kokoro/bmsln/kokoro_fireWork.bmb",
  L"data/actor/kokoro/bmsln/kokoro_spellC_Pilar.bmb",
  L"data/actor/kokoro/climax0000.bmp",
  L"data/actor/kokoro/climax0001.bmp",
  L"data/actor/kokoro/climax0002.bmp",
  L"data/actor/kokoro/climax0003.bmp",
  L"data/actor/kokoro/climax0004.bmp",
  L"data/actor/kokoro/climax0005.bmp",
  L"data/actor/kokoro/climax0006.bmp",
  L"data/actor/kokoro/climax0007.bmp",
  L"data/actor/kokoro/climax0008.bmp",
  L"data/actor/kokoro/climaxMaskA0000.bmp",
  L"data/actor/kokoro/climaxMaskA0001.bmp",
  L"data/actor/kokoro/crash0000.bmp",
  L"data/actor/kokoro/crash0001.bmp",
  L"data/actor/kokoro/crash0002.bmp",
  L"data/actor/kokoro/crashLoop0000.bmp",
  L"data/actor/kokoro/crashLoop0001.bmp",
  L"data/actor/kokoro/cut0000.png",
  L"data/actor/kokoro/cut0001.png",
  L"data/actor/kokoro/cut0002.png",
  L"data/actor/kokoro/cut0003.png",
  L"data/actor/kokoro/damageBody0000.bmp",
  L"data/actor/kokoro/damageBody0001.bmp",
  L"data/actor/kokoro/damageBody0002.bmp",
  L"data/actor/kokoro/damageBody0003.bmp",
  L"data/actor/kokoro/damageBody0004.bmp",
  L"data/actor/kokoro/damageHead0000.bmp",
  L"data/actor/kokoro/damageHead0001.bmp",
  L"data/actor/kokoro/damageHead0002.bmp",
  L"data/actor/kokoro/damageHead0003.bmp",
  L"data/actor/kokoro/damageHead0004.bmp",
  L"data/actor/kokoro/damageSpin0000.bmp",
  L"data/actor/kokoro/damageSpin0001.bmp",
  L"data/actor/kokoro/damageSpin0002.bmp",
  L"data/actor/kokoro/damageSpin0003.bmp",
  L"data/actor/kokoro/damageUpper0000.bmp",
  L"data/actor/kokoro/damageUpper0001.bmp",
  L"data/actor/kokoro/damageUpper0002.bmp",
  L"data/actor/kokoro/damageUpper0003.bmp",
  L"data/actor/kokoro/damageUpper0004.bmp",
  L"data/actor/kokoro/damageUpper0005.bmp",
  L"data/actor/kokoro/damageUpper0006.bmp",
  L"data/actor/kokoro/damageUpper0007.bmp",
  L"data/actor/kokoro/damageUpper0008.bmp",
  L"data/actor/kokoro/damageUpper0009.bmp",
  L"data/actor/kokoro/damageUpper0010.bmp",
  L"data/actor/kokoro/damageUpper0011.bmp",
  L"data/actor/kokoro/damageUpper0012.bmp",
  L"data/actor/kokoro/damageUpper0013.bmp",
  L"data/actor/kokoro/damageUpper0014.bmp",
  L"data/actor/kokoro/damageUpper0015.bmp",
  L"data/actor/kokoro/damageUpper0016.bmp",
  L"data/actor/kokoro/damageUpper0017.bmp",
  L"data/actor/kokoro/damageUpper0018.bmp",
  L"data/actor/kokoro/damageWall0000.bmp",
  L"data/actor/kokoro/damageWall0001.bmp",
  L"data/actor/kokoro/damageWall0002.bmp",
  L"data/actor/kokoro/damageWall0003.bmp",
  L"data/actor/kokoro/damageWall0004.bmp",
  L"data/actor/kokoro/damageWall0005.bmp",
  L"data/actor/kokoro/damageWall0006.bmp",
  L"data/actor/kokoro/dashBack0000.bmp",
  L"data/actor/kokoro/dashBack0001.bmp",
  L"data/actor/kokoro/dashBack0002.bmp",
  L"data/actor/kokoro/dashBackLoop0000.bmp",
  L"data/actor/kokoro/dashBackLoop0001.bmp",
  L"data/actor/kokoro/dashBackLoop0002.bmp",
  L"data/actor/kokoro/dashBackLoop0003.bmp",
  L"data/actor/kokoro/dashBackLoop0004.bmp",
  L"data/actor/kokoro/dashFront0000.bmp",
  L"data/actor/kokoro/dashFront0001.bmp",
  L"data/actor/kokoro/dashFront0002.bmp",
  L"data/actor/kokoro/dashFrontLoop0000.bmp",
  L"data/actor/kokoro/dashFrontLoop0001.bmp",
  L"data/actor/kokoro/dashFrontLoop0002.bmp",
  L"data/actor/kokoro/dashFrontLoop0003.bmp",
  L"data/actor/kokoro/dashFrontLoop0004.bmp",
  L"data/actor/kokoro/dummy.bmp",
  L"data/actor/kokoro/face_spellCallB.png",
  L"data/actor/kokoro/HighShotA0000.bmp",
  L"data/actor/kokoro/HighShotA0001.bmp",
  L"data/actor/kokoro/HighShotA0002.bmp",
  L"data/actor/kokoro/HighShotA0003.bmp",
  L"data/actor/kokoro/HighShotA0004.bmp",
  L"data/actor/kokoro/HighShotA0005.bmp",
  L"data/actor/kokoro/HighShotA0006.bmp",
  L"data/actor/kokoro/HighShotA0007.bmp",
  L"data/actor/kokoro/HighShotA0008.bmp",
  L"data/actor/kokoro/HighShotA0009.bmp",
  L"data/actor/kokoro/HighShotAb0000.bmp",
  L"data/actor/kokoro/HighShotAb0001.bmp",
  L"data/actor/kokoro/HighShotAb0002.bmp",
  L"data/actor/kokoro/HighShotAb0003.bmp",
  L"data/actor/kokoro/HighShotAb0004.bmp",
  L"data/actor/kokoro/HighShotAb0005.bmp",
  L"data/actor/kokoro/HighShotAb0006.bmp",
  L"data/actor/kokoro/HighShotAb0007.bmp",
  L"data/actor/kokoro/item0000.bmp",
  L"data/actor/kokoro/item0001.bmp",
  L"data/actor/kokoro/item0002.bmp",
  L"data/actor/kokoro/item0003.bmp",
  L"data/actor/kokoro/item0004.bmp",
  L"data/actor/kokoro/item0005.bmp",
  L"data/actor/kokoro/item0006.bmp",
  L"data/actor/kokoro/item0007.bmp",
  L"data/actor/kokoro/item0008.bmp",
  L"data/actor/kokoro/item0009.bmp",
  L"data/actor/kokoro/item0010.bmp",
  L"data/actor/kokoro/kokoro.pat",
  L"data/actor/kokoro/kokoro_ed.pat",
  L"data/actor/kokoro/maskA0000.bmp",
  L"data/actor/kokoro/maskB0000.bmp",
  L"data/actor/kokoro/maskC0000.bmp",
  L"data/actor/kokoro/maskD0000.bmp",
  L"data/actor/kokoro/maskE0000.bmp",
  L"data/actor/kokoro/maskF0000.bmp",
  L"data/actor/kokoro/missGuard0000.bmp",
  L"data/actor/kokoro/missGuard0001.bmp",
  L"data/actor/kokoro/missGuard0002.bmp",
  L"data/actor/kokoro/missGuard0003.bmp",
  L"data/actor/kokoro/occult0000.bmp",
  L"data/actor/kokoro/occult0001.bmp",
  L"data/actor/kokoro/occult0002.bmp",
  L"data/actor/kokoro/occult0003.bmp",
  L"data/actor/kokoro/occult0004.bmp",
  L"data/actor/kokoro/occult0005.bmp",
  L"data/actor/kokoro/occult0006.bmp",
  L"data/actor/kokoro/occult0007.bmp",
  L"data/actor/kokoro/occult0008.bmp",
  L"data/actor/kokoro/occult0009.bmp",
  L"data/actor/kokoro/occult0010.bmp",
  L"data/actor/kokoro/occult0011.bmp",
  L"data/actor/kokoro/occult0012.bmp",
  L"data/actor/kokoro/occult0013.bmp",
  L"data/actor/kokoro/occult0014.bmp",
  L"data/actor/kokoro/occult0015.bmp",
  L"data/actor/kokoro/occult0016.bmp",
  L"data/actor/kokoro/occult_shot0000.bmp",
  L"data/actor/kokoro/occult_shot0001.bmp",
  L"data/actor/kokoro/occult_shot0002.bmp",
  L"data/actor/kokoro/palette000.bmp",
  L"data/actor/kokoro/palette001.bmp",
  L"data/actor/kokoro/palette002.bmp",
  L"data/actor/kokoro/palette003.bmp",
  L"data/actor/kokoro/palette004.bmp",
  L"data/actor/kokoro/palette005.bmp",
  L"data/actor/kokoro/palette006.bmp",
  L"data/actor/kokoro/palette007.bmp",
  L"data/actor/kokoro/shotLow0000.bmp",
  L"data/actor/kokoro/shotLow0001.bmp",
  L"data/actor/kokoro/shotLow0002.bmp",
  L"data/actor/kokoro/shotLow0003.bmp",
  L"data/actor/kokoro/shotLow0004.bmp",
  L"data/actor/kokoro/shotLow0005.bmp",
  L"data/actor/kokoro/shotLow0006.bmp",
  L"data/actor/kokoro/shotLow0007.bmp",
  L"data/actor/kokoro/shotLow0008.bmp",
  L"data/actor/kokoro/shotLowB0000.bmp",
  L"data/actor/kokoro/shotLowB0001.bmp",
  L"data/actor/kokoro/shotLowB0002.bmp",
  L"data/actor/kokoro/shotLowB0003.bmp",
  L"data/actor/kokoro/shotLowB0004.bmp",
  L"data/actor/kokoro/shotLowB0005.bmp",
  L"data/actor/kokoro/shotLowB0006.bmp",
  L"data/actor/kokoro/skillA0000.bmp",
  L"data/actor/kokoro/skillA0001.bmp",
  L"data/actor/kokoro/skillA0002.bmp",
  L"data/actor/kokoro/skillA0003.bmp",
  L"data/actor/kokoro/skillA0004.bmp",
  L"data/actor/kokoro/skillA0005.bmp",
  L"data/actor/kokoro/skillA0006.bmp",
  L"data/actor/kokoro/skillA0007.bmp",
  L"data/actor/kokoro/skillA0008.bmp",
  L"data/actor/kokoro/skillA0009.bmp",
  L"data/actor/kokoro/skillA0010.bmp",
  L"data/actor/kokoro/skillA0011.bmp",
  L"data/actor/kokoro/skillA0012.bmp",
  L"data/actor/kokoro/skillA0013.bmp",
  L"data/actor/kokoro/skillA0014.bmp",
  L"data/actor/kokoro/skillA0015.bmp",
  L"data/actor/kokoro/skillB0000.bmp",
  L"data/actor/kokoro/skillB0001.bmp",
  L"data/actor/kokoro/skillB0002.bmp",
  L"data/actor/kokoro/skillB0003.bmp",
  L"data/actor/kokoro/skillB0004.bmp",
  L"data/actor/kokoro/skillB0005.bmp",
  L"data/actor/kokoro/skillB0006.bmp",
  L"data/actor/kokoro/skillB0007.bmp",
  L"data/actor/kokoro/skillB0008.bmp",
  L"data/actor/kokoro/skillBb0000.bmp",
  L"data/actor/kokoro/skillBb0001.bmp",
  L"data/actor/kokoro/skillBb0002.bmp",
  L"data/actor/kokoro/skillBb0003.bmp",
  L"data/actor/kokoro/skillBb0004.bmp",
  L"data/actor/kokoro/skillBb0005.bmp",
  L"data/actor/kokoro/skillC0000.bmp",
  L"data/actor/kokoro/skillC0001.bmp",
  L"data/actor/kokoro/skillC0002.bmp",
  L"data/actor/kokoro/skillC0003.bmp",
  L"data/actor/kokoro/skillC0004.bmp",
  L"data/actor/kokoro/skillC0005.bmp",
  L"data/actor/kokoro/skillC0006.bmp",
  L"data/actor/kokoro/skillC0007.bmp",
  L"data/actor/kokoro/skillC0008.bmp",
  L"data/actor/kokoro/skillC0009.bmp",
  L"data/actor/kokoro/skillC0010.bmp",
  L"data/actor/kokoro/skillCLoop0000.bmp",
  L"data/actor/kokoro/skillCLoop0001.bmp",
  L"data/actor/kokoro/skillCLoop0002.bmp",
  L"data/actor/kokoro/skillCLoop0003.bmp",
  L"data/actor/kokoro/skillCLoop0004.bmp",
  L"data/actor/kokoro/skillD0000.bmp",
  L"data/actor/kokoro/skillD0001.bmp",
  L"data/actor/kokoro/skillD0002.bmp",
  L"data/actor/kokoro/skillD0003.bmp",
  L"data/actor/kokoro/skillD0004.bmp",
  L"data/actor/kokoro/skillD0005.bmp",
  L"data/actor/kokoro/skillD0006.bmp",
  L"data/actor/kokoro/skillD0007.bmp",
  L"data/actor/kokoro/skillD_Loop0000.bmp",
  L"data/actor/kokoro/skillD_Loop0001.bmp",
  L"data/actor/kokoro/skillD_Loop0002.bmp",
  L"data/actor/kokoro/skillD_Loop0003.bmp",
  L"data/actor/kokoro/skillD_Loop0004.bmp",
  L"data/actor/kokoro/skillF0000.bmp",
  L"data/actor/kokoro/skillF0001.bmp",
  L"data/actor/kokoro/skillF0002.bmp",
  L"data/actor/kokoro/skillF0003.bmp",
  L"data/actor/kokoro/skillF0004.bmp",
  L"data/actor/kokoro/skillF0005.bmp",
  L"data/actor/kokoro/skillF0006.bmp",
  L"data/actor/kokoro/skillF0007.bmp",
  L"data/actor/kokoro/skillF0008.bmp",
  L"data/actor/kokoro/skillF0009.bmp",
  L"data/actor/kokoro/skillF0010.bmp",
  L"data/actor/kokoro/skillF0011.bmp",
  L"data/actor/kokoro/skillF0012.bmp",
  L"data/actor/kokoro/skillF0013.bmp",
  L"data/actor/kokoro/skillF0014.bmp",
  L"data/actor/kokoro/skillF0015.bmp",
  L"data/actor/kokoro/skillG0000.bmp",
  L"data/actor/kokoro/skillG0001.bmp",
  L"data/actor/kokoro/skillG0002.bmp",
  L"data/actor/kokoro/skillG0003.bmp",
  L"data/actor/kokoro/skillG0004.bmp",
  L"data/actor/kokoro/skillG0005.bmp",
  L"data/actor/kokoro/skillG0006.bmp",
  L"data/actor/kokoro/skillG0007.bmp",
  L"data/actor/kokoro/skillG0008.bmp",
  L"data/actor/kokoro/slide0000.bmp",
  L"data/actor/kokoro/slide0001.bmp",
  L"data/actor/kokoro/slide0002.bmp",
  L"data/actor/kokoro/slide0003.bmp",
  L"data/actor/kokoro/slide0004.bmp",
  L"data/actor/kokoro/slide0005.bmp",
  L"data/actor/kokoro/slide0006.bmp",
  L"data/actor/kokoro/slide0007.bmp",
  L"data/actor/kokoro/slide0008.bmp",
  L"data/actor/kokoro/slide0009.bmp",
  L"data/actor/kokoro/slideUnderLoop0000.bmp",
  L"data/actor/kokoro/slideUnderLoop0001.bmp",
  L"data/actor/kokoro/slideUnderLoop0002.bmp",
  L"data/actor/kokoro/slideUnderLoop0003.bmp",
  L"data/actor/kokoro/slideUnderLoop0004.bmp",
  L"data/actor/kokoro/slideUpperLoop0000.bmp",
  L"data/actor/kokoro/slideUpperLoop0001.bmp",
  L"data/actor/kokoro/slideUpperLoop0002.bmp",
  L"data/actor/kokoro/slideUpperLoop0003.bmp",
  L"data/actor/kokoro/slideUpperLoop0004.bmp",
  L"data/actor/kokoro/spellA0000.bmp",
  L"data/actor/kokoro/spellA0001.bmp",
  L"data/actor/kokoro/spellA0002.bmp",
  L"data/actor/kokoro/spellA0003.bmp",
  L"data/actor/kokoro/spellA0004.bmp",
  L"data/actor/kokoro/spellA0005.bmp",
  L"data/actor/kokoro/spellA0006.bmp",
  L"data/actor/kokoro/spellA0007.bmp",
  L"data/actor/kokoro/spellA0008.bmp",
  L"data/actor/kokoro/spellA0009.bmp",
  L"data/actor/kokoro/spellCb0000.bmp",
  L"data/actor/kokoro/spellCb0001.bmp",
  L"data/actor/kokoro/spellCb0002.bmp",
  L"data/actor/kokoro/spellCb0003.bmp",
  L"data/actor/kokoro/spellCb0004.bmp",
  L"data/actor/kokoro/spellMask_C0000.bmp",
  L"data/actor/kokoro/spellMask_C0001.bmp",
  L"data/actor/kokoro/spellMask_C0002.bmp",
  L"data/actor/kokoro/spellMask_C0003.bmp",
  L"data/actor/kokoro/stand0000.bmp",
  L"data/actor/kokoro/stand0001.bmp",
  L"data/actor/kokoro/stand0002.bmp",
  L"data/actor/kokoro/stand0003.bmp",
  L"data/actor/kokoro/stand0004.bmp",
  L"data/actor/kokoro/stand0005.bmp",
  L"data/actor/kokoro/stand0006.bmp",
  L"data/actor/kokoro/stand0007.bmp",
  L"data/actor/kokoro/stand0008.bmp",
  L"data/actor/kokoro/stand0009.bmp",
  L"data/actor/kokoro/stand0010.bmp",
  L"data/actor/kokoro/stand0011.bmp",
  L"data/actor/kokoro/stand0012.bmp",
  L"data/actor/kokoro/stand0013.bmp",
  L"data/actor/kokoro/stand0014.bmp",
  L"data/actor/kokoro/stand0015.bmp",
  L"data/actor/kokoro/stand0016.bmp",
  L"data/actor/kokoro/stand0017.bmp",
  L"data/actor/kokoro/stand0018.bmp",
  L"data/actor/kokoro/stand0019.bmp",
  L"data/actor/kokoro/stand0020.bmp",
  L"data/actor/kokoro/stand0021.bmp",
  L"data/actor/kokoro/stand0022.bmp",
  L"data/actor/kokoro/stand0023.bmp",
  L"data/actor/kokoro/stand0024.bmp",
  L"data/actor/kokoro/stand0025.bmp",
  L"data/actor/kokoro/stand0026.bmp",
  L"data/actor/kokoro/stand0027.bmp",
  L"data/actor/kokoro/stun0000.bmp",
  L"data/actor/kokoro/stun0001.bmp",
  L"data/actor/kokoro/stun0002.bmp",
  L"data/actor/kokoro/testr_climaxeffecta0000.png",
  L"data/actor/kokoro/testr_climaxeffectb0000.png",
  L"data/actor/kokoro/testr_climaxeffectc0000.png",
  L"data/actor/kokoro/texture/auraA0000.png",
  L"data/actor/kokoro/texture/auraB0000.png",
  L"data/actor/kokoro/texture/auraC0000.png",
  L"data/actor/kokoro/texture/ball.bmp",
  L"data/actor/kokoro/texture/beamA0000.png",
  L"data/actor/kokoro/texture/bladeA0000.dds",
  L"data/actor/kokoro/texture/bladeA0001.dds",
  L"data/actor/kokoro/texture/bladeA0002.dds",
  L"data/actor/kokoro/texture/bladeA0002.png",
  L"data/actor/kokoro/texture/bladeA0003.dds",
  L"data/actor/kokoro/texture/bladeA0003.png",
  L"data/actor/kokoro/texture/bladeA0004.dds",
  L"data/actor/kokoro/texture/bladeA0005.dds",
  L"data/actor/kokoro/texture/climax_auravortex0000.dds",
  L"data/actor/kokoro/texture/climax_mask0000.dds",
  L"data/actor/kokoro/texture/emotionFontA.png",
  L"data/actor/kokoro/texture/fireShotA0000.dds",
  L"data/actor/kokoro/texture/fireshotBackA0000.dds",
  L"data/actor/kokoro/texture/foxMaskAuraA000.png",
  L"data/actor/kokoro/texture/hairWaveA000.png",
  L"data/actor/kokoro/texture/kokoro_animalDamage000.png",
  L"data/actor/kokoro/texture/kokoro_animalDamage001.png",
  L"data/actor/kokoro/texture/kokoro_animalDamage002.png",
  L"data/actor/kokoro/texture/kokoro_animalDamage003.png",
  L"data/actor/kokoro/texture/kokoro_animal_00000.png",
  L"data/actor/kokoro/texture/kokoro_animal_00001.png",
  L"data/actor/kokoro/texture/kokoro_animal_00002.png",
  L"data/actor/kokoro/texture/kokoro_animal_00003.png",
  L"data/actor/kokoro/texture/kokoro_animal_00004.png",
  L"data/actor/kokoro/texture/kokoro_animal_00005.png",
  L"data/actor/kokoro/texture/kokoro_animal_00006.png",
  L"data/actor/kokoro/texture/kokoro_animal_00007.png",
  L"data/actor/kokoro/texture/kokoro_animal_00008.png",
  L"data/actor/kokoro/texture/kokoro_animal_00009.png",
  L"data/actor/kokoro/texture/kokoro_animal_00010.png",
  L"data/actor/kokoro/texture/kokoro_animal_00011.png",
  L"data/actor/kokoro/texture/kokoro_auraA0000.png",
  L"data/actor/kokoro/texture/kokoro_field.png",
  L"data/actor/kokoro/texture/kokoro_fire.png",
  L"data/actor/kokoro/texture/kokoro_fireB.png",
  L"data/actor/kokoro/texture/kokoro_fireBase.png",
  L"data/actor/kokoro/texture/kokoro_fireWorkA0000.png",
  L"data/actor/kokoro/texture/kokoro_sparkLine.png",
  L"data/actor/kokoro/texture/kona_A.bmp",
  L"data/actor/kokoro/texture/lightning_mapA.png",
  L"data/actor/kokoro/texture/mantleB0000.bmp",
  L"data/actor/kokoro/texture/mantleG0000.bmp",
  L"data/actor/kokoro/texture/mantleR0000.bmp",
  L"data/actor/kokoro/texture/mantletest000.bmp",
  L"data/actor/kokoro/texture/marisaBall2.bmp",
  L"data/actor/kokoro/texture/marisaStarFlare.bmp",
  L"data/actor/kokoro/texture/mask_ball.png",
  L"data/actor/kokoro/texture/monoAuraA0000.png",
  L"data/actor/kokoro/texture/monoAuraA0001.png",
  L"data/actor/kokoro/texture/netA0000.png",
  L"data/actor/kokoro/texture/occult_face0000.dds",
  L"data/actor/kokoro/texture/occult_splash0000.dds",
  L"data/actor/kokoro/texture/reimu_musouBase.png",
  L"data/actor/kokoro/texture/reimu_wallA.png",
  L"data/actor/kokoro/texture/reimu_wallA_mask.png",
  L"data/actor/kokoro/texture/ringSparkA0000.png",
  L"data/actor/kokoro/texture/skillA_fox.png",
  L"data/actor/kokoro/texture/skillA_mono.png",
  L"data/actor/kokoro/texture/skillD_shadowA0000.png",
  L"data/actor/kokoro/texture/skillD_squeezeA.png",
  L"data/actor/kokoro/texture/skillD_squeezeMono.png",
  L"data/actor/kokoro/texture/skillD_trail.png",
  L"data/actor/kokoro/texture/skillD_trail2.png",
  L"data/actor/kokoro/texture/skillE_Trail.png",
  L"data/actor/kokoro/texture/spellC_shadowA0000.png",
  L"data/actor/kokoro/texture/spellC_shadowA0001.png",
  L"data/actor/kokoro/texture/spellC_shadowA0002.png",
  L"data/actor/kokoro/texture/spellC_shadowA0003.png",
  L"data/actor/kokoro/texture/spellC_shadowA0004.png",
  L"data/actor/kokoro/texture/stringA000.png",
  L"data/actor/kokoro/texture/test_guage.png",
  L"data/actor/kokoro/texture/test_ikari.png",
  L"data/actor/kokoro/texture/test_ki.png",
  L"data/actor/kokoro/texture/test_ui.png",
  L"data/actor/kokoro/texture/trail.png",
  L"data/actor/kokoro/turn0000.bmp",
  L"data/actor/kokoro/turn0001.bmp",
  L"data/actor/kokoro/turn0002.bmp",
  L"data/actor/kokoro/walkBack0000.bmp",
  L"data/actor/kokoro/walkBack0001.bmp",
  L"data/actor/kokoro/walkBack0002.bmp",
  L"data/actor/kokoro/walkBack0003.bmp",
  L"data/actor/kokoro/walkBack0004.bmp",
  L"data/actor/kokoro/walkBack0005.bmp",
  L"data/actor/kokoro/walkBack0006.bmp",
  L"data/actor/kokoro/walkBackLoop0000.bmp",
  L"data/actor/kokoro/walkBackLoop0001.bmp",
  L"data/actor/kokoro/walkBackLoop0002.bmp",
  L"data/actor/kokoro/walkBackLoop0003.bmp",
  L"data/actor/kokoro/walkBackLoop0004.bmp",
  L"data/actor/kokoro/walkFront0000.bmp",
  L"data/actor/kokoro/walkFront0001.bmp",
  L"data/actor/kokoro/walkFront0002.bmp",
  L"data/actor/kokoro/walkFront0003.bmp",
  L"data/actor/kokoro/walkFront0004.bmp",
  L"data/actor/kokoro/walkFront0005.bmp",
  L"data/actor/kokoro/walkFrontLoop0000.bmp",
  L"data/actor/kokoro/walkFrontLoop0001.bmp",
  L"data/actor/kokoro/walkFrontLoop0002.bmp",
  L"data/actor/kokoro/walkFrontLoop0003.bmp",
  L"data/actor/kokoro/walkFrontLoop0004.bmp",
  L"data/actor/kokoro/winA0000.bmp",
  L"data/actor/kokoro/winA0001.bmp",
  L"data/actor/kokoro/winA0002.bmp",
  L"data/actor/kokoro/winA0003.bmp",
  L"data/actor/kokoro/winA0004.bmp",
  L"data/actor/kokoro/winA0005.bmp",
  L"data/actor/kokoro/winA0006.bmp",
  L"data/actor/kokoro/winA0007.bmp",
  L"data/actor/kokoro/winA0008.bmp",
  L"data/actor/kokoro.nut",
  L"data/actor/kokoroInit.nut",
  L"data/actor/kokoro_base.nut",
  L"data/actor/kokoro_boss.nut",
  L"data/actor/kokoro_cpu.nut",
  L"data/actor/kokoro_cpuBoss.nut",
  L"data/actor/kokoro_shot.nut",
  L"data/actor/mamizou/atkDashHigh0002.bmp",
  L"data/actor/mamizou/atkDashHigh0003.bmp",
  L"data/actor/mamizou/atkDashHigh0004.bmp",
  L"data/actor/mamizou/atkDashHigh0005.bmp",
  L"data/actor/mamizou/atkDashHigh0006.bmp",
  L"data/actor/mamizou/atkDashHigh0007.bmp",
  L"data/actor/mamizou/atkDashLow0000.bmp",
  L"data/actor/mamizou/atkDashLow0001.bmp",
  L"data/actor/mamizou/atkDashLow0002.bmp",
  L"data/actor/mamizou/atkDashLow0003.bmp",
  L"data/actor/mamizou/atkDashLow0004.bmp",
  L"data/actor/mamizou/atkDashLow0005.bmp",
  L"data/actor/mamizou/atkDashLow0006.bmp",
  L"data/actor/mamizou/atkDashLow0007.bmp",
  L"data/actor/mamizou/atkDashLow0008.bmp",
  L"data/actor/mamizou/atkDashLow0009.bmp",
  L"data/actor/mamizou/atkDashLow0010.bmp",
  L"data/actor/mamizou/atkDashLow0011.bmp",
  L"data/actor/mamizou/atkHigh0000.bmp",
  L"data/actor/mamizou/atkHigh0001.bmp",
  L"data/actor/mamizou/atkHigh0002.bmp",
  L"data/actor/mamizou/atkHigh0003.bmp",
  L"data/actor/mamizou/atkHigh0004.bmp",
  L"data/actor/mamizou/atkHigh0005.bmp",
  L"data/actor/mamizou/atkHigh0006.bmp",
  L"data/actor/mamizou/atkHigh0007.bmp",
  L"data/actor/mamizou/atkHigh0008.bmp",
  L"data/actor/mamizou/atkHigh0009.bmp",
  L"data/actor/mamizou/atkHigh0010.bmp",
  L"data/actor/mamizou/atkHigh0011.bmp",
  L"data/actor/mamizou/atkHigh0012.bmp",
  L"data/actor/mamizou/atkHigh0013.bmp",
  L"data/actor/mamizou/atkHigh0014.bmp",
  L"data/actor/mamizou/atkHighFront0000.bmp",
  L"data/actor/mamizou/atkHighFront0001.bmp",
  L"data/actor/mamizou/atkHighFront0002.bmp",
  L"data/actor/mamizou/atkHighFront0003.bmp",
  L"data/actor/mamizou/atkHighFront0004.bmp",
  L"data/actor/mamizou/atkHighFront0005.bmp",
  L"data/actor/mamizou/atkHighFront0006.bmp",
  L"data/actor/mamizou/atkHighFront0007.bmp",
  L"data/actor/mamizou/atkHighFront0008.bmp",
  L"data/actor/mamizou/atkHighFront0009.bmp",
  L"data/actor/mamizou/atkHighFront0010.bmp",
  L"data/actor/mamizou/atkHighFront0011.bmp",
  L"data/actor/mamizou/atkHighFront0012.bmp",
  L"data/actor/mamizou/atkHighFront0013.bmp",
  L"data/actor/mamizou/atkHighFront0014.bmp",
  L"data/actor/mamizou/atkHighFront0015.bmp",
  L"data/actor/mamizou/atkHighUnder0001.bmp",
  L"data/actor/mamizou/atkHighUnder0002.bmp",
  L"data/actor/mamizou/atkHighUnder0003.bmp",
  L"data/actor/mamizou/atkHighUnder0004.bmp",
  L"data/actor/mamizou/atkHighUnder0005.bmp",
  L"data/actor/mamizou/atkHighUnder0006.bmp",
  L"data/actor/mamizou/atkHighUnder0007.bmp",
  L"data/actor/mamizou/atkHighUnder0008.bmp",
  L"data/actor/mamizou/atkHighUnder0009.bmp",
  L"data/actor/mamizou/atkHighUnder0010.bmp",
  L"data/actor/mamizou/atkHighUnder0011.bmp",
  L"data/actor/mamizou/atkHighUpper0000.bmp",
  L"data/actor/mamizou/atkHighUpper0001.bmp",
  L"data/actor/mamizou/atkHighUpper0002.bmp",
  L"data/actor/mamizou/atkHighUpper0003.bmp",
  L"data/actor/mamizou/atkHighUpper0004.bmp",
  L"data/actor/mamizou/atkHighUpper0005.bmp",
  L"data/actor/mamizou/atkHighUpper0006.bmp",
  L"data/actor/mamizou/atkHighUpper0007.bmp",
  L"data/actor/mamizou/atkHighUpper0008.bmp",
  L"data/actor/mamizou/atkHighUpper0009.bmp",
  L"data/actor/mamizou/atkHighUpper0010.bmp",
  L"data/actor/mamizou/atkLow0000.bmp",
  L"data/actor/mamizou/atkLow0001.bmp",
  L"data/actor/mamizou/atkLow0002.bmp",
  L"data/actor/mamizou/atkLow0003.bmp",
  L"data/actor/mamizou/atkLow0004.bmp",
  L"data/actor/mamizou/atkLow0005.bmp",
  L"data/actor/mamizou/atkLow0006.bmp",
  L"data/actor/mamizou/atkLow0007.bmp",
  L"data/actor/mamizou/atkLow0008.bmp",
  L"data/actor/mamizou/atkLow0009.bmp",
  L"data/actor/mamizou/atkLow0010.bmp",
  L"data/actor/mamizou/atkLow0011.bmp",
  L"data/actor/mamizou/atkLow0012.bmp",
  L"data/actor/mamizou/atk_Mid0000.bmp",
  L"data/actor/mamizou/atk_Mid0001.bmp",
  L"data/actor/mamizou/atk_Mid0002.bmp",
  L"data/actor/mamizou/atk_Mid0003.bmp",
  L"data/actor/mamizou/atk_Mid0004.bmp",
  L"data/actor/mamizou/atk_Mid0005.bmp",
  L"data/actor/mamizou/atk_Mid0006.bmp",
  L"data/actor/mamizou/atk_Mid0007.bmp",
  L"data/actor/mamizou/atk_Mid0008.bmp",
  L"data/actor/mamizou/battleBeginA0000.bmp",
  L"data/actor/mamizou/battleBeginA0001.bmp",
  L"data/actor/mamizou/battleBeginA0002.bmp",
  L"data/actor/mamizou/battleBeginA0003.bmp",
  L"data/actor/mamizou/battleBeginA0004.bmp",
  L"data/actor/mamizou/battleBeginA0005.bmp",
  L"data/actor/mamizou/battleBeginA0006.bmp",
  L"data/actor/mamizou/battleBeginA0007.bmp",
  L"data/actor/mamizou/battleBeginA0008.bmp",
  L"data/actor/mamizou/battleBeginB0000.bmp",
  L"data/actor/mamizou/battleBeginB0001.bmp",
  L"data/actor/mamizou/battleBeginB0002.bmp",
  L"data/actor/mamizou/battleBeginB0003.bmp",
  L"data/actor/mamizou/battleBeginB0004.bmp",
  L"data/actor/mamizou/battleBeginB0005.bmp",
  L"data/actor/mamizou/battleBeginB0006.bmp",
  L"data/actor/mamizou/battleBeginB0007.bmp",
  L"data/actor/mamizou/battleBeginB0008.bmp",
  L"data/actor/mamizou/battleBeginB0009.bmp",
  L"data/actor/mamizou/battleBeginB0010.bmp",
  L"data/actor/mamizou/battleBeginB0011.bmp",
  L"data/actor/mamizou/battleBeginB0012.bmp",
  L"data/actor/mamizou/bmsln/mamizou_ClimaxSmoke.bmb",
  L"data/actor/mamizou/bmsln/mamizou_fireWork.bmb",
  L"data/actor/mamizou/bmsln/mamizou_steam.bmb",
  L"data/actor/mamizou/climax0000.bmp",
  L"data/actor/mamizou/climax0001.bmp",
  L"data/actor/mamizou/climax0002.bmp",
  L"data/actor/mamizou/climax0003.bmp",
  L"data/actor/mamizou/climax0004.bmp",
  L"data/actor/mamizou/climax0005.bmp",
  L"data/actor/mamizou/climax0006.bmp",
  L"data/actor/mamizou/damageBody0000.bmp",
  L"data/actor/mamizou/damageBody0001.bmp",
  L"data/actor/mamizou/damageBody0002.bmp",
  L"data/actor/mamizou/damageBody0003.bmp",
  L"data/actor/mamizou/damageBody0004.bmp",
  L"data/actor/mamizou/damageHead0000.bmp",
  L"data/actor/mamizou/damageHead0001.bmp",
  L"data/actor/mamizou/damageHead0002.bmp",
  L"data/actor/mamizou/damageHead0003.bmp",
  L"data/actor/mamizou/damageHead0004.bmp",
  L"data/actor/mamizou/damageSpin0000.bmp",
  L"data/actor/mamizou/damageSpin0001.bmp",
  L"data/actor/mamizou/damageSpin0002.bmp",
  L"data/actor/mamizou/damageSpin0003.bmp",
  L"data/actor/mamizou/damageUpper0000.bmp",
  L"data/actor/mamizou/damageUpper0001.bmp",
  L"data/actor/mamizou/damageUpper0002.bmp",
  L"data/actor/mamizou/damageUpper0003.bmp",
  L"data/actor/mamizou/damageUpper0004.bmp",
  L"data/actor/mamizou/damageUpper0005.bmp",
  L"data/actor/mamizou/damageUpper0006.bmp",
  L"data/actor/mamizou/damageUpper0007.bmp",
  L"data/actor/mamizou/damageUpper0008.bmp",
  L"data/actor/mamizou/damageUpper0009.bmp",
  L"data/actor/mamizou/damageUpper0010.bmp",
  L"data/actor/mamizou/damageUpper0011.bmp",
  L"data/actor/mamizou/damageUpper0012.bmp",
  L"data/actor/mamizou/damageUpper0013.bmp",
  L"data/actor/mamizou/damageUpper0014.bmp",
  L"data/actor/mamizou/damageUpper0015.bmp",
  L"data/actor/mamizou/damageWall0000.bmp",
  L"data/actor/mamizou/damageWall0001.bmp",
  L"data/actor/mamizou/damageWall0002.bmp",
  L"data/actor/mamizou/damageWall0003.bmp",
  L"data/actor/mamizou/damageWall0004.bmp",
  L"data/actor/mamizou/damageWall0005.bmp",
  L"data/actor/mamizou/damageWall0006.bmp",
  L"data/actor/mamizou/damageWall0007.bmp",
  L"data/actor/mamizou/dashBack0000.bmp",
  L"data/actor/mamizou/dashBack0001.bmp",
  L"data/actor/mamizou/dashBack0002.bmp",
  L"data/actor/mamizou/dashBack0003.bmp",
  L"data/actor/mamizou/dashBack0004.bmp",
  L"data/actor/mamizou/dashBack0005.bmp",
  L"data/actor/mamizou/dashBack0006.bmp",
  L"data/actor/mamizou/dashBack0007.bmp",
  L"data/actor/mamizou/dashBack0008.bmp",
  L"data/actor/mamizou/dashBack0009.bmp",
  L"data/actor/mamizou/dashBack0010.bmp",
  L"data/actor/mamizou/dashBack0011.bmp",
  L"data/actor/mamizou/dashBack0012.bmp",
  L"data/actor/mamizou/dashFront0000.bmp",
  L"data/actor/mamizou/dashFront0001.bmp",
  L"data/actor/mamizou/dashFront0002.bmp",
  L"data/actor/mamizou/dashFront0003.bmp",
  L"data/actor/mamizou/dashFront0004.bmp",
  L"data/actor/mamizou/dashFront0005.bmp",
  L"data/actor/mamizou/dashFront0006.bmp",
  L"data/actor/mamizou/dashFront0007.bmp",
  L"data/actor/mamizou/dashFront0008.bmp",
  L"data/actor/mamizou/dashFront0009.bmp",
  L"data/actor/mamizou/dashFront0010.bmp",
  L"data/actor/mamizou/dashFront0011.bmp",
  L"data/actor/mamizou/dashFront0012.bmp",
  L"data/actor/mamizou/face_spellCallB.png",
  L"data/actor/mamizou/face_spellCallB_r.png",
  L"data/actor/mamizou/guard0000.bmp",
  L"data/actor/mamizou/guardCrash0000.bmp",
  L"data/actor/mamizou/guardCrash0001.bmp",
  L"data/actor/mamizou/guardCrash0002.bmp",
  L"data/actor/mamizou/guardCrash0003.bmp",
  L"data/actor/mamizou/guardCrash0004.bmp",
  L"data/actor/mamizou/guardCrash0005.bmp",
  L"data/actor/mamizou/guardMiss0000.bmp",
  L"data/actor/mamizou/guardMiss0001.bmp",
  L"data/actor/mamizou/guardMiss0002.bmp",
  L"data/actor/mamizou/guardMiss0003.bmp",
  L"data/actor/mamizou/item0000.bmp",
  L"data/actor/mamizou/item0001.bmp",
  L"data/actor/mamizou/item0002.bmp",
  L"data/actor/mamizou/item0003.bmp",
  L"data/actor/mamizou/item0004.bmp",
  L"data/actor/mamizou/item0005.bmp",
  L"data/actor/mamizou/item0006.bmp",
  L"data/actor/mamizou/item0007.bmp",
  L"data/actor/mamizou/lose0000.bmp",
  L"data/actor/mamizou/lose0001.bmp",
  L"data/actor/mamizou/lose0002.bmp",
  L"data/actor/mamizou/lose0003.bmp",
  L"data/actor/mamizou/lose0004.bmp",
  L"data/actor/mamizou/lose0005.bmp",
  L"data/actor/mamizou/lose0006.bmp",
  L"data/actor/mamizou/mamizou.pat",
  L"data/actor/mamizou/mamizou_ed.pat",
  L"data/actor/mamizou/occult0000.bmp",
  L"data/actor/mamizou/occult0001.bmp",
  L"data/actor/mamizou/occult0002.bmp",
  L"data/actor/mamizou/occult0003.bmp",
  L"data/actor/mamizou/occult0004.bmp",
  L"data/actor/mamizou/occult_alian0000.bmp",
  L"data/actor/mamizou/occult_alian0001.bmp",
  L"data/actor/mamizou/occult_alian0002.bmp",
  L"data/actor/mamizou/occult_alian0003.bmp",
  L"data/actor/mamizou/palette000.bmp",
  L"data/actor/mamizou/palette001.bmp",
  L"data/actor/mamizou/palette002.bmp",
  L"data/actor/mamizou/palette003.bmp",
  L"data/actor/mamizou/palette004.bmp",
  L"data/actor/mamizou/palette005.bmp",
  L"data/actor/mamizou/palette006.bmp",
  L"data/actor/mamizou/palette007.bmp",
  L"data/actor/mamizou/shotHighA0000.bmp",
  L"data/actor/mamizou/shotHighA0001.bmp",
  L"data/actor/mamizou/shotHighA0002.bmp",
  L"data/actor/mamizou/shotHighA0003.bmp",
  L"data/actor/mamizou/shotHighA0004.bmp",
  L"data/actor/mamizou/shotHighA0005.bmp",
  L"data/actor/mamizou/shotHighA0006.bmp",
  L"data/actor/mamizou/shotHighA0007.bmp",
  L"data/actor/mamizou/shotHighA0008.bmp",
  L"data/actor/mamizou/shotHighA0009.bmp",
  L"data/actor/mamizou/shotHighA0010.bmp",
  L"data/actor/mamizou/shotLow0000.bmp",
  L"data/actor/mamizou/shotLow0001.bmp",
  L"data/actor/mamizou/shotLow0002.bmp",
  L"data/actor/mamizou/shotLow0003.bmp",
  L"data/actor/mamizou/shotLow0004.bmp",
  L"data/actor/mamizou/shotLow0005.bmp",
  L"data/actor/mamizou/shotLow0006.bmp",
  L"data/actor/mamizou/shotLow0007.bmp",
  L"data/actor/mamizou/shotLow0008.bmp",
  L"data/actor/mamizou/shotLow0009.bmp",
  L"data/actor/mamizou/shotLow0010.bmp",
  L"data/actor/mamizou/shotLow0011.bmp",
  L"data/actor/mamizou/shotLow0012.bmp",
  L"data/actor/mamizou/shotLow0013.bmp",
  L"data/actor/mamizou/skillA0000.bmp",
  L"data/actor/mamizou/skillA0001.bmp",
  L"data/actor/mamizou/skillA0002.bmp",
  L"data/actor/mamizou/skillA0003.bmp",
  L"data/actor/mamizou/skillA0004.bmp",
  L"data/actor/mamizou/skillA0005.bmp",
  L"data/actor/mamizou/skillA0006.bmp",
  L"data/actor/mamizou/skillA0007.bmp",
  L"data/actor/mamizou/skillA0008.bmp",
  L"data/actor/mamizou/skillA0009.bmp",
  L"data/actor/mamizou/skillA0010.bmp",
  L"data/actor/mamizou/skillA_Under0000.bmp",
  L"data/actor/mamizou/skillA_Under0001.bmp",
  L"data/actor/mamizou/skillA_Under0002.bmp",
  L"data/actor/mamizou/skillA_Under0003.bmp",
  L"data/actor/mamizou/skillA_Under0004.bmp",
  L"data/actor/mamizou/skillA_Under0005.bmp",
  L"data/actor/mamizou/skillA_Upper0000.bmp",
  L"data/actor/mamizou/skillA_Upper0001.bmp",
  L"data/actor/mamizou/skillA_Upper0002.bmp",
  L"data/actor/mamizou/skillA_Upper0003.bmp",
  L"data/actor/mamizou/skillA_Upper0004.bmp",
  L"data/actor/mamizou/skillB0000.bmp",
  L"data/actor/mamizou/skillB0001.bmp",
  L"data/actor/mamizou/skillB0002.bmp",
  L"data/actor/mamizou/skillB0003.bmp",
  L"data/actor/mamizou/skillB0004.bmp",
  L"data/actor/mamizou/skillB0005.bmp",
  L"data/actor/mamizou/skillB0006.bmp",
  L"data/actor/mamizou/skillB0007.bmp",
  L"data/actor/mamizou/skillB0008.bmp",
  L"data/actor/mamizou/skillB0009.bmp",
  L"data/actor/mamizou/skillB0010.bmp",
  L"data/actor/mamizou/skillB0011.bmp",
  L"data/actor/mamizou/skillB0012.bmp",
  L"data/actor/mamizou/skillB0013.bmp",
  L"data/actor/mamizou/skillB0014.bmp",
  L"data/actor/mamizou/skillC0000.bmp",
  L"data/actor/mamizou/skillC0001.bmp",
  L"data/actor/mamizou/skillC0002.bmp",
  L"data/actor/mamizou/skillC0003.bmp",
  L"data/actor/mamizou/skillC0004.bmp",
  L"data/actor/mamizou/skillC0005.bmp",
  L"data/actor/mamizou/skillC0006.bmp",
  L"data/actor/mamizou/skillC0007.bmp",
  L"data/actor/mamizou/skillC0008.bmp",
  L"data/actor/mamizou/skillC0009.bmp",
  L"data/actor/mamizou/slideUpper0000.bmp",
  L"data/actor/mamizou/slideUpper0001.bmp",
  L"data/actor/mamizou/slideUpper0002.bmp",
  L"data/actor/mamizou/slideUpper0003.bmp",
  L"data/actor/mamizou/slideUpper0004.bmp",
  L"data/actor/mamizou/slideUpper0005.bmp",
  L"data/actor/mamizou/slideUpper0006.bmp",
  L"data/actor/mamizou/slideUpper0007.bmp",
  L"data/actor/mamizou/slideUpper0008.bmp",
  L"data/actor/mamizou/slideUpper0009.bmp",
  L"data/actor/mamizou/slideUpper0010.bmp",
  L"data/actor/mamizou/slideUpper0011.bmp",
  L"data/actor/mamizou/slideUpper0012.bmp",
  L"data/actor/mamizou/slideUpper0013.bmp",
  L"data/actor/mamizou/slideUpper0014.bmp",
  L"data/actor/mamizou/slideUpper0015.bmp",
  L"data/actor/mamizou/slideUpper0016.bmp",
  L"data/actor/mamizou/slideUpper0017.bmp",
  L"data/actor/mamizou/spellA0000.bmp",
  L"data/actor/mamizou/spellA0001.bmp",
  L"data/actor/mamizou/spellA0002.bmp",
  L"data/actor/mamizou/spellA0003.bmp",
  L"data/actor/mamizou/spellA0004.bmp",
  L"data/actor/mamizou/spellA0005.bmp",
  L"data/actor/mamizou/spellA0006.bmp",
  L"data/actor/mamizou/spellA0007.bmp",
  L"data/actor/mamizou/spellA0008.bmp",
  L"data/actor/mamizou/spellA0009.bmp",
  L"data/actor/mamizou/spellA0010.bmp",
  L"data/actor/mamizou/spellA0011.bmp",
  L"data/actor/mamizou/spellA0012.bmp",
  L"data/actor/mamizou/spellB0000.bmp",
  L"data/actor/mamizou/spellB0001.bmp",
  L"data/actor/mamizou/spellB0002.bmp",
  L"data/actor/mamizou/spellB0003.bmp",
  L"data/actor/mamizou/spellB0004.bmp",
  L"data/actor/mamizou/spellB0005.bmp",
  L"data/actor/mamizou/spellB0006.bmp",
  L"data/actor/mamizou/spellB0007.bmp",
  L"data/actor/mamizou/spellC0000.bmp",
  L"data/actor/mamizou/spellC0001.bmp",
  L"data/actor/mamizou/spellC0002.bmp",
  L"data/actor/mamizou/spellC0003.bmp",
  L"data/actor/mamizou/spellC_Loop0000.bmp",
  L"data/actor/mamizou/spellC_Loop0001.bmp",
  L"data/actor/mamizou/spellC_Loop0002.bmp",
  L"data/actor/mamizou/spellC_Loop0003.bmp",
  L"data/actor/mamizou/stand0000.bmp",
  L"data/actor/mamizou/stand0001.bmp",
  L"data/actor/mamizou/stand0002.bmp",
  L"data/actor/mamizou/stand0003.bmp",
  L"data/actor/mamizou/stand0004.bmp",
  L"data/actor/mamizou/stand0005.bmp",
  L"data/actor/mamizou/stand0006.bmp",
  L"data/actor/mamizou/stand0007.bmp",
  L"data/actor/mamizou/stand0008.bmp",
  L"data/actor/mamizou/stand0009.bmp",
  L"data/actor/mamizou/stand0010.bmp",
  L"data/actor/mamizou/stand0011.bmp",
  L"data/actor/mamizou/stand0012.bmp",
  L"data/actor/mamizou/stand0013.bmp",
  L"data/actor/mamizou/stand0014.bmp",
  L"data/actor/mamizou/stand0015.bmp",
  L"data/actor/mamizou/stand0016.bmp",
  L"data/actor/mamizou/stand0017.bmp",
  L"data/actor/mamizou/stand0018.bmp",
  L"data/actor/mamizou/stand0019.bmp",
  L"data/actor/mamizou/stun0000.bmp",
  L"data/actor/mamizou/stun0001.bmp",
  L"data/actor/mamizou/stun0002.bmp",
  L"data/actor/mamizou/stun0003.bmp",
  L"data/actor/mamizou/stun0004.bmp",
  L"data/actor/mamizou/stun0005.bmp",
  L"data/actor/mamizou/stun0006.bmp",
  L"data/actor/mamizou/stun0007.bmp",
  L"data/actor/mamizou/texture/andonB_00.png",
  L"data/actor/mamizou/texture/andonB_01.png",
  L"data/actor/mamizou/texture/andonB_02.png",
  L"data/actor/mamizou/texture/andonB_03.png",
  L"data/actor/mamizou/texture/andonB_04.png",
  L"data/actor/mamizou/texture/andonB_05.png",
  L"data/actor/mamizou/texture/andonB_06.png",
  L"data/actor/mamizou/texture/andonB_07.png",
  L"data/actor/mamizou/texture/andon_00.png",
  L"data/actor/mamizou/texture/andon_01.png",
  L"data/actor/mamizou/texture/andon_02.png",
  L"data/actor/mamizou/texture/andon_03.png",
  L"data/actor/mamizou/texture/andon_04.png",
  L"data/actor/mamizou/texture/andon_05.png",
  L"data/actor/mamizou/texture/andon_06.png",
  L"data/actor/mamizou/texture/andon_07.png",
  L"data/actor/mamizou/texture/ball.png",
  L"data/actor/mamizou/texture/bomb.dds",
  L"data/actor/mamizou/texture/chagama00.png",
  L"data/actor/mamizou/texture/chagama01.png",
  L"data/actor/mamizou/texture/chouzyuuA.png",
  L"data/actor/mamizou/texture/chouzyuuB.png",
  L"data/actor/mamizou/texture/climaxBack.dds",
  L"data/actor/mamizou/texture/climaxcut0000.dds",
  L"data/actor/mamizou/texture/climaxItem.png",
  L"data/actor/mamizou/texture/climax_light0000.png",
  L"data/actor/mamizou/texture/fireA0000.png",
  L"data/actor/mamizou/texture/fireWorkA0000.dds",
  L"data/actor/mamizou/texture/karakasa_00.png",
  L"data/actor/mamizou/texture/karakasa_01.png",
  L"data/actor/mamizou/texture/karakasa_02.png",
  L"data/actor/mamizou/texture/kasa_D_00.png",
  L"data/actor/mamizou/texture/kasa_D_01.png",
  L"data/actor/mamizou/texture/kasa_D_02.png",
  L"data/actor/mamizou/texture/kasa_D_03.png",
  L"data/actor/mamizou/texture/kasa_K_00.png",
  L"data/actor/mamizou/texture/kasa_K_01.png",
  L"data/actor/mamizou/texture/kasa_K_02.png",
  L"data/actor/mamizou/texture/kasa_K_03.png",
  L"data/actor/mamizou/texture/kasa_K_04.png",
  L"data/actor/mamizou/texture/kasa_K_05.png",
  L"data/actor/mamizou/texture/kasa_K_06.png",
  L"data/actor/mamizou/texture/kasa_K_07.png",
  L"data/actor/mamizou/texture/kasa_K_08.png",
  L"data/actor/mamizou/texture/kasa_K_09.png",
  L"data/actor/mamizou/texture/kasa_K_10.png",
  L"data/actor/mamizou/texture/kona_A.png",
  L"data/actor/mamizou/texture/mamizou_animalDamage000.png",
  L"data/actor/mamizou/texture/mamizou_animalDamage001.png",
  L"data/actor/mamizou/texture/mamizou_animalDamage002.png",
  L"data/actor/mamizou/texture/mamizou_animalDamage003.png",
  L"data/actor/mamizou/texture/mamizou_animal_00000.png",
  L"data/actor/mamizou/texture/mamizou_animal_00001.png",
  L"data/actor/mamizou/texture/mamizou_animal_00002.png",
  L"data/actor/mamizou/texture/mamizou_animal_00003.png",
  L"data/actor/mamizou/texture/mamizou_animal_00004.png",
  L"data/actor/mamizou/texture/mamizou_animal_00005.png",
  L"data/actor/mamizou/texture/mamizou_animal_00006.png",
  L"data/actor/mamizou/texture/mamizou_animal_00007.png",
  L"data/actor/mamizou/texture/mamizou_animal_00008.png",
  L"data/actor/mamizou/texture/mamizou_animal_00009.png",
  L"data/actor/mamizou/texture/mamizou_animal_00010.png",
  L"data/actor/mamizou/texture/mamizou_animal_00011.png",
  L"data/actor/mamizou/texture/mamizou_beam0000.png",
  L"data/actor/mamizou/texture/mamizou_charge.png",
  L"data/actor/mamizou/texture/mamizou_leaf1.png",
  L"data/actor/mamizou/texture/mamizou_leaf2.png",
  L"data/actor/mamizou/texture/mamizou_leaf3.png",
  L"data/actor/mamizou/texture/mamizou_leaf4.png",
  L"data/actor/mamizou/texture/mamizou_leaf_black.png",
  L"data/actor/mamizou/texture/mamizou_leaf_gray.png",
  L"data/actor/mamizou/texture/mamizou_leaf_red.png",
  L"data/actor/mamizou/texture/marisa_sparkLine.png",
  L"data/actor/mamizou/texture/mask_ball.png",
  L"data/actor/mamizou/texture/monsterA0000.png",
  L"data/actor/mamizou/texture/monsterA0001.png",
  L"data/actor/mamizou/texture/monsterB0000.png",
  L"data/actor/mamizou/texture/monsterB0001.png",
  L"data/actor/mamizou/texture/monsterC0000.png",
  L"data/actor/mamizou/texture/monsterC0001.png",
  L"data/actor/mamizou/texture/monsterD0000.png",
  L"data/actor/mamizou/texture/monsterD0001.png",
  L"data/actor/mamizou/texture/monsterE0000.png",
  L"data/actor/mamizou/texture/monsterE0001.png",
  L"data/actor/mamizou/texture/monsterF0000.png",
  L"data/actor/mamizou/texture/monsterF0001.png",
  L"data/actor/mamizou/texture/monsterG0000.png",
  L"data/actor/mamizou/texture/monsterG0001.png",
  L"data/actor/mamizou/texture/monsterH0000.png",
  L"data/actor/mamizou/texture/monsterH0001.png",
  L"data/actor/mamizou/texture/monsterI0000.png",
  L"data/actor/mamizou/texture/monsterI0001.png",
  L"data/actor/mamizou/texture/monsterJ0000.png",
  L"data/actor/mamizou/texture/monsterJ0001.png",
  L"data/actor/mamizou/texture/monsterK0000.png",
  L"data/actor/mamizou/texture/monsterK0001.png",
  L"data/actor/mamizou/texture/monsterL0000.png",
  L"data/actor/mamizou/texture/monsterL0001.png",
  L"data/actor/mamizou/texture/monsterM0000.png",
  L"data/actor/mamizou/texture/monsterM0001.png",
  L"data/actor/mamizou/texture/monsterN0000.png",
  L"data/actor/mamizou/texture/monsterN0001.png",
  L"data/actor/mamizou/texture/monsterO0000.png",
  L"data/actor/mamizou/texture/monsterO0001.png",
  L"data/actor/mamizou/texture/monsterP0000.png",
  L"data/actor/mamizou/texture/monsterP0001.png",
  L"data/actor/mamizou/texture/monsterQ0000.png",
  L"data/actor/mamizou/texture/monsterQ0001.png",
  L"data/actor/mamizou/texture/monsterR0000.png",
  L"data/actor/mamizou/texture/monsterR0001.png",
  L"data/actor/mamizou/texture/nameCall.png",
  L"data/actor/mamizou/texture/nurikabe00.png",
  L"data/actor/mamizou/texture/nurikabe01.png",
  L"data/actor/mamizou/texture/nurikabe02.png",
  L"data/actor/mamizou/texture/occult_cap0000.dds",
  L"data/actor/mamizou/texture/occult_ufo0000.dds",
  L"data/actor/mamizou/texture/sippo_00.png",
  L"data/actor/mamizou/texture/sippo_01.png",
  L"data/actor/mamizou/texture/sippo_02.png",
  L"data/actor/mamizou/texture/sippo_03.png",
  L"data/actor/mamizou/texture/sippo_04.png",
  L"data/actor/mamizou/texture/sippo_05.png",
  L"data/actor/mamizou/texture/sippo_06.png",
  L"data/actor/mamizou/texture/sippo_07.png",
  L"data/actor/mamizou/texture/smoke.png",
  L"data/actor/mamizou/texture/smokeB.png",
  L"data/actor/mamizou/texture/speedLineA0000.dds",
  L"data/actor/mamizou/texture/steamA0000.png",
  L"data/actor/mamizou/texture/steamB0000.png",
  L"data/actor/mamizou/texture/swingA0000.png",
  L"data/actor/mamizou/texture/tanukiA.png",
  L"data/actor/mamizou/texture/tanukiB.png",
  L"data/actor/mamizou/texture/tanukiC.png",
  L"data/actor/mamizou/texture/tanukiD.png",
  L"data/actor/mamizou/texture/tanukiE.png",
  L"data/actor/mamizou/texture/torii.png",
  L"data/actor/mamizou/texture/turube01.png",
  L"data/actor/mamizou/texture/ufobeam0000.png",
  L"data/actor/mamizou/turn0000.bmp",
  L"data/actor/mamizou/turn0001.bmp",
  L"data/actor/mamizou/turn0002.bmp",
  L"data/actor/mamizou/walkBack0000.bmp",
  L"data/actor/mamizou/walkBack0001.bmp",
  L"data/actor/mamizou/walkBack0002.bmp",
  L"data/actor/mamizou/walkBack0003.bmp",
  L"data/actor/mamizou/walkBack0004.bmp",
  L"data/actor/mamizou/walkBackLoop0000.bmp",
  L"data/actor/mamizou/walkBackLoop0001.bmp",
  L"data/actor/mamizou/walkBackLoop0002.bmp",
  L"data/actor/mamizou/walkBackLoop0003.bmp",
  L"data/actor/mamizou/walkBackLoop0004.bmp",
  L"data/actor/mamizou/walkBackLoop0005.bmp",
  L"data/actor/mamizou/walkFront0000.bmp",
  L"data/actor/mamizou/walkFront0001.bmp",
  L"data/actor/mamizou/walkFront0002.bmp",
  L"data/actor/mamizou/walkFront0003.bmp",
  L"data/actor/mamizou/walkFront0004.bmp",
  L"data/actor/mamizou/walkFront0005.bmp",
  L"data/actor/mamizou/walkFront0006.bmp",
  L"data/actor/mamizou/walkFrontLoop0000.bmp",
  L"data/actor/mamizou/walkFrontLoop0001.bmp",
  L"data/actor/mamizou/walkFrontLoop0002.bmp",
  L"data/actor/mamizou/walkFrontLoop0003.bmp",
  L"data/actor/mamizou/walkFrontLoop0004.bmp",
  L"data/actor/mamizou/walkFrontLoop0005.bmp",
  L"data/actor/mamizou/winA0000.bmp",
  L"data/actor/mamizou/winA0001.bmp",
  L"data/actor/mamizou/winA0002.bmp",
  L"data/actor/mamizou/winA0003.bmp",
  L"data/actor/mamizou/winA0004.bmp",
  L"data/actor/mamizou/winA0005.bmp",
  L"data/actor/mamizou/winA0006.bmp",
  L"data/actor/mamizou/winA0007.bmp",
  L"data/actor/mamizou/winA0008.bmp",
  L"data/actor/mamizou/winA0009.bmp",
  L"data/actor/mamizou/winA0010.bmp",
  L"data/actor/mamizou/winA0011.bmp",
  L"data/actor/mamizou/winA0012.bmp",
  L"data/actor/mamizou/winB0000.bmp",
  L"data/actor/mamizou/winB0001.bmp",
  L"data/actor/mamizou/winB0002.bmp",
  L"data/actor/mamizou/winB0003.bmp",
  L"data/actor/mamizou/winB0004.bmp",
  L"data/actor/mamizou/winB0005.bmp",
  L"data/actor/mamizou/winB0006.bmp",
  L"data/actor/mamizou/winB0007.bmp",
  L"data/actor/mamizou/winB0008.bmp",
  L"data/actor/mamizou/winB0009.bmp",
  L"data/actor/mamizou/winB0010.bmp",
  L"data/actor/mamizou/winB0011.bmp",
  L"data/actor/mamizou/winB0012.bmp",
  L"data/actor/mamizou/winB0013.bmp",
  L"data/actor/mamizou/winB0014.bmp",
  L"data/actor/mamizou/winB0015.bmp",
  L"data/actor/mamizou/winB0016.bmp",
  L"data/actor/mamizou/winB0017.bmp",
  L"data/actor/mamizou/winB0018.bmp",
  L"data/actor/mamizou/winB0019.bmp",
  L"data/actor/mamizou/winB0020.bmp",
  L"data/actor/mamizou/winB0021.bmp",
  L"data/actor/mamizou/winB0022.bmp",
  L"data/actor/mamizou/winB0023.bmp",
  L"data/actor/mamizou/winB0024.bmp",
  L"data/actor/mamizou/winB0025.bmp",
  L"data/actor/mamizou.nut",
  L"data/actor/mamizouInit.nut",
  L"data/actor/mamizou_base.nut",
  L"data/actor/mamizou_boss.nut",
  L"data/actor/mamizou_cpu.nut",
  L"data/actor/mamizou_cpuBoss.nut",
  L"data/actor/mamizou_shot.nut",
  L"data/actor/marisa/atkHigh0000.bmp",
  L"data/actor/marisa/atkHigh0001.bmp",
  L"data/actor/marisa/atkHigh0002.bmp",
  L"data/actor/marisa/atkHigh0003.bmp",
  L"data/actor/marisa/atkHigh0004.bmp",
  L"data/actor/marisa/atkHigh0005.bmp",
  L"data/actor/marisa/atkHigh0006.bmp",
  L"data/actor/marisa/atkHigh0007.bmp",
  L"data/actor/marisa/atkHighFront0000.bmp",
  L"data/actor/marisa/atkHighFront0001.bmp",
  L"data/actor/marisa/atkHighFront0002.bmp",
  L"data/actor/marisa/atkHighFront0003.bmp",
  L"data/actor/marisa/atkHighFront0004.bmp",
  L"data/actor/marisa/atkHighFront0005.bmp",
  L"data/actor/marisa/atkHighFront0006.bmp",
  L"data/actor/marisa/atkHighUpper_blade0000.png",
  L"data/actor/marisa/atkHighUpper_blade0001.png",
  L"data/actor/marisa/atkHighUpper_blade0002.png",
  L"data/actor/marisa/atkHighUpper_blade0003.png",
  L"data/actor/marisa/atkHighUpper_blade0004.png",
  L"data/actor/marisa/atkHigh_Blade0000.png",
  L"data/actor/marisa/atkHigh_Blade0001.png",
  L"data/actor/marisa/atkHigh_Blade0002.png",
  L"data/actor/marisa/atkHigh_Blade0003.png",
  L"data/actor/marisa/atkHigh_Blade0004.png",
  L"data/actor/marisa/atkMid_Blade0000.png",
  L"data/actor/marisa/atkMid_Blade0001.png",
  L"data/actor/marisa/atkMid_Blade0002.png",
  L"data/actor/marisa/atkMid_Blade0003.png",
  L"data/actor/marisa/battleBeginA0000.bmp",
  L"data/actor/marisa/battleBeginA0001.bmp",
  L"data/actor/marisa/battleBeginA0002.bmp",
  L"data/actor/marisa/battleBeginA0003.bmp",
  L"data/actor/marisa/battleBeginA0004.bmp",
  L"data/actor/marisa/battleBeginA0005.bmp",
  L"data/actor/marisa/battleBeginA0006.bmp",
  L"data/actor/marisa/battleBeginA0007.bmp",
  L"data/actor/marisa/battleBeginA0008.bmp",
  L"data/actor/marisa/battleBeginA0009.bmp",
  L"data/actor/marisa/bloom0000.bmp",
  L"data/actor/marisa/bmsln/marisa_atkA.bmb",
  L"data/actor/marisa/bmsln/marisa_brazingStar.bmb",
  L"data/actor/marisa/bmsln/marisa_brazingStarB.bmb",
  L"data/actor/marisa/bmsln/marisa_enhance.bmb",
  L"data/actor/marisa/bmsln/marisa_layline.bmb",
  L"data/actor/marisa/bmsln/marisa_layline_End.bmb",
  L"data/actor/marisa/bmsln/marisa_magicM.bmb",
  L"data/actor/marisa/bmsln/marisa_magicM_Exp.bmb",
  L"data/actor/marisa/bmsln/marisa_masterSpark.bmb",
  L"data/actor/marisa/bmsln/marisa_potionExp.bmb",
  L"data/actor/marisa/bmsln/marisa_saturnA.bmb",
  L"data/actor/marisa/bmsln/marisa_saturnA_End.bmb",
  L"data/actor/marisa/bmsln/marisa_shotA.bmb",
  L"data/actor/marisa/bmsln/marisa_shotA_Fire.bmb",
  L"data/actor/marisa/bmsln/marisa_shotLowExp.bmb",
  L"data/actor/marisa/bmsln/marisa_starExpload.bmb",
  L"data/actor/marisa/bmsln/marisa_starFallExp.bmb",
  L"data/actor/marisa/bmsln/shotLow_A_main.bmb",
  L"data/actor/marisa/bmsln/_Vbg{.bmb",
  L"data/actor/marisa/bmsln/_Vbg.bmb",
  L"data/actor/marisa/climaxAssult0000.bmp",
  L"data/actor/marisa/climaxFirst0000.bmp",
  L"data/actor/marisa/climaxFirst0001.bmp",
  L"data/actor/marisa/climaxFirst0002.bmp",
  L"data/actor/marisa/climaxFirst0003.bmp",
  L"data/actor/marisa/climaxFirst0004.bmp",
  L"data/actor/marisa/climaxFirst0005.bmp",
  L"data/actor/marisa/climaxFirst0006.bmp",
  L"data/actor/marisa/climaxFirst0007.bmp",
  L"data/actor/marisa/climaxFirst0008.bmp",
  L"data/actor/marisa/climaxFirst0009.bmp",
  L"data/actor/marisa/climaxFirst0010.bmp",
  L"data/actor/marisa/climaxFirst0011.bmp",
  L"data/actor/marisa/climax_Arm0000.png",
  L"data/actor/marisa/climax_Arm0001.png",
  L"data/actor/marisa/climax_BackBase.png",
  L"data/actor/marisa/climax_BackDoor0000.png",
  L"data/actor/marisa/climax_BackDoor0001.png",
  L"data/actor/marisa/climax_CutFace.png",
  L"data/actor/marisa/climax_lineObject.png",
  L"data/actor/marisa/damageBody0000.bmp",
  L"data/actor/marisa/damageBody0001.bmp",
  L"data/actor/marisa/damageBody0002.bmp",
  L"data/actor/marisa/damageBody0003.bmp",
  L"data/actor/marisa/damageBody0004.bmp",
  L"data/actor/marisa/damageDownB0000.bmp",
  L"data/actor/marisa/damageDownB0001.bmp",
  L"data/actor/marisa/damageDownB0002.bmp",
  L"data/actor/marisa/damageDownB0003.bmp",
  L"data/actor/marisa/damageDownB0004.bmp",
  L"data/actor/marisa/damageDownB0005.bmp",
  L"data/actor/marisa/damageDownB0006.bmp",
  L"data/actor/marisa/damageDownB0007.bmp",
  L"data/actor/marisa/damageDownB0008.bmp",
  L"data/actor/marisa/damageDownB0009.bmp",
  L"data/actor/marisa/damageDownB0010.bmp",
  L"data/actor/marisa/damageDownB0011.bmp",
  L"data/actor/marisa/damageDownB0012.bmp",
  L"data/actor/marisa/damageDownB0013.bmp",
  L"data/actor/marisa/damageDownB0014.bmp",
  L"data/actor/marisa/damageDownB0015.bmp",
  L"data/actor/marisa/damageDownB0016.bmp",
  L"data/actor/marisa/damageDownB0017.bmp",
  L"data/actor/marisa/damageDownB0018.bmp",
  L"data/actor/marisa/damageHead0001.bmp",
  L"data/actor/marisa/damageHead0002.bmp",
  L"data/actor/marisa/damageHead0003.bmp",
  L"data/actor/marisa/damageHead0004.bmp",
  L"data/actor/marisa/damageHead0005.bmp",
  L"data/actor/marisa/damageSpin0000.bmp",
  L"data/actor/marisa/damageSpin0001.bmp",
  L"data/actor/marisa/damageSpin0002.bmp",
  L"data/actor/marisa/damageSpin0003.bmp",
  L"data/actor/marisa/damageWall0001.bmp",
  L"data/actor/marisa/damageWall0002.bmp",
  L"data/actor/marisa/damageWall0003.bmp",
  L"data/actor/marisa/damageWall0004.bmp",
  L"data/actor/marisa/damageWall0005.bmp",
  L"data/actor/marisa/dummy.bmp",
  L"data/actor/marisa/effect_atkDashHigh0000.png",
  L"data/actor/marisa/effect_atkDashHigh0001.png",
  L"data/actor/marisa/effect_atkDashHigh0002.png",
  L"data/actor/marisa/effect_atkDashHigh0003.png",
  L"data/actor/marisa/effect_atkHighUnder0000.png",
  L"data/actor/marisa/effect_atkHighUnder0001.png",
  L"data/actor/marisa/effect_atkHighUnder0002.png",
  L"data/actor/marisa/effect_atkHighUnder0003.png",
  L"data/actor/marisa/effect_atkHighUpper0000.png",
  L"data/actor/marisa/effect_atkHighUpper0001.png",
  L"data/actor/marisa/effect_atkHighUpper0002.png",
  L"data/actor/marisa/effect_climax0000.png",
  L"data/actor/marisa/effect_climax0001.png",
  L"data/actor/marisa/effect_climax0002.png",
  L"data/actor/marisa/effect_climaxB0000.png",
  L"data/actor/marisa/effect_shotHigh0000.png",
  L"data/actor/marisa/effect_shotHigh0001.png",
  L"data/actor/marisa/effect_shotHigh0002.png",
  L"data/actor/marisa/effect_shotHigh0003.png",
  L"data/actor/marisa/effect_shotHigh0004.png",
  L"data/actor/marisa/effect_shotHigh0005.png",
  L"data/actor/marisa/effect_shotHighB0000.bmp",
  L"data/actor/marisa/effect_shotHighB0001.bmp",
  L"data/actor/marisa/effect_shotHighB0002.bmp",
  L"data/actor/marisa/effect_shotHighB0003.bmp",
  L"data/actor/marisa/effect_shotHighB0004.bmp",
  L"data/actor/marisa/effect_shotHighB0005.bmp",
  L"data/actor/marisa/effect_skillA0000.bmp",
  L"data/actor/marisa/effect_skillA0001.bmp",
  L"data/actor/marisa/effect_skillA0002.bmp",
  L"data/actor/marisa/effect_skillD0000.bmp",
  L"data/actor/marisa/effect_skillD0001.bmp",
  L"data/actor/marisa/effect_skillD0002.bmp",
  L"data/actor/marisa/effect_skillD0003.bmp",
  L"data/actor/marisa/effect_skillD0004.bmp",
  L"data/actor/marisa/effect_skillD0005.bmp",
  L"data/actor/marisa/effect_skillD0006.bmp",
  L"data/actor/marisa/effect_skillDb0000.png",
  L"data/actor/marisa/effect_skillDb0001.png",
  L"data/actor/marisa/effect_skillDb0002.png",
  L"data/actor/marisa/effect_skillDb0003.png",
  L"data/actor/marisa/effect_skillDb0004.png",
  L"data/actor/marisa/effect_skillDb0005.png",
  L"data/actor/marisa/effect_skillE0000.png",
  L"data/actor/marisa/effect_skillE0001.png",
  L"data/actor/marisa/effect_skillE0002.png",
  L"data/actor/marisa/effect_skillE0003.png",
  L"data/actor/marisa/effect_spellB.png",
  L"data/actor/marisa/face_spellCall.png",
  L"data/actor/marisa/guard0000.bmp",
  L"data/actor/marisa/guard0001.bmp",
  L"data/actor/marisa/guard0002.bmp",
  L"data/actor/marisa/guard0003.bmp",
  L"data/actor/marisa/guard0004.bmp",
  L"data/actor/marisa/guard_miss0000.bmp",
  L"data/actor/marisa/guard_miss0001.bmp",
  L"data/actor/marisa/guard_miss0002.bmp",
  L"data/actor/marisa/guard_miss0003.bmp",
  L"data/actor/marisa/item0000.bmp",
  L"data/actor/marisa/item0001.bmp",
  L"data/actor/marisa/item0002.bmp",
  L"data/actor/marisa/item0003.bmp",
  L"data/actor/marisa/item0004.bmp",
  L"data/actor/marisa/item0005.bmp",
  L"data/actor/marisa/item0006.bmp",
  L"data/actor/marisa/item0007.bmp",
  L"data/actor/marisa/lose0000.bmp",
  L"data/actor/marisa/lose0001.bmp",
  L"data/actor/marisa/lose0002.bmp",
  L"data/actor/marisa/lose0003.bmp",
  L"data/actor/marisa/lose0004.bmp",
  L"data/actor/marisa/lose0005.bmp",
  L"data/actor/marisa/lose0006.bmp",
  L"data/actor/marisa/lose0007.bmp",
  L"data/actor/marisa/lose0008.bmp",
  L"data/actor/marisa/lose0009.bmp",
  L"data/actor/marisa/lose0010.bmp",
  L"data/actor/marisa/lose0011.bmp",
  L"data/actor/marisa/lose0012.bmp",
  L"data/actor/marisa/marisa.pat",
  L"data/actor/marisa/marisa_ed.pat",
  L"data/actor/marisa/model/marisa_starExpload.m3r",
  L"data/actor/marisa/model/marisa_starExpload_wave.png",
  L"data/actor/marisa/occult_dolla0000.bmp",
  L"data/actor/marisa/occult_dollb0011.bmp",
  L"data/actor/marisa/occult_dollb0012.bmp",
  L"data/actor/marisa/occult_dollb0013.bmp",
  L"data/actor/marisa/occult_dollb0014.bmp",
  L"data/actor/marisa/occult_dollb0015.bmp",
  L"data/actor/marisa/occult_dollb0016.bmp",
  L"data/actor/marisa/occult_dollb0017.bmp",
  L"data/actor/marisa/occult_dollb0018.bmp",
  L"data/actor/marisa/occult_dr0000.png",
  L"data/actor/marisa/occult_dr0001.png",
  L"data/actor/marisa/occult_dr0002.png",
  L"data/actor/marisa/occult_dr0003.png",
  L"data/actor/marisa/occult_dr0004.png",
  L"data/actor/marisa/occult_dr0005.png",
  L"data/actor/marisa/palette000.bmp",
  L"data/actor/marisa/palette001.bmp",
  L"data/actor/marisa/palette002.bmp",
  L"data/actor/marisa/palette003.bmp",
  L"data/actor/marisa/palette004.bmp",
  L"data/actor/marisa/palette005.bmp",
  L"data/actor/marisa/palette006.bmp",
  L"data/actor/marisa/palette007.bmp",
  L"data/actor/marisa/skillA_Loop0000.bmp",
  L"data/actor/marisa/skillA_Loop0001.bmp",
  L"data/actor/marisa/skillA_Loop0002.bmp",
  L"data/actor/marisa/skillE0000.bmp",
  L"data/actor/marisa/skillE0001.bmp",
  L"data/actor/marisa/skillE0002.bmp",
  L"data/actor/marisa/skillE0003.bmp",
  L"data/actor/marisa/skillE0004.bmp",
  L"data/actor/marisa/skillE0005.bmp",
  L"data/actor/marisa/skillE0006.bmp",
  L"data/actor/marisa/skillE0007.bmp",
  L"data/actor/marisa/skillE0008.bmp",
  L"data/actor/marisa/skillE0009.bmp",
  L"data/actor/marisa/skillE0010.bmp",
  L"data/actor/marisa/skillE0011.bmp",
  L"data/actor/marisa/skillE0012.bmp",
  L"data/actor/marisa/skillE0013.bmp",
  L"data/actor/marisa/skillE0014.bmp",
  L"data/actor/marisa/skillE0015.bmp",
  L"data/actor/marisa/skillE0016.bmp",
  L"data/actor/marisa/skillE_BladeA0000.png",
  L"data/actor/marisa/skillE_BladeB0000.png",
  L"data/actor/marisa/skillF0000.bmp",
  L"data/actor/marisa/skillF0001.bmp",
  L"data/actor/marisa/skillF0002.bmp",
  L"data/actor/marisa/skillF0003.bmp",
  L"data/actor/marisa/skillF0004.bmp",
  L"data/actor/marisa/skillF0005.bmp",
  L"data/actor/marisa/skillF0007.bmp",
  L"data/actor/marisa/skillF0008.bmp",
  L"data/actor/marisa/skillF0009.bmp",
  L"data/actor/marisa/skillF0010.bmp",
  L"data/actor/marisa/skillF0011.bmp",
  L"data/actor/marisa/skillF0012.bmp",
  L"data/actor/marisa/spellA0000.bmp",
  L"data/actor/marisa/spellA0001.bmp",
  L"data/actor/marisa/spellA0002.bmp",
  L"data/actor/marisa/spellA0003.bmp",
  L"data/actor/marisa/spellA0004.bmp",
  L"data/actor/marisa/spellA0005.bmp",
  L"data/actor/marisa/spellA0006.bmp",
  L"data/actor/marisa/spellA0007.bmp",
  L"data/actor/marisa/spellA0008.bmp",
  L"data/actor/marisa/spellA0009.bmp",
  L"data/actor/marisa/spellA0010.bmp",
  L"data/actor/marisa/spellA0011.bmp",
  L"data/actor/marisa/spellA0012.bmp",
  L"data/actor/marisa/spellA0013.bmp",
  L"data/actor/marisa/spellA0014.bmp",
  L"data/actor/marisa/spellA0015.bmp",
  L"data/actor/marisa/spellB0000.bmp",
  L"data/actor/marisa/stand0000.bmp",
  L"data/actor/marisa/stand0001.bmp",
  L"data/actor/marisa/stand0002.bmp",
  L"data/actor/marisa/stand0003.bmp",
  L"data/actor/marisa/stand0004.bmp",
  L"data/actor/marisa/stand0005.bmp",
  L"data/actor/marisa/stand0006.bmp",
  L"data/actor/marisa/stand0007.bmp",
  L"data/actor/marisa/stand0008.bmp",
  L"data/actor/marisa/stand0009.bmp",
  L"data/actor/marisa/stand0010.bmp",
  L"data/actor/marisa/stand0011.bmp",
  L"data/actor/marisa/stand0012.bmp",
  L"data/actor/marisa/stand0013.bmp",
  L"data/actor/marisa/stand0014.bmp",
  L"data/actor/marisa/stun0000.bmp",
  L"data/actor/marisa/stun0001.bmp",
  L"data/actor/marisa/stun0002.bmp",
  L"data/actor/marisa/stun0003.bmp",
  L"data/actor/marisa/stun0004.bmp",
  L"data/actor/marisa/stun0005.bmp",
  L"data/actor/marisa/test_atkHighDash0000.bmp",
  L"data/actor/marisa/test_atkHighDash0001.bmp",
  L"data/actor/marisa/test_atkHighDash0002.bmp",
  L"data/actor/marisa/test_atkHighDash0003.bmp",
  L"data/actor/marisa/test_atkHighDash0004.bmp",
  L"data/actor/marisa/test_atkHighDash0005.bmp",
  L"data/actor/marisa/test_atkHighDash0006.bmp",
  L"data/actor/marisa/test_atkHighDash0007.bmp",
  L"data/actor/marisa/test_atkHighDash0008.bmp",
  L"data/actor/marisa/test_atkHighDash0009.bmp",
  L"data/actor/marisa/test_atkHighDash0010.bmp",
  L"data/actor/marisa/test_atkHighDash0011.bmp",
  L"data/actor/marisa/test_atkHighDash0012.bmp",
  L"data/actor/marisa/test_atkHighDash0013.bmp",
  L"data/actor/marisa/test_atkHighUnder0000.bmp",
  L"data/actor/marisa/test_atkHighUnder0001.bmp",
  L"data/actor/marisa/test_atkHighUnder0002.bmp",
  L"data/actor/marisa/test_atkHighUnder0003.bmp",
  L"data/actor/marisa/test_atkHighUnder0004.bmp",
  L"data/actor/marisa/test_atkHighUnder0005.bmp",
  L"data/actor/marisa/test_atkHighUnder0006.bmp",
  L"data/actor/marisa/test_atkHighUnder0007.bmp",
  L"data/actor/marisa/test_atkHighUnder0008.bmp",
  L"data/actor/marisa/test_atkHighUnder0009.bmp",
  L"data/actor/marisa/test_atkHighUnder0010.bmp",
  L"data/actor/marisa/test_atkHighUpper0000.bmp",
  L"data/actor/marisa/test_atkHighUpper0001.bmp",
  L"data/actor/marisa/test_atkHighUpper0002.bmp",
  L"data/actor/marisa/test_atkHighUpper0003.bmp",
  L"data/actor/marisa/test_atkHighUpper0004.bmp",
  L"data/actor/marisa/test_atkHighUpper0005.bmp",
  L"data/actor/marisa/test_atkHighUpper0006.bmp",
  L"data/actor/marisa/test_atkHighUpper0007.bmp",
  L"data/actor/marisa/test_atkHighUpper0008.bmp",
  L"data/actor/marisa/test_atkHighUpper0009.bmp",
  L"data/actor/marisa/test_atkHighUpper0010.bmp",
  L"data/actor/marisa/test_atkLowA0000.bmp",
  L"data/actor/marisa/test_atkLowA0001.bmp",
  L"data/actor/marisa/test_atkLowA0002.bmp",
  L"data/actor/marisa/test_atkLowA0003.bmp",
  L"data/actor/marisa/test_atkLowA0004.bmp",
  L"data/actor/marisa/test_atkLowA0005.bmp",
  L"data/actor/marisa/test_atkLowA0006.bmp",
  L"data/actor/marisa/test_atkLowA0007.bmp",
  L"data/actor/marisa/test_atkMid0000.bmp",
  L"data/actor/marisa/test_atkMid0001.bmp",
  L"data/actor/marisa/test_atkMid0002.bmp",
  L"data/actor/marisa/test_atkMid0003.bmp",
  L"data/actor/marisa/test_atkMid0004.bmp",
  L"data/actor/marisa/test_atkMid0005.bmp",
  L"data/actor/marisa/test_atkMid0006.bmp",
  L"data/actor/marisa/test_atkMid0007.bmp",
  L"data/actor/marisa/test_atkMid0008.bmp",
  L"data/actor/marisa/test_atkMid0009.bmp",
  L"data/actor/marisa/test_atkMid0010.bmp",
  L"data/actor/marisa/test_battleBeginB0000.bmp",
  L"data/actor/marisa/test_battleBeginB0001.bmp",
  L"data/actor/marisa/test_battleBeginB0002.bmp",
  L"data/actor/marisa/test_battleBeginB0003.bmp",
  L"data/actor/marisa/test_battleBeginB0004.bmp",
  L"data/actor/marisa/test_battleBeginB0005.bmp",
  L"data/actor/marisa/test_battleBeginB0006.bmp",
  L"data/actor/marisa/test_battleBeginB0007.bmp",
  L"data/actor/marisa/test_battleBeginB0008.bmp",
  L"data/actor/marisa/test_battleBeginB0009.bmp",
  L"data/actor/marisa/test_dashBack0000.bmp",
  L"data/actor/marisa/test_dashBack0001.bmp",
  L"data/actor/marisa/test_dashBack0002.bmp",
  L"data/actor/marisa/test_dashBack0003.bmp",
  L"data/actor/marisa/test_dashBack0004.bmp",
  L"data/actor/marisa/test_dashBack0005.bmp",
  L"data/actor/marisa/test_dashBack0006.bmp",
  L"data/actor/marisa/test_dashBack0007.bmp",
  L"data/actor/marisa/test_dashBack0008.bmp",
  L"data/actor/marisa/test_dashBack0009.bmp",
  L"data/actor/marisa/test_dashBack0010.bmp",
  L"data/actor/marisa/test_dashBack0011.bmp",
  L"data/actor/marisa/test_dashBack0012.bmp",
  L"data/actor/marisa/test_dashFront0000.bmp",
  L"data/actor/marisa/test_dashFront0001.bmp",
  L"data/actor/marisa/test_dashFront0002.bmp",
  L"data/actor/marisa/test_dashFront0004.bmp",
  L"data/actor/marisa/test_dashFront0005.bmp",
  L"data/actor/marisa/test_dashFront0006.bmp",
  L"data/actor/marisa/test_dashFront0007.bmp",
  L"data/actor/marisa/test_dashFront0008.bmp",
  L"data/actor/marisa/test_dashFront0009.bmp",
  L"data/actor/marisa/test_dashFront0010.bmp",
  L"data/actor/marisa/test_dashFront0011.bmp",
  L"data/actor/marisa/test_dashFront0012.bmp",
  L"data/actor/marisa/test_dashFront0013.bmp",
  L"data/actor/marisa/test_effect.bmp",
  L"data/actor/marisa/test_guardCrash0000.bmp",
  L"data/actor/marisa/test_guardCrash0001.bmp",
  L"data/actor/marisa/test_guardCrash0002.bmp",
  L"data/actor/marisa/test_guardCrash0003.bmp",
  L"data/actor/marisa/test_guardCrash0004.bmp",
  L"data/actor/marisa/test_guardCrash0005.bmp",
  L"data/actor/marisa/test_guardCrash0006.bmp",
  L"data/actor/marisa/test_guardCrash0007.bmp",
  L"data/actor/marisa/test_move20000.bmp",
  L"data/actor/marisa/test_move20001.bmp",
  L"data/actor/marisa/test_move20002.bmp",
  L"data/actor/marisa/test_move20003.bmp",
  L"data/actor/marisa/test_move20004.bmp",
  L"data/actor/marisa/test_move20005.bmp",
  L"data/actor/marisa/test_move20006.bmp",
  L"data/actor/marisa/test_move20007.bmp",
  L"data/actor/marisa/test_move20008.bmp",
  L"data/actor/marisa/test_move20009.bmp",
  L"data/actor/marisa/test_move20010.bmp",
  L"data/actor/marisa/test_move20011.bmp",
  L"data/actor/marisa/test_move20012.bmp",
  L"data/actor/marisa/test_move20013.bmp",
  L"data/actor/marisa/test_move20014.bmp",
  L"data/actor/marisa/test_move20015.bmp",
  L"data/actor/marisa/test_move20016.bmp",
  L"data/actor/marisa/test_move20017.bmp",
  L"data/actor/marisa/test_shotHigh0000.bmp",
  L"data/actor/marisa/test_shotHigh0001.bmp",
  L"data/actor/marisa/test_shotHigh0002.bmp",
  L"data/actor/marisa/test_shotHigh0003.bmp",
  L"data/actor/marisa/test_shotHigh0004.bmp",
  L"data/actor/marisa/test_shotHigh0005.bmp",
  L"data/actor/marisa/test_shotHigh0006.bmp",
  L"data/actor/marisa/test_shotHigh0007.bmp",
  L"data/actor/marisa/test_shotHigh0008.bmp",
  L"data/actor/marisa/test_shotHigh0009.bmp",
  L"data/actor/marisa/test_shotHigh0010.bmp",
  L"data/actor/marisa/test_shotHigh0011.bmp",
  L"data/actor/marisa/test_shotHigh0012.bmp",
  L"data/actor/marisa/test_shotLow0000.bmp",
  L"data/actor/marisa/test_shotLow0001.bmp",
  L"data/actor/marisa/test_shotLow0002.bmp",
  L"data/actor/marisa/test_shotLow0007.bmp",
  L"data/actor/marisa/test_shotLow0008.bmp",
  L"data/actor/marisa/test_shotLow0009.bmp",
  L"data/actor/marisa/test_shotLow0010.bmp",
  L"data/actor/marisa/test_skillA0004.bmp",
  L"data/actor/marisa/test_skillB0000.bmp",
  L"data/actor/marisa/test_skillB0001.bmp",
  L"data/actor/marisa/test_skillB0002.bmp",
  L"data/actor/marisa/test_skillB0003.bmp",
  L"data/actor/marisa/test_skillB0004.bmp",
  L"data/actor/marisa/test_skillB0005.bmp",
  L"data/actor/marisa/test_skillB0006.bmp",
  L"data/actor/marisa/test_skillB0007.bmp",
  L"data/actor/marisa/test_skillC0000.bmp",
  L"data/actor/marisa/test_skillC0001.bmp",
  L"data/actor/marisa/test_skillC0002.bmp",
  L"data/actor/marisa/test_skillC0003.bmp",
  L"data/actor/marisa/test_skillC0004.bmp",
  L"data/actor/marisa/test_skillC0005.bmp",
  L"data/actor/marisa/test_skillC0006.bmp",
  L"data/actor/marisa/test_skillC0007.bmp",
  L"data/actor/marisa/test_skillC0008.bmp",
  L"data/actor/marisa/test_skillD0000.bmp",
  L"data/actor/marisa/test_skillD0001.bmp",
  L"data/actor/marisa/test_skillD0002.bmp",
  L"data/actor/marisa/test_skillD0003.bmp",
  L"data/actor/marisa/test_skillD0004.bmp",
  L"data/actor/marisa/test_skillD0005.bmp",
  L"data/actor/marisa/test_skillD0006.bmp",
  L"data/actor/marisa/test_skillD0007.bmp",
  L"data/actor/marisa/test_skillD0008.bmp",
  L"data/actor/marisa/test_skillD0009.bmp",
  L"data/actor/marisa/test_skillD0010.bmp",
  L"data/actor/marisa/test_skillD0011.bmp",
  L"data/actor/marisa/test_skillE0006.bmp",
  L"data/actor/marisa/test_skillE_Loop0000.bmp",
  L"data/actor/marisa/test_skillE_Loop0001.bmp",
  L"data/actor/marisa/test_spellB0000.bmp",
  L"data/actor/marisa/test_spellB0001.bmp",
  L"data/actor/marisa/test_spellB0002.bmp",
  L"data/actor/marisa/test_spellB0003.bmp",
  L"data/actor/marisa/test_spellB0004.bmp",
  L"data/actor/marisa/test_spellB0005.bmp",
  L"data/actor/marisa/test_spellB0006.bmp",
  L"data/actor/marisa/test_spellB0007.bmp",
  L"data/actor/marisa/test_spellBb0000.bmp",
  L"data/actor/marisa/test_spellBb0001.bmp",
  L"data/actor/marisa/test_spellBb0002.bmp",
  L"data/actor/marisa/test_spellBb0003.bmp",
  L"data/actor/marisa/test_spellBb0004.bmp",
  L"data/actor/marisa/test_spellBb0005.bmp",
  L"data/actor/marisa/test_spellBb0006.bmp",
  L"data/actor/marisa/test_spellBb0007.bmp",
  L"data/actor/marisa/test_walkBack0000.bmp",
  L"data/actor/marisa/test_walkBack0001.bmp",
  L"data/actor/marisa/test_walkBack0002.bmp",
  L"data/actor/marisa/test_walkBack0003.bmp",
  L"data/actor/marisa/test_walkBack0004.bmp",
  L"data/actor/marisa/test_walkBack0005.bmp",
  L"data/actor/marisa/test_walkBack0006.bmp",
  L"data/actor/marisa/test_walkBack0007.bmp",
  L"data/actor/marisa/test_walkBack0008.bmp",
  L"data/actor/marisa/test_walkBack0010.bmp",
  L"data/actor/marisa/test_walkBack0011.bmp",
  L"data/actor/marisa/test_walkBack0012.bmp",
  L"data/actor/marisa/test_walkBack0013.bmp",
  L"data/actor/marisa/test_walkFront0000.bmp",
  L"data/actor/marisa/test_walkFront0001.bmp",
  L"data/actor/marisa/test_walkFront0002.bmp",
  L"data/actor/marisa/test_walkFront0003.bmp",
  L"data/actor/marisa/test_walkFront0004.bmp",
  L"data/actor/marisa/test_walkFront0010.bmp",
  L"data/actor/marisa/test_walkFront0011.bmp",
  L"data/actor/marisa/test_walkFront0012.bmp",
  L"data/actor/marisa/test_walkFront0013.bmp",
  L"data/actor/marisa/test_walkFront0014.bmp",
  L"data/actor/marisa/test_walkFront0015.bmp",
  L"data/actor/marisa/test_walkFront0016.bmp",
  L"data/actor/marisa/texture/ball.bmp",
  L"data/actor/marisa/texture/ball.png",
  L"data/actor/marisa/texture/bitOrb_base0000.png",
  L"data/actor/marisa/texture/blueFire000.png",
  L"data/actor/marisa/texture/bullet_exp.png",
  L"data/actor/marisa/texture/guardFlash.png",
  L"data/actor/marisa/texture/kona_A.bmp",
  L"data/actor/marisa/texture/lightPilar.png",
  L"data/actor/marisa/texture/magicBottle000.png",
  L"data/actor/marisa/texture/marisaBall2.bmp",
  L"data/actor/marisa/texture/marisaStarFlare.bmp",
  L"data/actor/marisa/texture/marisa_animalDamage000.png",
  L"data/actor/marisa/texture/marisa_animalDamage001.png",
  L"data/actor/marisa/texture/marisa_animalDamage002.png",
  L"data/actor/marisa/texture/marisa_animalDamage003.png",
  L"data/actor/marisa/texture/marisa_animal_00000.png",
  L"data/actor/marisa/texture/marisa_animal_00001.png",
  L"data/actor/marisa/texture/marisa_animal_00002.png",
  L"data/actor/marisa/texture/marisa_animal_00003.png",
  L"data/actor/marisa/texture/marisa_animal_00004.png",
  L"data/actor/marisa/texture/marisa_animal_00005.png",
  L"data/actor/marisa/texture/marisa_animal_00006.png",
  L"data/actor/marisa/texture/marisa_animal_00007.png",
  L"data/actor/marisa/texture/marisa_animal_00008.png",
  L"data/actor/marisa/texture/marisa_animal_00009.png",
  L"data/actor/marisa/texture/marisa_animal_00010.png",
  L"data/actor/marisa/texture/marisa_animal_00011.png",
  L"data/actor/marisa/texture/marisa_atkA.png",
  L"data/actor/marisa/texture/marisa_chargeLine.png",
  L"data/actor/marisa/texture/marisa_laylineA.png",
  L"data/actor/marisa/texture/marisa_magicM.png",
  L"data/actor/marisa/texture/marisa_masterSpark0000.png",
  L"data/actor/marisa/texture/marisa_SaturnA.png",
  L"data/actor/marisa/texture/marisa_shotExp.png",
  L"data/actor/marisa/texture/marisa_sparkLine.png",
  L"data/actor/marisa/texture/marisa_starA.png",
  L"data/actor/marisa/texture/marisa_whiteBox0000.bmp",
  L"data/actor/marisa/texture/mask_ball.png",
  L"data/actor/marisa/texture/occultObject.png",
  L"data/actor/marisa/texture/occultPhotol0000.png",
  L"data/actor/marisa/texture/occultPiano0000.png",
  L"data/actor/marisa/texture/occultPiano0001.png",
  L"data/actor/marisa/texture/occultPiano0002.png",
  L"data/actor/marisa/texture/occult_ninomiya0000.png",
  L"data/actor/marisa/texture/occult_ninomiya0001.png",
  L"data/actor/marisa/texture/occult_ninomiya0002.png",
  L"data/actor/marisa/texture/pilarA0000.bmp",
  L"data/actor/marisa/texture/shotcharge_tail0000.png",
  L"data/actor/marisa/texture/shotStarFallA0000.png",
  L"data/actor/marisa/texture/shot_laserA0000.png",
  L"data/actor/marisa/texture/shot_laserHeadA0000.png",
  L"data/actor/marisa/texture/skillG_Trail.png",
  L"data/actor/marisa/texture/spellCharge.png",
  L"data/actor/marisa/texture/test_occultBall0000.png",
  L"data/actor/marisa/turn0000.bmp",
  L"data/actor/marisa/turn0001.bmp",
  L"data/actor/marisa/turn0002.bmp",
  L"data/actor/marisa/walkFrontLoop0000.bmp",
  L"data/actor/marisa/walkFrontLoop0001.bmp",
  L"data/actor/marisa/walkFrontLoop0002.bmp",
  L"data/actor/marisa/walkFrontLoop0003.bmp",
  L"data/actor/marisa/walkFrontLoop0004.bmp",
  L"data/actor/marisa/winA0000.bmp",
  L"data/actor/marisa/winA0001.bmp",
  L"data/actor/marisa/winA0002.bmp",
  L"data/actor/marisa/winA0003.bmp",
  L"data/actor/marisa/winA0004.bmp",
  L"data/actor/marisa/winA0005.bmp",
  L"data/actor/marisa/winA0006.bmp",
  L"data/actor/marisa/winA0007.bmp",
  L"data/actor/marisa/winA0008.bmp",
  L"data/actor/marisa/winA0009.bmp",
  L"data/actor/marisa/winA0010.bmp",
  L"data/actor/marisa/winA0011.bmp",
  L"data/actor/marisa/winA0012.bmp",
  L"data/actor/marisa/winB0000.bmp",
  L"data/actor/marisa/winB0001.bmp",
  L"data/actor/marisa/winB0002.bmp",
  L"data/actor/marisa/winB0003.bmp",
  L"data/actor/marisa/winB0004.bmp",
  L"data/actor/marisa/winB0005.bmp",
  L"data/actor/marisa/winB0006.bmp",
  L"data/actor/marisa/winB0007.bmp",
  L"data/actor/marisa/winB0008.bmp",
  L"data/actor/marisa/winB0009.bmp",
  L"data/actor/marisa/winB0010.bmp",
  L"data/actor/marisa.nut",
  L"data/actor/marisaInit.nut",
  L"data/actor/marisa_base.nut",
  L"data/actor/marisa_boss.nut",
  L"data/actor/marisa_cpu.nut",
  L"data/actor/marisa_cpuBoss.nut",
  L"data/actor/marisa_shot.nut",
  L"data/actor/miko/atkHigh0000.bmp",
  L"data/actor/miko/atkHigh0001.bmp",
  L"data/actor/miko/atkHigh0002.bmp",
  L"data/actor/miko/atkHigh0003.bmp",
  L"data/actor/miko/atkHigh0004.bmp",
  L"data/actor/miko/atkHigh0005.bmp",
  L"data/actor/miko/atkHigh0006.bmp",
  L"data/actor/miko/atkHigh0007.bmp",
  L"data/actor/miko/atkHigh0008.bmp",
  L"data/actor/miko/atkHigh0009.bmp",
  L"data/actor/miko/atkHigh0010.bmp",
  L"data/actor/miko/atkHighDash0000.bmp",
  L"data/actor/miko/atkHighDash0001.bmp",
  L"data/actor/miko/atkHighDash0002.bmp",
  L"data/actor/miko/atkHighDash0003.bmp",
  L"data/actor/miko/atkHighDash0004.bmp",
  L"data/actor/miko/atkHighDash0005.bmp",
  L"data/actor/miko/atkHighDash0006.bmp",
  L"data/actor/miko/atkHighDash0007.bmp",
  L"data/actor/miko/atkHighDash0008.bmp",
  L"data/actor/miko/atkHighDash0009.bmp",
  L"data/actor/miko/atkHighDash0010.bmp",
  L"data/actor/miko/atkHighDash0011.bmp",
  L"data/actor/miko/atkHighDash0012.bmp",
  L"data/actor/miko/atkHighDash0013.bmp",
  L"data/actor/miko/atkHighDash0014.bmp",
  L"data/actor/miko/atkHighDash0015.bmp",
  L"data/actor/miko/atkHighDash0016.bmp",
  L"data/actor/miko/atkHighDash0017.bmp",
  L"data/actor/miko/atkHighDash0018.bmp",
  L"data/actor/miko/atkHighDash0019.bmp",
  L"data/actor/miko/atkHighDash0020.bmp",
  L"data/actor/miko/atkHighFront0000.bmp",
  L"data/actor/miko/atkHighFront0001.bmp",
  L"data/actor/miko/atkHighFront0002.bmp",
  L"data/actor/miko/atkHighFront0003.bmp",
  L"data/actor/miko/atkHighFront0004.bmp",
  L"data/actor/miko/atkHighFront0005.bmp",
  L"data/actor/miko/atkHighFront0006.bmp",
  L"data/actor/miko/atkHighFront0007.bmp",
  L"data/actor/miko/atkHighFront0008.bmp",
  L"data/actor/miko/atkHighFront0009.bmp",
  L"data/actor/miko/atkHighFront0010.bmp",
  L"data/actor/miko/atkHighFront0011.bmp",
  L"data/actor/miko/atkHighFront0012.bmp",
  L"data/actor/miko/atkHighFront0013.bmp",
  L"data/actor/miko/atkHighUnder0000.bmp",
  L"data/actor/miko/atkHighUnder0001.bmp",
  L"data/actor/miko/atkHighUnder0002.bmp",
  L"data/actor/miko/atkHighUnder0003.bmp",
  L"data/actor/miko/atkHighUnder0004.bmp",
  L"data/actor/miko/atkHighUnder0005.bmp",
  L"data/actor/miko/atkHighUnder0006.bmp",
  L"data/actor/miko/atkHighUnder0007.bmp",
  L"data/actor/miko/atkHighUnder0008.bmp",
  L"data/actor/miko/atkHighUnder0009.bmp",
  L"data/actor/miko/atkHighUpper0000.bmp",
  L"data/actor/miko/atkHighUpper0001.bmp",
  L"data/actor/miko/atkHighUpper0002.bmp",
  L"data/actor/miko/atkHighUpper0003.bmp",
  L"data/actor/miko/atkHighUpper0004.bmp",
  L"data/actor/miko/atkHighUpper0005.bmp",
  L"data/actor/miko/atkHighUpper0006.bmp",
  L"data/actor/miko/atkHighUpper0007.bmp",
  L"data/actor/miko/atkHighUpper0008.bmp",
  L"data/actor/miko/atkHighUpper0009.bmp",
  L"data/actor/miko/atkHighUpper0010.bmp",
  L"data/actor/miko/atkHighUpper0011.bmp",
  L"data/actor/miko/atkHighUpper0012.bmp",
  L"data/actor/miko/atkLow0000.bmp",
  L"data/actor/miko/atkLow0001.bmp",
  L"data/actor/miko/atkLow0002.bmp",
  L"data/actor/miko/atkLow0003.bmp",
  L"data/actor/miko/atkLow0004.bmp",
  L"data/actor/miko/atkLow0005.bmp",
  L"data/actor/miko/atkLow0006.bmp",
  L"data/actor/miko/atkLow0007.bmp",
  L"data/actor/miko/atkLowDash0000.bmp",
  L"data/actor/miko/atkLowDash0001.bmp",
  L"data/actor/miko/atkLowDash0002.bmp",
  L"data/actor/miko/atkLowDash0003.bmp",
  L"data/actor/miko/atkLowDash0004.bmp",
  L"data/actor/miko/atkLowDash0005.bmp",
  L"data/actor/miko/atkLowDash0006.bmp",
  L"data/actor/miko/atkLowDash0007.bmp",
  L"data/actor/miko/atkLowDash0008.bmp",
  L"data/actor/miko/atkLowDash0009.bmp",
  L"data/actor/miko/atkLowDash0010.bmp",
  L"data/actor/miko/atkMid0000.bmp",
  L"data/actor/miko/atkMid0001.bmp",
  L"data/actor/miko/atkMid0002.bmp",
  L"data/actor/miko/atkMid0003.bmp",
  L"data/actor/miko/atkMid0004.bmp",
  L"data/actor/miko/atkMid0005.bmp",
  L"data/actor/miko/atkMid0006.bmp",
  L"data/actor/miko/atkMid0007.bmp",
  L"data/actor/miko/atkMid0008.bmp",
  L"data/actor/miko/atkMid0009.bmp",
  L"data/actor/miko/atkMid0010.bmp",
  L"data/actor/miko/atkMid0011.bmp",
  L"data/actor/miko/atkMid0012.bmp",
  L"data/actor/miko/atkMid0013.bmp",
  L"data/actor/miko/atkMid0014.bmp",
  L"data/actor/miko/battleBeginA0000.bmp",
  L"data/actor/miko/battleBeginA0001.bmp",
  L"data/actor/miko/battleBeginA0002.bmp",
  L"data/actor/miko/battleBeginA0003.bmp",
  L"data/actor/miko/battleBeginA0004.bmp",
  L"data/actor/miko/battleBeginA0005.bmp",
  L"data/actor/miko/battleBeginA0006.bmp",
  L"data/actor/miko/battleBeginALoop0000.bmp",
  L"data/actor/miko/battleBeginALoop0001.bmp",
  L"data/actor/miko/battleBeginALoop0002.bmp",
  L"data/actor/miko/battleBeginALoop0003.bmp",
  L"data/actor/miko/battleBeginALoop0004.bmp",
  L"data/actor/miko/battleBeginB0000.bmp",
  L"data/actor/miko/battleBeginB0001.bmp",
  L"data/actor/miko/battleBeginB0002.bmp",
  L"data/actor/miko/battleBeginB0003.bmp",
  L"data/actor/miko/battleBeginB0004.bmp",
  L"data/actor/miko/battleBeginB0005.bmp",
  L"data/actor/miko/battleBeginB0006.bmp",
  L"data/actor/miko/battleBeginB0007.bmp",
  L"data/actor/miko/battleBeginB0008.bmp",
  L"data/actor/miko/bmsln/miko_bariaT.bmb",
  L"data/actor/miko/bmsln/miko_chargeFire.bmb",
  L"data/actor/miko/bmsln/miko_climaxFall.bmb",
  L"data/actor/miko/bmsln/miko_clow.bmb",
  L"data/actor/miko/bmsln/miko_dragonFire.bmb",
  L"data/actor/miko/bmsln/miko_nichirin.bmb",
  L"data/actor/miko/bmsln/miko_nichirinLoop.bmb",
  L"data/actor/miko/bmsln/miko_spellC.bmb",
  L"data/actor/miko/bmsln/miko_spellCb.bmb",
  L"data/actor/miko/bmsln/miko_warp.bmb",
  L"data/actor/miko/climax0000.bmp",
  L"data/actor/miko/climax0001.bmp",
  L"data/actor/miko/climax0002.bmp",
  L"data/actor/miko/climax0003.bmp",
  L"data/actor/miko/climax0004.bmp",
  L"data/actor/miko/climax0005.bmp",
  L"data/actor/miko/climax0006.bmp",
  L"data/actor/miko/climax0007.bmp",
  L"data/actor/miko/climax0008.bmp",
  L"data/actor/miko/climax0009.bmp",
  L"data/actor/miko/climax0010.bmp",
  L"data/actor/miko/climax0011.bmp",
  L"data/actor/miko/climax0012.bmp",
  L"data/actor/miko/climax00130.bmp",
  L"data/actor/miko/climaxcut0000.png",
  L"data/actor/miko/crash0000.bmp",
  L"data/actor/miko/crash0001.bmp",
  L"data/actor/miko/crash0002.bmp",
  L"data/actor/miko/crash0003.bmp",
  L"data/actor/miko/crash0004.bmp",
  L"data/actor/miko/crash0005.bmp",
  L"data/actor/miko/damageBody0000.bmp",
  L"data/actor/miko/damageBody0001.bmp",
  L"data/actor/miko/damageBody0002.bmp",
  L"data/actor/miko/damageBody0003.bmp",
  L"data/actor/miko/damageBody0004.bmp",
  L"data/actor/miko/damageHead0000.bmp",
  L"data/actor/miko/damageHead0001.bmp",
  L"data/actor/miko/damageHead0002.bmp",
  L"data/actor/miko/damageHead0003.bmp",
  L"data/actor/miko/damageHead0004.bmp",
  L"data/actor/miko/damageWall0000.bmp",
  L"data/actor/miko/damageWall0001.bmp",
  L"data/actor/miko/damageWall0002.bmp",
  L"data/actor/miko/damageWall0003.bmp",
  L"data/actor/miko/damageWall0004.bmp",
  L"data/actor/miko/damageWall0005.bmp",
  L"data/actor/miko/damageWall0006.bmp",
  L"data/actor/miko/damageWall0007.bmp",
  L"data/actor/miko/damage_down0000.bmp",
  L"data/actor/miko/damage_down0001.bmp",
  L"data/actor/miko/damage_down0002.bmp",
  L"data/actor/miko/damage_down0003.bmp",
  L"data/actor/miko/damage_down0004.bmp",
  L"data/actor/miko/damage_spin0000.bmp",
  L"data/actor/miko/damage_spin0001.bmp",
  L"data/actor/miko/damage_spin0002.bmp",
  L"data/actor/miko/damage_spin0003.bmp",
  L"data/actor/miko/damage_Upper0000.bmp",
  L"data/actor/miko/damage_Upper0001.bmp",
  L"data/actor/miko/damage_Upper0002.bmp",
  L"data/actor/miko/damage_Upper0003.bmp",
  L"data/actor/miko/damage_Upper0004.bmp",
  L"data/actor/miko/damage_Upper0005.bmp",
  L"data/actor/miko/damage_Upper0006.bmp",
  L"data/actor/miko/damage_Upper0007.bmp",
  L"data/actor/miko/damage_UpperLoop0000.bmp",
  L"data/actor/miko/damage_UpperLoop0001.bmp",
  L"data/actor/miko/damage_UpperLoopB0000.bmp",
  L"data/actor/miko/damage_UpperLoopB0001.bmp",
  L"data/actor/miko/dashBack0000.bmp",
  L"data/actor/miko/dashBack0001.bmp",
  L"data/actor/miko/dashBack0002.bmp",
  L"data/actor/miko/dashBack0003.bmp",
  L"data/actor/miko/dashBack0004.bmp",
  L"data/actor/miko/dashBack0005.bmp",
  L"data/actor/miko/dashBackLoop0000.bmp",
  L"data/actor/miko/dashBackLoop0001.bmp",
  L"data/actor/miko/dashBackLoop0002.bmp",
  L"data/actor/miko/dashBackLoop0003.bmp",
  L"data/actor/miko/dashBackLoop0004.bmp",
  L"data/actor/miko/dashFront0000.bmp",
  L"data/actor/miko/dashFront0001.bmp",
  L"data/actor/miko/dashFront0002.bmp",
  L"data/actor/miko/dashFront0003.bmp",
  L"data/actor/miko/dashFront0004.bmp",
  L"data/actor/miko/dashFront0005.bmp",
  L"data/actor/miko/dashFrontLoop0000.bmp",
  L"data/actor/miko/dashFrontLoop0001.bmp",
  L"data/actor/miko/dashFrontLoop0002.bmp",
  L"data/actor/miko/dashFrontLoop0003.bmp",
  L"data/actor/miko/dashFrontLoop0004.bmp",
  L"data/actor/miko/face_spellcallb.png",
  L"data/actor/miko/guard0000.bmp",
  L"data/actor/miko/guard0001.bmp",
  L"data/actor/miko/guard0002.bmp",
  L"data/actor/miko/guard0003.bmp",
  L"data/actor/miko/guardCrash0000.bmp",
  L"data/actor/miko/guardCrash0001.bmp",
  L"data/actor/miko/guardCrash0002.bmp",
  L"data/actor/miko/guardCrash0003.bmp",
  L"data/actor/miko/guardCrash0004.bmp",
  L"data/actor/miko/guardCrash0005.bmp",
  L"data/actor/miko/item0000.bmp",
  L"data/actor/miko/item0001.bmp",
  L"data/actor/miko/item0002.bmp",
  L"data/actor/miko/item0003.bmp",
  L"data/actor/miko/item0004.bmp",
  L"data/actor/miko/item0005.bmp",
  L"data/actor/miko/item0006.bmp",
  L"data/actor/miko/item0007.bmp",
  L"data/actor/miko/item0008.bmp",
  L"data/actor/miko/item0009.bmp",
  L"data/actor/miko/item0010.bmp",
  L"data/actor/miko/lose0000.bmp",
  L"data/actor/miko/lose0001.bmp",
  L"data/actor/miko/lose0002.bmp",
  L"data/actor/miko/lose0003.bmp",
  L"data/actor/miko/lose0004.bmp",
  L"data/actor/miko/miko.pat",
  L"data/actor/miko/miko_ed.pat",
  L"data/actor/miko/missGuard0000.bmp",
  L"data/actor/miko/missGuard0001.bmp",
  L"data/actor/miko/missGuard0002.bmp",
  L"data/actor/miko/missGuard0003.bmp",
  L"data/actor/miko/occult0000.bmp",
  L"data/actor/miko/occult0001.bmp",
  L"data/actor/miko/occult0002.bmp",
  L"data/actor/miko/occult0003.bmp",
  L"data/actor/miko/occult0004.bmp",
  L"data/actor/miko/occult0005.bmp",
  L"data/actor/miko/occult0006.bmp",
  L"data/actor/miko/occult0007.bmp",
  L"data/actor/miko/occult0008.bmp",
  L"data/actor/miko/occult0009.bmp",
  L"data/actor/miko/occult0010.bmp",
  L"data/actor/miko/occult0011.bmp",
  L"data/actor/miko/occult0012.bmp",
  L"data/actor/miko/occult0013.bmp",
  L"data/actor/miko/occult0014.bmp",
  L"data/actor/miko/occult0015.bmp",
  L"data/actor/miko/occult0016.bmp",
  L"data/actor/miko/occult0017.bmp",
  L"data/actor/miko/occult0018.bmp",
  L"data/actor/miko/occult0019.bmp",
  L"data/actor/miko/occult0020.bmp",
  L"data/actor/miko/occult0021.bmp",
  L"data/actor/miko/occult0022.bmp",
  L"data/actor/miko/occult0023.bmp",
  L"data/actor/miko/occult0024.bmp",
  L"data/actor/miko/occult0025.bmp",
  L"data/actor/miko/occult0026.bmp",
  L"data/actor/miko/palette000.bmp",
  L"data/actor/miko/palette001.bmp",
  L"data/actor/miko/palette002.bmp",
  L"data/actor/miko/palette003.bmp",
  L"data/actor/miko/palette004.bmp",
  L"data/actor/miko/palette005.bmp",
  L"data/actor/miko/palette006.bmp",
  L"data/actor/miko/palette007.bmp",
  L"data/actor/miko/shotHigh0000.bmp",
  L"data/actor/miko/shotHigh0001.bmp",
  L"data/actor/miko/shotHigh0002.bmp",
  L"data/actor/miko/shotHigh0003.bmp",
  L"data/actor/miko/shotHigh0004.bmp",
  L"data/actor/miko/shotHigh0005.bmp",
  L"data/actor/miko/shotHigh0006.bmp",
  L"data/actor/miko/shotHigh0007.bmp",
  L"data/actor/miko/shotHigh0008.bmp",
  L"data/actor/miko/shotHigh0009.bmp",
  L"data/actor/miko/shotHigh0010.bmp",
  L"data/actor/miko/shotHigh0011.bmp",
  L"data/actor/miko/shotHigh0012.bmp",
  L"data/actor/miko/shotHigh0013.bmp",
  L"data/actor/miko/shotHigh0014.bmp",
  L"data/actor/miko/shotHigh0015.bmp",
  L"data/actor/miko/shotLow0000.bmp",
  L"data/actor/miko/shotLow0001.bmp",
  L"data/actor/miko/shotLow0002.bmp",
  L"data/actor/miko/shotLow0003.bmp",
  L"data/actor/miko/shotLow0004.bmp",
  L"data/actor/miko/shotLow0005.bmp",
  L"data/actor/miko/shotLow0006.bmp",
  L"data/actor/miko/shotLow0007.bmp",
  L"data/actor/miko/skillA0000.bmp",
  L"data/actor/miko/skillA0001.bmp",
  L"data/actor/miko/skillA0002.bmp",
  L"data/actor/miko/skillA0003.bmp",
  L"data/actor/miko/skillA0004.bmp",
  L"data/actor/miko/skillA0005.bmp",
  L"data/actor/miko/skillA0006.bmp",
  L"data/actor/miko/skillA0007.bmp",
  L"data/actor/miko/skillA0008.bmp",
  L"data/actor/miko/skillA0009.bmp",
  L"data/actor/miko/skillAb0000.bmp",
  L"data/actor/miko/skillAb0001.bmp",
  L"data/actor/miko/skillAb0002.bmp",
  L"data/actor/miko/skillAb0003.bmp",
  L"data/actor/miko/skillAb0004.bmp",
  L"data/actor/miko/skillAb0005.bmp",
  L"data/actor/miko/skillAb0006.bmp",
  L"data/actor/miko/skillAb0007.bmp",
  L"data/actor/miko/skillAb0008.bmp",
  L"data/actor/miko/skillAb0009.bmp",
  L"data/actor/miko/skillAb0010.bmp",
  L"data/actor/miko/skillAb0011.bmp",
  L"data/actor/miko/skillAb0012.bmp",
  L"data/actor/miko/skillB0000.bmp",
  L"data/actor/miko/skillB0001.bmp",
  L"data/actor/miko/skillB0002.bmp",
  L"data/actor/miko/skillB0003.bmp",
  L"data/actor/miko/skillB0004.bmp",
  L"data/actor/miko/skillB0005.bmp",
  L"data/actor/miko/skillB0006.bmp",
  L"data/actor/miko/skillB0007.bmp",
  L"data/actor/miko/skillB0008.bmp",
  L"data/actor/miko/skillB0009.bmp",
  L"data/actor/miko/skillB0010.bmp",
  L"data/actor/miko/skillB0011.bmp",
  L"data/actor/miko/skillB0012.bmp",
  L"data/actor/miko/skillB0013.bmp",
  L"data/actor/miko/skillB0014.bmp",
  L"data/actor/miko/skillC0000.bmp",
  L"data/actor/miko/skillC0001.bmp",
  L"data/actor/miko/skillC0002.bmp",
  L"data/actor/miko/skillC0003.bmp",
  L"data/actor/miko/skillC0004.bmp",
  L"data/actor/miko/skillC0005.bmp",
  L"data/actor/miko/skillC0006.bmp",
  L"data/actor/miko/skillC0007.bmp",
  L"data/actor/miko/skillC0008.bmp",
  L"data/actor/miko/skillC0009.bmp",
  L"data/actor/miko/skillC0010.bmp",
  L"data/actor/miko/skillC0011.bmp",
  L"data/actor/miko/skillC0012.bmp",
  L"data/actor/miko/skillC0013.bmp",
  L"data/actor/miko/skillC0014.bmp",
  L"data/actor/miko/skillC0015.bmp",
  L"data/actor/miko/skillC0016.bmp",
  L"data/actor/miko/skillD0000.bmp",
  L"data/actor/miko/skillD0001.bmp",
  L"data/actor/miko/skillD0002.bmp",
  L"data/actor/miko/skillD0003.bmp",
  L"data/actor/miko/skillD0004.bmp",
  L"data/actor/miko/skillD0005.bmp",
  L"data/actor/miko/skillD0006.bmp",
  L"data/actor/miko/skillD0007.bmp",
  L"data/actor/miko/skillD0008.bmp",
  L"data/actor/miko/skillD0009.bmp",
  L"data/actor/miko/skillD0010.bmp",
  L"data/actor/miko/skillD0011.bmp",
  L"data/actor/miko/skillD0012.bmp",
  L"data/actor/miko/skillD0013.bmp",
  L"data/actor/miko/skillD0014.bmp",
  L"data/actor/miko/skillE0000.bmp",
  L"data/actor/miko/skillE0001.bmp",
  L"data/actor/miko/skillE0002.bmp",
  L"data/actor/miko/skillE0003.bmp",
  L"data/actor/miko/skillE0004.bmp",
  L"data/actor/miko/skillE0005.bmp",
  L"data/actor/miko/skillE0006.bmp",
  L"data/actor/miko/skillE0007.bmp",
  L"data/actor/miko/skillE0008.bmp",
  L"data/actor/miko/skillE0009.bmp",
  L"data/actor/miko/skillE0010.bmp",
  L"data/actor/miko/skillE0011.bmp",
  L"data/actor/miko/skillE0012.bmp",
  L"data/actor/miko/skillE0013.bmp",
  L"data/actor/miko/skillE0014.bmp",
  L"data/actor/miko/skillE0015.bmp",
  L"data/actor/miko/skillE0016.bmp",
  L"data/actor/miko/skillE0017.bmp",
  L"data/actor/miko/skillE0018.bmp",
  L"data/actor/miko/skillE0019.bmp",
  L"data/actor/miko/skillG0000.bmp",
  L"data/actor/miko/skillG0001.bmp",
  L"data/actor/miko/skillG0002.bmp",
  L"data/actor/miko/skillG0003.bmp",
  L"data/actor/miko/skillG0004.bmp",
  L"data/actor/miko/skillG0005.bmp",
  L"data/actor/miko/skillG0006.bmp",
  L"data/actor/miko/skillG0007.bmp",
  L"data/actor/miko/skillG0008.bmp",
  L"data/actor/miko/skillG0009.bmp",
  L"data/actor/miko/slideUnderLoop0000.bmp",
  L"data/actor/miko/slideUnderLoop0001.bmp",
  L"data/actor/miko/slideUnderLoop0002.bmp",
  L"data/actor/miko/slideUnderLoop0003.bmp",
  L"data/actor/miko/slideUnderLoop0004.bmp",
  L"data/actor/miko/slideUpper0000.bmp",
  L"data/actor/miko/slideUpper0001.bmp",
  L"data/actor/miko/slideUpper0002.bmp",
  L"data/actor/miko/slideUpper0003.bmp",
  L"data/actor/miko/slideUpper0004.bmp",
  L"data/actor/miko/slideUpper0005.bmp",
  L"data/actor/miko/slideUpper0006.bmp",
  L"data/actor/miko/slideUpperLoop0000.bmp",
  L"data/actor/miko/slideUpperLoop0001.bmp",
  L"data/actor/miko/slideUpperLoop0002.bmp",
  L"data/actor/miko/slideUpperLoop0003.bmp",
  L"data/actor/miko/slideUpperLoop0004.bmp",
  L"data/actor/miko/slide_UnderLoop0000.bmp",
  L"data/actor/miko/slide_UnderLoop0001.bmp",
  L"data/actor/miko/slide_UnderLoop0002.bmp",
  L"data/actor/miko/slide_UnderLoop0003.bmp",
  L"data/actor/miko/slide_UnderLoop0004.bmp",
  L"data/actor/miko/slide_Upper0000.bmp",
  L"data/actor/miko/slide_Upper0001.bmp",
  L"data/actor/miko/slide_Upper0002.bmp",
  L"data/actor/miko/slide_Upper0003.bmp",
  L"data/actor/miko/slide_Upper0004.bmp",
  L"data/actor/miko/slide_Upper0005.bmp",
  L"data/actor/miko/slide_Upper0006.bmp",
  L"data/actor/miko/slide_Upper0007.bmp",
  L"data/actor/miko/slide_Upper0008.bmp",
  L"data/actor/miko/slide_Upper0009.bmp",
  L"data/actor/miko/slide_UpperLoop0000.bmp",
  L"data/actor/miko/slide_UpperLoop0001.bmp",
  L"data/actor/miko/slide_UpperLoop0002.bmp",
  L"data/actor/miko/slide_UpperLoop0003.bmp",
  L"data/actor/miko/slide_UpperLoop0004.bmp",
  L"data/actor/miko/spellA0000.bmp",
  L"data/actor/miko/spellA0001.bmp",
  L"data/actor/miko/spellA0002.bmp",
  L"data/actor/miko/spellA0003.bmp",
  L"data/actor/miko/spellA0004.bmp",
  L"data/actor/miko/spellA0005.bmp",
  L"data/actor/miko/spellA0006.bmp",
  L"data/actor/miko/spellA0007.bmp",
  L"data/actor/miko/spellA0008.bmp",
  L"data/actor/miko/spellA0009.bmp",
  L"data/actor/miko/spellA0010.bmp",
  L"data/actor/miko/spellA0011.bmp",
  L"data/actor/miko/spellA0012.bmp",
  L"data/actor/miko/spellALoop0000.bmp",
  L"data/actor/miko/spellALoop0001.bmp",
  L"data/actor/miko/spellALoop0002.bmp",
  L"data/actor/miko/spellALoop0003.bmp",
  L"data/actor/miko/spellALoop0004.bmp",
  L"data/actor/miko/spellC0000.bmp",
  L"data/actor/miko/spellC0001.bmp",
  L"data/actor/miko/spellC0002.bmp",
  L"data/actor/miko/spellC0003.bmp",
  L"data/actor/miko/spellC0004.bmp",
  L"data/actor/miko/spellC0005.bmp",
  L"data/actor/miko/spellC0006.bmp",
  L"data/actor/miko/spellC0007.bmp",
  L"data/actor/miko/spellC0008.bmp",
  L"data/actor/miko/spellC0009.bmp",
  L"data/actor/miko/spellC0010.bmp",
  L"data/actor/miko/spellC0011.bmp",
  L"data/actor/miko/spellC0012.bmp",
  L"data/actor/miko/spellC0013.bmp",
  L"data/actor/miko/spellC0014.bmp",
  L"data/actor/miko/stand0000.bmp",
  L"data/actor/miko/stand0001.bmp",
  L"data/actor/miko/stand0002.bmp",
  L"data/actor/miko/stand0003.bmp",
  L"data/actor/miko/stand0004.bmp",
  L"data/actor/miko/stand0005.bmp",
  L"data/actor/miko/stand0006.bmp",
  L"data/actor/miko/stand0007.bmp",
  L"data/actor/miko/stand0008.bmp",
  L"data/actor/miko/stand0009.bmp",
  L"data/actor/miko/stand0010.bmp",
  L"data/actor/miko/stand0011.bmp",
  L"data/actor/miko/stand0012.bmp",
  L"data/actor/miko/stand0013.bmp",
  L"data/actor/miko/stun0000.bmp",
  L"data/actor/miko/stun0001.bmp",
  L"data/actor/miko/stun0002.bmp",
  L"data/actor/miko/stunLoop0000.bmp",
  L"data/actor/miko/stunLoop0001.bmp",
  L"data/actor/miko/stunLoop0002.bmp",
  L"data/actor/miko/stunLoop0003.bmp",
  L"data/actor/miko/stunLoop0004.bmp",
  L"data/actor/miko/stunLoop0005.bmp",
  L"data/actor/miko/test_effect.bmp",
  L"data/actor/miko/test_effect000.png",
  L"data/actor/miko/test_effect001.png",
  L"data/actor/miko/texture/auraA0000.png",
  L"data/actor/miko/texture/ball.png",
  L"data/actor/miko/texture/ballB.bmp",
  L"data/actor/miko/texture/bariaT.png",
  L"data/actor/miko/texture/chouzyuuA.png",
  L"data/actor/miko/texture/climax_slash0000.dds",
  L"data/actor/miko/texture/clowA000.png",
  L"data/actor/miko/texture/clowA001.png",
  L"data/actor/miko/texture/clowA002.png",
  L"data/actor/miko/texture/clowB0000.png",
  L"data/actor/miko/texture/clowB0001.png",
  L"data/actor/miko/texture/clowB0002.png",
  L"data/actor/miko/texture/common_spark.png",
  L"data/actor/miko/texture/cut_aura0000.dds",
  L"data/actor/miko/texture/earth0000.png",
  L"data/actor/miko/texture/earth0001.png",
  L"data/actor/miko/texture/earth0002.png",
  L"data/actor/miko/texture/earth0003.png",
  L"data/actor/miko/texture/earth0004.png",
  L"data/actor/miko/texture/earth0005.png",
  L"data/actor/miko/texture/earth0006.png",
  L"data/actor/miko/texture/earth0007.png",
  L"data/actor/miko/texture/earth0008.png",
  L"data/actor/miko/texture/earth0009.png",
  L"data/actor/miko/texture/earth0010.png",
  L"data/actor/miko/texture/earth0011.png",
  L"data/actor/miko/texture/earth0012.png",
  L"data/actor/miko/texture/earth0013.png",
  L"data/actor/miko/texture/earth0014.png",
  L"data/actor/miko/texture/fireBack.png",
  L"data/actor/miko/texture/fireKick0000.png",
  L"data/actor/miko/texture/fireMask.png",
  L"data/actor/miko/texture/hexPanel.png",
  L"data/actor/miko/texture/laserBaseA000.png",
  L"data/actor/miko/texture/laserBaseA001.png",
  L"data/actor/miko/texture/mantleHigh.png",
  L"data/actor/miko/texture/mantleLow.png",
  L"data/actor/miko/texture/mantletest000.bmp",
  L"data/actor/miko/texture/marisaBall2.bmp",
  L"data/actor/miko/texture/miko_animalDamage000.png",
  L"data/actor/miko/texture/miko_animalDamage001.png",
  L"data/actor/miko/texture/miko_animalDamage002.png",
  L"data/actor/miko/texture/miko_animalDamage003.png",
  L"data/actor/miko/texture/miko_animal_00000.png",
  L"data/actor/miko/texture/miko_animal_00001.png",
  L"data/actor/miko/texture/miko_animal_00002.png",
  L"data/actor/miko/texture/miko_animal_00003.png",
  L"data/actor/miko/texture/miko_animal_00004.png",
  L"data/actor/miko/texture/miko_animal_00005.png",
  L"data/actor/miko/texture/miko_animal_00006.png",
  L"data/actor/miko/texture/miko_animal_00007.png",
  L"data/actor/miko/texture/miko_animal_00008.png",
  L"data/actor/miko/texture/miko_animal_00009.png",
  L"data/actor/miko/texture/miko_animal_00010.png",
  L"data/actor/miko/texture/miko_animal_00011.png",
  L"data/actor/miko/texture/miko_ballA.bmp",
  L"data/actor/miko/texture/miko_ballB.png",
  L"data/actor/miko/texture/miko_climaxblade.png",
  L"data/actor/miko/texture/miko_fire.png",
  L"data/actor/miko/texture/miko_kona_A.bmp",
  L"data/actor/miko/texture/miko_RingA.bmp",
  L"data/actor/miko/texture/miko_spellC_Branch.png",
  L"data/actor/miko/texture/miko_spellC_Laser.png",
  L"data/actor/miko/texture/nichirin.png",
  L"data/actor/miko/texture/occult_aura0000.dds",
  L"data/actor/miko/texture/occult_ball0000.png",
  L"data/actor/miko/texture/occult_select0000.dds",
  L"data/actor/miko/texture/occult_slash0000.dds",
  L"data/actor/miko/texture/rodRollA0000.png",
  L"data/actor/miko/texture/shot_MonolaserA0000.png",
  L"data/actor/miko/texture/skillG_sword.png",
  L"data/actor/miko/texture/skillG_Trail.png",
  L"data/actor/miko/texture/smoke.png",
  L"data/actor/miko/texture/sunRing.png",
  L"data/actor/miko/texture/sword0000.png",
  L"data/actor/miko/texture/trail.png",
  L"data/actor/miko/texture/vortexloop0000.png",
  L"data/actor/miko/Turn0000.bmp",
  L"data/actor/miko/Turn0001.bmp",
  L"data/actor/miko/Turn0002.bmp",
  L"data/actor/miko/walkBack0000.bmp",
  L"data/actor/miko/walkBack0001.bmp",
  L"data/actor/miko/walkBack0003.bmp",
  L"data/actor/miko/walkBack0004.bmp",
  L"data/actor/miko/walkBack0005.bmp",
  L"data/actor/miko/walkBackloop0000.bmp",
  L"data/actor/miko/walkBackloop0001.bmp",
  L"data/actor/miko/walkBackloop0002.bmp",
  L"data/actor/miko/walkBackloop0003.bmp",
  L"data/actor/miko/walkBackloop0004.bmp",
  L"data/actor/miko/walkFront0000.bmp",
  L"data/actor/miko/walkFront0001.bmp",
  L"data/actor/miko/walkFront0002.bmp",
  L"data/actor/miko/walkFront0003.bmp",
  L"data/actor/miko/walkFront0004.bmp",
  L"data/actor/miko/walkFront0005.bmp",
  L"data/actor/miko/walkFrontLoop0000.bmp",
  L"data/actor/miko/walkFrontLoop0001.bmp",
  L"data/actor/miko/walkFrontLoop0002.bmp",
  L"data/actor/miko/walkFrontLoop0003.bmp",
  L"data/actor/miko/walkFrontLoop0004.bmp",
  L"data/actor/miko/winA0000.bmp",
  L"data/actor/miko/winA0001.bmp",
  L"data/actor/miko/winA0002.bmp",
  L"data/actor/miko/winA0003.bmp",
  L"data/actor/miko/winA0004.bmp",
  L"data/actor/miko/winB0000.bmp",
  L"data/actor/miko/winB0001.bmp",
  L"data/actor/miko/winB0002.bmp",
  L"data/actor/miko/winB0003.bmp",
  L"data/actor/miko/winB0004.bmp",
  L"data/actor/miko/winB0005.bmp",
  L"data/actor/miko.nut",
  L"data/actor/mikoInit.nut",
  L"data/actor/miko_base.nut",
  L"data/actor/miko_boss.nut",
  L"data/actor/miko_cpu.nut",
  L"data/actor/miko_cpuBoss.nut",
  L"data/actor/miko_r.nut",
  L"data/actor/miko_shot.nut",
  L"data/actor/mokou/atkDash0000.bmp",
  L"data/actor/mokou/atkDash0001.bmp",
  L"data/actor/mokou/atkDash0002.bmp",
  L"data/actor/mokou/atkDash0003.bmp",
  L"data/actor/mokou/atkDash0004.bmp",
  L"data/actor/mokou/atkDash0005.bmp",
  L"data/actor/mokou/atkDash0006.bmp",
  L"data/actor/mokou/atkDash0007.bmp",
  L"data/actor/mokou/atkDash0008.bmp",
  L"data/actor/mokou/atkFront0000.bmp",
  L"data/actor/mokou/atkFront0001.bmp",
  L"data/actor/mokou/atkFront0002.bmp",
  L"data/actor/mokou/atkFront0003.bmp",
  L"data/actor/mokou/atkFront0004.bmp",
  L"data/actor/mokou/atkFront0005.bmp",
  L"data/actor/mokou/atkFront0006.bmp",
  L"data/actor/mokou/atkFront0007.bmp",
  L"data/actor/mokou/atkFront0008.bmp",
  L"data/actor/mokou/atkfront0009.bmp",
  L"data/actor/mokou/atkHighFrontAir0000.bmp",
  L"data/actor/mokou/atkHighFrontAir0001.bmp",
  L"data/actor/mokou/atkHighFrontAir0002.bmp",
  L"data/actor/mokou/atkHighFrontAir0003.bmp",
  L"data/actor/mokou/atkHighFrontAir0004.bmp",
  L"data/actor/mokou/atkHighFrontAir0005.bmp",
  L"data/actor/mokou/atkHighFrontAir0006.bmp",
  L"data/actor/mokou/atkHighFrontAir0007.bmp",
  L"data/actor/mokou/atkHighFrontAir0008.bmp",
  L"data/actor/mokou/atkHighUnder0000.bmp",
  L"data/actor/mokou/atkHighUnder0001.bmp",
  L"data/actor/mokou/atkHighUnder0002.bmp",
  L"data/actor/mokou/atkHighUnder0003.bmp",
  L"data/actor/mokou/atkHighUnder0004.bmp",
  L"data/actor/mokou/atkHighUnder0005.bmp",
  L"data/actor/mokou/atkHighUnder0006.bmp",
  L"data/actor/mokou/atkHighUnder0007.bmp",
  L"data/actor/mokou/atkHighUnder0008.bmp",
  L"data/actor/mokou/atkHighUpper0000.bmp",
  L"data/actor/mokou/atkHighUpper0001.bmp",
  L"data/actor/mokou/atkHighUpper0002.bmp",
  L"data/actor/mokou/atkHighUpper0003.bmp",
  L"data/actor/mokou/atkHighUpper0004.bmp",
  L"data/actor/mokou/atkHighUpper0005.bmp",
  L"data/actor/mokou/atkHighUpper0006.bmp",
  L"data/actor/mokou/atkHighUpper0007.bmp",
  L"data/actor/mokou/atkLow0000.bmp",
  L"data/actor/mokou/atkLow0001.bmp",
  L"data/actor/mokou/atkLow0002.bmp",
  L"data/actor/mokou/atkLow0003.bmp",
  L"data/actor/mokou/atkLow0004.bmp",
  L"data/actor/mokou/atkLow0005.bmp",
  L"data/actor/mokou/atkLow0006.bmp",
  L"data/actor/mokou/atkMid0000.bmp",
  L"data/actor/mokou/atkMid0001.bmp",
  L"data/actor/mokou/atkMid0002.bmp",
  L"data/actor/mokou/atkMid0003.bmp",
  L"data/actor/mokou/atkMid0004.bmp",
  L"data/actor/mokou/atkMid0005.bmp",
  L"data/actor/mokou/atkMid0006.bmp",
  L"data/actor/mokou/atkMidAir0000.bmp",
  L"data/actor/mokou/atkMidAir0001.bmp",
  L"data/actor/mokou/atkMidAir0002.bmp",
  L"data/actor/mokou/atkMidAir0003.bmp",
  L"data/actor/mokou/atkMidAir0004.bmp",
  L"data/actor/mokou/atkMidAir0005.bmp",
  L"data/actor/mokou/atkMidAir0006.bmp",
  L"data/actor/mokou/atkMidAir0007.bmp",
  L"data/actor/mokou/atkMidAir0008.bmp",
  L"data/actor/mokou/beginBattleA0000.bmp",
  L"data/actor/mokou/beginBattleA0001.bmp",
  L"data/actor/mokou/beginBattleA0002.bmp",
  L"data/actor/mokou/beginBattleA0003.bmp",
  L"data/actor/mokou/beginBattleA0004.bmp",
  L"data/actor/mokou/beginBattleA0005.bmp",
  L"data/actor/mokou/beginBattleA0006.bmp",
  L"data/actor/mokou/beginBattleA0007.bmp",
  L"data/actor/mokou/beginBattleA0008.bmp",
  L"data/actor/mokou/bmsln/reimu_buster.bmb",
  L"data/actor/mokou/bmsln/reimu_busterHit.bmb",
  L"data/actor/mokou/bmsln/reimu_fallKickA.bmb",
  L"data/actor/mokou/bmsln/reimu_HighShotBaria.bmb",
  L"data/actor/mokou/bmsln/reimu_keisei.bmb",
  L"data/actor/mokou/bmsln/reimu_kibakuzinA.bmb",
  L"data/actor/mokou/bmsln/reimu_musouB.bmb",
  L"data/actor/mokou/bmsln/reimu_musouG.bmb",
  L"data/actor/mokou/bmsln/reimu_musouHitB.bmb",
  L"data/actor/mokou/bmsln/reimu_musouHitG.bmb",
  L"data/actor/mokou/bmsln/reimu_musouHitR.bmb",
  L"data/actor/mokou/bmsln/reimu_musouR.bmb",
  L"data/actor/mokou/bmsln/reimu_shot.bmb",
  L"data/actor/mokou/bmsln/reimu_shotA.bmb",
  L"data/actor/mokou/bmsln/reimu_shotA_gateRing.bmb",
  L"data/actor/mokou/bmsln/reimu_shotA_hit.bmb",
  L"data/actor/mokou/bmsln/reimu_skillG_kick.bmb",
  L"data/actor/mokou/bmsln/reimu_TenseiA000.bmb",
  L"data/actor/mokou/bmsln/reimu_tenseiFinish.bmb",
  L"data/actor/mokou/bmsln/reimu_tenseiRock.bmb",
  L"data/actor/mokou/bmsln/reimu_tenseiRockShot.bmb",
  L"data/actor/mokou/bmsln/shot_A_000.bmb",
  L"data/actor/mokou/bmsln/shot_A_000.bmsln",
  L"data/actor/mokou/climax0000.bmp",
  L"data/actor/mokou/climax0001.bmp",
  L"data/actor/mokou/climax0002.bmp",
  L"data/actor/mokou/climax0003.bmp",
  L"data/actor/mokou/climax0004.bmp",
  L"data/actor/mokou/climax0005.bmp",
  L"data/actor/mokou/climax0006.bmp",
  L"data/actor/mokou/climax0007.bmp",
  L"data/actor/mokou/climaxCut0000.png",
  L"data/actor/mokou/damageBody0000.bmp",
  L"data/actor/mokou/damageBody0001.bmp",
  L"data/actor/mokou/damageBody0002.bmp",
  L"data/actor/mokou/damageBody0003.bmp",
  L"data/actor/mokou/damageHead0000.bmp",
  L"data/actor/mokou/damageHead0001.bmp",
  L"data/actor/mokou/damageHead0002.bmp",
  L"data/actor/mokou/damageHead0003.bmp",
  L"data/actor/mokou/damageHead0004.bmp",
  L"data/actor/mokou/damageSpin0000.bmp",
  L"data/actor/mokou/damageSpin0001.bmp",
  L"data/actor/mokou/damageSpin0002.bmp",
  L"data/actor/mokou/damageSpin0003.bmp",
  L"data/actor/mokou/damageupper0000.bmp",
  L"data/actor/mokou/damageUpper0001.bmp",
  L"data/actor/mokou/damageUpper0002.bmp",
  L"data/actor/mokou/damageUpper0003.bmp",
  L"data/actor/mokou/damageUpper0004.bmp",
  L"data/actor/mokou/damageUpper0005.bmp",
  L"data/actor/mokou/damageUpper0006.bmp",
  L"data/actor/mokou/damageUpper0007.bmp",
  L"data/actor/mokou/damageUpper0008.bmp",
  L"data/actor/mokou/damageUpper0009.bmp",
  L"data/actor/mokou/damageUpper0010.bmp",
  L"data/actor/mokou/damageWall0000.bmp",
  L"data/actor/mokou/damageWall0001.bmp",
  L"data/actor/mokou/damageWall0002.bmp",
  L"data/actor/mokou/damageWall0003.bmp",
  L"data/actor/mokou/damageWall0004.bmp",
  L"data/actor/mokou/damageWall0005.bmp",
  L"data/actor/mokou/dashBack0000.bmp",
  L"data/actor/mokou/dashBack0001.bmp",
  L"data/actor/mokou/dashBack0002.bmp",
  L"data/actor/mokou/dashBack0003.bmp",
  L"data/actor/mokou/dashBack0004.bmp",
  L"data/actor/mokou/dashBackLoop0000.bmp",
  L"data/actor/mokou/dashBackLoop0001.bmp",
  L"data/actor/mokou/dashBackLoop0002.bmp",
  L"data/actor/mokou/dashBackLoop0003.bmp",
  L"data/actor/mokou/dashFront0000.bmp",
  L"data/actor/mokou/dashFront0001.bmp",
  L"data/actor/mokou/dashFront0002.bmp",
  L"data/actor/mokou/dashFront0003.bmp",
  L"data/actor/mokou/dashFront0004.bmp",
  L"data/actor/mokou/dashFrontLoop0000.bmp",
  L"data/actor/mokou/dashFrontLoop0001.bmp",
  L"data/actor/mokou/dashFrontLoop0002.bmp",
  L"data/actor/mokou/dashFrontLoop0003.bmp",
  L"data/actor/mokou/down0000.bmp",
  L"data/actor/mokou/down0001.bmp",
  L"data/actor/mokou/down0002.bmp",
  L"data/actor/mokou/down0003.bmp",
  L"data/actor/mokou/dummy.bmp",
  L"data/actor/mokou/face_spellCallB.png",
  L"data/actor/mokou/guard0000.bmp",
  L"data/actor/mokou/guard0001.bmp",
  L"data/actor/mokou/guard0002.bmp",
  L"data/actor/mokou/guardCrash0000.bmp",
  L"data/actor/mokou/guardCrash0001.bmp",
  L"data/actor/mokou/guardCrash0002.bmp",
  L"data/actor/mokou/guardCrash0003.bmp",
  L"data/actor/mokou/guardMiss0000.bmp",
  L"data/actor/mokou/guardMiss0001.bmp",
  L"data/actor/mokou/guardMiss0002.bmp",
  L"data/actor/mokou/guardMiss0003.bmp",
  L"data/actor/mokou/lose0000.bmp",
  L"data/actor/mokou/lose0001.bmp",
  L"data/actor/mokou/lose0002.bmp",
  L"data/actor/mokou/lose0003.bmp",
  L"data/actor/mokou/lose0004.bmp",
  L"data/actor/mokou/lose0005.bmp",
  L"data/actor/mokou/lose0006.bmp",
  L"data/actor/mokou/mokou.pat",
  L"data/actor/mokou/mokou_ed.pat",
  L"data/actor/mokou/occult0000.bmp",
  L"data/actor/mokou/occult0001.bmp",
  L"data/actor/mokou/occult0002.bmp",
  L"data/actor/mokou/occult0003.bmp",
  L"data/actor/mokou/occultLoop0000.bmp",
  L"data/actor/mokou/occultLoop0001.bmp",
  L"data/actor/mokou/occultLoop0002.bmp",
  L"data/actor/mokou/occultLoop0003.bmp",
  L"data/actor/mokou/palette000.bmp",
  L"data/actor/mokou/palette001.bmp",
  L"data/actor/mokou/palette002.bmp",
  L"data/actor/mokou/palette003.bmp",
  L"data/actor/mokou/palette004.bmp",
  L"data/actor/mokou/palette005.bmp",
  L"data/actor/mokou/palette006.bmp",
  L"data/actor/mokou/palette007.bmp",
  L"data/actor/mokou/shotFront0000.bmp",
  L"data/actor/mokou/shotFront0001.bmp",
  L"data/actor/mokou/shotFront0002.bmp",
  L"data/actor/mokou/shotFront0003.bmp",
  L"data/actor/mokou/shotFront0004.bmp",
  L"data/actor/mokou/shotFront0005.bmp",
  L"data/actor/mokou/shotFront0006.bmp",
  L"data/actor/mokou/shotFront0007.bmp",
  L"data/actor/mokou/shotFront0008.bmp",
  L"data/actor/mokou/shotNormal0000.bmp",
  L"data/actor/mokou/shotNormal0001.bmp",
  L"data/actor/mokou/shotNormal0002.bmp",
  L"data/actor/mokou/shotNormal0003.bmp",
  L"data/actor/mokou/shotNormal0004.bmp",
  L"data/actor/mokou/shotNormal0005.bmp",
  L"data/actor/mokou/shotNormal0006.bmp",
  L"data/actor/mokou/shotNormal0007.bmp",
  L"data/actor/mokou/skillA0000.bmp",
  L"data/actor/mokou/skillA0001.bmp",
  L"data/actor/mokou/skillA0002.bmp",
  L"data/actor/mokou/skillA0003.bmp",
  L"data/actor/mokou/skillA0004.bmp",
  L"data/actor/mokou/skillA0005.bmp",
  L"data/actor/mokou/skillA0006.bmp",
  L"data/actor/mokou/skillA0007.bmp",
  L"data/actor/mokou/skillA0008.bmp",
  L"data/actor/mokou/skillA0009.bmp",
  L"data/actor/mokou/skillB0000.bmp",
  L"data/actor/mokou/skillB0001.bmp",
  L"data/actor/mokou/skillB0002.bmp",
  L"data/actor/mokou/skillB0003.bmp",
  L"data/actor/mokou/skillB0004.bmp",
  L"data/actor/mokou/skillB0005.bmp",
  L"data/actor/mokou/skillB0006.bmp",
  L"data/actor/mokou/skillB0007.bmp",
  L"data/actor/mokou/skillB0008.bmp",
  L"data/actor/mokou/skillBb0000.bmp",
  L"data/actor/mokou/skillBb0001.bmp",
  L"data/actor/mokou/skillBb0002.bmp",
  L"data/actor/mokou/skillBb0003.bmp",
  L"data/actor/mokou/skillBb0004.bmp",
  L"data/actor/mokou/skillBb0005.bmp",
  L"data/actor/mokou/skillBb0006.bmp",
  L"data/actor/mokou/skillB_bomb0000.bmp",
  L"data/actor/mokou/skillC0000.bmp",
  L"data/actor/mokou/skillC0001.bmp",
  L"data/actor/mokou/skillC0002.bmp",
  L"data/actor/mokou/skillC0003.bmp",
  L"data/actor/mokou/skillC0004.bmp",
  L"data/actor/mokou/skillC0005.bmp",
  L"data/actor/mokou/skillC0006.bmp",
  L"data/actor/mokou/skillC0007.bmp",
  L"data/actor/mokou/skillC0008.bmp",
  L"data/actor/mokou/skillD0000.bmp",
  L"data/actor/mokou/skillD0001.bmp",
  L"data/actor/mokou/skillD0002.bmp",
  L"data/actor/mokou/skillD0003.bmp",
  L"data/actor/mokou/skillD0004.bmp",
  L"data/actor/mokou/skillD0005.bmp",
  L"data/actor/mokou/skillD0006.bmp",
  L"data/actor/mokou/skillD0007.bmp",
  L"data/actor/mokou/skillD0008.bmp",
  L"data/actor/mokou/skillD0009.bmp",
  L"data/actor/mokou/skillD0010.bmp",
  L"data/actor/mokou/skillE0000.bmp",
  L"data/actor/mokou/skillE0001.bmp",
  L"data/actor/mokou/skillE0002.bmp",
  L"data/actor/mokou/skillE0003.bmp",
  L"data/actor/mokou/skillE0004.bmp",
  L"data/actor/mokou/skillE0005.bmp",
  L"data/actor/mokou/skillE0006.bmp",
  L"data/actor/mokou/skillE0007.bmp",
  L"data/actor/mokou/skillE0008.bmp",
  L"data/actor/mokou/skillE0009.bmp",
  L"data/actor/mokou/skillE0010.bmp",
  L"data/actor/mokou/skillE_Loop0000.bmp",
  L"data/actor/mokou/skillE_Loop0001.bmp",
  L"data/actor/mokou/skillE_Loop0002.bmp",
  L"data/actor/mokou/skillE_Loop0003.bmp",
  L"data/actor/mokou/skillF0000.bmp",
  L"data/actor/mokou/skillF0001.bmp",
  L"data/actor/mokou/skillF0002.bmp",
  L"data/actor/mokou/skillF0003.bmp",
  L"data/actor/mokou/skillF0004.bmp",
  L"data/actor/mokou/skillF0005.bmp",
  L"data/actor/mokou/skillF0006.bmp",
  L"data/actor/mokou/skillF0007.bmp",
  L"data/actor/mokou/skillG0000.bmp",
  L"data/actor/mokou/skillG0001.bmp",
  L"data/actor/mokou/skillG0002.bmp",
  L"data/actor/mokou/slide0000.bmp",
  L"data/actor/mokou/slide0001.bmp",
  L"data/actor/mokou/slide0002.bmp",
  L"data/actor/mokou/slide0003.bmp",
  L"data/actor/mokou/slide0004.bmp",
  L"data/actor/mokou/slide0005.bmp",
  L"data/actor/mokou/slide0006.bmp",
  L"data/actor/mokou/slideUnderLoop0000.bmp",
  L"data/actor/mokou/slideUnderLoop0001.bmp",
  L"data/actor/mokou/slideUnderLoop0002.bmp",
  L"data/actor/mokou/slideUnderLoop0003.bmp",
  L"data/actor/mokou/slideUpperLoop0000.bmp",
  L"data/actor/mokou/slideUpperLoop0001.bmp",
  L"data/actor/mokou/slideUpperLoop0002.bmp",
  L"data/actor/mokou/slideUpperLoop0003.bmp",
  L"data/actor/mokou/spellA0000.bmp",
  L"data/actor/mokou/spellA0001.bmp",
  L"data/actor/mokou/spellA0002.bmp",
  L"data/actor/mokou/spellA0003.bmp",
  L"data/actor/mokou/spellA0004.bmp",
  L"data/actor/mokou/spellA0005.bmp",
  L"data/actor/mokou/spellA0006.bmp",
  L"data/actor/mokou/spellA0007.bmp",
  L"data/actor/mokou/spellA0008.bmp",
  L"data/actor/mokou/spellA0009.bmp",
  L"data/actor/mokou/spellA0010.bmp",
  L"data/actor/mokou/spellA0011.bmp",
  L"data/actor/mokou/spellA0012.bmp",
  L"data/actor/mokou/spellC00.png",
  L"data/actor/mokou/spellC0000.bmp",
  L"data/actor/mokou/spellC0001.bmp",
  L"data/actor/mokou/spellC0002.bmp",
  L"data/actor/mokou/spellC0003.bmp",
  L"data/actor/mokou/spellC0004.bmp",
  L"data/actor/mokou/spellC0005.bmp",
  L"data/actor/mokou/spellC0006.bmp",
  L"data/actor/mokou/spellC0007.bmp",
  L"data/actor/mokou/spellC0008.bmp",
  L"data/actor/mokou/spellC0009.bmp",
  L"data/actor/mokou/spellC0010.bmp",
  L"data/actor/mokou/spellC0011.bmp",
  L"data/actor/mokou/spellC0012.bmp",
  L"data/actor/mokou/spellC0013.bmp",
  L"data/actor/mokou/spellC01.png",
  L"data/actor/mokou/spellC02.png",
  L"data/actor/mokou/spellC03.png",
  L"data/actor/mokou/spellC04.png",
  L"data/actor/mokou/spellC05.png",
  L"data/actor/mokou/spellC06.png",
  L"data/actor/mokou/spellCall0000.bmp",
  L"data/actor/mokou/spellCall0001.bmp",
  L"data/actor/mokou/spellCall0002.bmp",
  L"data/actor/mokou/spellCall0003.bmp",
  L"data/actor/mokou/spellCall0004.bmp",
  L"data/actor/mokou/stand0000.bmp",
  L"data/actor/mokou/stand0001.bmp",
  L"data/actor/mokou/stand0002.bmp",
  L"data/actor/mokou/stand0003.bmp",
  L"data/actor/mokou/stand0004.bmp",
  L"data/actor/mokou/stand0005.bmp",
  L"data/actor/mokou/stand0006.bmp",
  L"data/actor/mokou/stand0007.bmp",
  L"data/actor/mokou/stand0008.bmp",
  L"data/actor/mokou/stand0009.bmp",
  L"data/actor/mokou/stand0010.bmp",
  L"data/actor/mokou/stand0011.bmp",
  L"data/actor/mokou/stand0012.bmp",
  L"data/actor/mokou/stunLoop0000.bmp",
  L"data/actor/mokou/stunLoop0001.bmp",
  L"data/actor/mokou/stunLoop0002.bmp",
  L"data/actor/mokou/stunLoop0003.bmp",
  L"data/actor/mokou/stunLoop0004.bmp",
  L"data/actor/mokou/test_effect.bmp",
  L"data/actor/mokou/test_lose0000.bmp",
  L"data/actor/mokou/test_lose0001.bmp",
  L"data/actor/mokou/texture/amulet0000.dds",
  L"data/actor/mokou/texture/amulet0001.dds",
  L"data/actor/mokou/texture/atkAirMidFire0000.dds",
  L"data/actor/mokou/texture/atkMidFire0000.dds",
  L"data/actor/mokou/texture/atkMidFire0001.dds",
  L"data/actor/mokou/texture/atkUpperEffect0000.dds",
  L"data/actor/mokou/texture/atkUpperEffect0001.dds",
  L"data/actor/mokou/texture/ball.bmp",
  L"data/actor/mokou/texture/chargeShot_fire0000.dds",
  L"data/actor/mokou/texture/chargeShot_fire0001.dds",
  L"data/actor/mokou/texture/charge_trail0000.png",
  L"data/actor/mokou/texture/charge_trail0001.png",
  L"data/actor/mokou/texture/climax_cut0000.dds",
  L"data/actor/mokou/texture/climax_Fire0000.png",
  L"data/actor/mokou/texture/climax_pilar0000.png",
  L"data/actor/mokou/texture/climax_pilar0001.png",
  L"data/actor/mokou/texture/climax_pilar0002.png",
  L"data/actor/mokou/texture/firePart0000.dds",
  L"data/actor/mokou/texture/fireWing0000.dds",
  L"data/actor/mokou/texture/marisaBall2.bmp",
  L"data/actor/mokou/texture/marisaStarFlare.bmp",
  L"data/actor/mokou/texture/mask_ball.png",
  L"data/actor/mokou/texture/mokou_fireBase0000.png",
  L"data/actor/mokou/texture/mokou_fireBase0001.png",
  L"data/actor/mokou/texture/mokou_FireTexture0000.png",
  L"data/actor/mokou/texture/mokou_FireTexture0001.png",
  L"data/actor/mokou/texture/mokou_occultFire0000.png",
  L"data/actor/mokou/texture/moko_animal00000.png",
  L"data/actor/mokou/texture/moko_animal00006.png",
  L"data/actor/mokou/texture/moko_animal00012.png",
  L"data/actor/mokou/texture/moko_animal00018.png",
  L"data/actor/mokou/texture/moko_animal00024.png",
  L"data/actor/mokou/texture/moko_animalDamage00000.png",
  L"data/actor/mokou/texture/moko_animalDamage00006.png",
  L"data/actor/mokou/texture/moko_animalDamage00012.png",
  L"data/actor/mokou/texture/moko_animalDamage00018.png",
  L"data/actor/mokou/texture/moko_animalDamage00024.png",
  L"data/actor/mokou/texture/musou_trail.png",
  L"data/actor/mokou/texture/occult_fireB0000.dds",
  L"data/actor/mokou/texture/occult_fireR0000.dds",
  L"data/actor/mokou/texture/ooiri2.png",
  L"data/actor/mokou/texture/reimu_fallKick.png",
  L"data/actor/mokou/texture/shotFrontBird0000.dds",
  L"data/actor/mokou/texture/shot_object0000.dds",
  L"data/actor/mokou/texture/shot_object0001.dds",
  L"data/actor/mokou/texture/skillB_clow0000.dds",
  L"data/actor/mokou/texture/skillB_clow0001.dds",
  L"data/actor/mokou/texture/skillExp0000.dds",
  L"data/actor/mokou/texture/skillExp0001.dds",
  L"data/actor/mokou/texture/skillE_fire0000.dds",
  L"data/actor/mokou/texture/skillE_fire0001.dds",
  L"data/actor/mokou/texture/skillE_fire0002.dds",
  L"data/actor/mokou/texture/skillF_mokoFire0000.png",
  L"data/actor/mokou/texture/skillF_mokoFire0001.png",
  L"data/actor/mokou/texture/skillF_mokoFire0002.png",
  L"data/actor/mokou/texture/skillF_mokoFire0003.png",
  L"data/actor/mokou/texture/skillF_mokoFire0004.png",
  L"data/actor/mokou/texture/skillF_mokoFire0005.png",
  L"data/actor/mokou/texture/spellA_fire0000.dds",
  L"data/actor/mokou/texture/spellA_fireVortex0000.dds",
  L"data/actor/mokou/texture/spellA_fireVortex0000.png",
  L"data/actor/mokou/texture/spellA_fireVortex0001.dds",
  L"data/actor/mokou/texture/spellA_fireVortex0002.dds",
  L"data/actor/mokou/texture/spellB_fujiFire.dds",
  L"data/actor/mokou/texture/spellB_fujiFireB.dds",
  L"data/actor/mokou/texture/spellB_slash0000.dds",
  L"data/actor/mokou/texture/spellB_slash0001.dds",
  L"data/actor/mokou/texture/spellB_stone0000.dds",
  L"data/actor/mokou/texture/spellC_fire.dds",
  L"data/actor/mokou/texture/spellC_fire0001.dds",
  L"data/actor/mokou/texture/swing0000.png",
  L"data/actor/mokou/texture/swing0001.png",
  L"data/actor/mokou/walkBack0000.bmp",
  L"data/actor/mokou/walkBack0001.bmp",
  L"data/actor/mokou/walkBack0002.bmp",
  L"data/actor/mokou/walkBack0003.bmp",
  L"data/actor/mokou/walkBackloop0000.bmp",
  L"data/actor/mokou/walkBackloop0001.bmp",
  L"data/actor/mokou/walkBackloop0002.bmp",
  L"data/actor/mokou/walkBackloop0003.bmp",
  L"data/actor/mokou/walkFront0000.bmp",
  L"data/actor/mokou/walkFront0001.bmp",
  L"data/actor/mokou/walkFront0002.bmp",
  L"data/actor/mokou/walkFront0003.bmp",
  L"data/actor/mokou/walkFront0004.bmp",
  L"data/actor/mokou/walkFrontLoop0000.bmp",
  L"data/actor/mokou/walkFrontLoop0001.bmp",
  L"data/actor/mokou/walkFrontLoop0002.bmp",
  L"data/actor/mokou/walkFrontLoop0003.bmp",
  L"data/actor/mokou/winA0000.bmp",
  L"data/actor/mokou/winA0001.bmp",
  L"data/actor/mokou/winA0002.bmp",
  L"data/actor/mokou/winA0003.bmp",
  L"data/actor/mokou/winA0004.bmp",
  L"data/actor/mokou/winA0005.bmp",
  L"data/actor/mokou/winB0000.bmp",
  L"data/actor/mokou/winB0001.bmp",
  L"data/actor/mokou/winB0002.bmp",
  L"data/actor/mokou/winB0003.bmp",
  L"data/actor/mokou/winB0004.bmp",
  L"data/actor/mokou/winB0005.bmp",
  L"data/actor/mokou/winB0006.bmp",
  L"data/actor/mokou/winB0007.bmp",
  L"data/actor/mokou/wingA0000.bmp",
  L"data/actor/mokou/wingA0001.bmp",
  L"data/actor/mokou/wingA0002.bmp",
  L"data/actor/mokou/wingA0003.bmp",
  L"data/actor/mokou/wingA0004.bmp",
  L"data/actor/mokou/wingA0005.bmp",
  L"data/actor/mokou/wingA0006.bmp",
  L"data/actor/mokou/wingAb0000.bmp",
  L"data/actor/mokou/wingAb0001.bmp",
  L"data/actor/mokou/wingAb0002.bmp",
  L"data/actor/mokou/wingAb0003.bmp",
  L"data/actor/mokou/wingAb0004.bmp",
  L"data/actor/mokou/wingAb0005.bmp",
  L"data/actor/mokou/wingAb0006.bmp",
  L"data/actor/mokou/wingB0000.bmp",
  L"data/actor/mokou/wingB0001.bmp",
  L"data/actor/mokou/wingB0002.bmp",
  L"data/actor/mokou/wingB0003.bmp",
  L"data/actor/mokou/wingB0004.bmp",
  L"data/actor/mokou/wingB0005.bmp",
  L"data/actor/mokou/wingB0006.bmp",
  L"data/actor/mokou/wingB0007.bmp",
  L"data/actor/mokou/wingB0008.bmp",
  L"data/actor/mokou/wingB0009.bmp",
  L"data/actor/mokou/wingB0010.bmp",
  L"data/actor/mokou/wingBb0000.bmp",
  L"data/actor/mokou/wingBb0001.bmp",
  L"data/actor/mokou/wingBb0002.bmp",
  L"data/actor/mokou/wingBb0003.bmp",
  L"data/actor/mokou/wingBb0004.bmp",
  L"data/actor/mokou/wingBb0005.bmp",
  L"data/actor/mokou/wingBb0006.bmp",
  L"data/actor/mokou/wingBb0007.bmp",
  L"data/actor/mokou/wingBb0008.bmp",
  L"data/actor/mokou/wingBb0009.bmp",
  L"data/actor/mokou/wingBb0010.bmp",
  L"data/actor/mokou/wingC0000.bmp",
  L"data/actor/mokou/wingC0001.bmp",
  L"data/actor/mokou/wingC0002.bmp",
  L"data/actor/mokou/wingD0000.bmp",
  L"data/actor/mokou/wingD0001.bmp",
  L"data/actor/mokou/wingD0002.bmp",
  L"data/actor/mokou/wingE0000.bmp",
  L"data/actor/mokou/wingE0001.bmp",
  L"data/actor/mokou/wingE0002.bmp",
  L"data/actor/mokou/wingE0003.bmp",
  L"data/actor/mokou/wingE0004.bmp",
  L"data/actor/mokou/wingE0005.bmp",
  L"data/actor/mokou/wingE0006.bmp",
  L"data/actor/mokou/wingE0007.bmp",
  L"data/actor/mokou/wingE0008.bmp",
  L"data/actor/mokou/wingE0009.bmp",
  L"data/actor/mokou/wingE0010.bmp",
  L"data/actor/mokou.nut",
  L"data/actor/mokouInit.nut",
  L"data/actor/mokou_base.nut",
  L"data/actor/mokou_boss.nut",
  L"data/actor/mokou_cpu.nut",
  L"data/actor/mokou_cpuBoss.nut",
  L"data/actor/mokou_shot.nut",
  L"data/actor/morph_futo/battleBeginB0000.bmp",
  L"data/actor/morph_futo/battleBeginB0001.bmp",
  L"data/actor/morph_futo/battleBeginB0002.bmp",
  L"data/actor/morph_futo/battleBeginB0003.bmp",
  L"data/actor/morph_futo/battleBeginB0004.bmp",
  L"data/actor/morph_futo/battleBeginB0005.bmp",
  L"data/actor/morph_futo/battleBeginB0006.bmp",
  L"data/actor/morph_futo/battleBeginB0007.bmp",
  L"data/actor/morph_futo/morph_futo.nut",
  L"data/actor/morph_futo/morph_futo.pat",
  L"data/actor/morph_futo/morph_futo_shot.nut",
  L"data/actor/morph_futo/palette000.bmp",
  L"data/actor/morph_futo/texture/dishA0000.png",
  L"data/actor/morph_futo/texture/skillG_000.png",
  L"data/actor/morph_futo/texture/skillG_001.png",
  L"data/actor/morph_futo/texture/skillG_002.png",
  L"data/actor/morph_futo/texture/skillG_003.png",
  L"data/actor/morph_futo/texture/skillG_004.png",
  L"data/actor/morph_futo/texture/skillG_005.png",
  L"data/actor/morph_futo/texture/skillG_006.png",
  L"data/actor/morph_futo/texture/skillG_007.png",
  L"data/actor/morph_futo/texture/skillG_008.png",
  L"data/actor/morph_futo/texture/skillG_009.png",
  L"data/actor/morph_futo/texture/skillG_010.png",
  L"data/actor/morph_futo/texture/skillG_011.png",
  L"data/actor/morph_futo/texture/skillG_012.png",
  L"data/actor/morph_futo/texture/skillG_013.png",
  L"data/actor/morph_futo/texture/skillG_014.png",
  L"data/actor/morph_futo/winA0000.bmp",
  L"data/actor/morph_futo/winA0001.bmp",
  L"data/actor/morph_futo/winA0002.bmp",
  L"data/actor/morph_futo/winA0003.bmp",
  L"data/actor/morph_futo/winA0004.bmp",
  L"data/actor/morph_futo/winA0005.bmp",
  L"data/actor/morph_futo/winA0006.bmp",
  L"data/actor/morph_hijiri/atkHigh0000.bmp",
  L"data/actor/morph_hijiri/atkHigh0001.bmp",
  L"data/actor/morph_hijiri/atkHigh0002.bmp",
  L"data/actor/morph_hijiri/atkHigh0003.bmp",
  L"data/actor/morph_hijiri/atkHigh0004.bmp",
  L"data/actor/morph_hijiri/atkHigh0005.bmp",
  L"data/actor/morph_hijiri/morph_hijiri.nut",
  L"data/actor/morph_hijiri/morph_hijiri.pat",
  L"data/actor/morph_hijiri/morph_hijiri_shot.nut",
  L"data/actor/morph_hijiri/palette000.bmp",
  L"data/actor/morph_hijiri/skillA0000.bmp",
  L"data/actor/morph_hijiri/skillA0001.bmp",
  L"data/actor/morph_hijiri/skillA0002.bmp",
  L"data/actor/morph_hijiri/skillA0003.bmp",
  L"data/actor/morph_hijiri/skillA0004.bmp",
  L"data/actor/morph_hijiri/skillAb0000.bmp",
  L"data/actor/morph_hijiri/skillAb0001.bmp",
  L"data/actor/morph_hijiri/skillAb0002.bmp",
  L"data/actor/morph_hijiri/skillAb0003.bmp",
  L"data/actor/morph_hijiri/skillAb0004.bmp",
  L"data/actor/morph_hijiri/texture/bladeB0000.png",
  L"data/actor/morph_hijiri/texture/bladeD0000.png",
  L"data/actor/morph_hijiri/texture/bladeE0000.png",
  L"data/actor/morph_ichirin/morph_ichirin.nut",
  L"data/actor/morph_ichirin/morph_ichirin.pat",
  L"data/actor/morph_ichirin/morph_ichirin_shot.nut",
  L"data/actor/morph_ichirin/palette000.bmp",
  L"data/actor/morph_ichirin/skillB0002.bmp",
  L"data/actor/morph_ichirin/skillB0003.bmp",
  L"data/actor/morph_ichirin/skillB0004.bmp",
  L"data/actor/morph_ichirin/skillB0005.bmp",
  L"data/actor/morph_ichirin/skillB0006.bmp",
  L"data/actor/morph_ichirin/skillB0007.bmp",
  L"data/actor/morph_ichirin/skillB0008.bmp",
  L"data/actor/morph_ichirin/skillB0009.bmp",
  L"data/actor/morph_ichirin/unzan_EffectD0000.bmp",
  L"data/actor/morph_ichirin/unzan_EffectD0001.bmp",
  L"data/actor/morph_ichirin/unzan_EffectD0002.bmp",
  L"data/actor/morph_ichirin/unzan_handD.png",
  L"data/actor/morph_ichirin/unzan_handD_a.png",
  L"data/actor/morph_ichirin/unzan_handD_c.png",
  L"data/actor/morph_koishi/atkHighFrontOB0004.bmp",
  L"data/actor/morph_koishi/morph_koishi.nut",
  L"data/actor/morph_koishi/morph_koishi.pat",
  L"data/actor/morph_koishi/morph_koishi_shot.nut",
  L"data/actor/morph_koishi/palette000.bmp",
  L"data/actor/morph_koishi/skillOB0000.bmp",
  L"data/actor/morph_koishi/skillOB0001.bmp",
  L"data/actor/morph_koishi/skillOB0002.bmp",
  L"data/actor/morph_koishi/skillOB0003.bmp",
  L"data/actor/morph_koishi/skillOB0004.bmp",
  L"data/actor/morph_koishi/skillOB0005.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0000.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0001.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0002.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0003.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0004.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0005.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0006.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0007.bmp",
  L"data/actor/morph_koishi/test_atkHighFront0008.bmp",
  L"data/actor/morph_koishi/texture/roseD.png",
  L"data/actor/morph_kokoro/bmsln/kokoro_blaze.bmb",
  L"data/actor/morph_kokoro/morph_kokoro.nut",
  L"data/actor/morph_kokoro/morph_kokoro.pat",
  L"data/actor/morph_kokoro/morph_kokoro_shot.nut",
  L"data/actor/morph_kokoro/palette000.bmp",
  L"data/actor/morph_kokoro/skillA0002.bmp",
  L"data/actor/morph_kokoro/skillA0003.bmp",
  L"data/actor/morph_kokoro/skillA0004.bmp",
  L"data/actor/morph_kokoro/skillA0005.bmp",
  L"data/actor/morph_kokoro/skillA0006.bmp",
  L"data/actor/morph_kokoro/skillA0007.bmp",
  L"data/actor/morph_kokoro/skillA0008.bmp",
  L"data/actor/morph_kokoro/skillA0009.bmp",
  L"data/actor/morph_kokoro/skillA0010.bmp",
  L"data/actor/morph_kokoro/texture/kokoro_fireB.png",
  L"data/actor/morph_kokoro/texture/kokoro_fireBase.png",
  L"data/actor/morph_kokoro/texture/kokoro_sparkLine.png",
  L"data/actor/morph_kokoro/texture/mantletest000.bmp",
  L"data/actor/morph_marisa/morph_marisa.nut",
  L"data/actor/morph_marisa/morph_marisa.pat",
  L"data/actor/morph_marisa/morph_marisa_shot.nut",
  L"data/actor/morph_marisa/palette000.bmp",
  L"data/actor/morph_marisa/skillE_BladeA0000.png",
  L"data/actor/morph_marisa/test_atkHighDash0000.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0001.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0002.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0003.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0004.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0005.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0006.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0007.bmp",
  L"data/actor/morph_marisa/test_atkHighDash0008.bmp",
  L"data/actor/morph_miko/mantletest000.bmp",
  L"data/actor/morph_miko/morph_miko.nut",
  L"data/actor/morph_miko/morph_miko.pat",
  L"data/actor/morph_miko/morph_miko_shot.nut",
  L"data/actor/morph_miko/palette000.bmp",
  L"data/actor/morph_miko/shotHigh0003.bmp",
  L"data/actor/morph_miko/shotHigh0004.bmp",
  L"data/actor/morph_miko/shotHigh0005.bmp",
  L"data/actor/morph_miko/shotHigh0006.bmp",
  L"data/actor/morph_miko/shotHigh0007.bmp",
  L"data/actor/morph_miko/shotHigh0008.bmp",
  L"data/actor/morph_miko/shotHigh0009.bmp",
  L"data/actor/morph_miko/shotHigh0010.bmp",
  L"data/actor/morph_miko/shotHigh0011.bmp",
  L"data/actor/morph_miko/texture/laserBaseA000.png",
  L"data/actor/morph_nitori/atkHighUpper0000.bmp",
  L"data/actor/morph_nitori/atkHighUpper0001.bmp",
  L"data/actor/morph_nitori/atkHighUpper0002.bmp",
  L"data/actor/morph_nitori/atkHighUpper0003.bmp",
  L"data/actor/morph_nitori/atkHighUpper0004.bmp",
  L"data/actor/morph_nitori/atkHighUpper0005.bmp",
  L"data/actor/morph_nitori/atkHighUpper0006.bmp",
  L"data/actor/morph_nitori/atkHighUpper0007.bmp",
  L"data/actor/morph_nitori/atkHighUpper0008.bmp",
  L"data/actor/morph_nitori/atkHighUpper0009.bmp",
  L"data/actor/morph_nitori/atkHighUpper0010.bmp",
  L"data/actor/morph_nitori/atkHighUpper0011.bmp",
  L"data/actor/morph_nitori/bmsln/morphnitori_dori.bmb",
  L"data/actor/morph_nitori/morph_nitori.nut",
  L"data/actor/morph_nitori/morph_nitori.pat",
  L"data/actor/morph_nitori/morph_nitori_shot.nut",
  L"data/actor/morph_nitori/palette000.bmp",
  L"data/actor/morph_nitori/texture/nitori_doriru.dds",
  L"data/actor/morph_nitori/texture/splashA.png",
  L"data/actor/morph_reimu/mask_ball.png",
  L"data/actor/morph_reimu/morph_reimu.nut",
  L"data/actor/morph_reimu/morph_reimu.pat",
  L"data/actor/morph_reimu/morph_reimu_shot.nut",
  L"data/actor/morph_reimu/palette000.bmp",
  L"data/actor/morph_reimu/reimu_onmyoBall.png",
  L"data/actor/morph_reimu/spellA0016.bmp",
  L"data/actor/morph_reimu/spellA0017.bmp",
  L"data/actor/morph_reimu/spellA0018.bmp",
  L"data/actor/morph_reimu/spellA0019.bmp",
  L"data/actor/morph_reimu/spellA0020.bmp",
  L"data/actor/morph_reimu/spellA0021.bmp",
  L"data/actor/morph_reimu/spellA0022.bmp",
  L"data/actor/morph_reimu/spellA0023.bmp",
  L"data/actor/neutralInit.nut",
  L"data/actor/nitori/armHead0000.bmp",
  L"data/actor/nitori/armHead0001.bmp",
  L"data/actor/nitori/armPoint.bmp",
  L"data/actor/nitori/armWire0000.bmp",
  L"data/actor/nitori/atkHigh0000.bmp",
  L"data/actor/nitori/atkHigh0001.bmp",
  L"data/actor/nitori/atkHigh0002.bmp",
  L"data/actor/nitori/atkHigh0003.bmp",
  L"data/actor/nitori/atkHigh0004.bmp",
  L"data/actor/nitori/atkHigh0005.bmp",
  L"data/actor/nitori/atkHigh0006.bmp",
  L"data/actor/nitori/atkHigh0007.bmp",
  L"data/actor/nitori/atkHighFront0000.bmp",
  L"data/actor/nitori/atkHighFront0001.bmp",
  L"data/actor/nitori/atkHighFront0002.bmp",
  L"data/actor/nitori/atkHighFront0003.bmp",
  L"data/actor/nitori/atkHighFront0004.bmp",
  L"data/actor/nitori/atkHighFront0005.bmp",
  L"data/actor/nitori/atkHighFront0006.bmp",
  L"data/actor/nitori/atkHighFront0007.bmp",
  L"data/actor/nitori/atkHighFront0008.bmp",
  L"data/actor/nitori/atkHighUnder0000.bmp",
  L"data/actor/nitori/atkHighUnder0001.bmp",
  L"data/actor/nitori/atkHighUnder0002.bmp",
  L"data/actor/nitori/atkHighUnder0003.bmp",
  L"data/actor/nitori/atkHighUnder0004.bmp",
  L"data/actor/nitori/atkHighUnder0005.bmp",
  L"data/actor/nitori/atkHighUnder0006.bmp",
  L"data/actor/nitori/atkHighUnder0007.bmp",
  L"data/actor/nitori/atkHighUpper0000.bmp",
  L"data/actor/nitori/atkHighUpper0001.bmp",
  L"data/actor/nitori/atkHighUpper0002.bmp",
  L"data/actor/nitori/atkHighUpper0003.bmp",
  L"data/actor/nitori/atkHighUpper0004.bmp",
  L"data/actor/nitori/atkHighUpper0005.bmp",
  L"data/actor/nitori/atkHighUpper0006.bmp",
  L"data/actor/nitori/atkHighUpper0007.bmp",
  L"data/actor/nitori/atkHighUpper0008.bmp",
  L"data/actor/nitori/atkHighUpper0009.bmp",
  L"data/actor/nitori/atkHighUpper0010.bmp",
  L"data/actor/nitori/atkHighUpper0011.bmp",
  L"data/actor/nitori/atkLow0000.bmp",
  L"data/actor/nitori/atkLow0001.bmp",
  L"data/actor/nitori/atkLow0002.bmp",
  L"data/actor/nitori/atkLow0003.bmp",
  L"data/actor/nitori/atkLow0004.bmp",
  L"data/actor/nitori/atkLow0005.bmp",
  L"data/actor/nitori/atkLow0006.bmp",
  L"data/actor/nitori/atkLow0007.bmp",
  L"data/actor/nitori/atkLow0008.bmp",
  L"data/actor/nitori/atkLow0009.bmp",
  L"data/actor/nitori/atkMid0000.bmp",
  L"data/actor/nitori/atkMid0001.bmp",
  L"data/actor/nitori/atkMid0002.bmp",
  L"data/actor/nitori/atkMid0003.bmp",
  L"data/actor/nitori/atkMid0004.bmp",
  L"data/actor/nitori/atkMid0005.bmp",
  L"data/actor/nitori/atkMid0006.bmp",
  L"data/actor/nitori/atkMid0007.bmp",
  L"data/actor/nitori/atkMid0008.bmp",
  L"data/actor/nitori/balloonA0000.bmp",
  L"data/actor/nitori/battleBeginA0000.bmp",
  L"data/actor/nitori/battleBeginA0001.bmp",
  L"data/actor/nitori/battleBeginA0002.bmp",
  L"data/actor/nitori/battleBeginA0003.bmp",
  L"data/actor/nitori/battleBeginA0004.bmp",
  L"data/actor/nitori/battleBeginA0005.bmp",
  L"data/actor/nitori/battleBeginA0006.bmp",
  L"data/actor/nitori/battleBeginA0007.bmp",
  L"data/actor/nitori/battleBeginB0000.bmp",
  L"data/actor/nitori/battleBeginB0001.bmp",
  L"data/actor/nitori/battleBeginB0002.bmp",
  L"data/actor/nitori/battleBeginB0003.bmp",
  L"data/actor/nitori/bmsln/nitori_AquaExp.bmb",
  L"data/actor/nitori/bmsln/nitori_climaxFire.bmb",
  L"data/actor/nitori/bmsln/nitori_fireWork.bmb",
  L"data/actor/nitori/canonA0000.bmp",
  L"data/actor/nitori/canonA0001.bmp",
  L"data/actor/nitori/canonA0002.bmp",
  L"data/actor/nitori/climax0000.bmp",
  L"data/actor/nitori/climax0001.bmp",
  L"data/actor/nitori/climax0002.bmp",
  L"data/actor/nitori/climax0003.bmp",
  L"data/actor/nitori/climax0004.bmp",
  L"data/actor/nitori/climax0005.bmp",
  L"data/actor/nitori/climax0006.bmp",
  L"data/actor/nitori/climax0007.bmp",
  L"data/actor/nitori/climax0008.bmp",
  L"data/actor/nitori/climax0009.bmp",
  L"data/actor/nitori/climaxMantle.bmp",
  L"data/actor/nitori/climaxMantleFlash.png",
  L"data/actor/nitori/climaxMaskA000.bmp",
  L"data/actor/nitori/damageBody0000.bmp",
  L"data/actor/nitori/damageBody0001.bmp",
  L"data/actor/nitori/damageBody0002.bmp",
  L"data/actor/nitori/damageBody0003.bmp",
  L"data/actor/nitori/damageBody0004.bmp",
  L"data/actor/nitori/damageDown0000.bmp",
  L"data/actor/nitori/damageDown0001.bmp",
  L"data/actor/nitori/damageDown0002.bmp",
  L"data/actor/nitori/damageDown0003.bmp",
  L"data/actor/nitori/damageDown0004.bmp",
  L"data/actor/nitori/damageDown0005.bmp",
  L"data/actor/nitori/damageDown0006.bmp",
  L"data/actor/nitori/damageDown0007.bmp",
  L"data/actor/nitori/damageHead0000.bmp",
  L"data/actor/nitori/damageHead0001.bmp",
  L"data/actor/nitori/damageHead0002.bmp",
  L"data/actor/nitori/damageHead0003.bmp",
  L"data/actor/nitori/damageHead0004.bmp",
  L"data/actor/nitori/damageSpin0000.bmp",
  L"data/actor/nitori/damageSpin0001.bmp",
  L"data/actor/nitori/damageSpin0002.bmp",
  L"data/actor/nitori/damageSpin0003.bmp",
  L"data/actor/nitori/damageUpper0000.bmp",
  L"data/actor/nitori/damageUpper0001.bmp",
  L"data/actor/nitori/damageUpper0002.bmp",
  L"data/actor/nitori/damageUpper0003.bmp",
  L"data/actor/nitori/damageUpper0004.bmp",
  L"data/actor/nitori/damageUpper0005.bmp",
  L"data/actor/nitori/damageUpper0006.bmp",
  L"data/actor/nitori/damageUpper0007.bmp",
  L"data/actor/nitori/damageUpper0008.bmp",
  L"data/actor/nitori/damageUpper0009.bmp",
  L"data/actor/nitori/damageUpper0010.bmp",
  L"data/actor/nitori/damageUpper0011.bmp",
  L"data/actor/nitori/damageUpper0012.bmp",
  L"data/actor/nitori/damageWall0000.bmp",
  L"data/actor/nitori/damageWall0001.bmp",
  L"data/actor/nitori/damageWall0002.bmp",
  L"data/actor/nitori/damageWall0003.bmp",
  L"data/actor/nitori/damageWall0004.bmp",
  L"data/actor/nitori/damageWall0005.bmp",
  L"data/actor/nitori/damageWall0006.bmp",
  L"data/actor/nitori/damageWall0007.bmp",
  L"data/actor/nitori/dashBack0000.bmp",
  L"data/actor/nitori/dashBack0001.bmp",
  L"data/actor/nitori/dashBack0002.bmp",
  L"data/actor/nitori/dashBack0003.bmp",
  L"data/actor/nitori/dashBack0004.bmp",
  L"data/actor/nitori/dashBack0005.bmp",
  L"data/actor/nitori/dashBackLoop0000.bmp",
  L"data/actor/nitori/dashBackLoop0001.bmp",
  L"data/actor/nitori/dashBackLoop0002.bmp",
  L"data/actor/nitori/dashFront0000.bmp",
  L"data/actor/nitori/dashFront0001.bmp",
  L"data/actor/nitori/dashFront0002.bmp",
  L"data/actor/nitori/dashFront0003.bmp",
  L"data/actor/nitori/dashFront0004.bmp",
  L"data/actor/nitori/dashFront0005.bmp",
  L"data/actor/nitori/dashFront0006.bmp",
  L"data/actor/nitori/dashFront0007.bmp",
  L"data/actor/nitori/dashFrontLoop0000.bmp",
  L"data/actor/nitori/dashFrontLoop0001.bmp",
  L"data/actor/nitori/dashFrontLoop0002.bmp",
  L"data/actor/nitori/face_spellCallB.png",
  L"data/actor/nitori/guard0000.bmp",
  L"data/actor/nitori/guard0001.bmp",
  L"data/actor/nitori/guard0002.bmp",
  L"data/actor/nitori/guard0003.bmp",
  L"data/actor/nitori/guardCrash0000.bmp",
  L"data/actor/nitori/guardCrash0001.bmp",
  L"data/actor/nitori/guardCrash0002.bmp",
  L"data/actor/nitori/guardCrash0003.bmp",
  L"data/actor/nitori/guardCrash0004.bmp",
  L"data/actor/nitori/guardCrash0005.bmp",
  L"data/actor/nitori/guardMiss0000.bmp",
  L"data/actor/nitori/guardMiss0001.bmp",
  L"data/actor/nitori/guardMiss0002.bmp",
  L"data/actor/nitori/guardMiss0003.bmp",
  L"data/actor/nitori/item0000.bmp",
  L"data/actor/nitori/item0001.bmp",
  L"data/actor/nitori/item0002.bmp",
  L"data/actor/nitori/item0003.bmp",
  L"data/actor/nitori/item0004.bmp",
  L"data/actor/nitori/item0005.bmp",
  L"data/actor/nitori/item0006.bmp",
  L"data/actor/nitori/item0007.bmp",
  L"data/actor/nitori/lose0000.bmp",
  L"data/actor/nitori/lose0001.bmp",
  L"data/actor/nitori/lose0002.bmp",
  L"data/actor/nitori/lose0003.bmp",
  L"data/actor/nitori/lose0004.bmp",
  L"data/actor/nitori/lose0005.bmp",
  L"data/actor/nitori/lose0006.bmp",
  L"data/actor/nitori/lose0007.bmp",
  L"data/actor/nitori/nitori.pat",
  L"data/actor/nitori/nitori_ed.pat",
  L"data/actor/nitori/occult0000.bmp",
  L"data/actor/nitori/occult0001.bmp",
  L"data/actor/nitori/occult0002.bmp",
  L"data/actor/nitori/occult0003.bmp",
  L"data/actor/nitori/occult0004.bmp",
  L"data/actor/nitori/occultloop0000.bmp",
  L"data/actor/nitori/occultloop0001.bmp",
  L"data/actor/nitori/occultloop0002.bmp",
  L"data/actor/nitori/occultloop0003.bmp",
  L"data/actor/nitori/occultloop0004.bmp",
  L"data/actor/nitori/occultswitch0000.bmp",
  L"data/actor/nitori/occultswitch0001.bmp",
  L"data/actor/nitori/occultswitch0002.bmp",
  L"data/actor/nitori/occultswitch0003.bmp",
  L"data/actor/nitori/occultswitch0004.bmp",
  L"data/actor/nitori/occult_nessy0000.bmp",
  L"data/actor/nitori/occult_nessy0001.bmp",
  L"data/actor/nitori/occult_nessy0002.bmp",
  L"data/actor/nitori/occult_nessy0003.bmp",
  L"data/actor/nitori/palette000.bmp",
  L"data/actor/nitori/palette001.bmp",
  L"data/actor/nitori/palette002.bmp",
  L"data/actor/nitori/palette003.bmp",
  L"data/actor/nitori/palette004.bmp",
  L"data/actor/nitori/palette005.bmp",
  L"data/actor/nitori/palette006.bmp",
  L"data/actor/nitori/palette007.bmp",
  L"data/actor/nitori/pallete.bmp",
  L"data/actor/nitori/shotExpA0000.bmp",
  L"data/actor/nitori/shotHigh0000.bmp",
  L"data/actor/nitori/shotHigh0001.bmp",
  L"data/actor/nitori/shotHigh0002.bmp",
  L"data/actor/nitori/shotHigh0003.bmp",
  L"data/actor/nitori/shotHigh0004.bmp",
  L"data/actor/nitori/shotHigh0005.bmp",
  L"data/actor/nitori/shotHigh0006.bmp",
  L"data/actor/nitori/shotHigh0007.bmp",
  L"data/actor/nitori/shotHigh0008.bmp",
  L"data/actor/nitori/shotHighUnder0000.bmp",
  L"data/actor/nitori/shotHighUnder0001.bmp",
  L"data/actor/nitori/shotHighUnder0002.bmp",
  L"data/actor/nitori/shotHighUnder0003.bmp",
  L"data/actor/nitori/shotHighUnder0004.bmp",
  L"data/actor/nitori/shotHighUnder0005.bmp",
  L"data/actor/nitori/shotHighUnder0006.bmp",
  L"data/actor/nitori/shotHighUnder0007.bmp",
  L"data/actor/nitori/shotHighUnder0008.bmp",
  L"data/actor/nitori/shotLow0000.bmp",
  L"data/actor/nitori/shotLow0001.bmp",
  L"data/actor/nitori/shotLow0002.bmp",
  L"data/actor/nitori/shotLow0003.bmp",
  L"data/actor/nitori/shotLow0004.bmp",
  L"data/actor/nitori/shotLow0005.bmp",
  L"data/actor/nitori/shotLow0006.bmp",
  L"data/actor/nitori/shotLow0007.bmp",
  L"data/actor/nitori/shotLowUnder0001.bmp",
  L"data/actor/nitori/shotLowUnder0002.bmp",
  L"data/actor/nitori/shotLowUpper0000.bmp",
  L"data/actor/nitori/shotLowUpper0002.bmp",
  L"data/actor/nitori/skillA0000.bmp",
  L"data/actor/nitori/skillA0001.bmp",
  L"data/actor/nitori/skillA0002.bmp",
  L"data/actor/nitori/skillA0003.bmp",
  L"data/actor/nitori/skillA0004.bmp",
  L"data/actor/nitori/skillA0005.bmp",
  L"data/actor/nitori/skillA0006.bmp",
  L"data/actor/nitori/skillA0007.bmp",
  L"data/actor/nitori/skillB0000.bmp",
  L"data/actor/nitori/skillB0001.bmp",
  L"data/actor/nitori/skillB0002.bmp",
  L"data/actor/nitori/skillB0003.bmp",
  L"data/actor/nitori/skillB0004.bmp",
  L"data/actor/nitori/skillB0005.bmp",
  L"data/actor/nitori/skillB0006.bmp",
  L"data/actor/nitori/skillB0007.bmp",
  L"data/actor/nitori/skillBb0000.bmp",
  L"data/actor/nitori/skillC0000.bmp",
  L"data/actor/nitori/skillC0001.bmp",
  L"data/actor/nitori/skillC0002.bmp",
  L"data/actor/nitori/skillC0003.bmp",
  L"data/actor/nitori/skillC0004.bmp",
  L"data/actor/nitori/skillC0005.bmp",
  L"data/actor/nitori/skillC0006.bmp",
  L"data/actor/nitori/skillC0007.bmp",
  L"data/actor/nitori/skillD0000.bmp",
  L"data/actor/nitori/skillD0001.bmp",
  L"data/actor/nitori/skillD0002.bmp",
  L"data/actor/nitori/skillD0003.bmp",
  L"data/actor/nitori/skillD0004.bmp",
  L"data/actor/nitori/skillD0005.bmp",
  L"data/actor/nitori/skillD0006.bmp",
  L"data/actor/nitori/skillD0007.bmp",
  L"data/actor/nitori/skillE0000.bmp",
  L"data/actor/nitori/skillE0001.bmp",
  L"data/actor/nitori/skillE0002.bmp",
  L"data/actor/nitori/skillE0003.bmp",
  L"data/actor/nitori/skillE0004.bmp",
  L"data/actor/nitori/skillE0005.bmp",
  L"data/actor/nitori/skillE0006.bmp",
  L"data/actor/nitori/skillE0007.bmp",
  L"data/actor/nitori/skillE0008.bmp",
  L"data/actor/nitori/skillE0009.bmp",
  L"data/actor/nitori/skillE0010.bmp",
  L"data/actor/nitori/skillE0011.bmp",
  L"data/actor/nitori/skillE0012.bmp",
  L"data/actor/nitori/skillE0013.bmp",
  L"data/actor/nitori/skillE0014.bmp",
  L"data/actor/nitori/skillG0000.bmp",
  L"data/actor/nitori/skillG0001.bmp",
  L"data/actor/nitori/skillG0002.bmp",
  L"data/actor/nitori/skillG0003.bmp",
  L"data/actor/nitori/skillG0004.bmp",
  L"data/actor/nitori/skillG0005.bmp",
  L"data/actor/nitori/skillG0006.bmp",
  L"data/actor/nitori/skillG_Loop0000.bmp",
  L"data/actor/nitori/skillG_Loop0001.bmp",
  L"data/actor/nitori/skillG_Loop0002.bmp",
  L"data/actor/nitori/slide0000.bmp",
  L"data/actor/nitori/slide0001.bmp",
  L"data/actor/nitori/slide0002.bmp",
  L"data/actor/nitori/slide0003.bmp",
  L"data/actor/nitori/slide0004.bmp",
  L"data/actor/nitori/slide0005.bmp",
  L"data/actor/nitori/slide0006.bmp",
  L"data/actor/nitori/slide0007.bmp",
  L"data/actor/nitori/slide0008.bmp",
  L"data/actor/nitori/slide0009.bmp",
  L"data/actor/nitori/slide0010.bmp",
  L"data/actor/nitori/slideLoopUnder0000.bmp",
  L"data/actor/nitori/slideLoopUnder0001.bmp",
  L"data/actor/nitori/slideLoopUnder0002.bmp",
  L"data/actor/nitori/slideLoopUnder0003.bmp",
  L"data/actor/nitori/slideLoopUnder0004.bmp",
  L"data/actor/nitori/slideLoopUpper0000.bmp",
  L"data/actor/nitori/slideLoopUpper0001.bmp",
  L"data/actor/nitori/slideLoopUpper0002.bmp",
  L"data/actor/nitori/spellA0000.bmp",
  L"data/actor/nitori/spellA0001.bmp",
  L"data/actor/nitori/spellA0002.bmp",
  L"data/actor/nitori/spellA0003.bmp",
  L"data/actor/nitori/spellA0004.bmp",
  L"data/actor/nitori/spellA0005.bmp",
  L"data/actor/nitori/spellA0006.bmp",
  L"data/actor/nitori/spellA0007.bmp",
  L"data/actor/nitori/spellA0008.bmp",
  L"data/actor/nitori/spellB0000.bmp",
  L"data/actor/nitori/spellB0001.bmp",
  L"data/actor/nitori/spellB0002.bmp",
  L"data/actor/nitori/spellB0003.bmp",
  L"data/actor/nitori/spellB0004.bmp",
  L"data/actor/nitori/spellB0005.bmp",
  L"data/actor/nitori/spellB0006.bmp",
  L"data/actor/nitori/spellB0007.bmp",
  L"data/actor/nitori/spellB0008.bmp",
  L"data/actor/nitori/spellB0009.bmp",
  L"data/actor/nitori/spellBack.png",
  L"data/actor/nitori/spellC0000.bmp",
  L"data/actor/nitori/spellC0001.bmp",
  L"data/actor/nitori/spellC0002.bmp",
  L"data/actor/nitori/spellC0003.bmp",
  L"data/actor/nitori/spellC0004.bmp",
  L"data/actor/nitori/spellC0005.bmp",
  L"data/actor/nitori/spellC0006.bmp",
  L"data/actor/nitori/spellC0007.bmp",
  L"data/actor/nitori/spellC0008.bmp",
  L"data/actor/nitori/spellC0009.bmp",
  L"data/actor/nitori/spellC0010.bmp",
  L"data/actor/nitori/spellC0011.bmp",
  L"data/actor/nitori/stand0000.bmp",
  L"data/actor/nitori/stand0001.bmp",
  L"data/actor/nitori/stand0002.bmp",
  L"data/actor/nitori/stand0003.bmp",
  L"data/actor/nitori/stand0004.bmp",
  L"data/actor/nitori/stand0005.bmp",
  L"data/actor/nitori/stand0006.bmp",
  L"data/actor/nitori/stand0007.bmp",
  L"data/actor/nitori/stand0008.bmp",
  L"data/actor/nitori/stand0009.bmp",
  L"data/actor/nitori/stand0010.bmp",
  L"data/actor/nitori/stand0011.bmp",
  L"data/actor/nitori/stand0012.bmp",
  L"data/actor/nitori/stun0000.bmp",
  L"data/actor/nitori/stun0001.bmp",
  L"data/actor/nitori/stun0002.bmp",
  L"data/actor/nitori/stunLoop0000.bmp",
  L"data/actor/nitori/stunLoop0001.bmp",
  L"data/actor/nitori/stunLoop0002.bmp",
  L"data/actor/nitori/stunLoop0003.bmp",
  L"data/actor/nitori/stunLoop0004.bmp",
  L"data/actor/nitori/testr_climaxback0000.png",
  L"data/actor/nitori/testr_climaxback0003.png",
  L"data/actor/nitori/testr_climaxFace.png",
  L"data/actor/nitori/testr_occult0003.png",
  L"data/actor/nitori/testr_occult0006.png",
  L"data/actor/nitori/test_atkDashLow0000.bmp",
  L"data/actor/nitori/test_atkDashLow0001.bmp",
  L"data/actor/nitori/test_atkDashLow0002.bmp",
  L"data/actor/nitori/test_atkDashLow0003.bmp",
  L"data/actor/nitori/test_atkDashLow0004.bmp",
  L"data/actor/nitori/test_atkDashLow0005.bmp",
  L"data/actor/nitori/test_atkDashLow0006.bmp",
  L"data/actor/nitori/test_atkDashLow0007.bmp",
  L"data/actor/nitori/test_atkDashLow0008.bmp",
  L"data/actor/nitori/test_atkDashLow0009.bmp",
  L"data/actor/nitori/test_atkDashLow0010.bmp",
  L"data/actor/nitori/test_atkDashLow0011.bmp",
  L"data/actor/nitori/texture/ball.png",
  L"data/actor/nitori/texture/bigWave.png",
  L"data/actor/nitori/texture/bubble0000.png",
  L"data/actor/nitori/texture/bulletFb000.bmp",
  L"data/actor/nitori/texture/bulletKa000.bmp",
  L"data/actor/nitori/texture/bullet_rainA000.bmp",
  L"data/actor/nitori/texture/chargeB.png",
  L"data/actor/nitori/texture/climaxback.png",
  L"data/actor/nitori/texture/climax_cut0000.dds",
  L"data/actor/nitori/texture/climax_fire0001.dds",
  L"data/actor/nitori/texture/climax_lake0000.dds",
  L"data/actor/nitori/texture/climax_smokeA.png",
  L"data/actor/nitori/texture/fireWorkA0000.png",
  L"data/actor/nitori/texture/gearA0000.dds",
  L"data/actor/nitori/texture/lightBar.png",
  L"data/actor/nitori/texture/marisa_SaturnA.png",
  L"data/actor/nitori/texture/nessy0000.dds",
  L"data/actor/nitori/texture/nessyponp0000.dds",
  L"data/actor/nitori/texture/nitori_animalDamage000.png",
  L"data/actor/nitori/texture/nitori_animalDamage001.png",
  L"data/actor/nitori/texture/nitori_animalDamage002.png",
  L"data/actor/nitori/texture/nitori_animalDamage003.png",
  L"data/actor/nitori/texture/nitori_animal_00000.png",
  L"data/actor/nitori/texture/nitori_animal_00001.png",
  L"data/actor/nitori/texture/nitori_animal_00002.png",
  L"data/actor/nitori/texture/nitori_animal_00003.png",
  L"data/actor/nitori/texture/nitori_animal_00004.png",
  L"data/actor/nitori/texture/nitori_animal_00005.png",
  L"data/actor/nitori/texture/nitori_animal_00006.png",
  L"data/actor/nitori/texture/nitori_animal_00007.png",
  L"data/actor/nitori/texture/nitori_animal_00008.png",
  L"data/actor/nitori/texture/nitori_animal_00009.png",
  L"data/actor/nitori/texture/nitori_animal_00010.png",
  L"data/actor/nitori/texture/nitori_animal_00011.png",
  L"data/actor/nitori/texture/nitori_bar.png",
  L"data/actor/nitori/texture/nitori_guage.png",
  L"data/actor/nitori/texture/nitori_mistloop0000.png",
  L"data/actor/nitori/texture/nitori_mistloop0001.png",
  L"data/actor/nitori/texture/nitori_mistloop0002.png",
  L"data/actor/nitori/texture/nitori_nessyeye0000.png",
  L"data/actor/nitori/texture/rain.png",
  L"data/actor/nitori/texture/rotorA.png",
  L"data/actor/nitori/texture/rotorBladeA0000.png",
  L"data/actor/nitori/texture/rotorBrake.png",
  L"data/actor/nitori/texture/searchlight.png",
  L"data/actor/nitori/texture/skillA.png",
  L"data/actor/nitori/texture/skillD0000.png",
  L"data/actor/nitori/texture/skillDD0001.png",
  L"data/actor/nitori/texture/skillG_bullet.png",
  L"data/actor/nitori/texture/spinWatarA0000.dds",
  L"data/actor/nitori/texture/splashA.png",
  L"data/actor/nitori/texture/splushA000.bmp",
  L"data/actor/nitori/texture/StarFlare.bmp",
  L"data/actor/nitori/texture/watarsplash0000.png",
  L"data/actor/nitori/texture/watarsplash0001.dds",
  L"data/actor/nitori/texture/waterBulletA0000.png",
  L"data/actor/nitori/turn0001.bmp",
  L"data/actor/nitori/turn0002.bmp",
  L"data/actor/nitori/turn0003.bmp",
  L"data/actor/nitori/walkBack0000.bmp",
  L"data/actor/nitori/walkBack0001.bmp",
  L"data/actor/nitori/walkBack0002.bmp",
  L"data/actor/nitori/walkBack0003.bmp",
  L"data/actor/nitori/walkBack0004.bmp",
  L"data/actor/nitori/walkBack0005.bmp",
  L"data/actor/nitori/walkBack0006.bmp",
  L"data/actor/nitori/walkBackloop0000.bmp",
  L"data/actor/nitori/walkBackloop0001.bmp",
  L"data/actor/nitori/walkBackloop0002.bmp",
  L"data/actor/nitori/walkBackloop0003.bmp",
  L"data/actor/nitori/walkBackloop0004.bmp",
  L"data/actor/nitori/walkFront0000.bmp",
  L"data/actor/nitori/walkFront0001.bmp",
  L"data/actor/nitori/walkFront0002.bmp",
  L"data/actor/nitori/walkFront0003.bmp",
  L"data/actor/nitori/walkFront0004.bmp",
  L"data/actor/nitori/walkFront0005.bmp",
  L"data/actor/nitori/walkFrontLoop0000.bmp",
  L"data/actor/nitori/walkFrontLoop0001.bmp",
  L"data/actor/nitori/walkFrontLoop0002.bmp",
  L"data/actor/nitori/walkFrontLoop0003.bmp",
  L"data/actor/nitori/walkFrontLoop0004.bmp",
  L"data/actor/nitori/winA0000.bmp",
  L"data/actor/nitori/winA0001.bmp",
  L"data/actor/nitori/winA0002.bmp",
  L"data/actor/nitori/winA0003.bmp",
  L"data/actor/nitori/winA0004.bmp",
  L"data/actor/nitori/winA0005.bmp",
  L"data/actor/nitori/winA0006.bmp",
  L"data/actor/nitori/WinB0000.bmp",
  L"data/actor/nitori/WinB0001.bmp",
  L"data/actor/nitori/WinB0002.bmp",
  L"data/actor/nitori/WinB0003.bmp",
  L"data/actor/nitori/WinB0004.bmp",
  L"data/actor/nitori/WinB0005.bmp",
  L"data/actor/nitori/WinB0006.bmp",
  L"data/actor/nitori/WinB0007.bmp",
  L"data/actor/nitori.nut",
  L"data/actor/nitoriInit.nut",
  L"data/actor/nitori_base.nut",
  L"data/actor/nitori_boss.nut",
  L"data/actor/nitori_cpu.nut",
  L"data/actor/nitori_cpuBoss.nut",
  L"data/actor/nitori_shot.nut",
  L"data/actor/ObjectCommon.nut",
  L"data/actor/playerCommonScript.nut",
  L"data/actor/playerItemScript.nut",
  L"data/actor/reimu/atk_a0000.bmp",
  L"data/actor/reimu/atk_a0001.bmp",
  L"data/actor/reimu/atk_a0002.bmp",
  L"data/actor/reimu/atk_a0003.bmp",
  L"data/actor/reimu/atk_a0004.bmp",
  L"data/actor/reimu/atk_a0005.bmp",
  L"data/actor/reimu/atk_a0006.bmp",
  L"data/actor/reimu/atk_a0007.bmp",
  L"data/actor/reimu/atk_a0008.bmp",
  L"data/actor/reimu/atk_dashA0000.bmp",
  L"data/actor/reimu/atk_dashA0001.bmp",
  L"data/actor/reimu/atk_dashA0002.bmp",
  L"data/actor/reimu/atk_dashA0003.bmp",
  L"data/actor/reimu/atk_dashA0004.bmp",
  L"data/actor/reimu/atk_dashA0005.bmp",
  L"data/actor/reimu/atk_dashA0006.bmp",
  L"data/actor/reimu/atk_dashA0007.bmp",
  L"data/actor/reimu/atk_dashA0008.bmp",
  L"data/actor/reimu/atk_dashA0009.bmp",
  L"data/actor/reimu/atk_dashA0010.bmp",
  L"data/actor/reimu/atk_dashB0000.bmp",
  L"data/actor/reimu/atk_dashB0001.bmp",
  L"data/actor/reimu/atk_dashB0002.bmp",
  L"data/actor/reimu/atk_dashB0003.bmp",
  L"data/actor/reimu/atk_dashB0004.bmp",
  L"data/actor/reimu/atk_dashB0005.bmp",
  L"data/actor/reimu/atk_dashB0006.bmp",
  L"data/actor/reimu/atk_dashB0007.bmp",
  L"data/actor/reimu/atk_dashB0008.bmp",
  L"data/actor/reimu/atk_dashB0009.bmp",
  L"data/actor/reimu/atk_High0000.bmp",
  L"data/actor/reimu/atk_High0001.bmp",
  L"data/actor/reimu/atk_High0002.bmp",
  L"data/actor/reimu/atk_High0003.bmp",
  L"data/actor/reimu/atk_High0004.bmp",
  L"data/actor/reimu/atk_High0005.bmp",
  L"data/actor/reimu/atk_High0006.bmp",
  L"data/actor/reimu/atk_High0007.bmp",
  L"data/actor/reimu/atk_High0008.bmp",
  L"data/actor/reimu/atk_High0009.bmp",
  L"data/actor/reimu/atk_High0010.bmp",
  L"data/actor/reimu/atk_High0011.bmp",
  L"data/actor/reimu/atk_High0012.bmp",
  L"data/actor/reimu/atk_High0013.bmp",
  L"data/actor/reimu/atk_High0014.bmp",
  L"data/actor/reimu/atk_High0015.bmp",
  L"data/actor/reimu/atk_High0016.bmp",
  L"data/actor/reimu/atk_HighB0000.bmp",
  L"data/actor/reimu/atk_HighB0001.bmp",
  L"data/actor/reimu/atk_HighB0002.bmp",
  L"data/actor/reimu/atk_HighB0003.bmp",
  L"data/actor/reimu/atk_HighB0004.bmp",
  L"data/actor/reimu/atk_HighB0005.bmp",
  L"data/actor/reimu/atk_HighB0006.bmp",
  L"data/actor/reimu/atk_HighB0007.bmp",
  L"data/actor/reimu/atk_HighB0008.bmp",
  L"data/actor/reimu/atk_HighB0009.bmp",
  L"data/actor/reimu/atk_HighB0010.bmp",
  L"data/actor/reimu/atk_HighB0011.bmp",
  L"data/actor/reimu/atk_HighC0000.bmp",
  L"data/actor/reimu/atk_HighC0001.bmp",
  L"data/actor/reimu/atk_HighC0002.bmp",
  L"data/actor/reimu/atk_HighC0003.bmp",
  L"data/actor/reimu/atk_HighC0004.bmp",
  L"data/actor/reimu/atk_HighC0005.bmp",
  L"data/actor/reimu/atk_HighC0006.bmp",
  L"data/actor/reimu/atk_HighC0007.bmp",
  L"data/actor/reimu/atk_HighC0008.bmp",
  L"data/actor/reimu/atk_HighC0009.bmp",
  L"data/actor/reimu/atk_HighC0010.bmp",
  L"data/actor/reimu/atk_HighC0011.bmp",
  L"data/actor/reimu/atk_HighC0012.bmp",
  L"data/actor/reimu/atk_HighUnder0000.bmp",
  L"data/actor/reimu/atk_HighUnder0001.bmp",
  L"data/actor/reimu/atk_HighUnder0002.bmp",
  L"data/actor/reimu/atk_HighUnder0003.bmp",
  L"data/actor/reimu/atk_HighUnder0004.bmp",
  L"data/actor/reimu/atk_HighUnder0005.bmp",
  L"data/actor/reimu/atk_HighUnder0006.bmp",
  L"data/actor/reimu/atk_HighUnder0007.bmp",
  L"data/actor/reimu/atk_HighUnder0008.bmp",
  L"data/actor/reimu/atk_HighUnder0009.bmp",
  L"data/actor/reimu/atk_HighUnder0010.bmp",
  L"data/actor/reimu/atk_HighUnder0011.bmp",
  L"data/actor/reimu/atk_HighUpper0000.bmp",
  L"data/actor/reimu/atk_HighUpper0001.bmp",
  L"data/actor/reimu/atk_HighUpper0002.bmp",
  L"data/actor/reimu/atk_HighUpper0003.bmp",
  L"data/actor/reimu/atk_HighUpper0004.bmp",
  L"data/actor/reimu/atk_HighUpper0005.bmp",
  L"data/actor/reimu/atk_HighUpper0006.bmp",
  L"data/actor/reimu/atk_HighUpper0007.bmp",
  L"data/actor/reimu/atk_HighUpper0008.bmp",
  L"data/actor/reimu/atk_HighUpper0009.bmp",
  L"data/actor/reimu/atk_HighUpper0010.bmp",
  L"data/actor/reimu/atk_HighUpper0011.bmp",
  L"data/actor/reimu/atk_HighUpper0012.bmp",
  L"data/actor/reimu/atk_HighUpper0013.bmp",
  L"data/actor/reimu/atk_HighUpper0014.bmp",
  L"data/actor/reimu/atk_Mid0000.bmp",
  L"data/actor/reimu/atk_Mid0001.bmp",
  L"data/actor/reimu/atk_Mid0002.bmp",
  L"data/actor/reimu/atk_Mid0003.bmp",
  L"data/actor/reimu/atk_Mid0004.bmp",
  L"data/actor/reimu/atk_Mid0005.bmp",
  L"data/actor/reimu/atk_Mid0006.bmp",
  L"data/actor/reimu/atk_Mid0007.bmp",
  L"data/actor/reimu/atk_Mid0008.bmp",
  L"data/actor/reimu/atk_Mid0009.bmp",
  L"data/actor/reimu/atk_Mid0010.bmp",
  L"data/actor/reimu/beginBattleA0000.bmp",
  L"data/actor/reimu/beginBattleA0001.bmp",
  L"data/actor/reimu/beginBattleA0002.bmp",
  L"data/actor/reimu/beginBattleA0003.bmp",
  L"data/actor/reimu/beginBattleA0004.bmp",
  L"data/actor/reimu/beginBattleA0005.bmp",
  L"data/actor/reimu/beginBattleA0006.bmp",
  L"data/actor/reimu/beginBattleA0007.bmp",
  L"data/actor/reimu/beginBattleA0008.bmp",
  L"data/actor/reimu/beginBattleA0009.bmp",
  L"data/actor/reimu/beginBattleA0010.bmp",
  L"data/actor/reimu/beginBattleA0011.bmp",
  L"data/actor/reimu/beginBattleA0012.bmp",
  L"data/actor/reimu/beginBattleA0013.bmp",
  L"data/actor/reimu/beginBattleA0014.bmp",
  L"data/actor/reimu/bmsln/reimu_buster.bmb",
  L"data/actor/reimu/bmsln/reimu_busterHit.bmb",
  L"data/actor/reimu/bmsln/reimu_fallKickA.bmb",
  L"data/actor/reimu/bmsln/reimu_HighShotBaria.bmb",
  L"data/actor/reimu/bmsln/reimu_keisei.bmb",
  L"data/actor/reimu/bmsln/reimu_kibakuzinA.bmb",
  L"data/actor/reimu/bmsln/reimu_musouB.bmb",
  L"data/actor/reimu/bmsln/reimu_musouG.bmb",
  L"data/actor/reimu/bmsln/reimu_musouHitB.bmb",
  L"data/actor/reimu/bmsln/reimu_musouHitG.bmb",
  L"data/actor/reimu/bmsln/reimu_musouHitR.bmb",
  L"data/actor/reimu/bmsln/reimu_musouR.bmb",
  L"data/actor/reimu/bmsln/reimu_shot.bmb",
  L"data/actor/reimu/bmsln/reimu_shotA.bmb",
  L"data/actor/reimu/bmsln/reimu_shotA_gateRing.bmb",
  L"data/actor/reimu/bmsln/reimu_shotA_hit.bmb",
  L"data/actor/reimu/bmsln/reimu_skillG_kick.bmb",
  L"data/actor/reimu/bmsln/reimu_TenseiA000.bmb",
  L"data/actor/reimu/bmsln/reimu_tenseiFinish.bmb",
  L"data/actor/reimu/bmsln/reimu_tenseiRock.bmb",
  L"data/actor/reimu/bmsln/reimu_tenseiRockShot.bmb",
  L"data/actor/reimu/bmsln/shot_A_000.bmb",
  L"data/actor/reimu/bmsln/shot_A_000.bmsln",
  L"data/actor/reimu/bouA0000.bmp",
  L"data/actor/reimu/climaxA0000.bmp",
  L"data/actor/reimu/climaxA0001.bmp",
  L"data/actor/reimu/climaxA0002.bmp",
  L"data/actor/reimu/climaxA0003.bmp",
  L"data/actor/reimu/climaxA0004.bmp",
  L"data/actor/reimu/climaxA0005.bmp",
  L"data/actor/reimu/climaxA0006.bmp",
  L"data/actor/reimu/climaxA0007.bmp",
  L"data/actor/reimu/climaxA0008.bmp",
  L"data/actor/reimu/climaxA0009.bmp",
  L"data/actor/reimu/climaxA0010.bmp",
  L"data/actor/reimu/climaxA0011.bmp",
  L"data/actor/reimu/climaxA0012.bmp",
  L"data/actor/reimu/climaxA0013.bmp",
  L"data/actor/reimu/climaxA0014.bmp",
  L"data/actor/reimu/climaxA0015.bmp",
  L"data/actor/reimu/climaxA0016.bmp",
  L"data/actor/reimu/climax_cutFace.png",
  L"data/actor/reimu/damageUnder0000.bmp",
  L"data/actor/reimu/damageUnder0001.bmp",
  L"data/actor/reimu/damageUnder0002.bmp",
  L"data/actor/reimu/damageUnder0003.bmp",
  L"data/actor/reimu/damageUnder0004.bmp",
  L"data/actor/reimu/damageUpper0000.bmp",
  L"data/actor/reimu/damageUpper0001.bmp",
  L"data/actor/reimu/damageUpper0002.bmp",
  L"data/actor/reimu/damageUpper0003.bmp",
  L"data/actor/reimu/damageUpper0004.bmp",
  L"data/actor/reimu/damageWall0000.bmp",
  L"data/actor/reimu/damageWall0001.bmp",
  L"data/actor/reimu/damageWall0002.bmp",
  L"data/actor/reimu/damageWall0003.bmp",
  L"data/actor/reimu/damageWall0004.bmp",
  L"data/actor/reimu/damageWall0005.bmp",
  L"data/actor/reimu/damageWall0006.bmp",
  L"data/actor/reimu/damageWall0007.bmp",
  L"data/actor/reimu/damage_fall0000.bmp",
  L"data/actor/reimu/damage_fall0001.bmp",
  L"data/actor/reimu/damage_fall0002.bmp",
  L"data/actor/reimu/damage_fall0003.bmp",
  L"data/actor/reimu/damage_fall0004.bmp",
  L"data/actor/reimu/damage_fall0005.bmp",
  L"data/actor/reimu/damage_fall0005b.bmp",
  L"data/actor/reimu/damage_fall0006.bmp",
  L"data/actor/reimu/damage_lift0000.bmp",
  L"data/actor/reimu/damage_lift0001.bmp",
  L"data/actor/reimu/damage_lift0002.bmp",
  L"data/actor/reimu/damage_lift0003.bmp",
  L"data/actor/reimu/damage_lift0004.bmp",
  L"data/actor/reimu/damage_lift0005.bmp",
  L"data/actor/reimu/damage_lift0006.bmp",
  L"data/actor/reimu/damage_lift0006b.bmp",
  L"data/actor/reimu/damage_spin0000.bmp",
  L"data/actor/reimu/damage_spin0001.bmp",
  L"data/actor/reimu/damage_spin0002.bmp",
  L"data/actor/reimu/damage_spin0003.bmp",
  L"data/actor/reimu/dashBack0000.bmp",
  L"data/actor/reimu/dashBack0001.bmp",
  L"data/actor/reimu/dashBack0002.bmp",
  L"data/actor/reimu/dashBack0003.bmp",
  L"data/actor/reimu/dashBack0004.bmp",
  L"data/actor/reimu/dashBack0005.bmp",
  L"data/actor/reimu/dashBack0006.bmp",
  L"data/actor/reimu/dashBack0007.bmp",
  L"data/actor/reimu/dashBack0008.bmp",
  L"data/actor/reimu/dashBack0009.bmp",
  L"data/actor/reimu/dashBackLoop0000.bmp",
  L"data/actor/reimu/dashBackLoop0001.bmp",
  L"data/actor/reimu/dashBackLoop0002.bmp",
  L"data/actor/reimu/dashBackLoop0003.bmp",
  L"data/actor/reimu/dashBackLoop0004.bmp",
  L"data/actor/reimu/dashFront0000.bmp",
  L"data/actor/reimu/dashFront0001.bmp",
  L"data/actor/reimu/dashFront0002.bmp",
  L"data/actor/reimu/dashFront0003.bmp",
  L"data/actor/reimu/dashFront0004.bmp",
  L"data/actor/reimu/dashFront0005.bmp",
  L"data/actor/reimu/dashFront0006.bmp",
  L"data/actor/reimu/dashFront0007.bmp",
  L"data/actor/reimu/dashFront0008.bmp",
  L"data/actor/reimu/dashFront0009.bmp",
  L"data/actor/reimu/dashFrontLoop0000.bmp",
  L"data/actor/reimu/dashFrontLoop0001.bmp",
  L"data/actor/reimu/dashFrontLoop0002.bmp",
  L"data/actor/reimu/dashFrontLoop0003.bmp",
  L"data/actor/reimu/dashFrontLoop0004.bmp",
  L"data/actor/reimu/downLoop0000.bmp",
  L"data/actor/reimu/downLoop0001.bmp",
  L"data/actor/reimu/downLoop0002.bmp",
  L"data/actor/reimu/downLoop0003.bmp",
  L"data/actor/reimu/downLoop0004.bmp",
  L"data/actor/reimu/dummy.bmp",
  L"data/actor/reimu/effect_skillA0000.bmp",
  L"data/actor/reimu/effect_skillA0001.bmp",
  L"data/actor/reimu/effect_skillA0002.bmp",
  L"data/actor/reimu/effect_skillA0003.bmp",
  L"data/actor/reimu/effect_spellA_aura0000.dds",
  L"data/actor/reimu/effect_spellA_aura0001.dds",
  L"data/actor/reimu/effect_spellA_aura0002.dds",
  L"data/actor/reimu/effect_spellA_aura0003.dds",
  L"data/actor/reimu/effect_spellA_aura0004.dds",
  L"data/actor/reimu/effect_spellA_aura0005.dds",
  L"data/actor/reimu/effect_spellA_aura0006.dds",
  L"data/actor/reimu/effect_spellA_aura0007.dds",
  L"data/actor/reimu/effect_spellA_aura0008.dds",
  L"data/actor/reimu/effect_spellA_aura0009.dds",
  L"data/actor/reimu/effect_spellA_aura0010.dds",
  L"data/actor/reimu/effect_spellA_aura0011.dds",
  L"data/actor/reimu/effect_spellA_aura0012.dds",
  L"data/actor/reimu/effect_spellA_aura0013.dds",
  L"data/actor/reimu/effect_spellA_aura0014.dds",
  L"data/actor/reimu/effect_spellA_aura0015.dds",
  L"data/actor/reimu/effect_spellA_aura0016.dds",
  L"data/actor/reimu/effect_spellA_aura0017.dds",
  L"data/actor/reimu/effect_spellA_auraB0000.dds",
  L"data/actor/reimu/effect_spellA_auraB0001.dds",
  L"data/actor/reimu/effect_spellA_auraB0002.dds",
  L"data/actor/reimu/effect_spellA_auraB0003.dds",
  L"data/actor/reimu/effect_spellA_auraB0004.dds",
  L"data/actor/reimu/effect_spellA_auraB0005.dds",
  L"data/actor/reimu/effect_spellA_auraB0006.dds",
  L"data/actor/reimu/effect_spellA_auraB0007.dds",
  L"data/actor/reimu/effect_spellA_auraB0008.dds",
  L"data/actor/reimu/effect_spellA_auraB0009.dds",
  L"data/actor/reimu/effect_spellA_auraB0010.dds",
  L"data/actor/reimu/effect_spellA_auraB0011.dds",
  L"data/actor/reimu/effect_spellA_auraB0012.dds",
  L"data/actor/reimu/effect_spellA_auraB0013.dds",
  L"data/actor/reimu/effect_spellA_auraB0014.dds",
  L"data/actor/reimu/effect_spellA_auraB0015.dds",
  L"data/actor/reimu/effect_spellA_auraB0016.dds",
  L"data/actor/reimu/effect_spellA_auraB0017.dds",
  L"data/actor/reimu/effect_spellB0000.png",
  L"data/actor/reimu/effect_spellB0001.png",
  L"data/actor/reimu/effect_spellB0002.png",
  L"data/actor/reimu/effect_spellB0003.png",
  L"data/actor/reimu/effect_spellB0004.png",
  L"data/actor/reimu/effect_spellB0005.png",
  L"data/actor/reimu/effect_spellB0006.png",
  L"data/actor/reimu/effect_spellB0007.png",
  L"data/actor/reimu/effect_spellB0008.png",
  L"data/actor/reimu/effect_spellB0009.png",
  L"data/actor/reimu/effect_spellB0010.png",
  L"data/actor/reimu/effect_spellB0011.png",
  L"data/actor/reimu/effect_spellB0012.png",
  L"data/actor/reimu/effect_spellB0013.png",
  L"data/actor/reimu/effect_spellB0014.png",
  L"data/actor/reimu/effect_spellB0015.png",
  L"data/actor/reimu/effect_spellBb0000.png",
  L"data/actor/reimu/effect_spellBb0001.png",
  L"data/actor/reimu/effect_spellBb0002.png",
  L"data/actor/reimu/effect_spellBb0003.png",
  L"data/actor/reimu/effect_spellBb0004.png",
  L"data/actor/reimu/effect_spellBb0005.png",
  L"data/actor/reimu/effect_spellBb0006.png",
  L"data/actor/reimu/effect_spellBb0007.png",
  L"data/actor/reimu/effect_spellBb0008.png",
  L"data/actor/reimu/effect_spellBb0009.png",
  L"data/actor/reimu/effect_spellBb0010.png",
  L"data/actor/reimu/effect_spellBb0011.png",
  L"data/actor/reimu/effect_spellBb0012.png",
  L"data/actor/reimu/effect_spellBb0013.png",
  L"data/actor/reimu/effect_spellBb0014.png",
  L"data/actor/reimu/effect_spellBb0015.png",
  L"data/actor/reimu/face_spellCall.png",
  L"data/actor/reimu/guard0000.bmp",
  L"data/actor/reimu/guard0001.bmp",
  L"data/actor/reimu/guard0002.bmp",
  L"data/actor/reimu/guard0003.bmp",
  L"data/actor/reimu/guard0004.bmp",
  L"data/actor/reimu/guardCrash0000.bmp",
  L"data/actor/reimu/guardCrash0001.bmp",
  L"data/actor/reimu/guardCrash0002.bmp",
  L"data/actor/reimu/guardCrash0003.bmp",
  L"data/actor/reimu/guardCrash0004.bmp",
  L"data/actor/reimu/guardCrash0005.bmp",
  L"data/actor/reimu/guard_miss0000.bmp",
  L"data/actor/reimu/guard_miss0001.bmp",
  L"data/actor/reimu/guard_miss0002.bmp",
  L"data/actor/reimu/guard_miss0003.bmp",
  L"data/actor/reimu/item0000.bmp",
  L"data/actor/reimu/item0001.bmp",
  L"data/actor/reimu/item0002.bmp",
  L"data/actor/reimu/item0003.bmp",
  L"data/actor/reimu/item0004.bmp",
  L"data/actor/reimu/item0005.bmp",
  L"data/actor/reimu/item0006.bmp",
  L"data/actor/reimu/item0007.bmp",
  L"data/actor/reimu/item0008.bmp",
  L"data/actor/reimu/item0009.bmp",
  L"data/actor/reimu/item0010.bmp",
  L"data/actor/reimu/item0011.bmp",
  L"data/actor/reimu/item0012.bmp",
  L"data/actor/reimu/lose0000.bmp",
  L"data/actor/reimu/lose0001.bmp",
  L"data/actor/reimu/lose0002.bmp",
  L"data/actor/reimu/lose0003.bmp",
  L"data/actor/reimu/lose0004.bmp",
  L"data/actor/reimu/lose0005.bmp",
  L"data/actor/reimu/lose0006.bmp",
  L"data/actor/reimu/lose0007.bmp",
  L"data/actor/reimu/lose0008.bmp",
  L"data/actor/reimu/lose0009.bmp",
  L"data/actor/reimu/move_20000.bmp",
  L"data/actor/reimu/move_20001.bmp",
  L"data/actor/reimu/move_20002.bmp",
  L"data/actor/reimu/move_20003.bmp",
  L"data/actor/reimu/move_20004.bmp",
  L"data/actor/reimu/move_20005.bmp",
  L"data/actor/reimu/move_20006.bmp",
  L"data/actor/reimu/move_2loop0000.bmp",
  L"data/actor/reimu/move_2loop0001.bmp",
  L"data/actor/reimu/move_2loop0002.bmp",
  L"data/actor/reimu/move_2loop0003.bmp",
  L"data/actor/reimu/move_2loop0004.bmp",
  L"data/actor/reimu/move_80000.bmp",
  L"data/actor/reimu/move_80001.bmp",
  L"data/actor/reimu/move_80002.bmp",
  L"data/actor/reimu/move_80003.bmp",
  L"data/actor/reimu/move_80004.bmp",
  L"data/actor/reimu/move_80005.bmp",
  L"data/actor/reimu/move_80006.bmp",
  L"data/actor/reimu/move_80007.bmp",
  L"data/actor/reimu/move_80008.bmp",
  L"data/actor/reimu/move_8loop0000.bmp",
  L"data/actor/reimu/move_8loop0001.bmp",
  L"data/actor/reimu/move_8loop0002.bmp",
  L"data/actor/reimu/move_8loop0003.bmp",
  L"data/actor/reimu/move_8loop0004.bmp",
  L"data/actor/reimu/object_winB0000.png",
  L"data/actor/reimu/occult0000.bmp",
  L"data/actor/reimu/occult0001.bmp",
  L"data/actor/reimu/occult0002.bmp",
  L"data/actor/reimu/occult0003.bmp",
  L"data/actor/reimu/occult0004.bmp",
  L"data/actor/reimu/occult0005.bmp",
  L"data/actor/reimu/occult0006.bmp",
  L"data/actor/reimu/occult0007.bmp",
  L"data/actor/reimu/occult0008.bmp",
  L"data/actor/reimu/occult0009.bmp",
  L"data/actor/reimu/occult_mask0000.bmp",
  L"data/actor/reimu/occult_mask0001.bmp",
  L"data/actor/reimu/occult_mask0002.bmp",
  L"data/actor/reimu/occult_mask0003.bmp",
  L"data/actor/reimu/occult_mask0004.bmp",
  L"data/actor/reimu/occult_mask0005.bmp",
  L"data/actor/reimu/palette000.bmp",
  L"data/actor/reimu/palette001.bmp",
  L"data/actor/reimu/palette002.bmp",
  L"data/actor/reimu/palette003.bmp",
  L"data/actor/reimu/palette004.bmp",
  L"data/actor/reimu/palette005.bmp",
  L"data/actor/reimu/palette006.bmp",
  L"data/actor/reimu/palette007.bmp",
  L"data/actor/reimu/reimu.pat",
  L"data/actor/reimu/reimu_ed.pat",
  L"data/actor/reimu/reimu_occult_sotoba0000.png",
  L"data/actor/reimu/reimu_occult_sotoba0001.png",
  L"data/actor/reimu/samasoBLD0000.dds",
  L"data/actor/reimu/samasoBLD0001.dds",
  L"data/actor/reimu/samasoBLD0002.dds",
  L"data/actor/reimu/samasoBLD0003.dds",
  L"data/actor/reimu/samasoBLD0004.dds",
  L"data/actor/reimu/samasoBLD0005.dds",
  L"data/actor/reimu/samasoBLD0006.dds",
  L"data/actor/reimu/samasoBLD0007.dds",
  L"data/actor/reimu/samasoBLD0008.dds",
  L"data/actor/reimu/samasoBLD0009.dds",
  L"data/actor/reimu/shotA_Loop0000.bmp",
  L"data/actor/reimu/shotA_Loop0001.bmp",
  L"data/actor/reimu/shotA_Loop0002.bmp",
  L"data/actor/reimu/shotA_Loop0003.bmp",
  L"data/actor/reimu/shotA_Loop0004.bmp",
  L"data/actor/reimu/shot_A0000.bmp",
  L"data/actor/reimu/shot_A0001.bmp",
  L"data/actor/reimu/shot_A0002.bmp",
  L"data/actor/reimu/shot_A0003.bmp",
  L"data/actor/reimu/shot_A0004.bmp",
  L"data/actor/reimu/shot_A0005.bmp",
  L"data/actor/reimu/shot_A0006.bmp",
  L"data/actor/reimu/shot_A0007.bmp",
  L"data/actor/reimu/shot_A0008.bmp",
  L"data/actor/reimu/shot_A0009.bmp",
  L"data/actor/reimu/shot_A0010.bmp",
  L"data/actor/reimu/shot_A0011.bmp",
  L"data/actor/reimu/shot_B0000.bmp",
  L"data/actor/reimu/shot_B0001.bmp",
  L"data/actor/reimu/shot_B0002.bmp",
  L"data/actor/reimu/shot_B0003.bmp",
  L"data/actor/reimu/shot_B0004.bmp",
  L"data/actor/reimu/shot_B0005.bmp",
  L"data/actor/reimu/shot_B0006.bmp",
  L"data/actor/reimu/shot_B0007.bmp",
  L"data/actor/reimu/shot_B0008.bmp",
  L"data/actor/reimu/shot_B0009.bmp",
  L"data/actor/reimu/shot_B0010.bmp",
  L"data/actor/reimu/shot_B0011.bmp",
  L"data/actor/reimu/shot_C0000.bmp",
  L"data/actor/reimu/shot_C0001.bmp",
  L"data/actor/reimu/shot_C0002.bmp",
  L"data/actor/reimu/shot_C0003.bmp",
  L"data/actor/reimu/shot_C0004.bmp",
  L"data/actor/reimu/shot_C0005.bmp",
  L"data/actor/reimu/shot_C0006.bmp",
  L"data/actor/reimu/shot_C0007.bmp",
  L"data/actor/reimu/shot_C0008.bmp",
  L"data/actor/reimu/shot_C0009.bmp",
  L"data/actor/reimu/shot_C0010.bmp",
  L"data/actor/reimu/shot_D0000.bmp",
  L"data/actor/reimu/shot_D0001.bmp",
  L"data/actor/reimu/shot_D0002.bmp",
  L"data/actor/reimu/shot_D0003.bmp",
  L"data/actor/reimu/shot_D0004.bmp",
  L"data/actor/reimu/shot_D0005.bmp",
  L"data/actor/reimu/shot_D0006.bmp",
  L"data/actor/reimu/shot_D0007.bmp",
  L"data/actor/reimu/shot_D0008.bmp",
  L"data/actor/reimu/shot_D0009.bmp",
  L"data/actor/reimu/shot_D0010.bmp",
  L"data/actor/reimu/shot_D0011.bmp",
  L"data/actor/reimu/shot_D0012.bmp",
  L"data/actor/reimu/skillG_Under0000.bmp",
  L"data/actor/reimu/skillG_Under0001.bmp",
  L"data/actor/reimu/skillG_Upper0000.bmp",
  L"data/actor/reimu/skillG_Upper0001.bmp",
  L"data/actor/reimu/skillG_Upper0002.bmp",
  L"data/actor/reimu/skillG_Upper0003.bmp",
  L"data/actor/reimu/skillG_Upper0004.bmp",
  L"data/actor/reimu/skillG_Upper0005.bmp",
  L"data/actor/reimu/skill_A0000.bmp",
  L"data/actor/reimu/skill_A0001.bmp",
  L"data/actor/reimu/skill_A0002.bmp",
  L"data/actor/reimu/skill_A0003.bmp",
  L"data/actor/reimu/skill_A0004.bmp",
  L"data/actor/reimu/skill_A0005.bmp",
  L"data/actor/reimu/skill_A0006.bmp",
  L"data/actor/reimu/skill_A0007.bmp",
  L"data/actor/reimu/skill_A0008.bmp",
  L"data/actor/reimu/skill_A0009.bmp",
  L"data/actor/reimu/skill_A0010.bmp",
  L"data/actor/reimu/skill_A0011.bmp",
  L"data/actor/reimu/skill_A0012.bmp",
  L"data/actor/reimu/spellA0000.bmp",
  L"data/actor/reimu/spellA0001.bmp",
  L"data/actor/reimu/spellA0002.bmp",
  L"data/actor/reimu/spellA0003.bmp",
  L"data/actor/reimu/spellA0004.bmp",
  L"data/actor/reimu/spellA0005.bmp",
  L"data/actor/reimu/spellA0006.bmp",
  L"data/actor/reimu/spellA0007.bmp",
  L"data/actor/reimu/spellA0008.bmp",
  L"data/actor/reimu/spellA0009.bmp",
  L"data/actor/reimu/spellA0010.bmp",
  L"data/actor/reimu/spellA0011.bmp",
  L"data/actor/reimu/spellA0012.bmp",
  L"data/actor/reimu/spellA0013.bmp",
  L"data/actor/reimu/spellA0014.bmp",
  L"data/actor/reimu/spellA0015.bmp",
  L"data/actor/reimu/spellA0016.bmp",
  L"data/actor/reimu/spellA0017.bmp",
  L"data/actor/reimu/spellA0018.bmp",
  L"data/actor/reimu/spellA0019.bmp",
  L"data/actor/reimu/spellA0020.bmp",
  L"data/actor/reimu/spellA0021.bmp",
  L"data/actor/reimu/spellA0022.bmp",
  L"data/actor/reimu/spellA0023.bmp",
  L"data/actor/reimu/spellA0024.bmp",
  L"data/actor/reimu/spellA0025.bmp",
  L"data/actor/reimu/spellA0026.bmp",
  L"data/actor/reimu/spellA_Loop0000.bmp",
  L"data/actor/reimu/spellB0000.bmp",
  L"data/actor/reimu/spellB0001.bmp",
  L"data/actor/reimu/spellB0002.bmp",
  L"data/actor/reimu/spellB0003.bmp",
  L"data/actor/reimu/spellB0004.bmp",
  L"data/actor/reimu/spellB0005.bmp",
  L"data/actor/reimu/spellB0006.bmp",
  L"data/actor/reimu/spellB0007.bmp",
  L"data/actor/reimu/spellB0008.bmp",
  L"data/actor/reimu/spellB0009.bmp",
  L"data/actor/reimu/spellB0010.bmp",
  L"data/actor/reimu/spellB0011.bmp",
  L"data/actor/reimu/spellB0012.bmp",
  L"data/actor/reimu/spellB0013.bmp",
  L"data/actor/reimu/spellB0014.bmp",
  L"data/actor/reimu/spellB0015.bmp",
  L"data/actor/reimu/spellB0016.bmp",
  L"data/actor/reimu/spellB0017.bmp",
  L"data/actor/reimu/spellB0018.bmp",
  L"data/actor/reimu/spellB0019.bmp",
  L"data/actor/reimu/spellB0020.bmp",
  L"data/actor/reimu/spellB0021.bmp",
  L"data/actor/reimu/spellB0022.bmp",
  L"data/actor/reimu/spellB0023.bmp",
  L"data/actor/reimu/spellB0024.bmp",
  L"data/actor/reimu/spellB0025.bmp",
  L"data/actor/reimu/spellC0000.bmp",
  L"data/actor/reimu/spellC0001.bmp",
  L"data/actor/reimu/spellC0002.bmp",
  L"data/actor/reimu/spellC0003.bmp",
  L"data/actor/reimu/spellC0004.bmp",
  L"data/actor/reimu/spellC0005.bmp",
  L"data/actor/reimu/spellC0006.bmp",
  L"data/actor/reimu/spellC0007.bmp",
  L"data/actor/reimu/spellC0008.bmp",
  L"data/actor/reimu/spellC0009.bmp",
  L"data/actor/reimu/stun0000.bmp",
  L"data/actor/reimu/stun0001.bmp",
  L"data/actor/reimu/stun0002.bmp",
  L"data/actor/reimu/stun0003.bmp",
  L"data/actor/reimu/stun0004.bmp",
  L"data/actor/reimu/stun0005.bmp",
  L"data/actor/reimu/stunEnd0000.bmp",
  L"data/actor/reimu/stunEnd0001.bmp",
  L"data/actor/reimu/stunEnd0002.bmp",
  L"data/actor/reimu/stunEnd0003.bmp",
  L"data/actor/reimu/testR_ClimaxBack.png",
  L"data/actor/reimu/testR_climaxLine.png",
  L"data/actor/reimu/testR_climaxLine2.png",
  L"data/actor/reimu/test_effect.bmp",
  L"data/actor/reimu/test_stand0000.bmp",
  L"data/actor/reimu/test_stand0001.bmp",
  L"data/actor/reimu/test_stand0002.bmp",
  L"data/actor/reimu/test_stand0003.bmp",
  L"data/actor/reimu/test_stand0004.bmp",
  L"data/actor/reimu/test_stand0005.bmp",
  L"data/actor/reimu/test_stand0006.bmp",
  L"data/actor/reimu/test_stand0007.bmp",
  L"data/actor/reimu/test_stand0008.bmp",
  L"data/actor/reimu/test_stand0009.bmp",
  L"data/actor/reimu/test_stand0010.bmp",
  L"data/actor/reimu/test_stand0011.bmp",
  L"data/actor/reimu/test_stand0012.bmp",
  L"data/actor/reimu/test_stand0013.bmp",
  L"data/actor/reimu/texture/ball.bmp",
  L"data/actor/reimu/texture/boss1_mask0000.png",
  L"data/actor/reimu/texture/boss1_ring0000.dds",
  L"data/actor/reimu/texture/bulletGateFlash.bmp",
  L"data/actor/reimu/texture/bulletGateRing.bmp",
  L"data/actor/reimu/texture/bullet_shotA0000.png",
  L"data/actor/reimu/texture/bullet_shotB0000.png",
  L"data/actor/reimu/texture/kona_A.bmp",
  L"data/actor/reimu/texture/lightning_mapA.png",
  L"data/actor/reimu/texture/marisaBall2.bmp",
  L"data/actor/reimu/texture/marisaStarFlare.bmp",
  L"data/actor/reimu/texture/mask_ball.png",
  L"data/actor/reimu/texture/musou_trail.png",
  L"data/actor/reimu/texture/ofudaHit.bmp",
  L"data/actor/reimu/texture/ooiri.bmp",
  L"data/actor/reimu/texture/ooiri_aura.bmp",
  L"data/actor/reimu/texture/reimu_amulet0000.bmp",
  L"data/actor/reimu/texture/reimu_animalDamage000.png",
  L"data/actor/reimu/texture/reimu_animalDamage001.png",
  L"data/actor/reimu/texture/reimu_animalDamage002.png",
  L"data/actor/reimu/texture/reimu_animalDamage003.png",
  L"data/actor/reimu/texture/reimu_animal_00000.png",
  L"data/actor/reimu/texture/reimu_animal_00001.png",
  L"data/actor/reimu/texture/reimu_animal_00002.png",
  L"data/actor/reimu/texture/reimu_animal_00003.png",
  L"data/actor/reimu/texture/reimu_animal_00004.png",
  L"data/actor/reimu/texture/reimu_animal_00005.png",
  L"data/actor/reimu/texture/reimu_animal_00006.png",
  L"data/actor/reimu/texture/reimu_animal_00007.png",
  L"data/actor/reimu/texture/reimu_animal_00008.png",
  L"data/actor/reimu/texture/reimu_animal_00009.png",
  L"data/actor/reimu/texture/reimu_animal_00010.png",
  L"data/actor/reimu/texture/reimu_animal_00011.png",
  L"data/actor/reimu/texture/reimu_boxA.png",
  L"data/actor/reimu/texture/reimu_chargeLine.png",
  L"data/actor/reimu/texture/reimu_climaxMask0000.png",
  L"data/actor/reimu/texture/reimu_climaxMask0001.png",
  L"data/actor/reimu/texture/reimu_climaxSlashA.png",
  L"data/actor/reimu/texture/reimu_fallKick.png",
  L"data/actor/reimu/texture/reimu_lasyWord0000.png",
  L"data/actor/reimu/texture/reimu_loopAuraA.png",
  L"data/actor/reimu/texture/reimu_musouBase.png",
  L"data/actor/reimu/texture/reimu_occultMask0000.png",
  L"data/actor/reimu/texture/reimu_onmyoBall.png",
  L"data/actor/reimu/texture/reimu_skillG_FlashA.png",
  L"data/actor/reimu/texture/reimu_skillG_Trail.png",
  L"data/actor/reimu/texture/reimu_tenseiA000.png",
  L"data/actor/reimu/texture/reimu_tenseiFuda.png",
  L"data/actor/reimu/texture/reimu_wallA.png",
  L"data/actor/reimu/texture/reimu_wallA_Halfmask.png",
  L"data/actor/reimu/texture/reimu_wallA_mask.png",
  L"data/actor/reimu/texture/reimu_wallFlashA.png",
  L"data/actor/reimu/texture/shotStingA0000.png",
  L"data/actor/reimu/texture/smoke.png",
  L"data/actor/reimu/texture/spellC.dds",
  L"data/actor/reimu/texture/sukima_back0000.png",
  L"data/actor/reimu/turn0000.bmp",
  L"data/actor/reimu/turn0001.bmp",
  L"data/actor/reimu/turn0002.bmp",
  L"data/actor/reimu/walk0000.bmp",
  L"data/actor/reimu/walk0001.bmp",
  L"data/actor/reimu/walk0002.bmp",
  L"data/actor/reimu/walk0003.bmp",
  L"data/actor/reimu/walk0004.bmp",
  L"data/actor/reimu/walk0005.bmp",
  L"data/actor/reimu/walk0006.bmp",
  L"data/actor/reimu/walk0007.bmp",
  L"data/actor/reimu/walk0008.bmp",
  L"data/actor/reimu/walk0009.bmp",
  L"data/actor/reimu/walkBack0000.bmp",
  L"data/actor/reimu/walkBack0001.bmp",
  L"data/actor/reimu/walkBack0002.bmp",
  L"data/actor/reimu/walkBack0003.bmp",
  L"data/actor/reimu/walkBack0004.bmp",
  L"data/actor/reimu/walkBack0005.bmp",
  L"data/actor/reimu/walkBack0006.bmp",
  L"data/actor/reimu/walkBack0007.bmp",
  L"data/actor/reimu/walkBack0008.bmp",
  L"data/actor/reimu/walkBack0009.bmp",
  L"data/actor/reimu/walkBack0010.bmp",
  L"data/actor/reimu/walkBackloop0000.bmp",
  L"data/actor/reimu/walkBackloop0001.bmp",
  L"data/actor/reimu/walkBackloop0002.bmp",
  L"data/actor/reimu/walkBackloop0003.bmp",
  L"data/actor/reimu/walkBackloop0004.bmp",
  L"data/actor/reimu/walkloop0000.bmp",
  L"data/actor/reimu/walkloop0001.bmp",
  L"data/actor/reimu/walkloop0002.bmp",
  L"data/actor/reimu/walkloop0003.bmp",
  L"data/actor/reimu/walkloop0004.bmp",
  L"data/actor/reimu/warpMask.bmp",
  L"data/actor/reimu/winA0000.bmp",
  L"data/actor/reimu/winA0001.bmp",
  L"data/actor/reimu/winA0002.bmp",
  L"data/actor/reimu/winA0003.bmp",
  L"data/actor/reimu/winA0004.bmp",
  L"data/actor/reimu/winA0005.bmp",
  L"data/actor/reimu/winA0006.bmp",
  L"data/actor/reimu/winA0007.bmp",
  L"data/actor/reimu/winA0008.bmp",
  L"data/actor/reimu/winA0009.bmp",
  L"data/actor/reimu/winA0010.bmp",
  L"data/actor/reimu/winA0011.bmp",
  L"data/actor/reimu/winA0012.bmp",
  L"data/actor/reimu/winB0000.bmp",
  L"data/actor/reimu/winB0001.bmp",
  L"data/actor/reimu/winB0002.bmp",
  L"data/actor/reimu/winB0003.bmp",
  L"data/actor/reimu/winB0004.bmp",
  L"data/actor/reimu/winB0005.bmp",
  L"data/actor/reimu/winB0006.bmp",
  L"data/actor/reimu/winB0007.bmp",
  L"data/actor/reimu/winB0008.bmp",
  L"data/actor/reimu/winB0009.bmp",
  L"data/actor/reimu.nut",
  L"data/actor/reimuInit.nut",
  L"data/actor/reimu_base.nut",
  L"data/actor/reimu_boss.nut",
  L"data/actor/reimu_cpu.nut",
  L"data/actor/reimu_cpuBoss.nut",
  L"data/actor/reimu_shot.nut",
  L"data/actor/sinmyoumaru/atkHighFront0001.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0002.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0003.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0004.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0005.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0006.bmp",
  L"data/actor/sinmyoumaru/atkHighFront0007.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0000.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0001.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0002.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0003.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0004.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0005.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0006.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0007.bmp",
  L"data/actor/sinmyoumaru/atkHighUnder0008.bmp",
  L"data/actor/sinmyoumaru/atkLow0000.bmp",
  L"data/actor/sinmyoumaru/atkLow0001.bmp",
  L"data/actor/sinmyoumaru/atkLow0002.bmp",
  L"data/actor/sinmyoumaru/atkLow0003.bmp",
  L"data/actor/sinmyoumaru/atkLow0004.bmp",
  L"data/actor/sinmyoumaru/atkLow0005.bmp",
  L"data/actor/sinmyoumaru/atkMid0000.bmp",
  L"data/actor/sinmyoumaru/atkMid0001.bmp",
  L"data/actor/sinmyoumaru/atkMid0002.bmp",
  L"data/actor/sinmyoumaru/atkMid0003.bmp",
  L"data/actor/sinmyoumaru/atkMid0004.bmp",
  L"data/actor/sinmyoumaru/atkMid0005.bmp",
  L"data/actor/sinmyoumaru/atkMid0006.bmp",
  L"data/actor/sinmyoumaru/atkMid0007.bmp",
  L"data/actor/sinmyoumaru/atkMid0008.bmp",
  L"data/actor/sinmyoumaru/atkUpper0000.bmp",
  L"data/actor/sinmyoumaru/atkUpper0001.bmp",
  L"data/actor/sinmyoumaru/atkUpper0002.bmp",
  L"data/actor/sinmyoumaru/atkUpper0003.bmp",
  L"data/actor/sinmyoumaru/atkUpper0004.bmp",
  L"data/actor/sinmyoumaru/atkUpper0005.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0000.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0001.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0002.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0003.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0004.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0005.bmp",
  L"data/actor/sinmyoumaru/battleBeginA0006.bmp",
  L"data/actor/sinmyoumaru/bmsln/reimu_buster.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_busterHit.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_fallKickA.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_HighShotBaria.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_keisei.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_kibakuzinA.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouB.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouG.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouHitB.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouHitG.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouHitR.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_musouR.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_shot.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_shotA.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_shotA_gateRing.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_shotA_hit.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_skillG_kick.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_TenseiA000.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_tenseiFinish.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_tenseiRock.bmb",
  L"data/actor/sinmyoumaru/bmsln/reimu_tenseiRockShot.bmb",
  L"data/actor/sinmyoumaru/bmsln/shot_A_000.bmb",
  L"data/actor/sinmyoumaru/bmsln/shot_A_000.bmsln",
  L"data/actor/sinmyoumaru/chargeShot_slash0000.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slash0001.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slash0002.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slash0003.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slash0004.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slash0005.bmp",
  L"data/actor/sinmyoumaru/chargeshot_slash0006.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0000.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0001.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0002.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0003.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0004.bmp",
  L"data/actor/sinmyoumaru/chargeShot_slashB0005.bmp",
  L"data/actor/sinmyoumaru/climax0000.bmp",
  L"data/actor/sinmyoumaru/climax0001.bmp",
  L"data/actor/sinmyoumaru/climax0002.bmp",
  L"data/actor/sinmyoumaru/climax0003.bmp",
  L"data/actor/sinmyoumaru/climax0004.bmp",
  L"data/actor/sinmyoumaru/climax0005.bmp",
  L"data/actor/sinmyoumaru/climax0006.bmp",
  L"data/actor/sinmyoumaru/climax0007.bmp",
  L"data/actor/sinmyoumaru/climax0008.bmp",
  L"data/actor/sinmyoumaru/climax0009.bmp",
  L"data/actor/sinmyoumaru/climax0010.bmp",
  L"data/actor/sinmyoumaru/climaxCut0000.png",
  L"data/actor/sinmyoumaru/climax_cut0000.png",
  L"data/actor/sinmyoumaru/climax_koduchi0000.bmp",
  L"data/actor/sinmyoumaru/crash0000.bmp",
  L"data/actor/sinmyoumaru/crash0001.bmp",
  L"data/actor/sinmyoumaru/crash0002.bmp",
  L"data/actor/sinmyoumaru/crash0003.bmp",
  L"data/actor/sinmyoumaru/crash0004.bmp",
  L"data/actor/sinmyoumaru/damageBody0000.bmp",
  L"data/actor/sinmyoumaru/damageBody0001.bmp",
  L"data/actor/sinmyoumaru/damageBody0002.bmp",
  L"data/actor/sinmyoumaru/damageBody0003.bmp",
  L"data/actor/sinmyoumaru/damageBody0004.bmp",
  L"data/actor/sinmyoumaru/damageHead0000.bmp",
  L"data/actor/sinmyoumaru/damageHead0001.bmp",
  L"data/actor/sinmyoumaru/damageHead0002.bmp",
  L"data/actor/sinmyoumaru/damageHead0003.bmp",
  L"data/actor/sinmyoumaru/damageHead0004.bmp",
  L"data/actor/sinmyoumaru/damageSpin0000.bmp",
  L"data/actor/sinmyoumaru/damageSpin0001.bmp",
  L"data/actor/sinmyoumaru/damageSpin0002.bmp",
  L"data/actor/sinmyoumaru/damageSpin0003.bmp",
  L"data/actor/sinmyoumaru/damageUnder0000.bmp",
  L"data/actor/sinmyoumaru/damageUnder0001.bmp",
  L"data/actor/sinmyoumaru/damageUnder0002.bmp",
  L"data/actor/sinmyoumaru/damageUnder0003.bmp",
  L"data/actor/sinmyoumaru/damageUnder0004.bmp",
  L"data/actor/sinmyoumaru/damageUnder0005.bmp",
  L"data/actor/sinmyoumaru/damageUnder0006.bmp",
  L"data/actor/sinmyoumaru/damageUnder0007.bmp",
  L"data/actor/sinmyoumaru/damageUnder0008.bmp",
  L"data/actor/sinmyoumaru/damageUpper0001.bmp",
  L"data/actor/sinmyoumaru/damageUpper0002.bmp",
  L"data/actor/sinmyoumaru/damageUpper0003.bmp",
  L"data/actor/sinmyoumaru/damageUpper0004.bmp",
  L"data/actor/sinmyoumaru/damageUpper0005.bmp",
  L"data/actor/sinmyoumaru/damageUpper0006.bmp",
  L"data/actor/sinmyoumaru/damageUpper0007.bmp",
  L"data/actor/sinmyoumaru/damageUpper0008.bmp",
  L"data/actor/sinmyoumaru/damageUpper0009.bmp",
  L"data/actor/sinmyoumaru/damageUpper0010.bmp",
  L"data/actor/sinmyoumaru/damageUpper0011.bmp",
  L"data/actor/sinmyoumaru/damageUpper0012.bmp",
  L"data/actor/sinmyoumaru/damageUpper0013.bmp",
  L"data/actor/sinmyoumaru/damageUpper0014.bmp",
  L"data/actor/sinmyoumaru/damageUpper0015.bmp",
  L"data/actor/sinmyoumaru/damageUpper0016.bmp",
  L"data/actor/sinmyoumaru/damageWall0000.bmp",
  L"data/actor/sinmyoumaru/damageWall0001.bmp",
  L"data/actor/sinmyoumaru/damageWall0002.bmp",
  L"data/actor/sinmyoumaru/damageWall0003.bmp",
  L"data/actor/sinmyoumaru/damageWall0004.bmp",
  L"data/actor/sinmyoumaru/damageWall0005.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0002.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0003.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0004.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0005.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0006.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0007.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0008.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0009.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0010.bmp",
  L"data/actor/sinmyoumaru/damage_Upper0011.bmp",
  L"data/actor/sinmyoumaru/dashBack0000.bmp",
  L"data/actor/sinmyoumaru/dashBack0001.bmp",
  L"data/actor/sinmyoumaru/dashBack0002.bmp",
  L"data/actor/sinmyoumaru/dashBack0003.bmp",
  L"data/actor/sinmyoumaru/dashFront0000.bmp",
  L"data/actor/sinmyoumaru/dashFront0001.bmp",
  L"data/actor/sinmyoumaru/dashFront0002.bmp",
  L"data/actor/sinmyoumaru/dashFront0003.bmp",
  L"data/actor/sinmyoumaru/face_spellCallB.png",
  L"data/actor/sinmyoumaru/guard0000.bmp",
  L"data/actor/sinmyoumaru/guard0001.bmp",
  L"data/actor/sinmyoumaru/guard0002.bmp",
  L"data/actor/sinmyoumaru/guard0003.bmp",
  L"data/actor/sinmyoumaru/guard0004.bmp",
  L"data/actor/sinmyoumaru/guardMiss0001.bmp",
  L"data/actor/sinmyoumaru/guardMiss0002.bmp",
  L"data/actor/sinmyoumaru/guardMiss0003.bmp",
  L"data/actor/sinmyoumaru/guardMiss0004.bmp",
  L"data/actor/sinmyoumaru/lose0000.bmp",
  L"data/actor/sinmyoumaru/lose0001.bmp",
  L"data/actor/sinmyoumaru/lose0002.bmp",
  L"data/actor/sinmyoumaru/lose0003.bmp",
  L"data/actor/sinmyoumaru/lose0004.bmp",
  L"data/actor/sinmyoumaru/occult0000.bmp",
  L"data/actor/sinmyoumaru/occult0001.bmp",
  L"data/actor/sinmyoumaru/occult0002.bmp",
  L"data/actor/sinmyoumaru/occult0003.bmp",
  L"data/actor/sinmyoumaru/occult0004.bmp",
  L"data/actor/sinmyoumaru/occult0005.bmp",
  L"data/actor/sinmyoumaru/occult_objectA0000.bmp",
  L"data/actor/sinmyoumaru/occult_objectA0001.bmp",
  L"data/actor/sinmyoumaru/palette000.bmp",
  L"data/actor/sinmyoumaru/palette001.bmp",
  L"data/actor/sinmyoumaru/palette002.bmp",
  L"data/actor/sinmyoumaru/palette003.bmp",
  L"data/actor/sinmyoumaru/palette004.bmp",
  L"data/actor/sinmyoumaru/palette005.bmp",
  L"data/actor/sinmyoumaru/palette006.bmp",
  L"data/actor/sinmyoumaru/palette007.bmp",
  L"data/actor/sinmyoumaru/shotCharge0000.bmp",
  L"data/actor/sinmyoumaru/shotCharge0001.bmp",
  L"data/actor/sinmyoumaru/shotCharge0002.bmp",
  L"data/actor/sinmyoumaru/shotCharge0003.bmp",
  L"data/actor/sinmyoumaru/shotCharge0004.bmp",
  L"data/actor/sinmyoumaru/shotCharge0005.bmp",
  L"data/actor/sinmyoumaru/shotCharge0006.bmp",
  L"data/actor/sinmyoumaru/shotCharge0007.bmp",
  L"data/actor/sinmyoumaru/shotCharge0008.bmp",
  L"data/actor/sinmyoumaru/shotNormal0000.bmp",
  L"data/actor/sinmyoumaru/shotNormal0001.bmp",
  L"data/actor/sinmyoumaru/shotNormal0002.bmp",
  L"data/actor/sinmyoumaru/shotNormal0003.bmp",
  L"data/actor/sinmyoumaru/shotNormal0004.bmp",
  L"data/actor/sinmyoumaru/shotNormal0005.bmp",
  L"data/actor/sinmyoumaru/shotNormal0006.bmp",
  L"data/actor/sinmyoumaru/shotNormal0007.bmp",
  L"data/actor/sinmyoumaru/shotNormal0008.bmp",
  L"data/actor/sinmyoumaru/sinmyoumaru.pat",
  L"data/actor/sinmyoumaru/sinmyoumaru_ed.pat",
  L"data/actor/sinmyoumaru/skillA0000.bmp",
  L"data/actor/sinmyoumaru/skillA0001.bmp",
  L"data/actor/sinmyoumaru/skillA0002.bmp",
  L"data/actor/sinmyoumaru/skillA0003.bmp",
  L"data/actor/sinmyoumaru/skillA0004.bmp",
  L"data/actor/sinmyoumaru/skillA0005.bmp",
  L"data/actor/sinmyoumaru/skillA0006.bmp",
  L"data/actor/sinmyoumaru/skillA0007.bmp",
  L"data/actor/sinmyoumaru/skillA0008.bmp",
  L"data/actor/sinmyoumaru/skillA0009.bmp",
  L"data/actor/sinmyoumaru/skillA0010.bmp",
  L"data/actor/sinmyoumaru/skillA0011.bmp",
  L"data/actor/sinmyoumaru/skillB0000.bmp",
  L"data/actor/sinmyoumaru/skillB0001.bmp",
  L"data/actor/sinmyoumaru/skillB0002.bmp",
  L"data/actor/sinmyoumaru/skillB0003.bmp",
  L"data/actor/sinmyoumaru/skillB0004.bmp",
  L"data/actor/sinmyoumaru/skillB0005.bmp",
  L"data/actor/sinmyoumaru/skillB0006.bmp",
  L"data/actor/sinmyoumaru/skillB0007.bmp",
  L"data/actor/sinmyoumaru/skillB0008.bmp",
  L"data/actor/sinmyoumaru/skillC0000.bmp",
  L"data/actor/sinmyoumaru/skillC0001.bmp",
  L"data/actor/sinmyoumaru/skillC0002.bmp",
  L"data/actor/sinmyoumaru/skillC0003.bmp",
  L"data/actor/sinmyoumaru/skillC0004.bmp",
  L"data/actor/sinmyoumaru/skillC0005.bmp",
  L"data/actor/sinmyoumaru/skillC0006.bmp",
  L"data/actor/sinmyoumaru/skillC0007.bmp",
  L"data/actor/sinmyoumaru/skillC0008.bmp",
  L"data/actor/sinmyoumaru/skillD0001.bmp",
  L"data/actor/sinmyoumaru/skillD0002.bmp",
  L"data/actor/sinmyoumaru/skillD0003.bmp",
  L"data/actor/sinmyoumaru/skillD0004.bmp",
  L"data/actor/sinmyoumaru/skillD0005.bmp",
  L"data/actor/sinmyoumaru/skillD0006.bmp",
  L"data/actor/sinmyoumaru/skillD0007.bmp",
  L"data/actor/sinmyoumaru/skillD0008.bmp",
  L"data/actor/sinmyoumaru/skillD0009.bmp",
  L"data/actor/sinmyoumaru/skillD0010.bmp",
  L"data/actor/sinmyoumaru/skillE0000.bmp",
  L"data/actor/sinmyoumaru/skillE0001.bmp",
  L"data/actor/sinmyoumaru/skillE0002.bmp",
  L"data/actor/sinmyoumaru/skillE0003.bmp",
  L"data/actor/sinmyoumaru/skillE0004.bmp",
  L"data/actor/sinmyoumaru/skillE0005.bmp",
  L"data/actor/sinmyoumaru/skillE0006.bmp",
  L"data/actor/sinmyoumaru/skillE0007.bmp",
  L"data/actor/sinmyoumaru/skillE0008.bmp",
  L"data/actor/sinmyoumaru/skillE0009.bmp",
  L"data/actor/sinmyoumaru/skillE0010.bmp",
  L"data/actor/sinmyoumaru/skillE0011.bmp",
  L"data/actor/sinmyoumaru/skillE0012.bmp",
  L"data/actor/sinmyoumaru/skillE0013.bmp",
  L"data/actor/sinmyoumaru/slide0000.bmp",
  L"data/actor/sinmyoumaru/slide0002.bmp",
  L"data/actor/sinmyoumaru/slide0003.bmp",
  L"data/actor/sinmyoumaru/slide0004.bmp",
  L"data/actor/sinmyoumaru/slide0005.bmp",
  L"data/actor/sinmyoumaru/slide0006.bmp",
  L"data/actor/sinmyoumaru/slide0008.bmp",
  L"data/actor/sinmyoumaru/slideLoopA0000.bmp",
  L"data/actor/sinmyoumaru/slideLoopA0001.bmp",
  L"data/actor/sinmyoumaru/slideLoopA0002.bmp",
  L"data/actor/sinmyoumaru/slideLoopA0003.bmp",
  L"data/actor/sinmyoumaru/slideLoopA0004.bmp",
  L"data/actor/sinmyoumaru/slideUnderLoop0000.bmp",
  L"data/actor/sinmyoumaru/slideUnderLoop0001.bmp",
  L"data/actor/sinmyoumaru/slideUnderLoop0002.bmp",
  L"data/actor/sinmyoumaru/slideUnderLoop0003.bmp",
  L"data/actor/sinmyoumaru/slideUnderLoop0004.bmp",
  L"data/actor/sinmyoumaru/slideUpper0000.bmp",
  L"data/actor/sinmyoumaru/slideUpper0001.bmp",
  L"data/actor/sinmyoumaru/slideUpper0002.bmp",
  L"data/actor/sinmyoumaru/slideUpper0003.bmp",
  L"data/actor/sinmyoumaru/slideUpper0004.bmp",
  L"data/actor/sinmyoumaru/slideUpper0005.bmp",
  L"data/actor/sinmyoumaru/slideUpper0006.bmp",
  L"data/actor/sinmyoumaru/slideUpper0007.bmp",
  L"data/actor/sinmyoumaru/slideUpper0008.bmp",
  L"data/actor/sinmyoumaru/slideUpperLoop0000.bmp",
  L"data/actor/sinmyoumaru/slideUpperLoop0001.bmp",
  L"data/actor/sinmyoumaru/slideUpperLoop0002.bmp",
  L"data/actor/sinmyoumaru/slideUpperLoop0003.bmp",
  L"data/actor/sinmyoumaru/slideUpperLoop0004.bmp",
  L"data/actor/sinmyoumaru/spellA0000.bmp",
  L"data/actor/sinmyoumaru/spellA0001.bmp",
  L"data/actor/sinmyoumaru/spellA0002.bmp",
  L"data/actor/sinmyoumaru/spellA0003.bmp",
  L"data/actor/sinmyoumaru/spellA0004.bmp",
  L"data/actor/sinmyoumaru/spellA0005.bmp",
  L"data/actor/sinmyoumaru/spellA0006.bmp",
  L"data/actor/sinmyoumaru/spellA0007.bmp",
  L"data/actor/sinmyoumaru/spellA0008.bmp",
  L"data/actor/sinmyoumaru/spellA0009.bmp",
  L"data/actor/sinmyoumaru/spellA0010.bmp",
  L"data/actor/sinmyoumaru/spellA0011.bmp",
  L"data/actor/sinmyoumaru/spellA0012.bmp",
  L"data/actor/sinmyoumaru/spellB0000.bmp",
  L"data/actor/sinmyoumaru/spellB0001.bmp",
  L"data/actor/sinmyoumaru/spellB0002.bmp",
  L"data/actor/sinmyoumaru/spellB0003.bmp",
  L"data/actor/sinmyoumaru/spellB0004.bmp",
  L"data/actor/sinmyoumaru/spellB0005.bmp",
  L"data/actor/sinmyoumaru/sprash0000.bmp",
  L"data/actor/sinmyoumaru/sprash0001.bmp",
  L"data/actor/sinmyoumaru/sprash0002.bmp",
  L"data/actor/sinmyoumaru/sprash0003.bmp",
  L"data/actor/sinmyoumaru/sprash0004.bmp",
  L"data/actor/sinmyoumaru/stand0000.bmp",
  L"data/actor/sinmyoumaru/stand0001.bmp",
  L"data/actor/sinmyoumaru/stand0002.bmp",
  L"data/actor/sinmyoumaru/stand0003.bmp",
  L"data/actor/sinmyoumaru/stand0004.bmp",
  L"data/actor/sinmyoumaru/stand0005.bmp",
  L"data/actor/sinmyoumaru/stand0006.bmp",
  L"data/actor/sinmyoumaru/stand0007.bmp",
  L"data/actor/sinmyoumaru/stand0008.bmp",
  L"data/actor/sinmyoumaru/stand0009.bmp",
  L"data/actor/sinmyoumaru/standB0000.bmp",
  L"data/actor/sinmyoumaru/standB0001.bmp",
  L"data/actor/sinmyoumaru/standB0002.bmp",
  L"data/actor/sinmyoumaru/standB0003.bmp",
  L"data/actor/sinmyoumaru/standB0004.bmp",
  L"data/actor/sinmyoumaru/stun0000.bmp",
  L"data/actor/sinmyoumaru/stun0001.bmp",
  L"data/actor/sinmyoumaru/stun0002.bmp",
  L"data/actor/sinmyoumaru/stun0003.bmp",
  L"data/actor/sinmyoumaru/stun0004.bmp",
  L"data/actor/sinmyoumaru/testR_climax0007.png",
  L"data/actor/sinmyoumaru/test_effect.bmp",
  L"data/actor/sinmyoumaru/texture/ball.bmp",
  L"data/actor/sinmyoumaru/texture/climax_back0000.png",
  L"data/actor/sinmyoumaru/texture/climax_foot0002.png",
  L"data/actor/sinmyoumaru/texture/climax_giant0000.png",
  L"data/actor/sinmyoumaru/texture/climax_giant0001.dds",
  L"data/actor/sinmyoumaru/texture/climax_giant0001.png",
  L"data/actor/sinmyoumaru/texture/climax_hammerLight0000.dds",
  L"data/actor/sinmyoumaru/texture/lightning_mapA.png",
  L"data/actor/sinmyoumaru/texture/marisaBall2.bmp",
  L"data/actor/sinmyoumaru/texture/marisaStarFlare.bmp",
  L"data/actor/sinmyoumaru/texture/mask_ball.png",
  L"data/actor/sinmyoumaru/texture/miko_climaxblade.png",
  L"data/actor/sinmyoumaru/texture/occult_shot0000.dds",
  L"data/actor/sinmyoumaru/texture/occult_trail.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00000.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00006.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00012.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00018.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00024.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00000.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00006.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00012.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00018.png",
  L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00024.png",
  L"data/actor/sinmyoumaru/texture/shotStingA0000.png",
  L"data/actor/sinmyoumaru/texture/sinmyoumaru_shotNormal0000.png",
  L"data/actor/sinmyoumaru/texture/skillA_wave0000.dds",
  L"data/actor/sinmyoumaru/texture/skillB_sword0000.dds",
  L"data/actor/sinmyoumaru/texture/skillC_texture0000.dds",
  L"data/actor/sinmyoumaru/texture/skillD_fish0000.dds",
  L"data/actor/sinmyoumaru/texture/skillD_fish0001.dds",
  L"data/actor/sinmyoumaru/texture/skillD_fish0002.dds",
  L"data/actor/sinmyoumaru/texture/smoke.png",
  L"data/actor/sinmyoumaru/texture/spellA_swing0000.dds",
  L"data/actor/sinmyoumaru/texture/spellB_smallAura0000.png",
  L"data/actor/sinmyoumaru/texture/spellB_smallAura0001.png",
  L"data/actor/sinmyoumaru/texture/spellB_smallAura0002.png",
  L"data/actor/sinmyoumaru/texture/spellB_smallAura0003.png",
  L"data/actor/sinmyoumaru/texture/spellC_fish0000.dds",
  L"data/actor/sinmyoumaru/texture/spellC_splash.dds",
  L"data/actor/sinmyoumaru/texture/stone0000.dds",
  L"data/actor/sinmyoumaru/texture/swing0000.png",
  L"data/actor/sinmyoumaru/texture/watarBall0000.dds",
  L"data/actor/sinmyoumaru/walk0000.bmp",
  L"data/actor/sinmyoumaru/walk0001.bmp",
  L"data/actor/sinmyoumaru/walk0002.bmp",
  L"data/actor/sinmyoumaru/walk0003.bmp",
  L"data/actor/sinmyoumaru/walk0004.bmp",
  L"data/actor/sinmyoumaru/walkBack0000.bmp",
  L"data/actor/sinmyoumaru/walkBack0001.bmp",
  L"data/actor/sinmyoumaru/walkBack0002.bmp",
  L"data/actor/sinmyoumaru/walkBack0003.bmp",
  L"data/actor/sinmyoumaru/walkBack0004.bmp",
  L"data/actor/sinmyoumaru/warpMask.bmp",
  L"data/actor/sinmyoumaru/winA0000.bmp",
  L"data/actor/sinmyoumaru/winA0001.bmp",
  L"data/actor/sinmyoumaru/winA0002.bmp",
  L"data/actor/sinmyoumaru/winA0003.bmp",
  L"data/actor/sinmyoumaru/winA0004.bmp",
  L"data/actor/sinmyoumaru/winA0005.bmp",
  L"data/actor/sinmyoumaru/winA0006.bmp",
  L"data/actor/sinmyoumaru/winA0007.bmp",
  L"data/actor/sinmyoumaru/winA0008.bmp",
  L"data/actor/sinmyoumaru/winA0009.bmp",
  L"data/actor/sinmyoumaru.nut",
  L"data/actor/sinmyoumaruInit.nut",
  L"data/actor/sinmyoumaru_base.nut",
  L"data/actor/sinmyoumaru_boss.nut",
  L"data/actor/sinmyoumaru_cpu.nut",
  L"data/actor/sinmyoumaru_cpuBoss.nut",
  L"data/actor/sinmyoumaru_shot.nut",
  L"data/actor/story/futo/story.pat",
  L"data/actor/story/futo/texture/story_moji_title.png",
  L"data/actor/story/futo/whiteBack.bmp",
  L"data/actor/story/hijiri/story.pat",
  L"data/actor/story/hijiri/texture/story_moji_title.png",
  L"data/actor/story/hijiri/whiteBack.bmp",
  L"data/actor/story/ichirin/story.pat",
  L"data/actor/story/ichirin/texture/story_moji_title.png",
  L"data/actor/story/ichirin/whiteBack.bmp",
  L"data/actor/story/kasen/story.pat",
  L"data/actor/story/kasen/texture/story_moji_title.png",
  L"data/actor/story/kasen/whiteBack.bmp",
  L"data/actor/story/koishi/story.pat",
  L"data/actor/story/koishi/texture/story_moji_title.png",
  L"data/actor/story/koishi/whiteBack.bmp",
  L"data/actor/story/kokoro/story.pat",
  L"data/actor/story/kokoro/texture/story_moji_title.png",
  L"data/actor/story/kokoro/whiteBack.bmp",
  L"data/actor/story/mamizou/story.pat",
  L"data/actor/story/mamizou/texture/story_moji_title.png",
  L"data/actor/story/mamizou/whiteBack.bmp",
  L"data/actor/story/marisa/story.pat",
  L"data/actor/story/marisa/texture/story_moji_title.png",
  L"data/actor/story/marisa/whiteBack.bmp",
  L"data/actor/story/miko/story.pat",
  L"data/actor/story/miko/texture/story_moji_title.png",
  L"data/actor/story/miko/whiteBack.bmp",
  L"data/actor/story/mokou/story.pat",
  L"data/actor/story/mokou/texture/story_moji_title.png",
  L"data/actor/story/mokou/whiteBack.bmp",
  L"data/actor/story/nitori/story.pat",
  L"data/actor/story/nitori/texture/story_moji_title.png",
  L"data/actor/story/nitori/whiteBack.bmp",
  L"data/actor/story/reimu/story.pat",
  L"data/actor/story/reimu/texture/story_moji_title.png",
  L"data/actor/story/reimu/tips0000.dds",
  L"data/actor/story/reimu/tips0001.dds",
  L"data/actor/story/reimu/tips0002.dds",
  L"data/actor/story/reimu/tips0003.dds",
  L"data/actor/story/reimu/whiteBack.bmp",
  L"data/actor/story/reimub/story.pat",
  L"data/actor/story/reimub/texture/story_moji_title.png",
  L"data/actor/story/reimuB/whiteBack.bmp",
  L"data/actor/story/sinmyoumaru/story.pat",
  L"data/actor/story/sinmyoumaru/texture/story_moji_title.png",
  L"data/actor/story/sinmyoumaru/whiteBack.bmp",
  L"data/actor/story/usami/story.pat",
  L"data/actor/story/usami/texture/story_moji_title.png",
  L"data/actor/story/usami/whiteBack.bmp",
  L"data/actor/storyEffect.nut",
  L"data/actor/usami/atkDashLow0000.bmp",
  L"data/actor/usami/atkDashLow0001.bmp",
  L"data/actor/usami/atkDashLow0002.bmp",
  L"data/actor/usami/atkDashLow0003.bmp",
  L"data/actor/usami/atkDashLow0004.bmp",
  L"data/actor/usami/atkDashLow0005.bmp",
  L"data/actor/usami/atkDashLow0006.bmp",
  L"data/actor/usami/atkDashLow0007.bmp",
  L"data/actor/usami/atkDashLow0008.bmp",
  L"data/actor/usami/atkDashLow0009.bmp",
  L"data/actor/usami/atkDashLow0010.bmp",
  L"data/actor/usami/atkDashLow0011.bmp",
  L"data/actor/usami/atkDashLow0012.bmp",
  L"data/actor/usami/atkDashLow0013.bmp",
  L"data/actor/usami/atkDashLow0014.bmp",
  L"data/actor/usami/atkFront0000.bmp",
  L"data/actor/usami/atkFront0001.bmp",
  L"data/actor/usami/atkFront0002.bmp",
  L"data/actor/usami/atkFront0003.bmp",
  L"data/actor/usami/atkFront0004.bmp",
  L"data/actor/usami/atkFront0005.bmp",
  L"data/actor/usami/atkFront0006.bmp",
  L"data/actor/usami/atkFront0007.bmp",
  L"data/actor/usami/atkFront0008.bmp",
  L"data/actor/usami/atkFront0009.bmp",
  L"data/actor/usami/atkFrontObject0000.png",
  L"data/actor/usami/atkFrontObject0001.dds",
  L"data/actor/usami/atkFrontObject0002.dds",
  L"data/actor/usami/atkHigh0000.bmp",
  L"data/actor/usami/atkHigh0001.bmp",
  L"data/actor/usami/atkHigh0002.bmp",
  L"data/actor/usami/atkHigh0003.bmp",
  L"data/actor/usami/atkHigh0004.bmp",
  L"data/actor/usami/atkHigh0005.bmp",
  L"data/actor/usami/atkHigh0006.bmp",
  L"data/actor/usami/atkHigh0007.bmp",
  L"data/actor/usami/atkHigh0008.bmp",
  L"data/actor/usami/atkHigh0009.bmp",
  L"data/actor/usami/atkHighObject0000.dds",
  L"data/actor/usami/atkLow0000.bmp",
  L"data/actor/usami/atkLow0001.bmp",
  L"data/actor/usami/atkLow0002.bmp",
  L"data/actor/usami/atkLow0003.bmp",
  L"data/actor/usami/atkLow0004.bmp",
  L"data/actor/usami/atkLow0005.bmp",
  L"data/actor/usami/atkLow0006.bmp",
  L"data/actor/usami/atkLow0007.bmp",
  L"data/actor/usami/atkLow0008.bmp",
  L"data/actor/usami/atkMid0000.bmp",
  L"data/actor/usami/atkMid0001.bmp",
  L"data/actor/usami/atkMid0002.bmp",
  L"data/actor/usami/atkMid0003.bmp",
  L"data/actor/usami/atkMid0004.bmp",
  L"data/actor/usami/atkMid0005.bmp",
  L"data/actor/usami/atkMid0006.bmp",
  L"data/actor/usami/atkMid0007.bmp",
  L"data/actor/usami/atkMid0008.bmp",
  L"data/actor/usami/atkMid0009.bmp",
  L"data/actor/usami/atkMid0010.bmp",
  L"data/actor/usami/atkUnder0000.bmp",
  L"data/actor/usami/atkUnder0001.bmp",
  L"data/actor/usami/atkUnder0002.bmp",
  L"data/actor/usami/atkUnder0003.bmp",
  L"data/actor/usami/atkUnder0004.bmp",
  L"data/actor/usami/atkUnder0005.bmp",
  L"data/actor/usami/atkUnder0006.bmp",
  L"data/actor/usami/atkUnder0007.bmp",
  L"data/actor/usami/atkUnder0008.bmp",
  L"data/actor/usami/atkUnder0009.bmp",
  L"data/actor/usami/atkUnderObject0000.png",
  L"data/actor/usami/atkUnderObject0001.png",
  L"data/actor/usami/atkUnderObject0002.png",
  L"data/actor/usami/atkUnderObject0003.png",
  L"data/actor/usami/atkUnderObjectB0001.png",
  L"data/actor/usami/atkUnderObjectB0002.png",
  L"data/actor/usami/atkUnderObjectB0003.png",
  L"data/actor/usami/battleBegin0000.bmp",
  L"data/actor/usami/battleBegin0001.bmp",
  L"data/actor/usami/battleBegin0002.bmp",
  L"data/actor/usami/battleBegin0003.bmp",
  L"data/actor/usami/battleBegin0004.bmp",
  L"data/actor/usami/battleBegin0005.bmp",
  L"data/actor/usami/battleBegin0006.bmp",
  L"data/actor/usami/battleBegin0007.bmp",
  L"data/actor/usami/beginBattle_card0000.bmp",
  L"data/actor/usami/beginBattle_card0001.bmp",
  L"data/actor/usami/beginBattle_card0002.bmp",
  L"data/actor/usami/beginBattle_card0003.bmp",
  L"data/actor/usami/beginBattle_card0004.bmp",
  L"data/actor/usami/beginBattle_card0005.bmp",
  L"data/actor/usami/beginBattle_card0006.bmp",
  L"data/actor/usami/beginBattle_card0007.bmp",
  L"data/actor/usami/beginBattle_card0008.bmp",
  L"data/actor/usami/beginBattle_card0009.bmp",
  L"data/actor/usami/beginBattle_card0010.bmp",
  L"data/actor/usami/beginBattle_card0011.bmp",
  L"data/actor/usami/beginBattle_card0012.bmp",
  L"data/actor/usami/beginBattle_card0013.bmp",
  L"data/actor/usami/bird0000.bmp",
  L"data/actor/usami/bird0001.bmp",
  L"data/actor/usami/bird0002.bmp",
  L"data/actor/usami/bird0003.bmp",
  L"data/actor/usami/bird0004.bmp",
  L"data/actor/usami/bird0005.bmp",
  L"data/actor/usami/bmsln/reimu_buster.bmb",
  L"data/actor/usami/bmsln/reimu_busterHit.bmb",
  L"data/actor/usami/bmsln/reimu_fallKickA.bmb",
  L"data/actor/usami/bmsln/reimu_HighShotBaria.bmb",
  L"data/actor/usami/bmsln/reimu_keisei.bmb",
  L"data/actor/usami/bmsln/reimu_kibakuzinA.bmb",
  L"data/actor/usami/bmsln/reimu_musouB.bmb",
  L"data/actor/usami/bmsln/reimu_musouG.bmb",
  L"data/actor/usami/bmsln/reimu_musouHitB.bmb",
  L"data/actor/usami/bmsln/reimu_musouHitG.bmb",
  L"data/actor/usami/bmsln/reimu_musouHitR.bmb",
  L"data/actor/usami/bmsln/reimu_musouR.bmb",
  L"data/actor/usami/bmsln/reimu_shot.bmb",
  L"data/actor/usami/bmsln/reimu_shotA.bmb",
  L"data/actor/usami/bmsln/reimu_shotA_gateRing.bmb",
  L"data/actor/usami/bmsln/reimu_shotA_hit.bmb",
  L"data/actor/usami/bmsln/reimu_skillG_kick.bmb",
  L"data/actor/usami/bmsln/reimu_TenseiA000.bmb",
  L"data/actor/usami/bmsln/reimu_tenseiFinish.bmb",
  L"data/actor/usami/bmsln/reimu_tenseiRock.bmb",
  L"data/actor/usami/bmsln/reimu_tenseiRockShot.bmb",
  L"data/actor/usami/bmsln/shot_A_000.bmb",
  L"data/actor/usami/bmsln/shot_A_000.bmsln",
  L"data/actor/usami/climax0000.bmp",
  L"data/actor/usami/climax0001.bmp",
  L"data/actor/usami/climax0002.bmp",
  L"data/actor/usami/climax0003.bmp",
  L"data/actor/usami/climax0004.bmp",
  L"data/actor/usami/climax0005.bmp",
  L"data/actor/usami/climax0006.bmp",
  L"data/actor/usami/climaxCut0000.png",
  L"data/actor/usami/climaxLoop0000.bmp",
  L"data/actor/usami/climaxLoop0001.bmp",
  L"data/actor/usami/climaxLoop0002.bmp",
  L"data/actor/usami/climaxLoop0003.bmp",
  L"data/actor/usami/damageBody0000.bmp",
  L"data/actor/usami/damageBody0001.bmp",
  L"data/actor/usami/damageBody0002.bmp",
  L"data/actor/usami/damageBody0003.bmp",
  L"data/actor/usami/damageBody0004.bmp",
  L"data/actor/usami/damageHead0000.bmp",
  L"data/actor/usami/damageHead0001.bmp",
  L"data/actor/usami/damageHead0002.bmp",
  L"data/actor/usami/damageHead0003.bmp",
  L"data/actor/usami/damageSpin0000.bmp",
  L"data/actor/usami/damageSpin0001.bmp",
  L"data/actor/usami/damageSpin0002.bmp",
  L"data/actor/usami/damageSpin0003.bmp",
  L"data/actor/usami/damageUnder0000.bmp",
  L"data/actor/usami/damageUnder0001.bmp",
  L"data/actor/usami/damageUnder0002.bmp",
  L"data/actor/usami/damageUnder0003.bmp",
  L"data/actor/usami/damageUnder0004.bmp",
  L"data/actor/usami/damageUnder0005.bmp",
  L"data/actor/usami/damageUnder0006.bmp",
  L"data/actor/usami/damageUnder0007.bmp",
  L"data/actor/usami/damageUnder0008.bmp",
  L"data/actor/usami/damageUnder0009.bmp",
  L"data/actor/usami/damageUnder0010.bmp",
  L"data/actor/usami/damageUnder0011.bmp",
  L"data/actor/usami/damageUnder0012.bmp",
  L"data/actor/usami/damageUnder0013.bmp",
  L"data/actor/usami/damageUnder0014.bmp",
  L"data/actor/usami/damageWall0000.bmp",
  L"data/actor/usami/damageWall0001.bmp",
  L"data/actor/usami/damageWall0002.bmp",
  L"data/actor/usami/damageWall0003.bmp",
  L"data/actor/usami/damageWall0004.bmp",
  L"data/actor/usami/damageWall0005.bmp",
  L"data/actor/usami/dashBack0000.bmp",
  L"data/actor/usami/dashBack0001.bmp",
  L"data/actor/usami/dashBack0002.bmp",
  L"data/actor/usami/dashBack0003.bmp",
  L"data/actor/usami/dashBack0004.bmp",
  L"data/actor/usami/dashBack0005.bmp",
  L"data/actor/usami/dashBack0006.bmp",
  L"data/actor/usami/dashBack0007.bmp",
  L"data/actor/usami/dashBack0008.bmp",
  L"data/actor/usami/dashBack0009.bmp",
  L"data/actor/usami/dashBack0010.bmp",
  L"data/actor/usami/dashBack0011.bmp",
  L"data/actor/usami/dashFront0000.bmp",
  L"data/actor/usami/dashFront0001.bmp",
  L"data/actor/usami/dashFront0002.bmp",
  L"data/actor/usami/dashFront0003.bmp",
  L"data/actor/usami/dashFront0004.bmp",
  L"data/actor/usami/dashFront0005.bmp",
  L"data/actor/usami/dashFront0006.bmp",
  L"data/actor/usami/dashFrontLoop0000.bmp",
  L"data/actor/usami/dashFrontLoop0001.bmp",
  L"data/actor/usami/dashFrontLoop0002.bmp",
  L"data/actor/usami/dashFrontLoop0003.bmp",
  L"data/actor/usami/dummy.bmp",
  L"data/actor/usami/face_spellCallB.png",
  L"data/actor/usami/guard0000.bmp",
  L"data/actor/usami/guard0001.bmp",
  L"data/actor/usami/guard0002.bmp",
  L"data/actor/usami/guard0003.bmp",
  L"data/actor/usami/guardCrash0000.bmp",
  L"data/actor/usami/guardCrash0001.bmp",
  L"data/actor/usami/guardCrash0002.bmp",
  L"data/actor/usami/guardCrash0003.bmp",
  L"data/actor/usami/guardMiss0000.bmp",
  L"data/actor/usami/guardMiss0001.bmp",
  L"data/actor/usami/guardMiss0002.bmp",
  L"data/actor/usami/guardMiss0003.bmp",
  L"data/actor/usami/lose0000.bmp",
  L"data/actor/usami/lose0001.bmp",
  L"data/actor/usami/lose0002.bmp",
  L"data/actor/usami/lose0003.bmp",
  L"data/actor/usami/lose0004.bmp",
  L"data/actor/usami/lose0005.bmp",
  L"data/actor/usami/lose0006.bmp",
  L"data/actor/usami/lose0007.bmp",
  L"data/actor/usami/lose0008.bmp",
  L"data/actor/usami/lose0009.bmp",
  L"data/actor/usami/lose0010.bmp",
  L"data/actor/usami/lose0011.bmp",
  L"data/actor/usami/occult0000.bmp",
  L"data/actor/usami/occult0001.bmp",
  L"data/actor/usami/occult0002.bmp",
  L"data/actor/usami/occult0003.bmp",
  L"data/actor/usami/occult0004.bmp",
  L"data/actor/usami/occult0005.bmp",
  L"data/actor/usami/occult0006.bmp",
  L"data/actor/usami/occult0007.bmp",
  L"data/actor/usami/occult0008.bmp",
  L"data/actor/usami/occult0009.bmp",
  L"data/actor/usami/occult0010.bmp",
  L"data/actor/usami/occult0011.bmp",
  L"data/actor/usami/occult0012.bmp",
  L"data/actor/usami/occult0013.bmp",
  L"data/actor/usami/occult0014.bmp",
  L"data/actor/usami/occult0015.bmp",
  L"data/actor/usami/palette000.bmp",
  L"data/actor/usami/palette001.bmp",
  L"data/actor/usami/palette002.bmp",
  L"data/actor/usami/palette003.bmp",
  L"data/actor/usami/palette004.bmp",
  L"data/actor/usami/palette005.bmp",
  L"data/actor/usami/palette006.bmp",
  L"data/actor/usami/palette007.bmp",
  L"data/actor/usami/shot0000.bmp",
  L"data/actor/usami/shot0001.bmp",
  L"data/actor/usami/shot0002.bmp",
  L"data/actor/usami/shot0003.bmp",
  L"data/actor/usami/shot0004.bmp",
  L"data/actor/usami/shot0005.bmp",
  L"data/actor/usami/shot0006.bmp",
  L"data/actor/usami/shot0007.bmp",
  L"data/actor/usami/shot0008.bmp",
  L"data/actor/usami/shot0009.bmp",
  L"data/actor/usami/shot0010.bmp",
  L"data/actor/usami/shotCharge0000.bmp",
  L"data/actor/usami/shotCharge0001.bmp",
  L"data/actor/usami/shotCharge0002.bmp",
  L"data/actor/usami/shotCharge0003.bmp",
  L"data/actor/usami/shotCharge0004.bmp",
  L"data/actor/usami/shotCharge0005.bmp",
  L"data/actor/usami/shotCharge0006.bmp",
  L"data/actor/usami/shotCharge0007.bmp",
  L"data/actor/usami/shotCharge0008.bmp",
  L"data/actor/usami/shotCharge0009.bmp",
  L"data/actor/usami/shotCharge0010.bmp",
  L"data/actor/usami/skillA0000.bmp",
  L"data/actor/usami/skillA0001.bmp",
  L"data/actor/usami/skillA0002.bmp",
  L"data/actor/usami/skillA0003.bmp",
  L"data/actor/usami/skillA0004.bmp",
  L"data/actor/usami/skillA0005.bmp",
  L"data/actor/usami/skillA0006.bmp",
  L"data/actor/usami/skillA0007.bmp",
  L"data/actor/usami/skillA0008.bmp",
  L"data/actor/usami/skillA0009.bmp",
  L"data/actor/usami/skillA0010.bmp",
  L"data/actor/usami/skillB0000.bmp",
  L"data/actor/usami/skillB0001.bmp",
  L"data/actor/usami/skillB0002.bmp",
  L"data/actor/usami/skillB0003.bmp",
  L"data/actor/usami/skillB0004.bmp",
  L"data/actor/usami/skillB0005.bmp",
  L"data/actor/usami/skillB0006.bmp",
  L"data/actor/usami/skillB0007.bmp",
  L"data/actor/usami/skillC0000.bmp",
  L"data/actor/usami/skillC0001.bmp",
  L"data/actor/usami/skillC0002.bmp",
  L"data/actor/usami/skillC0003.bmp",
  L"data/actor/usami/skillC0004.bmp",
  L"data/actor/usami/skillC0005.bmp",
  L"data/actor/usami/skillC0006.bmp",
  L"data/actor/usami/skillC0007.bmp",
  L"data/actor/usami/skillC0008.bmp",
  L"data/actor/usami/skillC0009.bmp",
  L"data/actor/usami/skillC0010.bmp",
  L"data/actor/usami/skillC0011.bmp",
  L"data/actor/usami/skillC0012.bmp",
  L"data/actor/usami/skillC_hole0000.dds",
  L"data/actor/usami/skillC_sprash0000.dds",
  L"data/actor/usami/skillC_sprash0001.dds",
  L"data/actor/usami/skillD0000.bmp",
  L"data/actor/usami/skillD0001.bmp",
  L"data/actor/usami/skillD0002.bmp",
  L"data/actor/usami/skillD0003.bmp",
  L"data/actor/usami/skillD0004.bmp",
  L"data/actor/usami/skillD0005.bmp",
  L"data/actor/usami/skillD0006.bmp",
  L"data/actor/usami/skillD0007.bmp",
  L"data/actor/usami/skillD0008.bmp",
  L"data/actor/usami/skillD0009.bmp",
  L"data/actor/usami/skillD0010.bmp",
  L"data/actor/usami/skillD0011.bmp",
  L"data/actor/usami/skillD0012.bmp",
  L"data/actor/usami/skillD0013.bmp",
  L"data/actor/usami/skillD0014.bmp",
  L"data/actor/usami/skillD_object0000.dds",
  L"data/actor/usami/skillD_object0001.dds",
  L"data/actor/usami/skillE_object0000.dds",
  L"data/actor/usami/skillE_object0001.dds",
  L"data/actor/usami/skillF0000.bmp",
  L"data/actor/usami/skillF0001.bmp",
  L"data/actor/usami/skillF0002.bmp",
  L"data/actor/usami/skillF0003.bmp",
  L"data/actor/usami/skillF0004.bmp",
  L"data/actor/usami/skillF0005.bmp",
  L"data/actor/usami/skillF0006.bmp",
  L"data/actor/usami/skillF0007.bmp",
  L"data/actor/usami/skillF0008.bmp",
  L"data/actor/usami/skillF0009.bmp",
  L"data/actor/usami/skillF0010.bmp",
  L"data/actor/usami/skillF0011.bmp",
  L"data/actor/usami/skillF0012.bmp",
  L"data/actor/usami/skillF_Object0001.png",
  L"data/actor/usami/skillF_Object0002.png",
  L"data/actor/usami/slide0000.bmp",
  L"data/actor/usami/slide0001.bmp",
  L"data/actor/usami/slide0002.bmp",
  L"data/actor/usami/slide0003.bmp",
  L"data/actor/usami/slide0004.bmp",
  L"data/actor/usami/slide0005.bmp",
  L"data/actor/usami/slide0006.bmp",
  L"data/actor/usami/slide0007.bmp",
  L"data/actor/usami/slide0008.bmp",
  L"data/actor/usami/slide0009.bmp",
  L"data/actor/usami/slide0010.bmp",
  L"data/actor/usami/slide0011.bmp",
  L"data/actor/usami/slide0012.bmp",
  L"data/actor/usami/spellA0000.bmp",
  L"data/actor/usami/spellA0001.bmp",
  L"data/actor/usami/spellA0002.bmp",
  L"data/actor/usami/spellA0003.bmp",
  L"data/actor/usami/spellA0004.bmp",
  L"data/actor/usami/spellA0005.bmp",
  L"data/actor/usami/spellA0006.bmp",
  L"data/actor/usami/spellA0007.bmp",
  L"data/actor/usami/spellA0008.bmp",
  L"data/actor/usami/spellA0009.bmp",
  L"data/actor/usami/spellA0010.bmp",
  L"data/actor/usami/spellA0011.bmp",
  L"data/actor/usami/spellB0000.bmp",
  L"data/actor/usami/spellB0001.bmp",
  L"data/actor/usami/spellB0002.bmp",
  L"data/actor/usami/spellB0003.bmp",
  L"data/actor/usami/spellB0004.bmp",
  L"data/actor/usami/spellB0005.bmp",
  L"data/actor/usami/spellB0006.bmp",
  L"data/actor/usami/spellB0007.bmp",
  L"data/actor/usami/spellB0008.bmp",
  L"data/actor/usami/spellB0009.bmp",
  L"data/actor/usami/spellB0010.bmp",
  L"data/actor/usami/stan0000.bmp",
  L"data/actor/usami/stan0001.bmp",
  L"data/actor/usami/stan0002.bmp",
  L"data/actor/usami/stan0003.bmp",
  L"data/actor/usami/stan0004.bmp",
  L"data/actor/usami/stan0005.bmp",
  L"data/actor/usami/stand0000.bmp",
  L"data/actor/usami/stand0001.bmp",
  L"data/actor/usami/stand0002.bmp",
  L"data/actor/usami/stand0003.bmp",
  L"data/actor/usami/stand0004.bmp",
  L"data/actor/usami/stand0005.bmp",
  L"data/actor/usami/stand0006.bmp",
  L"data/actor/usami/stand0007.bmp",
  L"data/actor/usami/stand0008.bmp",
  L"data/actor/usami/stand0009.bmp",
  L"data/actor/usami/stand0010.bmp",
  L"data/actor/usami/stand0011.bmp",
  L"data/actor/usami/stand0012.bmp",
  L"data/actor/usami/stand0013.bmp",
  L"data/actor/usami/stand0014.bmp",
  L"data/actor/usami/stand0015.bmp",
  L"data/actor/usami/stand0016.bmp",
  L"data/actor/usami/stand0017.bmp",
  L"data/actor/usami/stand0018.bmp",
  L"data/actor/usami/stand0019.bmp",
  L"data/actor/usami/stanEnd0000.bmp",
  L"data/actor/usami/stanEnd0001.bmp",
  L"data/actor/usami/test_effect.bmp",
  L"data/actor/usami/texture/A0000.png",
  L"data/actor/usami/texture/A0005.png",
  L"data/actor/usami/texture/A0010.png",
  L"data/actor/usami/texture/A0015.png",
  L"data/actor/usami/texture/A0020.png",
  L"data/actor/usami/texture/A0025.png",
  L"data/actor/usami/texture/A0030.png",
  L"data/actor/usami/texture/A0035.png",
  L"data/actor/usami/texture/A0040.png",
  L"data/actor/usami/texture/A0045.png",
  L"data/actor/usami/texture/B0000.png",
  L"data/actor/usami/texture/B0005.png",
  L"data/actor/usami/texture/B0010.png",
  L"data/actor/usami/texture/B0015.png",
  L"data/actor/usami/texture/B0020.png",
  L"data/actor/usami/texture/B0025.png",
  L"data/actor/usami/texture/B0030.png",
  L"data/actor/usami/texture/B0035.png",
  L"data/actor/usami/texture/B0040.png",
  L"data/actor/usami/texture/B0045.png",
  L"data/actor/usami/texture/ball.bmp",
  L"data/actor/usami/texture/bossSpellE_object0000.dds",
  L"data/actor/usami/texture/boss_aura0000.dds",
  L"data/actor/usami/texture/bulletGateFlash.bmp",
  L"data/actor/usami/texture/bulletGateRing.bmp",
  L"data/actor/usami/texture/C0000.png",
  L"data/actor/usami/texture/C0005.png",
  L"data/actor/usami/texture/C0010.png",
  L"data/actor/usami/texture/C0015.png",
  L"data/actor/usami/texture/C0020.png",
  L"data/actor/usami/texture/C0025.png",
  L"data/actor/usami/texture/C0030.png",
  L"data/actor/usami/texture/C0035.png",
  L"data/actor/usami/texture/C0040.png",
  L"data/actor/usami/texture/C0045.png",
  L"data/actor/usami/texture/chargeO.png",
  L"data/actor/usami/texture/climax_aura0000.png",
  L"data/actor/usami/texture/climax_aura0001.png",
  L"data/actor/usami/texture/climax_brake0000.png",
  L"data/actor/usami/texture/climax_lightPilar0000.dds",
  L"data/actor/usami/texture/climax_lightRay0000.dds",
  L"data/actor/usami/texture/D0000.png",
  L"data/actor/usami/texture/D0005.png",
  L"data/actor/usami/texture/D0010.png",
  L"data/actor/usami/texture/D0015.png",
  L"data/actor/usami/texture/D0020.png",
  L"data/actor/usami/texture/D0025.png",
  L"data/actor/usami/texture/D0030.png",
  L"data/actor/usami/texture/D0035.png",
  L"data/actor/usami/texture/D0040.png",
  L"data/actor/usami/texture/D0045.png",
  L"data/actor/usami/texture/E0000.png",
  L"data/actor/usami/texture/E0005.png",
  L"data/actor/usami/texture/E0010.png",
  L"data/actor/usami/texture/E0015.png",
  L"data/actor/usami/texture/E0020.png",
  L"data/actor/usami/texture/E0025.png",
  L"data/actor/usami/texture/E0030.png",
  L"data/actor/usami/texture/E0035.png",
  L"data/actor/usami/texture/E0040.png",
  L"data/actor/usami/texture/E0045.png",
  L"data/actor/usami/texture/kona_A.bmp",
  L"data/actor/usami/texture/lightning_mapA.png",
  L"data/actor/usami/texture/mantle000.png",
  L"data/actor/usami/texture/marisaBall2.bmp",
  L"data/actor/usami/texture/marisaStarFlare.bmp",
  L"data/actor/usami/texture/mask_ball.png",
  L"data/actor/usami/texture/normalShotCard0000.png",
  L"data/actor/usami/texture/normalShotCard0001.png",
  L"data/actor/usami/texture/normalShotCard0002.png",
  L"data/actor/usami/texture/normalShotCard0003.png",
  L"data/actor/usami/texture/normalShotCard0004.png",
  L"data/actor/usami/texture/occult_A_Laser0000.dds",
  L"data/actor/usami/texture/occult_light0000.dds",
  L"data/actor/usami/texture/occult_shot_object000.png",
  L"data/actor/usami/texture/occult_spark.png",
  L"data/actor/usami/texture/occult_splash0000.dds",
  L"data/actor/usami/texture/occult_vortex0000.dds",
  L"data/actor/usami/texture/reimu_boxA.png",
  L"data/actor/usami/texture/reimu_chargeLine.png",
  L"data/actor/usami/texture/reimu_musouBase.png",
  L"data/actor/usami/texture/reimu_occultMask0000.png",
  L"data/actor/usami/texture/reimu_wallA_Halfmask.png",
  L"data/actor/usami/texture/reimu_wallA_mask.png",
  L"data/actor/usami/texture/reimu_wallFlashA.png",
  L"data/actor/usami/texture/shotFront_fire0000.dds",
  L"data/actor/usami/texture/skillE_object0000.dds",
  L"data/actor/usami/texture/skillF_mail0000.dds",
  L"data/actor/usami/texture/skillF_Object0001.dds",
  L"data/actor/usami/texture/smoke.png",
  L"data/actor/usami/texture/spellA_Flash0000.dds",
  L"data/actor/usami/texture/spellA_Flash0001.dds",
  L"data/actor/usami/texture/spellB_Aura0000.png",
  L"data/actor/usami/texture/spellB_hole0000.dds",
  L"data/actor/usami/texture/spellB_hole0001.dds",
  L"data/actor/usami/texture/spellC_tower0000.png",
  L"data/actor/usami/texture/spellC_tower0001.png",
  L"data/actor/usami/texture/spellC_tower0002.png",
  L"data/actor/usami/texture/sukima_back0000.png",
  L"data/actor/usami/texture/sumire_animal00000.png",
  L"data/actor/usami/texture/sumire_animal00006.png",
  L"data/actor/usami/texture/sumire_animal00012.png",
  L"data/actor/usami/texture/sumire_animal00018.png",
  L"data/actor/usami/texture/sumire_animal00024.png",
  L"data/actor/usami/texture/sumire_animalDamage00000.png",
  L"data/actor/usami/texture/sumire_animalDamage00006.png",
  L"data/actor/usami/texture/sumire_animalDamage00012.png",
  L"data/actor/usami/texture/sumire_animalDamage00018.png",
  L"data/actor/usami/texture/sumire_animalDamage00024.png",
  L"data/actor/usami/texture/swingA0000.png",
  L"data/actor/usami/texture/test_climaxBack.png",
  L"data/actor/usami/texture/trail0000.png",
  L"data/actor/usami/texture/usami_skillA0000.png",
  L"data/actor/usami/usami.pat",
  L"data/actor/usami/usami_ed.pat",
  L"data/actor/usami/walkBack0000.bmp",
  L"data/actor/usami/walkBack0001.bmp",
  L"data/actor/usami/walkBack0002.bmp",
  L"data/actor/usami/walkBack0003.bmp",
  L"data/actor/usami/walkBack0004.bmp",
  L"data/actor/usami/walkBack0005.bmp",
  L"data/actor/usami/walkBackLoop0000.bmp",
  L"data/actor/usami/walkBackLoop0001.bmp",
  L"data/actor/usami/walkBackLoop0002.bmp",
  L"data/actor/usami/walkBackLoop0003.bmp",
  L"data/actor/usami/walkBackLoop0004.bmp",
  L"data/actor/usami/walkFront0000.bmp",
  L"data/actor/usami/walkFront0001.bmp",
  L"data/actor/usami/walkFront0002.bmp",
  L"data/actor/usami/walkFront0003.bmp",
  L"data/actor/usami/walkFront0004.bmp",
  L"data/actor/usami/walkFront0005.bmp",
  L"data/actor/usami/walkFront0006.bmp",
  L"data/actor/usami/walkFrontLoop0000.bmp",
  L"data/actor/usami/walkFrontLoop0001.bmp",
  L"data/actor/usami/walkFrontLoop0002.bmp",
  L"data/actor/usami/walkFrontLoop0003.bmp",
  L"data/actor/usami/walkFrontLoop0004.bmp",
  L"data/actor/usami/warpMask.bmp",
  L"data/actor/usami/winA0000.bmp",
  L"data/actor/usami/winA0001.bmp",
  L"data/actor/usami/winA0002.bmp",
  L"data/actor/usami/winA0003.bmp",
  L"data/actor/usami/winA0004.bmp",
  L"data/actor/usami/winA0005.bmp",
  L"data/actor/usami/winA0006.bmp",
  L"data/actor/usami/winA0007.bmp",
  L"data/actor/usami/winB0000.bmp",
  L"data/actor/usami/winB0001.bmp",
  L"data/actor/usami/winB0002.bmp",
  L"data/actor/usami/winB0003.bmp",
  L"data/actor/usami/winB0004.bmp",
  L"data/actor/usami/winB0005.bmp",
  L"data/actor/usami.nut",
  L"data/actor/usamiInit.nut",
  L"data/actor/usami_base.nut",
  L"data/actor/usami_boss.nut",
  L"data/actor/usami_cpu.nut",
  L"data/actor/usami_cpuBoss.nut",
  L"data/actor/usami_shot.nut",
  L"data/backGround/bg01/000n/n.mat",
  L"data/backGround/bg01/000bO/C.mat",
  L"data/backGround/bg01/000/C.mat",
  L"data/backGround/bg01/000/C.mat",
  L"data/backGround/bg01/000O/C.mat",
  L"data/backGround/bg01/000O/C.mat",
  L"data/backGround/bg01/000[/C.mat",
  L"data/backGround/bg01/000/C.mat",
  L"data/backGround/bg01/000؉E/ؑE.mat",
  L"data/backGround/bg01/000؏/ؑE.mat",
  L"data/backGround/bg01/000؏/ؑ卶.mat",
  L"data/backGround/bg01/000؍/ؑ卶.mat",
  L"data/backGround/bg01/000A[`/C.mat",
  L"data/backGround/bg01/000U/C.mat",
  L"data/backGround/bg01/000ΒʘH/C.mat",
  L"data/backGround/bg01/000_/C.mat",
  L"data/backGround/bg01/000_Њb/C.mat",
  L"data/backGround/bg01/000_Ж{/C.mat",
  L"data/backGround/bg01/000/.mat",
  L"data/backGround/bg01/000/C.mat",
  L"data/backGround/bg01/001R/R.mat",
  L"data/backGround/bg01/002/RO.mat",
  L"data/backGround/bg01/003RO/RO.mat",
  L"data/backGround/bg01/004kusa/`.mat",
  L"data/backGround/bg01/004kusa/a.mat",
  L"data/backGround/bg01/004kusa/b.mat",
  L"data/backGround/bg01/004X/X.mat",
  L"data/backGround/bg01/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/006tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/007tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/008tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/009tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/010kusa/`.mat",
  L"data/backGround/bg01/010kusa/a.mat",
  L"data/backGround/bg01/010kusa/b.mat",
  L"data/backGround/bg01/020tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/021tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/022tree/ؗtϗ.mat",
  L"data/backGround/bg01/023tree/ؗtϕ\a.mat",
  L"data/backGround/bg01/024tree/ؗtϗ.mat",
  L"data/backGround/bg01/025tree/ؗtϕ\.mat",
  L"data/backGround/bg01/026tree/ؗtϗ.mat",
  L"data/backGround/bg01/027tree/ؗtϕ\.mat",
  L"data/backGround/bg01/030kusa/a.mat",
  L"data/backGround/bg01/030kusa/b.mat",
  L"data/backGround/bg01/031kusa/`.mat",
  L"data/backGround/bg01/031kusa/b.mat",
  L"data/backGround/bg01/032tree/ؗtϗ.mat",
  L"data/backGround/bg01/033_tree/ؗtϕ\.mat",
  L"data/backGround/bg01/034tree/ؗtϗ.mat",
  L"data/backGround/bg01/035tree/ؗtϕ\.mat",
  L"data/backGround/bg01/036tree/ؗtϗ.mat",
  L"data/backGround/bg01/037tree/ؗtϕ\.mat",
  L"data/backGround/bg01/040kusa/`.mat",
  L"data/backGround/bg01/040kusa/b.mat",
  L"data/backGround/bg01/041kusa/`.mat",
  L"data/backGround/bg01/041kusa/a.mat",
  L"data/backGround/bg01/042kusa/`.mat",
  L"data/backGround/bg01/bg01.msh",
  L"data/backGround/bg01/bgtest_5.dds",
  L"data/backGround/bg01/bgtest_n02.dds",
  L"data/backGround/bg01/kusa.png",
  L"data/backGround/bg01/kusa2.png",
  L"data/backGround/bg01/kusa3.png",
  L"data/backGround/bg01/mori_O03.dds",
  L"data/backGround/bg01/mori_O04.dds",
  L"data/backGround/bg01/obj1/ؗtϕ\.mat",
  L"data/backGround/bg01/obj1/ؗtϕ\.mat",
  L"data/backGround/bg01/obj1/ؗtϕ\.mat",
  L"data/backGround/bg01/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj1/ؗtϗ.mat",
  L"data/backGround/bg01/obj1/ؗtϗ.mat",
  L"data/backGround/bg01/obj10/ؗtϗ.mat",
  L"data/backGround/bg01/obj11/ؗtϕ\.mat",
  L"data/backGround/bg01/obj12/ؗtϕ\.mat",
  L"data/backGround/bg01/obj13/ؗtϗ.mat",
  L"data/backGround/bg01/obj14/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj15/ؗtϗ.mat",
  L"data/backGround/bg01/obj16/ؗtϕ\.mat",
  L"data/backGround/bg01/obj17/ؗtϗ.mat",
  L"data/backGround/bg01/obj18/ؗtϕ\.mat",
  L"data/backGround/bg01/obj2/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj3/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj4/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj5/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj6/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj7/ؗtϕ\a.mat",
  L"data/backGround/bg01/obj8/ؗtϕ\.mat",
  L"data/backGround/bg01/obj9/ؗtϗ.mat",
  L"data/backGround/bg01/treeA.dds",
  L"data/backGround/bg01/treeA.msh",
  L"data/backGround/bg01/treeA.tak",
  L"data/backGround/bg01/treeB.dds",
  L"data/backGround/bg01/n/n.mat",
  L"data/backGround/bg01/bO/C.mat",
  L"data/backGround/bg01//C.mat",
  L"data/backGround/bg01//C.mat",
  L"data/backGround/bg01/O/C.mat",
  L"data/backGround/bg01/O/C.mat",
  L"data/backGround/bg01/[/C.mat",
  L"data/backGround/bg01//C.mat",
  L"data/backGround/bg01/R/R.mat",
  L"data/backGround/bg01/R1/R.mat",
  L"data/backGround/bg01/RO/RO.mat",
  L"data/backGround/bg01/RO`/RO.mat",
  L"data/backGround/bg01/Rŉ01.dds",
  L"data/backGround/bg01/؉E/ؑE.mat",
  L"data/backGround/bg01/؏/ؑE.mat",
  L"data/backGround/bg01/؏/ؑ卶.mat",
  L"data/backGround/bg01/؍/ؑ卶.mat",
  L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg01/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg01/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg01/ؗt/ؗtϗ.mat",
  L"data/backGround/bg01/ؗt/ؗtϗ.mat",
  L"data/backGround/bg01/X/X.mat",
  L"data/backGround/bg01/A[`/C.mat",
  L"data/backGround/bg01/U/C.mat",
  L"data/backGround/bg01/ΒʘH/C.mat",
  L"data/backGround/bg01/ΒʘH/C.mat",
  L"data/backGround/bg01/_Њb/C.mat",
  L"data/backGround/bg01/_Ж{/C.mat",
  L"data/backGround/bg01//.mat",
  L"data/backGround/bg01/01.dds",
  L"data/backGround/bg01//`.mat",
  L"data/backGround/bg01//a.mat",
  L"data/backGround/bg01//b.mat",
  L"data/backGround/bg01/tA.dds",
  L"data/backGround/bg01/tA.dds",
  L"data/backGround/bg01/tAO.dds",
  L"data/backGround/bg01/tϏ01.dds",
  L"data/backGround/bg01/tϏ02.dds",
  L"data/backGround/bg01/tϏ03.dds",
  L"data/backGround/bg01/tϏc01.dds",
  L"data/backGround/bg01//C.mat",
  L"data/backGround/bg02/000main/19 - Default.mat",
  L"data/backGround/bg02/000main/mat1.mat",
  L"data/backGround/bg02/000e[u02/mat8.mat",
  L"data/backGround/bg02/000e[u1/mat8.mat",
  L"data/backGround/bg02/000㏬/mat8.mat",
  L"data/backGround/bg02/000n/mat1.mat",
  L"data/backGround/bg02/000/04 - Default.mat",
  L"data/backGround/bg02/000/mat8.mat",
  L"data/backGround/bg02/000_Oȓ/mat8.mat",
  L"data/backGround/bg02/000_ƉE/mat8.mat",
  L"data/backGround/bg02/000_ƉE[/mat8.mat",
  L"data/backGround/bg02/000_ƍ/mat8.mat",
  L"data/backGround/bg02/000_ԉ{/mat8.mat",
  L"data/backGround/bg02/000_ԉ/mat8.mat",
  L"data/backGround/bg02/000_/mat8.mat",
  L"data/backGround/bg02/000_O/mat8.mat",
  L"data/backGround/bg02/000_݉/mat8.mat",
  L"data/backGround/bg02/000_݉JE^[/mat8.mat",
  L"data/backGround/bg02/000_݉x_/mat8.mat",
  L"data/backGround/bg02/000_݉/mat8.mat",
  L"data/backGround/bg02/000_݉/mat8.mat",
  L"data/backGround/bg02/000_݉2f/mat8.mat",
  L"data/backGround/bg02/000_݉O1f/mat8.mat",
  L"data/backGround/bg02/000_݉O2f/mat8.mat",
  L"data/backGround/bg02/000_݉/mat8.mat",
  L"data/backGround/bg02/000_݉Ŕ/mat8.mat",
  L"data/backGround/bg02/000_/mat8.mat",
  L"data/backGround/bg02/000_O/mat8.mat",
  L"data/backGround/bg02/000_/mat8.mat",
  L"data/backGround/bg02/000_Ŕ/mat8.mat",
  L"data/backGround/bg02/000񓔂`/mat8.mat",
  L"data/backGround/bg02/000/.mat",
  L"data/backGround/bg02/0001/mat8.mat",
  L"data/backGround/bg02/0002/mat8.mat",
  L"data/backGround/bg02/0003/mat8.mat",
  L"data/backGround/bg02/0004/mat8.mat",
  L"data/backGround/bg02/0005/mat8.mat",
  L"data/backGround/bg02/0006/mat8.mat",
  L"data/backGround/bg02/0007/mat8.mat",
  L"data/backGround/bg02/0008/mat8.mat",
  L"data/backGround/bg02/000M֎q/mat8.mat",
  L"data/backGround/bg02/000MP/mat8.mat",
  L"data/backGround/bg02/000MQ/mat8.mat",
  L"data/backGround/bg02/001R/R.mat",
  L"data/backGround/bg02/002/RO.mat",
  L"data/backGround/bg02/004X01/RO.mat",
  L"data/backGround/bg02/005X/RO.mat",
  L"data/backGround/bg02/006XO/Material #528.mat",
  L"data/backGround/bg02/006XO01/Material #521.mat",
  L"data/backGround/bg02/007XO/Material #521.mat",
  L"data/backGround/bg02/008XO/Material #528.mat",
  L"data/backGround/bg02/008XO2/Material #528.mat",
  L"data/backGround/bg02/bg02.msh",
  L"data/backGround/bg02/bg02.tak",
  L"data/backGround/bg02/bg02_a.msh",
  L"data/backGround/bg02/BL02a_bill.dds",
  L"data/backGround/bg02/BL07m_bill.dds",
  L"data/backGround/bg02/siro/19 - Default.mat",
  L"data/backGround/bg02/ǂwin.dds",
  L"data/backGround/bg02/ǂwiX01.dds",
  L"data/backGround/bg02/ǂwi03.dds",
  L"data/backGround/bg02/̂/mat6.mat",
  L"data/backGround/bg02/e[u/mat6.mat",
  L"data/backGround/bg02/Oȓ/mat6.mat",
  L"data/backGround/bg02/㏬/mat6.mat",
  L"data/backGround/bg02//mat6.mat",
  L"data/backGround/bg02/֎q/mat6.mat",
  L"data/backGround/bg02/ƉE/mat6.mat",
  L"data/backGround/bg02/ƍ/mat6.mat",
  L"data/backGround/bg02/ƍ/mat6.mat",
  L"data/backGround/bg02/01.dds",
  L"data/backGround/bg02/ԉ/mat6.mat",
  L"data/backGround/bg02//mat6.mat",
  L"data/backGround/bg02/݉/mat6.mat",
  L"data/backGround/bg02/݉/mat6.mat",
  L"data/backGround/bg02/݉/mat6.mat",
  L"data/backGround/bg03/000funea/mat1.mat",
  L"data/backGround/bg03/000funea/mat2.mat",
  L"data/backGround/bg03/000h[/mat3.mat",
  L"data/backGround/bg03/000/kumo_naka.mat",
  L"data/backGround/bg03/000/kumo_oku.mat",
  L"data/backGround/bg03/000D/mat1.mat",
  L"data/backGround/bg03/000D/mat2.mat",
  L"data/backGround/bg03/001kumo/mat4.mat",
  L"data/backGround/bg03/001kumob/mat4.mat",
  L"data/backGround/bg03/002kumo/mat4.mat",
  L"data/backGround/bg03/003kumo/mat4.mat",
  L"data/backGround/bg03/004kumo/mat5.mat",
  L"data/backGround/bg03/backup/fune_body.bmp",
  L"data/backGround/bg03/backup/fune_sora.bmp",
  L"data/backGround/bg03/backup/ho01.bmp",
  L"data/backGround/bg03/backup/kumo_A.png",
  L"data/backGround/bg03/backup/kumo_B.png",
  L"data/backGround/bg03/backup/kumo_oku.png",
  L"data/backGround/bg03/bg03.msh",
  L"data/backGround/bg03/fune.msh",
  L"data/backGround/bg03/fune.tak",
  L"data/backGround/bg03/fune_body.dds",
  L"data/backGround/bg03/fune_sora.dds",
  L"data/backGround/bg03/ho01.dds",
  L"data/backGround/bg03/kumo.msh",
  L"data/backGround/bg03/kumo_A.dds",
  L"data/backGround/bg03/kumo_B.dds",
  L"data/backGround/bg03/kumo_naka.dds",
  L"data/backGround/bg03/kumo_oku.dds",
  L"data/backGround/bg03/obj9/mat1.mat",
  L"data/backGround/bg03/obj9/mat2.mat",
  L"data/backGround/bg03/h[/mat3.mat",
  L"data/backGround/bg03//kumo_naka.mat",
  L"data/backGround/bg03//kumo_oku.mat",
  L"data/backGround/bg03/D/mat1.mat",
  L"data/backGround/bg03/D/mat2.mat",
  L"data/backGround/bg04/000treeA/mat8.mat",
  L"data/backGround/bg04/000treeB/mat8.mat",
  L"data/backGround/bg04/000tree_small/mat8.mat",
  L"data/backGround/bg04/000n/A.mat",
  L"data/backGround/bg04/000nЂȒd/A.mat",
  L"data/backGround/bg04/000n/mat1.mat",
  L"data/backGround/bg04/000n/mat2.mat",
  L"data/backGround/bg04/000n/A.mat",
  L"data/backGround/bg04/000/A.mat",
  L"data/backGround/bg04/000k/A.mat",
  L"data/backGround/bg04/000R/mat2.mat",
  L"data/backGround/bg04/000肷/A.mat",
  L"data/backGround/bg04/000肷O/A.mat",
  L"data/backGround/bg04/000/mat1.mat",
  L"data/backGround/bg04/000U/A.mat",
  L"data/backGround/bg04/000UO/A.mat",
  L"data/backGround/bg04/000U/A.mat",
  L"data/backGround/bg04/000U/A.mat",
  L"data/backGround/bg04/000/.mat",
  L"data/backGround/bg04/000j/A.mat",
  L"data/backGround/bg04/000ΑK/A.mat",
  L"data/backGround/bg04/000ǂ/A.mat",
  L"data/backGround/bg04/000Ki/A.mat",
  L"data/backGround/bg04/001R/R.mat",
  L"data/backGround/bg04/002/RO.mat",
  L"data/backGround/bg04/003RO/RO.mat",
  L"data/backGround/bg04/004kusa/`.mat",
  L"data/backGround/bg04/004kusa/a.mat",
  L"data/backGround/bg04/004kusa/b.mat",
  L"data/backGround/bg04/004X/X.mat",
  L"data/backGround/bg04/005tree/ؗtϕ\.mat",
  L"data/backGround/bg04/005tree/ؗtϕ\.mat",
  L"data/backGround/bg04/005tree/ؗtϕ\.mat",
  L"data/backGround/bg04/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/006tree/mat3.mat",
  L"data/backGround/bg04/006tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/007tree/mat3.mat",
  L"data/backGround/bg04/007tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/008tree/mat3.mat",
  L"data/backGround/bg04/008tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/009tree/mat3.mat",
  L"data/backGround/bg04/009tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/010tree/mat3.mat",
  L"data/backGround/bg04/011tree/mat3.mat",
  L"data/backGround/bg04/012tree/mat3.mat",
  L"data/backGround/bg04/012tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/013tree/mat3.mat",
  L"data/backGround/bg04/014tree/mat3.mat",
  L"data/backGround/bg04/015tree/mat3.mat",
  L"data/backGround/bg04/016tree/mat3.mat",
  L"data/backGround/bg04/017tree/mat3.mat",
  L"data/backGround/bg04/018tree/mat3.mat",
  L"data/backGround/bg04/019tree/mat3.mat",
  L"data/backGround/bg04/020tree/mat3.mat",
  L"data/backGround/bg04/021tree/mat3.mat",
  L"data/backGround/bg04/022tree/mat3.mat",
  L"data/backGround/bg04/023tree/mat3.mat",
  L"data/backGround/bg04/023tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/024tree/mat3.mat",
  L"data/backGround/bg04/025tree/mat3.mat",
  L"data/backGround/bg04/026tree/mat3.mat",
  L"data/backGround/bg04/027tree/mat3.mat",
  L"data/backGround/bg04/028tree/mat3.mat",
  L"data/backGround/bg04/029tree/mat3.mat",
  L"data/backGround/bg04/030tree/mat3.mat",
  L"data/backGround/bg04/031tree/mat3.mat",
  L"data/backGround/bg04/031tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/032tree/mat3.mat",
  L"data/backGround/bg04/033tree/mat3.mat",
  L"data/backGround/bg04/034tree/mat3.mat",
  L"data/backGround/bg04/035tree/mat3.mat",
  L"data/backGround/bg04/036tree/mat3.mat",
  L"data/backGround/bg04/037tree/mat3.mat",
  L"data/backGround/bg04/038tree/mat3.mat",
  L"data/backGround/bg04/039tree/mat3.mat",
  L"data/backGround/bg04/040tree/mat3.mat",
  L"data/backGround/bg04/041tree/mat3.mat",
  L"data/backGround/bg04/042tree/mat3.mat",
  L"data/backGround/bg04/043tree/mat3.mat",
  L"data/backGround/bg04/044tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/045tree/mat3.mat",
  L"data/backGround/bg04/046tree/mat3.mat",
  L"data/backGround/bg04/047tree/mat3.mat",
  L"data/backGround/bg04/048tree/mat3.mat",
  L"data/backGround/bg04/049tree/mat3.mat",
  L"data/backGround/bg04/050tree/mat3.mat",
  L"data/backGround/bg04/051tree/mat3.mat",
  L"data/backGround/bg04/052tree/mat3.mat",
  L"data/backGround/bg04/053tree/mat3.mat",
  L"data/backGround/bg04/054tree/mat3.mat",
  L"data/backGround/bg04/055tree/mat3.mat",
  L"data/backGround/bg04/056tree/mat3.mat",
  L"data/backGround/bg04/057tree/mat3.mat",
  L"data/backGround/bg04/058tree/mat3.mat",
  L"data/backGround/bg04/059tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/060tree/mat3.mat",
  L"data/backGround/bg04/061tree/ؗtϕ\a.mat",
  L"data/backGround/bg04/062tree/mat3.mat",
  L"data/backGround/bg04/063tree/mat4.mat",
  L"data/backGround/bg04/064tree/mat4.mat",
  L"data/backGround/bg04/065tree/mat3.mat",
  L"data/backGround/bg04/066tree/mat3.mat",
  L"data/backGround/bg04/067tree/mat3.mat",
  L"data/backGround/bg04/068tree/mat3.mat",
  L"data/backGround/bg04/069tree/ؗtϕ\.mat",
  L"data/backGround/bg04/070tree/mat3.mat",
  L"data/backGround/bg04/071tree/mat3.mat",
  L"data/backGround/bg04/072tree/mat3.mat",
  L"data/backGround/bg04/073tree/mat4.mat",
  L"data/backGround/bg04/074tree/mat3.mat",
  L"data/backGround/bg04/075tree/mat3.mat",
  L"data/backGround/bg04/076tree/mat4.mat",
  L"data/backGround/bg04/077tree/mat3.mat",
  L"data/backGround/bg04/078tree/mat3.mat",
  L"data/backGround/bg04/079tree/mat3.mat",
  L"data/backGround/bg04/080tree/mat3.mat",
  L"data/backGround/bg04/081tree/ؗtϕ\.mat",
  L"data/backGround/bg04/082tree/mat3.mat",
  L"data/backGround/bg04/083tree/mat3.mat",
  L"data/backGround/bg04/084tree/mat3.mat",
  L"data/backGround/bg04/085tree/mat3.mat",
  L"data/backGround/bg04/086tree/mat3.mat",
  L"data/backGround/bg04/087tree/mat3.mat",
  L"data/backGround/bg04/088tree/mat3.mat",
  L"data/backGround/bg04/089tree/mat3.mat",
  L"data/backGround/bg04/090tree/mat3.mat",
  L"data/backGround/bg04/091tree/mat3.mat",
  L"data/backGround/bg04/092tree/mat3.mat",
  L"data/backGround/bg04/093tree/mat3.mat",
  L"data/backGround/bg04/094tree/mat3.mat",
  L"data/backGround/bg04/095tree/mat3.mat",
  L"data/backGround/bg04/096tree/mat3.mat",
  L"data/backGround/bg04/097tree/mat3.mat",
  L"data/backGround/bg04/098tree/mat3.mat",
  L"data/backGround/bg04/099tree/mat3.mat",
  L"data/backGround/bg04/100tree/mat3.mat",
  L"data/backGround/bg04/101tree/mat3.mat",
  L"data/backGround/bg04/102tree/mat3.mat",
  L"data/backGround/bg04/103tree/mat3.mat",
  L"data/backGround/bg04/104tree/mat4.mat",
  L"data/backGround/bg04/105tree/mat3.mat",
  L"data/backGround/bg04/106tree/ؗtϕ\.mat",
  L"data/backGround/bg04/107tree/mat3.mat",
  L"data/backGround/bg04/108tree/mat3.mat",
  L"data/backGround/bg04/109tree/mat3.mat",
  L"data/backGround/bg04/110tree/mat3.mat",
  L"data/backGround/bg04/111tree/mat3.mat",
  L"data/backGround/bg04/112tree/mat3.mat",
  L"data/backGround/bg04/113tree/mat3.mat",
  L"data/backGround/bg04/114tree/mat3.mat",
  L"data/backGround/bg04/115tree/mat3.mat",
  L"data/backGround/bg04/116tree/mat3.mat",
  L"data/backGround/bg04/117tree/mat3.mat",
  L"data/backGround/bg04/118tree/mat4.mat",
  L"data/backGround/bg04/119tree/mat4.mat",
  L"data/backGround/bg04/120tree/mat4.mat",
  L"data/backGround/bg04/121tree/mat3.mat",
  L"data/backGround/bg04/122tree/mat4.mat",
  L"data/backGround/bg04/123tree/mat3.mat",
  L"data/backGround/bg04/124tree/mat3.mat",
  L"data/backGround/bg04/125tree/mat4.mat",
  L"data/backGround/bg04/126tree/mat4.mat",
  L"data/backGround/bg04/127tree/mat4.mat",
  L"data/backGround/bg04/128tree/mat4.mat",
  L"data/backGround/bg04/129tree/mat3.mat",
  L"data/backGround/bg04/130tree/mat3.mat",
  L"data/backGround/bg04/131tree/mat4.mat",
  L"data/backGround/bg04/132tree/mat4.mat",
  L"data/backGround/bg04/133tree/mat4.mat",
  L"data/backGround/bg04/134tree/mat4.mat",
  L"data/backGround/bg04/135tree/mat4.mat",
  L"data/backGround/bg04/136tree/mat4.mat",
  L"data/backGround/bg04/137tree/mat4.mat",
  L"data/backGround/bg04/138tree/mat4.mat",
  L"data/backGround/bg04/139tree/mat4.mat",
  L"data/backGround/bg04/bg04.msh",
  L"data/backGround/bg04/bg04_a.msh",
  L"data/backGround/bg04/bg04_front.msh",
  L"data/backGround/bg04/hata.msh",
  L"data/backGround/bg04/hataA00000.png",
  L"data/backGround/bg04/hataA00004.png",
  L"data/backGround/bg04/hataA00014.png",
  L"data/backGround/bg04/hataL_00/mat8.mat",
  L"data/backGround/bg04/hataL_01/mat8.mat",
  L"data/backGround/bg04/hataL_02/mat8.mat",
  L"data/backGround/bg04/hataL_03/mat8.mat",
  L"data/backGround/bg04/hataL_04/mat8.mat",
  L"data/backGround/bg04/hataL_05/mat8.mat",
  L"data/backGround/bg04/hataR_00/mat5.mat",
  L"data/backGround/bg04/hataR_01/mat5.mat",
  L"data/backGround/bg04/hataR_02/mat7.mat",
  L"data/backGround/bg04/hataR_03/mat5.mat",
  L"data/backGround/bg04/hataR_04/mat6.mat",
  L"data/backGround/bg04/hataR_05/mat5.mat",
  L"data/backGround/bg04/htataB00000.png",
  L"data/backGround/bg04/kusa.dds",
  L"data/backGround/bg04/kusa.png",
  L"data/backGround/bg04/mob/mob_aya.pat",
  L"data/backGround/bg04/mob/mob_B.pat",
  L"data/backGround/bg04/mob/mob_C.pat",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00011.dds",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00012.dds",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00013.dds",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00014.dds",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00015.dds",
  L"data/backGround/bg04/mob/mob_hataa/k_3_00016.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00015.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00017.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00019.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00021.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00022.dds",
  L"data/backGround/bg04/mob/mob_hatab/q_00023.dds",
  L"data/backGround/bg04/mob/mob_hatate.pat",
  L"data/backGround/bg04/mob/mob_K.pat",
  L"data/backGround/bg04/mob/mob_kogasa.pat",
  L"data/backGround/bg04/mob/mob_kyouko.pat",
  L"data/backGround/bg04/mob/mob_mistya.pat",
  L"data/backGround/bg04/mob/mob_shou.pat",
  L"data/backGround/bg04/mori_O03.dds",
  L"data/backGround/bg04/mori_[v.dds",
  L"data/backGround/bg04/obj1/mat3.mat",
  L"data/backGround/bg04/obj2/mat3.mat",
  L"data/backGround/bg04/plane01/01 - Default.mat",
  L"data/backGround/bg04/plane02/01 - Default.mat",
  L"data/backGround/bg04/plane03/01 - Default.mat",
  L"data/backGround/bg04/plane04/01 - Default.mat",
  L"data/backGround/bg04/plane05/01 - Default.mat",
  L"data/backGround/bg04/plane06/01 - Default.mat",
  L"data/backGround/bg04/reimu/05 - Default.mat",
  L"data/backGround/bg04/tree.msh",
  L"data/backGround/bg04/treeA/mat3.mat",
  L"data/backGround/bg04/treeA/mat8.mat",
  L"data/backGround/bg04/treeB/mat3.mat",
  L"data/backGround/bg04/treeB/mat8.mat",
  L"data/backGround/bg04/tree_small/mat3.mat",
  L"data/backGround/bg04/tree_small/mat8.mat",
  L"data/backGround/bg04/n/A.mat",
  L"data/backGround/bg04/nЂȒd/A.mat",
  L"data/backGround/bg04/n/mat1.mat",
  L"data/backGround/bg04/n/mat2.mat",
  L"data/backGround/bg04/n/mat3.mat",
  L"data/backGround/bg04/n/mat4.mat",
  L"data/backGround/bg04/n/mat7.mat",
  L"data/backGround/bg04/n/RN03.mat",
  L"data/backGround/bg04/n/A.mat",
  L"data/backGround/bg04//05 - Default.mat",
  L"data/backGround/bg04//mat1.mat",
  L"data/backGround/bg04//mat2.mat",
  L"data/backGround/bg04//mat3.mat",
  L"data/backGround/bg04//mat6.mat",
  L"data/backGround/bg04//RNp[c01.mat",
  L"data/backGround/bg04//ǎe.mat",
  L"data/backGround/bg04//.mat",
  L"data/backGround/bg04//A.mat",
  L"data/backGround/bg04//_Њ01.mat",
  L"data/backGround/bg04/5.dds",
  L"data/backGround/bg04/eNX`a.dds",
  L"data/backGround/bg04/n.dds",
  L"data/backGround/bg04/k/A.mat",
  L"data/backGround/bg04/.dds",
  L"data/backGround/bg04/Rŉ01.dds",
  L"data/backGround/bg04/R/mat2.mat",
  L"data/backGround/bg04/RE/mat2.mat",
  L"data/backGround/bg04/RE/mat3.mat",
  L"data/backGround/bg04/RE/mat7.mat",
  L"data/backGround/bg04/RE/n.mat",
  L"data/backGround/bg04/RE/A.mat",
  L"data/backGround/bg04/R/mat2.mat",
  L"data/backGround/bg04/R/mat3.mat",
  L"data/backGround/bg04/R/mat7.mat",
  L"data/backGround/bg04/R/A.mat",
  L"data/backGround/bg04/肷/mat3.mat",
  L"data/backGround/bg04/肷/A.mat",
  L"data/backGround/bg04/E/mat5.mat",
  L"data/backGround/bg04/E/mat6.mat",
  L"data/backGround/bg04/E/mat7.mat",
  L"data/backGround/bg04/E/A.mat",
  L"data/backGround/bg04//mat8.mat",
  L"data/backGround/bg04//A.mat",
  L"data/backGround/bg04/U/mat1.mat",
  L"data/backGround/bg04/U/mat3.mat",
  L"data/backGround/bg04/U/A.mat",
  L"data/backGround/bg04/U/A.mat",
  L"data/backGround/bg04/U/A.mat",
  L"data/backGround/bg04/01.dds",
  L"data/backGround/bg04/j/A.mat",
  L"data/backGround/bg04/tA.dds",
  L"data/backGround/bg04/tA.dds",
  L"data/backGround/bg04/tAO.dds",
  L"data/backGround/bg04/tϏ01.dds",
  L"data/backGround/bg04/tϏ02.dds",
  L"data/backGround/bg04/tϏ03.dds",
  L"data/backGround/bg04/tϏc01.dds",
  L"data/backGround/bg04/ΑK/A.mat",
  L"data/backGround/bg04/ǂ/mat3.mat",
  L"data/backGround/bg04/ǂ/mat5.mat",
  L"data/backGround/bg04/ǂ/mat6.mat",
  L"data/backGround/bg04/ǂ/.mat",
  L"data/backGround/bg04/ǂ/A.mat",
  L"data/backGround/bg04/Ki/mat3.mat",
  L"data/backGround/bg04/Ki/A.mat",
  L"data/backGround/bg05/000C/mat3.mat",
  L"data/backGround/bg05/000~/mat3.mat",
  L"data/backGround/bg05/000~/mat3.mat",
  L"data/backGround/bg05/000x_/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000{/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000艜/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000/mat5.mat",
  L"data/backGround/bg05/000/mat3.mat",
  L"data/backGround/bg05/000/mat5.mat",
  L"data/backGround/bg05/000e/mat3.mat",
  L"data/backGround/bg05/000e/mat3.mat",
  L"data/backGround/bg05/000e/mat3.mat",
  L"data/backGround/bg05/000e/mat3.mat",
  L"data/backGround/bg05/000/mat2.mat",
  L"data/backGround/bg05/000qubN/mat3.mat",
  L"data/backGround/bg05/000/.mat",
  L"data/backGround/bg05/000i`/07 - Default.mat",
  L"data/backGround/bg05/000蒌C/mat3.mat",
  L"data/backGround/bg05/000/mat4.mat",
  L"data/backGround/bg05/010/mat1.mat",
  L"data/backGround/bg05/011/mat1.mat",
  L"data/backGround/bg05/012/mat1.mat",
  L"data/backGround/bg05/013/mat1.mat",
  L"data/backGround/bg05/014/mat1.mat",
  L"data/backGround/bg05/015/mat1.mat",
  L"data/backGround/bg05/016/mat1.mat",
  L"data/backGround/bg05/017/mat1.mat",
  L"data/backGround/bg05/018/mat1.mat",
  L"data/backGround/bg05/019/mat1.mat",
  L"data/backGround/bg05/020/mat1.mat",
  L"data/backGround/bg05/021/mat1.mat",
  L"data/backGround/bg05/022/mat1.mat",
  L"data/backGround/bg05/023/mat1.mat",
  L"data/backGround/bg05/024/mat1.mat",
  L"data/backGround/bg05/025/mat1.mat",
  L"data/backGround/bg05/026/mat1.mat",
  L"data/backGround/bg05/027/mat1.mat",
  L"data/backGround/bg05/028/mat1.mat",
  L"data/backGround/bg05/029/mat1.mat",
  L"data/backGround/bg05/030/mat1.mat",
  L"data/backGround/bg05/031/mat1.mat",
  L"data/backGround/bg05/032/mat1.mat",
  L"data/backGround/bg05/033/mat1.mat",
  L"data/backGround/bg05/050/mat1.mat",
  L"data/backGround/bg05/bg05.msh",
  L"data/backGround/bg05/bg05_a.msh",
  L"data/backGround/bg05/dragon.dds",
  L"data/backGround/bg05/kazari_00/mat4.mat",
  L"data/backGround/bg05/kazari_01/mat4.mat",
  L"data/backGround/bg05/kazari_02/mat4.mat",
  L"data/backGround/bg05/kazari_03/mat4.mat",
  L"data/backGround/bg05/kazari_04/mat4.mat",
  L"data/backGround/bg05/kazari_05/mat4.mat",
  L"data/backGround/bg05/kazari_06/mat4.mat",
  L"data/backGround/bg05/kazari_07/mat4.mat",
  L"data/backGround/bg05/kazari_08/mat4.mat",
  L"data/backGround/bg05/kazari_09/mat4.mat",
  L"data/backGround/bg05/kazari_10/mat4.mat",
  L"data/backGround/bg05/kazari_11/mat4.mat",
  L"data/backGround/bg05/kazari_12/mat4.mat",
  L"data/backGround/bg05/kazari_13/mat4.mat",
  L"data/backGround/bg05/kazari_14/mat4.mat",
  L"data/backGround/bg05/kazari_15/mat4.mat",
  L"data/backGround/bg05/kazari_16/mat4.mat",
  L"data/backGround/bg05/kazari_17/mat4.mat",
  L"data/backGround/bg05/kazari_18/mat4.mat",
  L"data/backGround/bg05/kazari_19/mat4.mat",
  L"data/backGround/bg05/kazari_20/mat4.mat",
  L"data/backGround/bg05/kazari_21/mat4.mat",
  L"data/backGround/bg05/kazari_22/mat4.mat",
  L"data/backGround/bg05/kazari_23/mat4.mat",
  L"data/backGround/bg05/kazari_24/mat4.mat",
  L"data/backGround/bg05/kazari_25/mat4.mat",
  L"data/backGround/bg05/kiri.msh",
  L"data/backGround/bg05/mob/mob.txt",
  L"data/backGround/bg05/mob/mob_eiki.pat",
  L"data/backGround/bg05/mob/mob_komachi.pat",
  L"data/backGround/bg05/mob/mob_miyafuru.pat",
  L"data/backGround/bg05/mob/mob_seiga.pat",
  L"data/backGround/bg05/mob/mob_tojiko.pat",
  L"data/backGround/bg05/mob/mob_youmu.pat",
  L"data/backGround/bg05/mob/mob_yuyuko.pat",
  L"data/backGround/bg05/mob/shadowJ.bmp",
  L"data/backGround/bg05/mob/shadow_A.bmp",
  L"data/backGround/bg05/mob/shadow_B.bmp",
  L"data/backGround/bg05/mob/shadow_C.bmp",
  L"data/backGround/bg05/mob/shadow_D.bmp",
  L"data/backGround/bg05/mob/shadow_F.bmp",
  L"data/backGround/bg05/mob/shadow_G.bmp",
  L"data/backGround/bg05/mob/shadow_kourin.bmp",
  L"data/backGround/bg05/mob/Ƃ0000.png",
  L"data/backGround/bg05/mob/Ƃ0001.png",
  L"data/backGround/bg05/mob/Ƃ0002.png",
  L"data/backGround/bg05/mob/Ƃ0003.png",
  L"data/backGround/bg05/mob/䂱0000.png",
  L"data/backGround/bg05/mob/d0000.png",
  L"data/backGround/bg05/mob/{0000.png",
  L"data/backGround/bg05/mob/{0001.png",
  L"data/backGround/bg05/mob/{0002.png",
  L"data/backGround/bg05/mob/{0003.png",
  L"data/backGround/bg05/mob/0000.png",
  L"data/backGround/bg05/mob/fG0000.png",
  L"data/backGround/bg05/mob/0000.png",
  L"data/backGround/bg05/mob/0001.png",
  L"data/backGround/bg05/mob/0002.png",
  L"data/backGround/bg05/mobl.dds",
  L"data/backGround/bg05/plane01/01 - Default.mat",
  L"data/backGround/bg05/plane02/01 - Default.mat",
  L"data/backGround/bg05/plane03/01 - Default.mat",
  L"data/backGround/bg05/plane04/01 - Default.mat",
  L"data/backGround/bg05/plane05/01 - Default.mat",
  L"data/backGround/bg05/plane06/01 - Default.mat",
  L"data/backGround/bg05/C/06 - Default.mat",
  L"data/backGround/bg05/C/mat1.mat",
  L"data/backGround/bg05/C/mat3.mat",
  L"data/backGround/bg05/lui/mat1.mat",
  L"data/backGround/bg05/luiQ/mat1.mat",
  L"data/backGround/bg05/luőO/mat1.mat",
  L"data/backGround/bg05/luőO2/mat1.mat",
  L"data/backGround/bg05/luŉ/mat1.mat",
  L"data/backGround/bg05/~/06 - Default.mat",
  L"data/backGround/bg05/~/mat1.mat",
  L"data/backGround/bg05/~/mat3.mat",
  L"data/backGround/bg05/~/mat1.mat",
  L"data/backGround/bg05/~/mat3.mat",
  L"data/backGround/bg05//06 - Default.mat",
  L"data/backGround/bg05/x_/mat1.mat",
  L"data/backGround/bg05/x_/mat3.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05/{/mat1.mat",
  L"data/backGround/bg05/{/mat3.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05/艜/mat1.mat",
  L"data/backGround/bg05/艜/mat3.mat",
  L"data/backGround/bg05//06 - Default.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05//06 - Default.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05//mat5.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat3.mat",
  L"data/backGround/bg05//06 - Default.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat5.mat",
  L"data/backGround/bg05/e/06 - Default.mat",
  L"data/backGround/bg05/e/mat1.mat",
  L"data/backGround/bg05/e/mat3.mat",
  L"data/backGround/bg05/e/mat1.mat",
  L"data/backGround/bg05/e/mat3.mat",
  L"data/backGround/bg05/e/mat1.mat",
  L"data/backGround/bg05/e/mat3.mat",
  L"data/backGround/bg05/e/mat1.mat",
  L"data/backGround/bg05/e/mat3.mat",
  L"data/backGround/bg05//06 - Default.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05//mat2.mat",
  L"data/backGround/bg05/qubN/mat1.mat",
  L"data/backGround/bg05/qubN/mat3.mat",
  L"data/backGround/bg05/qubN01/mat1.mat",
  L"data/backGround/bg05/_qn`n01.dds",
  L"data/backGround/bg05/_qn`C.dds",
  L"data/backGround/bg05/_qn`.dds",
  L"data/backGround/bg05/_qi.dds",
  L"data/backGround/bg05/_yoru.dds",
  L"data/backGround/bg05/i`/07 - Default.mat",
  L"data/backGround/bg05/i`/14 - Default.mat",
  L"data/backGround/bg05/Ki/06 - Default.mat",
  L"data/backGround/bg05/Ki_q/mat1.mat",
  L"data/backGround/bg05//mat1.mat",
  L"data/backGround/bg05/.dds",
  L"data/backGround/bg05/蒌C/mat1.mat",
  L"data/backGround/bg05/蒌C/mat3.mat",
  L"data/backGround/bg05//mat4.mat",
  L"data/backGround/bg06/000/mat1.mat",
  L"data/backGround/bg06/000/mat3.mat",
  L"data/backGround/bg06/000/12 - Default.mat",
  L"data/backGround/bg06/000/21 - Default.mat",
  L"data/backGround/bg06/000/mat1.mat",
  L"data/backGround/bg06/00001/12 - Default.mat",
  L"data/backGround/bg06/000/.mat",
  L"data/backGround/bg06/000/04 - Default.mat",
  L"data/backGround/bg06/000/12 - Default.mat",
  L"data/backGround/bg06/001/mat2.mat",
  L"data/backGround/bg06/002/mat2.mat",
  L"data/backGround/bg06/003/mat2.mat",
  L"data/backGround/bg06/050flower/mat4.mat",
  L"data/backGround/bg06/bg06.msh",
  L"data/backGround/bg06/bg06_a.msh",
  L"data/backGround/bg06/flower/mat4.mat",
  L"data/backGround/bg06/light.msh",
  L"data/backGround/bg06/mob/hane_lily.bmp",
  L"data/backGround/bg06/mob/mob.txt",
  L"data/backGround/bg06/mob/mob_haneA.pat",
  L"data/backGround/bg06/mob/mob_lily.pat",
  L"data/backGround/bg06/mob/mob_luna.pat",
  L"data/backGround/bg06/mob/mob_luna_hane.pat",
  L"data/backGround/bg06/mob/mob_sany.pat",
  L"data/backGround/bg06/mob/mob_sany_hane.pat",
  L"data/backGround/bg06/mob/mob_star.pat",
  L"data/backGround/bg06/mob/mob_star_hane.pat",
  L"data/backGround/bg06/mob/shadowJ.bmp",
  L"data/backGround/bg06/mob/shadow_A.bmp",
  L"data/backGround/bg06/mob/shadow_B.bmp",
  L"data/backGround/bg06/mob/shadow_C.bmp",
  L"data/backGround/bg06/mob/shadow_D.bmp",
  L"data/backGround/bg06/mob/shadow_F.bmp",
  L"data/backGround/bg06/mob/shadow_G.bmp",
  L"data/backGround/bg06/mob/shadow_kourin.bmp",
  L"data/backGround/bg06/plane01/01 - Default.mat",
  L"data/backGround/bg06/plane01/21 - Default.mat",
  L"data/backGround/bg06/plane02/01 - Default.mat",
  L"data/backGround/bg06/plane03/01 - Default.mat",
  L"data/backGround/bg06/plane04/01 - Default.mat",
  L"data/backGround/bg06/plane05/01 - Default.mat",
  L"data/backGround/bg06/plane06/01 - Default.mat",
  L"data/backGround/bg06/.dds",
  L"data/backGround/bg06//21 - Default.mat",
  L"data/backGround/bg06//mat3.mat",
  L"data/backGround/bg06//21 - Default.mat",
  L"data/backGround/bg06/01/mat3.mat",
  L"data/backGround/bg06/zsXe[W08.dds",
  L"data/backGround/bg06/zsXe[W.dds",
  L"data/backGround/bg06/zsXe[W.dds",
  L"data/backGround/bg06/zsXe[W.dds",
  L"data/backGround/bg06//mat3.mat",
  L"data/backGround/bg06/@.dds",
  L"data/backGround/bg06//mat1.mat",
  L"data/backGround/bg07/000/mat2.mat",
  L"data/backGround/bg07/000/mat3.mat",
  L"data/backGround/bg07/000/.mat",
  L"data/backGround/bg07/001R/R.mat",
  L"data/backGround/bg07/002/RO.mat",
  L"data/backGround/bg07/003RO/RO.mat",
  L"data/backGround/bg07/bg07.msh",
  L"data/backGround/bg07/bg_a.msh",
  L"data/backGround/bg07/mob/mob_aya.pat",
  L"data/backGround/bg07/mob/mob_hatate.pat",
  L"data/backGround/bg07/mob/mob_hina.pat",
  L"data/backGround/bg07/mob/mob_kanako.pat",
  L"data/backGround/bg07/mob/mob_minoriko.pat",
  L"data/backGround/bg07/mob/mob_point.txt",
  L"data/backGround/bg07/mob/mob_sanae.pat",
  L"data/backGround/bg07/mob/mob_sizuha.pat",
  L"data/backGround/bg07/mob/mob_suwako.pat",
  L"data/backGround/bg07/mob/mob_taki/taki0001.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0002.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0003.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0004.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0005.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0006.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0007.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0008.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0009.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0010.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0011.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0012.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0013.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0014.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0015.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0016.dds",
  L"data/backGround/bg07/mob/mob_taki/taki0017.dds",
  L"data/backGround/bg07/mob/shadowJ.bmp",
  L"data/backGround/bg07/mob/shadow_A.bmp",
  L"data/backGround/bg07/mob/shadow_B.bmp",
  L"data/backGround/bg07/mob/shadow_C.bmp",
  L"data/backGround/bg07/mob/shadow_D.bmp",
  L"data/backGround/bg07/mob/shadow_F.bmp",
  L"data/backGround/bg07/mob/shadow_G.bmp",
  L"data/backGround/bg07/mob/shadow_kourin.bmp",
  L"data/backGround/bg07/obj1/mat3.mat",
  L"data/backGround/bg07/obj10/mat3.mat",
  L"data/backGround/bg07/obj11/mat3.mat",
  L"data/backGround/bg07/obj12/mat3.mat",
  L"data/backGround/bg07/obj13/mat3.mat",
  L"data/backGround/bg07/obj14/mat3.mat",
  L"data/backGround/bg07/obj15/mat3.mat",
  L"data/backGround/bg07/obj16/mat3.mat",
  L"data/backGround/bg07/obj17/mat3.mat",
  L"data/backGround/bg07/obj18/mat3.mat",
  L"data/backGround/bg07/obj19/mat3.mat",
  L"data/backGround/bg07/obj2/mat3.mat",
  L"data/backGround/bg07/obj20/mat3.mat",
  L"data/backGround/bg07/obj21/mat3.mat",
  L"data/backGround/bg07/obj22/mat3.mat",
  L"data/backGround/bg07/obj23/mat3.mat",
  L"data/backGround/bg07/obj24/mat3.mat",
  L"data/backGround/bg07/obj25/mat3.mat",
  L"data/backGround/bg07/obj26/mat3.mat",
  L"data/backGround/bg07/obj27/mat3.mat",
  L"data/backGround/bg07/obj28/mat3.mat",
  L"data/backGround/bg07/obj29/mat3.mat",
  L"data/backGround/bg07/obj3/mat3.mat",
  L"data/backGround/bg07/obj30/mat3.mat",
  L"data/backGround/bg07/obj31/mat3.mat",
  L"data/backGround/bg07/obj32/mat3.mat",
  L"data/backGround/bg07/obj33/mat3.mat",
  L"data/backGround/bg07/obj34/mat3.mat",
  L"data/backGround/bg07/obj35/mat3.mat",
  L"data/backGround/bg07/obj36/mat3.mat",
  L"data/backGround/bg07/obj37/mat3.mat",
  L"data/backGround/bg07/obj38/mat3.mat",
  L"data/backGround/bg07/obj39/mat3.mat",
  L"data/backGround/bg07/obj4/mat3.mat",
  L"data/backGround/bg07/obj40/mat3.mat",
  L"data/backGround/bg07/obj41/mat3.mat",
  L"data/backGround/bg07/obj42/mat3.mat",
  L"data/backGround/bg07/obj43/mat3.mat",
  L"data/backGround/bg07/obj5/mat3.mat",
  L"data/backGround/bg07/obj6/mat3.mat",
  L"data/backGround/bg07/obj7/mat3.mat",
  L"data/backGround/bg07/obj8/mat3.mat",
  L"data/backGround/bg07/obj9/mat3.mat",
  L"data/backGround/bg07/plane01/01 - Default.mat",
  L"data/backGround/bg07/plane02/01 - Default.mat",
  L"data/backGround/bg07/plane03/01 - Default.mat",
  L"data/backGround/bg07/plane04/01 - Default.mat",
  L"data/backGround/bg07/plane05/01 - Default.mat",
  L"data/backGround/bg07/taki.msh",
  L"data/backGround/bg07/ɂƂXe[Wshadow.dds",
  L"data/backGround/bg07/ɂƂXe[WIuWF.dds",
  L"data/backGround/bg07/pCv/04 - Default.mat",
  L"data/backGround/bg07/pCv/mat1.mat",
  L"data/backGround/bg07/pCv/[va.mat",
  L"data/backGround/bg07/C/04 - Default.mat",
  L"data/backGround/bg07/C/mat1.mat",
  L"data/backGround/bg07/C/mat2.mat",
  L"data/backGround/bg07/C1/04 - Default.mat",
  L"data/backGround/bg07/.dds",
  L"data/backGround/bg07//03 - Default.mat",
  L"data/backGround/bg07/X.dds",
  L"data/backGround/bg07//03 - Default.mat",
  L"data/backGround/bg07//mat4.mat",
  L"data/backGround/bg07//04 - Default.mat",
  L"data/backGround/bg07//mat1.mat",
  L"data/backGround/bg07//mat2.mat",
  L"data/backGround/bg07/t/mat3.mat",
  L"data/backGround/bg07/t/ؗtϕ\.mat",
  L"data/backGround/bg07/tϏ01.dds",
  L"data/backGround/bg08/bg08.msh",
  L"data/backGround/bg08/mob/}0000.png",
  L"data/backGround/bg08/plane01/01 - Default.mat",
  L"data/backGround/bg08/plane02/01 - Default.mat",
  L"data/backGround/bg08/plane03/01 - Default.mat",
  L"data/backGround/bg08/plane04/01 - Default.mat",
  L"data/backGround/bg08/Xe[W13.dds",
  L"data/backGround/bg08/Xe[W13B.dds",
  L"data/backGround/bg08/ǉ/11 - Default.mat",
  L"data/backGround/bg08/ǉ/mat4.mat",
  L"data/backGround/bg08/ǂP/11 - Default.mat",
  L"data/backGround/bg08/ǂP/mat1.mat",
  L"data/backGround/bg08/ǂP/mat4.mat",
  L"data/backGround/bg08/ǂP01/mat1.mat",
  L"data/backGround/bg08/ǂP1/11 - Default.mat",
  L"data/backGround/bg08/ǂP1/mat4.mat",
  L"data/backGround/bg08/ǂQ/11 - Default.mat",
  L"data/backGround/bg08/ǂQ/mat1.mat",
  L"data/backGround/bg08/ǂQ/mat4.mat",
  L"data/backGround/bg08/ǂQ01/mat1.mat",
  L"data/backGround/bg08/ǂQ1/mat4.mat",
  L"data/backGround/bg08/ǂR/11 - Default.mat",
  L"data/backGround/bg08/ǂR/mat1.mat",
  L"data/backGround/bg08/ǂR/mat4.mat",
  L"data/backGround/bg08/ǂR01/mat1.mat",
  L"data/backGround/bg08/ǂR1/mat4.mat",
  L"data/backGround/bg08/V/11 - Default.mat",
  L"data/backGround/bg08/V/mat4.mat",
  L"data/backGround/bg08/P/11 - Default.mat",
  L"data/backGround/bg08/P/mat1.mat",
  L"data/backGround/bg08/P/mat4.mat",
  L"data/backGround/bg08/P01/mat1.mat",
  L"data/backGround/bg08/P1/11 - Default.mat",
  L"data/backGround/bg08/P1/mat4.mat",
  L"data/backGround/bg08/P2/11 - Default.mat",
  L"data/backGround/bg08/P2/mat4.mat",
  L"data/backGround/bg08/Q/11 - Default.mat",
  L"data/backGround/bg08/Q/mat1.mat",
  L"data/backGround/bg08/Q/mat4.mat",
  L"data/backGround/bg08/Q01/mat1.mat",
  L"data/backGround/bg08/Q1/11 - Default.mat",
  L"data/backGround/bg08/Q1/mat4.mat",
  L"data/backGround/bg08/Q2/11 - Default.mat",
  L"data/backGround/bg08/Q2/mat4.mat",
  L"data/backGround/bg08/R/11 - Default.mat",
  L"data/backGround/bg08/R/mat1.mat",
  L"data/backGround/bg08/R/mat4.mat",
  L"data/backGround/bg08/R01/mat1.mat",
  L"data/backGround/bg08/R1/11 - Default.mat",
  L"data/backGround/bg08/R1/mat4.mat",
  L"data/backGround/bg08/R2/mat4.mat",
  L"data/backGround/bg08//mat1.mat",
  L"data/backGround/bg08/b/mat1.mat",
  L"data/backGround/bg08/b/mat2.mat",
  L"data/backGround/bg08/ǃVv/11 - Default.mat",
  L"data/backGround/bg08/ǃVv/mat4.mat",
  L"data/backGround/bg09/000n/mat1.mat",
  L"data/backGround/bg09/000n/mat2.mat",
  L"data/backGround/bg09/000n/mat3.mat",
  L"data/backGround/bg09/000n/A.mat",
  L"data/backGround/bg09/000bO/C.mat",
  L"data/backGround/bg09/000/C.mat",
  L"data/backGround/bg09/000/C.mat",
  L"data/backGround/bg09/000O/C.mat",
  L"data/backGround/bg09/000O/C.mat",
  L"data/backGround/bg09/000[/C.mat",
  L"data/backGround/bg09/000/C.mat",
  L"data/backGround/bg09/000A[`/C.mat",
  L"data/backGround/bg09/000U/C.mat",
  L"data/backGround/bg09/000ΒʘH/C.mat",
  L"data/backGround/bg09/000_/C.mat",
  L"data/backGround/bg09/000_Њb/C.mat",
  L"data/backGround/bg09/000_Ж{/C.mat",
  L"data/backGround/bg09/000/.mat",
  L"data/backGround/bg09/001R/mat4.mat",
  L"data/backGround/bg09/001R/R.mat",
  L"data/backGround/bg09/002/RO.mat",
  L"data/backGround/bg09/002X/mat5.mat",
  L"data/backGround/bg09/002X/mat6.mat",
  L"data/backGround/bg09/003nʑ/mat1.mat",
  L"data/backGround/bg09/003RO/RO.mat",
  L"data/backGround/bg09/003X/mat7.mat",
  L"data/backGround/bg09/004XOE/mat9.mat",
  L"data/backGround/bg09/005XO/mat8.mat",
  L"data/backGround/bg09/006nʑ/mat1.mat",
  L"data/backGround/bg09/bg09.msh",
  L"data/backGround/bg09/bg09_a.msh",
  L"data/backGround/bg09/kusa_[.png",
  L"data/backGround/bg09/mob/hane_lily.bmp",
  L"data/backGround/bg09/obj1/mat2.mat",
  L"data/backGround/bg09/obj2/mat2.mat",
  L"data/backGround/bg09/plane01/01 - Default.mat",
  L"data/backGround/bg09/plane02/01 - Default.mat",
  L"data/backGround/bg09/plane03/01 - Default.mat",
  L"data/backGround/bg09/plane04/01 - Default.mat",
  L"data/backGround/bg09/plane05/01 - Default.mat",
  L"data/backGround/bg09/plane06/01 - Default.mat",
  L"data/backGround/bg09/plane07/01 - Default.mat",
  L"data/backGround/bg09/plane08/01 - Default.mat",
  L"data/backGround/bg09/}~]EXe[W3.dds",
  L"data/backGround/bg09/}~]EX.dds",
  L"data/backGround/bg09/}~]EXO.dds",
  L"data/backGround/bg09/}~]EXOE.dds",
  L"data/backGround/bg09/}~]EXO.dds",
  L"data/backGround/bg09/}~]EX艜.dds",
  L"data/backGround/bg09/}~]EX艜E.dds",
  L"data/backGround/bg09/}~]EX艜.dds",
  L"data/backGround/bg09/n/mat3.mat",
  L"data/backGround/bg09/n1/mat3.mat",
  L"data/backGround/bg09/nʑ/mat1.mat",
  L"data/backGround/bg09/X/mat5.mat",
  L"data/backGround/bg09/X/mat6.mat",
  L"data/backGround/bg09/_/C.mat",
  L"data/backGround/bg09/[01.dds",
  L"data/backGround/bg10/000e[u1/mat8.mat",
  L"data/backGround/bg10/000㏬/mat8.mat",
  L"data/backGround/bg10/000/04 - Default.mat",
  L"data/backGround/bg10/000_Oȓ/mat8.mat",
  L"data/backGround/bg10/000_ƉE/mat8.mat",
  L"data/backGround/bg10/000_ƉE[/mat8.mat",
  L"data/backGround/bg10/000_ƍ/mat8.mat",
  L"data/backGround/bg10/000_ԉ{/mat8.mat",
  L"data/backGround/bg10/000_ԉ/mat8.mat",
  L"data/backGround/bg10/000_/mat8.mat",
  L"data/backGround/bg10/000_O/mat8.mat",
  L"data/backGround/bg10/000_݉/mat8.mat",
  L"data/backGround/bg10/000_݉JE^[/mat8.mat",
  L"data/backGround/bg10/000_݉x_/mat8.mat",
  L"data/backGround/bg10/000_݉/mat8.mat",
  L"data/backGround/bg10/000_݉/mat8.mat",
  L"data/backGround/bg10/000_݉2f/mat8.mat",
  L"data/backGround/bg10/000_݉O1f/mat8.mat",
  L"data/backGround/bg10/000_݉O2f/mat8.mat",
  L"data/backGround/bg10/000_݉/mat8.mat",
  L"data/backGround/bg10/000_݉Ŕ/mat8.mat",
  L"data/backGround/bg10/000_/mat8.mat",
  L"data/backGround/bg10/000_O/mat8.mat",
  L"data/backGround/bg10/000_/mat8.mat",
  L"data/backGround/bg10/000_Ŕ/mat8.mat",
  L"data/backGround/bg10/000񓔂`/mat8.mat",
  L"data/backGround/bg10/000/.mat",
  L"data/backGround/bg10/0001/mat8.mat",
  L"data/backGround/bg10/0002/mat8.mat",
  L"data/backGround/bg10/0003/mat8.mat",
  L"data/backGround/bg10/0004/mat8.mat",
  L"data/backGround/bg10/0005/mat8.mat",
  L"data/backGround/bg10/0006/mat8.mat",
  L"data/backGround/bg10/0007/mat8.mat",
  L"data/backGround/bg10/0008/mat8.mat",
  L"data/backGround/bg10/000M֎q/mat8.mat",
  L"data/backGround/bg10/000MP/mat8.mat",
  L"data/backGround/bg10/000MQ/mat8.mat",
  L"data/backGround/bg10/001R/R.mat",
  L"data/backGround/bg10/002/RO.mat",
  L"data/backGround/bg10/bg10.msh",
  L"data/backGround/bg10/mob/mob.txt",
  L"data/backGround/bg10/mob/mob_A.pat",
  L"data/backGround/bg10/mob/mob_A0000.png",
  L"data/backGround/bg10/mob/mob_B.pat",
  L"data/backGround/bg10/mob/mob_B0000.png",
  L"data/backGround/bg10/mob/mob_B0001.png",
  L"data/backGround/bg10/mob/mob_B0002.png",
  L"data/backGround/bg10/mob/mob_B0003.png",
  L"data/backGround/bg10/mob/mob_C.pat",
  L"data/backGround/bg10/mob/mob_C0000.png",
  L"data/backGround/bg10/mob/mob_C0001.png",
  L"data/backGround/bg10/mob/mob_C0002.png",
  L"data/backGround/bg10/mob/mob_C0003.png",
  L"data/backGround/bg10/mob/mob_D.pat",
  L"data/backGround/bg10/mob/mob_D0000.png",
  L"data/backGround/bg10/mob/mob_D0001.png",
  L"data/backGround/bg10/mob/mob_D0002.png",
  L"data/backGround/bg10/mob/mob_D0003.png",
  L"data/backGround/bg10/mob/mob_E.pat",
  L"data/backGround/bg10/mob/mob_E0000.png",
  L"data/backGround/bg10/mob/mob_E0001.png",
  L"data/backGround/bg10/mob/mob_E0002.png",
  L"data/backGround/bg10/mob/mob_E0003.png",
  L"data/backGround/bg10/mob/mob_eirin.pat",
  L"data/backGround/bg10/mob/mob_eirin0000.png",
  L"data/backGround/bg10/mob/mob_eirin0001.png",
  L"data/backGround/bg10/mob/mob_eirin0002.png",
  L"data/backGround/bg10/mob/mob_F.pat",
  L"data/backGround/bg10/mob/mob_F0000.png",
  L"data/backGround/bg10/mob/mob_F0001.png",
  L"data/backGround/bg10/mob/mob_F0002.png",
  L"data/backGround/bg10/mob/mob_F0003.png",
  L"data/backGround/bg10/mob/mob_G.pat",
  L"data/backGround/bg10/mob/mob_G0000.png",
  L"data/backGround/bg10/mob/mob_G0001.png",
  L"data/backGround/bg10/mob/mob_G0002.png",
  L"data/backGround/bg10/mob/mob_G0003.png",
  L"data/backGround/bg10/mob/mob_H.pat",
  L"data/backGround/bg10/mob/mob_H0000.png",
  L"data/backGround/bg10/mob/mob_H0001.png",
  L"data/backGround/bg10/mob/mob_H0002.png",
  L"data/backGround/bg10/mob/mob_H0003.png",
  L"data/backGround/bg10/mob/mob_I.pat",
  L"data/backGround/bg10/mob/mob_I0000.png",
  L"data/backGround/bg10/mob/mob_I0001.png",
  L"data/backGround/bg10/mob/mob_I0002.png",
  L"data/backGround/bg10/mob/mob_I0003.png",
  L"data/backGround/bg10/mob/mob_J.pat",
  L"data/backGround/bg10/mob/mob_J0000.png",
  L"data/backGround/bg10/mob/mob_J0001.png",
  L"data/backGround/bg10/mob/mob_J0002.png",
  L"data/backGround/bg10/mob/mob_J0003.png",
  L"data/backGround/bg10/mob/mob_K.pat",
  L"data/backGround/bg10/mob/mob_K0000.png",
  L"data/backGround/bg10/mob/mob_K0001.png",
  L"data/backGround/bg10/mob/mob_K0002.png",
  L"data/backGround/bg10/mob/mob_K0003.png",
  L"data/backGround/bg10/mob/mob_kaguya.pat",
  L"data/backGround/bg10/mob/mob_kaguya0000.png",
  L"data/backGround/bg10/mob/mob_kaguya0001.png",
  L"data/backGround/bg10/mob/mob_kaguya0002.png",
  L"data/backGround/bg10/mob/mob_kaguya0003.png",
  L"data/backGround/bg10/mob/mob_kaguya0004.png",
  L"data/backGround/bg10/mob/mob_kaguya0005.png",
  L"data/backGround/bg10/mob/mob_kaguya0006.png",
  L"data/backGround/bg10/mob/mob_kaguya0007.png",
  L"data/backGround/bg10/mob/mob_kaguya0008.png",
  L"data/backGround/bg10/mob/mob_kaguya0009.png",
  L"data/backGround/bg10/mob/mob_keine.pat",
  L"data/backGround/bg10/mob/mob_keine0000.png",
  L"data/backGround/bg10/mob/mob_keine0001.png",
  L"data/backGround/bg10/mob/mob_keine0002.png",
  L"data/backGround/bg10/mob/mob_kourin.pat",
  L"data/backGround/bg10/mob/mob_kourin0000.png",
  L"data/backGround/bg10/mob/mob_kourin0001.png",
  L"data/backGround/bg10/mob/mob_kourin0002.png",
  L"data/backGround/bg10/mob/mob_kourin0003.png",
  L"data/backGround/bg10/mob/mob_mokou.pat",
  L"data/backGround/bg10/mob/mob_mokou0000.png",
  L"data/backGround/bg10/mob/mob_mokou0001.png",
  L"data/backGround/bg10/mob/mob_mokou0002.png",
  L"data/backGround/bg10/mob/mob_mokou0003.png",
  L"data/backGround/bg10/mob/mob_suika.pat",
  L"data/backGround/bg10/mob/mob_suika0000.png",
  L"data/backGround/bg10/mob/mob_suika0001.png",
  L"data/backGround/bg10/mob/mob_suika0002.png",
  L"data/backGround/bg10/mob/mob_suika0003.png",
  L"data/backGround/bg10/mob/mob_tei.pat",
  L"data/backGround/bg10/mob/mob_tei0000.png",
  L"data/backGround/bg10/mob/mob_tei0001.png",
  L"data/backGround/bg10/mob/mob_tei0002.png",
  L"data/backGround/bg10/mob/mob_tei0003.png",
  L"data/backGround/bg10/mob/mob_udon.pat",
  L"data/backGround/bg10/mob/mob_udon0000.png",
  L"data/backGround/bg10/mob/mob_udon0001.png",
  L"data/backGround/bg10/mob/mob_udon0002.png",
  L"data/backGround/bg10/mob/mob_yuugi.pat",
  L"data/backGround/bg10/mob/mob_yuugi0000.png",
  L"data/backGround/bg10/mob/mob_yuugi0001.png",
  L"data/backGround/bg10/mob/mob_yuugi0002.png",
  L"data/backGround/bg10/mob/mob_yuugi0003.png",
  L"data/backGround/bg10/mob/shadowJ.bmp",
  L"data/backGround/bg10/mob/shadow_A.bmp",
  L"data/backGround/bg10/mob/shadow_B.bmp",
  L"data/backGround/bg10/mob/shadow_C.bmp",
  L"data/backGround/bg10/mob/shadow_D.bmp",
  L"data/backGround/bg10/mob/shadow_F.bmp",
  L"data/backGround/bg10/mob/shadow_G.bmp",
  L"data/backGround/bg10/mob/shadow_kourin.bmp",
  L"data/backGround/bg10/mob/wallMask.pat",
  L"data/backGround/bg10/mob/wallMask0000.png",
  L"data/backGround/bg10/̂/mat6.mat",
  L"data/backGround/bg10/e[u/mat6.mat",
  L"data/backGround/bg10/Oȓ/mat6.mat",
  L"data/backGround/bg10/㏬/mat6.mat",
  L"data/backGround/bg10/Rŉ.dds",
  L"data/backGround/bg10//mat6.mat",
  L"data/backGround/bg10/֎q/mat6.mat",
  L"data/backGround/bg10/ƉE/mat6.mat",
  L"data/backGround/bg10/ƍ/mat6.mat",
  L"data/backGround/bg10/ƍ/mat6.mat",
  L"data/backGround/bg10/_yoru.dds",
  L"data/backGround/bg10/ԉ/mat6.mat",
  L"data/backGround/bg10//mat6.mat",
  L"data/backGround/bg10/݉/mat6.mat",
  L"data/backGround/bg10/݉/mat6.mat",
  L"data/backGround/bg10/݉/mat6.mat",
  L"data/backGround/bg10/Xe[Wnʖ.dds",
  L"data/backGround/bg10/Xe[W.dds",
  L"data/backGround/bg11/000n/mat3.mat",
  L"data/backGround/bg11/000/.mat",
  L"data/backGround/bg11/001R/mat4.mat",
  L"data/backGround/bg11/002X/mat5.mat",
  L"data/backGround/bg11/002X/mat6.mat",
  L"data/backGround/bg11/003X/mat7.mat",
  L"data/backGround/bg11/bg11.msh",
  L"data/backGround/bg11/bg11_a.msh",
  L"data/backGround/bg11/plane01/01 - Default.mat",
  L"data/backGround/bg11/plane02/01 - Default.mat",
  L"data/backGround/bg11/plane03/01 - Default.mat",
  L"data/backGround/bg11/plane04/01 - Default.mat",
  L"data/backGround/bg11/plane05/01 - Default.mat",
  L"data/backGround/bg11/}~]EXe[W_.dds",
  L"data/backGround/bg11/}~]EX_.dds",
  L"data/backGround/bg11/}~]EXOE_.dds",
  L"data/backGround/bg11/}~]EXO_.dds",
  L"data/backGround/bg11/}~]EX艜_.dds",
  L"data/backGround/bg11/}~]EX艜E_.dds",
  L"data/backGround/bg11/}~]EX艜_.dds",
  L"data/backGround/bg11/_}~]E.dds",
  L"data/backGround/bg12/12.dds",
  L"data/backGround/bg12/bg12.msh",
  L"data/backGround/bg12/bg12.tak",
  L"data/backGround/bg12/bg12_a.msh",
  L"data/backGround/bg12/i/i.mat",
  L"data/backGround/bg12/i.dds",
  L"data/backGround/bg12/郁C/wire_028089185.mat",
  L"data/backGround/bg12/ߌi/ߌi.mat",
  L"data/backGround/bg12/ߌi.dds",
  L"data/backGround/bg12/ߌi001/ߌi.mat",
  L"data/backGround/bg12/i/i02.mat",
  L"data/backGround/bg12/i02.dds",
  L"data/backGround/bg13/000e[u02/mat8.mat",
  L"data/backGround/bg13/000e[u1/mat8.mat",
  L"data/backGround/bg13/000㏬/mat8.mat",
  L"data/backGround/bg13/000/04 - Default.mat",
  L"data/backGround/bg13/000/mat8.mat",
  L"data/backGround/bg13/000_Oȓ/mat8.mat",
  L"data/backGround/bg13/000_ƉE/mat8.mat",
  L"data/backGround/bg13/000_ƉE[/mat8.mat",
  L"data/backGround/bg13/000_ƍ/mat8.mat",
  L"data/backGround/bg13/000_ԉ{/mat8.mat",
  L"data/backGround/bg13/000_ԉ/mat8.mat",
  L"data/backGround/bg13/000_/mat8.mat",
  L"data/backGround/bg13/000_O/mat8.mat",
  L"data/backGround/bg13/000_݉/mat8.mat",
  L"data/backGround/bg13/000_݉JE^[/mat8.mat",
  L"data/backGround/bg13/000_݉x_/mat8.mat",
  L"data/backGround/bg13/000_݉/mat8.mat",
  L"data/backGround/bg13/000_݉/mat8.mat",
  L"data/backGround/bg13/000_݉2f/mat8.mat",
  L"data/backGround/bg13/000_݉O1f/mat8.mat",
  L"data/backGround/bg13/000_݉O2f/mat8.mat",
  L"data/backGround/bg13/000_݉/mat8.mat",
  L"data/backGround/bg13/000_݉Ŕ/mat8.mat",
  L"data/backGround/bg13/000_/mat8.mat",
  L"data/backGround/bg13/000_O/mat8.mat",
  L"data/backGround/bg13/000_/mat8.mat",
  L"data/backGround/bg13/000_Ŕ/mat8.mat",
  L"data/backGround/bg13/000񓔂`/mat8.mat",
  L"data/backGround/bg13/000/.mat",
  L"data/backGround/bg13/0001/mat8.mat",
  L"data/backGround/bg13/0002/mat8.mat",
  L"data/backGround/bg13/0003/mat8.mat",
  L"data/backGround/bg13/0004/mat8.mat",
  L"data/backGround/bg13/0005/mat8.mat",
  L"data/backGround/bg13/0006/mat8.mat",
  L"data/backGround/bg13/0007/mat8.mat",
  L"data/backGround/bg13/0008/mat8.mat",
  L"data/backGround/bg13/000M֎q/mat8.mat",
  L"data/backGround/bg13/000MP/mat8.mat",
  L"data/backGround/bg13/000MQ/mat8.mat",
  L"data/backGround/bg13/001R/R.mat",
  L"data/backGround/bg13/002/RO.mat",
  L"data/backGround/bg13/bg02.msh",
  L"data/backGround/bg13/bg02.tak",
  L"data/backGround/bg13/bg13.msh",
  L"data/backGround/bg13/bg13.tak",
  L"data/backGround/bg13/mori_O03.dds",
  L"data/backGround/bg13/mori_O04.dds",
  L"data/backGround/bg13/̂/mat6.mat",
  L"data/backGround/bg13/e[u/mat6.mat",
  L"data/backGround/bg13/Oȓ/mat6.mat",
  L"data/backGround/bg13/㏬/mat6.mat",
  L"data/backGround/bg13/Rŉ01.dds",
  L"data/backGround/bg13//mat6.mat",
  L"data/backGround/bg13/֎q/mat6.mat",
  L"data/backGround/bg13/ƉE/mat6.mat",
  L"data/backGround/bg13/ƍ/mat6.mat",
  L"data/backGround/bg13/ƍ/mat6.mat",
  L"data/backGround/bg13/01.dds",
  L"data/backGround/bg13/ԉ/mat6.mat",
  L"data/backGround/bg13//mat6.mat",
  L"data/backGround/bg13/݉/mat6.mat",
  L"data/backGround/bg13/݉/mat6.mat",
  L"data/backGround/bg13/݉/mat6.mat",
  L"data/backGround/bg13/Xe[Wn.dds",
  L"data/backGround/bg13/Xe[W{.dds",
  L"data/backGround/bg14/000main/19 - Default.mat",
  L"data/backGround/bg14/000main/mat1.mat",
  L"data/backGround/bg14/000e[u02/mat8.mat",
  L"data/backGround/bg14/000e[u1/mat8.mat",
  L"data/backGround/bg14/000㏬/mat8.mat",
  L"data/backGround/bg14/000n/mat1.mat",
  L"data/backGround/bg14/000/04 - Default.mat",
  L"data/backGround/bg14/000/mat8.mat",
  L"data/backGround/bg14/000_Oȓ/mat8.mat",
  L"data/backGround/bg14/000_ƉE/mat8.mat",
  L"data/backGround/bg14/000_ƉE[/mat8.mat",
  L"data/backGround/bg14/000_ƍ/mat8.mat",
  L"data/backGround/bg14/000_ԉ{/mat8.mat",
  L"data/backGround/bg14/000_ԉ/mat8.mat",
  L"data/backGround/bg14/000_/mat8.mat",
  L"data/backGround/bg14/000_O/mat8.mat",
  L"data/backGround/bg14/000_݉/mat8.mat",
  L"data/backGround/bg14/000_݉JE^[/mat8.mat",
  L"data/backGround/bg14/000_݉x_/mat8.mat",
  L"data/backGround/bg14/000_݉/mat8.mat",
  L"data/backGround/bg14/000_݉/p[c`.mat",
  L"data/backGround/bg14/000_݉/mat8.mat",
  L"data/backGround/bg14/000_݉2f/mat8.mat",
  L"data/backGround/bg14/000_݉O1f/mat8.mat",
  L"data/backGround/bg14/000_݉O2f/mat8.mat",
  L"data/backGround/bg14/000_݉/mat8.mat",
  L"data/backGround/bg14/000_݉Ŕ/mat8.mat",
  L"data/backGround/bg14/000_/mat8.mat",
  L"data/backGround/bg14/000_O/mat8.mat",
  L"data/backGround/bg14/000_/mat8.mat",
  L"data/backGround/bg14/000_Ŕ/mat8.mat",
  L"data/backGround/bg14/000񓔂`/mat8.mat",
  L"data/backGround/bg14/000؉E/ؑE.mat",
  L"data/backGround/bg14/000؍/ؑ卶.mat",
  L"data/backGround/bg14/000_Ж{/p[c`.mat",
  L"data/backGround/bg14/000_Ж{/C.mat",
  L"data/backGround/bg14/000_Ж{/`.mat",
  L"data/backGround/bg14/000_Ж{/[v`.mat",
  L"data/backGround/bg14/000_Ж{/[va.mat",
  L"data/backGround/bg14/000_Ж{/.mat",
  L"data/backGround/bg14/000/.mat",
  L"data/backGround/bg14/0001/mat8.mat",
  L"data/backGround/bg14/0001/p[c`.mat",
  L"data/backGround/bg14/0001/嗝΂`.mat",
  L"data/backGround/bg14/0002/mat8.mat",
  L"data/backGround/bg14/0003/mat8.mat",
  L"data/backGround/bg14/0004/mat8.mat",
  L"data/backGround/bg14/0005/mat8.mat",
  L"data/backGround/bg14/0006/mat8.mat",
  L"data/backGround/bg14/0007/mat8.mat",
  L"data/backGround/bg14/0008/mat8.mat",
  L"data/backGround/bg14/000M֎q/mat8.mat",
  L"data/backGround/bg14/000MP/mat8.mat",
  L"data/backGround/bg14/000MQ/mat8.mat",
  L"data/backGround/bg14/001R/R.mat",
  L"data/backGround/bg14/002main/mat1.mat",
  L"data/backGround/bg14/002/RO.mat",
  L"data/backGround/bg14/003RO/RO.mat",
  L"data/backGround/bg14/003X/RO.mat",
  L"data/backGround/bg14/003X01/RO.mat",
  L"data/backGround/bg14/004X01/RO.mat",
  L"data/backGround/bg14/005X/RO.mat",
  L"data/backGround/bg14/006XO/Material #528.mat",
  L"data/backGround/bg14/006XO01/Material #521.mat",
  L"data/backGround/bg14/007XO/Material #521.mat",
  L"data/backGround/bg14/008XO/Material #528.mat",
  L"data/backGround/bg14/008XO2/Material #528.mat",
  L"data/backGround/bg14/bg02.msh",
  L"data/backGround/bg14/bg02.mshtest",
  L"data/backGround/bg14/bg02.tak",
  L"data/backGround/bg14/bg02_a.msh",
  L"data/backGround/bg14/BL02a_bill.png",
  L"data/backGround/bg14/BL07m_bill.png",
  L"data/backGround/bg14/Forest01/19 - Default.mat",
  L"data/backGround/bg14/Forest01/Material #521.mat",
  L"data/backGround/bg14/Forest01/Material #528.mat",
  L"data/backGround/bg14/Forest01.msh",
  L"data/backGround/bg14/mori_O03.dds",
  L"data/backGround/bg14/mori_O04.dds",
  L"data/backGround/bg14/treeA.dds",
  L"data/backGround/bg14/treeB.dds",
  L"data/backGround/bg14/ǂwin.bmp",
  L"data/backGround/bg14/ǂwiX01.png",
  L"data/backGround/bg14/ǂwi03.bmp",
  L"data/backGround/bg14/̂/mat6.mat",
  L"data/backGround/bg14/e[u/mat6.mat",
  L"data/backGround/bg14/vp/vp.mat",
  L"data/backGround/bg14/WJZ/WJZ.mat",
  L"data/backGround/bg14/Oȓ/mat6.mat",
  L"data/backGround/bg14/ʕW/ʕW.mat",
  L"data/backGround/bg14/㏬/mat6.mat",
  L"data/backGround/bg14/Rŉ01.dds",
  L"data/backGround/bg14//mat6.mat",
  L"data/backGround/bg14/֎q/mat6.mat",
  L"data/backGround/bg14/ƉE/mat6.mat",
  L"data/backGround/bg14/ƍ/mat6.mat",
  L"data/backGround/bg14/ƍ/mat6.mat",
  L"data/backGround/bg14/01.dds",
  L"data/backGround/bg14/ԉ/mat6.mat",
  L"data/backGround/bg14//mat6.mat",
  L"data/backGround/bg14/db{bNX/db{bNX.mat",
  L"data/backGround/bg14/݉/mat6.mat",
  L"data/backGround/bg14/݉/mat6.mat",
  L"data/backGround/bg14/݉/mat6.mat",
  L"data/backGround/bg14/Xe[Wn.dds",
  L"data/backGround/bg14/Xe[W{.dds",
  L"data/backGround/bg15/000main/19 - Default.mat",
  L"data/backGround/bg15/000e[u1/mat8.mat",
  L"data/backGround/bg15/000㏬/mat8.mat",
  L"data/backGround/bg15/000n/mat1.mat",
  L"data/backGround/bg15/000/04 - default.mat",
  L"data/backGround/bg15/000_Oȓ/mat8.mat",
  L"data/backGround/bg15/000_ƉE/mat8.mat",
  L"data/backGround/bg15/000_ƉE[/mat8.mat",
  L"data/backGround/bg15/000_ƍ/mat8.mat",
  L"data/backGround/bg15/000_ԉ{/mat8.mat",
  L"data/backGround/bg15/000_ԉ/mat8.mat",
  L"data/backGround/bg15/000_/mat8.mat",
  L"data/backGround/bg15/000_O/mat8.mat",
  L"data/backGround/bg15/000_݉/mat8.mat",
  L"data/backGround/bg15/000_݉JE^[/mat8.mat",
  L"data/backGround/bg15/000_݉x_/mat8.mat",
  L"data/backGround/bg15/000_݉/mat8.mat",
  L"data/backGround/bg15/000_݉/mat8.mat",
  L"data/backGround/bg15/000_݉2f/mat8.mat",
  L"data/backGround/bg15/000_݉O1f/mat8.mat",
  L"data/backGround/bg15/000_݉O2f/mat8.mat",
  L"data/backGround/bg15/000_݉/mat8.mat",
  L"data/backGround/bg15/000_݉Ŕ/mat8.mat",
  L"data/backGround/bg15/000_/mat8.mat",
  L"data/backGround/bg15/000_O/mat8.mat",
  L"data/backGround/bg15/000_/mat8.mat",
  L"data/backGround/bg15/000_Ŕ/mat8.mat",
  L"data/backGround/bg15/000񓔂`/mat8.mat",
  L"data/backGround/bg15/000/.mat",
  L"data/backGround/bg15/0001/mat8.mat",
  L"data/backGround/bg15/0002/mat8.mat",
  L"data/backGround/bg15/0003/mat8.mat",
  L"data/backGround/bg15/0004/mat8.mat",
  L"data/backGround/bg15/0005/mat8.mat",
  L"data/backGround/bg15/0006/mat8.mat",
  L"data/backGround/bg15/0007/mat8.mat",
  L"data/backGround/bg15/0008/mat8.mat",
  L"data/backGround/bg15/000M֎q/mat8.mat",
  L"data/backGround/bg15/000MP/mat8.mat",
  L"data/backGround/bg15/000MQ/mat8.mat",
  L"data/backGround/bg15/001R/R.mat",
  L"data/backGround/bg15/004X01/RO.mat",
  L"data/backGround/bg15/005X/RO.mat",
  L"data/backGround/bg15/006XO01/Material #521.mat",
  L"data/backGround/bg15/007XO/Material #521.mat",
  L"data/backGround/bg15/008XO2/Material #528.mat",
  L"data/backGround/bg15/bg15.msh",
  L"data/backGround/bg15/bg15.tak",
  L"data/backGround/bg15/bg15_a.msh",
  L"data/backGround/bg15/Forest01/19 - Default.mat",
  L"data/backGround/bg15/Forest01/Material #521.mat",
  L"data/backGround/bg15/Forest01/Material #528.mat",
  L"data/backGround/bg15/Forest01.msh",
  L"data/backGround/bg15/mori_O03.dds",
  L"data/backGround/bg15/mori_O04.dds",
  L"data/backGround/bg15/Rŉ01.dds",
  L"data/backGround/bg15/01.dds",
  L"data/backGround/bg15/Xe[Wn.dds",
  L"data/backGround/bg15/Xe[W{.dds",
  L"data/backGround/bg16/000n/n.mat",
  L"data/backGround/bg16/000bO/C.mat",
  L"data/backGround/bg16/000/C.mat",
  L"data/backGround/bg16/000/C.mat",
  L"data/backGround/bg16/000O/C.mat",
  L"data/backGround/bg16/000O/C.mat",
  L"data/backGround/bg16/000[/C.mat",
  L"data/backGround/bg16/000/C.mat",
  L"data/backGround/bg16/000؉E/ؑE.mat",
  L"data/backGround/bg16/000؏/ؑE.mat",
  L"data/backGround/bg16/000؏/ؑ卶.mat",
  L"data/backGround/bg16/000؍/ؑ卶.mat",
  L"data/backGround/bg16/000A[`/C.mat",
  L"data/backGround/bg16/000U/C.mat",
  L"data/backGround/bg16/000ΒʘH/C.mat",
  L"data/backGround/bg16/000_/C.mat",
  L"data/backGround/bg16/000_Њb/C.mat",
  L"data/backGround/bg16/000_Ж{/C.mat",
  L"data/backGround/bg16/000/.mat",
  L"data/backGround/bg16/000/C.mat",
  L"data/backGround/bg16/001R/R.mat",
  L"data/backGround/bg16/002/RO.mat",
  L"data/backGround/bg16/003RO/RO.mat",
  L"data/backGround/bg16/004kusa/`.mat",
  L"data/backGround/bg16/004kusa/a.mat",
  L"data/backGround/bg16/004kusa/b.mat",
  L"data/backGround/bg16/004X/X.mat",
  L"data/backGround/bg16/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/006tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/007tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/008tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/009tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/010kusa/`.mat",
  L"data/backGround/bg16/010kusa/a.mat",
  L"data/backGround/bg16/010kusa/b.mat",
  L"data/backGround/bg16/020tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/021tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/022tree/ؗtϗ.mat",
  L"data/backGround/bg16/023tree/ؗtϕ\a.mat",
  L"data/backGround/bg16/024tree/ؗtϗ.mat",
  L"data/backGround/bg16/025tree/ؗtϕ\.mat",
  L"data/backGround/bg16/026tree/ؗtϗ.mat",
  L"data/backGround/bg16/027tree/ؗtϕ\.mat",
  L"data/backGround/bg16/030kusa/a.mat",
  L"data/backGround/bg16/030kusa/b.mat",
  L"data/backGround/bg16/031kusa/`.mat",
  L"data/backGround/bg16/031kusa/b.mat",
  L"data/backGround/bg16/032tree/ؗtϗ.mat",
  L"data/backGround/bg16/033_tree/ؗtϕ\.mat",
  L"data/backGround/bg16/034tree/ؗtϗ.mat",
  L"data/backGround/bg16/035tree/ؗtϕ\.mat",
  L"data/backGround/bg16/036tree/ؗtϗ.mat",
  L"data/backGround/bg16/037tree/ؗtϕ\.mat",
  L"data/backGround/bg16/040kusa/`.mat",
  L"data/backGround/bg16/040kusa/b.mat",
  L"data/backGround/bg16/041kusa/`.mat",
  L"data/backGround/bg16/041kusa/a.mat",
  L"data/backGround/bg16/042kusa/`.mat",
  L"data/backGround/bg16/bg01.msh",
  L"data/backGround/bg16/bgtest_5.dds",
  L"data/backGround/bg16/bgtest_n02.dds",
  L"data/backGround/bg16/kusa.png",
  L"data/backGround/bg16/kusa2.png",
  L"data/backGround/bg16/kusa3.png",
  L"data/backGround/bg16/mori_O03.dds",
  L"data/backGround/bg16/mori_O04.dds",
  L"data/backGround/bg16/obj1/ؗtϕ\.mat",
  L"data/backGround/bg16/obj1/ؗtϕ\.mat",
  L"data/backGround/bg16/obj1/ؗtϕ\.mat",
  L"data/backGround/bg16/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj1/ؗtϗ.mat",
  L"data/backGround/bg16/obj1/ؗtϗ.mat",
  L"data/backGround/bg16/obj10/ؗtϗ.mat",
  L"data/backGround/bg16/obj11/ؗtϕ\.mat",
  L"data/backGround/bg16/obj12/ؗtϕ\.mat",
  L"data/backGround/bg16/obj13/ؗtϗ.mat",
  L"data/backGround/bg16/obj14/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj15/ؗtϗ.mat",
  L"data/backGround/bg16/obj16/ؗtϕ\.mat",
  L"data/backGround/bg16/obj17/ؗtϗ.mat",
  L"data/backGround/bg16/obj18/ؗtϕ\.mat",
  L"data/backGround/bg16/obj2/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj3/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj4/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj5/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj6/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj7/ؗtϕ\a.mat",
  L"data/backGround/bg16/obj8/ؗtϕ\.mat",
  L"data/backGround/bg16/obj9/ؗtϗ.mat",
  L"data/backGround/bg16/treeA.dds",
  L"data/backGround/bg16/treeA.msh",
  L"data/backGround/bg16/treeA.tak",
  L"data/backGround/bg16/treeB.dds",
  L"data/backGround/bg16/n/n.mat",
  L"data/backGround/bg16/bO/C.mat",
  L"data/backGround/bg16//C.mat",
  L"data/backGround/bg16//C.mat",
  L"data/backGround/bg16/O/C.mat",
  L"data/backGround/bg16/O/C.mat",
  L"data/backGround/bg16/[/C.mat",
  L"data/backGround/bg16//C.mat",
  L"data/backGround/bg16/R/R.mat",
  L"data/backGround/bg16/R1/R.mat",
  L"data/backGround/bg16/RO/RO.mat",
  L"data/backGround/bg16/RO`/RO.mat",
  L"data/backGround/bg16/Rŉ01.dds",
  L"data/backGround/bg16/؉E/ؑE.mat",
  L"data/backGround/bg16/؏/ؑE.mat",
  L"data/backGround/bg16/؏/ؑ卶.mat",
  L"data/backGround/bg16/؍/ؑ卶.mat",
  L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg16/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg16/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg16/ؗt/ؗtϗ.mat",
  L"data/backGround/bg16/ؗt/ؗtϗ.mat",
  L"data/backGround/bg16/X/X.mat",
  L"data/backGround/bg16/A[`/C.mat",
  L"data/backGround/bg16/U/C.mat",
  L"data/backGround/bg16/ΒʘH/C.mat",
  L"data/backGround/bg16/ΒʘH/C.mat",
  L"data/backGround/bg16/_Њb/C.mat",
  L"data/backGround/bg16/_Ж{/C.mat",
  L"data/backGround/bg16//.mat",
  L"data/backGround/bg16/01.dds",
  L"data/backGround/bg16//`.mat",
  L"data/backGround/bg16//a.mat",
  L"data/backGround/bg16//b.mat",
  L"data/backGround/bg16/tA.dds",
  L"data/backGround/bg16/tA.dds",
  L"data/backGround/bg16/tAO.dds",
  L"data/backGround/bg16/tϏ01.dds",
  L"data/backGround/bg16/tϏ02.dds",
  L"data/backGround/bg16/tϏ03.dds",
  L"data/backGround/bg16/tϏc01.dds",
  L"data/backGround/bg16//C.mat",
  L"data/backGround/bg17/000n/n.mat",
  L"data/backGround/bg17/000n/C.mat",
  L"data/backGround/bg17/000n/.mat",
  L"data/backGround/bg17/000bO/C.mat",
  L"data/backGround/bg17/000/C.mat",
  L"data/backGround/bg17/000/C.mat",
  L"data/backGround/bg17/000O/C.mat",
  L"data/backGround/bg17/000O/C.mat",
  L"data/backGround/bg17/000[/C.mat",
  L"data/backGround/bg17/000/C.mat",
  L"data/backGround/bg17/000؉E/ؑE.mat",
  L"data/backGround/bg17/000؏/ؑE.mat",
  L"data/backGround/bg17/000؏/ؑ卶.mat",
  L"data/backGround/bg17/000؍/ؑ卶.mat",
  L"data/backGround/bg17/000A[`/C.mat",
  L"data/backGround/bg17/000U/C.mat",
  L"data/backGround/bg17/000ΒʘH/C.mat",
  L"data/backGround/bg17/000_/C.mat",
  L"data/backGround/bg17/000_Њb/C.mat",
  L"data/backGround/bg17/000_Ж{/C.mat",
  L"data/backGround/bg17/000/.mat",
  L"data/backGround/bg17/000/C.mat",
  L"data/backGround/bg17/001R/R.mat",
  L"data/backGround/bg17/002/RO.mat",
  L"data/backGround/bg17/003RO/RO.mat",
  L"data/backGround/bg17/004kusa/`.mat",
  L"data/backGround/bg17/004kusa/a.mat",
  L"data/backGround/bg17/004kusa/b.mat",
  L"data/backGround/bg17/004X/X.mat",
  L"data/backGround/bg17/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/006tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/007tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/008tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/009tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/010kusa/`.mat",
  L"data/backGround/bg17/010kusa/a.mat",
  L"data/backGround/bg17/010kusa/b.mat",
  L"data/backGround/bg17/020tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/021tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/022tree/ؗtϗ.mat",
  L"data/backGround/bg17/023tree/ؗtϕ\a.mat",
  L"data/backGround/bg17/024tree/ؗtϗ.mat",
  L"data/backGround/bg17/025tree/ؗtϕ\.mat",
  L"data/backGround/bg17/026tree/ؗtϗ.mat",
  L"data/backGround/bg17/027tree/ؗtϕ\.mat",
  L"data/backGround/bg17/030kusa/a.mat",
  L"data/backGround/bg17/030kusa/b.mat",
  L"data/backGround/bg17/031kusa/`.mat",
  L"data/backGround/bg17/031kusa/b.mat",
  L"data/backGround/bg17/032tree/ؗtϗ.mat",
  L"data/backGround/bg17/033_tree/ؗtϕ\.mat",
  L"data/backGround/bg17/034tree/ؗtϗ.mat",
  L"data/backGround/bg17/035tree/ؗtϕ\.mat",
  L"data/backGround/bg17/036tree/ؗtϗ.mat",
  L"data/backGround/bg17/037tree/ؗtϕ\.mat",
  L"data/backGround/bg17/040kusa/`.mat",
  L"data/backGround/bg17/040kusa/b.mat",
  L"data/backGround/bg17/041kusa/`.mat",
  L"data/backGround/bg17/041kusa/a.mat",
  L"data/backGround/bg17/042kusa/`.mat",
  L"data/backGround/bg17/bg01.msh",
  L"data/backGround/bg17/bgtest_5.dds",
  L"data/backGround/bg17/bgtest_n02.dds",
  L"data/backGround/bg17/bgtest_n03.dds",
  L"data/backGround/bg17/kusa.png",
  L"data/backGround/bg17/kusa2.png",
  L"data/backGround/bg17/kusa3.png",
  L"data/backGround/bg17/kusa3Q.png",
  L"data/backGround/bg17/mori_O03.dds",
  L"data/backGround/bg17/mori_O04.dds",
  L"data/backGround/bg17/mori_O.dds",
  L"data/backGround/bg17/mori_O.png",
  L"data/backGround/bg17/obj1/ؗtϕ\.mat",
  L"data/backGround/bg17/obj1/ؗtϕ\.mat",
  L"data/backGround/bg17/obj1/ؗtϕ\.mat",
  L"data/backGround/bg17/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj1/ؗtϗ.mat",
  L"data/backGround/bg17/obj1/ؗtϗ.mat",
  L"data/backGround/bg17/obj10/ؗtϗ.mat",
  L"data/backGround/bg17/obj11/ؗtϕ\.mat",
  L"data/backGround/bg17/obj12/ؗtϕ\.mat",
  L"data/backGround/bg17/obj13/ؗtϗ.mat",
  L"data/backGround/bg17/obj14/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj15/ؗtϗ.mat",
  L"data/backGround/bg17/obj16/ؗtϕ\.mat",
  L"data/backGround/bg17/obj17/ؗtϗ.mat",
  L"data/backGround/bg17/obj18/ؗtϕ\.mat",
  L"data/backGround/bg17/obj2/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj3/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj4/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj5/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj6/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj7/ؗtϕ\a.mat",
  L"data/backGround/bg17/obj8/ؗtϕ\.mat",
  L"data/backGround/bg17/obj9/ؗtϗ.mat",
  L"data/backGround/bg17/treeA.dds",
  L"data/backGround/bg17/treeA.msh",
  L"data/backGround/bg17/treeA.tak",
  L"data/backGround/bg17/treeA.bmp",
  L"data/backGround/bg17/treeB.dds",
  L"data/backGround/bg17/treeB01.bmp",
  L"data/backGround/bg17/yakei.bmp",
  L"data/backGround/bg17//.mat",
  L"data/backGround/bg17/.png",
  L"data/backGround/bg17/n/n.mat",
  L"data/backGround/bg17/bO/C.mat",
  L"data/backGround/bg17/i/i.mat",
  L"data/backGround/bg17/01.bmp",
  L"data/backGround/bg17/01.dds",
  L"data/backGround/bg17//C.mat",
  L"data/backGround/bg17//C.mat",
  L"data/backGround/bg17/O/C.mat",
  L"data/backGround/bg17/O/C.mat",
  L"data/backGround/bg17/[/C.mat",
  L"data/backGround/bg17//C.mat",
  L"data/backGround/bg17/R/R.mat",
  L"data/backGround/bg17/R1/R.mat",
  L"data/backGround/bg17/RO/RO.mat",
  L"data/backGround/bg17/RO`/RO.mat",
  L"data/backGround/bg17/Rŉ01.dds",
  L"data/backGround/bg17/Rŉ01.png",
  L"data/backGround/bg17/؉E/ؑE.mat",
  L"data/backGround/bg17/؏/ؑE.mat",
  L"data/backGround/bg17/؏/ؑ卶.mat",
  L"data/backGround/bg17/؍/ؑ卶.mat",
  L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg17/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg17/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg17/ؗt/ؗtϗ.mat",
  L"data/backGround/bg17/ؗt/ؗtϗ.mat",
  L"data/backGround/bg17/X/X.mat",
  L"data/backGround/bg17/A[`/C.mat",
  L"data/backGround/bg17/U/C.mat",
  L"data/backGround/bg17/ΒʘH/C.mat",
  L"data/backGround/bg17/ΒʘH/C.mat",
  L"data/backGround/bg17/_Њb/C.mat",
  L"data/backGround/bg17/_Ж{/C.mat",
  L"data/backGround/bg17//.mat",
  L"data/backGround/bg17/01.dds",
  L"data/backGround/bg17//`.mat",
  L"data/backGround/bg17//a.mat",
  L"data/backGround/bg17//b.mat",
  L"data/backGround/bg17/tA.dds",
  L"data/backGround/bg17/tA.dds",
  L"data/backGround/bg17/tA.png",
  L"data/backGround/bg17/tA.dds",
  L"data/backGround/bg17/tA.dds",
  L"data/backGround/bg17/tA.png",
  L"data/backGround/bg17/tAO.dds",
  L"data/backGround/bg17/tAO.dds",
  L"data/backGround/bg17/tAO.png",
  L"data/backGround/bg17/tϏ01.dds",
  L"data/backGround/bg17/tϏ02.dds",
  L"data/backGround/bg17/tϏ02.dds",
  L"data/backGround/bg17/tϏ02.png",
  L"data/backGround/bg17/tϏ03.dds",
  L"data/backGround/bg17/tϏ.dds",
  L"data/backGround/bg17/tϏ.png",
  L"data/backGround/bg17/tϏ01.dds",
  L"data/backGround/bg17/tϏ01.png",
  L"data/backGround/bg17/tϏc01.dds",
  L"data/backGround/bg17/tϏc.dds",
  L"data/backGround/bg17/tϏc.png",
  L"data/backGround/bg17//C.mat",
  L"data/backGround/bg17/.png",
  L"data/backGround/bg18/000nc/n.mat",
  L"data/backGround/bg18/000nd/n.mat",
  L"data/backGround/bg18/000nʂ`/n.mat",
  L"data/backGround/bg18/000nʂa/n.mat",
  L"data/backGround/bg18/001buildinga/rb.mat",
  L"data/backGround/bg18/001buildinga/rc.mat",
  L"data/backGround/bg18/001buildinga/rd.mat",
  L"data/backGround/bg18/001buildinga/r`.mat",
  L"data/backGround/bg18/001buildingb/rb.mat",
  L"data/backGround/bg18/001buildingb/rc.mat",
  L"data/backGround/bg18/001buildingb/rd.mat",
  L"data/backGround/bg18/001buildingb/r`.mat",
  L"data/backGround/bg18/001buildingb/Q.mat",
  L"data/backGround/bg18/001buildingc/rb.mat",
  L"data/backGround/bg18/001buildingc/rc.mat",
  L"data/backGround/bg18/001buildingc/rd.mat",
  L"data/backGround/bg18/001buildingc/r`.mat",
  L"data/backGround/bg18/001buildingd/rb.mat",
  L"data/backGround/bg18/001buildingd/rc.mat",
  L"data/backGround/bg18/001buildingd/rd.mat",
  L"data/backGround/bg18/001buildingd/r`.mat",
  L"data/backGround/bg18/001buildingd/Q.mat",
  L"data/backGround/bg18/001As/r`.mat",
  L"data/backGround/bg18/001As/ra.mat",
  L"data/backGround/bg18/001As/rb.mat",
  L"data/backGround/bg18/001As/rc.mat",
  L"data/backGround/bg18/001c/r`.mat",
  L"data/backGround/bg18/001c/ra.mat",
  L"data/backGround/bg18/001c/rb.mat",
  L"data/backGround/bg18/001c/rc.mat",
  L"data/backGround/bg18/001Cs001/r`.mat",
  L"data/backGround/bg18/001Cs001/ra.mat",
  L"data/backGround/bg18/001Cs001/rb.mat",
  L"data/backGround/bg18/001Cs001/rc.mat",
  L"data/backGround/bg18/001Cs002/r`.mat",
  L"data/backGround/bg18/001Cs002/ra.mat",
  L"data/backGround/bg18/001Cs002/rb.mat",
  L"data/backGround/bg18/001Cs002/rc.mat",
  L"data/backGround/bg18/001d/r`.mat",
  L"data/backGround/bg18/001d/ra.mat",
  L"data/backGround/bg18/001d/rb.mat",
  L"data/backGround/bg18/001d/rc.mat",
  L"data/backGround/bg18/001d/.mat",
  L"data/backGround/bg18/001Ds001/r`.mat",
  L"data/backGround/bg18/001Ds001/ra.mat",
  L"data/backGround/bg18/001Ds001/rb.mat",
  L"data/backGround/bg18/001Ds001/rc.mat",
  L"data/backGround/bg18/001Ds001/.mat",
  L"data/backGround/bg18/001Ds002/r`.mat",
  L"data/backGround/bg18/001Ds002/ra.mat",
  L"data/backGround/bg18/001Ds002/rb.mat",
  L"data/backGround/bg18/001Ds002/rc.mat",
  L"data/backGround/bg18/001Ds002/.mat",
  L"data/backGround/bg18/001`/r`.mat",
  L"data/backGround/bg18/001`/ra.mat",
  L"data/backGround/bg18/001`/rb.mat",
  L"data/backGround/bg18/001`/rc.mat",
  L"data/backGround/bg18/001`s2/r`.mat",
  L"data/backGround/bg18/001`s2/ra.mat",
  L"data/backGround/bg18/001`s2/rb.mat",
  L"data/backGround/bg18/001`s2/rc.mat",
  L"data/backGround/bg18/001a/r`.mat",
  L"data/backGround/bg18/001a/ra.mat",
  L"data/backGround/bg18/001a/rb.mat",
  L"data/backGround/bg18/001a/rc.mat",
  L"data/backGround/bg18/001a/.mat",
  L"data/backGround/bg18/001as/r`.mat",
  L"data/backGround/bg18/001as/ra.mat",
  L"data/backGround/bg18/001as/rb.mat",
  L"data/backGround/bg18/001as/rc.mat",
  L"data/backGround/bg18/001as/.mat",
  L"data/backGround/bg18/001as2/r`.mat",
  L"data/backGround/bg18/001as2/ra.mat",
  L"data/backGround/bg18/001as2/rb.mat",
  L"data/backGround/bg18/001as2/rc.mat",
  L"data/backGround/bg18/001as2/.mat",
  L"data/backGround/bg18/001Hc/H`.mat",
  L"data/backGround/bg18/001Hd/H`.mat",
  L"data/backGround/bg18/001H`/H`.mat",
  L"data/backGround/bg18/001Ha/H`.mat",
  L"data/backGround/bg18/002lightreda/lightred.mat",
  L"data/backGround/bg18/002lightredb/lightred.mat",
  L"data/backGround/bg18/002lightredc/lightred.mat",
  L"data/backGround/bg18/002lightredd/lightred.mat",
  L"data/backGround/bg18/002lightwhitea/lightwhite.mat",
  L"data/backGround/bg18/002lightwhiteb/lightwhite.mat",
  L"data/backGround/bg18/002lightwhitec/lightwhite.mat",
  L"data/backGround/bg18/002lightwhited/lightwhite.mat",
  L"data/backGround/bg18/002Cgc/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg18/002Cgd/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg18/002Cg`/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg18/002Cga/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg18/002Cgc/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg18/002Cgd/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg18/002CgԂ`/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg18/002CgԂa/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg18/bg18.msh",
  L"data/backGround/bg18/building.msh",
  L"data/backGround/bg18/building.tak",
  L"data/backGround/bg18/building_light.msh",
  L"data/backGround/bg18/r`.dds",
  L"data/backGround/bg18/ra.dds",
  L"data/backGround/bg18/rb.dds",
  L"data/backGround/bg18/rc.dds",
  L"data/backGround/bg18/Cg.png",
  L"data/backGround/bg18/Cg.png",
  L"data/backGround/bg18/i.dds",
  L"data/backGround/bg18/ih[/rb.mat",
  L"data/backGround/bg18/ih[/ii.mat",
  L"data/backGround/bg18/ii/ii.mat",
  L"data/backGround/bg18/in.dds",
  L"data/backGround/bg18/.png",
  L"data/backGround/bg18/t.png",
  L"data/backGround/bg18/X_.dds",
  L"data/backGround/bg19/000funea/mat1.mat",
  L"data/backGround/bg19/000funea/mat2.mat",
  L"data/backGround/bg19/000h[/mat3.mat",
  L"data/backGround/bg19/000/kumo_naka.mat",
  L"data/backGround/bg19/000/kumo_oku.mat",
  L"data/backGround/bg19/000D/mat1.mat",
  L"data/backGround/bg19/000D/mat2.mat",
  L"data/backGround/bg19/001kumo/mat4.mat",
  L"data/backGround/bg19/001kumob/mat4.mat",
  L"data/backGround/bg19/002kumo/mat4.mat",
  L"data/backGround/bg19/003kumo/mat4.mat",
  L"data/backGround/bg19/004kumo/mat5.mat",
  L"data/backGround/bg19/backup/fune_body.bmp",
  L"data/backGround/bg19/backup/fune_sora.bmp",
  L"data/backGround/bg19/backup/ho01.bmp",
  L"data/backGround/bg19/backup/kumo_A.png",
  L"data/backGround/bg19/backup/kumo_B.png",
  L"data/backGround/bg19/backup/kumo_oku.png",
  L"data/backGround/bg19/bg19.msh",
  L"data/backGround/bg19/fune.msh",
  L"data/backGround/bg19/fune.tak",
  L"data/backGround/bg19/fune_body.dds",
  L"data/backGround/bg19/fune_sora.dds",
  L"data/backGround/bg19/ho01.dds",
  L"data/backGround/bg19/kumo.msh",
  L"data/backGround/bg19/kumo_a.dds",
  L"data/backGround/bg19/kumo_b.dds",
  L"data/backGround/bg19/kumo_naka.dds",
  L"data/backGround/bg19/kumo_oku.dds",
  L"data/backGround/bg19/obj9/mat1.mat",
  L"data/backGround/bg19/obj9/mat2.mat",
  L"data/backGround/bg19/h[/mat3.mat",
  L"data/backGround/bg19//kumo_naka.mat",
  L"data/backGround/bg19//kumo_oku.mat",
  L"data/backGround/bg19/D/mat1.mat",
  L"data/backGround/bg19/D/mat2.mat",
  L"data/backGround/bg20/000n/a.mat",
  L"data/backGround/bg20/000nЂȒd/a.mat",
  L"data/backGround/bg20/000n/mat1.mat",
  L"data/backGround/bg20/000n/mat2.mat",
  L"data/backGround/bg20/000n/a.mat",
  L"data/backGround/bg20/000/a.mat",
  L"data/backGround/bg20/000k/a.mat",
  L"data/backGround/bg20/000R/mat2.mat",
  L"data/backGround/bg20/000肷/a.mat",
  L"data/backGround/bg20/000肷O/a.mat",
  L"data/backGround/bg20/000/mat1.mat",
  L"data/backGround/bg20/000U/a.mat",
  L"data/backGround/bg20/000UO/a.mat",
  L"data/backGround/bg20/000U/a.mat",
  L"data/backGround/bg20/000U/a.mat",
  L"data/backGround/bg20/000/.mat",
  L"data/backGround/bg20/000j/a.mat",
  L"data/backGround/bg20/000ΑK/a.mat",
  L"data/backGround/bg20/000ǂ/a.mat",
  L"data/backGround/bg20/000Ki/a.mat",
  L"data/backGround/bg20/001R/R.mat",
  L"data/backGround/bg20/002/RO.mat",
  L"data/backGround/bg20/005tree/ؗtϕ\.mat",
  L"data/backGround/bg20/005tree/ؗtϕ\.mat",
  L"data/backGround/bg20/005tree/ؗtϕ\.mat",
  L"data/backGround/bg20/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg20/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg20/006tree/mat3.mat",
  L"data/backGround/bg20/007tree/mat3.mat",
  L"data/backGround/bg20/008tree/mat3.mat",
  L"data/backGround/bg20/009tree/mat3.mat",
  L"data/backGround/bg20/010tree/mat3.mat",
  L"data/backGround/bg20/011tree/mat3.mat",
  L"data/backGround/bg20/012tree/mat3.mat",
  L"data/backGround/bg20/013tree/mat3.mat",
  L"data/backGround/bg20/014tree/mat3.mat",
  L"data/backGround/bg20/015tree/mat3.mat",
  L"data/backGround/bg20/016tree/mat3.mat",
  L"data/backGround/bg20/017tree/mat3.mat",
  L"data/backGround/bg20/018tree/mat3.mat",
  L"data/backGround/bg20/019tree/mat3.mat",
  L"data/backGround/bg20/020tree/mat3.mat",
  L"data/backGround/bg20/021tree/mat3.mat",
  L"data/backGround/bg20/022tree/mat3.mat",
  L"data/backGround/bg20/023tree/mat3.mat",
  L"data/backGround/bg20/024tree/mat3.mat",
  L"data/backGround/bg20/025tree/mat3.mat",
  L"data/backGround/bg20/026tree/mat3.mat",
  L"data/backGround/bg20/027tree/mat3.mat",
  L"data/backGround/bg20/028tree/mat3.mat",
  L"data/backGround/bg20/029tree/mat3.mat",
  L"data/backGround/bg20/030tree/mat3.mat",
  L"data/backGround/bg20/031tree/mat3.mat",
  L"data/backGround/bg20/032tree/mat3.mat",
  L"data/backGround/bg20/033tree/mat3.mat",
  L"data/backGround/bg20/034tree/mat3.mat",
  L"data/backGround/bg20/035tree/mat3.mat",
  L"data/backGround/bg20/036tree/mat3.mat",
  L"data/backGround/bg20/037tree/mat3.mat",
  L"data/backGround/bg20/038tree/mat3.mat",
  L"data/backGround/bg20/039tree/mat3.mat",
  L"data/backGround/bg20/040tree/mat3.mat",
  L"data/backGround/bg20/041tree/mat3.mat",
  L"data/backGround/bg20/042tree/mat3.mat",
  L"data/backGround/bg20/043tree/mat3.mat",
  L"data/backGround/bg20/044tree/ؗtϕ\a.mat",
  L"data/backGround/bg20/045tree/mat3.mat",
  L"data/backGround/bg20/046tree/mat3.mat",
  L"data/backGround/bg20/047tree/mat3.mat",
  L"data/backGround/bg20/048tree/mat3.mat",
  L"data/backGround/bg20/049tree/mat3.mat",
  L"data/backGround/bg20/050tree/mat3.mat",
  L"data/backGround/bg20/051tree/mat3.mat",
  L"data/backGround/bg20/052tree/mat3.mat",
  L"data/backGround/bg20/053tree/mat3.mat",
  L"data/backGround/bg20/054tree/mat3.mat",
  L"data/backGround/bg20/055tree/mat3.mat",
  L"data/backGround/bg20/056tree/mat3.mat",
  L"data/backGround/bg20/057tree/mat3.mat",
  L"data/backGround/bg20/058tree/mat3.mat",
  L"data/backGround/bg20/059tree/ؗtϕ\a.mat",
  L"data/backGround/bg20/060tree/mat3.mat",
  L"data/backGround/bg20/061tree/ؗtϕ\a.mat",
  L"data/backGround/bg20/062tree/mat3.mat",
  L"data/backGround/bg20/063tree/mat4.mat",
  L"data/backGround/bg20/064tree/mat4.mat",
  L"data/backGround/bg20/065tree/mat3.mat",
  L"data/backGround/bg20/066tree/mat3.mat",
  L"data/backGround/bg20/067tree/mat3.mat",
  L"data/backGround/bg20/068tree/mat3.mat",
  L"data/backGround/bg20/069tree/ؗtϕ\.mat",
  L"data/backGround/bg20/070tree/mat3.mat",
  L"data/backGround/bg20/071tree/mat3.mat",
  L"data/backGround/bg20/072tree/mat3.mat",
  L"data/backGround/bg20/073tree/mat4.mat",
  L"data/backGround/bg20/074tree/mat3.mat",
  L"data/backGround/bg20/075tree/mat3.mat",
  L"data/backGround/bg20/076tree/mat4.mat",
  L"data/backGround/bg20/077tree/mat3.mat",
  L"data/backGround/bg20/078tree/mat3.mat",
  L"data/backGround/bg20/079tree/mat3.mat",
  L"data/backGround/bg20/080tree/mat3.mat",
  L"data/backGround/bg20/081tree/ؗtϕ\.mat",
  L"data/backGround/bg20/082tree/mat3.mat",
  L"data/backGround/bg20/083tree/mat3.mat",
  L"data/backGround/bg20/084tree/mat3.mat",
  L"data/backGround/bg20/085tree/mat3.mat",
  L"data/backGround/bg20/086tree/mat3.mat",
  L"data/backGround/bg20/087tree/mat3.mat",
  L"data/backGround/bg20/088tree/mat3.mat",
  L"data/backGround/bg20/089tree/mat3.mat",
  L"data/backGround/bg20/090tree/mat3.mat",
  L"data/backGround/bg20/091tree/mat3.mat",
  L"data/backGround/bg20/092tree/mat3.mat",
  L"data/backGround/bg20/093tree/mat3.mat",
  L"data/backGround/bg20/094tree/mat3.mat",
  L"data/backGround/bg20/095tree/mat3.mat",
  L"data/backGround/bg20/096tree/mat3.mat",
  L"data/backGround/bg20/097tree/mat3.mat",
  L"data/backGround/bg20/098tree/mat3.mat",
  L"data/backGround/bg20/099tree/mat3.mat",
  L"data/backGround/bg20/100tree/mat3.mat",
  L"data/backGround/bg20/101tree/mat3.mat",
  L"data/backGround/bg20/102tree/mat3.mat",
  L"data/backGround/bg20/103tree/mat3.mat",
  L"data/backGround/bg20/104tree/mat4.mat",
  L"data/backGround/bg20/105tree/mat3.mat",
  L"data/backGround/bg20/106tree/ؗtϕ\.mat",
  L"data/backGround/bg20/107tree/mat3.mat",
  L"data/backGround/bg20/108tree/mat3.mat",
  L"data/backGround/bg20/109tree/mat3.mat",
  L"data/backGround/bg20/110tree/mat3.mat",
  L"data/backGround/bg20/111tree/mat3.mat",
  L"data/backGround/bg20/112tree/mat3.mat",
  L"data/backGround/bg20/113tree/mat3.mat",
  L"data/backGround/bg20/114tree/mat3.mat",
  L"data/backGround/bg20/115tree/mat3.mat",
  L"data/backGround/bg20/116tree/mat3.mat",
  L"data/backGround/bg20/117tree/mat3.mat",
  L"data/backGround/bg20/118tree/mat4.mat",
  L"data/backGround/bg20/119tree/mat4.mat",
  L"data/backGround/bg20/120tree/mat4.mat",
  L"data/backGround/bg20/122tree/mat4.mat",
  L"data/backGround/bg20/123tree/mat3.mat",
  L"data/backGround/bg20/124tree/mat3.mat",
  L"data/backGround/bg20/125tree/mat4.mat",
  L"data/backGround/bg20/126tree/mat4.mat",
  L"data/backGround/bg20/127tree/mat4.mat",
  L"data/backGround/bg20/128tree/mat4.mat",
  L"data/backGround/bg20/129tree/mat3.mat",
  L"data/backGround/bg20/130tree/mat3.mat",
  L"data/backGround/bg20/131tree/mat4.mat",
  L"data/backGround/bg20/132tree/mat4.mat",
  L"data/backGround/bg20/133tree/mat4.mat",
  L"data/backGround/bg20/134tree/mat4.mat",
  L"data/backGround/bg20/135tree/mat4.mat",
  L"data/backGround/bg20/136tree/mat4.mat",
  L"data/backGround/bg20/137tree/mat4.mat",
  L"data/backGround/bg20/138tree/mat4.mat",
  L"data/backGround/bg20/139tree/mat4.mat",
  L"data/backGround/bg20/bg20.msh",
  L"data/backGround/bg20/bg20_a.msh",
  L"data/backGround/bg20/bg20_front.msh",
  L"data/backGround/bg20/hata.msh",
  L"data/backGround/bg20/hataa00000.png",
  L"data/backGround/bg20/hataa00004.png",
  L"data/backGround/bg20/hataa00014.png",
  L"data/backGround/bg20/hatal_00/mat8.mat",
  L"data/backGround/bg20/hatal_01/mat8.mat",
  L"data/backGround/bg20/hatal_02/mat8.mat",
  L"data/backGround/bg20/hatal_03/mat8.mat",
  L"data/backGround/bg20/hatal_04/mat8.mat",
  L"data/backGround/bg20/hatal_05/mat8.mat",
  L"data/backGround/bg20/hatar_00/mat5.mat",
  L"data/backGround/bg20/hatar_01/mat5.mat",
  L"data/backGround/bg20/hatar_02/mat7.mat",
  L"data/backGround/bg20/hatar_03/mat5.mat",
  L"data/backGround/bg20/hatar_04/mat6.mat",
  L"data/backGround/bg20/hatar_05/mat5.mat",
  L"data/backGround/bg20/htatab00000.png",
  L"data/backGround/bg20/kusa.dds",
  L"data/backGround/bg20/kusa.png",
  L"data/backGround/bg20/mob/mob_aya.pat",
  L"data/backGround/bg20/mob/mob_B.pat",
  L"data/backGround/bg20/mob/mob_C.pat",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00011.dds",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00012.dds",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00013.dds",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00014.dds",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00015.dds",
  L"data/backGround/bg20/mob/mob_hataa/k_3_00016.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00015.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00017.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00019.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00021.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00022.dds",
  L"data/backGround/bg20/mob/mob_hatab/q_00023.dds",
  L"data/backGround/bg20/mob/mob_hatate.pat",
  L"data/backGround/bg20/mob/mob_K.pat",
  L"data/backGround/bg20/mob/mob_kogasa.pat",
  L"data/backGround/bg20/mob/mob_kyouko.pat",
  L"data/backGround/bg20/mob/mob_mistya.pat",
  L"data/backGround/bg20/mob/mob_shou.pat",
  L"data/backGround/bg20/mori_O03.dds",
  L"data/backGround/bg20/mori_[v.dds",
  L"data/backGround/bg20/tree.msh",
  L"data/backGround/bg20/5.dds",
  L"data/backGround/bg20/eNX`a.dds",
  L"data/backGround/bg20/n.dds",
  L"data/backGround/bg20/.dds",
  L"data/backGround/bg20/Rŉ01.dds",
  L"data/backGround/bg20/E/a.mat",
  L"data/backGround/bg20//a.mat",
  L"data/backGround/bg20/01.dds",
  L"data/backGround/bg20/ta.dds",
  L"data/backGround/bg20/ta.dds",
  L"data/backGround/bg20/taO.dds",
  L"data/backGround/bg20/tϏ01.dds",
  L"data/backGround/bg20/tϏ02.dds",
  L"data/backGround/bg20/tϏ03.dds",
  L"data/backGround/bg20/tϏc01.dds",
  L"data/backGround/bg21/000/mat1.mat",
  L"data/backGround/bg21/000/mat3.mat",
  L"data/backGround/bg21/000/12 - default.mat",
  L"data/backGround/bg21/000/04 - default.mat",
  L"data/backGround/bg21/001/mat2.mat",
  L"data/backGround/bg21/002/mat2.mat",
  L"data/backGround/bg21/003/mat2.mat",
  L"data/backGround/bg21/050flower/mat4.mat",
  L"data/backGround/bg21/bg21.msh",
  L"data/backGround/bg21/bg21_a.msh",
  L"data/backGround/bg21/light.msh",
  L"data/backGround/bg21/.dds",
  L"data/backGround/bg21/zsXe[W08.dds",
  L"data/backGround/bg21/zsXe[W.dds",
  L"data/backGround/bg21/zsXe[W.dds",
  L"data/backGround/bg21/zsXe[W.dds",
  L"data/backGround/bg21/@.dds",
  L"data/backGround/bg22/000/.mat",
  L"data/backGround/bg22/010/mat1.mat",
  L"data/backGround/bg22/011/mat1.mat",
  L"data/backGround/bg22/012/mat1.mat",
  L"data/backGround/bg22/013/mat1.mat",
  L"data/backGround/bg22/014/mat1.mat",
  L"data/backGround/bg22/015/mat1.mat",
  L"data/backGround/bg22/016/mat1.mat",
  L"data/backGround/bg22/017/mat1.mat",
  L"data/backGround/bg22/018/mat1.mat",
  L"data/backGround/bg22/019/mat1.mat",
  L"data/backGround/bg22/020/mat1.mat",
  L"data/backGround/bg22/021/mat1.mat",
  L"data/backGround/bg22/022/mat1.mat",
  L"data/backGround/bg22/023/mat1.mat",
  L"data/backGround/bg22/024/mat1.mat",
  L"data/backGround/bg22/025/mat1.mat",
  L"data/backGround/bg22/026/mat1.mat",
  L"data/backGround/bg22/027/mat1.mat",
  L"data/backGround/bg22/028/mat1.mat",
  L"data/backGround/bg22/029/mat1.mat",
  L"data/backGround/bg22/030/mat1.mat",
  L"data/backGround/bg22/031/mat1.mat",
  L"data/backGround/bg22/032/mat1.mat",
  L"data/backGround/bg22/033/mat1.mat",
  L"data/backGround/bg22/bg22.msh",
  L"data/backGround/bg22/bg22_a.msh",
  L"data/backGround/bg22/dragon.dds",
  L"data/backGround/bg22/kazari_00/mat4.mat",
  L"data/backGround/bg22/kazari_01/mat4.mat",
  L"data/backGround/bg22/kazari_02/mat4.mat",
  L"data/backGround/bg22/kazari_03/mat4.mat",
  L"data/backGround/bg22/kazari_04/mat4.mat",
  L"data/backGround/bg22/kazari_05/mat4.mat",
  L"data/backGround/bg22/kazari_06/mat4.mat",
  L"data/backGround/bg22/kazari_07/mat4.mat",
  L"data/backGround/bg22/kazari_08/mat4.mat",
  L"data/backGround/bg22/kazari_09/mat4.mat",
  L"data/backGround/bg22/kazari_10/mat4.mat",
  L"data/backGround/bg22/kazari_11/mat4.mat",
  L"data/backGround/bg22/kazari_12/mat4.mat",
  L"data/backGround/bg22/kazari_13/mat4.mat",
  L"data/backGround/bg22/kazari_14/mat4.mat",
  L"data/backGround/bg22/kazari_15/mat4.mat",
  L"data/backGround/bg22/kazari_16/mat4.mat",
  L"data/backGround/bg22/kazari_17/mat4.mat",
  L"data/backGround/bg22/kazari_18/mat4.mat",
  L"data/backGround/bg22/kazari_19/mat4.mat",
  L"data/backGround/bg22/kazari_20/mat4.mat",
  L"data/backGround/bg22/kazari_21/mat4.mat",
  L"data/backGround/bg22/kazari_22/mat4.mat",
  L"data/backGround/bg22/kazari_23/mat4.mat",
  L"data/backGround/bg22/kazari_24/mat4.mat",
  L"data/backGround/bg22/kazari_25/mat4.mat",
  L"data/backGround/bg22/kiri.msh",
  L"data/backGround/bg22/mobl.dds",
  L"data/backGround/bg22/C/mat3.mat",
  L"data/backGround/bg22/lui/mat1.mat",
  L"data/backGround/bg22/luiQ/mat1.mat",
  L"data/backGround/bg22/luőO/mat1.mat",
  L"data/backGround/bg22/luőO2/mat1.mat",
  L"data/backGround/bg22/luŉ/mat1.mat",
  L"data/backGround/bg22/~/mat3.mat",
  L"data/backGround/bg22/~/mat3.mat",
  L"data/backGround/bg22/x_/mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22/{/mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22/艜/mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22//mat5.mat",
  L"data/backGround/bg22//mat3.mat",
  L"data/backGround/bg22//mat5.mat",
  L"data/backGround/bg22/e/mat3.mat",
  L"data/backGround/bg22/e/mat3.mat",
  L"data/backGround/bg22/e/mat3.mat",
  L"data/backGround/bg22/e/mat3.mat",
  L"data/backGround/bg22//mat2.mat",
  L"data/backGround/bg22/qubN/mat3.mat",
  L"data/backGround/bg22/_qn`n01.dds",
  L"data/backGround/bg22/_qn`C.dds",
  L"data/backGround/bg22/_qn`.dds",
  L"data/backGround/bg22/_qi.dds",
  L"data/backGround/bg22/_yoru.dds",
  L"data/backGround/bg22/i`/07 - default.mat",
  L"data/backGround/bg22/.dds",
  L"data/backGround/bg22/蒌C/mat3.mat",
  L"data/backGround/bg22//mat4.mat",
  L"data/backGround/bg23/000/mat2.mat",
  L"data/backGround/bg23/010/mat1.mat",
  L"data/backGround/bg23/011/mat1.mat",
  L"data/backGround/bg23/012/mat1.mat",
  L"data/backGround/bg23/013/mat1.mat",
  L"data/backGround/bg23/014/mat1.mat",
  L"data/backGround/bg23/015/mat1.mat",
  L"data/backGround/bg23/016/mat1.mat",
  L"data/backGround/bg23/017/mat1.mat",
  L"data/backGround/bg23/018/mat1.mat",
  L"data/backGround/bg23/019/mat1.mat",
  L"data/backGround/bg23/020/mat1.mat",
  L"data/backGround/bg23/021/mat1.mat",
  L"data/backGround/bg23/022/mat1.mat",
  L"data/backGround/bg23/023/mat1.mat",
  L"data/backGround/bg23/024/mat1.mat",
  L"data/backGround/bg23/025/mat1.mat",
  L"data/backGround/bg23/026/mat1.mat",
  L"data/backGround/bg23/027/mat1.mat",
  L"data/backGround/bg23/028/mat1.mat",
  L"data/backGround/bg23/029/mat1.mat",
  L"data/backGround/bg23/030/mat1.mat",
  L"data/backGround/bg23/031/mat1.mat",
  L"data/backGround/bg23/032/mat1.mat",
  L"data/backGround/bg23/033/mat1.mat",
  L"data/backGround/bg23/bg23.msh",
  L"data/backGround/bg23/bg23_a.msh",
  L"data/backGround/bg23/kiri.msh",
  L"data/backGround/bg23/mob/mob_aya.pat",
  L"data/backGround/bg23/mob/mob_hatate.pat",
  L"data/backGround/bg23/mob/mob_hina.pat",
  L"data/backGround/bg23/mob/mob_kanako.pat",
  L"data/backGround/bg23/mob/mob_minoriko.pat",
  L"data/backGround/bg23/mob/mob_point.txt",
  L"data/backGround/bg23/mob/mob_sanae.pat",
  L"data/backGround/bg23/mob/mob_sizuha.pat",
  L"data/backGround/bg23/mob/mob_suwako.pat",
  L"data/backGround/bg23/mob/mob_taki/taki0001.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0002.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0003.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0004.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0005.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0006.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0007.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0008.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0009.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0010.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0011.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0012.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0013.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0014.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0015.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0016.dds",
  L"data/backGround/bg23/mob/mob_taki/taki0017.dds",
  L"data/backGround/bg23/mob/shadowJ.bmp",
  L"data/backGround/bg23/mob/shadow_A.bmp",
  L"data/backGround/bg23/mob/shadow_B.bmp",
  L"data/backGround/bg23/mob/shadow_C.bmp",
  L"data/backGround/bg23/mob/shadow_D.bmp",
  L"data/backGround/bg23/mob/shadow_F.bmp",
  L"data/backGround/bg23/mob/shadow_G.bmp",
  L"data/backGround/bg23/mob/shadow_kourin.bmp",
  L"data/backGround/bg23/obj1/mat3.mat",
  L"data/backGround/bg23/obj10/mat3.mat",
  L"data/backGround/bg23/obj11/mat3.mat",
  L"data/backGround/bg23/obj12/mat3.mat",
  L"data/backGround/bg23/obj13/mat3.mat",
  L"data/backGround/bg23/obj14/mat3.mat",
  L"data/backGround/bg23/obj15/mat3.mat",
  L"data/backGround/bg23/obj16/mat3.mat",
  L"data/backGround/bg23/obj17/mat3.mat",
  L"data/backGround/bg23/obj18/mat3.mat",
  L"data/backGround/bg23/obj19/mat3.mat",
  L"data/backGround/bg23/obj2/mat3.mat",
  L"data/backGround/bg23/obj20/mat3.mat",
  L"data/backGround/bg23/obj21/mat3.mat",
  L"data/backGround/bg23/obj22/mat3.mat",
  L"data/backGround/bg23/obj23/mat3.mat",
  L"data/backGround/bg23/obj24/mat3.mat",
  L"data/backGround/bg23/obj25/mat3.mat",
  L"data/backGround/bg23/obj26/mat3.mat",
  L"data/backGround/bg23/obj27/mat3.mat",
  L"data/backGround/bg23/obj28/mat3.mat",
  L"data/backGround/bg23/obj29/mat3.mat",
  L"data/backGround/bg23/obj3/mat3.mat",
  L"data/backGround/bg23/obj30/mat3.mat",
  L"data/backGround/bg23/obj31/mat3.mat",
  L"data/backGround/bg23/obj32/mat3.mat",
  L"data/backGround/bg23/obj33/mat3.mat",
  L"data/backGround/bg23/obj34/mat3.mat",
  L"data/backGround/bg23/obj35/mat3.mat",
  L"data/backGround/bg23/obj36/mat3.mat",
  L"data/backGround/bg23/obj37/mat3.mat",
  L"data/backGround/bg23/obj38/mat3.mat",
  L"data/backGround/bg23/obj39/mat3.mat",
  L"data/backGround/bg23/obj4/mat3.mat",
  L"data/backGround/bg23/obj40/mat3.mat",
  L"data/backGround/bg23/obj41/mat3.mat",
  L"data/backGround/bg23/obj42/mat3.mat",
  L"data/backGround/bg23/obj43/mat3.mat",
  L"data/backGround/bg23/obj5/mat3.mat",
  L"data/backGround/bg23/obj6/mat3.mat",
  L"data/backGround/bg23/obj7/mat3.mat",
  L"data/backGround/bg23/obj8/mat3.mat",
  L"data/backGround/bg23/obj9/mat3.mat",
  L"data/backGround/bg23/taki.msh",
  L"data/backGround/bg23/ɂƂXe[Wshadow.dds",
  L"data/backGround/bg23/ɂƂXe[WIuWF.dds",
  L"data/backGround/bg23/pCv/mat1.mat",
  L"data/backGround/bg23/C1/04 - default.mat",
  L"data/backGround/bg23/.dds",
  L"data/backGround/bg23/X.dds",
  L"data/backGround/bg23//mat4.mat",
  L"data/backGround/bg23//mat1.mat",
  L"data/backGround/bg23/tϏ01.dds",
  L"data/backGround/bg23/.dds",
  L"data/backGround/bg24/bg24.msh",
  L"data/backGround/bg24/Xe[W13.dds",
  L"data/backGround/bg24/Xe[W13b.dds",
  L"data/backGround/bg24/ǉ/11 - default.mat",
  L"data/backGround/bg24/ǂP/11 - default.mat",
  L"data/backGround/bg24/ǂP1/11 - default.mat",
  L"data/backGround/bg24/ǂQ/11 - default.mat",
  L"data/backGround/bg24/ǂR/11 - default.mat",
  L"data/backGround/bg24/V/11 - default.mat",
  L"data/backGround/bg24/P/11 - default.mat",
  L"data/backGround/bg24/P1/11 - default.mat",
  L"data/backGround/bg24/P2/11 - default.mat",
  L"data/backGround/bg24/Q/11 - default.mat",
  L"data/backGround/bg24/Q1/11 - default.mat",
  L"data/backGround/bg24/Q2/11 - default.mat",
  L"data/backGround/bg24/R/11 - default.mat",
  L"data/backGround/bg24/R1/11 - default.mat",
  L"data/backGround/bg24/b/mat1.mat",
  L"data/backGround/bg24/ǃVv/11 - default.mat",
  L"data/backGround/bg24/.dds",
  L"data/backGround/bg25/12.dds",
  L"data/backGround/bg25/bg25.msh",
  L"data/backGround/bg25/bg25.tak",
  L"data/backGround/bg25/bg25_a.msh",
  L"data/backGround/bg25/i/i.mat",
  L"data/backGround/bg25/i.dds",
  L"data/backGround/bg25/郁C/wire_028089185.mat",
  L"data/backGround/bg25/ߌi/ߌi.mat",
  L"data/backGround/bg25/ߌi.dds",
  L"data/backGround/bg25/ߌi001/ߌi.mat",
  L"data/backGround/bg25/i/i02.mat",
  L"data/backGround/bg25/i02.dds",
  L"data/backGround/bg26/000/bamboo_c1.mat",
  L"data/backGround/bg26/001/bamboo_c1.mat",
  L"data/backGround/bg26/002/bamboo_c2.mat",
  L"data/backGround/bg26/003/bamboo_b2.mat",
  L"data/backGround/bg26/003/grass_1.mat",
  L"data/backGround/bg26/004/bamboo_b2.mat",
  L"data/backGround/bg26/004/grass_1.mat",
  L"data/backGround/bg26/005/grass_2.mat",
  L"data/backGround/bg26/006/grass_1.mat",
  L"data/backGround/bg26/006/grass_2.mat",
  L"data/backGround/bg26/007/grass_2.mat",
  L"data/backGround/bg26/008/bamboo_b2.mat",
  L"data/backGround/bg26/009/grass_1.mat",
  L"data/backGround/bg26/010/bamboo_b2.mat",
  L"data/backGround/bg26/011/grass_1.mat",
  L"data/backGround/bg26/012/bamboo_a4.mat",
  L"data/backGround/bg26/013/grass_1.mat",
  L"data/backGround/bg26/014/|01.mat",
  L"data/backGround/bg26/015/grass_1.mat",
  L"data/backGround/bg26/015/grass_2.mat",
  L"data/backGround/bg26/016/bamboo_a2.mat",
  L"data/backGround/bg26/017/grass_2.mat",
  L"data/backGround/bg26/018/bamboo_a5.mat",
  L"data/backGround/bg26/019/bamboo_a2.mat",
  L"data/backGround/bg26/020/bamboo_a3.mat",
  L"data/backGround/bg26/021/bamboo_a3.mat",
  L"data/backGround/bg26/022/bamboo_a4.mat",
  L"data/backGround/bg26/023/bamboo_a2.mat",
  L"data/backGround/bg26/023/grass_1.mat",
  L"data/backGround/bg26/024/grass_1.mat",
  L"data/backGround/bg26/024/grass_2.mat",
  L"data/backGround/bg26/025/|01.mat",
  L"data/backGround/bg26/026/grass_1.mat",
  L"data/backGround/bg26/027/bamboo_a5.mat",
  L"data/backGround/bg26/028/bamboo_a5.mat",
  L"data/backGround/bg26/029/|01.mat",
  L"data/backGround/bg26/030/bamboo_a4.mat",
  L"data/backGround/bg26/031/bamboo_a5.mat",
  L"data/backGround/bg26/032/grass_1.mat",
  L"data/backGround/bg26/033/bamboo_a4.mat",
  L"data/backGround/bg26/034/grass_1.mat",
  L"data/backGround/bg26/035/grass_1.mat",
  L"data/backGround/bg26/036/grass_2.mat",
  L"data/backGround/bg26/bamboo_a2_col.dds",
  L"data/backGround/bg26/bamboo_a3_col.dds",
  L"data/backGround/bg26/bamboo_a4_col.dds",
  L"data/backGround/bg26/bamboo_a5_col.dds",
  L"data/backGround/bg26/bamboo_b2_col.dds",
  L"data/backGround/bg26/bamboo_c1_col.dds",
  L"data/backGround/bg26/bamboo_c2_col.dds",
  L"data/backGround/bg26/bg26.msh",
  L"data/backGround/bg26/bg26_tree.msh",
  L"data/backGround/bg26/grass_1_col.dds",
  L"data/backGround/bg26/grass_2_col.dds",
  L"data/backGround/bg26/sky2.dds",
  L"data/backGround/bg26/nʂa/material__50.mat",
  L"data/backGround/bg26//sky.mat",
  L"data/backGround/bg26/|01.dds",
  L"data/backGround/bg26/|ђn02.dds",
  L"data/backGround/bg27/000n/n.mat",
  L"data/backGround/bg27/000n/C.mat",
  L"data/backGround/bg27/000n/.mat",
  L"data/backGround/bg27/000bO/C.mat",
  L"data/backGround/bg27/000/C.mat",
  L"data/backGround/bg27/000/C.mat",
  L"data/backGround/bg27/000O/C.mat",
  L"data/backGround/bg27/000O/C.mat",
  L"data/backGround/bg27/000[/C.mat",
  L"data/backGround/bg27/000/C.mat",
  L"data/backGround/bg27/000؉E/ؑE.mat",
  L"data/backGround/bg27/000؏/ؑE.mat",
  L"data/backGround/bg27/000؏/ؑ卶.mat",
  L"data/backGround/bg27/000؍/ؑ卶.mat",
  L"data/backGround/bg27/000A[`/C.mat",
  L"data/backGround/bg27/000U/C.mat",
  L"data/backGround/bg27/000ΒʘH/C.mat",
  L"data/backGround/bg27/000_/C.mat",
  L"data/backGround/bg27/000_Њb/C.mat",
  L"data/backGround/bg27/000_Ж{/C.mat",
  L"data/backGround/bg27/000/.mat",
  L"data/backGround/bg27/000/C.mat",
  L"data/backGround/bg27/001R/R.mat",
  L"data/backGround/bg27/002/RO.mat",
  L"data/backGround/bg27/003RO/RO.mat",
  L"data/backGround/bg27/004kusa/`.mat",
  L"data/backGround/bg27/004kusa/a.mat",
  L"data/backGround/bg27/004kusa/b.mat",
  L"data/backGround/bg27/004X/X.mat",
  L"data/backGround/bg27/005tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/006tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/007tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/008tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/009tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/010kusa/`.mat",
  L"data/backGround/bg27/010kusa/a.mat",
  L"data/backGround/bg27/010kusa/b.mat",
  L"data/backGround/bg27/020tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/021tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/022tree/ؗtϗ.mat",
  L"data/backGround/bg27/023tree/ؗtϕ\a.mat",
  L"data/backGround/bg27/024tree/ؗtϗ.mat",
  L"data/backGround/bg27/025tree/ؗtϕ\.mat",
  L"data/backGround/bg27/026tree/ؗtϗ.mat",
  L"data/backGround/bg27/027tree/ؗtϕ\.mat",
  L"data/backGround/bg27/030kusa/a.mat",
  L"data/backGround/bg27/030kusa/b.mat",
  L"data/backGround/bg27/031kusa/`.mat",
  L"data/backGround/bg27/031kusa/b.mat",
  L"data/backGround/bg27/032tree/ؗtϗ.mat",
  L"data/backGround/bg27/033_tree/ؗtϕ\.mat",
  L"data/backGround/bg27/034tree/ؗtϗ.mat",
  L"data/backGround/bg27/035tree/ؗtϕ\.mat",
  L"data/backGround/bg27/036tree/ؗtϗ.mat",
  L"data/backGround/bg27/037tree/ؗtϕ\.mat",
  L"data/backGround/bg27/040kusa/`.mat",
  L"data/backGround/bg27/040kusa/b.mat",
  L"data/backGround/bg27/041kusa/`.mat",
  L"data/backGround/bg27/041kusa/a.mat",
  L"data/backGround/bg27/042kusa/`.mat",
  L"data/backGround/bg27/bg01.msh",
  L"data/backGround/bg27/bg27.msh",
  L"data/backGround/bg27/bg27_light.msh",
  L"data/backGround/bg27/bg27_tree.msh",
  L"data/backGround/bg27/bgtest_n03.dds",
  L"data/backGround/bg27/bgtest_ٕϐ_.dds",
  L"data/backGround/bg27/kusa.png",
  L"data/backGround/bg27/kusa2.png",
  L"data/backGround/bg27/kusa3.png",
  L"data/backGround/bg27/kusa3Q.png",
  L"data/backGround/bg27/mori_O.dds",
  L"data/backGround/bg27/obj1/ؗtϕ\.mat",
  L"data/backGround/bg27/obj1/ؗtϕ\.mat",
  L"data/backGround/bg27/obj1/ؗtϕ\.mat",
  L"data/backGround/bg27/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj1/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj1/ؗtϗ.mat",
  L"data/backGround/bg27/obj1/ؗtϗ.mat",
  L"data/backGround/bg27/obj10/ؗtϗ.mat",
  L"data/backGround/bg27/obj11/ؗtϕ\.mat",
  L"data/backGround/bg27/obj12/ؗtϕ\.mat",
  L"data/backGround/bg27/obj13/ؗtϗ.mat",
  L"data/backGround/bg27/obj14/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj15/ؗtϗ.mat",
  L"data/backGround/bg27/obj16/ؗtϕ\.mat",
  L"data/backGround/bg27/obj17/ؗtϗ.mat",
  L"data/backGround/bg27/obj18/ؗtϕ\.mat",
  L"data/backGround/bg27/obj2/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj3/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj4/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj5/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj6/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj7/ؗtϕ\a.mat",
  L"data/backGround/bg27/obj8/ؗtϕ\.mat",
  L"data/backGround/bg27/obj9/ؗtϗ.mat",
  L"data/backGround/bg27/treeA.msh",
  L"data/backGround/bg27/treeA.tak",
  L"data/backGround/bg27/treea.dds",
  L"data/backGround/bg27/treeb01.dds",
  L"data/backGround/bg27/yakei.dds",
  L"data/backGround/bg27//.mat",
  L"data/backGround/bg27/.dds",
  L"data/backGround/bg27/n/n.mat",
  L"data/backGround/bg27/bO/C.mat",
  L"data/backGround/bg27/i/i.mat",
  L"data/backGround/bg27/01.dds",
  L"data/backGround/bg27//C.mat",
  L"data/backGround/bg27//C.mat",
  L"data/backGround/bg27/O/C.mat",
  L"data/backGround/bg27/O/C.mat",
  L"data/backGround/bg27/[/C.mat",
  L"data/backGround/bg27//C.mat",
  L"data/backGround/bg27/R/R.mat",
  L"data/backGround/bg27/R1/R.mat",
  L"data/backGround/bg27/RO/RO.mat",
  L"data/backGround/bg27/RO`/RO.mat",
  L"data/backGround/bg27/Rŉ01.dds",
  L"data/backGround/bg27/؉E/ؑE.mat",
  L"data/backGround/bg27/؏/ؑE.mat",
  L"data/backGround/bg27/؏/ؑ卶.mat",
  L"data/backGround/bg27/؍/ؑ卶.mat",
  L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
  L"data/backGround/bg27/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg27/ؗt/ؗtϕ\a.mat",
  L"data/backGround/bg27/ؗt/ؗtϗ.mat",
  L"data/backGround/bg27/ؗt/ؗtϗ.mat",
  L"data/backGround/bg27/X/X.mat",
  L"data/backGround/bg27/A[`/C.mat",
  L"data/backGround/bg27/U/C.mat",
  L"data/backGround/bg27/ΒʘH/C.mat",
  L"data/backGround/bg27/ΒʘH/C.mat",
  L"data/backGround/bg27/_Њb/C.mat",
  L"data/backGround/bg27/_Ж{/C.mat",
  L"data/backGround/bg27//.mat",
  L"data/backGround/bg27//`.mat",
  L"data/backGround/bg27//a.mat",
  L"data/backGround/bg27//b.mat",
  L"data/backGround/bg27/ta.dds",
  L"data/backGround/bg27/ta.dds",
  L"data/backGround/bg27/taO.dds",
  L"data/backGround/bg27/tϏ02.dds",
  L"data/backGround/bg27/tϏ.dds",
  L"data/backGround/bg27/tϏ01.dds",
  L"data/backGround/bg27/tϏc.dds",
  L"data/backGround/bg27//C.mat",
  L"data/backGround/bg27/.dds",
  L"data/backGround/bg28/000nc/n.mat",
  L"data/backGround/bg28/000nd/n.mat",
  L"data/backGround/bg28/000nʂ`/n.mat",
  L"data/backGround/bg28/000nʂa/n.mat",
  L"data/backGround/bg28/001c/r`.mat",
  L"data/backGround/bg28/001c/ra.mat",
  L"data/backGround/bg28/001c/rb.mat",
  L"data/backGround/bg28/001c/rc.mat",
  L"data/backGround/bg28/001d/r`.mat",
  L"data/backGround/bg28/001d/ra.mat",
  L"data/backGround/bg28/001d/rb.mat",
  L"data/backGround/bg28/001d/rc.mat",
  L"data/backGround/bg28/001d/.mat",
  L"data/backGround/bg28/001`/r`.mat",
  L"data/backGround/bg28/001`/ra.mat",
  L"data/backGround/bg28/001`/rb.mat",
  L"data/backGround/bg28/001`/rc.mat",
  L"data/backGround/bg28/001a/r`.mat",
  L"data/backGround/bg28/001a/ra.mat",
  L"data/backGround/bg28/001a/rb.mat",
  L"data/backGround/bg28/001a/rc.mat",
  L"data/backGround/bg28/001a/.mat",
  L"data/backGround/bg28/001Hc/H`.mat",
  L"data/backGround/bg28/001Hd/H`.mat",
  L"data/backGround/bg28/001H`/H`.mat",
  L"data/backGround/bg28/001Ha/H`.mat",
  L"data/backGround/bg28/002Cgc/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg28/002Cgd/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg28/002Cg`/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg28/002Cga/asfalt_diff1_jpg8.mat",
  L"data/backGround/bg28/002Cgc/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg28/002Cgd/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg28/002CgԂ`/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg28/002CgԂa/asfalt_diff1_jpg7.mat",
  L"data/backGround/bg28/bg15.msh",
  L"data/backGround/bg28/bg28.msh",
  L"data/backGround/bg28/building.msh",
  L"data/backGround/bg28/building.tak",
  L"data/backGround/bg28/building_light.msh",
  L"data/backGround/bg28/r`.dds",
  L"data/backGround/bg28/ra.dds",
  L"data/backGround/bg28/rb.dds",
  L"data/backGround/bg28/rc.dds",
  L"data/backGround/bg28/Cg.png",
  L"data/backGround/bg28/Cg.png",
  L"data/backGround/bg28/i.dds",
  L"data/backGround/bg28/ih[/rb.mat",
  L"data/backGround/bg28/ih[/ii.mat",
  L"data/backGround/bg28/ii/ii.mat",
  L"data/backGround/bg28/in.dds",
  L"data/backGround/bg28/.png",
  L"data/backGround/bg28/X_.dds",
  L"data/backGround/min/back.bmp",
  L"data/backGround/min/back.dds",
  L"data/backGround/min/bg01.dds",
  L"data/backGround/min/bg02.dds",
  L"data/backGround/min/bg03.dds",
  L"data/backGround/min/bg04.dds",
  L"data/backGround/min/bg05.dds",
  L"data/backGround/min/bg06.dds",
  L"data/backGround/min/bg07.dds",
  L"data/backGround/min/bg08.dds",
  L"data/backGround/min/bg09.dds",
  L"data/backGround/min/bg10.dds",
  L"data/backGround/min/bg11.dds",
  L"data/backGround/min/bg12.dds",
  L"data/backGround/min/bg15.dds",
  L"data/backGround/min/bg16.dds",
  L"data/backGround/min/bg17.dds",
  L"data/backGround/min/bg19.dds",
  L"data/backGround/min/bg20.dds",
  L"data/backGround/min/bg21.dds",
  L"data/backGround/min/bg22.dds",
  L"data/backGround/min/bg23.dds",
  L"data/backGround/min/bg24.dds",
  L"data/backGround/min/bg25.dds",
  L"data/backGround/min/bg26.dds",
  L"data/backGround/min/bg27.dds",
  L"data/backGround/min/bg28.dds",
  L"data/backGround/min/building.png",
  L"data/bgm/bgm.csv",
  L"data/bgm/ed.ogg",
  L"data/bgm/ed.png",
  L"data/bgm/ed.sfl",
  L"data/bgm/futo1.ogg",
  L"data/bgm/futo1.png",
  L"data/bgm/futo1.sfl",
  L"data/bgm/futo1b.png",
  L"data/bgm/futo2.ogg",
  L"data/bgm/hijiri1.ogg",
  L"data/bgm/hijiri1.png",
  L"data/bgm/hijiri1.sfl",
  L"data/bgm/hijiri1b.png",
  L"data/bgm/hijiri2.ogg",
  L"data/bgm/ichirin1.ogg",
  L"data/bgm/ichirin1.png",
  L"data/bgm/ichirin1.sfl",
  L"data/bgm/ichirin1b.png",
  L"data/bgm/ichirin2.ogg",
  L"data/bgm/kasen1.ogg",
  L"data/bgm/kasen1.png",
  L"data/bgm/kasen1.sfl",
  L"data/bgm/kasen1b.png",
  L"data/bgm/kasen2.ogg",
  L"data/bgm/koishi1.ogg",
  L"data/bgm/koishi1.png",
  L"data/bgm/koishi1.sfl",
  L"data/bgm/koishi1b.png",
  L"data/bgm/koishi2.ogg",
  L"data/bgm/kokoro1.ogg",
  L"data/bgm/kokoro1.png",
  L"data/bgm/kokoro1.sfl",
  L"data/bgm/kokoro1b.png",
  L"data/bgm/kokoro2.ogg",
  L"data/bgm/mamizou1.ogg",
  L"data/bgm/mamizou1.png",
  L"data/bgm/mamizou1.sfl",
  L"data/bgm/mamizou1b.png",
  L"data/bgm/mamizou2.ogg",
  L"data/bgm/marisa1.ogg",
  L"data/bgm/marisa1.png",
  L"data/bgm/marisa1.sfl",
  L"data/bgm/marisa1b.png",
  L"data/bgm/marisa2.ogg",
  L"data/bgm/miko1.ogg",
  L"data/bgm/miko1.png",
  L"data/bgm/miko1.sfl",
  L"data/bgm/miko1b.png",
  L"data/bgm/miko2.ogg",
  L"data/bgm/mokou1.ogg",
  L"data/bgm/mokou1.png",
  L"data/bgm/mokou1.sfl",
  L"data/bgm/mokou1b.png",
  L"data/bgm/mokou2.ogg",
  L"data/bgm/nitori1.ogg",
  L"data/bgm/nitori1.png",
  L"data/bgm/nitori1.sfl",
  L"data/bgm/nitori1b.png",
  L"data/bgm/nitori2.ogg",
  L"data/bgm/reimu1.ogg",
  L"data/bgm/reimu1.png",
  L"data/bgm/reimu1.sfl",
  L"data/bgm/reimu1b.png",
  L"data/bgm/reimu2.ogg",
  L"data/bgm/select.ogg",
  L"data/bgm/select.png",
  L"data/bgm/select.sfl",
  L"data/bgm/sinmyoumaru1.ogg",
  L"data/bgm/sinmyoumaru1.png",
  L"data/bgm/sinmyoumaru1.sfl",
  L"data/bgm/sinmyoumaru1b.png",
  L"data/bgm/sinmyoumaru2.ogg",
  L"data/bgm/st01_1.ogg",
  L"data/bgm/st01_1.png",
  L"data/bgm/st01_1.sfl",
  L"data/bgm/st01_1b.png",
  L"data/bgm/st01_2.ogg",
  L"data/bgm/st02_1.ogg",
  L"data/bgm/st02_1.png",
  L"data/bgm/st02_1.sfl",
  L"data/bgm/st02_1b.png",
  L"data/bgm/st02_2.ogg",
  L"data/bgm/st03_1.ogg",
  L"data/bgm/st03_1.png",
  L"data/bgm/st03_1.sfl",
  L"data/bgm/st03_1b.png",
  L"data/bgm/st03_2.ogg",
  L"data/bgm/st04_1.ogg",
  L"data/bgm/st04_1.png",
  L"data/bgm/st04_1.sfl",
  L"data/bgm/st04_1b.png",
  L"data/bgm/st04_2.ogg",
  L"data/bgm/st05_1.ogg",
  L"data/bgm/st05_1.png",
  L"data/bgm/st05_1.sfl",
  L"data/bgm/st05_1b.png",
  L"data/bgm/st05_2.ogg",
  L"data/bgm/staffroll.ogg",
  L"data/bgm/staffroll.png",
  L"data/bgm/ta01.ogg",
  L"data/bgm/ta01.png",
  L"data/bgm/ta01.sfl",
  L"data/bgm/ta01b.png",
  L"data/bgm/ta02.ogg",
  L"data/bgm/ta02.png",
  L"data/bgm/ta02.sfl",
  L"data/bgm/ta02b.png",
  L"data/bgm/ta03.ogg",
  L"data/bgm/ta03.png",
  L"data/bgm/ta03.sfl",
  L"data/bgm/ta03b.png",
  L"data/bgm/ta04.ogg",
  L"data/bgm/ta04.png",
  L"data/bgm/ta04.sfl",
  L"data/bgm/ta04b.png",
  L"data/bgm/ta05.ogg",
  L"data/bgm/ta05.png",
  L"data/bgm/ta05.sfl",
  L"data/bgm/ta05b.png",
  L"data/bgm/ta06.ogg",
  L"data/bgm/ta06.png",
  L"data/bgm/ta06.sfl",
  L"data/bgm/ta06b.png",
  L"data/bgm/ta07.ogg",
  L"data/bgm/ta07.png",
  L"data/bgm/ta07.sfl",
  L"data/bgm/ta07b.png",
  L"data/bgm/ta13.ogg",
  L"data/bgm/ta14.ogg",
  L"data/bgm/ta14.sfl",
  L"data/bgm/title.ogg",
  L"data/bgm/title.png",
  L"data/bgm/title.sfl",
  L"data/bgm/usami1.ogg",
  L"data/bgm/usami1.png",
  L"data/bgm/usami1.sfl",
  L"data/bgm/usami1b.png",
  L"data/bgm/usami2.ogg",
  L"data/bm/bmsln/Hiteffect08_gravity.bmb",
  L"data/bm/model/arch_belt01_ks01.dae",
  L"data/bm/model/belt03_ks01.dae",
  L"data/bm/model/belt04_ks01.dae",
  L"data/bm/model/belt05_all_ks01.dae",
  L"data/bm/model/ce_ball_ks0001.dae",
  L"data/bm/model/disc04_ks01.dae",
  L"data/bm/model/disc05_ks01.dae",
  L"data/bm/model/disc06.DAE",
  L"data/bm/texture/circle01.bmp",
  L"data/bm/texture/circle01.png",
  L"data/bm/texture/circle01_64_ks01.png",
  L"data/bm/texture/circle02_64_ks01.png",
  L"data/bm/texture/circle02_ks0001.png",
  L"data/bm/texture/circle11_ks04.png",
  L"data/bm/texture/circle13_128_ks0002.png",
  L"data/bm/texture/circle13_128_ks0003.png",
  L"data/bm/texture/circle15.png",
  L"data/bm/texture/circle16_ks0001.png",
  L"data/bm/texture/circle_ill02_ks01.png",
  L"data/bm/texture/circle_ill2_ks01.png",
  L"data/bm/texture/circle_ill_ks01.png",
  L"data/bm/texture/cloud_ks01.png",
  L"data/bm/texture/distortion01_ks0001.png",
  L"data/bm/texture/distortion02_anime_ks01.png",
  L"data/bm/texture/edn_cyou_ks0001.png",
  L"data/bm/texture/energywave_flagments.png",
  L"data/bm/texture/energywave_sphere.png",
  L"data/bm/texture/exp07_ks0001.png",
  L"data/bm/texture/flash1_ks01.png",
  L"data/bm/texture/fragment01_ks03.png",
  L"data/bm/texture/fragment_ks0001.png",
  L"data/bm/texture/f_wind_line_01.bmp",
  L"data/bm/texture/hahenB.bmp",
  L"data/bm/texture/hanenA.bmp",
  L"data/bm/texture/housya.bmp",
  L"data/bm/texture/housyaA.btcg",
  L"data/bm/texture/housya_test.bmp",
  L"data/bm/texture/housya_test.png",
  L"data/bm/texture/line.bmp",
  L"data/bm/texture/line_blur.bmp",
  L"data/bm/texture/particle01_ks01.png",
  L"data/bm/texture/shiny01_ks0001.png",
  L"data/bm/texture/shiny03_ks01.png",
  L"data/bm/texture/shiny_ks0001.png",
  L"data/bm/texture/sky_sc_ks0001.png",
  L"data/bm/texture/speed_line.bmp",
  L"data/bm/texture/speed_line.png",
  L"data/bm/texture/stripe_ks02.png",
  L"data/bm/texture/sun_bm02.png",
  L"data/csv/ItemCommon.csv",
  L"data/csv/ItemFuto.csv",
  L"data/csv/ItemHanako.csv",
  L"data/csv/ItemHijiri.csv",
  L"data/csv/ItemIchirin.csv",
  L"data/csv/ItemKoishi.csv",
  L"data/csv/ItemKokoro.csv",
  L"data/csv/ItemMamizou.csv",
  L"data/csv/ItemMarisa.csv",
  L"data/csv/ItemMiko.csv",
  L"data/csv/ItemNitori.csv",
  L"data/csv/ItemReimu.csv",
  L"data/csv/PopularEvent.csv",
  L"data/csv/spellcard/futo.csv",
  L"data/csv/spellcard/hijiri.csv",
  L"data/csv/spellcard/ichirin.csv",
  L"data/csv/spellCard/kasen.csv",
  L"data/csv/spellcard/koishi.csv",
  L"data/csv/spellcard/kokoro.csv",
  L"data/csv/spellcard/mamizou.csv",
  L"data/csv/spellCard/marisa.csv",
  L"data/csv/spellcard/miko.csv",
  L"data/csv/spellcard/mokou.csv",
  L"data/csv/spellcard/nitori.csv",
  L"data/csv/spellCard/reimu.csv",
  L"data/csv/spellcard/sinmyoumaru.csv",
  L"data/csv/spellcard/usami.csv",
  L"data/csv/story/backGround.csv",
  L"data/csv/story/enemyList.csv",
  L"data/csv/story/futo/stage1.csv",
  L"data/csv/story/futo/stage2.csv",
  L"data/csv/story/futo/stage3.csv",
  L"data/csv/story/futo/stage4.csv",
  L"data/csv/story/hijiri/stage1.csv",
  L"data/csv/story/hijiri/stage2.csv",
  L"data/csv/story/hijiri/stage3.csv",
  L"data/csv/story/hijiri/stage4.csv",
  L"data/csv/story/hijiri/stage5.csv",
  L"data/csv/story/ichirin/stage1.csv",
  L"data/csv/story/ichirin/stage2.csv",
  L"data/csv/story/ichirin/stage3.csv",
  L"data/csv/story/ichirin/stage4.csv",
  L"data/csv/story/kasen/stage1.csv",
  L"data/csv/story/kasen/stage2.csv",
  L"data/csv/story/kasen/stage3.csv",
  L"data/csv/story/kasen/stage4.csv",
  L"data/csv/story/kasen/stage5.csv",
  L"data/csv/story/koishi/stage1.csv",
  L"data/csv/story/koishi/stage2.csv",
  L"data/csv/story/koishi/stage3.csv",
  L"data/csv/story/koishi/stage4.csv",
  L"data/csv/story/kokoro/stage1.csv",
  L"data/csv/story/kokoro/stage2.csv",
  L"data/csv/story/kokoro/stage3.csv",
  L"data/csv/story/kokoro/stage4.csv",
  L"data/csv/story/mamizou/stage1.csv",
  L"data/csv/story/mamizou/stage2.csv",
  L"data/csv/story/mamizou/stage3.csv",
  L"data/csv/story/mamizou/stage4.csv",
  L"data/csv/story/mamizou/stage5.csv",
  L"data/csv/story/marisa/stage1.csv",
  L"data/csv/story/marisa/stage2.csv",
  L"data/csv/story/marisa/stage3.csv",
  L"data/csv/story/marisa/stage4.csv",
  L"data/csv/story/marisa/stage5.csv",
  L"data/csv/story/miko/stage1.csv",
  L"data/csv/story/miko/stage2.csv",
  L"data/csv/story/miko/stage3.csv",
  L"data/csv/story/miko/stage4.csv",
  L"data/csv/story/miko/stage5.csv",
  L"data/csv/story/mokou/stage1.csv",
  L"data/csv/story/mokou/stage2.csv",
  L"data/csv/story/mokou/stage3.csv",
  L"data/csv/story/mokou/stage4.csv",
  L"data/csv/story/mokou/stage5.csv",
  L"data/csv/story/nitori/stage1.csv",
  L"data/csv/story/nitori/stage2.csv",
  L"data/csv/story/nitori/stage3.csv",
  L"data/csv/story/nitori/stage4.csv",
  L"data/csv/story/reimu/stage1.csv",
  L"data/csv/story/reimu/stage2.csv",
  L"data/csv/story/reimu/stage3.csv",
  L"data/csv/story/reimub/stage1.csv",
  L"data/csv/story/reimub/stage2.csv",
  L"data/csv/story/reimub/stage3.csv",
  L"data/csv/story/reimub/stage4.csv",
  L"data/csv/story/sinmyoumaru/stage1.csv",
  L"data/csv/story/sinmyoumaru/stage2.csv",
  L"data/csv/story/sinmyoumaru/stage3.csv",
  L"data/csv/story/sinmyoumaru/stage4.csv",
  L"data/csv/story/sinmyoumaru/stage5.csv",
  L"data/csv/story/usami/stage1.csv",
  L"data/csv/story/usami/stage2.csv",
  L"data/csv/story/usami/stage3.csv",
  L"data/csv/story/usami/stage4.csv",
  L"data/csv/story/usami/stage5.csv",
  L"data/csv/story/usami/stage6.csv",
  L"data/csv/story/usami/stage7.csv",
  L"data/default_profile.prf",
  L"data/event/balloon/a05x2.png",
  L"data/event/balloon/a11x2.png",
  L"data/event/balloon/a15x3.png",
  L"data/event/balloon/b05x2.png",
  L"data/event/balloon/b11x2.png",
  L"data/event/balloon/b15x3.png",
  L"data/event/balloon/balloon.csv",
  L"data/event/balloon/balloon_ed01.png",
  L"data/event/balloon/c05x2.png",
  L"data/event/balloon/c11x2.png",
  L"data/event/balloon/c15x3.png",
  L"data/event/balloon/d05x2.png",
  L"data/event/balloon/d11x2.png",
  L"data/event/balloon/d15x3.png",
  L"data/event/balloon/hukidasi-l.png",
  L"data/event/balloon/hukidasi-m.png",
  L"data/event/balloon/hukidasi-s.png",
  L"data/event/extend/index.dat",
  L"data/event/extend/th145_CharName_Cutin.nut",
  L"data/event/extend/th145_Hide.nut",
  L"data/event/extend/th145_Show.nut",
  L"data/event/pic/ed/back0.dds",
  L"data/event/pic/ed/back1.dds",
  L"data/event/pic/ed/back2.dds",
  L"data/event/pic/ed/back3.dds",
  L"data/event/pic/ed/back4.dds",
  L"data/event/pic/ed/back5.dds",
  L"data/event/pic/ed/back6.dds",
  L"data/event/pic/ed/edbg.dds",
  L"data/event/pic/ed/futo0.dds",
  L"data/event/pic/ed/futo1.dds",
  L"data/event/pic/ed/hijiri0.dds",
  L"data/event/pic/ed/hijiri1.dds",
  L"data/event/pic/ed/ichirin0.dds",
  L"data/event/pic/ed/ichirin1.dds",
  L"data/event/pic/ed/kasen0.dds",
  L"data/event/pic/ed/kasen1.dds",
  L"data/event/pic/ed/koishi0.dds",
  L"data/event/pic/ed/koishi1.dds",
  L"data/event/pic/ed/kokoro0.dds",
  L"data/event/pic/ed/kokoro1.dds",
  L"data/event/pic/ed/mamizou0.dds",
  L"data/event/pic/ed/mamizou1.dds",
  L"data/event/pic/ed/marisa0.dds",
  L"data/event/pic/ed/marisa1.dds",
  L"data/event/pic/ed/miko0.dds",
  L"data/event/pic/ed/miko1.dds",
  L"data/event/pic/ed/mokou0.dds",
  L"data/event/pic/ed/mokou1.dds",
  L"data/event/pic/ed/nitori0.dds",
  L"data/event/pic/ed/nitori1.dds",
  L"data/event/pic/ed/reimu0.dds",
  L"data/event/pic/ed/reimu1.dds",
  L"data/event/pic/ed/sinmyoumaru0.dds",
  L"data/event/pic/ed/sinmyoumaru1.dds",
  L"data/event/pic/ed/usami0.dds",
  L"data/event/pic/ed/usami1.dds",
  L"data/event/pic/futo/01.dds",
  L"data/event/pic/futo/02.dds",
  L"data/event/pic/futo/03.dds",
  L"data/event/pic/futo/03.th145_charname_cutin.csv",
  L"data/event/pic/futo/03_mono1.dds",
  L"data/event/pic/futo/03_mono2.dds",
  L"data/event/pic/futo/03_mono2_r.dds",
  L"data/event/pic/futo/03_mono3.dds",
  L"data/event/pic/futo/03_mono_nameplate.dds",
  L"data/event/pic/futo/05.dds",
  L"data/event/pic/futo/06.dds",
  L"data/event/pic/futo/07.dds",
  L"data/event/pic/futo/08.dds",
  L"data/event/pic/futo/09.dds",
  L"data/event/pic/futo/10.dds",
  L"data/event/pic/futo/11.dds",
  L"data/event/pic/futo.csv",
  L"data/event/pic/hijiri/01.dds",
  L"data/event/pic/hijiri/02.dds",
  L"data/event/pic/hijiri/03.dds",
  L"data/event/pic/hijiri/03.th145_charname_cutin.csv",
  L"data/event/pic/hijiri/03_mono1.dds",
  L"data/event/pic/hijiri/03_mono2.dds",
  L"data/event/pic/hijiri/03_mono2_r.dds",
  L"data/event/pic/hijiri/03_mono3.dds",
  L"data/event/pic/hijiri/03_mono_nameplate.dds",
  L"data/event/pic/hijiri/05.dds",
  L"data/event/pic/hijiri/06.dds",
  L"data/event/pic/hijiri/07.dds",
  L"data/event/pic/hijiri/08.dds",
  L"data/event/pic/hijiri/09.dds",
  L"data/event/pic/hijiri/10.dds",
  L"data/event/pic/hijiri.csv",
  L"data/event/pic/ichirin/01.dds",
  L"data/event/pic/ichirin/02.dds",
  L"data/event/pic/ichirin/03.dds",
  L"data/event/pic/ichirin/03.th145_charname_cutin.csv",
  L"data/event/pic/ichirin/03_mono1.dds",
  L"data/event/pic/ichirin/03_mono2.dds",
  L"data/event/pic/ichirin/03_mono2_r.dds",
  L"data/event/pic/ichirin/03_mono3.dds",
  L"data/event/pic/ichirin/03_mono_nameplate.dds",
  L"data/event/pic/ichirin/05.dds",
  L"data/event/pic/ichirin/06.dds",
  L"data/event/pic/ichirin/07.dds",
  L"data/event/pic/ichirin/08.dds",
  L"data/event/pic/ichirin/09.dds",
  L"data/event/pic/ichirin/10.dds",
  L"data/event/pic/ichirin.csv",
  L"data/event/pic/kasen/01.dds",
  L"data/event/pic/kasen/02.dds",
  L"data/event/pic/kasen/03.dds",
  L"data/event/pic/kasen/04.dds",
  L"data/event/pic/kasen/05.dds",
  L"data/event/pic/kasen/06.dds",
  L"data/event/pic/kasen/06.th145_CharName_Cutin.csv",
  L"data/event/pic/kasen/06_mono1.dds",
  L"data/event/pic/kasen/06_mono2.dds",
  L"data/event/pic/kasen/06_mono2_r.dds",
  L"data/event/pic/kasen/06_mono3.dds",
  L"data/event/pic/kasen/06_mono_nameplate.dds",
  L"data/event/pic/kasen/07.dds",
  L"data/event/pic/kasen/08.dds",
  L"data/event/pic/kasen/09.dds",
  L"data/event/pic/kasen/10.dds",
  L"data/event/pic/kasen/15.dds",
  L"data/event/pic/kasen/16.dds",
  L"data/event/pic/kasen/16.th145_charname_cutin.csv",
  L"data/event/pic/kasen/16_mono1.dds",
  L"data/event/pic/kasen/16_mono2.dds",
  L"data/event/pic/kasen/16_mono2_r.dds",
  L"data/event/pic/kasen/16_mono3.dds",
  L"data/event/pic/kasen/16_mono_nameplate.dds",
  L"data/event/pic/kasen.csv",
  L"data/event/pic/koishi/01.dds",
  L"data/event/pic/koishi/02.dds",
  L"data/event/pic/koishi/03.dds",
  L"data/event/pic/koishi/03.th145_charname_cutin.csv",
  L"data/event/pic/koishi/03_mono1.dds",
  L"data/event/pic/koishi/03_mono2.dds",
  L"data/event/pic/koishi/03_mono2_r.dds",
  L"data/event/pic/koishi/03_mono3.dds",
  L"data/event/pic/koishi/03_mono_nameplate.dds",
  L"data/event/pic/koishi/05.dds",
  L"data/event/pic/koishi/06.dds",
  L"data/event/pic/koishi/07.dds",
  L"data/event/pic/koishi/08.dds",
  L"data/event/pic/koishi/09.dds",
  L"data/event/pic/koishi/10.dds",
  L"data/event/pic/koishi.csv",
  L"data/event/pic/kokoro/01.dds",
  L"data/event/pic/kokoro/02.dds",
  L"data/event/pic/kokoro/03.dds",
  L"data/event/pic/kokoro/03.th145_charname_cutin.csv",
  L"data/event/pic/kokoro/03_mono1.dds",
  L"data/event/pic/kokoro/03_mono2.dds",
  L"data/event/pic/kokoro/03_mono2_r.dds",
  L"data/event/pic/kokoro/03_mono3.dds",
  L"data/event/pic/kokoro/03_mono_nameplate.dds",
  L"data/event/pic/kokoro/05.dds",
  L"data/event/pic/kokoro/06.dds",
  L"data/event/pic/kokoro/07.dds",
  L"data/event/pic/kokoro/08.dds",
  L"data/event/pic/kokoro/09.dds",
  L"data/event/pic/kokoro/10.dds",
  L"data/event/pic/kokoro.csv",
  L"data/event/pic/mamizou/01.dds",
  L"data/event/pic/mamizou/01_r.dds",
  L"data/event/pic/mamizou/02.dds",
  L"data/event/pic/mamizou/02_r.dds",
  L"data/event/pic/mamizou/03.dds",
  L"data/event/pic/mamizou/03.th145_charname_cutin.csv",
  L"data/event/pic/mamizou/03_mono1.dds",
  L"data/event/pic/mamizou/03_mono2.dds",
  L"data/event/pic/mamizou/03_mono2_r.dds",
  L"data/event/pic/mamizou/03_mono3.dds",
  L"data/event/pic/mamizou/03_mono_nameplate.dds",
  L"data/event/pic/mamizou/03_r.dds",
  L"data/event/pic/mamizou/03_r.th145_charname_cutin.csv",
  L"data/event/pic/mamizou/03_r_mono1.dds",
  L"data/event/pic/mamizou/03_r_mono2.dds",
  L"data/event/pic/mamizou/03_r_mono2_r.dds",
  L"data/event/pic/mamizou/03_r_mono3.dds",
  L"data/event/pic/mamizou/03_r_mono_nameplate.dds",
  L"data/event/pic/mamizou/05.dds",
  L"data/event/pic/mamizou/05_r.dds",
  L"data/event/pic/mamizou/06.dds",
  L"data/event/pic/mamizou/06_r.dds",
  L"data/event/pic/mamizou/07.dds",
  L"data/event/pic/mamizou/07_r.dds",
  L"data/event/pic/mamizou/08.dds",
  L"data/event/pic/mamizou/08_r.dds",
  L"data/event/pic/mamizou/09.dds",
  L"data/event/pic/mamizou/09_r.dds",
  L"data/event/pic/mamizou/10.dds",
  L"data/event/pic/mamizou/10_r.dds",
  L"data/event/pic/mamizou.csv",
  L"data/event/pic/marisa/01.dds",
  L"data/event/pic/marisa/02.dds",
  L"data/event/pic/marisa/03.dds",
  L"data/event/pic/marisa/04.dds",
  L"data/event/pic/marisa/05.dds",
  L"data/event/pic/marisa/06.dds",
  L"data/event/pic/marisa/07.dds",
  L"data/event/pic/marisa/08.dds",
  L"data/event/pic/marisa/09.dds",
  L"data/event/pic/marisa/10.dds",
  L"data/event/pic/marisa/11.dds",
  L"data/event/pic/marisa/11.th145_CharName_Cutin.csv",
  L"data/event/pic/marisa/11_mono1.dds",
  L"data/event/pic/marisa/11_mono2.dds",
  L"data/event/pic/marisa/11_mono2_r.dds",
  L"data/event/pic/marisa/11_mono3.dds",
  L"data/event/pic/marisa/11_mono_nameplate.dds",
  L"data/event/pic/marisa/13.dds",
  L"data/event/pic/marisa/14.dds",
  L"data/event/pic/marisa.csv",
  L"data/event/pic/miko/01.dds",
  L"data/event/pic/miko/02.dds",
  L"data/event/pic/miko/02_r.dds",
  L"data/event/pic/miko/03.dds",
  L"data/event/pic/miko/03.th145_charname_cutin.csv",
  L"data/event/pic/miko/03_mono1.dds",
  L"data/event/pic/miko/03_mono2.dds",
  L"data/event/pic/miko/03_mono2_r.dds",
  L"data/event/pic/miko/03_mono3.dds",
  L"data/event/pic/miko/03_mono_nameplate.dds",
  L"data/event/pic/miko/05.dds",
  L"data/event/pic/miko/05_r.dds",
  L"data/event/pic/miko/06.dds",
  L"data/event/pic/miko/07.dds",
  L"data/event/pic/miko/07_r.dds",
  L"data/event/pic/miko/08.dds",
  L"data/event/pic/miko/08_r.dds",
  L"data/event/pic/miko/09.dds",
  L"data/event/pic/miko/09_r.dds",
  L"data/event/pic/miko/10.dds",
  L"data/event/pic/miko.csv",
  L"data/event/pic/mokou/01.dds",
  L"data/event/pic/mokou/02.dds",
  L"data/event/pic/mokou/03.dds",
  L"data/event/pic/mokou/03.th145_charname_cutin.csv",
  L"data/event/pic/mokou/03_mono1.dds",
  L"data/event/pic/mokou/03_mono2.dds",
  L"data/event/pic/mokou/03_mono2_r.dds",
  L"data/event/pic/mokou/03_mono3.dds",
  L"data/event/pic/mokou/03_mono_nameplate.dds",
  L"data/event/pic/mokou/05.dds",
  L"data/event/pic/mokou/06.dds",
  L"data/event/pic/mokou/07.dds",
  L"data/event/pic/mokou/08.dds",
  L"data/event/pic/mokou/09.dds",
  L"data/event/pic/mokou/10.dds",
  L"data/event/pic/mokou.csv",
  L"data/event/pic/nitori/01.dds",
  L"data/event/pic/nitori/02.dds",
  L"data/event/pic/nitori/03.dds",
  L"data/event/pic/nitori/03.th145_charname_cutin.csv",
  L"data/event/pic/nitori/03_mono1.dds",
  L"data/event/pic/nitori/03_mono2.dds",
  L"data/event/pic/nitori/03_mono2_r.dds",
  L"data/event/pic/nitori/03_mono3.dds",
  L"data/event/pic/nitori/03_mono_nameplate.dds",
  L"data/event/pic/nitori/05.dds",
  L"data/event/pic/nitori/06.dds",
  L"data/event/pic/nitori/07.dds",
  L"data/event/pic/nitori/08.dds",
  L"data/event/pic/nitori/09.dds",
  L"data/event/pic/nitori/10.dds",
  L"data/event/pic/nitori.csv",
  L"data/event/pic/reimu/01.dds",
  L"data/event/pic/reimu/02.dds",
  L"data/event/pic/reimu/03.dds",
  L"data/event/pic/reimu/04.dds",
  L"data/event/pic/reimu/05.dds",
  L"data/event/pic/reimu/06.dds",
  L"data/event/pic/reimu/07.dds",
  L"data/event/pic/reimu/08.dds",
  L"data/event/pic/reimu/09.dds",
  L"data/event/pic/reimu/10.dds",
  L"data/event/pic/reimu/11.dds",
  L"data/event/pic/reimu/12.dds",
  L"data/event/pic/reimu/16.dds",
  L"data/event/pic/reimu/16.th145_CharName_Cutin.csv",
  L"data/event/pic/reimu/16_mono1.dds",
  L"data/event/pic/reimu/16_mono2.dds",
  L"data/event/pic/reimu/16_mono2_r.dds",
  L"data/event/pic/reimu/16_mono3.dds",
  L"data/event/pic/reimu/16_mono_nameplate.dds",
  L"data/event/pic/reimu/17.dds",
  L"data/event/pic/reimu.csv",
  L"data/event/pic/sinmyoumaru/01.dds",
  L"data/event/pic/sinmyoumaru/02.dds",
  L"data/event/pic/sinmyoumaru/03.dds",
  L"data/event/pic/sinmyoumaru/03.th145_charname_cutin.csv",
  L"data/event/pic/sinmyoumaru/03_mono1.dds",
  L"data/event/pic/sinmyoumaru/03_mono2.dds",
  L"data/event/pic/sinmyoumaru/03_mono2_r.dds",
  L"data/event/pic/sinmyoumaru/03_mono3.dds",
  L"data/event/pic/sinmyoumaru/03_mono_nameplate.dds",
  L"data/event/pic/sinmyoumaru/05.dds",
  L"data/event/pic/sinmyoumaru/06.dds",
  L"data/event/pic/sinmyoumaru/07.dds",
  L"data/event/pic/sinmyoumaru/08.dds",
  L"data/event/pic/sinmyoumaru/09.dds",
  L"data/event/pic/sinmyoumaru/10.dds",
  L"data/event/pic/sinmyoumaru.csv",
  L"data/event/pic/usami/01.dds",
  L"data/event/pic/usami/02.dds",
  L"data/event/pic/usami/03.dds",
  L"data/event/pic/usami/03.th145_charname_cutin.csv",
  L"data/event/pic/usami/03_mono1.dds",
  L"data/event/pic/usami/03_mono2.dds",
  L"data/event/pic/usami/03_mono2_r.dds",
  L"data/event/pic/usami/03_mono3.dds",
  L"data/event/pic/usami/03_mono_nameplate.dds",
  L"data/event/pic/usami/05.dds",
  L"data/event/pic/usami/06.dds",
  L"data/event/pic/usami/07.dds",
  L"data/event/pic/usami/08.dds",
  L"data/event/pic/usami/09.dds",
  L"data/event/pic/usami/10.dds",
  L"data/event/pic/usami.csv",
  L"data/event/script/ed_futo.pl",
  L"data/event/script/ed_hijiri.pl",
  L"data/event/script/ed_ichirin.pl",
  L"data/event/script/ed_kasen.pl",
  L"data/event/script/ed_koishi.pl",
  L"data/event/script/ed_kokoro.pl",
  L"data/event/script/ed_mamizou.pl",
  L"data/event/script/ed_marisa.pl",
  L"data/event/script/ed_miko.pl",
  L"data/event/script/ed_mokou.pl",
  L"data/event/script/ed_nitori.pl",
  L"data/event/script/ed_reimuB.pl",
  L"data/event/script/ed_sinmyoumaru.pl",
  L"data/event/script/ed_usami.pl",
  L"data/event/script/futo/stage1.pl",
  L"data/event/script/futo/stage2.pl",
  L"data/event/script/futo/stage3.pl",
  L"data/event/script/futo/stage4.pl",
  L"data/event/script/futo.nut",
  L"data/event/script/hijiri/stage1.pl",
  L"data/event/script/hijiri/stage2.pl",
  L"data/event/script/hijiri/stage3.pl",
  L"data/event/script/hijiri/stage4.pl",
  L"data/event/script/hijiri/stage5.pl",
  L"data/event/script/hijiri.nut",
  L"data/event/script/ichirin/stage1.pl",
  L"data/event/script/ichirin/stage2.pl",
  L"data/event/script/ichirin/stage3.pl",
  L"data/event/script/ichirin/stage4.pl",
  L"data/event/script/ichirin.nut",
  L"data/event/script/kasen/stage1.pl",
  L"data/event/script/kasen/stage2.pl",
  L"data/event/script/kasen/stage3.pl",
  L"data/event/script/kasen/stage4.pl",
  L"data/event/script/kasen/stage5.pl",
  L"data/event/script/kasen.nut",
  L"data/event/script/koishi/stage1.pl",
  L"data/event/script/koishi/stage2.pl",
  L"data/event/script/koishi/stage3.pl",
  L"data/event/script/koishi/stage4.pl",
  L"data/event/script/koishi.nut",
  L"data/event/script/kokoro/stage1.pl",
  L"data/event/script/kokoro/stage2.pl",
  L"data/event/script/kokoro/stage3.pl",
  L"data/event/script/kokoro/stage4.pl",
  L"data/event/script/kokoro.nut",
  L"data/event/script/mamizou/stage1.pl",
  L"data/event/script/mamizou/stage2.pl",
  L"data/event/script/mamizou/stage3.pl",
  L"data/event/script/mamizou/stage4.pl",
  L"data/event/script/mamizou/stage5.pl",
  L"data/event/script/mamizou.nut",
  L"data/event/script/marisa/stage1.pl",
  L"data/event/script/marisa/stage2.pl",
  L"data/event/script/marisa/stage3.pl",
  L"data/event/script/marisa/stage4.pl",
  L"data/event/script/marisa/stage5.pl",
  L"data/event/script/marisa.nut",
  L"data/event/script/miko/stage1.pl",
  L"data/event/script/miko/stage2.pl",
  L"data/event/script/miko/stage3.pl",
  L"data/event/script/miko/stage4.pl",
  L"data/event/script/miko/stage5.pl",
  L"data/event/script/miko.nut",
  L"data/event/script/mokou/stage1.pl",
  L"data/event/script/mokou/stage2.pl",
  L"data/event/script/mokou/stage3.pl",
  L"data/event/script/mokou/stage4.pl",
  L"data/event/script/mokou/stage5.pl",
  L"data/event/script/mokou.nut",
  L"data/event/script/nitori/stage1.pl",
  L"data/event/script/nitori/stage2.pl",
  L"data/event/script/nitori/stage3.pl",
  L"data/event/script/nitori/stage4.pl",
  L"data/event/script/nitori.nut",
  L"data/event/script/reimu/stage1.pl",
  L"data/event/script/reimu/stage2.pl",
  L"data/event/script/reimu/stage3.pl",
  L"data/event/script/reimu.nut",
  L"data/event/script/reimub/stage1.pl",
  L"data/event/script/reimub/stage2.pl",
  L"data/event/script/reimub/stage3.pl",
  L"data/event/script/reimub/stage4.pl",
  L"data/event/script/reimub.nut",
  L"data/event/script/sinmyoumaru/stage1.pl",
  L"data/event/script/sinmyoumaru/stage2.pl",
  L"data/event/script/sinmyoumaru/stage3.pl",
  L"data/event/script/sinmyoumaru/stage4.pl",
  L"data/event/script/sinmyoumaru/stage5.pl",
  L"data/event/script/sinmyoumaru.nut",
  L"data/event/script/usami/stage1.pl",
  L"data/event/script/usami/stage2.pl",
  L"data/event/script/usami/stage3.pl",
  L"data/event/script/usami/stage4.pl",
  L"data/event/script/usami/stage5.pl",
  L"data/event/script/usami/stage6.pl",
  L"data/event/script/usami/stage7.pl",
  L"data/event/script/usami.nut",
  L"data/font/ipag.ttf",
  L"data/font/NotoSansJP-Black.otf",
  L"data/font/NotoSansJP-Bold.otf",
  L"data/font/NotoSansJP-DemiLight.otf",
  L"data/font/NotoSansJP-Light.otf",
  L"data/font/NotoSansJP-Medium.otf",
  L"data/font/NotoSansJP-Regular.otf",
  L"data/font/NotoSansJP-Thin-Windows.otf",
  L"data/font/rounded-mplus-1p-regular.ttf",
  L"data/index/CAttribute.017",
  L"data/index/CLayer.017",
  L"data/index/CMaterial.017",
  L"data/index/CMesh.017",
  L"data/index/CMeshNode.017",
  L"data/index/CMeshRef.017",
  L"data/index/CMeshRoot.017",
  L"data/index/CShape.017",
  L"data/index/CSkin.017",
  L"data/material/obj1/mat1.mat",
  L"data/material//bgtest.bmp",
  L"data/material//mat1.mat",
  L"data/material//mat3.mat",
  L"data/material/U/mat1.mat",
  L"data/material/U/RN03.mat",
  L"data/material/U01/mat1.mat",
  L"data/material/U01/RN03.mat",
  L"data/material/_Љ/mat1.mat",
  L"data/material/_Љ/.mat",
  L"data/material/_Љ/_Њ01.mat",
  L"data/material/_Ж{/mat1.mat",
  L"data/material/_Ж{/ӂ03.mat",
  L"data/material/_Ж{/RN03.mat",
  L"data/material/_Ж{/RNp[c01.mat",
  L"data/material/_Ж{/ǎe.mat",
  L"data/material/_Ж{/L.mat",
  L"data/material/_Ж{/.mat",
  L"data/material/_Ж{/A.mat",
  L"data/material/_Ж{/_Њ01.mat",
  L"data/material//mat1.mat",
  L"data/material//RNp[c01.mat",
  L"data/material//ǎe.mat",
  L"data/material//.mat",
  L"data/material//_Њ01.mat",
  L"data/material/ΑK/mat1.mat",
  L"data/material/ΑK/RNp[c01.mat",
  L"data/material/ΑK/.mat",
  L"data/material/ʘH/mat1.mat",
  L"data/material/ʘH/mat4.mat",
  L"data/script/actor.nut",
  L"data/script/act_def.nut",
  L"data/script/backGround/bg01.nut",
  L"data/script/backGround/bg02.nut",
  L"data/script/backGround/bg03.nut",
  L"data/script/backGround/bg04.nut",
  L"data/script/backGround/bg05.nut",
  L"data/script/backGround/bg06.nut",
  L"data/script/backGround/bg07.nut",
  L"data/script/backGround/bg08.nut",
  L"data/script/backGround/bg09.nut",
  L"data/script/backGround/bg10.nut",
  L"data/script/backGround/bg11.nut",
  L"data/script/backGround/bg12.nut",
  L"data/script/backGround/bg13.nut",
  L"data/script/backGround/bg14.nut",
  L"data/script/backGround/bg15.nut",
  L"data/script/backGround/bg16.nut",
  L"data/script/backGround/bg17.nut",
  L"data/script/backGround/bg18.nut",
  L"data/script/backGround/bg18_actor.nut",
  L"data/script/backGround/bg18_min.nut",
  L"data/script/backGround/bg19.nut",
  L"data/script/backGround/bg20.nut",
  L"data/script/backGround/bg21.nut",
  L"data/script/backGround/bg22.nut",
  L"data/script/backGround/bg23.nut",
  L"data/script/backGround/bg24.nut",
  L"data/script/backGround/bg25.nut",
  L"data/script/backGround/bg26.nut",
  L"data/script/backGround/bg27.nut",
  L"data/script/backGround/bg28.nut",
  L"data/script/backGround/bg29.nut",
  L"data/script/backGround/bg29_min.nut",
  L"data/script/backGround/bg_min.nut",
  L"data/script/boot.nut",
  L"data/script/boot_product.nut",
  L"data/script/camera.nut",
  L"data/script/camera_2d.nut",
  L"data/script/camera_3d.nut",
  L"data/script/class.nut",
  L"data/script/command.nut",
  L"data/script/config.nut",
  L"data/script/const.nut",
  L"data/script/const_key.nut",
  L"data/script/font.nut",
  L"data/script/game.nut",
  L"data/script/game_battle.nut",
  L"data/script/game_load.nut",
  L"data/script/game_occult.nut",
  L"data/script/game_scene.nut",
  L"data/script/game_story.nut",
  L"data/script/global.nut",
  L"data/script/hit.nut",
  L"data/script/input.nut",
  L"data/script/input_command.nut",
  L"data/script/keymap.nut",
  L"data/script/loadFiles.nut",
  L"data/script/math.nut",
  L"data/script/practice.nut",
  L"data/script/render.nut",
  L"data/script/renderer_vm.nut",
  L"data/script/replay.nut",
  L"data/script/savedata.nut",
  L"data/script/sound.nut",
  L"data/script/stage.nut",
  L"data/script/story.nut",
  L"data/script/win.nut",
  L"data/script/world.nut",
  L"data/se/common/200.wav",
  L"data/se/common/201.wav",
  L"data/se/common/202.wav",
  L"data/se/common/800.wav",
  L"data/se/common/801.wav",
  L"data/se/common/803.wav",
  L"data/se/common/804.wav",
  L"data/se/common/805.wav",
  L"data/se/common/810.wav",
  L"data/se/common/813.wav",
  L"data/se/common/816.wav",
  L"data/se/common/817.wav",
  L"data/se/common/820.wav",
  L"data/se/common/823.wav",
  L"data/se/common/824.wav",
  L"data/se/common/825.wav",
  L"data/se/common/826.wav",
  L"data/se/common/827.wav",
  L"data/se/common/828.wav",
  L"data/se/common/829.wav",
  L"data/se/common/830.wav",
  L"data/se/common/832.wav",
  L"data/se/common/833.wav",
  L"data/se/common/834.wav",
  L"data/se/common/835.wav",
  L"data/se/common/836.wav",
  L"data/se/common/837.wav",
  L"data/se/common/838.wav",
  L"data/se/common/839.wav",
  L"data/se/common/842.wav",
  L"data/se/common/843.wav",
  L"data/se/common/844.wav",
  L"data/se/common/845.wav",
  L"data/se/common/846.wav",
  L"data/se/common/847.wav",
  L"data/se/common/848.wav",
  L"data/se/common/849.wav",
  L"data/se/common/850.wav",
  L"data/se/common/851.wav",
  L"data/se/common/852.wav",
  L"data/se/common/854.wav",
  L"data/se/common/855.wav",
  L"data/se/common/856.wav",
  L"data/se/common/857.wav",
  L"data/se/common/858.wav",
  L"data/se/common/862.wav",
  L"data/se/common/900.wav",
  L"data/se/common/902.wav",
  L"data/se/common/903.wav",
  L"data/se/common/906.wav",
  L"data/se/common/907.wav",
  L"data/se/common/908.wav",
  L"data/se/common/910.wav",
  L"data/se/common/911.wav",
  L"data/se/common/912.wav",
  L"data/se/common/922.wav",
  L"data/se/common/923.wav",
  L"data/se/common/926.wav",
  L"data/se/common/927.wav",
  L"data/se/common/928.wav",
  L"data/se/common/929.wav",
  L"data/se/common/h001.wav",
  L"data/se/common/h002.wav",
  L"data/se/common/h003.wav",
  L"data/se/common/h004.wav",
  L"data/se/common/h005.wav",
  L"data/se/common/h017.wav",
  L"data/se/common/h018.wav",
  L"data/se/common/h019.wav",
  L"data/se/common/h026.wav",
  L"data/se/common/h027.wav",
  L"data/se/common/h029.wav",
  L"data/se/common/h030.wav",
  L"data/se/common/h035_3.wav",
  L"data/se/common/h035_4.wav",
  L"data/se/common/h036.wav",
  L"data/se/common/h037.wav",
  L"data/se/common/h038.wav",
  L"data/se/common/h039_1.wav",
  L"data/se/common/h044.wav",
  L"data/se/common/h053_2.wav",
  L"data/se/common/h068.wav",
  L"data/se/common/h073_2.wav",
  L"data/se/common/h073_3.wav",
  L"data/se/common/h074.wav",
  L"data/se/common/s002.wav",
  L"data/se/common/s002_2.wav",
  L"data/se/common/s003.wav",
  L"data/se/common/s003_4.wav",
  L"data/se/common/s004_2.wav",
  L"data/se/common/s004_3.wav",
  L"data/se/common/s004_4.wav",
  L"data/se/common/s004_5.wav",
  L"data/se/common/s005_2.wav",
  L"data/se/common/s005_3.wav",
  L"data/se/common/s005_4.wav",
  L"data/se/common/s006.wav",
  L"data/se/common/s006_3.wav",
  L"data/se/common/s007.wav",
  L"data/se/common/s007_4.wav",
  L"data/se/common/s010_2.wav",
  L"data/se/common/s011_2.wav",
  L"data/se/common/s013.wav",
  L"data/se/common/s016_1.wav",
  L"data/se/common/s016_2.wav",
  L"data/se/common/s022.wav",
  L"data/se/common/s025.wav",
  L"data/se/common/s050.wav",
  L"data/se/common/s057.wav",
  L"data/se/common/s064.wav",
  L"data/se/futo/1800.wav",
  L"data/se/futo/1804.wav",
  L"data/se/futo/1806.wav",
  L"data/se/futo/1808.wav",
  L"data/se/futo/1810.wav",
  L"data/se/futo/1811.wav",
  L"data/se/futo/1814.wav",
  L"data/se/futo/1815.wav",
  L"data/se/futo/1822.wav",
  L"data/se/futo/1823.wav",
  L"data/se/futo/1825.wav",
  L"data/se/futo/1831.wav",
  L"data/se/futo/1832.wav",
  L"data/se/futo/1833.wav",
  L"data/se/futo/1835.wav",
  L"data/se/futo/1836.wav",
  L"data/se/futo/1837.wav",
  L"data/se/futo/1838.wav",
  L"data/se/futo/1839.wav",
  L"data/se/futo/1840.wav",
  L"data/se/futo/1842.wav",
  L"data/se/futo/1843.wav",
  L"data/se/futo/1899.wav",
  L"data/se/futo/1900.wav",
  L"data/se/futo/1901.wav",
  L"data/se/futo/1903.wav",
  L"data/se/futo/1904.wav",
  L"data/se/futo/1905.wav",
  L"data/se/futo/1906.wav",
  L"data/se/futo/1907.wav",
  L"data/se/futo/1908.wav",
  L"data/se/futo/1911.wav",
  L"data/se/futo/1913.wav",
  L"data/se/futo/1914.wav",
  L"data/se/futo/1915.wav",
  L"data/se/futo/1916.wav",
  L"data/se/futo/1917.wav",
  L"data/se/futo/1919.wav",
  L"data/se/futo/1920.wav",
  L"data/se/futo/1930.wav",
  L"data/se/futo/1932.wav",
  L"data/se/futo/1933.wav",
  L"data/se/futo/1935.wav",
  L"data/se/futo/1936.wav",
  L"data/se/futo/1950.wav",
  L"data/se/futo/1951.wav",
  L"data/se/futo/1952.wav",
  L"data/se/futo/1953.wav",
  L"data/se/futo/1956.wav",
  L"data/se/futo/1958.wav",
  L"data/se/futo/1959.wav",
  L"data/se/futo/1960.wav",
  L"data/se/futo/1961.wav",
  L"data/se/futo/1962.wav",
  L"data/se/futo/1963.wav",
  L"data/se/futo/1965.wav",
  L"data/se/futo/1967.wav",
  L"data/se/futo/1968.wav",
  L"data/se/futo/1969.wav",
  L"data/se/futo/1970.wav",
  L"data/se/futo/1989.wav",
  L"data/se/futo/1990.wav",
  L"data/se/futo/1991.wav",
  L"data/se/futo/1992.wav",
  L"data/se/futo/1993.wav",
  L"data/se/futo/1994.wav",
  L"data/se/futo.csv",
  L"data/se/hijiri/1600.wav",
  L"data/se/hijiri/1601.wav",
  L"data/se/hijiri/1605.wav",
  L"data/se/hijiri/1607.wav",
  L"data/se/hijiri/1609.wav",
  L"data/se/hijiri/1610.wav",
  L"data/se/hijiri/1613.wav",
  L"data/se/hijiri/1615.wav",
  L"data/se/hijiri/1616.wav",
  L"data/se/hijiri/1619.wav",
  L"data/se/hijiri/1621.wav",
  L"data/se/hijiri/1622.wav",
  L"data/se/hijiri/1623.wav",
  L"data/se/hijiri/1624.wav",
  L"data/se/hijiri/1625.wav",
  L"data/se/hijiri/1626.wav",
  L"data/se/hijiri/1627.wav",
  L"data/se/hijiri/1629.wav",
  L"data/se/hijiri/1700.wav",
  L"data/se/hijiri/1701.wav",
  L"data/se/hijiri/1704.wav",
  L"data/se/hijiri/1706.wav",
  L"data/se/hijiri/1707.wav",
  L"data/se/hijiri/1708.wav",
  L"data/se/hijiri/1710.wav",
  L"data/se/hijiri/1712.wav",
  L"data/se/hijiri/1713.wav",
  L"data/se/hijiri/1715.wav",
  L"data/se/hijiri/1719.wav",
  L"data/se/hijiri/1721.wav",
  L"data/se/hijiri/1724.wav",
  L"data/se/hijiri/1725.wav",
  L"data/se/hijiri/1730.wav",
  L"data/se/hijiri/1731.wav",
  L"data/se/hijiri/1732.wav",
  L"data/se/hijiri/1733.wav",
  L"data/se/hijiri/1734.wav",
  L"data/se/hijiri/1736.wav",
  L"data/se/hijiri/1740.wav",
  L"data/se/hijiri/1742.wav",
  L"data/se/hijiri/1743.wav",
  L"data/se/hijiri/1745.wav",
  L"data/se/hijiri/1746.wav",
  L"data/se/hijiri/1750.wav",
  L"data/se/hijiri/1752.wav",
  L"data/se/hijiri/1753.wav",
  L"data/se/hijiri/1754.wav",
  L"data/se/hijiri/1755.wav",
  L"data/se/hijiri/1757.wav",
  L"data/se/hijiri/1758.wav",
  L"data/se/hijiri/1760.wav",
  L"data/se/hijiri.csv",
  L"data/se/ichirin/1451.wav",
  L"data/se/ichirin/1471.wav",
  L"data/se/ichirin/1475.wav",
  L"data/se/ichirin/1476.wav",
  L"data/se/ichirin/1477.wav",
  L"data/se/ichirin/1478.wav",
  L"data/se/ichirin/1479.wav",
  L"data/se/ichirin/1480.wav",
  L"data/se/ichirin/1481.wav",
  L"data/se/ichirin/1489.wav",
  L"data/se/ichirin/1500.wav",
  L"data/se/ichirin/1501.wav",
  L"data/se/ichirin/1502.wav",
  L"data/se/ichirin/1503.wav",
  L"data/se/ichirin/1505.wav",
  L"data/se/ichirin/1507.wav",
  L"data/se/ichirin/1520.wav",
  L"data/se/ichirin/1522.wav",
  L"data/se/ichirin/1523.wav",
  L"data/se/ichirin/1524.wav",
  L"data/se/ichirin/1526.wav",
  L"data/se/ichirin/1528.wav",
  L"data/se/ichirin/1529.wav",
  L"data/se/ichirin/1540.wav",
  L"data/se/ichirin/1541.wav",
  L"data/se/ichirin/1542.wav",
  L"data/se/ichirin/1544.wav",
  L"data/se/ichirin/1550.wav",
  L"data/se/ichirin/1551.wav",
  L"data/se/ichirin/1553.wav",
  L"data/se/ichirin/1554.wav",
  L"data/se/ichirin/1555.wav",
  L"data/se/ichirin/1556.wav",
  L"data/se/ichirin/1557.wav",
  L"data/se/ichirin/1558.wav",
  L"data/se/ichirin/1559.wav",
  L"data/se/ichirin/1560.wav",
  L"data/se/ichirin/1573.wav",
  L"data/se/ichirin/1574.wav",
  L"data/se/ichirin/1576.wav",
  L"data/se/ichirin/1590.wav",
  L"data/se/ichirin/1591.wav",
  L"data/se/ichirin/1592.wav",
  L"data/se/ichirin/1593.wav",
  L"data/se/ichirin/1599.wav",
  L"data/se/ichirin.csv",
  L"data/se/kasen/3000.wav",
  L"data/se/kasen/3002.wav",
  L"data/se/kasen/3004.wav",
  L"data/se/kasen/3006.wav",
  L"data/se/kasen/3008.wav",
  L"data/se/kasen/3010.wav",
  L"data/se/kasen/3012.wav",
  L"data/se/kasen/3021.wav",
  L"data/se/kasen/3023.wav",
  L"data/se/kasen/3024.wav",
  L"data/se/kasen/3026.wav",
  L"data/se/kasen/3027.wav",
  L"data/se/kasen/3028.wav",
  L"data/se/kasen/3030.wav",
  L"data/se/kasen/3031.wav",
  L"data/se/kasen/3033.wav",
  L"data/se/kasen/3034.wav",
  L"data/se/kasen/3035.wav",
  L"data/se/kasen/3038.wav",
  L"data/se/kasen/3039.wav",
  L"data/se/kasen/3040.wav",
  L"data/se/kasen/3041.wav",
  L"data/se/kasen/3043.wav",
  L"data/se/kasen/3045.wav",
  L"data/se/kasen/3046.wav",
  L"data/se/kasen/3048.wav",
  L"data/se/kasen/3050.wav",
  L"data/se/kasen/3051.wav",
  L"data/se/kasen/3052.wav",
  L"data/se/kasen/3053.wav",
  L"data/se/kasen/3054.wav",
  L"data/se/kasen/3055.wav",
  L"data/se/kasen/3056.wav",
  L"data/se/kasen/3057.wav",
  L"data/se/kasen/3058.wav",
  L"data/se/kasen/3059.wav",
  L"data/se/kasen/3060.wav",
  L"data/se/kasen/3061.wav",
  L"data/se/kasen/3062.wav",
  L"data/se/kasen/3063.wav",
  L"data/se/kasen/3065.wav",
  L"data/se/kasen/3068.wav",
  L"data/se/kasen/3069.wav",
  L"data/se/kasen/3070.wav",
  L"data/se/kasen/3071.wav",
  L"data/se/kasen/3073.wav",
  L"data/se/kasen/3074.wav",
  L"data/se/kasen/3075.wav",
  L"data/se/kasen/3076.wav",
  L"data/se/kasen/3078.wav",
  L"data/se/kasen/3080.wav",
  L"data/se/kasen/3081.wav",
  L"data/se/kasen.csv",
  L"data/se/koishi/2400.wav",
  L"data/se/koishi/2402.wav",
  L"data/se/koishi/2403.wav",
  L"data/se/koishi/2405.wav",
  L"data/se/koishi/2407.wav",
  L"data/se/koishi/2408.wav",
  L"data/se/koishi/2411.wav",
  L"data/se/koishi/2413.wav",
  L"data/se/koishi/2414.wav",
  L"data/se/koishi/2415.wav",
  L"data/se/koishi/2417.wav",
  L"data/se/koishi/2420.wav",
  L"data/se/koishi/2422.wav",
  L"data/se/koishi/2423.wav",
  L"data/se/koishi/2425.wav",
  L"data/se/koishi/2430.wav",
  L"data/se/koishi/2431.wav",
  L"data/se/koishi/2432.wav",
  L"data/se/koishi/2433.wav",
  L"data/se/koishi/2435.wav",
  L"data/se/koishi/2436.wav",
  L"data/se/koishi/2438.wav",
  L"data/se/koishi/2439.wav",
  L"data/se/koishi/2440.wav",
  L"data/se/koishi/2441.wav",
  L"data/se/koishi/2442.wav",
  L"data/se/koishi/2443.wav",
  L"data/se/koishi/2445.wav",
  L"data/se/koishi/2446.wav",
  L"data/se/koishi/2447.wav",
  L"data/se/koishi/2450.wav",
  L"data/se/koishi/2451.wav",
  L"data/se/koishi/2452.wav",
  L"data/se/koishi/2453.wav",
  L"data/se/koishi/2454.wav",
  L"data/se/koishi/2455.wav",
  L"data/se/koishi/2457.wav",
  L"data/se/koishi/2458.wav",
  L"data/se/koishi/2459.wav",
  L"data/se/koishi/2460.wav",
  L"data/se/koishi/2461.wav",
  L"data/se/koishi/2463.wav",
  L"data/se/koishi/2500.wav",
  L"data/se/koishi/2502.wav",
  L"data/se/koishi/2504.wav",
  L"data/se/koishi/2505.wav",
  L"data/se/koishi/2506.wav",
  L"data/se/koishi/2507.wav",
  L"data/se/koishi/2550.wav",
  L"data/se/koishi/2552.wav",
  L"data/se/koishi/2553.wav",
  L"data/se/koishi/2555.wav",
  L"data/se/koishi/2556.wav",
  L"data/se/koishi/2590.wav",
  L"data/se/koishi/2591.wav",
  L"data/se/koishi/2592.wav",
  L"data/se/koishi/2594.wav",
  L"data/se/koishi/2595.wav",
  L"data/se/koishi/2596.wav",
  L"data/se/koishi/2598.wav",
  L"data/se/koishi/2599.wav",
  L"data/se/koishi.csv",
  L"data/se/kokoro/2800.wav",
  L"data/se/kokoro/2802.wav",
  L"data/se/kokoro/2804.wav",
  L"data/se/kokoro/2806.wav",
  L"data/se/kokoro/2808.wav",
  L"data/se/kokoro/2810.wav",
  L"data/se/kokoro/2812.wav",
  L"data/se/kokoro/2813.wav",
  L"data/se/kokoro/2816.wav",
  L"data/se/kokoro/2817.wav",
  L"data/se/kokoro/2820.wav",
  L"data/se/kokoro/2822.wav",
  L"data/se/kokoro/2824.wav",
  L"data/se/kokoro/2826.wav",
  L"data/se/kokoro/2827.wav",
  L"data/se/kokoro/2900.wav",
  L"data/se/kokoro/2902.wav",
  L"data/se/kokoro/2905.wav",
  L"data/se/kokoro/2907.wav",
  L"data/se/kokoro/2909.wav",
  L"data/se/kokoro/2912.wav",
  L"data/se/kokoro/2913.wav",
  L"data/se/kokoro/2914.wav",
  L"data/se/kokoro/2917.wav",
  L"data/se/kokoro/2918.wav",
  L"data/se/kokoro/2921.wav",
  L"data/se/kokoro/2922.wav",
  L"data/se/kokoro/2925.wav",
  L"data/se/kokoro/2926.wav",
  L"data/se/kokoro/2927.wav",
  L"data/se/kokoro/2929.wav",
  L"data/se/kokoro/2930.wav",
  L"data/se/kokoro/2931.wav",
  L"data/se/kokoro/2932.wav",
  L"data/se/kokoro/2933.wav",
  L"data/se/kokoro/2934.wav",
  L"data/se/kokoro/2935.wav",
  L"data/se/kokoro/2950.wav",
  L"data/se/kokoro/2951.wav",
  L"data/se/kokoro/2952.wav",
  L"data/se/kokoro/2955.wav",
  L"data/se/kokoro/2970.wav",
  L"data/se/kokoro/2972.wav",
  L"data/se/kokoro/2975.wav",
  L"data/se/kokoro/2977.wav",
  L"data/se/kokoro/2980.wav",
  L"data/se/kokoro/2981.wav",
  L"data/se/kokoro/2982.wav",
  L"data/se/kokoro/2983.wav",
  L"data/se/kokoro/2984.wav",
  L"data/se/kokoro/2985.wav",
  L"data/se/kokoro/2990.wav",
  L"data/se/kokoro/2992.wav",
  L"data/se/kokoro/2993.wav",
  L"data/se/kokoro/2994.wav",
  L"data/se/kokoro/2996.wav",
  L"data/se/kokoro/2997.wav",
  L"data/se/kokoro.csv",
  L"data/se/mamizou/2600.wav",
  L"data/se/mamizou/2601.wav",
  L"data/se/mamizou/2602.wav",
  L"data/se/mamizou/2604.wav",
  L"data/se/mamizou/2605.wav",
  L"data/se/mamizou/2606.wav",
  L"data/se/mamizou/2609.wav",
  L"data/se/mamizou/2610.wav",
  L"data/se/mamizou/2611.wav",
  L"data/se/mamizou/2612.wav",
  L"data/se/mamizou/2613.wav",
  L"data/se/mamizou/2614.wav",
  L"data/se/mamizou/2615.wav",
  L"data/se/mamizou/2617.wav",
  L"data/se/mamizou/2619.wav",
  L"data/se/mamizou/2620.wav",
  L"data/se/mamizou/2621.wav",
  L"data/se/mamizou/2622.wav",
  L"data/se/mamizou/2625.wav",
  L"data/se/mamizou/2627.wav",
  L"data/se/mamizou/2628.wav",
  L"data/se/mamizou/2629.wav",
  L"data/se/mamizou/2631.wav",
  L"data/se/mamizou/2637.wav",
  L"data/se/mamizou/2638.wav",
  L"data/se/mamizou/2639.wav",
  L"data/se/mamizou/2640.wav",
  L"data/se/mamizou/2641.wav",
  L"data/se/mamizou/2642.wav",
  L"data/se/mamizou/2643.wav",
  L"data/se/mamizou/2644.wav",
  L"data/se/mamizou/2650.wav",
  L"data/se/mamizou/2652.wav",
  L"data/se/mamizou/2654.wav",
  L"data/se/mamizou/2655.wav",
  L"data/se/mamizou/2658.wav",
  L"data/se/mamizou/2660.wav",
  L"data/se/mamizou/2661.wav",
  L"data/se/mamizou/2662.wav",
  L"data/se/mamizou/2663.wav",
  L"data/se/mamizou/2664.wav",
  L"data/se/mamizou/2667.wav",
  L"data/se/mamizou/2668.wav",
  L"data/se/mamizou/2669.wav",
  L"data/se/mamizou/2670.wav",
  L"data/se/mamizou/2672.wav",
  L"data/se/mamizou/2673.wav",
  L"data/se/mamizou/2674.wav",
  L"data/se/mamizou/2690.wav",
  L"data/se/mamizou/2691.wav",
  L"data/se/mamizou/2692.wav",
  L"data/se/mamizou/2693.wav",
  L"data/se/mamizou/2695.wav",
  L"data/se/mamizou/2697.wav",
  L"data/se/mamizou/2699.wav",
  L"data/se/mamizou/2701.wav",
  L"data/se/mamizou/2703.wav",
  L"data/se/mamizou/2705.wav",
  L"data/se/mamizou/2707.wav",
  L"data/se/mamizou/2708.wav",
  L"data/se/mamizou/2709.wav",
  L"data/se/mamizou/2710.wav",
  L"data/se/mamizou.csv",
  L"data/se/marisa/1200.wav",
  L"data/se/marisa/1202.wav",
  L"data/se/marisa/1204.wav",
  L"data/se/marisa/1206.wav",
  L"data/se/marisa/1208.wav",
  L"data/se/marisa/1210.wav",
  L"data/se/marisa/1216.wav",
  L"data/se/marisa/1250.wav",
  L"data/se/marisa/1251.wav",
  L"data/se/marisa/1253.wav",
  L"data/se/marisa/1258.wav",
  L"data/se/marisa/1259.wav",
  L"data/se/marisa/1262.wav",
  L"data/se/marisa/1263.wav",
  L"data/se/marisa/1264.wav",
  L"data/se/marisa/1266.wav",
  L"data/se/marisa/1267.wav",
  L"data/se/marisa/1268.wav",
  L"data/se/marisa/1270.wav",
  L"data/se/marisa/1272.wav",
  L"data/se/marisa/1273.wav",
  L"data/se/marisa/1274.wav",
  L"data/se/marisa/1275.wav",
  L"data/se/marisa/1276.wav",
  L"data/se/marisa/1279.wav",
  L"data/se/marisa/1280.wav",
  L"data/se/marisa/1281.wav",
  L"data/se/marisa/1290.wav",
  L"data/se/marisa/1291.wav",
  L"data/se/marisa/1292.wav",
  L"data/se/marisa/1300.wav",
  L"data/se/marisa/1302.wav",
  L"data/se/marisa/1303.wav",
  L"data/se/marisa/1305.wav",
  L"data/se/marisa/1306.wav",
  L"data/se/marisa/1308.wav",
  L"data/se/marisa/1310.wav",
  L"data/se/marisa/1312.wav",
  L"data/se/marisa/1314.wav",
  L"data/se/marisa/1315.wav",
  L"data/se/marisa/1350.wav",
  L"data/se/marisa/1351.wav",
  L"data/se/marisa/1352.wav",
  L"data/se/marisa/1354.wav",
  L"data/se/marisa/1356.wav",
  L"data/se/marisa/1358.wav",
  L"data/se/marisa/1359.wav",
  L"data/se/marisa/1363.wav",
  L"data/se/marisa/1364.wav",
  L"data/se/marisa/1366.wav",
  L"data/se/marisa/1367.wav",
  L"data/se/marisa/1368.wav",
  L"data/se/marisa/1369.wav",
  L"data/se/marisa/1371.wav",
  L"data/se/marisa/1373.wav",
  L"data/se/marisa/1390.wav",
  L"data/se/marisa.csv",
  L"data/se/miko/2000.wav",
  L"data/se/miko/2002.wav",
  L"data/se/miko/2004.wav",
  L"data/se/miko/2006.wav",
  L"data/se/miko/2008.wav",
  L"data/se/miko/2009.wav",
  L"data/se/miko/2011.wav",
  L"data/se/miko/2013.wav",
  L"data/se/miko/2015.wav",
  L"data/se/miko/2017.wav",
  L"data/se/miko/2050.wav",
  L"data/se/miko/2051.wav",
  L"data/se/miko/2053.wav",
  L"data/se/miko/2054.wav",
  L"data/se/miko/2100.wav",
  L"data/se/miko/2101.wav",
  L"data/se/miko/2102.wav",
  L"data/se/miko/2103.wav",
  L"data/se/miko/2105.wav",
  L"data/se/miko/2106.wav",
  L"data/se/miko/2108.wav",
  L"data/se/miko/2109.wav",
  L"data/se/miko/2111.wav",
  L"data/se/miko/2112.wav",
  L"data/se/miko/2113.wav",
  L"data/se/miko/2115.wav",
  L"data/se/miko/2117.wav",
  L"data/se/miko/2120.wav",
  L"data/se/miko/2121.wav",
  L"data/se/miko/2123.wav",
  L"data/se/miko/2124.wav",
  L"data/se/miko/2126.wav",
  L"data/se/miko/2128.wav",
  L"data/se/miko/2130.wav",
  L"data/se/miko/2131.wav",
  L"data/se/miko/2132.wav",
  L"data/se/miko/2133.wav",
  L"data/se/miko/2135.wav",
  L"data/se/miko/2136.wav",
  L"data/se/miko/2137.wav",
  L"data/se/miko/2150.wav",
  L"data/se/miko/2151.wav",
  L"data/se/miko/2152.wav",
  L"data/se/miko/2153.wav",
  L"data/se/miko/2190.wav",
  L"data/se/miko/2191.wav",
  L"data/se/miko.csv",
  L"data/se/mokou/3200.wav",
  L"data/se/mokou/3204.wav",
  L"data/se/mokou/3208.wav",
  L"data/se/mokou/3210.wav",
  L"data/se/mokou/3214.wav",
  L"data/se/mokou/3220.wav",
  L"data/se/mokou/3224.wav",
  L"data/se/mokou/3226.wav",
  L"data/se/mokou/3228.wav",
  L"data/se/mokou/3230.wav",
  L"data/se/mokou/3232.wav",
  L"data/se/mokou/3234.wav",
  L"data/se/mokou/3235.wav",
  L"data/se/mokou/3236.wav",
  L"data/se/mokou/3237.wav",
  L"data/se/mokou/3240.wav",
  L"data/se/mokou/3241.wav",
  L"data/se/mokou/3242.wav",
  L"data/se/mokou/3250.wav",
  L"data/se/mokou/3252.wav",
  L"data/se/mokou/3254.wav",
  L"data/se/mokou/3255.wav",
  L"data/se/mokou/3257.wav",
  L"data/se/mokou/3258.wav",
  L"data/se/mokou/3261.wav",
  L"data/se/mokou/3263.wav",
  L"data/se/mokou/3264.wav",
  L"data/se/mokou/3265.wav",
  L"data/se/mokou/3267.wav",
  L"data/se/mokou/3269.wav",
  L"data/se/mokou/3271.wav",
  L"data/se/mokou/3272.wav",
  L"data/se/mokou/3273.wav",
  L"data/se/mokou/3275.wav",
  L"data/se/mokou/3277.wav",
  L"data/se/mokou/3279.wav",
  L"data/se/mokou/3281.wav",
  L"data/se/mokou/3282.wav",
  L"data/se/mokou/3284.wav",
  L"data/se/mokou/3285.wav",
  L"data/se/mokou/3287.wav",
  L"data/se/mokou/3288.wav",
  L"data/se/mokou/3289.wav",
  L"data/se/mokou/3290.wav",
  L"data/se/mokou/3292.wav",
  L"data/se/mokou/3293.wav",
  L"data/se/mokou/3294.wav",
  L"data/se/mokou/3295.wav",
  L"data/se/mokou/3296.wav",
  L"data/se/mokou.csv",
  L"data/se/nitori/2200.wav",
  L"data/se/nitori/2201.wav",
  L"data/se/nitori/2202.wav",
  L"data/se/nitori/2203.wav",
  L"data/se/nitori/2210.wav",
  L"data/se/nitori/2212.wav",
  L"data/se/nitori/2214.wav",
  L"data/se/nitori/2216.wav",
  L"data/se/nitori/2218.wav",
  L"data/se/nitori/2219.wav",
  L"data/se/nitori/2220.wav",
  L"data/se/nitori/2222.wav",
  L"data/se/nitori/2223.wav",
  L"data/se/nitori/2225.wav",
  L"data/se/nitori/2227.wav",
  L"data/se/nitori/2229.wav",
  L"data/se/nitori/2230.wav",
  L"data/se/nitori/2231.wav",
  L"data/se/nitori/2232.wav",
  L"data/se/nitori/2251.wav",
  L"data/se/nitori/2252.wav",
  L"data/se/nitori/2253.wav",
  L"data/se/nitori/2254.wav",
  L"data/se/nitori/2255.wav",
  L"data/se/nitori/2256.wav",
  L"data/se/nitori/2257.wav",
  L"data/se/nitori/2258.wav",
  L"data/se/nitori/2259.wav",
  L"data/se/nitori/2261.wav",
  L"data/se/nitori/2262.wav",
  L"data/se/nitori/2264.wav",
  L"data/se/nitori/2265.wav",
  L"data/se/nitori/2269.wav",
  L"data/se/nitori/2270.wav",
  L"data/se/nitori/2272.wav",
  L"data/se/nitori/2274.wav",
  L"data/se/nitori/2275.wav",
  L"data/se/nitori/2279.wav",
  L"data/se/nitori/2281.wav",
  L"data/se/nitori/2282.wav",
  L"data/se/nitori/2283.wav",
  L"data/se/nitori/2286.wav",
  L"data/se/nitori/2300.wav",
  L"data/se/nitori/2301.wav",
  L"data/se/nitori/2302.wav",
  L"data/se/nitori/2303.wav",
  L"data/se/nitori/2304.wav",
  L"data/se/nitori/2305.wav",
  L"data/se/nitori/2306.wav",
  L"data/se/nitori/2309.wav",
  L"data/se/nitori/2310.wav",
  L"data/se/nitori/2311.wav",
  L"data/se/nitori/2313.wav",
  L"data/se/nitori/2315.wav",
  L"data/se/nitori/2350.wav",
  L"data/se/nitori/2352.wav",
  L"data/se/nitori/2353.wav",
  L"data/se/nitori/2355.wav",
  L"data/se/nitori/2357.wav",
  L"data/se/nitori/2390.wav",
  L"data/se/nitori/2391.wav",
  L"data/se/nitori/2392.wav",
  L"data/se/nitori/2393.wav",
  L"data/se/nitori/2394.wav",
  L"data/se/nitori/2395.wav",
  L"data/se/nitori/2396.wav",
  L"data/se/nitori/2397.wav",
  L"data/se/nitori.csv",
  L"data/se/reimu/1050.wav",
  L"data/se/reimu/1051.wav",
  L"data/se/reimu/1052.wav",
  L"data/se/reimu/1053.wav",
  L"data/se/reimu/1054.wav",
  L"data/se/reimu/1055.wav",
  L"data/se/reimu/1056.wav",
  L"data/se/reimu/1057.wav",
  L"data/se/reimu/1061.wav",
  L"data/se/reimu/1063.wav",
  L"data/se/reimu/1070.wav",
  L"data/se/reimu/1071.wav",
  L"data/se/reimu/1072.wav",
  L"data/se/reimu/1074.wav",
  L"data/se/reimu/1075.wav",
  L"data/se/reimu/1076.wav",
  L"data/se/reimu/1077.wav",
  L"data/se/reimu/1090.wav",
  L"data/se/reimu/1091.wav",
  L"data/se/reimu/1092.wav",
  L"data/se/reimu/1093.wav",
  L"data/se/reimu/1094.wav",
  L"data/se/reimu/1095.wav",
  L"data/se/reimu/1100.wav",
  L"data/se/reimu/1101.wav",
  L"data/se/reimu/1102.wav",
  L"data/se/reimu/1103.wav",
  L"data/se/reimu/1104.wav",
  L"data/se/reimu/1105.wav",
  L"data/se/reimu/1106.wav",
  L"data/se/reimu/1107.wav",
  L"data/se/reimu/1108.wav",
  L"data/se/reimu/1109.wav",
  L"data/se/reimu/1111.wav",
  L"data/se/reimu/1113.wav",
  L"data/se/reimu/1114.wav",
  L"data/se/reimu/1115.wav",
  L"data/se/reimu/1116.wav",
  L"data/se/reimu/1117.wav",
  L"data/se/reimu/1118.wav",
  L"data/se/reimu/1120.wav",
  L"data/se/reimu/1150.wav",
  L"data/se/reimu/1155.wav",
  L"data/se/reimu/1156.wav",
  L"data/se/reimu/1160.wav",
  L"data/se/reimu/1163.wav",
  L"data/se/reimu/1164.wav",
  L"data/se/reimu/1165.wav",
  L"data/se/reimu/1170.wav",
  L"data/se/reimu/1174.wav",
  L"data/se/reimu/1175.wav",
  L"data/se/reimu/1176.wav",
  L"data/se/reimu/1190.wav",
  L"data/se/reimu/1191.wav",
  L"data/se/reimu/1192.wav",
  L"data/se/reimu/1193.wav",
  L"data/se/reimu.csv",
  L"data/se/se.csv",
  L"data/se/sinmyoumaru/3400.wav",
  L"data/se/sinmyoumaru/3404.wav",
  L"data/se/sinmyoumaru/3408.wav",
  L"data/se/sinmyoumaru/3412.wav",
  L"data/se/sinmyoumaru/3416.wav",
  L"data/se/sinmyoumaru/3430.wav",
  L"data/se/sinmyoumaru/3432.wav",
  L"data/se/sinmyoumaru/3434.wav",
  L"data/se/sinmyoumaru/3437.wav",
  L"data/se/sinmyoumaru/3438.wav",
  L"data/se/sinmyoumaru/3440.wav",
  L"data/se/sinmyoumaru/3442.wav",
  L"data/se/sinmyoumaru/3444.wav",
  L"data/se/sinmyoumaru/3445.wav",
  L"data/se/sinmyoumaru/3447.wav",
  L"data/se/sinmyoumaru/3449.wav",
  L"data/se/sinmyoumaru/3450.wav",
  L"data/se/sinmyoumaru/3453.wav",
  L"data/se/sinmyoumaru/3455.wav",
  L"data/se/sinmyoumaru/3456.wav",
  L"data/se/sinmyoumaru/3457.wav",
  L"data/se/sinmyoumaru/3458.wav",
  L"data/se/sinmyoumaru/3459.wav",
  L"data/se/sinmyoumaru/3460.wav",
  L"data/se/sinmyoumaru/3461.wav",
  L"data/se/sinmyoumaru/3462.wav",
  L"data/se/sinmyoumaru/3464.wav",
  L"data/se/sinmyoumaru/3466.wav",
  L"data/se/sinmyoumaru/3470.wav",
  L"data/se/sinmyoumaru/3472.wav",
  L"data/se/sinmyoumaru/3474.wav",
  L"data/se/sinmyoumaru/3475.wav",
  L"data/se/sinmyoumaru/3476.wav",
  L"data/se/sinmyoumaru/3477.wav",
  L"data/se/sinmyoumaru/3479.wav",
  L"data/se/sinmyoumaru/3480.wav",
  L"data/se/sinmyoumaru/3481.wav",
  L"data/se/sinmyoumaru/3482.wav",
  L"data/se/sinmyoumaru/3483.wav",
  L"data/se/sinmyoumaru/3486.wav",
  L"data/se/sinmyoumaru/3487.wav",
  L"data/se/sinmyoumaru/3488.wav",
  L"data/se/sinmyoumaru/3489.wav",
  L"data/se/sinmyoumaru/3490.wav",
  L"data/se/sinmyoumaru.csv",
  L"data/se/system/connect_complete.wav",
  L"data/se/system/sys_cancel.wav",
  L"data/se/system/sys_cancel2.wav",
  L"data/se/system/sys_config_change_value.wav",
  L"data/se/system/sys_cursor.wav",
  L"data/se/system/sys_cursor2.wav",
  L"data/se/system/sys_equip_release.wav",
  L"data/se/system/sys_newspaper_stop.wav",
  L"data/se/system/sys_ok.wav",
  L"data/se/system/sys_ok2.wav",
  L"data/se/system/sys_page.wav",
  L"data/se/system/sys_pause_on.wav",
  L"data/se/system/sys_show_submenu.wav",
  L"data/se/system/sys_trash.wav",
  L"data/se/system/talk_clear_balloon.wav",
  L"data/se/system/talk_press_next.wav",
  L"data/se/usami/3602.wav",
  L"data/se/usami/3606.wav",
  L"data/se/usami/3610.wav",
  L"data/se/usami/3614.wav",
  L"data/se/usami/3618.wav",
  L"data/se/usami/3624.wav",
  L"data/se/usami/3625.wav",
  L"data/se/usami/3627.wav",
  L"data/se/usami/3628.wav",
  L"data/se/usami/3630.wav",
  L"data/se/usami/3631.wav",
  L"data/se/usami/3633.wav",
  L"data/se/usami/3634.wav",
  L"data/se/usami/3635.wav",
  L"data/se/usami/3637.wav",
  L"data/se/usami/3638.wav",
  L"data/se/usami/3640.wav",
  L"data/se/usami/3641.wav",
  L"data/se/usami/3643.wav",
  L"data/se/usami/3645.wav",
  L"data/se/usami/3646.wav",
  L"data/se/usami/3647.wav",
  L"data/se/usami/3649.wav",
  L"data/se/usami/3650.wav",
  L"data/se/usami/3652.wav",
  L"data/se/usami/3653.wav",
  L"data/se/usami/3654.wav",
  L"data/se/usami/3655.wav",
  L"data/se/usami/3656.wav",
  L"data/se/usami/3658.wav",
  L"data/se/usami/3670.wav",
  L"data/se/usami/3672.wav",
  L"data/se/usami/3673.wav",
  L"data/se/usami/3675.wav",
  L"data/se/usami/3676.wav",
  L"data/se/usami/3678.wav",
  L"data/se/usami/3679.wav",
  L"data/se/usami/3680.wav",
  L"data/se/usami/3681.wav",
  L"data/se/usami/3683.wav",
  L"data/se/usami/3685.wav",
  L"data/se/usami/3687.wav",
  L"data/se/usami/3688.wav",
  L"data/se/usami/3689.wav",
  L"data/se/usami/3690.wav",
  L"data/se/usami/3691.wav",
  L"data/se/usami/3692.wav",
  L"data/se/usami/3693.wav",
  L"data/se/usami/3699.wav",
  L"data/se/usami/3700.wav",
  L"data/se/usami/3703.wav",
  L"data/se/usami/3704.wav",
  L"data/se/usami/3705.wav",
  L"data/se/usami/3706.wav",
  L"data/se/usami/3707.wav",
  L"data/se/usami/3708.wav",
  L"data/se/usami/3709.wav",
  L"data/se/usami/3710.wav",
  L"data/se/usami/3711.wav",
  L"data/se/usami.csv",
  L"data/system/BattleStatus/bar_effect_01.png",
  L"data/system/BattleStatus/bar_effect_02.png",
  L"data/system/BattleStatus/bar_effect_03.png",
  L"data/system/BattleStatus/BattleStatus.act",
  L"data/system/BattleStatus/BattleStatus._DEBUG.nut",
  L"data/system/BattleStatus/bg_face1p.png",
  L"data/system/BattleStatus/bg_face2p.png",
  L"data/system/BattleStatus/DrawNumber.nut",
  L"data/system/BattleStatus/frame_card_max_l.png",
  L"data/system/BattleStatus/frame_card_max_r.png",
  L"data/system/BattleStatus/frame_card_on_l.png",
  L"data/system/BattleStatus/frame_card_on_r.png",
  L"data/system/BattleStatus/frame_main_l.png",
  L"data/system/BattleStatus/frame_main_r.png",
  L"data/system/BattleStatus/frame_radar.png",
  L"data/system/BattleStatus/frame_radar_black1.png",
  L"data/system/BattleStatus/frame_radar_black2.png",
  L"data/system/BattleStatus/frame_radar_grid.png",
  L"data/system/BattleStatus/frame_radar_main.png",
  L"data/system/BattleStatus/frame_radar_main2.png",
  L"data/system/BattleStatus/frame_radar_moji.png",
  L"data/system/BattleStatus/frame_radar_nazo.png",
  L"data/system/BattleStatus/frame_spell_l.png",
  L"data/system/BattleStatus/frame_spell_max_l.png",
  L"data/system/BattleStatus/frame_spell_max_r.png",
  L"data/system/BattleStatus/frame_spell_r.png",
  L"data/system/BattleStatus/frame_story1.png",
  L"data/system/BattleStatus/frame_story2.png",
  L"data/system/BattleStatus/frame_story3.png",
  L"data/system/BattleStatus/frame_story4.png",
  L"data/system/BattleStatus/frame_win.png",
  L"data/system/BattleStatus/gauge_life.png",
  L"data/system/BattleStatus/gauge_spell_l.png",
  L"data/system/BattleStatus/gauge_spell_r.png",
  L"data/system/BattleStatus/gauge_spell_shadow_l.png",
  L"data/system/BattleStatus/guard_panel.png",
  L"data/system/BattleStatus/heart.png",
  L"data/system/BattleStatus/hijiri/chant_count.png",
  L"data/system/BattleStatus/hijiri/hijiri.nut",
  L"data/system/BattleStatus/hijiri/miniface_hijiri.png",
  L"data/system/BattleStatus/hijiri/resource.act",
  L"data/system/BattleStatus/hozon_base.dds",
  L"data/system/BattleStatus/hozon_moji.png",
  L"data/system/BattleStatus/huto/dish.png",
  L"data/system/BattleStatus/huto/dish_mini.png",
  L"data/system/BattleStatus/huto/dish_mini_bg.png",
  L"data/system/BattleStatus/huto/futo.nut",
  L"data/system/BattleStatus/huto/huto_sara1.png",
  L"data/system/BattleStatus/huto/huto_sara2.png",
  L"data/system/BattleStatus/huto/huto_sara3.png",
  L"data/system/BattleStatus/huto/huto_sara4.png",
  L"data/system/BattleStatus/huto/huto_sara5.png",
  L"data/system/BattleStatus/huto/miniface_futo.png",
  L"data/system/BattleStatus/huto/resource.act",
  L"data/system/BattleStatus/ichirin/ichirin.nut",
  L"data/system/BattleStatus/ichirin/miniface_ichirin.png",
  L"data/system/BattleStatus/ichirin/resource.act",
  L"data/system/BattleStatus/icon_cpu.bmp",
  L"data/system/BattleStatus/icon_frame.png",
  L"data/system/BattleStatus/kasen/miniface_kasen.png",
  L"data/system/BattleStatus/kasen/resource.act",
  L"data/system/BattleStatus/koishi/koishi.nut",
  L"data/system/BattleStatus/koishi/miniface_koishi.png",
  L"data/system/BattleStatus/koishi/resource.act",
  L"data/system/BattleStatus/kokoro/kokoro.nut",
  L"data/system/BattleStatus/kokoro/miniface_kokoro.png",
  L"data/system/BattleStatus/kokoro/resource.act",
  L"data/system/BattleStatus/kokoro/th145_guage.png",
  L"data/system/BattleStatus/kokoro/th145_ikari.png",
  L"data/system/BattleStatus/kokoro/th145_ki.png",
  L"data/system/BattleStatus/kokoro/th145_mu.png",
  L"data/system/BattleStatus/kokoro/th145_ui.png",
  L"data/system/BattleStatus/mamizou/mamizou.nut",
  L"data/system/BattleStatus/mamizou/mamizou_charge.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf1.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf2.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf3.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf4.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf_bg.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf_black.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf_gray.png",
  L"data/system/BattleStatus/mamizou/mamizou_leaf_red.png",
  L"data/system/BattleStatus/mamizou/miniface_mamizou.png",
  L"data/system/BattleStatus/mamizou/resource.act",
  L"data/system/BattleStatus/marisa/marisa.nut",
  L"data/system/BattleStatus/marisa/miniface_marisa.png",
  L"data/system/BattleStatus/marisa/resource.act",
  L"data/system/BattleStatus/miko/mantle.png",
  L"data/system/BattleStatus/miko/miko.nut",
  L"data/system/BattleStatus/miko/miniface_miko.png",
  L"data/system/BattleStatus/miko/resource.act",
  L"data/system/BattleStatus/moji_charaname.png",
  L"data/system/BattleStatus/moji_hit.png",
  L"data/system/BattleStatus/moji_hit_num.png",
  L"data/system/BattleStatus/moji_hit_state.png",
  L"data/system/BattleStatus/moji_hit_state_blue.png",
  L"data/system/BattleStatus/moji_hit_state_green.png",
  L"data/system/BattleStatus/moji_hit_state_red.png",
  L"data/system/BattleStatus/moji_score.png",
  L"data/system/BattleStatus/moji_score_spell_num_green.png",
  L"data/system/BattleStatus/moji_score_spell_num_white.png",
  L"data/system/BattleStatus/moji_score_spell_num_yellow.png",
  L"data/system/BattleStatus/moji_spell_num_slash.png",
  L"data/system/BattleStatus/moji_spell_power.png",
  L"data/system/BattleStatus/moji_time_num_big.png",
  L"data/system/BattleStatus/moji_time_num_gray.png",
  L"data/system/BattleStatus/moji_time_num_green.png",
  L"data/system/BattleStatus/moji_time_num_purple.png",
  L"data/system/BattleStatus/moji_time_num_red.png",
  L"data/system/BattleStatus/mokou/miniface_mokou.png",
  L"data/system/BattleStatus/mokou/mokou.nut",
  L"data/system/BattleStatus/mokou/resource.act",
  L"data/system/BattleStatus/nitori/miniface_nitori.png",
  L"data/system/BattleStatus/nitori/nessie_gauge.png",
  L"data/system/BattleStatus/nitori/nitori.nut",
  L"data/system/BattleStatus/nitori/resource.act",
  L"data/system/BattleStatus/occult_ball.png",
  L"data/system/BattleStatus/occult_frame.png",
  L"data/system/BattleStatus/reimu/miniface_reimu.png",
  L"data/system/BattleStatus/reimu/reimu.nut",
  L"data/system/BattleStatus/reimu/resource.act",
  L"data/system/BattleStatus/reipower_a1p.png",
  L"data/system/BattleStatus/reipower_a2p.png",
  L"data/system/BattleStatus/reipower_base.png",
  L"data/system/BattleStatus/sinmyoumaru/miniface_sinmyoumaru.png",
  L"data/system/BattleStatus/sinmyoumaru/resource.act",
  L"data/system/BattleStatus/spellcard1m.png",
  L"data/system/BattleStatus/spell_bg.png",
  L"data/system/BattleStatus/spell_gauge.png",
  L"data/system/BattleStatus/spell_time.png",
  L"data/system/BattleStatus/time_mugen.png",
  L"data/system/BattleStatus/usami/miniface_usami.png",
  L"data/system/BattleStatus/usami/resource.act",
  L"data/system/bg/bg.act",
  L"data/system/bg/bg.Debug.nut",
  L"data/system/bg/bg_title2.dds",
  L"data/system/bg/bg_title2.png",
  L"data/system/bg/mist0000.png",
  L"data/system/black_dot.png",
  L"data/system/boot_splash/boot_splash.act",
  L"data/system/boot_splash/boot_splash.png",
  L"data/system/char_select3/0/color/000.png",
  L"data/system/char_select3/0/color/001.png",
  L"data/system/char_select3/0/color/002.png",
  L"data/system/char_select3/0/color/003.png",
  L"data/system/char_select3/0/color/004.png",
  L"data/system/char_select3/0/color/005.png",
  L"data/system/char_select3/0/color/006.png",
  L"data/system/char_select3/0/color/007.png",
  L"data/system/char_select3/0/color/index.dat",
  L"data/system/char_select3/0/equip/a/000.png",
  L"data/system/char_select3/0/equip/a/000.png.csv",
  L"data/system/char_select3/0/equip/a/index.dat",
  L"data/system/char_select3/0/equip/b/000.png",
  L"data/system/char_select3/0/equip/b/000.png.csv",
  L"data/system/char_select3/0/equip/b/index.dat",
  L"data/system/char_select3/0/equip/c/000.png",
  L"data/system/char_select3/0/equip/c/000.png.csv",
  L"data/system/char_select3/0/equip/c/index.dat",
  L"data/system/char_select3/0/sel_illust.dds",
  L"data/system/char_select3/0/sel_illust2.dds",
  L"data/system/char_select3/0/sel_illust2_s.dds",
  L"data/system/char_select3/0/sel_illust_s.dds",
  L"data/system/char_select3/0/skill_list_a.dds",
  L"data/system/char_select3/0/skill_list_b.dds",
  L"data/system/char_select3/0/skill_list_c.dds",
  L"data/system/char_select3/1/color/000.png",
  L"data/system/char_select3/1/color/001.png",
  L"data/system/char_select3/1/color/002.png",
  L"data/system/char_select3/1/color/003.png",
  L"data/system/char_select3/1/color/004.png",
  L"data/system/char_select3/1/color/005.png",
  L"data/system/char_select3/1/color/006.png",
  L"data/system/char_select3/1/color/007.png",
  L"data/system/char_select3/1/color/index.dat",
  L"data/system/char_select3/1/equip/a/000.png",
  L"data/system/char_select3/1/equip/a/000.png.csv",
  L"data/system/char_select3/1/equip/a/index.dat",
  L"data/system/char_select3/1/equip/b/000.png",
  L"data/system/char_select3/1/equip/b/000.png.csv",
  L"data/system/char_select3/1/equip/b/index.dat",
  L"data/system/char_select3/1/equip/c/000.png",
  L"data/system/char_select3/1/equip/c/000.png.csv",
  L"data/system/char_select3/1/equip/c/index.dat",
  L"data/system/char_select3/1/sel_illust.dds",
  L"data/system/char_select3/1/sel_illust2.dds",
  L"data/system/char_select3/1/sel_illust2_s.dds",
  L"data/system/char_select3/1/sel_illust_s.dds",
  L"data/system/char_select3/1/skill_list_a.dds",
  L"data/system/char_select3/1/skill_list_b.dds",
  L"data/system/char_select3/1/skill_list_c.dds",
  L"data/system/char_select3/10/color/000.png",
  L"data/system/char_select3/10/color/001.png",
  L"data/system/char_select3/10/color/002.png",
  L"data/system/char_select3/10/color/003.png",
  L"data/system/char_select3/10/color/004.png",
  L"data/system/char_select3/10/color/005.png",
  L"data/system/char_select3/10/color/006.png",
  L"data/system/char_select3/10/color/007.png",
  L"data/system/char_select3/10/color/index.dat",
  L"data/system/char_select3/10/equip/a/000.png",
  L"data/system/char_select3/10/equip/a/000.png.csv",
  L"data/system/char_select3/10/equip/a/index.dat",
  L"data/system/char_select3/10/equip/b/000.png",
  L"data/system/char_select3/10/equip/b/000.png.csv",
  L"data/system/char_select3/10/equip/b/index.dat",
  L"data/system/char_select3/10/equip/c/000.png",
  L"data/system/char_select3/10/equip/c/000.png.csv",
  L"data/system/char_select3/10/equip/c/index.dat",
  L"data/system/char_select3/10/sel_illust.dds",
  L"data/system/char_select3/10/sel_illust2.dds",
  L"data/system/char_select3/10/sel_illust2_s.dds",
  L"data/system/char_select3/10/sel_illust_s.dds",
  L"data/system/char_select3/10/skill_list_a.dds",
  L"data/system/char_select3/10/skill_list_b.dds",
  L"data/system/char_select3/10/skill_list_c.dds",
  L"data/system/char_select3/11/color/000.png",
  L"data/system/char_select3/11/color/001.png",
  L"data/system/char_select3/11/color/002.png",
  L"data/system/char_select3/11/color/003.png",
  L"data/system/char_select3/11/color/004.png",
  L"data/system/char_select3/11/color/005.png",
  L"data/system/char_select3/11/color/006.png",
  L"data/system/char_select3/11/color/007.png",
  L"data/system/char_select3/11/color/index.dat",
  L"data/system/char_select3/11/equip/a/000.png",
  L"data/system/char_select3/11/equip/a/000.png.csv",
  L"data/system/char_select3/11/equip/a/index.dat",
  L"data/system/char_select3/11/equip/b/000.png",
  L"data/system/char_select3/11/equip/b/000.png.csv",
  L"data/system/char_select3/11/equip/b/index.dat",
  L"data/system/char_select3/11/equip/c/000.png",
  L"data/system/char_select3/11/equip/c/000.png.csv",
  L"data/system/char_select3/11/equip/c/index.dat",
  L"data/system/char_select3/11/sel_illust.dds",
  L"data/system/char_select3/11/sel_illust2.dds",
  L"data/system/char_select3/11/sel_illust2_s.dds",
  L"data/system/char_select3/11/sel_illust_s.dds",
  L"data/system/char_select3/11/skill_list_a.dds",
  L"data/system/char_select3/11/skill_list_b.dds",
  L"data/system/char_select3/11/skill_list_c.dds",
  L"data/system/char_select3/12/color/000.png",
  L"data/system/char_select3/12/color/001.png",
  L"data/system/char_select3/12/color/002.png",
  L"data/system/char_select3/12/color/003.png",
  L"data/system/char_select3/12/color/004.png",
  L"data/system/char_select3/12/color/005.png",
  L"data/system/char_select3/12/color/006.png",
  L"data/system/char_select3/12/color/007.png",
  L"data/system/char_select3/12/color/index.dat",
  L"data/system/char_select3/12/equip/a/000.png",
  L"data/system/char_select3/12/equip/a/000.png.csv",
  L"data/system/char_select3/12/equip/a/index.dat",
  L"data/system/char_select3/12/equip/b/000.png",
  L"data/system/char_select3/12/equip/b/000.png.csv",
  L"data/system/char_select3/12/equip/b/index.dat",
  L"data/system/char_select3/12/equip/c/000.png",
  L"data/system/char_select3/12/equip/c/000.png.csv",
  L"data/system/char_select3/12/equip/c/index.dat",
  L"data/system/char_select3/12/sel_illust.dds",
  L"data/system/char_select3/12/sel_illust2.dds",
  L"data/system/char_select3/12/sel_illust2_s.dds",
  L"data/system/char_select3/12/sel_illust_s.dds",
  L"data/system/char_select3/12/skill_list_a.dds",
  L"data/system/char_select3/12/skill_list_b.dds",
  L"data/system/char_select3/12/skill_list_c.dds",
  L"data/system/char_select3/13/color/000.png",
  L"data/system/char_select3/13/color/001.png",
  L"data/system/char_select3/13/color/002.png",
  L"data/system/char_select3/13/color/003.png",
  L"data/system/char_select3/13/color/004.png",
  L"data/system/char_select3/13/color/005.png",
  L"data/system/char_select3/13/color/006.png",
  L"data/system/char_select3/13/color/007.png",
  L"data/system/char_select3/13/color/index.dat",
  L"data/system/char_select3/13/equip/a/000.png",
  L"data/system/char_select3/13/equip/a/000.png.csv",
  L"data/system/char_select3/13/equip/a/index.dat",
  L"data/system/char_select3/13/equip/b/000.png",
  L"data/system/char_select3/13/equip/b/000.png.csv",
  L"data/system/char_select3/13/equip/b/index.dat",
  L"data/system/char_select3/13/equip/c/000.png",
  L"data/system/char_select3/13/equip/c/000.png.csv",
  L"data/system/char_select3/13/equip/c/index.dat",
  L"data/system/char_select3/13/sel_illust.dds",
  L"data/system/char_select3/13/sel_illust2.dds",
  L"data/system/char_select3/13/sel_illust2_s.dds",
  L"data/system/char_select3/13/sel_illust_s.dds",
  L"data/system/char_select3/13/skill_list_a.dds",
  L"data/system/char_select3/13/skill_list_b.dds",
  L"data/system/char_select3/13/skill_list_c.dds",
  L"data/system/char_select3/2/color/000.png",
  L"data/system/char_select3/2/color/001.png",
  L"data/system/char_select3/2/color/002.png",
  L"data/system/char_select3/2/color/003.png",
  L"data/system/char_select3/2/color/004.png",
  L"data/system/char_select3/2/color/005.png",
  L"data/system/char_select3/2/color/006.png",
  L"data/system/char_select3/2/color/007.png",
  L"data/system/char_select3/2/color/index.dat",
  L"data/system/char_select3/2/equip/a/000.png",
  L"data/system/char_select3/2/equip/a/000.png.csv",
  L"data/system/char_select3/2/equip/a/index.dat",
  L"data/system/char_select3/2/equip/b/000.png",
  L"data/system/char_select3/2/equip/b/000.png.csv",
  L"data/system/char_select3/2/equip/b/index.dat",
  L"data/system/char_select3/2/equip/c/000.png",
  L"data/system/char_select3/2/equip/c/000.png.csv",
  L"data/system/char_select3/2/equip/c/index.dat",
  L"data/system/char_select3/2/sel_illust.dds",
  L"data/system/char_select3/2/sel_illust2.dds",
  L"data/system/char_select3/2/sel_illust2_s.dds",
  L"data/system/char_select3/2/sel_illust_s.dds",
  L"data/system/char_select3/2/skill_list_a.dds",
  L"data/system/char_select3/2/skill_list_b.dds",
  L"data/system/char_select3/2/skill_list_c.dds",
  L"data/system/char_select3/3/color/000.png",
  L"data/system/char_select3/3/color/001.png",
  L"data/system/char_select3/3/color/002.png",
  L"data/system/char_select3/3/color/003.png",
  L"data/system/char_select3/3/color/004.png",
  L"data/system/char_select3/3/color/005.png",
  L"data/system/char_select3/3/color/006.png",
  L"data/system/char_select3/3/color/007.png",
  L"data/system/char_select3/3/color/index.dat",
  L"data/system/char_select3/3/equip/a/000.png",
  L"data/system/char_select3/3/equip/a/000.png.csv",
  L"data/system/char_select3/3/equip/a/index.dat",
  L"data/system/char_select3/3/equip/b/000.png",
  L"data/system/char_select3/3/equip/b/000.png.csv",
  L"data/system/char_select3/3/equip/b/index.dat",
  L"data/system/char_select3/3/equip/c/000.png",
  L"data/system/char_select3/3/equip/c/000.png.csv",
  L"data/system/char_select3/3/equip/c/index.dat",
  L"data/system/char_select3/3/sel_illust.dds",
  L"data/system/char_select3/3/sel_illust2.dds",
  L"data/system/char_select3/3/sel_illust2_s.dds",
  L"data/system/char_select3/3/sel_illust_s.dds",
  L"data/system/char_select3/3/skill_list_a.dds",
  L"data/system/char_select3/3/skill_list_b.dds",
  L"data/system/char_select3/3/skill_list_c.dds",
  L"data/system/char_select3/4/color/000.png",
  L"data/system/char_select3/4/color/001.png",
  L"data/system/char_select3/4/color/002.png",
  L"data/system/char_select3/4/color/003.png",
  L"data/system/char_select3/4/color/004.png",
  L"data/system/char_select3/4/color/005.png",
  L"data/system/char_select3/4/color/006.png",
  L"data/system/char_select3/4/color/007.png",
  L"data/system/char_select3/4/color/index.dat",
  L"data/system/char_select3/4/equip/a/000.png",
  L"data/system/char_select3/4/equip/a/000.png.csv",
  L"data/system/char_select3/4/equip/a/index.dat",
  L"data/system/char_select3/4/equip/b/000.png",
  L"data/system/char_select3/4/equip/b/000.png.csv",
  L"data/system/char_select3/4/equip/b/index.dat",
  L"data/system/char_select3/4/equip/c/000.png",
  L"data/system/char_select3/4/equip/c/000.png.csv",
  L"data/system/char_select3/4/equip/c/index.dat",
  L"data/system/char_select3/4/sel_illust.dds",
  L"data/system/char_select3/4/sel_illust2.dds",
  L"data/system/char_select3/4/sel_illust2_s.dds",
  L"data/system/char_select3/4/sel_illust_s.dds",
  L"data/system/char_select3/4/skill_list_a.dds",
  L"data/system/char_select3/4/skill_list_b.dds",
  L"data/system/char_select3/4/skill_list_c.dds",
  L"data/system/char_select3/5/color/000.png",
  L"data/system/char_select3/5/color/001.png",
  L"data/system/char_select3/5/color/002.png",
  L"data/system/char_select3/5/color/003.png",
  L"data/system/char_select3/5/color/004.png",
  L"data/system/char_select3/5/color/005.png",
  L"data/system/char_select3/5/color/006.png",
  L"data/system/char_select3/5/color/007.png",
  L"data/system/char_select3/5/color/index.dat",
  L"data/system/char_select3/5/equip/a/000.png",
  L"data/system/char_select3/5/equip/a/000.png.csv",
  L"data/system/char_select3/5/equip/a/index.dat",
  L"data/system/char_select3/5/equip/b/000.png",
  L"data/system/char_select3/5/equip/b/000.png.csv",
  L"data/system/char_select3/5/equip/b/index.dat",
  L"data/system/char_select3/5/equip/c/000.png",
  L"data/system/char_select3/5/equip/c/000.png.csv",
  L"data/system/char_select3/5/equip/c/index.dat",
  L"data/system/char_select3/5/sel_illust.dds",
  L"data/system/char_select3/5/sel_illust2.dds",
  L"data/system/char_select3/5/sel_illust2_s.dds",
  L"data/system/char_select3/5/sel_illust_s.dds",
  L"data/system/char_select3/5/skill_list_a.dds",
  L"data/system/char_select3/5/skill_list_b.dds",
  L"data/system/char_select3/5/skill_list_c.dds",
  L"data/system/char_select3/6/color/000.png",
  L"data/system/char_select3/6/color/001.png",
  L"data/system/char_select3/6/color/002.png",
  L"data/system/char_select3/6/color/003.png",
  L"data/system/char_select3/6/color/004.png",
  L"data/system/char_select3/6/color/005.png",
  L"data/system/char_select3/6/color/006.png",
  L"data/system/char_select3/6/color/007.png",
  L"data/system/char_select3/6/color/index.dat",
  L"data/system/char_select3/6/equip/a/000.png",
  L"data/system/char_select3/6/equip/a/000.png.csv",
  L"data/system/char_select3/6/equip/a/index.dat",
  L"data/system/char_select3/6/equip/b/000.png",
  L"data/system/char_select3/6/equip/b/000.png.csv",
  L"data/system/char_select3/6/equip/b/index.dat",
  L"data/system/char_select3/6/equip/c/000.png",
  L"data/system/char_select3/6/equip/c/000.png.csv",
  L"data/system/char_select3/6/equip/c/index.dat",
  L"data/system/char_select3/6/sel_illust.dds",
  L"data/system/char_select3/6/sel_illust2.dds",
  L"data/system/char_select3/6/sel_illust2_s.dds",
  L"data/system/char_select3/6/sel_illust_s.dds",
  L"data/system/char_select3/6/skill_list_a.dds",
  L"data/system/char_select3/6/skill_list_b.dds",
  L"data/system/char_select3/6/skill_list_c.dds",
  L"data/system/char_select3/7/color/000.png",
  L"data/system/char_select3/7/color/001.png",
  L"data/system/char_select3/7/color/002.png",
  L"data/system/char_select3/7/color/003.png",
  L"data/system/char_select3/7/color/004.png",
  L"data/system/char_select3/7/color/005.png",
  L"data/system/char_select3/7/color/006.png",
  L"data/system/char_select3/7/color/007.png",
  L"data/system/char_select3/7/color/index.dat",
  L"data/system/char_select3/7/equip/a/000.png",
  L"data/system/char_select3/7/equip/a/000.png.csv",
  L"data/system/char_select3/7/equip/a/index.dat",
  L"data/system/char_select3/7/equip/b/000.png",
  L"data/system/char_select3/7/equip/b/000.png.csv",
  L"data/system/char_select3/7/equip/b/index.dat",
  L"data/system/char_select3/7/equip/c/000.png",
  L"data/system/char_select3/7/equip/c/000.png.csv",
  L"data/system/char_select3/7/equip/c/index.dat",
  L"data/system/char_select3/7/sel_illust.dds",
  L"data/system/char_select3/7/sel_illust2.dds",
  L"data/system/char_select3/7/sel_illust2_s.dds",
  L"data/system/char_select3/7/sel_illust_s.dds",
  L"data/system/char_select3/7/skill_list_a.dds",
  L"data/system/char_select3/7/skill_list_b.dds",
  L"data/system/char_select3/7/skill_list_c.dds",
  L"data/system/char_select3/8/color/000.png",
  L"data/system/char_select3/8/color/001.png",
  L"data/system/char_select3/8/color/002.png",
  L"data/system/char_select3/8/color/003.png",
  L"data/system/char_select3/8/color/004.png",
  L"data/system/char_select3/8/color/005.png",
  L"data/system/char_select3/8/color/006.png",
  L"data/system/char_select3/8/color/007.png",
  L"data/system/char_select3/8/color/index.dat",
  L"data/system/char_select3/8/equip/a/000.png",
  L"data/system/char_select3/8/equip/a/000.png.csv",
  L"data/system/char_select3/8/equip/a/index.dat",
  L"data/system/char_select3/8/equip/b/000.png",
  L"data/system/char_select3/8/equip/b/000.png.csv",
  L"data/system/char_select3/8/equip/b/index.dat",
  L"data/system/char_select3/8/equip/c/000.png",
  L"data/system/char_select3/8/equip/c/000.png.csv",
  L"data/system/char_select3/8/equip/c/index.dat",
  L"data/system/char_select3/8/sel_illust.dds",
  L"data/system/char_select3/8/sel_illust2.dds",
  L"data/system/char_select3/8/sel_illust2_s.dds",
  L"data/system/char_select3/8/sel_illust_s.dds",
  L"data/system/char_select3/8/skill_list_a.dds",
  L"data/system/char_select3/8/skill_list_b.dds",
  L"data/system/char_select3/8/skill_list_c.dds",
  L"data/system/char_select3/9/color/000.png",
  L"data/system/char_select3/9/color/001.png",
  L"data/system/char_select3/9/color/002.png",
  L"data/system/char_select3/9/color/003.png",
  L"data/system/char_select3/9/color/004.png",
  L"data/system/char_select3/9/color/005.png",
  L"data/system/char_select3/9/color/006.png",
  L"data/system/char_select3/9/color/007.png",
  L"data/system/char_select3/9/color/index.dat",
  L"data/system/char_select3/9/equip/a/000.png",
  L"data/system/char_select3/9/equip/a/000.png.csv",
  L"data/system/char_select3/9/equip/a/index.dat",
  L"data/system/char_select3/9/equip/b/000.png",
  L"data/system/char_select3/9/equip/b/000.png.csv",
  L"data/system/char_select3/9/equip/b/index.dat",
  L"data/system/char_select3/9/equip/c/000.png",
  L"data/system/char_select3/9/equip/c/000.png.csv",
  L"data/system/char_select3/9/equip/c/index.dat",
  L"data/system/char_select3/9/sel_illust.dds",
  L"data/system/char_select3/9/sel_illust2.dds",
  L"data/system/char_select3/9/sel_illust2_s.dds",
  L"data/system/char_select3/9/sel_illust_s.dds",
  L"data/system/char_select3/9/skill_list_a.dds",
  L"data/system/char_select3/9/skill_list_b.dds",
  L"data/system/char_select3/9/skill_list_c.dds",
  L"data/system/char_select3/accept_bg.dds",
  L"data/system/char_select3/accept_bg.png",
  L"data/system/char_select3/arrow_b.png",
  L"data/system/char_select3/arrow_b2.png",
  L"data/system/char_select3/arrow_lr.png",
  L"data/system/char_select3/arrow_u.png",
  L"data/system/char_select3/arrow_u2.png",
  L"data/system/char_select3/bg_base1p.dds",
  L"data/system/char_select3/bg_base1p.png",
  L"data/system/char_select3/bg_base2p.dds",
  L"data/system/char_select3/bg_base2p.png",
  L"data/system/char_select3/bg_gradation.png",
  L"data/system/char_select3/card_reverse.png",
  L"data/system/char_select3/center1.dds",
  L"data/system/char_select3/center1.png",
  L"data/system/char_select3/center2.png",
  L"data/system/char_select3/center_black.png",
  L"data/system/char_select3/center_cell_bk.png",
  L"data/system/char_select3/center_cell_wt.png",
  L"data/system/char_select3/center_tougou_new1.dds",
  L"data/system/char_select3/center_tougou_new2.dds",
  L"data/system/char_select3/char_select3.act",
  L"data/system/char_select3/char_select3.debug.nut",
  L"data/system/char_select3/cs_1p.png",
  L"data/system/char_select3/cs_1p_r.png",
  L"data/system/char_select3/cs_2p.png",
  L"data/system/char_select3/cs_com.png",
  L"data/system/char_select3/cs_xxxselect.png",
  L"data/system/char_select3/cursor_color.png",
  L"data/system/char_select3/cursor_color_num.png",
  L"data/system/char_select3/cursor_ring.png",
  L"data/system/char_select3/cursor_select1p.png",
  L"data/system/char_select3/cursor_select2p.png",
  L"data/system/char_select3/graph_bar_horz.png",
  L"data/system/char_select3/hukidasi1p.png",
  L"data/system/char_select3/hukidasi2p.png",
  L"data/system/char_select3/icon_gamepad.png",
  L"data/system/char_select3/icon_keyboard.png",
  L"data/system/char_select3/moji_namelist1.dds",
  L"data/system/char_select3/moji_namelist1.png",
  L"data/system/char_select3/moji_namelist2a.dds",
  L"data/system/char_select3/moji_namelist2a.png",
  L"data/system/char_select3/moji_namelist2b.dds",
  L"data/system/char_select3/moji_namelist2b.png",
  L"data/system/char_select3/ping_icon.png",
  L"data/system/char_select3/resource.act",
  L"data/system/char_select3/story/cursor_select.png",
  L"data/system/char_select3/story/cursor_select_half.png",
  L"data/system/char_select3/story/moji_storyname.png",
  L"data/system/char_select3/story/moji_storyname_dk.png",
  L"data/system/char_select3/story/summary.txt",
  L"data/system/char_select3/story/summary_stone.png",
  L"data/system/char_select3/story/trophy000.png",
  L"data/system/char_select3/story_select.global.nut",
  L"data/system/char_select3/trial_stage/bg_stage1.png",
  L"data/system/char_select3/trial_stage/bg_stage2.png",
  L"data/system/char_select3/trial_stage/moji_center.png",
  L"data/system/char_select3/trial_stage/moji_name.png",
  L"data/system/char_select3/trial_stage/moji_select.png",
  L"data/system/circle_logo/circle.png",
  L"data/system/circle_logo/CircleLogo.act",
  L"data/system/Component/Capture.act",
  L"data/system/Component/Capture.global.nut",
  L"data/system/Component/common.nut",
  L"data/system/component/def_font_pattern.nut",
  L"data/system/component/enum_file.nut",
  L"data/system/component/fader.act",
  L"data/system/component/fader.global.nut",
  L"data/system/component/network.nut",
  L"data/system/component/selector.nut",
  L"data/system/component/utility.act",
  L"data/system/Component/Utility.global.nut",
  L"data/system/continue_confirm/base.dds",
  L"data/system/continue_confirm/continue_confirm.act",
  L"data/system/continue_confirm/continue_confirm.debug.nut",
  L"data/system/continue_confirm/hozon.png",
  L"data/system/cursor_main.png",
  L"data/system/cursor_main_y.png",
  L"data/system/dummy_dot.png",
  L"data/system/ed2/00.dds",
  L"data/system/ed2/ed.act",
  L"data/system/ed2/ed.debug.nut",
  L"data/system/ed2/roll00.dds",
  L"data/system/ed2/roll01.dds",
  L"data/system/ed2/roll02.dds",
  L"data/system/ed2/roll03.dds",
  L"data/system/ed2/roll04.dds",
  L"data/system/ed2/roll05.dds",
  L"data/system/ed2/roll06.dds",
  L"data/system/ed2/roll07.dds",
  L"data/system/ed2/roll08.dds",
  L"data/system/ed2/roll09.dds",
  L"data/system/ed2/roll10.dds",
  L"data/system/ed2/roll11.dds",
  L"data/system/effect/black_dot.png",
  L"data/system/effect/fire1.act",
  L"data/system/effect/fire1_1.act",
  L"data/system/effect/ikari.png",
  L"data/system/effect/light1.png",
  L"data/system/effect/mask.png",
  L"data/system/effect/mask2.png",
  L"data/system/effect/red_point.png",
  L"data/system/effect/spell_name.act",
  L"data/system/effect/spell_name2.act",
  L"data/system/font/config_moji1.png",
  L"data/system/font/config_moji2.png",
  L"data/system/font/config_pad1.png",
  L"data/system/font/config_pad2.png",
  L"data/system/font/explain_pad_key.png",
  L"data/system/font/hits_damage_num.png",
  L"data/system/font/hits_num_b.png",
  L"data/system/font/hits_num_s.png",
  L"data/system/font/hits_rate_num.png",
  L"data/system/font/hits_stun_num.png",
  L"data/system/font/main_page_space.png",
  L"data/system/font/marisa_satelight.png",
  L"data/system/font/miko_kanzen.png",
  L"data/system/font/num_h30.png",
  L"data/system/font/talk_extra.png",
  L"data/system/font/usami_telekinesis.png",
  L"data/system/icon/icon.act",
  L"data/system/icon/icon.Debug.nut",
  L"data/system/icon_frame.png",
  L"data/system/icon_frame_old.png",
  L"data/system/main_base2.png",
  L"data/system/main_icon.bmp",
  L"data/system/main_icon_taso.png",
  L"data/system/manbow_render/battle.act",
  L"data/system/manbow_render/common.act",
  L"data/system/manbow_render/csv/futo.csv",
  L"data/system/manbow_render/csv/hijiri.csv",
  L"data/system/manbow_render/csv/ichirin.csv",
  L"data/system/manbow_render/csv/koishi.csv",
  L"data/system/manbow_render/csv/kokoro.csv",
  L"data/system/manbow_render/csv/mamizou.csv",
  L"data/system/manbow_render/csv/marisa.csv",
  L"data/system/manbow_render/csv/midashi1.csv",
  L"data/system/manbow_render/csv/midashi2.csv",
  L"data/system/manbow_render/csv/miko.csv",
  L"data/system/manbow_render/csv/nitori.csv",
  L"data/system/manbow_render/csv/reimu.csv",
  L"data/system/manbow_render/csv_vs/futo.csv",
  L"data/system/manbow_render/csv_vs/hijiri.csv",
  L"data/system/manbow_render/csv_vs/ichirin.csv",
  L"data/system/manbow_render/csv_vs/koishi.csv",
  L"data/system/manbow_render/csv_vs/kokoro.csv",
  L"data/system/manbow_render/csv_vs/mamizou.csv",
  L"data/system/manbow_render/csv_vs/marisa.csv",
  L"data/system/manbow_render/csv_vs/miko.csv",
  L"data/system/manbow_render/csv_vs/nitori.csv",
  L"data/system/manbow_render/csv_vs/reimu.csv",
  L"data/system/manbow_render/midashi1/futo_a1.dds",
  L"data/system/manbow_render/midashi1/futo_a2.dds",
  L"data/system/manbow_render/midashi1/futo_a3.dds",
  L"data/system/manbow_render/midashi1/futo_a4.dds",
  L"data/system/manbow_render/midashi1/futo_a5.dds",
  L"data/system/manbow_render/midashi1/futo_b1.dds",
  L"data/system/manbow_render/midashi1/futo_b2.dds",
  L"data/system/manbow_render/midashi1/futo_b3.dds",
  L"data/system/manbow_render/midashi1/futo_b4.dds",
  L"data/system/manbow_render/midashi1/futo_b5.dds",
  L"data/system/manbow_render/midashi1/futo_l1.dds",
  L"data/system/manbow_render/midashi1/futo_l2.dds",
  L"data/system/manbow_render/midashi1/futo_l3.dds",
  L"data/system/manbow_render/midashi1/futo_l4.dds",
  L"data/system/manbow_render/midashi1/futo_l5.dds",
  L"data/system/manbow_render/midashi1/futo_l6.dds",
  L"data/system/manbow_render/midashi1/futo_l7.dds",
  L"data/system/manbow_render/midashi1/futo_w1.dds",
  L"data/system/manbow_render/midashi1/futo_w2.dds",
  L"data/system/manbow_render/midashi1/futo_w3.dds",
  L"data/system/manbow_render/midashi1/futo_w4.dds",
  L"data/system/manbow_render/midashi1/hijiri_a1.dds",
  L"data/system/manbow_render/midashi1/hijiri_a2.dds",
  L"data/system/manbow_render/midashi1/hijiri_a3.dds",
  L"data/system/manbow_render/midashi1/hijiri_a4.dds",
  L"data/system/manbow_render/midashi1/hijiri_a5.dds",
  L"data/system/manbow_render/midashi1/hijiri_b1.dds",
  L"data/system/manbow_render/midashi1/hijiri_b2.dds",
  L"data/system/manbow_render/midashi1/hijiri_b3.dds",
  L"data/system/manbow_render/midashi1/hijiri_b4.dds",
  L"data/system/manbow_render/midashi1/hijiri_b5.dds",
  L"data/system/manbow_render/midashi1/hijiri_l1.dds",
  L"data/system/manbow_render/midashi1/hijiri_l2.dds",
  L"data/system/manbow_render/midashi1/hijiri_l3.dds",
  L"data/system/manbow_render/midashi1/hijiri_l4.dds",
  L"data/system/manbow_render/midashi1/hijiri_l5.dds",
  L"data/system/manbow_render/midashi1/hijiri_l6.dds",
  L"data/system/manbow_render/midashi1/hijiri_l7.dds",
  L"data/system/manbow_render/midashi1/hijiri_w1.dds",
  L"data/system/manbow_render/midashi1/hijiri_w2.dds",
  L"data/system/manbow_render/midashi1/hijiri_w3.dds",
  L"data/system/manbow_render/midashi1/hijiri_w4.dds",
  L"data/system/manbow_render/midashi1/ichirin_a1.dds",
  L"data/system/manbow_render/midashi1/ichirin_a2.dds",
  L"data/system/manbow_render/midashi1/ichirin_a3.dds",
  L"data/system/manbow_render/midashi1/ichirin_a4.dds",
  L"data/system/manbow_render/midashi1/ichirin_a5.dds",
  L"data/system/manbow_render/midashi1/ichirin_b1.dds",
  L"data/system/manbow_render/midashi1/ichirin_b2.dds",
  L"data/system/manbow_render/midashi1/ichirin_b3.dds",
  L"data/system/manbow_render/midashi1/ichirin_b4.dds",
  L"data/system/manbow_render/midashi1/ichirin_b5.dds",
  L"data/system/manbow_render/midashi1/ichirin_l1.dds",
  L"data/system/manbow_render/midashi1/ichirin_l2.dds",
  L"data/system/manbow_render/midashi1/ichirin_l3.dds",
  L"data/system/manbow_render/midashi1/ichirin_l4.dds",
  L"data/system/manbow_render/midashi1/ichirin_l5.dds",
  L"data/system/manbow_render/midashi1/ichirin_l6.dds",
  L"data/system/manbow_render/midashi1/ichirin_l7.dds",
  L"data/system/manbow_render/midashi1/ichirin_w1.dds",
  L"data/system/manbow_render/midashi1/ichirin_w2.dds",
  L"data/system/manbow_render/midashi1/ichirin_w3.dds",
  L"data/system/manbow_render/midashi1/ichirin_w4.dds",
  L"data/system/manbow_render/midashi1/koishi_a1.dds",
  L"data/system/manbow_render/midashi1/koishi_a2.dds",
  L"data/system/manbow_render/midashi1/koishi_a3.dds",
  L"data/system/manbow_render/midashi1/koishi_a4.dds",
  L"data/system/manbow_render/midashi1/koishi_a5.dds",
  L"data/system/manbow_render/midashi1/koishi_b1.dds",
  L"data/system/manbow_render/midashi1/koishi_b2.dds",
  L"data/system/manbow_render/midashi1/koishi_b3.dds",
  L"data/system/manbow_render/midashi1/koishi_b4.dds",
  L"data/system/manbow_render/midashi1/koishi_b5.dds",
  L"data/system/manbow_render/midashi1/koishi_l1.dds",
  L"data/system/manbow_render/midashi1/koishi_l2.dds",
  L"data/system/manbow_render/midashi1/koishi_l3.dds",
  L"data/system/manbow_render/midashi1/koishi_l4.dds",
  L"data/system/manbow_render/midashi1/koishi_l5.dds",
  L"data/system/manbow_render/midashi1/koishi_l6.dds",
  L"data/system/manbow_render/midashi1/koishi_l7.dds",
  L"data/system/manbow_render/midashi1/koishi_w1.dds",
  L"data/system/manbow_render/midashi1/koishi_w2.dds",
  L"data/system/manbow_render/midashi1/koishi_w3.dds",
  L"data/system/manbow_render/midashi1/koishi_w4.dds",
  L"data/system/manbow_render/midashi1/kokoro_a1.dds",
  L"data/system/manbow_render/midashi1/kokoro_a2.dds",
  L"data/system/manbow_render/midashi1/kokoro_a3.dds",
  L"data/system/manbow_render/midashi1/kokoro_a4.dds",
  L"data/system/manbow_render/midashi1/kokoro_a5.dds",
  L"data/system/manbow_render/midashi1/kokoro_b1.dds",
  L"data/system/manbow_render/midashi1/kokoro_b2.dds",
  L"data/system/manbow_render/midashi1/kokoro_b3.dds",
  L"data/system/manbow_render/midashi1/kokoro_b4.dds",
  L"data/system/manbow_render/midashi1/kokoro_b5.dds",
  L"data/system/manbow_render/midashi1/kokoro_l1.dds",
  L"data/system/manbow_render/midashi1/kokoro_l2.dds",
  L"data/system/manbow_render/midashi1/kokoro_l3.dds",
  L"data/system/manbow_render/midashi1/kokoro_l4.dds",
  L"data/system/manbow_render/midashi1/kokoro_l5.dds",
  L"data/system/manbow_render/midashi1/kokoro_l6.dds",
  L"data/system/manbow_render/midashi1/kokoro_w1.dds",
  L"data/system/manbow_render/midashi1/kokoro_w2.dds",
  L"data/system/manbow_render/midashi1/kokoro_w3.dds",
  L"data/system/manbow_render/midashi1/kokoro_w4.dds",
  L"data/system/manbow_render/midashi1/kokoro_w5.dds",
  L"data/system/manbow_render/midashi1/kokoro_w6.dds",
  L"data/system/manbow_render/midashi1/mamizou_a1.dds",
  L"data/system/manbow_render/midashi1/mamizou_a2.dds",
  L"data/system/manbow_render/midashi1/mamizou_a3.dds",
  L"data/system/manbow_render/midashi1/mamizou_a4.dds",
  L"data/system/manbow_render/midashi1/mamizou_a5.dds",
  L"data/system/manbow_render/midashi1/mamizou_b1.dds",
  L"data/system/manbow_render/midashi1/mamizou_b2.dds",
  L"data/system/manbow_render/midashi1/mamizou_b3.dds",
  L"data/system/manbow_render/midashi1/mamizou_b4.dds",
  L"data/system/manbow_render/midashi1/mamizou_b5.dds",
  L"data/system/manbow_render/midashi1/mamizou_l1.dds",
  L"data/system/manbow_render/midashi1/mamizou_l2.dds",
  L"data/system/manbow_render/midashi1/mamizou_l3.dds",
  L"data/system/manbow_render/midashi1/mamizou_l4.dds",
  L"data/system/manbow_render/midashi1/mamizou_l5.dds",
  L"data/system/manbow_render/midashi1/mamizou_l6.dds",
  L"data/system/manbow_render/midashi1/mamizou_w1.dds",
  L"data/system/manbow_render/midashi1/mamizou_w2.dds",
  L"data/system/manbow_render/midashi1/mamizou_w3.dds",
  L"data/system/manbow_render/midashi1/mamizou_w4.dds",
  L"data/system/manbow_render/midashi1/marisa_a1.dds",
  L"data/system/manbow_render/midashi1/marisa_a2.dds",
  L"data/system/manbow_render/midashi1/marisa_a3.dds",
  L"data/system/manbow_render/midashi1/marisa_a4.dds",
  L"data/system/manbow_render/midashi1/marisa_a5.dds",
  L"data/system/manbow_render/midashi1/marisa_b1.dds",
  L"data/system/manbow_render/midashi1/marisa_b2.dds",
  L"data/system/manbow_render/midashi1/marisa_b3.dds",
  L"data/system/manbow_render/midashi1/marisa_b4.dds",
  L"data/system/manbow_render/midashi1/marisa_b5.dds",
  L"data/system/manbow_render/midashi1/marisa_l1.dds",
  L"data/system/manbow_render/midashi1/marisa_l2.dds",
  L"data/system/manbow_render/midashi1/marisa_l3.dds",
  L"data/system/manbow_render/midashi1/marisa_l4.dds",
  L"data/system/manbow_render/midashi1/marisa_l5.dds",
  L"data/system/manbow_render/midashi1/marisa_l6.dds",
  L"data/system/manbow_render/midashi1/marisa_l7.dds",
  L"data/system/manbow_render/midashi1/marisa_w1.dds",
  L"data/system/manbow_render/midashi1/marisa_w2.dds",
  L"data/system/manbow_render/midashi1/marisa_w3.dds",
  L"data/system/manbow_render/midashi1/marisa_w4.dds",
  L"data/system/manbow_render/midashi1/miko_a1.dds",
  L"data/system/manbow_render/midashi1/miko_a2.dds",
  L"data/system/manbow_render/midashi1/miko_a3.dds",
  L"data/system/manbow_render/midashi1/miko_a4.dds",
  L"data/system/manbow_render/midashi1/miko_a5.dds",
  L"data/system/manbow_render/midashi1/miko_b1.dds",
  L"data/system/manbow_render/midashi1/miko_b2.dds",
  L"data/system/manbow_render/midashi1/miko_b3.dds",
  L"data/system/manbow_render/midashi1/miko_b4.dds",
  L"data/system/manbow_render/midashi1/miko_b5.dds",
  L"data/system/manbow_render/midashi1/miko_l1.dds",
  L"data/system/manbow_render/midashi1/miko_l2.dds",
  L"data/system/manbow_render/midashi1/miko_l3.dds",
  L"data/system/manbow_render/midashi1/miko_l4.dds",
  L"data/system/manbow_render/midashi1/miko_l5.dds",
  L"data/system/manbow_render/midashi1/miko_l6.dds",
  L"data/system/manbow_render/midashi1/miko_l7.dds",
  L"data/system/manbow_render/midashi1/miko_w1.dds",
  L"data/system/manbow_render/midashi1/miko_w2.dds",
  L"data/system/manbow_render/midashi1/miko_w3.dds",
  L"data/system/manbow_render/midashi1/miko_w4.dds",
  L"data/system/manbow_render/midashi1/nitori_a1.dds",
  L"data/system/manbow_render/midashi1/nitori_a2.dds",
  L"data/system/manbow_render/midashi1/nitori_a3.dds",
  L"data/system/manbow_render/midashi1/nitori_a4.dds",
  L"data/system/manbow_render/midashi1/nitori_a5.dds",
  L"data/system/manbow_render/midashi1/nitori_b1.dds",
  L"data/system/manbow_render/midashi1/nitori_b2.dds",
  L"data/system/manbow_render/midashi1/nitori_b3.dds",
  L"data/system/manbow_render/midashi1/nitori_b4.dds",
  L"data/system/manbow_render/midashi1/nitori_b5.dds",
  L"data/system/manbow_render/midashi1/nitori_l1.dds",
  L"data/system/manbow_render/midashi1/nitori_l2.dds",
  L"data/system/manbow_render/midashi1/nitori_l3.dds",
  L"data/system/manbow_render/midashi1/nitori_l4.dds",
  L"data/system/manbow_render/midashi1/nitori_l5.dds",
  L"data/system/manbow_render/midashi1/nitori_l6.dds",
  L"data/system/manbow_render/midashi1/nitori_l7.dds",
  L"data/system/manbow_render/midashi1/nitori_w1.dds",
  L"data/system/manbow_render/midashi1/nitori_w2.dds",
  L"data/system/manbow_render/midashi1/nitori_w3.dds",
  L"data/system/manbow_render/midashi1/nitori_w4.dds",
  L"data/system/manbow_render/midashi1/reimu_a1.dds",
  L"data/system/manbow_render/midashi1/reimu_a2.dds",
  L"data/system/manbow_render/midashi1/reimu_a3.dds",
  L"data/system/manbow_render/midashi1/reimu_a4.dds",
  L"data/system/manbow_render/midashi1/reimu_a5.dds",
  L"data/system/manbow_render/midashi1/reimu_b1.dds",
  L"data/system/manbow_render/midashi1/reimu_b2.dds",
  L"data/system/manbow_render/midashi1/reimu_b3.dds",
  L"data/system/manbow_render/midashi1/reimu_b4.dds",
  L"data/system/manbow_render/midashi1/reimu_b5.dds",
  L"data/system/manbow_render/midashi1/reimu_l1.dds",
  L"data/system/manbow_render/midashi1/reimu_l2.dds",
  L"data/system/manbow_render/midashi1/reimu_l3.dds",
  L"data/system/manbow_render/midashi1/reimu_l4.dds",
  L"data/system/manbow_render/midashi1/reimu_l5.dds",
  L"data/system/manbow_render/midashi1/reimu_l6.dds",
  L"data/system/manbow_render/midashi1/reimu_l7.dds",
  L"data/system/manbow_render/midashi1/reimu_w1.dds",
  L"data/system/manbow_render/midashi1/reimu_w2.dds",
  L"data/system/manbow_render/midashi1/reimu_w3.dds",
  L"data/system/manbow_render/midashi1/reimu_w4.dds",
  L"data/system/manbow_render/midashi2/common_1.dds",
  L"data/system/manbow_render/midashi2/common_2.dds",
  L"data/system/manbow_render/midashi2/common_3.dds",
  L"data/system/manbow_render/midashi2/futo_1.dds",
  L"data/system/manbow_render/midashi2/futo_2.dds",
  L"data/system/manbow_render/midashi2/futo_3.dds",
  L"data/system/manbow_render/midashi2/futo_4.dds",
  L"data/system/manbow_render/midashi2/futo_5.dds",
  L"data/system/manbow_render/midashi2/futo_7.dds",
  L"data/system/manbow_render/midashi2/hijiri_1.dds",
  L"data/system/manbow_render/midashi2/hijiri_2.dds",
  L"data/system/manbow_render/midashi2/hijiri_3.dds",
  L"data/system/manbow_render/midashi2/hijiri_4.dds",
  L"data/system/manbow_render/midashi2/hijiri_6.dds",
  L"data/system/manbow_render/midashi2/hijiri_7.dds",
  L"data/system/manbow_render/midashi2/ichirin_1.dds",
  L"data/system/manbow_render/midashi2/ichirin_2.dds",
  L"data/system/manbow_render/midashi2/ichirin_3.dds",
  L"data/system/manbow_render/midashi2/ichirin_4.dds",
  L"data/system/manbow_render/midashi2/ichirin_6.dds",
  L"data/system/manbow_render/midashi2/ichirin_7.dds",
  L"data/system/manbow_render/midashi2/koishi_1.dds",
  L"data/system/manbow_render/midashi2/koishi_2.dds",
  L"data/system/manbow_render/midashi2/koishi_5.dds",
  L"data/system/manbow_render/midashi2/koishi_6.dds",
  L"data/system/manbow_render/midashi2/koishi_7.dds",
  L"data/system/manbow_render/midashi2/kokoro_1.dds",
  L"data/system/manbow_render/midashi2/kokoro_2.dds",
  L"data/system/manbow_render/midashi2/kokoro_3.dds",
  L"data/system/manbow_render/midashi2/kokoro_4.dds",
  L"data/system/manbow_render/midashi2/kokoro_5.dds",
  L"data/system/manbow_render/midashi2/kokoro_6.dds",
  L"data/system/manbow_render/midashi2/kokoro_7.dds",
  L"data/system/manbow_render/midashi2/mamizou_1.dds",
  L"data/system/manbow_render/midashi2/mamizou_2.dds",
  L"data/system/manbow_render/midashi2/mamizou_3.dds",
  L"data/system/manbow_render/midashi2/mamizou_4.dds",
  L"data/system/manbow_render/midashi2/marisa_1.dds",
  L"data/system/manbow_render/midashi2/marisa_2.dds",
  L"data/system/manbow_render/midashi2/marisa_3.dds",
  L"data/system/manbow_render/midashi2/marisa_4.dds",
  L"data/system/manbow_render/midashi2/marisa_5.dds",
  L"data/system/manbow_render/midashi2/marisa_6.dds",
  L"data/system/manbow_render/midashi2/marisa_7.dds",
  L"data/system/manbow_render/midashi2/miko_1.dds",
  L"data/system/manbow_render/midashi2/miko_2.dds",
  L"data/system/manbow_render/midashi2/miko_3.dds",
  L"data/system/manbow_render/midashi2/miko_4.dds",
  L"data/system/manbow_render/midashi2/miko_5.dds",
  L"data/system/manbow_render/midashi2/miko_7.dds",
  L"data/system/manbow_render/midashi2/nitori_1.dds",
  L"data/system/manbow_render/midashi2/nitori_2.dds",
  L"data/system/manbow_render/midashi2/nitori_3.dds",
  L"data/system/manbow_render/midashi2/nitori_4.dds",
  L"data/system/manbow_render/midashi2/reimu_1.dds",
  L"data/system/manbow_render/midashi2/reimu_2.dds",
  L"data/system/manbow_render/midashi2/reimu_3.dds",
  L"data/system/manbow_render/midashi2/reimu_4.dds",
  L"data/system/manbow_render/midashi2/reimu_5.dds",
  L"data/system/manbow_render/midashi2/reimu_6.dds",
  L"data/system/manbow_render/news.dds",
  L"data/system/manbow_render/news_md_num.png",
  L"data/system/manbow_render/news_midashi1.png",
  L"data/system/manbow_render/news_midashi2.png",
  L"data/system/manbow_render/news_midashi3.png",
  L"data/system/manbow_render/news_name.png",
  L"data/system/manbow_render/news_topday.png",
  L"data/system/manbow_render/news_vs.png",
  L"data/system/manbow_render/news_year_num.png",
  L"data/system/manbow_render/news_youbi.png",
  L"data/system/menu_frame/cursor/rei_blue.png",
  L"data/system/menu_frame/cursor/rei_red.png",
  L"data/system/menu_frame/dummy_dot.png",
  L"data/system/menu_frame/frame/shadow.png",
  L"data/system/menu_frame/frame/shadow_h.png",
  L"data/system/menu_frame/frame/window_back.png",
  L"data/system/menu_frame/menu_bg.act",
  L"data/system/menu_frame/menu_frame.act",
  L"data/system/menu_frame/moji_page2.png",
  L"data/system/menu_frame/moji_page_menu.png",
  L"data/system/menu_frame/moji_side.png",
  L"data/system/menu_frame/moji_side_practice.png",
  L"data/system/menu_frame/wallpaper/wallpaper_01.dds",
  L"data/system/menu_frame/wallpaper/wallpaper_02.dds",
  L"data/system/menu_frame/window/base_popup_3line.dds",
  L"data/system/menu_frame/window/bg_stone1.png",
  L"data/system/music_room/bg.dds",
  L"data/system/music_room/bg_bar.png",
  L"data/system/music_room/music_room.act",
  L"data/system/music_room/music_room.debug.nut",
  L"data/system/music_room/name_default.png",
  L"data/system/music_room/name_secret.png",
  L"data/system/music_room/page_dot.png",
  L"data/system/network_vs/explain/001_input_text.png",
  L"data/system/network_vs/explain/002_wait_for_connection.png",
  L"data/system/network_vs/explain/003_select_network_history.png",
  L"data/system/network_vs/explain/004_select_profile.png",
  L"data/system/network_vs/explain/005_top_menu.png",
  L"data/system/network_vs/name_white.png",
  L"data/system/network_vs/network_vs.act",
  L"data/system/network_vs/network_vs.Debug.nut",
  L"data/system/network_vs/network_waiting.act",
  L"data/system/nowloading.png",
  L"data/system/op_th145/cut1.png",
  L"data/system/op_th145/cut2.png",
  L"data/system/op_th145/cut3.png",
  L"data/system/op_th145/op_th145.act",
  L"data/system/page_dot.png",
  L"data/system/page_dot_edge.png",
  L"data/system/page_dot_stone.png",
  L"data/system/page_dot_stone_dk.png",
  L"data/system/pause/bg.dds",
  L"data/system/pause/pause.act",
  L"data/system/pause/pause.debug.nut",
  L"data/system/practice/bg.dds",
  L"data/system/practice/font_cant_change.png",
  L"data/system/practice/font_nothing_to_do.png",
  L"data/system/practice/font_num32x24.png",
  L"data/system/practice/main_right_practice.png",
  L"data/system/practice/marisa_base1b.png",
  L"data/system/practice/on_draw.nut",
  L"data/system/practice/practice.act",
  L"data/system/practice/practice_bg.dds",
  L"data/system/practice/practice_explain.png",
  L"data/system/practice/practice_life1.png",
  L"data/system/practice/practice_life2.png",
  L"data/system/practice/practice_menu1.png",
  L"data/system/practice/practice_menu2.png",
  L"data/system/practice/practice_menu3.png",
  L"data/system/practice/practice_ninki.png",
  L"data/system/practice/practice_rei1.png",
  L"data/system/practice/practice_rei2.png",
  L"data/system/practice/practice_square1.png",
  L"data/system/practice/practice_square2.png",
  L"data/system/practice/reimu_base2.png",
  L"data/system/profile/bg_stone1.png",
  L"data/system/profile/bg_stone2.png",
  L"data/system/profile/bg_stone3.png",
  L"data/system/profile/equip/chart_line.png",
  L"data/system/profile/equip/chart_moji.png",
  L"data/system/profile/equip/chart_texture.png",
  L"data/system/profile/equip/chart_texture2.png",
  L"data/system/profile/equip/item_big.png",
  L"data/system/profile/equip/item_m.png",
  L"data/system/profile/equip/item_m_light.png",
  L"data/system/profile/equip/item_m_mask.png",
  L"data/system/profile/equip/kidoairaku.png",
  L"data/system/profile/equip/over_arrow.png",
  L"data/system/profile/equip/over_moji.png",
  L"data/system/profile/equip/set_select.png",
  L"data/system/profile/equip/soubi_hai-iie.dds",
  L"data/system/profile/equip/soubi_moji1.png",
  L"data/system/profile/equip/soubi_moji2.png",
  L"data/system/profile/equip/under_base.png",
  L"data/system/profile/icon_frame2.png",
  L"data/system/profile/icon_moji2.png",
  L"data/system/profile/keyconfig/moji_keyconfig_menu1.png",
  L"data/system/profile/keyconfig/moji_keyconfig_menu2.png",
  L"data/system/profile/keyconfig/moji_keyconfig_menu3.png",
  L"data/system/profile/main_icon.png",
  L"data/system/profile/moji_yoteiwindow.png",
  L"data/system/profile/profile.act",
  L"data/system/profile/profile.Debug.nut",
  L"data/system/profile/submenu/submenu.dds",
  L"data/system/profile/submenu/submenu2.dds",
  L"data/system/profile/submenu/submenu3.dds",
  L"data/system/profile_select/bg.dds",
  L"data/system/profile_select/profile_select.act",
  L"data/system/profile_select/profile_select.debug.nut",
  L"data/system/replay_confirm/base.dds",
  L"data/system/replay_confirm/hozon.dds",
  L"data/system/replay_confirm/replay_confirm.act",
  L"data/system/replay_confirm/replay_confirm.debug.nut",
  L"data/system/replay_select/base.dds",
  L"data/system/replay_select/base_pooup_2line.dds",
  L"data/system/replay_select/replay_select.act",
  L"data/system/replay_select/replay_select.debug.nut",
  L"data/system/stage_select/arrow_b.png",
  L"data/system/stage_select/arrow_b2.png",
  L"data/system/stage_select/arrow_u.png",
  L"data/system/stage_select/arrow_u2.png",
  L"data/system/stage_select/banner/banner01.dds",
  L"data/system/stage_select/banner/banner02.dds",
  L"data/system/stage_select/banner/banner03.dds",
  L"data/system/stage_select/banner/banner04.dds",
  L"data/system/stage_select/banner/banner05.dds",
  L"data/system/stage_select/banner/banner06.dds",
  L"data/system/stage_select/banner/banner07.dds",
  L"data/system/stage_select/banner/banner08.dds",
  L"data/system/stage_select/banner/banner09.dds",
  L"data/system/stage_select/banner/banner10.dds",
  L"data/system/stage_select/banner/banner11.dds",
  L"data/system/stage_select/banner/banner12.dds",
  L"data/system/stage_select/banner/banner15.dds",
  L"data/system/stage_select/banner/banner16.dds",
  L"data/system/stage_select/banner/banner17.dds",
  L"data/system/stage_select/banner/banner19.dds",
  L"data/system/stage_select/banner/banner20.dds",
  L"data/system/stage_select/banner/banner21.dds",
  L"data/system/stage_select/banner/banner22.dds",
  L"data/system/stage_select/banner/banner23.dds",
  L"data/system/stage_select/banner/banner24.dds",
  L"data/system/stage_select/banner/banner25.dds",
  L"data/system/stage_select/banner/banner26.dds",
  L"data/system/stage_select/banner/banner27.dds",
  L"data/system/stage_select/banner/banner28.dds",
  L"data/system/stage_select/banner_random.png",
  L"data/system/stage_select/cursor_select2.png",
  L"data/system/stage_select/minibgwhite.png",
  L"data/system/stage_select/moji_bgmname1.dds",
  L"data/system/stage_select/moji_bgmname2.dds",
  L"data/system/stage_select/moji_bgmname_story1.dds",
  L"data/system/stage_select/moji_bgmname_story2.dds",
  L"data/system/stage_select/moji_stagename1.dds",
  L"data/system/stage_select/moji_stagename2.dds",
  L"data/system/stage_select/stage_select.act",
  L"data/system/stage_select/stage_select.debug.nut",
  L"data/system/sys_config/gauge_volume1.png",
  L"data/system/sys_config/gauge_volume2.png",
  L"data/system/sys_config/moji_menu1.png",
  L"data/system/sys_config/moji_menu2.png",
  L"data/system/sys_config/moji_menu3.png",
  L"data/system/sys_config/sys_config.act",
  L"data/system/sys_config/sys_config.debug.nut",
  L"data/system/talk/balloon.act",
  L"data/system/talk/black_dot.png",
  L"data/system/talk/blank_dot.png",
  L"data/system/talk/talk.act",
  L"data/system/talk/talk.debug.nut",
  L"data/system/talk/white_dot.png",
  L"data/system/text_input_base.png",
  L"data/system/title/bgchar/001.dds",
  L"data/system/title/bgchar/index.dat",
  L"data/system/title/copyright.png",
  L"data/system/title/logo1.dds",
  L"data/system/title/logo1.png",
  L"data/system/title/logo1_edge.dds",
  L"data/system/title/logo1_edge.png",
  L"data/system/title/logo2.png",
  L"data/system/title/moji_menu.png",
  L"data/system/title/moji_menu2.png",
  L"data/system/title/moji_menu2_dk.png",
  L"data/system/title/moji_menu_dk.png",
  L"data/system/title/moji_taikenban.png",
  L"data/system/title/Title.act",
  L"data/system/title/Title.Debug.nut",
  L"data/system/white_dot.png",
  L"data/win/message/futo.csv",
  L"data/win/message/hijiri.csv",
  L"data/win/message/ichirin.csv",
  L"data/win/message/kasen.csv",
  L"data/win/message/koishi.csv",
  L"data/win/message/kokoro.csv",
  L"data/win/message/mamizou.csv",
  L"data/win/message/marisa.csv",
  L"data/win/message/miko.csv",
  L"data/win/message/mokou.csv",
  L"data/win/message/nitori.csv",
  L"data/win/message/reimu.csv",
  L"data/win/message/sinmyoumaru.csv",
  L"data/win/message/usami.csv",
  L"data/win/rate/futo.csv",
  L"data/win/rate/hijiri.csv",
  L"data/win/rate/ichirin.csv",
  L"data/win/rate/kasen.csv",
  L"data/win/rate/koishi.csv",
  L"data/win/rate/kokoro.csv",
  L"data/win/rate/mamizou.csv",
  L"data/win/rate/marisa.csv",
  L"data/win/rate/miko.csv",
  L"data/win/rate/mokou.csv",
  L"data/win/rate/nitori.csv",
  L"data/win/rate/reimu.csv",
  L"data/win/rate/sinmyoumaru.csv",
  L"data/win/rate/usami.csv",

  // pb`zz
  L"data/actor/hanako/texture/occult_spark.png",
  L"data/actor/hanako/texture/skillF_Object0001.dds",
  L"data/actor/hanako/winA0000.bmp",
  L"data/actor/hanako/winA0001.bmp",
  L"data/actor/hanako/winA0002.bmp",
  L"data/actor/story/reimu/tips0002b.png",
  L"data/actor/story/reimu/tips0003b.png",
  L"data/script/version.nut",

   // 1.31b
   L"data/system/title/update_stone.png",

  // Web̌
  L"data/system/title/moji_menu_taikenban.png",
};

} // TH145

} // TouhouSE
