#include "stdafx.h"

namespace TouhouSE {

namespace TH155 {

const TH145Pak::FilenameArray FILE_NAME_LIST = {
   // th155.pak
   L"data/actor/common/common.pat",
   L"data/actor/common_texture/aura_loop_mono0000.png",
   L"data/actor/common_texture/ball_0000.png",
   L"data/actor/common_texture/ball_0001.png",
   L"data/actor/common_texture/baria.png",
   L"data/actor/common_texture/box_mono0000.png",
   L"data/actor/common_texture/callcard0000.png",
   L"data/actor/common_texture/callcard0001.png",
   L"data/actor/common_texture/callcard0002.png",
   L"data/actor/common_texture/callcard0003.png",
   L"data/actor/common_texture/callcard0004.png",
   L"data/actor/common_texture/callcard0005.png",
   L"data/actor/common_texture/callcard0006.png",
   L"data/actor/common_texture/callcard0007.png",
   L"data/actor/common_texture/callcard0008.png",
   L"data/actor/common_texture/callcard0009.png",
   L"data/actor/common_texture/chargeA.png",
   L"data/actor/common_texture/chargeB.png",
   L"data/actor/common_texture/chargeLine.png",
   L"data/actor/common_texture/chargeO.png",
   L"data/actor/common_texture/chargeParticle0000.png",
   L"data/actor/common_texture/circle0000.png",
   L"data/actor/common_texture/circle0001.png",
   L"data/actor/common_texture/common_shot.png",
   L"data/actor/common_texture/crimax000.png",
   L"data/actor/common_texture/crimaxRing.png",
   L"data/actor/common_texture/debuff_icon.png",
   L"data/actor/common_texture/fade_ball_0000.png",
   L"data/actor/common_texture/fade_ring_0000.png",
   L"data/actor/common_texture/fire_particle_mono0000.png",
   L"data/actor/common_texture/flashEffectA.png",
   L"data/actor/common_texture/guardA0000.png",
   L"data/actor/common_texture/guardB0000.png",
   L"data/actor/common_texture/guardringA.png",
   L"data/actor/common_texture/hitA0000.png",
   L"data/actor/common_texture/hyoui_trail.png",
   L"data/actor/common_texture/item_h.png",
   L"data/actor/common_texture/lightbar.png",
   L"data/actor/common_texture/lightning_mono0000.png",
   L"data/actor/common_texture/line_wave_mono0000.png",
   L"data/actor/common_texture/loopTexA.png",
   L"data/actor/common_texture/loopTexB.png",
   L"data/actor/common_texture/mask_fade_ball.png",
   L"data/actor/common_texture/occultAura0000.png",
   L"data/actor/common_texture/occultAuraA0000.png",
   L"data/actor/common_texture/occult_object000.png",
   L"data/actor/common_texture/occult_trail0000.png",
   L"data/actor/common_texture/smoke.png",
   L"data/actor/common_texture/spark.png",
   L"data/actor/common_texture/speedLine0000.png",
   L"data/actor/common_texture/spellBaria0000.png",
   L"data/actor/common_texture/spellBariaB0000.png",
   L"data/actor/common_texture/spellBariaB0001.png",
   L"data/actor/common_texture/spellBariaB0002.png",
   L"data/actor/common_texture/spellBariaB0003.png",
   L"data/actor/common_texture/spellBariaR0000.png",
   L"data/actor/common_texture/spellBariaR0001.png",
   L"data/actor/common_texture/spellBariaR0002.png",
   L"data/actor/common_texture/spellBariaR0003.png",
   L"data/actor/common_texture/spellcallback0000.png",
   L"data/actor/common_texture/spellcallback0001.png",
   L"data/actor/common_texture/spellChargeA0000.png",
   L"data/actor/common_texture/spellRing0000.png",
   L"data/actor/common_texture/spellRing0001.png",
   L"data/actor/common_texture/spell_back_1P.png",
   L"data/actor/common_texture/spell_back_2p.png",
   L"data/actor/common_texture/spell_back_lw.png",
   L"data/actor/common_texture/spell_call_edge0000.png",
   L"data/actor/common_texture/spell_call_mask.png",
   L"data/actor/common_texture/swing0000.png",
   L"data/actor/common_texture/swing0001.png",
   L"data/actor/common_texture/trail_common.png",
   L"data/actor/common_texture/vortex0000.png",
   L"data/actor/common_texture/vortex0001.png",
   L"data/actor/common_texture/whiteBack.png",
   L"data/actor/common_texture/win1P.png",
   L"data/actor/common_texture/win2P.png",
   L"data/actor/com_common_action.nut",
   L"data/actor/com_stack_action.nut",
   L"data/actor/doremy/animal0000.png",
   L"data/actor/doremy/animal0001.png",
   L"data/actor/doremy/animal0002.png",
   L"data/actor/doremy/animal0003.png",
   L"data/actor/doremy/animal0004.png",
   L"data/actor/doremy/animal0005.png",
   L"data/actor/doremy/animal0006.png",
   L"data/actor/doremy/animal0007.png",
   L"data/actor/doremy/animal0008.png",
   L"data/actor/doremy/animal0009.png",
   L"data/actor/doremy/animal_damage0000.png",
   L"data/actor/doremy/animal_damage0001.png",
   L"data/actor/doremy/animal_damage0002.png",
   L"data/actor/doremy/animal_damage0003.png",
   L"data/actor/doremy/animal_damage0004.png",
   L"data/actor/doremy/atk_air0000.bmp",
   L"data/actor/doremy/atk_air0001.bmp",
   L"data/actor/doremy/atk_air0002.bmp",
   L"data/actor/doremy/atk_air0003.bmp",
   L"data/actor/doremy/atk_air0004.bmp",
   L"data/actor/doremy/atk_air0005.bmp",
   L"data/actor/doremy/atk_air0006.bmp",
   L"data/actor/doremy/atk_front0000.bmp",
   L"data/actor/doremy/atk_front0001.bmp",
   L"data/actor/doremy/atk_front0002.bmp",
   L"data/actor/doremy/atk_front0003.bmp",
   L"data/actor/doremy/atk_front0004.bmp",
   L"data/actor/doremy/atk_front0005.bmp",
   L"data/actor/doremy/atk_front0006.bmp",
   L"data/actor/doremy/atk_front0007.bmp",
   L"data/actor/doremy/atk_front0008.bmp",
   L"data/actor/doremy/atk_low0000.bmp",
   L"data/actor/doremy/atk_low0001.bmp",
   L"data/actor/doremy/atk_low0002.bmp",
   L"data/actor/doremy/atk_low0003.bmp",
   L"data/actor/doremy/atk_low0004.bmp",
   L"data/actor/doremy/atk_low0005.bmp",
   L"data/actor/doremy/atk_low0006.bmp",
   L"data/actor/doremy/atk_mid0000.bmp",
   L"data/actor/doremy/atk_mid0001.bmp",
   L"data/actor/doremy/atk_mid0002.bmp",
   L"data/actor/doremy/atk_mid0003.bmp",
   L"data/actor/doremy/atk_mid0004.bmp",
   L"data/actor/doremy/atk_mid0005.bmp",
   L"data/actor/doremy/atk_mid0006.bmp",
   L"data/actor/doremy/atk_mid0007.bmp",
   L"data/actor/doremy/atk_upper0000.bmp",
   L"data/actor/doremy/atk_upper0001.bmp",
   L"data/actor/doremy/atk_upper0002.bmp",
   L"data/actor/doremy/atk_upper0003.bmp",
   L"data/actor/doremy/atk_upper0004.bmp",
   L"data/actor/doremy/atk_upper0005.bmp",
   L"data/actor/doremy/atk_upper0006.bmp",
   L"data/actor/doremy/atk_upper0007.bmp",
   L"data/actor/doremy/atk_upper0008.bmp",
   L"data/actor/doremy/atk_upper0009.bmp",
   L"data/actor/doremy/atk_upper0010.bmp",
   L"data/actor/doremy/atk_upper0011.bmp",
   L"data/actor/doremy/atk_upper0012.bmp",
   L"data/actor/doremy/atk_upper0013.bmp",
   L"data/actor/doremy/atk_upper0014.bmp",
   L"data/actor/doremy/ball_atk_under0000.bmp",
   L"data/actor/doremy/ball_atk_under0001.bmp",
   L"data/actor/doremy/ball_atk_under0002.bmp",
   L"data/actor/doremy/ball_atk_underB0000.bmp",
   L"data/actor/doremy/ball_atk_underB0001.bmp",
   L"data/actor/doremy/ball_atk_underB0002.bmp",
   L"data/actor/doremy/battle_begin_A0000.bmp",
   L"data/actor/doremy/battle_begin_A0001.bmp",
   L"data/actor/doremy/battle_begin_A0002.bmp",
   L"data/actor/doremy/battle_begin_A0003.bmp",
   L"data/actor/doremy/battle_begin_A0004.bmp",
   L"data/actor/doremy/battle_begin_A0005.bmp",
   L"data/actor/doremy/battle_begin_A0006.bmp",
   L"data/actor/doremy/battle_begin_A0007.bmp",
   L"data/actor/doremy/battle_begin_A0008.bmp",
   L"data/actor/doremy/battle_begin_A0009.bmp",
   L"data/actor/doremy/battle_begin_A0010.bmp",
   L"data/actor/doremy/battle_begin_A0011.bmp",
   L"data/actor/doremy/battle_begin_A0012.bmp",
   L"data/actor/doremy/battle_begin_A0013.bmp",
   L"data/actor/doremy/battle_begin_A0014.bmp",
   L"data/actor/doremy/battle_begin_A0015.bmp",
   L"data/actor/doremy/battle_begin_A0016.bmp",
   L"data/actor/doremy/battle_begin_A0017.bmp",
   L"data/actor/doremy/battle_begin_A0018.bmp",
   L"data/actor/doremy/battle_begin_B0000.bmp",
   L"data/actor/doremy/battle_begin_B0001.bmp",
   L"data/actor/doremy/battle_begin_B0002.bmp",
   L"data/actor/doremy/battle_begin_B0003.bmp",
   L"data/actor/doremy/battle_begin_B0004.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0000.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0001.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0002.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0003.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0004.bmp",
   L"data/actor/doremy/battle_begin_team_udonge0005.bmp",
   L"data/actor/doremy/damage_body0000.bmp",
   L"data/actor/doremy/damage_body0001.bmp",
   L"data/actor/doremy/damage_body0002.bmp",
   L"data/actor/doremy/damage_body0003.bmp",
   L"data/actor/doremy/damage_down0000.bmp",
   L"data/actor/doremy/damage_down0001.bmp",
   L"data/actor/doremy/damage_down0002.bmp",
   L"data/actor/doremy/damage_down0003.bmp",
   L"data/actor/doremy/damage_down0004.bmp",
   L"data/actor/doremy/damage_down0005.bmp",
   L"data/actor/doremy/damage_down0006.bmp",
   L"data/actor/doremy/damage_down0007.bmp",
   L"data/actor/doremy/damage_down0008.bmp",
   L"data/actor/doremy/damage_down0009.bmp",
   L"data/actor/doremy/damage_down_loop0000.bmp",
   L"data/actor/doremy/damage_down_loop0001.bmp",
   L"data/actor/doremy/damage_down_loop0002.bmp",
   L"data/actor/doremy/damage_down_loop0003.bmp",
   L"data/actor/doremy/damage_down_loop0004.bmp",
   L"data/actor/doremy/damage_head0000.bmp",
   L"data/actor/doremy/damage_head0001.bmp",
   L"data/actor/doremy/damage_head0002.bmp",
   L"data/actor/doremy/damage_head0003.bmp",
   L"data/actor/doremy/damage_spin0000.bmp",
   L"data/actor/doremy/damage_spin0001.bmp",
   L"data/actor/doremy/damage_spin0002.bmp",
   L"data/actor/doremy/damage_spin0003.bmp",
   L"data/actor/doremy/damage_stun0000.bmp",
   L"data/actor/doremy/damage_stun0001.bmp",
   L"data/actor/doremy/damage_stun0002.bmp",
   L"data/actor/doremy/damage_stun0003.bmp",
   L"data/actor/doremy/damage_stun0004.bmp",
   L"data/actor/doremy/damage_stun0005.bmp",
   L"data/actor/doremy/damage_stun0006.bmp",
   L"data/actor/doremy/damage_stunB0000.bmp",
   L"data/actor/doremy/damage_stunB0001.bmp",
   L"data/actor/doremy/damage_stunB0002.bmp",
   L"data/actor/doremy/damage_stunB0003.bmp",
   L"data/actor/doremy/damage_stunB_loop0000.bmp",
   L"data/actor/doremy/damage_stunB_loop0001.bmp",
   L"data/actor/doremy/damage_stunB_loop0002.bmp",
   L"data/actor/doremy/damage_stunB_loop0003.bmp",
   L"data/actor/doremy/damage_stunB_loop0004.bmp",
   L"data/actor/doremy/damage_wall0000.bmp",
   L"data/actor/doremy/damage_wall0001.bmp",
   L"data/actor/doremy/damage_wall0002.bmp",
   L"data/actor/doremy/damage_wall0003.bmp",
   L"data/actor/doremy/damage_wall0004.bmp",
   L"data/actor/doremy/damage_wall0005.bmp",
   L"data/actor/doremy/doremy.pat",
   L"data/actor/doremy/doremy_ed.pat",
   L"data/actor/doremy/grab0000.bmp",
   L"data/actor/doremy/grab0001.bmp",
   L"data/actor/doremy/grab0002.bmp",
   L"data/actor/doremy/grab0003.bmp",
   L"data/actor/doremy/grab0004.bmp",
   L"data/actor/doremy/grab0005.bmp",
   L"data/actor/doremy/grab0006.bmp",
   L"data/actor/doremy/grab0007.bmp",
   L"data/actor/doremy/grab_miss0000.bmp",
   L"data/actor/doremy/grab_miss0001.bmp",
   L"data/actor/doremy/grab_miss0002.bmp",
   L"data/actor/doremy/guard_crash0000.bmp",
   L"data/actor/doremy/guard_crash0001.bmp",
   L"data/actor/doremy/guard_crash0002.bmp",
   L"data/actor/doremy/guard_crash0003.bmp",
   L"data/actor/doremy/last_word0000.bmp",
   L"data/actor/doremy/last_word0001.bmp",
   L"data/actor/doremy/last_word0002.bmp",
   L"data/actor/doremy/last_word0003.bmp",
   L"data/actor/doremy/last_word0004.bmp",
   L"data/actor/doremy/last_word0005.bmp",
   L"data/actor/doremy/last_word0006.bmp",
   L"data/actor/doremy/last_word0007.bmp",
   L"data/actor/doremy/last_word0008.bmp",
   L"data/actor/doremy/last_word0009.bmp",
   L"data/actor/doremy/last_word0010.bmp",
   L"data/actor/doremy/last_word0011.bmp",
   L"data/actor/doremy/last_word0012.bmp",
   L"data/actor/doremy/last_word0013.bmp",
   L"data/actor/doremy/last_word0014.bmp",
   L"data/actor/doremy/last_word0015.bmp",
   L"data/actor/doremy/lose0000.bmp",
   L"data/actor/doremy/lose0001.bmp",
   L"data/actor/doremy/lose0002.bmp",
   L"data/actor/doremy/lose0003.bmp",
   L"data/actor/doremy/lose0004.bmp",
   L"data/actor/doremy/lose0005.bmp",
   L"data/actor/doremy/mukon_atk_air0000.bmp",
   L"data/actor/doremy/mukon_big_0000.bmp",
   L"data/actor/doremy/mukon_mid0000.bmp",
   L"data/actor/doremy/occult0000.bmp",
   L"data/actor/doremy/occult0001.bmp",
   L"data/actor/doremy/occult0002.bmp",
   L"data/actor/doremy/occult0003.bmp",
   L"data/actor/doremy/occult0004.bmp",
   L"data/actor/doremy/occult0005.bmp",
   L"data/actor/doremy/occult0006.bmp",
   L"data/actor/doremy/occult0007.bmp",
   L"data/actor/doremy/occult0008.bmp",
   L"data/actor/doremy/occult_stump0000.bmp",
   L"data/actor/doremy/occult_stump0001.bmp",
   L"data/actor/doremy/occult_stump0002.bmp",
   L"data/actor/doremy/occult_stump0003.bmp",
   L"data/actor/doremy/palette000.bmp",
   L"data/actor/doremy/palette001.bmp",
   L"data/actor/doremy/palette002.bmp",
   L"data/actor/doremy/palette003.bmp",
   L"data/actor/doremy/palette004.bmp",
   L"data/actor/doremy/palette005.bmp",
   L"data/actor/doremy/palette006.bmp",
   L"data/actor/doremy/palette007.bmp",
   L"data/actor/doremy/palette100.bmp",
   L"data/actor/doremy/palette101.bmp",
   L"data/actor/doremy/palette102.bmp",
   L"data/actor/doremy/palette103.bmp",
   L"data/actor/doremy/palette104.bmp",
   L"data/actor/doremy/palette105.bmp",
   L"data/actor/doremy/palette106.bmp",
   L"data/actor/doremy/palette107.bmp",
   L"data/actor/doremy/ride_sheep0000.bmp",
   L"data/actor/doremy/ride_sheep0001.bmp",
   L"data/actor/doremy/ride_sheep0002.bmp",
   L"data/actor/doremy/ride_sheep0003.bmp",
   L"data/actor/doremy/ride_sheep0004.bmp",
   L"data/actor/doremy/shot_front0000.bmp",
   L"data/actor/doremy/shot_front0001.bmp",
   L"data/actor/doremy/shot_front0002.bmp",
   L"data/actor/doremy/shot_front0003.bmp",
   L"data/actor/doremy/shot_front0004.bmp",
   L"data/actor/doremy/shot_front0005.bmp",
   L"data/actor/doremy/shot_front0006.bmp",
   L"data/actor/doremy/shot_front0007.bmp",
   L"data/actor/doremy/shot_front0008.bmp",
   L"data/actor/doremy/shot_front0009.bmp",
   L"data/actor/doremy/shot_makura0000.bmp",
   L"data/actor/doremy/shot_makura0001.bmp",
   L"data/actor/doremy/shot_normal0000.bmp",
   L"data/actor/doremy/shot_normal0001.bmp",
   L"data/actor/doremy/shot_normal0002.bmp",
   L"data/actor/doremy/shot_normal0003.bmp",
   L"data/actor/doremy/shot_normal0004.bmp",
   L"data/actor/doremy/shot_normal0005.bmp",
   L"data/actor/doremy/shot_normal0006.bmp",
   L"data/actor/doremy/skill_balloon0000.bmp",
   L"data/actor/doremy/skill_balloon0001.bmp",
   L"data/actor/doremy/skill_balloon0002.bmp",
   L"data/actor/doremy/skill_balloon0003.bmp",
   L"data/actor/doremy/skill_balloon_flight0000.bmp",
   L"data/actor/doremy/skill_balloon_flight0001.bmp",
   L"data/actor/doremy/skill_balloon_flight0002.bmp",
   L"data/actor/doremy/skill_balloon_flight0003.bmp",
   L"data/actor/doremy/skill_balloon_flight0004.bmp",
   L"data/actor/doremy/skill_balloon_flight0005.bmp",
   L"data/actor/doremy/skill_cushion0000.bmp",
   L"data/actor/doremy/skill_cushion0001.bmp",
   L"data/actor/doremy/skill_cushion0002.bmp",
   L"data/actor/doremy/skill_cushion0003.bmp",
   L"data/actor/doremy/skill_cushion0004.bmp",
   L"data/actor/doremy/skill_cushion_Jump0000.bmp",
   L"data/actor/doremy/skill_cushion_Jump0001.bmp",
   L"data/actor/doremy/skill_cushion_Jump0002.bmp",
   L"data/actor/doremy/skill_cushion_Jump0003.bmp",
   L"data/actor/doremy/skill_cushion_Jump0004.bmp",
   L"data/actor/doremy/skill_cushion_Jump0005.bmp",
   L"data/actor/doremy/skill_cushion_Jump0006.bmp",
   L"data/actor/doremy/skill_cushion_Jump0007.bmp",
   L"data/actor/doremy/skill_cushion_Jump0008.bmp",
   L"data/actor/doremy/skill_cushion_Jump0009.bmp",
   L"data/actor/doremy/skill_front_shoot0000.bmp",
   L"data/actor/doremy/skill_front_shoot0001.bmp",
   L"data/actor/doremy/skill_front_shoot0002.bmp",
   L"data/actor/doremy/skill_front_shoot0003.bmp",
   L"data/actor/doremy/skill_front_shoot0004.bmp",
   L"data/actor/doremy/skill_front_shoot0005.bmp",
   L"data/actor/doremy/skill_front_shoot0006.bmp",
   L"data/actor/doremy/skill_front_shoot0007.bmp",
   L"data/actor/doremy/skill_front_shoot0008.bmp",
   L"data/actor/doremy/skill_front_shoot0009.bmp",
   L"data/actor/doremy/skill_front_shoot0010.bmp",
   L"data/actor/doremy/skill_front_shoot0011.bmp",
   L"data/actor/doremy/skill_vacuum0000.bmp",
   L"data/actor/doremy/skill_vacuum0001.bmp",
   L"data/actor/doremy/skill_vacuum0002.bmp",
   L"data/actor/doremy/skill_vacuum0003.bmp",
   L"data/actor/doremy/skill_vacuum0004.bmp",
   L"data/actor/doremy/skill_vacuum0005.bmp",
   L"data/actor/doremy/skill_vacuum0006.bmp",
   L"data/actor/doremy/skill_vacuum0007.bmp",
   L"data/actor/doremy/skill_vacuum0008.bmp",
   L"data/actor/doremy/skill_vacuum0009.bmp",
   L"data/actor/doremy/skill_vacuum0010.bmp",
   L"data/actor/doremy/skill_vacuum0011.bmp",
   L"data/actor/doremy/skill_vacuum0012.bmp",
   L"data/actor/doremy/spell_A0000.bmp",
   L"data/actor/doremy/spell_A0001.bmp",
   L"data/actor/doremy/spell_A0002.bmp",
   L"data/actor/doremy/spell_A0003.bmp",
   L"data/actor/doremy/spell_A0004.bmp",
   L"data/actor/doremy/spell_A0005.bmp",
   L"data/actor/doremy/spell_A0006.bmp",
   L"data/actor/doremy/spell_A0007.bmp",
   L"data/actor/doremy/spell_A0008.bmp",
   L"data/actor/doremy/spell_A0009.bmp",
   L"data/actor/doremy/spell_A0010.bmp",
   L"data/actor/doremy/spell_A0011.bmp",
   L"data/actor/doremy/spell_A0012.bmp",
   L"data/actor/doremy/spell_A0013.bmp",
   L"data/actor/doremy/spell_A0014.bmp",
   L"data/actor/doremy/spell_A0015.bmp",
   L"data/actor/doremy/spell_A0016.bmp",
   L"data/actor/doremy/spell_A0017.bmp",
   L"data/actor/doremy/spell_B0000.bmp",
   L"data/actor/doremy/spell_B0001.bmp",
   L"data/actor/doremy/spell_B0002.bmp",
   L"data/actor/doremy/spell_B0003.bmp",
   L"data/actor/doremy/spell_B0004.bmp",
   L"data/actor/doremy/spell_B0005.bmp",
   L"data/actor/doremy/spell_B0006.bmp",
   L"data/actor/doremy/spell_B0007.bmp",
   L"data/actor/doremy/spell_B0008.bmp",
   L"data/actor/doremy/spell_B0009.bmp",
   L"data/actor/doremy/spell_B0010.bmp",
   L"data/actor/doremy/spell_B0011.bmp",
   L"data/actor/doremy/spell_B0012.bmp",
   L"data/actor/doremy/spell_B0013.bmp",
   L"data/actor/doremy/spell_B0014.bmp",
   L"data/actor/doremy/spell_C0000.bmp",
   L"data/actor/doremy/spell_C0001.bmp",
   L"data/actor/doremy/spell_C0002.bmp",
   L"data/actor/doremy/spell_C0003.bmp",
   L"data/actor/doremy/spell_C0004.bmp",
   L"data/actor/doremy/spell_C0005.bmp",
   L"data/actor/doremy/spell_C0006.bmp",
   L"data/actor/doremy/spell_C0007.bmp",
   L"data/actor/doremy/spell_C0008.bmp",
   L"data/actor/doremy/spell_C0009.bmp",
   L"data/actor/doremy/spell_C0010.bmp",
   L"data/actor/doremy/spell_C0011.bmp",
   L"data/actor/doremy/spell_C0012.bmp",
   L"data/actor/doremy/spell_C0013.bmp",
   L"data/actor/doremy/spell_C0014.bmp",
   L"data/actor/doremy/spell_C0015.bmp",
   L"data/actor/doremy/spell_call0000.bmp",
   L"data/actor/doremy/spell_call0001.bmp",
   L"data/actor/doremy/spell_call0002.bmp",
   L"data/actor/doremy/spell_call0003.bmp",
   L"data/actor/doremy/spell_call0004.bmp",
   L"data/actor/doremy/spell_call0005.bmp",
   L"data/actor/doremy/spell_call0006.bmp",
   L"data/actor/doremy/spell_C_parts0000.bmp",
   L"data/actor/doremy/spell_C_parts0001.bmp",
   L"data/actor/doremy/spell_C_parts0002.bmp",
   L"data/actor/doremy/spell_C_parts0003.bmp",
   L"data/actor/doremy/spell_C_parts0004.bmp",
   L"data/actor/doremy/stand0000.bmp",
   L"data/actor/doremy/stand0001.bmp",
   L"data/actor/doremy/stand0002.bmp",
   L"data/actor/doremy/stand0003.bmp",
   L"data/actor/doremy/stand0004.bmp",
   L"data/actor/doremy/stand0005.bmp",
   L"data/actor/doremy/stand0006.bmp",
   L"data/actor/doremy/stand0007.bmp",
   L"data/actor/doremy/stand0008.bmp",
   L"data/actor/doremy/stand0009.bmp",
   L"data/actor/doremy/test_atk_under_end0000.bmp",
   L"data/actor/doremy/test_atk_under_end0001.bmp",
   L"data/actor/doremy/test_atk_under_end0002.bmp",
   L"data/actor/doremy/test_atk_under_end0003.bmp",
   L"data/actor/doremy/test_atk_under_end0004.bmp",
   L"data/actor/doremy/test_atk_under_end0005.bmp",
   L"data/actor/doremy/test_atk_under_end0006.bmp",
   L"data/actor/doremy/test_atk_under_loop0000.bmp",
   L"data/actor/doremy/test_atk_under_loop0001.bmp",
   L"data/actor/doremy/test_atk_under_loop0002.bmp",
   L"data/actor/doremy/test_atk_under_loop0003.bmp",
   L"data/actor/doremy/test_atk_under_loop0004.bmp",
   L"data/actor/doremy/test_atk_under_loop0005.bmp",
   L"data/actor/doremy/test_atk_under_pre0000.bmp",
   L"data/actor/doremy/test_atk_under_pre0001.bmp",
   L"data/actor/doremy/test_atk_under_pre0002.bmp",
   L"data/actor/doremy/test_dashBack0000.bmp",
   L"data/actor/doremy/test_dashBack0001.bmp",
   L"data/actor/doremy/test_dashBack0002.bmp",
   L"data/actor/doremy/test_dashBack0003.bmp",
   L"data/actor/doremy/test_dashBack0004.bmp",
   L"data/actor/doremy/test_dashBack0005.bmp",
   L"data/actor/doremy/test_dashBack0006.bmp",
   L"data/actor/doremy/test_dashBackLoop0000.bmp",
   L"data/actor/doremy/test_dashBackLoop0001.bmp",
   L"data/actor/doremy/test_dashBackLoop0002.bmp",
   L"data/actor/doremy/test_dashBackLoop0003.bmp",
   L"data/actor/doremy/test_dashBackLoop0004.bmp",
   L"data/actor/doremy/test_dashFront0000.bmp",
   L"data/actor/doremy/test_dashFront0001.bmp",
   L"data/actor/doremy/test_dashFront0002.bmp",
   L"data/actor/doremy/test_dashFront0003.bmp",
   L"data/actor/doremy/test_dashFront0004.bmp",
   L"data/actor/doremy/test_dashFront0005.bmp",
   L"data/actor/doremy/test_dashFront0006.bmp",
   L"data/actor/doremy/test_dashFrontLoop0000.bmp",
   L"data/actor/doremy/test_dashFrontLoop0001.bmp",
   L"data/actor/doremy/test_dashFrontLoop0002.bmp",
   L"data/actor/doremy/test_dashFrontLoop0003.bmp",
   L"data/actor/doremy/test_dashFrontLoop0004.bmp",
   L"data/actor/doremy/test_guard0000.bmp",
   L"data/actor/doremy/test_guard0001.bmp",
   L"data/actor/doremy/test_guard0002.bmp",
   L"data/actor/doremy/test_guard0003.bmp",
   L"data/actor/doremy/test_guardMiss0000.bmp",
   L"data/actor/doremy/test_guardMiss0001.bmp",
   L"data/actor/doremy/test_guardMiss0002.bmp",
   L"data/actor/doremy/test_guardMiss0003.bmp",
   L"data/actor/doremy/test_sheep_shot000.bmp",
   L"data/actor/doremy/test_sheep_shot001.bmp",
   L"data/actor/doremy/test_sheep_shot002.bmp",
   L"data/actor/doremy/test_sheep_shot003.bmp",
   L"data/actor/doremy/test_slide0000.bmp",
   L"data/actor/doremy/test_slide0001.bmp",
   L"data/actor/doremy/test_slide0002.bmp",
   L"data/actor/doremy/test_slide0003.bmp",
   L"data/actor/doremy/test_slide0004.bmp",
   L"data/actor/doremy/test_slide0005.bmp",
   L"data/actor/doremy/test_slide0006.bmp",
   L"data/actor/doremy/test_slide0007.bmp",
   L"data/actor/doremy/test_slide_loop_fall0000.bmp",
   L"data/actor/doremy/test_slide_loop_fall0001.bmp",
   L"data/actor/doremy/test_slide_loop_fall0002.bmp",
   L"data/actor/doremy/test_slide_loop_fall0003.bmp",
   L"data/actor/doremy/test_slide_loop_fall0004.bmp",
   L"data/actor/doremy/test_slide_upper_loop0000.bmp",
   L"data/actor/doremy/test_slide_upper_loop0001.bmp",
   L"data/actor/doremy/test_slide_upper_loop0002.bmp",
   L"data/actor/doremy/test_slide_upper_loop0003.bmp",
   L"data/actor/doremy/test_slide_upper_loop0004.bmp",
   L"data/actor/doremy/test_stand.bmp",
   L"data/actor/doremy/test_walkBack0000.bmp",
   L"data/actor/doremy/test_walkBack0001.bmp",
   L"data/actor/doremy/test_walkBack0002.bmp",
   L"data/actor/doremy/test_walkBack0003.bmp",
   L"data/actor/doremy/test_walkBack0004.bmp",
   L"data/actor/doremy/test_walkBackLoop0000.bmp",
   L"data/actor/doremy/test_walkBackLoop0001.bmp",
   L"data/actor/doremy/test_walkBackLoop0002.bmp",
   L"data/actor/doremy/test_walkBackLoop0003.bmp",
   L"data/actor/doremy/test_walkBackLoop0004.bmp",
   L"data/actor/doremy/test_walkFront0000.bmp",
   L"data/actor/doremy/test_walkFront0001.bmp",
   L"data/actor/doremy/test_walkFront0002.bmp",
   L"data/actor/doremy/test_walkFront0003.bmp",
   L"data/actor/doremy/test_walkFront0004.bmp",
   L"data/actor/doremy/test_walkFront0005.bmp",
   L"data/actor/doremy/test_walkFrontLoop0000.bmp",
   L"data/actor/doremy/test_walkFrontLoop0001.bmp",
   L"data/actor/doremy/test_walkFrontLoop0002.bmp",
   L"data/actor/doremy/test_walkFrontLoop0003.bmp",
   L"data/actor/doremy/test_walkFrontLoop0004.bmp",
   L"data/actor/doremy/texture/back_space.png",
   L"data/actor/doremy/texture/ball.bmp",
   L"data/actor/doremy/texture/bed000.png",
   L"data/actor/doremy/texture/bed001.png",
   L"data/actor/doremy/texture/bed002.png",
   L"data/actor/doremy/texture/face_master_doremy.png",
   L"data/actor/doremy/texture/face_master_doremy2.png",
   L"data/actor/doremy/texture/face_slave_doremy.png",
   L"data/actor/doremy/texture/face_spell_cut.png",
   L"data/actor/doremy/texture/hole_mask.png",
   L"data/actor/doremy/texture/lastWard_squeez0000.png",
   L"data/actor/doremy/texture/lastWord0000.png",
   L"data/actor/doremy/texture/lastWordBack0000.png",
   L"data/actor/doremy/texture/lastWord_chain0000.png",
   L"data/actor/doremy/texture/last_word_cut000.png",
   L"data/actor/doremy/texture/lotus.png",
   L"data/actor/doremy/texture/shot_charge_bullet0000.png",
   L"data/actor/doremy/texture/spellB_vortex000.png",
   L"data/actor/doremy/texture/spellB_vortex001.png",
   L"data/actor/doremy/texture/spellB_vortex002.png",
   L"data/actor/doremy/texture/spell_use_cut.png",
   L"data/actor/doremy/texture/test_lastWord_swing0000.png",
   L"data/actor/doremy/texture/trail.png",
   L"data/actor/doremy/texture/win_doremy.png",
   L"data/actor/doremy/turn0000.bmp",
   L"data/actor/doremy/turn0001.bmp",
   L"data/actor/doremy/turn0002.bmp",
   L"data/actor/doremy/win_A0000.bmp",
   L"data/actor/doremy/win_A0001.bmp",
   L"data/actor/doremy/win_A0002.bmp",
   L"data/actor/doremy/win_A0003.bmp",
   L"data/actor/doremy/win_A0004.bmp",
   L"data/actor/doremy/win_A0005.bmp",
   L"data/actor/doremy.nut",
   L"data/actor/doremy_base.nut",
   L"data/actor/doremy_boss.nut",
   L"data/actor/doremy_boss_base.nut",
   L"data/actor/doremy_boss_init.nut",
   L"data/actor/doremy_boss_shot.nut",
   L"data/actor/doremy_com.nut",
   L"data/actor/doremy_combo.nut",
   L"data/actor/doremy_com_function.nut",
   L"data/actor/doremy_init.nut",
   L"data/actor/doremy_practice_init.nut",
   L"data/actor/doremy_shot.nut",
   L"data/actor/doremy_team.nut",
   L"data/actor/dummy/dummy.pat",
   L"data/actor/dummy.nut",
   L"data/actor/dummy_base.nut",
   L"data/actor/dummy_init.nut",
   L"data/actor/effect/effect.pat",
   L"data/actor/effect/spellBack.bmp",
   L"data/actor/effect.nut",
   L"data/actor/futo/atkDashLow0000.bmp",
   L"data/actor/futo/atkDashLow0001.bmp",
   L"data/actor/futo/atkDashLow0002.bmp",
   L"data/actor/futo/atkDashLow0003.bmp",
   L"data/actor/futo/atkDashLow0004.bmp",
   L"data/actor/futo/atkDashLow0005.bmp",
   L"data/actor/futo/atkDashLow0006.bmp",
   L"data/actor/futo/atkHigh0000.bmp",
   L"data/actor/futo/atkHigh0001.bmp",
   L"data/actor/futo/atkHigh0002.bmp",
   L"data/actor/futo/atkHigh0003.bmp",
   L"data/actor/futo/atkHigh0004.bmp",
   L"data/actor/futo/atkHigh0005.bmp",
   L"data/actor/futo/atkHigh0006.bmp",
   L"data/actor/futo/atkHigh0007.bmp",
   L"data/actor/futo/atkHigh0008.bmp",
   L"data/actor/futo/atkHighFront0000.bmp",
   L"data/actor/futo/atkHighFront0001.bmp",
   L"data/actor/futo/atkHighFront0002.bmp",
   L"data/actor/futo/atkHighFront0003.bmp",
   L"data/actor/futo/atkHighFront0004.bmp",
   L"data/actor/futo/atkHighFront0005.bmp",
   L"data/actor/futo/atkHighFront0006.bmp",
   L"data/actor/futo/atkHighFront0007.bmp",
   L"data/actor/futo/atkHighFront0008.bmp",
   L"data/actor/futo/atkHighFront0009.bmp",
   L"data/actor/futo/atkHighUnder0000.bmp",
   L"data/actor/futo/atkHighUnder0001.bmp",
   L"data/actor/futo/atkHighUnder0002.bmp",
   L"data/actor/futo/atkHighUnder0003.bmp",
   L"data/actor/futo/atkHighUnder0004.bmp",
   L"data/actor/futo/atkHighUnder0005.bmp",
   L"data/actor/futo/atkHighUnder0006.bmp",
   L"data/actor/futo/atkHighUnder0007.bmp",
   L"data/actor/futo/atkHighUnder0008.bmp",
   L"data/actor/futo/atkHighUpper0000.bmp",
   L"data/actor/futo/atkHighUpper0001.bmp",
   L"data/actor/futo/atkHighUpper0002.bmp",
   L"data/actor/futo/atkHighUpper0003.bmp",
   L"data/actor/futo/atkHighUpper0004.bmp",
   L"data/actor/futo/atkHighUpper0005.bmp",
   L"data/actor/futo/atkHighUpper0006.bmp",
   L"data/actor/futo/atkHighUpper0007.bmp",
   L"data/actor/futo/atkHighUpper0008.bmp",
   L"data/actor/futo/atkHighUpper0009.bmp",
   L"data/actor/futo/atkHighUpper0010.bmp",
   L"data/actor/futo/atkHighUpper0011.bmp",
   L"data/actor/futo/atkLow0000.bmp",
   L"data/actor/futo/atkLow0001.bmp",
   L"data/actor/futo/atkLow0002.bmp",
   L"data/actor/futo/atkLow0003.bmp",
   L"data/actor/futo/atkLow0004.bmp",
   L"data/actor/futo/atkLow0005.bmp",
   L"data/actor/futo/atkLow0006.bmp",
   L"data/actor/futo/atkMid0000.bmp",
   L"data/actor/futo/atkMid0001.bmp",
   L"data/actor/futo/atkMid0002.bmp",
   L"data/actor/futo/atkMid0003.bmp",
   L"data/actor/futo/atkMid0004.bmp",
   L"data/actor/futo/atkMid0005.bmp",
   L"data/actor/futo/atkMid0006.bmp",
   L"data/actor/futo/atkMid0007.bmp",
   L"data/actor/futo/atk_front_air0000.bmp",
   L"data/actor/futo/atk_front_air0001.bmp",
   L"data/actor/futo/atk_front_air0002.bmp",
   L"data/actor/futo/atk_front_air0003.bmp",
   L"data/actor/futo/atk_front_air0004.bmp",
   L"data/actor/futo/atk_front_air0005.bmp",
   L"data/actor/futo/atk_front_air0006.bmp",
   L"data/actor/futo/atk_front_air0007.bmp",
   L"data/actor/futo/atk_grab0000.bmp",
   L"data/actor/futo/atk_grab0001.bmp",
   L"data/actor/futo/atk_grab0002.bmp",
   L"data/actor/futo/atk_grab0003.bmp",
   L"data/actor/futo/atk_grab0004.bmp",
   L"data/actor/futo/atk_grab0005.bmp",
   L"data/actor/futo/atk_grab0006.bmp",
   L"data/actor/futo/battleBeginB0000.bmp",
   L"data/actor/futo/battleBeginB0001.bmp",
   L"data/actor/futo/battleBeginB0002.bmp",
   L"data/actor/futo/battleBeginB0003.bmp",
   L"data/actor/futo/battleBeginB0004.bmp",
   L"data/actor/futo/battleBeginB0005.bmp",
   L"data/actor/futo/battleBeginB0006.bmp",
   L"data/actor/futo/battleBeginB0007.bmp",
   L"data/actor/futo/BattleBeginC0000.bmp",
   L"data/actor/futo/BattleBeginC0001.bmp",
   L"data/actor/futo/BattleBeginC0003.bmp",
   L"data/actor/futo/BattleBeginC0004.bmp",
   L"data/actor/futo/BattleBeginC_Loop0000.bmp",
   L"data/actor/futo/BattleBeginC_Loop0001.bmp",
   L"data/actor/futo/BattleBeginC_Loop0002.bmp",
   L"data/actor/futo/BattleBeginC_Loop0003.bmp",
   L"data/actor/futo/BattleBeginC_Loop0004.bmp",
   L"data/actor/futo/beginBattleA0000.bmp",
   L"data/actor/futo/beginBattleA0001.bmp",
   L"data/actor/futo/beginBattleA0002.bmp",
   L"data/actor/futo/beginBattleA0003.bmp",
   L"data/actor/futo/beginBattleA0004.bmp",
   L"data/actor/futo/beginBattleA0005.bmp",
   L"data/actor/futo/beginBattleA0006.bmp",
   L"data/actor/futo/beginBattleA0007.bmp",
   L"data/actor/futo/bmsln/futo_climaxFire.bmb",
   L"data/actor/futo/bmsln/futo_firePilar.bmb",
   L"data/actor/futo/bmsln/futo_levelUp.bmb",
   L"data/actor/futo/bmsln/futo_rollFire.bmb",
   L"data/actor/futo/bmsln/futo_tornade.bmb",
   L"data/actor/futo/climax0000.bmp",
   L"data/actor/futo/climax0001.bmp",
   L"data/actor/futo/climax0002.bmp",
   L"data/actor/futo/climax0003.bmp",
   L"data/actor/futo/climax0004.bmp",
   L"data/actor/futo/climax0005.bmp",
   L"data/actor/futo/climax0006.bmp",
   L"data/actor/futo/climaxLoop0000.bmp",
   L"data/actor/futo/climaxLoop0001.bmp",
   L"data/actor/futo/climaxLoop0002.bmp",
   L"data/actor/futo/climaxLoop0003.bmp",
   L"data/actor/futo/climaxLoop0004.bmp",
   L"data/actor/futo/climaxLoop0005.bmp",
   L"data/actor/futo/climax_well0000.bmp",
   L"data/actor/futo/crash0000.bmp",
   L"data/actor/futo/crash0001.bmp",
   L"data/actor/futo/crash0002.bmp",
   L"data/actor/futo/crash0003.bmp",
   L"data/actor/futo/crash0004.bmp",
   L"data/actor/futo/cut0000.png",
   L"data/actor/futo/cut0001.png",
   L"data/actor/futo/damageBody0000.bmp",
   L"data/actor/futo/damageBody0001.bmp",
   L"data/actor/futo/damageBody0002.bmp",
   L"data/actor/futo/damageBody0003.bmp",
   L"data/actor/futo/damageBody0004.bmp",
   L"data/actor/futo/damageHead0000.bmp",
   L"data/actor/futo/damageHead0001.bmp",
   L"data/actor/futo/damageHead0002.bmp",
   L"data/actor/futo/damageHead0003.bmp",
   L"data/actor/futo/damageHead0004.bmp",
   L"data/actor/futo/damageSpin0000.bmp",
   L"data/actor/futo/damageSpin0001.bmp",
   L"data/actor/futo/damageSpin0002.bmp",
   L"data/actor/futo/damageSpin0003.bmp",
   L"data/actor/futo/damageUpper0000.bmp",
   L"data/actor/futo/damageUpper0001.bmp",
   L"data/actor/futo/damageUpper0002.bmp",
   L"data/actor/futo/damageUpper0003.bmp",
   L"data/actor/futo/damageUpper0004.bmp",
   L"data/actor/futo/damageUpper0005.bmp",
   L"data/actor/futo/damageUpper0006.bmp",
   L"data/actor/futo/damageUpper0007.bmp",
   L"data/actor/futo/damageUpper0008.bmp",
   L"data/actor/futo/damageUpper0009.bmp",
   L"data/actor/futo/damageUpper0010.bmp",
   L"data/actor/futo/damageUpper0011.bmp",
   L"data/actor/futo/damageUpper0012.bmp",
   L"data/actor/futo/damageUpper0013.bmp",
   L"data/actor/futo/damageUpper0014.bmp",
   L"data/actor/futo/damageWall0000.bmp",
   L"data/actor/futo/damageWall0001.bmp",
   L"data/actor/futo/damageWall0002.bmp",
   L"data/actor/futo/damageWall0003.bmp",
   L"data/actor/futo/damageWall0004.bmp",
   L"data/actor/futo/damageWall0005.bmp",
   L"data/actor/futo/damageWall0006.bmp",
   L"data/actor/futo/dashBack0000.bmp",
   L"data/actor/futo/dashBack0001.bmp",
   L"data/actor/futo/dashBack0002.bmp",
   L"data/actor/futo/dashBack0003.bmp",
   L"data/actor/futo/dashBack0004.bmp",
   L"data/actor/futo/dashBack0005.bmp",
   L"data/actor/futo/dashBack0006.bmp",
   L"data/actor/futo/dashBackLoop0000.bmp",
   L"data/actor/futo/dashBackLoop0001.bmp",
   L"data/actor/futo/dashBackLoop0002.bmp",
   L"data/actor/futo/dashBackLoop0003.bmp",
   L"data/actor/futo/dashBackLoop0004.bmp",
   L"data/actor/futo/dashFront0000.bmp",
   L"data/actor/futo/dashFront0001.bmp",
   L"data/actor/futo/dashFront0002.bmp",
   L"data/actor/futo/dashFront0003.bmp",
   L"data/actor/futo/dashFront0004.bmp",
   L"data/actor/futo/dashFront0005.bmp",
   L"data/actor/futo/dashFront0006.bmp",
   L"data/actor/futo/dashFrontLoop0000.bmp",
   L"data/actor/futo/dashFrontLoop0001.bmp",
   L"data/actor/futo/dashFrontLoop0002.bmp",
   L"data/actor/futo/dashFrontLoop0003.bmp",
   L"data/actor/futo/dashFrontLoop0004.bmp",
   L"data/actor/futo/face_spellcallb.png",
   L"data/actor/futo/futo.pat",
   L"data/actor/futo/futo_ed.pat",
   L"data/actor/futo/guard0000.bmp",
   L"data/actor/futo/guard0001.bmp",
   L"data/actor/futo/guard0002.bmp",
   L"data/actor/futo/guard0003.bmp",
   L"data/actor/futo/item0000.bmp",
   L"data/actor/futo/item0001.bmp",
   L"data/actor/futo/item0002.bmp",
   L"data/actor/futo/item0003.bmp",
   L"data/actor/futo/item0004.bmp",
   L"data/actor/futo/item0005.bmp",
   L"data/actor/futo/item0006.bmp",
   L"data/actor/futo/lose0000.bmp",
   L"data/actor/futo/lose0001.bmp",
   L"data/actor/futo/lose0002.bmp",
   L"data/actor/futo/lose0003.bmp",
   L"data/actor/futo/missGuard0000.bmp",
   L"data/actor/futo/missGuard0001.bmp",
   L"data/actor/futo/missGuard0002.bmp",
   L"data/actor/futo/missGuard0003.bmp",
   L"data/actor/futo/occultA0000.bmp",
   L"data/actor/futo/occultA0001.bmp",
   L"data/actor/futo/occultA0002.bmp",
   L"data/actor/futo/occultA0003.bmp",
   L"data/actor/futo/occultA0004.bmp",
   L"data/actor/futo/occultB0000.bmp",
   L"data/actor/futo/occultB0001.bmp",
   L"data/actor/futo/occultB0002.bmp",
   L"data/actor/futo/occultB0003.bmp",
   L"data/actor/futo/occultB0004.bmp",
   L"data/actor/futo/occultB0005.bmp",
   L"data/actor/futo/occultB0006.bmp",
   L"data/actor/futo/occultC0000.bmp",
   L"data/actor/futo/occultC0001.bmp",
   L"data/actor/futo/occultC0002.bmp",
   L"data/actor/futo/occultC0003.bmp",
   L"data/actor/futo/occultC0004.bmp",
   L"data/actor/futo/occultC0005.bmp",
   L"data/actor/futo/occult_dish0000.bmp",
   L"data/actor/futo/occult_okiku0000.bmp",
   L"data/actor/futo/occult_okiku0001.bmp",
   L"data/actor/futo/occult_okiku0002.bmp",
   L"data/actor/futo/occult_okiku0003.bmp",
   L"data/actor/futo/occult_okiku0004.bmp",
   L"data/actor/futo/palette000.bmp",
   L"data/actor/futo/palette001.bmp",
   L"data/actor/futo/palette002.bmp",
   L"data/actor/futo/palette003.bmp",
   L"data/actor/futo/palette004.bmp",
   L"data/actor/futo/palette005.bmp",
   L"data/actor/futo/palette006.bmp",
   L"data/actor/futo/palette007.bmp",
   L"data/actor/futo/palette100.bmp",
   L"data/actor/futo/palette101.bmp",
   L"data/actor/futo/palette102.bmp",
   L"data/actor/futo/palette103.bmp",
   L"data/actor/futo/palette104.bmp",
   L"data/actor/futo/palette105.bmp",
   L"data/actor/futo/palette106.bmp",
   L"data/actor/futo/palette107.bmp",
   L"data/actor/futo/ShotHigh0000.bmp",
   L"data/actor/futo/ShotHigh0001.bmp",
   L"data/actor/futo/ShotHigh0002.bmp",
   L"data/actor/futo/ShotHigh0003.bmp",
   L"data/actor/futo/ShotHigh0004.bmp",
   L"data/actor/futo/ShotHigh0005.bmp",
   L"data/actor/futo/ShotHigh0006.bmp",
   L"data/actor/futo/ShotHigh0007.bmp",
   L"data/actor/futo/ShotHigh0008.bmp",
   L"data/actor/futo/ShotHigh0009.bmp",
   L"data/actor/futo/ShotHigh0010.bmp",
   L"data/actor/futo/shotLow0000.bmp",
   L"data/actor/futo/shotLow0001.bmp",
   L"data/actor/futo/shotLow0002.bmp",
   L"data/actor/futo/shotLow0003.bmp",
   L"data/actor/futo/shotLow0004.bmp",
   L"data/actor/futo/shotLow0005.bmp",
   L"data/actor/futo/shotLow0006.bmp",
   L"data/actor/futo/shotLow0007.bmp",
   L"data/actor/futo/shotLow0008.bmp",
   L"data/actor/futo/shotLow0009.bmp",
   L"data/actor/futo/shotLow0010.bmp",
   L"data/actor/futo/shotLow0011.bmp",
   L"data/actor/futo/shotLow0012.bmp",
   L"data/actor/futo/skillA0000.bmp",
   L"data/actor/futo/skillA0001.bmp",
   L"data/actor/futo/skillA0002.bmp",
   L"data/actor/futo/skillA0003.bmp",
   L"data/actor/futo/skillA0004.bmp",
   L"data/actor/futo/skillA0005.bmp",
   L"data/actor/futo/skillA_Loop0000.bmp",
   L"data/actor/futo/skillA_Loop0001.bmp",
   L"data/actor/futo/skillA_Loop0002.bmp",
   L"data/actor/futo/skillA_Loop0003.bmp",
   L"data/actor/futo/skillB0000.bmp",
   L"data/actor/futo/skillB0001.bmp",
   L"data/actor/futo/skillB0002.bmp",
   L"data/actor/futo/skillB0003.bmp",
   L"data/actor/futo/skillB0004.bmp",
   L"data/actor/futo/skillB0005.bmp",
   L"data/actor/futo/skillB0006.bmp",
   L"data/actor/futo/skillB0007.bmp",
   L"data/actor/futo/skillC0000.bmp",
   L"data/actor/futo/skillC0001.bmp",
   L"data/actor/futo/skillC0002.bmp",
   L"data/actor/futo/skillC0003.bmp",
   L"data/actor/futo/skillC0004.bmp",
   L"data/actor/futo/skillC0005.bmp",
   L"data/actor/futo/skillC0006.bmp",
   L"data/actor/futo/skillC0007.bmp",
   L"data/actor/futo/skillD0000.bmp",
   L"data/actor/futo/skillD0001.bmp",
   L"data/actor/futo/skillD0002.bmp",
   L"data/actor/futo/skillD0003.bmp",
   L"data/actor/futo/skillD0004.bmp",
   L"data/actor/futo/skillD0005.bmp",
   L"data/actor/futo/skillD0006.bmp",
   L"data/actor/futo/skillD0007.bmp",
   L"data/actor/futo/skillD0008.bmp",
   L"data/actor/futo/skillD0009.bmp",
   L"data/actor/futo/skillG0000.bmp",
   L"data/actor/futo/skillG0001.bmp",
   L"data/actor/futo/skillG0002.bmp",
   L"data/actor/futo/skillG0003.bmp",
   L"data/actor/futo/skillG0004.bmp",
   L"data/actor/futo/skillG0005.bmp",
   L"data/actor/futo/skillG0006.bmp",
   L"data/actor/futo/skillG0007.bmp",
   L"data/actor/futo/skillG0008.bmp",
   L"data/actor/futo/skillG_Loop0000.bmp",
   L"data/actor/futo/skillG_Loop0001.bmp",
   L"data/actor/futo/skillG_Loop0002.bmp",
   L"data/actor/futo/skillG_Loop0003.bmp",
   L"data/actor/futo/skillG_Loop0004.bmp",
   L"data/actor/futo/slide0000.bmp",
   L"data/actor/futo/slide0001.bmp",
   L"data/actor/futo/slide0002.bmp",
   L"data/actor/futo/slide0003.bmp",
   L"data/actor/futo/slide0004.bmp",
   L"data/actor/futo/slide0005.bmp",
   L"data/actor/futo/slide0006.bmp",
   L"data/actor/futo/slide0007.bmp",
   L"data/actor/futo/slideUnderLoop0000.bmp",
   L"data/actor/futo/slideUnderLoop0001.bmp",
   L"data/actor/futo/slideUnderLoop0002.bmp",
   L"data/actor/futo/slideUnderLoop0003.bmp",
   L"data/actor/futo/slideUnderLoop0004.bmp",
   L"data/actor/futo/slideUpperLoop0000.bmp",
   L"data/actor/futo/slideUpperLoop0001.bmp",
   L"data/actor/futo/slideUpperLoop0002.bmp",
   L"data/actor/futo/slideUpperLoop0003.bmp",
   L"data/actor/futo/slideUpperLoop0004.bmp",
   L"data/actor/futo/spellA0000.bmp",
   L"data/actor/futo/spellA0001.bmp",
   L"data/actor/futo/spellA0002.bmp",
   L"data/actor/futo/spellA0003.bmp",
   L"data/actor/futo/spellA0004.bmp",
   L"data/actor/futo/spellA0005.bmp",
   L"data/actor/futo/spellA0006.bmp",
   L"data/actor/futo/spellA0007.bmp",
   L"data/actor/futo/spellA0008.bmp",
   L"data/actor/futo/spellA0009.bmp",
   L"data/actor/futo/spellA0010.bmp",
   L"data/actor/futo/spellB0000.bmp",
   L"data/actor/futo/spellB0001.bmp",
   L"data/actor/futo/spellB0002.bmp",
   L"data/actor/futo/spellB0003.bmp",
   L"data/actor/futo/spellB0004.bmp",
   L"data/actor/futo/spellB0005.bmp",
   L"data/actor/futo/spellB0006.bmp",
   L"data/actor/futo/spellB0007.bmp",
   L"data/actor/futo/spellBLoop0000.bmp",
   L"data/actor/futo/spellBLoop0001.bmp",
   L"data/actor/futo/spellBLoop0002.bmp",
   L"data/actor/futo/spellBLoop0003.bmp",
   L"data/actor/futo/spellBLoop0004.bmp",
   L"data/actor/futo/stand0000.bmp",
   L"data/actor/futo/stand0001.bmp",
   L"data/actor/futo/stand0002.bmp",
   L"data/actor/futo/stand0003.bmp",
   L"data/actor/futo/stand0004.bmp",
   L"data/actor/futo/stand0005.bmp",
   L"data/actor/futo/stand0006.bmp",
   L"data/actor/futo/stand0007.bmp",
   L"data/actor/futo/stand0008.bmp",
   L"data/actor/futo/stand0009.bmp",
   L"data/actor/futo/stand0010.bmp",
   L"data/actor/futo/stand0011.bmp",
   L"data/actor/futo/standB0000.bmp",
   L"data/actor/futo/standB0001.bmp",
   L"data/actor/futo/standB0002.bmp",
   L"data/actor/futo/standB0003.bmp",
   L"data/actor/futo/standB0004.bmp",
   L"data/actor/futo/stun0000.bmp",
   L"data/actor/futo/stun0001.bmp",
   L"data/actor/futo/stun0002.bmp",
   L"data/actor/futo/stun0003.bmp",
   L"data/actor/futo/stun0004.bmp",
   L"data/actor/futo/stun0005.bmp",
   L"data/actor/futo/stunEnd0000.bmp",
   L"data/actor/futo/stunEnd0001.bmp",
   L"data/actor/futo/stunEnd0002.bmp",
   L"data/actor/futo/team_begin_A0000.bmp",
   L"data/actor/futo/team_begin_A0001.bmp",
   L"data/actor/futo/texture/arrowA0000.dds",
   L"data/actor/futo/texture/auraA0000.dds",
   L"data/actor/futo/texture/auraA0000.png",
   L"data/actor/futo/texture/ball.bmp",
   L"data/actor/futo/texture/climaxBack.png",
   L"data/actor/futo/texture/climax_hit0000.png",
   L"data/actor/futo/texture/climax_smash.dds",
   L"data/actor/futo/texture/climax_smash0001.dds",
   L"data/actor/futo/texture/climax_smash0002.dds",
   L"data/actor/futo/texture/climax_srueez0000.dds",
   L"data/actor/futo/texture/climax_srueez0001.dds",
   L"data/actor/futo/texture/dangerA.png",
   L"data/actor/futo/texture/dangerB.png",
   L"data/actor/futo/texture/dangerC.png",
   L"data/actor/futo/texture/dishA0000.png",
   L"data/actor/futo/texture/dishShardA0000.dds",
   L"data/actor/futo/texture/face_master_futo.png",
   L"data/actor/futo/texture/face_master_futo2.png",
   L"data/actor/futo/texture/face_slave_futo.png",
   L"data/actor/futo/texture/face_spell_cut.png",
   L"data/actor/futo/texture/fire.dds",
   L"data/actor/futo/texture/fireBase.png",
   L"data/actor/futo/texture/fireMask.png",
   L"data/actor/futo/texture/fireParticle.png",
   L"data/actor/futo/texture/fire_atkUpper.dds",
   L"data/actor/futo/texture/fune.png",
   L"data/actor/futo/texture/fune_B.png",
   L"data/actor/futo/texture/fune_C.png",
   L"data/actor/futo/texture/futo_animalDamage000.png",
   L"data/actor/futo/texture/futo_animalDamage001.png",
   L"data/actor/futo/texture/futo_animalDamage002.png",
   L"data/actor/futo/texture/futo_animalDamage003.png",
   L"data/actor/futo/texture/futo_animal_00000.png",
   L"data/actor/futo/texture/futo_animal_00001.png",
   L"data/actor/futo/texture/futo_animal_00002.png",
   L"data/actor/futo/texture/futo_animal_00003.png",
   L"data/actor/futo/texture/futo_animal_00004.png",
   L"data/actor/futo/texture/futo_animal_00005.png",
   L"data/actor/futo/texture/futo_animal_00006.png",
   L"data/actor/futo/texture/futo_animal_00007.png",
   L"data/actor/futo/texture/futo_animal_00008.png",
   L"data/actor/futo/texture/futo_animal_00009.png",
   L"data/actor/futo/texture/futo_animal_00010.png",
   L"data/actor/futo/texture/futo_animal_00011.png",
   L"data/actor/futo/texture/futo_fire.dds",
   L"data/actor/futo/texture/futo_fireBase.png",
   L"data/actor/futo/texture/futo_fireMask.png",
   L"data/actor/futo/texture/futo_sparkLine.dds",
   L"data/actor/futo/texture/iron0000.dds",
   L"data/actor/futo/texture/kona_A.bmp",
   L"data/actor/futo/texture/lightning_mapA.png",
   L"data/actor/futo/texture/luckFontA.png",
   L"data/actor/futo/texture/luckFontB.png",
   L"data/actor/futo/texture/mask_ball.png",
   L"data/actor/futo/texture/musou_trail.png",
   L"data/actor/futo/texture/nameCall.png",
   L"data/actor/futo/texture/occult_smoke0000.dds",
   L"data/actor/futo/texture/ringA.bmp",
   L"data/actor/futo/texture/rollFire.png",
   L"data/actor/futo/texture/sara_01.png",
   L"data/actor/futo/texture/sara_02.png",
   L"data/actor/futo/texture/sara_03.png",
   L"data/actor/futo/texture/sara_04.png",
   L"data/actor/futo/texture/sara_05.png",
   L"data/actor/futo/texture/skillG_000.png",
   L"data/actor/futo/texture/skillG_001.png",
   L"data/actor/futo/texture/skillG_002.png",
   L"data/actor/futo/texture/skillG_003.png",
   L"data/actor/futo/texture/skillG_004.png",
   L"data/actor/futo/texture/skillG_005.png",
   L"data/actor/futo/texture/skillG_006.png",
   L"data/actor/futo/texture/skillG_007.png",
   L"data/actor/futo/texture/skillG_008.png",
   L"data/actor/futo/texture/skillG_009.png",
   L"data/actor/futo/texture/skillG_010.png",
   L"data/actor/futo/texture/skillG_011.png",
   L"data/actor/futo/texture/skillG_012.png",
   L"data/actor/futo/texture/skillG_013.png",
   L"data/actor/futo/texture/skillG_014.png",
   L"data/actor/futo/texture/smoke.dds",
   L"data/actor/futo/texture/sparkLine.dds",
   L"data/actor/futo/texture/spellC.dds",
   L"data/actor/futo/texture/spellC_Aura.png",
   L"data/actor/futo/texture/spellC_chouchin.png",
   L"data/actor/futo/texture/spellC_haka.png",
   L"data/actor/futo/texture/spellC_saisenbako.png",
   L"data/actor/futo/texture/spellC_sakabin.png",
   L"data/actor/futo/texture/spellC_sakadaru.png",
   L"data/actor/futo/texture/spellC_tansu.png",
   L"data/actor/futo/texture/spellC_uekibachi.png",
   L"data/actor/futo/texture/spellC_ufoB.png",
   L"data/actor/futo/texture/spell_use_cut.png",
   L"data/actor/futo/texture/squeezeA0000.png",
   L"data/actor/futo/texture/stone.png",
   L"data/actor/futo/texture/stoneB.png",
   L"data/actor/futo/texture/tatumakiHighFront.dds",
   L"data/actor/futo/texture/tornade.png",
   L"data/actor/futo/texture/tornade000.png",
   L"data/actor/futo/texture/tornade001.png",
   L"data/actor/futo/texture/tornade002.png",
   L"data/actor/futo/texture/tornade003.png",
   L"data/actor/futo/texture/tornade004.png",
   L"data/actor/futo/texture/tornade005.png",
   L"data/actor/futo/texture/tornade006.png",
   L"data/actor/futo/texture/vortexA0000.dds",
   L"data/actor/futo/texture/watarFall0000.dds",
   L"data/actor/futo/texture/watarFall0000.png",
   L"data/actor/futo/turn0000.bmp",
   L"data/actor/futo/turn0001.bmp",
   L"data/actor/futo/turn0002.bmp",
   L"data/actor/futo/walkBack0000.bmp",
   L"data/actor/futo/walkBack0001.bmp",
   L"data/actor/futo/walkBack0002.bmp",
   L"data/actor/futo/walkBack0003.bmp",
   L"data/actor/futo/walkBack0004.bmp",
   L"data/actor/futo/walkBack0005.bmp",
   L"data/actor/futo/walkBack0006.bmp",
   L"data/actor/futo/walkBackLoop0000.bmp",
   L"data/actor/futo/walkBackLoop0001.bmp",
   L"data/actor/futo/walkBackLoop0002.bmp",
   L"data/actor/futo/walkBackLoop0003.bmp",
   L"data/actor/futo/walkBackLoop0004.bmp",
   L"data/actor/futo/walkFront0000.bmp",
   L"data/actor/futo/walkFront0001.bmp",
   L"data/actor/futo/walkFront0002.bmp",
   L"data/actor/futo/walkFront0003.bmp",
   L"data/actor/futo/walkFront0004.bmp",
   L"data/actor/futo/walkFront0005.bmp",
   L"data/actor/futo/walkFrontLoop0000.bmp",
   L"data/actor/futo/walkFrontLoop0001.bmp",
   L"data/actor/futo/walkFrontLoop0002.bmp",
   L"data/actor/futo/walkFrontLoop0003.bmp",
   L"data/actor/futo/walkFrontLoop0004.bmp",
   L"data/actor/futo/winA0000.bmp",
   L"data/actor/futo/winA0001.bmp",
   L"data/actor/futo/winA0002.bmp",
   L"data/actor/futo/winA0003.bmp",
   L"data/actor/futo/winA0004.bmp",
   L"data/actor/futo/winA0005.bmp",
   L"data/actor/futo/winA0006.bmp",
   L"data/actor/futo.nut",
   L"data/actor/futo_base.nut",
   L"data/actor/futo_boss.nut",
   L"data/actor/futo_boss_base.nut",
   L"data/actor/futo_boss_init.nut",
   L"data/actor/futo_boss_shot.nut",
   L"data/actor/futo_com.nut",
   L"data/actor/futo_combo.nut",
   L"data/actor/futo_com_function.nut",
   L"data/actor/futo_init.nut",
   L"data/actor/futo_practice_init.nut",
   L"data/actor/futo_shot.nut",
   L"data/actor/futo_team.nut",
   L"data/actor/hijiri/atkDashHigh0000.bmp",
   L"data/actor/hijiri/atkDashHigh0001.bmp",
   L"data/actor/hijiri/atkDashHigh0002.bmp",
   L"data/actor/hijiri/atkDashHigh0003.bmp",
   L"data/actor/hijiri/atkDashHigh0004.bmp",
   L"data/actor/hijiri/atkDashHigh0005.bmp",
   L"data/actor/hijiri/atkDashHigh0006.bmp",
   L"data/actor/hijiri/atkDashHigh0007.bmp",
   L"data/actor/hijiri/atkDashLow0000.bmp",
   L"data/actor/hijiri/atkDashLow0001.bmp",
   L"data/actor/hijiri/atkDashLow0002.bmp",
   L"data/actor/hijiri/atkDashLow0003.bmp",
   L"data/actor/hijiri/atkDashLow0004.bmp",
   L"data/actor/hijiri/atkDashLow0005.bmp",
   L"data/actor/hijiri/atkDashLow0006.bmp",
   L"data/actor/hijiri/atkDashLow0007.bmp",
   L"data/actor/hijiri/atkDashLow0008.bmp",
   L"data/actor/hijiri/atkHigh0000.bmp",
   L"data/actor/hijiri/atkHigh0001.bmp",
   L"data/actor/hijiri/atkHigh0002.bmp",
   L"data/actor/hijiri/atkHigh0003.bmp",
   L"data/actor/hijiri/atkHigh0004.bmp",
   L"data/actor/hijiri/atkHigh0005.bmp",
   L"data/actor/hijiri/atkHigh0006.bmp",
   L"data/actor/hijiri/atkHigh0007.bmp",
   L"data/actor/hijiri/atkHigh0008.bmp",
   L"data/actor/hijiri/atkHigh0009.bmp",
   L"data/actor/hijiri/atkHighUpper0000.bmp",
   L"data/actor/hijiri/atkHighUpper0001.bmp",
   L"data/actor/hijiri/atkHighUpper0002.bmp",
   L"data/actor/hijiri/atkHighUpper0003.bmp",
   L"data/actor/hijiri/atkHighUpper0004.bmp",
   L"data/actor/hijiri/atkHighUpper0005.bmp",
   L"data/actor/hijiri/atkHighUpper0006.bmp",
   L"data/actor/hijiri/atkHighUpper0007.bmp",
   L"data/actor/hijiri/atkLow0000.bmp",
   L"data/actor/hijiri/atkLow0001.bmp",
   L"data/actor/hijiri/atkLow0002.bmp",
   L"data/actor/hijiri/atkLow0003.bmp",
   L"data/actor/hijiri/atkLow0004.bmp",
   L"data/actor/hijiri/atkLow0005.bmp",
   L"data/actor/hijiri/atkLow0006.bmp",
   L"data/actor/hijiri/atkLowB0000.bmp",
   L"data/actor/hijiri/atkLowB0001.bmp",
   L"data/actor/hijiri/atkLowB0002.bmp",
   L"data/actor/hijiri/atkLowB0003.bmp",
   L"data/actor/hijiri/atkLowB0004.bmp",
   L"data/actor/hijiri/atkLowB0005.bmp",
   L"data/actor/hijiri/atkMid0000.bmp",
   L"data/actor/hijiri/atkMid0001.bmp",
   L"data/actor/hijiri/atkMid0002.bmp",
   L"data/actor/hijiri/atkMid0003.bmp",
   L"data/actor/hijiri/atkMid0004.bmp",
   L"data/actor/hijiri/atkMid0005.bmp",
   L"data/actor/hijiri/atkMid0006.bmp",
   L"data/actor/hijiri/atkMid0007.bmp",
   L"data/actor/hijiri/atkMid0008.bmp",
   L"data/actor/hijiri/atkMid0009.bmp",
   L"data/actor/hijiri/atlHighUnder0000.bmp",
   L"data/actor/hijiri/atlHighUnder0001.bmp",
   L"data/actor/hijiri/atlHighUnder0002.bmp",
   L"data/actor/hijiri/atlHighUnder0003.bmp",
   L"data/actor/hijiri/atlHighUnder0004.bmp",
   L"data/actor/hijiri/atlHighUnder0005.bmp",
   L"data/actor/hijiri/atlHighUnder0006.bmp",
   L"data/actor/hijiri/atlHighUnder0007.bmp",
   L"data/actor/hijiri/atlHighUnder0008.bmp",
   L"data/actor/hijiri/atlHighUnder0009.bmp",
   L"data/actor/hijiri/atlHighUnder0010.bmp",
   L"data/actor/hijiri/atlHighUnder0011.bmp",
   L"data/actor/hijiri/atlHighUnder0012.bmp",
   L"data/actor/hijiri/atlHighUnder0013.bmp",
   L"data/actor/hijiri/atlHighUnder0014.bmp",
   L"data/actor/hijiri/atlHighUnder0015.bmp",
   L"data/actor/hijiri/atlHighUnder0016.bmp",
   L"data/actor/hijiri/atlHighUnder0017.bmp",
   L"data/actor/hijiri/atlHighUnder0018.bmp",
   L"data/actor/hijiri/atlHighUnder0019.bmp",
   L"data/actor/hijiri/battleBeginA0000.bmp",
   L"data/actor/hijiri/battleBeginA0001.bmp",
   L"data/actor/hijiri/battleBeginA0002.bmp",
   L"data/actor/hijiri/battleBeginA0003.bmp",
   L"data/actor/hijiri/battleBeginA0004.bmp",
   L"data/actor/hijiri/battleBeginA0005.bmp",
   L"data/actor/hijiri/battleBeginA0006.bmp",
   L"data/actor/hijiri/bellA000.bmp",
   L"data/actor/hijiri/bmsln/hijiri_climaxAuraA.bmb",
   L"data/actor/hijiri/bmsln/hijiri_climaxHitA.bmb",
   L"data/actor/hijiri/bmsln/hijiri_lightningA.bmb",
   L"data/actor/hijiri/bmsln/hijiri_skillB.bmb",
   L"data/actor/hijiri/bmsln/hijiri_skillG.bmb",
   L"data/actor/hijiri/bmsln/hijiri_spellC_Impact.bmb",
   L"data/actor/hijiri/bmsln/hijiri_spellC_Pilar.bmb",
   L"data/actor/hijiri/chant0000.bmp",
   L"data/actor/hijiri/chant0001.bmp",
   L"data/actor/hijiri/chant0002.bmp",
   L"data/actor/hijiri/chant0003.bmp",
   L"data/actor/hijiri/chant0004.bmp",
   L"data/actor/hijiri/chant0005.bmp",
   L"data/actor/hijiri/chant0006.bmp",
   L"data/actor/hijiri/chant0007.bmp",
   L"data/actor/hijiri/chant0008.bmp",
   L"data/actor/hijiri/chant0009.bmp",
   L"data/actor/hijiri/chant0010.bmp",
   L"data/actor/hijiri/chant0011.bmp",
   L"data/actor/hijiri/climax0000.bmp",
   L"data/actor/hijiri/climax0001.bmp",
   L"data/actor/hijiri/climax0002.bmp",
   L"data/actor/hijiri/climax0003.bmp",
   L"data/actor/hijiri/climax0004.bmp",
   L"data/actor/hijiri/climax0005.bmp",
   L"data/actor/hijiri/climax0006.bmp",
   L"data/actor/hijiri/climax0007.bmp",
   L"data/actor/hijiri/climax0008.bmp",
   L"data/actor/hijiri/climax0009.bmp",
   L"data/actor/hijiri/climax0010.bmp",
   L"data/actor/hijiri/climax0011.bmp",
   L"data/actor/hijiri/climaxcut0000.png",
   L"data/actor/hijiri/damageBody0000.bmp",
   L"data/actor/hijiri/damageBody0001.bmp",
   L"data/actor/hijiri/damageBody0002.bmp",
   L"data/actor/hijiri/damageBody0003.bmp",
   L"data/actor/hijiri/damageBody0004.bmp",
   L"data/actor/hijiri/damageDown0000.bmp",
   L"data/actor/hijiri/damageDown0001.bmp",
   L"data/actor/hijiri/damageDown0002.bmp",
   L"data/actor/hijiri/damageDown0003.bmp",
   L"data/actor/hijiri/damageDown0004.bmp",
   L"data/actor/hijiri/damageDown0005.bmp",
   L"data/actor/hijiri/damageDown0006.bmp",
   L"data/actor/hijiri/damageDown0007.bmp",
   L"data/actor/hijiri/damageDown0008.bmp",
   L"data/actor/hijiri/damageDown0009.bmp",
   L"data/actor/hijiri/damageDown0010.bmp",
   L"data/actor/hijiri/damageDown0011.bmp",
   L"data/actor/hijiri/damageDown0012.bmp",
   L"data/actor/hijiri/damageDown0013.bmp",
   L"data/actor/hijiri/damageDown0014.bmp",
   L"data/actor/hijiri/damageDownLoop0000.bmp",
   L"data/actor/hijiri/damageDownLoop0001.bmp",
   L"data/actor/hijiri/damageDownLoop0002.bmp",
   L"data/actor/hijiri/damageDownLoop0003.bmp",
   L"data/actor/hijiri/damageDownLoop0004.bmp",
   L"data/actor/hijiri/damageHead0000.bmp",
   L"data/actor/hijiri/damageHead0001.bmp",
   L"data/actor/hijiri/damageHead0002.bmp",
   L"data/actor/hijiri/damageHead0003.bmp",
   L"data/actor/hijiri/damageHead0004.bmp",
   L"data/actor/hijiri/damageSpin0000.bmp",
   L"data/actor/hijiri/damageSpin0001.bmp",
   L"data/actor/hijiri/damageSpin0002.bmp",
   L"data/actor/hijiri/damageSpin0003.bmp",
   L"data/actor/hijiri/damageWall0000.bmp",
   L"data/actor/hijiri/damageWall0001.bmp",
   L"data/actor/hijiri/damageWall0002.bmp",
   L"data/actor/hijiri/damageWall0003.bmp",
   L"data/actor/hijiri/damageWall0004.bmp",
   L"data/actor/hijiri/damageWall0005.bmp",
   L"data/actor/hijiri/damageWall0006.bmp",
   L"data/actor/hijiri/dashBack0000.bmp",
   L"data/actor/hijiri/dashBack0001.bmp",
   L"data/actor/hijiri/dashBackB0000.bmp",
   L"data/actor/hijiri/dashBackB0001.bmp",
   L"data/actor/hijiri/dashBackB0002.bmp",
   L"data/actor/hijiri/dashBackB0003.bmp",
   L"data/actor/hijiri/dashBackB0004.bmp",
   L"data/actor/hijiri/dashBackB0005.bmp",
   L"data/actor/hijiri/dashBackB0006.bmp",
   L"data/actor/hijiri/dashBackB0007.bmp",
   L"data/actor/hijiri/dashFront0000.bmp",
   L"data/actor/hijiri/dashFront0001.bmp",
   L"data/actor/hijiri/dashFront0002.bmp",
   L"data/actor/hijiri/dashFront0003.bmp",
   L"data/actor/hijiri/dashFront0004.bmp",
   L"data/actor/hijiri/dashFrontB0000.bmp",
   L"data/actor/hijiri/dashFrontB0001.bmp",
   L"data/actor/hijiri/dashFrontB0002.bmp",
   L"data/actor/hijiri/dashFrontB0003.bmp",
   L"data/actor/hijiri/dashFrontB0004.bmp",
   L"data/actor/hijiri/dashFrontB0005.bmp",
   L"data/actor/hijiri/dashFrontB0006.bmp",
   L"data/actor/hijiri/dashFrontB0007.bmp",
   L"data/actor/hijiri/dokkoA0000.bmp",
   L"data/actor/hijiri/face_spellcallb.png",
   L"data/actor/hijiri/grab0000.bmp",
   L"data/actor/hijiri/grab0001.bmp",
   L"data/actor/hijiri/grab0002.bmp",
   L"data/actor/hijiri/grab0003.bmp",
   L"data/actor/hijiri/grab0004.bmp",
   L"data/actor/hijiri/grab0005.bmp",
   L"data/actor/hijiri/grab_hit0000.bmp",
   L"data/actor/hijiri/grab_hit0001.bmp",
   L"data/actor/hijiri/grab_hit0002.bmp",
   L"data/actor/hijiri/grab_hit0003.bmp",
   L"data/actor/hijiri/grab_hit0004.bmp",
   L"data/actor/hijiri/grab_hit0005.bmp",
   L"data/actor/hijiri/grab_hit0006.bmp",
   L"data/actor/hijiri/grab_hit0007.bmp",
   L"data/actor/hijiri/grab_hit0008.bmp",
   L"data/actor/hijiri/guard0000.bmp",
   L"data/actor/hijiri/guard0001.bmp",
   L"data/actor/hijiri/guard0002.bmp",
   L"data/actor/hijiri/guard0003.bmp",
   L"data/actor/hijiri/guardCrash0000.bmp",
   L"data/actor/hijiri/guardCrash0001.bmp",
   L"data/actor/hijiri/guardCrash0002.bmp",
   L"data/actor/hijiri/guardCrash0003.bmp",
   L"data/actor/hijiri/guardCrash0004.bmp",
   L"data/actor/hijiri/guardCrash0005.bmp",
   L"data/actor/hijiri/guardMiss0000.bmp",
   L"data/actor/hijiri/guardMiss0001.bmp",
   L"data/actor/hijiri/guardMiss0002.bmp",
   L"data/actor/hijiri/guardMiss0003.bmp",
   L"data/actor/hijiri/hijiri.pat",
   L"data/actor/hijiri/hijiri_ed.pat",
   L"data/actor/hijiri/item0000.bmp",
   L"data/actor/hijiri/item0001.bmp",
   L"data/actor/hijiri/item0002.bmp",
   L"data/actor/hijiri/item0003.bmp",
   L"data/actor/hijiri/item0004.bmp",
   L"data/actor/hijiri/item0005.bmp",
   L"data/actor/hijiri/item0006.bmp",
   L"data/actor/hijiri/item0007.bmp",
   L"data/actor/hijiri/item0008.bmp",
   L"data/actor/hijiri/lose0000.bmp",
   L"data/actor/hijiri/lose0001.bmp",
   L"data/actor/hijiri/lose0002.bmp",
   L"data/actor/hijiri/lose0003.bmp",
   L"data/actor/hijiri/lose0004.bmp",
   L"data/actor/hijiri/lose0005.bmp",
   L"data/actor/hijiri/lose0006.bmp",
   L"data/actor/hijiri/lose0007.bmp",
   L"data/actor/hijiri/lose0008.bmp",
   L"data/actor/hijiri/lose0009.bmp",
   L"data/actor/hijiri/model/hijiri_skillG_dome.png",
   L"data/actor/hijiri/occult0000.bmp",
   L"data/actor/hijiri/occult0001.bmp",
   L"data/actor/hijiri/occult0002.bmp",
   L"data/actor/hijiri/occult0003.bmp",
   L"data/actor/hijiri/occult0004.bmp",
   L"data/actor/hijiri/occult0005.bmp",
   L"data/actor/hijiri/occult0006.bmp",
   L"data/actor/hijiri/occult0007.bmp",
   L"data/actor/hijiri/occult0008.bmp",
   L"data/actor/hijiri/occult0009.bmp",
   L"data/actor/hijiri/occult0010.bmp",
   L"data/actor/hijiri/occult0011.bmp",
   L"data/actor/hijiri/occult0012.bmp",
   L"data/actor/hijiri/occult0013.bmp",
   L"data/actor/hijiri/occult0014.bmp",
   L"data/actor/hijiri/palette000.bmp",
   L"data/actor/hijiri/palette001.bmp",
   L"data/actor/hijiri/palette002.bmp",
   L"data/actor/hijiri/palette003.bmp",
   L"data/actor/hijiri/palette004.bmp",
   L"data/actor/hijiri/palette005.bmp",
   L"data/actor/hijiri/palette006.bmp",
   L"data/actor/hijiri/palette007.bmp",
   L"data/actor/hijiri/palette100.bmp",
   L"data/actor/hijiri/palette101.bmp",
   L"data/actor/hijiri/palette102.bmp",
   L"data/actor/hijiri/palette103.bmp",
   L"data/actor/hijiri/palette104.bmp",
   L"data/actor/hijiri/palette105.bmp",
   L"data/actor/hijiri/palette106.bmp",
   L"data/actor/hijiri/palette107.bmp",
   L"data/actor/hijiri/shotHigh0000.bmp",
   L"data/actor/hijiri/shotHigh0001.bmp",
   L"data/actor/hijiri/shotHigh0002.bmp",
   L"data/actor/hijiri/shotHigh0003.bmp",
   L"data/actor/hijiri/shotHigh0004.bmp",
   L"data/actor/hijiri/shotHigh0005.bmp",
   L"data/actor/hijiri/shotHigh0006.bmp",
   L"data/actor/hijiri/shotHigh0007.bmp",
   L"data/actor/hijiri/shotHigh0008.bmp",
   L"data/actor/hijiri/shotHigh0009.bmp",
   L"data/actor/hijiri/shotHigh0010.bmp",
   L"data/actor/hijiri/shotHighFront0000.bmp",
   L"data/actor/hijiri/shotHighFront0001.bmp",
   L"data/actor/hijiri/shotHighFront0002.bmp",
   L"data/actor/hijiri/shotHighFront0003.bmp",
   L"data/actor/hijiri/shotHighFront0004.bmp",
   L"data/actor/hijiri/shotHighFront0005.bmp",
   L"data/actor/hijiri/shotHighFront0006.bmp",
   L"data/actor/hijiri/shotHighFront0007.bmp",
   L"data/actor/hijiri/shotHighFront0008.bmp",
   L"data/actor/hijiri/shotHighFront0009.bmp",
   L"data/actor/hijiri/shotLow0000.bmp",
   L"data/actor/hijiri/shotLow0001.bmp",
   L"data/actor/hijiri/shotLow0002.bmp",
   L"data/actor/hijiri/shotLow0003.bmp",
   L"data/actor/hijiri/shotLow0004.bmp",
   L"data/actor/hijiri/shotLow0005.bmp",
   L"data/actor/hijiri/shotLow0006.bmp",
   L"data/actor/hijiri/shotLow0007.bmp",
   L"data/actor/hijiri/shotLow0008.bmp",
   L"data/actor/hijiri/shotLow0009.bmp",
   L"data/actor/hijiri/skillA0000.bmp",
   L"data/actor/hijiri/skillA0001.bmp",
   L"data/actor/hijiri/skillA0002.bmp",
   L"data/actor/hijiri/skillA0003.bmp",
   L"data/actor/hijiri/skillA0004.bmp",
   L"data/actor/hijiri/skillA0005.bmp",
   L"data/actor/hijiri/skillA0006.bmp",
   L"data/actor/hijiri/skillA0007.bmp",
   L"data/actor/hijiri/skillA0008.bmp",
   L"data/actor/hijiri/skillA0009.bmp",
   L"data/actor/hijiri/skillAb0000.bmp",
   L"data/actor/hijiri/skillAb0001.bmp",
   L"data/actor/hijiri/skillAb0002.bmp",
   L"data/actor/hijiri/skillAb0003.bmp",
   L"data/actor/hijiri/skillAb0004.bmp",
   L"data/actor/hijiri/skillAb0005.bmp",
   L"data/actor/hijiri/skillAb0006.bmp",
   L"data/actor/hijiri/skillAb0007.bmp",
   L"data/actor/hijiri/skillB0000.bmp",
   L"data/actor/hijiri/skillB0001.bmp",
   L"data/actor/hijiri/skillB0002.bmp",
   L"data/actor/hijiri/skillB0003.bmp",
   L"data/actor/hijiri/skillB0004.bmp",
   L"data/actor/hijiri/skillB0005.bmp",
   L"data/actor/hijiri/skillB0006.bmp",
   L"data/actor/hijiri/skillB0007.bmp",
   L"data/actor/hijiri/skillB0008.bmp",
   L"data/actor/hijiri/skillC0000.bmp",
   L"data/actor/hijiri/skillC0001.bmp",
   L"data/actor/hijiri/skillC0002.bmp",
   L"data/actor/hijiri/skillC0003.bmp",
   L"data/actor/hijiri/skillC0004.bmp",
   L"data/actor/hijiri/skillC0005.bmp",
   L"data/actor/hijiri/skillC0006.bmp",
   L"data/actor/hijiri/skillC0007.bmp",
   L"data/actor/hijiri/skillC0008.bmp",
   L"data/actor/hijiri/skillCb0000.bmp",
   L"data/actor/hijiri/skillCb0001.bmp",
   L"data/actor/hijiri/skillCb0002.bmp",
   L"data/actor/hijiri/skillCb0003.bmp",
   L"data/actor/hijiri/skillCb0004.bmp",
   L"data/actor/hijiri/skillCb0005.bmp",
   L"data/actor/hijiri/skillCb0006.bmp",
   L"data/actor/hijiri/skillCb0007.bmp",
   L"data/actor/hijiri/skillCb0008.bmp",
   L"data/actor/hijiri/skillD0000.bmp",
   L"data/actor/hijiri/skillD0001.bmp",
   L"data/actor/hijiri/skillD0002.bmp",
   L"data/actor/hijiri/skillD0003.bmp",
   L"data/actor/hijiri/skillD0004.bmp",
   L"data/actor/hijiri/skillD0005.bmp",
   L"data/actor/hijiri/skillD0006.bmp",
   L"data/actor/hijiri/skillD0007.bmp",
   L"data/actor/hijiri/skillE0000.bmp",
   L"data/actor/hijiri/skillE0001.bmp",
   L"data/actor/hijiri/skillE0002.bmp",
   L"data/actor/hijiri/skillE0003.bmp",
   L"data/actor/hijiri/skillE0004.bmp",
   L"data/actor/hijiri/skillE0005.bmp",
   L"data/actor/hijiri/skillE0006.bmp",
   L"data/actor/hijiri/skillE0007.bmp",
   L"data/actor/hijiri/skillE0008.bmp",
   L"data/actor/hijiri/skillE0009.bmp",
   L"data/actor/hijiri/skillF0000.bmp",
   L"data/actor/hijiri/skillF0001.bmp",
   L"data/actor/hijiri/skillF0002.bmp",
   L"data/actor/hijiri/skillF0003.bmp",
   L"data/actor/hijiri/skillF0004.bmp",
   L"data/actor/hijiri/skillF0005.bmp",
   L"data/actor/hijiri/skillF0006.bmp",
   L"data/actor/hijiri/skillFb0000.bmp",
   L"data/actor/hijiri/skillFb0001.bmp",
   L"data/actor/hijiri/skillFb0002.bmp",
   L"data/actor/hijiri/skillFb0003.bmp",
   L"data/actor/hijiri/skillFb0004.bmp",
   L"data/actor/hijiri/skillFb0005.bmp",
   L"data/actor/hijiri/skillFb0006.bmp",
   L"data/actor/hijiri/skillG0000.bmp",
   L"data/actor/hijiri/skillG0001.bmp",
   L"data/actor/hijiri/skillG0002.bmp",
   L"data/actor/hijiri/skillG0003.bmp",
   L"data/actor/hijiri/skillG0004.bmp",
   L"data/actor/hijiri/skillG0005.bmp",
   L"data/actor/hijiri/skillG0006.bmp",
   L"data/actor/hijiri/skillG0007.bmp",
   L"data/actor/hijiri/skillG0008.bmp",
   L"data/actor/hijiri/skillG0009.bmp",
   L"data/actor/hijiri/skillG0010.bmp",
   L"data/actor/hijiri/skillG0011.bmp",
   L"data/actor/hijiri/skillG0012.bmp",
   L"data/actor/hijiri/skillG0013.bmp",
   L"data/actor/hijiri/skillG0014.bmp",
   L"data/actor/hijiri/skill_v_chop0000.bmp",
   L"data/actor/hijiri/skill_v_chop0001.bmp",
   L"data/actor/hijiri/skill_v_chop0002.bmp",
   L"data/actor/hijiri/skill_v_chop0003.bmp",
   L"data/actor/hijiri/skill_v_chop0004.bmp",
   L"data/actor/hijiri/skill_v_chop0005.bmp",
   L"data/actor/hijiri/skill_v_chop0006.bmp",
   L"data/actor/hijiri/skill_v_chop0007.bmp",
   L"data/actor/hijiri/skill_v_chop0008.bmp",
   L"data/actor/hijiri/slide0000.bmp",
   L"data/actor/hijiri/slide0001.bmp",
   L"data/actor/hijiri/slide0002.bmp",
   L"data/actor/hijiri/slide0003.bmp",
   L"data/actor/hijiri/slide0004.bmp",
   L"data/actor/hijiri/slide0005.bmp",
   L"data/actor/hijiri/slide0006.bmp",
   L"data/actor/hijiri/slide0007.bmp",
   L"data/actor/hijiri/slide0008.bmp",
   L"data/actor/hijiri/slide0009.bmp",
   L"data/actor/hijiri/slideUnderLoop0000.bmp",
   L"data/actor/hijiri/slideUnderLoop0001.bmp",
   L"data/actor/hijiri/slideUnderLoop0002.bmp",
   L"data/actor/hijiri/slideUnderLoop0003.bmp",
   L"data/actor/hijiri/slideUnderLoop0004.bmp",
   L"data/actor/hijiri/slideUpperLoop0000.bmp",
   L"data/actor/hijiri/slideUpperLoop0001.bmp",
   L"data/actor/hijiri/slideUpperLoop0002.bmp",
   L"data/actor/hijiri/slideUpperLoop0003.bmp",
   L"data/actor/hijiri/slideUpperLoop0004.bmp",
   L"data/actor/hijiri/spellB0000.bmp",
   L"data/actor/hijiri/spellB0001.bmp",
   L"data/actor/hijiri/spellB0002.bmp",
   L"data/actor/hijiri/spellB0003.bmp",
   L"data/actor/hijiri/spellB0004.bmp",
   L"data/actor/hijiri/spellB0005.bmp",
   L"data/actor/hijiri/spellB0006.bmp",
   L"data/actor/hijiri/spellB0007.bmp",
   L"data/actor/hijiri/spellB0008.bmp",
   L"data/actor/hijiri/spellB0009.bmp",
   L"data/actor/hijiri/spellB0010.bmp",
   L"data/actor/hijiri/spellB0011.bmp",
   L"data/actor/hijiri/spellB0012.bmp",
   L"data/actor/hijiri/spellB0013.bmp",
   L"data/actor/hijiri/spellB0014.bmp",
   L"data/actor/hijiri/spellC0000.bmp",
   L"data/actor/hijiri/spellC0001.bmp",
   L"data/actor/hijiri/spellC0002.bmp",
   L"data/actor/hijiri/spellC0003.bmp",
   L"data/actor/hijiri/spellC0004.bmp",
   L"data/actor/hijiri/spellC0005.bmp",
   L"data/actor/hijiri/spellC0006.bmp",
   L"data/actor/hijiri/spellC0007.bmp",
   L"data/actor/hijiri/spellC0008.bmp",
   L"data/actor/hijiri/spellC0009.bmp",
   L"data/actor/hijiri/spellC0010.bmp",
   L"data/actor/hijiri/spellC0011.bmp",
   L"data/actor/hijiri/spellC0012.bmp",
   L"data/actor/hijiri/spellC0013.bmp",
   L"data/actor/hijiri/spellC0014.bmp",
   L"data/actor/hijiri/spellC0015.bmp",
   L"data/actor/hijiri/spellC0016.bmp",
   L"data/actor/hijiri/spellC0017.bmp",
   L"data/actor/hijiri/spellC0018.bmp",
   L"data/actor/hijiri/stand0000.bmp",
   L"data/actor/hijiri/stand0001.bmp",
   L"data/actor/hijiri/stand0002.bmp",
   L"data/actor/hijiri/stand0003.bmp",
   L"data/actor/hijiri/stand0004.bmp",
   L"data/actor/hijiri/stand0005.bmp",
   L"data/actor/hijiri/stand0006.bmp",
   L"data/actor/hijiri/stand0007.bmp",
   L"data/actor/hijiri/stand0008.bmp",
   L"data/actor/hijiri/stand0009.bmp",
   L"data/actor/hijiri/stand0010.bmp",
   L"data/actor/hijiri/stand0011.bmp",
   L"data/actor/hijiri/stand0012.bmp",
   L"data/actor/hijiri/stand0013.bmp",
   L"data/actor/hijiri/stun0000.bmp",
   L"data/actor/hijiri/stun0001.bmp",
   L"data/actor/hijiri/stun0002.bmp",
   L"data/actor/hijiri/stun0003.bmp",
   L"data/actor/hijiri/stun0004.bmp",
   L"data/actor/hijiri/stun0005.bmp",
   L"data/actor/hijiri/stun0006.bmp",
   L"data/actor/hijiri/stun0007.bmp",
   L"data/actor/hijiri/stun0008.bmp",
   L"data/actor/hijiri/team_begin_A0000.bmp",
   L"data/actor/hijiri/team_begin_A0001.bmp",
   L"data/actor/hijiri/team_begin_A0002.bmp",
   L"data/actor/hijiri/team_begin_A0003.bmp",
   L"data/actor/hijiri/team_begin_A0004.bmp",
   L"data/actor/hijiri/team_begin_A0005.bmp",
   L"data/actor/hijiri/team_begin_A0006.bmp",
   L"data/actor/hijiri/test_occult0001.bmp",
   L"data/actor/hijiri/texture/assultTrailA0000.png",
   L"data/actor/hijiri/texture/atkEffectA0000.png",
   L"data/actor/hijiri/texture/atkEffectA0001.png",
   L"data/actor/hijiri/texture/atkEffectA0002.png",
   L"data/actor/hijiri/texture/atkEffectA0003.png",
   L"data/actor/hijiri/texture/atkEffectA0004.png",
   L"data/actor/hijiri/texture/atkEffectA0005.png",
   L"data/actor/hijiri/texture/atkEffectA0006.png",
   L"data/actor/hijiri/texture/atkEffectA0007.png",
   L"data/actor/hijiri/texture/atkEffectA0008.png",
   L"data/actor/hijiri/texture/atkEffectA0009.png",
   L"data/actor/hijiri/texture/atkEffectA0010.png",
   L"data/actor/hijiri/texture/atkEffectA0011.png",
   L"data/actor/hijiri/texture/atkEffectA0012.png",
   L"data/actor/hijiri/texture/atkEffectA0013.png",
   L"data/actor/hijiri/texture/atkEffectA0014.png",
   L"data/actor/hijiri/texture/ball.bmp",
   L"data/actor/hijiri/texture/bikeLight0000.png",
   L"data/actor/hijiri/texture/bike_back0000.bmp",
   L"data/actor/hijiri/texture/bladeA0000.png",
   L"data/actor/hijiri/texture/bladeB0000.png",
   L"data/actor/hijiri/texture/bladeC0000.png",
   L"data/actor/hijiri/texture/bladeD0000.png",
   L"data/actor/hijiri/texture/bladeE0000.png",
   L"data/actor/hijiri/texture/chouzyuuA.png",
   L"data/actor/hijiri/texture/climaxAuraA.png",
   L"data/actor/hijiri/texture/climaxBack.png",
   L"data/actor/hijiri/texture/climaxLaserA0000.png",
   L"data/actor/hijiri/texture/climaxLaserCore.dds",
   L"data/actor/hijiri/texture/climax_lineObject.png",
   L"data/actor/hijiri/texture/face_master_hijiri.png",
   L"data/actor/hijiri/texture/face_master_hijiri2.png",
   L"data/actor/hijiri/texture/face_slave_hijiri.png",
   L"data/actor/hijiri/texture/face_spell_cut.png",
   L"data/actor/hijiri/texture/flare.bmp",
   L"data/actor/hijiri/texture/hijirimoji.png",
   L"data/actor/hijiri/texture/hijiri_animalDamage000.png",
   L"data/actor/hijiri/texture/hijiri_animalDamage001.png",
   L"data/actor/hijiri/texture/hijiri_animalDamage002.png",
   L"data/actor/hijiri/texture/hijiri_animalDamage003.png",
   L"data/actor/hijiri/texture/hijiri_animal_00000.png",
   L"data/actor/hijiri/texture/hijiri_animal_00001.png",
   L"data/actor/hijiri/texture/hijiri_animal_00002.png",
   L"data/actor/hijiri/texture/hijiri_animal_00003.png",
   L"data/actor/hijiri/texture/hijiri_animal_00004.png",
   L"data/actor/hijiri/texture/hijiri_animal_00005.png",
   L"data/actor/hijiri/texture/hijiri_animal_00006.png",
   L"data/actor/hijiri/texture/hijiri_animal_00007.png",
   L"data/actor/hijiri/texture/hijiri_animal_00008.png",
   L"data/actor/hijiri/texture/hijiri_animal_00009.png",
   L"data/actor/hijiri/texture/hijiri_animal_00010.png",
   L"data/actor/hijiri/texture/hijiri_animal_00011.png",
   L"data/actor/hijiri/texture/hijiri_climaxeffect.png",
   L"data/actor/hijiri/texture/hijiri_skillG.dds",
   L"data/actor/hijiri/texture/hijiri_skillG_Flash.dds",
   L"data/actor/hijiri/texture/hijiri_spellC_Pilar.dds",
   L"data/actor/hijiri/texture/kona_A.bmp",
   L"data/actor/hijiri/texture/lightningA.dds",
   L"data/actor/hijiri/texture/lightning_mapA.png",
   L"data/actor/hijiri/texture/lotus.png",
   L"data/actor/hijiri/texture/marisaBall2.bmp",
   L"data/actor/hijiri/texture/marisaStarFlare.bmp",
   L"data/actor/hijiri/texture/mask_ball.png",
   L"data/actor/hijiri/texture/ofudaHit.bmp",
   L"data/actor/hijiri/texture/reimu_fallKick.png",
   L"data/actor/hijiri/texture/reimu_wallA_mask.png",
   L"data/actor/hijiri/texture/scrollA0000.bmp",
   L"data/actor/hijiri/texture/scrollA0001.bmp",
   L"data/actor/hijiri/texture/scrollA0002.bmp",
   L"data/actor/hijiri/texture/scrollA0003.bmp",
   L"data/actor/hijiri/texture/scrollA0004.bmp",
   L"data/actor/hijiri/texture/scrollA0005.bmp",
   L"data/actor/hijiri/texture/scrollB0000.bmp",
   L"data/actor/hijiri/texture/scrollB0001.bmp",
   L"data/actor/hijiri/texture/scrollB0002.bmp",
   L"data/actor/hijiri/texture/scrollBm0000.bmp",
   L"data/actor/hijiri/texture/scrollBm0001.bmp",
   L"data/actor/hijiri/texture/scrollBm0002.bmp",
   L"data/actor/hijiri/texture/scrollC0000.bmp",
   L"data/actor/hijiri/texture/scrollC0001.bmp",
   L"data/actor/hijiri/texture/scrollC0002.bmp",
   L"data/actor/hijiri/texture/scrollC0003.bmp",
   L"data/actor/hijiri/texture/scrollC0004.bmp",
   L"data/actor/hijiri/texture/scrollC0005.bmp",
   L"data/actor/hijiri/texture/skillB.png",
   L"data/actor/hijiri/texture/skillG_Aura.dds",
   L"data/actor/hijiri/texture/slide0000.png",
   L"data/actor/hijiri/texture/smoke.png",
   L"data/actor/hijiri/texture/spark_object0000.dds",
   L"data/actor/hijiri/texture/spellCharge.png",
   L"data/actor/hijiri/texture/spellC_chopA.png",
   L"data/actor/hijiri/texture/spellC_chopA2.png",
   L"data/actor/hijiri/texture/spellC_Pilar.dds",
   L"data/actor/hijiri/texture/spell_use_cut.png",
   L"data/actor/hijiri/texture/stoneA0000.png",
   L"data/actor/hijiri/texture/tornadeBase0000.png",
   L"data/actor/hijiri/texture/tornadebase0001.png",
   L"data/actor/hijiri/texture/tornadeBase0002.png",
   L"data/actor/hijiri/texture/trail.png",
   L"data/actor/hijiri/turn0000.bmp",
   L"data/actor/hijiri/turn0001.bmp",
   L"data/actor/hijiri/turn0002.bmp",
   L"data/actor/hijiri/walkBack0000.bmp",
   L"data/actor/hijiri/walkBack0001.bmp",
   L"data/actor/hijiri/walkBack0002.bmp",
   L"data/actor/hijiri/walkBack0003.bmp",
   L"data/actor/hijiri/walkBack0004.bmp",
   L"data/actor/hijiri/walkBack0005.bmp",
   L"data/actor/hijiri/walkBackLoop0000.bmp",
   L"data/actor/hijiri/walkBackLoop0001.bmp",
   L"data/actor/hijiri/walkBackLoop0002.bmp",
   L"data/actor/hijiri/walkBackLoop0003.bmp",
   L"data/actor/hijiri/walkBackLoop0004.bmp",
   L"data/actor/hijiri/walkFront0000.bmp",
   L"data/actor/hijiri/walkFront0001.bmp",
   L"data/actor/hijiri/walkFront0002.bmp",
   L"data/actor/hijiri/walkFront0003.bmp",
   L"data/actor/hijiri/walkFront0004.bmp",
   L"data/actor/hijiri/walkFront0005.bmp",
   L"data/actor/hijiri/walkFront0006.bmp",
   L"data/actor/hijiri/walkFrontLoop0000.bmp",
   L"data/actor/hijiri/walkFrontLoop0001.bmp",
   L"data/actor/hijiri/walkFrontLoop0002.bmp",
   L"data/actor/hijiri/walkFrontLoop0003.bmp",
   L"data/actor/hijiri/walkFrontLoop0004.bmp",
   L"data/actor/hijiri/winB0000.bmp",
   L"data/actor/hijiri/winB0001.bmp",
   L"data/actor/hijiri/winB0002.bmp",
   L"data/actor/hijiri/winB0003.bmp",
   L"data/actor/hijiri/winB0004.bmp",
   L"data/actor/hijiri/winB0005.bmp",
   L"data/actor/hijiri/winC0000.bmp",
   L"data/actor/hijiri/winC0001.bmp",
   L"data/actor/hijiri/winC0002.bmp",
   L"data/actor/hijiri/winC0003.bmp",
   L"data/actor/hijiri/winC0004.bmp",
   L"data/actor/hijiri/winC0005.bmp",
   L"data/actor/hijiri/winC0006.bmp",
   L"data/actor/hijiri/winC0007.bmp",
   L"data/actor/hijiri/winC0008.bmp",
   L"data/actor/hijiri/winC0009.bmp",
   L"data/actor/hijiri/winD0000.bmp",
   L"data/actor/hijiri/winD0001.bmp",
   L"data/actor/hijiri/winD0002.bmp",
   L"data/actor/hijiri/winD0003.bmp",
   L"data/actor/hijiri/winD0004.bmp",
   L"data/actor/hijiri/winD0005.bmp",
   L"data/actor/hijiri/winD0006.bmp",
   L"data/actor/hijiri/winD0007.bmp",
   L"data/actor/hijiri/winD0008.bmp",
   L"data/actor/hijiri/winD0009.bmp",
   L"data/actor/hijiri.nut",
   L"data/actor/hijiri_base.nut",
   L"data/actor/hijiri_boss.nut",
   L"data/actor/hijiri_boss_base.nut",
   L"data/actor/hijiri_boss_init.nut",
   L"data/actor/hijiri_boss_shot.nut",
   L"data/actor/hijiri_com.nut",
   L"data/actor/hijiri_combo.nut",
   L"data/actor/hijiri_com_function.nut",
   L"data/actor/hijiri_init.nut",
   L"data/actor/hijiri_practice_init.nut",
   L"data/actor/hijiri_shot.nut",
   L"data/actor/hijiri_team.nut",
   L"data/actor/ichirin/armA.png",
   L"data/actor/ichirin/armB.png",
   L"data/actor/ichirin/armB_b.png",
   L"data/actor/ichirin/atkLowA0000.bmp",
   L"data/actor/ichirin/atkLowA0001.bmp",
   L"data/actor/ichirin/atkLowA0002.bmp",
   L"data/actor/ichirin/atkLowA0003.bmp",
   L"data/actor/ichirin/atkLowA0004.bmp",
   L"data/actor/ichirin/atkLowB0000.bmp",
   L"data/actor/ichirin/atkLowB0001.bmp",
   L"data/actor/ichirin/atkLowB0002.bmp",
   L"data/actor/ichirin/atkLowB0003.bmp",
   L"data/actor/ichirin/atkLowB0004.bmp",
   L"data/actor/ichirin/atkLowB0005.bmp",
   L"data/actor/ichirin/atk_HighDash0000.bmp",
   L"data/actor/ichirin/atk_HighDash0001.bmp",
   L"data/actor/ichirin/atk_HighDash0002.bmp",
   L"data/actor/ichirin/atk_HighDash0003.bmp",
   L"data/actor/ichirin/atk_HighDash0004.bmp",
   L"data/actor/ichirin/atk_HighDash0005.bmp",
   L"data/actor/ichirin/atk_HighDash0006.bmp",
   L"data/actor/ichirin/atk_HighDash0007.bmp",
   L"data/actor/ichirin/atk_HighFront0000.bmp",
   L"data/actor/ichirin/atk_HighFront0001.bmp",
   L"data/actor/ichirin/atk_HighFront0002.bmp",
   L"data/actor/ichirin/atk_HighFront0003.bmp",
   L"data/actor/ichirin/atk_HighFront0004.bmp",
   L"data/actor/ichirin/atk_HighFront0005.bmp",
   L"data/actor/ichirin/atk_HighFront0006.bmp",
   L"data/actor/ichirin/atk_HighFront0007.bmp",
   L"data/actor/ichirin/atk_HighFront0008.bmp",
   L"data/actor/ichirin/atk_HighFront0009.bmp",
   L"data/actor/ichirin/atk_HighFront0010.bmp",
   L"data/actor/ichirin/atk_HighFront0011.bmp",
   L"data/actor/ichirin/atk_HighUnder0000.bmp",
   L"data/actor/ichirin/atk_HighUnder0001.bmp",
   L"data/actor/ichirin/atk_HighUnder0002.bmp",
   L"data/actor/ichirin/atk_HighUnder0003.bmp",
   L"data/actor/ichirin/atk_HighUnder0004.bmp",
   L"data/actor/ichirin/atk_HighUnder0005.bmp",
   L"data/actor/ichirin/atk_HighUnder0006.bmp",
   L"data/actor/ichirin/atk_HighUnder0007.bmp",
   L"data/actor/ichirin/atk_HighUnder0008.bmp",
   L"data/actor/ichirin/atk_HighUnder0009.bmp",
   L"data/actor/ichirin/atk_HighUnder0010.bmp",
   L"data/actor/ichirin/atk_HighUpper0000.bmp",
   L"data/actor/ichirin/atk_HighUpper0001.bmp",
   L"data/actor/ichirin/atk_HighUpper0002.bmp",
   L"data/actor/ichirin/atk_HighUpper0003.bmp",
   L"data/actor/ichirin/atk_HighUpper0004.bmp",
   L"data/actor/ichirin/atk_HighUpper0005.bmp",
   L"data/actor/ichirin/atk_HighUpper0006.bmp",
   L"data/actor/ichirin/atk_HighUpper0007.bmp",
   L"data/actor/ichirin/atk_HighUpper0008.bmp",
   L"data/actor/ichirin/atk_HighUpper0009.bmp",
   L"data/actor/ichirin/atk_HighUpper0010.bmp",
   L"data/actor/ichirin/atk_HighUpperB0000.bmp",
   L"data/actor/ichirin/atk_HighUpperB0001.bmp",
   L"data/actor/ichirin/atk_HighUpperB0002.bmp",
   L"data/actor/ichirin/atk_HighUpperB0003.bmp",
   L"data/actor/ichirin/atk_HighUpperB0004.bmp",
   L"data/actor/ichirin/atk_HighUpperB0005.bmp",
   L"data/actor/ichirin/atk_HighUpperB0006.bmp",
   L"data/actor/ichirin/atk_HighUpperB0007.bmp",
   L"data/actor/ichirin/atk_HighUpperB0008.bmp",
   L"data/actor/ichirin/atk_HighUpperB0009.bmp",
   L"data/actor/ichirin/atk_HighUpperB0010.bmp",
   L"data/actor/ichirin/atk_HighUpperB0011.bmp",
   L"data/actor/ichirin/atk_HighUpperB0012.bmp",
   L"data/actor/ichirin/atk_HighUpperB0013.bmp",
   L"data/actor/ichirin/atk_MidA0000.bmp",
   L"data/actor/ichirin/atk_MidA0001.bmp",
   L"data/actor/ichirin/atk_MidA0002.bmp",
   L"data/actor/ichirin/atk_MidA0003.bmp",
   L"data/actor/ichirin/atk_MidA0004.bmp",
   L"data/actor/ichirin/atk_MidA0005.bmp",
   L"data/actor/ichirin/atk_MidA0006.bmp",
   L"data/actor/ichirin/atk_MidA0007.bmp",
   L"data/actor/ichirin/battleBeginB0000.bmp",
   L"data/actor/ichirin/battleBeginB0001.bmp",
   L"data/actor/ichirin/battleBeginB0002.bmp",
   L"data/actor/ichirin/battleBeginB0003.bmp",
   L"data/actor/ichirin/battleBeginB0004.bmp",
   L"data/actor/ichirin/battleBeginB0005.bmp",
   L"data/actor/ichirin/battleBeginB0006.bmp",
   L"data/actor/ichirin/battleBeginB0007.bmp",
   L"data/actor/ichirin/battleBeginB0008.bmp",
   L"data/actor/ichirin/battleBeginBLoop0000.bmp",
   L"data/actor/ichirin/battleBeginBLoop0001.bmp",
   L"data/actor/ichirin/battleBeginBLoop0002.bmp",
   L"data/actor/ichirin/battleBeginBLoop0003.bmp",
   L"data/actor/ichirin/battleBeginBLoop0004.bmp",
   L"data/actor/ichirin/begin0000.bmp",
   L"data/actor/ichirin/begin0001.bmp",
   L"data/actor/ichirin/begin0002.bmp",
   L"data/actor/ichirin/beginLoop0000.bmp",
   L"data/actor/ichirin/beginLoop0001.bmp",
   L"data/actor/ichirin/beginLoop0002.bmp",
   L"data/actor/ichirin/beginLoop0003.bmp",
   L"data/actor/ichirin/beginLoop0004.bmp",
   L"data/actor/ichirin/bmsln/ichirin_fistHitA.bmb",
   L"data/actor/ichirin/bmsln/ichirin_sparkHand.bmb",
   L"data/actor/ichirin/bmsln/ichirin_sparkHandB.bmb",
   L"data/actor/ichirin/climax0000.bmp",
   L"data/actor/ichirin/climax0001.bmp",
   L"data/actor/ichirin/climax0002.bmp",
   L"data/actor/ichirin/climax0003.bmp",
   L"data/actor/ichirin/climaxLoop0000.bmp",
   L"data/actor/ichirin/climaxLoop0001.bmp",
   L"data/actor/ichirin/climaxLoop0002.bmp",
   L"data/actor/ichirin/climaxLoop0003.bmp",
   L"data/actor/ichirin/climaxLoop0004.bmp",
   L"data/actor/ichirin/climaxLoopB0000.bmp",
   L"data/actor/ichirin/climaxLoopB0001.bmp",
   L"data/actor/ichirin/climaxLoopB0002.bmp",
   L"data/actor/ichirin/climaxLoopB0003.bmp",
   L"data/actor/ichirin/climaxLoopB0004.bmp",
   L"data/actor/ichirin/cut0000.png",
   L"data/actor/ichirin/cut0001.png",
   L"data/actor/ichirin/damageBody0000.bmp",
   L"data/actor/ichirin/damageBody0001.bmp",
   L"data/actor/ichirin/damageBody0002.bmp",
   L"data/actor/ichirin/damageBody0003.bmp",
   L"data/actor/ichirin/damageBody0004.bmp",
   L"data/actor/ichirin/damageDownLoop0000.bmp",
   L"data/actor/ichirin/damageDownLoop0001.bmp",
   L"data/actor/ichirin/damageDownLoop0002.bmp",
   L"data/actor/ichirin/damageDownLoop0003.bmp",
   L"data/actor/ichirin/damageDownLoop0004.bmp",
   L"data/actor/ichirin/damageHead0000.bmp",
   L"data/actor/ichirin/damageHead0001.bmp",
   L"data/actor/ichirin/damageHead0002.bmp",
   L"data/actor/ichirin/damageHead0003.bmp",
   L"data/actor/ichirin/damageHead0004.bmp",
   L"data/actor/ichirin/damageSpin0000.bmp",
   L"data/actor/ichirin/damageSpin0001.bmp",
   L"data/actor/ichirin/damageSpin0002.bmp",
   L"data/actor/ichirin/damageSpin0003.bmp",
   L"data/actor/ichirin/damageUnderLoopA0000.bmp",
   L"data/actor/ichirin/damageUnderLoopA0001.bmp",
   L"data/actor/ichirin/damageUpper0000.bmp",
   L"data/actor/ichirin/damageUpper0001.bmp",
   L"data/actor/ichirin/damageUpper0002.bmp",
   L"data/actor/ichirin/damageUpper0003.bmp",
   L"data/actor/ichirin/damageUpper0004.bmp",
   L"data/actor/ichirin/damageUpper0005.bmp",
   L"data/actor/ichirin/damageUpper0006.bmp",
   L"data/actor/ichirin/damageUpper0007.bmp",
   L"data/actor/ichirin/damageUpper0008.bmp",
   L"data/actor/ichirin/damageUpperLoopA0000.bmp",
   L"data/actor/ichirin/damageUpperLoopA0001.bmp",
   L"data/actor/ichirin/damageWall0000.bmp",
   L"data/actor/ichirin/damageWall0001.bmp",
   L"data/actor/ichirin/damageWall0002.bmp",
   L"data/actor/ichirin/damageWall0003.bmp",
   L"data/actor/ichirin/damageWall0004.bmp",
   L"data/actor/ichirin/damageWall0005.bmp",
   L"data/actor/ichirin/damageWall0006.bmp",
   L"data/actor/ichirin/dashBack0000.bmp",
   L"data/actor/ichirin/dashBack0001.bmp",
   L"data/actor/ichirin/dashBack0002.bmp",
   L"data/actor/ichirin/dashBack0003.bmp",
   L"data/actor/ichirin/dashBack0004.bmp",
   L"data/actor/ichirin/dashBack0005.bmp",
   L"data/actor/ichirin/dashBack0006.bmp",
   L"data/actor/ichirin/dashBack0007.bmp",
   L"data/actor/ichirin/dashBackLoop0000.bmp",
   L"data/actor/ichirin/dashBackLoop0001.bmp",
   L"data/actor/ichirin/dashBackLoop0002.bmp",
   L"data/actor/ichirin/dashBackLoop0003.bmp",
   L"data/actor/ichirin/dashBackLoop0004.bmp",
   L"data/actor/ichirin/dashFront0000.bmp",
   L"data/actor/ichirin/dashFront0001.bmp",
   L"data/actor/ichirin/dashFront0002.bmp",
   L"data/actor/ichirin/dashFront0003.bmp",
   L"data/actor/ichirin/dashFront0004.bmp",
   L"data/actor/ichirin/dashFront0005.bmp",
   L"data/actor/ichirin/dashFront0006.bmp",
   L"data/actor/ichirin/dashFront0007.bmp",
   L"data/actor/ichirin/dashFront0008.bmp",
   L"data/actor/ichirin/dashFrontLoop0000.bmp",
   L"data/actor/ichirin/dashFrontLoop0001.bmp",
   L"data/actor/ichirin/dashFrontLoop0002.bmp",
   L"data/actor/ichirin/dashFrontLoop0003.bmp",
   L"data/actor/ichirin/dashFrontLoop0004.bmp",
   L"data/actor/ichirin/down0000.bmp",
   L"data/actor/ichirin/down0001.bmp",
   L"data/actor/ichirin/down0002.bmp",
   L"data/actor/ichirin/down0003.bmp",
   L"data/actor/ichirin/down0004.bmp",
   L"data/actor/ichirin/draw0000.bmp",
   L"data/actor/ichirin/draw0001.bmp",
   L"data/actor/ichirin/draw0002.bmp",
   L"data/actor/ichirin/draw0003.bmp",
   L"data/actor/ichirin/draw0004.bmp",
   L"data/actor/ichirin/dummy.bmp",
   L"data/actor/ichirin/face_spellcallb.png",
   L"data/actor/ichirin/grab0000.bmp",
   L"data/actor/ichirin/grab0001.bmp",
   L"data/actor/ichirin/grab0002.bmp",
   L"data/actor/ichirin/grab0003.bmp",
   L"data/actor/ichirin/grab0004.bmp",
   L"data/actor/ichirin/grab0005.bmp",
   L"data/actor/ichirin/grab0006.bmp",
   L"data/actor/ichirin/grab_hit0000.bmp",
   L"data/actor/ichirin/grab_hit0001.bmp",
   L"data/actor/ichirin/grab_hit0002.bmp",
   L"data/actor/ichirin/grab_hit0003.bmp",
   L"data/actor/ichirin/grab_hit0004.bmp",
   L"data/actor/ichirin/grab_hit0005.bmp",
   L"data/actor/ichirin/grab_hit0006.bmp",
   L"data/actor/ichirin/grab_hit0007.bmp",
   L"data/actor/ichirin/grab_hit0008.bmp",
   L"data/actor/ichirin/grab_hit0009.bmp",
   L"data/actor/ichirin/grab_hit0010.bmp",
   L"data/actor/ichirin/grab_hit0011.bmp",
   L"data/actor/ichirin/grab_hit0012.bmp",
   L"data/actor/ichirin/grab_hit0013.bmp",
   L"data/actor/ichirin/guard0000.bmp",
   L"data/actor/ichirin/guard0001.bmp",
   L"data/actor/ichirin/guard0002.bmp",
   L"data/actor/ichirin/guard0003.bmp",
   L"data/actor/ichirin/guardCrash0000.bmp",
   L"data/actor/ichirin/guardCrash0001.bmp",
   L"data/actor/ichirin/guardCrash0002.bmp",
   L"data/actor/ichirin/guardCrash0003.bmp",
   L"data/actor/ichirin/guardCrash0004.bmp",
   L"data/actor/ichirin/hand1A.png",
   L"data/actor/ichirin/hand1B.png",
   L"data/actor/ichirin/hand2A.png",
   L"data/actor/ichirin/hand2B.png",
   L"data/actor/ichirin/hand3A.png",
   L"data/actor/ichirin/hand3B.png",
   L"data/actor/ichirin/head1.png",
   L"data/actor/ichirin/head2.png",
   L"data/actor/ichirin/ichirin.pat",
   L"data/actor/ichirin/ichirin_ed.pat",
   L"data/actor/ichirin/item0000.bmp",
   L"data/actor/ichirin/item0001.bmp",
   L"data/actor/ichirin/item0002.bmp",
   L"data/actor/ichirin/item0003.bmp",
   L"data/actor/ichirin/item0004.bmp",
   L"data/actor/ichirin/item0005.bmp",
   L"data/actor/ichirin/item0006.bmp",
   L"data/actor/ichirin/item0007.bmp",
   L"data/actor/ichirin/item0008.bmp",
   L"data/actor/ichirin/item0009.bmp",
   L"data/actor/ichirin/itemLoop0000.bmp",
   L"data/actor/ichirin/itemLoop0001.bmp",
   L"data/actor/ichirin/itemLoop0002.bmp",
   L"data/actor/ichirin/itemLoop0003.bmp",
   L"data/actor/ichirin/lose0000.bmp",
   L"data/actor/ichirin/lose0001.bmp",
   L"data/actor/ichirin/lose0002.bmp",
   L"data/actor/ichirin/lose0003.bmp",
   L"data/actor/ichirin/lose0004.bmp",
   L"data/actor/ichirin/lose0005.bmp",
   L"data/actor/ichirin/occult0000.bmp",
   L"data/actor/ichirin/occult0001.bmp",
   L"data/actor/ichirin/occult0002.bmp",
   L"data/actor/ichirin/occult0003.bmp",
   L"data/actor/ichirin/occult0004.bmp",
   L"data/actor/ichirin/occult0005.bmp",
   L"data/actor/ichirin/occult0006.bmp",
   L"data/actor/ichirin/occult0007.bmp",
   L"data/actor/ichirin/occultobject0000.bmp",
   L"data/actor/ichirin/occultobject0001.bmp",
   L"data/actor/ichirin/occultobject0002.bmp",
   L"data/actor/ichirin/occultobject0003.bmp",
   L"data/actor/ichirin/occultobject0004.bmp",
   L"data/actor/ichirin/occultobject0005.bmp",
   L"data/actor/ichirin/palette000.bmp",
   L"data/actor/ichirin/palette001.bmp",
   L"data/actor/ichirin/palette002.bmp",
   L"data/actor/ichirin/palette003.bmp",
   L"data/actor/ichirin/palette004.bmp",
   L"data/actor/ichirin/palette005.bmp",
   L"data/actor/ichirin/palette006.bmp",
   L"data/actor/ichirin/palette007.bmp",
   L"data/actor/ichirin/palette100.bmp",
   L"data/actor/ichirin/palette101.bmp",
   L"data/actor/ichirin/palette102.bmp",
   L"data/actor/ichirin/palette103.bmp",
   L"data/actor/ichirin/palette104.bmp",
   L"data/actor/ichirin/palette105.bmp",
   L"data/actor/ichirin/palette106.bmp",
   L"data/actor/ichirin/palette107.bmp",
   L"data/actor/ichirin/shotA0000.bmp",
   L"data/actor/ichirin/shotA0001.bmp",
   L"data/actor/ichirin/shotA0002.bmp",
   L"data/actor/ichirin/shotA0003.bmp",
   L"data/actor/ichirin/shotA0004.bmp",
   L"data/actor/ichirin/shotA0005.bmp",
   L"data/actor/ichirin/shotA0006.bmp",
   L"data/actor/ichirin/shotA0007.bmp",
   L"data/actor/ichirin/shotA0008.bmp",
   L"data/actor/ichirin/shotA0009.bmp",
   L"data/actor/ichirin/shotA0010.bmp",
   L"data/actor/ichirin/shotA0011.bmp",
   L"data/actor/ichirin/shotA_Front0000.bmp",
   L"data/actor/ichirin/shotA_Front0001.bmp",
   L"data/actor/ichirin/shotA_Front0002.bmp",
   L"data/actor/ichirin/shotA_Front0003.bmp",
   L"data/actor/ichirin/shotA_Front0004.bmp",
   L"data/actor/ichirin/shotA_Front0005.bmp",
   L"data/actor/ichirin/shotA_Front0006.bmp",
   L"data/actor/ichirin/shotA_Front0007.bmp",
   L"data/actor/ichirin/shotA_Front0008.bmp",
   L"data/actor/ichirin/shotA_Loop0000.bmp",
   L"data/actor/ichirin/shotA_Loop0001.bmp",
   L"data/actor/ichirin/shotA_Loop0002.bmp",
   L"data/actor/ichirin/shotA_LoopB0000.bmp",
   L"data/actor/ichirin/shotA_LoopB0001.bmp",
   L"data/actor/ichirin/shotA_LoopB0002.bmp",
   L"data/actor/ichirin/shotB0000.bmp",
   L"data/actor/ichirin/shotB0001.bmp",
   L"data/actor/ichirin/shotB0002.bmp",
   L"data/actor/ichirin/shotB0003.bmp",
   L"data/actor/ichirin/shotB0004.bmp",
   L"data/actor/ichirin/shotB0005.bmp",
   L"data/actor/ichirin/shotB0006.bmp",
   L"data/actor/ichirin/shotB0007.bmp",
   L"data/actor/ichirin/shotB0008.bmp",
   L"data/actor/ichirin/shotB0009.bmp",
   L"data/actor/ichirin/shotB0010.bmp",
   L"data/actor/ichirin/shot_High0000.bmp",
   L"data/actor/ichirin/shot_High0001.bmp",
   L"data/actor/ichirin/shot_High0002.bmp",
   L"data/actor/ichirin/shot_High0003.bmp",
   L"data/actor/ichirin/shot_High0004.bmp",
   L"data/actor/ichirin/shot_High0005.bmp",
   L"data/actor/ichirin/shot_High0006.bmp",
   L"data/actor/ichirin/shot_High0007.bmp",
   L"data/actor/ichirin/shot_High0008.bmp",
   L"data/actor/ichirin/shot_High0009.bmp",
   L"data/actor/ichirin/skillA0000.bmp",
   L"data/actor/ichirin/skillA0001.bmp",
   L"data/actor/ichirin/skillA0002.bmp",
   L"data/actor/ichirin/skillA0003.bmp",
   L"data/actor/ichirin/skillA0004.bmp",
   L"data/actor/ichirin/skillA0005.bmp",
   L"data/actor/ichirin/skillA0006.bmp",
   L"data/actor/ichirin/skillA0007.bmp",
   L"data/actor/ichirin/skillA0008.bmp",
   L"data/actor/ichirin/skillA0009.bmp",
   L"data/actor/ichirin/skillA0010.bmp",
   L"data/actor/ichirin/skillB0000.bmp",
   L"data/actor/ichirin/skillB0001.bmp",
   L"data/actor/ichirin/skillB0002.bmp",
   L"data/actor/ichirin/skillB0003.bmp",
   L"data/actor/ichirin/skillB0004.bmp",
   L"data/actor/ichirin/skillB0005.bmp",
   L"data/actor/ichirin/skillB0006.bmp",
   L"data/actor/ichirin/skillB0007.bmp",
   L"data/actor/ichirin/skillB0008.bmp",
   L"data/actor/ichirin/skillB0009.bmp",
   L"data/actor/ichirin/skillB0010.bmp",
   L"data/actor/ichirin/skillB0011.bmp",
   L"data/actor/ichirin/skill_fall_chop0000.bmp",
   L"data/actor/ichirin/skill_fall_chop0001.bmp",
   L"data/actor/ichirin/skill_fall_chop0002.bmp",
   L"data/actor/ichirin/skill_fall_chop0003.bmp",
   L"data/actor/ichirin/skill_fall_chop0004.bmp",
   L"data/actor/ichirin/skill_fall_chop0005.bmp",
   L"data/actor/ichirin/skill_fall_chop0006.bmp",
   L"data/actor/ichirin/skill_fall_chop0007.bmp",
   L"data/actor/ichirin/skill_fall_chop0008.bmp",
   L"data/actor/ichirin/slideLoop0000.bmp",
   L"data/actor/ichirin/slideLoop0001.bmp",
   L"data/actor/ichirin/slideLoop0002.bmp",
   L"data/actor/ichirin/slideLoop0003.bmp",
   L"data/actor/ichirin/slideLoop0004.bmp",
   L"data/actor/ichirin/slideLoop_Upper0000.bmp",
   L"data/actor/ichirin/slideLoop_Upper0001.bmp",
   L"data/actor/ichirin/slideLoop_Upper0002.bmp",
   L"data/actor/ichirin/slideLoop_Upper0003.bmp",
   L"data/actor/ichirin/slideLoop_Upper0004.bmp",
   L"data/actor/ichirin/slideUp0000.bmp",
   L"data/actor/ichirin/slideUp0001.bmp",
   L"data/actor/ichirin/slideUp0002.bmp",
   L"data/actor/ichirin/slideUp0003.bmp",
   L"data/actor/ichirin/slideUp0004.bmp",
   L"data/actor/ichirin/slideUp0005.bmp",
   L"data/actor/ichirin/slideUp0006.bmp",
   L"data/actor/ichirin/slideUp0007.bmp",
   L"data/actor/ichirin/slideUp0008.bmp",
   L"data/actor/ichirin/spellA0000.bmp",
   L"data/actor/ichirin/spellA0001.bmp",
   L"data/actor/ichirin/spellA0002.bmp",
   L"data/actor/ichirin/spellA0003.bmp",
   L"data/actor/ichirin/spellA0004.bmp",
   L"data/actor/ichirin/spellA0005.bmp",
   L"data/actor/ichirin/spellA0006.bmp",
   L"data/actor/ichirin/spellA0007.bmp",
   L"data/actor/ichirin/spellA0008.bmp",
   L"data/actor/ichirin/spellA0009.bmp",
   L"data/actor/ichirin/spellA0010.bmp",
   L"data/actor/ichirin/spellA0011.bmp",
   L"data/actor/ichirin/spellA0012.bmp",
   L"data/actor/ichirin/spellA0013.bmp",
   L"data/actor/ichirin/spellA0014.bmp",
   L"data/actor/ichirin/spellA0015.bmp",
   L"data/actor/ichirin/spellA0016.bmp",
   L"data/actor/ichirin/spellA0017.bmp",
   L"data/actor/ichirin/spellA0018.bmp",
   L"data/actor/ichirin/spellA0019.bmp",
   L"data/actor/ichirin/spellA0020.bmp",
   L"data/actor/ichirin/spellB0000.bmp",
   L"data/actor/ichirin/spellB0001.bmp",
   L"data/actor/ichirin/spellB0002.bmp",
   L"data/actor/ichirin/spellB0003.bmp",
   L"data/actor/ichirin/spellB0004.bmp",
   L"data/actor/ichirin/spellB0005.bmp",
   L"data/actor/ichirin/spellB0006.bmp",
   L"data/actor/ichirin/spellB0007.bmp",
   L"data/actor/ichirin/spellB0008.bmp",
   L"data/actor/ichirin/spellB0009.bmp",
   L"data/actor/ichirin/spellB0010.bmp",
   L"data/actor/ichirin/spellB0011.bmp",
   L"data/actor/ichirin/spellB0012.bmp",
   L"data/actor/ichirin/spellB0013.bmp",
   L"data/actor/ichirin/spellB0014.bmp",
   L"data/actor/ichirin/spellB0015.bmp",
   L"data/actor/ichirin/spellB0016.bmp",
   L"data/actor/ichirin/spellB0017.bmp",
   L"data/actor/ichirin/spellC0000.bmp",
   L"data/actor/ichirin/spellC0001.bmp",
   L"data/actor/ichirin/spellC0002.bmp",
   L"data/actor/ichirin/spellC0003.bmp",
   L"data/actor/ichirin/spellC0004.bmp",
   L"data/actor/ichirin/spellC0005.bmp",
   L"data/actor/ichirin/spellC0006.bmp",
   L"data/actor/ichirin/spellC0007.bmp",
   L"data/actor/ichirin/spellC0008.bmp",
   L"data/actor/ichirin/spellC0009.bmp",
   L"data/actor/ichirin/spellC0010.bmp",
   L"data/actor/ichirin/spellC0011.bmp",
   L"data/actor/ichirin/spellC0012.bmp",
   L"data/actor/ichirin/stand0000.bmp",
   L"data/actor/ichirin/stand0001.bmp",
   L"data/actor/ichirin/stand0002.bmp",
   L"data/actor/ichirin/stand0003.bmp",
   L"data/actor/ichirin/stand0004.bmp",
   L"data/actor/ichirin/stand0005.bmp",
   L"data/actor/ichirin/stand0006.bmp",
   L"data/actor/ichirin/stand0007.bmp",
   L"data/actor/ichirin/stand0008.bmp",
   L"data/actor/ichirin/stand0009.bmp",
   L"data/actor/ichirin/stand0010.bmp",
   L"data/actor/ichirin/stand0011.bmp",
   L"data/actor/ichirin/stand0012.bmp",
   L"data/actor/ichirin/stand0013.bmp",
   L"data/actor/ichirin/stand0014.bmp",
   L"data/actor/ichirin/stun0000.bmp",
   L"data/actor/ichirin/stun0001.bmp",
   L"data/actor/ichirin/stun0002.bmp",
   L"data/actor/ichirin/stun0003.bmp",
   L"data/actor/ichirin/stun0004.bmp",
   L"data/actor/ichirin/stunLoop0000.bmp",
   L"data/actor/ichirin/stunLoop0001.bmp",
   L"data/actor/ichirin/stunLoop0002.bmp",
   L"data/actor/ichirin/stunLoop0003.bmp",
   L"data/actor/ichirin/stunLoop0004.bmp",
   L"data/actor/ichirin/team_begin_A0000.bmp",
   L"data/actor/ichirin/team_begin_A0001.bmp",
   L"data/actor/ichirin/testr_climaxcutaura.png",
   L"data/actor/ichirin/test_bulletA000.bmp",
   L"data/actor/ichirin/test_effect.bmp",
   L"data/actor/ichirin/test_occult0000.bmp",
   L"data/actor/ichirin/test_occult0001.bmp",
   L"data/actor/ichirin/test_occult0002.bmp",
   L"data/actor/ichirin/test_occult0003.bmp",
   L"data/actor/ichirin/test_occult0004.bmp",
   L"data/actor/ichirin/test_skillTarnado001.png",
   L"data/actor/ichirin/test_skillTarnado002.png",
   L"data/actor/ichirin/texture/ball.png",
   L"data/actor/ichirin/texture/climax_aura0001.dds",
   L"data/actor/ichirin/texture/face_master_ichirin.png",
   L"data/actor/ichirin/texture/face_master_ichirin2.png",
   L"data/actor/ichirin/texture/face_slave_ichirin.png",
   L"data/actor/ichirin/texture/face_spell_cut_0000.png",
   L"data/actor/ichirin/texture/hitParticle.png",
   L"data/actor/ichirin/texture/hitSpark.png",
   L"data/actor/ichirin/texture/ichilin_climaxaura0000.png",
   L"data/actor/ichirin/texture/ichilin_climaxaura0001.png",
   L"data/actor/ichirin/texture/ichilin_climaxmask0000.png",
   L"data/actor/ichirin/texture/ichirin_animalDamage000.png",
   L"data/actor/ichirin/texture/ichirin_animalDamage001.png",
   L"data/actor/ichirin/texture/ichirin_animalDamage002.png",
   L"data/actor/ichirin/texture/ichirin_animalDamage003.png",
   L"data/actor/ichirin/texture/ichirin_animal_00000.png",
   L"data/actor/ichirin/texture/ichirin_animal_00001.png",
   L"data/actor/ichirin/texture/ichirin_animal_00002.png",
   L"data/actor/ichirin/texture/ichirin_animal_00003.png",
   L"data/actor/ichirin/texture/ichirin_animal_00004.png",
   L"data/actor/ichirin/texture/ichirin_animal_00005.png",
   L"data/actor/ichirin/texture/ichirin_animal_00006.png",
   L"data/actor/ichirin/texture/ichirin_animal_00007.png",
   L"data/actor/ichirin/texture/ichirin_animal_00008.png",
   L"data/actor/ichirin/texture/ichirin_animal_00009.png",
   L"data/actor/ichirin/texture/ichirin_animal_00010.png",
   L"data/actor/ichirin/texture/ichirin_animal_00011.png",
   L"data/actor/ichirin/texture/ichirin_back0000.png",
   L"data/actor/ichirin/texture/ichirin_climaxsmile0000.png",
   L"data/actor/ichirin/texture/ichirin_vortex0000.png",
   L"data/actor/ichirin/texture/kumo.png",
   L"data/actor/ichirin/texture/occultfire0000.dds",
   L"data/actor/ichirin/texture/shot_laserA0000.png",
   L"data/actor/ichirin/texture/spell_use_cut.png",
   L"data/actor/ichirin/texture/tatumakiA0000.png",
   L"data/actor/ichirin/texture/tatumakiA0001.png",
   L"data/actor/ichirin/texture/tatumakiA0002.png",
   L"data/actor/ichirin/texture/tatumakiA0003.png",
   L"data/actor/ichirin/texture/tatumakiA0004.png",
   L"data/actor/ichirin/texture/tatumakiA0005.png",
   L"data/actor/ichirin/texture/tatumakiA0006.png",
   L"data/actor/ichirin/texture/tatumakiA0007.png",
   L"data/actor/ichirin/texture/test_bulletBa000.bmp",
   L"data/actor/ichirin/texture/test_bulletBb000.bmp",
   L"data/actor/ichirin/texture/unzanBeam.png",
   L"data/actor/ichirin/texture/unzanEffectC0000.png",
   L"data/actor/ichirin/texture/unzanEffectC0001.png",
   L"data/actor/ichirin/texture/unzanSmokeA0000.png",
   L"data/actor/ichirin/texture/unzanThunderA0000.png",
   L"data/actor/ichirin/texture/win_ichirin.png",
   L"data/actor/ichirin/turn0000.bmp",
   L"data/actor/ichirin/turn0001.bmp",
   L"data/actor/ichirin/turn0002.bmp",
   L"data/actor/ichirin/turn0003.bmp",
   L"data/actor/ichirin/unzanClowd.png",
   L"data/actor/ichirin/unzanHeadSpin0000.png",
   L"data/actor/ichirin/unzanHeadSpin0001.png",
   L"data/actor/ichirin/unzan_EffectA0000.bmp",
   L"data/actor/ichirin/unzan_EffectA0001.bmp",
   L"data/actor/ichirin/unzan_EffectA0002.bmp",
   L"data/actor/ichirin/unzan_EffectB0000.bmp",
   L"data/actor/ichirin/unzan_EffectB0001.bmp",
   L"data/actor/ichirin/unzan_EffectB0002.bmp",
   L"data/actor/ichirin/unzan_EffectC0000.bmp",
   L"data/actor/ichirin/unzan_EffectC0001.bmp",
   L"data/actor/ichirin/unzan_EffectC0002.bmp",
   L"data/actor/ichirin/unzan_EffectD0000.bmp",
   L"data/actor/ichirin/unzan_EffectD0001.bmp",
   L"data/actor/ichirin/unzan_EffectD0002.bmp",
   L"data/actor/ichirin/unzan_EffectE0000.bmp",
   L"data/actor/ichirin/unzan_EffectE0001.bmp",
   L"data/actor/ichirin/unzan_EffectE0002.bmp",
   L"data/actor/ichirin/unzan_EffectF0000.bmp",
   L"data/actor/ichirin/unzan_EffectF0001.bmp",
   L"data/actor/ichirin/unzan_EffectF0002.bmp",
   L"data/actor/ichirin/unzan_handA.png",
   L"data/actor/ichirin/unzan_handA_a.png",
   L"data/actor/ichirin/unzan_handA_b.png",
   L"data/actor/ichirin/unzan_handA_c.png",
   L"data/actor/ichirin/unzan_handB.png",
   L"data/actor/ichirin/unzan_handB_a.png",
   L"data/actor/ichirin/unzan_handC.png",
   L"data/actor/ichirin/unzan_handC_a.png",
   L"data/actor/ichirin/unzan_handC_b.png",
   L"data/actor/ichirin/unzan_handC_c.png",
   L"data/actor/ichirin/unzan_handC_d.png",
   L"data/actor/ichirin/unzan_handD.png",
   L"data/actor/ichirin/unzan_handD_a.png",
   L"data/actor/ichirin/unzan_handD_b.png",
   L"data/actor/ichirin/unzan_handD_c.png",
   L"data/actor/ichirin/unzan_handE.png",
   L"data/actor/ichirin/unzan_handE_a.png",
   L"data/actor/ichirin/unzan_handE_b.png",
   L"data/actor/ichirin/unzan_handE_c.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0000.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0006.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0014.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0015.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0016.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0019.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0022.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0024.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0025.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0026.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0029.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0031.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0032.png",
   L"data/actor/ichirin/unzan_HeadDowbleUpper0033.png",
   L"data/actor/ichirin/unzan_HeadFront0000.png",
   L"data/actor/ichirin/unzan_HeadFront0006.png",
   L"data/actor/ichirin/unzan_HeadFront0010.png",
   L"data/actor/ichirin/unzan_HeadFront0014.png",
   L"data/actor/ichirin/unzan_HeadFront0015.png",
   L"data/actor/ichirin/unzan_HeadFront0016.png",
   L"data/actor/ichirin/unzan_HeadFront0019.png",
   L"data/actor/ichirin/unzan_HeadFront0023.png",
   L"data/actor/ichirin/unzan_HeadFront0026.png",
   L"data/actor/ichirin/unzan_HeadFront0027.png",
   L"data/actor/ichirin/unzan_HeadFront0028.png",
   L"data/actor/ichirin/unzan_HeadFront0029.png",
   L"data/actor/ichirin/unzan_HeadFront0031.png",
   L"data/actor/ichirin/unzan_HeadFront0035.png",
   L"data/actor/ichirin/unzan_HeadHook0000.png",
   L"data/actor/ichirin/unzan_HeadHook0006.png",
   L"data/actor/ichirin/unzan_HeadHook0015.png",
   L"data/actor/ichirin/unzan_HeadHook0016.png",
   L"data/actor/ichirin/unzan_HeadHook0017.png",
   L"data/actor/ichirin/unzan_HeadHook0018.png",
   L"data/actor/ichirin/unzan_HeadHook0019.png",
   L"data/actor/ichirin/unzan_HeadHook0027.png",
   L"data/actor/ichirin/unzan_HeadHook0029.png",
   L"data/actor/ichirin/unzan_HeadHook0030.png",
   L"data/actor/ichirin/unzan_HeadStraight0000.png",
   L"data/actor/ichirin/unzan_HeadStraight0002.png",
   L"data/actor/ichirin/unzan_HeadStraight0005.png",
   L"data/actor/ichirin/unzan_HeadStraight0006.png",
   L"data/actor/ichirin/unzan_HeadStraight0007.png",
   L"data/actor/ichirin/unzan_HeadStraight0011.png",
   L"data/actor/ichirin/unzan_HeadStraight0012.png",
   L"data/actor/ichirin/unzan_HeadStraight0013.png",
   L"data/actor/ichirin/unzan_HeadStraight0014.png",
   L"data/actor/ichirin/unzan_HeadStraight0016.png",
   L"data/actor/ichirin/unzan_HeadStraight0019.png",
   L"data/actor/ichirin/unzan_HeadStraight0021.png",
   L"data/actor/ichirin/unzan_HeadUnder0000.png",
   L"data/actor/ichirin/unzan_HeadUnder0006.png",
   L"data/actor/ichirin/unzan_HeadUnder0009.png",
   L"data/actor/ichirin/unzan_HeadUnder0011.png",
   L"data/actor/ichirin/unzan_HeadUnder0014.png",
   L"data/actor/ichirin/unzan_HeadUnder0015.png",
   L"data/actor/ichirin/unzan_HeadUnder0018.png",
   L"data/actor/ichirin/unzan_HeadUnder0021.png",
   L"data/actor/ichirin/unzan_HeadUnder0024.png",
   L"data/actor/ichirin/unzan_HeadUnder0027.png",
   L"data/actor/ichirin/unzan_HeadUnder0028.png",
   L"data/actor/ichirin/unzan_HeadUnder0031.png",
   L"data/actor/ichirin/unzan_HeadUnder0032.png",
   L"data/actor/ichirin/unzan_HeadUpper0000.png",
   L"data/actor/ichirin/unzan_HeadUpper0006.png",
   L"data/actor/ichirin/unzan_HeadUpper0009.png",
   L"data/actor/ichirin/unzan_HeadUpper0012.png",
   L"data/actor/ichirin/unzan_HeadUpper0014.png",
   L"data/actor/ichirin/unzan_HeadUpper0015.png",
   L"data/actor/ichirin/unzan_HeadUpper0024.png",
   L"data/actor/ichirin/unzan_HeadUpper0025.png",
   L"data/actor/ichirin/unzan_HeadUpper0026.png",
   L"data/actor/ichirin/unzan_HeadUpper0027.png",
   L"data/actor/ichirin/unzan_HeadUpper0028.png",
   L"data/actor/ichirin/unzan_HeadUpper0029.png",
   L"data/actor/ichirin/unzan_HeadUpper0031.png",
   L"data/actor/ichirin/unzan_HeadUpper0033.png",
   L"data/actor/ichirin/walkBack0000.bmp",
   L"data/actor/ichirin/walkBack0001.bmp",
   L"data/actor/ichirin/walkBack0002.bmp",
   L"data/actor/ichirin/walkBack0003.bmp",
   L"data/actor/ichirin/walkBack0004.bmp",
   L"data/actor/ichirin/walkBack0005.bmp",
   L"data/actor/ichirin/walkBack0006.bmp",
   L"data/actor/ichirin/walkBack0007.bmp",
   L"data/actor/ichirin/walkBackloop0000.bmp",
   L"data/actor/ichirin/walkBackloop0001.bmp",
   L"data/actor/ichirin/walkBackloop0002.bmp",
   L"data/actor/ichirin/walkBackloop0003.bmp",
   L"data/actor/ichirin/walkBackloop0004.bmp",
   L"data/actor/ichirin/walkFront0000.bmp",
   L"data/actor/ichirin/walkFront0001.bmp",
   L"data/actor/ichirin/walkFront0002.bmp",
   L"data/actor/ichirin/walkFront0003.bmp",
   L"data/actor/ichirin/walkFront0004.bmp",
   L"data/actor/ichirin/walkFront0005.bmp",
   L"data/actor/ichirin/walkFront0006.bmp",
   L"data/actor/ichirin/walkFront0007.bmp",
   L"data/actor/ichirin/walkFrontLoop0000.bmp",
   L"data/actor/ichirin/walkFrontLoop0001.bmp",
   L"data/actor/ichirin/walkFrontLoop0002.bmp",
   L"data/actor/ichirin/walkFrontLoop0003.bmp",
   L"data/actor/ichirin/walkFrontLoop0004.bmp",
   L"data/actor/ichirin/winA0000.bmp",
   L"data/actor/ichirin/winA0001.bmp",
   L"data/actor/ichirin/winA0002.bmp",
   L"data/actor/ichirin/winA0003.bmp",
   L"data/actor/ichirin/winA0004.bmp",
   L"data/actor/ichirin/winA0005.bmp",
   L"data/actor/ichirin/winA0006.bmp",
   L"data/actor/ichirin/winA0007.bmp",
   L"data/actor/ichirin/winA0008.bmp",
   L"data/actor/ichirin/winA0009.bmp",
   L"data/actor/ichirin/winA0010.bmp",
   L"data/actor/ichirin/winA0011.bmp",
   L"data/actor/ichirin/winA0012.bmp",
   L"data/actor/ichirin/winA0013.bmp",
   L"data/actor/ichirin/winB0000.bmp",
   L"data/actor/ichirin/winB0001.bmp",
   L"data/actor/ichirin/winB0002.bmp",
   L"data/actor/ichirin/winB0003.bmp",
   L"data/actor/ichirin/winB0004.bmp",
   L"data/actor/ichirin/winB0005.bmp",
   L"data/actor/ichirin/winB0006.bmp",
   L"data/actor/ichirin/winC0000.bmp",
   L"data/actor/ichirin/winC0001.bmp",
   L"data/actor/ichirin/winC0002.bmp",
   L"data/actor/ichirin/winC0003.bmp",
   L"data/actor/ichirin/winC0004.bmp",
   L"data/actor/ichirin/winC0005.bmp",
   L"data/actor/ichirin/winC0006.bmp",
   L"data/actor/ichirin/winC_Loop0000.bmp",
   L"data/actor/ichirin/winC_Loop0001.bmp",
   L"data/actor/ichirin/winC_Loop0002.bmp",
   L"data/actor/ichirin/winC_Loop0003.bmp",
   L"data/actor/ichirin/winD0000.bmp",
   L"data/actor/ichirin/winD0001.bmp",
   L"data/actor/ichirin/winD0002.bmp",
   L"data/actor/ichirin/winD0003.bmp",
   L"data/actor/ichirin/winD0004.bmp",
   L"data/actor/ichirin/winD_Loop0000.bmp",
   L"data/actor/ichirin/winD_Loop0001.bmp",
   L"data/actor/ichirin/winD_Loop0002.bmp",
   L"data/actor/ichirin/winD_Loop0003.bmp",
   L"data/actor/ichirin/win_ObjectA000.bmp",
   L"data/actor/ichirin/win_ObjectB000.bmp",
   L"data/actor/ichirin.nut",
   L"data/actor/ichirin_base.nut",
   L"data/actor/ichirin_boss.nut",
   L"data/actor/ichirin_boss_base.nut",
   L"data/actor/ichirin_boss_init.nut",
   L"data/actor/ichirin_boss_shot.nut",
   L"data/actor/ichirin_com.nut",
   L"data/actor/ichirin_combo.nut",
   L"data/actor/ichirin_com_function.nut",
   L"data/actor/ichirin_init.nut",
   L"data/actor/ichirin_practice_init.nut",
   L"data/actor/ichirin_shot.nut",
   L"data/actor/ichirin_team.nut",
   L"data/actor/initialize.nut",
   L"data/actor/jyoon/animal0000.png",
   L"data/actor/jyoon/animal0001.png",
   L"data/actor/jyoon/animal0002.png",
   L"data/actor/jyoon/animal0003.png",
   L"data/actor/jyoon/animal0004.png",
   L"data/actor/jyoon/animal0005.png",
   L"data/actor/jyoon/animal0006.png",
   L"data/actor/jyoon/animal0007.png",
   L"data/actor/jyoon/animal0008.png",
   L"data/actor/jyoon/animal0009.png",
   L"data/actor/jyoon/animal_damage0000.png",
   L"data/actor/jyoon/animal_damage0001.png",
   L"data/actor/jyoon/animal_damage0002.png",
   L"data/actor/jyoon/animal_damage0003.png",
   L"data/actor/jyoon/animal_damage0004.png",
   L"data/actor/jyoon/atk_dash_low0000.bmp",
   L"data/actor/jyoon/atk_dash_low0001.bmp",
   L"data/actor/jyoon/atk_dash_low0002.bmp",
   L"data/actor/jyoon/atk_dash_low0003.bmp",
   L"data/actor/jyoon/atk_dash_low0004.bmp",
   L"data/actor/jyoon/atk_dash_low0005.bmp",
   L"data/actor/jyoon/atk_dash_low0006.bmp",
   L"data/actor/jyoon/atk_dash_low0007.bmp",
   L"data/actor/jyoon/atk_dash_low0008.bmp",
   L"data/actor/jyoon/atk_front_air0000.bmp",
   L"data/actor/jyoon/atk_front_air0001.bmp",
   L"data/actor/jyoon/atk_front_air0002.bmp",
   L"data/actor/jyoon/atk_front_air0003.bmp",
   L"data/actor/jyoon/atk_front_air0004.bmp",
   L"data/actor/jyoon/atk_front_air0005.bmp",
   L"data/actor/jyoon/atk_front_air0006.bmp",
   L"data/actor/jyoon/atk_front_air0007.bmp",
   L"data/actor/jyoon/atk_front_air0008.bmp",
   L"data/actor/jyoon/atk_front_air0009.bmp",
   L"data/actor/jyoon/atk_grab0000.bmp",
   L"data/actor/jyoon/atk_grab0001.bmp",
   L"data/actor/jyoon/atk_grab0002.bmp",
   L"data/actor/jyoon/atk_grab0003.bmp",
   L"data/actor/jyoon/atk_grab0004.bmp",
   L"data/actor/jyoon/atk_grab0005.bmp",
   L"data/actor/jyoon/atk_grab0006.bmp",
   L"data/actor/jyoon/atk_grab0007.bmp",
   L"data/actor/jyoon/atk_grab0008.bmp",
   L"data/actor/jyoon/atk_low0000.bmp",
   L"data/actor/jyoon/atk_low0001.bmp",
   L"data/actor/jyoon/atk_low0002.bmp",
   L"data/actor/jyoon/atk_low0003.bmp",
   L"data/actor/jyoon/atk_low0004.bmp",
   L"data/actor/jyoon/atk_low0005.bmp",
   L"data/actor/jyoon/atk_Mid0000.bmp",
   L"data/actor/jyoon/atk_Mid0001.bmp",
   L"data/actor/jyoon/atk_Mid0002.bmp",
   L"data/actor/jyoon/atk_Mid0003.bmp",
   L"data/actor/jyoon/atk_Mid0004.bmp",
   L"data/actor/jyoon/atk_Mid0005.bmp",
   L"data/actor/jyoon/atk_mid0006.bmp",
   L"data/actor/jyoon/atk_mid0007.bmp",
   L"data/actor/jyoon/atk_mid0008.bmp",
   L"data/actor/jyoon/atk_mid_air0000.bmp",
   L"data/actor/jyoon/atk_mid_air0001.bmp",
   L"data/actor/jyoon/atk_mid_air0002.bmp",
   L"data/actor/jyoon/atk_mid_air0003.bmp",
   L"data/actor/jyoon/atk_mid_air0004.bmp",
   L"data/actor/jyoon/atk_mid_air0005.bmp",
   L"data/actor/jyoon/atk_upper0000.bmp",
   L"data/actor/jyoon/atk_upper0001.bmp",
   L"data/actor/jyoon/atk_upper0002.bmp",
   L"data/actor/jyoon/atk_upper0003.bmp",
   L"data/actor/jyoon/atk_upper0004.bmp",
   L"data/actor/jyoon/atk_upper0005.bmp",
   L"data/actor/jyoon/atk_upper0006.bmp",
   L"data/actor/jyoon/aura_tex0000.png",
   L"data/actor/jyoon/aura_tex0001.png",
   L"data/actor/jyoon/bmsln/reimu_buster.bmb",
   L"data/actor/jyoon/bmsln/reimu_busterHit.bmb",
   L"data/actor/jyoon/bmsln/reimu_fallKickA.bmb",
   L"data/actor/jyoon/bmsln/reimu_HighShotBaria.bmb",
   L"data/actor/jyoon/bmsln/reimu_keisei.bmb",
   L"data/actor/jyoon/bmsln/reimu_kibakuzinA.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouB.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouG.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouHitB.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouHitG.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouHitR.bmb",
   L"data/actor/jyoon/bmsln/reimu_musouR.bmb",
   L"data/actor/jyoon/bmsln/reimu_shot.bmb",
   L"data/actor/jyoon/bmsln/reimu_shotA.bmb",
   L"data/actor/jyoon/bmsln/reimu_shotA_gateRing.bmb",
   L"data/actor/jyoon/bmsln/reimu_shotA_hit.bmb",
   L"data/actor/jyoon/bmsln/reimu_skillG_kick.bmb",
   L"data/actor/jyoon/bmsln/reimu_TenseiA000.bmb",
   L"data/actor/jyoon/bmsln/reimu_tenseiFinish.bmb",
   L"data/actor/jyoon/bmsln/reimu_tenseiRock.bmb",
   L"data/actor/jyoon/bmsln/reimu_tenseiRockShot.bmb",
   L"data/actor/jyoon/bmsln/shot_A_000.bmb",
   L"data/actor/jyoon/bmsln/shot_A_000.bmsln",
   L"data/actor/jyoon/climax_finish0000.bmp",
   L"data/actor/jyoon/climax_finish0001.bmp",
   L"data/actor/jyoon/climax_finish0002.bmp",
   L"data/actor/jyoon/climax_finish0003.bmp",
   L"data/actor/jyoon/climax_finish0004.bmp",
   L"data/actor/jyoon/climax_finish0005.bmp",
   L"data/actor/jyoon/climax_finish0006.bmp",
   L"data/actor/jyoon/climax_finish0007.bmp",
   L"data/actor/jyoon/climax_finish0008.bmp",
   L"data/actor/jyoon/climax_grabB0000.bmp",
   L"data/actor/jyoon/climax_grabB0001.bmp",
   L"data/actor/jyoon/climax_grabB0002.bmp",
   L"data/actor/jyoon/climax_grabB0003.bmp",
   L"data/actor/jyoon/climax_grabB0004.bmp",
   L"data/actor/jyoon/climax_grabB0005.bmp",
   L"data/actor/jyoon/cloth.bmp",
   L"data/actor/jyoon/damage_body0000.bmp",
   L"data/actor/jyoon/damage_body0001.bmp",
   L"data/actor/jyoon/damage_body0002.bmp",
   L"data/actor/jyoon/damage_body0003.bmp",
   L"data/actor/jyoon/damage_crash0000.bmp",
   L"data/actor/jyoon/damage_crash0001.bmp",
   L"data/actor/jyoon/damage_crash0002.bmp",
   L"data/actor/jyoon/damage_crash0003.bmp",
   L"data/actor/jyoon/damage_crash0004.bmp",
   L"data/actor/jyoon/damage_crash0005.bmp",
   L"data/actor/jyoon/damage_down0000.bmp",
   L"data/actor/jyoon/damage_down0001.bmp",
   L"data/actor/jyoon/damage_down0002.bmp",
   L"data/actor/jyoon/damage_down0003.bmp",
   L"data/actor/jyoon/damage_down0004.bmp",
   L"data/actor/jyoon/damage_down0005.bmp",
   L"data/actor/jyoon/damage_down0006.bmp",
   L"data/actor/jyoon/damage_down0007.bmp",
   L"data/actor/jyoon/damage_down0008.bmp",
   L"data/actor/jyoon/damage_down0009.bmp",
   L"data/actor/jyoon/damage_down0010.bmp",
   L"data/actor/jyoon/damage_head0000.bmp",
   L"data/actor/jyoon/damage_head0001.bmp",
   L"data/actor/jyoon/damage_head0002.bmp",
   L"data/actor/jyoon/damage_head0003.bmp",
   L"data/actor/jyoon/damage_head0004.bmp",
   L"data/actor/jyoon/damage_spin0000.bmp",
   L"data/actor/jyoon/damage_spin0001.bmp",
   L"data/actor/jyoon/damage_spin0002.bmp",
   L"data/actor/jyoon/damage_spin0003.bmp",
   L"data/actor/jyoon/damage_stun0000.bmp",
   L"data/actor/jyoon/damage_stun0001.bmp",
   L"data/actor/jyoon/damage_stun0002.bmp",
   L"data/actor/jyoon/damage_stun0003.bmp",
   L"data/actor/jyoon/damage_stun0004.bmp",
   L"data/actor/jyoon/damage_stun0005.bmp",
   L"data/actor/jyoon/damage_wall0000.bmp",
   L"data/actor/jyoon/damage_wall0001.bmp",
   L"data/actor/jyoon/damage_wall0002.bmp",
   L"data/actor/jyoon/damage_wall0003.bmp",
   L"data/actor/jyoon/damage_wall0004.bmp",
   L"data/actor/jyoon/damage_wall0005.bmp",
   L"data/actor/jyoon/damage_wall0006.bmp",
   L"data/actor/jyoon/dash_back0000.bmp",
   L"data/actor/jyoon/dash_back0001.bmp",
   L"data/actor/jyoon/dash_back0002.bmp",
   L"data/actor/jyoon/dash_back0003.bmp",
   L"data/actor/jyoon/dash_back0004.bmp",
   L"data/actor/jyoon/dash_back0005.bmp",
   L"data/actor/jyoon/dash_back0006.bmp",
   L"data/actor/jyoon/dash_front0000.bmp",
   L"data/actor/jyoon/dash_front0001.bmp",
   L"data/actor/jyoon/dash_front0002.bmp",
   L"data/actor/jyoon/dash_front0003.bmp",
   L"data/actor/jyoon/dash_front0004.bmp",
   L"data/actor/jyoon/grab0001.bmp",
   L"data/actor/jyoon/grab0002.bmp",
   L"data/actor/jyoon/grab0003.bmp",
   L"data/actor/jyoon/grab0004.bmp",
   L"data/actor/jyoon/guard0000.bmp",
   L"data/actor/jyoon/guard0001.bmp",
   L"data/actor/jyoon/guard0002.bmp",
   L"data/actor/jyoon/guard_miss0000.bmp",
   L"data/actor/jyoon/guard_miss0001.bmp",
   L"data/actor/jyoon/guard_miss0002.bmp",
   L"data/actor/jyoon/guard_miss0003.bmp",
   L"data/actor/jyoon/guard_miss0004.bmp",
   L"data/actor/jyoon/half_damage_spin0000.bmp",
   L"data/actor/jyoon/half_damage_spin0001.bmp",
   L"data/actor/jyoon/half_damage_spin0002.bmp",
   L"data/actor/jyoon/half_damage_spin0003.bmp",
   L"data/actor/jyoon/half_damage_spin0004.bmp",
   L"data/actor/jyoon/half_damage_spin0005.bmp",
   L"data/actor/jyoon/half_damage_spin0006.bmp",
   L"data/actor/jyoon/half_damage_spin0007.bmp",
   L"data/actor/jyoon/jyoon.pat",
   L"data/actor/jyoon/lose0000.bmp",
   L"data/actor/jyoon/lose0001.bmp",
   L"data/actor/jyoon/lose0002.bmp",
   L"data/actor/jyoon/lose0003.bmp",
   L"data/actor/jyoon/lose0004.bmp",
   L"data/actor/jyoon/lose0005.bmp",
   L"data/actor/jyoon/move_slide0000.bmp",
   L"data/actor/jyoon/move_slide0001.bmp",
   L"data/actor/jyoon/move_slide0002.bmp",
   L"data/actor/jyoon/move_slide0003.bmp",
   L"data/actor/jyoon/move_slide0004.bmp",
   L"data/actor/jyoon/move_slide0005.bmp",
   L"data/actor/jyoon/move_slide0006.bmp",
   L"data/actor/jyoon/move_slide0007.bmp",
   L"data/actor/jyoon/occult0000.bmp",
   L"data/actor/jyoon/occult0001.bmp",
   L"data/actor/jyoon/occult0002.bmp",
   L"data/actor/jyoon/occult0003.bmp",
   L"data/actor/jyoon/occult0004.bmp",
   L"data/actor/jyoon/occult0005.bmp",
   L"data/actor/jyoon/occult0006.bmp",
   L"data/actor/jyoon/occult0007.bmp",
   L"data/actor/jyoon/palette000.bmp",
   L"data/actor/jyoon/palette001.bmp",
   L"data/actor/jyoon/palette002.bmp",
   L"data/actor/jyoon/palette003.bmp",
   L"data/actor/jyoon/palette004.bmp",
   L"data/actor/jyoon/palette005.bmp",
   L"data/actor/jyoon/palette006.bmp",
   L"data/actor/jyoon/palette007.bmp",
   L"data/actor/jyoon/palette100.bmp",
   L"data/actor/jyoon/palette101.bmp",
   L"data/actor/jyoon/palette102.bmp",
   L"data/actor/jyoon/palette103.bmp",
   L"data/actor/jyoon/palette104.bmp",
   L"data/actor/jyoon/palette105.bmp",
   L"data/actor/jyoon/palette106.bmp",
   L"data/actor/jyoon/palette107.bmp",
   L"data/actor/jyoon/shot_front0000.bmp",
   L"data/actor/jyoon/shot_front0001.bmp",
   L"data/actor/jyoon/shot_front0002.bmp",
   L"data/actor/jyoon/shot_front0003.bmp",
   L"data/actor/jyoon/shot_front0004.bmp",
   L"data/actor/jyoon/shot_front0005.bmp",
   L"data/actor/jyoon/shot_front0006.bmp",
   L"data/actor/jyoon/shot_front0007.bmp",
   L"data/actor/jyoon/shot_front0008.bmp",
   L"data/actor/jyoon/shot_under0000.bmp",
   L"data/actor/jyoon/shot_under0001.bmp",
   L"data/actor/jyoon/shot_under0002.bmp",
   L"data/actor/jyoon/shot_under0003.bmp",
   L"data/actor/jyoon/shot_under0004.bmp",
   L"data/actor/jyoon/shot_under0005.bmp",
   L"data/actor/jyoon/shot_under0006.bmp",
   L"data/actor/jyoon/shot_under0007.bmp",
   L"data/actor/jyoon/shot_under0008.bmp",
   L"data/actor/jyoon/shot_upper0000.bmp",
   L"data/actor/jyoon/shot_upper0001.bmp",
   L"data/actor/jyoon/shot_upper0002.bmp",
   L"data/actor/jyoon/shot_upper0003.bmp",
   L"data/actor/jyoon/shot_upper0004.bmp",
   L"data/actor/jyoon/shot_upper0005.bmp",
   L"data/actor/jyoon/shot_upper0006.bmp",
   L"data/actor/jyoon/shot_upper0007.bmp",
   L"data/actor/jyoon/shot_upper0008.bmp",
   L"data/actor/jyoon/shot_upper0009.bmp",
   L"data/actor/jyoon/skill_bag_catch0000.bmp",
   L"data/actor/jyoon/skill_bag_catch0001.bmp",
   L"data/actor/jyoon/skill_bag_catch0002.bmp",
   L"data/actor/jyoon/skill_bag_catch0003.bmp",
   L"data/actor/jyoon/skill_upper0000.bmp",
   L"data/actor/jyoon/skill_upper0001.bmp",
   L"data/actor/jyoon/skill_upper0002.bmp",
   L"data/actor/jyoon/skill_upper0003.bmp",
   L"data/actor/jyoon/skill_upper0004.bmp",
   L"data/actor/jyoon/skill_upper0005.bmp",
   L"data/actor/jyoon/skill_upper0006.bmp",
   L"data/actor/jyoon/skill_upper0007.bmp",
   L"data/actor/jyoon/skill_upper0008.bmp",
   L"data/actor/jyoon/skill_upper0009.bmp",
   L"data/actor/jyoon/spellB0000.bmp",
   L"data/actor/jyoon/spellB0001.bmp",
   L"data/actor/jyoon/spellB0002.bmp",
   L"data/actor/jyoon/spellB0003.bmp",
   L"data/actor/jyoon/spellB0004.bmp",
   L"data/actor/jyoon/spellB0005.bmp",
   L"data/actor/jyoon/spellB0006.bmp",
   L"data/actor/jyoon/spellB0007.bmp",
   L"data/actor/jyoon/spellCall0000.bmp",
   L"data/actor/jyoon/spellCall0001.bmp",
   L"data/actor/jyoon/spellCall0002.bmp",
   L"data/actor/jyoon/spellCall0003.bmp",
   L"data/actor/jyoon/spellCall0004.bmp",
   L"data/actor/jyoon/spellCall0005.bmp",
   L"data/actor/jyoon/stand0000.bmp",
   L"data/actor/jyoon/stand0001.bmp",
   L"data/actor/jyoon/stand0002.bmp",
   L"data/actor/jyoon/stand0003.bmp",
   L"data/actor/jyoon/stand0004.bmp",
   L"data/actor/jyoon/stand0005.bmp",
   L"data/actor/jyoon/stand0006.bmp",
   L"data/actor/jyoon/stand0007.bmp",
   L"data/actor/jyoon/stand0008.bmp",
   L"data/actor/jyoon/stand0009.bmp",
   L"data/actor/jyoon/stand0010.bmp",
   L"data/actor/jyoon/stand0011.bmp",
   L"data/actor/jyoon/stand0012.bmp",
   L"data/actor/jyoon/stand0013.bmp",
   L"data/actor/jyoon/stand0014.bmp",
   L"data/actor/jyoon/taxi0000.bmp",
   L"data/actor/jyoon/taxi0001.bmp",
   L"data/actor/jyoon/taxi0002.bmp",
   L"data/actor/jyoon/taxi0003.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0000.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0001.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0002.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0003.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0004.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0005.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0006.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0007.bmp",
   L"data/actor/jyoon/test_attack_dash_lowB0008.bmp",
   L"data/actor/jyoon/test_climax_attack0000.bmp",
   L"data/actor/jyoon/test_climax_attack0001.bmp",
   L"data/actor/jyoon/test_climax_attack0002.bmp",
   L"data/actor/jyoon/test_climax_attack0003.bmp",
   L"data/actor/jyoon/test_climax_attack0004.bmp",
   L"data/actor/jyoon/test_climax_attack0005.bmp",
   L"data/actor/jyoon/test_climax_attack0006.bmp",
   L"data/actor/jyoon/test_climax_attack0007.bmp",
   L"data/actor/jyoon/test_gold_typhoon0000.bmp",
   L"data/actor/jyoon/test_gold_typhoon0001.bmp",
   L"data/actor/jyoon/test_gold_typhoon0002.bmp",
   L"data/actor/jyoon/test_gold_typhoon0003.bmp",
   L"data/actor/jyoon/test_gold_typhoon0004.bmp",
   L"data/actor/jyoon/test_gold_typhoon0005.bmp",
   L"data/actor/jyoon/test_gold_typhoon0006.bmp",
   L"data/actor/jyoon/test_gold_typhoon0007.bmp",
   L"data/actor/jyoon/test_money_fire0000.bmp",
   L"data/actor/jyoon/test_money_fire0001.bmp",
   L"data/actor/jyoon/test_money_fire0002.bmp",
   L"data/actor/jyoon/test_money_fire0003.bmp",
   L"data/actor/jyoon/test_money_fire0004.bmp",
   L"data/actor/jyoon/test_money_fire0005.bmp",
   L"data/actor/jyoon/test_money_fire0006.bmp",
   L"data/actor/jyoon/test_money_fire0007.bmp",
   L"data/actor/jyoon/test_money_fire0008.bmp",
   L"data/actor/jyoon/test_skillA0000.bmp",
   L"data/actor/jyoon/test_skillA0001.bmp",
   L"data/actor/jyoon/test_skillA0002.bmp",
   L"data/actor/jyoon/test_skillA0003.bmp",
   L"data/actor/jyoon/test_skillA0004.bmp",
   L"data/actor/jyoon/test_skillA0005.bmp",
   L"data/actor/jyoon/test_skillA0006.bmp",
   L"data/actor/jyoon/test_skillA0007.bmp",
   L"data/actor/jyoon/test_skillA0008.bmp",
   L"data/actor/jyoon/test_skillA0009.bmp",
   L"data/actor/jyoon/test_skillA0010.bmp",
   L"data/actor/jyoon/test_skillD0000.bmp",
   L"data/actor/jyoon/test_skillD0001.bmp",
   L"data/actor/jyoon/test_skillD0002.bmp",
   L"data/actor/jyoon/test_skillD0003.bmp",
   L"data/actor/jyoon/test_skillD0004.bmp",
   L"data/actor/jyoon/test_skillD0005.bmp",
   L"data/actor/jyoon/test_skillD0006.bmp",
   L"data/actor/jyoon/test_skillD0007.bmp",
   L"data/actor/jyoon/test_skillD0008.bmp",
   L"data/actor/jyoon/test_skillD0009.bmp",
   L"data/actor/jyoon/test_skillE0000.bmp",
   L"data/actor/jyoon/test_skillE0001.bmp",
   L"data/actor/jyoon/test_skillE0002.bmp",
   L"data/actor/jyoon/test_skillE0003.bmp",
   L"data/actor/jyoon/test_skillE0004.bmp",
   L"data/actor/jyoon/test_skillE0005.bmp",
   L"data/actor/jyoon/test_skillE0006.bmp",
   L"data/actor/jyoon/test_skillE0007.bmp",
   L"data/actor/jyoon/test_skillE0008.bmp",
   L"data/actor/jyoon/test_skillE0009.bmp",
   L"data/actor/jyoon/test_slide0000.bmp",
   L"data/actor/jyoon/test_slide0001.bmp",
   L"data/actor/jyoon/test_slide0002.bmp",
   L"data/actor/jyoon/test_slide0003.bmp",
   L"data/actor/jyoon/test_slide0004.bmp",
   L"data/actor/jyoon/test_slide0005.bmp",
   L"data/actor/jyoon/test_slide0006.bmp",
   L"data/actor/jyoon/test_slide0007.bmp",
   L"data/actor/jyoon/test_spellA0000.bmp",
   L"data/actor/jyoon/test_spellA0001.bmp",
   L"data/actor/jyoon/test_spellA0002.bmp",
   L"data/actor/jyoon/test_spellA0003.bmp",
   L"data/actor/jyoon/test_spellA0004.bmp",
   L"data/actor/jyoon/test_spellA0005.bmp",
   L"data/actor/jyoon/test_spellA0006.bmp",
   L"data/actor/jyoon/test_spellA0007.bmp",
   L"data/actor/jyoon/test_spellA0008.bmp",
   L"data/actor/jyoon/test_spellA0009.bmp",
   L"data/actor/jyoon/test_spell_danceB0000.bmp",
   L"data/actor/jyoon/test_spell_danceB0001.bmp",
   L"data/actor/jyoon/test_spell_danceB0002.bmp",
   L"data/actor/jyoon/test_spell_danceB0003.bmp",
   L"data/actor/jyoon/test_spell_danceB0004.bmp",
   L"data/actor/jyoon/test_spell_danceB0005.bmp",
   L"data/actor/jyoon/test_spell_danceB0006.bmp",
   L"data/actor/jyoon/test_spell_danceC0000.bmp",
   L"data/actor/jyoon/test_spell_danceC0001.bmp",
   L"data/actor/jyoon/test_spell_danceC0002.bmp",
   L"data/actor/jyoon/test_spell_danceC0003.bmp",
   L"data/actor/jyoon/test_spell_danceC0004.bmp",
   L"data/actor/jyoon/test_spell_danceC0005.bmp",
   L"data/actor/jyoon/test_spell_danceC0006.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0000.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0001.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0002.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0003.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0004.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0005.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0006.bmp",
   L"data/actor/jyoon/test_spell_danceLoop0007.bmp",
   L"data/actor/jyoon/test_spell_dance_A0000.bmp",
   L"data/actor/jyoon/test_spell_dance_A0001.bmp",
   L"data/actor/jyoon/test_spell_dance_A0002.bmp",
   L"data/actor/jyoon/test_standB0000.bmp",
   L"data/actor/jyoon/test_winA0000.bmp",
   L"data/actor/jyoon/test_winA0001.bmp",
   L"data/actor/jyoon/test_winA0002.bmp",
   L"data/actor/jyoon/test_winA0003.bmp",
   L"data/actor/jyoon/test_winA0004.bmp",
   L"data/actor/jyoon/test_winA0005.bmp",
   L"data/actor/jyoon/test_winA0006.bmp",
   L"data/actor/jyoon/test_winA0007.bmp",
   L"data/actor/jyoon/test_winA0008.bmp",
   L"data/actor/jyoon/test_winB0000.bmp",
   L"data/actor/jyoon/test_winB0001.bmp",
   L"data/actor/jyoon/test_winB0002.bmp",
   L"data/actor/jyoon/test_winB0003.bmp",
   L"data/actor/jyoon/test_winB0004.bmp",
   L"data/actor/jyoon/test_winB0005.bmp",
   L"data/actor/jyoon/test_winB0006.bmp",
   L"data/actor/jyoon/texture/air_front_aura_0000.png",
   L"data/actor/jyoon/texture/air_front_aura_0001.png",
   L"data/actor/jyoon/texture/air_front_aura_0002.png",
   L"data/actor/jyoon/texture/air_front_aura_0003.png",
   L"data/actor/jyoon/texture/air_mid_aura0000.png",
   L"data/actor/jyoon/texture/air_mid_aura0001.png",
   L"data/actor/jyoon/texture/air_mid_aura0002.png",
   L"data/actor/jyoon/texture/air_mid_aura0003.png",
   L"data/actor/jyoon/texture/animalB0000.png",
   L"data/actor/jyoon/texture/animalB0001.png",
   L"data/actor/jyoon/texture/animalB0002.png",
   L"data/actor/jyoon/texture/animalB0003.png",
   L"data/actor/jyoon/texture/animalB0004.png",
   L"data/actor/jyoon/texture/animalB0005.png",
   L"data/actor/jyoon/texture/animalB0006.png",
   L"data/actor/jyoon/texture/animalB0007.png",
   L"data/actor/jyoon/texture/animalB0008.png",
   L"data/actor/jyoon/texture/animalB0009.png",
   L"data/actor/jyoon/texture/animalB_damage0000.png",
   L"data/actor/jyoon/texture/animalB_damage0001.png",
   L"data/actor/jyoon/texture/animalB_damage0002.png",
   L"data/actor/jyoon/texture/animalB_damage0003.png",
   L"data/actor/jyoon/texture/animalB_damage0004.png",
   L"data/actor/jyoon/texture/atk_aura_0000.png",
   L"data/actor/jyoon/texture/aura_climax_finish_0000.png",
   L"data/actor/jyoon/texture/aura_climax_finish_0001.png",
   L"data/actor/jyoon/texture/aura_climax_finish_0002.png",
   L"data/actor/jyoon/texture/aura_climax_finish_0003.png",
   L"data/actor/jyoon/texture/aura_climax_finish_0004.png",
   L"data/actor/jyoon/texture/aura_mid0000.png",
   L"data/actor/jyoon/texture/aura_mid0001.png",
   L"data/actor/jyoon/texture/aura_mid0002.png",
   L"data/actor/jyoon/texture/aura_mid0003.png",
   L"data/actor/jyoon/texture/aura_mid0004.png",
   L"data/actor/jyoon/texture/aura_mid0005.png",
   L"data/actor/jyoon/texture/aura_shot_front_0000.png",
   L"data/actor/jyoon/texture/aura_shot_front_0001.png",
   L"data/actor/jyoon/texture/aura_shot_front_0002.png",
   L"data/actor/jyoon/texture/aura_shot_front_0003.png",
   L"data/actor/jyoon/texture/aura_shot_front_0004.png",
   L"data/actor/jyoon/texture/aura_shot_normal_0000.png",
   L"data/actor/jyoon/texture/aura_shot_normal_0001.png",
   L"data/actor/jyoon/texture/aura_shot_normal_0002.png",
   L"data/actor/jyoon/texture/aura_shot_normal_0003.png",
   L"data/actor/jyoon/texture/aura_shot_under_0000.png",
   L"data/actor/jyoon/texture/aura_shot_under_0001.png",
   L"data/actor/jyoon/texture/aura_shot_under_0002.png",
   L"data/actor/jyoon/texture/aura_shot_under_0003.png",
   L"data/actor/jyoon/texture/aura_shot_under_0004.png",
   L"data/actor/jyoon/texture/aura_under0000.png",
   L"data/actor/jyoon/texture/aura_under0001.png",
   L"data/actor/jyoon/texture/aura_under0002.png",
   L"data/actor/jyoon/texture/aura_under0003.png",
   L"data/actor/jyoon/texture/aura_under0004.png",
   L"data/actor/jyoon/texture/aura_under0005.png",
   L"data/actor/jyoon/texture/cut_lw0000.png",
   L"data/actor/jyoon/texture/cut_lw0001.png",
   L"data/actor/jyoon/texture/dance_light.png",
   L"data/actor/jyoon/texture/dance_table.png",
   L"data/actor/jyoon/texture/dasu_aura0000.png",
   L"data/actor/jyoon/texture/dasu_aura0001.png",
   L"data/actor/jyoon/texture/dasu_aura0002.png",
   L"data/actor/jyoon/texture/face_master_jyoon.png",
   L"data/actor/jyoon/texture/face_master_jyoon2.png",
   L"data/actor/jyoon/texture/face_slave_jyoon.png",
   L"data/actor/jyoon/texture/face_spell_cut.png",
   L"data/actor/jyoon/texture/gradation_000.png",
   L"data/actor/jyoon/texture/jyoon_gold_flash000.png",
   L"data/actor/jyoon/texture/jyoon_money0000.png",
   L"data/actor/jyoon/texture/jyoon_money0001.png",
   L"data/actor/jyoon/texture/lastWord_goods0000.png",
   L"data/actor/jyoon/texture/ougi_000.png",
   L"data/actor/jyoon/texture/ougi_001.png",
   L"data/actor/jyoon/texture/ougi_002.png",
   L"data/actor/jyoon/texture/shot_wealth0000.png",
   L"data/actor/jyoon/texture/spell_use_cut.png",
   L"data/actor/jyoon/texture/test_crecent.png",
   L"data/actor/jyoon/texture/test_lastWord0005.png",
   L"data/actor/jyoon/turn0000.bmp",
   L"data/actor/jyoon/turn0001.bmp",
   L"data/actor/jyoon/turn0002.bmp",
   L"data/actor/jyoon/walk_back0000.bmp",
   L"data/actor/jyoon/walk_back0001.bmp",
   L"data/actor/jyoon/walk_back0002.bmp",
   L"data/actor/jyoon/walk_back0003.bmp",
   L"data/actor/jyoon/walk_back0004.bmp",
   L"data/actor/jyoon/walk_back0005.bmp",
   L"data/actor/jyoon/walk_front0000.bmp",
   L"data/actor/jyoon/walk_front0001.bmp",
   L"data/actor/jyoon/walk_front0002.bmp",
   L"data/actor/jyoon/walk_front0003.bmp",
   L"data/actor/jyoon/walk_front0004.bmp",
   L"data/actor/jyoon/walk_front0005.bmp",
   L"data/actor/jyoon/winB0000.bmp",
   L"data/actor/jyoon/winB0001.bmp",
   L"data/actor/jyoon/winB0002.bmp",
   L"data/actor/jyoon/winB0003.bmp",
   L"data/actor/jyoon/winB0004.bmp",
   L"data/actor/jyoon/winB0005.bmp",
   L"data/actor/jyoon/winB0006.bmp",
   L"data/actor/jyoon/winB0007.bmp",
   L"data/actor/jyoon/winB0008.bmp",
   L"data/actor/jyoon.nut",
   L"data/actor/jyoon_base.nut",
   L"data/actor/jyoon_boss.nut",
   L"data/actor/jyoon_boss_base.nut",
   L"data/actor/jyoon_boss_init.nut",
   L"data/actor/jyoon_boss_shot.nut",
   L"data/actor/jyoon_com.nut",
   L"data/actor/jyoon_combo.nut",
   L"data/actor/jyoon_com_function.nut",
   L"data/actor/jyoon_init.nut",
   L"data/actor/jyoon_practice_init.nut",
   L"data/actor/jyoon_shot.nut",
   L"data/actor/jyoon_team.nut",
   L"data/actor/kasen/atkFront0000.bmp",
   L"data/actor/kasen/atkFront0001.bmp",
   L"data/actor/kasen/atkFront0002.bmp",
   L"data/actor/kasen/atkFront0003.bmp",
   L"data/actor/kasen/atkFront0004.bmp",
   L"data/actor/kasen/atkFront0005.bmp",
   L"data/actor/kasen/atkFront0006.bmp",
   L"data/actor/kasen/atkFront0007.bmp",
   L"data/actor/kasen/atkHighFront0000.bmp",
   L"data/actor/kasen/atkHighFront0001.bmp",
   L"data/actor/kasen/atkHighFront0002.bmp",
   L"data/actor/kasen/atkHighFront0003.bmp",
   L"data/actor/kasen/atkHighFront0004.bmp",
   L"data/actor/kasen/atkHighFront0005.bmp",
   L"data/actor/kasen/atkHighFront0006.bmp",
   L"data/actor/kasen/atkHighFront0007.bmp",
   L"data/actor/kasen/atkHighFront0008.bmp",
   L"data/actor/kasen/atkLow0000.bmp",
   L"data/actor/kasen/atkLow0001.bmp",
   L"data/actor/kasen/atkLow0002.bmp",
   L"data/actor/kasen/atkLow0003.bmp",
   L"data/actor/kasen/atkLow0004.bmp",
   L"data/actor/kasen/atkLow0005.bmp",
   L"data/actor/kasen/atkUpper0000.bmp",
   L"data/actor/kasen/atkUpper0001.bmp",
   L"data/actor/kasen/atkUpper0002.bmp",
   L"data/actor/kasen/atkUpper0003.bmp",
   L"data/actor/kasen/atkUpper0004.bmp",
   L"data/actor/kasen/atkUpper0005.bmp",
   L"data/actor/kasen/atkUpper0006.bmp",
   L"data/actor/kasen/atkUpper0007.bmp",
   L"data/actor/kasen/atkUpper0008.bmp",
   L"data/actor/kasen/atkUpper0009.bmp",
   L"data/actor/kasen/atkUpper0010.bmp",
   L"data/actor/kasen/atkUpperArm0000.bmp",
   L"data/actor/kasen/atkUpperArm0001.bmp",
   L"data/actor/kasen/atkUpperArm0002.bmp",
   L"data/actor/kasen/atkUpperArm0003.bmp",
   L"data/actor/kasen/atk_dashLow0000.bmp",
   L"data/actor/kasen/atk_dashLow0001.bmp",
   L"data/actor/kasen/atk_dashLow0002.bmp",
   L"data/actor/kasen/atk_dashLow0003.bmp",
   L"data/actor/kasen/atk_dashLow0004.bmp",
   L"data/actor/kasen/atk_dashLow0005.bmp",
   L"data/actor/kasen/atk_dashLow0006.bmp",
   L"data/actor/kasen/atk_dashLow0007.bmp",
   L"data/actor/kasen/atk_Mid0000.bmp",
   L"data/actor/kasen/atk_Mid0001.bmp",
   L"data/actor/kasen/atk_Mid0002.bmp",
   L"data/actor/kasen/atk_Mid0003.bmp",
   L"data/actor/kasen/atk_Mid0004.bmp",
   L"data/actor/kasen/atk_Mid0005.bmp",
   L"data/actor/kasen/atk_Mid0006.bmp",
   L"data/actor/kasen/atk_Mid0007.bmp",
   L"data/actor/kasen/atk_Mid0008.bmp",
   L"data/actor/kasen/atk_mid_air0000.bmp",
   L"data/actor/kasen/atk_mid_air0001.bmp",
   L"data/actor/kasen/atk_mid_air0002.bmp",
   L"data/actor/kasen/atk_mid_air0003.bmp",
   L"data/actor/kasen/atk_mid_air0004.bmp",
   L"data/actor/kasen/atk_mid_air0005.bmp",
   L"data/actor/kasen/atk_mid_air0006.bmp",
   L"data/actor/kasen/atk_Under0000.bmp",
   L"data/actor/kasen/atk_Under0001.bmp",
   L"data/actor/kasen/atk_Under0002.bmp",
   L"data/actor/kasen/atk_Under0003.bmp",
   L"data/actor/kasen/atk_Under0004.bmp",
   L"data/actor/kasen/atk_Under0005.bmp",
   L"data/actor/kasen/atk_Under0006.bmp",
   L"data/actor/kasen/atk_Under0007.bmp",
   L"data/actor/kasen/atk_Under0008.bmp",
   L"data/actor/kasen/beginBattleB0000.bmp",
   L"data/actor/kasen/bmsln/reimu_buster.bmb",
   L"data/actor/kasen/bmsln/reimu_busterHit.bmb",
   L"data/actor/kasen/bmsln/reimu_fallKickA.bmb",
   L"data/actor/kasen/bmsln/reimu_HighShotBaria.bmb",
   L"data/actor/kasen/bmsln/reimu_keisei.bmb",
   L"data/actor/kasen/bmsln/reimu_kibakuzinA.bmb",
   L"data/actor/kasen/bmsln/reimu_musouB.bmb",
   L"data/actor/kasen/bmsln/reimu_musouG.bmb",
   L"data/actor/kasen/bmsln/reimu_musouHitB.bmb",
   L"data/actor/kasen/bmsln/reimu_musouHitG.bmb",
   L"data/actor/kasen/bmsln/reimu_musouHitR.bmb",
   L"data/actor/kasen/bmsln/reimu_musouR.bmb",
   L"data/actor/kasen/bmsln/reimu_shot.bmb",
   L"data/actor/kasen/bmsln/reimu_shotA.bmb",
   L"data/actor/kasen/bmsln/reimu_shotA_gateRing.bmb",
   L"data/actor/kasen/bmsln/reimu_shotA_hit.bmb",
   L"data/actor/kasen/bmsln/reimu_skillG_kick.bmb",
   L"data/actor/kasen/bmsln/reimu_TenseiA000.bmb",
   L"data/actor/kasen/bmsln/reimu_tenseiFinish.bmb",
   L"data/actor/kasen/bmsln/reimu_tenseiRock.bmb",
   L"data/actor/kasen/bmsln/reimu_tenseiRockShot.bmb",
   L"data/actor/kasen/bmsln/shot_A_000.bmb",
   L"data/actor/kasen/bmsln/shot_A_000.bmsln",
   L"data/actor/kasen/climax0000.bmp",
   L"data/actor/kasen/climax0001.bmp",
   L"data/actor/kasen/climax0002.bmp",
   L"data/actor/kasen/climax0003.bmp",
   L"data/actor/kasen/climax0004.bmp",
   L"data/actor/kasen/climax0005.bmp",
   L"data/actor/kasen/climax0006.bmp",
   L"data/actor/kasen/climax0007.bmp",
   L"data/actor/kasen/climax0008.bmp",
   L"data/actor/kasen/climax0009.bmp",
   L"data/actor/kasen/climax0010.bmp",
   L"data/actor/kasen/climax0011.bmp",
   L"data/actor/kasen/climaxArm0000.bmp",
   L"data/actor/kasen/climax_CutFace.png",
   L"data/actor/kasen/climax_HitLoop0000.bmp",
   L"data/actor/kasen/climax_Typoon0000.bmp",
   L"data/actor/kasen/climax_Typoon0001.bmp",
   L"data/actor/kasen/climax_Typoon0002.bmp",
   L"data/actor/kasen/climax_Typoon0003.bmp",
   L"data/actor/kasen/climax_Typoon0004.bmp",
   L"data/actor/kasen/damageSpin0000.bmp",
   L"data/actor/kasen/damageSpin0001.bmp",
   L"data/actor/kasen/damageSpin0002.bmp",
   L"data/actor/kasen/damageSpin0003.bmp",
   L"data/actor/kasen/damageUpper0000.bmp",
   L"data/actor/kasen/damageUpper0001.bmp",
   L"data/actor/kasen/damageUpper0002.bmp",
   L"data/actor/kasen/damageUpper0003.bmp",
   L"data/actor/kasen/damageUpper0004.bmp",
   L"data/actor/kasen/damageUpper0005.bmp",
   L"data/actor/kasen/damageUpper0006.bmp",
   L"data/actor/kasen/damageUpper0007.bmp",
   L"data/actor/kasen/damageUpper0008.bmp",
   L"data/actor/kasen/damageUpper0009.bmp",
   L"data/actor/kasen/damageUpper0010.bmp",
   L"data/actor/kasen/damageUpper0011.bmp",
   L"data/actor/kasen/damageUpper0012.bmp",
   L"data/actor/kasen/damageUpper0013.bmp",
   L"data/actor/kasen/damageUpper0014.bmp",
   L"data/actor/kasen/damage_body0000.bmp",
   L"data/actor/kasen/damage_body0001.bmp",
   L"data/actor/kasen/damage_body0002.bmp",
   L"data/actor/kasen/damage_body0003.bmp",
   L"data/actor/kasen/damage_body0004.bmp",
   L"data/actor/kasen/damage_head0000.bmp",
   L"data/actor/kasen/damage_head0001.bmp",
   L"data/actor/kasen/damage_head0002.bmp",
   L"data/actor/kasen/damage_head0003.bmp",
   L"data/actor/kasen/damage_head0004.bmp",
   L"data/actor/kasen/damage_wall0000.bmp",
   L"data/actor/kasen/damage_wall0001.bmp",
   L"data/actor/kasen/damage_wall0002.bmp",
   L"data/actor/kasen/damage_wall0003.bmp",
   L"data/actor/kasen/damage_wall0004.bmp",
   L"data/actor/kasen/dashBack0000.bmp",
   L"data/actor/kasen/dashBack0001.bmp",
   L"data/actor/kasen/dashBack0003.bmp",
   L"data/actor/kasen/dashBack0004.bmp",
   L"data/actor/kasen/dashBack0005.bmp",
   L"data/actor/kasen/dashBackLoop0000.bmp",
   L"data/actor/kasen/dashBackLoop0001.bmp",
   L"data/actor/kasen/dashBackLoop0002.bmp",
   L"data/actor/kasen/dashBackLoop0003.bmp",
   L"data/actor/kasen/dashBackLoop0004.bmp",
   L"data/actor/kasen/dashFront0000.bmp",
   L"data/actor/kasen/dashFront0001.bmp",
   L"data/actor/kasen/dashFront0003.bmp",
   L"data/actor/kasen/dashFront0004.bmp",
   L"data/actor/kasen/dashFront0005.bmp",
   L"data/actor/kasen/dashFrontLoop0000.bmp",
   L"data/actor/kasen/dashFrontLoop0001.bmp",
   L"data/actor/kasen/dashFrontLoop0002.bmp",
   L"data/actor/kasen/dashFrontLoop0003.bmp",
   L"data/actor/kasen/dashFrontLoop0004.bmp",
   L"data/actor/kasen/dragonB0000.bmp",
   L"data/actor/kasen/dragonB0001.bmp",
   L"data/actor/kasen/dragonB0002.bmp",
   L"data/actor/kasen/dragonB0003.bmp",
   L"data/actor/kasen/dragonB0004.bmp",
   L"data/actor/kasen/dragonB0005.bmp",
   L"data/actor/kasen/dragonB0006.bmp",
   L"data/actor/kasen/dragonB0007.bmp",
   L"data/actor/kasen/eagle_lose0000.bmp",
   L"data/actor/kasen/face_spellCall.png",
   L"data/actor/kasen/grab0000.bmp",
   L"data/actor/kasen/grab0001.bmp",
   L"data/actor/kasen/grab0002.bmp",
   L"data/actor/kasen/grab0003.bmp",
   L"data/actor/kasen/grab0004.bmp",
   L"data/actor/kasen/grab0005.bmp",
   L"data/actor/kasen/grab0006.bmp",
   L"data/actor/kasen/grab_hit0000.bmp",
   L"data/actor/kasen/grab_hit0001.bmp",
   L"data/actor/kasen/guard0000.bmp",
   L"data/actor/kasen/guard0001.bmp",
   L"data/actor/kasen/guard0002.bmp",
   L"data/actor/kasen/guard0003.bmp",
   L"data/actor/kasen/guardCrash0000.bmp",
   L"data/actor/kasen/guardCrash0001.bmp",
   L"data/actor/kasen/guardCrash0002.bmp",
   L"data/actor/kasen/guardCrash0003.bmp",
   L"data/actor/kasen/guardCrash0004.bmp",
   L"data/actor/kasen/guardCrash0005.bmp",
   L"data/actor/kasen/guard_miss0000.bmp",
   L"data/actor/kasen/guard_miss0001.bmp",
   L"data/actor/kasen/guard_miss0002.bmp",
   L"data/actor/kasen/guard_miss0003.bmp",
   L"data/actor/kasen/kanda0000.bmp",
   L"data/actor/kasen/kanda0001.bmp",
   L"data/actor/kasen/kanda0002.bmp",
   L"data/actor/kasen/kanda0003.bmp",
   L"data/actor/kasen/kanda0004.bmp",
   L"data/actor/kasen/kanda0005.bmp",
   L"data/actor/kasen/kanda0006.bmp",
   L"data/actor/kasen/kasen.pat",
   L"data/actor/kasen/kasen_ed.pat",
   L"data/actor/kasen/lose0000.bmp",
   L"data/actor/kasen/lose0001.bmp",
   L"data/actor/kasen/lose0002.bmp",
   L"data/actor/kasen/lose0003.bmp",
   L"data/actor/kasen/moveSlideLoop0000.bmp",
   L"data/actor/kasen/moveSlideLoop0001.bmp",
   L"data/actor/kasen/moveSlideLoop0002.bmp",
   L"data/actor/kasen/moveSlideLoop0003.bmp",
   L"data/actor/kasen/moveSlideLoop0004.bmp",
   L"data/actor/kasen/move_slide0000.bmp",
   L"data/actor/kasen/move_slide0002.bmp",
   L"data/actor/kasen/move_slide0003.bmp",
   L"data/actor/kasen/move_slide0004.bmp",
   L"data/actor/kasen/move_slide0005.bmp",
   L"data/actor/kasen/move_slide0006.bmp",
   L"data/actor/kasen/occult0000.bmp",
   L"data/actor/kasen/occult0001.bmp",
   L"data/actor/kasen/occult0002.bmp",
   L"data/actor/kasen/occult0003.bmp",
   L"data/actor/kasen/occult0004.bmp",
   L"data/actor/kasen/occult0005.bmp",
   L"data/actor/kasen/occult0006.bmp",
   L"data/actor/kasen/occult0007.bmp",
   L"data/actor/kasen/occult0008.bmp",
   L"data/actor/kasen/occult0009.bmp",
   L"data/actor/kasen/occult0010.bmp",
   L"data/actor/kasen/occult0011.bmp",
   L"data/actor/kasen/occultArm0000.bmp",
   L"data/actor/kasen/occultArm0001.bmp",
   L"data/actor/kasen/occult_armB0000.bmp",
   L"data/actor/kasen/occult_armB0001.bmp",
   L"data/actor/kasen/occult_armB0002.bmp",
   L"data/actor/kasen/occult_throw0000.bmp",
   L"data/actor/kasen/occult_throw0001.bmp",
   L"data/actor/kasen/occult_throw0002.bmp",
   L"data/actor/kasen/occult_throw0003.bmp",
   L"data/actor/kasen/occult_throw0004.bmp",
   L"data/actor/kasen/occult_throw0005.bmp",
   L"data/actor/kasen/occult_throw0006.bmp",
   L"data/actor/kasen/occult_throw0007.bmp",
   L"data/actor/kasen/occult_throw0008.bmp",
   L"data/actor/kasen/occult_throw0009.bmp",
   L"data/actor/kasen/occult_throw0010.bmp",
   L"data/actor/kasen/occult_throw0011.bmp",
   L"data/actor/kasen/occult_throw0012.bmp",
   L"data/actor/kasen/palette000.bmp",
   L"data/actor/kasen/palette001.bmp",
   L"data/actor/kasen/palette002.bmp",
   L"data/actor/kasen/palette003.bmp",
   L"data/actor/kasen/palette004.bmp",
   L"data/actor/kasen/palette005.bmp",
   L"data/actor/kasen/palette006.bmp",
   L"data/actor/kasen/palette007.bmp",
   L"data/actor/kasen/palette100.bmp",
   L"data/actor/kasen/palette101.bmp",
   L"data/actor/kasen/palette102.bmp",
   L"data/actor/kasen/palette103.bmp",
   L"data/actor/kasen/palette104.bmp",
   L"data/actor/kasen/palette105.bmp",
   L"data/actor/kasen/palette106.bmp",
   L"data/actor/kasen/palette107.bmp",
   L"data/actor/kasen/shotCharge0000.bmp",
   L"data/actor/kasen/shotCharge0001.bmp",
   L"data/actor/kasen/shotCharge0002.bmp",
   L"data/actor/kasen/shotCharge0003.bmp",
   L"data/actor/kasen/shotCharge0004.bmp",
   L"data/actor/kasen/shotCharge0005.bmp",
   L"data/actor/kasen/shotCharge0006.bmp",
   L"data/actor/kasen/shotFront0000.bmp",
   L"data/actor/kasen/shotFront0001.bmp",
   L"data/actor/kasen/shotFront0002.bmp",
   L"data/actor/kasen/shotFront0003.bmp",
   L"data/actor/kasen/shotFront0004.bmp",
   L"data/actor/kasen/shotFront0005.bmp",
   L"data/actor/kasen/shotFront0006.bmp",
   L"data/actor/kasen/shot_normal0000.bmp",
   L"data/actor/kasen/shot_normal0001.bmp",
   L"data/actor/kasen/shot_normal0002.bmp",
   L"data/actor/kasen/shot_normal0003.bmp",
   L"data/actor/kasen/shot_normal0004.bmp",
   L"data/actor/kasen/shot_normal0005.bmp",
   L"data/actor/kasen/shot_normal0006.bmp",
   L"data/actor/kasen/skillA0000.bmp",
   L"data/actor/kasen/skillA0001.bmp",
   L"data/actor/kasen/skillA0002.bmp",
   L"data/actor/kasen/skillA0003.bmp",
   L"data/actor/kasen/skillA0004.bmp",
   L"data/actor/kasen/skillA0005.bmp",
   L"data/actor/kasen/skillA0006.bmp",
   L"data/actor/kasen/skillA0007.bmp",
   L"data/actor/kasen/skillB0000.bmp",
   L"data/actor/kasen/skillB0001.bmp",
   L"data/actor/kasen/skillB0002.bmp",
   L"data/actor/kasen/skillB0003.bmp",
   L"data/actor/kasen/skillB0004.bmp",
   L"data/actor/kasen/skillB0005.bmp",
   L"data/actor/kasen/skillB0006.bmp",
   L"data/actor/kasen/skillB0007.bmp",
   L"data/actor/kasen/skillB0008.bmp",
   L"data/actor/kasen/skillB0009.bmp",
   L"data/actor/kasen/skillC0000.bmp",
   L"data/actor/kasen/skillC0001.bmp",
   L"data/actor/kasen/skillC0002.bmp",
   L"data/actor/kasen/skillC0003.bmp",
   L"data/actor/kasen/skillCb0000.bmp",
   L"data/actor/kasen/skillCb0001.bmp",
   L"data/actor/kasen/skillCb0002.bmp",
   L"data/actor/kasen/skillCc0000.bmp",
   L"data/actor/kasen/skillCc0001.bmp",
   L"data/actor/kasen/skillCc0002.bmp",
   L"data/actor/kasen/skillCc0003.bmp",
   L"data/actor/kasen/skillCc0004.bmp",
   L"data/actor/kasen/skillCc0005.bmp",
   L"data/actor/kasen/skillCd0000.bmp",
   L"data/actor/kasen/skillCd0001.bmp",
   L"data/actor/kasen/skillCd0002.bmp",
   L"data/actor/kasen/skillCd0003.bmp",
   L"data/actor/kasen/skillCd0004.bmp",
   L"data/actor/kasen/skillCd0005.bmp",
   L"data/actor/kasen/skillCd0006.bmp",
   L"data/actor/kasen/skillD0000.bmp",
   L"data/actor/kasen/skillD0001.bmp",
   L"data/actor/kasen/skillD0002.bmp",
   L"data/actor/kasen/skillD0003.bmp",
   L"data/actor/kasen/skillD0004.bmp",
   L"data/actor/kasen/skillD0005.bmp",
   L"data/actor/kasen/skillD0006.bmp",
   L"data/actor/kasen/skillD0007.bmp",
   L"data/actor/kasen/slideLoopB0000.bmp",
   L"data/actor/kasen/slideLoopB0001.bmp",
   L"data/actor/kasen/slideLoopB0002.bmp",
   L"data/actor/kasen/slideLoopB0003.bmp",
   L"data/actor/kasen/slideLoopB0004.bmp",
   L"data/actor/kasen/spellA0000.bmp",
   L"data/actor/kasen/spellA0001.bmp",
   L"data/actor/kasen/spellA0002.bmp",
   L"data/actor/kasen/spellA0003.bmp",
   L"data/actor/kasen/spellA0004.bmp",
   L"data/actor/kasen/spellA0005.bmp",
   L"data/actor/kasen/spellA0006.bmp",
   L"data/actor/kasen/spellA_bantageCapture0000.bmp",
   L"data/actor/kasen/spellA_throw0000.bmp",
   L"data/actor/kasen/spellA_throw0001.bmp",
   L"data/actor/kasen/spellA_throw0002.bmp",
   L"data/actor/kasen/spellA_throw0003.bmp",
   L"data/actor/kasen/spellA_throw0004.bmp",
   L"data/actor/kasen/spellA_throw0005.bmp",
   L"data/actor/kasen/spellA_throw0006.bmp",
   L"data/actor/kasen/spellA_throw0007.bmp",
   L"data/actor/kasen/spellA_throw0008.bmp",
   L"data/actor/kasen/spellA_throw0009.bmp",
   L"data/actor/kasen/spellA_throw0010.bmp",
   L"data/actor/kasen/spellA_throw0011.bmp",
   L"data/actor/kasen/spellA_throw0012.bmp",
   L"data/actor/kasen/spellA_throw0013.bmp",
   L"data/actor/kasen/spellA_throw0014.bmp",
   L"data/actor/kasen/spellA_throw0015.bmp",
   L"data/actor/kasen/spellA_throw0016.bmp",
   L"data/actor/kasen/spellA_throw0017.bmp",
   L"data/actor/kasen/spellA_throw0018.bmp",
   L"data/actor/kasen/spellA_throw0019.bmp",
   L"data/actor/kasen/spellA_throw0020.bmp",
   L"data/actor/kasen/spellB0000.bmp",
   L"data/actor/kasen/spellB0001.bmp",
   L"data/actor/kasen/spellB0002.bmp",
   L"data/actor/kasen/spellB0003.bmp",
   L"data/actor/kasen/spellB0004.bmp",
   L"data/actor/kasen/spellB0005.bmp",
   L"data/actor/kasen/spellB0006.bmp",
   L"data/actor/kasen/spellB0007.bmp",
   L"data/actor/kasen/spellB0008.bmp",
   L"data/actor/kasen/spellB0009.bmp",
   L"data/actor/kasen/spellB0010.bmp",
   L"data/actor/kasen/spellB0011.bmp",
   L"data/actor/kasen/spellB_batage0000.bmp",
   L"data/actor/kasen/spellB_batage0001.bmp",
   L"data/actor/kasen/spellC0000.bmp",
   L"data/actor/kasen/spellC0001.bmp",
   L"data/actor/kasen/spellC0002.bmp",
   L"data/actor/kasen/spellC0003.bmp",
   L"data/actor/kasen/spellC0004.bmp",
   L"data/actor/kasen/spellC0005.bmp",
   L"data/actor/kasen/spellC0006.bmp",
   L"data/actor/kasen/spellC0007.bmp",
   L"data/actor/kasen/spellC0008.bmp",
   L"data/actor/kasen/spellCall0000.bmp",
   L"data/actor/kasen/spellCall0001.bmp",
   L"data/actor/kasen/spellCall0002.bmp",
   L"data/actor/kasen/spellCall0003.bmp",
   L"data/actor/kasen/spellCall0004.bmp",
   L"data/actor/kasen/spellCall0005.bmp",
   L"data/actor/kasen/spellCall0006.bmp",
   L"data/actor/kasen/stand.bmp",
   L"data/actor/kasen/stand0000.bmp",
   L"data/actor/kasen/stand0001.bmp",
   L"data/actor/kasen/stand0002.bmp",
   L"data/actor/kasen/stand0003.bmp",
   L"data/actor/kasen/stand0004.bmp",
   L"data/actor/kasen/stand0005.bmp",
   L"data/actor/kasen/stand0006.bmp",
   L"data/actor/kasen/stand0007.bmp",
   L"data/actor/kasen/stand0008.bmp",
   L"data/actor/kasen/stand0009.bmp",
   L"data/actor/kasen/stand0010.bmp",
   L"data/actor/kasen/stand0011.bmp",
   L"data/actor/kasen/stand0012.bmp",
   L"data/actor/kasen/stand0013.bmp",
   L"data/actor/kasen/stand0014.bmp",
   L"data/actor/kasen/stun0000.bmp",
   L"data/actor/kasen/stun0001.bmp",
   L"data/actor/kasen/stun0002.bmp",
   L"data/actor/kasen/stun0003.bmp",
   L"data/actor/kasen/stun0004.bmp",
   L"data/actor/kasen/stun0005.bmp",
   L"data/actor/kasen/team_battle_beginA0000.bmp",
   L"data/actor/kasen/team_battle_beginA0001.bmp",
   L"data/actor/kasen/team_battle_beginA0002.bmp",
   L"data/actor/kasen/team_battle_beginA0003.bmp",
   L"data/actor/kasen/team_battle_beginA0004.bmp",
   L"data/actor/kasen/team_battle_beginA0005.bmp",
   L"data/actor/kasen/test_armShotUnder0000.bmp",
   L"data/actor/kasen/test_armShotUnder0001.bmp",
   L"data/actor/kasen/test_armShotUnder0002.bmp",
   L"data/actor/kasen/test_armShotUnder0003.bmp",
   L"data/actor/kasen/test_armShotUnder0004.bmp",
   L"data/actor/kasen/test_armShotUpper0000.bmp",
   L"data/actor/kasen/test_armShotUpper0001.bmp",
   L"data/actor/kasen/test_armShotUpper0002.bmp",
   L"data/actor/kasen/test_armShotUpper0003.bmp",
   L"data/actor/kasen/test_armShotUpper0004.bmp",
   L"data/actor/kasen/test_azarashi0000.bmp",
   L"data/actor/kasen/test_azarashi0001.bmp",
   L"data/actor/kasen/test_azarashi0002.bmp",
   L"data/actor/kasen/test_azarashi0003.bmp",
   L"data/actor/kasen/test_azarashi0004.bmp",
   L"data/actor/kasen/test_effect.bmp",
   L"data/actor/kasen/texture/ball.bmp",
   L"data/actor/kasen/texture/ballB.png",
   L"data/actor/kasen/texture/ballList0000.dds",
   L"data/actor/kasen/texture/climax_aura0000.png",
   L"data/actor/kasen/texture/climax_aura0001.png",
   L"data/actor/kasen/texture/common_spark.png",
   L"data/actor/kasen/texture/face_master_kasen.png",
   L"data/actor/kasen/texture/face_master_kasen2.png",
   L"data/actor/kasen/texture/face_slave_kasen.png",
   L"data/actor/kasen/texture/face_spell_cut.png",
   L"data/actor/kasen/texture/kasen_animal00000.png",
   L"data/actor/kasen/texture/kasen_animal00006.png",
   L"data/actor/kasen/texture/kasen_animal00012.png",
   L"data/actor/kasen/texture/kasen_animal00018.png",
   L"data/actor/kasen/texture/kasen_animal00024.png",
   L"data/actor/kasen/texture/kasen_animalDamage00000.png",
   L"data/actor/kasen/texture/kasen_animalDamage00006.png",
   L"data/actor/kasen/texture/kasen_animalDamage00012.png",
   L"data/actor/kasen/texture/kasen_animalDamage00018.png",
   L"data/actor/kasen/texture/kasen_animalDamage00024.png",
   L"data/actor/kasen/texture/kasen_auraWave0000.png",
   L"data/actor/kasen/texture/kasen_ballShot0000.png",
   L"data/actor/kasen/texture/kasen_climaxArmAura0000.png",
   L"data/actor/kasen/texture/kasen_climaxArmAura0001.png",
   L"data/actor/kasen/texture/kasen_climaxBack0000.png",
   L"data/actor/kasen/texture/kasen_colorBall0000.png",
   L"data/actor/kasen/texture/kasen_eableEffect0000.png",
   L"data/actor/kasen/texture/kasen_eagleFeather0000.png",
   L"data/actor/kasen/texture/kasen_shorNormal0000.png",
   L"data/actor/kasen/texture/kasen_shotVortex0000.png",
   L"data/actor/kasen/texture/kasen_skillBspark0000.png",
   L"data/actor/kasen/texture/kasen_skillBspark0001.png",
   L"data/actor/kasen/texture/kasen_skillB_smash0000.png",
   L"data/actor/kasen/texture/kasen_skillB_smash0001.png",
   L"data/actor/kasen/texture/kasen_skillB_smash0002.png",
   L"data/actor/kasen/texture/kasen_tigerClow0000.png",
   L"data/actor/kasen/texture/kasen_tigerGate0000.png",
   L"data/actor/kasen/texture/kasen_tigerGate0001.png",
   L"data/actor/kasen/texture/kasen_tigerGate0002.png",
   L"data/actor/kasen/texture/kasen_tigerGate0003.png",
   L"data/actor/kasen/texture/kasen_tigerHole0000.png",
   L"data/actor/kasen/texture/kasen_tornadeBase0000.png",
   L"data/actor/kasen/texture/kasen_tornadeBase0001.png",
   L"data/actor/kasen/texture/kasen_tornadeBase0002.png",
   L"data/actor/kasen/texture/kasen_trail.png",
   L"data/actor/kasen/texture/marisaBall2.bmp",
   L"data/actor/kasen/texture/marisaStarFlare.bmp",
   L"data/actor/kasen/texture/mask_ball.png",
   L"data/actor/kasen/texture/mask_Box.bmp",
   L"data/actor/kasen/texture/miko_ballB.png",
   L"data/actor/kasen/texture/occult_aura0000.dds",
   L"data/actor/kasen/texture/occult_ball0000.png",
   L"data/actor/kasen/texture/occult_slash0000.dds",
   L"data/actor/kasen/texture/reimu_boxA.png",
   L"data/actor/kasen/texture/reimu_fallKick.png",
   L"data/actor/kasen/texture/reimu_loopAuraA.png",
   L"data/actor/kasen/texture/reimu_musouBase.png",
   L"data/actor/kasen/texture/reimu_skillG_FlashA.png",
   L"data/actor/kasen/texture/reimu_wallA_Halfmask.png",
   L"data/actor/kasen/texture/reimu_wallA_mask.png",
   L"data/actor/kasen/texture/reimu_wallFlashA.png",
   L"data/actor/kasen/texture/shotStingA0000.png",
   L"data/actor/kasen/texture/skillC_charge0000.dds",
   L"data/actor/kasen/texture/skillE_fire0000.dds",
   L"data/actor/kasen/texture/skillE_fire0001.dds",
   L"data/actor/kasen/texture/skillE_texture0000.dds",
   L"data/actor/kasen/texture/spellA_swing0000.dds",
   L"data/actor/kasen/texture/spellB_shock0000.png",
   L"data/actor/kasen/texture/spellB_shock0001.png",
   L"data/actor/kasen/texture/spellC.dds",
   L"data/actor/kasen/texture/spellC_splash0000.dds",
   L"data/actor/kasen/texture/spellC_swing0000.dds",
   L"data/actor/kasen/texture/spell_use_cut.png",
   L"data/actor/kasen/tiger0000.bmp",
   L"data/actor/kasen/tiger0001.bmp",
   L"data/actor/kasen/tigerA0000.bmp",
   L"data/actor/kasen/tigerA0001.bmp",
   L"data/actor/kasen/tigerA0002.bmp",
   L"data/actor/kasen/tigerA0003.bmp",
   L"data/actor/kasen/tigerA0004.bmp",
   L"data/actor/kasen/turn0000.bmp",
   L"data/actor/kasen/turn0001.bmp",
   L"data/actor/kasen/turn0002.bmp",
   L"data/actor/kasen/walk0000.bmp",
   L"data/actor/kasen/walk0001.bmp",
   L"data/actor/kasen/walk0002.bmp",
   L"data/actor/kasen/walk0003.bmp",
   L"data/actor/kasen/walk0004.bmp",
   L"data/actor/kasen/walk0005.bmp",
   L"data/actor/kasen/walk0006.bmp",
   L"data/actor/kasen/walk0007.bmp",
   L"data/actor/kasen/walk0008.bmp",
   L"data/actor/kasen/walk0009.bmp",
   L"data/actor/kasen/walkBack0000.bmp",
   L"data/actor/kasen/walkBack0001.bmp",
   L"data/actor/kasen/walkBack0003.bmp",
   L"data/actor/kasen/walkBack0004.bmp",
   L"data/actor/kasen/walkBack0005.bmp",
   L"data/actor/kasen/walkBackloop0000.bmp",
   L"data/actor/kasen/walkBackloop0001.bmp",
   L"data/actor/kasen/walkBackloop0002.bmp",
   L"data/actor/kasen/walkBackloop0003.bmp",
   L"data/actor/kasen/walkBackloop0004.bmp",
   L"data/actor/kasen/walkloop0000.bmp",
   L"data/actor/kasen/walkloop0001.bmp",
   L"data/actor/kasen/walkloop0002.bmp",
   L"data/actor/kasen/walkloop0003.bmp",
   L"data/actor/kasen/walkloop0004.bmp",
   L"data/actor/kasen/warpMask.bmp",
   L"data/actor/kasen/winA0000.bmp",
   L"data/actor/kasen/winA0001.bmp",
   L"data/actor/kasen/winA0002.bmp",
   L"data/actor/kasen/winA0003.bmp",
   L"data/actor/kasen/winA0004.bmp",
   L"data/actor/kasen/winA0005.bmp",
   L"data/actor/kasen/winB0000.bmp",
   L"data/actor/kasen/winB0001.bmp",
   L"data/actor/kasen/winB0002.bmp",
   L"data/actor/kasen/winB0003.bmp",
   L"data/actor/kasen/winB0004.bmp",
   L"data/actor/kasen/winB0005.bmp",
   L"data/actor/kasen/winB0006.bmp",
   L"data/actor/kasen/winB0007.bmp",
   L"data/actor/kasen/winB0008.bmp",
   L"data/actor/kasen/winB0009.bmp",
   L"data/actor/kasen/winB0010.bmp",
   L"data/actor/kasen/winB0011.bmp",
   L"data/actor/kasen/winB0012.bmp",
   L"data/actor/kasen.nut",
   L"data/actor/kasen_base.nut",
   L"data/actor/kasen_boss.nut",
   L"data/actor/kasen_boss_base.nut",
   L"data/actor/kasen_boss_init.nut",
   L"data/actor/kasen_boss_shot.nut",
   L"data/actor/kasen_com.nut",
   L"data/actor/kasen_combo.nut",
   L"data/actor/kasen_com_function.nut",
   L"data/actor/kasen_eagle.nut",
   L"data/actor/kasen_init.nut",
   L"data/actor/kasen_practice_init.nut",
   L"data/actor/kasen_shot.nut",
   L"data/actor/kasen_team.nut",
   L"data/actor/koishi/atkHighFrontOB0000.bmp",
   L"data/actor/koishi/atkHighFrontOB0001.bmp",
   L"data/actor/koishi/atkHighFrontOB0002.bmp",
   L"data/actor/koishi/atkHighFrontOB0003.bmp",
   L"data/actor/koishi/atkHighFrontOB0004.bmp",
   L"data/actor/koishi/atkHighFrontOB0005.bmp",
   L"data/actor/koishi/atkHighFrontOB0006.bmp",
   L"data/actor/koishi/atkHighFrontOB0007.bmp",
   L"data/actor/koishi/atkHighFrontOB0008.bmp",
   L"data/actor/koishi/battleBeginB0000.bmp",
   L"data/actor/koishi/battleBeginB0001.bmp",
   L"data/actor/koishi/battleBeginB0002.bmp",
   L"data/actor/koishi/battleBeginB0003.bmp",
   L"data/actor/koishi/battleBeginB0004.bmp",
   L"data/actor/koishi/battleBeginB0005.bmp",
   L"data/actor/koishi/battleBeginB0006.bmp",
   L"data/actor/koishi/battleBeginB0007.bmp",
   L"data/actor/koishi/battleBeginB0008.bmp",
   L"data/actor/koishi/battleBeginB0009.bmp",
   L"data/actor/koishi/battleBeginB0010.bmp",
   L"data/actor/koishi/bmsln/climaxRose.bmb",
   L"data/actor/koishi/bmsln/koishi_skillA_Fire.bmb",
   L"data/actor/koishi/bmsln/koishi_subtare.bmb",
   L"data/actor/koishi/climaxbase0000.bmp",
   L"data/actor/koishi/climaxbase0001.bmp",
   L"data/actor/koishi/climaxbase0002.bmp",
   L"data/actor/koishi/climaxbase0003.bmp",
   L"data/actor/koishi/crash0000.bmp",
   L"data/actor/koishi/crash0001.bmp",
   L"data/actor/koishi/crash0002.bmp",
   L"data/actor/koishi/crash0003.bmp",
   L"data/actor/koishi/crash0004.bmp",
   L"data/actor/koishi/crash0005.bmp",
   L"data/actor/koishi/dash_back0000.bmp",
   L"data/actor/koishi/dash_back0001.bmp",
   L"data/actor/koishi/dash_back0002.bmp",
   L"data/actor/koishi/dash_back0003.bmp",
   L"data/actor/koishi/dash_back0004.bmp",
   L"data/actor/koishi/dash_back0005.bmp",
   L"data/actor/koishi/dash_back0006.bmp",
   L"data/actor/koishi/dash_back0007.bmp",
   L"data/actor/koishi/dash_back0008.bmp",
   L"data/actor/koishi/dash_back0009.bmp",
   L"data/actor/koishi/dash_back0010.bmp",
   L"data/actor/koishi/dash_back0011.bmp",
   L"data/actor/koishi/dash_back0012.bmp",
   L"data/actor/koishi/dash_back0013.bmp",
   L"data/actor/koishi/dash_back0014.bmp",
   L"data/actor/koishi/face_spellCallB.png",
   L"data/actor/koishi/koishi.pat",
   L"data/actor/koishi/koishi_ed.pat",
   L"data/actor/koishi/occult0000.bmp",
   L"data/actor/koishi/occult0001.bmp",
   L"data/actor/koishi/occult0002.bmp",
   L"data/actor/koishi/occult0003.bmp",
   L"data/actor/koishi/occult0004.bmp",
   L"data/actor/koishi/occult0005.bmp",
   L"data/actor/koishi/occult0006.bmp",
   L"data/actor/koishi/occult0007.bmp",
   L"data/actor/koishi/palette000.bmp",
   L"data/actor/koishi/palette001.bmp",
   L"data/actor/koishi/palette002.bmp",
   L"data/actor/koishi/palette003.bmp",
   L"data/actor/koishi/palette004.bmp",
   L"data/actor/koishi/palette005.bmp",
   L"data/actor/koishi/palette006.bmp",
   L"data/actor/koishi/palette007.bmp",
   L"data/actor/koishi/palette100.bmp",
   L"data/actor/koishi/palette101.bmp",
   L"data/actor/koishi/palette102.bmp",
   L"data/actor/koishi/palette103.bmp",
   L"data/actor/koishi/palette104.bmp",
   L"data/actor/koishi/palette105.bmp",
   L"data/actor/koishi/palette106.bmp",
   L"data/actor/koishi/palette107.bmp",
   L"data/actor/koishi/skillD0000.bmp",
   L"data/actor/koishi/skillD0001.bmp",
   L"data/actor/koishi/skillD0002.bmp",
   L"data/actor/koishi/skillD0003.bmp",
   L"data/actor/koishi/skillD0004.bmp",
   L"data/actor/koishi/skillD0005.bmp",
   L"data/actor/koishi/skillD0006.bmp",
   L"data/actor/koishi/skillD0007.bmp",
   L"data/actor/koishi/skillD0008.bmp",
   L"data/actor/koishi/skillG0000.bmp",
   L"data/actor/koishi/skillG0001.bmp",
   L"data/actor/koishi/skillG0002.bmp",
   L"data/actor/koishi/skillG0003.bmp",
   L"data/actor/koishi/skillG0004.bmp",
   L"data/actor/koishi/skillG0005.bmp",
   L"data/actor/koishi/skillG0006.bmp",
   L"data/actor/koishi/skillG0007.bmp",
   L"data/actor/koishi/skillG0008.bmp",
   L"data/actor/koishi/skillG0009.bmp",
   L"data/actor/koishi/skillOB0000.bmp",
   L"data/actor/koishi/skillOB0001.bmp",
   L"data/actor/koishi/skillOB0002.bmp",
   L"data/actor/koishi/skillOB0003.bmp",
   L"data/actor/koishi/skillOB0004.bmp",
   L"data/actor/koishi/skillOB0005.bmp",
   L"data/actor/koishi/spellB0000.bmp",
   L"data/actor/koishi/spellB0001.bmp",
   L"data/actor/koishi/spellB0002.bmp",
   L"data/actor/koishi/spellB0003.bmp",
   L"data/actor/koishi/spellB0004.bmp",
   L"data/actor/koishi/spellB0005.bmp",
   L"data/actor/koishi/spellB0006.bmp",
   L"data/actor/koishi/spellB0007.bmp",
   L"data/actor/koishi/spellB0008.bmp",
   L"data/actor/koishi/spellB0009.bmp",
   L"data/actor/koishi/spellB0010.bmp",
   L"data/actor/koishi/spellC0000.bmp",
   L"data/actor/koishi/spellC0001.bmp",
   L"data/actor/koishi/spellC0002.bmp",
   L"data/actor/koishi/spellC0003.bmp",
   L"data/actor/koishi/spellC0004.bmp",
   L"data/actor/koishi/spellC0005.bmp",
   L"data/actor/koishi/spellC0006.bmp",
   L"data/actor/koishi/spellC0007.bmp",
   L"data/actor/koishi/spellC0008.bmp",
   L"data/actor/koishi/spellC0009.bmp",
   L"data/actor/koishi/spellC0010.bmp",
   L"data/actor/koishi/spellC0011.bmp",
   L"data/actor/koishi/spellC0012.bmp",
   L"data/actor/koishi/stand0000.bmp",
   L"data/actor/koishi/stand0001.bmp",
   L"data/actor/koishi/stand0002.bmp",
   L"data/actor/koishi/stand0003.bmp",
   L"data/actor/koishi/stand0004.bmp",
   L"data/actor/koishi/stand0005.bmp",
   L"data/actor/koishi/stand0006.bmp",
   L"data/actor/koishi/stand0007.bmp",
   L"data/actor/koishi/stand0008.bmp",
   L"data/actor/koishi/stand0009.bmp",
   L"data/actor/koishi/stand0010.bmp",
   L"data/actor/koishi/stand0011.bmp",
   L"data/actor/koishi/team_battle_begin_marisa0000.bmp",
   L"data/actor/koishi/team_battle_begin_marisa0001.bmp",
   L"data/actor/koishi/team_battle_begin_marisa0002.bmp",
   L"data/actor/koishi/team_battle_begin_marisa0003.bmp",
   L"data/actor/koishi/testr_climaxfont000.png",
   L"data/actor/koishi/testr_climaxfont001.png",
   L"data/actor/koishi/testr_climaxfont002.png",
   L"data/actor/koishi/testr_climaxfont003.png",
   L"data/actor/koishi/testr_climaxfont004.png",
   L"data/actor/koishi/testr_climaxfont005.png",
   L"data/actor/koishi/testr_climaxfont006.png",
   L"data/actor/koishi/testr_climaxfont007.png",
   L"data/actor/koishi/testr_climaxfont008.png",
   L"data/actor/koishi/test_atkDash0000.bmp",
   L"data/actor/koishi/test_atkDash0001.bmp",
   L"data/actor/koishi/test_atkDash0002.bmp",
   L"data/actor/koishi/test_atkDash0003.bmp",
   L"data/actor/koishi/test_atkDash0004.bmp",
   L"data/actor/koishi/test_atkDash0005.bmp",
   L"data/actor/koishi/test_atkDash0006.bmp",
   L"data/actor/koishi/test_atkDash0007.bmp",
   L"data/actor/koishi/test_atkDashLow0000.bmp",
   L"data/actor/koishi/test_atkDashLow0001.bmp",
   L"data/actor/koishi/test_atkDashLow0002.bmp",
   L"data/actor/koishi/test_atkDashLow0003.bmp",
   L"data/actor/koishi/test_atkDashLow0004.bmp",
   L"data/actor/koishi/test_atkDashLow0005.bmp",
   L"data/actor/koishi/test_atkDashLow0006.bmp",
   L"data/actor/koishi/test_atkDashLow0007.bmp",
   L"data/actor/koishi/test_atkDashLow0008.bmp",
   L"data/actor/koishi/test_atkHigh0001.bmp",
   L"data/actor/koishi/test_atkHigh0002.bmp",
   L"data/actor/koishi/test_atkHigh0003.bmp",
   L"data/actor/koishi/test_atkHigh0004.bmp",
   L"data/actor/koishi/test_atkHigh0005.bmp",
   L"data/actor/koishi/test_atkHigh0006.bmp",
   L"data/actor/koishi/test_atkHigh0007.bmp",
   L"data/actor/koishi/test_atkHigh0010.bmp",
   L"data/actor/koishi/test_atkHigh0011.bmp",
   L"data/actor/koishi/test_atkHighFront0000.bmp",
   L"data/actor/koishi/test_atkHighFront0001.bmp",
   L"data/actor/koishi/test_atkHighFront0002.bmp",
   L"data/actor/koishi/test_atkHighFront0003.bmp",
   L"data/actor/koishi/test_atkHighFront0004.bmp",
   L"data/actor/koishi/test_atkHighFront0005.bmp",
   L"data/actor/koishi/test_atkHighFront0006.bmp",
   L"data/actor/koishi/test_atkHighFront0007.bmp",
   L"data/actor/koishi/test_atkHighFront0008.bmp",
   L"data/actor/koishi/test_atkHighUnder0000.bmp",
   L"data/actor/koishi/test_atkHighUnder0001.bmp",
   L"data/actor/koishi/test_atkHighUnder0002.bmp",
   L"data/actor/koishi/test_atkHighUnder0003.bmp",
   L"data/actor/koishi/test_atkHighUnder0004.bmp",
   L"data/actor/koishi/test_atkHighUnder0005.bmp",
   L"data/actor/koishi/test_atkHighUnder0006.bmp",
   L"data/actor/koishi/test_atkHighUnder0007.bmp",
   L"data/actor/koishi/test_atkHighUnder0008.bmp",
   L"data/actor/koishi/test_atkHighUnder0009.bmp",
   L"data/actor/koishi/test_atkHighUnder0010.bmp",
   L"data/actor/koishi/test_atkHighUpper0003.bmp",
   L"data/actor/koishi/test_atkHighUpper0004.bmp",
   L"data/actor/koishi/test_atkHighUpper0005.bmp",
   L"data/actor/koishi/test_atkHighUpper0006.bmp",
   L"data/actor/koishi/test_atkHighUpper0007.bmp",
   L"data/actor/koishi/test_atkHighUpper0008.bmp",
   L"data/actor/koishi/test_atkHighUpper0009.bmp",
   L"data/actor/koishi/test_atkHighUpper0015.bmp",
   L"data/actor/koishi/test_atkLow0000.bmp",
   L"data/actor/koishi/test_atkLow0001.bmp",
   L"data/actor/koishi/test_atkLow0002.bmp",
   L"data/actor/koishi/test_atkLow0003.bmp",
   L"data/actor/koishi/test_atkLow0004.bmp",
   L"data/actor/koishi/test_atkLow0005.bmp",
   L"data/actor/koishi/test_atkLow0006.bmp",
   L"data/actor/koishi/test_atkMid0000.bmp",
   L"data/actor/koishi/test_atkMid0001.bmp",
   L"data/actor/koishi/test_atkMid0002.bmp",
   L"data/actor/koishi/test_atkMid0003.bmp",
   L"data/actor/koishi/test_atkMid0004.bmp",
   L"data/actor/koishi/test_atkMid0005.bmp",
   L"data/actor/koishi/test_atkMid0006.bmp",
   L"data/actor/koishi/test_atkMid0007.bmp",
   L"data/actor/koishi/test_atkMidB0000.bmp",
   L"data/actor/koishi/test_atkMidB0001.bmp",
   L"data/actor/koishi/test_atkMidB0002.bmp",
   L"data/actor/koishi/test_atkMidB0003.bmp",
   L"data/actor/koishi/test_battleBeginA0000.bmp",
   L"data/actor/koishi/test_battleBeginA0001.bmp",
   L"data/actor/koishi/test_battleBeginA0002.bmp",
   L"data/actor/koishi/test_battleBeginA0003.bmp",
   L"data/actor/koishi/test_battleBeginA0004.bmp",
   L"data/actor/koishi/test_climax0000.bmp",
   L"data/actor/koishi/test_climax0001.bmp",
   L"data/actor/koishi/test_climax0002.bmp",
   L"data/actor/koishi/test_climax0003.bmp",
   L"data/actor/koishi/test_climax0004.bmp",
   L"data/actor/koishi/test_climax0005.bmp",
   L"data/actor/koishi/test_climax0006.bmp",
   L"data/actor/koishi/test_climax0007.bmp",
   L"data/actor/koishi/test_climax0008.bmp",
   L"data/actor/koishi/test_climax0009.bmp",
   L"data/actor/koishi/test_climax0010.bmp",
   L"data/actor/koishi/test_climax0011.bmp",
   L"data/actor/koishi/test_climax0012.bmp",
   L"data/actor/koishi/test_crash0000.bmp",
   L"data/actor/koishi/test_crash0001.bmp",
   L"data/actor/koishi/test_damageBody0000.bmp",
   L"data/actor/koishi/test_damageBody0001.bmp",
   L"data/actor/koishi/test_damageBody0002.bmp",
   L"data/actor/koishi/test_damageBody0003.bmp",
   L"data/actor/koishi/test_damageBody0004.bmp",
   L"data/actor/koishi/test_damageHead0000.bmp",
   L"data/actor/koishi/test_damageHead0001.bmp",
   L"data/actor/koishi/test_damageHead0002.bmp",
   L"data/actor/koishi/test_damageHead0003.bmp",
   L"data/actor/koishi/test_damageHead0004.bmp",
   L"data/actor/koishi/test_damageSpin0000.bmp",
   L"data/actor/koishi/test_damageSpin0001.bmp",
   L"data/actor/koishi/test_damageSpin0002.bmp",
   L"data/actor/koishi/test_damageSpin0003.bmp",
   L"data/actor/koishi/test_damageUpper0000.bmp",
   L"data/actor/koishi/test_damageWall0000.bmp",
   L"data/actor/koishi/test_damageWall0001.bmp",
   L"data/actor/koishi/test_damageWall0002.bmp",
   L"data/actor/koishi/test_damageWall0003.bmp",
   L"data/actor/koishi/test_damageWall0004.bmp",
   L"data/actor/koishi/test_dashFront0000.bmp",
   L"data/actor/koishi/test_dashFront0001.bmp",
   L"data/actor/koishi/test_dashFront0002.bmp",
   L"data/actor/koishi/test_dashFront0003.bmp",
   L"data/actor/koishi/test_dashFront0004.bmp",
   L"data/actor/koishi/test_dashFront0005.bmp",
   L"data/actor/koishi/test_dashFront0006.bmp",
   L"data/actor/koishi/test_dashFront0007.bmp",
   L"data/actor/koishi/test_down0000.bmp",
   L"data/actor/koishi/test_down0001.bmp",
   L"data/actor/koishi/test_down0002.bmp",
   L"data/actor/koishi/test_down0003.bmp",
   L"data/actor/koishi/test_down0004.bmp",
   L"data/actor/koishi/test_down0005.bmp",
   L"data/actor/koishi/test_down0006.bmp",
   L"data/actor/koishi/test_down0007.bmp",
   L"data/actor/koishi/test_down0008.bmp",
   L"data/actor/koishi/test_down0009.bmp",
   L"data/actor/koishi/test_down0010.bmp",
   L"data/actor/koishi/test_down0011.bmp",
   L"data/actor/koishi/test_down0012.bmp",
   L"data/actor/koishi/test_down0013.bmp",
   L"data/actor/koishi/test_down0014.bmp",
   L"data/actor/koishi/test_down0015.bmp",
   L"data/actor/koishi/test_down0016.bmp",
   L"data/actor/koishi/test_down0017.bmp",
   L"data/actor/koishi/test_effect.bmp",
   L"data/actor/koishi/test_guard0000.bmp",
   L"data/actor/koishi/test_guard0001.bmp",
   L"data/actor/koishi/test_guard0002.bmp",
   L"data/actor/koishi/test_guardMiss0000.bmp",
   L"data/actor/koishi/test_guardMiss0001.bmp",
   L"data/actor/koishi/test_guardMiss0002.bmp",
   L"data/actor/koishi/test_guardMiss0003.bmp",
   L"data/actor/koishi/test_item0000.bmp",
   L"data/actor/koishi/test_item0001.bmp",
   L"data/actor/koishi/test_item0002.bmp",
   L"data/actor/koishi/test_item0003.bmp",
   L"data/actor/koishi/test_item0004.bmp",
   L"data/actor/koishi/test_item0005.bmp",
   L"data/actor/koishi/test_item0006.bmp",
   L"data/actor/koishi/test_item0007.bmp",
   L"data/actor/koishi/test_lose0000.bmp",
   L"data/actor/koishi/test_lose0001.bmp",
   L"data/actor/koishi/test_lose0002.bmp",
   L"data/actor/koishi/test_lose0003.bmp",
   L"data/actor/koishi/test_lose0004.bmp",
   L"data/actor/koishi/test_setMotion0000.bmp",
   L"data/actor/koishi/test_setMotion0001.bmp",
   L"data/actor/koishi/test_setMotion0002.bmp",
   L"data/actor/koishi/test_setMotion0003.bmp",
   L"data/actor/koishi/test_setMotion0004.bmp",
   L"data/actor/koishi/test_setMotion0005.bmp",
   L"data/actor/koishi/test_shotHigh0000.bmp",
   L"data/actor/koishi/test_shotHigh0001.bmp",
   L"data/actor/koishi/test_shotHigh0002.bmp",
   L"data/actor/koishi/test_shotHigh0003.bmp",
   L"data/actor/koishi/test_shotHigh0004.bmp",
   L"data/actor/koishi/test_shotHigh0005.bmp",
   L"data/actor/koishi/test_shotHigh0006.bmp",
   L"data/actor/koishi/test_shotHigh0007.bmp",
   L"data/actor/koishi/test_shotLow0000.bmp",
   L"data/actor/koishi/test_shotLow0001.bmp",
   L"data/actor/koishi/test_shotLow0002.bmp",
   L"data/actor/koishi/test_shotLow0003.bmp",
   L"data/actor/koishi/test_shotLow0004.bmp",
   L"data/actor/koishi/test_shotLow0005.bmp",
   L"data/actor/koishi/test_shotLow0006.bmp",
   L"data/actor/koishi/test_skillA0000.bmp",
   L"data/actor/koishi/test_skillA0001.bmp",
   L"data/actor/koishi/test_skillA0002.bmp",
   L"data/actor/koishi/test_skillA0003.bmp",
   L"data/actor/koishi/test_skillA0004.bmp",
   L"data/actor/koishi/test_skillA0005.bmp",
   L"data/actor/koishi/test_skillA0006.bmp",
   L"data/actor/koishi/test_skillA0007.bmp",
   L"data/actor/koishi/test_skillA0008.bmp",
   L"data/actor/koishi/test_skillA0009.bmp",
   L"data/actor/koishi/test_skillA0010.bmp",
   L"data/actor/koishi/test_skillA0011.bmp",
   L"data/actor/koishi/test_skillA0012.bmp",
   L"data/actor/koishi/test_skillD0000.bmp",
   L"data/actor/koishi/test_skillD0001.bmp",
   L"data/actor/koishi/test_skillD0002.bmp",
   L"data/actor/koishi/test_skillD0003.bmp",
   L"data/actor/koishi/test_skillD0004.bmp",
   L"data/actor/koishi/test_skillD0005.bmp",
   L"data/actor/koishi/test_skillD0006.bmp",
   L"data/actor/koishi/test_skillD0007.bmp",
   L"data/actor/koishi/test_slide0000.bmp",
   L"data/actor/koishi/test_slide0001.bmp",
   L"data/actor/koishi/test_slide0002.bmp",
   L"data/actor/koishi/test_slide0003.bmp",
   L"data/actor/koishi/test_slide0004.bmp",
   L"data/actor/koishi/test_slide0005.bmp",
   L"data/actor/koishi/test_slide0006.bmp",
   L"data/actor/koishi/test_slide0007.bmp",
   L"data/actor/koishi/test_slide0008.bmp",
   L"data/actor/koishi/test_slide0009.bmp",
   L"data/actor/koishi/test_slide0010.bmp",
   L"data/actor/koishi/test_slide0011.bmp",
   L"data/actor/koishi/test_slide0012.bmp",
   L"data/actor/koishi/test_slide0013.bmp",
   L"data/actor/koishi/test_slide0014.bmp",
   L"data/actor/koishi/test_slide0015.bmp",
   L"data/actor/koishi/test_slide0016.bmp",
   L"data/actor/koishi/test_slide0017.bmp",
   L"data/actor/koishi/test_spellA0000.bmp",
   L"data/actor/koishi/test_spellA0001.bmp",
   L"data/actor/koishi/test_spellA0002.bmp",
   L"data/actor/koishi/test_spellA0003.bmp",
   L"data/actor/koishi/test_spellA0004.bmp",
   L"data/actor/koishi/test_spellA0005.bmp",
   L"data/actor/koishi/test_spellA0006.bmp",
   L"data/actor/koishi/test_spellA0007.bmp",
   L"data/actor/koishi/test_spellA0008.bmp",
   L"data/actor/koishi/test_spellA0009.bmp",
   L"data/actor/koishi/test_spellA0010.bmp",
   L"data/actor/koishi/test_stun0000.bmp",
   L"data/actor/koishi/test_stun0001.bmp",
   L"data/actor/koishi/test_stun0002.bmp",
   L"data/actor/koishi/test_stun0003.bmp",
   L"data/actor/koishi/test_stun0004.bmp",
   L"data/actor/koishi/test_stun0005.bmp",
   L"data/actor/koishi/test_turn0000.bmp",
   L"data/actor/koishi/test_turn0001.bmp",
   L"data/actor/koishi/test_turn0002.bmp",
   L"data/actor/koishi/test_winA0000.bmp",
   L"data/actor/koishi/test_winA0001.bmp",
   L"data/actor/koishi/test_winA0002.bmp",
   L"data/actor/koishi/test_winA0003.bmp",
   L"data/actor/koishi/test_winA0004.bmp",
   L"data/actor/koishi/test_winA0005.bmp",
   L"data/actor/koishi/test_winA0006.bmp",
   L"data/actor/koishi/test_winA0007.bmp",
   L"data/actor/koishi/texture/auraA0000.png",
   L"data/actor/koishi/texture/ball.bmp",
   L"data/actor/koishi/texture/ball.png",
   L"data/actor/koishi/texture/ball2.bmp",
   L"data/actor/koishi/texture/ball3.png",
   L"data/actor/koishi/texture/box_seet.bmp",
   L"data/actor/koishi/texture/cut0000.png",
   L"data/actor/koishi/texture/egoA0000.png",
   L"data/actor/koishi/texture/face_master_koishi.png",
   L"data/actor/koishi/texture/face_master_koishi2.png",
   L"data/actor/koishi/texture/face_slave_koishi.png",
   L"data/actor/koishi/texture/face_spell_cut.png",
   L"data/actor/koishi/texture/fire.png",
   L"data/actor/koishi/texture/heartA.png",
   L"data/actor/koishi/texture/koishi_animalDamage000.png",
   L"data/actor/koishi/texture/koishi_animalDamage001.png",
   L"data/actor/koishi/texture/koishi_animalDamage002.png",
   L"data/actor/koishi/texture/koishi_animalDamage003.png",
   L"data/actor/koishi/texture/koishi_animal_00000.png",
   L"data/actor/koishi/texture/koishi_animal_00001.png",
   L"data/actor/koishi/texture/koishi_animal_00002.png",
   L"data/actor/koishi/texture/koishi_animal_00003.png",
   L"data/actor/koishi/texture/koishi_animal_00004.png",
   L"data/actor/koishi/texture/koishi_animal_00005.png",
   L"data/actor/koishi/texture/koishi_animal_00006.png",
   L"data/actor/koishi/texture/koishi_animal_00007.png",
   L"data/actor/koishi/texture/koishi_animal_00008.png",
   L"data/actor/koishi/texture/koishi_animal_00009.png",
   L"data/actor/koishi/texture/koishi_animal_00010.png",
   L"data/actor/koishi/texture/koishi_animal_00011.png",
   L"data/actor/koishi/texture/koishi_fire.png",
   L"data/actor/koishi/texture/koishi_lastwordeffect.png",
   L"data/actor/koishi/texture/koishi_sparkLine.png",
   L"data/actor/koishi/texture/kona_A.bmp",
   L"data/actor/koishi/texture/kusyami.png",
   L"data/actor/koishi/texture/lightA0000.png",
   L"data/actor/koishi/texture/lightning_mapA.png",
   L"data/actor/koishi/texture/marisa_sparkLine.png",
   L"data/actor/koishi/texture/mask_ball.png",
   L"data/actor/koishi/texture/occult_phone0000.dds",
   L"data/actor/koishi/texture/ofudaHit.bmp",
   L"data/actor/koishi/texture/pulseA.png",
   L"data/actor/koishi/texture/reimu_wallA_mask.png",
   L"data/actor/koishi/texture/roseA.png",
   L"data/actor/koishi/texture/roseB.png",
   L"data/actor/koishi/texture/roseC.png",
   L"data/actor/koishi/texture/roseD.png",
   L"data/actor/koishi/texture/skillA_circleA.png",
   L"data/actor/koishi/texture/skillC_Laser.dds",
   L"data/actor/koishi/texture/skillG_B000.png",
   L"data/actor/koishi/texture/skillG_B001.png",
   L"data/actor/koishi/texture/skillG_B002.png",
   L"data/actor/koishi/texture/skillG_B003.png",
   L"data/actor/koishi/texture/skillG_B004.png",
   L"data/actor/koishi/texture/skillG_B005.png",
   L"data/actor/koishi/texture/skillG_B006.png",
   L"data/actor/koishi/texture/skillG_R000.png",
   L"data/actor/koishi/texture/skillG_R001.png",
   L"data/actor/koishi/texture/skillG_R002.png",
   L"data/actor/koishi/texture/skillG_R003.png",
   L"data/actor/koishi/texture/skillG_R004.png",
   L"data/actor/koishi/texture/skillG_R005.png",
   L"data/actor/koishi/texture/skillG_R006.png",
   L"data/actor/koishi/texture/sonic_wave0000.png",
   L"data/actor/koishi/texture/spellC_Shadow.dds",
   L"data/actor/koishi/texture/spell_use_cut.png",
   L"data/actor/koishi/texture/thornA.png",
   L"data/actor/koishi/texture/trailA.png",
   L"data/actor/koishi/texture/vortexloop0000.png",
   L"data/actor/koishi/walkBack0000.bmp",
   L"data/actor/koishi/walkBack0001.bmp",
   L"data/actor/koishi/walkBack0002.bmp",
   L"data/actor/koishi/walkBack0003.bmp",
   L"data/actor/koishi/walkBack0004.bmp",
   L"data/actor/koishi/walkBack0005.bmp",
   L"data/actor/koishi/walkBack0006.bmp",
   L"data/actor/koishi/walkBack0007.bmp",
   L"data/actor/koishi/walkBack0008.bmp",
   L"data/actor/koishi/walkBack0009.bmp",
   L"data/actor/koishi/walkBack0010.bmp",
   L"data/actor/koishi/walkBack0011.bmp",
   L"data/actor/koishi/walkBack0012.bmp",
   L"data/actor/koishi/walkFront0000.bmp",
   L"data/actor/koishi/walkFront0001.bmp",
   L"data/actor/koishi/walkFront0002.bmp",
   L"data/actor/koishi/walkFront0003.bmp",
   L"data/actor/koishi/walkFront0004.bmp",
   L"data/actor/koishi/walkFront0005.bmp",
   L"data/actor/koishi/walkFront0006.bmp",
   L"data/actor/koishi/walkFront0007.bmp",
   L"data/actor/koishi/walkFront0008.bmp",
   L"data/actor/koishi/walkFront0009.bmp",
   L"data/actor/koishi/walkFront0010.bmp",
   L"data/actor/koishi/walkFront0011.bmp",
   L"data/actor/koishi/walkFront0012.bmp",
   L"data/actor/koishi/winB0000.bmp",
   L"data/actor/koishi/winB0001.bmp",
   L"data/actor/koishi/winB0002.bmp",
   L"data/actor/koishi/winB0003.bmp",
   L"data/actor/koishi/winB0004.bmp",
   L"data/actor/koishi/winB0005.bmp",
   L"data/actor/koishi/winB0006.bmp",
   L"data/actor/koishi/winB0007.bmp",
   L"data/actor/koishi/winB_Hat0000.bmp",
   L"data/actor/koishi/winB_Hat0001.bmp",
   L"data/actor/koishi/winB_Hat0002.bmp",
   L"data/actor/koishi/winB_Hat0003.bmp",
   L"data/actor/koishi.nut",
   L"data/actor/koishi_base.nut",
   L"data/actor/koishi_boss.nut",
   L"data/actor/koishi_boss_base.nut",
   L"data/actor/koishi_boss_init.nut",
   L"data/actor/koishi_boss_shot.nut",
   L"data/actor/koishi_com.nut",
   L"data/actor/koishi_combo.nut",
   L"data/actor/koishi_com_function.nut",
   L"data/actor/koishi_init.nut",
   L"data/actor/koishi_practice_init.nut",
   L"data/actor/koishi_shot.nut",
   L"data/actor/koishi_team.nut",
   L"data/actor/kokoro/atkDashHigh0000.bmp",
   L"data/actor/kokoro/atkDashHigh0001.bmp",
   L"data/actor/kokoro/atkDashHigh0002.bmp",
   L"data/actor/kokoro/atkDashHigh0003.bmp",
   L"data/actor/kokoro/atkDashHigh0004.bmp",
   L"data/actor/kokoro/atkDashHigh0005.bmp",
   L"data/actor/kokoro/atkDashHigh0006.bmp",
   L"data/actor/kokoro/atkDashHigh0007.bmp",
   L"data/actor/kokoro/atkHigh0000.bmp",
   L"data/actor/kokoro/atkHigh0001.bmp",
   L"data/actor/kokoro/atkHigh0002.bmp",
   L"data/actor/kokoro/atkHigh0003.bmp",
   L"data/actor/kokoro/atkHigh0004.bmp",
   L"data/actor/kokoro/atkHigh0005.bmp",
   L"data/actor/kokoro/atkHigh0006.bmp",
   L"data/actor/kokoro/atkHigh0007.bmp",
   L"data/actor/kokoro/atkHigh0008.bmp",
   L"data/actor/kokoro/atkHigh0009.bmp",
   L"data/actor/kokoro/atkHigh0010.bmp",
   L"data/actor/kokoro/atkHigh0011.bmp",
   L"data/actor/kokoro/atkHigh0012.bmp",
   L"data/actor/kokoro/atkHighFront0000.bmp",
   L"data/actor/kokoro/atkHighFront0001.bmp",
   L"data/actor/kokoro/atkHighFront0002.bmp",
   L"data/actor/kokoro/atkHighFront0003.bmp",
   L"data/actor/kokoro/atkHighFront0004.bmp",
   L"data/actor/kokoro/atkHighFront0005.bmp",
   L"data/actor/kokoro/atkHighFront0006.bmp",
   L"data/actor/kokoro/atkHighFront0007.bmp",
   L"data/actor/kokoro/atkHighFront0008.bmp",
   L"data/actor/kokoro/atkHighFront0009.bmp",
   L"data/actor/kokoro/atkHighUnder0000.bmp",
   L"data/actor/kokoro/atkHighUnder0001.bmp",
   L"data/actor/kokoro/atkHighUnder0002.bmp",
   L"data/actor/kokoro/atkHighUnder0003.bmp",
   L"data/actor/kokoro/atkHighUnder0004.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0000.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0001.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0002.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0003.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0004.bmp",
   L"data/actor/kokoro/atkHighUnderLoop0005.bmp",
   L"data/actor/kokoro/atkHighUpper0000.bmp",
   L"data/actor/kokoro/atkHighUpper0001.bmp",
   L"data/actor/kokoro/atkHighUpper0002.bmp",
   L"data/actor/kokoro/atkHighUpper0003.bmp",
   L"data/actor/kokoro/atkHighUpper0004.bmp",
   L"data/actor/kokoro/atkHighUpper0005.bmp",
   L"data/actor/kokoro/atkHighUpper0006.bmp",
   L"data/actor/kokoro/atkHighUpper0007.bmp",
   L"data/actor/kokoro/atkHighUpper0008.bmp",
   L"data/actor/kokoro/atkHighUpper0009.bmp",
   L"data/actor/kokoro/atkHighUpper0010.bmp",
   L"data/actor/kokoro/atkHighUpper0011.bmp",
   L"data/actor/kokoro/atkHighUpper0012.bmp",
   L"data/actor/kokoro/atkLow0000.bmp",
   L"data/actor/kokoro/atkLow0001.bmp",
   L"data/actor/kokoro/atkLow0002.bmp",
   L"data/actor/kokoro/atkLow0003.bmp",
   L"data/actor/kokoro/atkLow0004.bmp",
   L"data/actor/kokoro/atkLow0005.bmp",
   L"data/actor/kokoro/atkLow0006.bmp",
   L"data/actor/kokoro/atkLow0007.bmp",
   L"data/actor/kokoro/atkLow0008.bmp",
   L"data/actor/kokoro/atkMid0000.bmp",
   L"data/actor/kokoro/atkMid0001.bmp",
   L"data/actor/kokoro/atkMid0002.bmp",
   L"data/actor/kokoro/atkMid0003.bmp",
   L"data/actor/kokoro/atkMid0004.bmp",
   L"data/actor/kokoro/atkMid0005.bmp",
   L"data/actor/kokoro/atkMid0006.bmp",
   L"data/actor/kokoro/atkMid0007.bmp",
   L"data/actor/kokoro/atkMidMask0000.bmp",
   L"data/actor/kokoro/atk_front_air0000.bmp",
   L"data/actor/kokoro/atk_front_air0001.bmp",
   L"data/actor/kokoro/atk_front_air0002.bmp",
   L"data/actor/kokoro/atk_front_air0003.bmp",
   L"data/actor/kokoro/atk_front_air0004.bmp",
   L"data/actor/kokoro/atk_front_air0005.bmp",
   L"data/actor/kokoro/atk_front_air0006.bmp",
   L"data/actor/kokoro/atk_front_air0007.bmp",
   L"data/actor/kokoro/atk_front_air0008.bmp",
   L"data/actor/kokoro/atk_front_air0009.bmp",
   L"data/actor/kokoro/battleBeginA0000.bmp",
   L"data/actor/kokoro/battleBeginA0001.bmp",
   L"data/actor/kokoro/battleBeginA0002.bmp",
   L"data/actor/kokoro/battleBeginA0003.bmp",
   L"data/actor/kokoro/battleBeginA0004.bmp",
   L"data/actor/kokoro/battleBeginA0005.bmp",
   L"data/actor/kokoro/battleBeginA0006.bmp",
   L"data/actor/kokoro/battleBeginA0007.bmp",
   L"data/actor/kokoro/battleBeginA0008.bmp",
   L"data/actor/kokoro/beginBattleA0000.bmp",
   L"data/actor/kokoro/beginBattleA0001.bmp",
   L"data/actor/kokoro/beginBattleA0002.bmp",
   L"data/actor/kokoro/beginBattleA0003.bmp",
   L"data/actor/kokoro/beginBattleA0004.bmp",
   L"data/actor/kokoro/beginBattleA0005.bmp",
   L"data/actor/kokoro/beginBattleA0006.bmp",
   L"data/actor/kokoro/beginBattleA0007.bmp",
   L"data/actor/kokoro/beginBattleA0008.bmp",
   L"data/actor/kokoro/beginBattleA0009.bmp",
   L"data/actor/kokoro/beginBattleA0010.bmp",
   L"data/actor/kokoro/beginBattleA2_Loop0000.bmp",
   L"data/actor/kokoro/beginBattleA2_Loop0001.bmp",
   L"data/actor/kokoro/beginBattleA2_Loop0002.bmp",
   L"data/actor/kokoro/beginBattleA2_Loop0003.bmp",
   L"data/actor/kokoro/beginBattleA2_Loop0004.bmp",
   L"data/actor/kokoro/beginBattleA_Loop0000.bmp",
   L"data/actor/kokoro/beginBattleA_Loop0001.bmp",
   L"data/actor/kokoro/beginBattleA_Loop0002.bmp",
   L"data/actor/kokoro/beginBattleA_Loop0003.bmp",
   L"data/actor/kokoro/beginBattleA_Loop0004.bmp",
   L"data/actor/kokoro/bmsln/beginAura.bmb",
   L"data/actor/kokoro/bmsln/emotionFieldB.bmb",
   L"data/actor/kokoro/bmsln/emotionFieldG.bmb",
   L"data/actor/kokoro/bmsln/emotionFieldR.bmb",
   L"data/actor/kokoro/bmsln/emotionFieldY.bmb",
   L"data/actor/kokoro/bmsln/hairShotA.bmb",
   L"data/actor/kokoro/bmsln/kokoro_6B_B.bmb",
   L"data/actor/kokoro/bmsln/kokoro_6B_G.bmb",
   L"data/actor/kokoro/bmsln/kokoro_6B_R.bmb",
   L"data/actor/kokoro/bmsln/kokoro_blaze.bmb",
   L"data/actor/kokoro/bmsln/kokoro_fireWork.bmb",
   L"data/actor/kokoro/bmsln/kokoro_spellC_Pilar.bmb",
   L"data/actor/kokoro/climax0000.bmp",
   L"data/actor/kokoro/climax0001.bmp",
   L"data/actor/kokoro/climax0002.bmp",
   L"data/actor/kokoro/climax0003.bmp",
   L"data/actor/kokoro/climax0004.bmp",
   L"data/actor/kokoro/climax0005.bmp",
   L"data/actor/kokoro/climax0006.bmp",
   L"data/actor/kokoro/climax0007.bmp",
   L"data/actor/kokoro/climax0008.bmp",
   L"data/actor/kokoro/climaxMaskA0000.bmp",
   L"data/actor/kokoro/climaxMaskA0001.bmp",
   L"data/actor/kokoro/crash0000.bmp",
   L"data/actor/kokoro/crash0001.bmp",
   L"data/actor/kokoro/crash0002.bmp",
   L"data/actor/kokoro/crashLoop0000.bmp",
   L"data/actor/kokoro/crashLoop0001.bmp",
   L"data/actor/kokoro/damageBody0000.bmp",
   L"data/actor/kokoro/damageBody0001.bmp",
   L"data/actor/kokoro/damageBody0002.bmp",
   L"data/actor/kokoro/damageBody0003.bmp",
   L"data/actor/kokoro/damageBody0004.bmp",
   L"data/actor/kokoro/damageHead0000.bmp",
   L"data/actor/kokoro/damageHead0001.bmp",
   L"data/actor/kokoro/damageHead0002.bmp",
   L"data/actor/kokoro/damageHead0003.bmp",
   L"data/actor/kokoro/damageHead0004.bmp",
   L"data/actor/kokoro/damageSpin0000.bmp",
   L"data/actor/kokoro/damageSpin0001.bmp",
   L"data/actor/kokoro/damageSpin0002.bmp",
   L"data/actor/kokoro/damageSpin0003.bmp",
   L"data/actor/kokoro/damageUpper0000.bmp",
   L"data/actor/kokoro/damageUpper0001.bmp",
   L"data/actor/kokoro/damageUpper0002.bmp",
   L"data/actor/kokoro/damageUpper0003.bmp",
   L"data/actor/kokoro/damageUpper0004.bmp",
   L"data/actor/kokoro/damageUpper0005.bmp",
   L"data/actor/kokoro/damageUpper0006.bmp",
   L"data/actor/kokoro/damageUpper0007.bmp",
   L"data/actor/kokoro/damageUpper0008.bmp",
   L"data/actor/kokoro/damageUpper0009.bmp",
   L"data/actor/kokoro/damageUpper0010.bmp",
   L"data/actor/kokoro/damageUpper0011.bmp",
   L"data/actor/kokoro/damageUpper0012.bmp",
   L"data/actor/kokoro/damageUpper0013.bmp",
   L"data/actor/kokoro/damageUpper0014.bmp",
   L"data/actor/kokoro/damageUpper0015.bmp",
   L"data/actor/kokoro/damageUpper0016.bmp",
   L"data/actor/kokoro/damageUpper0017.bmp",
   L"data/actor/kokoro/damageUpper0018.bmp",
   L"data/actor/kokoro/damageWall0000.bmp",
   L"data/actor/kokoro/damageWall0001.bmp",
   L"data/actor/kokoro/damageWall0002.bmp",
   L"data/actor/kokoro/damageWall0003.bmp",
   L"data/actor/kokoro/damageWall0004.bmp",
   L"data/actor/kokoro/damageWall0005.bmp",
   L"data/actor/kokoro/damageWall0006.bmp",
   L"data/actor/kokoro/dashBack0000.bmp",
   L"data/actor/kokoro/dashBack0001.bmp",
   L"data/actor/kokoro/dashBack0002.bmp",
   L"data/actor/kokoro/dashBackLoop0000.bmp",
   L"data/actor/kokoro/dashBackLoop0001.bmp",
   L"data/actor/kokoro/dashBackLoop0002.bmp",
   L"data/actor/kokoro/dashBackLoop0003.bmp",
   L"data/actor/kokoro/dashBackLoop0004.bmp",
   L"data/actor/kokoro/dashFront0000.bmp",
   L"data/actor/kokoro/dashFront0001.bmp",
   L"data/actor/kokoro/dashFront0002.bmp",
   L"data/actor/kokoro/dashFrontLoop0000.bmp",
   L"data/actor/kokoro/dashFrontLoop0001.bmp",
   L"data/actor/kokoro/dashFrontLoop0002.bmp",
   L"data/actor/kokoro/dashFrontLoop0003.bmp",
   L"data/actor/kokoro/dashFrontLoop0004.bmp",
   L"data/actor/kokoro/dummy.bmp",
   L"data/actor/kokoro/face_spellCallB.png",
   L"data/actor/kokoro/HighShotA0000.bmp",
   L"data/actor/kokoro/HighShotA0001.bmp",
   L"data/actor/kokoro/HighShotA0002.bmp",
   L"data/actor/kokoro/HighShotA0003.bmp",
   L"data/actor/kokoro/HighShotA0004.bmp",
   L"data/actor/kokoro/HighShotA0005.bmp",
   L"data/actor/kokoro/HighShotA0006.bmp",
   L"data/actor/kokoro/HighShotA0007.bmp",
   L"data/actor/kokoro/HighShotA0008.bmp",
   L"data/actor/kokoro/HighShotA0009.bmp",
   L"data/actor/kokoro/HighShotAb0000.bmp",
   L"data/actor/kokoro/HighShotAb0001.bmp",
   L"data/actor/kokoro/HighShotAb0002.bmp",
   L"data/actor/kokoro/HighShotAb0003.bmp",
   L"data/actor/kokoro/HighShotAb0004.bmp",
   L"data/actor/kokoro/HighShotAb0005.bmp",
   L"data/actor/kokoro/HighShotAb0006.bmp",
   L"data/actor/kokoro/HighShotAb0007.bmp",
   L"data/actor/kokoro/item0000.bmp",
   L"data/actor/kokoro/item0001.bmp",
   L"data/actor/kokoro/item0002.bmp",
   L"data/actor/kokoro/item0003.bmp",
   L"data/actor/kokoro/item0004.bmp",
   L"data/actor/kokoro/item0005.bmp",
   L"data/actor/kokoro/item0006.bmp",
   L"data/actor/kokoro/item0007.bmp",
   L"data/actor/kokoro/item0008.bmp",
   L"data/actor/kokoro/item0009.bmp",
   L"data/actor/kokoro/item0010.bmp",
   L"data/actor/kokoro/kokoro.pat",
   L"data/actor/kokoro/kokoro_ed.pat",
   L"data/actor/kokoro/maskA0000.bmp",
   L"data/actor/kokoro/maskB0000.bmp",
   L"data/actor/kokoro/maskC0000.bmp",
   L"data/actor/kokoro/maskD0000.bmp",
   L"data/actor/kokoro/maskE0000.bmp",
   L"data/actor/kokoro/maskF0000.bmp",
   L"data/actor/kokoro/missGuard0000.bmp",
   L"data/actor/kokoro/missGuard0001.bmp",
   L"data/actor/kokoro/missGuard0002.bmp",
   L"data/actor/kokoro/missGuard0003.bmp",
   L"data/actor/kokoro/occult0000.bmp",
   L"data/actor/kokoro/occult0001.bmp",
   L"data/actor/kokoro/occult0002.bmp",
   L"data/actor/kokoro/occult0003.bmp",
   L"data/actor/kokoro/occult0004.bmp",
   L"data/actor/kokoro/occult0005.bmp",
   L"data/actor/kokoro/occult0006.bmp",
   L"data/actor/kokoro/occult0007.bmp",
   L"data/actor/kokoro/occult0008.bmp",
   L"data/actor/kokoro/occult0009.bmp",
   L"data/actor/kokoro/occult0010.bmp",
   L"data/actor/kokoro/occult0011.bmp",
   L"data/actor/kokoro/occult0012.bmp",
   L"data/actor/kokoro/occult0013.bmp",
   L"data/actor/kokoro/occult0014.bmp",
   L"data/actor/kokoro/occult0015.bmp",
   L"data/actor/kokoro/occult0016.bmp",
   L"data/actor/kokoro/occult_shot0000.bmp",
   L"data/actor/kokoro/occult_shot0001.bmp",
   L"data/actor/kokoro/occult_shot0002.bmp",
   L"data/actor/kokoro/palette000.bmp",
   L"data/actor/kokoro/palette001.bmp",
   L"data/actor/kokoro/palette002.bmp",
   L"data/actor/kokoro/palette003.bmp",
   L"data/actor/kokoro/palette004.bmp",
   L"data/actor/kokoro/palette005.bmp",
   L"data/actor/kokoro/palette006.bmp",
   L"data/actor/kokoro/palette007.bmp",
   L"data/actor/kokoro/palette100.bmp",
   L"data/actor/kokoro/palette101.bmp",
   L"data/actor/kokoro/palette102.bmp",
   L"data/actor/kokoro/palette103.bmp",
   L"data/actor/kokoro/palette104.bmp",
   L"data/actor/kokoro/palette105.bmp",
   L"data/actor/kokoro/palette106.bmp",
   L"data/actor/kokoro/palette107.bmp",
   L"data/actor/kokoro/shotLow0000.bmp",
   L"data/actor/kokoro/shotLow0001.bmp",
   L"data/actor/kokoro/shotLow0002.bmp",
   L"data/actor/kokoro/shotLow0003.bmp",
   L"data/actor/kokoro/shotLow0004.bmp",
   L"data/actor/kokoro/shotLow0005.bmp",
   L"data/actor/kokoro/shotLow0006.bmp",
   L"data/actor/kokoro/shotLow0007.bmp",
   L"data/actor/kokoro/shotLow0008.bmp",
   L"data/actor/kokoro/shotLowB0000.bmp",
   L"data/actor/kokoro/shotLowB0001.bmp",
   L"data/actor/kokoro/shotLowB0002.bmp",
   L"data/actor/kokoro/shotLowB0003.bmp",
   L"data/actor/kokoro/shotLowB0004.bmp",
   L"data/actor/kokoro/shotLowB0005.bmp",
   L"data/actor/kokoro/shotLowB0006.bmp",
   L"data/actor/kokoro/skillA0000.bmp",
   L"data/actor/kokoro/skillA0001.bmp",
   L"data/actor/kokoro/skillA0002.bmp",
   L"data/actor/kokoro/skillA0003.bmp",
   L"data/actor/kokoro/skillA0004.bmp",
   L"data/actor/kokoro/skillA0005.bmp",
   L"data/actor/kokoro/skillA0006.bmp",
   L"data/actor/kokoro/skillA0007.bmp",
   L"data/actor/kokoro/skillA0008.bmp",
   L"data/actor/kokoro/skillA0009.bmp",
   L"data/actor/kokoro/skillA0010.bmp",
   L"data/actor/kokoro/skillA0011.bmp",
   L"data/actor/kokoro/skillA0012.bmp",
   L"data/actor/kokoro/skillA0013.bmp",
   L"data/actor/kokoro/skillA0014.bmp",
   L"data/actor/kokoro/skillA0015.bmp",
   L"data/actor/kokoro/skillB0000.bmp",
   L"data/actor/kokoro/skillB0001.bmp",
   L"data/actor/kokoro/skillB0002.bmp",
   L"data/actor/kokoro/skillB0003.bmp",
   L"data/actor/kokoro/skillB0004.bmp",
   L"data/actor/kokoro/skillB0005.bmp",
   L"data/actor/kokoro/skillB0006.bmp",
   L"data/actor/kokoro/skillB0007.bmp",
   L"data/actor/kokoro/skillB0008.bmp",
   L"data/actor/kokoro/skillBb0000.bmp",
   L"data/actor/kokoro/skillBb0001.bmp",
   L"data/actor/kokoro/skillBb0002.bmp",
   L"data/actor/kokoro/skillBb0003.bmp",
   L"data/actor/kokoro/skillBb0004.bmp",
   L"data/actor/kokoro/skillBb0005.bmp",
   L"data/actor/kokoro/skillC0000.bmp",
   L"data/actor/kokoro/skillC0001.bmp",
   L"data/actor/kokoro/skillC0002.bmp",
   L"data/actor/kokoro/skillC0003.bmp",
   L"data/actor/kokoro/skillC0004.bmp",
   L"data/actor/kokoro/skillC0005.bmp",
   L"data/actor/kokoro/skillC0006.bmp",
   L"data/actor/kokoro/skillC0007.bmp",
   L"data/actor/kokoro/skillC0008.bmp",
   L"data/actor/kokoro/skillC0009.bmp",
   L"data/actor/kokoro/skillC0010.bmp",
   L"data/actor/kokoro/skillCLoop0000.bmp",
   L"data/actor/kokoro/skillCLoop0001.bmp",
   L"data/actor/kokoro/skillCLoop0002.bmp",
   L"data/actor/kokoro/skillCLoop0003.bmp",
   L"data/actor/kokoro/skillCLoop0004.bmp",
   L"data/actor/kokoro/skillD0000.bmp",
   L"data/actor/kokoro/skillD0001.bmp",
   L"data/actor/kokoro/skillD0002.bmp",
   L"data/actor/kokoro/skillD0003.bmp",
   L"data/actor/kokoro/skillD0004.bmp",
   L"data/actor/kokoro/skillD0005.bmp",
   L"data/actor/kokoro/skillD0006.bmp",
   L"data/actor/kokoro/skillD0007.bmp",
   L"data/actor/kokoro/skillD_Loop0000.bmp",
   L"data/actor/kokoro/skillD_Loop0001.bmp",
   L"data/actor/kokoro/skillD_Loop0002.bmp",
   L"data/actor/kokoro/skillD_Loop0003.bmp",
   L"data/actor/kokoro/skillD_Loop0004.bmp",
   L"data/actor/kokoro/skillF0000.bmp",
   L"data/actor/kokoro/skillF0001.bmp",
   L"data/actor/kokoro/skillF0002.bmp",
   L"data/actor/kokoro/skillF0003.bmp",
   L"data/actor/kokoro/skillF0004.bmp",
   L"data/actor/kokoro/skillF0005.bmp",
   L"data/actor/kokoro/skillF0006.bmp",
   L"data/actor/kokoro/skillF0007.bmp",
   L"data/actor/kokoro/skillF0008.bmp",
   L"data/actor/kokoro/skillF0009.bmp",
   L"data/actor/kokoro/skillF0010.bmp",
   L"data/actor/kokoro/skillF0011.bmp",
   L"data/actor/kokoro/skillF0012.bmp",
   L"data/actor/kokoro/skillF0013.bmp",
   L"data/actor/kokoro/skillF0014.bmp",
   L"data/actor/kokoro/skillF0015.bmp",
   L"data/actor/kokoro/skillG0000.bmp",
   L"data/actor/kokoro/skillG0001.bmp",
   L"data/actor/kokoro/skillG0002.bmp",
   L"data/actor/kokoro/skillG0003.bmp",
   L"data/actor/kokoro/skillG0004.bmp",
   L"data/actor/kokoro/skillG0005.bmp",
   L"data/actor/kokoro/skillG0006.bmp",
   L"data/actor/kokoro/skillG0007.bmp",
   L"data/actor/kokoro/skillG0008.bmp",
   L"data/actor/kokoro/slide0000.bmp",
   L"data/actor/kokoro/slide0001.bmp",
   L"data/actor/kokoro/slide0002.bmp",
   L"data/actor/kokoro/slide0003.bmp",
   L"data/actor/kokoro/slide0004.bmp",
   L"data/actor/kokoro/slide0005.bmp",
   L"data/actor/kokoro/slide0006.bmp",
   L"data/actor/kokoro/slide0007.bmp",
   L"data/actor/kokoro/slide0008.bmp",
   L"data/actor/kokoro/slide0009.bmp",
   L"data/actor/kokoro/slideUnderLoop0000.bmp",
   L"data/actor/kokoro/slideUnderLoop0001.bmp",
   L"data/actor/kokoro/slideUnderLoop0002.bmp",
   L"data/actor/kokoro/slideUnderLoop0003.bmp",
   L"data/actor/kokoro/slideUnderLoop0004.bmp",
   L"data/actor/kokoro/slideUpperLoop0000.bmp",
   L"data/actor/kokoro/slideUpperLoop0001.bmp",
   L"data/actor/kokoro/slideUpperLoop0002.bmp",
   L"data/actor/kokoro/slideUpperLoop0003.bmp",
   L"data/actor/kokoro/slideUpperLoop0004.bmp",
   L"data/actor/kokoro/spellA0000.bmp",
   L"data/actor/kokoro/spellA0001.bmp",
   L"data/actor/kokoro/spellA0002.bmp",
   L"data/actor/kokoro/spellA0003.bmp",
   L"data/actor/kokoro/spellA0004.bmp",
   L"data/actor/kokoro/spellA0005.bmp",
   L"data/actor/kokoro/spellA0006.bmp",
   L"data/actor/kokoro/spellA0007.bmp",
   L"data/actor/kokoro/spellA0008.bmp",
   L"data/actor/kokoro/spellA0009.bmp",
   L"data/actor/kokoro/spellCb0000.bmp",
   L"data/actor/kokoro/spellCb0001.bmp",
   L"data/actor/kokoro/spellCb0002.bmp",
   L"data/actor/kokoro/spellCb0003.bmp",
   L"data/actor/kokoro/spellCb0004.bmp",
   L"data/actor/kokoro/spellMask_C0000.bmp",
   L"data/actor/kokoro/spellMask_C0001.bmp",
   L"data/actor/kokoro/spellMask_C0002.bmp",
   L"data/actor/kokoro/spellMask_C0003.bmp",
   L"data/actor/kokoro/stand0000.bmp",
   L"data/actor/kokoro/stand0001.bmp",
   L"data/actor/kokoro/stand0002.bmp",
   L"data/actor/kokoro/stand0003.bmp",
   L"data/actor/kokoro/stand0004.bmp",
   L"data/actor/kokoro/stand0005.bmp",
   L"data/actor/kokoro/stand0006.bmp",
   L"data/actor/kokoro/stand0007.bmp",
   L"data/actor/kokoro/stand0008.bmp",
   L"data/actor/kokoro/stand0009.bmp",
   L"data/actor/kokoro/stand0010.bmp",
   L"data/actor/kokoro/stand0011.bmp",
   L"data/actor/kokoro/stand0012.bmp",
   L"data/actor/kokoro/stand0013.bmp",
   L"data/actor/kokoro/stand0014.bmp",
   L"data/actor/kokoro/stand0015.bmp",
   L"data/actor/kokoro/stand0016.bmp",
   L"data/actor/kokoro/stand0017.bmp",
   L"data/actor/kokoro/stand0018.bmp",
   L"data/actor/kokoro/stand0019.bmp",
   L"data/actor/kokoro/stand0020.bmp",
   L"data/actor/kokoro/stand0021.bmp",
   L"data/actor/kokoro/stand0022.bmp",
   L"data/actor/kokoro/stand0023.bmp",
   L"data/actor/kokoro/stand0024.bmp",
   L"data/actor/kokoro/stand0025.bmp",
   L"data/actor/kokoro/stand0026.bmp",
   L"data/actor/kokoro/stand0027.bmp",
   L"data/actor/kokoro/stun0000.bmp",
   L"data/actor/kokoro/stun0001.bmp",
   L"data/actor/kokoro/stun0002.bmp",
   L"data/actor/kokoro/team_begin_A0000.bmp",
   L"data/actor/kokoro/team_begin_A0001.bmp",
   L"data/actor/kokoro/team_begin_A0002.bmp",
   L"data/actor/kokoro/team_begin_A0003.bmp",
   L"data/actor/kokoro/team_begin_A0004.bmp",
   L"data/actor/kokoro/team_begin_A0005.bmp",
   L"data/actor/kokoro/team_begin_A0006.bmp",
   L"data/actor/kokoro/team_begin_A0007.bmp",
   L"data/actor/kokoro/team_begin_A0008.bmp",
   L"data/actor/kokoro/team_begin_B0000.bmp",
   L"data/actor/kokoro/team_begin_B0001.bmp",
   L"data/actor/kokoro/team_begin_B0002.bmp",
   L"data/actor/kokoro/team_begin_B0003.bmp",
   L"data/actor/kokoro/team_begin_B0004.bmp",
   L"data/actor/kokoro/team_begin_B0005.bmp",
   L"data/actor/kokoro/team_begin_B0006.bmp",
   L"data/actor/kokoro/team_begin_B0007.bmp",
   L"data/actor/kokoro/team_begin_B0008.bmp",
   L"data/actor/kokoro/team_begin_C0000.bmp",
   L"data/actor/kokoro/team_begin_C0001.bmp",
   L"data/actor/kokoro/team_begin_C0002.bmp",
   L"data/actor/kokoro/team_begin_C0003.bmp",
   L"data/actor/kokoro/team_begin_C0004.bmp",
   L"data/actor/kokoro/team_begin_C0005.bmp",
   L"data/actor/kokoro/team_begin_C0006.bmp",
   L"data/actor/kokoro/team_begin_C0007.bmp",
   L"data/actor/kokoro/team_begin_C0008.bmp",
   L"data/actor/kokoro/testr_climaxeffecta0000.png",
   L"data/actor/kokoro/testr_climaxeffectb0000.png",
   L"data/actor/kokoro/testr_climaxeffectc0000.png",
   L"data/actor/kokoro/texture/auraA0000.png",
   L"data/actor/kokoro/texture/auraB0000.png",
   L"data/actor/kokoro/texture/auraC0000.png",
   L"data/actor/kokoro/texture/ball.bmp",
   L"data/actor/kokoro/texture/beamA0000.png",
   L"data/actor/kokoro/texture/bladeA0000.dds",
   L"data/actor/kokoro/texture/bladeA0001.dds",
   L"data/actor/kokoro/texture/bladeA0002.dds",
   L"data/actor/kokoro/texture/bladeA0002.png",
   L"data/actor/kokoro/texture/bladeA0003.dds",
   L"data/actor/kokoro/texture/bladeA0003.png",
   L"data/actor/kokoro/texture/bladeA0004.dds",
   L"data/actor/kokoro/texture/bladeA0005.dds",
   L"data/actor/kokoro/texture/climax_auravortex0000.dds",
   L"data/actor/kokoro/texture/climax_mask0000.dds",
   L"data/actor/kokoro/texture/cut0000.png",
   L"data/actor/kokoro/texture/cut0001.png",
   L"data/actor/kokoro/texture/cut0002.png",
   L"data/actor/kokoro/texture/cut0003.png",
   L"data/actor/kokoro/texture/emotionFontA.png",
   L"data/actor/kokoro/texture/face_master_kokoro.png",
   L"data/actor/kokoro/texture/face_master_kokoro2.png",
   L"data/actor/kokoro/texture/face_slave_kokoro.png",
   L"data/actor/kokoro/texture/face_spell_cut.png",
   L"data/actor/kokoro/texture/fireShotA0000.dds",
   L"data/actor/kokoro/texture/fireshotBackA0000.dds",
   L"data/actor/kokoro/texture/foxMaskAuraA000.png",
   L"data/actor/kokoro/texture/hairWaveA000.png",
   L"data/actor/kokoro/texture/kokoro_animalDamage000.png",
   L"data/actor/kokoro/texture/kokoro_animalDamage001.png",
   L"data/actor/kokoro/texture/kokoro_animalDamage002.png",
   L"data/actor/kokoro/texture/kokoro_animalDamage003.png",
   L"data/actor/kokoro/texture/kokoro_animal_00000.png",
   L"data/actor/kokoro/texture/kokoro_animal_00001.png",
   L"data/actor/kokoro/texture/kokoro_animal_00002.png",
   L"data/actor/kokoro/texture/kokoro_animal_00003.png",
   L"data/actor/kokoro/texture/kokoro_animal_00004.png",
   L"data/actor/kokoro/texture/kokoro_animal_00005.png",
   L"data/actor/kokoro/texture/kokoro_animal_00006.png",
   L"data/actor/kokoro/texture/kokoro_animal_00007.png",
   L"data/actor/kokoro/texture/kokoro_animal_00008.png",
   L"data/actor/kokoro/texture/kokoro_animal_00009.png",
   L"data/actor/kokoro/texture/kokoro_animal_00010.png",
   L"data/actor/kokoro/texture/kokoro_animal_00011.png",
   L"data/actor/kokoro/texture/kokoro_auraA0000.png",
   L"data/actor/kokoro/texture/kokoro_field.png",
   L"data/actor/kokoro/texture/kokoro_fire.png",
   L"data/actor/kokoro/texture/kokoro_fireB.png",
   L"data/actor/kokoro/texture/kokoro_fireBase.png",
   L"data/actor/kokoro/texture/kokoro_fireWorkA0000.png",
   L"data/actor/kokoro/texture/kokoro_sparkLine.png",
   L"data/actor/kokoro/texture/kona_A.bmp",
   L"data/actor/kokoro/texture/lightning_mapA.png",
   L"data/actor/kokoro/texture/mantleB0000.bmp",
   L"data/actor/kokoro/texture/mantleG0000.bmp",
   L"data/actor/kokoro/texture/mantleR0000.bmp",
   L"data/actor/kokoro/texture/mantletest000.bmp",
   L"data/actor/kokoro/texture/marisaBall2.bmp",
   L"data/actor/kokoro/texture/marisaStarFlare.bmp",
   L"data/actor/kokoro/texture/mask_ball.png",
   L"data/actor/kokoro/texture/monoAuraA0000.png",
   L"data/actor/kokoro/texture/monoAuraA0001.png",
   L"data/actor/kokoro/texture/netA0000.png",
   L"data/actor/kokoro/texture/occult_face0000.dds",
   L"data/actor/kokoro/texture/occult_splash0000.dds",
   L"data/actor/kokoro/texture/reimu_musouBase.png",
   L"data/actor/kokoro/texture/reimu_wallA.png",
   L"data/actor/kokoro/texture/reimu_wallA_mask.png",
   L"data/actor/kokoro/texture/ringSparkA0000.png",
   L"data/actor/kokoro/texture/skillA_fox.png",
   L"data/actor/kokoro/texture/skillA_mono.png",
   L"data/actor/kokoro/texture/skillD_shadowA0000.png",
   L"data/actor/kokoro/texture/skillD_squeezeA.png",
   L"data/actor/kokoro/texture/skillD_squeezeMono.png",
   L"data/actor/kokoro/texture/skillD_trail.png",
   L"data/actor/kokoro/texture/skillD_trail2.png",
   L"data/actor/kokoro/texture/skillE_Trail.png",
   L"data/actor/kokoro/texture/spellC_shadowA0000.png",
   L"data/actor/kokoro/texture/spellC_shadowA0001.png",
   L"data/actor/kokoro/texture/spellC_shadowA0002.png",
   L"data/actor/kokoro/texture/spellC_shadowA0003.png",
   L"data/actor/kokoro/texture/spellC_shadowA0004.png",
   L"data/actor/kokoro/texture/spell_use_cut.png",
   L"data/actor/kokoro/texture/stringA000.png",
   L"data/actor/kokoro/texture/test_guage.png",
   L"data/actor/kokoro/texture/test_ikari.png",
   L"data/actor/kokoro/texture/test_ki.png",
   L"data/actor/kokoro/texture/test_ui.png",
   L"data/actor/kokoro/texture/trail.png",
   L"data/actor/kokoro/turn0000.bmp",
   L"data/actor/kokoro/turn0001.bmp",
   L"data/actor/kokoro/turn0002.bmp",
   L"data/actor/kokoro/walkBack0000.bmp",
   L"data/actor/kokoro/walkBack0001.bmp",
   L"data/actor/kokoro/walkBack0002.bmp",
   L"data/actor/kokoro/walkBack0003.bmp",
   L"data/actor/kokoro/walkBack0004.bmp",
   L"data/actor/kokoro/walkBack0005.bmp",
   L"data/actor/kokoro/walkBack0006.bmp",
   L"data/actor/kokoro/walkBackLoop0000.bmp",
   L"data/actor/kokoro/walkBackLoop0001.bmp",
   L"data/actor/kokoro/walkBackLoop0002.bmp",
   L"data/actor/kokoro/walkBackLoop0003.bmp",
   L"data/actor/kokoro/walkBackLoop0004.bmp",
   L"data/actor/kokoro/walkFront0000.bmp",
   L"data/actor/kokoro/walkFront0001.bmp",
   L"data/actor/kokoro/walkFront0002.bmp",
   L"data/actor/kokoro/walkFront0003.bmp",
   L"data/actor/kokoro/walkFront0004.bmp",
   L"data/actor/kokoro/walkFront0005.bmp",
   L"data/actor/kokoro/walkFrontLoop0000.bmp",
   L"data/actor/kokoro/walkFrontLoop0001.bmp",
   L"data/actor/kokoro/walkFrontLoop0002.bmp",
   L"data/actor/kokoro/walkFrontLoop0003.bmp",
   L"data/actor/kokoro/walkFrontLoop0004.bmp",
   L"data/actor/kokoro/winA0000.bmp",
   L"data/actor/kokoro/winA0001.bmp",
   L"data/actor/kokoro/winA0002.bmp",
   L"data/actor/kokoro/winA0003.bmp",
   L"data/actor/kokoro/winA0004.bmp",
   L"data/actor/kokoro/winA0005.bmp",
   L"data/actor/kokoro/winA0006.bmp",
   L"data/actor/kokoro/winA0007.bmp",
   L"data/actor/kokoro/winA0008.bmp",
   L"data/actor/kokoro.nut",
   L"data/actor/kokoro_base.nut",
   L"data/actor/kokoro_boss.nut",
   L"data/actor/kokoro_boss_base.nut",
   L"data/actor/kokoro_boss_init.nut",
   L"data/actor/kokoro_boss_shot.nut",
   L"data/actor/kokoro_com.nut",
   L"data/actor/kokoro_combo.nut",
   L"data/actor/kokoro_com_function.nut",
   L"data/actor/kokoro_init.nut",
   L"data/actor/kokoro_practice_init.nut",
   L"data/actor/kokoro_shot.nut",
   L"data/actor/kokoro_team.nut",
   L"data/actor/mamizou/atkDashHigh0002.bmp",
   L"data/actor/mamizou/atkDashHigh0003.bmp",
   L"data/actor/mamizou/atkDashHigh0004.bmp",
   L"data/actor/mamizou/atkDashHigh0005.bmp",
   L"data/actor/mamizou/atkDashHigh0006.bmp",
   L"data/actor/mamizou/atkDashHigh0007.bmp",
   L"data/actor/mamizou/atkDashLow0000.bmp",
   L"data/actor/mamizou/atkDashLow0001.bmp",
   L"data/actor/mamizou/atkDashLow0002.bmp",
   L"data/actor/mamizou/atkDashLow0003.bmp",
   L"data/actor/mamizou/atkDashLow0004.bmp",
   L"data/actor/mamizou/atkDashLow0005.bmp",
   L"data/actor/mamizou/atkDashLow0006.bmp",
   L"data/actor/mamizou/atkDashLow0007.bmp",
   L"data/actor/mamizou/atkDashLow0008.bmp",
   L"data/actor/mamizou/atkDashLow0009.bmp",
   L"data/actor/mamizou/atkDashLow0010.bmp",
   L"data/actor/mamizou/atkDashLow0011.bmp",
   L"data/actor/mamizou/atkHigh0000.bmp",
   L"data/actor/mamizou/atkHigh0001.bmp",
   L"data/actor/mamizou/atkHigh0002.bmp",
   L"data/actor/mamizou/atkHigh0003.bmp",
   L"data/actor/mamizou/atkHigh0004.bmp",
   L"data/actor/mamizou/atkHigh0005.bmp",
   L"data/actor/mamizou/atkHigh0006.bmp",
   L"data/actor/mamizou/atkHigh0007.bmp",
   L"data/actor/mamizou/atkHigh0008.bmp",
   L"data/actor/mamizou/atkHigh0009.bmp",
   L"data/actor/mamizou/atkHigh0010.bmp",
   L"data/actor/mamizou/atkHigh0011.bmp",
   L"data/actor/mamizou/atkHigh0012.bmp",
   L"data/actor/mamizou/atkHigh0013.bmp",
   L"data/actor/mamizou/atkHigh0014.bmp",
   L"data/actor/mamizou/atkHighFront0000.bmp",
   L"data/actor/mamizou/atkHighFront0001.bmp",
   L"data/actor/mamizou/atkHighFront0002.bmp",
   L"data/actor/mamizou/atkHighFront0003.bmp",
   L"data/actor/mamizou/atkHighFront0004.bmp",
   L"data/actor/mamizou/atkHighFront0005.bmp",
   L"data/actor/mamizou/atkHighFront0006.bmp",
   L"data/actor/mamizou/atkHighFront0007.bmp",
   L"data/actor/mamizou/atkHighFront0008.bmp",
   L"data/actor/mamizou/atkHighFront0009.bmp",
   L"data/actor/mamizou/atkHighFront0010.bmp",
   L"data/actor/mamizou/atkHighFront0011.bmp",
   L"data/actor/mamizou/atkHighFront0012.bmp",
   L"data/actor/mamizou/atkHighFront0013.bmp",
   L"data/actor/mamizou/atkHighFront0014.bmp",
   L"data/actor/mamizou/atkHighFront0015.bmp",
   L"data/actor/mamizou/atkHighUnder0001.bmp",
   L"data/actor/mamizou/atkHighUnder0002.bmp",
   L"data/actor/mamizou/atkHighUnder0003.bmp",
   L"data/actor/mamizou/atkHighUnder0004.bmp",
   L"data/actor/mamizou/atkHighUnder0005.bmp",
   L"data/actor/mamizou/atkHighUnder0006.bmp",
   L"data/actor/mamizou/atkHighUnder0007.bmp",
   L"data/actor/mamizou/atkHighUnder0008.bmp",
   L"data/actor/mamizou/atkHighUnder0009.bmp",
   L"data/actor/mamizou/atkHighUnder0010.bmp",
   L"data/actor/mamizou/atkHighUnder0011.bmp",
   L"data/actor/mamizou/atkHighUpper0000.bmp",
   L"data/actor/mamizou/atkHighUpper0001.bmp",
   L"data/actor/mamizou/atkHighUpper0002.bmp",
   L"data/actor/mamizou/atkHighUpper0003.bmp",
   L"data/actor/mamizou/atkHighUpper0004.bmp",
   L"data/actor/mamizou/atkHighUpper0005.bmp",
   L"data/actor/mamizou/atkHighUpper0006.bmp",
   L"data/actor/mamizou/atkHighUpper0007.bmp",
   L"data/actor/mamizou/atkHighUpper0008.bmp",
   L"data/actor/mamizou/atkHighUpper0009.bmp",
   L"data/actor/mamizou/atkHighUpper0010.bmp",
   L"data/actor/mamizou/atkLow0000.bmp",
   L"data/actor/mamizou/atkLow0001.bmp",
   L"data/actor/mamizou/atkLow0002.bmp",
   L"data/actor/mamizou/atkLow0003.bmp",
   L"data/actor/mamizou/atkLow0004.bmp",
   L"data/actor/mamizou/atkLow0005.bmp",
   L"data/actor/mamizou/atkLow0006.bmp",
   L"data/actor/mamizou/atkLow0007.bmp",
   L"data/actor/mamizou/atkLow0008.bmp",
   L"data/actor/mamizou/atkLow0009.bmp",
   L"data/actor/mamizou/atkLow0010.bmp",
   L"data/actor/mamizou/atkLow0011.bmp",
   L"data/actor/mamizou/atkLow0012.bmp",
   L"data/actor/mamizou/atk_Mid0000.bmp",
   L"data/actor/mamizou/atk_Mid0001.bmp",
   L"data/actor/mamizou/atk_Mid0002.bmp",
   L"data/actor/mamizou/atk_Mid0003.bmp",
   L"data/actor/mamizou/atk_Mid0004.bmp",
   L"data/actor/mamizou/atk_Mid0005.bmp",
   L"data/actor/mamizou/atk_Mid0006.bmp",
   L"data/actor/mamizou/atk_Mid0007.bmp",
   L"data/actor/mamizou/atk_Mid0008.bmp",
   L"data/actor/mamizou/battleBeginA0000.bmp",
   L"data/actor/mamizou/battleBeginA0001.bmp",
   L"data/actor/mamizou/battleBeginA0002.bmp",
   L"data/actor/mamizou/battleBeginA0003.bmp",
   L"data/actor/mamizou/battleBeginA0004.bmp",
   L"data/actor/mamizou/battleBeginA0005.bmp",
   L"data/actor/mamizou/battleBeginA0006.bmp",
   L"data/actor/mamizou/battleBeginA0007.bmp",
   L"data/actor/mamizou/battleBeginA0008.bmp",
   L"data/actor/mamizou/battleBeginB0000.bmp",
   L"data/actor/mamizou/battleBeginB0001.bmp",
   L"data/actor/mamizou/battleBeginB0002.bmp",
   L"data/actor/mamizou/battleBeginB0003.bmp",
   L"data/actor/mamizou/battleBeginB0004.bmp",
   L"data/actor/mamizou/battleBeginB0005.bmp",
   L"data/actor/mamizou/battleBeginB0006.bmp",
   L"data/actor/mamizou/battleBeginB0007.bmp",
   L"data/actor/mamizou/battleBeginB0008.bmp",
   L"data/actor/mamizou/battleBeginB0009.bmp",
   L"data/actor/mamizou/battleBeginB0010.bmp",
   L"data/actor/mamizou/battleBeginB0011.bmp",
   L"data/actor/mamizou/battleBeginB0012.bmp",
   L"data/actor/mamizou/bmsln/mamizou_ClimaxSmoke.bmb",
   L"data/actor/mamizou/bmsln/mamizou_fireWork.bmb",
   L"data/actor/mamizou/bmsln/mamizou_steam.bmb",
   L"data/actor/mamizou/climax0000.bmp",
   L"data/actor/mamizou/climax0001.bmp",
   L"data/actor/mamizou/climax0002.bmp",
   L"data/actor/mamizou/climax0003.bmp",
   L"data/actor/mamizou/climax0004.bmp",
   L"data/actor/mamizou/climax0005.bmp",
   L"data/actor/mamizou/climax0006.bmp",
   L"data/actor/mamizou/damageBody0000.bmp",
   L"data/actor/mamizou/damageBody0001.bmp",
   L"data/actor/mamizou/damageBody0002.bmp",
   L"data/actor/mamizou/damageBody0003.bmp",
   L"data/actor/mamizou/damageBody0004.bmp",
   L"data/actor/mamizou/damageHead0000.bmp",
   L"data/actor/mamizou/damageHead0001.bmp",
   L"data/actor/mamizou/damageHead0002.bmp",
   L"data/actor/mamizou/damageHead0003.bmp",
   L"data/actor/mamizou/damageHead0004.bmp",
   L"data/actor/mamizou/damageSpin0000.bmp",
   L"data/actor/mamizou/damageSpin0001.bmp",
   L"data/actor/mamizou/damageSpin0002.bmp",
   L"data/actor/mamizou/damageSpin0003.bmp",
   L"data/actor/mamizou/damageUpper0000.bmp",
   L"data/actor/mamizou/damageUpper0001.bmp",
   L"data/actor/mamizou/damageUpper0002.bmp",
   L"data/actor/mamizou/damageUpper0003.bmp",
   L"data/actor/mamizou/damageUpper0004.bmp",
   L"data/actor/mamizou/damageUpper0005.bmp",
   L"data/actor/mamizou/damageUpper0006.bmp",
   L"data/actor/mamizou/damageUpper0007.bmp",
   L"data/actor/mamizou/damageUpper0008.bmp",
   L"data/actor/mamizou/damageUpper0009.bmp",
   L"data/actor/mamizou/damageUpper0010.bmp",
   L"data/actor/mamizou/damageUpper0011.bmp",
   L"data/actor/mamizou/damageUpper0012.bmp",
   L"data/actor/mamizou/damageUpper0013.bmp",
   L"data/actor/mamizou/damageUpper0014.bmp",
   L"data/actor/mamizou/damageUpper0015.bmp",
   L"data/actor/mamizou/damageWall0000.bmp",
   L"data/actor/mamizou/damageWall0001.bmp",
   L"data/actor/mamizou/damageWall0002.bmp",
   L"data/actor/mamizou/damageWall0003.bmp",
   L"data/actor/mamizou/damageWall0004.bmp",
   L"data/actor/mamizou/damageWall0005.bmp",
   L"data/actor/mamizou/damageWall0006.bmp",
   L"data/actor/mamizou/damageWall0007.bmp",
   L"data/actor/mamizou/dashBack0000.bmp",
   L"data/actor/mamizou/dashBack0001.bmp",
   L"data/actor/mamizou/dashBack0002.bmp",
   L"data/actor/mamizou/dashBack0003.bmp",
   L"data/actor/mamizou/dashBack0004.bmp",
   L"data/actor/mamizou/dashBack0005.bmp",
   L"data/actor/mamizou/dashBack0006.bmp",
   L"data/actor/mamizou/dashBack0007.bmp",
   L"data/actor/mamizou/dashBack0008.bmp",
   L"data/actor/mamizou/dashBack0009.bmp",
   L"data/actor/mamizou/dashBack0010.bmp",
   L"data/actor/mamizou/dashBack0011.bmp",
   L"data/actor/mamizou/dashBack0012.bmp",
   L"data/actor/mamizou/dashFront0000.bmp",
   L"data/actor/mamizou/dashFront0001.bmp",
   L"data/actor/mamizou/dashFront0002.bmp",
   L"data/actor/mamizou/dashFront0003.bmp",
   L"data/actor/mamizou/dashFront0004.bmp",
   L"data/actor/mamizou/dashFront0005.bmp",
   L"data/actor/mamizou/dashFront0006.bmp",
   L"data/actor/mamizou/dashFront0007.bmp",
   L"data/actor/mamizou/dashFront0008.bmp",
   L"data/actor/mamizou/dashFront0009.bmp",
   L"data/actor/mamizou/dashFront0010.bmp",
   L"data/actor/mamizou/dashFront0011.bmp",
   L"data/actor/mamizou/dashFront0012.bmp",
   L"data/actor/mamizou/face_spellCallB.png",
   L"data/actor/mamizou/face_spellCallB_r.png",
   L"data/actor/mamizou/grab0000.bmp",
   L"data/actor/mamizou/grab0001.bmp",
   L"data/actor/mamizou/grab0002.bmp",
   L"data/actor/mamizou/grab0003.bmp",
   L"data/actor/mamizou/grab0004.bmp",
   L"data/actor/mamizou/grab_hit0000.bmp",
   L"data/actor/mamizou/grab_hit0001.bmp",
   L"data/actor/mamizou/grab_hit0002.bmp",
   L"data/actor/mamizou/grab_hit0003.bmp",
   L"data/actor/mamizou/grab_hit0004.bmp",
   L"data/actor/mamizou/grab_hit0005.bmp",
   L"data/actor/mamizou/grab_hit0006.bmp",
   L"data/actor/mamizou/grab_hit0007.bmp",
   L"data/actor/mamizou/grab_hit0008.bmp",
   L"data/actor/mamizou/grab_hit0009.bmp",
   L"data/actor/mamizou/grab_hit0010.bmp",
   L"data/actor/mamizou/grab_hit0011.bmp",
   L"data/actor/mamizou/grab_hit0012.bmp",
   L"data/actor/mamizou/guard0000.bmp",
   L"data/actor/mamizou/guardCrash0000.bmp",
   L"data/actor/mamizou/guardCrash0001.bmp",
   L"data/actor/mamizou/guardCrash0002.bmp",
   L"data/actor/mamizou/guardCrash0003.bmp",
   L"data/actor/mamizou/guardCrash0004.bmp",
   L"data/actor/mamizou/guardCrash0005.bmp",
   L"data/actor/mamizou/guardMiss0000.bmp",
   L"data/actor/mamizou/guardMiss0001.bmp",
   L"data/actor/mamizou/guardMiss0002.bmp",
   L"data/actor/mamizou/guardMiss0003.bmp",
   L"data/actor/mamizou/item0000.bmp",
   L"data/actor/mamizou/item0001.bmp",
   L"data/actor/mamizou/item0002.bmp",
   L"data/actor/mamizou/item0003.bmp",
   L"data/actor/mamizou/item0004.bmp",
   L"data/actor/mamizou/item0005.bmp",
   L"data/actor/mamizou/item0006.bmp",
   L"data/actor/mamizou/item0007.bmp",
   L"data/actor/mamizou/lose0000.bmp",
   L"data/actor/mamizou/lose0001.bmp",
   L"data/actor/mamizou/lose0002.bmp",
   L"data/actor/mamizou/lose0003.bmp",
   L"data/actor/mamizou/lose0004.bmp",
   L"data/actor/mamizou/lose0005.bmp",
   L"data/actor/mamizou/lose0006.bmp",
   L"data/actor/mamizou/mamizou.pat",
   L"data/actor/mamizou/mamizou_ed.pat",
   L"data/actor/mamizou/occult0000.bmp",
   L"data/actor/mamizou/occult0001.bmp",
   L"data/actor/mamizou/occult0002.bmp",
   L"data/actor/mamizou/occult0003.bmp",
   L"data/actor/mamizou/occult0004.bmp",
   L"data/actor/mamizou/occult_alian0000.bmp",
   L"data/actor/mamizou/occult_alian0001.bmp",
   L"data/actor/mamizou/occult_alian0002.bmp",
   L"data/actor/mamizou/occult_alian0003.bmp",
   L"data/actor/mamizou/palette000.bmp",
   L"data/actor/mamizou/palette001.bmp",
   L"data/actor/mamizou/palette002.bmp",
   L"data/actor/mamizou/palette003.bmp",
   L"data/actor/mamizou/palette004.bmp",
   L"data/actor/mamizou/palette005.bmp",
   L"data/actor/mamizou/palette006.bmp",
   L"data/actor/mamizou/palette007.bmp",
   L"data/actor/mamizou/palette100.bmp",
   L"data/actor/mamizou/palette101.bmp",
   L"data/actor/mamizou/palette102.bmp",
   L"data/actor/mamizou/palette103.bmp",
   L"data/actor/mamizou/palette104.bmp",
   L"data/actor/mamizou/palette105.bmp",
   L"data/actor/mamizou/palette106.bmp",
   L"data/actor/mamizou/palette107.bmp",
   L"data/actor/mamizou/shotHighA0000.bmp",
   L"data/actor/mamizou/shotHighA0001.bmp",
   L"data/actor/mamizou/shotHighA0002.bmp",
   L"data/actor/mamizou/shotHighA0003.bmp",
   L"data/actor/mamizou/shotHighA0004.bmp",
   L"data/actor/mamizou/shotHighA0005.bmp",
   L"data/actor/mamizou/shotHighA0006.bmp",
   L"data/actor/mamizou/shotHighA0007.bmp",
   L"data/actor/mamizou/shotHighA0008.bmp",
   L"data/actor/mamizou/shotHighA0009.bmp",
   L"data/actor/mamizou/shotHighA0010.bmp",
   L"data/actor/mamizou/shotLow0000.bmp",
   L"data/actor/mamizou/shotLow0001.bmp",
   L"data/actor/mamizou/shotLow0002.bmp",
   L"data/actor/mamizou/shotLow0003.bmp",
   L"data/actor/mamizou/shotLow0004.bmp",
   L"data/actor/mamizou/shotLow0005.bmp",
   L"data/actor/mamizou/shotLow0006.bmp",
   L"data/actor/mamizou/shotLow0007.bmp",
   L"data/actor/mamizou/shotLow0008.bmp",
   L"data/actor/mamizou/shotLow0009.bmp",
   L"data/actor/mamizou/shotLow0010.bmp",
   L"data/actor/mamizou/shotLow0011.bmp",
   L"data/actor/mamizou/shotLow0012.bmp",
   L"data/actor/mamizou/shotLow0013.bmp",
   L"data/actor/mamizou/skillA0000.bmp",
   L"data/actor/mamizou/skillA0001.bmp",
   L"data/actor/mamizou/skillA0002.bmp",
   L"data/actor/mamizou/skillA0003.bmp",
   L"data/actor/mamizou/skillA0004.bmp",
   L"data/actor/mamizou/skillA0005.bmp",
   L"data/actor/mamizou/skillA0006.bmp",
   L"data/actor/mamizou/skillA0007.bmp",
   L"data/actor/mamizou/skillA0008.bmp",
   L"data/actor/mamizou/skillA0009.bmp",
   L"data/actor/mamizou/skillA0010.bmp",
   L"data/actor/mamizou/skillA_Under0000.bmp",
   L"data/actor/mamizou/skillA_Under0001.bmp",
   L"data/actor/mamizou/skillA_Under0002.bmp",
   L"data/actor/mamizou/skillA_Under0003.bmp",
   L"data/actor/mamizou/skillA_Under0004.bmp",
   L"data/actor/mamizou/skillA_Under0005.bmp",
   L"data/actor/mamizou/skillA_Upper0000.bmp",
   L"data/actor/mamizou/skillA_Upper0001.bmp",
   L"data/actor/mamizou/skillA_Upper0002.bmp",
   L"data/actor/mamizou/skillA_Upper0003.bmp",
   L"data/actor/mamizou/skillA_Upper0004.bmp",
   L"data/actor/mamizou/skillB0000.bmp",
   L"data/actor/mamizou/skillB0001.bmp",
   L"data/actor/mamizou/skillB0002.bmp",
   L"data/actor/mamizou/skillB0003.bmp",
   L"data/actor/mamizou/skillB0004.bmp",
   L"data/actor/mamizou/skillB0005.bmp",
   L"data/actor/mamizou/skillB0006.bmp",
   L"data/actor/mamizou/skillB0007.bmp",
   L"data/actor/mamizou/skillB0008.bmp",
   L"data/actor/mamizou/skillB0009.bmp",
   L"data/actor/mamizou/skillB0010.bmp",
   L"data/actor/mamizou/skillB0011.bmp",
   L"data/actor/mamizou/skillB0012.bmp",
   L"data/actor/mamizou/skillB0013.bmp",
   L"data/actor/mamizou/skillB0014.bmp",
   L"data/actor/mamizou/skillC0000.bmp",
   L"data/actor/mamizou/skillC0001.bmp",
   L"data/actor/mamizou/skillC0002.bmp",
   L"data/actor/mamizou/skillC0003.bmp",
   L"data/actor/mamizou/skillC0004.bmp",
   L"data/actor/mamizou/skillC0005.bmp",
   L"data/actor/mamizou/skillC0006.bmp",
   L"data/actor/mamizou/skillC0007.bmp",
   L"data/actor/mamizou/skillC0008.bmp",
   L"data/actor/mamizou/skillC0009.bmp",
   L"data/actor/mamizou/skill_taiko0000.bmp",
   L"data/actor/mamizou/skill_taiko0001.bmp",
   L"data/actor/mamizou/skill_taiko0002.bmp",
   L"data/actor/mamizou/skill_taiko0003.bmp",
   L"data/actor/mamizou/skill_taiko0004.bmp",
   L"data/actor/mamizou/skill_taiko0005.bmp",
   L"data/actor/mamizou/skill_taiko0006.bmp",
   L"data/actor/mamizou/skill_taiko0007.bmp",
   L"data/actor/mamizou/skill_taiko0008.bmp",
   L"data/actor/mamizou/skill_taiko0009.bmp",
   L"data/actor/mamizou/skill_taiko0010.bmp",
   L"data/actor/mamizou/skill_taiko_pre0000.bmp",
   L"data/actor/mamizou/skill_taiko_pre0001.bmp",
   L"data/actor/mamizou/skill_taiko_pre0002.bmp",
   L"data/actor/mamizou/skill_taiko_pre0003.bmp",
   L"data/actor/mamizou/skill_taiko_pre0004.bmp",
   L"data/actor/mamizou/skill_taiko_pre0005.bmp",
   L"data/actor/mamizou/slideUpper0000.bmp",
   L"data/actor/mamizou/slideUpper0001.bmp",
   L"data/actor/mamizou/slideUpper0002.bmp",
   L"data/actor/mamizou/slideUpper0003.bmp",
   L"data/actor/mamizou/slideUpper0004.bmp",
   L"data/actor/mamizou/slideUpper0005.bmp",
   L"data/actor/mamizou/slideUpper0006.bmp",
   L"data/actor/mamizou/slideUpper0007.bmp",
   L"data/actor/mamizou/slideUpper0008.bmp",
   L"data/actor/mamizou/slideUpper0009.bmp",
   L"data/actor/mamizou/slideUpper0010.bmp",
   L"data/actor/mamizou/slideUpper0011.bmp",
   L"data/actor/mamizou/slideUpper0012.bmp",
   L"data/actor/mamizou/slideUpper0013.bmp",
   L"data/actor/mamizou/slideUpper0014.bmp",
   L"data/actor/mamizou/slideUpper0015.bmp",
   L"data/actor/mamizou/slideUpper0016.bmp",
   L"data/actor/mamizou/slideUpper0017.bmp",
   L"data/actor/mamizou/spellA0000.bmp",
   L"data/actor/mamizou/spellA0001.bmp",
   L"data/actor/mamizou/spellA0002.bmp",
   L"data/actor/mamizou/spellA0003.bmp",
   L"data/actor/mamizou/spellA0004.bmp",
   L"data/actor/mamizou/spellA0005.bmp",
   L"data/actor/mamizou/spellA0006.bmp",
   L"data/actor/mamizou/spellA0007.bmp",
   L"data/actor/mamizou/spellA0008.bmp",
   L"data/actor/mamizou/spellA0009.bmp",
   L"data/actor/mamizou/spellA0010.bmp",
   L"data/actor/mamizou/spellA0011.bmp",
   L"data/actor/mamizou/spellA0012.bmp",
   L"data/actor/mamizou/spellB0000.bmp",
   L"data/actor/mamizou/spellB0001.bmp",
   L"data/actor/mamizou/spellB0002.bmp",
   L"data/actor/mamizou/spellB0003.bmp",
   L"data/actor/mamizou/spellB0004.bmp",
   L"data/actor/mamizou/spellB0005.bmp",
   L"data/actor/mamizou/spellB0006.bmp",
   L"data/actor/mamizou/spellB0007.bmp",
   L"data/actor/mamizou/spellC0000.bmp",
   L"data/actor/mamizou/spellC0001.bmp",
   L"data/actor/mamizou/spellC0002.bmp",
   L"data/actor/mamizou/spellC0003.bmp",
   L"data/actor/mamizou/spellC_Loop0000.bmp",
   L"data/actor/mamizou/spellC_Loop0001.bmp",
   L"data/actor/mamizou/spellC_Loop0002.bmp",
   L"data/actor/mamizou/spellC_Loop0003.bmp",
   L"data/actor/mamizou/stand0000.bmp",
   L"data/actor/mamizou/stand0001.bmp",
   L"data/actor/mamizou/stand0002.bmp",
   L"data/actor/mamizou/stand0003.bmp",
   L"data/actor/mamizou/stand0004.bmp",
   L"data/actor/mamizou/stand0005.bmp",
   L"data/actor/mamizou/stand0006.bmp",
   L"data/actor/mamizou/stand0007.bmp",
   L"data/actor/mamizou/stand0008.bmp",
   L"data/actor/mamizou/stand0009.bmp",
   L"data/actor/mamizou/stand0010.bmp",
   L"data/actor/mamizou/stand0011.bmp",
   L"data/actor/mamizou/stand0012.bmp",
   L"data/actor/mamizou/stand0013.bmp",
   L"data/actor/mamizou/stand0014.bmp",
   L"data/actor/mamizou/stand0015.bmp",
   L"data/actor/mamizou/stand0016.bmp",
   L"data/actor/mamizou/stand0017.bmp",
   L"data/actor/mamizou/stand0018.bmp",
   L"data/actor/mamizou/stand0019.bmp",
   L"data/actor/mamizou/stun0000.bmp",
   L"data/actor/mamizou/stun0001.bmp",
   L"data/actor/mamizou/stun0002.bmp",
   L"data/actor/mamizou/stun0003.bmp",
   L"data/actor/mamizou/stun0004.bmp",
   L"data/actor/mamizou/stun0005.bmp",
   L"data/actor/mamizou/stun0006.bmp",
   L"data/actor/mamizou/stun0007.bmp",
   L"data/actor/mamizou/team_begin_A0000.bmp",
   L"data/actor/mamizou/team_begin_A0001.bmp",
   L"data/actor/mamizou/team_begin_A0002.bmp",
   L"data/actor/mamizou/team_begin_A0003.bmp",
   L"data/actor/mamizou/team_begin_A0004.bmp",
   L"data/actor/mamizou/team_begin_A0005.bmp",
   L"data/actor/mamizou/team_begin_A0006.bmp",
   L"data/actor/mamizou/team_begin_A0007.bmp",
   L"data/actor/mamizou/team_begin_A0008.bmp",
   L"data/actor/mamizou/team_begin_A0009.bmp",
   L"data/actor/mamizou/team_begin_A0010.bmp",
   L"data/actor/mamizou/team_begin_A0011.bmp",
   L"data/actor/mamizou/team_begin_A0012.bmp",
   L"data/actor/mamizou/team_begin_A0013.bmp",
   L"data/actor/mamizou/team_begin_A0014.bmp",
   L"data/actor/mamizou/team_begin_A0015.bmp",
   L"data/actor/mamizou/texture/andonB_00.png",
   L"data/actor/mamizou/texture/andonB_01.png",
   L"data/actor/mamizou/texture/andonB_02.png",
   L"data/actor/mamizou/texture/andonB_03.png",
   L"data/actor/mamizou/texture/andonB_04.png",
   L"data/actor/mamizou/texture/andonB_05.png",
   L"data/actor/mamizou/texture/andonB_06.png",
   L"data/actor/mamizou/texture/andonB_07.png",
   L"data/actor/mamizou/texture/andon_00.png",
   L"data/actor/mamizou/texture/andon_01.png",
   L"data/actor/mamizou/texture/andon_02.png",
   L"data/actor/mamizou/texture/andon_03.png",
   L"data/actor/mamizou/texture/andon_04.png",
   L"data/actor/mamizou/texture/andon_05.png",
   L"data/actor/mamizou/texture/andon_06.png",
   L"data/actor/mamizou/texture/andon_07.png",
   L"data/actor/mamizou/texture/ball.png",
   L"data/actor/mamizou/texture/bomb.dds",
   L"data/actor/mamizou/texture/chagama00.png",
   L"data/actor/mamizou/texture/chagama01.png",
   L"data/actor/mamizou/texture/chouzyuuA.png",
   L"data/actor/mamizou/texture/chouzyuuB.png",
   L"data/actor/mamizou/texture/climaxBack.dds",
   L"data/actor/mamizou/texture/climaxcut0000.dds",
   L"data/actor/mamizou/texture/climaxItem.png",
   L"data/actor/mamizou/texture/climax_light0000.png",
   L"data/actor/mamizou/texture/face_master_mamizou.png",
   L"data/actor/mamizou/texture/face_master_mamizou2.png",
   L"data/actor/mamizou/texture/face_slave_mamizou.png",
   L"data/actor/mamizou/texture/face_spell_cut.png",
   L"data/actor/mamizou/texture/fireA0000.png",
   L"data/actor/mamizou/texture/fireWorkA0000.dds",
   L"data/actor/mamizou/texture/grab_kasa000.png",
   L"data/actor/mamizou/texture/grab_kasa001.png",
   L"data/actor/mamizou/texture/grab_kasa002.png",
   L"data/actor/mamizou/texture/grab_kasa003.png",
   L"data/actor/mamizou/texture/grab_kasa004.png",
   L"data/actor/mamizou/texture/grab_kasa005.png",
   L"data/actor/mamizou/texture/grab_kasa006.png",
   L"data/actor/mamizou/texture/karakasa_00.png",
   L"data/actor/mamizou/texture/karakasa_01.png",
   L"data/actor/mamizou/texture/karakasa_02.png",
   L"data/actor/mamizou/texture/kasa_D_00.png",
   L"data/actor/mamizou/texture/kasa_D_01.png",
   L"data/actor/mamizou/texture/kasa_D_02.png",
   L"data/actor/mamizou/texture/kasa_D_03.png",
   L"data/actor/mamizou/texture/kasa_K_00.png",
   L"data/actor/mamizou/texture/kasa_K_01.png",
   L"data/actor/mamizou/texture/kasa_K_02.png",
   L"data/actor/mamizou/texture/kasa_K_03.png",
   L"data/actor/mamizou/texture/kasa_K_04.png",
   L"data/actor/mamizou/texture/kasa_K_05.png",
   L"data/actor/mamizou/texture/kasa_K_06.png",
   L"data/actor/mamizou/texture/kasa_K_07.png",
   L"data/actor/mamizou/texture/kasa_K_08.png",
   L"data/actor/mamizou/texture/kasa_K_09.png",
   L"data/actor/mamizou/texture/kasa_K_10.png",
   L"data/actor/mamizou/texture/kona_A.png",
   L"data/actor/mamizou/texture/mamizou_animalDamage000.png",
   L"data/actor/mamizou/texture/mamizou_animalDamage001.png",
   L"data/actor/mamizou/texture/mamizou_animalDamage002.png",
   L"data/actor/mamizou/texture/mamizou_animalDamage003.png",
   L"data/actor/mamizou/texture/mamizou_animal_00000.png",
   L"data/actor/mamizou/texture/mamizou_animal_00001.png",
   L"data/actor/mamizou/texture/mamizou_animal_00002.png",
   L"data/actor/mamizou/texture/mamizou_animal_00003.png",
   L"data/actor/mamizou/texture/mamizou_animal_00004.png",
   L"data/actor/mamizou/texture/mamizou_animal_00005.png",
   L"data/actor/mamizou/texture/mamizou_animal_00006.png",
   L"data/actor/mamizou/texture/mamizou_animal_00007.png",
   L"data/actor/mamizou/texture/mamizou_animal_00008.png",
   L"data/actor/mamizou/texture/mamizou_animal_00009.png",
   L"data/actor/mamizou/texture/mamizou_animal_00010.png",
   L"data/actor/mamizou/texture/mamizou_animal_00011.png",
   L"data/actor/mamizou/texture/mamizou_beam0000.png",
   L"data/actor/mamizou/texture/mamizou_charge.png",
   L"data/actor/mamizou/texture/mamizou_leaf1.png",
   L"data/actor/mamizou/texture/mamizou_leaf2.png",
   L"data/actor/mamizou/texture/mamizou_leaf3.png",
   L"data/actor/mamizou/texture/mamizou_leaf4.png",
   L"data/actor/mamizou/texture/mamizou_leaf_black.png",
   L"data/actor/mamizou/texture/mamizou_leaf_gray.png",
   L"data/actor/mamizou/texture/mamizou_leaf_red.png",
   L"data/actor/mamizou/texture/marisa_sparkLine.png",
   L"data/actor/mamizou/texture/mask_ball.png",
   L"data/actor/mamizou/texture/monsterA0000.png",
   L"data/actor/mamizou/texture/monsterA0001.png",
   L"data/actor/mamizou/texture/monsterB0000.png",
   L"data/actor/mamizou/texture/monsterB0001.png",
   L"data/actor/mamizou/texture/monsterC0000.png",
   L"data/actor/mamizou/texture/monsterC0001.png",
   L"data/actor/mamizou/texture/monsterD0000.png",
   L"data/actor/mamizou/texture/monsterD0001.png",
   L"data/actor/mamizou/texture/monsterE0000.png",
   L"data/actor/mamizou/texture/monsterE0001.png",
   L"data/actor/mamizou/texture/monsterF0000.png",
   L"data/actor/mamizou/texture/monsterF0001.png",
   L"data/actor/mamizou/texture/monsterG0000.png",
   L"data/actor/mamizou/texture/monsterG0001.png",
   L"data/actor/mamizou/texture/monsterH0000.png",
   L"data/actor/mamizou/texture/monsterH0001.png",
   L"data/actor/mamizou/texture/monsterI0000.png",
   L"data/actor/mamizou/texture/monsterI0001.png",
   L"data/actor/mamizou/texture/monsterJ0000.png",
   L"data/actor/mamizou/texture/monsterJ0001.png",
   L"data/actor/mamizou/texture/monsterK0000.png",
   L"data/actor/mamizou/texture/monsterK0001.png",
   L"data/actor/mamizou/texture/monsterL0000.png",
   L"data/actor/mamizou/texture/monsterL0001.png",
   L"data/actor/mamizou/texture/monsterM0000.png",
   L"data/actor/mamizou/texture/monsterM0001.png",
   L"data/actor/mamizou/texture/monsterN0000.png",
   L"data/actor/mamizou/texture/monsterN0001.png",
   L"data/actor/mamizou/texture/monsterO0000.png",
   L"data/actor/mamizou/texture/monsterO0001.png",
   L"data/actor/mamizou/texture/monsterP0000.png",
   L"data/actor/mamizou/texture/monsterP0001.png",
   L"data/actor/mamizou/texture/monsterQ0000.png",
   L"data/actor/mamizou/texture/monsterQ0001.png",
   L"data/actor/mamizou/texture/monsterR0000.png",
   L"data/actor/mamizou/texture/monsterR0001.png",
   L"data/actor/mamizou/texture/nameCall.png",
   L"data/actor/mamizou/texture/nurikabe00.png",
   L"data/actor/mamizou/texture/nurikabe01.png",
   L"data/actor/mamizou/texture/nurikabe02.png",
   L"data/actor/mamizou/texture/occult_cap0000.dds",
   L"data/actor/mamizou/texture/occult_cap0001.dds",
   L"data/actor/mamizou/texture/occult_cap0002.dds",
   L"data/actor/mamizou/texture/occult_ufo0000.dds",
   L"data/actor/mamizou/texture/sippo_00.png",
   L"data/actor/mamizou/texture/sippo_01.png",
   L"data/actor/mamizou/texture/sippo_02.png",
   L"data/actor/mamizou/texture/sippo_03.png",
   L"data/actor/mamizou/texture/sippo_04.png",
   L"data/actor/mamizou/texture/sippo_05.png",
   L"data/actor/mamizou/texture/sippo_06.png",
   L"data/actor/mamizou/texture/sippo_07.png",
   L"data/actor/mamizou/texture/smoke.png",
   L"data/actor/mamizou/texture/smokeB.png",
   L"data/actor/mamizou/texture/speedLineA0000.dds",
   L"data/actor/mamizou/texture/spell_use_cut.png",
   L"data/actor/mamizou/texture/spell_use_cut_reverse.png",
   L"data/actor/mamizou/texture/steamA0000.png",
   L"data/actor/mamizou/texture/steamB0000.png",
   L"data/actor/mamizou/texture/swingA0000.png",
   L"data/actor/mamizou/texture/taiko_000.png",
   L"data/actor/mamizou/texture/taiko_001.png",
   L"data/actor/mamizou/texture/taiko_002.png",
   L"data/actor/mamizou/texture/taiko_003.png",
   L"data/actor/mamizou/texture/taiko_004.png",
   L"data/actor/mamizou/texture/taiko_005.png",
   L"data/actor/mamizou/texture/taiko_beat_0000.png",
   L"data/actor/mamizou/texture/taiko_beat_0001.png",
   L"data/actor/mamizou/texture/taiko_beat_0002.png",
   L"data/actor/mamizou/texture/taiko_beat_0003.png",
   L"data/actor/mamizou/texture/Taiko_shot000.png",
   L"data/actor/mamizou/texture/Taiko_shot001.png",
   L"data/actor/mamizou/texture/tanukiA.png",
   L"data/actor/mamizou/texture/tanukiB.png",
   L"data/actor/mamizou/texture/tanukiC.png",
   L"data/actor/mamizou/texture/tanukiD.png",
   L"data/actor/mamizou/texture/tanukiE.png",
   L"data/actor/mamizou/texture/torii.png",
   L"data/actor/mamizou/texture/turube01.png",
   L"data/actor/mamizou/texture/ufobeam0000.png",
   L"data/actor/mamizou/turn0000.bmp",
   L"data/actor/mamizou/turn0001.bmp",
   L"data/actor/mamizou/turn0002.bmp",
   L"data/actor/mamizou/walkBack0000.bmp",
   L"data/actor/mamizou/walkBack0001.bmp",
   L"data/actor/mamizou/walkBack0002.bmp",
   L"data/actor/mamizou/walkBack0003.bmp",
   L"data/actor/mamizou/walkBack0004.bmp",
   L"data/actor/mamizou/walkBackLoop0000.bmp",
   L"data/actor/mamizou/walkBackLoop0001.bmp",
   L"data/actor/mamizou/walkBackLoop0002.bmp",
   L"data/actor/mamizou/walkBackLoop0003.bmp",
   L"data/actor/mamizou/walkBackLoop0004.bmp",
   L"data/actor/mamizou/walkBackLoop0005.bmp",
   L"data/actor/mamizou/walkFront0000.bmp",
   L"data/actor/mamizou/walkFront0001.bmp",
   L"data/actor/mamizou/walkFront0002.bmp",
   L"data/actor/mamizou/walkFront0003.bmp",
   L"data/actor/mamizou/walkFront0004.bmp",
   L"data/actor/mamizou/walkFront0005.bmp",
   L"data/actor/mamizou/walkFront0006.bmp",
   L"data/actor/mamizou/walkFrontLoop0000.bmp",
   L"data/actor/mamizou/walkFrontLoop0001.bmp",
   L"data/actor/mamizou/walkFrontLoop0002.bmp",
   L"data/actor/mamizou/walkFrontLoop0003.bmp",
   L"data/actor/mamizou/walkFrontLoop0004.bmp",
   L"data/actor/mamizou/walkFrontLoop0005.bmp",
   L"data/actor/mamizou/winA0000.bmp",
   L"data/actor/mamizou/winA0001.bmp",
   L"data/actor/mamizou/winA0002.bmp",
   L"data/actor/mamizou/winA0003.bmp",
   L"data/actor/mamizou/winA0004.bmp",
   L"data/actor/mamizou/winA0005.bmp",
   L"data/actor/mamizou/winA0006.bmp",
   L"data/actor/mamizou/winA0007.bmp",
   L"data/actor/mamizou/winA0008.bmp",
   L"data/actor/mamizou/winA0009.bmp",
   L"data/actor/mamizou/winA0010.bmp",
   L"data/actor/mamizou/winA0011.bmp",
   L"data/actor/mamizou/winA0012.bmp",
   L"data/actor/mamizou/winB0000.bmp",
   L"data/actor/mamizou/winB0001.bmp",
   L"data/actor/mamizou/winB0002.bmp",
   L"data/actor/mamizou/winB0003.bmp",
   L"data/actor/mamizou/winB0004.bmp",
   L"data/actor/mamizou/winB0005.bmp",
   L"data/actor/mamizou/winB0006.bmp",
   L"data/actor/mamizou/winB0007.bmp",
   L"data/actor/mamizou/winB0008.bmp",
   L"data/actor/mamizou/winB0009.bmp",
   L"data/actor/mamizou/winB0010.bmp",
   L"data/actor/mamizou/winB0011.bmp",
   L"data/actor/mamizou/winB0012.bmp",
   L"data/actor/mamizou/winB0013.bmp",
   L"data/actor/mamizou/winB0014.bmp",
   L"data/actor/mamizou/winB0015.bmp",
   L"data/actor/mamizou/winB0016.bmp",
   L"data/actor/mamizou/winB0017.bmp",
   L"data/actor/mamizou/winB0018.bmp",
   L"data/actor/mamizou/winB0019.bmp",
   L"data/actor/mamizou/winB0020.bmp",
   L"data/actor/mamizou/winB0021.bmp",
   L"data/actor/mamizou/winB0022.bmp",
   L"data/actor/mamizou/winB0023.bmp",
   L"data/actor/mamizou/winB0024.bmp",
   L"data/actor/mamizou/winB0025.bmp",
   L"data/actor/mamizou.nut",
   L"data/actor/mamizou_base.nut",
   L"data/actor/mamizou_boss.nut",
   L"data/actor/mamizou_boss_base.nut",
   L"data/actor/mamizou_boss_init.nut",
   L"data/actor/mamizou_boss_shot.nut",
   L"data/actor/mamizou_com.nut",
   L"data/actor/mamizou_combo.nut",
   L"data/actor/mamizou_com_function.nut",
   L"data/actor/mamizou_init.nut",
   L"data/actor/mamizou_practice_init.nut",
   L"data/actor/mamizou_shot.nut",
   L"data/actor/mamizou_team.nut",
   L"data/actor/marisa/atkHigh0000.bmp",
   L"data/actor/marisa/atkHigh0001.bmp",
   L"data/actor/marisa/atkHigh0002.bmp",
   L"data/actor/marisa/atkHigh0003.bmp",
   L"data/actor/marisa/atkHigh0004.bmp",
   L"data/actor/marisa/atkHigh0005.bmp",
   L"data/actor/marisa/atkHigh0006.bmp",
   L"data/actor/marisa/atkHigh0007.bmp",
   L"data/actor/marisa/atkHighFront0000.bmp",
   L"data/actor/marisa/atkHighFront0001.bmp",
   L"data/actor/marisa/atkHighFront0002.bmp",
   L"data/actor/marisa/atkHighFront0003.bmp",
   L"data/actor/marisa/atkHighFront0004.bmp",
   L"data/actor/marisa/atkHighFront0005.bmp",
   L"data/actor/marisa/atkHighFront0006.bmp",
   L"data/actor/marisa/atkHighUpper_blade0000.png",
   L"data/actor/marisa/atkHighUpper_blade0001.png",
   L"data/actor/marisa/atkHighUpper_blade0002.png",
   L"data/actor/marisa/atkHighUpper_blade0003.png",
   L"data/actor/marisa/atkHighUpper_blade0004.png",
   L"data/actor/marisa/atkHigh_Blade0000.png",
   L"data/actor/marisa/atkHigh_Blade0001.png",
   L"data/actor/marisa/atkHigh_Blade0002.png",
   L"data/actor/marisa/atkHigh_Blade0003.png",
   L"data/actor/marisa/atkHigh_Blade0004.png",
   L"data/actor/marisa/atkMid_Blade0000.png",
   L"data/actor/marisa/atkMid_Blade0001.png",
   L"data/actor/marisa/atkMid_Blade0002.png",
   L"data/actor/marisa/atkMid_Blade0003.png",
   L"data/actor/marisa/battleBeginA0000.bmp",
   L"data/actor/marisa/battleBeginA0001.bmp",
   L"data/actor/marisa/battleBeginA0002.bmp",
   L"data/actor/marisa/battleBeginA0003.bmp",
   L"data/actor/marisa/battleBeginA0004.bmp",
   L"data/actor/marisa/battleBeginA0005.bmp",
   L"data/actor/marisa/battleBeginA0006.bmp",
   L"data/actor/marisa/battleBeginA0007.bmp",
   L"data/actor/marisa/battleBeginA0008.bmp",
   L"data/actor/marisa/battleBeginA0009.bmp",
   L"data/actor/marisa/battle_begin_team0000.bmp",
   L"data/actor/marisa/battle_begin_team0001.bmp",
   L"data/actor/marisa/battle_begin_team0002.bmp",
   L"data/actor/marisa/battle_begin_team0003.bmp",
   L"data/actor/marisa/battle_begin_teamB0000.bmp",
   L"data/actor/marisa/battle_begin_teamB0001.bmp",
   L"data/actor/marisa/battle_begin_teamB0002.bmp",
   L"data/actor/marisa/battle_begin_teamB0003.bmp",
   L"data/actor/marisa/battle_begin_teamB0004.bmp",
   L"data/actor/marisa/battle_begin_teamB0005.bmp",
   L"data/actor/marisa/battle_begin_teamB0006.bmp",
   L"data/actor/marisa/battle_begin_teamB0007.bmp",
   L"data/actor/marisa/bloom0000.bmp",
   L"data/actor/marisa/climaxAssult0000.bmp",
   L"data/actor/marisa/climaxFirst0000.bmp",
   L"data/actor/marisa/climaxFirst0001.bmp",
   L"data/actor/marisa/climaxFirst0002.bmp",
   L"data/actor/marisa/climaxFirst0003.bmp",
   L"data/actor/marisa/climaxFirst0004.bmp",
   L"data/actor/marisa/climaxFirst0005.bmp",
   L"data/actor/marisa/climaxFirst0006.bmp",
   L"data/actor/marisa/climaxFirst0007.bmp",
   L"data/actor/marisa/climaxFirst0008.bmp",
   L"data/actor/marisa/climaxFirst0009.bmp",
   L"data/actor/marisa/climaxFirst0010.bmp",
   L"data/actor/marisa/climaxFirst0011.bmp",
   L"data/actor/marisa/climax_Arm0000.png",
   L"data/actor/marisa/climax_Arm0001.png",
   L"data/actor/marisa/climax_BackBase.png",
   L"data/actor/marisa/climax_BackDoor0000.png",
   L"data/actor/marisa/climax_BackDoor0001.png",
   L"data/actor/marisa/climax_CutFace.png",
   L"data/actor/marisa/climax_lineObject.png",
   L"data/actor/marisa/damageBody0000.bmp",
   L"data/actor/marisa/damageBody0001.bmp",
   L"data/actor/marisa/damageBody0002.bmp",
   L"data/actor/marisa/damageBody0003.bmp",
   L"data/actor/marisa/damageBody0004.bmp",
   L"data/actor/marisa/damageDownB0000.bmp",
   L"data/actor/marisa/damageDownB0001.bmp",
   L"data/actor/marisa/damageDownB0002.bmp",
   L"data/actor/marisa/damageDownB0003.bmp",
   L"data/actor/marisa/damageDownB0004.bmp",
   L"data/actor/marisa/damageDownB0005.bmp",
   L"data/actor/marisa/damageDownB0006.bmp",
   L"data/actor/marisa/damageDownB0007.bmp",
   L"data/actor/marisa/damageDownB0008.bmp",
   L"data/actor/marisa/damageDownB0009.bmp",
   L"data/actor/marisa/damageDownB0010.bmp",
   L"data/actor/marisa/damageDownB0011.bmp",
   L"data/actor/marisa/damageDownB0012.bmp",
   L"data/actor/marisa/damageDownB0013.bmp",
   L"data/actor/marisa/damageDownB0014.bmp",
   L"data/actor/marisa/damageDownB0015.bmp",
   L"data/actor/marisa/damageDownB0016.bmp",
   L"data/actor/marisa/damageDownB0017.bmp",
   L"data/actor/marisa/damageDownB0018.bmp",
   L"data/actor/marisa/damageHead0001.bmp",
   L"data/actor/marisa/damageHead0002.bmp",
   L"data/actor/marisa/damageHead0003.bmp",
   L"data/actor/marisa/damageHead0004.bmp",
   L"data/actor/marisa/damageHead0005.bmp",
   L"data/actor/marisa/damageSpin0000.bmp",
   L"data/actor/marisa/damageSpin0001.bmp",
   L"data/actor/marisa/damageSpin0002.bmp",
   L"data/actor/marisa/damageSpin0003.bmp",
   L"data/actor/marisa/damageWall0001.bmp",
   L"data/actor/marisa/damageWall0002.bmp",
   L"data/actor/marisa/damageWall0003.bmp",
   L"data/actor/marisa/damageWall0004.bmp",
   L"data/actor/marisa/damageWall0005.bmp",
   L"data/actor/marisa/dummy.bmp",
   L"data/actor/marisa/effect_atkDashHigh0000.png",
   L"data/actor/marisa/effect_atkDashHigh0001.png",
   L"data/actor/marisa/effect_atkDashHigh0002.png",
   L"data/actor/marisa/effect_atkDashHigh0003.png",
   L"data/actor/marisa/effect_atkHighUnder0000.png",
   L"data/actor/marisa/effect_atkHighUnder0001.png",
   L"data/actor/marisa/effect_atkHighUnder0002.png",
   L"data/actor/marisa/effect_atkHighUnder0003.png",
   L"data/actor/marisa/effect_atkHighUpper0000.png",
   L"data/actor/marisa/effect_atkHighUpper0001.png",
   L"data/actor/marisa/effect_atkHighUpper0002.png",
   L"data/actor/marisa/effect_climax0000.png",
   L"data/actor/marisa/effect_climax0001.png",
   L"data/actor/marisa/effect_climax0002.png",
   L"data/actor/marisa/effect_climaxB0000.png",
   L"data/actor/marisa/effect_shotHigh0000.png",
   L"data/actor/marisa/effect_shotHigh0001.png",
   L"data/actor/marisa/effect_shotHigh0002.png",
   L"data/actor/marisa/effect_shotHigh0003.png",
   L"data/actor/marisa/effect_shotHigh0004.png",
   L"data/actor/marisa/effect_shotHigh0005.png",
   L"data/actor/marisa/effect_shotHighB0000.bmp",
   L"data/actor/marisa/effect_shotHighB0001.bmp",
   L"data/actor/marisa/effect_shotHighB0002.bmp",
   L"data/actor/marisa/effect_shotHighB0003.bmp",
   L"data/actor/marisa/effect_shotHighB0004.bmp",
   L"data/actor/marisa/effect_shotHighB0005.bmp",
   L"data/actor/marisa/effect_skillA0000.bmp",
   L"data/actor/marisa/effect_skillA0001.bmp",
   L"data/actor/marisa/effect_skillA0002.bmp",
   L"data/actor/marisa/effect_skillD0000.bmp",
   L"data/actor/marisa/effect_skillD0001.bmp",
   L"data/actor/marisa/effect_skillD0002.bmp",
   L"data/actor/marisa/effect_skillD0003.bmp",
   L"data/actor/marisa/effect_skillD0004.bmp",
   L"data/actor/marisa/effect_skillD0005.bmp",
   L"data/actor/marisa/effect_skillD0006.bmp",
   L"data/actor/marisa/effect_skillDb0000.png",
   L"data/actor/marisa/effect_skillDb0001.png",
   L"data/actor/marisa/effect_skillDb0002.png",
   L"data/actor/marisa/effect_skillDb0003.png",
   L"data/actor/marisa/effect_skillDb0004.png",
   L"data/actor/marisa/effect_skillDb0005.png",
   L"data/actor/marisa/effect_skillE0000.png",
   L"data/actor/marisa/effect_skillE0001.png",
   L"data/actor/marisa/effect_skillE0002.png",
   L"data/actor/marisa/effect_skillE0003.png",
   L"data/actor/marisa/effect_spellB.png",
   L"data/actor/marisa/face_spellCall.png",
   L"data/actor/marisa/grab0000.bmp",
   L"data/actor/marisa/grab0001.bmp",
   L"data/actor/marisa/grab0002.bmp",
   L"data/actor/marisa/grab0003.bmp",
   L"data/actor/marisa/grab0004.bmp",
   L"data/actor/marisa/grab0005.bmp",
   L"data/actor/marisa/guard0000.bmp",
   L"data/actor/marisa/guard0001.bmp",
   L"data/actor/marisa/guard0002.bmp",
   L"data/actor/marisa/guard0003.bmp",
   L"data/actor/marisa/guard0004.bmp",
   L"data/actor/marisa/guard_miss0000.bmp",
   L"data/actor/marisa/guard_miss0001.bmp",
   L"data/actor/marisa/guard_miss0002.bmp",
   L"data/actor/marisa/guard_miss0003.bmp",
   L"data/actor/marisa/item0000.bmp",
   L"data/actor/marisa/item0001.bmp",
   L"data/actor/marisa/item0002.bmp",
   L"data/actor/marisa/item0003.bmp",
   L"data/actor/marisa/item0004.bmp",
   L"data/actor/marisa/item0005.bmp",
   L"data/actor/marisa/item0006.bmp",
   L"data/actor/marisa/item0007.bmp",
   L"data/actor/marisa/lose0000.bmp",
   L"data/actor/marisa/lose0001.bmp",
   L"data/actor/marisa/lose0002.bmp",
   L"data/actor/marisa/lose0003.bmp",
   L"data/actor/marisa/lose0004.bmp",
   L"data/actor/marisa/lose0005.bmp",
   L"data/actor/marisa/lose0006.bmp",
   L"data/actor/marisa/lose0007.bmp",
   L"data/actor/marisa/lose0008.bmp",
   L"data/actor/marisa/lose0009.bmp",
   L"data/actor/marisa/lose0010.bmp",
   L"data/actor/marisa/lose0011.bmp",
   L"data/actor/marisa/lose0012.bmp",
   L"data/actor/marisa/marisa.pat",
   L"data/actor/marisa/marisa_ed.pat",
   L"data/actor/marisa/occult_dolla0000.bmp",
   L"data/actor/marisa/occult_dollb0011.bmp",
   L"data/actor/marisa/occult_dollb0012.bmp",
   L"data/actor/marisa/occult_dollb0013.bmp",
   L"data/actor/marisa/occult_dollb0014.bmp",
   L"data/actor/marisa/occult_dollb0015.bmp",
   L"data/actor/marisa/occult_dollb0016.bmp",
   L"data/actor/marisa/occult_dollb0017.bmp",
   L"data/actor/marisa/occult_dollb0018.bmp",
   L"data/actor/marisa/occult_dr0000.png",
   L"data/actor/marisa/occult_dr0001.png",
   L"data/actor/marisa/occult_dr0002.png",
   L"data/actor/marisa/occult_dr0003.png",
   L"data/actor/marisa/occult_dr0004.png",
   L"data/actor/marisa/occult_dr0005.png",
   L"data/actor/marisa/palette000.bmp",
   L"data/actor/marisa/palette001.bmp",
   L"data/actor/marisa/palette002.bmp",
   L"data/actor/marisa/palette003.bmp",
   L"data/actor/marisa/palette004.bmp",
   L"data/actor/marisa/palette005.bmp",
   L"data/actor/marisa/palette006.bmp",
   L"data/actor/marisa/palette007.bmp",
   L"data/actor/marisa/palette100.bmp",
   L"data/actor/marisa/palette101.bmp",
   L"data/actor/marisa/palette102.bmp",
   L"data/actor/marisa/palette103.bmp",
   L"data/actor/marisa/palette104.bmp",
   L"data/actor/marisa/palette105.bmp",
   L"data/actor/marisa/palette106.bmp",
   L"data/actor/marisa/palette107.bmp",
   L"data/actor/marisa/skillA_Loop0000.bmp",
   L"data/actor/marisa/skillA_Loop0001.bmp",
   L"data/actor/marisa/skillA_Loop0002.bmp",
   L"data/actor/marisa/skillE0000.bmp",
   L"data/actor/marisa/skillE0001.bmp",
   L"data/actor/marisa/skillE0002.bmp",
   L"data/actor/marisa/skillE0003.bmp",
   L"data/actor/marisa/skillE0004.bmp",
   L"data/actor/marisa/skillE0005.bmp",
   L"data/actor/marisa/skillE0006.bmp",
   L"data/actor/marisa/skillE0007.bmp",
   L"data/actor/marisa/skillE0008.bmp",
   L"data/actor/marisa/skillE0009.bmp",
   L"data/actor/marisa/skillE0010.bmp",
   L"data/actor/marisa/skillE0011.bmp",
   L"data/actor/marisa/skillE0012.bmp",
   L"data/actor/marisa/skillE0013.bmp",
   L"data/actor/marisa/skillE0014.bmp",
   L"data/actor/marisa/skillE0015.bmp",
   L"data/actor/marisa/skillE0016.bmp",
   L"data/actor/marisa/skillE_BladeA0000.png",
   L"data/actor/marisa/skillE_BladeB0000.png",
   L"data/actor/marisa/skillF0000.bmp",
   L"data/actor/marisa/skillF0001.bmp",
   L"data/actor/marisa/skillF0002.bmp",
   L"data/actor/marisa/skillF0003.bmp",
   L"data/actor/marisa/skillF0004.bmp",
   L"data/actor/marisa/skillF0005.bmp",
   L"data/actor/marisa/skillF0007.bmp",
   L"data/actor/marisa/skillF0008.bmp",
   L"data/actor/marisa/skillF0009.bmp",
   L"data/actor/marisa/skillF0010.bmp",
   L"data/actor/marisa/skillF0011.bmp",
   L"data/actor/marisa/skillF0012.bmp",
   L"data/actor/marisa/spellA0000.bmp",
   L"data/actor/marisa/spellA0001.bmp",
   L"data/actor/marisa/spellA0002.bmp",
   L"data/actor/marisa/spellA0003.bmp",
   L"data/actor/marisa/spellA0004.bmp",
   L"data/actor/marisa/spellA0005.bmp",
   L"data/actor/marisa/spellA0006.bmp",
   L"data/actor/marisa/spellA0007.bmp",
   L"data/actor/marisa/spellA0008.bmp",
   L"data/actor/marisa/spellA0009.bmp",
   L"data/actor/marisa/spellA0010.bmp",
   L"data/actor/marisa/spellA0011.bmp",
   L"data/actor/marisa/spellA0012.bmp",
   L"data/actor/marisa/spellA0013.bmp",
   L"data/actor/marisa/spellA0014.bmp",
   L"data/actor/marisa/spellA0015.bmp",
   L"data/actor/marisa/spellB0000.bmp",
   L"data/actor/marisa/stand0000.bmp",
   L"data/actor/marisa/stand0001.bmp",
   L"data/actor/marisa/stand0002.bmp",
   L"data/actor/marisa/stand0003.bmp",
   L"data/actor/marisa/stand0004.bmp",
   L"data/actor/marisa/stand0005.bmp",
   L"data/actor/marisa/stand0006.bmp",
   L"data/actor/marisa/stand0007.bmp",
   L"data/actor/marisa/stand0008.bmp",
   L"data/actor/marisa/stand0009.bmp",
   L"data/actor/marisa/stand0010.bmp",
   L"data/actor/marisa/stand0011.bmp",
   L"data/actor/marisa/stand0012.bmp",
   L"data/actor/marisa/stand0013.bmp",
   L"data/actor/marisa/stand0014.bmp",
   L"data/actor/marisa/stun0000.bmp",
   L"data/actor/marisa/stun0001.bmp",
   L"data/actor/marisa/stun0002.bmp",
   L"data/actor/marisa/stun0003.bmp",
   L"data/actor/marisa/stun0004.bmp",
   L"data/actor/marisa/stun0005.bmp",
   L"data/actor/marisa/test_atkHighDash0000.bmp",
   L"data/actor/marisa/test_atkHighDash0001.bmp",
   L"data/actor/marisa/test_atkHighDash0002.bmp",
   L"data/actor/marisa/test_atkHighDash0003.bmp",
   L"data/actor/marisa/test_atkHighDash0004.bmp",
   L"data/actor/marisa/test_atkHighDash0005.bmp",
   L"data/actor/marisa/test_atkHighDash0006.bmp",
   L"data/actor/marisa/test_atkHighDash0007.bmp",
   L"data/actor/marisa/test_atkHighDash0008.bmp",
   L"data/actor/marisa/test_atkHighDash0009.bmp",
   L"data/actor/marisa/test_atkHighDash0010.bmp",
   L"data/actor/marisa/test_atkHighDash0011.bmp",
   L"data/actor/marisa/test_atkHighDash0012.bmp",
   L"data/actor/marisa/test_atkHighDash0013.bmp",
   L"data/actor/marisa/test_atkHighUnder0000.bmp",
   L"data/actor/marisa/test_atkHighUnder0001.bmp",
   L"data/actor/marisa/test_atkHighUnder0002.bmp",
   L"data/actor/marisa/test_atkHighUnder0003.bmp",
   L"data/actor/marisa/test_atkHighUnder0004.bmp",
   L"data/actor/marisa/test_atkHighUnder0005.bmp",
   L"data/actor/marisa/test_atkHighUnder0006.bmp",
   L"data/actor/marisa/test_atkHighUnder0007.bmp",
   L"data/actor/marisa/test_atkHighUnder0008.bmp",
   L"data/actor/marisa/test_atkHighUnder0009.bmp",
   L"data/actor/marisa/test_atkHighUnder0010.bmp",
   L"data/actor/marisa/test_atkHighUpper0000.bmp",
   L"data/actor/marisa/test_atkHighUpper0001.bmp",
   L"data/actor/marisa/test_atkHighUpper0002.bmp",
   L"data/actor/marisa/test_atkHighUpper0003.bmp",
   L"data/actor/marisa/test_atkHighUpper0004.bmp",
   L"data/actor/marisa/test_atkHighUpper0005.bmp",
   L"data/actor/marisa/test_atkHighUpper0006.bmp",
   L"data/actor/marisa/test_atkHighUpper0007.bmp",
   L"data/actor/marisa/test_atkHighUpper0008.bmp",
   L"data/actor/marisa/test_atkHighUpper0009.bmp",
   L"data/actor/marisa/test_atkHighUpper0010.bmp",
   L"data/actor/marisa/test_atkLowA0000.bmp",
   L"data/actor/marisa/test_atkLowA0001.bmp",
   L"data/actor/marisa/test_atkLowA0002.bmp",
   L"data/actor/marisa/test_atkLowA0003.bmp",
   L"data/actor/marisa/test_atkLowA0004.bmp",
   L"data/actor/marisa/test_atkLowA0005.bmp",
   L"data/actor/marisa/test_atkLowA0006.bmp",
   L"data/actor/marisa/test_atkLowA0007.bmp",
   L"data/actor/marisa/test_atkMid0000.bmp",
   L"data/actor/marisa/test_atkMid0001.bmp",
   L"data/actor/marisa/test_atkMid0002.bmp",
   L"data/actor/marisa/test_atkMid0003.bmp",
   L"data/actor/marisa/test_atkMid0004.bmp",
   L"data/actor/marisa/test_atkMid0005.bmp",
   L"data/actor/marisa/test_atkMid0006.bmp",
   L"data/actor/marisa/test_atkMid0007.bmp",
   L"data/actor/marisa/test_atkMid0008.bmp",
   L"data/actor/marisa/test_atkMid0009.bmp",
   L"data/actor/marisa/test_atkMid0010.bmp",
   L"data/actor/marisa/test_battleBeginB0000.bmp",
   L"data/actor/marisa/test_battleBeginB0001.bmp",
   L"data/actor/marisa/test_battleBeginB0002.bmp",
   L"data/actor/marisa/test_battleBeginB0003.bmp",
   L"data/actor/marisa/test_battleBeginB0004.bmp",
   L"data/actor/marisa/test_battleBeginB0005.bmp",
   L"data/actor/marisa/test_battleBeginB0006.bmp",
   L"data/actor/marisa/test_battleBeginB0007.bmp",
   L"data/actor/marisa/test_battleBeginB0008.bmp",
   L"data/actor/marisa/test_battleBeginB0009.bmp",
   L"data/actor/marisa/test_dashBack0000.bmp",
   L"data/actor/marisa/test_dashBack0001.bmp",
   L"data/actor/marisa/test_dashBack0002.bmp",
   L"data/actor/marisa/test_dashBack0003.bmp",
   L"data/actor/marisa/test_dashBack0004.bmp",
   L"data/actor/marisa/test_dashBack0005.bmp",
   L"data/actor/marisa/test_dashBack0006.bmp",
   L"data/actor/marisa/test_dashBack0007.bmp",
   L"data/actor/marisa/test_dashBack0008.bmp",
   L"data/actor/marisa/test_dashBack0009.bmp",
   L"data/actor/marisa/test_dashBack0010.bmp",
   L"data/actor/marisa/test_dashBack0011.bmp",
   L"data/actor/marisa/test_dashBack0012.bmp",
   L"data/actor/marisa/test_dashFront0000.bmp",
   L"data/actor/marisa/test_dashFront0001.bmp",
   L"data/actor/marisa/test_dashFront0002.bmp",
   L"data/actor/marisa/test_dashFront0004.bmp",
   L"data/actor/marisa/test_dashFront0005.bmp",
   L"data/actor/marisa/test_dashFront0006.bmp",
   L"data/actor/marisa/test_dashFront0007.bmp",
   L"data/actor/marisa/test_dashFront0008.bmp",
   L"data/actor/marisa/test_dashFront0009.bmp",
   L"data/actor/marisa/test_dashFront0010.bmp",
   L"data/actor/marisa/test_dashFront0011.bmp",
   L"data/actor/marisa/test_dashFront0012.bmp",
   L"data/actor/marisa/test_dashFront0013.bmp",
   L"data/actor/marisa/test_effect.bmp",
   L"data/actor/marisa/test_guardCrash0000.bmp",
   L"data/actor/marisa/test_guardCrash0001.bmp",
   L"data/actor/marisa/test_guardCrash0002.bmp",
   L"data/actor/marisa/test_guardCrash0003.bmp",
   L"data/actor/marisa/test_guardCrash0004.bmp",
   L"data/actor/marisa/test_guardCrash0005.bmp",
   L"data/actor/marisa/test_guardCrash0006.bmp",
   L"data/actor/marisa/test_guardCrash0007.bmp",
   L"data/actor/marisa/test_move20000.bmp",
   L"data/actor/marisa/test_move20001.bmp",
   L"data/actor/marisa/test_move20002.bmp",
   L"data/actor/marisa/test_move20003.bmp",
   L"data/actor/marisa/test_move20004.bmp",
   L"data/actor/marisa/test_move20005.bmp",
   L"data/actor/marisa/test_move20006.bmp",
   L"data/actor/marisa/test_move20007.bmp",
   L"data/actor/marisa/test_move20008.bmp",
   L"data/actor/marisa/test_move20009.bmp",
   L"data/actor/marisa/test_move20010.bmp",
   L"data/actor/marisa/test_move20011.bmp",
   L"data/actor/marisa/test_move20012.bmp",
   L"data/actor/marisa/test_move20013.bmp",
   L"data/actor/marisa/test_move20014.bmp",
   L"data/actor/marisa/test_move20015.bmp",
   L"data/actor/marisa/test_move20016.bmp",
   L"data/actor/marisa/test_move20017.bmp",
   L"data/actor/marisa/test_shotHigh0000.bmp",
   L"data/actor/marisa/test_shotHigh0001.bmp",
   L"data/actor/marisa/test_shotHigh0002.bmp",
   L"data/actor/marisa/test_shotHigh0003.bmp",
   L"data/actor/marisa/test_shotHigh0004.bmp",
   L"data/actor/marisa/test_shotHigh0005.bmp",
   L"data/actor/marisa/test_shotHigh0006.bmp",
   L"data/actor/marisa/test_shotHigh0007.bmp",
   L"data/actor/marisa/test_shotHigh0008.bmp",
   L"data/actor/marisa/test_shotHigh0009.bmp",
   L"data/actor/marisa/test_shotHigh0010.bmp",
   L"data/actor/marisa/test_shotHigh0011.bmp",
   L"data/actor/marisa/test_shotHigh0012.bmp",
   L"data/actor/marisa/test_shotLow0000.bmp",
   L"data/actor/marisa/test_shotLow0001.bmp",
   L"data/actor/marisa/test_shotLow0002.bmp",
   L"data/actor/marisa/test_shotLow0007.bmp",
   L"data/actor/marisa/test_shotLow0008.bmp",
   L"data/actor/marisa/test_shotLow0009.bmp",
   L"data/actor/marisa/test_shotLow0010.bmp",
   L"data/actor/marisa/test_skillA0004.bmp",
   L"data/actor/marisa/test_skillB0000.bmp",
   L"data/actor/marisa/test_skillB0001.bmp",
   L"data/actor/marisa/test_skillB0002.bmp",
   L"data/actor/marisa/test_skillB0003.bmp",
   L"data/actor/marisa/test_skillB0004.bmp",
   L"data/actor/marisa/test_skillB0005.bmp",
   L"data/actor/marisa/test_skillB0006.bmp",
   L"data/actor/marisa/test_skillB0007.bmp",
   L"data/actor/marisa/test_skillC0000.bmp",
   L"data/actor/marisa/test_skillC0001.bmp",
   L"data/actor/marisa/test_skillC0002.bmp",
   L"data/actor/marisa/test_skillC0003.bmp",
   L"data/actor/marisa/test_skillC0004.bmp",
   L"data/actor/marisa/test_skillC0005.bmp",
   L"data/actor/marisa/test_skillC0006.bmp",
   L"data/actor/marisa/test_skillC0007.bmp",
   L"data/actor/marisa/test_skillC0008.bmp",
   L"data/actor/marisa/test_skillD0000.bmp",
   L"data/actor/marisa/test_skillD0001.bmp",
   L"data/actor/marisa/test_skillD0002.bmp",
   L"data/actor/marisa/test_skillD0003.bmp",
   L"data/actor/marisa/test_skillD0004.bmp",
   L"data/actor/marisa/test_skillD0005.bmp",
   L"data/actor/marisa/test_skillD0006.bmp",
   L"data/actor/marisa/test_skillD0007.bmp",
   L"data/actor/marisa/test_skillD0008.bmp",
   L"data/actor/marisa/test_skillD0009.bmp",
   L"data/actor/marisa/test_skillD0010.bmp",
   L"data/actor/marisa/test_skillD0011.bmp",
   L"data/actor/marisa/test_skillE0006.bmp",
   L"data/actor/marisa/test_skillE_Loop0000.bmp",
   L"data/actor/marisa/test_skillE_Loop0001.bmp",
   L"data/actor/marisa/test_spellB0000.bmp",
   L"data/actor/marisa/test_spellB0001.bmp",
   L"data/actor/marisa/test_spellB0002.bmp",
   L"data/actor/marisa/test_spellB0003.bmp",
   L"data/actor/marisa/test_spellB0004.bmp",
   L"data/actor/marisa/test_spellB0005.bmp",
   L"data/actor/marisa/test_spellB0006.bmp",
   L"data/actor/marisa/test_spellB0007.bmp",
   L"data/actor/marisa/test_spellBb0000.bmp",
   L"data/actor/marisa/test_spellBb0001.bmp",
   L"data/actor/marisa/test_spellBb0002.bmp",
   L"data/actor/marisa/test_spellBb0003.bmp",
   L"data/actor/marisa/test_spellBb0004.bmp",
   L"data/actor/marisa/test_spellBb0005.bmp",
   L"data/actor/marisa/test_spellBb0006.bmp",
   L"data/actor/marisa/test_spellBb0007.bmp",
   L"data/actor/marisa/test_walkBack0000.bmp",
   L"data/actor/marisa/test_walkBack0001.bmp",
   L"data/actor/marisa/test_walkBack0002.bmp",
   L"data/actor/marisa/test_walkBack0003.bmp",
   L"data/actor/marisa/test_walkBack0004.bmp",
   L"data/actor/marisa/test_walkBack0005.bmp",
   L"data/actor/marisa/test_walkBack0006.bmp",
   L"data/actor/marisa/test_walkBack0007.bmp",
   L"data/actor/marisa/test_walkBack0008.bmp",
   L"data/actor/marisa/test_walkBack0010.bmp",
   L"data/actor/marisa/test_walkBack0011.bmp",
   L"data/actor/marisa/test_walkBack0012.bmp",
   L"data/actor/marisa/test_walkBack0013.bmp",
   L"data/actor/marisa/test_walkFront0000.bmp",
   L"data/actor/marisa/test_walkFront0001.bmp",
   L"data/actor/marisa/test_walkFront0002.bmp",
   L"data/actor/marisa/test_walkFront0003.bmp",
   L"data/actor/marisa/test_walkFront0004.bmp",
   L"data/actor/marisa/test_walkFront0010.bmp",
   L"data/actor/marisa/test_walkFront0011.bmp",
   L"data/actor/marisa/test_walkFront0012.bmp",
   L"data/actor/marisa/test_walkFront0013.bmp",
   L"data/actor/marisa/test_walkFront0014.bmp",
   L"data/actor/marisa/test_walkFront0015.bmp",
   L"data/actor/marisa/test_walkFront0016.bmp",
   L"data/actor/marisa/texture/bitOrb_base0000.png",
   L"data/actor/marisa/texture/blueFire000.png",
   L"data/actor/marisa/texture/bullet_exp.png",
   L"data/actor/marisa/texture/face_master_marisa.png",
   L"data/actor/marisa/texture/face_master_marisa2.png",
   L"data/actor/marisa/texture/face_slave_marisa.png",
   L"data/actor/marisa/texture/face_spell_cut_0001.png",
   L"data/actor/marisa/texture/guardFlash.png",
   L"data/actor/marisa/texture/lightPilar.png",
   L"data/actor/marisa/texture/magicBottle000.png",
   L"data/actor/marisa/texture/marisa_animalDamage000.png",
   L"data/actor/marisa/texture/marisa_animalDamage001.png",
   L"data/actor/marisa/texture/marisa_animalDamage002.png",
   L"data/actor/marisa/texture/marisa_animalDamage003.png",
   L"data/actor/marisa/texture/marisa_animal_00000.png",
   L"data/actor/marisa/texture/marisa_animal_00001.png",
   L"data/actor/marisa/texture/marisa_animal_00002.png",
   L"data/actor/marisa/texture/marisa_animal_00003.png",
   L"data/actor/marisa/texture/marisa_animal_00004.png",
   L"data/actor/marisa/texture/marisa_animal_00005.png",
   L"data/actor/marisa/texture/marisa_animal_00006.png",
   L"data/actor/marisa/texture/marisa_animal_00007.png",
   L"data/actor/marisa/texture/marisa_animal_00008.png",
   L"data/actor/marisa/texture/marisa_animal_00009.png",
   L"data/actor/marisa/texture/marisa_animal_00010.png",
   L"data/actor/marisa/texture/marisa_animal_00011.png",
   L"data/actor/marisa/texture/marisa_atkA.png",
   L"data/actor/marisa/texture/marisa_laylineA.png",
   L"data/actor/marisa/texture/marisa_magicM.png",
   L"data/actor/marisa/texture/marisa_masterSpark0000.png",
   L"data/actor/marisa/texture/marisa_shotExp.png",
   L"data/actor/marisa/texture/marisa_starA.png",
   L"data/actor/marisa/texture/occultObject.png",
   L"data/actor/marisa/texture/occultPhotol0000.png",
   L"data/actor/marisa/texture/occultPiano0000.png",
   L"data/actor/marisa/texture/occultPiano0001.png",
   L"data/actor/marisa/texture/occultPiano0002.png",
   L"data/actor/marisa/texture/occult_ninomiya0000.png",
   L"data/actor/marisa/texture/occult_ninomiya0001.png",
   L"data/actor/marisa/texture/occult_ninomiya0002.png",
   L"data/actor/marisa/texture/pilarA0000.bmp",
   L"data/actor/marisa/texture/shotcharge_tail0000.png",
   L"data/actor/marisa/texture/shotStarFallA0000.png",
   L"data/actor/marisa/texture/shot_laserA0000.png",
   L"data/actor/marisa/texture/shot_laserHeadA0000.png",
   L"data/actor/marisa/texture/skillG_Trail.png",
   L"data/actor/marisa/texture/spellCharge.png",
   L"data/actor/marisa/texture/spell_use_cut.png",
   L"data/actor/marisa/texture/test_occultBall0000.png",
   L"data/actor/marisa/texture/win_marisa.png",
   L"data/actor/marisa/turn0000.bmp",
   L"data/actor/marisa/turn0001.bmp",
   L"data/actor/marisa/turn0002.bmp",
   L"data/actor/marisa/walkFrontLoop0000.bmp",
   L"data/actor/marisa/walkFrontLoop0001.bmp",
   L"data/actor/marisa/walkFrontLoop0002.bmp",
   L"data/actor/marisa/walkFrontLoop0003.bmp",
   L"data/actor/marisa/walkFrontLoop0004.bmp",
   L"data/actor/marisa/winA0000.bmp",
   L"data/actor/marisa/winA0001.bmp",
   L"data/actor/marisa/winA0002.bmp",
   L"data/actor/marisa/winA0003.bmp",
   L"data/actor/marisa/winA0004.bmp",
   L"data/actor/marisa/winA0005.bmp",
   L"data/actor/marisa/winA0006.bmp",
   L"data/actor/marisa/winA0007.bmp",
   L"data/actor/marisa/winA0008.bmp",
   L"data/actor/marisa/winA0009.bmp",
   L"data/actor/marisa/winA0010.bmp",
   L"data/actor/marisa/winA0011.bmp",
   L"data/actor/marisa/winA0012.bmp",
   L"data/actor/marisa/winB0000.bmp",
   L"data/actor/marisa/winB0001.bmp",
   L"data/actor/marisa/winB0002.bmp",
   L"data/actor/marisa/winB0003.bmp",
   L"data/actor/marisa/winB0004.bmp",
   L"data/actor/marisa/winB0005.bmp",
   L"data/actor/marisa/winB0006.bmp",
   L"data/actor/marisa/winB0007.bmp",
   L"data/actor/marisa/winB0008.bmp",
   L"data/actor/marisa/winB0009.bmp",
   L"data/actor/marisa/winB0010.bmp",
   L"data/actor/marisa.nut",
   L"data/actor/marisa_base.nut",
   L"data/actor/marisa_boss.nut",
   L"data/actor/marisa_boss_base.nut",
   L"data/actor/marisa_boss_init.nut",
   L"data/actor/marisa_boss_shot.nut",
   L"data/actor/marisa_com.nut",
   L"data/actor/marisa_combo.nut",
   L"data/actor/marisa_com_function.nut",
   L"data/actor/marisa_init.nut",
   L"data/actor/marisa_practice_init.nut",
   L"data/actor/marisa_shot.nut",
   L"data/actor/marisa_team.nut",
   L"data/actor/miko/atkHigh0000.bmp",
   L"data/actor/miko/atkHigh0001.bmp",
   L"data/actor/miko/atkHigh0002.bmp",
   L"data/actor/miko/atkHigh0003.bmp",
   L"data/actor/miko/atkHigh0004.bmp",
   L"data/actor/miko/atkHigh0005.bmp",
   L"data/actor/miko/atkHigh0006.bmp",
   L"data/actor/miko/atkHigh0007.bmp",
   L"data/actor/miko/atkHigh0008.bmp",
   L"data/actor/miko/atkHigh0009.bmp",
   L"data/actor/miko/atkHigh0010.bmp",
   L"data/actor/miko/atkHighDash0000.bmp",
   L"data/actor/miko/atkHighDash0001.bmp",
   L"data/actor/miko/atkHighDash0002.bmp",
   L"data/actor/miko/atkHighDash0003.bmp",
   L"data/actor/miko/atkHighDash0004.bmp",
   L"data/actor/miko/atkHighDash0005.bmp",
   L"data/actor/miko/atkHighDash0006.bmp",
   L"data/actor/miko/atkHighDash0007.bmp",
   L"data/actor/miko/atkHighDash0008.bmp",
   L"data/actor/miko/atkHighDash0009.bmp",
   L"data/actor/miko/atkHighDash0010.bmp",
   L"data/actor/miko/atkHighDash0011.bmp",
   L"data/actor/miko/atkHighDash0012.bmp",
   L"data/actor/miko/atkHighDash0013.bmp",
   L"data/actor/miko/atkHighDash0014.bmp",
   L"data/actor/miko/atkHighDash0015.bmp",
   L"data/actor/miko/atkHighDash0016.bmp",
   L"data/actor/miko/atkHighDash0017.bmp",
   L"data/actor/miko/atkHighDash0018.bmp",
   L"data/actor/miko/atkHighDash0019.bmp",
   L"data/actor/miko/atkHighDash0020.bmp",
   L"data/actor/miko/atkHighFront0000.bmp",
   L"data/actor/miko/atkHighFront0001.bmp",
   L"data/actor/miko/atkHighFront0002.bmp",
   L"data/actor/miko/atkHighFront0003.bmp",
   L"data/actor/miko/atkHighFront0004.bmp",
   L"data/actor/miko/atkHighFront0005.bmp",
   L"data/actor/miko/atkHighFront0006.bmp",
   L"data/actor/miko/atkHighFront0007.bmp",
   L"data/actor/miko/atkHighFront0008.bmp",
   L"data/actor/miko/atkHighFront0009.bmp",
   L"data/actor/miko/atkHighFront0010.bmp",
   L"data/actor/miko/atkHighFront0011.bmp",
   L"data/actor/miko/atkHighFront0012.bmp",
   L"data/actor/miko/atkHighFront0013.bmp",
   L"data/actor/miko/atkHighUnder0000.bmp",
   L"data/actor/miko/atkHighUnder0001.bmp",
   L"data/actor/miko/atkHighUnder0002.bmp",
   L"data/actor/miko/atkHighUnder0003.bmp",
   L"data/actor/miko/atkHighUnder0004.bmp",
   L"data/actor/miko/atkHighUnder0005.bmp",
   L"data/actor/miko/atkHighUnder0006.bmp",
   L"data/actor/miko/atkHighUnder0007.bmp",
   L"data/actor/miko/atkHighUnder0008.bmp",
   L"data/actor/miko/atkHighUnder0009.bmp",
   L"data/actor/miko/atkHighUpper0000.bmp",
   L"data/actor/miko/atkHighUpper0001.bmp",
   L"data/actor/miko/atkHighUpper0002.bmp",
   L"data/actor/miko/atkHighUpper0003.bmp",
   L"data/actor/miko/atkHighUpper0004.bmp",
   L"data/actor/miko/atkHighUpper0005.bmp",
   L"data/actor/miko/atkHighUpper0006.bmp",
   L"data/actor/miko/atkHighUpper0007.bmp",
   L"data/actor/miko/atkHighUpper0008.bmp",
   L"data/actor/miko/atkHighUpper0009.bmp",
   L"data/actor/miko/atkHighUpper0010.bmp",
   L"data/actor/miko/atkHighUpper0011.bmp",
   L"data/actor/miko/atkHighUpper0012.bmp",
   L"data/actor/miko/atkLow0000.bmp",
   L"data/actor/miko/atkLow0001.bmp",
   L"data/actor/miko/atkLow0002.bmp",
   L"data/actor/miko/atkLow0003.bmp",
   L"data/actor/miko/atkLow0004.bmp",
   L"data/actor/miko/atkLow0005.bmp",
   L"data/actor/miko/atkLow0006.bmp",
   L"data/actor/miko/atkLow0007.bmp",
   L"data/actor/miko/atkLowDash0000.bmp",
   L"data/actor/miko/atkLowDash0001.bmp",
   L"data/actor/miko/atkLowDash0002.bmp",
   L"data/actor/miko/atkLowDash0003.bmp",
   L"data/actor/miko/atkLowDash0004.bmp",
   L"data/actor/miko/atkLowDash0005.bmp",
   L"data/actor/miko/atkLowDash0006.bmp",
   L"data/actor/miko/atkLowDash0007.bmp",
   L"data/actor/miko/atkLowDash0008.bmp",
   L"data/actor/miko/atkLowDash0009.bmp",
   L"data/actor/miko/atkLowDash0010.bmp",
   L"data/actor/miko/atkMid0000.bmp",
   L"data/actor/miko/atkMid0001.bmp",
   L"data/actor/miko/atkMid0002.bmp",
   L"data/actor/miko/atkMid0003.bmp",
   L"data/actor/miko/atkMid0004.bmp",
   L"data/actor/miko/atkMid0005.bmp",
   L"data/actor/miko/atkMid0006.bmp",
   L"data/actor/miko/atkMid0007.bmp",
   L"data/actor/miko/atkMid0008.bmp",
   L"data/actor/miko/atkMid0009.bmp",
   L"data/actor/miko/atkMid0010.bmp",
   L"data/actor/miko/atkMid0011.bmp",
   L"data/actor/miko/atkMid0012.bmp",
   L"data/actor/miko/atkMid0013.bmp",
   L"data/actor/miko/atkMid0014.bmp",
   L"data/actor/miko/battleBeginA0000.bmp",
   L"data/actor/miko/battleBeginA0001.bmp",
   L"data/actor/miko/battleBeginA0002.bmp",
   L"data/actor/miko/battleBeginA0003.bmp",
   L"data/actor/miko/battleBeginA0004.bmp",
   L"data/actor/miko/battleBeginA0005.bmp",
   L"data/actor/miko/battleBeginA0006.bmp",
   L"data/actor/miko/battleBeginALoop0000.bmp",
   L"data/actor/miko/battleBeginALoop0001.bmp",
   L"data/actor/miko/battleBeginALoop0002.bmp",
   L"data/actor/miko/battleBeginALoop0003.bmp",
   L"data/actor/miko/battleBeginALoop0004.bmp",
   L"data/actor/miko/battleBeginB0000.bmp",
   L"data/actor/miko/battleBeginB0001.bmp",
   L"data/actor/miko/battleBeginB0002.bmp",
   L"data/actor/miko/battleBeginB0003.bmp",
   L"data/actor/miko/battleBeginB0004.bmp",
   L"data/actor/miko/battleBeginB0005.bmp",
   L"data/actor/miko/battleBeginB0006.bmp",
   L"data/actor/miko/battleBeginB0007.bmp",
   L"data/actor/miko/battleBeginB0008.bmp",
   L"data/actor/miko/bmsln/miko_bariaT.bmb",
   L"data/actor/miko/bmsln/miko_chargeFire.bmb",
   L"data/actor/miko/bmsln/miko_climaxFall.bmb",
   L"data/actor/miko/bmsln/miko_clow.bmb",
   L"data/actor/miko/bmsln/miko_dragonFire.bmb",
   L"data/actor/miko/bmsln/miko_nichirin.bmb",
   L"data/actor/miko/bmsln/miko_nichirinLoop.bmb",
   L"data/actor/miko/bmsln/miko_spellC.bmb",
   L"data/actor/miko/bmsln/miko_spellCb.bmb",
   L"data/actor/miko/bmsln/miko_warp.bmb",
   L"data/actor/miko/climax0000.bmp",
   L"data/actor/miko/climax0001.bmp",
   L"data/actor/miko/climax0002.bmp",
   L"data/actor/miko/climax0003.bmp",
   L"data/actor/miko/climax0004.bmp",
   L"data/actor/miko/climax0005.bmp",
   L"data/actor/miko/climax0006.bmp",
   L"data/actor/miko/climax0007.bmp",
   L"data/actor/miko/climax0008.bmp",
   L"data/actor/miko/climax0009.bmp",
   L"data/actor/miko/climax0010.bmp",
   L"data/actor/miko/climax0011.bmp",
   L"data/actor/miko/climax0012.bmp",
   L"data/actor/miko/climax00130.bmp",
   L"data/actor/miko/climaxcut0000.png",
   L"data/actor/miko/crash0000.bmp",
   L"data/actor/miko/crash0001.bmp",
   L"data/actor/miko/crash0002.bmp",
   L"data/actor/miko/crash0003.bmp",
   L"data/actor/miko/crash0004.bmp",
   L"data/actor/miko/crash0005.bmp",
   L"data/actor/miko/damageBody0000.bmp",
   L"data/actor/miko/damageBody0001.bmp",
   L"data/actor/miko/damageBody0002.bmp",
   L"data/actor/miko/damageBody0003.bmp",
   L"data/actor/miko/damageBody0004.bmp",
   L"data/actor/miko/damageHead0000.bmp",
   L"data/actor/miko/damageHead0001.bmp",
   L"data/actor/miko/damageHead0002.bmp",
   L"data/actor/miko/damageHead0003.bmp",
   L"data/actor/miko/damageHead0004.bmp",
   L"data/actor/miko/damageWall0000.bmp",
   L"data/actor/miko/damageWall0001.bmp",
   L"data/actor/miko/damageWall0002.bmp",
   L"data/actor/miko/damageWall0003.bmp",
   L"data/actor/miko/damageWall0004.bmp",
   L"data/actor/miko/damageWall0005.bmp",
   L"data/actor/miko/damageWall0006.bmp",
   L"data/actor/miko/damageWall0007.bmp",
   L"data/actor/miko/damage_down0000.bmp",
   L"data/actor/miko/damage_down0001.bmp",
   L"data/actor/miko/damage_down0002.bmp",
   L"data/actor/miko/damage_down0003.bmp",
   L"data/actor/miko/damage_down0004.bmp",
   L"data/actor/miko/damage_spin0000.bmp",
   L"data/actor/miko/damage_spin0001.bmp",
   L"data/actor/miko/damage_spin0002.bmp",
   L"data/actor/miko/damage_spin0003.bmp",
   L"data/actor/miko/damage_Upper0000.bmp",
   L"data/actor/miko/damage_Upper0001.bmp",
   L"data/actor/miko/damage_Upper0002.bmp",
   L"data/actor/miko/damage_Upper0003.bmp",
   L"data/actor/miko/damage_Upper0004.bmp",
   L"data/actor/miko/damage_Upper0005.bmp",
   L"data/actor/miko/damage_Upper0006.bmp",
   L"data/actor/miko/damage_Upper0007.bmp",
   L"data/actor/miko/damage_UpperLoop0000.bmp",
   L"data/actor/miko/damage_UpperLoop0001.bmp",
   L"data/actor/miko/damage_UpperLoopB0000.bmp",
   L"data/actor/miko/damage_UpperLoopB0001.bmp",
   L"data/actor/miko/dashBack0000.bmp",
   L"data/actor/miko/dashBack0001.bmp",
   L"data/actor/miko/dashBack0002.bmp",
   L"data/actor/miko/dashBack0003.bmp",
   L"data/actor/miko/dashBack0004.bmp",
   L"data/actor/miko/dashBack0005.bmp",
   L"data/actor/miko/dashBackLoop0000.bmp",
   L"data/actor/miko/dashBackLoop0001.bmp",
   L"data/actor/miko/dashBackLoop0002.bmp",
   L"data/actor/miko/dashBackLoop0003.bmp",
   L"data/actor/miko/dashBackLoop0004.bmp",
   L"data/actor/miko/dashFront0000.bmp",
   L"data/actor/miko/dashFront0001.bmp",
   L"data/actor/miko/dashFront0002.bmp",
   L"data/actor/miko/dashFront0003.bmp",
   L"data/actor/miko/dashFront0004.bmp",
   L"data/actor/miko/dashFront0005.bmp",
   L"data/actor/miko/dashFrontLoop0000.bmp",
   L"data/actor/miko/dashFrontLoop0001.bmp",
   L"data/actor/miko/dashFrontLoop0002.bmp",
   L"data/actor/miko/dashFrontLoop0003.bmp",
   L"data/actor/miko/dashFrontLoop0004.bmp",
   L"data/actor/miko/face_spellcallb.png",
   L"data/actor/miko/grab0000.bmp",
   L"data/actor/miko/grab0001.bmp",
   L"data/actor/miko/grab0002.bmp",
   L"data/actor/miko/grab0003.bmp",
   L"data/actor/miko/grab0004.bmp",
   L"data/actor/miko/grab0005.bmp",
   L"data/actor/miko/grab0006.bmp",
   L"data/actor/miko/guard0000.bmp",
   L"data/actor/miko/guard0001.bmp",
   L"data/actor/miko/guard0002.bmp",
   L"data/actor/miko/guard0003.bmp",
   L"data/actor/miko/guardCrash0000.bmp",
   L"data/actor/miko/guardCrash0001.bmp",
   L"data/actor/miko/guardCrash0002.bmp",
   L"data/actor/miko/guardCrash0003.bmp",
   L"data/actor/miko/guardCrash0004.bmp",
   L"data/actor/miko/guardCrash0005.bmp",
   L"data/actor/miko/half_damage_spin0000.bmp",
   L"data/actor/miko/half_damage_spin0001.bmp",
   L"data/actor/miko/half_damage_spin0002.bmp",
   L"data/actor/miko/half_damage_spin0003.bmp",
   L"data/actor/miko/half_damage_spin0004.bmp",
   L"data/actor/miko/half_damage_spin0005.bmp",
   L"data/actor/miko/half_damage_spin0006.bmp",
   L"data/actor/miko/half_damage_spin0007.bmp",
   L"data/actor/miko/item0000.bmp",
   L"data/actor/miko/item0001.bmp",
   L"data/actor/miko/item0002.bmp",
   L"data/actor/miko/item0003.bmp",
   L"data/actor/miko/item0004.bmp",
   L"data/actor/miko/item0005.bmp",
   L"data/actor/miko/item0006.bmp",
   L"data/actor/miko/item0007.bmp",
   L"data/actor/miko/item0008.bmp",
   L"data/actor/miko/item0009.bmp",
   L"data/actor/miko/item0010.bmp",
   L"data/actor/miko/lose0000.bmp",
   L"data/actor/miko/lose0001.bmp",
   L"data/actor/miko/lose0002.bmp",
   L"data/actor/miko/lose0003.bmp",
   L"data/actor/miko/lose0004.bmp",
   L"data/actor/miko/miko.pat",
   L"data/actor/miko/miko_ed.pat",
   L"data/actor/miko/missGuard0000.bmp",
   L"data/actor/miko/missGuard0001.bmp",
   L"data/actor/miko/missGuard0002.bmp",
   L"data/actor/miko/missGuard0003.bmp",
   L"data/actor/miko/occult0000.bmp",
   L"data/actor/miko/occult0001.bmp",
   L"data/actor/miko/occult0002.bmp",
   L"data/actor/miko/occult0003.bmp",
   L"data/actor/miko/occult0004.bmp",
   L"data/actor/miko/occult0005.bmp",
   L"data/actor/miko/occult0006.bmp",
   L"data/actor/miko/occult0007.bmp",
   L"data/actor/miko/occult0008.bmp",
   L"data/actor/miko/occult0009.bmp",
   L"data/actor/miko/occult0010.bmp",
   L"data/actor/miko/occult0011.bmp",
   L"data/actor/miko/occult0012.bmp",
   L"data/actor/miko/occult0013.bmp",
   L"data/actor/miko/occult0014.bmp",
   L"data/actor/miko/occult0015.bmp",
   L"data/actor/miko/occult0016.bmp",
   L"data/actor/miko/occult0017.bmp",
   L"data/actor/miko/occult0018.bmp",
   L"data/actor/miko/occult0019.bmp",
   L"data/actor/miko/occult0020.bmp",
   L"data/actor/miko/occult0021.bmp",
   L"data/actor/miko/occult0022.bmp",
   L"data/actor/miko/occult0023.bmp",
   L"data/actor/miko/occult0024.bmp",
   L"data/actor/miko/occult0025.bmp",
   L"data/actor/miko/occult0026.bmp",
   L"data/actor/miko/palette000.bmp",
   L"data/actor/miko/palette001.bmp",
   L"data/actor/miko/palette002.bmp",
   L"data/actor/miko/palette003.bmp",
   L"data/actor/miko/palette004.bmp",
   L"data/actor/miko/palette005.bmp",
   L"data/actor/miko/palette006.bmp",
   L"data/actor/miko/palette007.bmp",
   L"data/actor/miko/palette100.bmp",
   L"data/actor/miko/palette101.bmp",
   L"data/actor/miko/palette102.bmp",
   L"data/actor/miko/palette103.bmp",
   L"data/actor/miko/palette104.bmp",
   L"data/actor/miko/palette105.bmp",
   L"data/actor/miko/palette106.bmp",
   L"data/actor/miko/palette107.bmp",
   L"data/actor/miko/shotHigh0000.bmp",
   L"data/actor/miko/shotHigh0001.bmp",
   L"data/actor/miko/shotHigh0002.bmp",
   L"data/actor/miko/shotHigh0003.bmp",
   L"data/actor/miko/shotHigh0004.bmp",
   L"data/actor/miko/shotHigh0005.bmp",
   L"data/actor/miko/shotHigh0006.bmp",
   L"data/actor/miko/shotHigh0007.bmp",
   L"data/actor/miko/shotHigh0008.bmp",
   L"data/actor/miko/shotHigh0009.bmp",
   L"data/actor/miko/shotHigh0010.bmp",
   L"data/actor/miko/shotHigh0011.bmp",
   L"data/actor/miko/shotHigh0012.bmp",
   L"data/actor/miko/shotHigh0013.bmp",
   L"data/actor/miko/shotHigh0014.bmp",
   L"data/actor/miko/shotHigh0015.bmp",
   L"data/actor/miko/shotLow0000.bmp",
   L"data/actor/miko/shotLow0001.bmp",
   L"data/actor/miko/shotLow0002.bmp",
   L"data/actor/miko/shotLow0003.bmp",
   L"data/actor/miko/shotLow0004.bmp",
   L"data/actor/miko/shotLow0005.bmp",
   L"data/actor/miko/shotLow0006.bmp",
   L"data/actor/miko/shotLow0007.bmp",
   L"data/actor/miko/skillA0000.bmp",
   L"data/actor/miko/skillA0001.bmp",
   L"data/actor/miko/skillA0002.bmp",
   L"data/actor/miko/skillA0003.bmp",
   L"data/actor/miko/skillA0004.bmp",
   L"data/actor/miko/skillA0005.bmp",
   L"data/actor/miko/skillA0006.bmp",
   L"data/actor/miko/skillA0007.bmp",
   L"data/actor/miko/skillA0008.bmp",
   L"data/actor/miko/skillA0009.bmp",
   L"data/actor/miko/skillAb0000.bmp",
   L"data/actor/miko/skillAb0001.bmp",
   L"data/actor/miko/skillAb0002.bmp",
   L"data/actor/miko/skillAb0003.bmp",
   L"data/actor/miko/skillAb0004.bmp",
   L"data/actor/miko/skillAb0005.bmp",
   L"data/actor/miko/skillAb0006.bmp",
   L"data/actor/miko/skillAb0007.bmp",
   L"data/actor/miko/skillAb0008.bmp",
   L"data/actor/miko/skillAb0009.bmp",
   L"data/actor/miko/skillAb0010.bmp",
   L"data/actor/miko/skillAb0011.bmp",
   L"data/actor/miko/skillAb0012.bmp",
   L"data/actor/miko/skillB0000.bmp",
   L"data/actor/miko/skillB0001.bmp",
   L"data/actor/miko/skillB0002.bmp",
   L"data/actor/miko/skillB0003.bmp",
   L"data/actor/miko/skillB0004.bmp",
   L"data/actor/miko/skillB0005.bmp",
   L"data/actor/miko/skillB0006.bmp",
   L"data/actor/miko/skillB0007.bmp",
   L"data/actor/miko/skillB0008.bmp",
   L"data/actor/miko/skillB0009.bmp",
   L"data/actor/miko/skillB0010.bmp",
   L"data/actor/miko/skillB0011.bmp",
   L"data/actor/miko/skillB0012.bmp",
   L"data/actor/miko/skillB0013.bmp",
   L"data/actor/miko/skillB0014.bmp",
   L"data/actor/miko/skillC0000.bmp",
   L"data/actor/miko/skillC0001.bmp",
   L"data/actor/miko/skillC0002.bmp",
   L"data/actor/miko/skillC0003.bmp",
   L"data/actor/miko/skillC0004.bmp",
   L"data/actor/miko/skillC0005.bmp",
   L"data/actor/miko/skillC0006.bmp",
   L"data/actor/miko/skillC0007.bmp",
   L"data/actor/miko/skillC0008.bmp",
   L"data/actor/miko/skillC0009.bmp",
   L"data/actor/miko/skillC0010.bmp",
   L"data/actor/miko/skillC0011.bmp",
   L"data/actor/miko/skillC0012.bmp",
   L"data/actor/miko/skillC0013.bmp",
   L"data/actor/miko/skillC0014.bmp",
   L"data/actor/miko/skillC0015.bmp",
   L"data/actor/miko/skillC0016.bmp",
   L"data/actor/miko/skillD0000.bmp",
   L"data/actor/miko/skillD0001.bmp",
   L"data/actor/miko/skillD0002.bmp",
   L"data/actor/miko/skillD0003.bmp",
   L"data/actor/miko/skillD0004.bmp",
   L"data/actor/miko/skillD0005.bmp",
   L"data/actor/miko/skillD0006.bmp",
   L"data/actor/miko/skillD0007.bmp",
   L"data/actor/miko/skillD0008.bmp",
   L"data/actor/miko/skillD0009.bmp",
   L"data/actor/miko/skillD0010.bmp",
   L"data/actor/miko/skillD0011.bmp",
   L"data/actor/miko/skillD0012.bmp",
   L"data/actor/miko/skillD0013.bmp",
   L"data/actor/miko/skillD0014.bmp",
   L"data/actor/miko/skillE0000.bmp",
   L"data/actor/miko/skillE0001.bmp",
   L"data/actor/miko/skillE0002.bmp",
   L"data/actor/miko/skillE0003.bmp",
   L"data/actor/miko/skillE0004.bmp",
   L"data/actor/miko/skillE0005.bmp",
   L"data/actor/miko/skillE0006.bmp",
   L"data/actor/miko/skillE0007.bmp",
   L"data/actor/miko/skillE0008.bmp",
   L"data/actor/miko/skillE0009.bmp",
   L"data/actor/miko/skillE0010.bmp",
   L"data/actor/miko/skillE0011.bmp",
   L"data/actor/miko/skillE0012.bmp",
   L"data/actor/miko/skillE0013.bmp",
   L"data/actor/miko/skillE0014.bmp",
   L"data/actor/miko/skillE0015.bmp",
   L"data/actor/miko/skillE0016.bmp",
   L"data/actor/miko/skillE0017.bmp",
   L"data/actor/miko/skillE0018.bmp",
   L"data/actor/miko/skillE0019.bmp",
   L"data/actor/miko/skillG0000.bmp",
   L"data/actor/miko/skillG0001.bmp",
   L"data/actor/miko/skillG0002.bmp",
   L"data/actor/miko/skillG0003.bmp",
   L"data/actor/miko/skillG0004.bmp",
   L"data/actor/miko/skillG0005.bmp",
   L"data/actor/miko/skillG0006.bmp",
   L"data/actor/miko/skillG0007.bmp",
   L"data/actor/miko/skillG0008.bmp",
   L"data/actor/miko/skillG0009.bmp",
   L"data/actor/miko/skill_guse_flash0000.bmp",
   L"data/actor/miko/skill_guse_flash0001.bmp",
   L"data/actor/miko/skill_guse_flash0002.bmp",
   L"data/actor/miko/skill_guse_flash0003.bmp",
   L"data/actor/miko/skill_guse_flash0004.bmp",
   L"data/actor/miko/skill_guse_flash0005.bmp",
   L"data/actor/miko/skill_guse_flash0006.bmp",
   L"data/actor/miko/skill_guse_flash0007.bmp",
   L"data/actor/miko/skill_guse_flash0008.bmp",
   L"data/actor/miko/skill_guse_flash0009.bmp",
   L"data/actor/miko/skill_guse_flash0010.bmp",
   L"data/actor/miko/slideUnderLoop0000.bmp",
   L"data/actor/miko/slideUnderLoop0001.bmp",
   L"data/actor/miko/slideUnderLoop0002.bmp",
   L"data/actor/miko/slideUnderLoop0003.bmp",
   L"data/actor/miko/slideUnderLoop0004.bmp",
   L"data/actor/miko/slideUpper0000.bmp",
   L"data/actor/miko/slideUpper0001.bmp",
   L"data/actor/miko/slideUpper0002.bmp",
   L"data/actor/miko/slideUpper0003.bmp",
   L"data/actor/miko/slideUpper0004.bmp",
   L"data/actor/miko/slideUpper0005.bmp",
   L"data/actor/miko/slideUpper0006.bmp",
   L"data/actor/miko/slideUpperLoop0000.bmp",
   L"data/actor/miko/slideUpperLoop0001.bmp",
   L"data/actor/miko/slideUpperLoop0002.bmp",
   L"data/actor/miko/slideUpperLoop0003.bmp",
   L"data/actor/miko/slideUpperLoop0004.bmp",
   L"data/actor/miko/slide_UnderLoop0000.bmp",
   L"data/actor/miko/slide_UnderLoop0001.bmp",
   L"data/actor/miko/slide_UnderLoop0002.bmp",
   L"data/actor/miko/slide_UnderLoop0003.bmp",
   L"data/actor/miko/slide_UnderLoop0004.bmp",
   L"data/actor/miko/slide_Upper0000.bmp",
   L"data/actor/miko/slide_Upper0001.bmp",
   L"data/actor/miko/slide_Upper0002.bmp",
   L"data/actor/miko/slide_Upper0003.bmp",
   L"data/actor/miko/slide_Upper0004.bmp",
   L"data/actor/miko/slide_Upper0005.bmp",
   L"data/actor/miko/slide_Upper0006.bmp",
   L"data/actor/miko/slide_Upper0007.bmp",
   L"data/actor/miko/slide_Upper0008.bmp",
   L"data/actor/miko/slide_Upper0009.bmp",
   L"data/actor/miko/slide_UpperLoop0000.bmp",
   L"data/actor/miko/slide_UpperLoop0001.bmp",
   L"data/actor/miko/slide_UpperLoop0002.bmp",
   L"data/actor/miko/slide_UpperLoop0003.bmp",
   L"data/actor/miko/slide_UpperLoop0004.bmp",
   L"data/actor/miko/spellA0000.bmp",
   L"data/actor/miko/spellA0001.bmp",
   L"data/actor/miko/spellA0002.bmp",
   L"data/actor/miko/spellA0003.bmp",
   L"data/actor/miko/spellA0004.bmp",
   L"data/actor/miko/spellA0005.bmp",
   L"data/actor/miko/spellA0006.bmp",
   L"data/actor/miko/spellA0007.bmp",
   L"data/actor/miko/spellA0008.bmp",
   L"data/actor/miko/spellA0009.bmp",
   L"data/actor/miko/spellA0010.bmp",
   L"data/actor/miko/spellA0011.bmp",
   L"data/actor/miko/spellA0012.bmp",
   L"data/actor/miko/spellALoop0000.bmp",
   L"data/actor/miko/spellALoop0001.bmp",
   L"data/actor/miko/spellALoop0002.bmp",
   L"data/actor/miko/spellALoop0003.bmp",
   L"data/actor/miko/spellALoop0004.bmp",
   L"data/actor/miko/spellC0000.bmp",
   L"data/actor/miko/spellC0001.bmp",
   L"data/actor/miko/spellC0002.bmp",
   L"data/actor/miko/spellC0003.bmp",
   L"data/actor/miko/spellC0004.bmp",
   L"data/actor/miko/spellC0005.bmp",
   L"data/actor/miko/spellC0006.bmp",
   L"data/actor/miko/spellC0007.bmp",
   L"data/actor/miko/spellC0008.bmp",
   L"data/actor/miko/spellC0009.bmp",
   L"data/actor/miko/spellC0010.bmp",
   L"data/actor/miko/spellC0011.bmp",
   L"data/actor/miko/spellC0012.bmp",
   L"data/actor/miko/spellC0013.bmp",
   L"data/actor/miko/spellC0014.bmp",
   L"data/actor/miko/stand0000.bmp",
   L"data/actor/miko/stand0001.bmp",
   L"data/actor/miko/stand0002.bmp",
   L"data/actor/miko/stand0003.bmp",
   L"data/actor/miko/stand0004.bmp",
   L"data/actor/miko/stand0005.bmp",
   L"data/actor/miko/stand0006.bmp",
   L"data/actor/miko/stand0007.bmp",
   L"data/actor/miko/stand0008.bmp",
   L"data/actor/miko/stand0009.bmp",
   L"data/actor/miko/stand0010.bmp",
   L"data/actor/miko/stand0011.bmp",
   L"data/actor/miko/stand0012.bmp",
   L"data/actor/miko/stand0013.bmp",
   L"data/actor/miko/stun0000.bmp",
   L"data/actor/miko/stun0001.bmp",
   L"data/actor/miko/stun0002.bmp",
   L"data/actor/miko/stunLoop0000.bmp",
   L"data/actor/miko/stunLoop0001.bmp",
   L"data/actor/miko/stunLoop0002.bmp",
   L"data/actor/miko/stunLoop0003.bmp",
   L"data/actor/miko/stunLoop0004.bmp",
   L"data/actor/miko/stunLoop0005.bmp",
   L"data/actor/miko/team_begin_A0000.bmp",
   L"data/actor/miko/team_begin_A0001.bmp",
   L"data/actor/miko/team_begin_A0002.bmp",
   L"data/actor/miko/team_begin_A0003.bmp",
   L"data/actor/miko/team_begin_A0004.bmp",
   L"data/actor/miko/team_begin_A0005.bmp",
   L"data/actor/miko/team_begin_A0006.bmp",
   L"data/actor/miko/team_begin_A0007.bmp",
   L"data/actor/miko/team_begin_A0008.bmp",
   L"data/actor/miko/team_begin_A0009.bmp",
   L"data/actor/miko/test_effect.bmp",
   L"data/actor/miko/test_effect000.png",
   L"data/actor/miko/test_effect001.png",
   L"data/actor/miko/texture/auraA0000.png",
   L"data/actor/miko/texture/ball.png",
   L"data/actor/miko/texture/ballB.bmp",
   L"data/actor/miko/texture/bariaT.png",
   L"data/actor/miko/texture/box_texture0000.bmp",
   L"data/actor/miko/texture/chouzyuuA.png",
   L"data/actor/miko/texture/climax_slash0000.dds",
   L"data/actor/miko/texture/clowA000.png",
   L"data/actor/miko/texture/clowA001.png",
   L"data/actor/miko/texture/clowA002.png",
   L"data/actor/miko/texture/clowB0000.png",
   L"data/actor/miko/texture/clowB0001.png",
   L"data/actor/miko/texture/clowB0002.png",
   L"data/actor/miko/texture/common_spark.png",
   L"data/actor/miko/texture/cut_aura0000.dds",
   L"data/actor/miko/texture/earth0000.png",
   L"data/actor/miko/texture/earth0001.png",
   L"data/actor/miko/texture/earth0002.png",
   L"data/actor/miko/texture/earth0003.png",
   L"data/actor/miko/texture/earth0004.png",
   L"data/actor/miko/texture/earth0005.png",
   L"data/actor/miko/texture/earth0006.png",
   L"data/actor/miko/texture/earth0007.png",
   L"data/actor/miko/texture/earth0008.png",
   L"data/actor/miko/texture/earth0009.png",
   L"data/actor/miko/texture/earth0010.png",
   L"data/actor/miko/texture/earth0011.png",
   L"data/actor/miko/texture/earth0012.png",
   L"data/actor/miko/texture/earth0013.png",
   L"data/actor/miko/texture/earth0014.png",
   L"data/actor/miko/texture/face_master_miko.png",
   L"data/actor/miko/texture/face_master_miko2.png",
   L"data/actor/miko/texture/face_master_miko3.png",
   L"data/actor/miko/texture/face_slave_miko.png",
   L"data/actor/miko/texture/face_slave_miko_r.png",
   L"data/actor/miko/texture/face_spell_cut.png",
   L"data/actor/miko/texture/fireBack.png",
   L"data/actor/miko/texture/fireKick0000.png",
   L"data/actor/miko/texture/fireMask.png",
   L"data/actor/miko/texture/hexPanel.png",
   L"data/actor/miko/texture/laserBaseA000.png",
   L"data/actor/miko/texture/laserBaseA001.png",
   L"data/actor/miko/texture/mantleHigh.png",
   L"data/actor/miko/texture/mantleLow.png",
   L"data/actor/miko/texture/mantletest000.bmp",
   L"data/actor/miko/texture/marisaBall2.bmp",
   L"data/actor/miko/texture/miko_animalDamage000.png",
   L"data/actor/miko/texture/miko_animalDamage001.png",
   L"data/actor/miko/texture/miko_animalDamage002.png",
   L"data/actor/miko/texture/miko_animalDamage003.png",
   L"data/actor/miko/texture/miko_animal_00000.png",
   L"data/actor/miko/texture/miko_animal_00001.png",
   L"data/actor/miko/texture/miko_animal_00002.png",
   L"data/actor/miko/texture/miko_animal_00003.png",
   L"data/actor/miko/texture/miko_animal_00004.png",
   L"data/actor/miko/texture/miko_animal_00005.png",
   L"data/actor/miko/texture/miko_animal_00006.png",
   L"data/actor/miko/texture/miko_animal_00007.png",
   L"data/actor/miko/texture/miko_animal_00008.png",
   L"data/actor/miko/texture/miko_animal_00009.png",
   L"data/actor/miko/texture/miko_animal_00010.png",
   L"data/actor/miko/texture/miko_animal_00011.png",
   L"data/actor/miko/texture/miko_ballA.bmp",
   L"data/actor/miko/texture/miko_ballB.png",
   L"data/actor/miko/texture/miko_climaxblade.png",
   L"data/actor/miko/texture/miko_fire.png",
   L"data/actor/miko/texture/miko_kona_A.bmp",
   L"data/actor/miko/texture/miko_RingA.bmp",
   L"data/actor/miko/texture/miko_spellC_Branch.png",
   L"data/actor/miko/texture/miko_spellC_Laser.png",
   L"data/actor/miko/texture/nichirin.png",
   L"data/actor/miko/texture/occult_aura0000.dds",
   L"data/actor/miko/texture/occult_ball0000.png",
   L"data/actor/miko/texture/occult_select0000.dds",
   L"data/actor/miko/texture/occult_select0001.dds",
   L"data/actor/miko/texture/occult_slash0000.dds",
   L"data/actor/miko/texture/rodRollA0000.png",
   L"data/actor/miko/texture/shot_MonolaserA0000.png",
   L"data/actor/miko/texture/skillG_sword.png",
   L"data/actor/miko/texture/skillG_Trail.png",
   L"data/actor/miko/texture/smoke.png",
   L"data/actor/miko/texture/spell_use_cut.png",
   L"data/actor/miko/texture/sunRing.png",
   L"data/actor/miko/texture/sword0000.png",
   L"data/actor/miko/texture/trail.png",
   L"data/actor/miko/texture/vortexloop0000.png",
   L"data/actor/miko/Turn0000.bmp",
   L"data/actor/miko/Turn0001.bmp",
   L"data/actor/miko/Turn0002.bmp",
   L"data/actor/miko/walkBack0000.bmp",
   L"data/actor/miko/walkBack0001.bmp",
   L"data/actor/miko/walkBack0003.bmp",
   L"data/actor/miko/walkBack0004.bmp",
   L"data/actor/miko/walkBack0005.bmp",
   L"data/actor/miko/walkBackloop0000.bmp",
   L"data/actor/miko/walkBackloop0001.bmp",
   L"data/actor/miko/walkBackloop0002.bmp",
   L"data/actor/miko/walkBackloop0003.bmp",
   L"data/actor/miko/walkBackloop0004.bmp",
   L"data/actor/miko/walkFront0000.bmp",
   L"data/actor/miko/walkFront0001.bmp",
   L"data/actor/miko/walkFront0002.bmp",
   L"data/actor/miko/walkFront0003.bmp",
   L"data/actor/miko/walkFront0004.bmp",
   L"data/actor/miko/walkFront0005.bmp",
   L"data/actor/miko/walkFrontLoop0000.bmp",
   L"data/actor/miko/walkFrontLoop0001.bmp",
   L"data/actor/miko/walkFrontLoop0002.bmp",
   L"data/actor/miko/walkFrontLoop0003.bmp",
   L"data/actor/miko/walkFrontLoop0004.bmp",
   L"data/actor/miko/winA0000.bmp",
   L"data/actor/miko/winA0001.bmp",
   L"data/actor/miko/winA0002.bmp",
   L"data/actor/miko/winA0003.bmp",
   L"data/actor/miko/winA0004.bmp",
   L"data/actor/miko/winB0000.bmp",
   L"data/actor/miko/winB0001.bmp",
   L"data/actor/miko/winB0002.bmp",
   L"data/actor/miko/winB0003.bmp",
   L"data/actor/miko/winB0004.bmp",
   L"data/actor/miko/winB0005.bmp",
   L"data/actor/miko.nut",
   L"data/actor/miko_base.nut",
   L"data/actor/miko_boss.nut",
   L"data/actor/miko_boss_base.nut",
   L"data/actor/miko_boss_init.nut",
   L"data/actor/miko_boss_shot.nut",
   L"data/actor/miko_com.nut",
   L"data/actor/miko_combo.nut",
   L"data/actor/miko_com_function.nut",
   L"data/actor/miko_init.nut",
   L"data/actor/miko_practice_init.nut",
   L"data/actor/miko_shot.nut",
   L"data/actor/miko_team.nut",
   L"data/actor/mokou/atkDash0000.bmp",
   L"data/actor/mokou/atkDash0001.bmp",
   L"data/actor/mokou/atkDash0002.bmp",
   L"data/actor/mokou/atkDash0003.bmp",
   L"data/actor/mokou/atkDash0004.bmp",
   L"data/actor/mokou/atkDash0005.bmp",
   L"data/actor/mokou/atkDash0006.bmp",
   L"data/actor/mokou/atkDash0007.bmp",
   L"data/actor/mokou/atkDash0008.bmp",
   L"data/actor/mokou/atkFront0000.bmp",
   L"data/actor/mokou/atkFront0001.bmp",
   L"data/actor/mokou/atkFront0002.bmp",
   L"data/actor/mokou/atkFront0003.bmp",
   L"data/actor/mokou/atkFront0004.bmp",
   L"data/actor/mokou/atkFront0005.bmp",
   L"data/actor/mokou/atkFront0006.bmp",
   L"data/actor/mokou/atkFront0007.bmp",
   L"data/actor/mokou/atkFront0008.bmp",
   L"data/actor/mokou/atkfront0009.bmp",
   L"data/actor/mokou/atkHighFrontAir0000.bmp",
   L"data/actor/mokou/atkHighFrontAir0001.bmp",
   L"data/actor/mokou/atkHighFrontAir0002.bmp",
   L"data/actor/mokou/atkHighFrontAir0003.bmp",
   L"data/actor/mokou/atkHighFrontAir0004.bmp",
   L"data/actor/mokou/atkHighFrontAir0005.bmp",
   L"data/actor/mokou/atkHighFrontAir0006.bmp",
   L"data/actor/mokou/atkHighFrontAir0007.bmp",
   L"data/actor/mokou/atkHighFrontAir0008.bmp",
   L"data/actor/mokou/atkHighUnder0000.bmp",
   L"data/actor/mokou/atkHighUnder0001.bmp",
   L"data/actor/mokou/atkHighUnder0002.bmp",
   L"data/actor/mokou/atkHighUnder0003.bmp",
   L"data/actor/mokou/atkHighUnder0004.bmp",
   L"data/actor/mokou/atkHighUnder0005.bmp",
   L"data/actor/mokou/atkHighUnder0006.bmp",
   L"data/actor/mokou/atkHighUnder0007.bmp",
   L"data/actor/mokou/atkHighUnder0008.bmp",
   L"data/actor/mokou/atkHighUpper0000.bmp",
   L"data/actor/mokou/atkHighUpper0001.bmp",
   L"data/actor/mokou/atkHighUpper0002.bmp",
   L"data/actor/mokou/atkHighUpper0003.bmp",
   L"data/actor/mokou/atkHighUpper0004.bmp",
   L"data/actor/mokou/atkHighUpper0005.bmp",
   L"data/actor/mokou/atkHighUpper0006.bmp",
   L"data/actor/mokou/atkHighUpper0007.bmp",
   L"data/actor/mokou/atkLow0000.bmp",
   L"data/actor/mokou/atkLow0001.bmp",
   L"data/actor/mokou/atkLow0002.bmp",
   L"data/actor/mokou/atkLow0003.bmp",
   L"data/actor/mokou/atkLow0004.bmp",
   L"data/actor/mokou/atkLow0005.bmp",
   L"data/actor/mokou/atkLow0006.bmp",
   L"data/actor/mokou/atkMid0000.bmp",
   L"data/actor/mokou/atkMid0001.bmp",
   L"data/actor/mokou/atkMid0002.bmp",
   L"data/actor/mokou/atkMid0003.bmp",
   L"data/actor/mokou/atkMid0004.bmp",
   L"data/actor/mokou/atkMid0005.bmp",
   L"data/actor/mokou/atkMid0006.bmp",
   L"data/actor/mokou/atkMidAir0000.bmp",
   L"data/actor/mokou/atkMidAir0001.bmp",
   L"data/actor/mokou/atkMidAir0002.bmp",
   L"data/actor/mokou/atkMidAir0003.bmp",
   L"data/actor/mokou/atkMidAir0004.bmp",
   L"data/actor/mokou/atkMidAir0005.bmp",
   L"data/actor/mokou/atkMidAir0006.bmp",
   L"data/actor/mokou/atkMidAir0007.bmp",
   L"data/actor/mokou/atkMidAir0008.bmp",
   L"data/actor/mokou/beginBattleA0000.bmp",
   L"data/actor/mokou/beginBattleA0001.bmp",
   L"data/actor/mokou/beginBattleA0002.bmp",
   L"data/actor/mokou/beginBattleA0003.bmp",
   L"data/actor/mokou/beginBattleA0004.bmp",
   L"data/actor/mokou/beginBattleA0005.bmp",
   L"data/actor/mokou/beginBattleA0006.bmp",
   L"data/actor/mokou/beginBattleA0007.bmp",
   L"data/actor/mokou/beginBattleA0008.bmp",
   L"data/actor/mokou/climax0000.bmp",
   L"data/actor/mokou/climax0001.bmp",
   L"data/actor/mokou/climax0002.bmp",
   L"data/actor/mokou/climax0003.bmp",
   L"data/actor/mokou/climax0004.bmp",
   L"data/actor/mokou/climax0005.bmp",
   L"data/actor/mokou/climax0006.bmp",
   L"data/actor/mokou/climax0007.bmp",
   L"data/actor/mokou/climaxCut0000.png",
   L"data/actor/mokou/damageBody0000.bmp",
   L"data/actor/mokou/damageBody0001.bmp",
   L"data/actor/mokou/damageBody0002.bmp",
   L"data/actor/mokou/damageBody0003.bmp",
   L"data/actor/mokou/damageHead0000.bmp",
   L"data/actor/mokou/damageHead0001.bmp",
   L"data/actor/mokou/damageHead0002.bmp",
   L"data/actor/mokou/damageHead0003.bmp",
   L"data/actor/mokou/damageHead0004.bmp",
   L"data/actor/mokou/damageSpin0000.bmp",
   L"data/actor/mokou/damageSpin0001.bmp",
   L"data/actor/mokou/damageSpin0002.bmp",
   L"data/actor/mokou/damageSpin0003.bmp",
   L"data/actor/mokou/damageupper0000.bmp",
   L"data/actor/mokou/damageUpper0001.bmp",
   L"data/actor/mokou/damageUpper0002.bmp",
   L"data/actor/mokou/damageUpper0003.bmp",
   L"data/actor/mokou/damageUpper0004.bmp",
   L"data/actor/mokou/damageUpper0005.bmp",
   L"data/actor/mokou/damageUpper0006.bmp",
   L"data/actor/mokou/damageUpper0007.bmp",
   L"data/actor/mokou/damageUpper0008.bmp",
   L"data/actor/mokou/damageUpper0009.bmp",
   L"data/actor/mokou/damageUpper0010.bmp",
   L"data/actor/mokou/damageWall0000.bmp",
   L"data/actor/mokou/damageWall0001.bmp",
   L"data/actor/mokou/damageWall0002.bmp",
   L"data/actor/mokou/damageWall0003.bmp",
   L"data/actor/mokou/damageWall0004.bmp",
   L"data/actor/mokou/damageWall0005.bmp",
   L"data/actor/mokou/dashBack0000.bmp",
   L"data/actor/mokou/dashBack0001.bmp",
   L"data/actor/mokou/dashBack0002.bmp",
   L"data/actor/mokou/dashBack0003.bmp",
   L"data/actor/mokou/dashBack0004.bmp",
   L"data/actor/mokou/dashBackLoop0000.bmp",
   L"data/actor/mokou/dashBackLoop0001.bmp",
   L"data/actor/mokou/dashBackLoop0002.bmp",
   L"data/actor/mokou/dashBackLoop0003.bmp",
   L"data/actor/mokou/dashFront0000.bmp",
   L"data/actor/mokou/dashFront0001.bmp",
   L"data/actor/mokou/dashFront0002.bmp",
   L"data/actor/mokou/dashFront0003.bmp",
   L"data/actor/mokou/dashFront0004.bmp",
   L"data/actor/mokou/dashFrontLoop0000.bmp",
   L"data/actor/mokou/dashFrontLoop0001.bmp",
   L"data/actor/mokou/dashFrontLoop0002.bmp",
   L"data/actor/mokou/dashFrontLoop0003.bmp",
   L"data/actor/mokou/down0000.bmp",
   L"data/actor/mokou/down0001.bmp",
   L"data/actor/mokou/down0002.bmp",
   L"data/actor/mokou/down0003.bmp",
   L"data/actor/mokou/dummy.bmp",
   L"data/actor/mokou/grab0000.bmp",
   L"data/actor/mokou/grab0001.bmp",
   L"data/actor/mokou/grab0002.bmp",
   L"data/actor/mokou/grab0003.bmp",
   L"data/actor/mokou/grab0004.bmp",
   L"data/actor/mokou/grab0005.bmp",
   L"data/actor/mokou/grab_hit0000.bmp",
   L"data/actor/mokou/grab_hit0001.bmp",
   L"data/actor/mokou/grab_hit0002.bmp",
   L"data/actor/mokou/grab_hit0003.bmp",
   L"data/actor/mokou/grab_hit0004.bmp",
   L"data/actor/mokou/grab_hit0005.bmp",
   L"data/actor/mokou/guard0000.bmp",
   L"data/actor/mokou/guard0001.bmp",
   L"data/actor/mokou/guard0002.bmp",
   L"data/actor/mokou/guardCrash0000.bmp",
   L"data/actor/mokou/guardCrash0001.bmp",
   L"data/actor/mokou/guardCrash0002.bmp",
   L"data/actor/mokou/guardCrash0003.bmp",
   L"data/actor/mokou/guardMiss0000.bmp",
   L"data/actor/mokou/guardMiss0001.bmp",
   L"data/actor/mokou/guardMiss0002.bmp",
   L"data/actor/mokou/guardMiss0003.bmp",
   L"data/actor/mokou/lose0000.bmp",
   L"data/actor/mokou/lose0001.bmp",
   L"data/actor/mokou/lose0002.bmp",
   L"data/actor/mokou/lose0003.bmp",
   L"data/actor/mokou/lose0004.bmp",
   L"data/actor/mokou/lose0005.bmp",
   L"data/actor/mokou/lose0006.bmp",
   L"data/actor/mokou/mokou.pat",
   L"data/actor/mokou/mokouex.pat",
   L"data/actor/mokou/mokou_ed.pat",
   L"data/actor/mokou/occult0000.bmp",
   L"data/actor/mokou/occult0001.bmp",
   L"data/actor/mokou/occult0002.bmp",
   L"data/actor/mokou/occult0003.bmp",
   L"data/actor/mokou/occultLoop0000.bmp",
   L"data/actor/mokou/occultLoop0001.bmp",
   L"data/actor/mokou/occultLoop0002.bmp",
   L"data/actor/mokou/occultLoop0003.bmp",
   L"data/actor/mokou/palette000.bmp",
   L"data/actor/mokou/palette001.bmp",
   L"data/actor/mokou/palette002.bmp",
   L"data/actor/mokou/palette003.bmp",
   L"data/actor/mokou/palette004.bmp",
   L"data/actor/mokou/palette005.bmp",
   L"data/actor/mokou/palette006.bmp",
   L"data/actor/mokou/palette007.bmp",
   L"data/actor/mokou/palette100.bmp",
   L"data/actor/mokou/palette101.bmp",
   L"data/actor/mokou/palette102.bmp",
   L"data/actor/mokou/palette103.bmp",
   L"data/actor/mokou/palette104.bmp",
   L"data/actor/mokou/palette105.bmp",
   L"data/actor/mokou/palette106.bmp",
   L"data/actor/mokou/palette107.bmp",
   L"data/actor/mokou/palette999.bmp",
   L"data/actor/mokou/shotFront0000.bmp",
   L"data/actor/mokou/shotFront0001.bmp",
   L"data/actor/mokou/shotFront0002.bmp",
   L"data/actor/mokou/shotFront0003.bmp",
   L"data/actor/mokou/shotFront0004.bmp",
   L"data/actor/mokou/shotFront0005.bmp",
   L"data/actor/mokou/shotFront0006.bmp",
   L"data/actor/mokou/shotFront0007.bmp",
   L"data/actor/mokou/shotFront0008.bmp",
   L"data/actor/mokou/shotNormal0000.bmp",
   L"data/actor/mokou/shotNormal0001.bmp",
   L"data/actor/mokou/shotNormal0002.bmp",
   L"data/actor/mokou/shotNormal0003.bmp",
   L"data/actor/mokou/shotNormal0004.bmp",
   L"data/actor/mokou/shotNormal0005.bmp",
   L"data/actor/mokou/shotNormal0006.bmp",
   L"data/actor/mokou/shotNormal0007.bmp",
   L"data/actor/mokou/skillA0000.bmp",
   L"data/actor/mokou/skillA0001.bmp",
   L"data/actor/mokou/skillA0002.bmp",
   L"data/actor/mokou/skillA0003.bmp",
   L"data/actor/mokou/skillA0004.bmp",
   L"data/actor/mokou/skillA0005.bmp",
   L"data/actor/mokou/skillA0006.bmp",
   L"data/actor/mokou/skillA0007.bmp",
   L"data/actor/mokou/skillA0008.bmp",
   L"data/actor/mokou/skillA0009.bmp",
   L"data/actor/mokou/skillB0000.bmp",
   L"data/actor/mokou/skillB0001.bmp",
   L"data/actor/mokou/skillB0002.bmp",
   L"data/actor/mokou/skillB0003.bmp",
   L"data/actor/mokou/skillB0004.bmp",
   L"data/actor/mokou/skillB0005.bmp",
   L"data/actor/mokou/skillB0006.bmp",
   L"data/actor/mokou/skillB0007.bmp",
   L"data/actor/mokou/skillB0008.bmp",
   L"data/actor/mokou/skillBb0000.bmp",
   L"data/actor/mokou/skillBb0001.bmp",
   L"data/actor/mokou/skillBb0002.bmp",
   L"data/actor/mokou/skillBb0003.bmp",
   L"data/actor/mokou/skillBb0004.bmp",
   L"data/actor/mokou/skillBb0005.bmp",
   L"data/actor/mokou/skillBb0006.bmp",
   L"data/actor/mokou/skillB_bomb0000.bmp",
   L"data/actor/mokou/skillC0000.bmp",
   L"data/actor/mokou/skillC0001.bmp",
   L"data/actor/mokou/skillC0002.bmp",
   L"data/actor/mokou/skillC0003.bmp",
   L"data/actor/mokou/skillC0004.bmp",
   L"data/actor/mokou/skillC0005.bmp",
   L"data/actor/mokou/skillC0006.bmp",
   L"data/actor/mokou/skillC0007.bmp",
   L"data/actor/mokou/skillC0008.bmp",
   L"data/actor/mokou/skillD0000.bmp",
   L"data/actor/mokou/skillD0001.bmp",
   L"data/actor/mokou/skillD0002.bmp",
   L"data/actor/mokou/skillD0003.bmp",
   L"data/actor/mokou/skillD0004.bmp",
   L"data/actor/mokou/skillD0005.bmp",
   L"data/actor/mokou/skillD0006.bmp",
   L"data/actor/mokou/skillD0007.bmp",
   L"data/actor/mokou/skillD0008.bmp",
   L"data/actor/mokou/skillD0009.bmp",
   L"data/actor/mokou/skillD0010.bmp",
   L"data/actor/mokou/skillE0000.bmp",
   L"data/actor/mokou/skillE0001.bmp",
   L"data/actor/mokou/skillE0002.bmp",
   L"data/actor/mokou/skillE0003.bmp",
   L"data/actor/mokou/skillE0004.bmp",
   L"data/actor/mokou/skillE0005.bmp",
   L"data/actor/mokou/skillE0006.bmp",
   L"data/actor/mokou/skillE0007.bmp",
   L"data/actor/mokou/skillE0008.bmp",
   L"data/actor/mokou/skillE0009.bmp",
   L"data/actor/mokou/skillE0010.bmp",
   L"data/actor/mokou/skillE_Loop0000.bmp",
   L"data/actor/mokou/skillE_Loop0001.bmp",
   L"data/actor/mokou/skillE_Loop0002.bmp",
   L"data/actor/mokou/skillE_Loop0003.bmp",
   L"data/actor/mokou/skillF0000.bmp",
   L"data/actor/mokou/skillF0001.bmp",
   L"data/actor/mokou/skillF0002.bmp",
   L"data/actor/mokou/skillF0003.bmp",
   L"data/actor/mokou/skillF0004.bmp",
   L"data/actor/mokou/skillF0005.bmp",
   L"data/actor/mokou/skillF0006.bmp",
   L"data/actor/mokou/skillF0007.bmp",
   L"data/actor/mokou/skillG0000.bmp",
   L"data/actor/mokou/skillG0001.bmp",
   L"data/actor/mokou/skillG0002.bmp",
   L"data/actor/mokou/skill_sweep_kick0000.bmp",
   L"data/actor/mokou/skill_sweep_kick0001.bmp",
   L"data/actor/mokou/skill_sweep_kick0002.bmp",
   L"data/actor/mokou/skill_sweep_kick0003.bmp",
   L"data/actor/mokou/skill_sweep_kick0004.bmp",
   L"data/actor/mokou/skill_sweep_kick0005.bmp",
   L"data/actor/mokou/skill_sweep_kick0006.bmp",
   L"data/actor/mokou/skill_sweep_kick0007.bmp",
   L"data/actor/mokou/skill_sweep_kick0008.bmp",
   L"data/actor/mokou/slide0000.bmp",
   L"data/actor/mokou/slide0001.bmp",
   L"data/actor/mokou/slide0002.bmp",
   L"data/actor/mokou/slide0003.bmp",
   L"data/actor/mokou/slide0004.bmp",
   L"data/actor/mokou/slide0005.bmp",
   L"data/actor/mokou/slide0006.bmp",
   L"data/actor/mokou/slideUnderLoop0000.bmp",
   L"data/actor/mokou/slideUnderLoop0001.bmp",
   L"data/actor/mokou/slideUnderLoop0002.bmp",
   L"data/actor/mokou/slideUnderLoop0003.bmp",
   L"data/actor/mokou/slideUpperLoop0000.bmp",
   L"data/actor/mokou/slideUpperLoop0001.bmp",
   L"data/actor/mokou/slideUpperLoop0002.bmp",
   L"data/actor/mokou/slideUpperLoop0003.bmp",
   L"data/actor/mokou/spellA0000.bmp",
   L"data/actor/mokou/spellA0001.bmp",
   L"data/actor/mokou/spellA0002.bmp",
   L"data/actor/mokou/spellA0003.bmp",
   L"data/actor/mokou/spellA0004.bmp",
   L"data/actor/mokou/spellA0005.bmp",
   L"data/actor/mokou/spellA0006.bmp",
   L"data/actor/mokou/spellA0007.bmp",
   L"data/actor/mokou/spellA0008.bmp",
   L"data/actor/mokou/spellA0009.bmp",
   L"data/actor/mokou/spellA0010.bmp",
   L"data/actor/mokou/spellA0011.bmp",
   L"data/actor/mokou/spellA0012.bmp",
   L"data/actor/mokou/spellC00.png",
   L"data/actor/mokou/spellC0000.bmp",
   L"data/actor/mokou/spellC0001.bmp",
   L"data/actor/mokou/spellC0002.bmp",
   L"data/actor/mokou/spellC0003.bmp",
   L"data/actor/mokou/spellC0004.bmp",
   L"data/actor/mokou/spellC0005.bmp",
   L"data/actor/mokou/spellC0006.bmp",
   L"data/actor/mokou/spellC0007.bmp",
   L"data/actor/mokou/spellC0008.bmp",
   L"data/actor/mokou/spellC0009.bmp",
   L"data/actor/mokou/spellC0010.bmp",
   L"data/actor/mokou/spellC0011.bmp",
   L"data/actor/mokou/spellC0012.bmp",
   L"data/actor/mokou/spellC0013.bmp",
   L"data/actor/mokou/spellC01.png",
   L"data/actor/mokou/spellC02.png",
   L"data/actor/mokou/spellC03.png",
   L"data/actor/mokou/spellC04.png",
   L"data/actor/mokou/spellC05.png",
   L"data/actor/mokou/spellC06.png",
   L"data/actor/mokou/spellCall0000.bmp",
   L"data/actor/mokou/spellCall0001.bmp",
   L"data/actor/mokou/spellCall0002.bmp",
   L"data/actor/mokou/spellCall0003.bmp",
   L"data/actor/mokou/spellCall0004.bmp",
   L"data/actor/mokou/stand0000.bmp",
   L"data/actor/mokou/stand0001.bmp",
   L"data/actor/mokou/stand0002.bmp",
   L"data/actor/mokou/stand0003.bmp",
   L"data/actor/mokou/stand0004.bmp",
   L"data/actor/mokou/stand0005.bmp",
   L"data/actor/mokou/stand0006.bmp",
   L"data/actor/mokou/stand0007.bmp",
   L"data/actor/mokou/stand0008.bmp",
   L"data/actor/mokou/stand0009.bmp",
   L"data/actor/mokou/stand0010.bmp",
   L"data/actor/mokou/stand0011.bmp",
   L"data/actor/mokou/stand0012.bmp",
   L"data/actor/mokou/stunLoop0000.bmp",
   L"data/actor/mokou/stunLoop0001.bmp",
   L"data/actor/mokou/stunLoop0002.bmp",
   L"data/actor/mokou/stunLoop0003.bmp",
   L"data/actor/mokou/stunLoop0004.bmp",
   L"data/actor/mokou/test_effect.bmp",
   L"data/actor/mokou/test_lose0000.bmp",
   L"data/actor/mokou/test_lose0001.bmp",
   L"data/actor/mokou/texture/amulet0000.dds",
   L"data/actor/mokou/texture/amulet0001.dds",
   L"data/actor/mokou/texture/atkAirMidFire0000.dds",
   L"data/actor/mokou/texture/atkMidFire0000.dds",
   L"data/actor/mokou/texture/atkMidFire0001.dds",
   L"data/actor/mokou/texture/atkUpperEffect0000.dds",
   L"data/actor/mokou/texture/atkUpperEffect0001.dds",
   L"data/actor/mokou/texture/chargeShot_fire0000.dds",
   L"data/actor/mokou/texture/chargeShot_fire0001.dds",
   L"data/actor/mokou/texture/charge_trail0000.png",
   L"data/actor/mokou/texture/charge_trail0001.png",
   L"data/actor/mokou/texture/climax_cut0000.dds",
   L"data/actor/mokou/texture/climax_Fire0000.png",
   L"data/actor/mokou/texture/climax_pilar0000.png",
   L"data/actor/mokou/texture/climax_pilar0001.png",
   L"data/actor/mokou/texture/climax_pilar0002.png",
   L"data/actor/mokou/texture/face_master_mokou.png",
   L"data/actor/mokou/texture/face_master_mokou2.png",
   L"data/actor/mokou/texture/face_slave_mokou.png",
   L"data/actor/mokou/texture/face_spell_cut_0002.png",
   L"data/actor/mokou/texture/firePart0000.dds",
   L"data/actor/mokou/texture/fireWing0000.dds",
   L"data/actor/mokou/texture/mask_ball.png",
   L"data/actor/mokou/texture/mokou_fireBase0000.png",
   L"data/actor/mokou/texture/mokou_fireBase0001.png",
   L"data/actor/mokou/texture/mokou_FireTexture0000.png",
   L"data/actor/mokou/texture/mokou_FireTexture0001.png",
   L"data/actor/mokou/texture/mokou_FireTexture0002.png",
   L"data/actor/mokou/texture/mokou_FireTexture0003.png",
   L"data/actor/mokou/texture/mokou_occultFire0000.png",
   L"data/actor/mokou/texture/moko_animal00000.png",
   L"data/actor/mokou/texture/moko_animal00006.png",
   L"data/actor/mokou/texture/moko_animal00012.png",
   L"data/actor/mokou/texture/moko_animal00018.png",
   L"data/actor/mokou/texture/moko_animal00024.png",
   L"data/actor/mokou/texture/moko_animalDamage00000.png",
   L"data/actor/mokou/texture/moko_animalDamage00006.png",
   L"data/actor/mokou/texture/moko_animalDamage00012.png",
   L"data/actor/mokou/texture/moko_animalDamage00018.png",
   L"data/actor/mokou/texture/moko_animalDamage00024.png",
   L"data/actor/mokou/texture/occult_fireB0000.dds",
   L"data/actor/mokou/texture/occult_fireR0000.dds",
   L"data/actor/mokou/texture/ooiri2.png",
   L"data/actor/mokou/texture/reimu_fallKick.png",
   L"data/actor/mokou/texture/shotFrontBird0000.dds",
   L"data/actor/mokou/texture/shot_object0000.dds",
   L"data/actor/mokou/texture/shot_object0001.dds",
   L"data/actor/mokou/texture/skillB_clow0000.dds",
   L"data/actor/mokou/texture/skillB_clow0001.dds",
   L"data/actor/mokou/texture/skillExp0000.dds",
   L"data/actor/mokou/texture/skillExp0001.dds",
   L"data/actor/mokou/texture/skillE_fire0000.dds",
   L"data/actor/mokou/texture/skillE_fire0001.dds",
   L"data/actor/mokou/texture/skillE_fire0002.dds",
   L"data/actor/mokou/texture/skillF_mokoFire0000.png",
   L"data/actor/mokou/texture/skillF_mokoFire0001.png",
   L"data/actor/mokou/texture/skillF_mokoFire0002.png",
   L"data/actor/mokou/texture/skillF_mokoFire0003.png",
   L"data/actor/mokou/texture/skillF_mokoFire0004.png",
   L"data/actor/mokou/texture/skillF_mokoFire0005.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0000.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0001.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0002.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0003.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0004.png",
   L"data/actor/mokou/texture/skillF_mokoFireB0005.png",
   L"data/actor/mokou/texture/spellA_fire0000.dds",
   L"data/actor/mokou/texture/spellA_fire0001.png",
   L"data/actor/mokou/texture/spellA_fireVortex0000.dds",
   L"data/actor/mokou/texture/spellA_fireVortex0000.png",
   L"data/actor/mokou/texture/spellA_fireVortex0001.dds",
   L"data/actor/mokou/texture/spellA_fireVortex0002.dds",
   L"data/actor/mokou/texture/spellA_firevortex0003.png",
   L"data/actor/mokou/texture/spellA_fireVortex0004.png",
   L"data/actor/mokou/texture/spellA_fireVortex0005.png",
   L"data/actor/mokou/texture/spellB_fujiFire.dds",
   L"data/actor/mokou/texture/spellB_fujiFireB.dds",
   L"data/actor/mokou/texture/spellB_slash0000.dds",
   L"data/actor/mokou/texture/spellB_slash0001.dds",
   L"data/actor/mokou/texture/spellB_stone0000.dds",
   L"data/actor/mokou/texture/spellC_fire.dds",
   L"data/actor/mokou/texture/spellC_fire0001.dds",
   L"data/actor/mokou/texture/spell_use_cut.png",
   L"data/actor/mokou/texture/win_mokou.png",
   L"data/actor/mokou/walkBack0000.bmp",
   L"data/actor/mokou/walkBack0001.bmp",
   L"data/actor/mokou/walkBack0002.bmp",
   L"data/actor/mokou/walkBack0003.bmp",
   L"data/actor/mokou/walkBackloop0000.bmp",
   L"data/actor/mokou/walkBackloop0001.bmp",
   L"data/actor/mokou/walkBackloop0002.bmp",
   L"data/actor/mokou/walkBackloop0003.bmp",
   L"data/actor/mokou/walkFront0000.bmp",
   L"data/actor/mokou/walkFront0001.bmp",
   L"data/actor/mokou/walkFront0002.bmp",
   L"data/actor/mokou/walkFront0003.bmp",
   L"data/actor/mokou/walkFront0004.bmp",
   L"data/actor/mokou/walkFrontLoop0000.bmp",
   L"data/actor/mokou/walkFrontLoop0001.bmp",
   L"data/actor/mokou/walkFrontLoop0002.bmp",
   L"data/actor/mokou/walkFrontLoop0003.bmp",
   L"data/actor/mokou/winA0000.bmp",
   L"data/actor/mokou/winA0001.bmp",
   L"data/actor/mokou/winA0002.bmp",
   L"data/actor/mokou/winA0003.bmp",
   L"data/actor/mokou/winA0004.bmp",
   L"data/actor/mokou/winA0005.bmp",
   L"data/actor/mokou/winB0000.bmp",
   L"data/actor/mokou/winB0001.bmp",
   L"data/actor/mokou/winB0002.bmp",
   L"data/actor/mokou/winB0003.bmp",
   L"data/actor/mokou/winB0004.bmp",
   L"data/actor/mokou/winB0005.bmp",
   L"data/actor/mokou/winB0006.bmp",
   L"data/actor/mokou/winB0007.bmp",
   L"data/actor/mokou/wingA0000.bmp",
   L"data/actor/mokou/wingA0001.bmp",
   L"data/actor/mokou/wingA0002.bmp",
   L"data/actor/mokou/wingA0003.bmp",
   L"data/actor/mokou/wingA0004.bmp",
   L"data/actor/mokou/wingA0005.bmp",
   L"data/actor/mokou/wingA0006.bmp",
   L"data/actor/mokou/wingAb0000.bmp",
   L"data/actor/mokou/wingAb0001.bmp",
   L"data/actor/mokou/wingAb0002.bmp",
   L"data/actor/mokou/wingAb0003.bmp",
   L"data/actor/mokou/wingAb0004.bmp",
   L"data/actor/mokou/wingAb0005.bmp",
   L"data/actor/mokou/wingAb0006.bmp",
   L"data/actor/mokou/wingB0000.bmp",
   L"data/actor/mokou/wingB0001.bmp",
   L"data/actor/mokou/wingB0002.bmp",
   L"data/actor/mokou/wingB0003.bmp",
   L"data/actor/mokou/wingB0004.bmp",
   L"data/actor/mokou/wingB0005.bmp",
   L"data/actor/mokou/wingB0006.bmp",
   L"data/actor/mokou/wingB0007.bmp",
   L"data/actor/mokou/wingB0008.bmp",
   L"data/actor/mokou/wingB0009.bmp",
   L"data/actor/mokou/wingB0010.bmp",
   L"data/actor/mokou/wingBb0000.bmp",
   L"data/actor/mokou/wingBb0001.bmp",
   L"data/actor/mokou/wingBb0002.bmp",
   L"data/actor/mokou/wingBb0003.bmp",
   L"data/actor/mokou/wingBb0004.bmp",
   L"data/actor/mokou/wingBb0005.bmp",
   L"data/actor/mokou/wingBb0006.bmp",
   L"data/actor/mokou/wingBb0007.bmp",
   L"data/actor/mokou/wingBb0008.bmp",
   L"data/actor/mokou/wingBb0009.bmp",
   L"data/actor/mokou/wingBb0010.bmp",
   L"data/actor/mokou/wingC0000.bmp",
   L"data/actor/mokou/wingC0001.bmp",
   L"data/actor/mokou/wingC0002.bmp",
   L"data/actor/mokou/wingD0000.bmp",
   L"data/actor/mokou/wingD0001.bmp",
   L"data/actor/mokou/wingD0002.bmp",
   L"data/actor/mokou/wingE0000.bmp",
   L"data/actor/mokou/wingE0001.bmp",
   L"data/actor/mokou/wingE0002.bmp",
   L"data/actor/mokou/wingE0003.bmp",
   L"data/actor/mokou/wingE0004.bmp",
   L"data/actor/mokou/wingE0005.bmp",
   L"data/actor/mokou/wingE0006.bmp",
   L"data/actor/mokou/wingE0007.bmp",
   L"data/actor/mokou/wingE0008.bmp",
   L"data/actor/mokou/wingE0009.bmp",
   L"data/actor/mokou/wingE0010.bmp",
   L"data/actor/mokou/wingF0001.bmp",
   L"data/actor/mokou/wingF0002.bmp",
   L"data/actor/mokou/wingF0003.bmp",
   L"data/actor/mokou/wingF0004.bmp",
   L"data/actor/mokou/wingF0005.bmp",
   L"data/actor/mokou/wingF0006.bmp",
   L"data/actor/mokou/wingF0007.bmp",
   L"data/actor/mokou.nut",
   L"data/actor/mokou_base.nut",
   L"data/actor/mokou_boss.nut",
   L"data/actor/mokou_boss_base.nut",
   L"data/actor/mokou_boss_init.nut",
   L"data/actor/mokou_boss_shot.nut",
   L"data/actor/mokou_com.nut",
   L"data/actor/mokou_combo.nut",
   L"data/actor/mokou_com_function.nut",
   L"data/actor/mokou_init.nut",
   L"data/actor/mokou_practice_init.nut",
   L"data/actor/mokou_shot.nut",
   L"data/actor/mokou_team.nut",
   L"data/actor/namazu/namazu.pat",
   L"data/actor/namazu/palette000.bmp",
   L"data/actor/namazu/texture/namazu0000.png",
   L"data/actor/namazu/texture/namazu0001.png",
   L"data/actor/namazu/texture/namazu0002.png",
   L"data/actor/namazu/texture/namazu_damage0000.png",
   L"data/actor/namazu/texture/namazu_jump0000.png",
   L"data/actor/namazu/texture/stand0000.bmp",
   L"data/actor/nitori/armHead0000.bmp",
   L"data/actor/nitori/armHead0001.bmp",
   L"data/actor/nitori/armPoint.bmp",
   L"data/actor/nitori/armWire0000.bmp",
   L"data/actor/nitori/atkHigh0000.bmp",
   L"data/actor/nitori/atkHigh0001.bmp",
   L"data/actor/nitori/atkHigh0002.bmp",
   L"data/actor/nitori/atkHigh0003.bmp",
   L"data/actor/nitori/atkHigh0004.bmp",
   L"data/actor/nitori/atkHigh0005.bmp",
   L"data/actor/nitori/atkHigh0006.bmp",
   L"data/actor/nitori/atkHigh0007.bmp",
   L"data/actor/nitori/atkHighFront0000.bmp",
   L"data/actor/nitori/atkHighFront0001.bmp",
   L"data/actor/nitori/atkHighFront0002.bmp",
   L"data/actor/nitori/atkHighFront0003.bmp",
   L"data/actor/nitori/atkHighFront0004.bmp",
   L"data/actor/nitori/atkHighFront0005.bmp",
   L"data/actor/nitori/atkHighFront0006.bmp",
   L"data/actor/nitori/atkHighFront0007.bmp",
   L"data/actor/nitori/atkHighFront0008.bmp",
   L"data/actor/nitori/atkHighUnder0000.bmp",
   L"data/actor/nitori/atkHighUnder0001.bmp",
   L"data/actor/nitori/atkHighUnder0002.bmp",
   L"data/actor/nitori/atkHighUnder0003.bmp",
   L"data/actor/nitori/atkHighUnder0004.bmp",
   L"data/actor/nitori/atkHighUnder0005.bmp",
   L"data/actor/nitori/atkHighUnder0006.bmp",
   L"data/actor/nitori/atkHighUnder0007.bmp",
   L"data/actor/nitori/atkHighUpper0000.bmp",
   L"data/actor/nitori/atkHighUpper0001.bmp",
   L"data/actor/nitori/atkHighUpper0002.bmp",
   L"data/actor/nitori/atkHighUpper0003.bmp",
   L"data/actor/nitori/atkHighUpper0004.bmp",
   L"data/actor/nitori/atkHighUpper0005.bmp",
   L"data/actor/nitori/atkHighUpper0006.bmp",
   L"data/actor/nitori/atkHighUpper0007.bmp",
   L"data/actor/nitori/atkHighUpper0008.bmp",
   L"data/actor/nitori/atkHighUpper0009.bmp",
   L"data/actor/nitori/atkHighUpper0010.bmp",
   L"data/actor/nitori/atkHighUpper0011.bmp",
   L"data/actor/nitori/atkLow0000.bmp",
   L"data/actor/nitori/atkLow0001.bmp",
   L"data/actor/nitori/atkLow0002.bmp",
   L"data/actor/nitori/atkLow0003.bmp",
   L"data/actor/nitori/atkLow0004.bmp",
   L"data/actor/nitori/atkLow0005.bmp",
   L"data/actor/nitori/atkLow0006.bmp",
   L"data/actor/nitori/atkLow0007.bmp",
   L"data/actor/nitori/atkLow0008.bmp",
   L"data/actor/nitori/atkLow0009.bmp",
   L"data/actor/nitori/atkMid0000.bmp",
   L"data/actor/nitori/atkMid0001.bmp",
   L"data/actor/nitori/atkMid0002.bmp",
   L"data/actor/nitori/atkMid0003.bmp",
   L"data/actor/nitori/atkMid0004.bmp",
   L"data/actor/nitori/atkMid0005.bmp",
   L"data/actor/nitori/atkMid0006.bmp",
   L"data/actor/nitori/atkMid0007.bmp",
   L"data/actor/nitori/atkMid0008.bmp",
   L"data/actor/nitori/balloonA0000.bmp",
   L"data/actor/nitori/battleBeginA0000.bmp",
   L"data/actor/nitori/battleBeginA0001.bmp",
   L"data/actor/nitori/battleBeginA0002.bmp",
   L"data/actor/nitori/battleBeginA0003.bmp",
   L"data/actor/nitori/battleBeginA0004.bmp",
   L"data/actor/nitori/battleBeginA0005.bmp",
   L"data/actor/nitori/battleBeginA0006.bmp",
   L"data/actor/nitori/battleBeginA0007.bmp",
   L"data/actor/nitori/battleBeginB0000.bmp",
   L"data/actor/nitori/battleBeginB0001.bmp",
   L"data/actor/nitori/battleBeginB0002.bmp",
   L"data/actor/nitori/battleBeginB0003.bmp",
   L"data/actor/nitori/bmsln/nitori_AquaExp.bmb",
   L"data/actor/nitori/bmsln/nitori_climaxFire.bmb",
   L"data/actor/nitori/bmsln/nitori_fireWork.bmb",
   L"data/actor/nitori/canonA0000.bmp",
   L"data/actor/nitori/canonA0001.bmp",
   L"data/actor/nitori/canonA0002.bmp",
   L"data/actor/nitori/climax0000.bmp",
   L"data/actor/nitori/climax0001.bmp",
   L"data/actor/nitori/climax0002.bmp",
   L"data/actor/nitori/climax0003.bmp",
   L"data/actor/nitori/climax0004.bmp",
   L"data/actor/nitori/climax0005.bmp",
   L"data/actor/nitori/climax0006.bmp",
   L"data/actor/nitori/climax0007.bmp",
   L"data/actor/nitori/climax0008.bmp",
   L"data/actor/nitori/climax0009.bmp",
   L"data/actor/nitori/climaxMantle.bmp",
   L"data/actor/nitori/climaxMantleFlash.png",
   L"data/actor/nitori/climaxMaskA000.bmp",
   L"data/actor/nitori/damageBody0000.bmp",
   L"data/actor/nitori/damageBody0001.bmp",
   L"data/actor/nitori/damageBody0002.bmp",
   L"data/actor/nitori/damageBody0003.bmp",
   L"data/actor/nitori/damageBody0004.bmp",
   L"data/actor/nitori/damageDown0000.bmp",
   L"data/actor/nitori/damageDown0001.bmp",
   L"data/actor/nitori/damageDown0002.bmp",
   L"data/actor/nitori/damageDown0003.bmp",
   L"data/actor/nitori/damageDown0004.bmp",
   L"data/actor/nitori/damageDown0005.bmp",
   L"data/actor/nitori/damageDown0006.bmp",
   L"data/actor/nitori/damageDown0007.bmp",
   L"data/actor/nitori/damageHead0000.bmp",
   L"data/actor/nitori/damageHead0001.bmp",
   L"data/actor/nitori/damageHead0002.bmp",
   L"data/actor/nitori/damageHead0003.bmp",
   L"data/actor/nitori/damageHead0004.bmp",
   L"data/actor/nitori/damageSpin0000.bmp",
   L"data/actor/nitori/damageSpin0001.bmp",
   L"data/actor/nitori/damageSpin0002.bmp",
   L"data/actor/nitori/damageSpin0003.bmp",
   L"data/actor/nitori/damageUpper0000.bmp",
   L"data/actor/nitori/damageUpper0001.bmp",
   L"data/actor/nitori/damageUpper0002.bmp",
   L"data/actor/nitori/damageUpper0003.bmp",
   L"data/actor/nitori/damageUpper0004.bmp",
   L"data/actor/nitori/damageUpper0005.bmp",
   L"data/actor/nitori/damageUpper0006.bmp",
   L"data/actor/nitori/damageUpper0007.bmp",
   L"data/actor/nitori/damageUpper0008.bmp",
   L"data/actor/nitori/damageUpper0009.bmp",
   L"data/actor/nitori/damageUpper0010.bmp",
   L"data/actor/nitori/damageUpper0011.bmp",
   L"data/actor/nitori/damageUpper0012.bmp",
   L"data/actor/nitori/damageWall0000.bmp",
   L"data/actor/nitori/damageWall0001.bmp",
   L"data/actor/nitori/damageWall0002.bmp",
   L"data/actor/nitori/damageWall0003.bmp",
   L"data/actor/nitori/damageWall0004.bmp",
   L"data/actor/nitori/damageWall0005.bmp",
   L"data/actor/nitori/damageWall0006.bmp",
   L"data/actor/nitori/damageWall0007.bmp",
   L"data/actor/nitori/dashBack0000.bmp",
   L"data/actor/nitori/dashBack0001.bmp",
   L"data/actor/nitori/dashBack0002.bmp",
   L"data/actor/nitori/dashBack0003.bmp",
   L"data/actor/nitori/dashBack0004.bmp",
   L"data/actor/nitori/dashBack0005.bmp",
   L"data/actor/nitori/dashBackLoop0000.bmp",
   L"data/actor/nitori/dashBackLoop0001.bmp",
   L"data/actor/nitori/dashBackLoop0002.bmp",
   L"data/actor/nitori/dashFront0000.bmp",
   L"data/actor/nitori/dashFront0001.bmp",
   L"data/actor/nitori/dashFront0002.bmp",
   L"data/actor/nitori/dashFront0003.bmp",
   L"data/actor/nitori/dashFront0004.bmp",
   L"data/actor/nitori/dashFront0005.bmp",
   L"data/actor/nitori/dashFront0006.bmp",
   L"data/actor/nitori/dashFront0007.bmp",
   L"data/actor/nitori/dashFrontLoop0000.bmp",
   L"data/actor/nitori/dashFrontLoop0001.bmp",
   L"data/actor/nitori/dashFrontLoop0002.bmp",
   L"data/actor/nitori/face_spellCallB.png",
   L"data/actor/nitori/grab0000.bmp",
   L"data/actor/nitori/grab0001.bmp",
   L"data/actor/nitori/grab0002.bmp",
   L"data/actor/nitori/grab0003.bmp",
   L"data/actor/nitori/grab0004.bmp",
   L"data/actor/nitori/grab0005.bmp",
   L"data/actor/nitori/grab0006.bmp",
   L"data/actor/nitori/grab_hit0000.bmp",
   L"data/actor/nitori/grab_hit0001.bmp",
   L"data/actor/nitori/grab_hit0002.bmp",
   L"data/actor/nitori/grab_hit0003.bmp",
   L"data/actor/nitori/grab_hit0004.bmp",
   L"data/actor/nitori/grab_hit0005.bmp",
   L"data/actor/nitori/grab_hit0006.bmp",
   L"data/actor/nitori/grab_hit0007.bmp",
   L"data/actor/nitori/grab_hit0008.bmp",
   L"data/actor/nitori/guard0000.bmp",
   L"data/actor/nitori/guard0001.bmp",
   L"data/actor/nitori/guard0002.bmp",
   L"data/actor/nitori/guard0003.bmp",
   L"data/actor/nitori/guardCrash0000.bmp",
   L"data/actor/nitori/guardCrash0001.bmp",
   L"data/actor/nitori/guardCrash0002.bmp",
   L"data/actor/nitori/guardCrash0003.bmp",
   L"data/actor/nitori/guardCrash0004.bmp",
   L"data/actor/nitori/guardCrash0005.bmp",
   L"data/actor/nitori/guardMiss0000.bmp",
   L"data/actor/nitori/guardMiss0001.bmp",
   L"data/actor/nitori/guardMiss0002.bmp",
   L"data/actor/nitori/guardMiss0003.bmp",
   L"data/actor/nitori/item0000.bmp",
   L"data/actor/nitori/item0001.bmp",
   L"data/actor/nitori/item0002.bmp",
   L"data/actor/nitori/item0003.bmp",
   L"data/actor/nitori/item0004.bmp",
   L"data/actor/nitori/item0005.bmp",
   L"data/actor/nitori/item0006.bmp",
   L"data/actor/nitori/item0007.bmp",
   L"data/actor/nitori/lose0000.bmp",
   L"data/actor/nitori/lose0001.bmp",
   L"data/actor/nitori/lose0002.bmp",
   L"data/actor/nitori/lose0003.bmp",
   L"data/actor/nitori/lose0004.bmp",
   L"data/actor/nitori/lose0005.bmp",
   L"data/actor/nitori/lose0006.bmp",
   L"data/actor/nitori/lose0007.bmp",
   L"data/actor/nitori/nitori.pat",
   L"data/actor/nitori/nitori_ed.pat",
   L"data/actor/nitori/occult0000.bmp",
   L"data/actor/nitori/occult0001.bmp",
   L"data/actor/nitori/occult0002.bmp",
   L"data/actor/nitori/occult0003.bmp",
   L"data/actor/nitori/occult0004.bmp",
   L"data/actor/nitori/occultloop0000.bmp",
   L"data/actor/nitori/occultloop0001.bmp",
   L"data/actor/nitori/occultloop0002.bmp",
   L"data/actor/nitori/occultloop0003.bmp",
   L"data/actor/nitori/occultloop0004.bmp",
   L"data/actor/nitori/occultswitch0000.bmp",
   L"data/actor/nitori/occultswitch0001.bmp",
   L"data/actor/nitori/occultswitch0002.bmp",
   L"data/actor/nitori/occultswitch0003.bmp",
   L"data/actor/nitori/occultswitch0004.bmp",
   L"data/actor/nitori/occult_nessy0000.bmp",
   L"data/actor/nitori/occult_nessy0001.bmp",
   L"data/actor/nitori/occult_nessy0002.bmp",
   L"data/actor/nitori/occult_nessy0003.bmp",
   L"data/actor/nitori/palette000.bmp",
   L"data/actor/nitori/palette001.bmp",
   L"data/actor/nitori/palette002.bmp",
   L"data/actor/nitori/palette003.bmp",
   L"data/actor/nitori/palette004.bmp",
   L"data/actor/nitori/palette005.bmp",
   L"data/actor/nitori/palette006.bmp",
   L"data/actor/nitori/palette007.bmp",
   L"data/actor/nitori/palette100.bmp",
   L"data/actor/nitori/palette101.bmp",
   L"data/actor/nitori/palette102.bmp",
   L"data/actor/nitori/palette103.bmp",
   L"data/actor/nitori/palette104.bmp",
   L"data/actor/nitori/palette105.bmp",
   L"data/actor/nitori/palette106.bmp",
   L"data/actor/nitori/palette107.bmp",
   L"data/actor/nitori/pallete.bmp",
   L"data/actor/nitori/shotExpA0000.bmp",
   L"data/actor/nitori/shotHigh0000.bmp",
   L"data/actor/nitori/shotHigh0001.bmp",
   L"data/actor/nitori/shotHigh0002.bmp",
   L"data/actor/nitori/shotHigh0003.bmp",
   L"data/actor/nitori/shotHigh0004.bmp",
   L"data/actor/nitori/shotHigh0005.bmp",
   L"data/actor/nitori/shotHigh0006.bmp",
   L"data/actor/nitori/shotHigh0007.bmp",
   L"data/actor/nitori/shotHigh0008.bmp",
   L"data/actor/nitori/shotHighUnder0000.bmp",
   L"data/actor/nitori/shotHighUnder0001.bmp",
   L"data/actor/nitori/shotHighUnder0002.bmp",
   L"data/actor/nitori/shotHighUnder0003.bmp",
   L"data/actor/nitori/shotHighUnder0004.bmp",
   L"data/actor/nitori/shotHighUnder0005.bmp",
   L"data/actor/nitori/shotHighUnder0006.bmp",
   L"data/actor/nitori/shotHighUnder0007.bmp",
   L"data/actor/nitori/shotHighUnder0008.bmp",
   L"data/actor/nitori/shotLow0000.bmp",
   L"data/actor/nitori/shotLow0001.bmp",
   L"data/actor/nitori/shotLow0002.bmp",
   L"data/actor/nitori/shotLow0003.bmp",
   L"data/actor/nitori/shotLow0004.bmp",
   L"data/actor/nitori/shotLow0005.bmp",
   L"data/actor/nitori/shotLow0006.bmp",
   L"data/actor/nitori/shotLow0007.bmp",
   L"data/actor/nitori/shotLowUnder0001.bmp",
   L"data/actor/nitori/shotLowUnder0002.bmp",
   L"data/actor/nitori/shotLowUpper0000.bmp",
   L"data/actor/nitori/shotLowUpper0002.bmp",
   L"data/actor/nitori/skillA0000.bmp",
   L"data/actor/nitori/skillA0001.bmp",
   L"data/actor/nitori/skillA0002.bmp",
   L"data/actor/nitori/skillA0003.bmp",
   L"data/actor/nitori/skillA0004.bmp",
   L"data/actor/nitori/skillA0005.bmp",
   L"data/actor/nitori/skillA0006.bmp",
   L"data/actor/nitori/skillA0007.bmp",
   L"data/actor/nitori/skillB0000.bmp",
   L"data/actor/nitori/skillB0001.bmp",
   L"data/actor/nitori/skillB0002.bmp",
   L"data/actor/nitori/skillB0003.bmp",
   L"data/actor/nitori/skillB0004.bmp",
   L"data/actor/nitori/skillB0005.bmp",
   L"data/actor/nitori/skillB0006.bmp",
   L"data/actor/nitori/skillB0007.bmp",
   L"data/actor/nitori/skillBb0000.bmp",
   L"data/actor/nitori/skillC0000.bmp",
   L"data/actor/nitori/skillC0001.bmp",
   L"data/actor/nitori/skillC0002.bmp",
   L"data/actor/nitori/skillC0003.bmp",
   L"data/actor/nitori/skillC0004.bmp",
   L"data/actor/nitori/skillC0005.bmp",
   L"data/actor/nitori/skillC0006.bmp",
   L"data/actor/nitori/skillC0007.bmp",
   L"data/actor/nitori/skillD0000.bmp",
   L"data/actor/nitori/skillD0001.bmp",
   L"data/actor/nitori/skillD0002.bmp",
   L"data/actor/nitori/skillD0003.bmp",
   L"data/actor/nitori/skillD0004.bmp",
   L"data/actor/nitori/skillD0005.bmp",
   L"data/actor/nitori/skillD0006.bmp",
   L"data/actor/nitori/skillD0007.bmp",
   L"data/actor/nitori/skillE0000.bmp",
   L"data/actor/nitori/skillE0001.bmp",
   L"data/actor/nitori/skillE0002.bmp",
   L"data/actor/nitori/skillE0003.bmp",
   L"data/actor/nitori/skillE0004.bmp",
   L"data/actor/nitori/skillE0005.bmp",
   L"data/actor/nitori/skillE0006.bmp",
   L"data/actor/nitori/skillE0007.bmp",
   L"data/actor/nitori/skillE0008.bmp",
   L"data/actor/nitori/skillE0009.bmp",
   L"data/actor/nitori/skillE0010.bmp",
   L"data/actor/nitori/skillE0011.bmp",
   L"data/actor/nitori/skillE0012.bmp",
   L"data/actor/nitori/skillE0013.bmp",
   L"data/actor/nitori/skillE0014.bmp",
   L"data/actor/nitori/skillG0000.bmp",
   L"data/actor/nitori/skillG0001.bmp",
   L"data/actor/nitori/skillG0002.bmp",
   L"data/actor/nitori/skillG0003.bmp",
   L"data/actor/nitori/skillG0004.bmp",
   L"data/actor/nitori/skillG0005.bmp",
   L"data/actor/nitori/skillG0006.bmp",
   L"data/actor/nitori/skillG_Loop0000.bmp",
   L"data/actor/nitori/skillG_Loop0001.bmp",
   L"data/actor/nitori/skillG_Loop0002.bmp",
   L"data/actor/nitori/skill_drill0000.bmp",
   L"data/actor/nitori/skill_drill0001.bmp",
   L"data/actor/nitori/skill_drill0002.bmp",
   L"data/actor/nitori/skill_drill0003.bmp",
   L"data/actor/nitori/skill_drill0004.bmp",
   L"data/actor/nitori/skill_drill0005.bmp",
   L"data/actor/nitori/skill_drill0006.bmp",
   L"data/actor/nitori/skill_drill0007.bmp",
   L"data/actor/nitori/skill_drill0008.bmp",
   L"data/actor/nitori/skill_drill0009.bmp",
   L"data/actor/nitori/skill_drill0010.bmp",
   L"data/actor/nitori/skill_drill0011.bmp",
   L"data/actor/nitori/skill_drill0012.bmp",
   L"data/actor/nitori/skill_drill0013.bmp",
   L"data/actor/nitori/slide0000.bmp",
   L"data/actor/nitori/slide0001.bmp",
   L"data/actor/nitori/slide0002.bmp",
   L"data/actor/nitori/slide0003.bmp",
   L"data/actor/nitori/slide0004.bmp",
   L"data/actor/nitori/slide0005.bmp",
   L"data/actor/nitori/slide0006.bmp",
   L"data/actor/nitori/slide0007.bmp",
   L"data/actor/nitori/slide0008.bmp",
   L"data/actor/nitori/slide0009.bmp",
   L"data/actor/nitori/slide0010.bmp",
   L"data/actor/nitori/slideLoopUnder0000.bmp",
   L"data/actor/nitori/slideLoopUnder0001.bmp",
   L"data/actor/nitori/slideLoopUnder0002.bmp",
   L"data/actor/nitori/slideLoopUnder0003.bmp",
   L"data/actor/nitori/slideLoopUnder0004.bmp",
   L"data/actor/nitori/slideLoopUpper0000.bmp",
   L"data/actor/nitori/slideLoopUpper0001.bmp",
   L"data/actor/nitori/slideLoopUpper0002.bmp",
   L"data/actor/nitori/spellA0000.bmp",
   L"data/actor/nitori/spellA0001.bmp",
   L"data/actor/nitori/spellA0002.bmp",
   L"data/actor/nitori/spellA0003.bmp",
   L"data/actor/nitori/spellA0004.bmp",
   L"data/actor/nitori/spellA0005.bmp",
   L"data/actor/nitori/spellA0006.bmp",
   L"data/actor/nitori/spellA0007.bmp",
   L"data/actor/nitori/spellA0008.bmp",
   L"data/actor/nitori/spellB0000.bmp",
   L"data/actor/nitori/spellB0001.bmp",
   L"data/actor/nitori/spellB0002.bmp",
   L"data/actor/nitori/spellB0003.bmp",
   L"data/actor/nitori/spellB0004.bmp",
   L"data/actor/nitori/spellB0005.bmp",
   L"data/actor/nitori/spellB0006.bmp",
   L"data/actor/nitori/spellB0007.bmp",
   L"data/actor/nitori/spellB0008.bmp",
   L"data/actor/nitori/spellB0009.bmp",
   L"data/actor/nitori/spellBack.png",
   L"data/actor/nitori/spellC0000.bmp",
   L"data/actor/nitori/spellC0001.bmp",
   L"data/actor/nitori/spellC0002.bmp",
   L"data/actor/nitori/spellC0003.bmp",
   L"data/actor/nitori/spellC0004.bmp",
   L"data/actor/nitori/spellC0005.bmp",
   L"data/actor/nitori/spellC0006.bmp",
   L"data/actor/nitori/spellC0007.bmp",
   L"data/actor/nitori/spellC0008.bmp",
   L"data/actor/nitori/spellC0009.bmp",
   L"data/actor/nitori/spellC0010.bmp",
   L"data/actor/nitori/spellC0011.bmp",
   L"data/actor/nitori/stand0000.bmp",
   L"data/actor/nitori/stand0001.bmp",
   L"data/actor/nitori/stand0002.bmp",
   L"data/actor/nitori/stand0003.bmp",
   L"data/actor/nitori/stand0004.bmp",
   L"data/actor/nitori/stand0005.bmp",
   L"data/actor/nitori/stand0006.bmp",
   L"data/actor/nitori/stand0007.bmp",
   L"data/actor/nitori/stand0008.bmp",
   L"data/actor/nitori/stand0009.bmp",
   L"data/actor/nitori/stand0010.bmp",
   L"data/actor/nitori/stand0011.bmp",
   L"data/actor/nitori/stand0012.bmp",
   L"data/actor/nitori/stun0000.bmp",
   L"data/actor/nitori/stun0001.bmp",
   L"data/actor/nitori/stun0002.bmp",
   L"data/actor/nitori/stunLoop0000.bmp",
   L"data/actor/nitori/stunLoop0001.bmp",
   L"data/actor/nitori/stunLoop0002.bmp",
   L"data/actor/nitori/stunLoop0003.bmp",
   L"data/actor/nitori/stunLoop0004.bmp",
   L"data/actor/nitori/team_begin_A0000.bmp",
   L"data/actor/nitori/team_begin_A0001.bmp",
   L"data/actor/nitori/team_begin_A0002.bmp",
   L"data/actor/nitori/team_begin_A0003.bmp",
   L"data/actor/nitori/team_begin_A0004.bmp",
   L"data/actor/nitori/team_begin_A0005.bmp",
   L"data/actor/nitori/team_begin_A0006.bmp",
   L"data/actor/nitori/team_begin_A0007.bmp",
   L"data/actor/nitori/testr_climaxback0000.png",
   L"data/actor/nitori/testr_climaxback0003.png",
   L"data/actor/nitori/testr_climaxFace.png",
   L"data/actor/nitori/testr_occult0003.png",
   L"data/actor/nitori/testr_occult0006.png",
   L"data/actor/nitori/test_atkDashLow0000.bmp",
   L"data/actor/nitori/test_atkDashLow0001.bmp",
   L"data/actor/nitori/test_atkDashLow0002.bmp",
   L"data/actor/nitori/test_atkDashLow0003.bmp",
   L"data/actor/nitori/test_atkDashLow0004.bmp",
   L"data/actor/nitori/test_atkDashLow0005.bmp",
   L"data/actor/nitori/test_atkDashLow0006.bmp",
   L"data/actor/nitori/test_atkDashLow0007.bmp",
   L"data/actor/nitori/test_atkDashLow0008.bmp",
   L"data/actor/nitori/test_atkDashLow0009.bmp",
   L"data/actor/nitori/test_atkDashLow0010.bmp",
   L"data/actor/nitori/test_atkDashLow0011.bmp",
   L"data/actor/nitori/texture/ball.png",
   L"data/actor/nitori/texture/bigWave.png",
   L"data/actor/nitori/texture/bubble0000.png",
   L"data/actor/nitori/texture/bulletFb000.bmp",
   L"data/actor/nitori/texture/bulletKa000.bmp",
   L"data/actor/nitori/texture/bullet_rainA000.bmp",
   L"data/actor/nitori/texture/chargeB.png",
   L"data/actor/nitori/texture/climaxback.png",
   L"data/actor/nitori/texture/climax_cut0000.dds",
   L"data/actor/nitori/texture/climax_fire0001.dds",
   L"data/actor/nitori/texture/climax_lake0000.dds",
   L"data/actor/nitori/texture/climax_smokeA.png",
   L"data/actor/nitori/texture/face_master_nitori.png",
   L"data/actor/nitori/texture/face_master_nitori2.png",
   L"data/actor/nitori/texture/face_slave_nitori.png",
   L"data/actor/nitori/texture/face_spell_cut_0000.png",
   L"data/actor/nitori/texture/fireWorkA0000.png",
   L"data/actor/nitori/texture/gearA0000.dds",
   L"data/actor/nitori/texture/lightBar.png",
   L"data/actor/nitori/texture/marisa_SaturnA.png",
   L"data/actor/nitori/texture/nessy0000.dds",
   L"data/actor/nitori/texture/nessyponp0000.dds",
   L"data/actor/nitori/texture/nitori_animalDamage000.png",
   L"data/actor/nitori/texture/nitori_animalDamage001.png",
   L"data/actor/nitori/texture/nitori_animalDamage002.png",
   L"data/actor/nitori/texture/nitori_animalDamage003.png",
   L"data/actor/nitori/texture/nitori_animal_00000.png",
   L"data/actor/nitori/texture/nitori_animal_00001.png",
   L"data/actor/nitori/texture/nitori_animal_00002.png",
   L"data/actor/nitori/texture/nitori_animal_00003.png",
   L"data/actor/nitori/texture/nitori_animal_00004.png",
   L"data/actor/nitori/texture/nitori_animal_00005.png",
   L"data/actor/nitori/texture/nitori_animal_00006.png",
   L"data/actor/nitori/texture/nitori_animal_00007.png",
   L"data/actor/nitori/texture/nitori_animal_00008.png",
   L"data/actor/nitori/texture/nitori_animal_00009.png",
   L"data/actor/nitori/texture/nitori_animal_00010.png",
   L"data/actor/nitori/texture/nitori_animal_00011.png",
   L"data/actor/nitori/texture/nitori_bar.png",
   L"data/actor/nitori/texture/nitori_guage.png",
   L"data/actor/nitori/texture/nitori_mistloop0000.png",
   L"data/actor/nitori/texture/nitori_mistloop0001.png",
   L"data/actor/nitori/texture/nitori_mistloop0002.png",
   L"data/actor/nitori/texture/nitori_nessyeye0000.png",
   L"data/actor/nitori/texture/rain.png",
   L"data/actor/nitori/texture/rotorA.png",
   L"data/actor/nitori/texture/rotorBladeA0000.png",
   L"data/actor/nitori/texture/rotorBrake.png",
   L"data/actor/nitori/texture/searchlight.png",
   L"data/actor/nitori/texture/skillA.png",
   L"data/actor/nitori/texture/skillD0000.png",
   L"data/actor/nitori/texture/skillDD0001.png",
   L"data/actor/nitori/texture/skillG_bullet.png",
   L"data/actor/nitori/texture/spell_use_cut.png",
   L"data/actor/nitori/texture/spinWatarA0000.dds",
   L"data/actor/nitori/texture/splashA.png",
   L"data/actor/nitori/texture/splushA000.bmp",
   L"data/actor/nitori/texture/StarFlare.bmp",
   L"data/actor/nitori/texture/watarsplash0000.png",
   L"data/actor/nitori/texture/watarsplash0001.dds",
   L"data/actor/nitori/texture/waterBulletA0000.png",
   L"data/actor/nitori/texture/win_nitori.png",
   L"data/actor/nitori/turn0001.bmp",
   L"data/actor/nitori/turn0002.bmp",
   L"data/actor/nitori/turn0003.bmp",
   L"data/actor/nitori/walkBack0000.bmp",
   L"data/actor/nitori/walkBack0001.bmp",
   L"data/actor/nitori/walkBack0002.bmp",
   L"data/actor/nitori/walkBack0003.bmp",
   L"data/actor/nitori/walkBack0004.bmp",
   L"data/actor/nitori/walkBack0005.bmp",
   L"data/actor/nitori/walkBack0006.bmp",
   L"data/actor/nitori/walkBackloop0000.bmp",
   L"data/actor/nitori/walkBackloop0001.bmp",
   L"data/actor/nitori/walkBackloop0002.bmp",
   L"data/actor/nitori/walkBackloop0003.bmp",
   L"data/actor/nitori/walkBackloop0004.bmp",
   L"data/actor/nitori/walkFront0000.bmp",
   L"data/actor/nitori/walkFront0001.bmp",
   L"data/actor/nitori/walkFront0002.bmp",
   L"data/actor/nitori/walkFront0003.bmp",
   L"data/actor/nitori/walkFront0004.bmp",
   L"data/actor/nitori/walkFront0005.bmp",
   L"data/actor/nitori/walkFrontLoop0000.bmp",
   L"data/actor/nitori/walkFrontLoop0001.bmp",
   L"data/actor/nitori/walkFrontLoop0002.bmp",
   L"data/actor/nitori/walkFrontLoop0003.bmp",
   L"data/actor/nitori/walkFrontLoop0004.bmp",
   L"data/actor/nitori/winA0000.bmp",
   L"data/actor/nitori/winA0001.bmp",
   L"data/actor/nitori/winA0002.bmp",
   L"data/actor/nitori/winA0003.bmp",
   L"data/actor/nitori/winA0004.bmp",
   L"data/actor/nitori/winA0005.bmp",
   L"data/actor/nitori/winA0006.bmp",
   L"data/actor/nitori/WinB0000.bmp",
   L"data/actor/nitori/WinB0001.bmp",
   L"data/actor/nitori/WinB0002.bmp",
   L"data/actor/nitori/WinB0003.bmp",
   L"data/actor/nitori/WinB0004.bmp",
   L"data/actor/nitori/WinB0005.bmp",
   L"data/actor/nitori/WinB0006.bmp",
   L"data/actor/nitori/WinB0007.bmp",
   L"data/actor/nitori.nut",
   L"data/actor/nitori_base.nut",
   L"data/actor/nitori_boss.nut",
   L"data/actor/nitori_boss_base.nut",
   L"data/actor/nitori_boss_init.nut",
   L"data/actor/nitori_boss_shot.nut",
   L"data/actor/nitori_com.nut",
   L"data/actor/nitori_combo.nut",
   L"data/actor/nitori_com_function.nut",
   L"data/actor/nitori_init.nut",
   L"data/actor/nitori_practice_init.nut",
   L"data/actor/nitori_shot.nut",
   L"data/actor/nitori_team.nut",
   L"data/actor/object_common.nut",
   L"data/actor/player_boss_move.nut",
   L"data/actor/player_common_move.nut",
   L"data/actor/player_story_move.nut",
   L"data/actor/player_team_move.nut",
   L"data/actor/reimu/atk_a0000.bmp",
   L"data/actor/reimu/atk_a0001.bmp",
   L"data/actor/reimu/atk_a0002.bmp",
   L"data/actor/reimu/atk_a0003.bmp",
   L"data/actor/reimu/atk_a0004.bmp",
   L"data/actor/reimu/atk_a0005.bmp",
   L"data/actor/reimu/atk_a0006.bmp",
   L"data/actor/reimu/atk_a0007.bmp",
   L"data/actor/reimu/atk_a0008.bmp",
   L"data/actor/reimu/atk_dashA0000.bmp",
   L"data/actor/reimu/atk_dashA0001.bmp",
   L"data/actor/reimu/atk_dashA0002.bmp",
   L"data/actor/reimu/atk_dashA0003.bmp",
   L"data/actor/reimu/atk_dashA0004.bmp",
   L"data/actor/reimu/atk_dashA0005.bmp",
   L"data/actor/reimu/atk_dashA0006.bmp",
   L"data/actor/reimu/atk_dashA0007.bmp",
   L"data/actor/reimu/atk_dashA0008.bmp",
   L"data/actor/reimu/atk_dashA0009.bmp",
   L"data/actor/reimu/atk_dashA0010.bmp",
   L"data/actor/reimu/atk_dashB0000.bmp",
   L"data/actor/reimu/atk_dashB0001.bmp",
   L"data/actor/reimu/atk_dashB0002.bmp",
   L"data/actor/reimu/atk_dashB0003.bmp",
   L"data/actor/reimu/atk_dashB0004.bmp",
   L"data/actor/reimu/atk_dashB0005.bmp",
   L"data/actor/reimu/atk_dashB0006.bmp",
   L"data/actor/reimu/atk_dashB0007.bmp",
   L"data/actor/reimu/atk_dashB0008.bmp",
   L"data/actor/reimu/atk_dashB0009.bmp",
   L"data/actor/reimu/atk_High0000.bmp",
   L"data/actor/reimu/atk_High0001.bmp",
   L"data/actor/reimu/atk_High0002.bmp",
   L"data/actor/reimu/atk_High0003.bmp",
   L"data/actor/reimu/atk_High0004.bmp",
   L"data/actor/reimu/atk_High0005.bmp",
   L"data/actor/reimu/atk_High0006.bmp",
   L"data/actor/reimu/atk_High0007.bmp",
   L"data/actor/reimu/atk_High0008.bmp",
   L"data/actor/reimu/atk_High0009.bmp",
   L"data/actor/reimu/atk_High0010.bmp",
   L"data/actor/reimu/atk_High0011.bmp",
   L"data/actor/reimu/atk_High0012.bmp",
   L"data/actor/reimu/atk_High0013.bmp",
   L"data/actor/reimu/atk_High0014.bmp",
   L"data/actor/reimu/atk_High0015.bmp",
   L"data/actor/reimu/atk_High0016.bmp",
   L"data/actor/reimu/atk_HighB0000.bmp",
   L"data/actor/reimu/atk_HighB0001.bmp",
   L"data/actor/reimu/atk_HighB0002.bmp",
   L"data/actor/reimu/atk_HighB0003.bmp",
   L"data/actor/reimu/atk_HighB0004.bmp",
   L"data/actor/reimu/atk_HighB0005.bmp",
   L"data/actor/reimu/atk_HighB0006.bmp",
   L"data/actor/reimu/atk_HighB0007.bmp",
   L"data/actor/reimu/atk_HighB0008.bmp",
   L"data/actor/reimu/atk_HighB0009.bmp",
   L"data/actor/reimu/atk_HighB0010.bmp",
   L"data/actor/reimu/atk_HighB0011.bmp",
   L"data/actor/reimu/atk_HighC0000.bmp",
   L"data/actor/reimu/atk_HighC0001.bmp",
   L"data/actor/reimu/atk_HighC0002.bmp",
   L"data/actor/reimu/atk_HighC0003.bmp",
   L"data/actor/reimu/atk_HighC0004.bmp",
   L"data/actor/reimu/atk_HighC0005.bmp",
   L"data/actor/reimu/atk_HighC0006.bmp",
   L"data/actor/reimu/atk_HighC0007.bmp",
   L"data/actor/reimu/atk_HighC0008.bmp",
   L"data/actor/reimu/atk_HighC0009.bmp",
   L"data/actor/reimu/atk_HighC0010.bmp",
   L"data/actor/reimu/atk_HighC0011.bmp",
   L"data/actor/reimu/atk_HighC0012.bmp",
   L"data/actor/reimu/atk_HighUnder0000.bmp",
   L"data/actor/reimu/atk_HighUnder0001.bmp",
   L"data/actor/reimu/atk_HighUnder0002.bmp",
   L"data/actor/reimu/atk_HighUnder0003.bmp",
   L"data/actor/reimu/atk_HighUnder0004.bmp",
   L"data/actor/reimu/atk_HighUnder0005.bmp",
   L"data/actor/reimu/atk_HighUnder0006.bmp",
   L"data/actor/reimu/atk_HighUnder0007.bmp",
   L"data/actor/reimu/atk_HighUnder0008.bmp",
   L"data/actor/reimu/atk_HighUnder0009.bmp",
   L"data/actor/reimu/atk_HighUnder0010.bmp",
   L"data/actor/reimu/atk_HighUnder0011.bmp",
   L"data/actor/reimu/atk_HighUpper0000.bmp",
   L"data/actor/reimu/atk_HighUpper0001.bmp",
   L"data/actor/reimu/atk_HighUpper0002.bmp",
   L"data/actor/reimu/atk_HighUpper0003.bmp",
   L"data/actor/reimu/atk_HighUpper0004.bmp",
   L"data/actor/reimu/atk_HighUpper0005.bmp",
   L"data/actor/reimu/atk_HighUpper0006.bmp",
   L"data/actor/reimu/atk_HighUpper0007.bmp",
   L"data/actor/reimu/atk_HighUpper0008.bmp",
   L"data/actor/reimu/atk_HighUpper0009.bmp",
   L"data/actor/reimu/atk_HighUpper0010.bmp",
   L"data/actor/reimu/atk_HighUpper0011.bmp",
   L"data/actor/reimu/atk_HighUpper0012.bmp",
   L"data/actor/reimu/atk_HighUpper0013.bmp",
   L"data/actor/reimu/atk_HighUpper0014.bmp",
   L"data/actor/reimu/atk_Mid0000.bmp",
   L"data/actor/reimu/atk_Mid0001.bmp",
   L"data/actor/reimu/atk_Mid0002.bmp",
   L"data/actor/reimu/atk_Mid0003.bmp",
   L"data/actor/reimu/atk_Mid0004.bmp",
   L"data/actor/reimu/atk_Mid0005.bmp",
   L"data/actor/reimu/atk_Mid0006.bmp",
   L"data/actor/reimu/atk_Mid0007.bmp",
   L"data/actor/reimu/atk_Mid0008.bmp",
   L"data/actor/reimu/atk_Mid0009.bmp",
   L"data/actor/reimu/atk_Mid0010.bmp",
   L"data/actor/reimu/beginBattleA0000.bmp",
   L"data/actor/reimu/beginBattleA0001.bmp",
   L"data/actor/reimu/beginBattleA0002.bmp",
   L"data/actor/reimu/beginBattleA0003.bmp",
   L"data/actor/reimu/beginBattleA0004.bmp",
   L"data/actor/reimu/beginBattleA0005.bmp",
   L"data/actor/reimu/beginBattleA0006.bmp",
   L"data/actor/reimu/beginBattleA0007.bmp",
   L"data/actor/reimu/beginBattleA0008.bmp",
   L"data/actor/reimu/beginBattleA0009.bmp",
   L"data/actor/reimu/beginBattleA0010.bmp",
   L"data/actor/reimu/beginBattleA0011.bmp",
   L"data/actor/reimu/beginBattleA0012.bmp",
   L"data/actor/reimu/beginBattleA0013.bmp",
   L"data/actor/reimu/beginBattleA0014.bmp",
   L"data/actor/reimu/bouA0000.bmp",
   L"data/actor/reimu/climaxA0000.bmp",
   L"data/actor/reimu/climaxA0001.bmp",
   L"data/actor/reimu/climaxA0002.bmp",
   L"data/actor/reimu/climaxA0003.bmp",
   L"data/actor/reimu/climaxA0004.bmp",
   L"data/actor/reimu/climaxA0005.bmp",
   L"data/actor/reimu/climaxA0006.bmp",
   L"data/actor/reimu/climaxA0007.bmp",
   L"data/actor/reimu/climaxA0008.bmp",
   L"data/actor/reimu/climaxA0009.bmp",
   L"data/actor/reimu/climaxA0010.bmp",
   L"data/actor/reimu/climaxA0011.bmp",
   L"data/actor/reimu/climaxA0012.bmp",
   L"data/actor/reimu/climaxA0013.bmp",
   L"data/actor/reimu/climaxA0014.bmp",
   L"data/actor/reimu/climaxA0015.bmp",
   L"data/actor/reimu/climaxA0016.bmp",
   L"data/actor/reimu/climax_cutFace.png",
   L"data/actor/reimu/damageUnder0000.bmp",
   L"data/actor/reimu/damageUnder0001.bmp",
   L"data/actor/reimu/damageUnder0002.bmp",
   L"data/actor/reimu/damageUnder0003.bmp",
   L"data/actor/reimu/damageUnder0004.bmp",
   L"data/actor/reimu/damageUpper0000.bmp",
   L"data/actor/reimu/damageUpper0001.bmp",
   L"data/actor/reimu/damageUpper0002.bmp",
   L"data/actor/reimu/damageUpper0003.bmp",
   L"data/actor/reimu/damageUpper0004.bmp",
   L"data/actor/reimu/damageWall0000.bmp",
   L"data/actor/reimu/damageWall0001.bmp",
   L"data/actor/reimu/damageWall0002.bmp",
   L"data/actor/reimu/damageWall0003.bmp",
   L"data/actor/reimu/damageWall0004.bmp",
   L"data/actor/reimu/damageWall0005.bmp",
   L"data/actor/reimu/damageWall0006.bmp",
   L"data/actor/reimu/damageWall0007.bmp",
   L"data/actor/reimu/damage_fall0000.bmp",
   L"data/actor/reimu/damage_fall0001.bmp",
   L"data/actor/reimu/damage_fall0002.bmp",
   L"data/actor/reimu/damage_fall0003.bmp",
   L"data/actor/reimu/damage_fall0004.bmp",
   L"data/actor/reimu/damage_fall0005.bmp",
   L"data/actor/reimu/damage_fall0005b.bmp",
   L"data/actor/reimu/damage_fall0006.bmp",
   L"data/actor/reimu/damage_lift0000.bmp",
   L"data/actor/reimu/damage_lift0001.bmp",
   L"data/actor/reimu/damage_lift0002.bmp",
   L"data/actor/reimu/damage_lift0003.bmp",
   L"data/actor/reimu/damage_lift0004.bmp",
   L"data/actor/reimu/damage_lift0005.bmp",
   L"data/actor/reimu/damage_lift0006.bmp",
   L"data/actor/reimu/damage_lift0006b.bmp",
   L"data/actor/reimu/damage_spin0000.bmp",
   L"data/actor/reimu/damage_spin0001.bmp",
   L"data/actor/reimu/damage_spin0002.bmp",
   L"data/actor/reimu/damage_spin0003.bmp",
   L"data/actor/reimu/dashBack0000.bmp",
   L"data/actor/reimu/dashBack0001.bmp",
   L"data/actor/reimu/dashBack0002.bmp",
   L"data/actor/reimu/dashBack0003.bmp",
   L"data/actor/reimu/dashBack0004.bmp",
   L"data/actor/reimu/dashBack0005.bmp",
   L"data/actor/reimu/dashBack0006.bmp",
   L"data/actor/reimu/dashBack0007.bmp",
   L"data/actor/reimu/dashBack0008.bmp",
   L"data/actor/reimu/dashBack0009.bmp",
   L"data/actor/reimu/dashBackLoop0000.bmp",
   L"data/actor/reimu/dashBackLoop0001.bmp",
   L"data/actor/reimu/dashBackLoop0002.bmp",
   L"data/actor/reimu/dashBackLoop0003.bmp",
   L"data/actor/reimu/dashBackLoop0004.bmp",
   L"data/actor/reimu/dashFront0000.bmp",
   L"data/actor/reimu/dashFront0001.bmp",
   L"data/actor/reimu/dashFront0002.bmp",
   L"data/actor/reimu/dashFront0003.bmp",
   L"data/actor/reimu/dashFront0004.bmp",
   L"data/actor/reimu/dashFront0005.bmp",
   L"data/actor/reimu/dashFront0006.bmp",
   L"data/actor/reimu/dashFront0007.bmp",
   L"data/actor/reimu/dashFront0008.bmp",
   L"data/actor/reimu/dashFront0009.bmp",
   L"data/actor/reimu/dashFrontLoop0000.bmp",
   L"data/actor/reimu/dashFrontLoop0001.bmp",
   L"data/actor/reimu/dashFrontLoop0002.bmp",
   L"data/actor/reimu/dashFrontLoop0003.bmp",
   L"data/actor/reimu/dashFrontLoop0004.bmp",
   L"data/actor/reimu/downLoop0000.bmp",
   L"data/actor/reimu/downLoop0001.bmp",
   L"data/actor/reimu/downLoop0002.bmp",
   L"data/actor/reimu/downLoop0003.bmp",
   L"data/actor/reimu/downLoop0004.bmp",
   L"data/actor/reimu/dummy.bmp",
   L"data/actor/reimu/effect_skillA0000.bmp",
   L"data/actor/reimu/effect_skillA0001.bmp",
   L"data/actor/reimu/effect_skillA0002.bmp",
   L"data/actor/reimu/effect_skillA0003.bmp",
   L"data/actor/reimu/effect_spellA_aura0000.dds",
   L"data/actor/reimu/effect_spellA_aura0001.dds",
   L"data/actor/reimu/effect_spellA_aura0002.dds",
   L"data/actor/reimu/effect_spellA_aura0003.dds",
   L"data/actor/reimu/effect_spellA_aura0004.dds",
   L"data/actor/reimu/effect_spellA_aura0005.dds",
   L"data/actor/reimu/effect_spellA_aura0006.dds",
   L"data/actor/reimu/effect_spellA_aura0007.dds",
   L"data/actor/reimu/effect_spellA_aura0008.dds",
   L"data/actor/reimu/effect_spellA_aura0009.dds",
   L"data/actor/reimu/effect_spellA_aura0010.dds",
   L"data/actor/reimu/effect_spellA_aura0011.dds",
   L"data/actor/reimu/effect_spellA_aura0012.dds",
   L"data/actor/reimu/effect_spellA_aura0013.dds",
   L"data/actor/reimu/effect_spellA_aura0014.dds",
   L"data/actor/reimu/effect_spellA_aura0015.dds",
   L"data/actor/reimu/effect_spellA_aura0016.dds",
   L"data/actor/reimu/effect_spellA_aura0017.dds",
   L"data/actor/reimu/effect_spellA_auraB0000.dds",
   L"data/actor/reimu/effect_spellA_auraB0001.dds",
   L"data/actor/reimu/effect_spellA_auraB0002.dds",
   L"data/actor/reimu/effect_spellA_auraB0003.dds",
   L"data/actor/reimu/effect_spellA_auraB0004.dds",
   L"data/actor/reimu/effect_spellA_auraB0005.dds",
   L"data/actor/reimu/effect_spellA_auraB0006.dds",
   L"data/actor/reimu/effect_spellA_auraB0007.dds",
   L"data/actor/reimu/effect_spellA_auraB0008.dds",
   L"data/actor/reimu/effect_spellA_auraB0009.dds",
   L"data/actor/reimu/effect_spellA_auraB0010.dds",
   L"data/actor/reimu/effect_spellA_auraB0011.dds",
   L"data/actor/reimu/effect_spellA_auraB0012.dds",
   L"data/actor/reimu/effect_spellA_auraB0013.dds",
   L"data/actor/reimu/effect_spellA_auraB0014.dds",
   L"data/actor/reimu/effect_spellA_auraB0015.dds",
   L"data/actor/reimu/effect_spellA_auraB0016.dds",
   L"data/actor/reimu/effect_spellA_auraB0017.dds",
   L"data/actor/reimu/effect_spellB0000.png",
   L"data/actor/reimu/effect_spellB0001.png",
   L"data/actor/reimu/effect_spellB0002.png",
   L"data/actor/reimu/effect_spellB0003.png",
   L"data/actor/reimu/effect_spellB0004.png",
   L"data/actor/reimu/effect_spellB0005.png",
   L"data/actor/reimu/effect_spellB0006.png",
   L"data/actor/reimu/effect_spellB0007.png",
   L"data/actor/reimu/effect_spellB0008.png",
   L"data/actor/reimu/effect_spellB0009.png",
   L"data/actor/reimu/effect_spellB0010.png",
   L"data/actor/reimu/effect_spellB0011.png",
   L"data/actor/reimu/effect_spellB0012.png",
   L"data/actor/reimu/effect_spellB0013.png",
   L"data/actor/reimu/effect_spellB0014.png",
   L"data/actor/reimu/effect_spellB0015.png",
   L"data/actor/reimu/effect_spellBb0000.png",
   L"data/actor/reimu/effect_spellBb0001.png",
   L"data/actor/reimu/effect_spellBb0002.png",
   L"data/actor/reimu/effect_spellBb0003.png",
   L"data/actor/reimu/effect_spellBb0004.png",
   L"data/actor/reimu/effect_spellBb0005.png",
   L"data/actor/reimu/effect_spellBb0006.png",
   L"data/actor/reimu/effect_spellBb0007.png",
   L"data/actor/reimu/effect_spellBb0008.png",
   L"data/actor/reimu/effect_spellBb0009.png",
   L"data/actor/reimu/effect_spellBb0010.png",
   L"data/actor/reimu/effect_spellBb0011.png",
   L"data/actor/reimu/effect_spellBb0012.png",
   L"data/actor/reimu/effect_spellBb0013.png",
   L"data/actor/reimu/effect_spellBb0014.png",
   L"data/actor/reimu/effect_spellBb0015.png",
   L"data/actor/reimu/face_spellCall.png",
   L"data/actor/reimu/grab0000.bmp",
   L"data/actor/reimu/grab0001.bmp",
   L"data/actor/reimu/grab0002.bmp",
   L"data/actor/reimu/grab0003.bmp",
   L"data/actor/reimu/grab0004.bmp",
   L"data/actor/reimu/grab0005.bmp",
   L"data/actor/reimu/guard0000.bmp",
   L"data/actor/reimu/guard0001.bmp",
   L"data/actor/reimu/guard0002.bmp",
   L"data/actor/reimu/guard0003.bmp",
   L"data/actor/reimu/guard0004.bmp",
   L"data/actor/reimu/guardCrash0000.bmp",
   L"data/actor/reimu/guardCrash0001.bmp",
   L"data/actor/reimu/guardCrash0002.bmp",
   L"data/actor/reimu/guardCrash0003.bmp",
   L"data/actor/reimu/guardCrash0004.bmp",
   L"data/actor/reimu/guardCrash0005.bmp",
   L"data/actor/reimu/guard_miss0000.bmp",
   L"data/actor/reimu/guard_miss0001.bmp",
   L"data/actor/reimu/guard_miss0002.bmp",
   L"data/actor/reimu/guard_miss0003.bmp",
   L"data/actor/reimu/item0000.bmp",
   L"data/actor/reimu/item0001.bmp",
   L"data/actor/reimu/item0002.bmp",
   L"data/actor/reimu/item0003.bmp",
   L"data/actor/reimu/item0004.bmp",
   L"data/actor/reimu/item0005.bmp",
   L"data/actor/reimu/item0006.bmp",
   L"data/actor/reimu/item0007.bmp",
   L"data/actor/reimu/item0008.bmp",
   L"data/actor/reimu/item0009.bmp",
   L"data/actor/reimu/item0010.bmp",
   L"data/actor/reimu/item0011.bmp",
   L"data/actor/reimu/item0012.bmp",
   L"data/actor/reimu/lose0000.bmp",
   L"data/actor/reimu/lose0001.bmp",
   L"data/actor/reimu/lose0002.bmp",
   L"data/actor/reimu/lose0003.bmp",
   L"data/actor/reimu/lose0004.bmp",
   L"data/actor/reimu/lose0005.bmp",
   L"data/actor/reimu/lose0006.bmp",
   L"data/actor/reimu/lose0007.bmp",
   L"data/actor/reimu/lose0008.bmp",
   L"data/actor/reimu/lose0009.bmp",
   L"data/actor/reimu/move_20000.bmp",
   L"data/actor/reimu/move_20001.bmp",
   L"data/actor/reimu/move_20002.bmp",
   L"data/actor/reimu/move_20003.bmp",
   L"data/actor/reimu/move_20004.bmp",
   L"data/actor/reimu/move_20005.bmp",
   L"data/actor/reimu/move_20006.bmp",
   L"data/actor/reimu/move_2loop0000.bmp",
   L"data/actor/reimu/move_2loop0001.bmp",
   L"data/actor/reimu/move_2loop0002.bmp",
   L"data/actor/reimu/move_2loop0003.bmp",
   L"data/actor/reimu/move_2loop0004.bmp",
   L"data/actor/reimu/move_80000.bmp",
   L"data/actor/reimu/move_80001.bmp",
   L"data/actor/reimu/move_80002.bmp",
   L"data/actor/reimu/move_80003.bmp",
   L"data/actor/reimu/move_80004.bmp",
   L"data/actor/reimu/move_80005.bmp",
   L"data/actor/reimu/move_80006.bmp",
   L"data/actor/reimu/move_80007.bmp",
   L"data/actor/reimu/move_80008.bmp",
   L"data/actor/reimu/move_8loop0000.bmp",
   L"data/actor/reimu/move_8loop0001.bmp",
   L"data/actor/reimu/move_8loop0002.bmp",
   L"data/actor/reimu/move_8loop0003.bmp",
   L"data/actor/reimu/move_8loop0004.bmp",
   L"data/actor/reimu/object_winB0000.png",
   L"data/actor/reimu/occult0000.bmp",
   L"data/actor/reimu/occult0001.bmp",
   L"data/actor/reimu/occult0002.bmp",
   L"data/actor/reimu/occult0003.bmp",
   L"data/actor/reimu/occult0004.bmp",
   L"data/actor/reimu/occult0005.bmp",
   L"data/actor/reimu/occult0006.bmp",
   L"data/actor/reimu/occult0007.bmp",
   L"data/actor/reimu/occult0008.bmp",
   L"data/actor/reimu/occult0009.bmp",
   L"data/actor/reimu/occult_mask0000.bmp",
   L"data/actor/reimu/occult_mask0001.bmp",
   L"data/actor/reimu/occult_mask0002.bmp",
   L"data/actor/reimu/occult_mask0003.bmp",
   L"data/actor/reimu/occult_mask0004.bmp",
   L"data/actor/reimu/occult_mask0005.bmp",
   L"data/actor/reimu/palette000.bmp",
   L"data/actor/reimu/palette001.bmp",
   L"data/actor/reimu/palette002.bmp",
   L"data/actor/reimu/palette003.bmp",
   L"data/actor/reimu/palette004.bmp",
   L"data/actor/reimu/palette005.bmp",
   L"data/actor/reimu/palette006.bmp",
   L"data/actor/reimu/palette007.bmp",
   L"data/actor/reimu/palette100.bmp",
   L"data/actor/reimu/palette101.bmp",
   L"data/actor/reimu/palette102.bmp",
   L"data/actor/reimu/palette103.bmp",
   L"data/actor/reimu/palette104.bmp",
   L"data/actor/reimu/palette105.bmp",
   L"data/actor/reimu/palette106.bmp",
   L"data/actor/reimu/palette107.bmp",
   L"data/actor/reimu/reimu.pat",
   L"data/actor/reimu/reimu_ed.pat",
   L"data/actor/reimu/reimu_occult_sotoba0000.png",
   L"data/actor/reimu/reimu_occult_sotoba0001.png",
   L"data/actor/reimu/samasoBLD0000.dds",
   L"data/actor/reimu/samasoBLD0001.dds",
   L"data/actor/reimu/samasoBLD0002.dds",
   L"data/actor/reimu/samasoBLD0003.dds",
   L"data/actor/reimu/samasoBLD0004.dds",
   L"data/actor/reimu/samasoBLD0005.dds",
   L"data/actor/reimu/samasoBLD0006.dds",
   L"data/actor/reimu/samasoBLD0007.dds",
   L"data/actor/reimu/samasoBLD0008.dds",
   L"data/actor/reimu/samasoBLD0009.dds",
   L"data/actor/reimu/shotA_Loop0000.bmp",
   L"data/actor/reimu/shotA_Loop0001.bmp",
   L"data/actor/reimu/shotA_Loop0002.bmp",
   L"data/actor/reimu/shotA_Loop0003.bmp",
   L"data/actor/reimu/shotA_Loop0004.bmp",
   L"data/actor/reimu/shot_A0000.bmp",
   L"data/actor/reimu/shot_A0001.bmp",
   L"data/actor/reimu/shot_A0002.bmp",
   L"data/actor/reimu/shot_A0003.bmp",
   L"data/actor/reimu/shot_A0004.bmp",
   L"data/actor/reimu/shot_A0005.bmp",
   L"data/actor/reimu/shot_A0006.bmp",
   L"data/actor/reimu/shot_A0007.bmp",
   L"data/actor/reimu/shot_A0008.bmp",
   L"data/actor/reimu/shot_A0009.bmp",
   L"data/actor/reimu/shot_A0010.bmp",
   L"data/actor/reimu/shot_A0011.bmp",
   L"data/actor/reimu/shot_B0000.bmp",
   L"data/actor/reimu/shot_B0001.bmp",
   L"data/actor/reimu/shot_B0002.bmp",
   L"data/actor/reimu/shot_B0003.bmp",
   L"data/actor/reimu/shot_B0004.bmp",
   L"data/actor/reimu/shot_B0005.bmp",
   L"data/actor/reimu/shot_B0006.bmp",
   L"data/actor/reimu/shot_B0007.bmp",
   L"data/actor/reimu/shot_B0008.bmp",
   L"data/actor/reimu/shot_B0009.bmp",
   L"data/actor/reimu/shot_B0010.bmp",
   L"data/actor/reimu/shot_B0011.bmp",
   L"data/actor/reimu/shot_C0000.bmp",
   L"data/actor/reimu/shot_C0001.bmp",
   L"data/actor/reimu/shot_C0002.bmp",
   L"data/actor/reimu/shot_C0003.bmp",
   L"data/actor/reimu/shot_C0004.bmp",
   L"data/actor/reimu/shot_C0005.bmp",
   L"data/actor/reimu/shot_C0006.bmp",
   L"data/actor/reimu/shot_C0007.bmp",
   L"data/actor/reimu/shot_C0008.bmp",
   L"data/actor/reimu/shot_C0009.bmp",
   L"data/actor/reimu/shot_C0010.bmp",
   L"data/actor/reimu/shot_D0000.bmp",
   L"data/actor/reimu/shot_D0001.bmp",
   L"data/actor/reimu/shot_D0002.bmp",
   L"data/actor/reimu/shot_D0003.bmp",
   L"data/actor/reimu/shot_D0004.bmp",
   L"data/actor/reimu/shot_D0005.bmp",
   L"data/actor/reimu/shot_D0006.bmp",
   L"data/actor/reimu/shot_D0007.bmp",
   L"data/actor/reimu/shot_D0008.bmp",
   L"data/actor/reimu/shot_D0009.bmp",
   L"data/actor/reimu/shot_D0010.bmp",
   L"data/actor/reimu/shot_D0011.bmp",
   L"data/actor/reimu/shot_D0012.bmp",
   L"data/actor/reimu/skillG_Under0000.bmp",
   L"data/actor/reimu/skillG_Under0001.bmp",
   L"data/actor/reimu/skillG_Upper0000.bmp",
   L"data/actor/reimu/skillG_Upper0001.bmp",
   L"data/actor/reimu/skillG_Upper0002.bmp",
   L"data/actor/reimu/skillG_Upper0003.bmp",
   L"data/actor/reimu/skillG_Upper0004.bmp",
   L"data/actor/reimu/skillG_Upper0005.bmp",
   L"data/actor/reimu/skill_A0000.bmp",
   L"data/actor/reimu/skill_A0001.bmp",
   L"data/actor/reimu/skill_A0002.bmp",
   L"data/actor/reimu/skill_A0003.bmp",
   L"data/actor/reimu/skill_A0004.bmp",
   L"data/actor/reimu/skill_A0005.bmp",
   L"data/actor/reimu/skill_A0006.bmp",
   L"data/actor/reimu/skill_A0007.bmp",
   L"data/actor/reimu/skill_A0008.bmp",
   L"data/actor/reimu/skill_A0009.bmp",
   L"data/actor/reimu/skill_A0010.bmp",
   L"data/actor/reimu/skill_A0011.bmp",
   L"data/actor/reimu/skill_A0012.bmp",
   L"data/actor/reimu/skill_occult_side0000.bmp",
   L"data/actor/reimu/skill_occult_side0001.bmp",
   L"data/actor/reimu/skill_occult_side0002.bmp",
   L"data/actor/reimu/skill_occult_side0003.bmp",
   L"data/actor/reimu/skill_occult_side0004.bmp",
   L"data/actor/reimu/skill_occult_side0005.bmp",
   L"data/actor/reimu/skill_occult_side0006.bmp",
   L"data/actor/reimu/skill_occult_side0007.bmp",
   L"data/actor/reimu/skill_occult_side0008.bmp",
   L"data/actor/reimu/skill_occult_side0009.bmp",
   L"data/actor/reimu/spellA0000.bmp",
   L"data/actor/reimu/spellA0001.bmp",
   L"data/actor/reimu/spellA0002.bmp",
   L"data/actor/reimu/spellA0003.bmp",
   L"data/actor/reimu/spellA0004.bmp",
   L"data/actor/reimu/spellA0005.bmp",
   L"data/actor/reimu/spellA0006.bmp",
   L"data/actor/reimu/spellA0007.bmp",
   L"data/actor/reimu/spellA0008.bmp",
   L"data/actor/reimu/spellA0009.bmp",
   L"data/actor/reimu/spellA0010.bmp",
   L"data/actor/reimu/spellA0011.bmp",
   L"data/actor/reimu/spellA0012.bmp",
   L"data/actor/reimu/spellA0013.bmp",
   L"data/actor/reimu/spellA0014.bmp",
   L"data/actor/reimu/spellA0015.bmp",
   L"data/actor/reimu/spellA0016.bmp",
   L"data/actor/reimu/spellA0017.bmp",
   L"data/actor/reimu/spellA0018.bmp",
   L"data/actor/reimu/spellA0019.bmp",
   L"data/actor/reimu/spellA0020.bmp",
   L"data/actor/reimu/spellA0021.bmp",
   L"data/actor/reimu/spellA0022.bmp",
   L"data/actor/reimu/spellA0023.bmp",
   L"data/actor/reimu/spellA0024.bmp",
   L"data/actor/reimu/spellA0025.bmp",
   L"data/actor/reimu/spellA0026.bmp",
   L"data/actor/reimu/spellA_Loop0000.bmp",
   L"data/actor/reimu/spellB0000.bmp",
   L"data/actor/reimu/spellB0001.bmp",
   L"data/actor/reimu/spellB0002.bmp",
   L"data/actor/reimu/spellB0003.bmp",
   L"data/actor/reimu/spellB0004.bmp",
   L"data/actor/reimu/spellB0005.bmp",
   L"data/actor/reimu/spellB0006.bmp",
   L"data/actor/reimu/spellB0007.bmp",
   L"data/actor/reimu/spellB0008.bmp",
   L"data/actor/reimu/spellB0009.bmp",
   L"data/actor/reimu/spellB0010.bmp",
   L"data/actor/reimu/spellB0011.bmp",
   L"data/actor/reimu/spellB0012.bmp",
   L"data/actor/reimu/spellB0013.bmp",
   L"data/actor/reimu/spellB0014.bmp",
   L"data/actor/reimu/spellB0015.bmp",
   L"data/actor/reimu/spellB0016.bmp",
   L"data/actor/reimu/spellB0017.bmp",
   L"data/actor/reimu/spellB0018.bmp",
   L"data/actor/reimu/spellB0019.bmp",
   L"data/actor/reimu/spellB0020.bmp",
   L"data/actor/reimu/spellB0021.bmp",
   L"data/actor/reimu/spellB0022.bmp",
   L"data/actor/reimu/spellB0023.bmp",
   L"data/actor/reimu/spellB0024.bmp",
   L"data/actor/reimu/spellB0025.bmp",
   L"data/actor/reimu/spellC0000.bmp",
   L"data/actor/reimu/spellC0001.bmp",
   L"data/actor/reimu/spellC0002.bmp",
   L"data/actor/reimu/spellC0003.bmp",
   L"data/actor/reimu/spellC0004.bmp",
   L"data/actor/reimu/spellC0005.bmp",
   L"data/actor/reimu/spellC0006.bmp",
   L"data/actor/reimu/spellC0007.bmp",
   L"data/actor/reimu/spellC0008.bmp",
   L"data/actor/reimu/spellC0009.bmp",
   L"data/actor/reimu/stun0000.bmp",
   L"data/actor/reimu/stun0001.bmp",
   L"data/actor/reimu/stun0002.bmp",
   L"data/actor/reimu/stun0003.bmp",
   L"data/actor/reimu/stun0004.bmp",
   L"data/actor/reimu/stun0005.bmp",
   L"data/actor/reimu/stunEnd0000.bmp",
   L"data/actor/reimu/stunEnd0001.bmp",
   L"data/actor/reimu/stunEnd0002.bmp",
   L"data/actor/reimu/stunEnd0003.bmp",
   L"data/actor/reimu/testR_ClimaxBack.png",
   L"data/actor/reimu/testR_climaxLine.png",
   L"data/actor/reimu/testR_climaxLine2.png",
   L"data/actor/reimu/test_effect.bmp",
   L"data/actor/reimu/test_stand0000.bmp",
   L"data/actor/reimu/test_stand0001.bmp",
   L"data/actor/reimu/test_stand0002.bmp",
   L"data/actor/reimu/test_stand0003.bmp",
   L"data/actor/reimu/test_stand0004.bmp",
   L"data/actor/reimu/test_stand0005.bmp",
   L"data/actor/reimu/test_stand0006.bmp",
   L"data/actor/reimu/test_stand0007.bmp",
   L"data/actor/reimu/test_stand0008.bmp",
   L"data/actor/reimu/test_stand0009.bmp",
   L"data/actor/reimu/test_stand0010.bmp",
   L"data/actor/reimu/test_stand0011.bmp",
   L"data/actor/reimu/test_stand0012.bmp",
   L"data/actor/reimu/test_stand0013.bmp",
   L"data/actor/reimu/texture/boss1_mask0000.png",
   L"data/actor/reimu/texture/boss1_ring0000.dds",
   L"data/actor/reimu/texture/bulletGateFlash.bmp",
   L"data/actor/reimu/texture/bulletGateRing.bmp",
   L"data/actor/reimu/texture/bullet_shotA0000.png",
   L"data/actor/reimu/texture/bullet_shotB0000.png",
   L"data/actor/reimu/texture/crecent_mask.png",
   L"data/actor/reimu/texture/crecent_shadow.png",
   L"data/actor/reimu/texture/face_master_reimu.png",
   L"data/actor/reimu/texture/face_master_reimu2.png",
   L"data/actor/reimu/texture/face_slave_reimu.png",
   L"data/actor/reimu/texture/face_spell_cut_0000.png",
   L"data/actor/reimu/texture/lightning_mapA.png",
   L"data/actor/reimu/texture/ooiri.bmp",
   L"data/actor/reimu/texture/ooiri_aura.bmp",
   L"data/actor/reimu/texture/reimu_amulet0000.bmp",
   L"data/actor/reimu/texture/reimu_animalDamage000.png",
   L"data/actor/reimu/texture/reimu_animalDamage001.png",
   L"data/actor/reimu/texture/reimu_animalDamage002.png",
   L"data/actor/reimu/texture/reimu_animalDamage003.png",
   L"data/actor/reimu/texture/reimu_animal_00000.png",
   L"data/actor/reimu/texture/reimu_animal_00001.png",
   L"data/actor/reimu/texture/reimu_animal_00002.png",
   L"data/actor/reimu/texture/reimu_animal_00003.png",
   L"data/actor/reimu/texture/reimu_animal_00004.png",
   L"data/actor/reimu/texture/reimu_animal_00005.png",
   L"data/actor/reimu/texture/reimu_animal_00006.png",
   L"data/actor/reimu/texture/reimu_animal_00007.png",
   L"data/actor/reimu/texture/reimu_animal_00008.png",
   L"data/actor/reimu/texture/reimu_animal_00009.png",
   L"data/actor/reimu/texture/reimu_animal_00010.png",
   L"data/actor/reimu/texture/reimu_animal_00011.png",
   L"data/actor/reimu/texture/reimu_climaxMask0000.png",
   L"data/actor/reimu/texture/reimu_climaxMask0001.png",
   L"data/actor/reimu/texture/reimu_climaxSlashA.png",
   L"data/actor/reimu/texture/reimu_lasyWord0000.png",
   L"data/actor/reimu/texture/reimu_musouBase.png",
   L"data/actor/reimu/texture/reimu_occultMask0000.png",
   L"data/actor/reimu/texture/reimu_onmyoBall.png",
   L"data/actor/reimu/texture/reimu_skillG_FlashA.png",
   L"data/actor/reimu/texture/reimu_skillG_Trail.png",
   L"data/actor/reimu/texture/reimu_tenseiA000.png",
   L"data/actor/reimu/texture/reimu_tenseiFuda.png",
   L"data/actor/reimu/texture/reimu_wallA.png",
   L"data/actor/reimu/texture/reimu_wallA_Halfmask.png",
   L"data/actor/reimu/texture/reimu_wallA_mask.png",
   L"data/actor/reimu/texture/reimu_wallFlashA.png",
   L"data/actor/reimu/texture/shotStingA0000.png",
   L"data/actor/reimu/texture/spellC.dds",
   L"data/actor/reimu/texture/spell_use_cut.png",
   L"data/actor/reimu/texture/sukima_back0000.png",
   L"data/actor/reimu/texture/win_reimu.png",
   L"data/actor/reimu/turn0000.bmp",
   L"data/actor/reimu/turn0001.bmp",
   L"data/actor/reimu/turn0002.bmp",
   L"data/actor/reimu/walk0000.bmp",
   L"data/actor/reimu/walk0001.bmp",
   L"data/actor/reimu/walk0002.bmp",
   L"data/actor/reimu/walk0003.bmp",
   L"data/actor/reimu/walk0004.bmp",
   L"data/actor/reimu/walk0005.bmp",
   L"data/actor/reimu/walk0006.bmp",
   L"data/actor/reimu/walk0007.bmp",
   L"data/actor/reimu/walk0008.bmp",
   L"data/actor/reimu/walk0009.bmp",
   L"data/actor/reimu/walkBack0000.bmp",
   L"data/actor/reimu/walkBack0001.bmp",
   L"data/actor/reimu/walkBack0002.bmp",
   L"data/actor/reimu/walkBack0003.bmp",
   L"data/actor/reimu/walkBack0004.bmp",
   L"data/actor/reimu/walkBack0005.bmp",
   L"data/actor/reimu/walkBack0006.bmp",
   L"data/actor/reimu/walkBack0007.bmp",
   L"data/actor/reimu/walkBack0008.bmp",
   L"data/actor/reimu/walkBack0009.bmp",
   L"data/actor/reimu/walkBack0010.bmp",
   L"data/actor/reimu/walkBackloop0000.bmp",
   L"data/actor/reimu/walkBackloop0001.bmp",
   L"data/actor/reimu/walkBackloop0002.bmp",
   L"data/actor/reimu/walkBackloop0003.bmp",
   L"data/actor/reimu/walkBackloop0004.bmp",
   L"data/actor/reimu/walkloop0000.bmp",
   L"data/actor/reimu/walkloop0001.bmp",
   L"data/actor/reimu/walkloop0002.bmp",
   L"data/actor/reimu/walkloop0003.bmp",
   L"data/actor/reimu/walkloop0004.bmp",
   L"data/actor/reimu/warpMask.bmp",
   L"data/actor/reimu/winA0000.bmp",
   L"data/actor/reimu/winA0001.bmp",
   L"data/actor/reimu/winA0002.bmp",
   L"data/actor/reimu/winA0003.bmp",
   L"data/actor/reimu/winA0004.bmp",
   L"data/actor/reimu/winA0005.bmp",
   L"data/actor/reimu/winA0006.bmp",
   L"data/actor/reimu/winA0007.bmp",
   L"data/actor/reimu/winA0008.bmp",
   L"data/actor/reimu/winA0009.bmp",
   L"data/actor/reimu/winA0010.bmp",
   L"data/actor/reimu/winA0011.bmp",
   L"data/actor/reimu/winA0012.bmp",
   L"data/actor/reimu/winB0000.bmp",
   L"data/actor/reimu/winB0001.bmp",
   L"data/actor/reimu/winB0002.bmp",
   L"data/actor/reimu/winB0003.bmp",
   L"data/actor/reimu/winB0004.bmp",
   L"data/actor/reimu/winB0005.bmp",
   L"data/actor/reimu/winB0006.bmp",
   L"data/actor/reimu/winB0007.bmp",
   L"data/actor/reimu/winB0008.bmp",
   L"data/actor/reimu/winB0009.bmp",
   L"data/actor/reimu.nut",
   L"data/actor/reimu_base.nut",
   L"data/actor/reimu_boss.nut",
   L"data/actor/reimu_boss_base.nut",
   L"data/actor/reimu_boss_init.nut",
   L"data/actor/reimu_boss_shot.nut",
   L"data/actor/reimu_com.nut",
   L"data/actor/reimu_combo.nut",
   L"data/actor/reimu_com_function.nut",
   L"data/actor/reimu_init.nut",
   L"data/actor/reimu_practice_init.nut",
   L"data/actor/reimu_shot.nut",
   L"data/actor/reimu_team.nut",
   L"data/actor/script/actor_check.nut",
   L"data/actor/script/actor_collision.nut",
   L"data/actor/script/actor_create.nut",
   L"data/actor/script/actor_function.nut",
   L"data/actor/script/actor_game.nut",
   L"data/actor/script/actor_input.nut",
   L"data/actor/script/actor_member.nut",
   L"data/actor/script/actor_screen.nut",
   L"data/actor/script/actor_team.nut",
   L"data/actor/script/actor_update.nut",
   L"data/actor/script/battle.nut",
   L"data/actor/script/boss_function.nut",
   L"data/actor/script/boss_member.nut",
   L"data/actor/script/class_other.nut",
   L"data/actor/script/com_function.nut",
   L"data/actor/script/com_member.nut",
   L"data/actor/script/com_update.nut",
   L"data/actor/script/effect_function.nut",
   L"data/actor/script/effect_member.nut",
   L"data/actor/script/effect_update.nut",
   L"data/actor/script/input_command.nut",
   L"data/actor/script/object_function.nut",
   L"data/actor/script/object_game.nut",
   L"data/actor/script/object_member.nut",
   L"data/actor/script/object_update.nut",
   L"data/actor/script/player_buff.nut",
   L"data/actor/script/player_check.nut",
   L"data/actor/script/player_effect_function.nut",
   L"data/actor/script/player_effect_game.nut",
   L"data/actor/script/player_effect_member.nut",
   L"data/actor/script/player_effect_update.nut",
   L"data/actor/script/player_function.nut",
   L"data/actor/script/player_game.nut",
   L"data/actor/script/player_input.nut",
   L"data/actor/script/player_member.nut",
   L"data/actor/script/player_spell.nut",
   L"data/actor/script/player_update.nut",
   L"data/actor/script/practice_function.nut",
   L"data/actor/script/practice_member.nut",
   L"data/actor/script/practice_update.nut",
   L"data/actor/script/shot_function.nut",
   L"data/actor/script/shot_game.nut",
   L"data/actor/script/shot_member.nut",
   L"data/actor/script/shot_update.nut",
   L"data/actor/shion/animal0000.png",
   L"data/actor/shion/animal0001.png",
   L"data/actor/shion/animal0002.png",
   L"data/actor/shion/animal0003.png",
   L"data/actor/shion/animal0004.png",
   L"data/actor/shion/animal0005.png",
   L"data/actor/shion/animal0006.png",
   L"data/actor/shion/animal0007.png",
   L"data/actor/shion/animal0008.png",
   L"data/actor/shion/animal0009.png",
   L"data/actor/shion/animal_damage0000.png",
   L"data/actor/shion/animal_damage0001.png",
   L"data/actor/shion/animal_damage0002.png",
   L"data/actor/shion/animal_damage0003.png",
   L"data/actor/shion/animal_damage0004.png",
   L"data/actor/shion/climax_moneyGet0000.bmp",
   L"data/actor/shion/climax_moneyGet0001.bmp",
   L"data/actor/shion/climax_moneyGet0002.bmp",
   L"data/actor/shion/climax_moneyGet0003.bmp",
   L"data/actor/shion/climax_moneyGet0004.bmp",
   L"data/actor/shion/climax_moneyGet0005.bmp",
   L"data/actor/shion/climax_moneyGet0006.bmp",
   L"data/actor/shion/climax_moneyGet0007.bmp",
   L"data/actor/shion/climax_moneyGet0008.bmp",
   L"data/actor/shion/climax_moneyGetB0000.bmp",
   L"data/actor/shion/climax_moneyGetB0001.bmp",
   L"data/actor/shion/climax_moneyGetB0002.bmp",
   L"data/actor/shion/climax_moneyGetB0003.bmp",
   L"data/actor/shion/climax_moneyGetB0004.bmp",
   L"data/actor/shion/climax_moneyGetB0005.bmp",
   L"data/actor/shion/climax_moneyGetB0006.bmp",
   L"data/actor/shion/climax_moneyGetB0007.bmp",
   L"data/actor/shion/climax_moneyGetB0008.bmp",
   L"data/actor/shion/damage_stun0000.bmp",
   L"data/actor/shion/damage_stun0001.bmp",
   L"data/actor/shion/damage_stun0002.bmp",
   L"data/actor/shion/damage_stun0003.bmp",
   L"data/actor/shion/damage_stun0004.bmp",
   L"data/actor/shion/move_back0000.bmp",
   L"data/actor/shion/move_back0001.bmp",
   L"data/actor/shion/move_back0002.bmp",
   L"data/actor/shion/move_back0003.bmp",
   L"data/actor/shion/move_back0004.bmp",
   L"data/actor/shion/move_back0005.bmp",
   L"data/actor/shion/move_back0006.bmp",
   L"data/actor/shion/move_back0007.bmp",
   L"data/actor/shion/move_back0008.bmp",
   L"data/actor/shion/move_front0000.bmp",
   L"data/actor/shion/move_front0001.bmp",
   L"data/actor/shion/move_front0002.bmp",
   L"data/actor/shion/move_front0003.bmp",
   L"data/actor/shion/move_front0004.bmp",
   L"data/actor/shion/move_front0005.bmp",
   L"data/actor/shion/move_front0006.bmp",
   L"data/actor/shion/move_front0007.bmp",
   L"data/actor/shion/move_front0008.bmp",
   L"data/actor/shion/occult0000.bmp",
   L"data/actor/shion/occult0001.bmp",
   L"data/actor/shion/occult0002.bmp",
   L"data/actor/shion/occult0003.bmp",
   L"data/actor/shion/occult0004.bmp",
   L"data/actor/shion/occult0005.bmp",
   L"data/actor/shion/occult0006.bmp",
   L"data/actor/shion/occult0007.bmp",
   L"data/actor/shion/occult0008.bmp",
   L"data/actor/shion/occult0009.bmp",
   L"data/actor/shion/occult_hyoui0000.bmp",
   L"data/actor/shion/occult_hyoui0001.bmp",
   L"data/actor/shion/occult_hyoui0002.bmp",
   L"data/actor/shion/occult_hyoui0003.bmp",
   L"data/actor/shion/occult_hyoui0004.bmp",
   L"data/actor/shion/occult_hyoui0005.bmp",
   L"data/actor/shion/occult_hyoui0006.bmp",
   L"data/actor/shion/occult_hyoui0007.bmp",
   L"data/actor/shion/occult_hyoui0008.bmp",
   L"data/actor/shion/ofuda0050.nut",
   L"data/actor/shion/palette000.bmp",
   L"data/actor/shion/palette001.bmp",
   L"data/actor/shion/palette002.bmp",
   L"data/actor/shion/palette003.bmp",
   L"data/actor/shion/palette004.bmp",
   L"data/actor/shion/palette005.bmp",
   L"data/actor/shion/palette006.bmp",
   L"data/actor/shion/palette007.bmp",
   L"data/actor/shion/palette100.bmp",
   L"data/actor/shion/palette101.bmp",
   L"data/actor/shion/palette102.bmp",
   L"data/actor/shion/palette103.bmp",
   L"data/actor/shion/palette104.bmp",
   L"data/actor/shion/palette105.bmp",
   L"data/actor/shion/palette106.bmp",
   L"data/actor/shion/palette107.bmp",
   L"data/actor/shion/shion.pat",
   L"data/actor/shion/shion_option.pat",
   L"data/actor/shion/shot_charge0000.bmp",
   L"data/actor/shion/shot_charge0001.bmp",
   L"data/actor/shion/shot_charge0002.bmp",
   L"data/actor/shion/shot_charge0003.bmp",
   L"data/actor/shion/shot_charge0004.bmp",
   L"data/actor/shion/stand0000.bmp",
   L"data/actor/shion/stand0001.bmp",
   L"data/actor/shion/stand0002.bmp",
   L"data/actor/shion/stand0003.bmp",
   L"data/actor/shion/stand0004.bmp",
   L"data/actor/shion/stand0005.bmp",
   L"data/actor/shion/stand0006.bmp",
   L"data/actor/shion/stand0007.bmp",
   L"data/actor/shion/stand0008.bmp",
   L"data/actor/shion/stand0009.bmp",
   L"data/actor/shion/stand0010.bmp",
   L"data/actor/shion/stand0011.bmp",
   L"data/actor/shion/stand0012.bmp",
   L"data/actor/shion/stand0013.bmp",
   L"data/actor/shion/stand0014.bmp",
   L"data/actor/shion/stand0015.bmp",
   L"data/actor/shion/stand0016.bmp",
   L"data/actor/shion/texture/aura_tex0000.png",
   L"data/actor/shion/texture/back_squeez0000.png",
   L"data/actor/shion/texture/boss_back.png",
   L"data/actor/shion/texture/crack000.png",
   L"data/actor/shion/texture/crack001.png",
   L"data/actor/shion/texture/crack002.png",
   L"data/actor/shion/texture/face_master_shion.png",
   L"data/actor/shion/texture/face_master_shion2.png",
   L"data/actor/shion/texture/face_master_shion_r.png",
   L"data/actor/shion/texture/face_master_shion_r2.png",
   L"data/actor/shion/texture/face_slave_shion.png",
   L"data/actor/shion/texture/face_slave_shion_r.png",
   L"data/actor/shion/texture/face_spell_cut.png",
   L"data/actor/shion/texture/shot_negative_000.png",
   L"data/actor/shion/texture/shot_negative_001.png",
   L"data/actor/shion/texture/shot_wealth0000.png",
   L"data/actor/shion/texture/spell_use_cut.png",
   L"data/actor/shion/texture/spell_use_cut_reverse.png",
   L"data/actor/shion/win_A0000.bmp",
   L"data/actor/shion/win_A0001.bmp",
   L"data/actor/shion/win_A0002.bmp",
   L"data/actor/shion/win_A0003.bmp",
   L"data/actor/shion/win_A0004.bmp",
   L"data/actor/shion/win_A0005.bmp",
   L"data/actor/shion/win_A0008.bmp",
   L"data/actor/shion/win_A0009.bmp",
   L"data/actor/shion/win_A0010.bmp",
   L"data/actor/shion/win_Ab0000.bmp",
   L"data/actor/shion/win_Ab0001.bmp",
   L"data/actor/shion/win_Ab0002.bmp",
   L"data/actor/shion/win_Ab0003.bmp",
   L"data/actor/shion/win_Ab0004.bmp",
   L"data/actor/shion/win_B0000.bmp",
   L"data/actor/shion/win_B0001.bmp",
   L"data/actor/shion/win_B0002.bmp",
   L"data/actor/shion/win_B0003.bmp",
   L"data/actor/shion/win_B0004.bmp",
   L"data/actor/shion/win_paper0000.bmp",
   L"data/actor/shion/win_paper0001.bmp",
   L"data/actor/shion/win_paper0002.bmp",
   L"data/actor/shion/win_paper0003.bmp",
   L"data/actor/shion/win_paper0004.bmp",
   L"data/actor/shion.nut",
   L"data/actor/shion_base.nut",
   L"data/actor/shion_boss.nut",
   L"data/actor/shion_boss_base.nut",
   L"data/actor/shion_boss_init.nut",
   L"data/actor/shion_boss_shot.nut",
   L"data/actor/shion_init.nut",
   L"data/actor/shion_option.nut",
   L"data/actor/shion_shot.nut",
   L"data/actor/shion_team.nut",
   L"data/actor/sinmyoumaru/atkHighFront0001.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0002.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0003.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0004.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0005.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0006.bmp",
   L"data/actor/sinmyoumaru/atkHighFront0007.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0000.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0001.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0002.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0003.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0004.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0005.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0006.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0007.bmp",
   L"data/actor/sinmyoumaru/atkHighUnder0008.bmp",
   L"data/actor/sinmyoumaru/atkLow0000.bmp",
   L"data/actor/sinmyoumaru/atkLow0001.bmp",
   L"data/actor/sinmyoumaru/atkLow0002.bmp",
   L"data/actor/sinmyoumaru/atkLow0003.bmp",
   L"data/actor/sinmyoumaru/atkLow0004.bmp",
   L"data/actor/sinmyoumaru/atkLow0005.bmp",
   L"data/actor/sinmyoumaru/atkMid0000.bmp",
   L"data/actor/sinmyoumaru/atkMid0001.bmp",
   L"data/actor/sinmyoumaru/atkMid0002.bmp",
   L"data/actor/sinmyoumaru/atkMid0003.bmp",
   L"data/actor/sinmyoumaru/atkMid0004.bmp",
   L"data/actor/sinmyoumaru/atkMid0005.bmp",
   L"data/actor/sinmyoumaru/atkMid0006.bmp",
   L"data/actor/sinmyoumaru/atkMid0007.bmp",
   L"data/actor/sinmyoumaru/atkMid0008.bmp",
   L"data/actor/sinmyoumaru/atkUpper0000.bmp",
   L"data/actor/sinmyoumaru/atkUpper0001.bmp",
   L"data/actor/sinmyoumaru/atkUpper0002.bmp",
   L"data/actor/sinmyoumaru/atkUpper0003.bmp",
   L"data/actor/sinmyoumaru/atkUpper0004.bmp",
   L"data/actor/sinmyoumaru/atkUpper0005.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0000.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0001.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0002.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0003.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0004.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0005.bmp",
   L"data/actor/sinmyoumaru/battleBeginA0006.bmp",
   L"data/actor/sinmyoumaru/bmsln/reimu_buster.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_busterHit.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_fallKickA.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_HighShotBaria.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_keisei.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_kibakuzinA.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouB.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouG.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouHitB.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouHitG.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouHitR.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_musouR.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_shot.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_shotA.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_shotA_gateRing.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_shotA_hit.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_skillG_kick.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_TenseiA000.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_tenseiFinish.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_tenseiRock.bmb",
   L"data/actor/sinmyoumaru/bmsln/reimu_tenseiRockShot.bmb",
   L"data/actor/sinmyoumaru/bmsln/shot_A_000.bmb",
   L"data/actor/sinmyoumaru/bmsln/shot_A_000.bmsln",
   L"data/actor/sinmyoumaru/chargeShot_slash0000.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slash0001.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slash0002.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slash0003.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slash0004.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slash0005.bmp",
   L"data/actor/sinmyoumaru/chargeshot_slash0006.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0000.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0001.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0002.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0003.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0004.bmp",
   L"data/actor/sinmyoumaru/chargeShot_slashB0005.bmp",
   L"data/actor/sinmyoumaru/climax0000.bmp",
   L"data/actor/sinmyoumaru/climax0001.bmp",
   L"data/actor/sinmyoumaru/climax0002.bmp",
   L"data/actor/sinmyoumaru/climax0003.bmp",
   L"data/actor/sinmyoumaru/climax0004.bmp",
   L"data/actor/sinmyoumaru/climax0005.bmp",
   L"data/actor/sinmyoumaru/climax0006.bmp",
   L"data/actor/sinmyoumaru/climax0007.bmp",
   L"data/actor/sinmyoumaru/climax0008.bmp",
   L"data/actor/sinmyoumaru/climax0009.bmp",
   L"data/actor/sinmyoumaru/climax0010.bmp",
   L"data/actor/sinmyoumaru/climaxCut0000.png",
   L"data/actor/sinmyoumaru/climax_cut0000.png",
   L"data/actor/sinmyoumaru/climax_koduchi0000.bmp",
   L"data/actor/sinmyoumaru/crash0000.bmp",
   L"data/actor/sinmyoumaru/crash0001.bmp",
   L"data/actor/sinmyoumaru/crash0002.bmp",
   L"data/actor/sinmyoumaru/crash0003.bmp",
   L"data/actor/sinmyoumaru/crash0004.bmp",
   L"data/actor/sinmyoumaru/damageBody0000.bmp",
   L"data/actor/sinmyoumaru/damageBody0001.bmp",
   L"data/actor/sinmyoumaru/damageBody0002.bmp",
   L"data/actor/sinmyoumaru/damageBody0003.bmp",
   L"data/actor/sinmyoumaru/damageBody0004.bmp",
   L"data/actor/sinmyoumaru/damageHead0000.bmp",
   L"data/actor/sinmyoumaru/damageHead0001.bmp",
   L"data/actor/sinmyoumaru/damageHead0002.bmp",
   L"data/actor/sinmyoumaru/damageHead0003.bmp",
   L"data/actor/sinmyoumaru/damageHead0004.bmp",
   L"data/actor/sinmyoumaru/damageSpin0000.bmp",
   L"data/actor/sinmyoumaru/damageSpin0001.bmp",
   L"data/actor/sinmyoumaru/damageSpin0002.bmp",
   L"data/actor/sinmyoumaru/damageSpin0003.bmp",
   L"data/actor/sinmyoumaru/damageUnder0000.bmp",
   L"data/actor/sinmyoumaru/damageUnder0001.bmp",
   L"data/actor/sinmyoumaru/damageUnder0002.bmp",
   L"data/actor/sinmyoumaru/damageUnder0003.bmp",
   L"data/actor/sinmyoumaru/damageUnder0004.bmp",
   L"data/actor/sinmyoumaru/damageUnder0005.bmp",
   L"data/actor/sinmyoumaru/damageUnder0006.bmp",
   L"data/actor/sinmyoumaru/damageUnder0007.bmp",
   L"data/actor/sinmyoumaru/damageUnder0008.bmp",
   L"data/actor/sinmyoumaru/damageUpper0001.bmp",
   L"data/actor/sinmyoumaru/damageUpper0002.bmp",
   L"data/actor/sinmyoumaru/damageUpper0003.bmp",
   L"data/actor/sinmyoumaru/damageUpper0004.bmp",
   L"data/actor/sinmyoumaru/damageUpper0005.bmp",
   L"data/actor/sinmyoumaru/damageUpper0006.bmp",
   L"data/actor/sinmyoumaru/damageUpper0007.bmp",
   L"data/actor/sinmyoumaru/damageUpper0008.bmp",
   L"data/actor/sinmyoumaru/damageUpper0009.bmp",
   L"data/actor/sinmyoumaru/damageUpper0010.bmp",
   L"data/actor/sinmyoumaru/damageUpper0011.bmp",
   L"data/actor/sinmyoumaru/damageUpper0012.bmp",
   L"data/actor/sinmyoumaru/damageUpper0013.bmp",
   L"data/actor/sinmyoumaru/damageUpper0014.bmp",
   L"data/actor/sinmyoumaru/damageUpper0015.bmp",
   L"data/actor/sinmyoumaru/damageUpper0016.bmp",
   L"data/actor/sinmyoumaru/damageWall0000.bmp",
   L"data/actor/sinmyoumaru/damageWall0001.bmp",
   L"data/actor/sinmyoumaru/damageWall0002.bmp",
   L"data/actor/sinmyoumaru/damageWall0003.bmp",
   L"data/actor/sinmyoumaru/damageWall0004.bmp",
   L"data/actor/sinmyoumaru/damageWall0005.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0002.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0003.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0004.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0005.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0006.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0007.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0008.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0009.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0010.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0011.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0012.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0013.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0014.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0015.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0016.bmp",
   L"data/actor/sinmyoumaru/damage_Upper0017.bmp",
   L"data/actor/sinmyoumaru/dashBack0000.bmp",
   L"data/actor/sinmyoumaru/dashBack0001.bmp",
   L"data/actor/sinmyoumaru/dashBack0002.bmp",
   L"data/actor/sinmyoumaru/dashBack0003.bmp",
   L"data/actor/sinmyoumaru/dashFront0000.bmp",
   L"data/actor/sinmyoumaru/dashFront0001.bmp",
   L"data/actor/sinmyoumaru/dashFront0002.bmp",
   L"data/actor/sinmyoumaru/dashFront0003.bmp",
   L"data/actor/sinmyoumaru/face_spellCallB.png",
   L"data/actor/sinmyoumaru/grab0000.bmp",
   L"data/actor/sinmyoumaru/grab0001.bmp",
   L"data/actor/sinmyoumaru/grab0002.bmp",
   L"data/actor/sinmyoumaru/grab0003.bmp",
   L"data/actor/sinmyoumaru/grab0004.bmp",
   L"data/actor/sinmyoumaru/grab_hit0000.bmp",
   L"data/actor/sinmyoumaru/grab_hit0001.bmp",
   L"data/actor/sinmyoumaru/grab_hit0002.bmp",
   L"data/actor/sinmyoumaru/grab_hit0003.bmp",
   L"data/actor/sinmyoumaru/grab_hit0004.bmp",
   L"data/actor/sinmyoumaru/grab_hit0005.bmp",
   L"data/actor/sinmyoumaru/grab_hit0006.bmp",
   L"data/actor/sinmyoumaru/grab_hit0007.bmp",
   L"data/actor/sinmyoumaru/grab_hit0008.bmp",
   L"data/actor/sinmyoumaru/grab_hit0009.bmp",
   L"data/actor/sinmyoumaru/grab_hit0010.bmp",
   L"data/actor/sinmyoumaru/grab_hit0011.bmp",
   L"data/actor/sinmyoumaru/grab_hit0012.bmp",
   L"data/actor/sinmyoumaru/grab_hit0013.bmp",
   L"data/actor/sinmyoumaru/grab_hit0014.bmp",
   L"data/actor/sinmyoumaru/guard0000.bmp",
   L"data/actor/sinmyoumaru/guard0001.bmp",
   L"data/actor/sinmyoumaru/guard0002.bmp",
   L"data/actor/sinmyoumaru/guard0003.bmp",
   L"data/actor/sinmyoumaru/guard0004.bmp",
   L"data/actor/sinmyoumaru/guardMiss0001.bmp",
   L"data/actor/sinmyoumaru/guardMiss0002.bmp",
   L"data/actor/sinmyoumaru/guardMiss0003.bmp",
   L"data/actor/sinmyoumaru/guardMiss0004.bmp",
   L"data/actor/sinmyoumaru/lose0000.bmp",
   L"data/actor/sinmyoumaru/lose0001.bmp",
   L"data/actor/sinmyoumaru/lose0002.bmp",
   L"data/actor/sinmyoumaru/lose0003.bmp",
   L"data/actor/sinmyoumaru/lose0004.bmp",
   L"data/actor/sinmyoumaru/occult0000.bmp",
   L"data/actor/sinmyoumaru/occult0001.bmp",
   L"data/actor/sinmyoumaru/occult0002.bmp",
   L"data/actor/sinmyoumaru/occult0003.bmp",
   L"data/actor/sinmyoumaru/occult0004.bmp",
   L"data/actor/sinmyoumaru/occult0005.bmp",
   L"data/actor/sinmyoumaru/occult_objectA0000.bmp",
   L"data/actor/sinmyoumaru/occult_objectA0001.bmp",
   L"data/actor/sinmyoumaru/palette000.bmp",
   L"data/actor/sinmyoumaru/palette001.bmp",
   L"data/actor/sinmyoumaru/palette002.bmp",
   L"data/actor/sinmyoumaru/palette003.bmp",
   L"data/actor/sinmyoumaru/palette004.bmp",
   L"data/actor/sinmyoumaru/palette005.bmp",
   L"data/actor/sinmyoumaru/palette006.bmp",
   L"data/actor/sinmyoumaru/palette007.bmp",
   L"data/actor/sinmyoumaru/palette100.bmp",
   L"data/actor/sinmyoumaru/palette101.bmp",
   L"data/actor/sinmyoumaru/palette102.bmp",
   L"data/actor/sinmyoumaru/palette103.bmp",
   L"data/actor/sinmyoumaru/palette104.bmp",
   L"data/actor/sinmyoumaru/palette105.bmp",
   L"data/actor/sinmyoumaru/palette106.bmp",
   L"data/actor/sinmyoumaru/palette107.bmp",
   L"data/actor/sinmyoumaru/shotCharge0000.bmp",
   L"data/actor/sinmyoumaru/shotCharge0001.bmp",
   L"data/actor/sinmyoumaru/shotCharge0002.bmp",
   L"data/actor/sinmyoumaru/shotCharge0003.bmp",
   L"data/actor/sinmyoumaru/shotCharge0004.bmp",
   L"data/actor/sinmyoumaru/shotCharge0005.bmp",
   L"data/actor/sinmyoumaru/shotCharge0006.bmp",
   L"data/actor/sinmyoumaru/shotCharge0007.bmp",
   L"data/actor/sinmyoumaru/shotCharge0008.bmp",
   L"data/actor/sinmyoumaru/shotNormal0000.bmp",
   L"data/actor/sinmyoumaru/shotNormal0001.bmp",
   L"data/actor/sinmyoumaru/shotNormal0002.bmp",
   L"data/actor/sinmyoumaru/shotNormal0003.bmp",
   L"data/actor/sinmyoumaru/shotNormal0004.bmp",
   L"data/actor/sinmyoumaru/shotNormal0005.bmp",
   L"data/actor/sinmyoumaru/shotNormal0006.bmp",
   L"data/actor/sinmyoumaru/shotNormal0007.bmp",
   L"data/actor/sinmyoumaru/shotNormal0008.bmp",
   L"data/actor/sinmyoumaru/sinmyoumaru.pat",
   L"data/actor/sinmyoumaru/sinmyoumaru_ed.pat",
   L"data/actor/sinmyoumaru/skillA0000.bmp",
   L"data/actor/sinmyoumaru/skillA0001.bmp",
   L"data/actor/sinmyoumaru/skillA0002.bmp",
   L"data/actor/sinmyoumaru/skillA0003.bmp",
   L"data/actor/sinmyoumaru/skillA0004.bmp",
   L"data/actor/sinmyoumaru/skillA0005.bmp",
   L"data/actor/sinmyoumaru/skillA0006.bmp",
   L"data/actor/sinmyoumaru/skillA0007.bmp",
   L"data/actor/sinmyoumaru/skillA0008.bmp",
   L"data/actor/sinmyoumaru/skillA0009.bmp",
   L"data/actor/sinmyoumaru/skillA0010.bmp",
   L"data/actor/sinmyoumaru/skillA0011.bmp",
   L"data/actor/sinmyoumaru/skillB0000.bmp",
   L"data/actor/sinmyoumaru/skillB0001.bmp",
   L"data/actor/sinmyoumaru/skillB0002.bmp",
   L"data/actor/sinmyoumaru/skillB0003.bmp",
   L"data/actor/sinmyoumaru/skillB0004.bmp",
   L"data/actor/sinmyoumaru/skillB0005.bmp",
   L"data/actor/sinmyoumaru/skillB0006.bmp",
   L"data/actor/sinmyoumaru/skillB0007.bmp",
   L"data/actor/sinmyoumaru/skillB0008.bmp",
   L"data/actor/sinmyoumaru/skillC0000.bmp",
   L"data/actor/sinmyoumaru/skillC0001.bmp",
   L"data/actor/sinmyoumaru/skillC0002.bmp",
   L"data/actor/sinmyoumaru/skillC0003.bmp",
   L"data/actor/sinmyoumaru/skillC0004.bmp",
   L"data/actor/sinmyoumaru/skillC0005.bmp",
   L"data/actor/sinmyoumaru/skillC0006.bmp",
   L"data/actor/sinmyoumaru/skillC0007.bmp",
   L"data/actor/sinmyoumaru/skillC0008.bmp",
   L"data/actor/sinmyoumaru/skillD0001.bmp",
   L"data/actor/sinmyoumaru/skillD0002.bmp",
   L"data/actor/sinmyoumaru/skillD0003.bmp",
   L"data/actor/sinmyoumaru/skillD0004.bmp",
   L"data/actor/sinmyoumaru/skillD0005.bmp",
   L"data/actor/sinmyoumaru/skillD0006.bmp",
   L"data/actor/sinmyoumaru/skillD0007.bmp",
   L"data/actor/sinmyoumaru/skillD0008.bmp",
   L"data/actor/sinmyoumaru/skillD0009.bmp",
   L"data/actor/sinmyoumaru/skillD0010.bmp",
   L"data/actor/sinmyoumaru/skillE0000.bmp",
   L"data/actor/sinmyoumaru/skillE0001.bmp",
   L"data/actor/sinmyoumaru/skillE0002.bmp",
   L"data/actor/sinmyoumaru/skillE0003.bmp",
   L"data/actor/sinmyoumaru/skillE0004.bmp",
   L"data/actor/sinmyoumaru/skillE0005.bmp",
   L"data/actor/sinmyoumaru/skillE0006.bmp",
   L"data/actor/sinmyoumaru/skillE0007.bmp",
   L"data/actor/sinmyoumaru/skillE0008.bmp",
   L"data/actor/sinmyoumaru/skillE0009.bmp",
   L"data/actor/sinmyoumaru/skillE0010.bmp",
   L"data/actor/sinmyoumaru/skillE0011.bmp",
   L"data/actor/sinmyoumaru/skillE0012.bmp",
   L"data/actor/sinmyoumaru/skillE0013.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0000.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0001.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0002.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0003.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0004.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0005.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0006.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0007.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0008.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0009.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0010.bmp",
   L"data/actor/sinmyoumaru/skill_hammer_spin0011.bmp",
   L"data/actor/sinmyoumaru/slide0000.bmp",
   L"data/actor/sinmyoumaru/slide0002.bmp",
   L"data/actor/sinmyoumaru/slide0003.bmp",
   L"data/actor/sinmyoumaru/slide0004.bmp",
   L"data/actor/sinmyoumaru/slide0005.bmp",
   L"data/actor/sinmyoumaru/slide0006.bmp",
   L"data/actor/sinmyoumaru/slide0008.bmp",
   L"data/actor/sinmyoumaru/slideLoopA0000.bmp",
   L"data/actor/sinmyoumaru/slideLoopA0001.bmp",
   L"data/actor/sinmyoumaru/slideLoopA0002.bmp",
   L"data/actor/sinmyoumaru/slideLoopA0003.bmp",
   L"data/actor/sinmyoumaru/slideLoopA0004.bmp",
   L"data/actor/sinmyoumaru/slideUnderLoop0000.bmp",
   L"data/actor/sinmyoumaru/slideUnderLoop0001.bmp",
   L"data/actor/sinmyoumaru/slideUnderLoop0002.bmp",
   L"data/actor/sinmyoumaru/slideUnderLoop0003.bmp",
   L"data/actor/sinmyoumaru/slideUnderLoop0004.bmp",
   L"data/actor/sinmyoumaru/slideUpper0000.bmp",
   L"data/actor/sinmyoumaru/slideUpper0001.bmp",
   L"data/actor/sinmyoumaru/slideUpper0002.bmp",
   L"data/actor/sinmyoumaru/slideUpper0003.bmp",
   L"data/actor/sinmyoumaru/slideUpper0004.bmp",
   L"data/actor/sinmyoumaru/slideUpper0005.bmp",
   L"data/actor/sinmyoumaru/slideUpper0006.bmp",
   L"data/actor/sinmyoumaru/slideUpper0007.bmp",
   L"data/actor/sinmyoumaru/slideUpper0008.bmp",
   L"data/actor/sinmyoumaru/slideUpperLoop0000.bmp",
   L"data/actor/sinmyoumaru/slideUpperLoop0001.bmp",
   L"data/actor/sinmyoumaru/slideUpperLoop0002.bmp",
   L"data/actor/sinmyoumaru/slideUpperLoop0003.bmp",
   L"data/actor/sinmyoumaru/slideUpperLoop0004.bmp",
   L"data/actor/sinmyoumaru/spellA0000.bmp",
   L"data/actor/sinmyoumaru/spellA0001.bmp",
   L"data/actor/sinmyoumaru/spellA0002.bmp",
   L"data/actor/sinmyoumaru/spellA0003.bmp",
   L"data/actor/sinmyoumaru/spellA0004.bmp",
   L"data/actor/sinmyoumaru/spellA0005.bmp",
   L"data/actor/sinmyoumaru/spellA0006.bmp",
   L"data/actor/sinmyoumaru/spellA0007.bmp",
   L"data/actor/sinmyoumaru/spellA0008.bmp",
   L"data/actor/sinmyoumaru/spellA0009.bmp",
   L"data/actor/sinmyoumaru/spellA0010.bmp",
   L"data/actor/sinmyoumaru/spellA0011.bmp",
   L"data/actor/sinmyoumaru/spellA0012.bmp",
   L"data/actor/sinmyoumaru/spellB0000.bmp",
   L"data/actor/sinmyoumaru/spellB0001.bmp",
   L"data/actor/sinmyoumaru/spellB0002.bmp",
   L"data/actor/sinmyoumaru/spellB0003.bmp",
   L"data/actor/sinmyoumaru/spellB0004.bmp",
   L"data/actor/sinmyoumaru/spellB0005.bmp",
   L"data/actor/sinmyoumaru/sprash0000.bmp",
   L"data/actor/sinmyoumaru/sprash0001.bmp",
   L"data/actor/sinmyoumaru/sprash0002.bmp",
   L"data/actor/sinmyoumaru/sprash0003.bmp",
   L"data/actor/sinmyoumaru/sprash0004.bmp",
   L"data/actor/sinmyoumaru/stand0000.bmp",
   L"data/actor/sinmyoumaru/stand0001.bmp",
   L"data/actor/sinmyoumaru/stand0002.bmp",
   L"data/actor/sinmyoumaru/stand0003.bmp",
   L"data/actor/sinmyoumaru/stand0004.bmp",
   L"data/actor/sinmyoumaru/stand0005.bmp",
   L"data/actor/sinmyoumaru/stand0006.bmp",
   L"data/actor/sinmyoumaru/stand0007.bmp",
   L"data/actor/sinmyoumaru/stand0008.bmp",
   L"data/actor/sinmyoumaru/stand0009.bmp",
   L"data/actor/sinmyoumaru/standB0000.bmp",
   L"data/actor/sinmyoumaru/standB0001.bmp",
   L"data/actor/sinmyoumaru/standB0002.bmp",
   L"data/actor/sinmyoumaru/standB0003.bmp",
   L"data/actor/sinmyoumaru/standB0004.bmp",
   L"data/actor/sinmyoumaru/standB0005.bmp",
   L"data/actor/sinmyoumaru/standB0006.bmp",
   L"data/actor/sinmyoumaru/stun0000.bmp",
   L"data/actor/sinmyoumaru/stun0001.bmp",
   L"data/actor/sinmyoumaru/stun0002.bmp",
   L"data/actor/sinmyoumaru/stun0003.bmp",
   L"data/actor/sinmyoumaru/stun0004.bmp",
   L"data/actor/sinmyoumaru/testR_climax0007.png",
   L"data/actor/sinmyoumaru/test_effect.bmp",
   L"data/actor/sinmyoumaru/texture/ball.bmp",
   L"data/actor/sinmyoumaru/texture/climax_back0000.png",
   L"data/actor/sinmyoumaru/texture/climax_foot0002.png",
   L"data/actor/sinmyoumaru/texture/climax_giant0000.png",
   L"data/actor/sinmyoumaru/texture/climax_giant0001.dds",
   L"data/actor/sinmyoumaru/texture/climax_giant0002.png",
   L"data/actor/sinmyoumaru/texture/climax_giant0003.png",
   L"data/actor/sinmyoumaru/texture/climax_hammerLight0000.dds",
   L"data/actor/sinmyoumaru/texture/face_master_sinmyoumaru.png",
   L"data/actor/sinmyoumaru/texture/face_master_sinmyoumaru2.png",
   L"data/actor/sinmyoumaru/texture/face_slave_sinmyoumaru.png",
   L"data/actor/sinmyoumaru/texture/face_spell_cut.png",
   L"data/actor/sinmyoumaru/texture/lightning_mapA.png",
   L"data/actor/sinmyoumaru/texture/marisaBall2.bmp",
   L"data/actor/sinmyoumaru/texture/marisaStarFlare.bmp",
   L"data/actor/sinmyoumaru/texture/mask_ball.png",
   L"data/actor/sinmyoumaru/texture/miko_climaxblade.png",
   L"data/actor/sinmyoumaru/texture/occult_shot0000.dds",
   L"data/actor/sinmyoumaru/texture/occult_trail.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00000.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00006.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00012.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00018.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animal00024.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00000.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00006.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00012.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00018.png",
   L"data/actor/sinmyoumaru/texture/shinmyoumaru_animalDamage00024.png",
   L"data/actor/sinmyoumaru/texture/shotStingA0000.png",
   L"data/actor/sinmyoumaru/texture/sinmyoumaru_shotNormal0000.png",
   L"data/actor/sinmyoumaru/texture/skillA_wave0000.dds",
   L"data/actor/sinmyoumaru/texture/skillB_sword0000.dds",
   L"data/actor/sinmyoumaru/texture/skillC_texture0000.dds",
   L"data/actor/sinmyoumaru/texture/skillD_fish0000.dds",
   L"data/actor/sinmyoumaru/texture/skillD_fish0001.dds",
   L"data/actor/sinmyoumaru/texture/skillD_fish0002.dds",
   L"data/actor/sinmyoumaru/texture/smoke.png",
   L"data/actor/sinmyoumaru/texture/spellA_swing0000.dds",
   L"data/actor/sinmyoumaru/texture/spellB_smallAura0000.png",
   L"data/actor/sinmyoumaru/texture/spellB_smallAura0001.png",
   L"data/actor/sinmyoumaru/texture/spellB_smallAura0002.png",
   L"data/actor/sinmyoumaru/texture/spellB_smallAura0003.png",
   L"data/actor/sinmyoumaru/texture/spellC_fish0000.dds",
   L"data/actor/sinmyoumaru/texture/spellC_splash.dds",
   L"data/actor/sinmyoumaru/texture/spell_use_cut.png",
   L"data/actor/sinmyoumaru/texture/stone0000.dds",
   L"data/actor/sinmyoumaru/texture/swing0000.png",
   L"data/actor/sinmyoumaru/texture/watarBall0000.dds",
   L"data/actor/sinmyoumaru/walk0000.bmp",
   L"data/actor/sinmyoumaru/walk0001.bmp",
   L"data/actor/sinmyoumaru/walk0002.bmp",
   L"data/actor/sinmyoumaru/walk0003.bmp",
   L"data/actor/sinmyoumaru/walk0004.bmp",
   L"data/actor/sinmyoumaru/walkBack0000.bmp",
   L"data/actor/sinmyoumaru/walkBack0001.bmp",
   L"data/actor/sinmyoumaru/walkBack0002.bmp",
   L"data/actor/sinmyoumaru/walkBack0003.bmp",
   L"data/actor/sinmyoumaru/walkBack0004.bmp",
   L"data/actor/sinmyoumaru/walk_back0000.bmp",
   L"data/actor/sinmyoumaru/walk_back0001.bmp",
   L"data/actor/sinmyoumaru/walk_back0002.bmp",
   L"data/actor/sinmyoumaru/walk_back0003.bmp",
   L"data/actor/sinmyoumaru/walk_back0004.bmp",
   L"data/actor/sinmyoumaru/walk_front0000.bmp",
   L"data/actor/sinmyoumaru/walk_front0001.bmp",
   L"data/actor/sinmyoumaru/walk_front0002.bmp",
   L"data/actor/sinmyoumaru/walk_front0003.bmp",
   L"data/actor/sinmyoumaru/walk_front0004.bmp",
   L"data/actor/sinmyoumaru/warpMask.bmp",
   L"data/actor/sinmyoumaru/winA0000.bmp",
   L"data/actor/sinmyoumaru/winA0001.bmp",
   L"data/actor/sinmyoumaru/winA0002.bmp",
   L"data/actor/sinmyoumaru/winA0003.bmp",
   L"data/actor/sinmyoumaru/winA0004.bmp",
   L"data/actor/sinmyoumaru/winA0005.bmp",
   L"data/actor/sinmyoumaru/winA0006.bmp",
   L"data/actor/sinmyoumaru/winA0007.bmp",
   L"data/actor/sinmyoumaru/winA0008.bmp",
   L"data/actor/sinmyoumaru/winA0009.bmp",
   L"data/actor/sinmyoumaru.nut",
   L"data/actor/sinmyoumaru_base.nut",
   L"data/actor/sinmyoumaru_boss.nut",
   L"data/actor/sinmyoumaru_boss_base.nut",
   L"data/actor/sinmyoumaru_boss_init.nut",
   L"data/actor/sinmyoumaru_boss_shot.nut",
   L"data/actor/sinmyoumaru_com.nut",
   L"data/actor/sinmyoumaru_combo.nut",
   L"data/actor/sinmyoumaru_com_function.nut",
   L"data/actor/sinmyoumaru_init.nut",
   L"data/actor/sinmyoumaru_practice_init.nut",
   L"data/actor/sinmyoumaru_shot.nut",
   L"data/actor/sinmyoumaru_team.nut",
   L"data/actor/status/bgm_title.nut",
   L"data/actor/status/combo.nut",
   L"data/actor/status/combo.pat",
   L"data/actor/status/gauge.pat",
   L"data/actor/status/gauge_common.nut",
   L"data/actor/status/gauge_sp.pat",
   L"data/actor/status/gauge_story.nut",
   L"data/actor/status/gauge_vs.nut",
   L"data/actor/status/spellcard.nut",
   L"data/actor/status/texture/gauge.png",
   L"data/actor/story_name/doremy/name.pat",
   L"data/actor/story_name/doremy/name.png",
   L"data/actor/story_name/doremy/name2.pat",
   L"data/actor/story_name/doremy/name_back.png",
   L"data/actor/story_name/futo/name.pat",
   L"data/actor/story_name/futo/name.png",
   L"data/actor/story_name/futo/name2.pat",
   L"data/actor/story_name/futo/name_back.png",
   L"data/actor/story_name/hijiri/name.pat",
   L"data/actor/story_name/hijiri/name.png",
   L"data/actor/story_name/hijiri/name2.pat",
   L"data/actor/story_name/hijiri/name_back.png",
   L"data/actor/story_name/ichirin/name.pat",
   L"data/actor/story_name/ichirin/name.png",
   L"data/actor/story_name/ichirin/name2.pat",
   L"data/actor/story_name/ichirin/name_back.png",
   L"data/actor/story_name/jyoon/name.pat",
   L"data/actor/story_name/jyoon/name.png",
   L"data/actor/story_name/jyoon/name2.pat",
   L"data/actor/story_name/jyoon/name_back.png",
   L"data/actor/story_name/kasen/name.pat",
   L"data/actor/story_name/kasen/name.png",
   L"data/actor/story_name/kasen/name2.pat",
   L"data/actor/story_name/kasen/name_back.png",
   L"data/actor/story_name/koishi/name.pat",
   L"data/actor/story_name/koishi/name.png",
   L"data/actor/story_name/koishi/name2.pat",
   L"data/actor/story_name/koishi/name_back.png",
   L"data/actor/story_name/kokoro/name.pat",
   L"data/actor/story_name/kokoro/name.png",
   L"data/actor/story_name/kokoro/name2.pat",
   L"data/actor/story_name/kokoro/name_back.png",
   L"data/actor/story_name/mamizou/name.pat",
   L"data/actor/story_name/mamizou/name.png",
   L"data/actor/story_name/mamizou/name2.pat",
   L"data/actor/story_name/mamizou/name_back.png",
   L"data/actor/story_name/marisa/name.pat",
   L"data/actor/story_name/marisa/name2.pat",
   L"data/actor/story_name/marisa/name_back.png",
   L"data/actor/story_name/marisa/name_marisa.png",
   L"data/actor/story_name/miko/name.pat",
   L"data/actor/story_name/miko/name.png",
   L"data/actor/story_name/miko/name2.pat",
   L"data/actor/story_name/miko/name_back.png",
   L"data/actor/story_name/mokou/name.pat",
   L"data/actor/story_name/mokou/name.png",
   L"data/actor/story_name/mokou/name2.pat",
   L"data/actor/story_name/mokou/name_back.png",
   L"data/actor/story_name/nitori/name.pat",
   L"data/actor/story_name/nitori/name.png",
   L"data/actor/story_name/nitori/name2.pat",
   L"data/actor/story_name/nitori/name_back.png",
   L"data/actor/story_name/reimu/name.pat",
   L"data/actor/story_name/reimu/name.png",
   L"data/actor/story_name/reimu/name2.pat",
   L"data/actor/story_name/reimu/name_back.png",
   L"data/actor/story_name/shion/name.pat",
   L"data/actor/story_name/shion/name.png",
   L"data/actor/story_name/shion/name2.pat",
   L"data/actor/story_name/shion/name_back.png",
   L"data/actor/story_name/sinmyoumaru/name.pat",
   L"data/actor/story_name/sinmyoumaru/name.png",
   L"data/actor/story_name/sinmyoumaru/name2.pat",
   L"data/actor/story_name/sinmyoumaru/name_back.png",
   L"data/actor/story_name/tenshi/name.pat",
   L"data/actor/story_name/tenshi/name.png",
   L"data/actor/story_name/tenshi/name2.pat",
   L"data/actor/story_name/tenshi/name_back.png",
   L"data/actor/story_name/udonge/name.pat",
   L"data/actor/story_name/udonge/name.png",
   L"data/actor/story_name/udonge/name2.pat",
   L"data/actor/story_name/udonge/name_back.png",
   L"data/actor/story_name/usami/name.pat",
   L"data/actor/story_name/usami/name.png",
   L"data/actor/story_name/usami/name2.pat",
   L"data/actor/story_name/usami/name_back.png",
   L"data/actor/story_name/yukari/name.pat",
   L"data/actor/story_name/yukari/name.png",
   L"data/actor/story_name/yukari/name2.pat",
   L"data/actor/story_name/yukari/name_back.png",
   L"data/actor/story_title/futo/title.pat",
   L"data/actor/story_title/futo/title2.pat",
   L"data/actor/story_title/futo/title3.pat",
   L"data/actor/story_title/futo/title4.pat",
   L"data/actor/story_title/futo/title5.pat",
   L"data/actor/story_title/futo/title_back.png",
   L"data/actor/story_title/futo/title_futo_1.png",
   L"data/actor/story_title/futo/title_futo_2.png",
   L"data/actor/story_title/futo/title_futo_3.png",
   L"data/actor/story_title/futo/title_futo_4.png",
   L"data/actor/story_title/futo/title_futo_5.png",
   L"data/actor/story_title/futo/title_shadow.png",
   L"data/actor/story_title/jyoon/title.pat",
   L"data/actor/story_title/jyoon/title2.pat",
   L"data/actor/story_title/jyoon/title3.pat",
   L"data/actor/story_title/jyoon/title4.pat",
   L"data/actor/story_title/jyoon/title5.pat",
   L"data/actor/story_title/jyoon/title6.pat",
   L"data/actor/story_title/jyoon/title_back.png",
   L"data/actor/story_title/jyoon/title_jyoon_1.png",
   L"data/actor/story_title/jyoon/title_jyoon_2.png",
   L"data/actor/story_title/jyoon/title_jyoon_3.png",
   L"data/actor/story_title/jyoon/title_jyoon_4.png",
   L"data/actor/story_title/jyoon/title_jyoon_5.png",
   L"data/actor/story_title/jyoon/title_jyoon_6.png",
   L"data/actor/story_title/jyoon/title_shadow.png",
   L"data/actor/story_title/mamizou/title.pat",
   L"data/actor/story_title/mamizou/title2.pat",
   L"data/actor/story_title/mamizou/title3.pat",
   L"data/actor/story_title/mamizou/title4.pat",
   L"data/actor/story_title/mamizou/title5.pat",
   L"data/actor/story_title/mamizou/title_back.png",
   L"data/actor/story_title/mamizou/title_mamizou1.png",
   L"data/actor/story_title/mamizou/title_mamizou2.png",
   L"data/actor/story_title/mamizou/title_mamizou3.png",
   L"data/actor/story_title/mamizou/title_mamizou4.png",
   L"data/actor/story_title/mamizou/title_mamizou5.png",
   L"data/actor/story_title/mamizou/title_shadow.png",
   L"data/actor/story_title/marisa/title.pat",
   L"data/actor/story_title/marisa/title2.pat",
   L"data/actor/story_title/marisa/title3.pat",
   L"data/actor/story_title/marisa/title4.pat",
   L"data/actor/story_title/marisa/title5.pat",
   L"data/actor/story_title/marisa/title_back.png",
   L"data/actor/story_title/marisa/title_marisa_1.png",
   L"data/actor/story_title/marisa/title_marisa_2.png",
   L"data/actor/story_title/marisa/title_marisa_3.png",
   L"data/actor/story_title/marisa/title_marisa_4.png",
   L"data/actor/story_title/marisa/title_marisa_5.png",
   L"data/actor/story_title/marisa/title_shadow.png",
   L"data/actor/story_title/miko/title.pat",
   L"data/actor/story_title/miko/title2.pat",
   L"data/actor/story_title/miko/title3.pat",
   L"data/actor/story_title/miko/title4.pat",
   L"data/actor/story_title/miko/title5.pat",
   L"data/actor/story_title/miko/title_back.png",
   L"data/actor/story_title/miko/title_miko_1.png",
   L"data/actor/story_title/miko/title_miko_2.png",
   L"data/actor/story_title/miko/title_miko_3.png",
   L"data/actor/story_title/miko/title_miko_4.png",
   L"data/actor/story_title/miko/title_miko_5.png",
   L"data/actor/story_title/miko/title_shadow.png",
   L"data/actor/story_title/nitori/title.pat",
   L"data/actor/story_title/nitori/title2.pat",
   L"data/actor/story_title/nitori/title3.pat",
   L"data/actor/story_title/nitori/title4.pat",
   L"data/actor/story_title/nitori/title5.pat",
   L"data/actor/story_title/nitori/title_back.png",
   L"data/actor/story_title/nitori/title_nitori_1.png",
   L"data/actor/story_title/nitori/title_nitori_2.png",
   L"data/actor/story_title/nitori/title_nitori_3.png",
   L"data/actor/story_title/nitori/title_nitori_4.png",
   L"data/actor/story_title/nitori/title_nitori_5.png",
   L"data/actor/story_title/nitori/title_shadow.png",
   L"data/actor/story_title/reimu/title.pat",
   L"data/actor/story_title/reimu/title2.pat",
   L"data/actor/story_title/reimu/title3.pat",
   L"data/actor/story_title/reimu/title4.pat",
   L"data/actor/story_title/reimu/title_back.png",
   L"data/actor/story_title/reimu/title_reimu_1.png",
   L"data/actor/story_title/reimu/title_reimu_2.png",
   L"data/actor/story_title/reimu/title_reimu_3.png",
   L"data/actor/story_title/reimu/title_reimu_4.png",
   L"data/actor/story_title/reimu/title_shadow.png",
   L"data/actor/story_title/tenshi/title.pat",
   L"data/actor/story_title/tenshi/title2.pat",
   L"data/actor/story_title/tenshi/title3.pat",
   L"data/actor/story_title/tenshi/title4.pat",
   L"data/actor/story_title/tenshi/title5.pat",
   L"data/actor/story_title/tenshi/title_back.png",
   L"data/actor/story_title/tenshi/title_shadow.png",
   L"data/actor/story_title/tenshi/title_tenshi_1.png",
   L"data/actor/story_title/tenshi/title_tenshi_2.png",
   L"data/actor/story_title/tenshi/title_tenshi_3.png",
   L"data/actor/story_title/tenshi/title_tenshi_4.png",
   L"data/actor/story_title/tenshi/title_tenshi_5.png",
   L"data/actor/story_title/udonge/title.pat",
   L"data/actor/story_title/udonge/title2.pat",
   L"data/actor/story_title/udonge/title3.pat",
   L"data/actor/story_title/udonge/title4.pat",
   L"data/actor/story_title/udonge/title_back.png",
   L"data/actor/story_title/udonge/title_shadow.png",
   L"data/actor/story_title/udonge/title_udonge_1.png",
   L"data/actor/story_title/udonge/title_udonge_2.png",
   L"data/actor/story_title/udonge/title_udonge_3.png",
   L"data/actor/story_title/udonge/title_udonge_4.png",
   L"data/actor/story_title/usami/title.pat",
   L"data/actor/story_title/usami/title2.pat",
   L"data/actor/story_title/usami/title3.pat",
   L"data/actor/story_title/usami/title4.pat",
   L"data/actor/story_title/usami/title5.pat",
   L"data/actor/story_title/usami/title_back.png",
   L"data/actor/story_title/usami/title_shadow.png",
   L"data/actor/story_title/usami/title_usami_1.png",
   L"data/actor/story_title/usami/title_usami_2.png",
   L"data/actor/story_title/usami/title_usami_3.png",
   L"data/actor/story_title/usami/title_usami_4.png",
   L"data/actor/story_title/usami/title_usami_5.png",
   L"data/actor/story_title/yukari/title.pat",
   L"data/actor/story_title/yukari/title2.pat",
   L"data/actor/story_title/yukari/title_back.png",
   L"data/actor/story_title/yukari/title_shadow.png",
   L"data/actor/story_title/yukari/title_yukari_1.png",
   L"data/actor/story_title/yukari/title_yukari_2.png",
   L"data/actor/tenshi/animal0000.png",
   L"data/actor/tenshi/animal0001.png",
   L"data/actor/tenshi/animal0002.png",
   L"data/actor/tenshi/animal0003.png",
   L"data/actor/tenshi/animal0004.png",
   L"data/actor/tenshi/animal0005.png",
   L"data/actor/tenshi/animal0006.png",
   L"data/actor/tenshi/animal0007.png",
   L"data/actor/tenshi/animal0008.png",
   L"data/actor/tenshi/animal0009.png",
   L"data/actor/tenshi/animal_damage0000.png",
   L"data/actor/tenshi/animal_damage0001.png",
   L"data/actor/tenshi/animal_damage0002.png",
   L"data/actor/tenshi/animal_damage0003.png",
   L"data/actor/tenshi/animal_damage0004.png",
   L"data/actor/tenshi/atk_air0000.bmp",
   L"data/actor/tenshi/atk_air0001.bmp",
   L"data/actor/tenshi/atk_air0002.bmp",
   L"data/actor/tenshi/atk_air0003.bmp",
   L"data/actor/tenshi/atk_air0004.bmp",
   L"data/actor/tenshi/atk_air0005.bmp",
   L"data/actor/tenshi/atk_air0006.bmp",
   L"data/actor/tenshi/atk_front0000.bmp",
   L"data/actor/tenshi/atk_front0001.bmp",
   L"data/actor/tenshi/atk_front0002.bmp",
   L"data/actor/tenshi/atk_front0003.bmp",
   L"data/actor/tenshi/atk_front0004.bmp",
   L"data/actor/tenshi/atk_front0005.bmp",
   L"data/actor/tenshi/atk_front0006.bmp",
   L"data/actor/tenshi/atk_front0007.bmp",
   L"data/actor/tenshi/atk_front0008.bmp",
   L"data/actor/tenshi/atk_front0009.bmp",
   L"data/actor/tenshi/atk_front0010.bmp",
   L"data/actor/tenshi/atk_low0000.bmp",
   L"data/actor/tenshi/atk_low0001.bmp",
   L"data/actor/tenshi/atk_low0002.bmp",
   L"data/actor/tenshi/atk_low0003.bmp",
   L"data/actor/tenshi/atk_low0004.bmp",
   L"data/actor/tenshi/atk_low0005.bmp",
   L"data/actor/tenshi/atk_Mid0000.bmp",
   L"data/actor/tenshi/atk_Mid0001.bmp",
   L"data/actor/tenshi/atk_Mid0002.bmp",
   L"data/actor/tenshi/atk_Mid0003.bmp",
   L"data/actor/tenshi/atk_Mid0004.bmp",
   L"data/actor/tenshi/atk_Mid0005.bmp",
   L"data/actor/tenshi/atk_Mid0006.bmp",
   L"data/actor/tenshi/atk_Mid0007.bmp",
   L"data/actor/tenshi/atk_Mid0008.bmp",
   L"data/actor/tenshi/atk_Mid0009.bmp",
   L"data/actor/tenshi/atk_under0000.bmp",
   L"data/actor/tenshi/atk_under0001.bmp",
   L"data/actor/tenshi/atk_under0002.bmp",
   L"data/actor/tenshi/atk_under0003.bmp",
   L"data/actor/tenshi/atk_under0004.bmp",
   L"data/actor/tenshi/atk_under0005.bmp",
   L"data/actor/tenshi/atk_under0006.bmp",
   L"data/actor/tenshi/atk_under0007.bmp",
   L"data/actor/tenshi/atk_under0008.bmp",
   L"data/actor/tenshi/atk_under0009.bmp",
   L"data/actor/tenshi/atk_upper0000.bmp",
   L"data/actor/tenshi/atk_upper0001.bmp",
   L"data/actor/tenshi/atk_upper0002.bmp",
   L"data/actor/tenshi/atk_upper0003.bmp",
   L"data/actor/tenshi/atk_upper0004.bmp",
   L"data/actor/tenshi/atk_upper0005.bmp",
   L"data/actor/tenshi/atk_upper0006.bmp",
   L"data/actor/tenshi/battle_begin_A0000.bmp",
   L"data/actor/tenshi/battle_begin_A0001.bmp",
   L"data/actor/tenshi/battle_begin_A0002.bmp",
   L"data/actor/tenshi/battle_begin_A0003.bmp",
   L"data/actor/tenshi/battle_begin_A0004.bmp",
   L"data/actor/tenshi/battle_begin_A0005.bmp",
   L"data/actor/tenshi/begin_battleB000.bmp",
   L"data/actor/tenshi/damage_body0000.bmp",
   L"data/actor/tenshi/damage_body0001.bmp",
   L"data/actor/tenshi/damage_body0002.bmp",
   L"data/actor/tenshi/damage_body0003.bmp",
   L"data/actor/tenshi/damage_down0001.bmp",
   L"data/actor/tenshi/damage_down0002.bmp",
   L"data/actor/tenshi/damage_down0003.bmp",
   L"data/actor/tenshi/damage_down0004.bmp",
   L"data/actor/tenshi/damage_down0005.bmp",
   L"data/actor/tenshi/damage_down0006.bmp",
   L"data/actor/tenshi/damage_down0007.bmp",
   L"data/actor/tenshi/damage_down0008.bmp",
   L"data/actor/tenshi/damage_down0009.bmp",
   L"data/actor/tenshi/damage_down0010.bmp",
   L"data/actor/tenshi/damage_down0011.bmp",
   L"data/actor/tenshi/damage_head0000.bmp",
   L"data/actor/tenshi/damage_head0001.bmp",
   L"data/actor/tenshi/damage_head0002.bmp",
   L"data/actor/tenshi/damage_head0003.bmp",
   L"data/actor/tenshi/damage_head0004.bmp",
   L"data/actor/tenshi/damage_spin0000.bmp",
   L"data/actor/tenshi/damage_spin0001.bmp",
   L"data/actor/tenshi/damage_spin0002.bmp",
   L"data/actor/tenshi/damage_spin0003.bmp",
   L"data/actor/tenshi/damage_stun0000.bmp",
   L"data/actor/tenshi/damage_stun0001.bmp",
   L"data/actor/tenshi/damage_stun0002.bmp",
   L"data/actor/tenshi/damage_stun0003.bmp",
   L"data/actor/tenshi/damage_stun0004.bmp",
   L"data/actor/tenshi/damage_stun0005.bmp",
   L"data/actor/tenshi/damage_stun0006.bmp",
   L"data/actor/tenshi/damage_wall0000.bmp",
   L"data/actor/tenshi/damage_wall0001.bmp",
   L"data/actor/tenshi/damage_wall0002.bmp",
   L"data/actor/tenshi/damage_wall0003.bmp",
   L"data/actor/tenshi/damage_wall0004.bmp",
   L"data/actor/tenshi/dash_back0000.bmp",
   L"data/actor/tenshi/dash_back0001.bmp",
   L"data/actor/tenshi/dash_back0002.bmp",
   L"data/actor/tenshi/dash_back0003.bmp",
   L"data/actor/tenshi/dash_back0004.bmp",
   L"data/actor/tenshi/dash_back0005.bmp",
   L"data/actor/tenshi/dash_back0006.bmp",
   L"data/actor/tenshi/dash_back0007.bmp",
   L"data/actor/tenshi/dash_back0008.bmp",
   L"data/actor/tenshi/dash_front0000.bmp",
   L"data/actor/tenshi/dash_front0001.bmp",
   L"data/actor/tenshi/dash_front0002.bmp",
   L"data/actor/tenshi/dash_front0003.bmp",
   L"data/actor/tenshi/dash_front0004.bmp",
   L"data/actor/tenshi/dash_front0005.bmp",
   L"data/actor/tenshi/dash_front0006.bmp",
   L"data/actor/tenshi/dash_front0007.bmp",
   L"data/actor/tenshi/dash_front0008.bmp",
   L"data/actor/tenshi/dash_front0009.bmp",
   L"data/actor/tenshi/dash_front0010.bmp",
   L"data/actor/tenshi/dash_front0011.bmp",
   L"data/actor/tenshi/dash_front0012.bmp",
   L"data/actor/tenshi/grab0000.bmp",
   L"data/actor/tenshi/grab0001.bmp",
   L"data/actor/tenshi/grab0002.bmp",
   L"data/actor/tenshi/grab0003.bmp",
   L"data/actor/tenshi/grab0004.bmp",
   L"data/actor/tenshi/guard0000.bmp",
   L"data/actor/tenshi/guard0001.bmp",
   L"data/actor/tenshi/guard0002.bmp",
   L"data/actor/tenshi/guard_crash0000.bmp",
   L"data/actor/tenshi/guard_crash0001.bmp",
   L"data/actor/tenshi/guard_crash0002.bmp",
   L"data/actor/tenshi/guard_crash0003.bmp",
   L"data/actor/tenshi/guard_miss0000.bmp",
   L"data/actor/tenshi/guard_miss0001.bmp",
   L"data/actor/tenshi/guard_miss0002.bmp",
   L"data/actor/tenshi/kaname_dorill0001.bmp",
   L"data/actor/tenshi/kaname_dorill0002.bmp",
   L"data/actor/tenshi/kaname_foot0000.bmp",
   L"data/actor/tenshi/kaname_foot0001.bmp",
   L"data/actor/tenshi/kaname_foot0002.bmp",
   L"data/actor/tenshi/kaname_foot0003.bmp",
   L"data/actor/tenshi/kaname_foot0004.bmp",
   L"data/actor/tenshi/kaname_foot0005.bmp",
   L"data/actor/tenshi/kaname_foot0006.bmp",
   L"data/actor/tenshi/kaname_foot0007.bmp",
   L"data/actor/tenshi/kaname_foot0008.bmp",
   L"data/actor/tenshi/kaname_pile0000.bmp",
   L"data/actor/tenshi/kaname_pile0001.bmp",
   L"data/actor/tenshi/kaname_pile0002.bmp",
   L"data/actor/tenshi/kaname_pile0003.bmp",
   L"data/actor/tenshi/kaname_shot000.bmp",
   L"data/actor/tenshi/kaname_shot001.bmp",
   L"data/actor/tenshi/last_word_A0000.bmp",
   L"data/actor/tenshi/last_word_A0001.bmp",
   L"data/actor/tenshi/last_word_A0002.bmp",
   L"data/actor/tenshi/last_word_A0003.bmp",
   L"data/actor/tenshi/last_word_A0004.bmp",
   L"data/actor/tenshi/last_word_A0005.bmp",
   L"data/actor/tenshi/last_word_A0006.bmp",
   L"data/actor/tenshi/last_word_A0007.bmp",
   L"data/actor/tenshi/last_word_A0008.bmp",
   L"data/actor/tenshi/last_word_A0009.bmp",
   L"data/actor/tenshi/last_word_A0010.bmp",
   L"data/actor/tenshi/last_word_A0011.bmp",
   L"data/actor/tenshi/last_word_B0000.bmp",
   L"data/actor/tenshi/last_word_B0001.bmp",
   L"data/actor/tenshi/last_word_B0002.bmp",
   L"data/actor/tenshi/last_word_C0000.bmp",
   L"data/actor/tenshi/last_word_C0001.bmp",
   L"data/actor/tenshi/last_word_C0002.bmp",
   L"data/actor/tenshi/last_word_C0003.bmp",
   L"data/actor/tenshi/last_word_C0004.bmp",
   L"data/actor/tenshi/last_word_C0005.bmp",
   L"data/actor/tenshi/last_word_C0006.bmp",
   L"data/actor/tenshi/lose0000.bmp",
   L"data/actor/tenshi/lose0001.bmp",
   L"data/actor/tenshi/lose0002.bmp",
   L"data/actor/tenshi/lose0003.bmp",
   L"data/actor/tenshi/palette000.bmp",
   L"data/actor/tenshi/palette001.bmp",
   L"data/actor/tenshi/palette002.bmp",
   L"data/actor/tenshi/palette003.bmp",
   L"data/actor/tenshi/palette004.bmp",
   L"data/actor/tenshi/palette005.bmp",
   L"data/actor/tenshi/palette006.bmp",
   L"data/actor/tenshi/palette007.bmp",
   L"data/actor/tenshi/palette100.bmp",
   L"data/actor/tenshi/palette101.bmp",
   L"data/actor/tenshi/palette102.bmp",
   L"data/actor/tenshi/palette103.bmp",
   L"data/actor/tenshi/palette104.bmp",
   L"data/actor/tenshi/palette105.bmp",
   L"data/actor/tenshi/palette106.bmp",
   L"data/actor/tenshi/palette107.bmp",
   L"data/actor/tenshi/shot_charge0000.bmp",
   L"data/actor/tenshi/shot_charge0001.bmp",
   L"data/actor/tenshi/shot_charge0002.bmp",
   L"data/actor/tenshi/shot_charge0003.bmp",
   L"data/actor/tenshi/shot_charge0004.bmp",
   L"data/actor/tenshi/shot_charge0005.bmp",
   L"data/actor/tenshi/shot_charge0006.bmp",
   L"data/actor/tenshi/shot_charge0007.bmp",
   L"data/actor/tenshi/shot_charge0008.bmp",
   L"data/actor/tenshi/shot_charge0009.bmp",
   L"data/actor/tenshi/shot_front0000.bmp",
   L"data/actor/tenshi/shot_front0001.bmp",
   L"data/actor/tenshi/shot_front0002.bmp",
   L"data/actor/tenshi/shot_front0003.bmp",
   L"data/actor/tenshi/shot_front0004.bmp",
   L"data/actor/tenshi/shot_front0005.bmp",
   L"data/actor/tenshi/shot_front0006.bmp",
   L"data/actor/tenshi/shot_front0007.bmp",
   L"data/actor/tenshi/shot_front0008.bmp",
   L"data/actor/tenshi/shot_front0009.bmp",
   L"data/actor/tenshi/shot_front_catch0000.bmp",
   L"data/actor/tenshi/shot_front_catch0001.bmp",
   L"data/actor/tenshi/shot_front_catch0002.bmp",
   L"data/actor/tenshi/shot_front_catch0003.bmp",
   L"data/actor/tenshi/skill_blade_slash0000.bmp",
   L"data/actor/tenshi/skill_blade_slash0001.bmp",
   L"data/actor/tenshi/skill_blade_slash0002.bmp",
   L"data/actor/tenshi/skill_blade_slash0003.bmp",
   L"data/actor/tenshi/skill_blade_slash0004.bmp",
   L"data/actor/tenshi/skill_blade_slash0005.bmp",
   L"data/actor/tenshi/skill_blade_slash0006.bmp",
   L"data/actor/tenshi/skill_blade_slash0007.bmp",
   L"data/actor/tenshi/skill_blade_slash0008.bmp",
   L"data/actor/tenshi/skill_blade_slash0009.bmp",
   L"data/actor/tenshi/skill_blade_slash0010.bmp",
   L"data/actor/tenshi/skill_blade_slash0011.bmp",
   L"data/actor/tenshi/skill_blade_slash0012.bmp",
   L"data/actor/tenshi/skill_blade_slash0013.bmp",
   L"data/actor/tenshi/skill_kaname_crash0000.bmp",
   L"data/actor/tenshi/skill_kaname_crash0001.bmp",
   L"data/actor/tenshi/skill_kaname_crash0002.bmp",
   L"data/actor/tenshi/skill_kaname_crash0003.bmp",
   L"data/actor/tenshi/skill_kaname_crash0004.bmp",
   L"data/actor/tenshi/skill_kaname_crash0005.bmp",
   L"data/actor/tenshi/skill_kaname_crash0006.bmp",
   L"data/actor/tenshi/skill_kaname_crash0007.bmp",
   L"data/actor/tenshi/skill_kaname_crash0008.bmp",
   L"data/actor/tenshi/skill_kaname_crash0009.bmp",
   L"data/actor/tenshi/skill_kaname_crash0010.bmp",
   L"data/actor/tenshi/skill_kaname_koma0000.bmp",
   L"data/actor/tenshi/skill_kaname_koma0001.bmp",
   L"data/actor/tenshi/skill_kaname_koma0002.bmp",
   L"data/actor/tenshi/skill_kaname_koma0003.bmp",
   L"data/actor/tenshi/skill_kaname_koma0004.bmp",
   L"data/actor/tenshi/skill_kaname_koma0005.bmp",
   L"data/actor/tenshi/skill_kaname_koma0006.bmp",
   L"data/actor/tenshi/skill_kaname_koma0007.bmp",
   L"data/actor/tenshi/skill_kaname_koma0008.bmp",
   L"data/actor/tenshi/skill_kaname_koma0009.bmp",
   L"data/actor/tenshi/skill_laname_jump0000.bmp",
   L"data/actor/tenshi/skill_laname_jump0001.bmp",
   L"data/actor/tenshi/skill_laname_jump0002.bmp",
   L"data/actor/tenshi/skill_laname_jump0003.bmp",
   L"data/actor/tenshi/skill_laname_jump0004.bmp",
   L"data/actor/tenshi/skill_laname_jump0005.bmp",
   L"data/actor/tenshi/skill_occult0000.bmp",
   L"data/actor/tenshi/skill_occult0001.bmp",
   L"data/actor/tenshi/skill_occult0002.bmp",
   L"data/actor/tenshi/skill_occult0003.bmp",
   L"data/actor/tenshi/skill_occult0004.bmp",
   L"data/actor/tenshi/skill_occult0005.bmp",
   L"data/actor/tenshi/skill_occult0006.bmp",
   L"data/actor/tenshi/skill_occult0007.bmp",
   L"data/actor/tenshi/skill_occult0008.bmp",
   L"data/actor/tenshi/slide0000.bmp",
   L"data/actor/tenshi/slide0001.bmp",
   L"data/actor/tenshi/slide0002.bmp",
   L"data/actor/tenshi/slide0003.bmp",
   L"data/actor/tenshi/slide0004.bmp",
   L"data/actor/tenshi/slide0005.bmp",
   L"data/actor/tenshi/slide0006.bmp",
   L"data/actor/tenshi/slide0007.bmp",
   L"data/actor/tenshi/slide0008.bmp",
   L"data/actor/tenshi/slide0009.bmp",
   L"data/actor/tenshi/slide0010.bmp",
   L"data/actor/tenshi/slide0011.bmp",
   L"data/actor/tenshi/slide0012.bmp",
   L"data/actor/tenshi/slide0013.bmp",
   L"data/actor/tenshi/slide0014.bmp",
   L"data/actor/tenshi/slide0015.bmp",
   L"data/actor/tenshi/slide0016.bmp",
   L"data/actor/tenshi/spell_call0000.bmp",
   L"data/actor/tenshi/spell_call0001.bmp",
   L"data/actor/tenshi/spell_call0002.bmp",
   L"data/actor/tenshi/spell_call0003.bmp",
   L"data/actor/tenshi/spell_call0004.bmp",
   L"data/actor/tenshi/spell_call0005.bmp",
   L"data/actor/tenshi/spell_call0006.bmp",
   L"data/actor/tenshi/spell_kaname_bit0000.bmp",
   L"data/actor/tenshi/spell_kaname_bit0001.bmp",
   L"data/actor/tenshi/spell_kaname_bit0002.bmp",
   L"data/actor/tenshi/spell_kaname_bit0003.bmp",
   L"data/actor/tenshi/spell_kaname_bit0004.bmp",
   L"data/actor/tenshi/spell_kaname_bit0005.bmp",
   L"data/actor/tenshi/spell_kaname_bit0006.bmp",
   L"data/actor/tenshi/spell_kaname_bit0007.bmp",
   L"data/actor/tenshi/spell_kaname_bit0008.bmp",
   L"data/actor/tenshi/spell_kaname_bit0009.bmp",
   L"data/actor/tenshi/spell_kaname_bit0010.bmp",
   L"data/actor/tenshi/spell_kaname_bit0011.bmp",
   L"data/actor/tenshi/spell_kick0000.bmp",
   L"data/actor/tenshi/spell_kick0001.bmp",
   L"data/actor/tenshi/spell_kick0002.bmp",
   L"data/actor/tenshi/spell_kick0003.bmp",
   L"data/actor/tenshi/spell_kick0004.bmp",
   L"data/actor/tenshi/spell_kick0005.bmp",
   L"data/actor/tenshi/spell_kick0006.bmp",
   L"data/actor/tenshi/spell_kick0007.bmp",
   L"data/actor/tenshi/spell_kick0008.bmp",
   L"data/actor/tenshi/spell_kick0009.bmp",
   L"data/actor/tenshi/spell_kick0010.bmp",
   L"data/actor/tenshi/spell_kick0011.bmp",
   L"data/actor/tenshi/spell_kick0012.bmp",
   L"data/actor/tenshi/spell_kick0013.bmp",
   L"data/actor/tenshi/spell_kick0014.bmp",
   L"data/actor/tenshi/spell_peach_eat0000.bmp",
   L"data/actor/tenshi/spell_peach_eat0001.bmp",
   L"data/actor/tenshi/spell_peach_eat0002.bmp",
   L"data/actor/tenshi/spell_peach_eat0003.bmp",
   L"data/actor/tenshi/spell_peach_eat0004.bmp",
   L"data/actor/tenshi/spell_peach_eat0005.bmp",
   L"data/actor/tenshi/spell_peach_eat0006.bmp",
   L"data/actor/tenshi/spell_peach_eat0007.bmp",
   L"data/actor/tenshi/spell_peach_eat0008.bmp",
   L"data/actor/tenshi/spell_peach_eat0009.bmp",
   L"data/actor/tenshi/spell_peach_eat0010.bmp",
   L"data/actor/tenshi/spell_peach_eat0011.bmp",
   L"data/actor/tenshi/stand0000.bmp",
   L"data/actor/tenshi/stand0001.bmp",
   L"data/actor/tenshi/stand0002.bmp",
   L"data/actor/tenshi/stand0003.bmp",
   L"data/actor/tenshi/stand0004.bmp",
   L"data/actor/tenshi/stand0005.bmp",
   L"data/actor/tenshi/stand0006.bmp",
   L"data/actor/tenshi/stand0007.bmp",
   L"data/actor/tenshi/stand0008.bmp",
   L"data/actor/tenshi/stand0009.bmp",
   L"data/actor/tenshi/stone_koma0000.bmp",
   L"data/actor/tenshi/stone_koma0001.bmp",
   L"data/actor/tenshi/stone_koma0002.bmp",
   L"data/actor/tenshi/tenshi.pat",
   L"data/actor/tenshi/texture/animal0000.png",
   L"data/actor/tenshi/texture/animal0001.png",
   L"data/actor/tenshi/texture/animal0002.png",
   L"data/actor/tenshi/texture/animal0003.png",
   L"data/actor/tenshi/texture/animal0004.png",
   L"data/actor/tenshi/texture/animal0005.png",
   L"data/actor/tenshi/texture/animal0006.png",
   L"data/actor/tenshi/texture/animal0007.png",
   L"data/actor/tenshi/texture/animal0008.png",
   L"data/actor/tenshi/texture/animal0009.png",
   L"data/actor/tenshi/texture/animal_damage0000.png",
   L"data/actor/tenshi/texture/animal_damage0001.png",
   L"data/actor/tenshi/texture/animal_damage0002.png",
   L"data/actor/tenshi/texture/animal_damage0003.png",
   L"data/actor/tenshi/texture/animal_damage0004.png",
   L"data/actor/tenshi/texture/blade_air_b0000.png",
   L"data/actor/tenshi/texture/blade_air_b0001.png",
   L"data/actor/tenshi/texture/blade_air_b0002.png",
   L"data/actor/tenshi/texture/blade_air_b0003.png",
   L"data/actor/tenshi/texture/blade_air_b0004.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0000.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0001.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0002.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0003.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0004.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0005.png",
   L"data/actor/tenshi/texture/blade_charge_shot_0006.png",
   L"data/actor/tenshi/texture/blade_far0000.png",
   L"data/actor/tenshi/texture/blade_far0001.png",
   L"data/actor/tenshi/texture/blade_far0002.png",
   L"data/actor/tenshi/texture/blade_far0003.png",
   L"data/actor/tenshi/texture/blade_front_a_0001.png",
   L"data/actor/tenshi/texture/blade_front_a_0002.png",
   L"data/actor/tenshi/texture/blade_front_a_0003.png",
   L"data/actor/tenshi/texture/blade_front_a_0004.png",
   L"data/actor/tenshi/texture/blade_front_a_0005.png",
   L"data/actor/tenshi/texture/blade_hisouken0000.png",
   L"data/actor/tenshi/texture/blade_hisouken0001.png",
   L"data/actor/tenshi/texture/blade_hisouken0002.png",
   L"data/actor/tenshi/texture/blade_hisouken0003.png",
   L"data/actor/tenshi/texture/blade_hisouken0004.png",
   L"data/actor/tenshi/texture/blade_hisouken0005.png",
   L"data/actor/tenshi/texture/blade_hisouken0006.png",
   L"data/actor/tenshi/texture/blade_upper_a0000.png",
   L"data/actor/tenshi/texture/blade_upper_a0001.png",
   L"data/actor/tenshi/texture/blade_upper_a0002.png",
   L"data/actor/tenshi/texture/blade_upper_a0003.png",
   L"data/actor/tenshi/texture/blade_upper_a0004.png",
   L"data/actor/tenshi/texture/bullet_barrage_000.png",
   L"data/actor/tenshi/texture/climax_cut.png",
   L"data/actor/tenshi/texture/face_master_tenshi.png",
   L"data/actor/tenshi/texture/face_master_tenshi2.png",
   L"data/actor/tenshi/texture/face_slave_tenshi.png",
   L"data/actor/tenshi/texture/face_spell_cut_0000.png",
   L"data/actor/tenshi/texture/ground_000.png",
   L"data/actor/tenshi/texture/hisou_laser_000.png",
   L"data/actor/tenshi/texture/lastWord_sky0000.png",
   L"data/actor/tenshi/texture/namazu_shot000.png",
   L"data/actor/tenshi/texture/namazu_shot001.png",
   L"data/actor/tenshi/texture/occult_clowd.png",
   L"data/actor/tenshi/texture/spell_use_cut.png",
   L"data/actor/tenshi/texture/sunRing.png",
   L"data/actor/tenshi/texture/sword_0000.png",
   L"data/actor/tenshi/texture/sword_0001.png",
   L"data/actor/tenshi/texture/sword_0002.png",
   L"data/actor/tenshi/texture/sword_0003.png",
   L"data/actor/tenshi/texture/sword_0004.png",
   L"data/actor/tenshi/texture/test_lastWord0002.png",
   L"data/actor/tenshi/texture/test_thunder.png",
   L"data/actor/tenshi/texture/wind_line.png",
   L"data/actor/tenshi/turn0000.bmp",
   L"data/actor/tenshi/turn0001.bmp",
   L"data/actor/tenshi/turn0002.bmp",
   L"data/actor/tenshi/walk_back0000.bmp",
   L"data/actor/tenshi/walk_back0001.bmp",
   L"data/actor/tenshi/walk_back0002.bmp",
   L"data/actor/tenshi/walk_back0003.bmp",
   L"data/actor/tenshi/walk_back0004.bmp",
   L"data/actor/tenshi/walk_back0005.bmp",
   L"data/actor/tenshi/walk_back0006.bmp",
   L"data/actor/tenshi/walk_back0007.bmp",
   L"data/actor/tenshi/walk_back0008.bmp",
   L"data/actor/tenshi/walk_front0000.bmp",
   L"data/actor/tenshi/walk_front0001.bmp",
   L"data/actor/tenshi/walk_front0002.bmp",
   L"data/actor/tenshi/walk_front0003.bmp",
   L"data/actor/tenshi/walk_front0004.bmp",
   L"data/actor/tenshi/walk_front0005.bmp",
   L"data/actor/tenshi/walk_front0006.bmp",
   L"data/actor/tenshi/walk_front0007.bmp",
   L"data/actor/tenshi/win_A0000.bmp",
   L"data/actor/tenshi/win_A0001.bmp",
   L"data/actor/tenshi/win_A0002.bmp",
   L"data/actor/tenshi/win_A0003.bmp",
   L"data/actor/tenshi/win_A0004.bmp",
   L"data/actor/tenshi.nut",
   L"data/actor/tenshi_base.nut",
   L"data/actor/tenshi_boss.nut",
   L"data/actor/tenshi_boss_base.nut",
   L"data/actor/tenshi_boss_init.nut",
   L"data/actor/tenshi_boss_shot.nut",
   L"data/actor/tenshi_com.nut",
   L"data/actor/tenshi_combo.nut",
   L"data/actor/tenshi_com_function.nut",
   L"data/actor/tenshi_init.nut",
   L"data/actor/tenshi_practice_init.nut",
   L"data/actor/tenshi_shot.nut",
   L"data/actor/tenshi_team.nut",
   L"data/actor/tutorial/tutorial_effect.pat",
   L"data/actor/tutorial/tutorial_snap000.png",
   L"data/actor/udonge/atkFront0000.bmp",
   L"data/actor/udonge/atkFront0001.bmp",
   L"data/actor/udonge/atkFront0002.bmp",
   L"data/actor/udonge/atkFront0003.bmp",
   L"data/actor/udonge/atkFront0004.bmp",
   L"data/actor/udonge/atkFront0005.bmp",
   L"data/actor/udonge/atkFront0006.bmp",
   L"data/actor/udonge/atk_dashLow0000.bmp",
   L"data/actor/udonge/atk_dashLow0001.bmp",
   L"data/actor/udonge/atk_dashLow0002.bmp",
   L"data/actor/udonge/atk_dashLow0003.bmp",
   L"data/actor/udonge/atk_dashLow0004.bmp",
   L"data/actor/udonge/atk_dashLow0005.bmp",
   L"data/actor/udonge/atk_dashLow0006.bmp",
   L"data/actor/udonge/atk_HighFrontAir0000.bmp",
   L"data/actor/udonge/atk_HighFrontAir0001.bmp",
   L"data/actor/udonge/atk_HighFrontAir0002.bmp",
   L"data/actor/udonge/atk_HighFrontAir0003.bmp",
   L"data/actor/udonge/atk_HighFrontAir0004.bmp",
   L"data/actor/udonge/atk_HighFrontAir0005.bmp",
   L"data/actor/udonge/atk_HighUnder0000.bmp",
   L"data/actor/udonge/atk_HighUnder0001.bmp",
   L"data/actor/udonge/atk_HighUnder0002.bmp",
   L"data/actor/udonge/atk_HighUnder0003.bmp",
   L"data/actor/udonge/atk_HighUnder0004.bmp",
   L"data/actor/udonge/atk_HighUnderAir0000.bmp",
   L"data/actor/udonge/atk_HighUnderAir0001.bmp",
   L"data/actor/udonge/atk_HighUnderAir0002.bmp",
   L"data/actor/udonge/atk_HighUnderAir0003.bmp",
   L"data/actor/udonge/atk_HighUnderAir0004.bmp",
   L"data/actor/udonge/atk_HighUnderAir0005.bmp",
   L"data/actor/udonge/atk_Low0000.bmp",
   L"data/actor/udonge/atk_Low0001.bmp",
   L"data/actor/udonge/atk_Low0002.bmp",
   L"data/actor/udonge/atk_Low0003.bmp",
   L"data/actor/udonge/atk_Low0004.bmp",
   L"data/actor/udonge/atk_Mid0000.bmp",
   L"data/actor/udonge/atk_Mid0001.bmp",
   L"data/actor/udonge/atk_Mid0002.bmp",
   L"data/actor/udonge/atk_Mid0003.bmp",
   L"data/actor/udonge/atk_Mid0004.bmp",
   L"data/actor/udonge/atk_Mid0005.bmp",
   L"data/actor/udonge/atk_MidAir0000.bmp",
   L"data/actor/udonge/atk_MidAir0001.bmp",
   L"data/actor/udonge/atk_MidAir0002.bmp",
   L"data/actor/udonge/atk_MidAir0003.bmp",
   L"data/actor/udonge/atk_MidAir0004.bmp",
   L"data/actor/udonge/atk_MidAir0005.bmp",
   L"data/actor/udonge/atk_upper0000.bmp",
   L"data/actor/udonge/atk_upper0001.bmp",
   L"data/actor/udonge/atk_upper0002.bmp",
   L"data/actor/udonge/atk_upper0003.bmp",
   L"data/actor/udonge/atk_upper0004.bmp",
   L"data/actor/udonge/battleBeginA0000.bmp",
   L"data/actor/udonge/battleBeginA0001.bmp",
   L"data/actor/udonge/battleBeginA0002.bmp",
   L"data/actor/udonge/battleBeginA0003.bmp",
   L"data/actor/udonge/battleBeginA0004.bmp",
   L"data/actor/udonge/battleBeginA0005.bmp",
   L"data/actor/udonge/battleBeginB0000.bmp",
   L"data/actor/udonge/battleBeginB0001.bmp",
   L"data/actor/udonge/battle_begin_team0000.bmp",
   L"data/actor/udonge/battle_begin_team0001.bmp",
   L"data/actor/udonge/battle_begin_team0002.bmp",
   L"data/actor/udonge/battle_begin_team0003.bmp",
   L"data/actor/udonge/battle_begin_team0004.bmp",
   L"data/actor/udonge/crash0000.bmp",
   L"data/actor/udonge/crash0001.bmp",
   L"data/actor/udonge/crash0002.bmp",
   L"data/actor/udonge/crash0003.bmp",
   L"data/actor/udonge/crash0004.bmp",
   L"data/actor/udonge/crash0005.bmp",
   L"data/actor/udonge/damage_body0000.bmp",
   L"data/actor/udonge/damage_body0001.bmp",
   L"data/actor/udonge/damage_body0002.bmp",
   L"data/actor/udonge/damage_body0003.bmp",
   L"data/actor/udonge/damage_Down0000.bmp",
   L"data/actor/udonge/damage_Down0001.bmp",
   L"data/actor/udonge/damage_Down0002.bmp",
   L"data/actor/udonge/damage_Down0003.bmp",
   L"data/actor/udonge/damage_Down0004.bmp",
   L"data/actor/udonge/damage_Down0005.bmp",
   L"data/actor/udonge/damage_DownB0000.bmp",
   L"data/actor/udonge/damage_DownB0001.bmp",
   L"data/actor/udonge/damage_DownB0002.bmp",
   L"data/actor/udonge/damage_DownB0003.bmp",
   L"data/actor/udonge/damage_DownB0004.bmp",
   L"data/actor/udonge/damage_DownB0005.bmp",
   L"data/actor/udonge/damage_DownB0006.bmp",
   L"data/actor/udonge/damage_DownB0007.bmp",
   L"data/actor/udonge/damage_DownB0008.bmp",
   L"data/actor/udonge/damage_DownB0009.bmp",
   L"data/actor/udonge/damage_DownB0010.bmp",
   L"data/actor/udonge/damage_head0000.bmp",
   L"data/actor/udonge/damage_head0001.bmp",
   L"data/actor/udonge/damage_head0002.bmp",
   L"data/actor/udonge/damage_head0003.bmp",
   L"data/actor/udonge/damage_head0004.bmp",
   L"data/actor/udonge/damage_spin0000.bmp",
   L"data/actor/udonge/damage_spin0001.bmp",
   L"data/actor/udonge/damage_spin0002.bmp",
   L"data/actor/udonge/damage_spin0003.bmp",
   L"data/actor/udonge/damage_stun0000.bmp",
   L"data/actor/udonge/damage_stun0001.bmp",
   L"data/actor/udonge/damage_stun0002.bmp",
   L"data/actor/udonge/damage_stun0003.bmp",
   L"data/actor/udonge/damage_stun0004.bmp",
   L"data/actor/udonge/damage_stun0005.bmp",
   L"data/actor/udonge/damage_wall0000.bmp",
   L"data/actor/udonge/damage_wall0001.bmp",
   L"data/actor/udonge/damage_wall0002.bmp",
   L"data/actor/udonge/damage_wall0003.bmp",
   L"data/actor/udonge/damage_wall0004.bmp",
   L"data/actor/udonge/damage_wall0005.bmp",
   L"data/actor/udonge/dash_back0000.bmp",
   L"data/actor/udonge/dash_back0001.bmp",
   L"data/actor/udonge/dash_back0002.bmp",
   L"data/actor/udonge/dash_back0003.bmp",
   L"data/actor/udonge/dash_back0004.bmp",
   L"data/actor/udonge/dash_back0005.bmp",
   L"data/actor/udonge/dash_back0006.bmp",
   L"data/actor/udonge/dash_back0007.bmp",
   L"data/actor/udonge/dash_back0008.bmp",
   L"data/actor/udonge/dash_back0009.bmp",
   L"data/actor/udonge/dash_back0010.bmp",
   L"data/actor/udonge/dash_front0000.bmp",
   L"data/actor/udonge/dash_front0001.bmp",
   L"data/actor/udonge/dash_front0002.bmp",
   L"data/actor/udonge/dash_front0003.bmp",
   L"data/actor/udonge/dash_front0004.bmp",
   L"data/actor/udonge/dash_front0005.bmp",
   L"data/actor/udonge/dash_front0006.bmp",
   L"data/actor/udonge/dash_front0007.bmp",
   L"data/actor/udonge/dash_front0008.bmp",
   L"data/actor/udonge/dash_front0009.bmp",
   L"data/actor/udonge/dash_front0010.bmp",
   L"data/actor/udonge/dummy.bmp",
   L"data/actor/udonge/grab0000.bmp",
   L"data/actor/udonge/grab0001.bmp",
   L"data/actor/udonge/grab0002.bmp",
   L"data/actor/udonge/grab0003.bmp",
   L"data/actor/udonge/grab0004.bmp",
   L"data/actor/udonge/grab0005.bmp",
   L"data/actor/udonge/grab0006.bmp",
   L"data/actor/udonge/grab_hit0000.bmp",
   L"data/actor/udonge/grab_hit0001.bmp",
   L"data/actor/udonge/guard0000.bmp",
   L"data/actor/udonge/guard0001.bmp",
   L"data/actor/udonge/guard0002.bmp",
   L"data/actor/udonge/guard_miss0000.bmp",
   L"data/actor/udonge/guard_miss0001.bmp",
   L"data/actor/udonge/guard_miss0002.bmp",
   L"data/actor/udonge/guard_miss0003.bmp",
   L"data/actor/udonge/kuneA0000.bmp",
   L"data/actor/udonge/kuneA0001.bmp",
   L"data/actor/udonge/kuneA2P0000.bmp",
   L"data/actor/udonge/kuneA2P0001.bmp",
   L"data/actor/udonge/kuneB0000.bmp",
   L"data/actor/udonge/kuneB0001.bmp",
   L"data/actor/udonge/kuneB0002.bmp",
   L"data/actor/udonge/kuneB0003.bmp",
   L"data/actor/udonge/kuneB0004.bmp",
   L"data/actor/udonge/kuneB0005.bmp",
   L"data/actor/udonge/kuneB2P0000.bmp",
   L"data/actor/udonge/kuneB2P0001.bmp",
   L"data/actor/udonge/kuneB2P0002.bmp",
   L"data/actor/udonge/kuneB2P0003.bmp",
   L"data/actor/udonge/kuneB2P0004.bmp",
   L"data/actor/udonge/kuneC0000.bmp",
   L"data/actor/udonge/kuneC0001.bmp",
   L"data/actor/udonge/kuneC2P0000.bmp",
   L"data/actor/udonge/kuneC2P0001.bmp",
   L"data/actor/udonge/kuneD0000.bmp",
   L"data/actor/udonge/kuneD0001.bmp",
   L"data/actor/udonge/kuneD0002.bmp",
   L"data/actor/udonge/kuneD0003.bmp",
   L"data/actor/udonge/kuneD0004.bmp",
   L"data/actor/udonge/kuneD0005.bmp",
   L"data/actor/udonge/kuneD0006.bmp",
   L"data/actor/udonge/kuneD0007.bmp",
   L"data/actor/udonge/kuneD2P0000.bmp",
   L"data/actor/udonge/kuneD2P0001.bmp",
   L"data/actor/udonge/kuneD2P0002.bmp",
   L"data/actor/udonge/kuneD2P0003.bmp",
   L"data/actor/udonge/kuneD2P0004.bmp",
   L"data/actor/udonge/kuneD2P0005.bmp",
   L"data/actor/udonge/kuneD2P0006.bmp",
   L"data/actor/udonge/kuneD2P0007.bmp",
   L"data/actor/udonge/kuneE0000.bmp",
   L"data/actor/udonge/kuneE0001.bmp",
   L"data/actor/udonge/kuneE0002.bmp",
   L"data/actor/udonge/kuneE0003.bmp",
   L"data/actor/udonge/kuneE0004.bmp",
   L"data/actor/udonge/kuneE2P0000.bmp",
   L"data/actor/udonge/kuneE2P0001.bmp",
   L"data/actor/udonge/kuneE2P0002.bmp",
   L"data/actor/udonge/kuneE2P0003.bmp",
   L"data/actor/udonge/kuneE2P0004.bmp",
   L"data/actor/udonge/kuneF0000.bmp",
   L"data/actor/udonge/kuneF0001.bmp",
   L"data/actor/udonge/kuneF0002.bmp",
   L"data/actor/udonge/kuneF0003.bmp",
   L"data/actor/udonge/kuneF0004.bmp",
   L"data/actor/udonge/kuneF0005.bmp",
   L"data/actor/udonge/kuneF2P0000.bmp",
   L"data/actor/udonge/kuneF2P0001.bmp",
   L"data/actor/udonge/kuneF2P0002.bmp",
   L"data/actor/udonge/kuneF2P0003.bmp",
   L"data/actor/udonge/kuneF2P0004.bmp",
   L"data/actor/udonge/kuneF2P0005.bmp",
   L"data/actor/udonge/kune_deadB0000.bmp",
   L"data/actor/udonge/kune_deadB0001.bmp",
   L"data/actor/udonge/kune_deadB0002.bmp",
   L"data/actor/udonge/kune_deadB0003.bmp",
   L"data/actor/udonge/kune_deadB0004.bmp",
   L"data/actor/udonge/kune_deadC00000000.bmp",
   L"data/actor/udonge/kune_deadC00000001.bmp",
   L"data/actor/udonge/kune_deadC00000002.bmp",
   L"data/actor/udonge/kune_deadC00000003.bmp",
   L"data/actor/udonge/kune_deadC00000004.bmp",
   L"data/actor/udonge/lastWord0000.bmp",
   L"data/actor/udonge/lastWord0001.bmp",
   L"data/actor/udonge/lastWord0002.bmp",
   L"data/actor/udonge/lastWord0003.bmp",
   L"data/actor/udonge/lastWord0004.bmp",
   L"data/actor/udonge/lastWord0005.bmp",
   L"data/actor/udonge/lastWord0006.bmp",
   L"data/actor/udonge/lastWord0007.bmp",
   L"data/actor/udonge/lastWord0008.bmp",
   L"data/actor/udonge/lastWord0009.bmp",
   L"data/actor/udonge/lastWord0010.bmp",
   L"data/actor/udonge/lose0000.bmp",
   L"data/actor/udonge/lose0001.bmp",
   L"data/actor/udonge/lose0002.bmp",
   L"data/actor/udonge/lose0003.bmp",
   L"data/actor/udonge/lose0004.bmp",
   L"data/actor/udonge/lose0005.bmp",
   L"data/actor/udonge/lose0006.bmp",
   L"data/actor/udonge/lose0007.bmp",
   L"data/actor/udonge/miss_guard0000.bmp",
   L"data/actor/udonge/miss_guard0001.bmp",
   L"data/actor/udonge/miss_guard0002.bmp",
   L"data/actor/udonge/miss_guard0003.bmp",
   L"data/actor/udonge/occult0000.bmp",
   L"data/actor/udonge/occult0001.bmp",
   L"data/actor/udonge/occult0002.bmp",
   L"data/actor/udonge/occult0003.bmp",
   L"data/actor/udonge/occult0004.bmp",
   L"data/actor/udonge/occult0005.bmp",
   L"data/actor/udonge/occult0006.bmp",
   L"data/actor/udonge/occult0007.bmp",
   L"data/actor/udonge/occult0008.bmp",
   L"data/actor/udonge/occult0009.bmp",
   L"data/actor/udonge/occult0010.bmp",
   L"data/actor/udonge/occult0011.bmp",
   L"data/actor/udonge/occult0012.bmp",
   L"data/actor/udonge/occult0013.bmp",
   L"data/actor/udonge/palette000.bmp",
   L"data/actor/udonge/palette001.bmp",
   L"data/actor/udonge/palette002.bmp",
   L"data/actor/udonge/palette003.bmp",
   L"data/actor/udonge/palette004.bmp",
   L"data/actor/udonge/palette005.bmp",
   L"data/actor/udonge/palette006.bmp",
   L"data/actor/udonge/palette007.bmp",
   L"data/actor/udonge/palette100.bmp",
   L"data/actor/udonge/palette101.bmp",
   L"data/actor/udonge/palette102.bmp",
   L"data/actor/udonge/palette103.bmp",
   L"data/actor/udonge/palette104.bmp",
   L"data/actor/udonge/palette105.bmp",
   L"data/actor/udonge/palette106.bmp",
   L"data/actor/udonge/palette107.bmp",
   L"data/actor/udonge/shotUnder0000.bmp",
   L"data/actor/udonge/shotUnder0001.bmp",
   L"data/actor/udonge/shotUnder0002.bmp",
   L"data/actor/udonge/shotUnder0003.bmp",
   L"data/actor/udonge/shotUnder0004.bmp",
   L"data/actor/udonge/shotUnder0005.bmp",
   L"data/actor/udonge/shot_charge0000.bmp",
   L"data/actor/udonge/shot_charge0001.bmp",
   L"data/actor/udonge/shot_charge0002.bmp",
   L"data/actor/udonge/shot_charge0003.bmp",
   L"data/actor/udonge/shot_charge0004.bmp",
   L"data/actor/udonge/shot_charge0005.bmp",
   L"data/actor/udonge/shot_charge0006.bmp",
   L"data/actor/udonge/shot_charge0007.bmp",
   L"data/actor/udonge/shot_charge0008.bmp",
   L"data/actor/udonge/shot_front0000.bmp",
   L"data/actor/udonge/shot_front0001.bmp",
   L"data/actor/udonge/shot_front0002.bmp",
   L"data/actor/udonge/shot_front0003.bmp",
   L"data/actor/udonge/shot_front0004.bmp",
   L"data/actor/udonge/shot_front0005.bmp",
   L"data/actor/udonge/shot_normal0000.bmp",
   L"data/actor/udonge/shot_normal0001.bmp",
   L"data/actor/udonge/shot_normal0002.bmp",
   L"data/actor/udonge/shot_normal0003.bmp",
   L"data/actor/udonge/shot_normal0004.bmp",
   L"data/actor/udonge/shot_normal0005.bmp",
   L"data/actor/udonge/shot_upper0000.bmp",
   L"data/actor/udonge/shot_upper0001.bmp",
   L"data/actor/udonge/shot_upper0002.bmp",
   L"data/actor/udonge/shot_upper0003.bmp",
   L"data/actor/udonge/shot_upper0004.bmp",
   L"data/actor/udonge/shot_upper0005.bmp",
   L"data/actor/udonge/skillA0000.bmp",
   L"data/actor/udonge/skillA0001.bmp",
   L"data/actor/udonge/skillA0002.bmp",
   L"data/actor/udonge/skillA0003.bmp",
   L"data/actor/udonge/skillA0004.bmp",
   L"data/actor/udonge/skillA0005.bmp",
   L"data/actor/udonge/skillA0006.bmp",
   L"data/actor/udonge/skillA0007.bmp",
   L"data/actor/udonge/skillB0000.bmp",
   L"data/actor/udonge/skillB0001.bmp",
   L"data/actor/udonge/skillB0002.bmp",
   L"data/actor/udonge/skillB0003.bmp",
   L"data/actor/udonge/skillB0004.bmp",
   L"data/actor/udonge/skillB0005.bmp",
   L"data/actor/udonge/skillB0006.bmp",
   L"data/actor/udonge/skillB0007.bmp",
   L"data/actor/udonge/skillB0008.bmp",
   L"data/actor/udonge/skillB_box0000.bmp",
   L"data/actor/udonge/skillC0000.bmp",
   L"data/actor/udonge/skillC0001.bmp",
   L"data/actor/udonge/skillC0002.bmp",
   L"data/actor/udonge/skillC0003.bmp",
   L"data/actor/udonge/skillC0004.bmp",
   L"data/actor/udonge/skillC0005.bmp",
   L"data/actor/udonge/skillC0006.bmp",
   L"data/actor/udonge/skillC0007.bmp",
   L"data/actor/udonge/skillD0000.bmp",
   L"data/actor/udonge/skillD0001.bmp",
   L"data/actor/udonge/skillD0002.bmp",
   L"data/actor/udonge/skillD0003.bmp",
   L"data/actor/udonge/skillD0004.bmp",
   L"data/actor/udonge/skillD0005.bmp",
   L"data/actor/udonge/skillD0006.bmp",
   L"data/actor/udonge/slide0000.bmp",
   L"data/actor/udonge/slide0001.bmp",
   L"data/actor/udonge/slide0002.bmp",
   L"data/actor/udonge/slide0003.bmp",
   L"data/actor/udonge/slide0004.bmp",
   L"data/actor/udonge/slide0005.bmp",
   L"data/actor/udonge/slide0006.bmp",
   L"data/actor/udonge/slide0007.bmp",
   L"data/actor/udonge/slideB0000.bmp",
   L"data/actor/udonge/slideB0001.bmp",
   L"data/actor/udonge/slideB0002.bmp",
   L"data/actor/udonge/slideB0003.bmp",
   L"data/actor/udonge/slideB0004.bmp",
   L"data/actor/udonge/slideB0005.bmp",
   L"data/actor/udonge/slide_move0006.bmp",
   L"data/actor/udonge/slide_move0007.bmp",
   L"data/actor/udonge/slide_move0008.bmp",
   L"data/actor/udonge/slide_move0009.bmp",
   L"data/actor/udonge/slide_move0010.bmp",
   L"data/actor/udonge/spellA0000.bmp",
   L"data/actor/udonge/spellA0001.bmp",
   L"data/actor/udonge/spellA0002.bmp",
   L"data/actor/udonge/spellA0003.bmp",
   L"data/actor/udonge/spellA0004.bmp",
   L"data/actor/udonge/spellA0005.bmp",
   L"data/actor/udonge/spellA0006.bmp",
   L"data/actor/udonge/spellA0007.bmp",
   L"data/actor/udonge/spellB0000.bmp",
   L"data/actor/udonge/spellB0001.bmp",
   L"data/actor/udonge/spellB0002.bmp",
   L"data/actor/udonge/spellB0003.bmp",
   L"data/actor/udonge/spellB0004.bmp",
   L"data/actor/udonge/spellB0005.bmp",
   L"data/actor/udonge/spellB0006.bmp",
   L"data/actor/udonge/spellB0007.bmp",
   L"data/actor/udonge/spellC0000.bmp",
   L"data/actor/udonge/spellC0001.bmp",
   L"data/actor/udonge/spellC0002.bmp",
   L"data/actor/udonge/spellC0003.bmp",
   L"data/actor/udonge/spellC0004.bmp",
   L"data/actor/udonge/spellC0005.bmp",
   L"data/actor/udonge/spellC0006.bmp",
   L"data/actor/udonge/spellC0007.bmp",
   L"data/actor/udonge/spellCall0000.bmp",
   L"data/actor/udonge/spellCall0001.bmp",
   L"data/actor/udonge/spellCall0002.bmp",
   L"data/actor/udonge/spellCall0003.bmp",
   L"data/actor/udonge/spellCall0004.bmp",
   L"data/actor/udonge/spellCall0005.bmp",
   L"data/actor/udonge/spellCall0006.bmp",
   L"data/actor/udonge/spellCall0007.bmp",
   L"data/actor/udonge/spellC_loop0000.bmp",
   L"data/actor/udonge/spellC_loop0001.bmp",
   L"data/actor/udonge/spellC_loop0002.bmp",
   L"data/actor/udonge/spellC_loop0003.bmp",
   L"data/actor/udonge/spellC_loop0004.bmp",
   L"data/actor/udonge/stand0000.bmp",
   L"data/actor/udonge/stand0001.bmp",
   L"data/actor/udonge/stand0002.bmp",
   L"data/actor/udonge/stand0003.bmp",
   L"data/actor/udonge/stand0004.bmp",
   L"data/actor/udonge/stand0005.bmp",
   L"data/actor/udonge/stand0006.bmp",
   L"data/actor/udonge/stand0007.bmp",
   L"data/actor/udonge/stand0008.bmp",
   L"data/actor/udonge/stand0009.bmp",
   L"data/actor/udonge/stand0010.bmp",
   L"data/actor/udonge/stand0011.bmp",
   L"data/actor/udonge/stand0012.bmp",
   L"data/actor/udonge/stand0013.bmp",
   L"data/actor/udonge/test_effect.bmp",
   L"data/actor/udonge/texture/animal0000.png",
   L"data/actor/udonge/texture/animal0001.png",
   L"data/actor/udonge/texture/animal0002.png",
   L"data/actor/udonge/texture/animal0003.png",
   L"data/actor/udonge/texture/animal0004.png",
   L"data/actor/udonge/texture/animal0005.png",
   L"data/actor/udonge/texture/animal0006.png",
   L"data/actor/udonge/texture/animal0007.png",
   L"data/actor/udonge/texture/animal0008.png",
   L"data/actor/udonge/texture/animal0009.png",
   L"data/actor/udonge/texture/ball.bmp",
   L"data/actor/udonge/texture/battleBeginA_shadow0000.png",
   L"data/actor/udonge/texture/bulletGateFlash.bmp",
   L"data/actor/udonge/texture/climaxCut0000.png",
   L"data/actor/udonge/texture/climaxCut0001.png",
   L"data/actor/udonge/texture/climax_grassClash0000.png",
   L"data/actor/udonge/texture/climax_grassClash0001.png",
   L"data/actor/udonge/texture/climax_hall0000.png",
   L"data/actor/udonge/texture/climax_hall0001.png",
   L"data/actor/udonge/texture/climax_hammerLight0000.dds",
   L"data/actor/udonge/texture/damage_animal0000.png",
   L"data/actor/udonge/texture/damage_animal0001.png",
   L"data/actor/udonge/texture/damage_animal0002.png",
   L"data/actor/udonge/texture/damage_animal0003.png",
   L"data/actor/udonge/texture/face_master_udonge.png",
   L"data/actor/udonge/texture/face_master_udonge2.png",
   L"data/actor/udonge/texture/face_slave_udonge.png",
   L"data/actor/udonge/texture/face_spell_cut_0003.png",
   L"data/actor/udonge/texture/frontShot_loop0000.png",
   L"data/actor/udonge/texture/gauge.png",
   L"data/actor/udonge/texture/glass_clash0000.png",
   L"data/actor/udonge/texture/insanity0000.png",
   L"data/actor/udonge/texture/kune_flash0000.png",
   L"data/actor/udonge/texture/poison_bubble0000.png",
   L"data/actor/udonge/texture/poison_shower0000.png",
   L"data/actor/udonge/texture/pulseA.png",
   L"data/actor/udonge/texture/redEyes0000.png",
   L"data/actor/udonge/texture/shotFrontRing0000.png",
   L"data/actor/udonge/texture/shotFrontRing0001.png",
   L"data/actor/udonge/texture/shotstinga0000.png",
   L"data/actor/udonge/texture/shot_normal0000.png",
   L"data/actor/udonge/texture/skillA_trail0000.png",
   L"data/actor/udonge/texture/skillD_shadow0000.png",
   L"data/actor/udonge/texture/skillE_0000.png",
   L"data/actor/udonge/texture/spell_use_cut.png",
   L"data/actor/udonge/texture/test_climaxBack0000.png",
   L"data/actor/udonge/texture/test_climaxBack0001.png",
   L"data/actor/udonge/texture/winA_shock0000.png",
   L"data/actor/udonge/texture/win_udonge.png",
   L"data/actor/udonge/turn0000.bmp",
   L"data/actor/udonge/turn0001.bmp",
   L"data/actor/udonge/turn0002.bmp",
   L"data/actor/udonge/udonge.pat",
   L"data/actor/udonge/udonge_ed.pat",
   L"data/actor/udonge/walkBack0000.bmp",
   L"data/actor/udonge/walkBack0001.bmp",
   L"data/actor/udonge/walkBack0002.bmp",
   L"data/actor/udonge/walkBack0003.bmp",
   L"data/actor/udonge/walkBack0004.bmp",
   L"data/actor/udonge/walkBack0005.bmp",
   L"data/actor/udonge/walkBack0006.bmp",
   L"data/actor/udonge/walkBack0007.bmp",
   L"data/actor/udonge/walkBack0008.bmp",
   L"data/actor/udonge/walk_front0000.bmp",
   L"data/actor/udonge/walk_front0001.bmp",
   L"data/actor/udonge/walk_front0002.bmp",
   L"data/actor/udonge/walk_front0003.bmp",
   L"data/actor/udonge/walk_front0004.bmp",
   L"data/actor/udonge/walk_front0005.bmp",
   L"data/actor/udonge/walk_front0006.bmp",
   L"data/actor/udonge/walk_front0007.bmp",
   L"data/actor/udonge/walk_front0008.bmp",
   L"data/actor/udonge/winA0001.bmp",
   L"data/actor/udonge/winA0002.bmp",
   L"data/actor/udonge/winA0003.bmp",
   L"data/actor/udonge/winA0004.bmp",
   L"data/actor/udonge/winA0005.bmp",
   L"data/actor/udonge/winA0006.bmp",
   L"data/actor/udonge/winA_gun0000.bmp",
   L"data/actor/udonge/winB0000.bmp",
   L"data/actor/udonge/winB0001.bmp",
   L"data/actor/udonge/winB0002.bmp",
   L"data/actor/udonge/winB0003.bmp",
   L"data/actor/udonge/winB0004.bmp",
   L"data/actor/udonge/winB0005.bmp",
   L"data/actor/udonge/winB0006.bmp",
   L"data/actor/udonge.nut",
   L"data/actor/udonge_base.nut",
   L"data/actor/udonge_boss.nut",
   L"data/actor/udonge_boss_base.nut",
   L"data/actor/udonge_boss_init.nut",
   L"data/actor/udonge_boss_shot.nut",
   L"data/actor/udonge_com.nut",
   L"data/actor/udonge_combo.nut",
   L"data/actor/udonge_com_function.nut",
   L"data/actor/udonge_init.nut",
   L"data/actor/udonge_practice_init.nut",
   L"data/actor/udonge_shot.nut",
   L"data/actor/udonge_team.nut",
   L"data/actor/usami/atkDashLow0000.bmp",
   L"data/actor/usami/atkDashLow0001.bmp",
   L"data/actor/usami/atkDashLow0002.bmp",
   L"data/actor/usami/atkDashLow0003.bmp",
   L"data/actor/usami/atkDashLow0004.bmp",
   L"data/actor/usami/atkDashLow0005.bmp",
   L"data/actor/usami/atkDashLow0006.bmp",
   L"data/actor/usami/atkDashLow0007.bmp",
   L"data/actor/usami/atkDashLow0008.bmp",
   L"data/actor/usami/atkDashLow0009.bmp",
   L"data/actor/usami/atkDashLow0010.bmp",
   L"data/actor/usami/atkDashLow0011.bmp",
   L"data/actor/usami/atkDashLow0012.bmp",
   L"data/actor/usami/atkDashLow0013.bmp",
   L"data/actor/usami/atkDashLow0014.bmp",
   L"data/actor/usami/atkFront0000.bmp",
   L"data/actor/usami/atkFront0001.bmp",
   L"data/actor/usami/atkFront0002.bmp",
   L"data/actor/usami/atkFront0003.bmp",
   L"data/actor/usami/atkFront0004.bmp",
   L"data/actor/usami/atkFront0005.bmp",
   L"data/actor/usami/atkFront0006.bmp",
   L"data/actor/usami/atkFront0007.bmp",
   L"data/actor/usami/atkFront0008.bmp",
   L"data/actor/usami/atkFront0009.bmp",
   L"data/actor/usami/atkFrontObject0000.png",
   L"data/actor/usami/atkFrontObject0001.dds",
   L"data/actor/usami/atkFrontObject0002.dds",
   L"data/actor/usami/atkHigh0000.bmp",
   L"data/actor/usami/atkHigh0001.bmp",
   L"data/actor/usami/atkHigh0002.bmp",
   L"data/actor/usami/atkHigh0003.bmp",
   L"data/actor/usami/atkHigh0004.bmp",
   L"data/actor/usami/atkHigh0005.bmp",
   L"data/actor/usami/atkHigh0006.bmp",
   L"data/actor/usami/atkHigh0007.bmp",
   L"data/actor/usami/atkHigh0008.bmp",
   L"data/actor/usami/atkHigh0009.bmp",
   L"data/actor/usami/atkHighObject0000.dds",
   L"data/actor/usami/atkLow0000.bmp",
   L"data/actor/usami/atkLow0001.bmp",
   L"data/actor/usami/atkLow0002.bmp",
   L"data/actor/usami/atkLow0003.bmp",
   L"data/actor/usami/atkLow0004.bmp",
   L"data/actor/usami/atkLow0005.bmp",
   L"data/actor/usami/atkLow0006.bmp",
   L"data/actor/usami/atkLow0007.bmp",
   L"data/actor/usami/atkLow0008.bmp",
   L"data/actor/usami/atkMid0000.bmp",
   L"data/actor/usami/atkMid0001.bmp",
   L"data/actor/usami/atkMid0002.bmp",
   L"data/actor/usami/atkMid0003.bmp",
   L"data/actor/usami/atkMid0004.bmp",
   L"data/actor/usami/atkMid0005.bmp",
   L"data/actor/usami/atkMid0006.bmp",
   L"data/actor/usami/atkMid0007.bmp",
   L"data/actor/usami/atkMid0008.bmp",
   L"data/actor/usami/atkmid0008_.bmp",
   L"data/actor/usami/atkMid0009.bmp",
   L"data/actor/usami/atkMid0010.bmp",
   L"data/actor/usami/atkUnder0000.bmp",
   L"data/actor/usami/atkUnder0001.bmp",
   L"data/actor/usami/atkUnder0002.bmp",
   L"data/actor/usami/atkUnder0003.bmp",
   L"data/actor/usami/atkUnder0004.bmp",
   L"data/actor/usami/atkUnder0005.bmp",
   L"data/actor/usami/atkUnder0006.bmp",
   L"data/actor/usami/atkUnder0007.bmp",
   L"data/actor/usami/atkUnder0008.bmp",
   L"data/actor/usami/atkUnder0009.bmp",
   L"data/actor/usami/atkUnderObject0000.png",
   L"data/actor/usami/atkUnderObject0001.png",
   L"data/actor/usami/atkUnderObject0002.png",
   L"data/actor/usami/atkUnderObject0003.png",
   L"data/actor/usami/atkUnderObjectB0001.png",
   L"data/actor/usami/atkUnderObjectB0002.png",
   L"data/actor/usami/atkUnderObjectB0003.png",
   L"data/actor/usami/battleBegin0000.bmp",
   L"data/actor/usami/battleBegin0001.bmp",
   L"data/actor/usami/battleBegin0002.bmp",
   L"data/actor/usami/battleBegin0003.bmp",
   L"data/actor/usami/battleBegin0004.bmp",
   L"data/actor/usami/battleBegin0005.bmp",
   L"data/actor/usami/battleBegin0006.bmp",
   L"data/actor/usami/battleBegin0007.bmp",
   L"data/actor/usami/beginBattle_card0000.bmp",
   L"data/actor/usami/beginBattle_card0001.bmp",
   L"data/actor/usami/beginBattle_card0002.bmp",
   L"data/actor/usami/beginBattle_card0003.bmp",
   L"data/actor/usami/beginBattle_card0004.bmp",
   L"data/actor/usami/beginBattle_card0005.bmp",
   L"data/actor/usami/beginBattle_card0006.bmp",
   L"data/actor/usami/beginBattle_card0007.bmp",
   L"data/actor/usami/beginBattle_card0008.bmp",
   L"data/actor/usami/beginBattle_card0009.bmp",
   L"data/actor/usami/beginBattle_card0010.bmp",
   L"data/actor/usami/beginBattle_card0011.bmp",
   L"data/actor/usami/beginBattle_card0012.bmp",
   L"data/actor/usami/beginBattle_card0013.bmp",
   L"data/actor/usami/bird0000.bmp",
   L"data/actor/usami/bird0001.bmp",
   L"data/actor/usami/bird0002.bmp",
   L"data/actor/usami/bird0003.bmp",
   L"data/actor/usami/bird0004.bmp",
   L"data/actor/usami/bird0005.bmp",
   L"data/actor/usami/bmsln/reimu_buster.bmb",
   L"data/actor/usami/bmsln/reimu_busterHit.bmb",
   L"data/actor/usami/bmsln/reimu_fallKickA.bmb",
   L"data/actor/usami/bmsln/reimu_HighShotBaria.bmb",
   L"data/actor/usami/bmsln/reimu_keisei.bmb",
   L"data/actor/usami/bmsln/reimu_kibakuzinA.bmb",
   L"data/actor/usami/bmsln/reimu_musouB.bmb",
   L"data/actor/usami/bmsln/reimu_musouG.bmb",
   L"data/actor/usami/bmsln/reimu_musouHitB.bmb",
   L"data/actor/usami/bmsln/reimu_musouHitG.bmb",
   L"data/actor/usami/bmsln/reimu_musouHitR.bmb",
   L"data/actor/usami/bmsln/reimu_musouR.bmb",
   L"data/actor/usami/bmsln/reimu_shot.bmb",
   L"data/actor/usami/bmsln/reimu_shotA.bmb",
   L"data/actor/usami/bmsln/reimu_shotA_gateRing.bmb",
   L"data/actor/usami/bmsln/reimu_shotA_hit.bmb",
   L"data/actor/usami/bmsln/reimu_skillG_kick.bmb",
   L"data/actor/usami/bmsln/reimu_TenseiA000.bmb",
   L"data/actor/usami/bmsln/reimu_tenseiFinish.bmb",
   L"data/actor/usami/bmsln/reimu_tenseiRock.bmb",
   L"data/actor/usami/bmsln/reimu_tenseiRockShot.bmb",
   L"data/actor/usami/bmsln/shot_A_000.bmb",
   L"data/actor/usami/bmsln/shot_A_000.bmsln",
   L"data/actor/usami/climax0000.bmp",
   L"data/actor/usami/climax0001.bmp",
   L"data/actor/usami/climax0002.bmp",
   L"data/actor/usami/climax0003.bmp",
   L"data/actor/usami/climax0004.bmp",
   L"data/actor/usami/climax0005.bmp",
   L"data/actor/usami/climax0006.bmp",
   L"data/actor/usami/climaxCut0000.png",
   L"data/actor/usami/climaxLoop0000.bmp",
   L"data/actor/usami/climaxLoop0001.bmp",
   L"data/actor/usami/climaxLoop0002.bmp",
   L"data/actor/usami/climaxLoop0003.bmp",
   L"data/actor/usami/damageBody0000.bmp",
   L"data/actor/usami/damageBody0001.bmp",
   L"data/actor/usami/damageBody0002.bmp",
   L"data/actor/usami/damageBody0003.bmp",
   L"data/actor/usami/damageBody0004.bmp",
   L"data/actor/usami/damageHead0000.bmp",
   L"data/actor/usami/damageHead0001.bmp",
   L"data/actor/usami/damageHead0002.bmp",
   L"data/actor/usami/damageHead0003.bmp",
   L"data/actor/usami/damageSpin0000.bmp",
   L"data/actor/usami/damageSpin0001.bmp",
   L"data/actor/usami/damageSpin0002.bmp",
   L"data/actor/usami/damageSpin0003.bmp",
   L"data/actor/usami/damageUnder0000.bmp",
   L"data/actor/usami/damageUnder0001.bmp",
   L"data/actor/usami/damageUnder0002.bmp",
   L"data/actor/usami/damageUnder0003.bmp",
   L"data/actor/usami/damageUnder0004.bmp",
   L"data/actor/usami/damageUnder0005.bmp",
   L"data/actor/usami/damageUnder0006.bmp",
   L"data/actor/usami/damageUnder0007.bmp",
   L"data/actor/usami/damageUnder0008.bmp",
   L"data/actor/usami/damageUnder0009.bmp",
   L"data/actor/usami/damageUnder0010.bmp",
   L"data/actor/usami/damageUnder0011.bmp",
   L"data/actor/usami/damageUnder0012.bmp",
   L"data/actor/usami/damageUnder0013.bmp",
   L"data/actor/usami/damageUnder0014.bmp",
   L"data/actor/usami/damageWall0000.bmp",
   L"data/actor/usami/damageWall0001.bmp",
   L"data/actor/usami/damageWall0002.bmp",
   L"data/actor/usami/damageWall0003.bmp",
   L"data/actor/usami/damageWall0004.bmp",
   L"data/actor/usami/damageWall0005.bmp",
   L"data/actor/usami/dashBack0000.bmp",
   L"data/actor/usami/dashBack0001.bmp",
   L"data/actor/usami/dashBack0002.bmp",
   L"data/actor/usami/dashBack0003.bmp",
   L"data/actor/usami/dashBack0004.bmp",
   L"data/actor/usami/dashBack0005.bmp",
   L"data/actor/usami/dashBack0006.bmp",
   L"data/actor/usami/dashBack0007.bmp",
   L"data/actor/usami/dashBack0008.bmp",
   L"data/actor/usami/dashBack0009.bmp",
   L"data/actor/usami/dashBack0010.bmp",
   L"data/actor/usami/dashBack0011.bmp",
   L"data/actor/usami/dashFront0000.bmp",
   L"data/actor/usami/dashFront0001.bmp",
   L"data/actor/usami/dashFront0002.bmp",
   L"data/actor/usami/dashFront0003.bmp",
   L"data/actor/usami/dashFront0004.bmp",
   L"data/actor/usami/dashFront0005.bmp",
   L"data/actor/usami/dashFront0006.bmp",
   L"data/actor/usami/dashFrontLoop0000.bmp",
   L"data/actor/usami/dashFrontLoop0001.bmp",
   L"data/actor/usami/dashFrontLoop0002.bmp",
   L"data/actor/usami/dashFrontLoop0003.bmp",
   L"data/actor/usami/dummy.bmp",
   L"data/actor/usami/face_spellCallB.png",
   L"data/actor/usami/grab0000.bmp",
   L"data/actor/usami/grab0001.bmp",
   L"data/actor/usami/grab0002.bmp",
   L"data/actor/usami/grab0003.bmp",
   L"data/actor/usami/grab0004.bmp",
   L"data/actor/usami/grab0005.bmp",
   L"data/actor/usami/guard0000.bmp",
   L"data/actor/usami/guard0001.bmp",
   L"data/actor/usami/guard0002.bmp",
   L"data/actor/usami/guard0003.bmp",
   L"data/actor/usami/guardCrash0000.bmp",
   L"data/actor/usami/guardCrash0001.bmp",
   L"data/actor/usami/guardCrash0002.bmp",
   L"data/actor/usami/guardCrash0003.bmp",
   L"data/actor/usami/guardMiss0000.bmp",
   L"data/actor/usami/guardMiss0001.bmp",
   L"data/actor/usami/guardMiss0002.bmp",
   L"data/actor/usami/guardMiss0003.bmp",
   L"data/actor/usami/half_damage_spin0000.bmp",
   L"data/actor/usami/half_damage_spin0001.bmp",
   L"data/actor/usami/half_damage_spin0002.bmp",
   L"data/actor/usami/half_damage_spin0003.bmp",
   L"data/actor/usami/half_damage_spin0004.bmp",
   L"data/actor/usami/half_damage_spin0005.bmp",
   L"data/actor/usami/half_damage_spin0006.bmp",
   L"data/actor/usami/half_damage_spin0007.bmp",
   L"data/actor/usami/lose0000.bmp",
   L"data/actor/usami/lose0001.bmp",
   L"data/actor/usami/lose0002.bmp",
   L"data/actor/usami/lose0003.bmp",
   L"data/actor/usami/lose0004.bmp",
   L"data/actor/usami/lose0005.bmp",
   L"data/actor/usami/lose0006.bmp",
   L"data/actor/usami/lose0007.bmp",
   L"data/actor/usami/lose0008.bmp",
   L"data/actor/usami/lose0009.bmp",
   L"data/actor/usami/lose0010.bmp",
   L"data/actor/usami/lose0011.bmp",
   L"data/actor/usami/mask_skt0000.bmp",
   L"data/actor/usami/occult0000.bmp",
   L"data/actor/usami/occult0001.bmp",
   L"data/actor/usami/occult0002.bmp",
   L"data/actor/usami/occult0003.bmp",
   L"data/actor/usami/occult0004.bmp",
   L"data/actor/usami/occult0005.bmp",
   L"data/actor/usami/occult0006.bmp",
   L"data/actor/usami/occult0007.bmp",
   L"data/actor/usami/occult0008.bmp",
   L"data/actor/usami/occult0009.bmp",
   L"data/actor/usami/occult0010.bmp",
   L"data/actor/usami/occult0011.bmp",
   L"data/actor/usami/occult0012.bmp",
   L"data/actor/usami/occult0013.bmp",
   L"data/actor/usami/occult0014.bmp",
   L"data/actor/usami/occult0015.bmp",
   L"data/actor/usami/palette000.bmp",
   L"data/actor/usami/palette001.bmp",
   L"data/actor/usami/palette002.bmp",
   L"data/actor/usami/palette003.bmp",
   L"data/actor/usami/palette004.bmp",
   L"data/actor/usami/palette005.bmp",
   L"data/actor/usami/palette006.bmp",
   L"data/actor/usami/palette007.bmp",
   L"data/actor/usami/palette100.bmp",
   L"data/actor/usami/palette101.bmp",
   L"data/actor/usami/palette102.bmp",
   L"data/actor/usami/palette103.bmp",
   L"data/actor/usami/palette104.bmp",
   L"data/actor/usami/palette105.bmp",
   L"data/actor/usami/palette106.bmp",
   L"data/actor/usami/palette107.bmp",
   L"data/actor/usami/palette999.bmp",
   L"data/actor/usami/shot0000.bmp",
   L"data/actor/usami/shot0001.bmp",
   L"data/actor/usami/shot0002.bmp",
   L"data/actor/usami/shot0003.bmp",
   L"data/actor/usami/shot0004.bmp",
   L"data/actor/usami/shot0005.bmp",
   L"data/actor/usami/shot0006.bmp",
   L"data/actor/usami/shot0007.bmp",
   L"data/actor/usami/shot0008.bmp",
   L"data/actor/usami/shot0009.bmp",
   L"data/actor/usami/shot0010.bmp",
   L"data/actor/usami/shotCharge0000.bmp",
   L"data/actor/usami/shotCharge0001.bmp",
   L"data/actor/usami/shotCharge0002.bmp",
   L"data/actor/usami/shotCharge0003.bmp",
   L"data/actor/usami/shotCharge0004.bmp",
   L"data/actor/usami/shotCharge0005.bmp",
   L"data/actor/usami/shotCharge0006.bmp",
   L"data/actor/usami/shotCharge0007.bmp",
   L"data/actor/usami/shotCharge0008.bmp",
   L"data/actor/usami/shotCharge0009.bmp",
   L"data/actor/usami/shotCharge0010.bmp",
   L"data/actor/usami/skillA0000.bmp",
   L"data/actor/usami/skillA0001.bmp",
   L"data/actor/usami/skillA0002.bmp",
   L"data/actor/usami/skillA0003.bmp",
   L"data/actor/usami/skillA0004.bmp",
   L"data/actor/usami/skillA0005.bmp",
   L"data/actor/usami/skillA0006.bmp",
   L"data/actor/usami/skillA0007.bmp",
   L"data/actor/usami/skillA0008.bmp",
   L"data/actor/usami/skillA0009.bmp",
   L"data/actor/usami/skillA0010.bmp",
   L"data/actor/usami/skillB0000.bmp",
   L"data/actor/usami/skillB0001.bmp",
   L"data/actor/usami/skillB0002.bmp",
   L"data/actor/usami/skillB0003.bmp",
   L"data/actor/usami/skillB0004.bmp",
   L"data/actor/usami/skillB0005.bmp",
   L"data/actor/usami/skillB0006.bmp",
   L"data/actor/usami/skillB0007.bmp",
   L"data/actor/usami/skillC0000.bmp",
   L"data/actor/usami/skillC0001.bmp",
   L"data/actor/usami/skillC0002.bmp",
   L"data/actor/usami/skillC0003.bmp",
   L"data/actor/usami/skillC0004.bmp",
   L"data/actor/usami/skillC0005.bmp",
   L"data/actor/usami/skillC0006.bmp",
   L"data/actor/usami/skillC0007.bmp",
   L"data/actor/usami/skillC0008.bmp",
   L"data/actor/usami/skillC0009.bmp",
   L"data/actor/usami/skillC0010.bmp",
   L"data/actor/usami/skillC0011.bmp",
   L"data/actor/usami/skillC0012.bmp",
   L"data/actor/usami/skillC_hole0000.dds",
   L"data/actor/usami/skillC_sprash0000.dds",
   L"data/actor/usami/skillC_sprash0001.dds",
   L"data/actor/usami/skillD0000.bmp",
   L"data/actor/usami/skillD0001.bmp",
   L"data/actor/usami/skillD0002.bmp",
   L"data/actor/usami/skillD0003.bmp",
   L"data/actor/usami/skillD0004.bmp",
   L"data/actor/usami/skillD0005.bmp",
   L"data/actor/usami/skillD0006.bmp",
   L"data/actor/usami/skillD0007.bmp",
   L"data/actor/usami/skillD0008.bmp",
   L"data/actor/usami/skillD0009.bmp",
   L"data/actor/usami/skillD0010.bmp",
   L"data/actor/usami/skillD0011.bmp",
   L"data/actor/usami/skillD0012.bmp",
   L"data/actor/usami/skillD0013.bmp",
   L"data/actor/usami/skillD0014.bmp",
   L"data/actor/usami/skillD_object0000.dds",
   L"data/actor/usami/skillD_object0001.dds",
   L"data/actor/usami/skillE_object0000.dds",
   L"data/actor/usami/skillE_object0001.dds",
   L"data/actor/usami/skillF0000.bmp",
   L"data/actor/usami/skillF0001.bmp",
   L"data/actor/usami/skillF0002.bmp",
   L"data/actor/usami/skillF0003.bmp",
   L"data/actor/usami/skillF0004.bmp",
   L"data/actor/usami/skillF0005.bmp",
   L"data/actor/usami/skillF0006.bmp",
   L"data/actor/usami/skillF0007.bmp",
   L"data/actor/usami/skillF0008.bmp",
   L"data/actor/usami/skillF0009.bmp",
   L"data/actor/usami/skillF0010.bmp",
   L"data/actor/usami/skillF0011.bmp",
   L"data/actor/usami/skillF0012.bmp",
   L"data/actor/usami/skillF_Object0001.png",
   L"data/actor/usami/skillF_Object0002.png",
   L"data/actor/usami/skill_gus_pipe0000.bmp",
   L"data/actor/usami/skill_gus_pipe0001.bmp",
   L"data/actor/usami/skill_gus_pipe0002.bmp",
   L"data/actor/usami/skill_gus_pipe0003.bmp",
   L"data/actor/usami/skill_gus_pipe0004.bmp",
   L"data/actor/usami/skill_gus_pipe0005.bmp",
   L"data/actor/usami/skill_gus_pipe0006.bmp",
   L"data/actor/usami/skill_gus_pipe0007.bmp",
   L"data/actor/usami/skill_gus_pipe0008.bmp",
   L"data/actor/usami/skill_gus_pipe0009.bmp",
   L"data/actor/usami/skill_gus_pipe0010.bmp",
   L"data/actor/usami/slide0000.bmp",
   L"data/actor/usami/slide0001.bmp",
   L"data/actor/usami/slide0002.bmp",
   L"data/actor/usami/slide0003.bmp",
   L"data/actor/usami/slide0004.bmp",
   L"data/actor/usami/slide0005.bmp",
   L"data/actor/usami/slide0006.bmp",
   L"data/actor/usami/slide0007.bmp",
   L"data/actor/usami/slide0008.bmp",
   L"data/actor/usami/slide0009.bmp",
   L"data/actor/usami/slide0010.bmp",
   L"data/actor/usami/slide0011.bmp",
   L"data/actor/usami/slide0012.bmp",
   L"data/actor/usami/spellA0000.bmp",
   L"data/actor/usami/spellA0001.bmp",
   L"data/actor/usami/spellA0002.bmp",
   L"data/actor/usami/spellA0003.bmp",
   L"data/actor/usami/spellA0004.bmp",
   L"data/actor/usami/spellA0005.bmp",
   L"data/actor/usami/spellA0006.bmp",
   L"data/actor/usami/spellA0007.bmp",
   L"data/actor/usami/spellA0008.bmp",
   L"data/actor/usami/spellA0009.bmp",
   L"data/actor/usami/spellA0010.bmp",
   L"data/actor/usami/spellA0011.bmp",
   L"data/actor/usami/spellB0000.bmp",
   L"data/actor/usami/spellB0001.bmp",
   L"data/actor/usami/spellB0002.bmp",
   L"data/actor/usami/spellB0003.bmp",
   L"data/actor/usami/spellB0004.bmp",
   L"data/actor/usami/spellB0005.bmp",
   L"data/actor/usami/spellB0006.bmp",
   L"data/actor/usami/spellB0007.bmp",
   L"data/actor/usami/spellB0008.bmp",
   L"data/actor/usami/spellB0009.bmp",
   L"data/actor/usami/spellB0010.bmp",
   L"data/actor/usami/stan0000.bmp",
   L"data/actor/usami/stan0001.bmp",
   L"data/actor/usami/stan0002.bmp",
   L"data/actor/usami/stan0003.bmp",
   L"data/actor/usami/stan0004.bmp",
   L"data/actor/usami/stan0005.bmp",
   L"data/actor/usami/stand0000.bmp",
   L"data/actor/usami/stand0001.bmp",
   L"data/actor/usami/stand0002.bmp",
   L"data/actor/usami/stand0003.bmp",
   L"data/actor/usami/stand0004.bmp",
   L"data/actor/usami/stand0005.bmp",
   L"data/actor/usami/stand0006.bmp",
   L"data/actor/usami/stand0007.bmp",
   L"data/actor/usami/stand0008.bmp",
   L"data/actor/usami/stand0009.bmp",
   L"data/actor/usami/stand0010.bmp",
   L"data/actor/usami/stand0011.bmp",
   L"data/actor/usami/stand0012.bmp",
   L"data/actor/usami/stand0013.bmp",
   L"data/actor/usami/stand0014.bmp",
   L"data/actor/usami/stand0015.bmp",
   L"data/actor/usami/stand0016.bmp",
   L"data/actor/usami/stand0017.bmp",
   L"data/actor/usami/stand0018.bmp",
   L"data/actor/usami/stand0019.bmp",
   L"data/actor/usami/stanEnd0000.bmp",
   L"data/actor/usami/stanEnd0001.bmp",
   L"data/actor/usami/test_effect.bmp",
   L"data/actor/usami/texture/A0000.png",
   L"data/actor/usami/texture/A0005.png",
   L"data/actor/usami/texture/A0010.png",
   L"data/actor/usami/texture/A0015.png",
   L"data/actor/usami/texture/A0020.png",
   L"data/actor/usami/texture/A0025.png",
   L"data/actor/usami/texture/A0030.png",
   L"data/actor/usami/texture/A0035.png",
   L"data/actor/usami/texture/A0040.png",
   L"data/actor/usami/texture/A0045.png",
   L"data/actor/usami/texture/B0000.png",
   L"data/actor/usami/texture/B0005.png",
   L"data/actor/usami/texture/B0010.png",
   L"data/actor/usami/texture/B0015.png",
   L"data/actor/usami/texture/B0020.png",
   L"data/actor/usami/texture/B0025.png",
   L"data/actor/usami/texture/B0030.png",
   L"data/actor/usami/texture/B0035.png",
   L"data/actor/usami/texture/B0040.png",
   L"data/actor/usami/texture/B0045.png",
   L"data/actor/usami/texture/ball.bmp",
   L"data/actor/usami/texture/bossSpellE_object0000.dds",
   L"data/actor/usami/texture/boss_aura0000.dds",
   L"data/actor/usami/texture/bulletGateFlash.bmp",
   L"data/actor/usami/texture/bulletGateRing.bmp",
   L"data/actor/usami/texture/C0000.png",
   L"data/actor/usami/texture/C0005.png",
   L"data/actor/usami/texture/C0010.png",
   L"data/actor/usami/texture/C0015.png",
   L"data/actor/usami/texture/C0020.png",
   L"data/actor/usami/texture/C0025.png",
   L"data/actor/usami/texture/C0030.png",
   L"data/actor/usami/texture/C0035.png",
   L"data/actor/usami/texture/C0040.png",
   L"data/actor/usami/texture/C0045.png",
   L"data/actor/usami/texture/chargeO.png",
   L"data/actor/usami/texture/climax_aura0000.png",
   L"data/actor/usami/texture/climax_aura0001.png",
   L"data/actor/usami/texture/climax_brake0000.png",
   L"data/actor/usami/texture/climax_lightPilar0000.dds",
   L"data/actor/usami/texture/climax_lightRay0000.dds",
   L"data/actor/usami/texture/D0000.png",
   L"data/actor/usami/texture/D0005.png",
   L"data/actor/usami/texture/D0010.png",
   L"data/actor/usami/texture/D0015.png",
   L"data/actor/usami/texture/D0020.png",
   L"data/actor/usami/texture/D0025.png",
   L"data/actor/usami/texture/D0030.png",
   L"data/actor/usami/texture/D0035.png",
   L"data/actor/usami/texture/D0040.png",
   L"data/actor/usami/texture/D0045.png",
   L"data/actor/usami/texture/E0000.png",
   L"data/actor/usami/texture/E0005.png",
   L"data/actor/usami/texture/E0010.png",
   L"data/actor/usami/texture/E0015.png",
   L"data/actor/usami/texture/E0020.png",
   L"data/actor/usami/texture/E0025.png",
   L"data/actor/usami/texture/E0030.png",
   L"data/actor/usami/texture/E0035.png",
   L"data/actor/usami/texture/E0040.png",
   L"data/actor/usami/texture/E0045.png",
   L"data/actor/usami/texture/face_master_usami.png",
   L"data/actor/usami/texture/face_master_usami2.png",
   L"data/actor/usami/texture/face_slave_usami.png",
   L"data/actor/usami/texture/face_spell_cut.png",
   L"data/actor/usami/texture/kona_A.bmp",
   L"data/actor/usami/texture/lightning_mapA.png",
   L"data/actor/usami/texture/mantle000.png",
   L"data/actor/usami/texture/marisaBall2.bmp",
   L"data/actor/usami/texture/marisaStarFlare.bmp",
   L"data/actor/usami/texture/mask_ball.png",
   L"data/actor/usami/texture/moonEffect0000.png",
   L"data/actor/usami/texture/normalShotCard0000.png",
   L"data/actor/usami/texture/normalShotCard0001.png",
   L"data/actor/usami/texture/normalShotCard0002.png",
   L"data/actor/usami/texture/normalShotCard0003.png",
   L"data/actor/usami/texture/normalShotCard0004.png",
   L"data/actor/usami/texture/normalShotCard0005.png",
   L"data/actor/usami/texture/occult_A_Laser0000.dds",
   L"data/actor/usami/texture/occult_light0000.dds",
   L"data/actor/usami/texture/occult_shot_object000.png",
   L"data/actor/usami/texture/occult_spark.png",
   L"data/actor/usami/texture/occult_splash0000.dds",
   L"data/actor/usami/texture/occult_vortex0000.dds",
   L"data/actor/usami/texture/reimu_boxA.png",
   L"data/actor/usami/texture/reimu_chargeLine.png",
   L"data/actor/usami/texture/reimu_musouBase.png",
   L"data/actor/usami/texture/reimu_occultMask0000.png",
   L"data/actor/usami/texture/reimu_wallA_Halfmask.png",
   L"data/actor/usami/texture/reimu_wallA_mask.png",
   L"data/actor/usami/texture/reimu_wallFlashA.png",
   L"data/actor/usami/texture/shotFront_fire0000.dds",
   L"data/actor/usami/texture/skillE_object0000.dds",
   L"data/actor/usami/texture/skillF_mail0000.dds",
   L"data/actor/usami/texture/skillF_Object0001.dds",
   L"data/actor/usami/texture/smoke.png",
   L"data/actor/usami/texture/spellA_Flash0000.dds",
   L"data/actor/usami/texture/spellA_Flash0001.dds",
   L"data/actor/usami/texture/spellB_Aura0000.png",
   L"data/actor/usami/texture/spellB_hole0000.dds",
   L"data/actor/usami/texture/spellB_hole0001.dds",
   L"data/actor/usami/texture/spellC_tower0000.png",
   L"data/actor/usami/texture/spellC_tower0001.png",
   L"data/actor/usami/texture/spellC_tower0002.png",
   L"data/actor/usami/texture/spell_use_cut.png",
   L"data/actor/usami/texture/sukima_back0000.png",
   L"data/actor/usami/texture/sumire_animal00000.png",
   L"data/actor/usami/texture/sumire_animal00006.png",
   L"data/actor/usami/texture/sumire_animal00012.png",
   L"data/actor/usami/texture/sumire_animal00018.png",
   L"data/actor/usami/texture/sumire_animal00024.png",
   L"data/actor/usami/texture/sumire_animalDamage00000.png",
   L"data/actor/usami/texture/sumire_animalDamage00006.png",
   L"data/actor/usami/texture/sumire_animalDamage00012.png",
   L"data/actor/usami/texture/sumire_animalDamage00018.png",
   L"data/actor/usami/texture/sumire_animalDamage00024.png",
   L"data/actor/usami/texture/swingA0000.png",
   L"data/actor/usami/texture/test_climaxBack.png",
   L"data/actor/usami/texture/trail0000.png",
   L"data/actor/usami/texture/usami_skillA0000.png",
   L"data/actor/usami/usami.pat",
   L"data/actor/usami/usamiex.pat",
   L"data/actor/usami/usami_ed.pat",
   L"data/actor/usami/walkBack0000.bmp",
   L"data/actor/usami/walkBack0001.bmp",
   L"data/actor/usami/walkBack0002.bmp",
   L"data/actor/usami/walkBack0003.bmp",
   L"data/actor/usami/walkBack0004.bmp",
   L"data/actor/usami/walkBack0005.bmp",
   L"data/actor/usami/walkBackLoop0000.bmp",
   L"data/actor/usami/walkBackLoop0001.bmp",
   L"data/actor/usami/walkBackLoop0002.bmp",
   L"data/actor/usami/walkBackLoop0003.bmp",
   L"data/actor/usami/walkBackLoop0004.bmp",
   L"data/actor/usami/walkFront0000.bmp",
   L"data/actor/usami/walkFront0001.bmp",
   L"data/actor/usami/walkFront0002.bmp",
   L"data/actor/usami/walkFront0003.bmp",
   L"data/actor/usami/walkFront0004.bmp",
   L"data/actor/usami/walkFront0005.bmp",
   L"data/actor/usami/walkFront0006.bmp",
   L"data/actor/usami/walkFrontLoop0000.bmp",
   L"data/actor/usami/walkFrontLoop0001.bmp",
   L"data/actor/usami/walkFrontLoop0002.bmp",
   L"data/actor/usami/walkFrontLoop0003.bmp",
   L"data/actor/usami/walkFrontLoop0004.bmp",
   L"data/actor/usami/warpMask.bmp",
   L"data/actor/usami/winA0000.bmp",
   L"data/actor/usami/winA0001.bmp",
   L"data/actor/usami/winA0002.bmp",
   L"data/actor/usami/winA0003.bmp",
   L"data/actor/usami/winA0004.bmp",
   L"data/actor/usami/winA0005.bmp",
   L"data/actor/usami/winA0006.bmp",
   L"data/actor/usami/winA0007.bmp",
   L"data/actor/usami/winB0000.bmp",
   L"data/actor/usami/winB0001.bmp",
   L"data/actor/usami/winB0002.bmp",
   L"data/actor/usami/winB0003.bmp",
   L"data/actor/usami/winB0004.bmp",
   L"data/actor/usami/winB0005.bmp",
   L"data/actor/usami.nut",
   L"data/actor/usami_base.nut",
   L"data/actor/usami_boss.nut",
   L"data/actor/usami_boss_base.nut",
   L"data/actor/usami_boss_init.nut",
   L"data/actor/usami_boss_shot.nut",
   L"data/actor/usami_com.nut",
   L"data/actor/usami_combo.nut",
   L"data/actor/usami_com_function.nut",
   L"data/actor/usami_init.nut",
   L"data/actor/usami_practice_init.nut",
   L"data/actor/usami_shot.nut",
   L"data/actor/usami_team.nut",
   L"data/actor/yukari/animal0000.png",
   L"data/actor/yukari/animal0001.png",
   L"data/actor/yukari/animal0002.png",
   L"data/actor/yukari/animal0003.png",
   L"data/actor/yukari/animal0004.png",
   L"data/actor/yukari/animal0005.png",
   L"data/actor/yukari/animal0006.png",
   L"data/actor/yukari/animal0007.png",
   L"data/actor/yukari/animal0008.png",
   L"data/actor/yukari/animal0009.png",
   L"data/actor/yukari/animal_damage0000.png",
   L"data/actor/yukari/animal_damage0001.png",
   L"data/actor/yukari/animal_damage0002.png",
   L"data/actor/yukari/animal_damage0003.png",
   L"data/actor/yukari/animal_damage0004.png",
   L"data/actor/yukari/atkLow0000.bmp",
   L"data/actor/yukari/atkLow0001.bmp",
   L"data/actor/yukari/atkLow0002.bmp",
   L"data/actor/yukari/atkLow0003.bmp",
   L"data/actor/yukari/atkLow0004.bmp",
   L"data/actor/yukari/atkLow0005.bmp",
   L"data/actor/yukari/atkLow0006.bmp",
   L"data/actor/yukari/atkLow0007.bmp",
   L"data/actor/yukari/atkLow0008.bmp",
   L"data/actor/yukari/atkLow0009.bmp",
   L"data/actor/yukari/atkLow0010.bmp",
   L"data/actor/yukari/atkMid0000.bmp",
   L"data/actor/yukari/atkMid0001.bmp",
   L"data/actor/yukari/atkMid0002.bmp",
   L"data/actor/yukari/atkMid0003.bmp",
   L"data/actor/yukari/atkMid0004.bmp",
   L"data/actor/yukari/atkMid0005.bmp",
   L"data/actor/yukari/atkMid0006.bmp",
   L"data/actor/yukari/atk_front0000.bmp",
   L"data/actor/yukari/atk_front0001.bmp",
   L"data/actor/yukari/atk_front0002.bmp",
   L"data/actor/yukari/atk_front0003.bmp",
   L"data/actor/yukari/atk_front0004.bmp",
   L"data/actor/yukari/atk_front0005.bmp",
   L"data/actor/yukari/atk_front0006.bmp",
   L"data/actor/yukari/atk_front0007.bmp",
   L"data/actor/yukari/atk_front0008.bmp",
   L"data/actor/yukari/atk_mid_air0000.bmp",
   L"data/actor/yukari/atk_mid_air0001.bmp",
   L"data/actor/yukari/atk_mid_air0002.bmp",
   L"data/actor/yukari/atk_mid_air0003.bmp",
   L"data/actor/yukari/atk_mid_air0004.bmp",
   L"data/actor/yukari/atk_mid_air0005.bmp",
   L"data/actor/yukari/atk_mid_air0006.bmp",
   L"data/actor/yukari/atk_mid_air0007.bmp",
   L"data/actor/yukari/atk_mid_air0008.bmp",
   L"data/actor/yukari/atk_under0000.bmp",
   L"data/actor/yukari/atk_under0001.bmp",
   L"data/actor/yukari/atk_under0002.bmp",
   L"data/actor/yukari/atk_under0003.bmp",
   L"data/actor/yukari/atk_under0004.bmp",
   L"data/actor/yukari/atk_under0005.bmp",
   L"data/actor/yukari/atk_upper0000.bmp",
   L"data/actor/yukari/atk_upper0001.bmp",
   L"data/actor/yukari/atk_upper0002.bmp",
   L"data/actor/yukari/atk_upper0003.bmp",
   L"data/actor/yukari/atk_upper0004.bmp",
   L"data/actor/yukari/atk_upper0005.bmp",
   L"data/actor/yukari/atk_upper0006.bmp",
   L"data/actor/yukari/atk_upper0007.bmp",
   L"data/actor/yukari/battle_beginA0000.bmp",
   L"data/actor/yukari/battle_beginA0001.bmp",
   L"data/actor/yukari/battle_beginA0002.bmp",
   L"data/actor/yukari/battle_beginA0003.bmp",
   L"data/actor/yukari/battle_beginA0004.bmp",
   L"data/actor/yukari/battle_beginA0005.bmp",
   L"data/actor/yukari/battle_beginA0006.bmp",
   L"data/actor/yukari/battle_beginA0007.bmp",
   L"data/actor/yukari/battle_beginA0008.bmp",
   L"data/actor/yukari/battle_beginA0009.bmp",
   L"data/actor/yukari/battle_beginA0010.bmp",
   L"data/actor/yukari/battle_beginA_chen0000.bmp",
   L"data/actor/yukari/battle_beginA_chen0001.bmp",
   L"data/actor/yukari/battle_beginA_ran0000.bmp",
   L"data/actor/yukari/battle_beginB0000.bmp",
   L"data/actor/yukari/battle_beginB0001.bmp",
   L"data/actor/yukari/battle_beginB0002.bmp",
   L"data/actor/yukari/battle_beginB0003.bmp",
   L"data/actor/yukari/battle_beginB0004.bmp",
   L"data/actor/yukari/battle_beginB0005.bmp",
   L"data/actor/yukari/battle_beginB0006.bmp",
   L"data/actor/yukari/battle_beginB0007.bmp",
   L"data/actor/yukari/battle_beginB0008.bmp",
   L"data/actor/yukari/battle_beginB0009.bmp",
   L"data/actor/yukari/battle_beginB0010.bmp",
   L"data/actor/yukari/battle_beginB0011.bmp",
   L"data/actor/yukari/battle_begin_reimu0000.bmp",
   L"data/actor/yukari/battle_begin_reimu0001.bmp",
   L"data/actor/yukari/battle_begin_reimu0002.bmp",
   L"data/actor/yukari/battle_begin_reimu0003.bmp",
   L"data/actor/yukari/battle_begin_reimu0004.bmp",
   L"data/actor/yukari/battle_begin_reimu0005.bmp",
   L"data/actor/yukari/battle_begin_reimu0006.bmp",
   L"data/actor/yukari/battle_begin_reimu0007.bmp",
   L"data/actor/yukari/battle_begin_reimu0008.bmp",
   L"data/actor/yukari/battle_begin_reimu0009.bmp",
   L"data/actor/yukari/battle_begin_reimu0010.bmp",
   L"data/actor/yukari/battle_begin_reimu0011.bmp",
   L"data/actor/yukari/battle_begin_reimu0012.bmp",
   L"data/actor/yukari/damageHead0000.bmp",
   L"data/actor/yukari/damageHead0001.bmp",
   L"data/actor/yukari/damageHead0002.bmp",
   L"data/actor/yukari/damageHead0003.bmp",
   L"data/actor/yukari/damageStun0000.bmp",
   L"data/actor/yukari/damageStun0001.bmp",
   L"data/actor/yukari/damageStun0002.bmp",
   L"data/actor/yukari/damageStun0003.bmp",
   L"data/actor/yukari/damageStun0004.bmp",
   L"data/actor/yukari/damageStun0005.bmp",
   L"data/actor/yukari/damageStun0006.bmp",
   L"data/actor/yukari/damage_body0000.bmp",
   L"data/actor/yukari/damage_body0001.bmp",
   L"data/actor/yukari/damage_body0002.bmp",
   L"data/actor/yukari/damage_body0003.bmp",
   L"data/actor/yukari/damage_down0001.bmp",
   L"data/actor/yukari/damage_down0002.bmp",
   L"data/actor/yukari/damage_down0003.bmp",
   L"data/actor/yukari/damage_down0004.bmp",
   L"data/actor/yukari/damage_down0005.bmp",
   L"data/actor/yukari/damage_down0006.bmp",
   L"data/actor/yukari/damage_down0007.bmp",
   L"data/actor/yukari/damage_down0008.bmp",
   L"data/actor/yukari/damage_down0009.bmp",
   L"data/actor/yukari/damage_down0010.bmp",
   L"data/actor/yukari/damage_down0011.bmp",
   L"data/actor/yukari/damage_down0012.bmp",
   L"data/actor/yukari/damage_down0013.bmp",
   L"data/actor/yukari/damage_down0014.bmp",
   L"data/actor/yukari/damage_down0015.bmp",
   L"data/actor/yukari/damage_down0016.bmp",
   L"data/actor/yukari/damage_down0017.bmp",
   L"data/actor/yukari/damage_down0018.bmp",
   L"data/actor/yukari/damage_down0019.bmp",
   L"data/actor/yukari/damage_down0020.bmp",
   L"data/actor/yukari/damage_down_B0000.bmp",
   L"data/actor/yukari/damage_down_B0001.bmp",
   L"data/actor/yukari/damage_down_B0002.bmp",
   L"data/actor/yukari/damage_down_B0003.bmp",
   L"data/actor/yukari/damage_down_B0004.bmp",
   L"data/actor/yukari/damage_down_B0005.bmp",
   L"data/actor/yukari/damage_down_B0006.bmp",
   L"data/actor/yukari/damage_down_B0007.bmp",
   L"data/actor/yukari/damage_down_B0008.bmp",
   L"data/actor/yukari/damage_down_B0009.bmp",
   L"data/actor/yukari/damage_spin0000.bmp",
   L"data/actor/yukari/damage_spin0001.bmp",
   L"data/actor/yukari/damage_spin0002.bmp",
   L"data/actor/yukari/damage_spin0003.bmp",
   L"data/actor/yukari/damage_wall0000.bmp",
   L"data/actor/yukari/damage_wall0001.bmp",
   L"data/actor/yukari/damage_wall0002.bmp",
   L"data/actor/yukari/damage_wall0003.bmp",
   L"data/actor/yukari/damage_wall0004.bmp",
   L"data/actor/yukari/dash_back0000.bmp",
   L"data/actor/yukari/dash_back0001.bmp",
   L"data/actor/yukari/dash_back0002.bmp",
   L"data/actor/yukari/dash_back0003.bmp",
   L"data/actor/yukari/dash_back0004.bmp",
   L"data/actor/yukari/dash_back0005.bmp",
   L"data/actor/yukari/dash_back0006.bmp",
   L"data/actor/yukari/dash_back0007.bmp",
   L"data/actor/yukari/dash_back0008.bmp",
   L"data/actor/yukari/dash_back0009.bmp",
   L"data/actor/yukari/dash_back0010.bmp",
   L"data/actor/yukari/dash_front0000.bmp",
   L"data/actor/yukari/dash_front0001.bmp",
   L"data/actor/yukari/dash_front0002.bmp",
   L"data/actor/yukari/dash_front0003.bmp",
   L"data/actor/yukari/dash_front0004.bmp",
   L"data/actor/yukari/dash_front0005.bmp",
   L"data/actor/yukari/dash_front0006.bmp",
   L"data/actor/yukari/dash_front0007.bmp",
   L"data/actor/yukari/dash_front0008.bmp",
   L"data/actor/yukari/dash_front0009.bmp",
   L"data/actor/yukari/dash_front0010.bmp",
   L"data/actor/yukari/dash_front0011.bmp",
   L"data/actor/yukari/grab0000.bmp",
   L"data/actor/yukari/grab0001.bmp",
   L"data/actor/yukari/grab0002.bmp",
   L"data/actor/yukari/grab0003.bmp",
   L"data/actor/yukari/grab0004.bmp",
   L"data/actor/yukari/grab_hit0000.bmp",
   L"data/actor/yukari/grab_hit0001.bmp",
   L"data/actor/yukari/grab_hit0002.bmp",
   L"data/actor/yukari/grab_hit0003.bmp",
   L"data/actor/yukari/grab_hit0004.bmp",
   L"data/actor/yukari/grab_hit0005.bmp",
   L"data/actor/yukari/guard0000.bmp",
   L"data/actor/yukari/guard0001.bmp",
   L"data/actor/yukari/guard0002.bmp",
   L"data/actor/yukari/guard0003.bmp",
   L"data/actor/yukari/guard_crash0000.bmp",
   L"data/actor/yukari/guard_crash0001.bmp",
   L"data/actor/yukari/guard_crash0002.bmp",
   L"data/actor/yukari/guard_crash0003.bmp",
   L"data/actor/yukari/guard_crash0004.bmp",
   L"data/actor/yukari/guard_crash0005.bmp",
   L"data/actor/yukari/guard_miss0000.bmp",
   L"data/actor/yukari/guard_miss0001.bmp",
   L"data/actor/yukari/guard_miss0002.bmp",
   L"data/actor/yukari/guard_miss0003.bmp",
   L"data/actor/yukari/last_word0000.bmp",
   L"data/actor/yukari/last_word0001.bmp",
   L"data/actor/yukari/last_word0002.bmp",
   L"data/actor/yukari/last_word0003.bmp",
   L"data/actor/yukari/last_word0004.bmp",
   L"data/actor/yukari/last_word0005.bmp",
   L"data/actor/yukari/last_word0006.bmp",
   L"data/actor/yukari/last_word0007.bmp",
   L"data/actor/yukari/last_word0008.bmp",
   L"data/actor/yukari/last_word0009.bmp",
   L"data/actor/yukari/last_word0010.bmp",
   L"data/actor/yukari/last_word_hit0000.bmp",
   L"data/actor/yukari/last_word_hit0001.bmp",
   L"data/actor/yukari/last_word_hit0002.bmp",
   L"data/actor/yukari/last_word_hit0003.bmp",
   L"data/actor/yukari/last_word_hit0004.bmp",
   L"data/actor/yukari/last_word_hit0005.bmp",
   L"data/actor/yukari/last_word_hit0006.bmp",
   L"data/actor/yukari/last_word_hit0007.bmp",
   L"data/actor/yukari/last_word_hit0008.bmp",
   L"data/actor/yukari/last_word_hit0009.bmp",
   L"data/actor/yukari/last_word_hit0010.bmp",
   L"data/actor/yukari/last_word_hit0011.bmp",
   L"data/actor/yukari/last_word_hit0012.bmp",
   L"data/actor/yukari/last_word_hit0013.bmp",
   L"data/actor/yukari/occult_atkLow0000.bmp",
   L"data/actor/yukari/occult_atkLow0001.bmp",
   L"data/actor/yukari/occult_atkLow0002.bmp",
   L"data/actor/yukari/occult_atkLow0003.bmp",
   L"data/actor/yukari/occult_atkLow0004.bmp",
   L"data/actor/yukari/occult_atkLow0005.bmp",
   L"data/actor/yukari/occult_atk_crawl0000.bmp",
   L"data/actor/yukari/occult_atk_crawl0001.bmp",
   L"data/actor/yukari/occult_atk_crawl0002.bmp",
   L"data/actor/yukari/occult_atk_crawl0003.bmp",
   L"data/actor/yukari/occult_atk_crawl0004.bmp",
   L"data/actor/yukari/occult_atk_crawl0005.bmp",
   L"data/actor/yukari/occult_atk_crawl0006.bmp",
   L"data/actor/yukari/occult_atk_crawl0007.bmp",
   L"data/actor/yukari/occult_atk_crawl0008.bmp",
   L"data/actor/yukari/occult_atk_crawl0009.bmp",
   L"data/actor/yukari/occult_atk_crawl0010.bmp",
   L"data/actor/yukari/occult_atk_crawl0011.bmp",
   L"data/actor/yukari/occult_atk_crawl0012.bmp",
   L"data/actor/yukari/occult_begin_atk0000.bmp",
   L"data/actor/yukari/occult_begin_atk0001.bmp",
   L"data/actor/yukari/occult_begin_atk0002.bmp",
   L"data/actor/yukari/occult_begin_atk0003.bmp",
   L"data/actor/yukari/occult_begin_atk0004.bmp",
   L"data/actor/yukari/occult_begin_atk0005.bmp",
   L"data/actor/yukari/occult_begin_atk0006.bmp",
   L"data/actor/yukari/occult_begin_atk0007.bmp",
   L"data/actor/yukari/occult_begin_atk0008.bmp",
   L"data/actor/yukari/occult_begin_atk0009.bmp",
   L"data/actor/yukari/occult_begin_atk0010.bmp",
   L"data/actor/yukari/occult_begin_atk0011.bmp",
   L"data/actor/yukari/occult_end_kick0000.bmp",
   L"data/actor/yukari/occult_end_kick0001.bmp",
   L"data/actor/yukari/occult_end_kick0002.bmp",
   L"data/actor/yukari/occult_end_kick0003.bmp",
   L"data/actor/yukari/occult_end_kick0004.bmp",
   L"data/actor/yukari/occult_end_kick0005.bmp",
   L"data/actor/yukari/occult_end_kick0006.bmp",
   L"data/actor/yukari/occult_end_kick0007.bmp",
   L"data/actor/yukari/occult_end_upper0000.bmp",
   L"data/actor/yukari/occult_end_upper0001.bmp",
   L"data/actor/yukari/occult_end_upper0002.bmp",
   L"data/actor/yukari/occult_end_upper0003.bmp",
   L"data/actor/yukari/occult_end_upper0004.bmp",
   L"data/actor/yukari/occult_end_upper0005.bmp",
   L"data/actor/yukari/occult_end_upper0006.bmp",
   L"data/actor/yukari/occult_end_upper0007.bmp",
   L"data/actor/yukari/occult_end_upper0008.bmp",
   L"data/actor/yukari/occult_end_upper0009.bmp",
   L"data/actor/yukari/occult_stand0000.bmp",
   L"data/actor/yukari/occult_stand0001.bmp",
   L"data/actor/yukari/occult_stand0002.bmp",
   L"data/actor/yukari/occult_stand0003.bmp",
   L"data/actor/yukari/occult_stand0004.bmp",
   L"data/actor/yukari/occult_stand0005.bmp",
   L"data/actor/yukari/occult_stand0006.bmp",
   L"data/actor/yukari/occult_stand0007.bmp",
   L"data/actor/yukari/occult_wait_under0000.bmp",
   L"data/actor/yukari/occult_wait_under0001.bmp",
   L"data/actor/yukari/occult_wait_under0002.bmp",
   L"data/actor/yukari/occult_wait_under0003.bmp",
   L"data/actor/yukari/occult_wait_under0004.bmp",
   L"data/actor/yukari/occult_wait_under0005.bmp",
   L"data/actor/yukari/occult_wait_under0006.bmp",
   L"data/actor/yukari/occult_wait_under0007.bmp",
   L"data/actor/yukari/occult_wait_under0008.bmp",
   L"data/actor/yukari/occult_wait_under0009.bmp",
   L"data/actor/yukari/occult_wait_under0010.bmp",
   L"data/actor/yukari/palette000.bmp",
   L"data/actor/yukari/palette001.bmp",
   L"data/actor/yukari/palette002.bmp",
   L"data/actor/yukari/palette003.bmp",
   L"data/actor/yukari/palette004.bmp",
   L"data/actor/yukari/palette005.bmp",
   L"data/actor/yukari/palette006.bmp",
   L"data/actor/yukari/palette007.bmp",
   L"data/actor/yukari/palette100.bmp",
   L"data/actor/yukari/palette101.bmp",
   L"data/actor/yukari/palette102.bmp",
   L"data/actor/yukari/palette103.bmp",
   L"data/actor/yukari/palette104.bmp",
   L"data/actor/yukari/palette105.bmp",
   L"data/actor/yukari/palette106.bmp",
   L"data/actor/yukari/palette107.bmp",
   L"data/actor/yukari/shot_charge0000.bmp",
   L"data/actor/yukari/shot_charge0001.bmp",
   L"data/actor/yukari/shot_charge0002.bmp",
   L"data/actor/yukari/shot_charge0003.bmp",
   L"data/actor/yukari/shot_charge0004.bmp",
   L"data/actor/yukari/shot_charge0005.bmp",
   L"data/actor/yukari/shot_charge0006.bmp",
   L"data/actor/yukari/shot_charge0007.bmp",
   L"data/actor/yukari/shot_charge0008.bmp",
   L"data/actor/yukari/shot_charge0009.bmp",
   L"data/actor/yukari/shot_charge0010.bmp",
   L"data/actor/yukari/shot_charge0011.bmp",
   L"data/actor/yukari/shot_normal0000.bmp",
   L"data/actor/yukari/shot_normal0001.bmp",
   L"data/actor/yukari/shot_normal0002.bmp",
   L"data/actor/yukari/shot_normal0003.bmp",
   L"data/actor/yukari/shot_normal0004.bmp",
   L"data/actor/yukari/shot_normal0005.bmp",
   L"data/actor/yukari/shot_normal0006.bmp",
   L"data/actor/yukari/shot_normal0007.bmp",
   L"data/actor/yukari/shot_normal0008.bmp",
   L"data/actor/yukari/shot_normal0009.bmp",
   L"data/actor/yukari/skill_cutter0000.bmp",
   L"data/actor/yukari/skill_cutter0001.bmp",
   L"data/actor/yukari/skill_cutter0002.bmp",
   L"data/actor/yukari/skill_cutter0003.bmp",
   L"data/actor/yukari/skill_cutter0004.bmp",
   L"data/actor/yukari/skill_cutter0005.bmp",
   L"data/actor/yukari/skill_cutter0006.bmp",
   L"data/actor/yukari/skill_cutter0007.bmp",
   L"data/actor/yukari/skill_cutter0008.bmp",
   L"data/actor/yukari/skill_cutter0009.bmp",
   L"data/actor/yukari/skill_finger0000.bmp",
   L"data/actor/yukari/skill_finger0001.bmp",
   L"data/actor/yukari/skill_finger0002.bmp",
   L"data/actor/yukari/skill_finger0003.bmp",
   L"data/actor/yukari/skill_finger0004.bmp",
   L"data/actor/yukari/skill_finger0005.bmp",
   L"data/actor/yukari/skill_finger0006.bmp",
   L"data/actor/yukari/skill_warpAttack0000.bmp",
   L"data/actor/yukari/skill_warpAttack0001.bmp",
   L"data/actor/yukari/skill_warpAttack0002.bmp",
   L"data/actor/yukari/skill_warpAttack0003.bmp",
   L"data/actor/yukari/skill_warpAttack0004.bmp",
   L"data/actor/yukari/skill_warpAttack0005.bmp",
   L"data/actor/yukari/skill_warpAttack0006.bmp",
   L"data/actor/yukari/skill_warpAttack0007.bmp",
   L"data/actor/yukari/skill_warpAttack0008.bmp",
   L"data/actor/yukari/skill_warpFall0000.bmp",
   L"data/actor/yukari/skill_warpFall0001.bmp",
   L"data/actor/yukari/skill_warpFall0002.bmp",
   L"data/actor/yukari/skill_warpFall0003.bmp",
   L"data/actor/yukari/skill_warpFall0004.bmp",
   L"data/actor/yukari/skill_warpFall_end0000.bmp",
   L"data/actor/yukari/skill_warpFall_end0001.bmp",
   L"data/actor/yukari/skill_warpFall_end0002.bmp",
   L"data/actor/yukari/skill_warpFall_end0003.bmp",
   L"data/actor/yukari/skill_warpFall_loop0000.bmp",
   L"data/actor/yukari/skill_warpFall_loop0001.bmp",
   L"data/actor/yukari/skill_warpFall_loop0002.bmp",
   L"data/actor/yukari/skill_warpFall_loop0003.bmp",
   L"data/actor/yukari/skill_warp_out0000.bmp",
   L"data/actor/yukari/skill_warp_out0001.bmp",
   L"data/actor/yukari/skill_warp_out0002.bmp",
   L"data/actor/yukari/skill_warp_out0003.bmp",
   L"data/actor/yukari/skill_warp_out0004.bmp",
   L"data/actor/yukari/skill_warp_out0005.bmp",
   L"data/actor/yukari/skill_warp_out0006.bmp",
   L"data/actor/yukari/skill_warp_out0007.bmp",
   L"data/actor/yukari/skill_warp_out0008.bmp",
   L"data/actor/yukari/skill_warp_out0009.bmp",
   L"data/actor/yukari/skill_warp_out0010.bmp",
   L"data/actor/yukari/slide0000.bmp",
   L"data/actor/yukari/slide0001.bmp",
   L"data/actor/yukari/slide0002.bmp",
   L"data/actor/yukari/slide0003.bmp",
   L"data/actor/yukari/slide0004.bmp",
   L"data/actor/yukari/slide0005.bmp",
   L"data/actor/yukari/slide0006.bmp",
   L"data/actor/yukari/slide0007.bmp",
   L"data/actor/yukari/slide0008.bmp",
   L"data/actor/yukari/slide0009.bmp",
   L"data/actor/yukari/slide0010.bmp",
   L"data/actor/yukari/slide0011.bmp",
   L"data/actor/yukari/slide0012.bmp",
   L"data/actor/yukari/slide0013.bmp",
   L"data/actor/yukari/slide0014.bmp",
   L"data/actor/yukari/slide0015.bmp",
   L"data/actor/yukari/slide0016.bmp",
   L"data/actor/yukari/slide0017.bmp",
   L"data/actor/yukari/spellB_chen0000.bmp",
   L"data/actor/yukari/spellB_ran0000.bmp",
   L"data/actor/yukari/spell_A0000.bmp",
   L"data/actor/yukari/spell_A0001.bmp",
   L"data/actor/yukari/spell_A0002.bmp",
   L"data/actor/yukari/spell_A0003.bmp",
   L"data/actor/yukari/spell_A0004.bmp",
   L"data/actor/yukari/spell_A0005.bmp",
   L"data/actor/yukari/spell_A0006.bmp",
   L"data/actor/yukari/spell_A0007.bmp",
   L"data/actor/yukari/spell_A0008.bmp",
   L"data/actor/yukari/spell_A0009.bmp",
   L"data/actor/yukari/spell_A0010.bmp",
   L"data/actor/yukari/spell_A0011.bmp",
   L"data/actor/yukari/spell_A0012.bmp",
   L"data/actor/yukari/spell_B0000.bmp",
   L"data/actor/yukari/spell_B0001.bmp",
   L"data/actor/yukari/spell_B0002.bmp",
   L"data/actor/yukari/spell_B0003.bmp",
   L"data/actor/yukari/spell_B0004.bmp",
   L"data/actor/yukari/spell_B0005.bmp",
   L"data/actor/yukari/spell_B0006.bmp",
   L"data/actor/yukari/spell_B0007.bmp",
   L"data/actor/yukari/spell_B0008.bmp",
   L"data/actor/yukari/spell_B0009.bmp",
   L"data/actor/yukari/spell_B0010.bmp",
   L"data/actor/yukari/spell_B0011.bmp",
   L"data/actor/yukari/spell_B0012.bmp",
   L"data/actor/yukari/spell_B0013.bmp",
   L"data/actor/yukari/spell_call0000.bmp",
   L"data/actor/yukari/spell_call0001.bmp",
   L"data/actor/yukari/spell_call0002.bmp",
   L"data/actor/yukari/spell_call0003.bmp",
   L"data/actor/yukari/spell_call0004.bmp",
   L"data/actor/yukari/spell_call0005.bmp",
   L"data/actor/yukari/spell_call0006.bmp",
   L"data/actor/yukari/spell_call0007.bmp",
   L"data/actor/yukari/spell_call0008.bmp",
   L"data/actor/yukari/stand0000.bmp",
   L"data/actor/yukari/stand0001.bmp",
   L"data/actor/yukari/stand0002.bmp",
   L"data/actor/yukari/stand0003.bmp",
   L"data/actor/yukari/stand0004.bmp",
   L"data/actor/yukari/stand0005.bmp",
   L"data/actor/yukari/stand0006.bmp",
   L"data/actor/yukari/stand0007.bmp",
   L"data/actor/yukari/stand0008.bmp",
   L"data/actor/yukari/stand0009.bmp",
   L"data/actor/yukari/stand0010.bmp",
   L"data/actor/yukari/test_skill_warpAttack0000.bmp",
   L"data/actor/yukari/test_skill_warpAttack0001.bmp",
   L"data/actor/yukari/test_skill_warpAttack0002.bmp",
   L"data/actor/yukari/test_skill_warpAttack0003.bmp",
   L"data/actor/yukari/test_skill_warpAttack0004.bmp",
   L"data/actor/yukari/test_skill_warpAttack0005.bmp",
   L"data/actor/yukari/test_skill_warpAttack0006.bmp",
   L"data/actor/yukari/test_skill_warpAttack0007.bmp",
   L"data/actor/yukari/test_skill_warpAttack0008.bmp",
   L"data/actor/yukari/texture/ball.png",
   L"data/actor/yukari/texture/battle_beginA_chen_flash000.png",
   L"data/actor/yukari/texture/battle_beginA_chen_flash001.png",
   L"data/actor/yukari/texture/battle_beginA_ran_flash000.png",
   L"data/actor/yukari/texture/blade_last_word000.png",
   L"data/actor/yukari/texture/blade_last_word001.png",
   L"data/actor/yukari/texture/blade_last_word002.png",
   L"data/actor/yukari/texture/blade_last_word003.png",
   L"data/actor/yukari/texture/blade_last_word004.png",
   L"data/actor/yukari/texture/blade_upper_kasa_0000.png",
   L"data/actor/yukari/texture/blade_upper_kasa_0001.png",
   L"data/actor/yukari/texture/blade_upper_kasa_0002.png",
   L"data/actor/yukari/texture/blade_upper_kasa_0003.png",
   L"data/actor/yukari/texture/face_master_yukari.png",
   L"data/actor/yukari/texture/face_master_yukari2.png",
   L"data/actor/yukari/texture/face_slave_yukari.png",
   L"data/actor/yukari/texture/face_spell_cut.png",
   L"data/actor/yukari/texture/hitparticle.png",
   L"data/actor/yukari/texture/hitspark.png",
   L"data/actor/yukari/texture/hyousiki_000.png",
   L"data/actor/yukari/texture/hyousiki_001.png",
   L"data/actor/yukari/texture/last_word_sukima0000.png",
   L"data/actor/yukari/texture/last_word_sukima0001.png",
   L"data/actor/yukari/texture/last_word_sukima0002.png",
   L"data/actor/yukari/texture/manzi_000.png",
   L"data/actor/yukari/texture/shot_charge_eye.png",
   L"data/actor/yukari/texture/shot_front_sukima0000.png",
   L"data/actor/yukari/texture/sotoba_0000.png",
   L"data/actor/yukari/texture/sotoba_0001.png",
   L"data/actor/yukari/texture/sotoba_mask.png",
   L"data/actor/yukari/texture/spellC_mask.png",
   L"data/actor/yukari/texture/spell_use_cut.png",
   L"data/actor/yukari/texture/sukima_back0000.png",
   L"data/actor/yukari/texture/sukima_front_0001.png",
   L"data/actor/yukari/texture/sukima_front_0002.png",
   L"data/actor/yukari/texture/sukima_front_0003.png",
   L"data/actor/yukari/texture/sukima_front_0004.png",
   L"data/actor/yukari/texture/sukima_wide_0001.png",
   L"data/actor/yukari/texture/sukima_wide_0002.png",
   L"data/actor/yukari/texture/sukima_wide_0003.png",
   L"data/actor/yukari/texture/sukima_wide_0004.png",
   L"data/actor/yukari/texture/sukima_wide_0005.png",
   L"data/actor/yukari/texture/sukima_wide_0006.png",
   L"data/actor/yukari/texture/test_lastWord0003.png",
   L"data/actor/yukari/texture/test_yukari_cut.png",
   L"data/actor/yukari/texture/train_000af.png",
   L"data/actor/yukari/texture/train_000bf.png",
   L"data/actor/yukari/texture/train_001bf.png",
   L"data/actor/yukari/texture/unzanbeam.png",
   L"data/actor/yukari/texture/yukari_sukima0000.png",
   L"data/actor/yukari/walk0000.bmp",
   L"data/actor/yukari/walk0001.bmp",
   L"data/actor/yukari/walk0002.bmp",
   L"data/actor/yukari/walk0003.bmp",
   L"data/actor/yukari/walk0004.bmp",
   L"data/actor/yukari/walk0005.bmp",
   L"data/actor/yukari/walk0006.bmp",
   L"data/actor/yukari/walk0007.bmp",
   L"data/actor/yukari/walk0008.bmp",
   L"data/actor/yukari/walkBack0000.bmp",
   L"data/actor/yukari/walkBack0001.bmp",
   L"data/actor/yukari/walkBack0002.bmp",
   L"data/actor/yukari/walkBack0003.bmp",
   L"data/actor/yukari/walkBack0004.bmp",
   L"data/actor/yukari/walkBack0005.bmp",
   L"data/actor/yukari/walkBack0006.bmp",
   L"data/actor/yukari/walkBack0007.bmp",
   L"data/actor/yukari/walkBack0008.bmp",
   L"data/actor/yukari/win_a0000.bmp",
   L"data/actor/yukari/win_a0001.bmp",
   L"data/actor/yukari/win_a0002.bmp",
   L"data/actor/yukari/win_a0003.bmp",
   L"data/actor/yukari/win_a0004.bmp",
   L"data/actor/yukari/win_a0005.bmp",
   L"data/actor/yukari/win_a0006.bmp",
   L"data/actor/yukari/win_b0000.bmp",
   L"data/actor/yukari/win_b0001.bmp",
   L"data/actor/yukari/win_b0002.bmp",
   L"data/actor/yukari/win_b0003.bmp",
   L"data/actor/yukari/win_b0004.bmp",
   L"data/actor/yukari/win_b0005.bmp",
   L"data/actor/yukari/win_b0006.bmp",
   L"data/actor/yukari/win_b0007.bmp",
   L"data/actor/yukari/win_b0008.bmp",
   L"data/actor/yukari/win_b0009.bmp",
   L"data/actor/yukari/win_b_chen0000.bmp",
   L"data/actor/yukari/win_b_chen0001.bmp",
   L"data/actor/yukari/win_b_chen0002.bmp",
   L"data/actor/yukari/win_b_chen0003.bmp",
   L"data/actor/yukari/win_b_chen0004.bmp",
   L"data/actor/yukari/win_b_chen0005.bmp",
   L"data/actor/yukari/win_b_chen0006.bmp",
   L"data/actor/yukari/win_b_chen0007.bmp",
   L"data/actor/yukari/win_b_chen0008.bmp",
   L"data/actor/yukari/win_b_chen0009.bmp",
   L"data/actor/yukari/win_b_chen0010.bmp",
   L"data/actor/yukari/win_b_chen0011.bmp",
   L"data/actor/yukari/yukari.pat",
   L"data/actor/yukari/yukari_ed.pat",
   L"data/actor/yukari.nut",
   L"data/actor/yukari_base.nut",
   L"data/actor/yukari_boss.nut",
   L"data/actor/yukari_boss_base.nut",
   L"data/actor/yukari_boss_init.nut",
   L"data/actor/yukari_boss_shot.nut",
   L"data/actor/yukari_com.nut",
   L"data/actor/yukari_combo.nut",
   L"data/actor/yukari_com_function.nut",
   L"data/actor/yukari_init.nut",
   L"data/actor/yukari_practice_init.nut",
   L"data/actor/yukari_shot.nut",
   L"data/actor/yukari_team.nut",
   L"data/backGround/bg01/000n/n.mat",
   L"data/backGround/bg01/000bO/C.mat",
   L"data/backGround/bg01/000/C.mat",
   L"data/backGround/bg01/000/C.mat",
   L"data/backGround/bg01/000O/C.mat",
   L"data/backGround/bg01/000O/C.mat",
   L"data/backGround/bg01/000[/C.mat",
   L"data/backGround/bg01/000/C.mat",
   L"data/backGround/bg01/000؉E/ؑE.mat",
   L"data/backGround/bg01/000؏/ؑE.mat",
   L"data/backGround/bg01/000؏/ؑ卶.mat",
   L"data/backGround/bg01/000؍/ؑ卶.mat",
   L"data/backGround/bg01/000A[`/C.mat",
   L"data/backGround/bg01/000U/C.mat",
   L"data/backGround/bg01/000ΒʘH/C.mat",
   L"data/backGround/bg01/000_/C.mat",
   L"data/backGround/bg01/000_Њb/C.mat",
   L"data/backGround/bg01/000_Ж{/C.mat",
   L"data/backGround/bg01/000/.mat",
   L"data/backGround/bg01/000/C.mat",
   L"data/backGround/bg01/001R/R.mat",
   L"data/backGround/bg01/002/RO.mat",
   L"data/backGround/bg01/003RO/RO.mat",
   L"data/backGround/bg01/004kusa/`.mat",
   L"data/backGround/bg01/004kusa/a.mat",
   L"data/backGround/bg01/004kusa/b.mat",
   L"data/backGround/bg01/004X/X.mat",
   L"data/backGround/bg01/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/010kusa/`.mat",
   L"data/backGround/bg01/010kusa/a.mat",
   L"data/backGround/bg01/010kusa/b.mat",
   L"data/backGround/bg01/020tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/021tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/022tree/ؗtϗ.mat",
   L"data/backGround/bg01/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg01/024tree/ؗtϗ.mat",
   L"data/backGround/bg01/025tree/ؗtϕ\.mat",
   L"data/backGround/bg01/026tree/ؗtϗ.mat",
   L"data/backGround/bg01/027tree/ؗtϕ\.mat",
   L"data/backGround/bg01/030kusa/a.mat",
   L"data/backGround/bg01/030kusa/b.mat",
   L"data/backGround/bg01/031kusa/`.mat",
   L"data/backGround/bg01/031kusa/b.mat",
   L"data/backGround/bg01/032tree/ؗtϗ.mat",
   L"data/backGround/bg01/033_tree/ؗtϕ\.mat",
   L"data/backGround/bg01/034tree/ؗtϗ.mat",
   L"data/backGround/bg01/035tree/ؗtϕ\.mat",
   L"data/backGround/bg01/036tree/ؗtϗ.mat",
   L"data/backGround/bg01/037tree/ؗtϕ\.mat",
   L"data/backGround/bg01/040kusa/`.mat",
   L"data/backGround/bg01/040kusa/b.mat",
   L"data/backGround/bg01/041kusa/`.mat",
   L"data/backGround/bg01/041kusa/a.mat",
   L"data/backGround/bg01/042kusa/`.mat",
   L"data/backGround/bg01/bg01.msh",
   L"data/backGround/bg01/bgtest_5.dds",
   L"data/backGround/bg01/bgtest_n02.dds",
   L"data/backGround/bg01/kusa.png",
   L"data/backGround/bg01/kusa2.png",
   L"data/backGround/bg01/kusa3.png",
   L"data/backGround/bg01/mori_O03.dds",
   L"data/backGround/bg01/mori_O04.dds",
   L"data/backGround/bg01/obj1/ؗtϕ\.mat",
   L"data/backGround/bg01/obj1/ؗtϕ\.mat",
   L"data/backGround/bg01/obj1/ؗtϕ\.mat",
   L"data/backGround/bg01/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj1/ؗtϗ.mat",
   L"data/backGround/bg01/obj1/ؗtϗ.mat",
   L"data/backGround/bg01/obj10/ؗtϗ.mat",
   L"data/backGround/bg01/obj11/ؗtϕ\.mat",
   L"data/backGround/bg01/obj12/ؗtϕ\.mat",
   L"data/backGround/bg01/obj13/ؗtϗ.mat",
   L"data/backGround/bg01/obj14/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj15/ؗtϗ.mat",
   L"data/backGround/bg01/obj16/ؗtϕ\.mat",
   L"data/backGround/bg01/obj17/ؗtϗ.mat",
   L"data/backGround/bg01/obj18/ؗtϕ\.mat",
   L"data/backGround/bg01/obj2/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj3/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj4/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj5/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj6/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj7/ؗtϕ\a.mat",
   L"data/backGround/bg01/obj8/ؗtϕ\.mat",
   L"data/backGround/bg01/obj9/ؗtϗ.mat",
   L"data/backGround/bg01/treeA.dds",
   L"data/backGround/bg01/treeA.msh",
   L"data/backGround/bg01/treeA.tak",
   L"data/backGround/bg01/treeB.dds",
   L"data/backGround/bg01/n/n.mat",
   L"data/backGround/bg01/bO/C.mat",
   L"data/backGround/bg01//C.mat",
   L"data/backGround/bg01//C.mat",
   L"data/backGround/bg01/O/C.mat",
   L"data/backGround/bg01/O/C.mat",
   L"data/backGround/bg01/[/C.mat",
   L"data/backGround/bg01//C.mat",
   L"data/backGround/bg01/R/R.mat",
   L"data/backGround/bg01/R1/R.mat",
   L"data/backGround/bg01/RO/RO.mat",
   L"data/backGround/bg01/RO`/RO.mat",
   L"data/backGround/bg01/Rŉ01.dds",
   L"data/backGround/bg01/؉E/ؑE.mat",
   L"data/backGround/bg01/؏/ؑE.mat",
   L"data/backGround/bg01/؏/ؑ卶.mat",
   L"data/backGround/bg01/؍/ؑ卶.mat",
   L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg01/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg01/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg01/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg01/ؗt/ؗtϗ.mat",
   L"data/backGround/bg01/ؗt/ؗtϗ.mat",
   L"data/backGround/bg01/X/X.mat",
   L"data/backGround/bg01/A[`/C.mat",
   L"data/backGround/bg01/U/C.mat",
   L"data/backGround/bg01/ΒʘH/C.mat",
   L"data/backGround/bg01/ΒʘH/C.mat",
   L"data/backGround/bg01/_Њb/C.mat",
   L"data/backGround/bg01/_Ж{/C.mat",
   L"data/backGround/bg01//.mat",
   L"data/backGround/bg01/01.dds",
   L"data/backGround/bg01//`.mat",
   L"data/backGround/bg01//a.mat",
   L"data/backGround/bg01//b.mat",
   L"data/backGround/bg01/tA.dds",
   L"data/backGround/bg01/tA.dds",
   L"data/backGround/bg01/tAO.dds",
   L"data/backGround/bg01/tϏ01.dds",
   L"data/backGround/bg01/tϏ02.dds",
   L"data/backGround/bg01/tϏ03.dds",
   L"data/backGround/bg01/tϏc01.dds",
   L"data/backGround/bg01//C.mat",
   L"data/backGround/bg02/000main/19 - Default.mat",
   L"data/backGround/bg02/000main/mat1.mat",
   L"data/backGround/bg02/000e[u02/mat8.mat",
   L"data/backGround/bg02/000e[u1/mat8.mat",
   L"data/backGround/bg02/000㏬/mat8.mat",
   L"data/backGround/bg02/000n/mat1.mat",
   L"data/backGround/bg02/000/04 - Default.mat",
   L"data/backGround/bg02/000/mat8.mat",
   L"data/backGround/bg02/000_Oȓ/mat8.mat",
   L"data/backGround/bg02/000_ƉE/mat8.mat",
   L"data/backGround/bg02/000_ƉE[/mat8.mat",
   L"data/backGround/bg02/000_ƍ/mat8.mat",
   L"data/backGround/bg02/000_ԉ{/mat8.mat",
   L"data/backGround/bg02/000_ԉ/mat8.mat",
   L"data/backGround/bg02/000_/mat8.mat",
   L"data/backGround/bg02/000_O/mat8.mat",
   L"data/backGround/bg02/000_݉/mat8.mat",
   L"data/backGround/bg02/000_݉JE^[/mat8.mat",
   L"data/backGround/bg02/000_݉x_/mat8.mat",
   L"data/backGround/bg02/000_݉/mat8.mat",
   L"data/backGround/bg02/000_݉/mat8.mat",
   L"data/backGround/bg02/000_݉2f/mat8.mat",
   L"data/backGround/bg02/000_݉O1f/mat8.mat",
   L"data/backGround/bg02/000_݉O2f/mat8.mat",
   L"data/backGround/bg02/000_݉/mat8.mat",
   L"data/backGround/bg02/000_݉Ŕ/mat8.mat",
   L"data/backGround/bg02/000_/mat8.mat",
   L"data/backGround/bg02/000_O/mat8.mat",
   L"data/backGround/bg02/000_/mat8.mat",
   L"data/backGround/bg02/000_Ŕ/mat8.mat",
   L"data/backGround/bg02/000񓔂`/mat8.mat",
   L"data/backGround/bg02/000/.mat",
   L"data/backGround/bg02/0001/mat8.mat",
   L"data/backGround/bg02/0002/mat8.mat",
   L"data/backGround/bg02/0003/mat8.mat",
   L"data/backGround/bg02/0004/mat8.mat",
   L"data/backGround/bg02/0005/mat8.mat",
   L"data/backGround/bg02/0006/mat8.mat",
   L"data/backGround/bg02/0007/mat8.mat",
   L"data/backGround/bg02/0008/mat8.mat",
   L"data/backGround/bg02/000M֎q/mat8.mat",
   L"data/backGround/bg02/000MP/mat8.mat",
   L"data/backGround/bg02/000MQ/mat8.mat",
   L"data/backGround/bg02/001R/R.mat",
   L"data/backGround/bg02/002/RO.mat",
   L"data/backGround/bg02/004X01/RO.mat",
   L"data/backGround/bg02/005X/RO.mat",
   L"data/backGround/bg02/006XO/Material #528.mat",
   L"data/backGround/bg02/006XO01/Material #521.mat",
   L"data/backGround/bg02/007XO/Material #521.mat",
   L"data/backGround/bg02/008XO/Material #528.mat",
   L"data/backGround/bg02/008XO2/Material #528.mat",
   L"data/backGround/bg02/bg02.msh",
   L"data/backGround/bg02/bg02.tak",
   L"data/backGround/bg02/bg02_a.msh",
   L"data/backGround/bg02/BL02a_bill.dds",
   L"data/backGround/bg02/BL07m_bill.dds",
   L"data/backGround/bg02/siro/19 - Default.mat",
   L"data/backGround/bg02/ǂwin.dds",
   L"data/backGround/bg02/ǂwiX01.dds",
   L"data/backGround/bg02/ǂwi03.dds",
   L"data/backGround/bg02/̂/mat6.mat",
   L"data/backGround/bg02/e[u/mat6.mat",
   L"data/backGround/bg02/Oȓ/mat6.mat",
   L"data/backGround/bg02/㏬/mat6.mat",
   L"data/backGround/bg02//mat6.mat",
   L"data/backGround/bg02/֎q/mat6.mat",
   L"data/backGround/bg02/ƉE/mat6.mat",
   L"data/backGround/bg02/ƍ/mat6.mat",
   L"data/backGround/bg02/ƍ/mat6.mat",
   L"data/backGround/bg02/01.dds",
   L"data/backGround/bg02/ԉ/mat6.mat",
   L"data/backGround/bg02//mat6.mat",
   L"data/backGround/bg02/݉/mat6.mat",
   L"data/backGround/bg02/݉/mat6.mat",
   L"data/backGround/bg02/݉/mat6.mat",
   L"data/backGround/bg03/000funea/mat1.mat",
   L"data/backGround/bg03/000funea/mat2.mat",
   L"data/backGround/bg03/000h[/mat3.mat",
   L"data/backGround/bg03/000/kumo_naka.mat",
   L"data/backGround/bg03/000/kumo_oku.mat",
   L"data/backGround/bg03/000D/mat1.mat",
   L"data/backGround/bg03/000D/mat2.mat",
   L"data/backGround/bg03/001kumo/mat4.mat",
   L"data/backGround/bg03/001kumob/mat4.mat",
   L"data/backGround/bg03/002kumo/mat4.mat",
   L"data/backGround/bg03/003kumo/mat4.mat",
   L"data/backGround/bg03/004kumo/mat5.mat",
   L"data/backGround/bg03/backup/fune_body.bmp",
   L"data/backGround/bg03/backup/fune_sora.bmp",
   L"data/backGround/bg03/backup/ho01.bmp",
   L"data/backGround/bg03/backup/kumo_A.png",
   L"data/backGround/bg03/backup/kumo_B.png",
   L"data/backGround/bg03/backup/kumo_oku.png",
   L"data/backGround/bg03/bg03.msh",
   L"data/backGround/bg03/fune.msh",
   L"data/backGround/bg03/fune.tak",
   L"data/backGround/bg03/fune_body.dds",
   L"data/backGround/bg03/fune_sora.dds",
   L"data/backGround/bg03/ho01.dds",
   L"data/backGround/bg03/kumo.msh",
   L"data/backGround/bg03/kumo_A.dds",
   L"data/backGround/bg03/kumo_B.dds",
   L"data/backGround/bg03/kumo_naka.dds",
   L"data/backGround/bg03/kumo_oku.dds",
   L"data/backGround/bg03/obj9/mat1.mat",
   L"data/backGround/bg03/obj9/mat2.mat",
   L"data/backGround/bg03/h[/mat3.mat",
   L"data/backGround/bg03//kumo_naka.mat",
   L"data/backGround/bg03//kumo_oku.mat",
   L"data/backGround/bg03/D/mat1.mat",
   L"data/backGround/bg03/D/mat2.mat",
   L"data/backGround/bg04/000treeA/mat8.mat",
   L"data/backGround/bg04/000treeB/mat8.mat",
   L"data/backGround/bg04/000tree_small/mat8.mat",
   L"data/backGround/bg04/000n/A.mat",
   L"data/backGround/bg04/000nЂȒd/A.mat",
   L"data/backGround/bg04/000n/mat1.mat",
   L"data/backGround/bg04/000n/mat2.mat",
   L"data/backGround/bg04/000n/A.mat",
   L"data/backGround/bg04/000/A.mat",
   L"data/backGround/bg04/000k/A.mat",
   L"data/backGround/bg04/000R/mat2.mat",
   L"data/backGround/bg04/000肷/A.mat",
   L"data/backGround/bg04/000肷O/A.mat",
   L"data/backGround/bg04/000/mat1.mat",
   L"data/backGround/bg04/000U/A.mat",
   L"data/backGround/bg04/000UO/A.mat",
   L"data/backGround/bg04/000U/A.mat",
   L"data/backGround/bg04/000U/A.mat",
   L"data/backGround/bg04/000/.mat",
   L"data/backGround/bg04/000j/A.mat",
   L"data/backGround/bg04/000ΑK/A.mat",
   L"data/backGround/bg04/000ǂ/A.mat",
   L"data/backGround/bg04/000Ki/A.mat",
   L"data/backGround/bg04/001R/R.mat",
   L"data/backGround/bg04/002/RO.mat",
   L"data/backGround/bg04/003RO/RO.mat",
   L"data/backGround/bg04/004kusa/`.mat",
   L"data/backGround/bg04/004kusa/a.mat",
   L"data/backGround/bg04/004kusa/b.mat",
   L"data/backGround/bg04/004X/X.mat",
   L"data/backGround/bg04/005tree/ؗtϕ\.mat",
   L"data/backGround/bg04/005tree/ؗtϕ\.mat",
   L"data/backGround/bg04/005tree/ؗtϕ\.mat",
   L"data/backGround/bg04/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/006tree/mat3.mat",
   L"data/backGround/bg04/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/007tree/mat3.mat",
   L"data/backGround/bg04/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/008tree/mat3.mat",
   L"data/backGround/bg04/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/009tree/mat3.mat",
   L"data/backGround/bg04/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/010tree/mat3.mat",
   L"data/backGround/bg04/011tree/mat3.mat",
   L"data/backGround/bg04/012tree/mat3.mat",
   L"data/backGround/bg04/012tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/013tree/mat3.mat",
   L"data/backGround/bg04/014tree/mat3.mat",
   L"data/backGround/bg04/015tree/mat3.mat",
   L"data/backGround/bg04/016tree/mat3.mat",
   L"data/backGround/bg04/017tree/mat3.mat",
   L"data/backGround/bg04/018tree/mat3.mat",
   L"data/backGround/bg04/019tree/mat3.mat",
   L"data/backGround/bg04/020tree/mat3.mat",
   L"data/backGround/bg04/021tree/mat3.mat",
   L"data/backGround/bg04/022tree/mat3.mat",
   L"data/backGround/bg04/023tree/mat3.mat",
   L"data/backGround/bg04/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/024tree/mat3.mat",
   L"data/backGround/bg04/025tree/mat3.mat",
   L"data/backGround/bg04/026tree/mat3.mat",
   L"data/backGround/bg04/027tree/mat3.mat",
   L"data/backGround/bg04/028tree/mat3.mat",
   L"data/backGround/bg04/029tree/mat3.mat",
   L"data/backGround/bg04/030tree/mat3.mat",
   L"data/backGround/bg04/031tree/mat3.mat",
   L"data/backGround/bg04/031tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/032tree/mat3.mat",
   L"data/backGround/bg04/033tree/mat3.mat",
   L"data/backGround/bg04/034tree/mat3.mat",
   L"data/backGround/bg04/035tree/mat3.mat",
   L"data/backGround/bg04/036tree/mat3.mat",
   L"data/backGround/bg04/037tree/mat3.mat",
   L"data/backGround/bg04/038tree/mat3.mat",
   L"data/backGround/bg04/039tree/mat3.mat",
   L"data/backGround/bg04/040tree/mat3.mat",
   L"data/backGround/bg04/041tree/mat3.mat",
   L"data/backGround/bg04/042tree/mat3.mat",
   L"data/backGround/bg04/043tree/mat3.mat",
   L"data/backGround/bg04/044tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/045tree/mat3.mat",
   L"data/backGround/bg04/046tree/mat3.mat",
   L"data/backGround/bg04/047tree/mat3.mat",
   L"data/backGround/bg04/048tree/mat3.mat",
   L"data/backGround/bg04/049tree/mat3.mat",
   L"data/backGround/bg04/050tree/mat3.mat",
   L"data/backGround/bg04/051tree/mat3.mat",
   L"data/backGround/bg04/052tree/mat3.mat",
   L"data/backGround/bg04/053tree/mat3.mat",
   L"data/backGround/bg04/054tree/mat3.mat",
   L"data/backGround/bg04/055tree/mat3.mat",
   L"data/backGround/bg04/056tree/mat3.mat",
   L"data/backGround/bg04/057tree/mat3.mat",
   L"data/backGround/bg04/058tree/mat3.mat",
   L"data/backGround/bg04/059tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/060tree/mat3.mat",
   L"data/backGround/bg04/061tree/ؗtϕ\a.mat",
   L"data/backGround/bg04/062tree/mat3.mat",
   L"data/backGround/bg04/063tree/mat4.mat",
   L"data/backGround/bg04/064tree/mat4.mat",
   L"data/backGround/bg04/065tree/mat3.mat",
   L"data/backGround/bg04/066tree/mat3.mat",
   L"data/backGround/bg04/067tree/mat3.mat",
   L"data/backGround/bg04/068tree/mat3.mat",
   L"data/backGround/bg04/069tree/ؗtϕ\.mat",
   L"data/backGround/bg04/070tree/mat3.mat",
   L"data/backGround/bg04/071tree/mat3.mat",
   L"data/backGround/bg04/072tree/mat3.mat",
   L"data/backGround/bg04/073tree/mat4.mat",
   L"data/backGround/bg04/074tree/mat3.mat",
   L"data/backGround/bg04/075tree/mat3.mat",
   L"data/backGround/bg04/076tree/mat4.mat",
   L"data/backGround/bg04/077tree/mat3.mat",
   L"data/backGround/bg04/078tree/mat3.mat",
   L"data/backGround/bg04/079tree/mat3.mat",
   L"data/backGround/bg04/080tree/mat3.mat",
   L"data/backGround/bg04/081tree/ؗtϕ\.mat",
   L"data/backGround/bg04/082tree/mat3.mat",
   L"data/backGround/bg04/083tree/mat3.mat",
   L"data/backGround/bg04/084tree/mat3.mat",
   L"data/backGround/bg04/085tree/mat3.mat",
   L"data/backGround/bg04/086tree/mat3.mat",
   L"data/backGround/bg04/087tree/mat3.mat",
   L"data/backGround/bg04/088tree/mat3.mat",
   L"data/backGround/bg04/089tree/mat3.mat",
   L"data/backGround/bg04/090tree/mat3.mat",
   L"data/backGround/bg04/091tree/mat3.mat",
   L"data/backGround/bg04/092tree/mat3.mat",
   L"data/backGround/bg04/093tree/mat3.mat",
   L"data/backGround/bg04/094tree/mat3.mat",
   L"data/backGround/bg04/095tree/mat3.mat",
   L"data/backGround/bg04/096tree/mat3.mat",
   L"data/backGround/bg04/097tree/mat3.mat",
   L"data/backGround/bg04/098tree/mat3.mat",
   L"data/backGround/bg04/099tree/mat3.mat",
   L"data/backGround/bg04/100tree/mat3.mat",
   L"data/backGround/bg04/101tree/mat3.mat",
   L"data/backGround/bg04/102tree/mat3.mat",
   L"data/backGround/bg04/103tree/mat3.mat",
   L"data/backGround/bg04/104tree/mat4.mat",
   L"data/backGround/bg04/105tree/mat3.mat",
   L"data/backGround/bg04/106tree/ؗtϕ\.mat",
   L"data/backGround/bg04/107tree/mat3.mat",
   L"data/backGround/bg04/108tree/mat3.mat",
   L"data/backGround/bg04/109tree/mat3.mat",
   L"data/backGround/bg04/110tree/mat3.mat",
   L"data/backGround/bg04/111tree/mat3.mat",
   L"data/backGround/bg04/112tree/mat3.mat",
   L"data/backGround/bg04/113tree/mat3.mat",
   L"data/backGround/bg04/114tree/mat3.mat",
   L"data/backGround/bg04/115tree/mat3.mat",
   L"data/backGround/bg04/116tree/mat3.mat",
   L"data/backGround/bg04/117tree/mat3.mat",
   L"data/backGround/bg04/118tree/mat4.mat",
   L"data/backGround/bg04/119tree/mat4.mat",
   L"data/backGround/bg04/120tree/mat4.mat",
   L"data/backGround/bg04/121tree/mat3.mat",
   L"data/backGround/bg04/122tree/mat4.mat",
   L"data/backGround/bg04/123tree/mat3.mat",
   L"data/backGround/bg04/124tree/mat3.mat",
   L"data/backGround/bg04/125tree/mat4.mat",
   L"data/backGround/bg04/126tree/mat4.mat",
   L"data/backGround/bg04/127tree/mat4.mat",
   L"data/backGround/bg04/128tree/mat4.mat",
   L"data/backGround/bg04/129tree/mat3.mat",
   L"data/backGround/bg04/130tree/mat3.mat",
   L"data/backGround/bg04/131tree/mat4.mat",
   L"data/backGround/bg04/132tree/mat4.mat",
   L"data/backGround/bg04/133tree/mat4.mat",
   L"data/backGround/bg04/134tree/mat4.mat",
   L"data/backGround/bg04/135tree/mat4.mat",
   L"data/backGround/bg04/136tree/mat4.mat",
   L"data/backGround/bg04/137tree/mat4.mat",
   L"data/backGround/bg04/138tree/mat4.mat",
   L"data/backGround/bg04/139tree/mat4.mat",
   L"data/backGround/bg04/bg04.msh",
   L"data/backGround/bg04/bg04_a.msh",
   L"data/backGround/bg04/bg04_front.msh",
   L"data/backGround/bg04/hata.msh",
   L"data/backGround/bg04/hataA00000.png",
   L"data/backGround/bg04/hataA00004.png",
   L"data/backGround/bg04/hataA00014.png",
   L"data/backGround/bg04/hataL_00/mat8.mat",
   L"data/backGround/bg04/hataL_01/mat8.mat",
   L"data/backGround/bg04/hataL_02/mat8.mat",
   L"data/backGround/bg04/hataL_03/mat8.mat",
   L"data/backGround/bg04/hataL_04/mat8.mat",
   L"data/backGround/bg04/hataL_05/mat8.mat",
   L"data/backGround/bg04/hataR_00/mat5.mat",
   L"data/backGround/bg04/hataR_01/mat5.mat",
   L"data/backGround/bg04/hataR_02/mat7.mat",
   L"data/backGround/bg04/hataR_03/mat5.mat",
   L"data/backGround/bg04/hataR_04/mat6.mat",
   L"data/backGround/bg04/hataR_05/mat5.mat",
   L"data/backGround/bg04/htataB00000.png",
   L"data/backGround/bg04/kusa.dds",
   L"data/backGround/bg04/kusa.png",
   L"data/backGround/bg04/mori_O03.dds",
   L"data/backGround/bg04/mori_[v.dds",
   L"data/backGround/bg04/obj1/mat3.mat",
   L"data/backGround/bg04/obj2/mat3.mat",
   L"data/backGround/bg04/plane01/01 - Default.mat",
   L"data/backGround/bg04/plane02/01 - Default.mat",
   L"data/backGround/bg04/plane03/01 - Default.mat",
   L"data/backGround/bg04/plane04/01 - Default.mat",
   L"data/backGround/bg04/plane05/01 - Default.mat",
   L"data/backGround/bg04/plane06/01 - Default.mat",
   L"data/backGround/bg04/reimu/05 - Default.mat",
   L"data/backGround/bg04/tree.msh",
   L"data/backGround/bg04/treeA/mat3.mat",
   L"data/backGround/bg04/treeA/mat8.mat",
   L"data/backGround/bg04/treeB/mat3.mat",
   L"data/backGround/bg04/treeB/mat8.mat",
   L"data/backGround/bg04/tree_small/mat3.mat",
   L"data/backGround/bg04/tree_small/mat8.mat",
   L"data/backGround/bg04/n/A.mat",
   L"data/backGround/bg04/nЂȒd/A.mat",
   L"data/backGround/bg04/n/mat1.mat",
   L"data/backGround/bg04/n/mat2.mat",
   L"data/backGround/bg04/n/mat3.mat",
   L"data/backGround/bg04/n/mat4.mat",
   L"data/backGround/bg04/n/mat7.mat",
   L"data/backGround/bg04/n/RN03.mat",
   L"data/backGround/bg04/n/A.mat",
   L"data/backGround/bg04//05 - Default.mat",
   L"data/backGround/bg04//mat1.mat",
   L"data/backGround/bg04//mat2.mat",
   L"data/backGround/bg04//mat3.mat",
   L"data/backGround/bg04//mat6.mat",
   L"data/backGround/bg04//RNp[c01.mat",
   L"data/backGround/bg04//ǎe.mat",
   L"data/backGround/bg04//.mat",
   L"data/backGround/bg04//A.mat",
   L"data/backGround/bg04//_Њ01.mat",
   L"data/backGround/bg04/5.dds",
   L"data/backGround/bg04/eNX`a.dds",
   L"data/backGround/bg04/n.dds",
   L"data/backGround/bg04/k/A.mat",
   L"data/backGround/bg04/.dds",
   L"data/backGround/bg04/Rŉ01.dds",
   L"data/backGround/bg04/R/mat2.mat",
   L"data/backGround/bg04/RE/mat2.mat",
   L"data/backGround/bg04/RE/mat3.mat",
   L"data/backGround/bg04/RE/mat7.mat",
   L"data/backGround/bg04/RE/n.mat",
   L"data/backGround/bg04/RE/A.mat",
   L"data/backGround/bg04/R/mat2.mat",
   L"data/backGround/bg04/R/mat3.mat",
   L"data/backGround/bg04/R/mat7.mat",
   L"data/backGround/bg04/R/A.mat",
   L"data/backGround/bg04/肷/mat3.mat",
   L"data/backGround/bg04/肷/A.mat",
   L"data/backGround/bg04/E/mat5.mat",
   L"data/backGround/bg04/E/mat6.mat",
   L"data/backGround/bg04/E/mat7.mat",
   L"data/backGround/bg04/E/A.mat",
   L"data/backGround/bg04//mat8.mat",
   L"data/backGround/bg04//A.mat",
   L"data/backGround/bg04/U/mat1.mat",
   L"data/backGround/bg04/U/mat3.mat",
   L"data/backGround/bg04/U/A.mat",
   L"data/backGround/bg04/U/A.mat",
   L"data/backGround/bg04/U/A.mat",
   L"data/backGround/bg04/01.dds",
   L"data/backGround/bg04/j/A.mat",
   L"data/backGround/bg04/tA.dds",
   L"data/backGround/bg04/tA.dds",
   L"data/backGround/bg04/tAO.dds",
   L"data/backGround/bg04/tϏ01.dds",
   L"data/backGround/bg04/tϏ02.dds",
   L"data/backGround/bg04/tϏ03.dds",
   L"data/backGround/bg04/tϏc01.dds",
   L"data/backGround/bg04/ΑK/A.mat",
   L"data/backGround/bg04/ǂ/mat3.mat",
   L"data/backGround/bg04/ǂ/mat5.mat",
   L"data/backGround/bg04/ǂ/mat6.mat",
   L"data/backGround/bg04/ǂ/.mat",
   L"data/backGround/bg04/ǂ/A.mat",
   L"data/backGround/bg04/Ki/mat3.mat",
   L"data/backGround/bg04/Ki/A.mat",
   L"data/backGround/bg05/000C/mat3.mat",
   L"data/backGround/bg05/000~/mat3.mat",
   L"data/backGround/bg05/000~/mat3.mat",
   L"data/backGround/bg05/000x_/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000{/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000艜/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000/mat5.mat",
   L"data/backGround/bg05/000/mat3.mat",
   L"data/backGround/bg05/000/mat5.mat",
   L"data/backGround/bg05/000e/mat3.mat",
   L"data/backGround/bg05/000e/mat3.mat",
   L"data/backGround/bg05/000e/mat3.mat",
   L"data/backGround/bg05/000e/mat3.mat",
   L"data/backGround/bg05/000/mat2.mat",
   L"data/backGround/bg05/000qubN/mat3.mat",
   L"data/backGround/bg05/000/.mat",
   L"data/backGround/bg05/000i`/07 - Default.mat",
   L"data/backGround/bg05/000蒌C/mat3.mat",
   L"data/backGround/bg05/000/mat4.mat",
   L"data/backGround/bg05/010/mat1.mat",
   L"data/backGround/bg05/011/mat1.mat",
   L"data/backGround/bg05/012/mat1.mat",
   L"data/backGround/bg05/013/mat1.mat",
   L"data/backGround/bg05/014/mat1.mat",
   L"data/backGround/bg05/015/mat1.mat",
   L"data/backGround/bg05/016/mat1.mat",
   L"data/backGround/bg05/017/mat1.mat",
   L"data/backGround/bg05/018/mat1.mat",
   L"data/backGround/bg05/019/mat1.mat",
   L"data/backGround/bg05/020/mat1.mat",
   L"data/backGround/bg05/021/mat1.mat",
   L"data/backGround/bg05/022/mat1.mat",
   L"data/backGround/bg05/023/mat1.mat",
   L"data/backGround/bg05/024/mat1.mat",
   L"data/backGround/bg05/025/mat1.mat",
   L"data/backGround/bg05/026/mat1.mat",
   L"data/backGround/bg05/027/mat1.mat",
   L"data/backGround/bg05/028/mat1.mat",
   L"data/backGround/bg05/029/mat1.mat",
   L"data/backGround/bg05/030/mat1.mat",
   L"data/backGround/bg05/031/mat1.mat",
   L"data/backGround/bg05/032/mat1.mat",
   L"data/backGround/bg05/033/mat1.mat",
   L"data/backGround/bg05/050/mat1.mat",
   L"data/backGround/bg05/bg05.msh",
   L"data/backGround/bg05/bg05_a.msh",
   L"data/backGround/bg05/dragon.dds",
   L"data/backGround/bg05/kazari_00/mat4.mat",
   L"data/backGround/bg05/kazari_01/mat4.mat",
   L"data/backGround/bg05/kazari_02/mat4.mat",
   L"data/backGround/bg05/kazari_03/mat4.mat",
   L"data/backGround/bg05/kazari_04/mat4.mat",
   L"data/backGround/bg05/kazari_05/mat4.mat",
   L"data/backGround/bg05/kazari_06/mat4.mat",
   L"data/backGround/bg05/kazari_07/mat4.mat",
   L"data/backGround/bg05/kazari_08/mat4.mat",
   L"data/backGround/bg05/kazari_09/mat4.mat",
   L"data/backGround/bg05/kazari_10/mat4.mat",
   L"data/backGround/bg05/kazari_11/mat4.mat",
   L"data/backGround/bg05/kazari_12/mat4.mat",
   L"data/backGround/bg05/kazari_13/mat4.mat",
   L"data/backGround/bg05/kazari_14/mat4.mat",
   L"data/backGround/bg05/kazari_15/mat4.mat",
   L"data/backGround/bg05/kazari_16/mat4.mat",
   L"data/backGround/bg05/kazari_17/mat4.mat",
   L"data/backGround/bg05/kazari_18/mat4.mat",
   L"data/backGround/bg05/kazari_19/mat4.mat",
   L"data/backGround/bg05/kazari_20/mat4.mat",
   L"data/backGround/bg05/kazari_21/mat4.mat",
   L"data/backGround/bg05/kazari_22/mat4.mat",
   L"data/backGround/bg05/kazari_23/mat4.mat",
   L"data/backGround/bg05/kazari_24/mat4.mat",
   L"data/backGround/bg05/kazari_25/mat4.mat",
   L"data/backGround/bg05/kiri.msh",
   L"data/backGround/bg05/mobl.dds",
   L"data/backGround/bg05/plane01/01 - Default.mat",
   L"data/backGround/bg05/plane02/01 - Default.mat",
   L"data/backGround/bg05/plane03/01 - Default.mat",
   L"data/backGround/bg05/plane04/01 - Default.mat",
   L"data/backGround/bg05/plane05/01 - Default.mat",
   L"data/backGround/bg05/plane06/01 - Default.mat",
   L"data/backGround/bg05/C/06 - Default.mat",
   L"data/backGround/bg05/C/mat1.mat",
   L"data/backGround/bg05/C/mat3.mat",
   L"data/backGround/bg05/lui/mat1.mat",
   L"data/backGround/bg05/luiQ/mat1.mat",
   L"data/backGround/bg05/luőO/mat1.mat",
   L"data/backGround/bg05/luőO2/mat1.mat",
   L"data/backGround/bg05/luŉ/mat1.mat",
   L"data/backGround/bg05/~/06 - Default.mat",
   L"data/backGround/bg05/~/mat1.mat",
   L"data/backGround/bg05/~/mat3.mat",
   L"data/backGround/bg05/~/mat1.mat",
   L"data/backGround/bg05/~/mat3.mat",
   L"data/backGround/bg05//06 - Default.mat",
   L"data/backGround/bg05/x_/mat1.mat",
   L"data/backGround/bg05/x_/mat3.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05/{/mat1.mat",
   L"data/backGround/bg05/{/mat3.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05/艜/mat1.mat",
   L"data/backGround/bg05/艜/mat3.mat",
   L"data/backGround/bg05//06 - Default.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05//06 - Default.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05//mat5.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat3.mat",
   L"data/backGround/bg05//06 - Default.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat5.mat",
   L"data/backGround/bg05/e/06 - Default.mat",
   L"data/backGround/bg05/e/mat1.mat",
   L"data/backGround/bg05/e/mat3.mat",
   L"data/backGround/bg05/e/mat1.mat",
   L"data/backGround/bg05/e/mat3.mat",
   L"data/backGround/bg05/e/mat1.mat",
   L"data/backGround/bg05/e/mat3.mat",
   L"data/backGround/bg05/e/mat1.mat",
   L"data/backGround/bg05/e/mat3.mat",
   L"data/backGround/bg05//06 - Default.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05//mat2.mat",
   L"data/backGround/bg05/qubN/mat1.mat",
   L"data/backGround/bg05/qubN/mat3.mat",
   L"data/backGround/bg05/qubN01/mat1.mat",
   L"data/backGround/bg05/_qn`n01.dds",
   L"data/backGround/bg05/_qn`C.dds",
   L"data/backGround/bg05/_qn`.dds",
   L"data/backGround/bg05/_qi.dds",
   L"data/backGround/bg05/_yoru.dds",
   L"data/backGround/bg05/i`/07 - Default.mat",
   L"data/backGround/bg05/i`/14 - Default.mat",
   L"data/backGround/bg05/Ki/06 - Default.mat",
   L"data/backGround/bg05/Ki_q/mat1.mat",
   L"data/backGround/bg05//mat1.mat",
   L"data/backGround/bg05/.dds",
   L"data/backGround/bg05/蒌C/mat1.mat",
   L"data/backGround/bg05/蒌C/mat3.mat",
   L"data/backGround/bg05//mat4.mat",
   L"data/backGround/bg06/000/mat1.mat",
   L"data/backGround/bg06/000/mat3.mat",
   L"data/backGround/bg06/000/12 - Default.mat",
   L"data/backGround/bg06/000/21 - Default.mat",
   L"data/backGround/bg06/000/mat1.mat",
   L"data/backGround/bg06/00001/12 - Default.mat",
   L"data/backGround/bg06/000/.mat",
   L"data/backGround/bg06/000/04 - Default.mat",
   L"data/backGround/bg06/000/12 - Default.mat",
   L"data/backGround/bg06/001/mat2.mat",
   L"data/backGround/bg06/002/mat2.mat",
   L"data/backGround/bg06/003/mat2.mat",
   L"data/backGround/bg06/050flower/mat4.mat",
   L"data/backGround/bg06/bg06.msh",
   L"data/backGround/bg06/bg06_a.msh",
   L"data/backGround/bg06/flower/mat4.mat",
   L"data/backGround/bg06/light.msh",
   L"data/backGround/bg06/plane01/01 - Default.mat",
   L"data/backGround/bg06/plane01/21 - Default.mat",
   L"data/backGround/bg06/plane02/01 - Default.mat",
   L"data/backGround/bg06/plane03/01 - Default.mat",
   L"data/backGround/bg06/plane04/01 - Default.mat",
   L"data/backGround/bg06/plane05/01 - Default.mat",
   L"data/backGround/bg06/plane06/01 - Default.mat",
   L"data/backGround/bg06/.dds",
   L"data/backGround/bg06//21 - Default.mat",
   L"data/backGround/bg06//mat3.mat",
   L"data/backGround/bg06//21 - Default.mat",
   L"data/backGround/bg06/01/mat3.mat",
   L"data/backGround/bg06/zsXe[W08.dds",
   L"data/backGround/bg06/zsXe[W.dds",
   L"data/backGround/bg06/zsXe[W.dds",
   L"data/backGround/bg06/zsXe[W.dds",
   L"data/backGround/bg06//mat3.mat",
   L"data/backGround/bg06/@.dds",
   L"data/backGround/bg06//mat1.mat",
   L"data/backGround/bg07/000/mat2.mat",
   L"data/backGround/bg07/000/mat3.mat",
   L"data/backGround/bg07/000/.mat",
   L"data/backGround/bg07/001R/R.mat",
   L"data/backGround/bg07/002/RO.mat",
   L"data/backGround/bg07/003RO/RO.mat",
   L"data/backGround/bg07/bg07.msh",
   L"data/backGround/bg07/bg_a.msh",
   L"data/backGround/bg07/mob/mob_taki/taki0001.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0002.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0003.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0004.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0005.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0006.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0007.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0008.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0009.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0010.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0011.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0012.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0013.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0014.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0015.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0016.dds",
   L"data/backGround/bg07/mob/mob_taki/taki0017.dds",
   L"data/backGround/bg07/obj1/mat3.mat",
   L"data/backGround/bg07/obj10/mat3.mat",
   L"data/backGround/bg07/obj11/mat3.mat",
   L"data/backGround/bg07/obj12/mat3.mat",
   L"data/backGround/bg07/obj13/mat3.mat",
   L"data/backGround/bg07/obj14/mat3.mat",
   L"data/backGround/bg07/obj15/mat3.mat",
   L"data/backGround/bg07/obj16/mat3.mat",
   L"data/backGround/bg07/obj17/mat3.mat",
   L"data/backGround/bg07/obj18/mat3.mat",
   L"data/backGround/bg07/obj19/mat3.mat",
   L"data/backGround/bg07/obj2/mat3.mat",
   L"data/backGround/bg07/obj20/mat3.mat",
   L"data/backGround/bg07/obj21/mat3.mat",
   L"data/backGround/bg07/obj22/mat3.mat",
   L"data/backGround/bg07/obj23/mat3.mat",
   L"data/backGround/bg07/obj24/mat3.mat",
   L"data/backGround/bg07/obj25/mat3.mat",
   L"data/backGround/bg07/obj26/mat3.mat",
   L"data/backGround/bg07/obj27/mat3.mat",
   L"data/backGround/bg07/obj28/mat3.mat",
   L"data/backGround/bg07/obj29/mat3.mat",
   L"data/backGround/bg07/obj3/mat3.mat",
   L"data/backGround/bg07/obj30/mat3.mat",
   L"data/backGround/bg07/obj31/mat3.mat",
   L"data/backGround/bg07/obj32/mat3.mat",
   L"data/backGround/bg07/obj33/mat3.mat",
   L"data/backGround/bg07/obj34/mat3.mat",
   L"data/backGround/bg07/obj35/mat3.mat",
   L"data/backGround/bg07/obj36/mat3.mat",
   L"data/backGround/bg07/obj37/mat3.mat",
   L"data/backGround/bg07/obj38/mat3.mat",
   L"data/backGround/bg07/obj39/mat3.mat",
   L"data/backGround/bg07/obj4/mat3.mat",
   L"data/backGround/bg07/obj40/mat3.mat",
   L"data/backGround/bg07/obj41/mat3.mat",
   L"data/backGround/bg07/obj42/mat3.mat",
   L"data/backGround/bg07/obj43/mat3.mat",
   L"data/backGround/bg07/obj5/mat3.mat",
   L"data/backGround/bg07/obj6/mat3.mat",
   L"data/backGround/bg07/obj7/mat3.mat",
   L"data/backGround/bg07/obj8/mat3.mat",
   L"data/backGround/bg07/obj9/mat3.mat",
   L"data/backGround/bg07/plane01/01 - Default.mat",
   L"data/backGround/bg07/plane02/01 - Default.mat",
   L"data/backGround/bg07/plane03/01 - Default.mat",
   L"data/backGround/bg07/plane04/01 - Default.mat",
   L"data/backGround/bg07/plane05/01 - Default.mat",
   L"data/backGround/bg07/taki.msh",
   L"data/backGround/bg07/ɂƂXe[Wshadow.dds",
   L"data/backGround/bg07/ɂƂXe[WIuWF.dds",
   L"data/backGround/bg07/pCv/04 - Default.mat",
   L"data/backGround/bg07/pCv/mat1.mat",
   L"data/backGround/bg07/pCv/[va.mat",
   L"data/backGround/bg07/C/04 - Default.mat",
   L"data/backGround/bg07/C/mat1.mat",
   L"data/backGround/bg07/C/mat2.mat",
   L"data/backGround/bg07/C1/04 - Default.mat",
   L"data/backGround/bg07/.dds",
   L"data/backGround/bg07//03 - Default.mat",
   L"data/backGround/bg07/X.dds",
   L"data/backGround/bg07//03 - Default.mat",
   L"data/backGround/bg07//mat4.mat",
   L"data/backGround/bg07//04 - Default.mat",
   L"data/backGround/bg07//mat1.mat",
   L"data/backGround/bg07//mat2.mat",
   L"data/backGround/bg07/t/mat3.mat",
   L"data/backGround/bg07/t/ؗtϕ\.mat",
   L"data/backGround/bg07/tϏ01.dds",
   L"data/backGround/bg08/bg08.msh",
   L"data/backGround/bg08/plane01/01 - Default.mat",
   L"data/backGround/bg08/plane02/01 - Default.mat",
   L"data/backGround/bg08/plane03/01 - Default.mat",
   L"data/backGround/bg08/plane04/01 - Default.mat",
   L"data/backGround/bg08/Xe[W13.dds",
   L"data/backGround/bg08/Xe[W13B.dds",
   L"data/backGround/bg08/ǉ/11 - Default.mat",
   L"data/backGround/bg08/ǉ/mat4.mat",
   L"data/backGround/bg08/ǂP/11 - Default.mat",
   L"data/backGround/bg08/ǂP/mat1.mat",
   L"data/backGround/bg08/ǂP/mat4.mat",
   L"data/backGround/bg08/ǂP01/mat1.mat",
   L"data/backGround/bg08/ǂP1/11 - Default.mat",
   L"data/backGround/bg08/ǂP1/mat4.mat",
   L"data/backGround/bg08/ǂQ/11 - Default.mat",
   L"data/backGround/bg08/ǂQ/mat1.mat",
   L"data/backGround/bg08/ǂQ/mat4.mat",
   L"data/backGround/bg08/ǂQ01/mat1.mat",
   L"data/backGround/bg08/ǂQ1/mat4.mat",
   L"data/backGround/bg08/ǂR/11 - Default.mat",
   L"data/backGround/bg08/ǂR/mat1.mat",
   L"data/backGround/bg08/ǂR/mat4.mat",
   L"data/backGround/bg08/ǂR01/mat1.mat",
   L"data/backGround/bg08/ǂR1/mat4.mat",
   L"data/backGround/bg08/V/11 - Default.mat",
   L"data/backGround/bg08/V/mat4.mat",
   L"data/backGround/bg08/P/11 - Default.mat",
   L"data/backGround/bg08/P/mat1.mat",
   L"data/backGround/bg08/P/mat4.mat",
   L"data/backGround/bg08/P01/mat1.mat",
   L"data/backGround/bg08/P1/11 - Default.mat",
   L"data/backGround/bg08/P1/mat4.mat",
   L"data/backGround/bg08/P2/11 - Default.mat",
   L"data/backGround/bg08/P2/mat4.mat",
   L"data/backGround/bg08/Q/11 - Default.mat",
   L"data/backGround/bg08/Q/mat1.mat",
   L"data/backGround/bg08/Q/mat4.mat",
   L"data/backGround/bg08/Q01/mat1.mat",
   L"data/backGround/bg08/Q1/11 - Default.mat",
   L"data/backGround/bg08/Q1/mat4.mat",
   L"data/backGround/bg08/Q2/11 - Default.mat",
   L"data/backGround/bg08/Q2/mat4.mat",
   L"data/backGround/bg08/R/11 - Default.mat",
   L"data/backGround/bg08/R/mat1.mat",
   L"data/backGround/bg08/R/mat4.mat",
   L"data/backGround/bg08/R01/mat1.mat",
   L"data/backGround/bg08/R1/11 - Default.mat",
   L"data/backGround/bg08/R1/mat4.mat",
   L"data/backGround/bg08/R2/mat4.mat",
   L"data/backGround/bg08//mat1.mat",
   L"data/backGround/bg08/b/mat1.mat",
   L"data/backGround/bg08/b/mat2.mat",
   L"data/backGround/bg08/ǃVv/11 - Default.mat",
   L"data/backGround/bg08/ǃVv/mat4.mat",
   L"data/backGround/bg09/000n/mat1.mat",
   L"data/backGround/bg09/000n/mat2.mat",
   L"data/backGround/bg09/000n/mat3.mat",
   L"data/backGround/bg09/000n/A.mat",
   L"data/backGround/bg09/000bO/C.mat",
   L"data/backGround/bg09/000/C.mat",
   L"data/backGround/bg09/000/C.mat",
   L"data/backGround/bg09/000O/C.mat",
   L"data/backGround/bg09/000O/C.mat",
   L"data/backGround/bg09/000[/C.mat",
   L"data/backGround/bg09/000/C.mat",
   L"data/backGround/bg09/000A[`/C.mat",
   L"data/backGround/bg09/000U/C.mat",
   L"data/backGround/bg09/000ΒʘH/C.mat",
   L"data/backGround/bg09/000_/C.mat",
   L"data/backGround/bg09/000_Њb/C.mat",
   L"data/backGround/bg09/000_Ж{/C.mat",
   L"data/backGround/bg09/000/.mat",
   L"data/backGround/bg09/001R/mat4.mat",
   L"data/backGround/bg09/001R/R.mat",
   L"data/backGround/bg09/002/RO.mat",
   L"data/backGround/bg09/002X/mat5.mat",
   L"data/backGround/bg09/002X/mat6.mat",
   L"data/backGround/bg09/003nʑ/mat1.mat",
   L"data/backGround/bg09/003RO/RO.mat",
   L"data/backGround/bg09/003X/mat7.mat",
   L"data/backGround/bg09/004XOE/mat9.mat",
   L"data/backGround/bg09/005XO/mat8.mat",
   L"data/backGround/bg09/006nʑ/mat1.mat",
   L"data/backGround/bg09/bg09.msh",
   L"data/backGround/bg09/bg09_a.msh",
   L"data/backGround/bg09/kusa_[.png",
   L"data/backGround/bg09/mob/hane_lily.bmp",
   L"data/backGround/bg09/obj1/mat2.mat",
   L"data/backGround/bg09/obj2/mat2.mat",
   L"data/backGround/bg09/plane01/01 - Default.mat",
   L"data/backGround/bg09/plane02/01 - Default.mat",
   L"data/backGround/bg09/plane03/01 - Default.mat",
   L"data/backGround/bg09/plane04/01 - Default.mat",
   L"data/backGround/bg09/plane05/01 - Default.mat",
   L"data/backGround/bg09/plane06/01 - Default.mat",
   L"data/backGround/bg09/plane07/01 - Default.mat",
   L"data/backGround/bg09/plane08/01 - Default.mat",
   L"data/backGround/bg09/}~]EXe[W3.dds",
   L"data/backGround/bg09/}~]EX.dds",
   L"data/backGround/bg09/}~]EXO.dds",
   L"data/backGround/bg09/}~]EXOE.dds",
   L"data/backGround/bg09/}~]EXO.dds",
   L"data/backGround/bg09/}~]EX艜.dds",
   L"data/backGround/bg09/}~]EX艜E.dds",
   L"data/backGround/bg09/}~]EX艜.dds",
   L"data/backGround/bg09/n/mat3.mat",
   L"data/backGround/bg09/n1/mat3.mat",
   L"data/backGround/bg09/nʑ/mat1.mat",
   L"data/backGround/bg09/X/mat5.mat",
   L"data/backGround/bg09/X/mat6.mat",
   L"data/backGround/bg09/_/C.mat",
   L"data/backGround/bg09/[01.dds",
   L"data/backGround/bg10/000e[u1/mat8.mat",
   L"data/backGround/bg10/000㏬/mat8.mat",
   L"data/backGround/bg10/000/04 - Default.mat",
   L"data/backGround/bg10/000_Oȓ/mat8.mat",
   L"data/backGround/bg10/000_ƉE/mat8.mat",
   L"data/backGround/bg10/000_ƉE[/mat8.mat",
   L"data/backGround/bg10/000_ƍ/mat8.mat",
   L"data/backGround/bg10/000_ԉ{/mat8.mat",
   L"data/backGround/bg10/000_ԉ/mat8.mat",
   L"data/backGround/bg10/000_/mat8.mat",
   L"data/backGround/bg10/000_O/mat8.mat",
   L"data/backGround/bg10/000_݉/mat8.mat",
   L"data/backGround/bg10/000_݉JE^[/mat8.mat",
   L"data/backGround/bg10/000_݉x_/mat8.mat",
   L"data/backGround/bg10/000_݉/mat8.mat",
   L"data/backGround/bg10/000_݉/mat8.mat",
   L"data/backGround/bg10/000_݉2f/mat8.mat",
   L"data/backGround/bg10/000_݉O1f/mat8.mat",
   L"data/backGround/bg10/000_݉O2f/mat8.mat",
   L"data/backGround/bg10/000_݉/mat8.mat",
   L"data/backGround/bg10/000_݉Ŕ/mat8.mat",
   L"data/backGround/bg10/000_/mat8.mat",
   L"data/backGround/bg10/000_O/mat8.mat",
   L"data/backGround/bg10/000_/mat8.mat",
   L"data/backGround/bg10/000_Ŕ/mat8.mat",
   L"data/backGround/bg10/000񓔂`/mat8.mat",
   L"data/backGround/bg10/000/.mat",
   L"data/backGround/bg10/0001/mat8.mat",
   L"data/backGround/bg10/0002/mat8.mat",
   L"data/backGround/bg10/0003/mat8.mat",
   L"data/backGround/bg10/0004/mat8.mat",
   L"data/backGround/bg10/0005/mat8.mat",
   L"data/backGround/bg10/0006/mat8.mat",
   L"data/backGround/bg10/0007/mat8.mat",
   L"data/backGround/bg10/0008/mat8.mat",
   L"data/backGround/bg10/000M֎q/mat8.mat",
   L"data/backGround/bg10/000MP/mat8.mat",
   L"data/backGround/bg10/000MQ/mat8.mat",
   L"data/backGround/bg10/001R/R.mat",
   L"data/backGround/bg10/002/RO.mat",
   L"data/backGround/bg10/bg10.msh",
   L"data/backGround/bg10/̂/mat6.mat",
   L"data/backGround/bg10/e[u/mat6.mat",
   L"data/backGround/bg10/Oȓ/mat6.mat",
   L"data/backGround/bg10/㏬/mat6.mat",
   L"data/backGround/bg10/Rŉ.dds",
   L"data/backGround/bg10//mat6.mat",
   L"data/backGround/bg10/֎q/mat6.mat",
   L"data/backGround/bg10/ƉE/mat6.mat",
   L"data/backGround/bg10/ƍ/mat6.mat",
   L"data/backGround/bg10/ƍ/mat6.mat",
   L"data/backGround/bg10/_yoru.dds",
   L"data/backGround/bg10/ԉ/mat6.mat",
   L"data/backGround/bg10//mat6.mat",
   L"data/backGround/bg10/݉/mat6.mat",
   L"data/backGround/bg10/݉/mat6.mat",
   L"data/backGround/bg10/݉/mat6.mat",
   L"data/backGround/bg10/Xe[Wnʖ.dds",
   L"data/backGround/bg10/Xe[W.dds",
   L"data/backGround/bg11/000n/mat3.mat",
   L"data/backGround/bg11/000/.mat",
   L"data/backGround/bg11/001R/mat4.mat",
   L"data/backGround/bg11/002X/mat5.mat",
   L"data/backGround/bg11/002X/mat6.mat",
   L"data/backGround/bg11/003X/mat7.mat",
   L"data/backGround/bg11/bg11.msh",
   L"data/backGround/bg11/bg11_a.msh",
   L"data/backGround/bg11/plane01/01 - Default.mat",
   L"data/backGround/bg11/plane02/01 - Default.mat",
   L"data/backGround/bg11/plane03/01 - Default.mat",
   L"data/backGround/bg11/plane04/01 - Default.mat",
   L"data/backGround/bg11/plane05/01 - Default.mat",
   L"data/backGround/bg11/}~]EXe[W_.dds",
   L"data/backGround/bg11/}~]EX_.dds",
   L"data/backGround/bg11/}~]EXOE_.dds",
   L"data/backGround/bg11/}~]EXO_.dds",
   L"data/backGround/bg11/}~]EX艜_.dds",
   L"data/backGround/bg11/}~]EX艜E_.dds",
   L"data/backGround/bg11/}~]EX艜_.dds",
   L"data/backGround/bg11/_}~]E.dds",
   L"data/backGround/bg12/12.dds",
   L"data/backGround/bg12/bg12.msh",
   L"data/backGround/bg12/bg12.tak",
   L"data/backGround/bg12/bg12_a.msh",
   L"data/backGround/bg12/i/i.mat",
   L"data/backGround/bg12/i.dds",
   L"data/backGround/bg12/郁C/wire_028089185.mat",
   L"data/backGround/bg12/ߌi/ߌi.mat",
   L"data/backGround/bg12/ߌi.dds",
   L"data/backGround/bg12/ߌi001/ߌi.mat",
   L"data/backGround/bg12/i/i02.mat",
   L"data/backGround/bg12/i02.dds",
   L"data/backGround/bg15/000main/19 - Default.mat",
   L"data/backGround/bg15/000e[u1/mat8.mat",
   L"data/backGround/bg15/000㏬/mat8.mat",
   L"data/backGround/bg15/000n/mat1.mat",
   L"data/backGround/bg15/000/04 - default.mat",
   L"data/backGround/bg15/000_Oȓ/mat8.mat",
   L"data/backGround/bg15/000_ƉE/mat8.mat",
   L"data/backGround/bg15/000_ƉE[/mat8.mat",
   L"data/backGround/bg15/000_ƍ/mat8.mat",
   L"data/backGround/bg15/000_ԉ{/mat8.mat",
   L"data/backGround/bg15/000_ԉ/mat8.mat",
   L"data/backGround/bg15/000_/mat8.mat",
   L"data/backGround/bg15/000_O/mat8.mat",
   L"data/backGround/bg15/000_݉/mat8.mat",
   L"data/backGround/bg15/000_݉JE^[/mat8.mat",
   L"data/backGround/bg15/000_݉x_/mat8.mat",
   L"data/backGround/bg15/000_݉/mat8.mat",
   L"data/backGround/bg15/000_݉/mat8.mat",
   L"data/backGround/bg15/000_݉2f/mat8.mat",
   L"data/backGround/bg15/000_݉O1f/mat8.mat",
   L"data/backGround/bg15/000_݉O2f/mat8.mat",
   L"data/backGround/bg15/000_݉/mat8.mat",
   L"data/backGround/bg15/000_݉Ŕ/mat8.mat",
   L"data/backGround/bg15/000_/mat8.mat",
   L"data/backGround/bg15/000_O/mat8.mat",
   L"data/backGround/bg15/000_/mat8.mat",
   L"data/backGround/bg15/000_Ŕ/mat8.mat",
   L"data/backGround/bg15/000񓔂`/mat8.mat",
   L"data/backGround/bg15/000/.mat",
   L"data/backGround/bg15/0001/mat8.mat",
   L"data/backGround/bg15/0002/mat8.mat",
   L"data/backGround/bg15/0003/mat8.mat",
   L"data/backGround/bg15/0004/mat8.mat",
   L"data/backGround/bg15/0005/mat8.mat",
   L"data/backGround/bg15/0006/mat8.mat",
   L"data/backGround/bg15/0007/mat8.mat",
   L"data/backGround/bg15/0008/mat8.mat",
   L"data/backGround/bg15/000M֎q/mat8.mat",
   L"data/backGround/bg15/000MP/mat8.mat",
   L"data/backGround/bg15/000MQ/mat8.mat",
   L"data/backGround/bg15/001R/R.mat",
   L"data/backGround/bg15/004X01/RO.mat",
   L"data/backGround/bg15/005X/RO.mat",
   L"data/backGround/bg15/006XO01/Material #521.mat",
   L"data/backGround/bg15/007XO/Material #521.mat",
   L"data/backGround/bg15/008XO2/Material #528.mat",
   L"data/backGround/bg15/bg15.msh",
   L"data/backGround/bg15/bg15.tak",
   L"data/backGround/bg15/bg15_a.msh",
   L"data/backGround/bg15/Forest01/19 - Default.mat",
   L"data/backGround/bg15/Forest01/Material #521.mat",
   L"data/backGround/bg15/Forest01/Material #528.mat",
   L"data/backGround/bg15/Forest01.msh",
   L"data/backGround/bg15/mori_O03.dds",
   L"data/backGround/bg15/mori_O04.dds",
   L"data/backGround/bg15/Rŉ01.dds",
   L"data/backGround/bg15/01.dds",
   L"data/backGround/bg15/Xe[Wn.dds",
   L"data/backGround/bg15/Xe[W{.dds",
   L"data/backGround/bg16/000n/n.mat",
   L"data/backGround/bg16/000bO/C.mat",
   L"data/backGround/bg16/000/C.mat",
   L"data/backGround/bg16/000/C.mat",
   L"data/backGround/bg16/000O/C.mat",
   L"data/backGround/bg16/000O/C.mat",
   L"data/backGround/bg16/000[/C.mat",
   L"data/backGround/bg16/000/C.mat",
   L"data/backGround/bg16/000؉E/ؑE.mat",
   L"data/backGround/bg16/000؏/ؑE.mat",
   L"data/backGround/bg16/000؏/ؑ卶.mat",
   L"data/backGround/bg16/000؍/ؑ卶.mat",
   L"data/backGround/bg16/000A[`/C.mat",
   L"data/backGround/bg16/000U/C.mat",
   L"data/backGround/bg16/000ΒʘH/C.mat",
   L"data/backGround/bg16/000_/C.mat",
   L"data/backGround/bg16/000_Њb/C.mat",
   L"data/backGround/bg16/000_Ж{/C.mat",
   L"data/backGround/bg16/000/.mat",
   L"data/backGround/bg16/000/C.mat",
   L"data/backGround/bg16/001R/R.mat",
   L"data/backGround/bg16/002/RO.mat",
   L"data/backGround/bg16/003RO/RO.mat",
   L"data/backGround/bg16/004kusa/`.mat",
   L"data/backGround/bg16/004kusa/a.mat",
   L"data/backGround/bg16/004kusa/b.mat",
   L"data/backGround/bg16/004X/X.mat",
   L"data/backGround/bg16/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/010kusa/`.mat",
   L"data/backGround/bg16/010kusa/a.mat",
   L"data/backGround/bg16/010kusa/b.mat",
   L"data/backGround/bg16/020tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/021tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/022tree/ؗtϗ.mat",
   L"data/backGround/bg16/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg16/024tree/ؗtϗ.mat",
   L"data/backGround/bg16/025tree/ؗtϕ\.mat",
   L"data/backGround/bg16/026tree/ؗtϗ.mat",
   L"data/backGround/bg16/027tree/ؗtϕ\.mat",
   L"data/backGround/bg16/030kusa/a.mat",
   L"data/backGround/bg16/030kusa/b.mat",
   L"data/backGround/bg16/031kusa/`.mat",
   L"data/backGround/bg16/031kusa/b.mat",
   L"data/backGround/bg16/032tree/ؗtϗ.mat",
   L"data/backGround/bg16/033_tree/ؗtϕ\.mat",
   L"data/backGround/bg16/034tree/ؗtϗ.mat",
   L"data/backGround/bg16/035tree/ؗtϕ\.mat",
   L"data/backGround/bg16/036tree/ؗtϗ.mat",
   L"data/backGround/bg16/037tree/ؗtϕ\.mat",
   L"data/backGround/bg16/040kusa/`.mat",
   L"data/backGround/bg16/040kusa/b.mat",
   L"data/backGround/bg16/041kusa/`.mat",
   L"data/backGround/bg16/041kusa/a.mat",
   L"data/backGround/bg16/042kusa/`.mat",
   L"data/backGround/bg16/bg01.msh",
   L"data/backGround/bg16/bgtest_5.dds",
   L"data/backGround/bg16/bgtest_n02.dds",
   L"data/backGround/bg16/kusa.png",
   L"data/backGround/bg16/kusa2.png",
   L"data/backGround/bg16/kusa3.png",
   L"data/backGround/bg16/mori_O03.dds",
   L"data/backGround/bg16/mori_O04.dds",
   L"data/backGround/bg16/obj1/ؗtϕ\.mat",
   L"data/backGround/bg16/obj1/ؗtϕ\.mat",
   L"data/backGround/bg16/obj1/ؗtϕ\.mat",
   L"data/backGround/bg16/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj1/ؗtϗ.mat",
   L"data/backGround/bg16/obj1/ؗtϗ.mat",
   L"data/backGround/bg16/obj10/ؗtϗ.mat",
   L"data/backGround/bg16/obj11/ؗtϕ\.mat",
   L"data/backGround/bg16/obj12/ؗtϕ\.mat",
   L"data/backGround/bg16/obj13/ؗtϗ.mat",
   L"data/backGround/bg16/obj14/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj15/ؗtϗ.mat",
   L"data/backGround/bg16/obj16/ؗtϕ\.mat",
   L"data/backGround/bg16/obj17/ؗtϗ.mat",
   L"data/backGround/bg16/obj18/ؗtϕ\.mat",
   L"data/backGround/bg16/obj2/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj3/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj4/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj5/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj6/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj7/ؗtϕ\a.mat",
   L"data/backGround/bg16/obj8/ؗtϕ\.mat",
   L"data/backGround/bg16/obj9/ؗtϗ.mat",
   L"data/backGround/bg16/treeA.dds",
   L"data/backGround/bg16/treeA.msh",
   L"data/backGround/bg16/treeA.tak",
   L"data/backGround/bg16/treeB.dds",
   L"data/backGround/bg16/n/n.mat",
   L"data/backGround/bg16/bO/C.mat",
   L"data/backGround/bg16//C.mat",
   L"data/backGround/bg16//C.mat",
   L"data/backGround/bg16/O/C.mat",
   L"data/backGround/bg16/O/C.mat",
   L"data/backGround/bg16/[/C.mat",
   L"data/backGround/bg16//C.mat",
   L"data/backGround/bg16/R/R.mat",
   L"data/backGround/bg16/R1/R.mat",
   L"data/backGround/bg16/RO/RO.mat",
   L"data/backGround/bg16/RO`/RO.mat",
   L"data/backGround/bg16/Rŉ01.dds",
   L"data/backGround/bg16/؉E/ؑE.mat",
   L"data/backGround/bg16/؏/ؑE.mat",
   L"data/backGround/bg16/؏/ؑ卶.mat",
   L"data/backGround/bg16/؍/ؑ卶.mat",
   L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg16/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg16/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg16/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg16/ؗt/ؗtϗ.mat",
   L"data/backGround/bg16/ؗt/ؗtϗ.mat",
   L"data/backGround/bg16/X/X.mat",
   L"data/backGround/bg16/A[`/C.mat",
   L"data/backGround/bg16/U/C.mat",
   L"data/backGround/bg16/ΒʘH/C.mat",
   L"data/backGround/bg16/ΒʘH/C.mat",
   L"data/backGround/bg16/_Њb/C.mat",
   L"data/backGround/bg16/_Ж{/C.mat",
   L"data/backGround/bg16//.mat",
   L"data/backGround/bg16/01.dds",
   L"data/backGround/bg16//`.mat",
   L"data/backGround/bg16//a.mat",
   L"data/backGround/bg16//b.mat",
   L"data/backGround/bg16/tA.dds",
   L"data/backGround/bg16/tA.dds",
   L"data/backGround/bg16/tAO.dds",
   L"data/backGround/bg16/tϏ01.dds",
   L"data/backGround/bg16/tϏ02.dds",
   L"data/backGround/bg16/tϏ03.dds",
   L"data/backGround/bg16/tϏc01.dds",
   L"data/backGround/bg16//C.mat",
   L"data/backGround/bg17/000n/n.mat",
   L"data/backGround/bg17/000n/C.mat",
   L"data/backGround/bg17/000n/.mat",
   L"data/backGround/bg17/000bO/C.mat",
   L"data/backGround/bg17/000/C.mat",
   L"data/backGround/bg17/000/C.mat",
   L"data/backGround/bg17/000O/C.mat",
   L"data/backGround/bg17/000O/C.mat",
   L"data/backGround/bg17/000[/C.mat",
   L"data/backGround/bg17/000/C.mat",
   L"data/backGround/bg17/000؉E/ؑE.mat",
   L"data/backGround/bg17/000؏/ؑE.mat",
   L"data/backGround/bg17/000؏/ؑ卶.mat",
   L"data/backGround/bg17/000؍/ؑ卶.mat",
   L"data/backGround/bg17/000A[`/C.mat",
   L"data/backGround/bg17/000U/C.mat",
   L"data/backGround/bg17/000ΒʘH/C.mat",
   L"data/backGround/bg17/000_/C.mat",
   L"data/backGround/bg17/000_Њb/C.mat",
   L"data/backGround/bg17/000_Ж{/C.mat",
   L"data/backGround/bg17/000/.mat",
   L"data/backGround/bg17/000/C.mat",
   L"data/backGround/bg17/001R/R.mat",
   L"data/backGround/bg17/002/RO.mat",
   L"data/backGround/bg17/003RO/RO.mat",
   L"data/backGround/bg17/004kusa/`.mat",
   L"data/backGround/bg17/004kusa/a.mat",
   L"data/backGround/bg17/004kusa/b.mat",
   L"data/backGround/bg17/004X/X.mat",
   L"data/backGround/bg17/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/010kusa/`.mat",
   L"data/backGround/bg17/010kusa/a.mat",
   L"data/backGround/bg17/010kusa/b.mat",
   L"data/backGround/bg17/020tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/021tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/022tree/ؗtϗ.mat",
   L"data/backGround/bg17/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg17/024tree/ؗtϗ.mat",
   L"data/backGround/bg17/025tree/ؗtϕ\.mat",
   L"data/backGround/bg17/026tree/ؗtϗ.mat",
   L"data/backGround/bg17/027tree/ؗtϕ\.mat",
   L"data/backGround/bg17/030kusa/a.mat",
   L"data/backGround/bg17/030kusa/b.mat",
   L"data/backGround/bg17/031kusa/`.mat",
   L"data/backGround/bg17/031kusa/b.mat",
   L"data/backGround/bg17/032tree/ؗtϗ.mat",
   L"data/backGround/bg17/033_tree/ؗtϕ\.mat",
   L"data/backGround/bg17/034tree/ؗtϗ.mat",
   L"data/backGround/bg17/035tree/ؗtϕ\.mat",
   L"data/backGround/bg17/036tree/ؗtϗ.mat",
   L"data/backGround/bg17/037tree/ؗtϕ\.mat",
   L"data/backGround/bg17/040kusa/`.mat",
   L"data/backGround/bg17/040kusa/b.mat",
   L"data/backGround/bg17/041kusa/`.mat",
   L"data/backGround/bg17/041kusa/a.mat",
   L"data/backGround/bg17/042kusa/`.mat",
   L"data/backGround/bg17/bg01.msh",
   L"data/backGround/bg17/bgtest_5.dds",
   L"data/backGround/bg17/bgtest_n02.dds",
   L"data/backGround/bg17/bgtest_n03.dds",
   L"data/backGround/bg17/kusa.png",
   L"data/backGround/bg17/kusa2.png",
   L"data/backGround/bg17/kusa3.png",
   L"data/backGround/bg17/kusa3Q.png",
   L"data/backGround/bg17/mori_O03.dds",
   L"data/backGround/bg17/mori_O04.dds",
   L"data/backGround/bg17/mori_O.dds",
   L"data/backGround/bg17/mori_O.png",
   L"data/backGround/bg17/obj1/ؗtϕ\.mat",
   L"data/backGround/bg17/obj1/ؗtϕ\.mat",
   L"data/backGround/bg17/obj1/ؗtϕ\.mat",
   L"data/backGround/bg17/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj1/ؗtϗ.mat",
   L"data/backGround/bg17/obj1/ؗtϗ.mat",
   L"data/backGround/bg17/obj10/ؗtϗ.mat",
   L"data/backGround/bg17/obj11/ؗtϕ\.mat",
   L"data/backGround/bg17/obj12/ؗtϕ\.mat",
   L"data/backGround/bg17/obj13/ؗtϗ.mat",
   L"data/backGround/bg17/obj14/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj15/ؗtϗ.mat",
   L"data/backGround/bg17/obj16/ؗtϕ\.mat",
   L"data/backGround/bg17/obj17/ؗtϗ.mat",
   L"data/backGround/bg17/obj18/ؗtϕ\.mat",
   L"data/backGround/bg17/obj2/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj3/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj4/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj5/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj6/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj7/ؗtϕ\a.mat",
   L"data/backGround/bg17/obj8/ؗtϕ\.mat",
   L"data/backGround/bg17/obj9/ؗtϗ.mat",
   L"data/backGround/bg17/treeA.dds",
   L"data/backGround/bg17/treeA.msh",
   L"data/backGround/bg17/treeA.tak",
   L"data/backGround/bg17/treeA.bmp",
   L"data/backGround/bg17/treeB.dds",
   L"data/backGround/bg17/treeB01.bmp",
   L"data/backGround/bg17/yakei.bmp",
   L"data/backGround/bg17//.mat",
   L"data/backGround/bg17/.png",
   L"data/backGround/bg17/n/n.mat",
   L"data/backGround/bg17/bO/C.mat",
   L"data/backGround/bg17/i/i.mat",
   L"data/backGround/bg17/01.bmp",
   L"data/backGround/bg17/01.dds",
   L"data/backGround/bg17//C.mat",
   L"data/backGround/bg17//C.mat",
   L"data/backGround/bg17/O/C.mat",
   L"data/backGround/bg17/O/C.mat",
   L"data/backGround/bg17/[/C.mat",
   L"data/backGround/bg17//C.mat",
   L"data/backGround/bg17/R/R.mat",
   L"data/backGround/bg17/R1/R.mat",
   L"data/backGround/bg17/RO/RO.mat",
   L"data/backGround/bg17/RO`/RO.mat",
   L"data/backGround/bg17/Rŉ01.dds",
   L"data/backGround/bg17/Rŉ01.png",
   L"data/backGround/bg17/؉E/ؑE.mat",
   L"data/backGround/bg17/؏/ؑE.mat",
   L"data/backGround/bg17/؏/ؑ卶.mat",
   L"data/backGround/bg17/؍/ؑ卶.mat",
   L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg17/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg17/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg17/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg17/ؗt/ؗtϗ.mat",
   L"data/backGround/bg17/ؗt/ؗtϗ.mat",
   L"data/backGround/bg17/X/X.mat",
   L"data/backGround/bg17/A[`/C.mat",
   L"data/backGround/bg17/U/C.mat",
   L"data/backGround/bg17/ΒʘH/C.mat",
   L"data/backGround/bg17/ΒʘH/C.mat",
   L"data/backGround/bg17/_Њb/C.mat",
   L"data/backGround/bg17/_Ж{/C.mat",
   L"data/backGround/bg17//.mat",
   L"data/backGround/bg17/01.dds",
   L"data/backGround/bg17//`.mat",
   L"data/backGround/bg17//a.mat",
   L"data/backGround/bg17//b.mat",
   L"data/backGround/bg17/tA.dds",
   L"data/backGround/bg17/tA.dds",
   L"data/backGround/bg17/tA.png",
   L"data/backGround/bg17/tA.dds",
   L"data/backGround/bg17/tA.dds",
   L"data/backGround/bg17/tA.png",
   L"data/backGround/bg17/tAO.dds",
   L"data/backGround/bg17/tAO.dds",
   L"data/backGround/bg17/tAO.png",
   L"data/backGround/bg17/tϏ01.dds",
   L"data/backGround/bg17/tϏ02.dds",
   L"data/backGround/bg17/tϏ02.dds",
   L"data/backGround/bg17/tϏ02.png",
   L"data/backGround/bg17/tϏ03.dds",
   L"data/backGround/bg17/tϏ.dds",
   L"data/backGround/bg17/tϏ.png",
   L"data/backGround/bg17/tϏ01.dds",
   L"data/backGround/bg17/tϏ01.png",
   L"data/backGround/bg17/tϏc01.dds",
   L"data/backGround/bg17/tϏc.dds",
   L"data/backGround/bg17/tϏc.png",
   L"data/backGround/bg17//C.mat",
   L"data/backGround/bg17/.png",
   L"data/backGround/bg19/000funea/mat1.mat",
   L"data/backGround/bg19/000funea/mat2.mat",
   L"data/backGround/bg19/000h[/mat3.mat",
   L"data/backGround/bg19/000/kumo_naka.mat",
   L"data/backGround/bg19/000/kumo_oku.mat",
   L"data/backGround/bg19/000D/mat1.mat",
   L"data/backGround/bg19/000D/mat2.mat",
   L"data/backGround/bg19/001kumo/mat4.mat",
   L"data/backGround/bg19/001kumob/mat4.mat",
   L"data/backGround/bg19/002kumo/mat4.mat",
   L"data/backGround/bg19/003kumo/mat4.mat",
   L"data/backGround/bg19/004kumo/mat5.mat",
   L"data/backGround/bg19/backup/fune_body.bmp",
   L"data/backGround/bg19/backup/fune_sora.bmp",
   L"data/backGround/bg19/backup/ho01.bmp",
   L"data/backGround/bg19/backup/kumo_A.png",
   L"data/backGround/bg19/backup/kumo_B.png",
   L"data/backGround/bg19/backup/kumo_oku.png",
   L"data/backGround/bg19/bg19.msh",
   L"data/backGround/bg19/fune.msh",
   L"data/backGround/bg19/fune.tak",
   L"data/backGround/bg19/fune_body.dds",
   L"data/backGround/bg19/fune_sora.dds",
   L"data/backGround/bg19/ho01.dds",
   L"data/backGround/bg19/kumo.msh",
   L"data/backGround/bg19/kumo_a.dds",
   L"data/backGround/bg19/kumo_b.dds",
   L"data/backGround/bg19/kumo_naka.dds",
   L"data/backGround/bg19/kumo_oku.dds",
   L"data/backGround/bg19/obj9/mat1.mat",
   L"data/backGround/bg19/obj9/mat2.mat",
   L"data/backGround/bg19/h[/mat3.mat",
   L"data/backGround/bg19//kumo_naka.mat",
   L"data/backGround/bg19//kumo_oku.mat",
   L"data/backGround/bg19/D/mat1.mat",
   L"data/backGround/bg19/D/mat2.mat",
   L"data/backGround/bg20/000n/a.mat",
   L"data/backGround/bg20/000nЂȒd/a.mat",
   L"data/backGround/bg20/000n/mat1.mat",
   L"data/backGround/bg20/000n/mat2.mat",
   L"data/backGround/bg20/000n/a.mat",
   L"data/backGround/bg20/000/a.mat",
   L"data/backGround/bg20/000k/a.mat",
   L"data/backGround/bg20/000R/mat2.mat",
   L"data/backGround/bg20/000肷/a.mat",
   L"data/backGround/bg20/000肷O/a.mat",
   L"data/backGround/bg20/000/mat1.mat",
   L"data/backGround/bg20/000U/a.mat",
   L"data/backGround/bg20/000UO/a.mat",
   L"data/backGround/bg20/000U/a.mat",
   L"data/backGround/bg20/000U/a.mat",
   L"data/backGround/bg20/000/.mat",
   L"data/backGround/bg20/000j/a.mat",
   L"data/backGround/bg20/000ΑK/a.mat",
   L"data/backGround/bg20/000ǂ/a.mat",
   L"data/backGround/bg20/000Ki/a.mat",
   L"data/backGround/bg20/001R/R.mat",
   L"data/backGround/bg20/002/RO.mat",
   L"data/backGround/bg20/005tree/ؗtϕ\.mat",
   L"data/backGround/bg20/005tree/ؗtϕ\.mat",
   L"data/backGround/bg20/005tree/ؗtϕ\.mat",
   L"data/backGround/bg20/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg20/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg20/006tree/mat3.mat",
   L"data/backGround/bg20/007tree/mat3.mat",
   L"data/backGround/bg20/008tree/mat3.mat",
   L"data/backGround/bg20/009tree/mat3.mat",
   L"data/backGround/bg20/010tree/mat3.mat",
   L"data/backGround/bg20/011tree/mat3.mat",
   L"data/backGround/bg20/012tree/mat3.mat",
   L"data/backGround/bg20/013tree/mat3.mat",
   L"data/backGround/bg20/014tree/mat3.mat",
   L"data/backGround/bg20/015tree/mat3.mat",
   L"data/backGround/bg20/016tree/mat3.mat",
   L"data/backGround/bg20/017tree/mat3.mat",
   L"data/backGround/bg20/018tree/mat3.mat",
   L"data/backGround/bg20/019tree/mat3.mat",
   L"data/backGround/bg20/020tree/mat3.mat",
   L"data/backGround/bg20/021tree/mat3.mat",
   L"data/backGround/bg20/022tree/mat3.mat",
   L"data/backGround/bg20/023tree/mat3.mat",
   L"data/backGround/bg20/024tree/mat3.mat",
   L"data/backGround/bg20/025tree/mat3.mat",
   L"data/backGround/bg20/026tree/mat3.mat",
   L"data/backGround/bg20/027tree/mat3.mat",
   L"data/backGround/bg20/028tree/mat3.mat",
   L"data/backGround/bg20/029tree/mat3.mat",
   L"data/backGround/bg20/030tree/mat3.mat",
   L"data/backGround/bg20/031tree/mat3.mat",
   L"data/backGround/bg20/032tree/mat3.mat",
   L"data/backGround/bg20/033tree/mat3.mat",
   L"data/backGround/bg20/034tree/mat3.mat",
   L"data/backGround/bg20/035tree/mat3.mat",
   L"data/backGround/bg20/036tree/mat3.mat",
   L"data/backGround/bg20/037tree/mat3.mat",
   L"data/backGround/bg20/038tree/mat3.mat",
   L"data/backGround/bg20/039tree/mat3.mat",
   L"data/backGround/bg20/040tree/mat3.mat",
   L"data/backGround/bg20/041tree/mat3.mat",
   L"data/backGround/bg20/042tree/mat3.mat",
   L"data/backGround/bg20/043tree/mat3.mat",
   L"data/backGround/bg20/044tree/ؗtϕ\a.mat",
   L"data/backGround/bg20/045tree/mat3.mat",
   L"data/backGround/bg20/046tree/mat3.mat",
   L"data/backGround/bg20/047tree/mat3.mat",
   L"data/backGround/bg20/048tree/mat3.mat",
   L"data/backGround/bg20/049tree/mat3.mat",
   L"data/backGround/bg20/050tree/mat3.mat",
   L"data/backGround/bg20/051tree/mat3.mat",
   L"data/backGround/bg20/052tree/mat3.mat",
   L"data/backGround/bg20/053tree/mat3.mat",
   L"data/backGround/bg20/054tree/mat3.mat",
   L"data/backGround/bg20/055tree/mat3.mat",
   L"data/backGround/bg20/056tree/mat3.mat",
   L"data/backGround/bg20/057tree/mat3.mat",
   L"data/backGround/bg20/058tree/mat3.mat",
   L"data/backGround/bg20/059tree/ؗtϕ\a.mat",
   L"data/backGround/bg20/060tree/mat3.mat",
   L"data/backGround/bg20/061tree/ؗtϕ\a.mat",
   L"data/backGround/bg20/062tree/mat3.mat",
   L"data/backGround/bg20/063tree/mat4.mat",
   L"data/backGround/bg20/064tree/mat4.mat",
   L"data/backGround/bg20/065tree/mat3.mat",
   L"data/backGround/bg20/066tree/mat3.mat",
   L"data/backGround/bg20/067tree/mat3.mat",
   L"data/backGround/bg20/068tree/mat3.mat",
   L"data/backGround/bg20/069tree/ؗtϕ\.mat",
   L"data/backGround/bg20/070tree/mat3.mat",
   L"data/backGround/bg20/071tree/mat3.mat",
   L"data/backGround/bg20/072tree/mat3.mat",
   L"data/backGround/bg20/073tree/mat4.mat",
   L"data/backGround/bg20/074tree/mat3.mat",
   L"data/backGround/bg20/075tree/mat3.mat",
   L"data/backGround/bg20/076tree/mat4.mat",
   L"data/backGround/bg20/077tree/mat3.mat",
   L"data/backGround/bg20/078tree/mat3.mat",
   L"data/backGround/bg20/079tree/mat3.mat",
   L"data/backGround/bg20/080tree/mat3.mat",
   L"data/backGround/bg20/081tree/ؗtϕ\.mat",
   L"data/backGround/bg20/082tree/mat3.mat",
   L"data/backGround/bg20/083tree/mat3.mat",
   L"data/backGround/bg20/084tree/mat3.mat",
   L"data/backGround/bg20/085tree/mat3.mat",
   L"data/backGround/bg20/086tree/mat3.mat",
   L"data/backGround/bg20/087tree/mat3.mat",
   L"data/backGround/bg20/088tree/mat3.mat",
   L"data/backGround/bg20/089tree/mat3.mat",
   L"data/backGround/bg20/090tree/mat3.mat",
   L"data/backGround/bg20/091tree/mat3.mat",
   L"data/backGround/bg20/092tree/mat3.mat",
   L"data/backGround/bg20/093tree/mat3.mat",
   L"data/backGround/bg20/094tree/mat3.mat",
   L"data/backGround/bg20/095tree/mat3.mat",
   L"data/backGround/bg20/096tree/mat3.mat",
   L"data/backGround/bg20/097tree/mat3.mat",
   L"data/backGround/bg20/098tree/mat3.mat",
   L"data/backGround/bg20/099tree/mat3.mat",
   L"data/backGround/bg20/100tree/mat3.mat",
   L"data/backGround/bg20/101tree/mat3.mat",
   L"data/backGround/bg20/102tree/mat3.mat",
   L"data/backGround/bg20/103tree/mat3.mat",
   L"data/backGround/bg20/104tree/mat4.mat",
   L"data/backGround/bg20/105tree/mat3.mat",
   L"data/backGround/bg20/106tree/ؗtϕ\.mat",
   L"data/backGround/bg20/107tree/mat3.mat",
   L"data/backGround/bg20/108tree/mat3.mat",
   L"data/backGround/bg20/109tree/mat3.mat",
   L"data/backGround/bg20/110tree/mat3.mat",
   L"data/backGround/bg20/111tree/mat3.mat",
   L"data/backGround/bg20/112tree/mat3.mat",
   L"data/backGround/bg20/113tree/mat3.mat",
   L"data/backGround/bg20/114tree/mat3.mat",
   L"data/backGround/bg20/115tree/mat3.mat",
   L"data/backGround/bg20/116tree/mat3.mat",
   L"data/backGround/bg20/117tree/mat3.mat",
   L"data/backGround/bg20/118tree/mat4.mat",
   L"data/backGround/bg20/119tree/mat4.mat",
   L"data/backGround/bg20/120tree/mat4.mat",
   L"data/backGround/bg20/122tree/mat4.mat",
   L"data/backGround/bg20/123tree/mat3.mat",
   L"data/backGround/bg20/124tree/mat3.mat",
   L"data/backGround/bg20/125tree/mat4.mat",
   L"data/backGround/bg20/126tree/mat4.mat",
   L"data/backGround/bg20/127tree/mat4.mat",
   L"data/backGround/bg20/128tree/mat4.mat",
   L"data/backGround/bg20/129tree/mat3.mat",
   L"data/backGround/bg20/130tree/mat3.mat",
   L"data/backGround/bg20/131tree/mat4.mat",
   L"data/backGround/bg20/132tree/mat4.mat",
   L"data/backGround/bg20/133tree/mat4.mat",
   L"data/backGround/bg20/134tree/mat4.mat",
   L"data/backGround/bg20/135tree/mat4.mat",
   L"data/backGround/bg20/136tree/mat4.mat",
   L"data/backGround/bg20/137tree/mat4.mat",
   L"data/backGround/bg20/138tree/mat4.mat",
   L"data/backGround/bg20/139tree/mat4.mat",
   L"data/backGround/bg20/bg20.msh",
   L"data/backGround/bg20/bg20_a.msh",
   L"data/backGround/bg20/bg20_front.msh",
   L"data/backGround/bg20/hata.msh",
   L"data/backGround/bg20/hataa00000.png",
   L"data/backGround/bg20/hataa00004.png",
   L"data/backGround/bg20/hataa00014.png",
   L"data/backGround/bg20/hatal_00/mat8.mat",
   L"data/backGround/bg20/hatal_01/mat8.mat",
   L"data/backGround/bg20/hatal_02/mat8.mat",
   L"data/backGround/bg20/hatal_03/mat8.mat",
   L"data/backGround/bg20/hatal_04/mat8.mat",
   L"data/backGround/bg20/hatal_05/mat8.mat",
   L"data/backGround/bg20/hatar_00/mat5.mat",
   L"data/backGround/bg20/hatar_01/mat5.mat",
   L"data/backGround/bg20/hatar_02/mat7.mat",
   L"data/backGround/bg20/hatar_03/mat5.mat",
   L"data/backGround/bg20/hatar_04/mat6.mat",
   L"data/backGround/bg20/hatar_05/mat5.mat",
   L"data/backGround/bg20/htatab00000.png",
   L"data/backGround/bg20/kusa.dds",
   L"data/backGround/bg20/kusa.png",
   L"data/backGround/bg20/mori_O03.dds",
   L"data/backGround/bg20/mori_[v.dds",
   L"data/backGround/bg20/tree.msh",
   L"data/backGround/bg20/5.dds",
   L"data/backGround/bg20/eNX`a.dds",
   L"data/backGround/bg20/n.dds",
   L"data/backGround/bg20/.dds",
   L"data/backGround/bg20/Rŉ01.dds",
   L"data/backGround/bg20/E/a.mat",
   L"data/backGround/bg20//a.mat",
   L"data/backGround/bg20/01.dds",
   L"data/backGround/bg20/ta.dds",
   L"data/backGround/bg20/ta.dds",
   L"data/backGround/bg20/taO.dds",
   L"data/backGround/bg20/tϏ01.dds",
   L"data/backGround/bg20/tϏ02.dds",
   L"data/backGround/bg20/tϏ03.dds",
   L"data/backGround/bg20/tϏc01.dds",
   L"data/backGround/bg21/000/mat1.mat",
   L"data/backGround/bg21/000/mat3.mat",
   L"data/backGround/bg21/000/12 - default.mat",
   L"data/backGround/bg21/000/04 - default.mat",
   L"data/backGround/bg21/001/mat2.mat",
   L"data/backGround/bg21/002/mat2.mat",
   L"data/backGround/bg21/003/mat2.mat",
   L"data/backGround/bg21/050flower/mat4.mat",
   L"data/backGround/bg21/bg21.msh",
   L"data/backGround/bg21/bg21_a.msh",
   L"data/backGround/bg21/light.msh",
   L"data/backGround/bg21/.dds",
   L"data/backGround/bg21/zsXe[W08.dds",
   L"data/backGround/bg21/zsXe[W.dds",
   L"data/backGround/bg21/zsXe[W.dds",
   L"data/backGround/bg21/zsXe[W.dds",
   L"data/backGround/bg21/@.dds",
   L"data/backGround/bg22/000/.mat",
   L"data/backGround/bg22/010/mat1.mat",
   L"data/backGround/bg22/011/mat1.mat",
   L"data/backGround/bg22/012/mat1.mat",
   L"data/backGround/bg22/013/mat1.mat",
   L"data/backGround/bg22/014/mat1.mat",
   L"data/backGround/bg22/015/mat1.mat",
   L"data/backGround/bg22/016/mat1.mat",
   L"data/backGround/bg22/017/mat1.mat",
   L"data/backGround/bg22/018/mat1.mat",
   L"data/backGround/bg22/019/mat1.mat",
   L"data/backGround/bg22/020/mat1.mat",
   L"data/backGround/bg22/021/mat1.mat",
   L"data/backGround/bg22/022/mat1.mat",
   L"data/backGround/bg22/023/mat1.mat",
   L"data/backGround/bg22/024/mat1.mat",
   L"data/backGround/bg22/025/mat1.mat",
   L"data/backGround/bg22/026/mat1.mat",
   L"data/backGround/bg22/027/mat1.mat",
   L"data/backGround/bg22/028/mat1.mat",
   L"data/backGround/bg22/029/mat1.mat",
   L"data/backGround/bg22/030/mat1.mat",
   L"data/backGround/bg22/031/mat1.mat",
   L"data/backGround/bg22/032/mat1.mat",
   L"data/backGround/bg22/033/mat1.mat",
   L"data/backGround/bg22/bg22.msh",
   L"data/backGround/bg22/bg22_a.msh",
   L"data/backGround/bg22/dragon.dds",
   L"data/backGround/bg22/kazari_00/mat4.mat",
   L"data/backGround/bg22/kazari_01/mat4.mat",
   L"data/backGround/bg22/kazari_02/mat4.mat",
   L"data/backGround/bg22/kazari_03/mat4.mat",
   L"data/backGround/bg22/kazari_04/mat4.mat",
   L"data/backGround/bg22/kazari_05/mat4.mat",
   L"data/backGround/bg22/kazari_06/mat4.mat",
   L"data/backGround/bg22/kazari_07/mat4.mat",
   L"data/backGround/bg22/kazari_08/mat4.mat",
   L"data/backGround/bg22/kazari_09/mat4.mat",
   L"data/backGround/bg22/kazari_10/mat4.mat",
   L"data/backGround/bg22/kazari_11/mat4.mat",
   L"data/backGround/bg22/kazari_12/mat4.mat",
   L"data/backGround/bg22/kazari_13/mat4.mat",
   L"data/backGround/bg22/kazari_14/mat4.mat",
   L"data/backGround/bg22/kazari_15/mat4.mat",
   L"data/backGround/bg22/kazari_16/mat4.mat",
   L"data/backGround/bg22/kazari_17/mat4.mat",
   L"data/backGround/bg22/kazari_18/mat4.mat",
   L"data/backGround/bg22/kazari_19/mat4.mat",
   L"data/backGround/bg22/kazari_20/mat4.mat",
   L"data/backGround/bg22/kazari_21/mat4.mat",
   L"data/backGround/bg22/kazari_22/mat4.mat",
   L"data/backGround/bg22/kazari_23/mat4.mat",
   L"data/backGround/bg22/kazari_24/mat4.mat",
   L"data/backGround/bg22/kazari_25/mat4.mat",
   L"data/backGround/bg22/kiri.msh",
   L"data/backGround/bg22/mobl.dds",
   L"data/backGround/bg22/C/mat3.mat",
   L"data/backGround/bg22/lui/mat1.mat",
   L"data/backGround/bg22/luiQ/mat1.mat",
   L"data/backGround/bg22/luőO/mat1.mat",
   L"data/backGround/bg22/luőO2/mat1.mat",
   L"data/backGround/bg22/luŉ/mat1.mat",
   L"data/backGround/bg22/~/mat3.mat",
   L"data/backGround/bg22/~/mat3.mat",
   L"data/backGround/bg22/x_/mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22/{/mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22/艜/mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22//mat5.mat",
   L"data/backGround/bg22//mat3.mat",
   L"data/backGround/bg22//mat5.mat",
   L"data/backGround/bg22/e/mat3.mat",
   L"data/backGround/bg22/e/mat3.mat",
   L"data/backGround/bg22/e/mat3.mat",
   L"data/backGround/bg22/e/mat3.mat",
   L"data/backGround/bg22//mat2.mat",
   L"data/backGround/bg22/qubN/mat3.mat",
   L"data/backGround/bg22/_qn`n01.dds",
   L"data/backGround/bg22/_qn`C.dds",
   L"data/backGround/bg22/_qn`.dds",
   L"data/backGround/bg22/_qi.dds",
   L"data/backGround/bg22/_yoru.dds",
   L"data/backGround/bg22/i`/07 - default.mat",
   L"data/backGround/bg22/.dds",
   L"data/backGround/bg22/蒌C/mat3.mat",
   L"data/backGround/bg22//mat4.mat",
   L"data/backGround/bg23/000/mat2.mat",
   L"data/backGround/bg23/010/mat1.mat",
   L"data/backGround/bg23/011/mat1.mat",
   L"data/backGround/bg23/012/mat1.mat",
   L"data/backGround/bg23/013/mat1.mat",
   L"data/backGround/bg23/014/mat1.mat",
   L"data/backGround/bg23/015/mat1.mat",
   L"data/backGround/bg23/016/mat1.mat",
   L"data/backGround/bg23/017/mat1.mat",
   L"data/backGround/bg23/018/mat1.mat",
   L"data/backGround/bg23/019/mat1.mat",
   L"data/backGround/bg23/020/mat1.mat",
   L"data/backGround/bg23/021/mat1.mat",
   L"data/backGround/bg23/022/mat1.mat",
   L"data/backGround/bg23/023/mat1.mat",
   L"data/backGround/bg23/024/mat1.mat",
   L"data/backGround/bg23/025/mat1.mat",
   L"data/backGround/bg23/026/mat1.mat",
   L"data/backGround/bg23/027/mat1.mat",
   L"data/backGround/bg23/028/mat1.mat",
   L"data/backGround/bg23/029/mat1.mat",
   L"data/backGround/bg23/030/mat1.mat",
   L"data/backGround/bg23/031/mat1.mat",
   L"data/backGround/bg23/032/mat1.mat",
   L"data/backGround/bg23/033/mat1.mat",
   L"data/backGround/bg23/bg23.msh",
   L"data/backGround/bg23/bg23_a.msh",
   L"data/backGround/bg23/kiri.msh",
   L"data/backGround/bg23/mob/mob_taki/taki0001.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0002.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0003.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0004.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0005.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0006.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0007.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0008.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0009.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0010.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0011.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0012.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0013.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0014.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0015.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0016.dds",
   L"data/backGround/bg23/mob/mob_taki/taki0017.dds",
   L"data/backGround/bg23/obj1/mat3.mat",
   L"data/backGround/bg23/obj10/mat3.mat",
   L"data/backGround/bg23/obj11/mat3.mat",
   L"data/backGround/bg23/obj12/mat3.mat",
   L"data/backGround/bg23/obj13/mat3.mat",
   L"data/backGround/bg23/obj14/mat3.mat",
   L"data/backGround/bg23/obj15/mat3.mat",
   L"data/backGround/bg23/obj16/mat3.mat",
   L"data/backGround/bg23/obj17/mat3.mat",
   L"data/backGround/bg23/obj18/mat3.mat",
   L"data/backGround/bg23/obj19/mat3.mat",
   L"data/backGround/bg23/obj2/mat3.mat",
   L"data/backGround/bg23/obj20/mat3.mat",
   L"data/backGround/bg23/obj21/mat3.mat",
   L"data/backGround/bg23/obj22/mat3.mat",
   L"data/backGround/bg23/obj23/mat3.mat",
   L"data/backGround/bg23/obj24/mat3.mat",
   L"data/backGround/bg23/obj25/mat3.mat",
   L"data/backGround/bg23/obj26/mat3.mat",
   L"data/backGround/bg23/obj27/mat3.mat",
   L"data/backGround/bg23/obj28/mat3.mat",
   L"data/backGround/bg23/obj29/mat3.mat",
   L"data/backGround/bg23/obj3/mat3.mat",
   L"data/backGround/bg23/obj30/mat3.mat",
   L"data/backGround/bg23/obj31/mat3.mat",
   L"data/backGround/bg23/obj32/mat3.mat",
   L"data/backGround/bg23/obj33/mat3.mat",
   L"data/backGround/bg23/obj34/mat3.mat",
   L"data/backGround/bg23/obj35/mat3.mat",
   L"data/backGround/bg23/obj36/mat3.mat",
   L"data/backGround/bg23/obj37/mat3.mat",
   L"data/backGround/bg23/obj38/mat3.mat",
   L"data/backGround/bg23/obj39/mat3.mat",
   L"data/backGround/bg23/obj4/mat3.mat",
   L"data/backGround/bg23/obj40/mat3.mat",
   L"data/backGround/bg23/obj41/mat3.mat",
   L"data/backGround/bg23/obj42/mat3.mat",
   L"data/backGround/bg23/obj43/mat3.mat",
   L"data/backGround/bg23/obj5/mat3.mat",
   L"data/backGround/bg23/obj6/mat3.mat",
   L"data/backGround/bg23/obj7/mat3.mat",
   L"data/backGround/bg23/obj8/mat3.mat",
   L"data/backGround/bg23/obj9/mat3.mat",
   L"data/backGround/bg23/taki.msh",
   L"data/backGround/bg23/ɂƂXe[Wshadow.dds",
   L"data/backGround/bg23/ɂƂXe[WIuWF.dds",
   L"data/backGround/bg23/pCv/mat1.mat",
   L"data/backGround/bg23/C1/04 - default.mat",
   L"data/backGround/bg23/.dds",
   L"data/backGround/bg23/X.dds",
   L"data/backGround/bg23//mat4.mat",
   L"data/backGround/bg23//mat1.mat",
   L"data/backGround/bg23/tϏ01.dds",
   L"data/backGround/bg23/.dds",
   L"data/backGround/bg24/bg24.msh",
   L"data/backGround/bg24/Xe[W13.dds",
   L"data/backGround/bg24/Xe[W13b.dds",
   L"data/backGround/bg24/ǉ/11 - default.mat",
   L"data/backGround/bg24/ǂP/11 - default.mat",
   L"data/backGround/bg24/ǂP1/11 - default.mat",
   L"data/backGround/bg24/ǂQ/11 - default.mat",
   L"data/backGround/bg24/ǂR/11 - default.mat",
   L"data/backGround/bg24/V/11 - default.mat",
   L"data/backGround/bg24/P/11 - default.mat",
   L"data/backGround/bg24/P1/11 - default.mat",
   L"data/backGround/bg24/P2/11 - default.mat",
   L"data/backGround/bg24/Q/11 - default.mat",
   L"data/backGround/bg24/Q1/11 - default.mat",
   L"data/backGround/bg24/Q2/11 - default.mat",
   L"data/backGround/bg24/R/11 - default.mat",
   L"data/backGround/bg24/R1/11 - default.mat",
   L"data/backGround/bg24/b/mat1.mat",
   L"data/backGround/bg24/ǃVv/11 - default.mat",
   L"data/backGround/bg24/.dds",
   L"data/backGround/bg25/12.dds",
   L"data/backGround/bg25/bg25.msh",
   L"data/backGround/bg25/bg25.tak",
   L"data/backGround/bg25/bg25_a.msh",
   L"data/backGround/bg25/i/i.mat",
   L"data/backGround/bg25/i.dds",
   L"data/backGround/bg25/郁C/wire_028089185.mat",
   L"data/backGround/bg25/ߌi/ߌi.mat",
   L"data/backGround/bg25/ߌi.dds",
   L"data/backGround/bg25/ߌi001/ߌi.mat",
   L"data/backGround/bg25/i/i02.mat",
   L"data/backGround/bg25/i02.dds",
   L"data/backGround/bg26/000/bamboo_c1.mat",
   L"data/backGround/bg26/001/bamboo_c1.mat",
   L"data/backGround/bg26/002/bamboo_c2.mat",
   L"data/backGround/bg26/003/bamboo_b2.mat",
   L"data/backGround/bg26/003/grass_1.mat",
   L"data/backGround/bg26/004/bamboo_b2.mat",
   L"data/backGround/bg26/004/grass_1.mat",
   L"data/backGround/bg26/005/grass_2.mat",
   L"data/backGround/bg26/006/grass_1.mat",
   L"data/backGround/bg26/006/grass_2.mat",
   L"data/backGround/bg26/007/grass_2.mat",
   L"data/backGround/bg26/008/bamboo_b2.mat",
   L"data/backGround/bg26/009/grass_1.mat",
   L"data/backGround/bg26/010/bamboo_b2.mat",
   L"data/backGround/bg26/011/grass_1.mat",
   L"data/backGround/bg26/012/bamboo_a4.mat",
   L"data/backGround/bg26/013/grass_1.mat",
   L"data/backGround/bg26/014/|01.mat",
   L"data/backGround/bg26/015/grass_1.mat",
   L"data/backGround/bg26/015/grass_2.mat",
   L"data/backGround/bg26/016/bamboo_a2.mat",
   L"data/backGround/bg26/017/grass_2.mat",
   L"data/backGround/bg26/018/bamboo_a5.mat",
   L"data/backGround/bg26/019/bamboo_a2.mat",
   L"data/backGround/bg26/020/bamboo_a3.mat",
   L"data/backGround/bg26/021/bamboo_a3.mat",
   L"data/backGround/bg26/022/bamboo_a4.mat",
   L"data/backGround/bg26/023/bamboo_a2.mat",
   L"data/backGround/bg26/023/grass_1.mat",
   L"data/backGround/bg26/024/grass_1.mat",
   L"data/backGround/bg26/024/grass_2.mat",
   L"data/backGround/bg26/025/|01.mat",
   L"data/backGround/bg26/026/grass_1.mat",
   L"data/backGround/bg26/027/bamboo_a5.mat",
   L"data/backGround/bg26/028/bamboo_a5.mat",
   L"data/backGround/bg26/029/|01.mat",
   L"data/backGround/bg26/030/bamboo_a4.mat",
   L"data/backGround/bg26/031/bamboo_a5.mat",
   L"data/backGround/bg26/032/grass_1.mat",
   L"data/backGround/bg26/033/bamboo_a4.mat",
   L"data/backGround/bg26/034/grass_1.mat",
   L"data/backGround/bg26/035/grass_1.mat",
   L"data/backGround/bg26/036/grass_2.mat",
   L"data/backGround/bg26/bamboo_a2_col.dds",
   L"data/backGround/bg26/bamboo_a3_col.dds",
   L"data/backGround/bg26/bamboo_a4_col.dds",
   L"data/backGround/bg26/bamboo_a5_col.dds",
   L"data/backGround/bg26/bamboo_b2_col.dds",
   L"data/backGround/bg26/bamboo_c1_col.dds",
   L"data/backGround/bg26/bamboo_c2_col.dds",
   L"data/backGround/bg26/bg26.msh",
   L"data/backGround/bg26/bg26_tree.msh",
   L"data/backGround/bg26/grass_1_col.dds",
   L"data/backGround/bg26/grass_2_col.dds",
   L"data/backGround/bg26/sky2.dds",
   L"data/backGround/bg26/nʂa/material__50.mat",
   L"data/backGround/bg26//sky.mat",
   L"data/backGround/bg26/|01.dds",
   L"data/backGround/bg26/|ђn02.dds",
   L"data/backGround/bg27/000n/n.mat",
   L"data/backGround/bg27/000n/C.mat",
   L"data/backGround/bg27/000n/.mat",
   L"data/backGround/bg27/000bO/C.mat",
   L"data/backGround/bg27/000/C.mat",
   L"data/backGround/bg27/000/C.mat",
   L"data/backGround/bg27/000O/C.mat",
   L"data/backGround/bg27/000O/C.mat",
   L"data/backGround/bg27/000[/C.mat",
   L"data/backGround/bg27/000/C.mat",
   L"data/backGround/bg27/000؉E/ؑE.mat",
   L"data/backGround/bg27/000؏/ؑE.mat",
   L"data/backGround/bg27/000؏/ؑ卶.mat",
   L"data/backGround/bg27/000؍/ؑ卶.mat",
   L"data/backGround/bg27/000A[`/C.mat",
   L"data/backGround/bg27/000U/C.mat",
   L"data/backGround/bg27/000ΒʘH/C.mat",
   L"data/backGround/bg27/000_/C.mat",
   L"data/backGround/bg27/000_Њb/C.mat",
   L"data/backGround/bg27/000_Ж{/C.mat",
   L"data/backGround/bg27/000/.mat",
   L"data/backGround/bg27/000/C.mat",
   L"data/backGround/bg27/001R/R.mat",
   L"data/backGround/bg27/002/RO.mat",
   L"data/backGround/bg27/003RO/RO.mat",
   L"data/backGround/bg27/004kusa/`.mat",
   L"data/backGround/bg27/004kusa/a.mat",
   L"data/backGround/bg27/004kusa/b.mat",
   L"data/backGround/bg27/004X/X.mat",
   L"data/backGround/bg27/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/010kusa/`.mat",
   L"data/backGround/bg27/010kusa/a.mat",
   L"data/backGround/bg27/010kusa/b.mat",
   L"data/backGround/bg27/020tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/021tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/022tree/ؗtϗ.mat",
   L"data/backGround/bg27/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg27/024tree/ؗtϗ.mat",
   L"data/backGround/bg27/025tree/ؗtϕ\.mat",
   L"data/backGround/bg27/026tree/ؗtϗ.mat",
   L"data/backGround/bg27/027tree/ؗtϕ\.mat",
   L"data/backGround/bg27/030kusa/a.mat",
   L"data/backGround/bg27/030kusa/b.mat",
   L"data/backGround/bg27/031kusa/`.mat",
   L"data/backGround/bg27/031kusa/b.mat",
   L"data/backGround/bg27/032tree/ؗtϗ.mat",
   L"data/backGround/bg27/033_tree/ؗtϕ\.mat",
   L"data/backGround/bg27/034tree/ؗtϗ.mat",
   L"data/backGround/bg27/035tree/ؗtϕ\.mat",
   L"data/backGround/bg27/036tree/ؗtϗ.mat",
   L"data/backGround/bg27/037tree/ؗtϕ\.mat",
   L"data/backGround/bg27/040kusa/`.mat",
   L"data/backGround/bg27/040kusa/b.mat",
   L"data/backGround/bg27/041kusa/`.mat",
   L"data/backGround/bg27/041kusa/a.mat",
   L"data/backGround/bg27/042kusa/`.mat",
   L"data/backGround/bg27/bg01.msh",
   L"data/backGround/bg27/bg27.msh",
   L"data/backGround/bg27/bg27_light.msh",
   L"data/backGround/bg27/bg27_tree.msh",
   L"data/backGround/bg27/bgtest_n03.dds",
   L"data/backGround/bg27/bgtest_ٕϐ_.dds",
   L"data/backGround/bg27/kusa.png",
   L"data/backGround/bg27/kusa2.png",
   L"data/backGround/bg27/kusa3.png",
   L"data/backGround/bg27/kusa3Q.png",
   L"data/backGround/bg27/mori_O03.dds",
   L"data/backGround/bg27/mori_O.dds",
   L"data/backGround/bg27/obj1/ؗtϕ\.mat",
   L"data/backGround/bg27/obj1/ؗtϕ\.mat",
   L"data/backGround/bg27/obj1/ؗtϕ\.mat",
   L"data/backGround/bg27/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj1/ؗtϗ.mat",
   L"data/backGround/bg27/obj1/ؗtϗ.mat",
   L"data/backGround/bg27/obj10/ؗtϗ.mat",
   L"data/backGround/bg27/obj11/ؗtϕ\.mat",
   L"data/backGround/bg27/obj12/ؗtϕ\.mat",
   L"data/backGround/bg27/obj13/ؗtϗ.mat",
   L"data/backGround/bg27/obj14/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj15/ؗtϗ.mat",
   L"data/backGround/bg27/obj16/ؗtϕ\.mat",
   L"data/backGround/bg27/obj17/ؗtϗ.mat",
   L"data/backGround/bg27/obj18/ؗtϕ\.mat",
   L"data/backGround/bg27/obj2/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj3/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj4/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj5/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj6/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj7/ؗtϕ\a.mat",
   L"data/backGround/bg27/obj8/ؗtϕ\.mat",
   L"data/backGround/bg27/obj9/ؗtϗ.mat",
   L"data/backGround/bg27/treeA.msh",
   L"data/backGround/bg27/treeA.tak",
   L"data/backGround/bg27/treea.dds",
   L"data/backGround/bg27/treeb01.dds",
   L"data/backGround/bg27/yakei.dds",
   L"data/backGround/bg27//.mat",
   L"data/backGround/bg27/.dds",
   L"data/backGround/bg27/n/n.mat",
   L"data/backGround/bg27/bO/C.mat",
   L"data/backGround/bg27/i/i.mat",
   L"data/backGround/bg27/01.dds",
   L"data/backGround/bg27//C.mat",
   L"data/backGround/bg27//C.mat",
   L"data/backGround/bg27/O/C.mat",
   L"data/backGround/bg27/O/C.mat",
   L"data/backGround/bg27/[/C.mat",
   L"data/backGround/bg27//C.mat",
   L"data/backGround/bg27/R/R.mat",
   L"data/backGround/bg27/R1/R.mat",
   L"data/backGround/bg27/RO/RO.mat",
   L"data/backGround/bg27/RO`/RO.mat",
   L"data/backGround/bg27/Rŉ01.dds",
   L"data/backGround/bg27/؉E/ؑE.mat",
   L"data/backGround/bg27/؏/ؑE.mat",
   L"data/backGround/bg27/؏/ؑ卶.mat",
   L"data/backGround/bg27/؍/ؑ卶.mat",
   L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg27/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg27/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg27/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg27/ؗt/ؗtϗ.mat",
   L"data/backGround/bg27/ؗt/ؗtϗ.mat",
   L"data/backGround/bg27/X/X.mat",
   L"data/backGround/bg27/A[`/C.mat",
   L"data/backGround/bg27/U/C.mat",
   L"data/backGround/bg27/ΒʘH/C.mat",
   L"data/backGround/bg27/ΒʘH/C.mat",
   L"data/backGround/bg27/_Њb/C.mat",
   L"data/backGround/bg27/_Ж{/C.mat",
   L"data/backGround/bg27//.mat",
   L"data/backGround/bg27//`.mat",
   L"data/backGround/bg27//a.mat",
   L"data/backGround/bg27//b.mat",
   L"data/backGround/bg27/ta.dds",
   L"data/backGround/bg27/ta.dds",
   L"data/backGround/bg27/taO.dds",
   L"data/backGround/bg27/tϏ02.dds",
   L"data/backGround/bg27/tϏ.dds",
   L"data/backGround/bg27/tϏ01.dds",
   L"data/backGround/bg27/tϏc.dds",
   L"data/backGround/bg27//C.mat",
   L"data/backGround/bg27/.dds",
   L"data/backGround/bg28/000nc/n.mat",
   L"data/backGround/bg28/000nd/n.mat",
   L"data/backGround/bg28/000nʂ`/n.mat",
   L"data/backGround/bg28/000nʂa/n.mat",
   L"data/backGround/bg28/001c/r`.mat",
   L"data/backGround/bg28/001c/ra.mat",
   L"data/backGround/bg28/001c/rb.mat",
   L"data/backGround/bg28/001c/rc.mat",
   L"data/backGround/bg28/001d/r`.mat",
   L"data/backGround/bg28/001d/ra.mat",
   L"data/backGround/bg28/001d/rb.mat",
   L"data/backGround/bg28/001d/rc.mat",
   L"data/backGround/bg28/001d/.mat",
   L"data/backGround/bg28/001`/r`.mat",
   L"data/backGround/bg28/001`/ra.mat",
   L"data/backGround/bg28/001`/rb.mat",
   L"data/backGround/bg28/001`/rc.mat",
   L"data/backGround/bg28/001a/r`.mat",
   L"data/backGround/bg28/001a/ra.mat",
   L"data/backGround/bg28/001a/rb.mat",
   L"data/backGround/bg28/001a/rc.mat",
   L"data/backGround/bg28/001a/.mat",
   L"data/backGround/bg28/001Hc/H`.mat",
   L"data/backGround/bg28/001Hd/H`.mat",
   L"data/backGround/bg28/001H`/H`.mat",
   L"data/backGround/bg28/001Ha/H`.mat",
   L"data/backGround/bg28/002Cgc/asfalt_diff1_jpg8.mat",
   L"data/backGround/bg28/002Cgd/asfalt_diff1_jpg8.mat",
   L"data/backGround/bg28/002Cg`/asfalt_diff1_jpg8.mat",
   L"data/backGround/bg28/002Cga/asfalt_diff1_jpg8.mat",
   L"data/backGround/bg28/002Cgc/asfalt_diff1_jpg7.mat",
   L"data/backGround/bg28/002Cgd/asfalt_diff1_jpg7.mat",
   L"data/backGround/bg28/002CgԂ`/asfalt_diff1_jpg7.mat",
   L"data/backGround/bg28/002CgԂa/asfalt_diff1_jpg7.mat",
   L"data/backGround/bg28/bg15.msh",
   L"data/backGround/bg28/bg28.msh",
   L"data/backGround/bg28/building.msh",
   L"data/backGround/bg28/building.tak",
   L"data/backGround/bg28/building_light.msh",
   L"data/backGround/bg28/sky/mat1.mat",
   L"data/backGround/bg28/r`.dds",
   L"data/backGround/bg28/ra.dds",
   L"data/backGround/bg28/rb.dds",
   L"data/backGround/bg28/rc.dds",
   L"data/backGround/bg28/Cg.png",
   L"data/backGround/bg28/Cg.png",
   L"data/backGround/bg28/i.dds",
   L"data/backGround/bg28/ih[/rb.mat",
   L"data/backGround/bg28/ih[/ii.mat",
   L"data/backGround/bg28/ii/ii.mat",
   L"data/backGround/bg28/in.dds",
   L"data/backGround/bg28/.png",
   L"data/backGround/bg28/X_.dds",
   L"data/backGround/bg30/bg01.msh",
   L"data/backGround/bg30/bg01.tak",
   L"data/backGround/bg30/test02.bmp",
   L"data/backGround/bg30/test02c.bmp",
   L"data/backGround/bg30/test02d.bmp",
   L"data/backGround/bg30/test02e.bmp",
   L"data/backGround/bg30/ǂ.bmp",
   L"data/backGround/bg30/O/01.mat",
   L"data/backGround/bg30/Q/01.mat",
   L"data/backGround/bg30/R/03.mat",
   L"data/backGround/bg30/S/04.mat",
   L"data/backGround/bg30/T/05.mat",
   L"data/backGround/bg31/000n/n.mat",
   L"data/backGround/bg31/000bO/C.mat",
   L"data/backGround/bg31/000/C.mat",
   L"data/backGround/bg31/000/C.mat",
   L"data/backGround/bg31/000O/C.mat",
   L"data/backGround/bg31/000O/C.mat",
   L"data/backGround/bg31/000[/C.mat",
   L"data/backGround/bg31/000/C.mat",
   L"data/backGround/bg31/000؉E/ؑE.mat",
   L"data/backGround/bg31/000؏/ؑE.mat",
   L"data/backGround/bg31/000؏/ؑ卶.mat",
   L"data/backGround/bg31/000؍/ؑ卶.mat",
   L"data/backGround/bg31/000A[`/C.mat",
   L"data/backGround/bg31/000U/C.mat",
   L"data/backGround/bg31/000ΒʘH/C.mat",
   L"data/backGround/bg31/000_/C.mat",
   L"data/backGround/bg31/000_Њb/C.mat",
   L"data/backGround/bg31/000_Ж{/C.mat",
   L"data/backGround/bg31/000/.mat",
   L"data/backGround/bg31/000/C.mat",
   L"data/backGround/bg31/001R/R.mat",
   L"data/backGround/bg31/002/RO.mat",
   L"data/backGround/bg31/003RO/RO.mat",
   L"data/backGround/bg31/004kusa/`.mat",
   L"data/backGround/bg31/004kusa/a.mat",
   L"data/backGround/bg31/004kusa/b.mat",
   L"data/backGround/bg31/004X/X.mat",
   L"data/backGround/bg31/005tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/006tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/007tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/008tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/009tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/010kusa/`.mat",
   L"data/backGround/bg31/010kusa/a.mat",
   L"data/backGround/bg31/010kusa/b.mat",
   L"data/backGround/bg31/020tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/021tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/022tree/ؗtϗ.mat",
   L"data/backGround/bg31/023tree/ؗtϕ\a.mat",
   L"data/backGround/bg31/024tree/ؗtϗ.mat",
   L"data/backGround/bg31/025tree/ؗtϕ\.mat",
   L"data/backGround/bg31/026tree/ؗtϗ.mat",
   L"data/backGround/bg31/027tree/ؗtϕ\.mat",
   L"data/backGround/bg31/030kusa/a.mat",
   L"data/backGround/bg31/030kusa/b.mat",
   L"data/backGround/bg31/031kusa/`.mat",
   L"data/backGround/bg31/031kusa/b.mat",
   L"data/backGround/bg31/032tree/ؗtϗ.mat",
   L"data/backGround/bg31/033_tree/ؗtϕ\.mat",
   L"data/backGround/bg31/034tree/ؗtϗ.mat",
   L"data/backGround/bg31/035tree/ؗtϕ\.mat",
   L"data/backGround/bg31/036tree/ؗtϗ.mat",
   L"data/backGround/bg31/037tree/ؗtϕ\.mat",
   L"data/backGround/bg31/040kusa/`.mat",
   L"data/backGround/bg31/040kusa/b.mat",
   L"data/backGround/bg31/041kusa/`.mat",
   L"data/backGround/bg31/041kusa/a.mat",
   L"data/backGround/bg31/042kusa/`.mat",
   L"data/backGround/bg31/bg01.msh",
   L"data/backGround/bg31/bgtest_5.dds",
   L"data/backGround/bg31/bgtest_n02.dds",
   L"data/backGround/bg31/kusa.png",
   L"data/backGround/bg31/kusa2.png",
   L"data/backGround/bg31/kusa3.png",
   L"data/backGround/bg31/mori_O03.dds",
   L"data/backGround/bg31/mori_O04.dds",
   L"data/backGround/bg31/obj1/ؗtϕ\.mat",
   L"data/backGround/bg31/obj1/ؗtϕ\.mat",
   L"data/backGround/bg31/obj1/ؗtϕ\.mat",
   L"data/backGround/bg31/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj1/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj1/ؗtϗ.mat",
   L"data/backGround/bg31/obj1/ؗtϗ.mat",
   L"data/backGround/bg31/obj10/ؗtϗ.mat",
   L"data/backGround/bg31/obj11/ؗtϕ\.mat",
   L"data/backGround/bg31/obj12/ؗtϕ\.mat",
   L"data/backGround/bg31/obj13/ؗtϗ.mat",
   L"data/backGround/bg31/obj14/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj15/ؗtϗ.mat",
   L"data/backGround/bg31/obj16/ؗtϕ\.mat",
   L"data/backGround/bg31/obj17/ؗtϗ.mat",
   L"data/backGround/bg31/obj18/ؗtϕ\.mat",
   L"data/backGround/bg31/obj2/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj3/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj4/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj5/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj6/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj7/ؗtϕ\a.mat",
   L"data/backGround/bg31/obj8/ؗtϕ\.mat",
   L"data/backGround/bg31/obj9/ؗtϗ.mat",
   L"data/backGround/bg31/treeA.dds",
   L"data/backGround/bg31/treeA.msh",
   L"data/backGround/bg31/treeA.tak",
   L"data/backGround/bg31/treeB.dds",
   L"data/backGround/bg31/n/n.mat",
   L"data/backGround/bg31/bO/C.mat",
   L"data/backGround/bg31//C.mat",
   L"data/backGround/bg31//C.mat",
   L"data/backGround/bg31/O/C.mat",
   L"data/backGround/bg31/O/C.mat",
   L"data/backGround/bg31/[/C.mat",
   L"data/backGround/bg31//C.mat",
   L"data/backGround/bg31/R/R.mat",
   L"data/backGround/bg31/R1/R.mat",
   L"data/backGround/bg31/RO/RO.mat",
   L"data/backGround/bg31/RO`/RO.mat",
   L"data/backGround/bg31/Rŉ01.dds",
   L"data/backGround/bg31/؉E/ؑE.mat",
   L"data/backGround/bg31/؏/ؑE.mat",
   L"data/backGround/bg31/؏/ؑ卶.mat",
   L"data/backGround/bg31/؍/ؑ卶.mat",
   L"data/backGround/bg31/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg31/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg31/ؗt/ؗtϕ\.mat",
   L"data/backGround/bg31/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg31/ؗt/ؗtϕ\a.mat",
   L"data/backGround/bg31/ؗt/ؗtϗ.mat",
   L"data/backGround/bg31/ؗt/ؗtϗ.mat",
   L"data/backGround/bg31/X/X.mat",
   L"data/backGround/bg31/A[`/C.mat",
   L"data/backGround/bg31/U/C.mat",
   L"data/backGround/bg31/ΒʘH/C.mat",
   L"data/backGround/bg31/ΒʘH/C.mat",
   L"data/backGround/bg31/_Њb/C.mat",
   L"data/backGround/bg31/_Ж{/C.mat",
   L"data/backGround/bg31//.mat",
   L"data/backGround/bg31/01.dds",
   L"data/backGround/bg31//`.mat",
   L"data/backGround/bg31//a.mat",
   L"data/backGround/bg31//b.mat",
   L"data/backGround/bg31/tA.dds",
   L"data/backGround/bg31/tA.dds",
   L"data/backGround/bg31/tAO.dds",
   L"data/backGround/bg31/tϏ01.dds",
   L"data/backGround/bg31/tϏ02.dds",
   L"data/backGround/bg31/tϏ03.dds",
   L"data/backGround/bg31/tϏc01.dds",
   L"data/backGround/bg31//C.mat",
   L"data/backGround/bg40/001/mat1.mat",
   L"data/backGround/bg40/002/mat4.mat",
   L"data/backGround/bg40/003/mat3.mat",
   L"data/backGround/bg40/004/mat2.mat",
   L"data/backGround/bg40/005n/mat7.mat",
   L"data/backGround/bg40/006R[X^[/mat6.mat",
   L"data/backGround/bg40/007ϗ/mat5.mat",
   L"data/backGround/bg40/008鉜/mat8.mat",
   L"data/backGround/bg40/009O/mat9.mat",
   L"data/backGround/bg40/010XO/mat7.mat",
   L"data/backGround/bg40/stage01.msh",
   L"data/backGround/bg40/WFbgR[X^[.png",
   L"data/backGround/bg40/鉜.png",
   L"data/backGround/bg40/O.png",
   L"data/backGround/bg40/A.png",
   L"data/backGround/bg40/B.png",
   L"data/backGround/bg40/.png",
   L"data/backGround/bg40/XO.png",
   L"data/backGround/bg40/.bmp",
   L"data/backGround/bg40/.png",
   L"data/backGround/bg40/ϗ.png",
   L"data/backGround/bg41/001/mat1.mat",
   L"data/backGround/bg41/002i/mat1.mat",
   L"data/backGround/bg41/003stone/Material__6342.mat",
   L"data/backGround/bg41/004stone/Material__6343.mat",
   L"data/backGround/bg41/006stone/mat2.mat",
   L"data/backGround/bg41/007o_rora/mat4.mat",
   L"data/backGround/bg41/stage01.msh",
   L"data/backGround/bg41/stagestone.msh",
   L"data/backGround/bg41/VqXe[W_I[.png",
   L"data/backGround/bg41/VqXe[W_.png",
   L"data/backGround/bg41/VqXe[W_Β.png",
   L"data/backGround/bg41/VqXe[W_Ώ.png",
   L"data/backGround/bg41/VqXe[W_i.bmp",
   L"data/backGround/bg42/000/Material__50.mat",
   L"data/backGround/bg42/001R/Material__49.mat",
   L"data/backGround/bg42/002ђ/Material__51.mat",
   L"data/backGround/bg42/003юO/Material__52.mat",
   L"data/backGround/bg42/004/Material__47.mat",
   L"data/backGround/bg42/004/Material__53.mat",
   L"data/backGround/bg42/005n/Material__48.mat",
   L"data/backGround/bg42/stage01.msh",
   L"data/backGround/bg42/test.mtl",
   L"data/backGround/bg42/.png",
   L"data/backGround/bg42/wiA~2.png",
   L"data/backGround/bg42/wiAn3.png",
   L"data/backGround/bg42/wiAؒ.png",
   L"data/backGround/bg42/wiA؎O.png",
   L"data/backGround/bg42/wiA.png",
   L"data/backGround/bg42/wiX.png",
   L"data/backGround/bg43/000/Material__50.mat",
   L"data/backGround/bg43/001X/Material__49.mat",
   L"data/backGround/bg43/001/mat1.mat",
   L"data/backGround/bg43/002ђ/Material__51.mat",
   L"data/backGround/bg43/002i/mat1.mat",
   L"data/backGround/bg43/003юO/Material__52.mat",
   L"data/backGround/bg43/004n/Material__48.mat",
   L"data/backGround/bg43/005/Material__47.mat",
   L"data/backGround/bg43/005/Material__53.mat",
   L"data/backGround/bg43/006Ɩ/Material__55.mat",
   L"data/backGround/bg43/007light/Material__54.mat",
   L"data/backGround/bg43/008light/Material__54.mat",
   L"data/backGround/bg43/009light/Material__54.mat",
   L"data/backGround/bg43/010light/Material__54.mat",
   L"data/backGround/bg43/011light/Material__54.mat",
   L"data/backGround/bg43/012light/Material__54.mat",
   L"data/backGround/bg43/013light/Material__54.mat",
   L"data/backGround/bg43/014light/Material__54.mat",
   L"data/backGround/bg43/015light/Material__54.mat",
   L"data/backGround/bg43/016light/Material__54.mat",
   L"data/backGround/bg43/017light/Material__54.mat",
   L"data/backGround/bg43/018light/Material__54.mat",
   L"data/backGround/bg43/019light/Material__54.mat",
   L"data/backGround/bg43/020human/Material__60.mat",
   L"data/backGround/bg43/021sai/Material__61.mat",
   L"data/backGround/bg43/022sai/Material__61.mat",
   L"data/backGround/bg43/023sai/Material__61.mat",
   L"data/backGround/bg43/030human/Material__60.mat",
   L"data/backGround/bg43/031sai/Material__61.mat",
   L"data/backGround/bg43/032sai/Material__61.mat",
   L"data/backGround/bg43/033sai/Material__61.mat",
   L"data/backGround/bg43/040human/Material__60.mat",
   L"data/backGround/bg43/041sai/Material__61.mat",
   L"data/backGround/bg43/042sai/Material__61.mat",
   L"data/backGround/bg43/043sai/Material__61.mat",
   L"data/backGround/bg43/050human/Material__60.mat",
   L"data/backGround/bg43/051sai/Material__61.mat",
   L"data/backGround/bg43/052sai/Material__61.mat",
   L"data/backGround/bg43/053sai/Material__61.mat",
   L"data/backGround/bg43/060human/Material__60.mat",
   L"data/backGround/bg43/061sai/Material__61.mat",
   L"data/backGround/bg43/062sai/Material__61.mat",
   L"data/backGround/bg43/063sai/Material__61.mat",
   L"data/backGround/bg43/light.png",
   L"data/backGround/bg43/orange/Material #5983.mat",
   L"data/backGround/bg43/orange.msh",
   L"data/backGround/bg43/sairium.msh",
   L"data/backGround/bg43/sairium1.msh",
   L"data/backGround/bg43/sairium2.msh",
   L"data/backGround/bg43/sairium3.msh",
   L"data/backGround/bg43/stage01.msh",
   L"data/backGround/bg43/TCEA.png",
   L"data/backGround/bg43/TCEA2.png",
   L"data/backGround/bg43/TCEA3.png",
   L"data/backGround/bg43/TCEA4.png",
   L"data/backGround/bg43/TCEorange.png",
   L"data/backGround/bg43/r[.png",
   L"data/backGround/bg43/.png",
   L"data/backGround/bg43/QOA.png",
   L"data/backGround/bg43/wiA~2.png",
   L"data/backGround/bg43/wiAn3.png",
   L"data/backGround/bg43/wiAؒ.png",
   L"data/backGround/bg43/wiA؎O.png",
   L"data/backGround/bg43/wiA.png",
   L"data/backGround/bg43/wiX.png",
   L"data/backGround/bg44/000/mat1.mat",
   L"data/backGround/bg44/001/mat2.mat",
   L"data/backGround/bg44/002/mat3.mat",
   L"data/backGround/bg44/003/mat4.mat",
   L"data/backGround/bg44/004/mat5.mat",
   L"data/backGround/bg44/obj8/mat3.mat",
   L"data/backGround/bg44/stage01.msh",
   L"data/backGround/bg44/i.png",
   L"data/backGround/bg44/O.png",
   L"data/backGround/bg44/O2.png",
   L"data/backGround/bg44/01.png",
   L"data/backGround/bg44/i.png",
   L"data/backGround/bg45/000main/19 - Default.mat",
   L"data/backGround/bg45/000main/mat1.mat",
   L"data/backGround/bg45/000e[u02/mat8.mat",
   L"data/backGround/bg45/000e[u1/mat8.mat",
   L"data/backGround/bg45/000㏬/mat8.mat",
   L"data/backGround/bg45/000n/mat1.mat",
   L"data/backGround/bg45/000/04 - Default.mat",
   L"data/backGround/bg45/000/mat8.mat",
   L"data/backGround/bg45/000_Oȓ/mat8.mat",
   L"data/backGround/bg45/000_ƉE/mat8.mat",
   L"data/backGround/bg45/000_ƉE[/mat8.mat",
   L"data/backGround/bg45/000_ƍ/mat8.mat",
   L"data/backGround/bg45/000_ԉ{/mat8.mat",
   L"data/backGround/bg45/000_ԉ/mat8.mat",
   L"data/backGround/bg45/000_/mat8.mat",
   L"data/backGround/bg45/000_O/mat8.mat",
   L"data/backGround/bg45/000_݉/mat8.mat",
   L"data/backGround/bg45/000_݉JE^[/mat8.mat",
   L"data/backGround/bg45/000_݉x_/mat8.mat",
   L"data/backGround/bg45/000_݉/mat8.mat",
   L"data/backGround/bg45/000_݉/mat8.mat",
   L"data/backGround/bg45/000_݉2F/mat8.mat",
   L"data/backGround/bg45/000_݉O1F/mat8.mat",
   L"data/backGround/bg45/000_݉O2F/mat8.mat",
   L"data/backGround/bg45/000_݉/mat8.mat",
   L"data/backGround/bg45/000_݉Ŕ/mat8.mat",
   L"data/backGround/bg45/000_/mat8.mat",
   L"data/backGround/bg45/000_O/mat8.mat",
   L"data/backGround/bg45/000_/mat8.mat",
   L"data/backGround/bg45/000_Ŕ/mat8.mat",
   L"data/backGround/bg45/000񓔂`/mat8.mat",
   L"data/backGround/bg45/000؉E/ؑE.mat",
   L"data/backGround/bg45/000؍/ؑ卶.mat",
   L"data/backGround/bg45/000_Ж{/C.mat",
   L"data/backGround/bg45/000/.mat",
   L"data/backGround/bg45/0001/mat8.mat",
   L"data/backGround/bg45/0002/mat8.mat",
   L"data/backGround/bg45/0003/mat8.mat",
   L"data/backGround/bg45/0004/mat8.mat",
   L"data/backGround/bg45/0005/mat8.mat",
   L"data/backGround/bg45/0006/mat8.mat",
   L"data/backGround/bg45/0007/mat8.mat",
   L"data/backGround/bg45/0008/mat8.mat",
   L"data/backGround/bg45/000M֎q/mat8.mat",
   L"data/backGround/bg45/000MP/mat8.mat",
   L"data/backGround/bg45/000MQ/mat8.mat",
   L"data/backGround/bg45/001R/R.mat",
   L"data/backGround/bg45/002main/mat1.mat",
   L"data/backGround/bg45/002/RO.mat",
   L"data/backGround/bg45/003RO/RO.mat",
   L"data/backGround/bg45/004X01/RO.mat",
   L"data/backGround/bg45/005X/RO.mat",
   L"data/backGround/bg45/006XO/Material #528.mat",
   L"data/backGround/bg45/006XO01/Material #521.mat",
   L"data/backGround/bg45/007XO/Material #521.mat",
   L"data/backGround/bg45/008XO/Material #528.mat",
   L"data/backGround/bg45/008XO2/Material #528.mat",
   L"data/backGround/bg45/bg02.msh",
   L"data/backGround/bg45/bg02.mshtest",
   L"data/backGround/bg45/bg02.tak",
   L"data/backGround/bg45/bg02_a.msh",
   L"data/backGround/bg45/BL02a_bill.png",
   L"data/backGround/bg45/BL07m_bill.png",
   L"data/backGround/bg45/Forest01/19 - Default.mat",
   L"data/backGround/bg45/Forest01/Material #521.mat",
   L"data/backGround/bg45/Forest01/Material #528.mat",
   L"data/backGround/bg45/Forest01.msh",
   L"data/backGround/bg45/ǂwin.png",
   L"data/backGround/bg45/ǂwiX01.png",
   L"data/backGround/bg45/ǂwi03.png",
   L"data/backGround/bg45/̂/mat6.mat",
   L"data/backGround/bg45/e[u/mat6.mat",
   L"data/backGround/bg45/Oȓ/mat6.mat",
   L"data/backGround/bg45/㏬/mat6.mat",
   L"data/backGround/bg45//mat6.mat",
   L"data/backGround/bg45/֎q/mat6.mat",
   L"data/backGround/bg45/ƉE/mat6.mat",
   L"data/backGround/bg45/ƍ/mat6.mat",
   L"data/backGround/bg45/ƍ/mat6.mat",
   L"data/backGround/bg45/01.png",
   L"data/backGround/bg45/ԉ/mat6.mat",
   L"data/backGround/bg45//mat6.mat",
   L"data/backGround/bg45/݉/mat6.mat",
   L"data/backGround/bg45/݉/mat6.mat",
   L"data/backGround/bg45/݉/mat6.mat",
   L"data/backGround/bg46/000/Material__50.mat",
   L"data/backGround/bg46/001X/Material__49.mat",
   L"data/backGround/bg46/002ђ/Material__51.mat",
   L"data/backGround/bg46/003юO/Material__52.mat",
   L"data/backGround/bg46/004n/Material__48.mat",
   L"data/backGround/bg46/005/Material__47.mat",
   L"data/backGround/bg46/005/Material__53.mat",
   L"data/backGround/bg46/006Ɩ/Material__55.mat",
   L"data/backGround/bg46/007light/Material__54.mat",
   L"data/backGround/bg46/008light/Material__54.mat",
   L"data/backGround/bg46/009light/Material__54.mat",
   L"data/backGround/bg46/010light/Material__54.mat",
   L"data/backGround/bg46/011light/Material__54.mat",
   L"data/backGround/bg46/012light/Material__54.mat",
   L"data/backGround/bg46/013light/Material__54.mat",
   L"data/backGround/bg46/014light/Material__54.mat",
   L"data/backGround/bg46/015light/Material__54.mat",
   L"data/backGround/bg46/016light/Material__54.mat",
   L"data/backGround/bg46/017light/Material__54.mat",
   L"data/backGround/bg46/018light/Material__54.mat",
   L"data/backGround/bg46/019light/Material__54.mat",
   L"data/backGround/bg46/020human/Material__60.mat",
   L"data/backGround/bg46/021sai/Material__61.mat",
   L"data/backGround/bg46/022sai/Material__61.mat",
   L"data/backGround/bg46/023sai/Material__61.mat",
   L"data/backGround/bg46/030human/Material__60.mat",
   L"data/backGround/bg46/031sai/Material__61.mat",
   L"data/backGround/bg46/032sai/Material__61.mat",
   L"data/backGround/bg46/033sai/Material__61.mat",
   L"data/backGround/bg46/040human/Material__60.mat",
   L"data/backGround/bg46/041sai/Material__61.mat",
   L"data/backGround/bg46/042sai/Material__61.mat",
   L"data/backGround/bg46/043sai/Material__61.mat",
   L"data/backGround/bg46/050human/Material__60.mat",
   L"data/backGround/bg46/051sai/Material__61.mat",
   L"data/backGround/bg46/052sai/Material__61.mat",
   L"data/backGround/bg46/053sai/Material__61.mat",
   L"data/backGround/bg46/060human/Material__60.mat",
   L"data/backGround/bg46/061sai/Material__61.mat",
   L"data/backGround/bg46/062sai/Material__61.mat",
   L"data/backGround/bg46/063sai/Material__61.mat",
   L"data/backGround/bg46/light.png",
   L"data/backGround/bg46/stage01.msh",
   L"data/backGround/bg46/TCEA.png",
   L"data/backGround/bg46/r[.png",
   L"data/backGround/bg46/.png",
   L"data/backGround/bg46/QOA.png",
   L"data/backGround/bg46/wiA~2.png",
   L"data/backGround/bg46/wiAn3.png",
   L"data/backGround/bg46/wiAؒ.png",
   L"data/backGround/bg46/wiA؎O.png",
   L"data/backGround/bg46/wiA.png",
   L"data/backGround/bg46/wiX.png",
   L"data/backGround/mob/Lunasa.png",
   L"data/backGround/mob/Lunasa0000.png",
   L"data/backGround/mob/Lunasa0001.png",
   L"data/backGround/mob/Lunasa0002.png",
   L"data/backGround/mob/Lunasa0003.png",
   L"data/backGround/mob/Lunasa0004.png",
   L"data/backGround/mob/Lunasa0005.png",
   L"data/backGround/mob/Lunasa0006.png",
   L"data/backGround/mob/Lunasa0007.png",
   L"data/backGround/mob/LunasaB0000.png",
   L"data/backGround/mob/LunasaB0001.png",
   L"data/backGround/mob/LunasaC0000.png",
   L"data/backGround/mob/LunasaC0001.png",
   L"data/backGround/mob/LunasaC0002.png",
   L"data/backGround/mob/LunasaC0003.png",
   L"data/backGround/mob/LunasaC0004.png",
   L"data/backGround/mob/LunasaC0005.png",
   L"data/backGround/mob/LunasaC0006.png",
   L"data/backGround/mob/LunasaC0007.png",
   L"data/backGround/mob/LunasaC0008.png",
   L"data/backGround/mob/LunasaC0009.png",
   L"data/backGround/mob/LunasaC0010.png",
   L"data/backGround/mob/LunasaC0011.png",
   L"data/backGround/mob/LunasaC0012.png",
   L"data/backGround/mob/LunasaC0013.png",
   L"data/backGround/mob/LunasaC0014.png",
   L"data/backGround/mob/LunasaC0015.png",
   L"data/backGround/mob/LunasaD0000.png",
   L"data/backGround/mob/LunasaD0001.png",
   L"data/backGround/mob/LunasaD0002.png",
   L"data/backGround/mob/LunasaD0003.png",
   L"data/backGround/mob/LunasaD0004.png",
   L"data/backGround/mob/LunasaD0005.png",
   L"data/backGround/mob/LunasaD0006.png",
   L"data/backGround/mob/LunasaD0007.png",
   L"data/backGround/mob/LunasaE0000.png",
   L"data/backGround/mob/LunasaE0001.png",
   L"data/backGround/mob/LunasaE0002.png",
   L"data/backGround/mob/LunasaE0003.png",
   L"data/backGround/mob/Lyrica.png",
   L"data/backGround/mob/Lyrica0000.png",
   L"data/backGround/mob/Lyrica0001.png",
   L"data/backGround/mob/Lyrica0002.png",
   L"data/backGround/mob/Lyrica0003.png",
   L"data/backGround/mob/LyricaB0000.png",
   L"data/backGround/mob/LyricaB0001.png",
   L"data/backGround/mob/LyricaC0000.png",
   L"data/backGround/mob/LyricaC0001.png",
   L"data/backGround/mob/LyricaC0002.png",
   L"data/backGround/mob/LyricaC0003.png",
   L"data/backGround/mob/LyricaC0004.png",
   L"data/backGround/mob/LyricaC0005.png",
   L"data/backGround/mob/LyricaC0006.png",
   L"data/backGround/mob/LyricaC0007.png",
   L"data/backGround/mob/LyricaC0008.png",
   L"data/backGround/mob/LyricaC0009.png",
   L"data/backGround/mob/LyricaC0010.png",
   L"data/backGround/mob/Merlin.png",
   L"data/backGround/mob/Merlin0000.png",
   L"data/backGround/mob/Merlin0001.png",
   L"data/backGround/mob/Merlin0002.png",
   L"data/backGround/mob/Merlin0003.png",
   L"data/backGround/mob/MerlinB0000.png",
   L"data/backGround/mob/MerlinB0001.png",
   L"data/backGround/mob/MerlinC0000.png",
   L"data/backGround/mob/MerlinC0001.png",
   L"data/backGround/mob/MerlinC0002.png",
   L"data/backGround/mob/MerlinC0003.png",
   L"data/backGround/mob/MerlinC0004.png",
   L"data/backGround/mob/MerlinC0005.png",
   L"data/backGround/mob/MerlinC0006.png",
   L"data/backGround/mob/MerlinC0007.png",
   L"data/backGround/mob/MerlinC0008.png",
   L"data/backGround/mob/MerlinC0009.png",
   L"data/backGround/mob/MerlinD0000.png",
   L"data/backGround/mob/MerlinD0001.png",
   L"data/backGround/mob/MerlinD0002.png",
   L"data/backGround/mob/MerlinD0003.png",
   L"data/backGround/mob/mob.pat",
   L"data/backGround/mob/Raiko.png",
   L"data/backGround/mob/Raiko0000.png",
   L"data/backGround/mob/Raiko0001.png",
   L"data/backGround/mob/Raiko0002.png",
   L"data/backGround/mob/Raiko0003.png",
   L"data/backGround/mob/Raiko0004.png",
   L"data/backGround/mob/Raiko0005.png",
   L"data/backGround/mob/Raiko0006.png",
   L"data/backGround/mob/Raiko0007.png",
   L"data/backGround/mob/RaikoB0000.png",
   L"data/backGround/mob/RaikoB0001.png",
   L"data/backGround/mob/RaikoC0000.png",
   L"data/backGround/mob/RaikoC0001.png",
   L"data/backGround/mob/RaikoC0002.png",
   L"data/backGround/mob/RaikoC0003.png",
   L"data/backGround/mob/RaikoC0004.png",
   L"data/backGround/mob/RaikoC0005.png",
   L"data/backGround/mob/RaikoC0006.png",
   L"data/backGround/mob/RaikoC0007.png",
   L"data/backGround/mob/RaikoC0008.png",
   L"data/backGround/mob/RaikoC0009.png",
   L"data/backGround/mob/RaikoC0010.png",
   L"data/backGround/mob/RaikoC0011.png",
   L"data/backGround/mob/RaikoC0012.png",
   L"data/backGround/mob/RaikoC0013.png",
   L"data/backGround/mob/RaikoC0014.png",
   L"data/bgm/145st01.ogg",
   L"data/bgm/145st01.sfl",
   L"data/bgm/145st01_20.ogg",
   L"data/bgm/145st02.ogg",
   L"data/bgm/145st02.sfl",
   L"data/bgm/145st02_20.ogg",
   L"data/bgm/145st03.ogg",
   L"data/bgm/145st03.sfl",
   L"data/bgm/145st03_20.ogg",
   L"data/bgm/145st04.ogg",
   L"data/bgm/145st04.sfl",
   L"data/bgm/145st04_20.ogg",
   L"data/bgm/155doremy1.ogg",
   L"data/bgm/155doremy1.sfl",
   L"data/bgm/155doremy1_20.ogg",
   L"data/bgm/155futo1.ogg",
   L"data/bgm/155futo1.sfl",
   L"data/bgm/155futo1_20.ogg",
   L"data/bgm/155hijiri1.ogg",
   L"data/bgm/155hijiri1.sfl",
   L"data/bgm/155hijiri1_20.ogg",
   L"data/bgm/155ichirin1.ogg",
   L"data/bgm/155ichirin1.sfl",
   L"data/bgm/155ichirin1_20.ogg",
   L"data/bgm/155kasen1.ogg",
   L"data/bgm/155kasen1.sfl",
   L"data/bgm/155kasen1_20.ogg",
   L"data/bgm/155koishi1.ogg",
   L"data/bgm/155koishi1.sfl",
   L"data/bgm/155koishi1_20.ogg",
   L"data/bgm/155kokoro1.ogg",
   L"data/bgm/155kokoro1.sfl",
   L"data/bgm/155kokoro1_20.ogg",
   L"data/bgm/155mamizou1.ogg",
   L"data/bgm/155mamizou1.sfl",
   L"data/bgm/155mamizou1_20.ogg",
   L"data/bgm/155marisa1.ogg",
   L"data/bgm/155marisa1.sfl",
   L"data/bgm/155marisa1_20.ogg",
   L"data/bgm/155miko1.ogg",
   L"data/bgm/155miko1.sfl",
   L"data/bgm/155miko1_20.ogg",
   L"data/bgm/155mokou1.ogg",
   L"data/bgm/155mokou1.sfl",
   L"data/bgm/155mokou1_20.ogg",
   L"data/bgm/155nitori1.ogg",
   L"data/bgm/155nitori1.sfl",
   L"data/bgm/155nitori1_20.ogg",
   L"data/bgm/155reimu1.ogg",
   L"data/bgm/155reimu1.sfl",
   L"data/bgm/155reimu1_20.ogg",
   L"data/bgm/155sinmyoumaru1.ogg",
   L"data/bgm/155sinmyoumaru1.sfl",
   L"data/bgm/155sinmyoumaru1_20.ogg",
   L"data/bgm/155tenshi1.ogg",
   L"data/bgm/155tenshi1.sfl",
   L"data/bgm/155tenshi1_20.ogg",
   L"data/bgm/155udonge1.ogg",
   L"data/bgm/155udonge1.sfl",
   L"data/bgm/155udonge1_20.ogg",
   L"data/bgm/155usami1.ogg",
   L"data/bgm/155usami1.sfl",
   L"data/bgm/155usami1_20.ogg",
   L"data/bgm/155yukari1.ogg",
   L"data/bgm/155yukari1.sfl",
   L"data/bgm/155yukari1_20.ogg",
   L"data/bgm/bgm.csv",
   L"data/bgm/bgst01.ogg",
   L"data/bgm/bgst01.sfl",
   L"data/bgm/bgst01_20.ogg",
   L"data/bgm/bgst02.ogg",
   L"data/bgm/bgst02.sfl",
   L"data/bgm/bgst02_20.ogg",
   L"data/bgm/bgst03.ogg",
   L"data/bgm/bgst03.sfl",
   L"data/bgm/bgst03_20.ogg",
   L"data/bgm/bgst04.ogg",
   L"data/bgm/bgst04.sfl",
   L"data/bgm/bgst04_20.ogg",
   L"data/bgm/bgst05.ogg",
   L"data/bgm/bgst05.sfl",
   L"data/bgm/bgst05_20.ogg",
   L"data/bgm/bgst06.ogg",
   L"data/bgm/bgst06.sfl",
   L"data/bgm/bgst06_20.ogg",
   L"data/bgm/bgst07.ogg",
   L"data/bgm/bgst07.sfl",
   L"data/bgm/bgst07_20.ogg",
   L"data/bgm/bgst08.ogg",
   L"data/bgm/bgst08.sfl",
   L"data/bgm/bgst08_20.ogg",
   L"data/bgm/bgst09.ogg",
   L"data/bgm/bgst09.sfl",
   L"data/bgm/bgst09_20.ogg",
   L"data/bgm/bgst10.ogg",
   L"data/bgm/bgst10.sfl",
   L"data/bgm/bgst10_20.ogg",
   L"data/bgm/bgst11.ogg",
   L"data/bgm/bgst11.sfl",
   L"data/bgm/bgst11_20.ogg",
   L"data/bgm/bgst12.ogg",
   L"data/bgm/bgst12.sfl",
   L"data/bgm/bgst12_20.ogg",
   L"data/bgm/bgst13.ogg",
   L"data/bgm/bgst13.sfl",
   L"data/bgm/bgst13_20.ogg",
   L"data/bgm/bgst14.ogg",
   L"data/bgm/bgst14.sfl",
   L"data/bgm/bgst14_20.ogg",
   L"data/bgm/bgst15.ogg",
   L"data/bgm/bgst15.sfl",
   L"data/bgm/bgst15_20.ogg",
   L"data/bgm/bgst16.ogg",
   L"data/bgm/bgst16.sfl",
   L"data/bgm/bgst16_20.ogg",
   L"data/bgm/bgst17.ogg",
   L"data/bgm/bgst17.sfl",
   L"data/bgm/bgst17_20.ogg",
   L"data/bgm/ending.ogg",
   L"data/bgm/ending.sfl",
   L"data/bgm/lastboss.ogg",
   L"data/bgm/lastboss.sfl",
   L"data/bgm/lastboss_20.ogg",
   L"data/bgm/midboss.ogg",
   L"data/bgm/midboss.sfl",
   L"data/bgm/midboss_20.ogg",
   L"data/bgm/staffroll0.ogg",
   L"data/bgm/staffroll1.ogg",
   L"data/bgm/staffroll2.ogg",
   L"data/bgm/story01.ogg",
   L"data/bgm/story01.sfl",
   L"data/bgm/story02.ogg",
   L"data/bgm/story02.sfl",
   L"data/bgm/story03.ogg",
   L"data/bgm/story03.sfl",
   L"data/bgm/story04.ogg",
   L"data/bgm/story04.sfl",
   L"data/bgm/story05.ogg",
   L"data/bgm/story05.sfl",
   L"data/bgm/story06.ogg",
   L"data/bgm/story06.sfl",
   L"data/bgm/story07.ogg",
   L"data/bgm/story07.sfl",
   L"data/bgm/story08.ogg",
   L"data/bgm/story08.sfl",
   L"data/bgm/story09.ogg",
   L"data/bgm/story09.sfl",
   L"data/bgm/th155op1.ogg",
   L"data/bgm/th155op1.sfl",
   L"data/bgm/th155op2.ogg",
   L"data/bgm/th155op2.sfl",
   L"data/bgm/th155op3.ogg",
   L"data/bgm/th155op3.sfl",
   L"data/bgm/th155op4.ogg",
   L"data/bgm/th155op4.sfl",
   L"data/effect/boss_charge.eft",
   L"data/effect/boss_charge2.eft",
   L"data/effect/boss_chargeBig.eft",
   L"data/effect/chara_pick_1p.eft",
   L"data/effect/chara_pick_2p.eft",
   L"data/effect/color_paper.eft",
   L"data/effect/cursor_flower_A.eft",
   L"data/effect/cursor_flower_B.eft",
   L"data/effect/dashFront.eft",
   L"data/effect/dashLine.eft",
   L"data/effect/dead_exp.eft",
   L"data/effect/dead_exp2.eft",
   L"data/effect/doremy_big_mukon.eft",
   L"data/effect/doremy_exp.eft",
   L"data/effect/doremy_sheep_exp.eft",
   L"data/effect/doremy_vacuum.eft",
   L"data/effect/fireWork.eft",
   L"data/effect/futo_catch_cyclone.eft",
   L"data/effect/futo_fireTower.eft",
   L"data/effect/futo_tornade.eft",
   L"data/effect/graze_petal.eft",
   L"data/effect/guardCrash.eft",
   L"data/effect/guard_baria.eft",
   L"data/effect/guard_cancel.eft",
   L"data/effect/hijiri_chopInpact.eft",
   L"data/effect/hijiri_chopPilar.eft",
   L"data/effect/hijiri_eye.eft",
   L"data/effect/hijiri_fist.eft",
   L"data/effect/hijiri_indr.eft",
   L"data/effect/hit_spark_front.eft",
   L"data/effect/hit_spark_high.eft",
   L"data/effect/hit_spark_low.eft",
   L"data/effect/hit_spark_mid.eft",
   L"data/effect/hit_spark_under.eft",
   L"data/effect/hit_spark_upper.eft",
   L"data/effect/hyoui_aura.eft",
   L"data/effect/hyoui_icon.eft",
   L"data/effect/ichirin_hit.eft",
   L"data/effect/ichirin_spark.eft",
   L"data/effect/ichirin_sparkFlare.eft",
   L"data/effect/ichirin_sparkFlare15.eft",
   L"data/effect/ichirin_sparkFlare20.eft",
   L"data/effect/ichirin_sparkFlare25.eft",
   L"data/effect/jyoon_coinGet.eft",
   L"data/effect/jyoon_fire_ring.eft",
   L"data/effect/jyoon_gold_typoonB.eft",
   L"data/effect/jyoon_grab_gold.eft",
   L"data/effect/jyoon_ground_poison.eft",
   L"data/effect/jyoon_kaiki_ball_main.eft",
   L"data/effect/jyoon_kaiki_ball_pre1.eft",
   L"data/effect/jyoon_kaiki_ball_pre2.eft",
   L"data/effect/jyoon_money_100.eft",
   L"data/effect/jyoon_normal_shot.eft",
   L"data/effect/jyoon_poison_gayzer.eft",
   L"data/effect/jyoon_tornade_shot.eft",
   L"data/effect/jyoon_upper_aura.eft",
   L"data/effect/kanzen_hyoui.eft",
   L"data/effect/kanzen_hyouiB.eft",
   L"data/effect/kokoro_chargeShotBack.eft",
   L"data/effect/kokoro_fire.eft",
   L"data/effect/kokoro_horizonWave.eft",
   L"data/effect/kokoro_pose0000.eft",
   L"data/effect/kokoro_pose0001.eft",
   L"data/effect/kokoro_pose0002.eft",
   L"data/effect/kokoro_pose0003.eft",
   L"data/effect/mamizou_back_fire.eft",
   L"data/effect/mamizou_smokeBurst.eft",
   L"data/effect/mamizou_smokeBurstB.eft",
   L"data/effect/mamizou_steam.eft",
   L"data/effect/marisa_aside.eft",
   L"data/effect/marisa_asideB.eft",
   L"data/effect/marisa_blazeStar.eft",
   L"data/effect/marisa_chargeExp.eft",
   L"data/effect/marisa_chargeShot.eft",
   L"data/effect/marisa_finger.eft",
   L"data/effect/marisa_layLine.eft",
   L"data/effect/marisa_pBomb.eft",
   L"data/effect/marisa_shotFire.eft",
   L"data/effect/marisa_spark.eft",
   L"data/effect/marisa_sparkPre.eft",
   L"data/effect/marisa_strtHit.eft",
   L"data/effect/miko_baria.eft",
   L"data/effect/miko_chargeSpark.eft",
   L"data/effect/miko_dragonFire.eft",
   L"data/effect/miko_dragonFireB.eft",
   L"data/effect/miko_guseflash.eft",
   L"data/effect/miko_kanzen.eft",
   L"data/effect/miko_kanzenB.eft",
   L"data/effect/miko_preRing.eft",
   L"data/effect/miko_sunRing.eft",
   L"data/effect/miko_warp.eft",
   L"data/effect/mokou_fireAura_blue.eft",
   L"data/effect/mokou_fireAura_blue2.eft",
   L"data/effect/mokou_fireAura_blue3.eft",
   L"data/effect/mokou_slash_kick.eft",
   L"data/effect/nitori_missileFire.eft",
   L"data/effect/nitori_splash.eft",
   L"data/effect/recover.eft",
   L"data/effect/reimu_box.eft",
   L"data/effect/reimu_busterExp.eft",
   L"data/effect/reimu_fallkick.eft",
   L"data/effect/reimu_occultCharge.eft",
   L"data/effect/reimu_occultSpark.eft",
   L"data/effect/round_1_long.eft",
   L"data/effect/round_2_long.eft",
   L"data/effect/round_3_long.eft",
   L"data/effect/round_4_long.eft",
   L"data/effect/round_5_long.eft",
   L"data/effect/round_draw.eft",
   L"data/effect/round_fight.eft",
   L"data/effect/round_ko.eft",
   L"data/effect/round_timeup.eft",
   L"data/effect/shion_berserk_aura.eft",
   L"data/effect/shion_boss_modeChange.eft",
   L"data/effect/shion_charge_aura.eft",
   L"data/effect/shion_charge_trail.eft",
   L"data/effect/shion_starLight.eft",
   L"data/effect/shion_vanish.eft",
   L"data/effect/spell_blossom.eft",
   L"data/effect/spell_break.eft",
   L"data/effect/spell_cut_petal.eft",
   L"data/effect/spell_use_petal_2.eft",
   L"data/effect/staff_blossum.eft",
   L"data/effect/stun_star.eft",
   L"data/effect/tenshi_climax_haarp.eft",
   L"data/effect/tenshi_eat.eft",
   L"data/effect/tenshi_haarp_field.eft",
   L"data/effect/tenshi_kaname_laser1.eft",
   L"data/effect/tenshi_lightning_occult.eft",
   L"data/effect/tenshi_peach_aura.eft",
   L"data/effect/tenshi_peach_power.eft",
   L"data/effect/Texture/Effect/auraC0000.nhtex",
   L"data/effect/Texture/Effect/auraC0001.nhtex",
   L"data/effect/Texture/Effect/aura_loop_mono0000.nhtex",
   L"data/effect/Texture/Effect/back_glow0000.nhtex",
   L"data/effect/Texture/Effect/baria0000.nhtex",
   L"data/effect/Texture/Effect/bariaMask0000.nhtex",
   L"data/effect/Texture/Effect/belt_aura0000.nhtex",
   L"data/effect/Texture/Effect/burst_aura_000.nhtex",
   L"data/effect/Texture/Effect/chargeLineMap.nhtex",
   L"data/effect/Texture/Effect/chargeParticle0000.nhtex",
   L"data/effect/Texture/Effect/char_select_cursor_000.nhtex",
   L"data/effect/Texture/Effect/commonFlash0000.nhtex",
   L"data/effect/Texture/Effect/commonFlashRing_mono0000.nhtex",
   L"data/effect/Texture/Effect/commonFlash_blue0000.nhtex",
   L"data/effect/Texture/Effect/commonFlash_eme0000.nhtex",
   L"data/effect/Texture/Effect/commonFlash_yellow0000.nhtex",
   L"data/effect/Texture/Effect/common_hitSpark0000.nhtex",
   L"data/effect/Texture/Effect/cross_flash_0000.nhtex",
   L"data/effect/Texture/Effect/dark_spark0000.nhtex",
   L"data/effect/Texture/Effect/dashLine0000.nhtex",
   L"data/effect/Texture/Effect/dash_wave0000.nhtex",
   L"data/effect/Texture/Effect/doremy_exp000.nhtex",
   L"data/effect/Texture/Effect/doremy_sheep_000.nhtex",
   L"data/effect/Texture/Effect/doremy_sheep_ball.nhtex",
   L"data/effect/Texture/Effect/doremy_vacum_000.nhtex",
   L"data/effect/Texture/Effect/expload_000.nhtex",
   L"data/effect/Texture/Effect/fadeBall0000.nhtex",
   L"data/effect/Texture/Effect/fadeBall0001.nhtex",
   L"data/effect/Texture/Effect/fadeBall0002.nhtex",
   L"data/effect/Texture/Effect/fadeBall_B0000.nhtex",
   L"data/effect/Texture/Effect/fall_fire0000.nhtex",
   L"data/effect/Texture/Effect/fire0000.nhtex",
   L"data/effect/Texture/Effect/fireAura_blue0000.nhtex",
   L"data/effect/Texture/Effect/fireChip0000.nhtex",
   L"data/effect/Texture/Effect/fireChip0001.nhtex",
   L"data/effect/Texture/Effect/fireWork0000.nhtex",
   L"data/effect/Texture/Effect/fire_ball0000.nhtex",
   L"data/effect/Texture/Effect/glass_break0000.nhtex",
   L"data/effect/Texture/Effect/glass_break0001.nhtex",
   L"data/effect/Texture/Effect/glass_break0002.nhtex",
   L"data/effect/Texture/Effect/graze_petal.nhtex",
   L"data/effect/Texture/Effect/graze_petal_b.nhtex",
   L"data/effect/Texture/Effect/gridtest_256-256.nhtex",
   L"data/effect/Texture/Effect/ground_poison.nhtex",
   L"data/effect/Texture/Effect/guard_loop0000.nhtex",
   L"data/effect/Texture/Effect/guard_ring0000.nhtex",
   L"data/effect/Texture/Effect/heaven000.nhtex",
   L"data/effect/Texture/Effect/hijiri_spellC_Pilar.nhtex",
   L"data/effect/Texture/Effect/hisou_laser.nhtex",
   L"data/effect/Texture/Effect/hitParticle0000.nhtex",
   L"data/effect/Texture/Effect/hit_spark.nhtex",
   L"data/effect/Texture/Effect/hit_spark_dir.nhtex",
   L"data/effect/Texture/Effect/horizonWave0000.nhtex",
   L"data/effect/Texture/Effect/horizonWave0001.nhtex",
   L"data/effect/Texture/Effect/hyoui_info_text.nhtex",
   L"data/effect/Texture/Effect/jyoon_fire_ring0001.nhtex",
   L"data/effect/Texture/Effect/jyoon_gold_flash000.nhtex",
   L"data/effect/Texture/Effect/jyoon_money0000.nhtex",
   L"data/effect/Texture/Effect/jyoon_money0001.nhtex",
   L"data/effect/Texture/Effect/jyoon_poison_gayzer0000.nhtex",
   L"data/effect/Texture/Effect/jyoon_tresure000.nhtex",
   L"data/effect/Texture/Effect/jyoon_upper_aura000.nhtex",
   L"data/effect/Texture/Effect/ko_call.nhtex",
   L"data/effect/Texture/Effect/kune_flash0000.nhtex",
   L"data/effect/Texture/Effect/kune_flash0001.nhtex",
   L"data/effect/Texture/Effect/laserBaseA000.nhtex",
   L"data/effect/Texture/Effect/laserBaseA001.nhtex",
   L"data/effect/Texture/Effect/lightLineRng0000.nhtex",
   L"data/effect/Texture/Effect/lightning0000.nhtex",
   L"data/effect/Texture/Effect/lightning_blue0000.nhtex",
   L"data/effect/texture/effect/lightning_map0000.nhtex",
   L"data/effect/Texture/Effect/lightning_map0001.nhtex",
   L"data/effect/Texture/Effect/light_charge0000.nhtex",
   L"data/effect/Texture/Effect/light_charge0001.nhtex",
   L"data/effect/Texture/Effect/light_charge0002.nhtex",
   L"data/effect/Texture/Effect/loop_fire0000.nhtex",
   L"data/effect/Texture/Effect/loop_hex.nhtex",
   L"data/effect/Texture/Effect/Loop_streem0000.nhtex",
   L"data/effect/Texture/Effect/loop_texture0000.nhtex",
   L"data/effect/Texture/Effect/loop_tex_tornade1.nhtex",
   L"data/effect/Texture/Effect/loop_tex_tornade2.nhtex",
   L"data/effect/Texture/Effect/mamizou_back_fire.nhtex",
   L"data/effect/Texture/Effect/marisa_laylineA.nhtex",
   L"data/effect/Texture/Effect/marisa_magicM.nhtex",
   L"data/effect/Texture/Effect/marisa_missileFire0000.nhtex",
   L"data/effect/Texture/Effect/marisa_star0000.nhtex",
   L"data/effect/Texture/Effect/marisa_star0001.nhtex",
   L"data/effect/Texture/Effect/mask_fadeBall0000.nhtex",
   L"data/effect/Texture/Effect/masterSpark0000.nhtex",
   L"data/effect/Texture/Effect/miko_spellC_Branch.nhtex",
   L"data/effect/Texture/Effect/miko_spellC_Laser0000.nhtex",
   L"data/effect/Texture/Effect/mokou_kick_fire.nhtex",
   L"data/effect/Texture/Effect/monoAuraA0000.nhtex",
   L"data/effect/Texture/Effect/monoAuraA0001.nhtex",
   L"data/effect/Texture/Effect/mukon_black_000.nhtex",
   L"data/effect/Texture/Effect/mukon_black_001.nhtex",
   L"data/effect/Texture/Effect/page_cursor000.nhtex",
   L"data/effect/Texture/Effect/particle_flower000.nhtex",
   L"data/effect/Texture/Effect/particle_flower001.nhtex",
   L"data/effect/Texture/Effect/petal_0000.nhtex",
   L"data/effect/Texture/Effect/petal_stoom_0.nhtex",
   L"data/effect/Texture/Effect/poison_bubble0000.nhtex",
   L"data/effect/Texture/Effect/poison_smoke0000.nhtex",
   L"data/effect/Texture/Effect/poison_spit0001.nhtex",
   L"data/effect/Texture/Effect/red_gunFire.nhtex",
   L"data/effect/Texture/Effect/reimu_amulet0000.nhtex",
   L"data/effect/Texture/Effect/ringA0000.nhtex",
   L"data/effect/Texture/Effect/round_1.nhtex",
   L"data/effect/Texture/Effect/round_draw.nhtex",
   L"data/effect/Texture/Effect/round_fight.nhtex",
   L"data/effect/Texture/Effect/shion_berserk_aura.nhtex",
   L"data/effect/Texture/Effect/shion_shadow0000.nhtex",
   L"data/effect/Texture/Effect/shockWave0000.nhtex",
   L"data/effect/Texture/Effect/shot_negative_000.nhtex",
   L"data/effect/Texture/Effect/shot_negative_001.nhtex",
   L"data/effect/Texture/Effect/side_smash0000.nhtex",
   L"data/effect/Texture/Effect/smoke0000.nhtex",
   L"data/effect/Texture/Effect/smokeBelt_loop0000.nhtex",
   L"data/effect/Texture/Effect/smoke_mamizou0000.nhtex",
   L"data/effect/Texture/Effect/spark0000.nhtex",
   L"data/effect/Texture/Effect/spark_000.nhtex",
   L"data/effect/Texture/Effect/spark_001.nhtex",
   L"data/effect/Texture/Effect/spark_anime_000.nhtex",
   L"data/effect/Texture/Effect/speedLineA0000.nhtex",
   L"data/effect/Texture/Effect/spellRing0001.nhtex",
   L"data/effect/Texture/Effect/spellRingBlue0000.nhtex",
   L"data/effect/Texture/Effect/spellRingMono0000.nhtex",
   L"data/effect/Texture/Effect/spell_B_slash.nhtex",
   L"data/effect/Texture/Effect/spell_B_slashB.nhtex",
   L"data/effect/Texture/Effect/splash0000.nhtex",
   L"data/effect/Texture/Effect/spline0000.nhtex",
   L"data/effect/Texture/Effect/squeezeA0000.nhtex",
   L"data/effect/Texture/Effect/stun_star.nhtex",
   L"data/effect/Texture/Effect/sun_ring0000.nhtex",
   L"data/effect/Texture/Effect/tenshi_eat_000.nhtex",
   L"data/effect/Texture/Effect/tenshi_haarp000.nhtex",
   L"data/effect/Texture/Effect/tenshi_haarp_map000.nhtex",
   L"data/effect/Texture/Effect/time_up_call.nhtex",
   L"data/effect/Texture/Effect/tornade.nhtex",
   L"data/effect/Texture/Effect/tutorial_clear0000.nhtex",
   L"data/effect/Texture/Effect/udonge_lastWard_Fire0000.nhtex",
   L"data/effect/Texture/Effect/udonge_violetCoon0000.nhtex",
   L"data/effect/Texture/Effect/udonge_violetLoop0000.nhtex",
   L"data/effect/Texture/Effect/udonge_winMark.nhtex",
   L"data/effect/Texture/Effect/unzanThunder0000.nhtex",
   L"data/effect/Texture/Effect/wall_hit0000.nhtex",
   L"data/effect/Texture/Effect/wave_loop0000.nhtex",
   L"data/effect/Texture/Effect/whiteBack.nhtex",
   L"data/effect/Texture/Effect/Wind.nhtex",
   L"data/effect/Texture/Effect/yellowLaserCore.nhtex",
   L"data/effect/Texture/Effect/yukari_kasa_blade0000.nhtex",
   L"data/effect/Texture/Effect/yukari_shard_mask.nhtex",
   L"data/effect/Texture/Effect/yukari_shard_shot0000.nhtex",
   L"data/effect/title_back_petal.eft",
   L"data/effect/udonge_climaxBreakGlass.eft",
   L"data/effect/udonge_climaxFireA.eft",
   L"data/effect/udonge_cornBeamA.eft",
   L"data/effect/udonge_cornBeamRoot.eft",
   L"data/effect/udonge_gunFireMid.eft",
   L"data/effect/udonge_gunFireMini.eft",
   L"data/effect/udonge_kuneShaut.eft",
   L"data/effect/udonge_kuneShautB.eft",
   L"data/effect/udonge_kuneShautBig.eft",
   L"data/effect/udonge_kuneShout2P.eft",
   L"data/effect/udonge_poisonExp.eft",
   L"data/effect/udonge_poisonExpB.eft",
   L"data/effect/udonge_poisonKune.eft",
   L"data/effect/udonge_sanAria.eft",
   L"data/effect/udonge_sanAria2.eft",
   L"data/effect/udonge_sanAria3.eft",
   L"data/effect/udonge_sanAria4.eft",
   L"data/effect/udonge_sanRing.eft",
   L"data/effect/udonge_shatterCamera.eft",
   L"data/effect/udonge_shotHitMini.eft",
   L"data/effect/udonge_winMark.eft",
   L"data/effect/usami_EXpower.eft",
   L"data/effect/wallHit.eft",
   L"data/effect/yukari_circle_blade.eft",
   L"data/effect/yukari_glass_break2.eft",
   L"data/effect/yukari_shard.eft",
   L"data/effect/yukari_spellC_gate.eft",
   L"data/effect/yukari_train_expload.eft",
   L"data/event/balloon/a05x2.png",
   L"data/event/balloon/a05x3.png",
   L"data/event/balloon/a08x2.png",
   L"data/event/balloon/a08x3.png",
   L"data/event/balloon/a11x2.png",
   L"data/event/balloon/a11x3.png",
   L"data/event/balloon/a15x2.png",
   L"data/event/balloon/a15x3.png",
   L"data/event/balloon/b05x2.png",
   L"data/event/balloon/b11x2.png",
   L"data/event/balloon/b15x3.png",
   L"data/event/balloon/balloon.pat",
   L"data/event/balloon/balloon_ed01.png",
   L"data/event/balloon/c05x2.png",
   L"data/event/balloon/c11x2.png",
   L"data/event/balloon/c15x3.png",
   L"data/event/balloon/d05x2.png",
   L"data/event/balloon/d11x2.png",
   L"data/event/balloon/d15x3.png",
   L"data/event/balloon/hukidasi-l.png",
   L"data/event/balloon/hukidasi-m.png",
   L"data/event/balloon/hukidasi-s.png",
   L"data/event/balloon/w15x3.png",
   L"data/event/pic/bg/bg_chikurin.png",
   L"data/event/pic/bg/bg_eientei.png",
   L"data/event/pic/bg/bg_hakurei.png",
   L"data/event/pic/bg/bg_kisinzyou.png",
   L"data/event/pic/bg/bg_myourenji.png",
   L"data/event/pic/bg/bg_sinreibyou.png",
   L"data/event/pic/bg/black.png",
   L"data/event/pic/doremy/01.png",
   L"data/event/pic/doremy/02.png",
   L"data/event/pic/doremy/03.png",
   L"data/event/pic/doremy/04.png",
   L"data/event/pic/doremy/05.png",
   L"data/event/pic/doremy/06.png",
   L"data/event/pic/doremy/07.png",
   L"data/event/pic/doremy/08.png",
   L"data/event/pic/doremy/09.png",
   L"data/event/pic/doremy/10.png",
   L"data/event/pic/doremy/face.pat",
   L"data/event/pic/doremy/face_r.pat",
   L"data/event/pic/futo/01.png",
   L"data/event/pic/futo/02.png",
   L"data/event/pic/futo/03.png",
   L"data/event/pic/futo/04.png",
   L"data/event/pic/futo/05.png",
   L"data/event/pic/futo/06.png",
   L"data/event/pic/futo/07.png",
   L"data/event/pic/futo/08.png",
   L"data/event/pic/futo/09.png",
   L"data/event/pic/futo/10.png",
   L"data/event/pic/futo/11.png",
   L"data/event/pic/futo/ed1.png",
   L"data/event/pic/futo/ed2.png",
   L"data/event/pic/futo/ed3.png",
   L"data/event/pic/futo/face.pat",
   L"data/event/pic/futo/face_r.pat",
   L"data/event/pic/hijiri/01.png",
   L"data/event/pic/hijiri/02.png",
   L"data/event/pic/hijiri/03.png",
   L"data/event/pic/hijiri/04.png",
   L"data/event/pic/hijiri/05.png",
   L"data/event/pic/hijiri/06.png",
   L"data/event/pic/hijiri/07.png",
   L"data/event/pic/hijiri/08.png",
   L"data/event/pic/hijiri/09.png",
   L"data/event/pic/hijiri/10.png",
   L"data/event/pic/hijiri/face.pat",
   L"data/event/pic/hijiri/face_r.pat",
   L"data/event/pic/ichirin/01.png",
   L"data/event/pic/ichirin/02.png",
   L"data/event/pic/ichirin/03.png",
   L"data/event/pic/ichirin/04.png",
   L"data/event/pic/ichirin/05.png",
   L"data/event/pic/ichirin/06.png",
   L"data/event/pic/ichirin/07.png",
   L"data/event/pic/ichirin/08.png",
   L"data/event/pic/ichirin/09.png",
   L"data/event/pic/ichirin/10.png",
   L"data/event/pic/ichirin/face.pat",
   L"data/event/pic/ichirin/face_r.pat",
   L"data/event/pic/jyoon/01.png",
   L"data/event/pic/jyoon/02.png",
   L"data/event/pic/jyoon/03.png",
   L"data/event/pic/jyoon/04.png",
   L"data/event/pic/jyoon/05.png",
   L"data/event/pic/jyoon/06.png",
   L"data/event/pic/jyoon/07.png",
   L"data/event/pic/jyoon/08.png",
   L"data/event/pic/jyoon/09.png",
   L"data/event/pic/jyoon/10.png",
   L"data/event/pic/jyoon/11.png",
   L"data/event/pic/jyoon/12.png",
   L"data/event/pic/jyoon/12_r.png",
   L"data/event/pic/jyoon/ed1.png",
   L"data/event/pic/jyoon/ed2.png",
   L"data/event/pic/jyoon/ed3.png",
   L"data/event/pic/jyoon/ed4.png",
   L"data/event/pic/jyoon/ed5.png",
   L"data/event/pic/jyoon/ed6.png",
   L"data/event/pic/jyoon/ed7.png",
   L"data/event/pic/jyoon/face.pat",
   L"data/event/pic/jyoon/face_r.pat",
   L"data/event/pic/kasen/01.png",
   L"data/event/pic/kasen/02.png",
   L"data/event/pic/kasen/03.png",
   L"data/event/pic/kasen/04.png",
   L"data/event/pic/kasen/05.png",
   L"data/event/pic/kasen/06.png",
   L"data/event/pic/kasen/07.png",
   L"data/event/pic/kasen/08.png",
   L"data/event/pic/kasen/09.png",
   L"data/event/pic/kasen/10.png",
   L"data/event/pic/kasen/15.png",
   L"data/event/pic/kasen/face.pat",
   L"data/event/pic/kasen/face_r.pat",
   L"data/event/pic/koishi/01.png",
   L"data/event/pic/koishi/02.png",
   L"data/event/pic/koishi/03.png",
   L"data/event/pic/koishi/04.png",
   L"data/event/pic/koishi/05.png",
   L"data/event/pic/koishi/06.png",
   L"data/event/pic/koishi/07.png",
   L"data/event/pic/koishi/08.png",
   L"data/event/pic/koishi/09.png",
   L"data/event/pic/koishi/10.png",
   L"data/event/pic/koishi/11.png",
   L"data/event/pic/koishi/face.pat",
   L"data/event/pic/koishi/face_r.pat",
   L"data/event/pic/kokoro/01.png",
   L"data/event/pic/kokoro/02.png",
   L"data/event/pic/kokoro/03.png",
   L"data/event/pic/kokoro/05.png",
   L"data/event/pic/kokoro/06.png",
   L"data/event/pic/kokoro/07.png",
   L"data/event/pic/kokoro/08.png",
   L"data/event/pic/kokoro/09.png",
   L"data/event/pic/kokoro/10.png",
   L"data/event/pic/kokoro/face.pat",
   L"data/event/pic/kokoro/face_r.pat",
   L"data/event/pic/mamizou/01.png",
   L"data/event/pic/mamizou/01_r.png",
   L"data/event/pic/mamizou/02.png",
   L"data/event/pic/mamizou/02_r.png",
   L"data/event/pic/mamizou/03.png",
   L"data/event/pic/mamizou/03_r.png",
   L"data/event/pic/mamizou/04.png",
   L"data/event/pic/mamizou/04_r.png",
   L"data/event/pic/mamizou/05.png",
   L"data/event/pic/mamizou/05_r.png",
   L"data/event/pic/mamizou/06.png",
   L"data/event/pic/mamizou/06_r.png",
   L"data/event/pic/mamizou/07.png",
   L"data/event/pic/mamizou/07_r.png",
   L"data/event/pic/mamizou/08.png",
   L"data/event/pic/mamizou/08_r.png",
   L"data/event/pic/mamizou/09.png",
   L"data/event/pic/mamizou/09_r.png",
   L"data/event/pic/mamizou/10.png",
   L"data/event/pic/mamizou/10_r.png",
   L"data/event/pic/mamizou/ed1.png",
   L"data/event/pic/mamizou/ed2.png",
   L"data/event/pic/mamizou/face.pat",
   L"data/event/pic/mamizou/face_r.pat",
   L"data/event/pic/marisa/01.png",
   L"data/event/pic/marisa/02.png",
   L"data/event/pic/marisa/03.png",
   L"data/event/pic/marisa/04.png",
   L"data/event/pic/marisa/05.png",
   L"data/event/pic/marisa/06.png",
   L"data/event/pic/marisa/07.png",
   L"data/event/pic/marisa/08.png",
   L"data/event/pic/marisa/09.png",
   L"data/event/pic/marisa/10.png",
   L"data/event/pic/marisa/11.png",
   L"data/event/pic/marisa/13.png",
   L"data/event/pic/marisa/ed1.png",
   L"data/event/pic/marisa/ed2.png",
   L"data/event/pic/marisa/ed3.png",
   L"data/event/pic/marisa/face.pat",
   L"data/event/pic/marisa/face_r.pat",
   L"data/event/pic/miko/01.png",
   L"data/event/pic/miko/02.png",
   L"data/event/pic/miko/02_r.png",
   L"data/event/pic/miko/03.png",
   L"data/event/pic/miko/04.png",
   L"data/event/pic/miko/05.png",
   L"data/event/pic/miko/05_r.png",
   L"data/event/pic/miko/06.png",
   L"data/event/pic/miko/07.png",
   L"data/event/pic/miko/07_r.png",
   L"data/event/pic/miko/08.png",
   L"data/event/pic/miko/08_r.png",
   L"data/event/pic/miko/09.png",
   L"data/event/pic/miko/09_r.png",
   L"data/event/pic/miko/10.png",
   L"data/event/pic/miko/ed1.png",
   L"data/event/pic/miko/ed2.png",
   L"data/event/pic/miko/face.pat",
   L"data/event/pic/miko/face_r.pat",
   L"data/event/pic/mokou/01.png",
   L"data/event/pic/mokou/02.png",
   L"data/event/pic/mokou/03.png",
   L"data/event/pic/mokou/04.png",
   L"data/event/pic/mokou/05.png",
   L"data/event/pic/mokou/06.png",
   L"data/event/pic/mokou/07.png",
   L"data/event/pic/mokou/08.png",
   L"data/event/pic/mokou/09.png",
   L"data/event/pic/mokou/10.png",
   L"data/event/pic/mokou/face.pat",
   L"data/event/pic/mokou/face_r.pat",
   L"data/event/pic/nitori/01.png",
   L"data/event/pic/nitori/02.png",
   L"data/event/pic/nitori/03.png",
   L"data/event/pic/nitori/04.png",
   L"data/event/pic/nitori/05.png",
   L"data/event/pic/nitori/06.png",
   L"data/event/pic/nitori/07.png",
   L"data/event/pic/nitori/08.png",
   L"data/event/pic/nitori/09.png",
   L"data/event/pic/nitori/10.png",
   L"data/event/pic/nitori/11.png",
   L"data/event/pic/nitori/12.png",
   L"data/event/pic/nitori/ed1.png",
   L"data/event/pic/nitori/ed2.png",
   L"data/event/pic/nitori/face.pat",
   L"data/event/pic/nitori/face_r.pat",
   L"data/event/pic/reimu/01.png",
   L"data/event/pic/reimu/02.png",
   L"data/event/pic/reimu/03.png",
   L"data/event/pic/reimu/04.png",
   L"data/event/pic/reimu/05.png",
   L"data/event/pic/reimu/06.png",
   L"data/event/pic/reimu/07.png",
   L"data/event/pic/reimu/08.png",
   L"data/event/pic/reimu/09.png",
   L"data/event/pic/reimu/10.png",
   L"data/event/pic/reimu/11.png",
   L"data/event/pic/reimu/12.png",
   L"data/event/pic/reimu/16.png",
   L"data/event/pic/reimu/17.png",
   L"data/event/pic/reimu/ed1.png",
   L"data/event/pic/reimu/ed2.png",
   L"data/event/pic/reimu/ed3.png",
   L"data/event/pic/reimu/ed4.png",
   L"data/event/pic/reimu/ed5.png",
   L"data/event/pic/reimu/face.pat",
   L"data/event/pic/reimu/face_r.pat",
   L"data/event/pic/shion/01.png",
   L"data/event/pic/shion/01_r.png",
   L"data/event/pic/shion/02.png",
   L"data/event/pic/shion/02_r.png",
   L"data/event/pic/shion/03.png",
   L"data/event/pic/shion/03_r.png",
   L"data/event/pic/shion/04.png",
   L"data/event/pic/shion/04_r.png",
   L"data/event/pic/shion/05.png",
   L"data/event/pic/shion/05_r.png",
   L"data/event/pic/shion/06.png",
   L"data/event/pic/shion/06_r.png",
   L"data/event/pic/shion/07.png",
   L"data/event/pic/shion/07_r.png",
   L"data/event/pic/shion/08.png",
   L"data/event/pic/shion/08_r.png",
   L"data/event/pic/shion/09.png",
   L"data/event/pic/shion/09_r.png",
   L"data/event/pic/shion/10.png",
   L"data/event/pic/shion/10_r.png",
   L"data/event/pic/shion/11.png",
   L"data/event/pic/shion/11_r.png",
   L"data/event/pic/shion/98.png",
   L"data/event/pic/shion/99test.png",
   L"data/event/pic/shion/face.pat",
   L"data/event/pic/shion/face_r.pat",
   L"data/event/pic/sinmyoumaru/01.png",
   L"data/event/pic/sinmyoumaru/02.png",
   L"data/event/pic/sinmyoumaru/03.png",
   L"data/event/pic/sinmyoumaru/04.png",
   L"data/event/pic/sinmyoumaru/05.png",
   L"data/event/pic/sinmyoumaru/06.png",
   L"data/event/pic/sinmyoumaru/07.png",
   L"data/event/pic/sinmyoumaru/08.png",
   L"data/event/pic/sinmyoumaru/09.png",
   L"data/event/pic/sinmyoumaru/10.png",
   L"data/event/pic/sinmyoumaru/face.pat",
   L"data/event/pic/sinmyoumaru/face_r.pat",
   L"data/event/pic/tenshi/01.png",
   L"data/event/pic/tenshi/02.png",
   L"data/event/pic/tenshi/03.png",
   L"data/event/pic/tenshi/04.png",
   L"data/event/pic/tenshi/05.png",
   L"data/event/pic/tenshi/06.png",
   L"data/event/pic/tenshi/07.png",
   L"data/event/pic/tenshi/08.png",
   L"data/event/pic/tenshi/09.png",
   L"data/event/pic/tenshi/10.png",
   L"data/event/pic/tenshi/11.png",
   L"data/event/pic/tenshi/ed1.png",
   L"data/event/pic/tenshi/ed2.png",
   L"data/event/pic/tenshi/face.pat",
   L"data/event/pic/tenshi/face_r.pat",
   L"data/event/pic/udonge/01.png",
   L"data/event/pic/udonge/02.png",
   L"data/event/pic/udonge/03.png",
   L"data/event/pic/udonge/04.png",
   L"data/event/pic/udonge/05.png",
   L"data/event/pic/udonge/06.png",
   L"data/event/pic/udonge/07.png",
   L"data/event/pic/udonge/08.png",
   L"data/event/pic/udonge/09.png",
   L"data/event/pic/udonge/10.png",
   L"data/event/pic/udonge/ed1.png",
   L"data/event/pic/udonge/ed2.png",
   L"data/event/pic/udonge/face.pat",
   L"data/event/pic/udonge/face_r.pat",
   L"data/event/pic/usami/01.png",
   L"data/event/pic/usami/02.png",
   L"data/event/pic/usami/03.png",
   L"data/event/pic/usami/04.png",
   L"data/event/pic/usami/05.png",
   L"data/event/pic/usami/06.png",
   L"data/event/pic/usami/07.png",
   L"data/event/pic/usami/08.png",
   L"data/event/pic/usami/09.png",
   L"data/event/pic/usami/10.png",
   L"data/event/pic/usami/ed1.png",
   L"data/event/pic/usami/ed2.png",
   L"data/event/pic/usami/face.pat",
   L"data/event/pic/usami/face_r.pat",
   L"data/event/pic/yukari/01.png",
   L"data/event/pic/yukari/02.png",
   L"data/event/pic/yukari/03.png",
   L"data/event/pic/yukari/04.png",
   L"data/event/pic/yukari/05.png",
   L"data/event/pic/yukari/06.png",
   L"data/event/pic/yukari/07.png",
   L"data/event/pic/yukari/08.png",
   L"data/event/pic/yukari/09.png",
   L"data/event/pic/yukari/10.png",
   L"data/event/pic/yukari/ed1.png",
   L"data/event/pic/yukari/ed2.png",
   L"data/event/pic/yukari/ed3.png",
   L"data/event/pic/yukari/ed4.png",
   L"data/event/pic/yukari/ed5.png",
   L"data/event/pic/yukari/ed6.png",
   L"data/event/pic/yukari/ed7.png",
   L"data/event/pic/yukari/ed8.png",
   L"data/event/pic/yukari/face.pat",
   L"data/event/pic/yukari/face_r.pat",
   L"data/event/script/futo/ed.pl",
   L"data/event/script/futo/stage1.pl",
   L"data/event/script/futo/stage2.pl",
   L"data/event/script/futo/stage3.pl",
   L"data/event/script/futo/stage4.pl",
   L"data/event/script/futo/stage5.pl",
   L"data/event/script/jyoon/ed.pl",
   L"data/event/script/jyoon/stage1.pl",
   L"data/event/script/jyoon/stage2.pl",
   L"data/event/script/jyoon/stage3.pl",
   L"data/event/script/jyoon/stage4.pl",
   L"data/event/script/jyoon/stage5.pl",
   L"data/event/script/jyoon/stage6.pl",
   L"data/event/script/mamizou/ed.pl",
   L"data/event/script/mamizou/stage1.pl",
   L"data/event/script/mamizou/stage2.pl",
   L"data/event/script/mamizou/stage3.pl",
   L"data/event/script/mamizou/stage4.pl",
   L"data/event/script/mamizou/stage5.pl",
   L"data/event/script/marisa/ed.pl",
   L"data/event/script/marisa/stage1.pl",
   L"data/event/script/marisa/stage2.pl",
   L"data/event/script/marisa/stage3.pl",
   L"data/event/script/marisa/stage4.pl",
   L"data/event/script/marisa/stage5.pl",
   L"data/event/script/miko/ed.pl",
   L"data/event/script/miko/stage1.pl",
   L"data/event/script/miko/stage2.pl",
   L"data/event/script/miko/stage3.pl",
   L"data/event/script/miko/stage4.pl",
   L"data/event/script/miko/stage5.pl",
   L"data/event/script/nitori/ed.pl",
   L"data/event/script/nitori/stage1.pl",
   L"data/event/script/nitori/stage2.pl",
   L"data/event/script/nitori/stage3.pl",
   L"data/event/script/nitori/stage4.pl",
   L"data/event/script/nitori/stage5.pl",
   L"data/event/script/reimu/ed.pl",
   L"data/event/script/reimu/stage1.pl",
   L"data/event/script/reimu/stage2.pl",
   L"data/event/script/reimu/stage3.pl",
   L"data/event/script/reimu/stage4.pl",
   L"data/event/script/tenshi/ed.pl",
   L"data/event/script/tenshi/stage1.pl",
   L"data/event/script/tenshi/stage2.pl",
   L"data/event/script/tenshi/stage3.pl",
   L"data/event/script/tenshi/stage4.pl",
   L"data/event/script/tenshi/stage5.pl",
   L"data/event/script/udonge/ed.pl",
   L"data/event/script/udonge/stage1.pl",
   L"data/event/script/udonge/stage2.pl",
   L"data/event/script/udonge/stage3.pl",
   L"data/event/script/udonge/stage4.pl",
   L"data/event/script/usami/ed.pl",
   L"data/event/script/usami/stage1.pl",
   L"data/event/script/usami/stage2.pl",
   L"data/event/script/usami/stage3.pl",
   L"data/event/script/usami/stage4.pl",
   L"data/event/script/usami/stage5.pl",
   L"data/event/script/yukari/ed.pl",
   L"data/event/script/yukari/stage1.pl",
   L"data/event/script/yukari/stage2.pl",
   L"data/font/font_texture_outline16_600.bmp",
   L"data/font/font_texture_outline24.bmp",
   L"data/font/spell_font.bmp",
   L"data/font/talk_font.bmp",
   L"data/plugin/se_information.dll",
   L"data/plugin/se_libact.dll",
   L"data/plugin/se_lobby.dll",
   L"data/plugin/se_trust.dll",
   L"data/plugin/se_upnp.dll",
   L"data/script/actor.nut",
   L"data/script/backGround/bg01.nut",
   L"data/script/backGround/bg02.nut",
   L"data/script/backGround/bg03.nut",
   L"data/script/backGround/bg04.nut",
   L"data/script/backGround/bg05.nut",
   L"data/script/backGround/bg06.nut",
   L"data/script/backGround/bg07.nut",
   L"data/script/backGround/bg08.nut",
   L"data/script/backGround/bg09.nut",
   L"data/script/backGround/bg10.nut",
   L"data/script/backGround/bg11.nut",
   L"data/script/backGround/bg12.nut",
   L"data/script/backGround/bg15.nut",
   L"data/script/backGround/bg16.nut",
   L"data/script/backGround/bg17.nut",
   L"data/script/backGround/bg19.nut",
   L"data/script/backGround/bg20.nut",
   L"data/script/backGround/bg21.nut",
   L"data/script/backGround/bg22.nut",
   L"data/script/backGround/bg23.nut",
   L"data/script/backGround/bg24.nut",
   L"data/script/backGround/bg25.nut",
   L"data/script/backGround/bg26.nut",
   L"data/script/backGround/bg27.nut",
   L"data/script/backGround/bg28.nut",
   L"data/script/backGround/bg30.nut",
   L"data/script/backGround/bg31.nut",
   L"data/script/backGround/bg40.nut",
   L"data/script/backGround/bg41.nut",
   L"data/script/backGround/bg42.nut",
   L"data/script/backGround/bg43.nut",
   L"data/script/backGround/bg44.nut",
   L"data/script/backGround/bg45.nut",
   L"data/script/backGround/bg46.nut",
   L"data/script/base.nut",
   L"data/script/battle/battle.nut",
   L"data/script/battle/battle_network.nut",
   L"data/script/battle/battle_on_hit.nut",
   L"data/script/battle/battle_on_move.nut",
   L"data/script/battle/battle_param.nut",
   L"data/script/battle/battle_practice.nut",
   L"data/script/battle/battle_replay.nut",
   L"data/script/battle/battle_replay_story.nut",
   L"data/script/battle/battle_story.nut",
   L"data/script/battle/battle_team.nut",
   L"data/script/battle/battle_tutorial.nut",
   L"data/script/battle/battle_update.nut",
   L"data/script/battle/battle_vs_player.nut",
   L"data/script/battle/battle_watch.nut",
   L"data/script/boot.nut",
   L"data/script/camera.nut",
   L"data/script/camera_2d.nut",
   L"data/script/camera_3d.nut",
   L"data/script/component.nut",
   L"data/script/config.nut",
   L"data/script/const.nut",
   L"data/script/const_key.nut",
   L"data/script/effect.nut",
   L"data/script/font.nut",
   L"data/script/graphics.nut",
   L"data/script/initialize.nut",
   L"data/script/input.nut",
   L"data/script/loop.nut",
   L"data/script/menu.nut",
   L"data/script/name.nut",
   L"data/script/renderer_vm.nut",
   L"data/script/replay.nut",
   L"data/script/savedata.nut",
   L"data/script/scene/practice.nut",
   L"data/script/scene/story.nut",
   L"data/script/scene/tutorial.nut",
   L"data/script/scene/vs.nut",
   L"data/script/scene/watch.nut",
   L"data/script/sound.nut",
   L"data/script/spell.nut",
   L"data/script/stage.nut",
   L"data/script/talk/talk.nut",
   L"data/script/talk/talk_balloon.nut",
   L"data/script/talk/talk_character.nut",
   L"data/script/talk/talk_command.nut",
   L"data/script/talk/talk_command_ex.nut",
   L"data/script/talk/talk_generate.nut",
   L"data/script/talk/talk_image.nut",
   L"data/script/talk/talk_text.nut",
   L"data/script/version.nut",
   L"data/se/common/800.wav",
   L"data/se/common/801.wav",
   L"data/se/common/803.wav",
   L"data/se/common/804.wav",
   L"data/se/common/805.wav",
   L"data/se/common/806.wav",
   L"data/se/common/807.wav",
   L"data/se/common/810.wav",
   L"data/se/common/813.wav",
   L"data/se/common/816.wav",
   L"data/se/common/817.wav",
   L"data/se/common/818.wav",
   L"data/se/common/820.wav",
   L"data/se/common/821.wav",
   L"data/se/common/823.wav",
   L"data/se/common/824.wav",
   L"data/se/common/825.wav",
   L"data/se/common/826.wav",
   L"data/se/common/827.wav",
   L"data/se/common/828.wav",
   L"data/se/common/829.wav",
   L"data/se/common/830.wav",
   L"data/se/common/832.wav",
   L"data/se/common/833.wav",
   L"data/se/common/834.wav",
   L"data/se/common/842.wav",
   L"data/se/common/846.wav",
   L"data/se/common/847.wav",
   L"data/se/common/849.wav",
   L"data/se/common/850.wav",
   L"data/se/common/851.wav",
   L"data/se/common/852.wav",
   L"data/se/common/853.wav",
   L"data/se/common/854.wav",
   L"data/se/common/855.wav",
   L"data/se/common/856.wav",
   L"data/se/common/857.wav",
   L"data/se/common/858.wav",
   L"data/se/common/862.wav",
   L"data/se/common/865.wav",
   L"data/se/common/866.wav",
   L"data/se/common/867.wav",
   L"data/se/common/868.wav",
   L"data/se/common/869.wav",
   L"data/se/common/870.wav",
   L"data/se/common/872.wav",
   L"data/se/common/873.wav",
   L"data/se/common/881.wav",
   L"data/se/common/900.wav",
   L"data/se/common/901.wav",
   L"data/se/common/902.wav",
   L"data/se/common/903.wav",
   L"data/se/common/906.wav",
   L"data/se/common/907.wav",
   L"data/se/common/h001.wav",
   L"data/se/common/h002.wav",
   L"data/se/common/h003.wav",
   L"data/se/common/h004.wav",
   L"data/se/common/h005.wav",
   L"data/se/common/h017.wav",
   L"data/se/common/h018.wav",
   L"data/se/common/h019.wav",
   L"data/se/common/h026.wav",
   L"data/se/common/h027.wav",
   L"data/se/common/h029.wav",
   L"data/se/common/h030.wav",
   L"data/se/common/h035_3.wav",
   L"data/se/common/h035_4.wav",
   L"data/se/common/h036.wav",
   L"data/se/common/h037.wav",
   L"data/se/common/h038.wav",
   L"data/se/common/h039_1.wav",
   L"data/se/common/h044.wav",
   L"data/se/common/h053_2.wav",
   L"data/se/common/h068.wav",
   L"data/se/common/h073_2.wav",
   L"data/se/common/h073_3.wav",
   L"data/se/common/h074.wav",
   L"data/se/common/s002.wav",
   L"data/se/common/s002_2.wav",
   L"data/se/common/s003.wav",
   L"data/se/common/s003_4.wav",
   L"data/se/common/s004_2.wav",
   L"data/se/common/s004_3.wav",
   L"data/se/common/s004_4.wav",
   L"data/se/common/s004_5.wav",
   L"data/se/common/s005_2.wav",
   L"data/se/common/s005_3.wav",
   L"data/se/common/s005_4.wav",
   L"data/se/common/s006.wav",
   L"data/se/common/s006_3.wav",
   L"data/se/common/s007.wav",
   L"data/se/common/s007_4.wav",
   L"data/se/common/s010_2.wav",
   L"data/se/common/s011_2.wav",
   L"data/se/common/s013.wav",
   L"data/se/common/s016_1.wav",
   L"data/se/common/s016_2.wav",
   L"data/se/common/s022.wav",
   L"data/se/common/s025.wav",
   L"data/se/common/s050.wav",
   L"data/se/common/s057.wav",
   L"data/se/common/s064.wav",
   L"data/se/doremy/4000.wav",
   L"data/se/doremy/4002.wav",
   L"data/se/doremy/4004.wav",
   L"data/se/doremy/4010.wav",
   L"data/se/doremy/4011.wav",
   L"data/se/doremy/4012.wav",
   L"data/se/doremy/4016.wav",
   L"data/se/doremy/4020.wav",
   L"data/se/doremy/4022.wav",
   L"data/se/doremy/4024.wav",
   L"data/se/doremy/4026.wav",
   L"data/se/doremy/4027.wav",
   L"data/se/doremy/4028.wav",
   L"data/se/doremy/4030.wav",
   L"data/se/doremy/4031.wav",
   L"data/se/doremy/4032.wav",
   L"data/se/doremy/4034.wav",
   L"data/se/doremy/4036.wav",
   L"data/se/doremy/4037.wav",
   L"data/se/doremy/4039.wav",
   L"data/se/doremy/4040.wav",
   L"data/se/doremy/4042.wav",
   L"data/se/doremy/4043.wav",
   L"data/se/doremy/4045.wav",
   L"data/se/doremy/4046.wav",
   L"data/se/doremy/4048.wav",
   L"data/se/doremy/4050.wav",
   L"data/se/doremy/4051.wav",
   L"data/se/doremy/4053.wav",
   L"data/se/doremy/4055.wav",
   L"data/se/doremy/4056.wav",
   L"data/se/doremy/4058.wav",
   L"data/se/doremy/4059.wav",
   L"data/se/doremy/4060.wav",
   L"data/se/doremy/4061.wav",
   L"data/se/doremy/4062.wav",
   L"data/se/doremy/4063.wav",
   L"data/se/doremy/4065.wav",
   L"data/se/doremy/4066.wav",
   L"data/se/doremy/4067.wav",
   L"data/se/doremy/4068.wav",
   L"data/se/doremy/4070.wav",
   L"data/se/doremy/4071.wav",
   L"data/se/doremy/4078.wav",
   L"data/se/doremy/4080.wav",
   L"data/se/doremy.csv",
   L"data/se/futo/1800.wav",
   L"data/se/futo/1804.wav",
   L"data/se/futo/1806.wav",
   L"data/se/futo/1808.wav",
   L"data/se/futo/1810.wav",
   L"data/se/futo/1811.wav",
   L"data/se/futo/1814.wav",
   L"data/se/futo/1815.wav",
   L"data/se/futo/1822.wav",
   L"data/se/futo/1823.wav",
   L"data/se/futo/1825.wav",
   L"data/se/futo/1831.wav",
   L"data/se/futo/1832.wav",
   L"data/se/futo/1833.wav",
   L"data/se/futo/1835.wav",
   L"data/se/futo/1836.wav",
   L"data/se/futo/1837.wav",
   L"data/se/futo/1838.wav",
   L"data/se/futo/1839.wav",
   L"data/se/futo/1840.wav",
   L"data/se/futo/1842.wav",
   L"data/se/futo/1843.wav",
   L"data/se/futo/1844.wav",
   L"data/se/futo/1846.wav",
   L"data/se/futo/1853.wav",
   L"data/se/futo/1855.wav",
   L"data/se/futo/1857.wav",
   L"data/se/futo/1899.wav",
   L"data/se/futo/1900.wav",
   L"data/se/futo/1901.wav",
   L"data/se/futo/1903.wav",
   L"data/se/futo/1904.wav",
   L"data/se/futo/1905.wav",
   L"data/se/futo/1906.wav",
   L"data/se/futo/1907.wav",
   L"data/se/futo/1908.wav",
   L"data/se/futo/1911.wav",
   L"data/se/futo/1913.wav",
   L"data/se/futo/1914.wav",
   L"data/se/futo/1915.wav",
   L"data/se/futo/1916.wav",
   L"data/se/futo/1917.wav",
   L"data/se/futo/1919.wav",
   L"data/se/futo/1920.wav",
   L"data/se/futo/1930.wav",
   L"data/se/futo/1932.wav",
   L"data/se/futo/1933.wav",
   L"data/se/futo/1935.wav",
   L"data/se/futo/1936.wav",
   L"data/se/futo/1950.wav",
   L"data/se/futo/1951.wav",
   L"data/se/futo/1952.wav",
   L"data/se/futo/1953.wav",
   L"data/se/futo/1956.wav",
   L"data/se/futo/1958.wav",
   L"data/se/futo/1959.wav",
   L"data/se/futo/1960.wav",
   L"data/se/futo/1961.wav",
   L"data/se/futo/1962.wav",
   L"data/se/futo/1963.wav",
   L"data/se/futo/1965.wav",
   L"data/se/futo/1967.wav",
   L"data/se/futo/1968.wav",
   L"data/se/futo/1969.wav",
   L"data/se/futo/1970.wav",
   L"data/se/futo/1989.wav",
   L"data/se/futo/1990.wav",
   L"data/se/futo/1991.wav",
   L"data/se/futo/1992.wav",
   L"data/se/futo/1993.wav",
   L"data/se/futo/1994.wav",
   L"data/se/futo.csv",
   L"data/se/hijiri/1600.wav",
   L"data/se/hijiri/1601.wav",
   L"data/se/hijiri/1605.wav",
   L"data/se/hijiri/1607.wav",
   L"data/se/hijiri/1609.wav",
   L"data/se/hijiri/1610.wav",
   L"data/se/hijiri/1613.wav",
   L"data/se/hijiri/1615.wav",
   L"data/se/hijiri/1616.wav",
   L"data/se/hijiri/1619.wav",
   L"data/se/hijiri/1621.wav",
   L"data/se/hijiri/1622.wav",
   L"data/se/hijiri/1623.wav",
   L"data/se/hijiri/1624.wav",
   L"data/se/hijiri/1625.wav",
   L"data/se/hijiri/1626.wav",
   L"data/se/hijiri/1627.wav",
   L"data/se/hijiri/1629.wav",
   L"data/se/hijiri/1700.wav",
   L"data/se/hijiri/1701.wav",
   L"data/se/hijiri/1704.wav",
   L"data/se/hijiri/1706.wav",
   L"data/se/hijiri/1707.wav",
   L"data/se/hijiri/1708.wav",
   L"data/se/hijiri/1710.wav",
   L"data/se/hijiri/1712.wav",
   L"data/se/hijiri/1713.wav",
   L"data/se/hijiri/1715.wav",
   L"data/se/hijiri/1719.wav",
   L"data/se/hijiri/1721.wav",
   L"data/se/hijiri/1724.wav",
   L"data/se/hijiri/1725.wav",
   L"data/se/hijiri/1730.wav",
   L"data/se/hijiri/1731.wav",
   L"data/se/hijiri/1732.wav",
   L"data/se/hijiri/1733.wav",
   L"data/se/hijiri/1734.wav",
   L"data/se/hijiri/1736.wav",
   L"data/se/hijiri/1740.wav",
   L"data/se/hijiri/1742.wav",
   L"data/se/hijiri/1743.wav",
   L"data/se/hijiri/1745.wav",
   L"data/se/hijiri/1746.wav",
   L"data/se/hijiri/1750.wav",
   L"data/se/hijiri/1752.wav",
   L"data/se/hijiri/1753.wav",
   L"data/se/hijiri/1754.wav",
   L"data/se/hijiri/1755.wav",
   L"data/se/hijiri/1757.wav",
   L"data/se/hijiri/1758.wav",
   L"data/se/hijiri/1760.wav",
   L"data/se/hijiri/1764.wav",
   L"data/se/hijiri.csv",
   L"data/se/ichirin/1451.wav",
   L"data/se/ichirin/1471.wav",
   L"data/se/ichirin/1475.wav",
   L"data/se/ichirin/1476.wav",
   L"data/se/ichirin/1477.wav",
   L"data/se/ichirin/1478.wav",
   L"data/se/ichirin/1479.wav",
   L"data/se/ichirin/1480.wav",
   L"data/se/ichirin/1481.wav",
   L"data/se/ichirin/1489.wav",
   L"data/se/ichirin/1500.wav",
   L"data/se/ichirin/1501.wav",
   L"data/se/ichirin/1502.wav",
   L"data/se/ichirin/1503.wav",
   L"data/se/ichirin/1505.wav",
   L"data/se/ichirin/1507.wav",
   L"data/se/ichirin/1520.wav",
   L"data/se/ichirin/1522.wav",
   L"data/se/ichirin/1523.wav",
   L"data/se/ichirin/1524.wav",
   L"data/se/ichirin/1526.wav",
   L"data/se/ichirin/1528.wav",
   L"data/se/ichirin/1529.wav",
   L"data/se/ichirin/1540.wav",
   L"data/se/ichirin/1541.wav",
   L"data/se/ichirin/1542.wav",
   L"data/se/ichirin/1544.wav",
   L"data/se/ichirin/1546.wav",
   L"data/se/ichirin/1548.wav",
   L"data/se/ichirin/1550.wav",
   L"data/se/ichirin/1551.wav",
   L"data/se/ichirin/1553.wav",
   L"data/se/ichirin/1554.wav",
   L"data/se/ichirin/1555.wav",
   L"data/se/ichirin/1556.wav",
   L"data/se/ichirin/1557.wav",
   L"data/se/ichirin/1558.wav",
   L"data/se/ichirin/1559.wav",
   L"data/se/ichirin/1560.wav",
   L"data/se/ichirin/1573.wav",
   L"data/se/ichirin/1574.wav",
   L"data/se/ichirin/1576.wav",
   L"data/se/ichirin/1590.wav",
   L"data/se/ichirin/1591.wav",
   L"data/se/ichirin/1592.wav",
   L"data/se/ichirin/1593.wav",
   L"data/se/ichirin/1599.wav",
   L"data/se/ichirin.csv",
   L"data/se/jyoon/4600.wav",
   L"data/se/jyoon/4602.wav",
   L"data/se/jyoon/4604.wav",
   L"data/se/jyoon/4606.wav",
   L"data/se/jyoon/4609.wav",
   L"data/se/jyoon/4611.wav",
   L"data/se/jyoon/4613.wav",
   L"data/se/jyoon/4615.wav",
   L"data/se/jyoon/4617.wav",
   L"data/se/jyoon/4619.wav",
   L"data/se/jyoon/4620.wav",
   L"data/se/jyoon/4622.wav",
   L"data/se/jyoon/4624.wav",
   L"data/se/jyoon/4626.wav",
   L"data/se/jyoon/4627.wav",
   L"data/se/jyoon/4628.wav",
   L"data/se/jyoon/4629.wav",
   L"data/se/jyoon/4630.wav",
   L"data/se/jyoon/4631.wav",
   L"data/se/jyoon/4632.wav",
   L"data/se/jyoon/4633.wav",
   L"data/se/jyoon/4635.wav",
   L"data/se/jyoon/4636.wav",
   L"data/se/jyoon/4638.wav",
   L"data/se/jyoon/4639.wav",
   L"data/se/jyoon/4640.wav",
   L"data/se/jyoon/4641.wav",
   L"data/se/jyoon/4643.wav",
   L"data/se/jyoon/4645.wav",
   L"data/se/jyoon/4648.wav",
   L"data/se/jyoon/4650.wav",
   L"data/se/jyoon/4651.wav",
   L"data/se/jyoon/4652.wav",
   L"data/se/jyoon/4653.wav",
   L"data/se/jyoon/4654.wav",
   L"data/se/jyoon/4655.wav",
   L"data/se/jyoon/4656.wav",
   L"data/se/jyoon/4657.wav",
   L"data/se/jyoon/4659.wav",
   L"data/se/jyoon/4660.wav",
   L"data/se/jyoon/4661.wav",
   L"data/se/jyoon/4663.wav",
   L"data/se/jyoon/4665.wav",
   L"data/se/jyoon/4674.wav",
   L"data/se/jyoon/4675.wav",
   L"data/se/jyoon/4676.wav",
   L"data/se/jyoon/4677.wav",
   L"data/se/jyoon/4679.wav",
   L"data/se/jyoon/4680.wav",
   L"data/se/jyoon/4681.wav",
   L"data/se/jyoon/4682.wav",
   L"data/se/jyoon/4683.wav",
   L"data/se/jyoon/4684.wav",
   L"data/se/jyoon/4685.wav",
   L"data/se/jyoon/4686.wav",
   L"data/se/jyoon.csv",
   L"data/se/kasen/3000.wav",
   L"data/se/kasen/3002.wav",
   L"data/se/kasen/3004.wav",
   L"data/se/kasen/3006.wav",
   L"data/se/kasen/3008.wav",
   L"data/se/kasen/3010.wav",
   L"data/se/kasen/3012.wav",
   L"data/se/kasen/3021.wav",
   L"data/se/kasen/3023.wav",
   L"data/se/kasen/3024.wav",
   L"data/se/kasen/3026.wav",
   L"data/se/kasen/3027.wav",
   L"data/se/kasen/3028.wav",
   L"data/se/kasen/3030.wav",
   L"data/se/kasen/3031.wav",
   L"data/se/kasen/3033.wav",
   L"data/se/kasen/3034.wav",
   L"data/se/kasen/3035.wav",
   L"data/se/kasen/3038.wav",
   L"data/se/kasen/3039.wav",
   L"data/se/kasen/3040.wav",
   L"data/se/kasen/3041.wav",
   L"data/se/kasen/3043.wav",
   L"data/se/kasen/3045.wav",
   L"data/se/kasen/3046.wav",
   L"data/se/kasen/3048.wav",
   L"data/se/kasen/3050.wav",
   L"data/se/kasen/3051.wav",
   L"data/se/kasen/3052.wav",
   L"data/se/kasen/3053.wav",
   L"data/se/kasen/3054.wav",
   L"data/se/kasen/3055.wav",
   L"data/se/kasen/3056.wav",
   L"data/se/kasen/3057.wav",
   L"data/se/kasen/3058.wav",
   L"data/se/kasen/3059.wav",
   L"data/se/kasen/3060.wav",
   L"data/se/kasen/3061.wav",
   L"data/se/kasen/3062.wav",
   L"data/se/kasen/3063.wav",
   L"data/se/kasen/3065.wav",
   L"data/se/kasen/3068.wav",
   L"data/se/kasen/3069.wav",
   L"data/se/kasen/3070.wav",
   L"data/se/kasen/3071.wav",
   L"data/se/kasen/3073.wav",
   L"data/se/kasen/3074.wav",
   L"data/se/kasen/3075.wav",
   L"data/se/kasen/3076.wav",
   L"data/se/kasen/3078.wav",
   L"data/se/kasen/3080.wav",
   L"data/se/kasen/3081.wav",
   L"data/se/kasen.csv",
   L"data/se/koishi/2400.wav",
   L"data/se/koishi/2402.wav",
   L"data/se/koishi/2403.wav",
   L"data/se/koishi/2405.wav",
   L"data/se/koishi/2407.wav",
   L"data/se/koishi/2408.wav",
   L"data/se/koishi/2411.wav",
   L"data/se/koishi/2413.wav",
   L"data/se/koishi/2414.wav",
   L"data/se/koishi/2415.wav",
   L"data/se/koishi/2417.wav",
   L"data/se/koishi/2420.wav",
   L"data/se/koishi/2422.wav",
   L"data/se/koishi/2423.wav",
   L"data/se/koishi/2425.wav",
   L"data/se/koishi/2430.wav",
   L"data/se/koishi/2431.wav",
   L"data/se/koishi/2432.wav",
   L"data/se/koishi/2433.wav",
   L"data/se/koishi/2435.wav",
   L"data/se/koishi/2436.wav",
   L"data/se/koishi/2438.wav",
   L"data/se/koishi/2439.wav",
   L"data/se/koishi/2440.wav",
   L"data/se/koishi/2441.wav",
   L"data/se/koishi/2442.wav",
   L"data/se/koishi/2443.wav",
   L"data/se/koishi/2445.wav",
   L"data/se/koishi/2446.wav",
   L"data/se/koishi/2447.wav",
   L"data/se/koishi/2450.wav",
   L"data/se/koishi/2451.wav",
   L"data/se/koishi/2452.wav",
   L"data/se/koishi/2453.wav",
   L"data/se/koishi/2454.wav",
   L"data/se/koishi/2455.wav",
   L"data/se/koishi/2457.wav",
   L"data/se/koishi/2458.wav",
   L"data/se/koishi/2459.wav",
   L"data/se/koishi/2460.wav",
   L"data/se/koishi/2461.wav",
   L"data/se/koishi/2463.wav",
   L"data/se/koishi/2465.wav",
   L"data/se/koishi/2500.wav",
   L"data/se/koishi/2502.wav",
   L"data/se/koishi/2504.wav",
   L"data/se/koishi/2505.wav",
   L"data/se/koishi/2506.wav",
   L"data/se/koishi/2507.wav",
   L"data/se/koishi/2550.wav",
   L"data/se/koishi/2552.wav",
   L"data/se/koishi/2553.wav",
   L"data/se/koishi/2555.wav",
   L"data/se/koishi/2556.wav",
   L"data/se/koishi/2590.wav",
   L"data/se/koishi/2591.wav",
   L"data/se/koishi/2592.wav",
   L"data/se/koishi/2594.wav",
   L"data/se/koishi/2595.wav",
   L"data/se/koishi/2596.wav",
   L"data/se/koishi/2598.wav",
   L"data/se/koishi/2599.wav",
   L"data/se/koishi.csv",
   L"data/se/kokoro/2800.wav",
   L"data/se/kokoro/2802.wav",
   L"data/se/kokoro/2804.wav",
   L"data/se/kokoro/2806.wav",
   L"data/se/kokoro/2808.wav",
   L"data/se/kokoro/2810.wav",
   L"data/se/kokoro/2812.wav",
   L"data/se/kokoro/2813.wav",
   L"data/se/kokoro/2816.wav",
   L"data/se/kokoro/2817.wav",
   L"data/se/kokoro/2820.wav",
   L"data/se/kokoro/2822.wav",
   L"data/se/kokoro/2824.wav",
   L"data/se/kokoro/2826.wav",
   L"data/se/kokoro/2827.wav",
   L"data/se/kokoro/2900.wav",
   L"data/se/kokoro/2902.wav",
   L"data/se/kokoro/2905.wav",
   L"data/se/kokoro/2907.wav",
   L"data/se/kokoro/2909.wav",
   L"data/se/kokoro/2912.wav",
   L"data/se/kokoro/2913.wav",
   L"data/se/kokoro/2914.wav",
   L"data/se/kokoro/2917.wav",
   L"data/se/kokoro/2918.wav",
   L"data/se/kokoro/2921.wav",
   L"data/se/kokoro/2922.wav",
   L"data/se/kokoro/2925.wav",
   L"data/se/kokoro/2926.wav",
   L"data/se/kokoro/2927.wav",
   L"data/se/kokoro/2929.wav",
   L"data/se/kokoro/2930.wav",
   L"data/se/kokoro/2931.wav",
   L"data/se/kokoro/2932.wav",
   L"data/se/kokoro/2933.wav",
   L"data/se/kokoro/2934.wav",
   L"data/se/kokoro/2935.wav",
   L"data/se/kokoro/2950.wav",
   L"data/se/kokoro/2951.wav",
   L"data/se/kokoro/2952.wav",
   L"data/se/kokoro/2955.wav",
   L"data/se/kokoro/2970.wav",
   L"data/se/kokoro/2972.wav",
   L"data/se/kokoro/2975.wav",
   L"data/se/kokoro/2977.wav",
   L"data/se/kokoro/2980.wav",
   L"data/se/kokoro/2981.wav",
   L"data/se/kokoro/2982.wav",
   L"data/se/kokoro/2983.wav",
   L"data/se/kokoro/2984.wav",
   L"data/se/kokoro/2985.wav",
   L"data/se/kokoro/2986.wav",
   L"data/se/kokoro/2987.wav",
   L"data/se/kokoro/2990.wav",
   L"data/se/kokoro/2992.wav",
   L"data/se/kokoro/2993.wav",
   L"data/se/kokoro/2994.wav",
   L"data/se/kokoro/2996.wav",
   L"data/se/kokoro/2997.wav",
   L"data/se/kokoro/2998.wav",
   L"data/se/kokoro.csv",
   L"data/se/mamizou/2600.wav",
   L"data/se/mamizou/2601.wav",
   L"data/se/mamizou/2602.wav",
   L"data/se/mamizou/2604.wav",
   L"data/se/mamizou/2605.wav",
   L"data/se/mamizou/2606.wav",
   L"data/se/mamizou/2609.wav",
   L"data/se/mamizou/2610.wav",
   L"data/se/mamizou/2611.wav",
   L"data/se/mamizou/2612.wav",
   L"data/se/mamizou/2613.wav",
   L"data/se/mamizou/2614.wav",
   L"data/se/mamizou/2615.wav",
   L"data/se/mamizou/2617.wav",
   L"data/se/mamizou/2619.wav",
   L"data/se/mamizou/2620.wav",
   L"data/se/mamizou/2621.wav",
   L"data/se/mamizou/2622.wav",
   L"data/se/mamizou/2625.wav",
   L"data/se/mamizou/2627.wav",
   L"data/se/mamizou/2628.wav",
   L"data/se/mamizou/2629.wav",
   L"data/se/mamizou/2631.wav",
   L"data/se/mamizou/2637.wav",
   L"data/se/mamizou/2638.wav",
   L"data/se/mamizou/2639.wav",
   L"data/se/mamizou/2640.wav",
   L"data/se/mamizou/2641.wav",
   L"data/se/mamizou/2642.wav",
   L"data/se/mamizou/2643.wav",
   L"data/se/mamizou/2644.wav",
   L"data/se/mamizou/2650.wav",
   L"data/se/mamizou/2652.wav",
   L"data/se/mamizou/2654.wav",
   L"data/se/mamizou/2655.wav",
   L"data/se/mamizou/2658.wav",
   L"data/se/mamizou/2660.wav",
   L"data/se/mamizou/2661.wav",
   L"data/se/mamizou/2662.wav",
   L"data/se/mamizou/2663.wav",
   L"data/se/mamizou/2664.wav",
   L"data/se/mamizou/2667.wav",
   L"data/se/mamizou/2668.wav",
   L"data/se/mamizou/2669.wav",
   L"data/se/mamizou/2670.wav",
   L"data/se/mamizou/2672.wav",
   L"data/se/mamizou/2673.wav",
   L"data/se/mamizou/2674.wav",
   L"data/se/mamizou/2690.wav",
   L"data/se/mamizou/2691.wav",
   L"data/se/mamizou/2692.wav",
   L"data/se/mamizou/2693.wav",
   L"data/se/mamizou/2695.wav",
   L"data/se/mamizou/2697.wav",
   L"data/se/mamizou/2699.wav",
   L"data/se/mamizou/2701.wav",
   L"data/se/mamizou/2703.wav",
   L"data/se/mamizou/2705.wav",
   L"data/se/mamizou/2707.wav",
   L"data/se/mamizou/2708.wav",
   L"data/se/mamizou/2709.wav",
   L"data/se/mamizou/2710.wav",
   L"data/se/mamizou/2711.wav",
   L"data/se/mamizou/2712.wav",
   L"data/se/mamizou/2713.wav",
   L"data/se/mamizou/2714.wav",
   L"data/se/mamizou/2715.wav",
   L"data/se/mamizou.csv",
   L"data/se/marisa/1200.wav",
   L"data/se/marisa/1202.wav",
   L"data/se/marisa/1204.wav",
   L"data/se/marisa/1206.wav",
   L"data/se/marisa/1208.wav",
   L"data/se/marisa/1210.wav",
   L"data/se/marisa/1216.wav",
   L"data/se/marisa/1224.wav",
   L"data/se/marisa/1225.wav",
   L"data/se/marisa/1250.wav",
   L"data/se/marisa/1251.wav",
   L"data/se/marisa/1253.wav",
   L"data/se/marisa/1258.wav",
   L"data/se/marisa/1259.wav",
   L"data/se/marisa/1262.wav",
   L"data/se/marisa/1263.wav",
   L"data/se/marisa/1264.wav",
   L"data/se/marisa/1266.wav",
   L"data/se/marisa/1267.wav",
   L"data/se/marisa/1268.wav",
   L"data/se/marisa/1270.wav",
   L"data/se/marisa/1272.wav",
   L"data/se/marisa/1273.wav",
   L"data/se/marisa/1274.wav",
   L"data/se/marisa/1275.wav",
   L"data/se/marisa/1276.wav",
   L"data/se/marisa/1279.wav",
   L"data/se/marisa/1280.wav",
   L"data/se/marisa/1281.wav",
   L"data/se/marisa/1290.wav",
   L"data/se/marisa/1291.wav",
   L"data/se/marisa/1292.wav",
   L"data/se/marisa/1293.wav",
   L"data/se/marisa/1300.wav",
   L"data/se/marisa/1302.wav",
   L"data/se/marisa/1303.wav",
   L"data/se/marisa/1305.wav",
   L"data/se/marisa/1306.wav",
   L"data/se/marisa/1308.wav",
   L"data/se/marisa/1310.wav",
   L"data/se/marisa/1312.wav",
   L"data/se/marisa/1314.wav",
   L"data/se/marisa/1315.wav",
   L"data/se/marisa/1350.wav",
   L"data/se/marisa/1351.wav",
   L"data/se/marisa/1352.wav",
   L"data/se/marisa/1354.wav",
   L"data/se/marisa/1356.wav",
   L"data/se/marisa/1358.wav",
   L"data/se/marisa/1359.wav",
   L"data/se/marisa/1363.wav",
   L"data/se/marisa/1364.wav",
   L"data/se/marisa/1366.wav",
   L"data/se/marisa/1367.wav",
   L"data/se/marisa/1368.wav",
   L"data/se/marisa/1369.wav",
   L"data/se/marisa/1371.wav",
   L"data/se/marisa/1373.wav",
   L"data/se/marisa/1390.wav",
   L"data/se/marisa.csv",
   L"data/se/miko/2000.wav",
   L"data/se/miko/2002.wav",
   L"data/se/miko/2004.wav",
   L"data/se/miko/2006.wav",
   L"data/se/miko/2008.wav",
   L"data/se/miko/2009.wav",
   L"data/se/miko/2011.wav",
   L"data/se/miko/2013.wav",
   L"data/se/miko/2015.wav",
   L"data/se/miko/2017.wav",
   L"data/se/miko/2050.wav",
   L"data/se/miko/2051.wav",
   L"data/se/miko/2053.wav",
   L"data/se/miko/2054.wav",
   L"data/se/miko/2100.wav",
   L"data/se/miko/2101.wav",
   L"data/se/miko/2102.wav",
   L"data/se/miko/2103.wav",
   L"data/se/miko/2105.wav",
   L"data/se/miko/2106.wav",
   L"data/se/miko/2108.wav",
   L"data/se/miko/2109.wav",
   L"data/se/miko/2111.wav",
   L"data/se/miko/2112.wav",
   L"data/se/miko/2113.wav",
   L"data/se/miko/2115.wav",
   L"data/se/miko/2117.wav",
   L"data/se/miko/2120.wav",
   L"data/se/miko/2121.wav",
   L"data/se/miko/2123.wav",
   L"data/se/miko/2124.wav",
   L"data/se/miko/2126.wav",
   L"data/se/miko/2128.wav",
   L"data/se/miko/2130.wav",
   L"data/se/miko/2131.wav",
   L"data/se/miko/2132.wav",
   L"data/se/miko/2133.wav",
   L"data/se/miko/2135.wav",
   L"data/se/miko/2136.wav",
   L"data/se/miko/2137.wav",
   L"data/se/miko/2150.wav",
   L"data/se/miko/2151.wav",
   L"data/se/miko/2152.wav",
   L"data/se/miko/2153.wav",
   L"data/se/miko/2154.wav",
   L"data/se/miko/2156.wav",
   L"data/se/miko/2158.wav",
   L"data/se/miko/2160.wav",
   L"data/se/miko/2161.wav",
   L"data/se/miko/2190.wav",
   L"data/se/miko/2191.wav",
   L"data/se/miko.csv",
   L"data/se/mokou/3200.wav",
   L"data/se/mokou/3204.wav",
   L"data/se/mokou/3208.wav",
   L"data/se/mokou/3210.wav",
   L"data/se/mokou/3214.wav",
   L"data/se/mokou/3220.wav",
   L"data/se/mokou/3224.wav",
   L"data/se/mokou/3226.wav",
   L"data/se/mokou/3228.wav",
   L"data/se/mokou/3230.wav",
   L"data/se/mokou/3232.wav",
   L"data/se/mokou/3234.wav",
   L"data/se/mokou/3235.wav",
   L"data/se/mokou/3236.wav",
   L"data/se/mokou/3237.wav",
   L"data/se/mokou/3240.wav",
   L"data/se/mokou/3241.wav",
   L"data/se/mokou/3242.wav",
   L"data/se/mokou/3250.wav",
   L"data/se/mokou/3252.wav",
   L"data/se/mokou/3254.wav",
   L"data/se/mokou/3255.wav",
   L"data/se/mokou/3257.wav",
   L"data/se/mokou/3258.wav",
   L"data/se/mokou/3261.wav",
   L"data/se/mokou/3263.wav",
   L"data/se/mokou/3264.wav",
   L"data/se/mokou/3265.wav",
   L"data/se/mokou/3267.wav",
   L"data/se/mokou/3269.wav",
   L"data/se/mokou/3271.wav",
   L"data/se/mokou/3272.wav",
   L"data/se/mokou/3273.wav",
   L"data/se/mokou/3275.wav",
   L"data/se/mokou/3277.wav",
   L"data/se/mokou/3279.wav",
   L"data/se/mokou/3281.wav",
   L"data/se/mokou/3282.wav",
   L"data/se/mokou/3284.wav",
   L"data/se/mokou/3285.wav",
   L"data/se/mokou/3287.wav",
   L"data/se/mokou/3288.wav",
   L"data/se/mokou/3289.wav",
   L"data/se/mokou/3290.wav",
   L"data/se/mokou/3292.wav",
   L"data/se/mokou/3293.wav",
   L"data/se/mokou/3294.wav",
   L"data/se/mokou/3295.wav",
   L"data/se/mokou/3296.wav",
   L"data/se/mokou/3297.wav",
   L"data/se/mokou/3298.wav",
   L"data/se/mokou/3299.wav",
   L"data/se/mokou/3300.wav",
   L"data/se/mokou/3301.wav",
   L"data/se/mokou/3302.wav",
   L"data/se/mokou/3303.wav",
   L"data/se/mokou/3304.wav",
   L"data/se/mokou/3305.wav",
   L"data/se/mokou.csv",
   L"data/se/nitori/2200.wav",
   L"data/se/nitori/2201.wav",
   L"data/se/nitori/2202.wav",
   L"data/se/nitori/2203.wav",
   L"data/se/nitori/2210.wav",
   L"data/se/nitori/2212.wav",
   L"data/se/nitori/2214.wav",
   L"data/se/nitori/2216.wav",
   L"data/se/nitori/2218.wav",
   L"data/se/nitori/2219.wav",
   L"data/se/nitori/2220.wav",
   L"data/se/nitori/2222.wav",
   L"data/se/nitori/2223.wav",
   L"data/se/nitori/2225.wav",
   L"data/se/nitori/2227.wav",
   L"data/se/nitori/2229.wav",
   L"data/se/nitori/2230.wav",
   L"data/se/nitori/2231.wav",
   L"data/se/nitori/2232.wav",
   L"data/se/nitori/2234.wav",
   L"data/se/nitori/2251.wav",
   L"data/se/nitori/2252.wav",
   L"data/se/nitori/2253.wav",
   L"data/se/nitori/2254.wav",
   L"data/se/nitori/2255.wav",
   L"data/se/nitori/2256.wav",
   L"data/se/nitori/2257.wav",
   L"data/se/nitori/2258.wav",
   L"data/se/nitori/2259.wav",
   L"data/se/nitori/2261.wav",
   L"data/se/nitori/2262.wav",
   L"data/se/nitori/2264.wav",
   L"data/se/nitori/2265.wav",
   L"data/se/nitori/2269.wav",
   L"data/se/nitori/2270.wav",
   L"data/se/nitori/2272.wav",
   L"data/se/nitori/2274.wav",
   L"data/se/nitori/2275.wav",
   L"data/se/nitori/2279.wav",
   L"data/se/nitori/2281.wav",
   L"data/se/nitori/2282.wav",
   L"data/se/nitori/2283.wav",
   L"data/se/nitori/2286.wav",
   L"data/se/nitori/2287.wav",
   L"data/se/nitori/2288.wav",
   L"data/se/nitori/2291.wav",
   L"data/se/nitori/2300.wav",
   L"data/se/nitori/2301.wav",
   L"data/se/nitori/2302.wav",
   L"data/se/nitori/2303.wav",
   L"data/se/nitori/2304.wav",
   L"data/se/nitori/2305.wav",
   L"data/se/nitori/2306.wav",
   L"data/se/nitori/2309.wav",
   L"data/se/nitori/2310.wav",
   L"data/se/nitori/2311.wav",
   L"data/se/nitori/2313.wav",
   L"data/se/nitori/2315.wav",
   L"data/se/nitori/2350.wav",
   L"data/se/nitori/2352.wav",
   L"data/se/nitori/2353.wav",
   L"data/se/nitori/2355.wav",
   L"data/se/nitori/2357.wav",
   L"data/se/nitori/2390.wav",
   L"data/se/nitori/2391.wav",
   L"data/se/nitori/2392.wav",
   L"data/se/nitori/2393.wav",
   L"data/se/nitori/2394.wav",
   L"data/se/nitori/2395.wav",
   L"data/se/nitori/2396.wav",
   L"data/se/nitori/2397.wav",
   L"data/se/nitori.csv",
   L"data/se/reimu/1050.wav",
   L"data/se/reimu/1051.wav",
   L"data/se/reimu/1052.wav",
   L"data/se/reimu/1053.wav",
   L"data/se/reimu/1054.wav",
   L"data/se/reimu/1055.wav",
   L"data/se/reimu/1056.wav",
   L"data/se/reimu/1057.wav",
   L"data/se/reimu/1061.wav",
   L"data/se/reimu/1063.wav",
   L"data/se/reimu/1070.wav",
   L"data/se/reimu/1071.wav",
   L"data/se/reimu/1072.wav",
   L"data/se/reimu/1073.wav",
   L"data/se/reimu/1074.wav",
   L"data/se/reimu/1075.wav",
   L"data/se/reimu/1076.wav",
   L"data/se/reimu/1077.wav",
   L"data/se/reimu/1079.wav",
   L"data/se/reimu/1090.wav",
   L"data/se/reimu/1091.wav",
   L"data/se/reimu/1092.wav",
   L"data/se/reimu/1093.wav",
   L"data/se/reimu/1094.wav",
   L"data/se/reimu/1095.wav",
   L"data/se/reimu/1100.wav",
   L"data/se/reimu/1101.wav",
   L"data/se/reimu/1102.wav",
   L"data/se/reimu/1103.wav",
   L"data/se/reimu/1104.wav",
   L"data/se/reimu/1105.wav",
   L"data/se/reimu/1106.wav",
   L"data/se/reimu/1107.wav",
   L"data/se/reimu/1108.wav",
   L"data/se/reimu/1109.wav",
   L"data/se/reimu/1111.wav",
   L"data/se/reimu/1113.wav",
   L"data/se/reimu/1114.wav",
   L"data/se/reimu/1115.wav",
   L"data/se/reimu/1116.wav",
   L"data/se/reimu/1117.wav",
   L"data/se/reimu/1118.wav",
   L"data/se/reimu/1120.wav",
   L"data/se/reimu/1131.wav",
   L"data/se/reimu/1133.wav",
   L"data/se/reimu/1138.wav",
   L"data/se/reimu/1150.wav",
   L"data/se/reimu/1155.wav",
   L"data/se/reimu/1156.wav",
   L"data/se/reimu/1160.wav",
   L"data/se/reimu/1163.wav",
   L"data/se/reimu/1164.wav",
   L"data/se/reimu/1165.wav",
   L"data/se/reimu/1170.wav",
   L"data/se/reimu/1174.wav",
   L"data/se/reimu/1175.wav",
   L"data/se/reimu/1176.wav",
   L"data/se/reimu/1190.wav",
   L"data/se/reimu/1191.wav",
   L"data/se/reimu/1192.wav",
   L"data/se/reimu/1193.wav",
   L"data/se/reimu.csv",
   L"data/se/se.csv",
   L"data/se/sinmyoumaru/3400.wav",
   L"data/se/sinmyoumaru/3404.wav",
   L"data/se/sinmyoumaru/3408.wav",
   L"data/se/sinmyoumaru/3412.wav",
   L"data/se/sinmyoumaru/3416.wav",
   L"data/se/sinmyoumaru/3430.wav",
   L"data/se/sinmyoumaru/3432.wav",
   L"data/se/sinmyoumaru/3434.wav",
   L"data/se/sinmyoumaru/3437.wav",
   L"data/se/sinmyoumaru/3438.wav",
   L"data/se/sinmyoumaru/3440.wav",
   L"data/se/sinmyoumaru/3442.wav",
   L"data/se/sinmyoumaru/3444.wav",
   L"data/se/sinmyoumaru/3445.wav",
   L"data/se/sinmyoumaru/3447.wav",
   L"data/se/sinmyoumaru/3449.wav",
   L"data/se/sinmyoumaru/3450.wav",
   L"data/se/sinmyoumaru/3453.wav",
   L"data/se/sinmyoumaru/3455.wav",
   L"data/se/sinmyoumaru/3456.wav",
   L"data/se/sinmyoumaru/3457.wav",
   L"data/se/sinmyoumaru/3458.wav",
   L"data/se/sinmyoumaru/3459.wav",
   L"data/se/sinmyoumaru/3460.wav",
   L"data/se/sinmyoumaru/3461.wav",
   L"data/se/sinmyoumaru/3462.wav",
   L"data/se/sinmyoumaru/3464.wav",
   L"data/se/sinmyoumaru/3466.wav",
   L"data/se/sinmyoumaru/3470.wav",
   L"data/se/sinmyoumaru/3472.wav",
   L"data/se/sinmyoumaru/3474.wav",
   L"data/se/sinmyoumaru/3475.wav",
   L"data/se/sinmyoumaru/3476.wav",
   L"data/se/sinmyoumaru/3477.wav",
   L"data/se/sinmyoumaru/3479.wav",
   L"data/se/sinmyoumaru/3480.wav",
   L"data/se/sinmyoumaru/3481.wav",
   L"data/se/sinmyoumaru/3482.wav",
   L"data/se/sinmyoumaru/3483.wav",
   L"data/se/sinmyoumaru/3486.wav",
   L"data/se/sinmyoumaru/3487.wav",
   L"data/se/sinmyoumaru/3488.wav",
   L"data/se/sinmyoumaru/3489.wav",
   L"data/se/sinmyoumaru/3490.wav",
   L"data/se/sinmyoumaru/3491.wav",
   L"data/se/sinmyoumaru/3493.wav",
   L"data/se/sinmyoumaru/3494.wav",
   L"data/se/sinmyoumaru/3495.wav",
   L"data/se/sinmyoumaru/3496.wav",
   L"data/se/sinmyoumaru.csv",
   L"data/se/system/connect_complete.wav",
   L"data/se/system/sys_cancel.wav",
   L"data/se/system/sys_cursor.wav",
   L"data/se/system/sys_invalid.wav",
   L"data/se/system/sys_ok.wav",
   L"data/se/system/sys_page.wav",
   L"data/se/system/sys_pause_on.wav",
   L"data/se/system/talk_balloon.wav",
   L"data/se/tenshi/4200.wav",
   L"data/se/tenshi/4202.wav",
   L"data/se/tenshi/4204.wav",
   L"data/se/tenshi/4206.wav",
   L"data/se/tenshi/4208.wav",
   L"data/se/tenshi/4210.wav",
   L"data/se/tenshi/4212.wav",
   L"data/se/tenshi/4213.wav",
   L"data/se/tenshi/4214.wav",
   L"data/se/tenshi/4216.wav",
   L"data/se/tenshi/4217.wav",
   L"data/se/tenshi/4219.wav",
   L"data/se/tenshi/4221.wav",
   L"data/se/tenshi/4223.wav",
   L"data/se/tenshi/4225.wav",
   L"data/se/tenshi/4226.wav",
   L"data/se/tenshi/4229.wav",
   L"data/se/tenshi/4230.wav",
   L"data/se/tenshi/4231.wav",
   L"data/se/tenshi/4233.wav",
   L"data/se/tenshi/4234.wav",
   L"data/se/tenshi/4235.wav",
   L"data/se/tenshi/4237.wav",
   L"data/se/tenshi/4238.wav",
   L"data/se/tenshi/4240.wav",
   L"data/se/tenshi/4241.wav",
   L"data/se/tenshi/4242.wav",
   L"data/se/tenshi/4243.wav",
   L"data/se/tenshi/4245.wav",
   L"data/se/tenshi/4246.wav",
   L"data/se/tenshi/4249.wav",
   L"data/se/tenshi/4253.wav",
   L"data/se/tenshi/4254.wav",
   L"data/se/tenshi/4255.wav",
   L"data/se/tenshi/4257.wav",
   L"data/se/tenshi/4258.wav",
   L"data/se/tenshi/4259.wav",
   L"data/se/tenshi/4260.wav",
   L"data/se/tenshi/4261.wav",
   L"data/se/tenshi/4264.wav",
   L"data/se/tenshi/4268.wav",
   L"data/se/tenshi/4275.wav",
   L"data/se/tenshi/4276.wav",
   L"data/se/tenshi.csv",
   L"data/se/udonge/3800.wav",
   L"data/se/udonge/3804.wav",
   L"data/se/udonge/3808.wav",
   L"data/se/udonge/3812.wav",
   L"data/se/udonge/3816.wav",
   L"data/se/udonge/3817.wav",
   L"data/se/udonge/3822.wav",
   L"data/se/udonge/3828.wav",
   L"data/se/udonge/3830.wav",
   L"data/se/udonge/3834.wav",
   L"data/se/udonge/3836.wav",
   L"data/se/udonge/3838.wav",
   L"data/se/udonge/3839.wav",
   L"data/se/udonge/3841.wav",
   L"data/se/udonge/3842.wav",
   L"data/se/udonge/3846.wav",
   L"data/se/udonge/3847.wav",
   L"data/se/udonge/3849.wav",
   L"data/se/udonge/3850.wav",
   L"data/se/udonge/3852.wav",
   L"data/se/udonge/3854.wav",
   L"data/se/udonge/3855.wav",
   L"data/se/udonge/3857.wav",
   L"data/se/udonge/3858.wav",
   L"data/se/udonge/3859.wav",
   L"data/se/udonge/3862.wav",
   L"data/se/udonge/3863.wav",
   L"data/se/udonge/3865.wav",
   L"data/se/udonge/3867.wav",
   L"data/se/udonge/3869.wav",
   L"data/se/udonge/3870.wav",
   L"data/se/udonge/3871.wav",
   L"data/se/udonge/3872.wav",
   L"data/se/udonge/3873.wav",
   L"data/se/udonge/3874.wav",
   L"data/se/udonge/3877.wav",
   L"data/se/udonge/3878.wav",
   L"data/se/udonge/3879.wav",
   L"data/se/udonge/3880.wav",
   L"data/se/udonge/3881.wav",
   L"data/se/udonge/3883.wav",
   L"data/se/udonge/3886.wav",
   L"data/se/udonge/3887.wav",
   L"data/se/udonge/3889.wav",
   L"data/se/udonge/3892.wav",
   L"data/se/udonge/3893.wav",
   L"data/se/udonge/3894.wav",
   L"data/se/udonge/3896.wav",
   L"data/se/udonge/3897.wav",
   L"data/se/udonge/3898.wav",
   L"data/se/udonge/3904.wav",
   L"data/se/udonge.csv",
   L"data/se/usami/3602.wav",
   L"data/se/usami/3606.wav",
   L"data/se/usami/3610.wav",
   L"data/se/usami/3614.wav",
   L"data/se/usami/3618.wav",
   L"data/se/usami/3624.wav",
   L"data/se/usami/3625.wav",
   L"data/se/usami/3627.wav",
   L"data/se/usami/3628.wav",
   L"data/se/usami/3630.wav",
   L"data/se/usami/3631.wav",
   L"data/se/usami/3633.wav",
   L"data/se/usami/3634.wav",
   L"data/se/usami/3635.wav",
   L"data/se/usami/3637.wav",
   L"data/se/usami/3638.wav",
   L"data/se/usami/3640.wav",
   L"data/se/usami/3641.wav",
   L"data/se/usami/3643.wav",
   L"data/se/usami/3645.wav",
   L"data/se/usami/3646.wav",
   L"data/se/usami/3647.wav",
   L"data/se/usami/3649.wav",
   L"data/se/usami/3650.wav",
   L"data/se/usami/3652.wav",
   L"data/se/usami/3653.wav",
   L"data/se/usami/3654.wav",
   L"data/se/usami/3655.wav",
   L"data/se/usami/3656.wav",
   L"data/se/usami/3658.wav",
   L"data/se/usami/3670.wav",
   L"data/se/usami/3672.wav",
   L"data/se/usami/3673.wav",
   L"data/se/usami/3675.wav",
   L"data/se/usami/3676.wav",
   L"data/se/usami/3678.wav",
   L"data/se/usami/3679.wav",
   L"data/se/usami/3680.wav",
   L"data/se/usami/3681.wav",
   L"data/se/usami/3683.wav",
   L"data/se/usami/3685.wav",
   L"data/se/usami/3687.wav",
   L"data/se/usami/3688.wav",
   L"data/se/usami/3689.wav",
   L"data/se/usami/3690.wav",
   L"data/se/usami/3691.wav",
   L"data/se/usami/3692.wav",
   L"data/se/usami/3693.wav",
   L"data/se/usami/3699.wav",
   L"data/se/usami/3700.wav",
   L"data/se/usami/3703.wav",
   L"data/se/usami/3704.wav",
   L"data/se/usami/3705.wav",
   L"data/se/usami/3706.wav",
   L"data/se/usami/3707.wav",
   L"data/se/usami/3708.wav",
   L"data/se/usami/3709.wav",
   L"data/se/usami/3710.wav",
   L"data/se/usami/3711.wav",
   L"data/se/usami/3717.wav",
   L"data/se/usami/3719.wav",
   L"data/se/usami.csv",
   L"data/se/yukari/4400.wav",
   L"data/se/yukari/4402.wav",
   L"data/se/yukari/4404.wav",
   L"data/se/yukari/4406.wav",
   L"data/se/yukari/4408.wav",
   L"data/se/yukari/4409.wav",
   L"data/se/yukari/4412.wav",
   L"data/se/yukari/4414.wav",
   L"data/se/yukari/4418.wav",
   L"data/se/yukari/4425.wav",
   L"data/se/yukari/4427.wav",
   L"data/se/yukari/4430.wav",
   L"data/se/yukari/4434.wav",
   L"data/se/yukari/4435.wav",
   L"data/se/yukari/4437.wav",
   L"data/se/yukari/4439.wav",
   L"data/se/yukari/4441.wav",
   L"data/se/yukari/4442.wav",
   L"data/se/yukari/4444.wav",
   L"data/se/yukari/4445.wav",
   L"data/se/yukari/4447.wav",
   L"data/se/yukari/4448.wav",
   L"data/se/yukari/4449.wav",
   L"data/se/yukari/4451.wav",
   L"data/se/yukari/4452.wav",
   L"data/se/yukari/4454.wav",
   L"data/se/yukari/4455.wav",
   L"data/se/yukari/4456.wav",
   L"data/se/yukari/4457.wav",
   L"data/se/yukari/4458.wav",
   L"data/se/yukari/4460.wav",
   L"data/se/yukari/4461.wav",
   L"data/se/yukari/4464.wav",
   L"data/se/yukari/4466.wav",
   L"data/se/yukari/4467.wav",
   L"data/se/yukari/4471.wav",
   L"data/se/yukari/4472.wav",
   L"data/se/yukari/4474.wav",
   L"data/se/yukari/4476.wav",
   L"data/se/yukari/4479.wav",
   L"data/se/yukari/4481.wav",
   L"data/se/yukari/4482.wav",
   L"data/se/yukari.csv",
   L"data/spell/doremy.csv",
   L"data/spell/doremy_0.png",
   L"data/spell/doremy_1.png",
   L"data/spell/doremy_2.png",
   L"data/spell/futo.csv",
   L"data/spell/futo_0.png",
   L"data/spell/futo_1.png",
   L"data/spell/futo_2.png",
   L"data/spell/hijiri.csv",
   L"data/spell/hijiri_0.png",
   L"data/spell/hijiri_1.png",
   L"data/spell/hijiri_2.png",
   L"data/spell/ichirin.csv",
   L"data/spell/ichirin_0.png",
   L"data/spell/ichirin_1.png",
   L"data/spell/ichirin_2.png",
   L"data/spell/jyoon.csv",
   L"data/spell/jyoon_0.png",
   L"data/spell/jyoon_1.png",
   L"data/spell/jyoon_2.png",
   L"data/spell/kasen.csv",
   L"data/spell/kasen_0.png",
   L"data/spell/kasen_1.png",
   L"data/spell/kasen_2.png",
   L"data/spell/koishi.csv",
   L"data/spell/koishi_0.png",
   L"data/spell/koishi_1.png",
   L"data/spell/koishi_2.png",
   L"data/spell/kokoro.csv",
   L"data/spell/kokoro_0.png",
   L"data/spell/kokoro_1.png",
   L"data/spell/kokoro_2.png",
   L"data/spell/mamizou.csv",
   L"data/spell/mamizou_0.png",
   L"data/spell/mamizou_1.png",
   L"data/spell/mamizou_2.png",
   L"data/spell/marisa.csv",
   L"data/spell/marisa_0.png",
   L"data/spell/marisa_1.png",
   L"data/spell/marisa_2.png",
   L"data/spell/miko.csv",
   L"data/spell/miko_0.png",
   L"data/spell/miko_1.png",
   L"data/spell/miko_2.png",
   L"data/spell/mokou.csv",
   L"data/spell/mokou_0.png",
   L"data/spell/mokou_1.png",
   L"data/spell/mokou_2.png",
   L"data/spell/nitori.csv",
   L"data/spell/nitori_0.png",
   L"data/spell/nitori_1.png",
   L"data/spell/nitori_2.png",
   L"data/spell/reimu.csv",
   L"data/spell/reimu_0.png",
   L"data/spell/reimu_1.png",
   L"data/spell/reimu_2.png",
   L"data/spell/sinmyoumaru.csv",
   L"data/spell/sinmyoumaru_0.png",
   L"data/spell/sinmyoumaru_1.png",
   L"data/spell/sinmyoumaru_2.png",
   L"data/spell/tenshi.csv",
   L"data/spell/tenshi_0.png",
   L"data/spell/tenshi_1.png",
   L"data/spell/tenshi_2.png",
   L"data/spell/udonge.csv",
   L"data/spell/udonge_0.png",
   L"data/spell/udonge_1.png",
   L"data/spell/udonge_2.png",
   L"data/spell/usami.csv",
   L"data/spell/usami_0.png",
   L"data/spell/usami_1.png",
   L"data/spell/usami_2.png",
   L"data/spell/yukari.csv",
   L"data/spell/yukari_0.png",
   L"data/spell/yukari_1.png",
   L"data/spell/yukari_2.png",
   L"data/story/spell_list/futo_stage_1.csv",
   L"data/story/spell_list/futo_stage_2.csv",
   L"data/story/spell_list/futo_stage_3.csv",
   L"data/story/spell_list/futo_stage_4.csv",
   L"data/story/spell_list/futo_stage_5.csv",
   L"data/story/spell_list/jyoon_stage_1.csv",
   L"data/story/spell_list/jyoon_stage_2.csv",
   L"data/story/spell_list/jyoon_stage_3.csv",
   L"data/story/spell_list/jyoon_stage_4.csv",
   L"data/story/spell_list/jyoon_stage_5.csv",
   L"data/story/spell_list/jyoon_stage_6.csv",
   L"data/story/spell_list/mamizou_stage_1.csv",
   L"data/story/spell_list/mamizou_stage_2.csv",
   L"data/story/spell_list/mamizou_stage_3.csv",
   L"data/story/spell_list/mamizou_stage_4.csv",
   L"data/story/spell_list/mamizou_stage_5.csv",
   L"data/story/spell_list/marisa_stage_1.csv",
   L"data/story/spell_list/marisa_stage_2.csv",
   L"data/story/spell_list/marisa_stage_3.csv",
   L"data/story/spell_list/marisa_stage_4.csv",
   L"data/story/spell_list/marisa_stage_5.csv",
   L"data/story/spell_list/miko_stage_1.csv",
   L"data/story/spell_list/miko_stage_2.csv",
   L"data/story/spell_list/miko_stage_3.csv",
   L"data/story/spell_list/miko_stage_4.csv",
   L"data/story/spell_list/miko_stage_5.csv",
   L"data/story/spell_list/nitori_stage_1.csv",
   L"data/story/spell_list/nitori_stage_2.csv",
   L"data/story/spell_list/nitori_stage_3.csv",
   L"data/story/spell_list/nitori_stage_4.csv",
   L"data/story/spell_list/nitori_stage_5.csv",
   L"data/story/spell_list/reimu_stage_1.csv",
   L"data/story/spell_list/reimu_stage_2.csv",
   L"data/story/spell_list/reimu_stage_3.csv",
   L"data/story/spell_list/reimu_stage_4.csv",
   L"data/story/spell_list/tenshi_stage_1.csv",
   L"data/story/spell_list/tenshi_stage_2.csv",
   L"data/story/spell_list/tenshi_stage_3.csv",
   L"data/story/spell_list/tenshi_stage_4.csv",
   L"data/story/spell_list/tenshi_stage_5.csv",
   L"data/story/spell_list/udonge_stage_1.csv",
   L"data/story/spell_list/udonge_stage_2.csv",
   L"data/story/spell_list/udonge_stage_3.csv",
   L"data/story/spell_list/udonge_stage_4.csv",
   L"data/story/spell_list/usami_stage_1.csv",
   L"data/story/spell_list/usami_stage_2.csv",
   L"data/story/spell_list/usami_stage_3.csv",
   L"data/story/spell_list/usami_stage_4.csv",
   L"data/story/spell_list/usami_stage_5.csv",
   L"data/story/spell_list/yukari_stage_1.csv",
   L"data/story/spell_list/yukari_stage_2.csv",
   L"data/story/stage_list/futo.csv",
   L"data/story/stage_list/jyoon.csv",
   L"data/story/stage_list/mamizou.csv",
   L"data/story/stage_list/marisa.csv",
   L"data/story/stage_list/miko.csv",
   L"data/story/stage_list/nitori.csv",
   L"data/story/stage_list/reimu.csv",
   L"data/story/stage_list/tenshi.csv",
   L"data/story/stage_list/udonge.csv",
   L"data/story/stage_list/usami.csv",
   L"data/story/stage_list/yukari.csv",
   L"data/system/back/back.nut",
   L"data/system/back/config_back.png",
   L"data/system/back/config_back2.png",
   L"data/system/back/config_front.png",
   L"data/system/boot/boot.nut",
   L"data/system/boot/boot.png",
   L"data/system/component/cursor.nut",
   L"data/system/component/menu_common.nut",
   L"data/system/component/network.nut",
   L"data/system/component/ui_base.nut",
   L"data/system/config/config.nut",
   L"data/system/config/config.pat",
   L"data/system/config/config.png",
   L"data/system/config/config_animation.nut",
   L"data/system/config/item.csv",
   L"data/system/cursor/back.png",
   L"data/system/cursor/cursor.nut",
   L"data/system/cursor/cursor.png",
   L"data/system/dialog/dialog.nut",
   L"data/system/dialog/mini_window.png",
   L"data/system/ed/ed.nut",
   L"data/system/ed/ed_back.png",
   L"data/system/ed/ed_message.png",
   L"data/system/ed/staffpic/ex_marisa.png",
   L"data/system/ed/staffpic/ex_reimu.png",
   L"data/system/ed/staffpic/ex_tenshi.png",
   L"data/system/ed/staffpic/ex_udon.png",
   L"data/system/ed/staffpic/ex_yukari.png",
   L"data/system/ed/staffpic/sakura.png",
   L"data/system/ed/staffpic/staffbg.png",
   L"data/system/ed/staffpic/staffmoji0.png",
   L"data/system/ed/staffpic/staffmoji1.png",
   L"data/system/ed/staffpic/staffmoji10.png",
   L"data/system/ed/staffpic/staffmoji11.png",
   L"data/system/ed/staffpic/staffmoji2.png",
   L"data/system/ed/staffpic/staffmoji3.png",
   L"data/system/ed/staffpic/staffmoji4.png",
   L"data/system/ed/staffpic/staffmoji5.png",
   L"data/system/ed/staffpic/staffmoji6.png",
   L"data/system/ed/staffpic/staffmoji7.png",
   L"data/system/ed/staffpic/staffmoji8.png",
   L"data/system/ed/staffpic/staffmoji9.png",
   L"data/system/ed/staffpic/staffpic0.png",
   L"data/system/ed/staffpic/staffpic1.png",
   L"data/system/ed/staffpic/staffpic2.png",
   L"data/system/ed/staffpic/staffpic3.png",
   L"data/system/ed/staffpic/staffpic4.png",
   L"data/system/ed/staffpic/staffpic5.png",
   L"data/system/ed/staffpic/staffwaku.png",
   L"data/system/ed/staffroll.csv",
   L"data/system/ed/staffroll.nut",
   L"data/system/help/help.nut",
   L"data/system/help/help.png",
   L"data/system/help/item.csv",
   L"data/system/key_config/config_moji1.png",
   L"data/system/key_config/config_pad1.png",
   L"data/system/key_config/config_pad2.png",
   L"data/system/key_config/key_config.nut",
   L"data/system/key_config/key_config.pat",
   L"data/system/key_config/key_config_animation.nut",
   L"data/system/key_config/parts.png",
   L"data/system/music_room/music_room.nut",
   L"data/system/music_room/music_room.pat",
   L"data/system/music_room/music_room_animation.nut",
   L"data/system/music_room/object.png",
   L"data/system/network/network.act",
   L"data/system/network/network.global.nut",
   L"data/system/network/network.nut",
   L"data/system/pause/item.csv",
   L"data/system/pause/pause.nut",
   L"data/system/pause/pause.pat",
   L"data/system/pause/pause.png",
   L"data/system/pause/pause_animation.nut",
   L"data/system/practice/item.csv",
   L"data/system/practice/practice.nut",
   L"data/system/practice/practice.pat",
   L"data/system/practice/practice_animation.nut",
   L"data/system/practice/practice_part000.png",
   L"data/system/replay_select/replay_object.png",
   L"data/system/replay_select/replay_select.act",
   L"data/system/replay_select/replay_select.nut",
   L"data/system/replay_select/replay_select_view.nut",
   L"data/system/select/back_000.png",
   L"data/system/select/center_object.png",
   L"data/system/select/character_select.pat",
   L"data/system/select/character_select2.pat",
   L"data/system/select/color_master/doremy.png",
   L"data/system/select/color_master/futo.png",
   L"data/system/select/color_master/hijiri.png",
   L"data/system/select/color_master/ichirin.png",
   L"data/system/select/color_master/jyoon.png",
   L"data/system/select/color_master/kasen.png",
   L"data/system/select/color_master/koishi.png",
   L"data/system/select/color_master/kokoro.png",
   L"data/system/select/color_master/mamizou.png",
   L"data/system/select/color_master/marisa.png",
   L"data/system/select/color_master/miko.png",
   L"data/system/select/color_master/mokou.png",
   L"data/system/select/color_master/nitori.png",
   L"data/system/select/color_master/reimu.png",
   L"data/system/select/color_master/sinmyoumaru.png",
   L"data/system/select/color_master/tenshi.png",
   L"data/system/select/color_master/udonge.png",
   L"data/system/select/color_master/usami.png",
   L"data/system/select/color_master/yukari.png",
   L"data/system/select/color_slave/doremy.png",
   L"data/system/select/color_slave/futo.png",
   L"data/system/select/color_slave/hijiri.png",
   L"data/system/select/color_slave/ichirin.png",
   L"data/system/select/color_slave/jyoon.png",
   L"data/system/select/color_slave/kasen.png",
   L"data/system/select/color_slave/koishi.png",
   L"data/system/select/color_slave/kokoro.png",
   L"data/system/select/color_slave/mamizou.png",
   L"data/system/select/color_slave/marisa.png",
   L"data/system/select/color_slave/miko.png",
   L"data/system/select/color_slave/mokou.png",
   L"data/system/select/color_slave/nitori.png",
   L"data/system/select/color_slave/reimu.png",
   L"data/system/select/color_slave/sinmyoumaru.png",
   L"data/system/select/color_slave/tenshi.png",
   L"data/system/select/color_slave/udonge.png",
   L"data/system/select/color_slave/usami.png",
   L"data/system/select/color_slave/yukari.png",
   L"data/system/select/master_frame_0.png",
   L"data/system/select/master_frame_back_1p.png",
   L"data/system/select/master_frame_back_2p.png",
   L"data/system/select/name/handle_name.csv",
   L"data/system/select/name/name.pat",
   L"data/system/select/name/name_000.png",
   L"data/system/select/name/name_001.png",
   L"data/system/select/name/name_002.png",
   L"data/system/select/name/name_003.png",
   L"data/system/select/name/name_004.png",
   L"data/system/select/name/name_005.png",
   L"data/system/select/name/name_006.png",
   L"data/system/select/name/name_007.png",
   L"data/system/select/name/name_008.png",
   L"data/system/select/name/name_009.png",
   L"data/system/select/name/name_010.png",
   L"data/system/select/name/name_011.png",
   L"data/system/select/name/name_012.png",
   L"data/system/select/name/name_013.png",
   L"data/system/select/name/name_014.png",
   L"data/system/select/name/name_015.png",
   L"data/system/select/name/name_016.png",
   L"data/system/select/name/name_017.png",
   L"data/system/select/name/name_018.png",
   L"data/system/select/name/name_back.png",
   L"data/system/select/name/name_b_000.png",
   L"data/system/select/name/name_b_001.png",
   L"data/system/select/name/name_b_002.png",
   L"data/system/select/name/name_b_003.png",
   L"data/system/select/name/name_b_004.png",
   L"data/system/select/name/name_b_005.png",
   L"data/system/select/name/name_b_006.png",
   L"data/system/select/name/name_b_007.png",
   L"data/system/select/name/name_b_008.png",
   L"data/system/select/name/name_b_009.png",
   L"data/system/select/name/name_b_010.png",
   L"data/system/select/name/name_b_011.png",
   L"data/system/select/name/name_b_012.png",
   L"data/system/select/name/name_b_013.png",
   L"data/system/select/name/name_b_014.png",
   L"data/system/select/name/name_b_015.png",
   L"data/system/select/name/name_b_016.png",
   L"data/system/select/name/name_b_017.png",
   L"data/system/select/name/name_b_018.png",
   L"data/system/select/name/name_c_000.png",
   L"data/system/select/name/name_c_001.png",
   L"data/system/select/name/name_c_002.png",
   L"data/system/select/name/name_c_003.png",
   L"data/system/select/name/name_c_004.png",
   L"data/system/select/name/name_c_005.png",
   L"data/system/select/name/name_c_006.png",
   L"data/system/select/name/name_c_007.png",
   L"data/system/select/name/name_c_008.png",
   L"data/system/select/name/name_c_009.png",
   L"data/system/select/name/name_c_010.png",
   L"data/system/select/name/name_c_011.png",
   L"data/system/select/name/name_c_012.png",
   L"data/system/select/name/name_c_013.png",
   L"data/system/select/name/name_c_014.png",
   L"data/system/select/name/name_c_015.png",
   L"data/system/select/name/name_c_016.png",
   L"data/system/select/name/name_c_017.png",
   L"data/system/select/name/name_c_018.png",
   L"data/system/select/parts.png",
   L"data/system/select/pic/face_000.png",
   L"data/system/select/pic/face_001.png",
   L"data/system/select/pic/face_002.png",
   L"data/system/select/pic/face_003.png",
   L"data/system/select/pic/face_b_000.png",
   L"data/system/select/pic/face_b_001.png",
   L"data/system/select/pic/face_b_002.png",
   L"data/system/select/pic/face_b_003.png",
   L"data/system/select/pic/face_doremy_a.png",
   L"data/system/select/pic/face_doremy_b.png",
   L"data/system/select/pic/face_futo_a.png",
   L"data/system/select/pic/face_futo_b.png",
   L"data/system/select/pic/face_hijiri_a.png",
   L"data/system/select/pic/face_hijiri_b.png",
   L"data/system/select/pic/face_ichirin_a.png",
   L"data/system/select/pic/face_ichirin_b.png",
   L"data/system/select/pic/face_jyoon_a.png",
   L"data/system/select/pic/face_jyoon_b.png",
   L"data/system/select/pic/face_kasen_a.png",
   L"data/system/select/pic/face_kasen_b.png",
   L"data/system/select/pic/face_koishi_a.png",
   L"data/system/select/pic/face_koishi_b.png",
   L"data/system/select/pic/face_kokoro_a.png",
   L"data/system/select/pic/face_kokoro_b.png",
   L"data/system/select/pic/face_mamizou_a.png",
   L"data/system/select/pic/face_mamizou_a_r.png",
   L"data/system/select/pic/face_mamizou_b.png",
   L"data/system/select/pic/face_mamizou_b_r.png",
   L"data/system/select/pic/face_miko_a.png",
   L"data/system/select/pic/face_miko_b.png",
   L"data/system/select/pic/face_nitori_a.png",
   L"data/system/select/pic/face_nitori_b.png",
   L"data/system/select/pic/face_sinmyoumaru_a.png",
   L"data/system/select/pic/face_sinmyoumaru_b.png",
   L"data/system/select/pic/face_tenshi_a.png",
   L"data/system/select/pic/face_tenshi_b.png",
   L"data/system/select/pic/face_usami_a.png",
   L"data/system/select/pic/face_usami_b.png",
   L"data/system/select/pic/face_yukari_a.png",
   L"data/system/select/pic/face_yukari_b.png",
   L"data/system/select/pic/pic.pat",
   L"data/system/select/script/animation_bgm.nut",
   L"data/system/select/script/animation_center.nut",
   L"data/system/select/script/animation_color.nut",
   L"data/system/select/script/animation_handle.nut",
   L"data/system/select/script/animation_item.nut",
   L"data/system/select/script/animation_master.nut",
   L"data/system/select/script/animation_name.nut",
   L"data/system/select/script/animation_name_slave.nut",
   L"data/system/select/script/animation_slave.nut",
   L"data/system/select/script/animation_spell.nut",
   L"data/system/select/script/animation_stage_center.nut",
   L"data/system/select/script/animation_stage_name.nut",
   L"data/system/select/script/animation_stage_title.nut",
   L"data/system/select/script/animation_story_character.nut",
   L"data/system/select/script/animation_story_title.nut",
   L"data/system/select/script/character_select_action.nut",
   L"data/system/select/script/character_select_animation.nut",
   L"data/system/select/script/story_select_action.nut",
   L"data/system/select/script/story_select_animation.nut",
   L"data/system/select/slave_frame_0.png",
   L"data/system/select/slave_frame_back_1p.png",
   L"data/system/select/slave_frame_back_2p.png",
   L"data/system/select/spell_frame_back_1p.png",
   L"data/system/select/stage_name/back_b_000.png",
   L"data/system/select/stage_name/back_b_001.png",
   L"data/system/select/stage_name/back_b_002.png",
   L"data/system/select/stage_name/back_b_003.png",
   L"data/system/select/stage_name/back_b_004.png",
   L"data/system/select/stage_name/back_b_005.png",
   L"data/system/select/stage_name/back_b_006.png",
   L"data/system/select/stage_name/back_b_007.png",
   L"data/system/select/stage_name/back_b_008.png",
   L"data/system/select/stage_name/back_b_009.png",
   L"data/system/select/stage_name/back_b_010.png",
   L"data/system/select/stage_name/back_b_011.png",
   L"data/system/select/stage_name/back_b_012.png",
   L"data/system/select/stage_name/back_b_013.png",
   L"data/system/select/stage_name/back_b_014.png",
   L"data/system/select/stage_name/back_b_015.png",
   L"data/system/select/stage_name/back_b_016.png",
   L"data/system/select/stage_name/back_b_017.png",
   L"data/system/select/stage_name/back_b_018.png",
   L"data/system/select/stage_name/back_name_000.png",
   L"data/system/select/stage_name/back_name_999.png",
   L"data/system/select/stage_name/name_back.png",
   L"data/system/select/stage_name/stage_name.pat",
   L"data/system/select/stage_parts.png",
   L"data/system/select/stage_pic/back_000.png",
   L"data/system/select/stage_pic/back_001.png",
   L"data/system/select/stage_pic/back_002.png",
   L"data/system/select/stage_pic/back_003.png",
   L"data/system/select/stage_pic/back_004.png",
   L"data/system/select/stage_pic/back_005.png",
   L"data/system/select/stage_pic/back_006.png",
   L"data/system/select/stage_pic/back_007.png",
   L"data/system/select/stage_pic/back_008.png",
   L"data/system/select/stage_pic/back_009.png",
   L"data/system/select/stage_pic/back_010.png",
   L"data/system/select/stage_pic/back_011.png",
   L"data/system/select/stage_pic/back_012.png",
   L"data/system/select/stage_pic/back_013.png",
   L"data/system/select/stage_pic/back_014.png",
   L"data/system/select/stage_pic/back_015.png",
   L"data/system/select/stage_pic/back_016.png",
   L"data/system/select/stage_pic/back_017.png",
   L"data/system/select/stage_pic/back_018.png",
   L"data/system/select/stage_pic/back_019.png",
   L"data/system/select/stage_pic/back_020.png",
   L"data/system/select/stage_pic/back_021.png",
   L"data/system/select/stage_pic/back_022.png",
   L"data/system/select/stage_pic/back_023.png",
   L"data/system/select/stage_pic/back_024.png",
   L"data/system/select/stage_pic/back_025.png",
   L"data/system/select/stage_pic/back_026.png",
   L"data/system/select/stage_pic/back_027.png",
   L"data/system/select/stage_pic/back_028.png",
   L"data/system/select/stage_pic/back_029.png",
   L"data/system/select/stage_pic/back_030.png",
   L"data/system/select/stage_pic/back_031.png",
   L"data/system/select/stage_pic/back_032.png",
   L"data/system/select/stage_pic/back_099.png",
   L"data/system/select/stage_pic/stage_pic.pat",
   L"data/system/select/story_pic/futo.png",
   L"data/system/select/story_pic/futo0.png",
   L"data/system/select/story_pic/futo1.png",
   L"data/system/select/story_pic/jyoon.png",
   L"data/system/select/story_pic/jyoon0.png",
   L"data/system/select/story_pic/jyoon1.png",
   L"data/system/select/story_pic/mamizou.png",
   L"data/system/select/story_pic/mamizou0.png",
   L"data/system/select/story_pic/mamizou1.png",
   L"data/system/select/story_pic/marisa.png",
   L"data/system/select/story_pic/marisa0.png",
   L"data/system/select/story_pic/marisa1.png",
   L"data/system/select/story_pic/miko.png",
   L"data/system/select/story_pic/miko0.png",
   L"data/system/select/story_pic/miko1.png",
   L"data/system/select/story_pic/nitori.png",
   L"data/system/select/story_pic/nitori0.png",
   L"data/system/select/story_pic/nitori1.png",
   L"data/system/select/story_pic/reimu.png",
   L"data/system/select/story_pic/reimu0.png",
   L"data/system/select/story_pic/reimu1.png",
   L"data/system/select/story_pic/story_pic.pat",
   L"data/system/select/story_pic/tenshi.png",
   L"data/system/select/story_pic/tenshi0.png",
   L"data/system/select/story_pic/tenshi1.png",
   L"data/system/select/story_pic/udonge.png",
   L"data/system/select/story_pic/udonge0.png",
   L"data/system/select/story_pic/udonge1.png",
   L"data/system/select/story_pic/usami.png",
   L"data/system/select/story_pic/usami0.png",
   L"data/system/select/story_pic/usami1.png",
   L"data/system/select/story_pic/yukari.png",
   L"data/system/select/story_pic/yukari0.png",
   L"data/system/select/story_pic/yukari1.png",
   L"data/system/select/story_title/name_futo.png",
   L"data/system/select/story_title/name_jyoon.png",
   L"data/system/select/story_title/name_mamizou.png",
   L"data/system/select/story_title/name_marisa.png",
   L"data/system/select/story_title/name_miko.png",
   L"data/system/select/story_title/name_nitori.png",
   L"data/system/select/story_title/name_reimu.png",
   L"data/system/select/story_title/name_tenshi.png",
   L"data/system/select/story_title/name_udonge.png",
   L"data/system/select/story_title/name_usami.png",
   L"data/system/select/story_title/name_yukari.png",
   L"data/system/select/story_title/stage_futo.png",
   L"data/system/select/story_title/stage_jyoon.png",
   L"data/system/select/story_title/stage_mamizou.png",
   L"data/system/select/story_title/stage_marisa.png",
   L"data/system/select/story_title/stage_miko.png",
   L"data/system/select/story_title/stage_nitori.png",
   L"data/system/select/story_title/stage_reimu.png",
   L"data/system/select/story_title/stage_tenshi.png",
   L"data/system/select/story_title/stage_udonge.png",
   L"data/system/select/story_title/stage_usami.png",
   L"data/system/select/story_title/stage_yukari.png",
   L"data/system/select/story_title/title_futo.png",
   L"data/system/select/story_title/title_jyoon.png",
   L"data/system/select/story_title/title_mamizou.png",
   L"data/system/select/story_title/title_marisa.png",
   L"data/system/select/story_title/title_miko.png",
   L"data/system/select/story_title/title_nitori.png",
   L"data/system/select/story_title/title_reimu.png",
   L"data/system/select/story_title/title_tenshi.png",
   L"data/system/select/story_title/title_udonge.png",
   L"data/system/select/story_title/title_usami.png",
   L"data/system/select/story_title/title_yukari.png",
   L"data/system/title/op.nut",
   L"data/system/title/op_000.png",
   L"data/system/title/op_001.png",
   L"data/system/title/title.nut",
   L"data/system/title/title.pat",
   L"data/system/title/title_animation.nut",
   L"data/system/title/title_back.png",
   L"data/system/title/title_logo_1.png",
   L"data/system/title/title_logo_2.png",
   L"data/system/title/title_object_1.png",
   L"data/system/title/title_text.png",
   L"data/system/tutorial/item.csv",
   L"data/system/tutorial/pause.png",
   L"data/system/tutorial/tutorial.act",
   L"data/system/tutorial/tutorial.global.nut",
   L"data/system/tutorial/tutorial.nut",
   L"data/system/watch/watch.nut",
   L"data/win/message/doremy.csv",
   L"data/win/message/futo.csv",
   L"data/win/message/hijiri.csv",
   L"data/win/message/ichirin.csv",
   L"data/win/message/jyoon.csv",
   L"data/win/message/kasen.csv",
   L"data/win/message/koishi.csv",
   L"data/win/message/kokoro.csv",
   L"data/win/message/mamizou.csv",
   L"data/win/message/marisa.csv",
   L"data/win/message/miko.csv",
   L"data/win/message/mokou.csv",
   L"data/win/message/nitori.csv",
   L"data/win/message/reimu.csv",
   L"data/win/message/sinmyoumaru.csv",
   L"data/win/message/tenshi.csv",
   L"data/win/message/udonge.csv",
   L"data/win/message/usami.csv",
   L"data/win/message/yukari.csv",
   L"data/win/rate/doremy.csv",
   L"data/win/rate/futo.csv",
   L"data/win/rate/hijiri.csv",
   L"data/win/rate/ichirin.csv",
   L"data/win/rate/jyoon.csv",
   L"data/win/rate/kasen.csv",
   L"data/win/rate/koishi.csv",
   L"data/win/rate/kokoro.csv",
   L"data/win/rate/mamizou.csv",
   L"data/win/rate/marisa.csv",
   L"data/win/rate/miko.csv",
   L"data/win/rate/mokou.csv",
   L"data/win/rate/nitori.csv",
   L"data/win/rate/reimu.csv",
   L"data/win/rate/sinmyoumaru.csv",
   L"data/win/rate/tenshi.csv",
   L"data/win/rate/udonge.csv",
   L"data/win/rate/usami.csv",
   L"data/win/rate/yukari.csv",

   // th155b.pak(ver1.10c)
   L"data/actor/common_texture/chargeBlue.png",
   L"data/actor/common_texture/win1P_en.png",
   L"data/actor/common_texture/win2P_en.png",
   L"data/actor/doremy/doremy.pat",
   L"data/actor/doremy/palette008.bmp",
   L"data/actor/doremy/palette009.bmp",
   L"data/actor/doremy/palette108.bmp",
   L"data/actor/doremy/palette109.bmp",
   L"data/actor/doremy/texture/blueFire000.png",
   L"data/actor/doremy/texture/win_doremy_en.png",
   L"data/actor/doremy.nut",
   L"data/actor/doremy_base.nut",
   L"data/actor/doremy_boss.nut",
   L"data/actor/doremy_boss_init.nut",
   L"data/actor/doremy_boss_shot.nut",
   L"data/actor/doremy_combo.nut",
   L"data/actor/doremy_init.nut",
   L"data/actor/doremy_shot.nut",
   L"data/actor/doremy_team.nut",
   L"data/actor/effect.nut",
   L"data/actor/futo/futo.pat",
   L"data/actor/futo/palette008.bmp",
   L"data/actor/futo/palette009.bmp",
   L"data/actor/futo/palette108.bmp",
   L"data/actor/futo/palette109.bmp",
   L"data/actor/futo/texture/futo_dish_mini.png",
   L"data/actor/futo/texture/futo_dish_mini001.png",
   L"data/actor/futo/texture/futo_dish_mini002.png",
   L"data/actor/futo/texture/futo_dish_mini003.png",
   L"data/actor/futo/texture/futo_dish_mini_bg.png",
   L"data/actor/futo/texture/futo_guage000.png",
   L"data/actor/futo/texture/win_futo.png",
   L"data/actor/futo/texture/win_futo_en.png",
   L"data/actor/futo.nut",
   L"data/actor/futo_base.nut",
   L"data/actor/futo_boss.nut",
   L"data/actor/futo_boss_shot.nut",
   L"data/actor/futo_init.nut",
   L"data/actor/futo_shot.nut",
   L"data/actor/hijiri/hijiri.pat",
   L"data/actor/hijiri/palette008.bmp",
   L"data/actor/hijiri/palette009.bmp",
   L"data/actor/hijiri/palette108.bmp",
   L"data/actor/hijiri/palette109.bmp",
   L"data/actor/hijiri/texture/win_hijiri.png",
   L"data/actor/hijiri/texture/win_hijiri_en.png",
   L"data/actor/hijiri_base.nut",
   L"data/actor/hijiri_boss.nut",
   L"data/actor/hijiri_boss_shot.nut",
   L"data/actor/hijiri_init.nut",
   L"data/actor/ichirin/ichirin.pat",
   L"data/actor/ichirin/palette008.bmp",
   L"data/actor/ichirin/palette009.bmp",
   L"data/actor/ichirin/palette108.bmp",
   L"data/actor/ichirin/palette109.bmp",
   L"data/actor/ichirin/texture/win_ichirin_en.png",
   L"data/actor/ichirin.nut",
   L"data/actor/ichirin_base.nut",
   L"data/actor/ichirin_boss.nut",
   L"data/actor/ichirin_boss_shot.nut",
   L"data/actor/jyoon/atk_front0000.bmp",
   L"data/actor/jyoon/atk_front0001.bmp",
   L"data/actor/jyoon/atk_front0002.bmp",
   L"data/actor/jyoon/atk_front0003.bmp",
   L"data/actor/jyoon/atk_front0004.bmp",
   L"data/actor/jyoon/atk_front0005.bmp",
   L"data/actor/jyoon/atk_front0006.bmp",
   L"data/actor/jyoon/atk_front0007.bmp",
   L"data/actor/jyoon/atk_front0008.bmp",
   L"data/actor/jyoon/atk_front0009.bmp",
   L"data/actor/jyoon/atk_under0000.bmp",
   L"data/actor/jyoon/atk_under0001.bmp",
   L"data/actor/jyoon/atk_under0002.bmp",
   L"data/actor/jyoon/atk_under0003.bmp",
   L"data/actor/jyoon/atk_under0004.bmp",
   L"data/actor/jyoon/atk_under0005.bmp",
   L"data/actor/jyoon/atk_under0006.bmp",
   L"data/actor/jyoon/atk_under0007.bmp",
   L"data/actor/jyoon/atk_under0008.bmp",
   L"data/actor/jyoon/atk_under0009.bmp",
   L"data/actor/jyoon/bag0000.bmp",
   L"data/actor/jyoon/bag0001.bmp",
   L"data/actor/jyoon/battle_beginA0000.bmp",
   L"data/actor/jyoon/battle_beginA0001.bmp",
   L"data/actor/jyoon/battle_beginA0002.bmp",
   L"data/actor/jyoon/battle_beginA0003.bmp",
   L"data/actor/jyoon/battle_beginA0004.bmp",
   L"data/actor/jyoon/battle_beginA0005.bmp",
   L"data/actor/jyoon/battle_beginA0006.bmp",
   L"data/actor/jyoon/battle_beginA0007.bmp",
   L"data/actor/jyoon/damage_down_loop0000.bmp",
   L"data/actor/jyoon/damage_down_loop0001.bmp",
   L"data/actor/jyoon/damage_down_loop0002.bmp",
   L"data/actor/jyoon/damage_down_loop0003.bmp",
   L"data/actor/jyoon/damage_down_loop0004.bmp",
   L"data/actor/jyoon/damage_down_loop0005.bmp",
   L"data/actor/jyoon/jyoon.pat",
   L"data/actor/jyoon/lastword_finish0000.bmp",
   L"data/actor/jyoon/lastword_finish0001.bmp",
   L"data/actor/jyoon/lastword_finish0002.bmp",
   L"data/actor/jyoon/lastword_finish0003.bmp",
   L"data/actor/jyoon/lastword_finish0004.bmp",
   L"data/actor/jyoon/lastword_finish0005.bmp",
   L"data/actor/jyoon/lastword_finish0006.bmp",
   L"data/actor/jyoon/lastword_finish0007.bmp",
   L"data/actor/jyoon/occult0002.bmp",
   L"data/actor/jyoon/occult0003.bmp",
   L"data/actor/jyoon/occult0004.bmp",
   L"data/actor/jyoon/occult0005.bmp",
   L"data/actor/jyoon/occult0006.bmp",
   L"data/actor/jyoon/palette000.bmp",
   L"data/actor/jyoon/palette001.bmp",
   L"data/actor/jyoon/palette002.bmp",
   L"data/actor/jyoon/palette003.bmp",
   L"data/actor/jyoon/palette004.bmp",
   L"data/actor/jyoon/palette005.bmp",
   L"data/actor/jyoon/palette006.bmp",
   L"data/actor/jyoon/palette007.bmp",
   L"data/actor/jyoon/palette008.bmp",
   L"data/actor/jyoon/palette009.bmp",
   L"data/actor/jyoon/palette100.bmp",
   L"data/actor/jyoon/palette101.bmp",
   L"data/actor/jyoon/palette102.bmp",
   L"data/actor/jyoon/palette103.bmp",
   L"data/actor/jyoon/palette104.bmp",
   L"data/actor/jyoon/palette105.bmp",
   L"data/actor/jyoon/palette106.bmp",
   L"data/actor/jyoon/palette107.bmp",
   L"data/actor/jyoon/palette108.bmp",
   L"data/actor/jyoon/palette109.bmp",
   L"data/actor/jyoon/shot_charge0000.bmp",
   L"data/actor/jyoon/shot_charge0001.bmp",
   L"data/actor/jyoon/shot_charge0002.bmp",
   L"data/actor/jyoon/shot_charge0003.bmp",
   L"data/actor/jyoon/shot_charge0004.bmp",
   L"data/actor/jyoon/shot_charge0005.bmp",
   L"data/actor/jyoon/shot_charge0006.bmp",
   L"data/actor/jyoon/shot_charge0007.bmp",
   L"data/actor/jyoon/shot_charge0008.bmp",
   L"data/actor/jyoon/shot_charge0009.bmp",
   L"data/actor/jyoon/shot_charge0010.bmp",
   L"data/actor/jyoon/skill_bag_throw0000.bmp",
   L"data/actor/jyoon/skill_bag_throw0001.bmp",
   L"data/actor/jyoon/skill_bag_throw0002.bmp",
   L"data/actor/jyoon/skill_bag_throw0003.bmp",
   L"data/actor/jyoon/skill_bag_throw0004.bmp",
   L"data/actor/jyoon/skill_bag_throw0005.bmp",
   L"data/actor/jyoon/skill_bag_throw0006.bmp",
   L"data/actor/jyoon/skill_bag_throw0007.bmp",
   L"data/actor/jyoon/skill_bag_throw0008.bmp",
   L"data/actor/jyoon/skill_dural0000.bmp",
   L"data/actor/jyoon/skill_dural0001.bmp",
   L"data/actor/jyoon/skill_dural0002.bmp",
   L"data/actor/jyoon/skill_dural0003.bmp",
   L"data/actor/jyoon/skill_dural0004.bmp",
   L"data/actor/jyoon/skill_dural0005.bmp",
   L"data/actor/jyoon/skill_dural0006.bmp",
   L"data/actor/jyoon/skill_dural0007.bmp",
   L"data/actor/jyoon/skill_dural0008.bmp",
   L"data/actor/jyoon/skill_jyurisen0000.bmp",
   L"data/actor/jyoon/skill_jyurisen0001.bmp",
   L"data/actor/jyoon/skill_jyurisen0002.bmp",
   L"data/actor/jyoon/skill_jyurisen0003.bmp",
   L"data/actor/jyoon/skill_jyurisen0004.bmp",
   L"data/actor/jyoon/skill_jyurisen0005.bmp",
   L"data/actor/jyoon/skill_jyurisen0006.bmp",
   L"data/actor/jyoon/skill_jyurisen0007.bmp",
   L"data/actor/jyoon/skill_typoon0000.bmp",
   L"data/actor/jyoon/skill_typoon0001.bmp",
   L"data/actor/jyoon/skill_typoon0002.bmp",
   L"data/actor/jyoon/skill_typoon0003.bmp",
   L"data/actor/jyoon/skill_typoon0004.bmp",
   L"data/actor/jyoon/skill_typoon0005.bmp",
   L"data/actor/jyoon/skill_typoon0006.bmp",
   L"data/actor/jyoon/skill_typoon0007.bmp",
   L"data/actor/jyoon/slide_downloop0000.bmp",
   L"data/actor/jyoon/slide_downloop0001.bmp",
   L"data/actor/jyoon/slide_downloop0002.bmp",
   L"data/actor/jyoon/slide_downloop0003.bmp",
   L"data/actor/jyoon/slide_downloop0004.bmp",
   L"data/actor/jyoon/slide_uploop0000.bmp",
   L"data/actor/jyoon/slide_uploop0001.bmp",
   L"data/actor/jyoon/slide_uploop0002.bmp",
   L"data/actor/jyoon/slide_uploop0003.bmp",
   L"data/actor/jyoon/slide_uploop0004.bmp",
   L"data/actor/jyoon/spellA_pre0000.bmp",
   L"data/actor/jyoon/spellA_pre0001.bmp",
   L"data/actor/jyoon/spellA_pre0002.bmp",
   L"data/actor/jyoon/spellA_pre0003.bmp",
   L"data/actor/jyoon/spellA_pre0004.bmp",
   L"data/actor/jyoon/spellA_pre0005.bmp",
   L"data/actor/jyoon/spellCall0005.bmp",
   L"data/actor/jyoon/spellC_finish0000.bmp",
   L"data/actor/jyoon/spellC_finish0001.bmp",
   L"data/actor/jyoon/spellC_finish0002.bmp",
   L"data/actor/jyoon/spellC_finish0003.bmp",
   L"data/actor/jyoon/spellC_loop0000.bmp",
   L"data/actor/jyoon/spellC_loop0001.bmp",
   L"data/actor/jyoon/spellC_loop0002.bmp",
   L"data/actor/jyoon/spellC_loop0003.bmp",
   L"data/actor/jyoon/spellC_loop0004.bmp",
   L"data/actor/jyoon/spellC_loop0005.bmp",
   L"data/actor/jyoon/spellC_loop0006.bmp",
   L"data/actor/jyoon/spellC_loop0007.bmp",
   L"data/actor/jyoon/texture/aura_atk_front000.png",
   L"data/actor/jyoon/texture/aura_atk_front001.png",
   L"data/actor/jyoon/texture/aura_atk_front002.png",
   L"data/actor/jyoon/texture/aura_atk_front003.png",
   L"data/actor/jyoon/texture/aura_atk_front004.png",
   L"data/actor/jyoon/texture/dance_table.png",
   L"data/actor/jyoon/texture/win_jyoon.png",
   L"data/actor/jyoon/texture/win_jyoon_en.png",
   L"data/actor/jyoon/walk_back0004.bmp",
   L"data/actor/jyoon/walk_back_loop0000.bmp",
   L"data/actor/jyoon/walk_back_loop0001.bmp",
   L"data/actor/jyoon/walk_back_loop0002.bmp",
   L"data/actor/jyoon/walk_back_loop0003.bmp",
   L"data/actor/jyoon/walk_front0000.bmp",
   L"data/actor/jyoon/walk_front0001.bmp",
   L"data/actor/jyoon/walk_front0002.bmp",
   L"data/actor/jyoon/walk_front0003.bmp",
   L"data/actor/jyoon/walk_front0004.bmp",
   L"data/actor/jyoon/walk_front0005.bmp",
   L"data/actor/jyoon/walk_front_loop0001.bmp",
   L"data/actor/jyoon/walk_front_loop0002.bmp",
   L"data/actor/jyoon/walk_front_loop0003.bmp",
   L"data/actor/jyoon/walk_front_loop0004.bmp",
   L"data/actor/jyoon/winA0000.bmp",
   L"data/actor/jyoon/winA0001.bmp",
   L"data/actor/jyoon/winA0002.bmp",
   L"data/actor/jyoon/winA0003.bmp",
   L"data/actor/jyoon/winA0004.bmp",
   L"data/actor/jyoon/winA0005.bmp",
   L"data/actor/jyoon/winA0006.bmp",
   L"data/actor/jyoon/winA0007.bmp",
   L"data/actor/jyoon.nut",
   L"data/actor/jyoon_base.nut",
   L"data/actor/jyoon_boss.nut",
   L"data/actor/jyoon_boss_base.nut",
   L"data/actor/jyoon_combo.nut",
   L"data/actor/jyoon_init.nut",
   L"data/actor/jyoon_shot.nut",
   L"data/actor/kasen/kasen.pat",
   L"data/actor/kasen/palette008.bmp",
   L"data/actor/kasen/palette009.bmp",
   L"data/actor/kasen/palette108.bmp",
   L"data/actor/kasen/palette109.bmp",
   L"data/actor/kasen/texture/blue_wave.png",
   L"data/actor/kasen/texture/win_kasen.png",
   L"data/actor/kasen/texture/win_kasen_en.png",
   L"data/actor/kasen.nut",
   L"data/actor/kasen_base.nut",
   L"data/actor/kasen_boss.nut",
   L"data/actor/kasen_boss_shot.nut",
   L"data/actor/kasen_combo.nut",
   L"data/actor/kasen_eagle.nut",
   L"data/actor/kasen_shot.nut",
   L"data/actor/koishi/koishi.pat",
   L"data/actor/koishi/palette008.bmp",
   L"data/actor/koishi/palette009.bmp",
   L"data/actor/koishi/palette108.bmp",
   L"data/actor/koishi/palette109.bmp",
   L"data/actor/koishi/texture/win_koishi.png",
   L"data/actor/koishi/texture/win_koishi_en.png",
   L"data/actor/koishi.nut",
   L"data/actor/koishi_base.nut",
   L"data/actor/koishi_boss.nut",
   L"data/actor/koishi_boss_base.nut",
   L"data/actor/koishi_boss_shot.nut",
   L"data/actor/koishi_init.nut",
   L"data/actor/koishi_shot.nut",
   L"data/actor/koishi_team.nut",
   L"data/actor/kokoro/damage_halfSpin0000.bmp",
   L"data/actor/kokoro/damage_halfSpin0001.bmp",
   L"data/actor/kokoro/damage_halfSpin0002.bmp",
   L"data/actor/kokoro/damage_halfSpin0003.bmp",
   L"data/actor/kokoro/damage_halfSpin0004.bmp",
   L"data/actor/kokoro/damage_halfSpin0005.bmp",
   L"data/actor/kokoro/damage_halfSpin0006.bmp",
   L"data/actor/kokoro/damage_halfSpin0007.bmp",
   L"data/actor/kokoro/kokoro.pat",
   L"data/actor/kokoro/palette000.bmp",
   L"data/actor/kokoro/palette008.bmp",
   L"data/actor/kokoro/palette009.bmp",
   L"data/actor/kokoro/palette108.bmp",
   L"data/actor/kokoro/palette109.bmp",
   L"data/actor/kokoro/texture/win_kokoro.png",
   L"data/actor/kokoro/texture/win_kokoro_en.png",
   L"data/actor/kokoro.nut",
   L"data/actor/kokoro_base.nut",
   L"data/actor/kokoro_boss.nut",
   L"data/actor/kokoro_boss_base.nut",
   L"data/actor/kokoro_boss_shot.nut",
   L"data/actor/kokoro_init.nut",
   L"data/actor/kokoro_shot.nut",
   L"data/actor/kokoro_team.nut",
   L"data/actor/mamizou/grab_hit0010.bmp",
   L"data/actor/mamizou/grab_hit0012.bmp",
   L"data/actor/mamizou/mamizou.pat",
   L"data/actor/mamizou/palette008.bmp",
   L"data/actor/mamizou/palette009.bmp",
   L"data/actor/mamizou/palette108.bmp",
   L"data/actor/mamizou/palette109.bmp",
   L"data/actor/mamizou/skill_taiko0000.bmp",
   L"data/actor/mamizou/skill_taiko0001.bmp",
   L"data/actor/mamizou/skill_taiko0002.bmp",
   L"data/actor/mamizou/skill_taiko0003.bmp",
   L"data/actor/mamizou/skill_taiko0004.bmp",
   L"data/actor/mamizou/skill_taiko0005.bmp",
   L"data/actor/mamizou/skill_taiko0006.bmp",
   L"data/actor/mamizou/skill_taiko0007.bmp",
   L"data/actor/mamizou/skill_taiko0008.bmp",
   L"data/actor/mamizou/skill_taiko0009.bmp",
   L"data/actor/mamizou/skill_taiko0010.bmp",
   L"data/actor/mamizou/skill_taiko_pre0000.bmp",
   L"data/actor/mamizou/skill_taiko_pre0001.bmp",
   L"data/actor/mamizou/skill_taiko_pre0002.bmp",
   L"data/actor/mamizou/skill_taiko_pre0003.bmp",
   L"data/actor/mamizou/skill_taiko_pre0004.bmp",
   L"data/actor/mamizou/skill_taiko_pre0005.bmp",
   L"data/actor/mamizou/team_begin_A0000.bmp",
   L"data/actor/mamizou/team_begin_A0001.bmp",
   L"data/actor/mamizou/team_begin_A0002.bmp",
   L"data/actor/mamizou/team_begin_A0003.bmp",
   L"data/actor/mamizou/team_begin_A0004.bmp",
   L"data/actor/mamizou/team_begin_A0005.bmp",
   L"data/actor/mamizou/team_begin_A0006.bmp",
   L"data/actor/mamizou/team_begin_A0007.bmp",
   L"data/actor/mamizou/team_begin_A0008.bmp",
   L"data/actor/mamizou/team_begin_A0009.bmp",
   L"data/actor/mamizou/team_begin_A0010.bmp",
   L"data/actor/mamizou/team_begin_A0011.bmp",
   L"data/actor/mamizou/team_begin_A0012.bmp",
   L"data/actor/mamizou/team_begin_A0013.bmp",
   L"data/actor/mamizou/team_begin_A0014.bmp",
   L"data/actor/mamizou/team_begin_A0015.bmp",
   L"data/actor/mamizou/texture/mamizou_charge_en.png",
   L"data/actor/mamizou/texture/mamizou_leaf_black.png",
   L"data/actor/mamizou/texture/win_mamizou.png",
   L"data/actor/mamizou/texture/win_mamizou_en.png",
   L"data/actor/mamizou.nut",
   L"data/actor/mamizou_base.nut",
   L"data/actor/mamizou_boss.nut",
   L"data/actor/mamizou_boss_shot.nut",
   L"data/actor/mamizou_combo.nut",
   L"data/actor/mamizou_com_function.nut",
   L"data/actor/mamizou_init.nut",
   L"data/actor/mamizou_shot.nut",
   L"data/actor/mamizou_team.nut",
   L"data/actor/marisa/marisa.pat",
   L"data/actor/marisa/palette008.bmp",
   L"data/actor/marisa/palette009.bmp",
   L"data/actor/marisa/palette108.bmp",
   L"data/actor/marisa/palette109.bmp",
   L"data/actor/marisa/texture/win_marisa_en.png",
   L"data/actor/marisa_base.nut",
   L"data/actor/marisa_boss.nut",
   L"data/actor/marisa_boss_shot.nut",
   L"data/actor/marisa_init.nut",
   L"data/actor/marisa_shot.nut",
   L"data/actor/miko/miko.pat",
   L"data/actor/miko/occult0020.bmp",
   L"data/actor/miko/occult0021.bmp",
   L"data/actor/miko/occult0022.bmp",
   L"data/actor/miko/occult0023.bmp",
   L"data/actor/miko/occult0024.bmp",
   L"data/actor/miko/occult0025.bmp",
   L"data/actor/miko/occult0026.bmp",
   L"data/actor/miko/palette000.bmp",
   L"data/actor/miko/palette008.bmp",
   L"data/actor/miko/palette009.bmp",
   L"data/actor/miko/palette108.bmp",
   L"data/actor/miko/palette109.bmp",
   L"data/actor/miko/texture/glow_mantle.png",
   L"data/actor/miko/texture/occult_select_en0000.png",
   L"data/actor/miko/texture/occult_select_en0001.png",
   L"data/actor/miko/texture/win_miko.png",
   L"data/actor/miko/texture/win_miko_en.png",
   L"data/actor/miko.nut",
   L"data/actor/miko_base.nut",
   L"data/actor/miko_boss.nut",
   L"data/actor/miko_boss_shot.nut",
   L"data/actor/miko_init.nut",
   L"data/actor/miko_shot.nut",
   L"data/actor/miko_team.nut",
   L"data/actor/mokou/grab0000.bmp",
   L"data/actor/mokou/grab0001.bmp",
   L"data/actor/mokou/grab0002.bmp",
   L"data/actor/mokou/grab0003.bmp",
   L"data/actor/mokou/grab0004.bmp",
   L"data/actor/mokou/grab0005.bmp",
   L"data/actor/mokou/grab_hit0000.bmp",
   L"data/actor/mokou/grab_hit0001.bmp",
   L"data/actor/mokou/grab_hit0002.bmp",
   L"data/actor/mokou/grab_hit0003.bmp",
   L"data/actor/mokou/grab_hit0004.bmp",
   L"data/actor/mokou/grab_hit0005.bmp",
   L"data/actor/mokou/mokou.pat",
   L"data/actor/mokou/palette008.bmp",
   L"data/actor/mokou/palette009.bmp",
   L"data/actor/mokou/palette108.bmp",
   L"data/actor/mokou/palette109.bmp",
   L"data/actor/mokou/skill_sweep_kick0000.bmp",
   L"data/actor/mokou/skill_sweep_kick0001.bmp",
   L"data/actor/mokou/skill_sweep_kick0002.bmp",
   L"data/actor/mokou/skill_sweep_kick0003.bmp",
   L"data/actor/mokou/skill_sweep_kick0004.bmp",
   L"data/actor/mokou/skill_sweep_kick0005.bmp",
   L"data/actor/mokou/skill_sweep_kick0006.bmp",
   L"data/actor/mokou/skill_sweep_kick0007.bmp",
   L"data/actor/mokou/skill_sweep_kick0008.bmp",
   L"data/actor/mokou/texture/win_mokou_en.png",
   L"data/actor/mokou.nut",
   L"data/actor/mokou_base.nut",
   L"data/actor/mokou_boss.nut",
   L"data/actor/mokou_boss_shot.nut",
   L"data/actor/mokou_init.nut",
   L"data/actor/mokou_shot.nut",
   L"data/actor/namazu/namazu.pat",
   L"data/actor/nitori/nitori.pat",
   L"data/actor/nitori/palette008.bmp",
   L"data/actor/nitori/palette009.bmp",
   L"data/actor/nitori/palette108.bmp",
   L"data/actor/nitori/palette109.bmp",
   L"data/actor/nitori/texture/win_nitori_en.png",
   L"data/actor/nitori_base.nut",
   L"data/actor/nitori_boss.nut",
   L"data/actor/object_common.nut",
   L"data/actor/player_common_move.nut",
   L"data/actor/player_story_move.nut",
   L"data/actor/player_team_move.nut",
   L"data/actor/reimu/palette008.bmp",
   L"data/actor/reimu/palette009.bmp",
   L"data/actor/reimu/palette108.bmp",
   L"data/actor/reimu/palette109.bmp",
   L"data/actor/reimu/reimu.pat",
   L"data/actor/reimu/texture/reimu_exBoss0000.png",
   L"data/actor/reimu/texture/win_reimu_en.png",
   L"data/actor/reimu.nut",
   L"data/actor/reimu_base.nut",
   L"data/actor/reimu_boss.nut",
   L"data/actor/reimu_boss_shot.nut",
   L"data/actor/reimu_shot.nut",
   L"data/actor/script/actor_game.nut",
   L"data/actor/script/actor_team.nut",
   L"data/actor/script/boss_function.nut",
   L"data/actor/script/com_function.nut",
   L"data/actor/script/input_command.nut",
   L"data/actor/script/player_function.nut",
   L"data/actor/script/player_game.nut",
   L"data/actor/script/player_input.nut",
   L"data/actor/script/player_member.nut",
   L"data/actor/script/player_spell.nut",
   L"data/actor/script/player_update.nut",
   L"data/actor/script/practice_update.nut",
   L"data/actor/shion/palette000.bmp",
   L"data/actor/shion/palette001.bmp",
   L"data/actor/shion/palette002.bmp",
   L"data/actor/shion/palette003.bmp",
   L"data/actor/shion/palette004.bmp",
   L"data/actor/shion/palette005.bmp",
   L"data/actor/shion/palette006.bmp",
   L"data/actor/shion/palette007.bmp",
   L"data/actor/shion/palette008.bmp",
   L"data/actor/shion/palette009.bmp",
   L"data/actor/shion/palette100.bmp",
   L"data/actor/shion/palette101.bmp",
   L"data/actor/shion/palette102.bmp",
   L"data/actor/shion/palette103.bmp",
   L"data/actor/shion/palette104.bmp",
   L"data/actor/shion/palette105.bmp",
   L"data/actor/shion/palette106.bmp",
   L"data/actor/shion/palette107.bmp",
   L"data/actor/shion/palette108.bmp",
   L"data/actor/shion/palette109.bmp",
   L"data/actor/shion/shion.pat",
   L"data/actor/shion/shion_option.pat",
   L"data/actor/shion_boss.nut",
   L"data/actor/shion_boss_base.nut",
   L"data/actor/shion_boss_shot.nut",
   L"data/actor/shion_option.nut",
   L"data/actor/shion_shot.nut",
   L"data/actor/shion_team.nut",
   L"data/actor/sinmyoumaru/palette008.bmp",
   L"data/actor/sinmyoumaru/palette009.bmp",
   L"data/actor/sinmyoumaru/palette108.bmp",
   L"data/actor/sinmyoumaru/palette109.bmp",
   L"data/actor/sinmyoumaru/sinmyoumaru.pat",
   L"data/actor/sinmyoumaru/texture/kobito_red0000.png",
   L"data/actor/sinmyoumaru/texture/kobito_red0001.png",
   L"data/actor/sinmyoumaru/texture/win_sinmyoumaru.png",
   L"data/actor/sinmyoumaru/texture/win_sinmyoumaru_en.png",
   L"data/actor/sinmyoumaru.nut",
   L"data/actor/sinmyoumaru_base.nut",
   L"data/actor/sinmyoumaru_boss.nut",
   L"data/actor/sinmyoumaru_boss_base.nut",
   L"data/actor/sinmyoumaru_boss_shot.nut",
   L"data/actor/sinmyoumaru_shot.nut",
   L"data/actor/status/gauge.pat",
   L"data/actor/status/gauge_common.nut",
   L"data/actor/status/gauge_story.nut",
   L"data/actor/status/gauge_vs.nut",
   L"data/actor/status/texture/gauge.png",
   L"data/actor/story_name/doremy/name2_en.pat",
   L"data/actor/story_name/doremy/name_en.pat",
   L"data/actor/story_name/doremy/name_en.png",
   L"data/actor/story_name/futo/name2_en.pat",
   L"data/actor/story_name/futo/name_en.pat",
   L"data/actor/story_name/futo/name_en.png",
   L"data/actor/story_name/hijiri/name2_en.pat",
   L"data/actor/story_name/hijiri/name_en.pat",
   L"data/actor/story_name/hijiri/name_en.png",
   L"data/actor/story_name/ichirin/name2_en.pat",
   L"data/actor/story_name/ichirin/name_en.pat",
   L"data/actor/story_name/ichirin/name_en.png",
   L"data/actor/story_name/jyoon/name2_en.pat",
   L"data/actor/story_name/jyoon/name_en.pat",
   L"data/actor/story_name/jyoon/name_en.png",
   L"data/actor/story_name/kasen/name2_en.pat",
   L"data/actor/story_name/kasen/name_en.pat",
   L"data/actor/story_name/kasen/name_en.png",
   L"data/actor/story_name/koishi/name2_en.pat",
   L"data/actor/story_name/koishi/name_en.pat",
   L"data/actor/story_name/koishi/name_en.png",
   L"data/actor/story_name/kokoro/name2_en.pat",
   L"data/actor/story_name/kokoro/name_en.pat",
   L"data/actor/story_name/kokoro/name_en.png",
   L"data/actor/story_name/mamizou/name2_en.pat",
   L"data/actor/story_name/mamizou/name_en.pat",
   L"data/actor/story_name/mamizou/name_en.png",
   L"data/actor/story_name/marisa/name2_en.pat",
   L"data/actor/story_name/marisa/name_en.pat",
   L"data/actor/story_name/marisa/name_marisa_en.png",
   L"data/actor/story_name/miko/name2_en.pat",
   L"data/actor/story_name/miko/name_en.pat",
   L"data/actor/story_name/miko/name_en.png",
   L"data/actor/story_name/mokou/name2_en.pat",
   L"data/actor/story_name/mokou/name_en.pat",
   L"data/actor/story_name/mokou/name_en.png",
   L"data/actor/story_name/nitori/name2_en.pat",
   L"data/actor/story_name/nitori/name_en.pat",
   L"data/actor/story_name/nitori/name_en.png",
   L"data/actor/story_name/reimu/name2_en.pat",
   L"data/actor/story_name/reimu/name_en.pat",
   L"data/actor/story_name/reimu/name_en.png",
   L"data/actor/story_name/shion/name2_en.pat",
   L"data/actor/story_name/shion/name_en.pat",
   L"data/actor/story_name/shion/name_en.png",
   L"data/actor/story_name/sinmyoumaru/name2_en.pat",
   L"data/actor/story_name/sinmyoumaru/name_en.pat",
   L"data/actor/story_name/sinmyoumaru/name_en.png",
   L"data/actor/story_name/tenshi/name2_en.pat",
   L"data/actor/story_name/tenshi/name_en.pat",
   L"data/actor/story_name/tenshi/name_en.png",
   L"data/actor/story_name/udonge/name2_en.pat",
   L"data/actor/story_name/udonge/name_en.pat",
   L"data/actor/story_name/udonge/name_en.png",
   L"data/actor/story_name/usami/name.png",
   L"data/actor/story_name/usami/name2_en.pat",
   L"data/actor/story_name/usami/name_en.pat",
   L"data/actor/story_name/usami/name_en.png",
   L"data/actor/story_name/yukari/name2_en.pat",
   L"data/actor/story_name/yukari/name_en.pat",
   L"data/actor/story_name/yukari/name_en.png",
   L"data/actor/story_title/futo/title2_en.pat",
   L"data/actor/story_title/futo/title3_en.pat",
   L"data/actor/story_title/futo/title4_en.pat",
   L"data/actor/story_title/futo/title5_en.pat",
   L"data/actor/story_title/futo/title_en.pat",
   L"data/actor/story_title/futo/title_futo_en_1.png",
   L"data/actor/story_title/futo/title_futo_en_2.png",
   L"data/actor/story_title/futo/title_futo_en_3.png",
   L"data/actor/story_title/futo/title_futo_en_4.png",
   L"data/actor/story_title/futo/title_futo_en_5.png",
   L"data/actor/story_title/jyoon/title2_en.pat",
   L"data/actor/story_title/jyoon/title3_en.pat",
   L"data/actor/story_title/jyoon/title4_en.pat",
   L"data/actor/story_title/jyoon/title5_en.pat",
   L"data/actor/story_title/jyoon/title6_en.pat",
   L"data/actor/story_title/jyoon/title_en.pat",
   L"data/actor/story_title/jyoon/title_jyoon_en_1.png",
   L"data/actor/story_title/jyoon/title_jyoon_en_2.png",
   L"data/actor/story_title/jyoon/title_jyoon_en_3.png",
   L"data/actor/story_title/jyoon/title_jyoon_en_4.png",
   L"data/actor/story_title/jyoon/title_jyoon_en_5.png",
   L"data/actor/story_title/jyoon/title_jyoon_en_6.png",
   L"data/actor/story_title/mamizou/title2_en.pat",
   L"data/actor/story_title/mamizou/title3_en.pat",
   L"data/actor/story_title/mamizou/title4_en.pat",
   L"data/actor/story_title/mamizou/title5_en.pat",
   L"data/actor/story_title/mamizou/title_en.pat",
   L"data/actor/story_title/mamizou/title_mamizou_en_1.png",
   L"data/actor/story_title/mamizou/title_mamizou_en_2.png",
   L"data/actor/story_title/mamizou/title_mamizou_en_3.png",
   L"data/actor/story_title/mamizou/title_mamizou_en_4.png",
   L"data/actor/story_title/mamizou/title_mamizou_en_5.png",
   L"data/actor/story_title/marisa/title2_en.pat",
   L"data/actor/story_title/marisa/title3_en.pat",
   L"data/actor/story_title/marisa/title4_en.pat",
   L"data/actor/story_title/marisa/title5_en.pat",
   L"data/actor/story_title/marisa/title_en.pat",
   L"data/actor/story_title/marisa/title_marisa_en_1.png",
   L"data/actor/story_title/marisa/title_marisa_en_2.png",
   L"data/actor/story_title/marisa/title_marisa_en_3.png",
   L"data/actor/story_title/marisa/title_marisa_en_4.png",
   L"data/actor/story_title/marisa/title_marisa_en_5.png",
   L"data/actor/story_title/miko/title2_en.pat",
   L"data/actor/story_title/miko/title3_en.pat",
   L"data/actor/story_title/miko/title4_en.pat",
   L"data/actor/story_title/miko/title5_en.pat",
   L"data/actor/story_title/miko/title_en.pat",
   L"data/actor/story_title/miko/title_miko_en_1.png",
   L"data/actor/story_title/miko/title_miko_en_2.png",
   L"data/actor/story_title/miko/title_miko_en_3.png",
   L"data/actor/story_title/miko/title_miko_en_4.png",
   L"data/actor/story_title/miko/title_miko_en_5.png",
   L"data/actor/story_title/nitori/title2_en.pat",
   L"data/actor/story_title/nitori/title3_en.pat",
   L"data/actor/story_title/nitori/title4_en.pat",
   L"data/actor/story_title/nitori/title5.pat",
   L"data/actor/story_title/nitori/title5_en.pat",
   L"data/actor/story_title/nitori/title_en.pat",
   L"data/actor/story_title/nitori/title_nitori_5.png",
   L"data/actor/story_title/nitori/title_nitori_en_1.png",
   L"data/actor/story_title/nitori/title_nitori_en_2.png",
   L"data/actor/story_title/nitori/title_nitori_en_3.png",
   L"data/actor/story_title/nitori/title_nitori_en_4.png",
   L"data/actor/story_title/nitori/title_nitori_en_5.png",
   L"data/actor/story_title/reimu/title2_en.pat",
   L"data/actor/story_title/reimu/title3_en.pat",
   L"data/actor/story_title/reimu/title4_en.pat",
   L"data/actor/story_title/reimu/title_en.pat",
   L"data/actor/story_title/reimu/title_reimu_en_1.png",
   L"data/actor/story_title/reimu/title_reimu_en_2.png",
   L"data/actor/story_title/reimu/title_reimu_en_3.png",
   L"data/actor/story_title/reimu/title_reimu_en_4.png",
   L"data/actor/story_title/tenshi/title2_en.pat",
   L"data/actor/story_title/tenshi/title3_en.pat",
   L"data/actor/story_title/tenshi/title4_en.pat",
   L"data/actor/story_title/tenshi/title5_en.pat",
   L"data/actor/story_title/tenshi/title_en.pat",
   L"data/actor/story_title/tenshi/title_tenshi_en_1.png",
   L"data/actor/story_title/tenshi/title_tenshi_en_2.png",
   L"data/actor/story_title/tenshi/title_tenshi_en_3.png",
   L"data/actor/story_title/tenshi/title_tenshi_en_4.png",
   L"data/actor/story_title/tenshi/title_tenshi_en_5.png",
   L"data/actor/story_title/udonge/title2_en.pat",
   L"data/actor/story_title/udonge/title3_en.pat",
   L"data/actor/story_title/udonge/title4_en.pat",
   L"data/actor/story_title/udonge/title_en.pat",
   L"data/actor/story_title/udonge/title_udonge_en_1.png",
   L"data/actor/story_title/udonge/title_udonge_en_2.png",
   L"data/actor/story_title/udonge/title_udonge_en_3.png",
   L"data/actor/story_title/udonge/title_udonge_en_4.png",
   L"data/actor/story_title/usami/title2_en.pat",
   L"data/actor/story_title/usami/title3_en.pat",
   L"data/actor/story_title/usami/title4_en.pat",
   L"data/actor/story_title/usami/title5_en.pat",
   L"data/actor/story_title/usami/title_en.pat",
   L"data/actor/story_title/usami/title_usami_en_1.png",
   L"data/actor/story_title/usami/title_usami_en_2.png",
   L"data/actor/story_title/usami/title_usami_en_3.png",
   L"data/actor/story_title/usami/title_usami_en_4.png",
   L"data/actor/story_title/usami/title_usami_en_5.png",
   L"data/actor/story_title/yukari/title.pat",
   L"data/actor/story_title/yukari/title2_en.pat",
   L"data/actor/story_title/yukari/title_en.pat",
   L"data/actor/story_title/yukari/title_yukari_1.png",
   L"data/actor/story_title/yukari/title_yukari_en_1.png",
   L"data/actor/story_title/yukari/title_yukari_en_2.png",
   L"data/actor/tenshi/dash_back0002.bmp",
   L"data/actor/tenshi/dash_back0003.bmp",
   L"data/actor/tenshi/dash_back0004.bmp",
   L"data/actor/tenshi/dash_back0005.bmp",
   L"data/actor/tenshi/dash_back0006.bmp",
   L"data/actor/tenshi/palette000.bmp",
   L"data/actor/tenshi/palette008.bmp",
   L"data/actor/tenshi/palette009.bmp",
   L"data/actor/tenshi/palette108.bmp",
   L"data/actor/tenshi/palette109.bmp",
   L"data/actor/tenshi/tenshi.pat",
   L"data/actor/tenshi/texture/back_space.png",
   L"data/actor/tenshi/texture/back_space0001.png",
   L"data/actor/tenshi/texture/red_laser000.bmp",
   L"data/actor/tenshi/texture/red_laser001.bmp",
   L"data/actor/tenshi/texture/red_laser002.bmp",
   L"data/actor/tenshi/texture/red_laser003.bmp",
   L"data/actor/tenshi/texture/red_laser004.bmp",
   L"data/actor/tenshi/texture/red_laser005.bmp",
   L"data/actor/tenshi/texture/red_laser006.bmp",
   L"data/actor/tenshi/texture/red_laser007.bmp",
   L"data/actor/tenshi/texture/red_laser008.bmp",
   L"data/actor/tenshi/texture/red_laser009.bmp",
   L"data/actor/tenshi/texture/red_laser010.bmp",
   L"data/actor/tenshi/texture/red_laser011.bmp",
   L"data/actor/tenshi/texture/red_laser012.bmp",
   L"data/actor/tenshi/texture/red_laser013.bmp",
   L"data/actor/tenshi/texture/red_laser014.bmp",
   L"data/actor/tenshi/texture/red_laser015.bmp",
   L"data/actor/tenshi/texture/red_laser016.bmp",
   L"data/actor/tenshi/texture/red_laser017.bmp",
   L"data/actor/tenshi/texture/red_laser018.bmp",
   L"data/actor/tenshi/texture/win_sinmyoumaru_en.png",
   L"data/actor/tenshi/texture/win_tenshi.png",
   L"data/actor/tenshi.nut",
   L"data/actor/tenshi_base.nut",
   L"data/actor/tenshi_boss.nut",
   L"data/actor/tenshi_boss_base.nut",
   L"data/actor/tenshi_boss_shot.nut",
   L"data/actor/tenshi_init.nut",
   L"data/actor/tenshi_shot.nut",
   L"data/actor/tenshi_team.nut",
   L"data/actor/udonge/palette008.bmp",
   L"data/actor/udonge/palette009.bmp",
   L"data/actor/udonge/palette108.bmp",
   L"data/actor/udonge/palette109.bmp",
   L"data/actor/udonge/texture/win_udonge_en.png",
   L"data/actor/udonge/udonge.pat",
   L"data/actor/udonge.nut",
   L"data/actor/udonge_base.nut",
   L"data/actor/udonge_boss.nut",
   L"data/actor/udonge_boss_shot.nut",
   L"data/actor/udonge_init.nut",
   L"data/actor/udonge_shot.nut",
   L"data/actor/usami/palette008.bmp",
   L"data/actor/usami/palette009.bmp",
   L"data/actor/usami/palette108.bmp",
   L"data/actor/usami/palette109.bmp",
   L"data/actor/usami/texture/win_usami.png",
   L"data/actor/usami/texture/win_usami_en.png",
   L"data/actor/usami/usami.pat",
   L"data/actor/usami_base.nut",
   L"data/actor/usami_boss.nut",
   L"data/actor/usami_boss_base.nut",
   L"data/actor/usami_boss_shot.nut",
   L"data/actor/yukari/atk_under0001.bmp",
   L"data/actor/yukari/atk_under0002.bmp",
   L"data/actor/yukari/atk_under0003.bmp",
   L"data/actor/yukari/atk_under0004.bmp",
   L"data/actor/yukari/atk_under0005.bmp",
   L"data/actor/yukari/palette000.bmp",
   L"data/actor/yukari/palette008.bmp",
   L"data/actor/yukari/palette009.bmp",
   L"data/actor/yukari/palette108.bmp",
   L"data/actor/yukari/palette109.bmp",
   L"data/actor/yukari/texture/win_yukari.png",
   L"data/actor/yukari/texture/win_yukari_en.png",
   L"data/actor/yukari/win_a0000.bmp",
   L"data/actor/yukari/win_a0001.bmp",
   L"data/actor/yukari/win_a0002.bmp",
   L"data/actor/yukari/win_a0003.bmp",
   L"data/actor/yukari/win_a0004.bmp",
   L"data/actor/yukari/win_a0005.bmp",
   L"data/actor/yukari/win_a0006.bmp",
   L"data/actor/yukari/yukari.pat",
   L"data/actor/yukari.nut",
   L"data/actor/yukari_base.nut",
   L"data/actor/yukari_boss.nut",
   L"data/actor/yukari_boss_shot.nut",
   L"data/actor/yukari_shot.nut",
   L"data/actor/yukari_team.nut",
   L"data/backGround/min/01.dds",
   L"data/backGround/min/02.dds",
   L"data/backGround/min/03.dds",
   L"data/backGround/min/04.dds",
   L"data/backGround/min/05.dds",
   L"data/backGround/min/06.dds",
   L"data/backGround/min/07.dds",
   L"data/backGround/min/08.dds",
   L"data/backGround/min/09.dds",
   L"data/backGround/min/10.dds",
   L"data/backGround/min/11.dds",
   L"data/backGround/min/12.dds",
   L"data/backGround/min/15.dds",
   L"data/backGround/min/16.dds",
   L"data/backGround/min/17.dds",
   L"data/backGround/min/19.dds",
   L"data/backGround/min/20.dds",
   L"data/backGround/min/21.dds",
   L"data/backGround/min/22.dds",
   L"data/backGround/min/23.dds",
   L"data/backGround/min/24.dds",
   L"data/backGround/min/25.dds",
   L"data/backGround/min/26.dds",
   L"data/backGround/min/27.dds",
   L"data/backGround/min/28.dds",
   L"data/backGround/min/30.dds",
   L"data/backGround/min/31.dds",
   L"data/backGround/min/40.dds",
   L"data/backGround/min/41.dds",
   L"data/backGround/min/42.dds",
   L"data/backGround/min/43.dds",
   L"data/backGround/min/44.dds",
   L"data/backGround/min/45.dds",
   L"data/backGround/min/46.dds",
   L"data/bgm/155tenshi1.ogg",
   L"data/bgm/155tenshi1.sfl",
   L"data/bgm/155tenshi1_20.ogg",
   L"data/bgm/155yukari1.ogg",
   L"data/bgm/155yukari1.sfl",
   L"data/bgm/155yukari1_20.ogg",
   L"data/bgm/bgm.csv",
   L"data/bgm/bgst03.ogg",
   L"data/bgm/bgst03.sfl",
   L"data/bgm/bgst03_20.ogg",
   L"data/bgm/bgst06.ogg",
   L"data/bgm/bgst06.sfl",
   L"data/bgm/bgst06_20.ogg",
   L"data/bgm/bgst11.ogg",
   L"data/bgm/bgst11.sfl",
   L"data/bgm/bgst11_20.ogg",
   L"data/effect/tenshi_space_debri.eft",
   L"data/effect/Texture/Effect/tenshi_stone_field0000.nhtex",
   L"data/event/balloon/b05x2.png",
   L"data/event/balloon/balloon.pat",
   L"data/event/balloon/d11x2.png",
   L"data/event/pic/futo/face.pat",
   L"data/event/pic/futo/face_r.pat",
   L"data/event/pic/ichirin/face.pat",
   L"data/event/pic/ichirin/face_r.pat",
   L"data/event/pic/jyoon/ed3_en.png",
   L"data/event/pic/jyoon/ed4_en.png",
   L"data/event/pic/jyoon/ed5_en.png",
   L"data/event/pic/jyoon/ed6_en.png",
   L"data/event/pic/jyoon/ed7_en.png",
   L"data/event/pic/jyoon/face.pat",
   L"data/event/pic/jyoon/face_r.pat",
   L"data/event/pic/koishi/face.pat",
   L"data/event/pic/koishi/face_r.pat",
   L"data/event/pic/marisa/face.pat",
   L"data/event/pic/marisa/face_r.pat",
   L"data/event/pic/miko/face.pat",
   L"data/event/pic/miko/face_r.pat",
   L"data/event/pic/nitori/face.pat",
   L"data/event/pic/nitori/face_r.pat",
   L"data/event/pic/reimu/ed1_en.png",
   L"data/event/pic/reimu/ed2_en.png",
   L"data/event/pic/reimu/ed3_en.png",
   L"data/event/pic/reimu/ed4_en.png",
   L"data/event/pic/reimu/ed5_en.png",
   L"data/event/pic/sinmyoumaru/face.pat",
   L"data/event/pic/sinmyoumaru/face_r.pat",
   L"data/event/pic/udonge/face.pat",
   L"data/event/pic/udonge/face_r.pat",
   L"data/event/pic/usami/11.png",
   L"data/event/pic/usami/face.pat",
   L"data/event/pic/usami/face_r.pat",
   L"data/event/pic/yukari/ed5_en.png",
   L"data/event/pic/yukari/ed6_en.png",
   L"data/event/pic/yukari/ed7_en.png",
   L"data/event/pic/yukari/ed8_en.png",
   L"data/event/pic/yukari/face.pat",
   L"data/event/pic/yukari/face_r.pat",
   L"data/event/script/futo/ed.pl",
   L"data/event/script/futo/stage1.pl",
   L"data/event/script/futo/stage2.pl",
   L"data/event/script/futo/stage3.pl",
   L"data/event/script/futo/stage4.pl",
   L"data/event/script/futo/stage5.pl",
   L"data/event/script/jyoon/ed.pl",
   L"data/event/script/jyoon/stage1.pl",
   L"data/event/script/jyoon/stage2.pl",
   L"data/event/script/jyoon/stage3.pl",
   L"data/event/script/jyoon/stage4.pl",
   L"data/event/script/jyoon/stage5.pl",
   L"data/event/script/jyoon/stage6.pl",
   L"data/event/script/mamizou/ed.pl",
   L"data/event/script/mamizou/stage1.pl",
   L"data/event/script/mamizou/stage2.pl",
   L"data/event/script/mamizou/stage3.pl",
   L"data/event/script/mamizou/stage4.pl",
   L"data/event/script/mamizou/stage5.pl",
   L"data/event/script/marisa/ed.pl",
   L"data/event/script/marisa/stage1.pl",
   L"data/event/script/marisa/stage2.pl",
   L"data/event/script/marisa/stage3.pl",
   L"data/event/script/marisa/stage4.pl",
   L"data/event/script/marisa/stage5.pl",
   L"data/event/script/miko/ed.pl",
   L"data/event/script/miko/stage1.pl",
   L"data/event/script/miko/stage2.pl",
   L"data/event/script/miko/stage3.pl",
   L"data/event/script/miko/stage4.pl",
   L"data/event/script/miko/stage5.pl",
   L"data/event/script/nitori/ed.pl",
   L"data/event/script/nitori/stage1.pl",
   L"data/event/script/nitori/stage2.pl",
   L"data/event/script/nitori/stage3.pl",
   L"data/event/script/nitori/stage4.pl",
   L"data/event/script/nitori/stage5.pl",
   L"data/event/script/reimu/ed.pl",
   L"data/event/script/reimu/stage1.pl",
   L"data/event/script/reimu/stage2.pl",
   L"data/event/script/reimu/stage3.pl",
   L"data/event/script/reimu/stage4.pl",
   L"data/event/script/tenshi/ed.pl",
   L"data/event/script/tenshi/stage1.pl",
   L"data/event/script/tenshi/stage2.pl",
   L"data/event/script/tenshi/stage3.pl",
   L"data/event/script/tenshi/stage4.pl",
   L"data/event/script/tenshi/stage5.pl",
   L"data/event/script/udonge/ed.pl",
   L"data/event/script/udonge/stage1.pl",
   L"data/event/script/udonge/stage2.pl",
   L"data/event/script/udonge/stage3.pl",
   L"data/event/script/udonge/stage4.pl",
   L"data/event/script/usami/ed.pl",
   L"data/event/script/usami/stage1.pl",
   L"data/event/script/usami/stage2.pl",
   L"data/event/script/usami/stage3.pl",
   L"data/event/script/usami/stage4.pl",
   L"data/event/script/usami/stage5.pl",
   L"data/event/script/yukari/ed.pl",
   L"data/event/script/yukari/stage1.pl",
   L"data/event/script/yukari/stage2.pl",
   L"data/font/font_texture_outline16_600.bmp",
   L"data/font/spell_font.bmp",
   L"data/script/backGround/bg43.nut",
   L"data/script/background/bg_min.nut",
   L"data/script/background/bg_min_43.nut",
   L"data/script/background/bg_min_46.nut",
   L"data/script/battle/battle.nut",
   L"data/script/battle/battle_network.nut",
   L"data/script/battle/battle_on_hit.nut",
   L"data/script/battle/battle_practice.nut",
   L"data/script/battle/battle_replay.nut",
   L"data/script/battle/battle_story.nut",
   L"data/script/battle/battle_team.nut",
   L"data/script/battle/battle_vs_player.nut",
   L"data/script/battle/battle_watch.nut",
   L"data/script/camera.nut",
   L"data/script/config.nut",
   L"data/script/const.nut",
   L"data/script/const_key.nut",
   L"data/script/font.nut",
   L"data/script/input.nut",
   L"data/script/loop.nut",
   L"data/script/replay.nut",
   L"data/script/savedata.nut",
   L"data/script/scene/practice.nut",
   L"data/script/scene/story.nut",
   L"data/script/scene/vs.nut",
   L"data/script/sound.nut",
   L"data/script/stage.nut",
   L"data/script/talk/talk.nut",
   L"data/script/talk/talk_balloon.nut",
   L"data/script/talk/talk_command.nut",
   L"data/script/talk/talk_generate.nut",
   L"data/script/talk/talk_subtitle.nut",
   L"data/script/talk/talk_text.nut",
   L"data/script/version.nut",
   L"data/se/mamizou/2716.wav",
   L"data/se/mamizou/2717.wav",
   L"data/se/mamizou/2718.wav",
   L"data/se/mamizou.csv",
   L"data/spell/jyoon.csv",
   L"data/spell/jyoon_0.png",
   L"data/spell/jyoon_2.png",
   L"data/story/spell_list/futo_stage_1.csv",
   L"data/story/spell_list/futo_stage_2.csv",
   L"data/story/spell_list/futo_stage_3.csv",
   L"data/story/spell_list/futo_stage_4.csv",
   L"data/story/spell_list/futo_stage_5.csv",
   L"data/story/spell_list/futo_stage_5_od.csv",
   L"data/story/spell_list/jyoon_stage_1.csv",
   L"data/story/spell_list/jyoon_stage_2.csv",
   L"data/story/spell_list/jyoon_stage_3.csv",
   L"data/story/spell_list/jyoon_stage_4.csv",
   L"data/story/spell_list/jyoon_stage_5.csv",
   L"data/story/spell_list/jyoon_stage_6_od.csv",
   L"data/story/spell_list/mamizou_stage_1.csv",
   L"data/story/spell_list/mamizou_stage_2.csv",
   L"data/story/spell_list/mamizou_stage_3.csv",
   L"data/story/spell_list/mamizou_stage_4.csv",
   L"data/story/spell_list/mamizou_stage_5.csv",
   L"data/story/spell_list/marisa_stage_3.csv",
   L"data/story/spell_list/marisa_stage_4.csv",
   L"data/story/spell_list/marisa_stage_5.csv",
   L"data/story/spell_list/miko_stage_1.csv",
   L"data/story/spell_list/miko_stage_2.csv",
   L"data/story/spell_list/miko_stage_3.csv",
   L"data/story/spell_list/miko_stage_4.csv",
   L"data/story/spell_list/miko_stage_5.csv",
   L"data/story/spell_list/nitori_stage_1.csv",
   L"data/story/spell_list/nitori_stage_2.csv",
   L"data/story/spell_list/nitori_stage_3.csv",
   L"data/story/spell_list/nitori_stage_4.csv",
   L"data/story/spell_list/nitori_stage_5.csv",
   L"data/story/spell_list/nitori_stage_5_od.csv",
   L"data/story/spell_list/reimu_stage_1.csv",
   L"data/story/spell_list/reimu_stage_2.csv",
   L"data/story/spell_list/reimu_stage_3.csv",
   L"data/story/spell_list/reimu_stage_4.csv",
   L"data/story/spell_list/tenshi_stage_1.csv",
   L"data/story/spell_list/tenshi_stage_2.csv",
   L"data/story/spell_list/tenshi_stage_3.csv",
   L"data/story/spell_list/tenshi_stage_4.csv",
   L"data/story/spell_list/udonge_stage_1.csv",
   L"data/story/spell_list/udonge_stage_2.csv",
   L"data/story/spell_list/udonge_stage_3.csv",
   L"data/story/spell_list/udonge_stage_4.csv",
   L"data/story/spell_list/usami_stage_1.csv",
   L"data/story/spell_list/usami_stage_2.csv",
   L"data/story/spell_list/usami_stage_3.csv",
   L"data/story/spell_list/usami_stage_4.csv",
   L"data/story/spell_list/usami_stage_5.csv",
   L"data/story/spell_list/usami_stage_5_od.csv",
   L"data/story/spell_list/yukari_stage_1.csv",
   L"data/story/stage_list/usami.csv",
   L"data/system/boot/boot.nut",
   L"data/system/component/item.csv",
   L"data/system/component/menu_common.nut",
   L"data/system/component/network.nut",
   L"data/system/component/ui_base.nut",
   L"data/system/config/config.nut",
   L"data/system/config/config_animation.nut",
   L"data/system/config/item.csv",
   L"data/system/cursor/cursor.png",
   L"data/system/dialog/dialog.nut",
   L"data/system/ed/staffpic/staffmoji0_en.png",
   L"data/system/ed/staffpic/staffmoji10_en.png",
   L"data/system/ed/staffpic/staffmoji11_en.png",
   L"data/system/ed/staffpic/staffmoji1_en.png",
   L"data/system/ed/staffpic/staffmoji2_en.png",
   L"data/system/ed/staffpic/staffmoji3_en.png",
   L"data/system/ed/staffpic/staffmoji4_en.png",
   L"data/system/ed/staffpic/staffmoji5_en.png",
   L"data/system/ed/staffpic/staffmoji6_en.png",
   L"data/system/ed/staffpic/staffmoji7_en.png",
   L"data/system/ed/staffpic/staffmoji8_en.png",
   L"data/system/ed/staffpic/staffmoji9_en.png",
   L"data/system/ed/staffroll.csv",
   L"data/system/ed/staffroll.nut",
   L"data/system/ed/staffroll_en.csv",
   L"data/system/help/help.nut",
   L"data/system/help/item.csv",
   L"data/system/key_config/config_moji1.png",
   L"data/system/key_config/config_pad1.png",
   L"data/system/key_config/config_pad1_en.png",
   L"data/system/key_config/config_pad2.png",
   L"data/system/key_config/config_pad2_en.png",
   L"data/system/key_config/key_config.nut",
   L"data/system/key_config/key_config.pat",
   L"data/system/key_config/key_config_animation.nut",
   L"data/system/key_config/parts.png",
   L"data/system/key_config/parts_en.png",
   L"data/system/music_room/music_room.nut",
   L"data/system/music_room/music_room_animation.nut",
   L"data/system/network/dialog_address.nut",
   L"data/system/network/dialog_connect.nut",
   L"data/system/network/dialog_port.nut",
   L"data/system/network/dialog_wait.nut",
   L"data/system/network/item.csv",
   L"data/system/network/network.act",
   L"data/system/network/network.global.nut",
   L"data/system/network/network.nut",
   L"data/system/network/network.pat",
   L"data/system/network/network_animation.nut",
   L"data/system/network/network_font.png",
   L"data/system/pause/pause.nut",
   L"data/system/pause/pause_animation.nut",
   L"data/system/practice/item.csv",
   L"data/system/practice/practice.nut",
   L"data/system/practice/practice.pat",
   L"data/system/practice/practice_animation.nut",
   L"data/system/practice/practice_part000.png",
   L"data/system/replay_select/replay_object.png",
   L"data/system/replay_select/replay_select.nut",
   L"data/system/replay_select/replay_select_view.nut",
   L"data/system/select/center_object.png",
   L"data/system/select/character_select_en.pat",
   L"data/system/select/color_master/doremy.png",
   L"data/system/select/color_master/futo.png",
   L"data/system/select/color_master/hijiri.png",
   L"data/system/select/color_master/ichirin.png",
   L"data/system/select/color_master/jyoon.png",
   L"data/system/select/color_master/kasen.png",
   L"data/system/select/color_master/koishi.png",
   L"data/system/select/color_master/kokoro.png",
   L"data/system/select/color_master/mamizou.png",
   L"data/system/select/color_master/marisa.png",
   L"data/system/select/color_master/miko.png",
   L"data/system/select/color_master/mokou.png",
   L"data/system/select/color_master/nitori.png",
   L"data/system/select/color_master/reimu.png",
   L"data/system/select/color_master/sinmyoumaru.png",
   L"data/system/select/color_master/tenshi.png",
   L"data/system/select/color_master/udonge.png",
   L"data/system/select/color_master/usami.png",
   L"data/system/select/color_master/yukari.png",
   L"data/system/select/color_slave/doremy.png",
   L"data/system/select/color_slave/futo.png",
   L"data/system/select/color_slave/hijiri.png",
   L"data/system/select/color_slave/ichirin.png",
   L"data/system/select/color_slave/jyoon.png",
   L"data/system/select/color_slave/kasen.png",
   L"data/system/select/color_slave/koishi.png",
   L"data/system/select/color_slave/kokoro.png",
   L"data/system/select/color_slave/mamizou.png",
   L"data/system/select/color_slave/marisa.png",
   L"data/system/select/color_slave/miko.png",
   L"data/system/select/color_slave/mokou.png",
   L"data/system/select/color_slave/nitori.png",
   L"data/system/select/color_slave/reimu.png",
   L"data/system/select/color_slave/sinmyoumaru.png",
   L"data/system/select/color_slave/tenshi.png",
   L"data/system/select/color_slave/udonge.png",
   L"data/system/select/color_slave/usami.png",
   L"data/system/select/color_slave/yukari.png",
   L"data/system/select/name/handle_name_en.csv",
   L"data/system/select/name/name_000_en.png",
   L"data/system/select/name/name_001_en.png",
   L"data/system/select/name/name_002_en.png",
   L"data/system/select/name/name_003_en.png",
   L"data/system/select/name/name_004_en.png",
   L"data/system/select/name/name_005_en.png",
   L"data/system/select/name/name_006_en.png",
   L"data/system/select/name/name_007_en.png",
   L"data/system/select/name/name_008_en.png",
   L"data/system/select/name/name_009_en.png",
   L"data/system/select/name/name_010_en.png",
   L"data/system/select/name/name_011_en.png",
   L"data/system/select/name/name_012_en.png",
   L"data/system/select/name/name_013.png",
   L"data/system/select/name/name_013_en.png",
   L"data/system/select/name/name_014_en.png",
   L"data/system/select/name/name_015_en.png",
   L"data/system/select/name/name_016_en.png",
   L"data/system/select/name/name_017_en.png",
   L"data/system/select/name/name_018_en.png",
   L"data/system/select/name/name_c_000_en.png",
   L"data/system/select/name/name_c_001_en.png",
   L"data/system/select/name/name_c_002_en.png",
   L"data/system/select/name/name_c_003_en.png",
   L"data/system/select/name/name_c_004_en.png",
   L"data/system/select/name/name_c_005_en.png",
   L"data/system/select/name/name_c_006_en.png",
   L"data/system/select/name/name_c_007_en.png",
   L"data/system/select/name/name_c_008_en.png",
   L"data/system/select/name/name_c_009_en.png",
   L"data/system/select/name/name_c_010_en.png",
   L"data/system/select/name/name_c_011_en.png",
   L"data/system/select/name/name_c_012_en.png",
   L"data/system/select/name/name_c_013.png",
   L"data/system/select/name/name_c_013_en.png",
   L"data/system/select/name/name_c_014_en.png",
   L"data/system/select/name/name_c_015_en.png",
   L"data/system/select/name/name_c_016_en.png",
   L"data/system/select/name/name_c_017_en.png",
   L"data/system/select/name/name_c_018_en.png",
   L"data/system/select/name/name_en.pat",
   L"data/system/select/parts.png",
   L"data/system/select/parts_en.png",
   L"data/system/select/script/animation_bgm.nut",
   L"data/system/select/script/animation_handle.nut",
   L"data/system/select/script/animation_stage_title.nut",
   L"data/system/select/script/animation_story_title.nut",
   L"data/system/select/script/character_select_action.nut",
   L"data/system/select/script/character_select_animation.nut",
   L"data/system/select/script/story_select_action.nut",
   L"data/system/select/script/story_select_animation.nut",
   L"data/system/select/stage_name/back_b_000_en.png",
   L"data/system/select/stage_name/back_b_001_en.png",
   L"data/system/select/stage_name/back_b_002_en.png",
   L"data/system/select/stage_name/back_b_003_en.png",
   L"data/system/select/stage_name/back_b_004_en.png",
   L"data/system/select/stage_name/back_b_005_en.png",
   L"data/system/select/stage_name/back_b_006_en.png",
   L"data/system/select/stage_name/back_b_007_en.png",
   L"data/system/select/stage_name/back_b_008_en.png",
   L"data/system/select/stage_name/back_b_009_en.png",
   L"data/system/select/stage_name/back_b_010_en.png",
   L"data/system/select/stage_name/back_b_011_en.png",
   L"data/system/select/stage_name/back_b_012_en.png",
   L"data/system/select/stage_name/back_b_013_en.png",
   L"data/system/select/stage_name/back_b_014_en.png",
   L"data/system/select/stage_name/back_b_015_en.png",
   L"data/system/select/stage_name/back_b_016_en.png",
   L"data/system/select/stage_name/back_b_017_en.png",
   L"data/system/select/stage_name/back_b_018_en.png",
   L"data/system/select/stage_name/back_name_999_en.png",
   L"data/system/select/stage_name/stage_name_en.pat",
   L"data/system/select/stage_pic/back_031.png",
   L"data/system/select/story_title/name_en_futo.png",
   L"data/system/select/story_title/name_en_jyoon.png",
   L"data/system/select/story_title/name_en_mamizou.png",
   L"data/system/select/story_title/name_en_marisa.png",
   L"data/system/select/story_title/name_en_miko.png",
   L"data/system/select/story_title/name_en_nitori.png",
   L"data/system/select/story_title/name_en_reimu.png",
   L"data/system/select/story_title/name_en_tenshi.png",
   L"data/system/select/story_title/name_en_udonge.png",
   L"data/system/select/story_title/name_en_usami.png",
   L"data/system/select/story_title/name_en_yukari.png",
   L"data/system/select/story_title/name_usami.png",
   L"data/system/select/story_title/stage_en_futo.png",
   L"data/system/select/story_title/stage_en_jyoon.png",
   L"data/system/select/story_title/stage_en_mamizou.png",
   L"data/system/select/story_title/stage_en_marisa.png",
   L"data/system/select/story_title/stage_en_miko.png",
   L"data/system/select/story_title/stage_en_nitori.png",
   L"data/system/select/story_title/stage_en_reimu.png",
   L"data/system/select/story_title/stage_en_tenshi.png",
   L"data/system/select/story_title/stage_en_udonge.png",
   L"data/system/select/story_title/stage_en_usami.png",
   L"data/system/select/story_title/stage_en_yukari.png",
   L"data/system/select/story_title/stage_nitori.png",
   L"data/system/select/story_title/stage_reimu.png",
   L"data/system/select/story_title/title_en_futo.png",
   L"data/system/select/story_title/title_en_jyoon.png",
   L"data/system/select/story_title/title_en_mamizou.png",
   L"data/system/select/story_title/title_en_marisa.png",
   L"data/system/select/story_title/title_en_miko.png",
   L"data/system/select/story_title/title_en_nitori.png",
   L"data/system/select/story_title/title_en_reimu.png",
   L"data/system/select/story_title/title_en_tenshi.png",
   L"data/system/select/story_title/title_en_udonge.png",
   L"data/system/select/story_title/title_en_usami.png",
   L"data/system/select/story_title/title_en_yukari.png",
   L"data/system/select/story_title/title_tenshi.png",
   L"data/system/title/op_001.png",
   L"data/system/title/title.nut",
   L"data/system/title/title_animation.nut",
   L"data/system/watch/back.png",
   L"data/system/watch/watch.nut",
   L"data/win/message/doremy.csv",
   L"data/win/message/futo.csv",
   L"data/win/message/hijiri.csv",
   L"data/win/message/ichirin.csv",
   L"data/win/message/jyoon.csv",
   L"data/win/message/kasen.csv",
   L"data/win/message/koishi.csv",
   L"data/win/message/kokoro.csv",
   L"data/win/message/mamizou.csv",
   L"data/win/message/marisa.csv",
   L"data/win/message/miko.csv",
   L"data/win/message/mokou.csv",
   L"data/win/message/nitori.csv",
   L"data/win/message/reimu.csv",
   L"data/win/message/sinmyoumaru.csv",
   L"data/win/message/tenshi.csv",
   L"data/win/message/udonge.csv",
   L"data/win/message/usami.csv",
   L"data/win/message/yukari.csv",

};

} // TH155

} // TouhouSE
